/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ue=["require","exports","vs/base/common/platform","vs/base/common/lifecycle","vs/base/common/path","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/nls","vs/nls!vs/server/remoteExtensionHostAgent","vs/base/common/network","vs/base/common/types","vs/base/common/errors","vs/base/common/async","vs/base/common/strings","vs/platform/files/common/files","vs/platform/log/common/log","vs/base/node/pfs","vs/base/common/buffer","vs/base/common/resources","vs/base/common/arrays","vs/base/common/objects","vs/platform/registry/common/platform","vs/base/common/process","vs/base/common/cancellation","vs/base/common/uuid","os","vs/platform/configuration/common/configuration","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/map","vs/base/common/extpath","fs","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/parts/ipc/common/ipc","vs/base/common/json","vs/base/common/errorMessage","vs/platform/product/common/productService","vs/platform/telemetry/common/telemetryUtils","vs/base/common/codicons","child_process","vs/platform/configuration/common/configurationRegistry","vs/platform/extensions/common/extensions","vs/platform/theme/common/colorRegistry","vs/server/remoteUriTransformer","vs/base/common/color","vs/base/common/stream","vs/base/common/performance","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/theme/common/themeService","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/marshalling","vs/platform/environment/node/argv","vs/platform/instantiation/common/descriptors","vs/platform/files/common/watcher","vs/platform/product/common/product","vs/base/common/semver/semver","vs/platform/request/common/request","vs/base/parts/ipc/node/ipc.net","vs/base/common/severity","vs/base/common/glob","vs/base/common/labels","vs/base/common/mime","vs/base/common/uriIpc","vs/editor/common/core/range","vs/base/node/processes","vs/base/parts/ipc/node/ipc.cp","vs/platform/extensions/common/extensionValidator","vs/platform/contextkey/common/contextkey","vs/platform/download/common/download","vs/platform/environment/node/shellEnv","vs/platform/instantiation/common/serviceCollection","vs/platform/localizations/common/localizations","vs/platform/files/node/diskFileSystemProvider","crypto","url","vs/platform/theme/common/theme","vs/platform/theme/common/tokenClassificationRegistry","vs/server/remoteLanguagePacks","vs/server/serverEnvironmentService","vs/workbench/services/themes/common/workbenchThemeService","vs/base/node/zip","vs/base/common/functional","vs/base/common/processes","vs/base/common/htmlContent","vs/base/common/normalization","vs/base/common/console","path","vs/base/node/id","net","vs/base/node/powershell","vs/base/node/ps","vs/base/parts/ipc/common/ipc.net","vs/editor/common/core/position","vs/base/common/jsonErrorMessages","vs/platform/environment/common/environmentService","vs/platform/files/common/io","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/fileService","vs/platform/log/common/logIpc","vs/platform/log/node/spdlogLog","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/platform/extensionManagement/common/extensionManagementCLIService","vs/platform/localizations/node/localizations","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/terminal/common/terminal","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/api/common/extHostTypes","vs/workbench/common/editor","vs/workbench/contrib/terminal/common/environmentVariable","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/editor/common/editorService","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/services/remote/common/remoteAgentService","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","vs/server/extensionHostConnection","vs/base/common/amd","vs/base/common/assert","vs/base/common/auth","vs/base/common/collections","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/linkedList","vs/base/common/numbers","vs/base/common/skipList","vs/base/common/stopwatch","vs/base/common/hash","vs/base/common/filters","vs/base/common/iconLabels","vs/base/node/decoder","vs/base/node/languagePacks","vs/base/node/macAddress","util","vs/base/node/extpath","vs/base/node/ports","vs/base/node/watcher","vs/base/parts/storage/common/storage","vs/editor/common/modes/languageSelector","vs/editor/common/modes/tokenizationRegistry","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/base/node/zip","vs/nls!vs/editor/common/view/editorColorRegistry","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/environment/node/shellEnv","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLIService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensionManagement/node/extensionsScanner","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/theme/common/colorRegistry","vs/nls!vs/platform/theme/common/tokenClassificationRegistry","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/server/remoteAgentEnvironmentImpl","vs/nls!vs/server/serverEnvironmentService","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/extensions/node/extensionPoints","vs/nls!vs/workbench/services/themes/common/colorThemeData","vs/nls!vs/workbench/services/themes/common/colorThemeSchema","vs/nls!vs/workbench/services/themes/common/themeConfiguration","vs/nls!vs/workbench/services/themes/common/themeExtensionPoints","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/download/common/downloadIpc","vs/platform/editor/common/editor","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/files/node/diskFileSystemProviderIpc","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/editor/common/services/modelService","vs/editor/common/modes/languageFeatureRegistry","vs/editor/common/modes","vs/platform/diagnostics/common/diagnostics","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/environment/node/argvHelper","vs/platform/files/common/ipcFileSystemProvider","vs/platform/files/node/watcher/nodejs/watcherService","vs/platform/files/node/watcher/nsfw/watcherService","vs/platform/files/node/watcher/parcel/watcherService","vs/platform/label/common/label","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/files/common/diskFileSystemProvider","vs/platform/markers/common/markers","vs/platform/notification/common/notification","vs/platform/product/common/marketplace","vs/platform/configuration/common/configurationModels","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/download/common/downloadService","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","vs/platform/storage/common/storage","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/errorTelemetry","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/node/appInsightsAppender","vs/platform/telemetry/node/errorTelemetry","vs/platform/terminal/common/requestStore","vs/platform/terminal/node/terminalEnvironment","vs/editor/common/view/editorColorRegistry","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/workspaces/common/workspaces","vs/server/common/net","vs/server/remoteExtensionManagement","vs/server/remoteTelemetryService","vs/server/remoteFileSystemProviderIpc","vs/server/webClientServer","vs/workbench/api/common/extHostRpcService","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/terminal/common/environmentVariableCollection","vs/workbench/contrib/terminal/common/terminalEnvironment","vs/workbench/contrib/testing/common/testId","vs/workbench/services/configuration/common/configuration","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostTypeConverters","vs/workbench/contrib/terminal/common/remoteTerminalChannel","vs/workbench/services/extensionResourceLoader/common/extensionResourceLoader","vs/workbench/services/extensions/common/extensionPoints","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/api/common/extHost.protocol","vs/workbench/api/common/extHostCommands","vs/workbench/services/extensions/common/remoteConsoleUtil","vs/workbench/services/extensions/node/extensionPoints","vs/server/remoteAgentEnvironmentImpl","vs/workbench/services/remote/common/remoteAgentFileSystemChannel","vs/workbench/services/themes/common/colorThemeSchema","vs/workbench/services/themes/common/plistParser","vs/workbench/services/themes/common/textMateScopeMatcher","vs/workbench/services/themes/common/themeCompatibility","vs/workbench/services/themes/common/colorThemeData","vs/workbench/services/themes/common/themeConfiguration","vs/workbench/services/themes/common/themeExtensionPoints","vs/server/serverThemeService","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionsScanner","zlib","vs/server/remoteExtensionHostAgentCli","vs/workbench/api/node/extHostCLIServer","vs/server/remoteTerminalChannel","vs/server/remoteExtensionHostAgentServer","perf_hooks","string_decoder","minimist","assert","graceful-fs","cookie","vs/base/common/marked/marked","yauzl","yazl","http","vs/server/remoteExtensionHostAgent"],de=function(Y){for(var e=[],S=0,k=Y.length;S<k;S++)e[S]=ue[Y[S]];return e};define(ue[126],de([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoaderStats=void 0;class S{static get(){const p=new Map,P=new Map,t=new Map,T=new Map;function h(u,c){u.has(c.detail)||u.set(c.detail,-c.timestamp)}function f(u,c){let b=u.get(c.detail);!b||b>=0||u.set(c.detail,b+c.timestamp)}const C=Y.getStats().slice(0).sort((u,c)=>u.timestamp-c.timestamp);for(const u of C)switch(u.type){case 10:h(p,u);break;case 11:case 12:f(p,u);break;case 21:h(P,u);break;case 22:f(P,u);break;case 33:h(t,u);break;case 34:f(t,u);break;case 31:h(T,u);break;case 32:f(T,u);break}let I=0;t.forEach(u=>I+=u);function m(u){let c=[];return u.forEach((b,g)=>c.push([g,b])),c}return{amdLoad:m(p),amdInvoke:m(P),nodeRequire:m(t),nodeEval:m(T),nodeRequireTotal:I}}static toMarkdownTable(p,P){let t="",T=[];return p.forEach((h,f)=>{T[f]=h.length}),P.forEach(h=>{h.forEach((f,C)=>{typeof f=="undefined"&&(f=h[C]="-");const I=f.toString().length;T[C]=Math.max(I,T[C])})}),p.forEach((h,f)=>{t+=`| ${h+" ".repeat(T[f]-h.toString().length)} `}),t+=`|
`,p.forEach((h,f)=>{t+=`| ${"-".repeat(T[f])} `}),t+=`|
`,P.forEach(h=>{h.forEach((f,C)=>{typeof f!="undefined"&&(t+=`| ${f+" ".repeat(T[C]-f.toString().length)} `)}),t+=`|
`}),t}}e.LoaderStats=S}),define(ue[127],de([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function S(k,p){if(!k)throw new Error(p?`Assertion failed (${p})`:"Assertion Failed")}e.ok=S}),define(ue[128],de([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AuthType=void 0;var S;(function(k){k.Password="password",k.None="none"})(S=e.AuthType||(e.AuthType={}))}),define(ue[129],de([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const S=Object.prototype.hasOwnProperty;function k(C){const I=[];for(let m in C)S.call(C,m)&&I.push(C[m]);return I}e.values=k;function p(C,I){for(let m in C)if(S.call(C,m)&&I({key:m,value:C[m]},function(){delete C[m]})===!1)return}e.forEach=p;function P(C,I){const m=Object.create(null);for(const u of C){const c=I(u);let b=m[c];b||(b=m[c]=[]),b.push(u)}return m}e.groupBy=P;function t(C){const I=Object.create(null);return C&&C.forEach((m,u)=>{I[u]=m}),I}e.fromMap=t;function T(C,I){const m=[],u=[];for(let c of C)I.has(c)||m.push(c);for(let c of I)C.has(c)||u.push(c);return{removed:m,added:u}}e.diffSets=T;function h(C,I){const m=[],u=[];for(let[c,b]of C)I.has(c)||m.push(b);for(let[c,b]of I)C.has(c)||u.push(b);return{removed:m,added:u}}e.diffMaps=h;class f{constructor(){this.map=new Map}add(I,m){let u=this.map.get(I);u||(u=new Set,this.map.set(I,u)),u.add(m)}delete(I,m){const u=this.map.get(I);!u||(u.delete(m),u.size===0&&this.map.delete(I))}forEach(I,m){const u=this.map.get(I);!u||u.forEach(m)}}e.SetMap=f}),define(ue[46],de([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Color=e.HSVA=e.HSLA=e.RGBA=void 0;function S(T,h){const f=Math.pow(10,h);return Math.round(T*f)/f}class k{constructor(h,f,C,I=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,h))|0,this.g=Math.min(255,Math.max(0,f))|0,this.b=Math.min(255,Math.max(0,C))|0,this.a=S(Math.max(Math.min(1,I),0),3)}static equals(h,f){return h.r===f.r&&h.g===f.g&&h.b===f.b&&h.a===f.a}}e.RGBA=k;class p{constructor(h,f,C,I){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,h),0)|0,this.s=S(Math.max(Math.min(1,f),0),3),this.l=S(Math.max(Math.min(1,C),0),3),this.a=S(Math.max(Math.min(1,I),0),3)}static equals(h,f){return h.h===f.h&&h.s===f.s&&h.l===f.l&&h.a===f.a}static fromRGBA(h){const f=h.r/255,C=h.g/255,I=h.b/255,m=h.a,u=Math.max(f,C,I),c=Math.min(f,C,I);let b=0,g=0;const D=(c+u)/2,w=u-c;if(w>0){switch(g=Math.min(D<=.5?w/(2*D):w/(2-2*D),1),u){case f:b=(C-I)/w+(C<I?6:0);break;case C:b=(I-f)/w+2;break;case I:b=(f-C)/w+4;break}b*=60,b=Math.round(b)}return new p(b,g,D,m)}static _hue2rgb(h,f,C){return C<0&&(C+=1),C>1&&(C-=1),C<1/6?h+(f-h)*6*C:C<1/2?f:C<2/3?h+(f-h)*(2/3-C)*6:h}static toRGBA(h){const f=h.h/360,{s:C,l:I,a:m}=h;let u,c,b;if(C===0)u=c=b=I;else{const g=I<.5?I*(1+C):I+C-I*C,D=2*I-g;u=p._hue2rgb(D,g,f+1/3),c=p._hue2rgb(D,g,f),b=p._hue2rgb(D,g,f-1/3)}return new k(Math.round(u*255),Math.round(c*255),Math.round(b*255),m)}}e.HSLA=p;class P{constructor(h,f,C,I){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,h),0)|0,this.s=S(Math.max(Math.min(1,f),0),3),this.v=S(Math.max(Math.min(1,C),0),3),this.a=S(Math.max(Math.min(1,I),0),3)}static equals(h,f){return h.h===f.h&&h.s===f.s&&h.v===f.v&&h.a===f.a}static fromRGBA(h){const f=h.r/255,C=h.g/255,I=h.b/255,m=Math.max(f,C,I),u=Math.min(f,C,I),c=m-u,b=m===0?0:c/m;let g;return c===0?g=0:m===f?g=((C-I)/c%6+6)%6:m===C?g=(I-f)/c+2:g=(f-C)/c+4,new P(Math.round(g*60),b,m,h.a)}static toRGBA(h){const{h:f,s:C,v:I,a:m}=h,u=I*C,c=u*(1-Math.abs(f/60%2-1)),b=I-u;let[g,D,w]=[0,0,0];return f<60?(g=u,D=c):f<120?(g=c,D=u):f<180?(D=u,w=c):f<240?(D=c,w=u):f<300?(g=c,w=u):f<=360&&(g=u,w=c),g=Math.round((g+b)*255),D=Math.round((D+b)*255),w=Math.round((w+b)*255),new k(g,D,w,m)}}e.HSVA=P;class t{constructor(h){if(h)if(h instanceof k)this.rgba=h;else if(h instanceof p)this._hsla=h,this.rgba=p.toRGBA(h);else if(h instanceof P)this._hsva=h,this.rgba=P.toRGBA(h);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}static fromHex(h){return t.Format.CSS.parseHex(h)||t.red}get hsla(){return this._hsla?this._hsla:p.fromRGBA(this.rgba)}get hsva(){return this._hsva?this._hsva:P.fromRGBA(this.rgba)}equals(h){return!!h&&k.equals(this.rgba,h.rgba)&&p.equals(this.hsla,h.hsla)&&P.equals(this.hsva,h.hsva)}getRelativeLuminance(){const h=t._relativeLuminanceForComponent(this.rgba.r),f=t._relativeLuminanceForComponent(this.rgba.g),C=t._relativeLuminanceForComponent(this.rgba.b),I=.2126*h+.7152*f+.0722*C;return S(I,4)}static _relativeLuminanceForComponent(h){const f=h/255;return f<=.03928?f/12.92:Math.pow((f+.055)/1.055,2.4)}getContrastRatio(h){const f=this.getRelativeLuminance(),C=h.getRelativeLuminance();return f>C?(f+.05)/(C+.05):(C+.05)/(f+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(h){const f=this.getRelativeLuminance(),C=h.getRelativeLuminance();return f>C}isDarkerThan(h){const f=this.getRelativeLuminance(),C=h.getRelativeLuminance();return f<C}lighten(h){return new t(new p(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*h,this.hsla.a))}darken(h){return new t(new p(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*h,this.hsla.a))}transparent(h){const{r:f,g:C,b:I,a:m}=this.rgba;return new t(new k(f,C,I,m*h))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new t(new k(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(h){const f=h.rgba,C=this.rgba.a,I=f.a,m=C+I*(1-C);if(m<1e-6)return t.transparent;const u=this.rgba.r*C/m+f.r*I*(1-C)/m,c=this.rgba.g*C/m+f.g*I*(1-C)/m,b=this.rgba.b*C/m+f.b*I*(1-C)/m;return new t(new k(u,c,b,m))}makeOpaque(h){if(this.isOpaque()||h.rgba.a!==1)return this;const{r:f,g:C,b:I,a:m}=this.rgba;return new t(new k(h.rgba.r-m*(h.rgba.r-f),h.rgba.g-m*(h.rgba.g-C),h.rgba.b-m*(h.rgba.b-I),1))}flatten(...h){const f=h.reduceRight((C,I)=>t._flatten(I,C));return t._flatten(this,f)}static _flatten(h,f){const C=1-h.rgba.a;return new t(new k(C*f.rgba.r+h.rgba.a*h.rgba.r,C*f.rgba.g+h.rgba.a*h.rgba.g,C*f.rgba.b+h.rgba.a*h.rgba.b))}toString(){return this._toString||(this._toString=t.Format.CSS.format(this)),this._toString}static getLighterColor(h,f,C){if(h.isLighterThan(f))return h;C=C||.5;const I=h.getRelativeLuminance(),m=f.getRelativeLuminance();return C=C*(m-I)/m,h.lighten(C)}static getDarkerColor(h,f,C){if(h.isDarkerThan(f))return h;C=C||.5;const I=h.getRelativeLuminance(),m=f.getRelativeLuminance();return C=C*(I-m)/I,h.darken(C)}}e.Color=t,t.white=new t(new k(255,255,255,1)),t.black=new t(new k(0,0,0,1)),t.red=new t(new k(255,0,0,1)),t.blue=new t(new k(0,0,255,1)),t.green=new t(new k(0,255,0,1)),t.cyan=new t(new k(0,255,255,1)),t.lightgrey=new t(new k(211,211,211,1)),t.transparent=new t(new k(0,0,0,0)),function(T){let h;(function(f){let C;(function(I){function m(r){return r.rgba.a===1?`rgb(${r.rgba.r}, ${r.rgba.g}, ${r.rgba.b})`:T.Format.CSS.formatRGBA(r)}I.formatRGB=m;function u(r){return`rgba(${r.rgba.r}, ${r.rgba.g}, ${r.rgba.b}, ${+r.rgba.a.toFixed(2)})`}I.formatRGBA=u;function c(r){return r.hsla.a===1?`hsl(${r.hsla.h}, ${(r.hsla.s*100).toFixed(2)}%, ${(r.hsla.l*100).toFixed(2)}%)`:T.Format.CSS.formatHSLA(r)}I.formatHSL=c;function b(r){return`hsla(${r.hsla.h}, ${(r.hsla.s*100).toFixed(2)}%, ${(r.hsla.l*100).toFixed(2)}%, ${r.hsla.a.toFixed(2)})`}I.formatHSLA=b;function g(r){const o=r.toString(16);return o.length!==2?"0"+o:o}function D(r){return`#${g(r.rgba.r)}${g(r.rgba.g)}${g(r.rgba.b)}`}I.formatHex=D;function w(r,o=!1){return o&&r.rgba.a===1?T.Format.CSS.formatHex(r):`#${g(r.rgba.r)}${g(r.rgba.g)}${g(r.rgba.b)}${g(Math.round(r.rgba.a*255))}`}I.formatHexA=w;function v(r){return r.isOpaque()?T.Format.CSS.formatHex(r):T.Format.CSS.formatRGBA(r)}I.format=v;function a(r){const o=r.length;if(o===0||r.charCodeAt(0)!==35)return null;if(o===7){const i=16*l(r.charCodeAt(1))+l(r.charCodeAt(2)),n=16*l(r.charCodeAt(3))+l(r.charCodeAt(4)),s=16*l(r.charCodeAt(5))+l(r.charCodeAt(6));return new T(new k(i,n,s,1))}if(o===9){const i=16*l(r.charCodeAt(1))+l(r.charCodeAt(2)),n=16*l(r.charCodeAt(3))+l(r.charCodeAt(4)),s=16*l(r.charCodeAt(5))+l(r.charCodeAt(6)),d=16*l(r.charCodeAt(7))+l(r.charCodeAt(8));return new T(new k(i,n,s,d/255))}if(o===4){const i=l(r.charCodeAt(1)),n=l(r.charCodeAt(2)),s=l(r.charCodeAt(3));return new T(new k(16*i+i,16*n+n,16*s+s))}if(o===5){const i=l(r.charCodeAt(1)),n=l(r.charCodeAt(2)),s=l(r.charCodeAt(3)),d=l(r.charCodeAt(4));return new T(new k(16*i+i,16*n+n,16*s+s,(16*d+d)/255))}return null}I.parseHex=a;function l(r){switch(r){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(C=f.CSS||(f.CSS={}))})(h=T.Format||(T.Format={}))}(t=e.Color||(e.Color={}))}),define(ue[52],de([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function S(t){return(T,h,f)=>{let C=null,I=null;if(typeof f.value=="function"?(C="value",I=f.value):typeof f.get=="function"&&(C="get",I=f.get),!I)throw new Error("not supported");f[C]=t(I,h)}}e.createDecorator=S;function k(t,T,h){let f=null,C=null;if(typeof h.value=="function"?(f="value",C=h.value,C.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof h.get=="function"&&(f="get",C=h.get),!C)throw new Error("not supported");const I=`$memoize$${T}`;h[f]=function(...m){return this.hasOwnProperty(I)||Object.defineProperty(this,I,{configurable:!1,enumerable:!1,writable:!1,value:C.apply(this,m)}),this[I]}}e.memoize=k;function p(t,T,h){return S((f,C)=>{const I=`$debounce$${C}`,m=`$debounce$result$${C}`;return function(...u){this[m]||(this[m]=h?h():void 0),clearTimeout(this[I]),T&&(this[m]=T(this[m],...u),u=[this[m]]),this[I]=setTimeout(()=>{f.apply(this,u),this[m]=h?h():void 0},t)}})}e.debounce=p;function P(t,T,h){return S((f,C)=>{const I=`$throttle$timer$${C}`,m=`$throttle$result$${C}`,u=`$throttle$lastRun$${C}`,c=`$throttle$pending$${C}`;return function(...b){if(this[m]||(this[m]=h?h():void 0),(this[u]===null||this[u]===void 0)&&(this[u]=-Number.MAX_VALUE),T&&(this[m]=T(this[m],...b)),this[c])return;const g=this[u]+t;g<=Date.now()?(this[u]=Date.now(),f.apply(this,[this[m]]),this[m]=h?h():void 0):(this[c]=!0,this[I]=setTimeout(()=>{this[c]=!1,this[u]=Date.now(),f.apply(this,[this[m]]),this[m]=h?h():void 0},g-Date.now()))}})}e.throttle=P}),define(ue[12],de([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class S{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(r){setTimeout(()=>{throw r.stack?new Error(r.message+`

`+r.stack):r},0)}}addListener(r){return this.listeners.push(r),()=>{this._removeListener(r)}}emit(r){this.listeners.forEach(o=>{o(r)})}_removeListener(r){this.listeners.splice(this.listeners.indexOf(r),1)}setUnexpectedErrorHandler(r){this.unexpectedErrorHandler=r}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(r){this.unexpectedErrorHandler(r),this.emit(r)}onUnexpectedExternalError(r){this.unexpectedErrorHandler(r)}}e.ErrorHandler=S,e.errorHandler=new S;function k(l){e.errorHandler.setUnexpectedErrorHandler(l)}e.setUnexpectedErrorHandler=k;function p(l){h(l)||e.errorHandler.onUnexpectedError(l)}e.onUnexpectedError=p;function P(l){h(l)||e.errorHandler.onUnexpectedExternalError(l)}e.onUnexpectedExternalError=P;function t(l){if(l instanceof Error){let{name:r,message:o}=l;const i=l.stacktrace||l.stack;return{$isError:!0,name:r,message:o,stack:i}}return l}e.transformErrorForSerialization=t;const T="Canceled";function h(l){return l instanceof Error&&l.name===T&&l.message===T}e.isPromiseCanceledError=h;class f extends Error{constructor(){super(T);this.name=this.message}}e.CancellationError=f;function C(){const l=new Error(T);return l.name=l.message,l}e.canceled=C;function I(l){return l?new Error(`Illegal argument: ${l}`):new Error("Illegal argument")}e.illegalArgument=I;function m(l){return l?new Error(`Illegal state: ${l}`):new Error("Illegal state")}e.illegalState=m;function u(l){return l?new Error(`readonly property '${l} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=u;function c(l){const r=new Error(`${l} has been disposed`);return r.name="DISPOSED",r}e.disposed=c;function b(l){return l?l.message?l.message:l.stack?l.stack.split(`
`)[0]:String(l):"Error"}e.getErrorMessage=b;class g extends Error{constructor(r){super("NotImplemented");r&&(this.message=r)}}e.NotImplementedError=g;class D extends Error{constructor(r){super("NotSupported");r&&(this.message=r)}}e.NotSupportedError=D;class w extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=w;function v(l){const r=l;return r instanceof Error&&Array.isArray(r.actions)}e.isErrorWithActions=v;function a(l,r=Object.create(null)){const o=new Error(l);return r.actions&&(o.actions=r.actions),o}e.createErrorWithActions=a}),define(ue[20],de([0,1,12]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.maxIndex=e.minIndex=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function k(z,B=0){return z[z.length-(1+B)]}e.tail=k;function p(z){if(z.length===0)throw new Error("Invalid tail call");return[z.slice(0,z.length-1),z[z.length-1]]}e.tail2=p;function P(z,B,W=(ie,oe)=>ie===oe){if(z===B)return!0;if(!z||!B||z.length!==B.length)return!1;for(let ie=0,oe=z.length;ie<oe;ie++)if(!W(z[ie],B[ie]))return!1;return!0}e.equals=P;function t(z,B,W){let ie=0,oe=z.length-1;for(;ie<=oe;){const we=(ie+oe)/2|0,se=W(z[we],B);if(se<0)ie=we+1;else if(se>0)oe=we-1;else return we}return-(ie+1)}e.binarySearch=t;function T(z,B){let W=0,ie=z.length;if(ie===0)return 0;for(;W<ie;){const oe=Math.floor((W+ie)/2);B(z[oe])?ie=oe:W=oe+1}return W}e.findFirstInSorted=T;function h(z,B,W){if(z=z|0,z>=B.length)throw new TypeError("invalid index");let ie=B[Math.floor(B.length*Math.random())],oe=[],we=[],se=[];for(let ae of B){const ke=W(ae,ie);ke<0?oe.push(ae):ke>0?we.push(ae):se.push(ae)}return z<oe.length?h(z,oe,W):z<oe.length+se.length?se[0]:h(z-(oe.length+se.length),we,W)}e.quickSelect=h;function f(z,B){const W=[];let ie;for(const oe of z.slice(0).sort(B))!ie||B(ie[0],oe)!==0?(ie=[oe],W.push(ie)):ie.push(oe);return W}e.groupBy=f;function C(z,B,W){const ie=[];function oe(ae,ke,De){if(ke===0&&De.length===0)return;const Oe=ie[ie.length-1];Oe&&Oe.start+Oe.deleteCount===ae?(Oe.deleteCount+=ke,Oe.toInsert.push(...De)):ie.push({start:ae,deleteCount:ke,toInsert:De})}let we=0,se=0;for(;;){if(we===z.length){oe(we,0,B.slice(se));break}if(se===B.length){oe(we,z.length-we,[]);break}const ae=z[we],ke=B[se],De=W(ae,ke);De===0?(we+=1,se+=1):De<0?(oe(we,1,[]),we+=1):De>0&&(oe(we,0,[ke]),se+=1)}return ie}e.sortedDiff=C;function I(z,B,W){const ie=C(z,B,W),oe=[],we=[];for(const se of ie)oe.push(...z.slice(se.start,se.start+se.deleteCount)),we.push(...se.toInsert);return{removed:oe,added:we}}e.delta=I;function m(z,B,W){if(W===0)return[];const ie=z.slice(0,W).sort(B);return c(z,B,ie,W,z.length),ie}e.top=m;function u(z,B,W,ie,oe){return W===0?Promise.resolve([]):new Promise((we,se)=>{(async()=>{const ae=z.length,ke=z.slice(0,W).sort(B);for(let De=W,Oe=Math.min(W+ie,ae);De<ae;De=Oe,Oe=Math.min(Oe+ie,ae)){if(De>W&&await new Promise(Be=>setTimeout(Be)),oe&&oe.isCancellationRequested)throw(0,S.canceled)();c(z,B,ke,De,Oe)}return ke})().then(we,se)})}e.topAsync=u;function c(z,B,W,ie,oe){for(const we=W.length;ie<oe;ie++){const se=z[ie];if(B(se,W[we-1])<0){W.pop();const ae=T(W,ke=>B(se,ke)<0);W.splice(ae,0,se)}}}function b(z){return z.filter(B=>!!B)}e.coalesce=b;function g(z){let B=0;for(let W=0;W<z.length;W++)z[W]&&(z[B]=z[W],B+=1);z.length=B}e.coalesceInPlace=g;function D(z,B,W){z.splice(W,0,z.splice(B,1)[0])}e.move=D;function w(z){return!Array.isArray(z)||z.length===0}e.isFalsyOrEmpty=w;function v(z){return Array.isArray(z)&&z.length>0}e.isNonEmptyArray=v;function a(z,B=W=>W){const W=new Set;return z.filter(ie=>{const oe=B(ie);return W.has(oe)?!1:(W.add(oe),!0)})}e.distinct=a;function l(z){const B=Object.create(null);return W=>{const ie=z(W);return B[ie]?!1:(B[ie]=!0,!0)}}e.uniqueFilter=l;function r(z,B){const W=o(z,B);if(W!==-1)return z[W]}e.findLast=r;function o(z,B){for(let W=z.length-1;W>=0;W--){const ie=z[W];if(B(ie))return W}return-1}e.lastIndex=o;function i(z,B){return z.length>0?z[0]:B}e.firstOrDefault=i;function n(z,B,W=(ie,oe)=>ie===oe){let ie=0;for(let oe=0,we=Math.min(z.length,B.length);oe<we&&W(z[oe],B[oe]);oe++)ie++;return ie}e.commonPrefixLength=n;function s(z){return[].concat(...z)}e.flatten=s;function d(z,B){let W=typeof B=="number"?z:0;typeof B=="number"?W=z:(W=0,B=z);const ie=[];if(W<=B)for(let oe=W;oe<B;oe++)ie.push(oe);else for(let oe=W;oe>B;oe--)ie.push(oe);return ie}e.range=d;function y(z,B,W){return z.reduce((ie,oe)=>(ie[B(oe)]=W?W(oe):oe,ie),Object.create(null))}e.index=y;function A(z,B){return z.push(B),()=>E(z,B)}e.insert=A;function E(z,B){const W=z.indexOf(B);if(W>-1)return z.splice(W,1),B}e.remove=E;function R(z,B,W){const ie=z.slice(0,B),oe=z.slice(B);return ie.concat(W,oe)}e.arrayInsert=R;function O(z,B){let W;if(typeof B=="number"){let ie=B;W=()=>{const oe=Math.sin(ie++)*179426549;return oe-Math.floor(oe)}}else W=Math.random;for(let ie=z.length-1;ie>0;ie-=1){const oe=Math.floor(W()*(ie+1)),we=z[ie];z[ie]=z[oe],z[oe]=we}}e.shuffle=O;function K(z,B){const W=z.indexOf(B);W>-1&&(z.splice(W,1),z.unshift(B))}e.pushToStart=K;function te(z,B){const W=z.indexOf(B);W>-1&&(z.splice(W,1),z.push(B))}e.pushToEnd=te;function j(z,B){return Array.isArray(z)?z.map(B):B(z)}e.mapArrayOrNot=j;function _(z){return Array.isArray(z)?z:[z]}e.asArray=_;function U(z){return z[Math.floor(Math.random()*z.length)]}e.getRandomElement=U;function F(z,B){for(const W of z){const ie=B(W);if(ie!==void 0)return ie}}e.mapFind=F;function M(z,B,W){const ie=ee(z,B),oe=z.length,we=W.length;z.length=oe+we;for(let se=oe-1;se>=ie;se--)z[se+we]=z[se];for(let se=0;se<we;se++)z[se+ie]=W[se]}e.insertInto=M;function V(z,B,W,ie){const oe=ee(z,B),we=z.splice(oe,W);return M(z,oe,ie),we}e.splice=V;function ee(z,B){return B<0?Math.max(B+z.length,0):Math.min(B,z.length)}function G(z,B){let W=Number.MAX_SAFE_INTEGER,ie=0;return z.forEach((oe,we)=>{const se=B(oe);se<W&&(W=se,ie=we)}),ie}e.minIndex=G;function H(z,B){let W=Number.MIN_SAFE_INTEGER,ie=0;return z.forEach((oe,we)=>{const se=B(oe);se>W&&(W=se,ie=we)}),ie}e.maxIndex=H;class q{constructor(B){this.items=B,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(B){let W=this.firstIdx;for(;W<this.items.length&&B(this.items[W]);)W++;const ie=W===this.firstIdx?null:this.items.slice(this.firstIdx,W);return this.firstIdx=W,ie}takeFromEndWhile(B){let W=this.lastIdx;for(;W>=0&&B(this.items[W]);)W--;const ie=W===this.lastIdx?null:this.items.slice(W+1,this.lastIdx+1);return this.lastIdx=W,ie}peek(){return this.items[this.firstIdx]}dequeue(){const B=this.items[this.firstIdx];return this.firstIdx++,B}takeCount(B){const W=this.items.slice(this.firstIdx,this.firstIdx+B);return this.firstIdx+=B,W}}e.ArrayQueue=q}),define(ue[85],de([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function S(k){const p=this;let P=!1,t;return function(){return P||(P=!0,t=k.apply(p,arguments)),t}}e.once=S}),define(ue[53],de([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var S;(function(k){function p(l){return l&&typeof l=="object"&&typeof l[Symbol.iterator]=="function"}k.is=p;const P=Object.freeze([]);function t(){return P}k.empty=t;function*T(l){yield l}k.single=T;function h(l){return l||P}k.from=h;function f(l){return!l||l[Symbol.iterator]().next().done===!0}k.isEmpty=f;function C(l){return l[Symbol.iterator]().next().value}k.first=C;function I(l,r){for(const o of l)if(r(o))return!0;return!1}k.some=I;function m(l,r){for(const o of l)if(r(o))return o}k.find=m;function*u(l,r){for(const o of l)r(o)&&(yield o)}k.filter=u;function*c(l,r){let o=0;for(const i of l)yield r(i,o++)}k.map=c;function*b(...l){for(const r of l)for(const o of r)yield o}k.concat=b;function*g(l){for(const r of l)for(const o of r)yield o}k.concatNested=g;function D(l,r,o){let i=o;for(const n of l)i=r(i,n);return i}k.reduce=D;function*w(l,r,o=l.length){for(r<0&&(r+=l.length),o<0?o+=l.length:o>l.length&&(o=l.length);r<o;r++)yield l[r]}k.slice=w;function v(l,r=Number.POSITIVE_INFINITY){const o=[];if(r===0)return[o,l];const i=l[Symbol.iterator]();for(let n=0;n<r;n++){const s=i.next();if(s.done)return[o,k.empty()];o.push(s.value)}return[o,{[Symbol.iterator](){return i}}]}k.consume=v;function a(l,r,o=(i,n)=>i===n){const i=l[Symbol.iterator](),n=r[Symbol.iterator]();for(;;){const s=i.next(),d=n.next();if(s.done!==d.done)return!1;if(s.done)return!0;if(!o(s.value,d.value))return!1}}k.equals=a})(S=e.Iterable||(e.Iterable={}))}),define(ue[36],de([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var S;(function(r){r[r.None=0]="None",r[r.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",r[r.UnexpectedEndOfString=2]="UnexpectedEndOfString",r[r.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",r[r.InvalidUnicode=4]="InvalidUnicode",r[r.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",r[r.InvalidCharacter=6]="InvalidCharacter"})(S=e.ScanError||(e.ScanError={}));var k;(function(r){r[r.OpenBraceToken=1]="OpenBraceToken",r[r.CloseBraceToken=2]="CloseBraceToken",r[r.OpenBracketToken=3]="OpenBracketToken",r[r.CloseBracketToken=4]="CloseBracketToken",r[r.CommaToken=5]="CommaToken",r[r.ColonToken=6]="ColonToken",r[r.NullKeyword=7]="NullKeyword",r[r.TrueKeyword=8]="TrueKeyword",r[r.FalseKeyword=9]="FalseKeyword",r[r.StringLiteral=10]="StringLiteral",r[r.NumericLiteral=11]="NumericLiteral",r[r.LineCommentTrivia=12]="LineCommentTrivia",r[r.BlockCommentTrivia=13]="BlockCommentTrivia",r[r.LineBreakTrivia=14]="LineBreakTrivia",r[r.Trivia=15]="Trivia",r[r.Unknown=16]="Unknown",r[r.EOF=17]="EOF"})(k=e.SyntaxKind||(e.SyntaxKind={}));var p;(function(r){r[r.InvalidSymbol=1]="InvalidSymbol",r[r.InvalidNumberFormat=2]="InvalidNumberFormat",r[r.PropertyNameExpected=3]="PropertyNameExpected",r[r.ValueExpected=4]="ValueExpected",r[r.ColonExpected=5]="ColonExpected",r[r.CommaExpected=6]="CommaExpected",r[r.CloseBraceExpected=7]="CloseBraceExpected",r[r.CloseBracketExpected=8]="CloseBracketExpected",r[r.EndOfFileExpected=9]="EndOfFileExpected",r[r.InvalidCommentToken=10]="InvalidCommentToken",r[r.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",r[r.UnexpectedEndOfString=12]="UnexpectedEndOfString",r[r.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",r[r.InvalidUnicode=14]="InvalidUnicode",r[r.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",r[r.InvalidCharacter=16]="InvalidCharacter"})(p=e.ParseErrorCode||(e.ParseErrorCode={}));var P;(function(r){r.DEFAULT={allowTrailingComma:!0}})(P=e.ParseOptions||(e.ParseOptions={}));function t(r,o=!1){let i=0,n=r.length,s="",d=0,y=16,A=0;function E(U){let F=0,M=0;for(;F<U;){const V=r.charCodeAt(i);if(V>=48&&V<=57)M=M*16+V-48;else if(V>=65&&V<=70)M=M*16+V-65+10;else if(V>=97&&V<=102)M=M*16+V-97+10;else break;i++,F++}return F<U&&(M=-1),M}function R(U){i=U,s="",d=0,y=16,A=0}function O(){const U=i;if(r.charCodeAt(i)===48)i++;else for(i++;i<r.length&&f(r.charCodeAt(i));)i++;if(i<r.length&&r.charCodeAt(i)===46)if(i++,i<r.length&&f(r.charCodeAt(i)))for(i++;i<r.length&&f(r.charCodeAt(i));)i++;else return A=3,r.substring(U,i);let F=i;if(i<r.length&&(r.charCodeAt(i)===69||r.charCodeAt(i)===101))if(i++,(i<r.length&&r.charCodeAt(i)===43||r.charCodeAt(i)===45)&&i++,i<r.length&&f(r.charCodeAt(i))){for(i++;i<r.length&&f(r.charCodeAt(i));)i++;F=i}else A=3;return r.substring(U,F)}function K(){let U="",F=i;for(;;){if(i>=n){U+=r.substring(F,i),A=2;break}const M=r.charCodeAt(i);if(M===34){U+=r.substring(F,i),i++;break}if(M===92){if(U+=r.substring(F,i),i++,i>=n){A=2;break}switch(r.charCodeAt(i++)){case 34:U+='"';break;case 92:U+="\\";break;case 47:U+="/";break;case 98:U+="\b";break;case 102:U+="\f";break;case 110:U+=`
`;break;case 114:U+="\r";break;case 116:U+="	";break;case 117:const ee=E(4);ee>=0?U+=String.fromCharCode(ee):A=4;break;default:A=5}F=i;continue}if(M>=0&&M<=31)if(h(M)){U+=r.substring(F,i),A=2;break}else A=6;i++}return U}function te(){if(s="",A=0,d=i,i>=n)return d=n,y=17;let U=r.charCodeAt(i);if(T(U)){do i++,s+=String.fromCharCode(U),U=r.charCodeAt(i);while(T(U));return y=15}if(h(U))return i++,s+=String.fromCharCode(U),U===13&&r.charCodeAt(i)===10&&(i++,s+=`
`),y=14;switch(U){case 123:return i++,y=1;case 125:return i++,y=2;case 91:return i++,y=3;case 93:return i++,y=4;case 58:return i++,y=6;case 44:return i++,y=5;case 34:return i++,s=K(),y=10;case 47:const F=i-1;if(r.charCodeAt(i+1)===47){for(i+=2;i<n&&!h(r.charCodeAt(i));)i++;return s=r.substring(F,i),y=12}if(r.charCodeAt(i+1)===42){i+=2;const M=n-1;let V=!1;for(;i<M;){if(r.charCodeAt(i)===42&&r.charCodeAt(i+1)===47){i+=2,V=!0;break}i++}return V||(i++,A=1),s=r.substring(F,i),y=13}return s+=String.fromCharCode(U),i++,y=16;case 45:if(s+=String.fromCharCode(U),i++,i===n||!f(r.charCodeAt(i)))return y=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return s+=O(),y=11;default:for(;i<n&&j(U);)i++,U=r.charCodeAt(i);if(d!==i){switch(s=r.substring(d,i),s){case"true":return y=8;case"false":return y=9;case"null":return y=7}return y=16}return s+=String.fromCharCode(U),i++,y=16}}function j(U){if(T(U)||h(U))return!1;switch(U){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function _(){let U;do U=te();while(U>=12&&U<=15);return U}return{setPosition:R,getPosition:()=>i,scan:o?_:te,getToken:()=>y,getTokenValue:()=>s,getTokenOffset:()=>d,getTokenLength:()=>i-d,getTokenError:()=>A}}e.createScanner=t;function T(r){return r===32||r===9||r===11||r===12||r===160||r===5760||r>=8192&&r<=8203||r===8239||r===8287||r===12288||r===65279}function h(r){return r===10||r===13||r===8232||r===8233}function f(r){return r>=48&&r<=57}var C;(function(r){r[r.nullCharacter=0]="nullCharacter",r[r.maxAsciiCharacter=127]="maxAsciiCharacter",r[r.lineFeed=10]="lineFeed",r[r.carriageReturn=13]="carriageReturn",r[r.lineSeparator=8232]="lineSeparator",r[r.paragraphSeparator=8233]="paragraphSeparator",r[r.nextLine=133]="nextLine",r[r.space=32]="space",r[r.nonBreakingSpace=160]="nonBreakingSpace",r[r.enQuad=8192]="enQuad",r[r.emQuad=8193]="emQuad",r[r.enSpace=8194]="enSpace",r[r.emSpace=8195]="emSpace",r[r.threePerEmSpace=8196]="threePerEmSpace",r[r.fourPerEmSpace=8197]="fourPerEmSpace",r[r.sixPerEmSpace=8198]="sixPerEmSpace",r[r.figureSpace=8199]="figureSpace",r[r.punctuationSpace=8200]="punctuationSpace",r[r.thinSpace=8201]="thinSpace",r[r.hairSpace=8202]="hairSpace",r[r.zeroWidthSpace=8203]="zeroWidthSpace",r[r.narrowNoBreakSpace=8239]="narrowNoBreakSpace",r[r.ideographicSpace=12288]="ideographicSpace",r[r.mathematicalSpace=8287]="mathematicalSpace",r[r.ogham=5760]="ogham",r[r._=95]="_",r[r.$=36]="$",r[r._0=48]="_0",r[r._1=49]="_1",r[r._2=50]="_2",r[r._3=51]="_3",r[r._4=52]="_4",r[r._5=53]="_5",r[r._6=54]="_6",r[r._7=55]="_7",r[r._8=56]="_8",r[r._9=57]="_9",r[r.a=97]="a",r[r.b=98]="b",r[r.c=99]="c",r[r.d=100]="d",r[r.e=101]="e",r[r.f=102]="f",r[r.g=103]="g",r[r.h=104]="h",r[r.i=105]="i",r[r.j=106]="j",r[r.k=107]="k",r[r.l=108]="l",r[r.m=109]="m",r[r.n=110]="n",r[r.o=111]="o",r[r.p=112]="p",r[r.q=113]="q",r[r.r=114]="r",r[r.s=115]="s",r[r.t=116]="t",r[r.u=117]="u",r[r.v=118]="v",r[r.w=119]="w",r[r.x=120]="x",r[r.y=121]="y",r[r.z=122]="z",r[r.A=65]="A",r[r.B=66]="B",r[r.C=67]="C",r[r.D=68]="D",r[r.E=69]="E",r[r.F=70]="F",r[r.G=71]="G",r[r.H=72]="H",r[r.I=73]="I",r[r.J=74]="J",r[r.K=75]="K",r[r.L=76]="L",r[r.M=77]="M",r[r.N=78]="N",r[r.O=79]="O",r[r.P=80]="P",r[r.Q=81]="Q",r[r.R=82]="R",r[r.S=83]="S",r[r.T=84]="T",r[r.U=85]="U",r[r.V=86]="V",r[r.W=87]="W",r[r.X=88]="X",r[r.Y=89]="Y",r[r.Z=90]="Z",r[r.ampersand=38]="ampersand",r[r.asterisk=42]="asterisk",r[r.at=64]="at",r[r.backslash=92]="backslash",r[r.bar=124]="bar",r[r.caret=94]="caret",r[r.closeBrace=125]="closeBrace",r[r.closeBracket=93]="closeBracket",r[r.closeParen=41]="closeParen",r[r.colon=58]="colon",r[r.comma=44]="comma",r[r.dot=46]="dot",r[r.doubleQuote=34]="doubleQuote",r[r.equals=61]="equals",r[r.exclamation=33]="exclamation",r[r.greaterThan=62]="greaterThan",r[r.lessThan=60]="lessThan",r[r.minus=45]="minus",r[r.openBrace=123]="openBrace",r[r.openBracket=91]="openBracket",r[r.openParen=40]="openParen",r[r.percent=37]="percent",r[r.plus=43]="plus",r[r.question=63]="question",r[r.semicolon=59]="semicolon",r[r.singleQuote=39]="singleQuote",r[r.slash=47]="slash",r[r.tilde=126]="tilde",r[r.backspace=8]="backspace",r[r.formFeed=12]="formFeed",r[r.byteOrderMark=65279]="byteOrderMark",r[r.tab=9]="tab",r[r.verticalTab=11]="verticalTab"})(C||(C={}));function I(r,o){const i=[],n=new Object;let s;const d={value:{},offset:0,length:0,type:"object",parent:void 0};let y=!1;function A(E,R,O,K){d.value=E,d.offset=R,d.length=O,d.type=K,d.colonOffset=void 0,s=d}try{v(r,{onObjectBegin:(E,R)=>{if(o<=E)throw n;s=void 0,y=o>E,i.push("")},onObjectProperty:(E,R,O)=>{if(o<R||(A(E,R,O,"property"),i[i.length-1]=E,o<=R+O))throw n},onObjectEnd:(E,R)=>{if(o<=E)throw n;s=void 0,i.pop()},onArrayBegin:(E,R)=>{if(o<=E)throw n;s=void 0,i.push(0)},onArrayEnd:(E,R)=>{if(o<=E)throw n;s=void 0,i.pop()},onLiteralValue:(E,R,O)=>{if(o<R||(A(E,R,O,l(E)),o<=R+O))throw n},onSeparator:(E,R,O)=>{if(o<=R)throw n;if(E===":"&&s&&s.type==="property")s.colonOffset=R,y=!1,s=void 0;else if(E===","){const K=i[i.length-1];typeof K=="number"?i[i.length-1]=K+1:(y=!0,i[i.length-1]=""),s=void 0}}})}catch(E){if(E!==n)throw E}return{path:i,previousNode:s,isAtPropertyKey:y,matches:E=>{let R=0;for(let O=0;R<E.length&&O<i.length;O++)if(E[R]===i[O]||E[R]==="*")R++;else if(E[R]!=="**")return!1;return R===E.length}}}e.getLocation=I;function m(r,o=[],i=P.DEFAULT){let n=null,s=[];const d=[];function y(E){Array.isArray(s)?s.push(E):n!==null&&(s[n]=E)}return v(r,{onObjectBegin:()=>{const E={};y(E),d.push(s),s=E,n=null},onObjectProperty:E=>{n=E},onObjectEnd:()=>{s=d.pop()},onArrayBegin:()=>{const E=[];y(E),d.push(s),s=E,n=null},onArrayEnd:()=>{s=d.pop()},onLiteralValue:y,onError:(E,R,O)=>{o.push({error:E,offset:R,length:O})}},i),s[0]}e.parse=m;function u(r,o=[],i=P.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(E){n.type==="property"&&(n.length=E-n.offset,n=n.parent)}function d(E){return n.children.push(E),E}v(r,{onObjectBegin:E=>{n=d({type:"object",offset:E,length:-1,parent:n,children:[]})},onObjectProperty:(E,R,O)=>{n=d({type:"property",offset:R,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:E,offset:R,length:O,parent:n})},onObjectEnd:(E,R)=>{n.length=E+R-n.offset,n=n.parent,s(E+R)},onArrayBegin:(E,R)=>{n=d({type:"array",offset:E,length:-1,parent:n,children:[]})},onArrayEnd:(E,R)=>{n.length=E+R-n.offset,n=n.parent,s(E+R)},onLiteralValue:(E,R,O)=>{d({type:l(E),offset:R,length:O,parent:n,value:E}),s(R+O)},onSeparator:(E,R,O)=>{n.type==="property"&&(E===":"?n.colonOffset=R:E===","&&s(R))},onError:(E,R,O)=>{o.push({error:E,offset:R,length:O})}},i);const A=n.children[0];return A&&delete A.parent,A}e.parseTree=u;function c(r,o){if(!r)return;let i=r;for(let n of o)if(typeof n=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let s=!1;for(const d of i.children)if(Array.isArray(d.children)&&d.children[0].value===n){i=d.children[1],s=!0;break}if(!s)return}else{const s=n;if(i.type!=="array"||s<0||!Array.isArray(i.children)||s>=i.children.length)return;i=i.children[s]}return i}e.findNodeAtLocation=c;function b(r){if(!r.parent||!r.parent.children)return[];const o=b(r.parent);if(r.parent.type==="property"){const i=r.parent.children[0].value;o.push(i)}else if(r.parent.type==="array"){const i=r.parent.children.indexOf(r);i!==-1&&o.push(i)}return o}e.getNodePath=b;function g(r){switch(r.type){case"array":return r.children.map(g);case"object":const o=Object.create(null);for(let i of r.children){const n=i.children[1];n&&(o[i.children[0].value]=g(n))}return o;case"null":case"string":case"number":case"boolean":return r.value;default:return}}e.getNodeValue=g;function D(r,o,i=!1){return o>=r.offset&&o<r.offset+r.length||i&&o===r.offset+r.length}e.contains=D;function w(r,o,i=!1){if(D(r,o,i)){const n=r.children;if(Array.isArray(n))for(let s=0;s<n.length&&n[s].offset<=o;s++){const d=w(n[s],o,i);if(d)return d}return r}}e.findNodeAtOffset=w;function v(r,o,i=P.DEFAULT){const n=t(r,!1);function s(W){return W?()=>W(n.getTokenOffset(),n.getTokenLength()):()=>!0}function d(W){return W?ie=>W(ie,n.getTokenOffset(),n.getTokenLength()):()=>!0}const y=s(o.onObjectBegin),A=d(o.onObjectProperty),E=s(o.onObjectEnd),R=s(o.onArrayBegin),O=s(o.onArrayEnd),K=d(o.onLiteralValue),te=d(o.onSeparator),j=s(o.onComment),_=d(o.onError),U=i&&i.disallowComments,F=i&&i.allowTrailingComma;function M(){for(;;){const W=n.scan();switch(n.getTokenError()){case 4:V(14);break;case 5:V(15);break;case 3:V(13);break;case 1:U||V(11);break;case 2:V(12);break;case 6:V(16);break}switch(W){case 12:case 13:U?V(10):j();break;case 16:V(1);break;case 15:case 14:break;default:return W}}}function V(W,ie=[],oe=[]){if(_(W),ie.length+oe.length>0){let we=n.getToken();for(;we!==17;){if(ie.indexOf(we)!==-1){M();break}else if(oe.indexOf(we)!==-1)break;we=M()}}}function ee(W){const ie=n.getTokenValue();return W?K(ie):A(ie),M(),!0}function G(){switch(n.getToken()){case 11:let W=0;try{W=JSON.parse(n.getTokenValue()),typeof W!="number"&&(V(2),W=0)}catch(ie){V(2)}K(W);break;case 7:K(null);break;case 8:K(!0);break;case 9:K(!1);break;default:return!1}return M(),!0}function H(){return n.getToken()!==10?(V(3,[],[2,5]),!1):(ee(!1),n.getToken()===6?(te(":"),M(),B()||V(4,[],[2,5])):V(5,[],[2,5]),!0)}function q(){y(),M();let W=!1;for(;n.getToken()!==2&&n.getToken()!==17;){if(n.getToken()===5){if(W||V(4,[],[]),te(","),M(),n.getToken()===2&&F)break}else W&&V(6,[],[]);H()||V(4,[],[2,5]),W=!0}return E(),n.getToken()!==2?V(7,[2],[]):M(),!0}function z(){R(),M();let W=!1;for(;n.getToken()!==4&&n.getToken()!==17;){if(n.getToken()===5){if(W||V(4,[],[]),te(","),M(),n.getToken()===4&&F)break}else W&&V(6,[],[]);B()||V(4,[],[4,5]),W=!0}return O(),n.getToken()!==4?V(8,[4],[]):M(),!0}function B(){switch(n.getToken()){case 3:return z();case 1:return q();case 10:return ee(!0);default:return G()}}return M(),n.getToken()===17?i.allowEmptyContent?!0:(V(4,[],[]),!1):B()?(n.getToken()!==17&&V(9,[],[]),!0):(V(4,[],[]),!1)}e.visit=v;function a(r,o){let i=t(r),n=[],s,d=0,y;do switch(y=i.getPosition(),s=i.scan(),s){case 12:case 13:case 17:d!==y&&n.push(r.substring(d,y)),o!==void 0&&n.push(i.getTokenValue().replace(/[^\r\n]/g,o)),d=i.getPosition();break}while(s!==17);return n.join("")}e.stripComments=a;function l(r){switch(typeof r){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(r){if(Array.isArray(r))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=l}),define(ue[130],de([0,1,36]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function k(h,f,C){let I,m,u,c,b;if(f){for(c=f.offset,b=c+f.length,u=c;u>0&&!T(h,u-1);)u--;let d=b;for(;d<h.length&&!T(h,d);)d++;m=h.substring(u,d),I=P(m,C)}else m=h,I=0,u=0,c=0,b=h.length;const g=t(C,h);let D=!1,w=0,v;C.insertSpaces?v=p(" ",C.tabSize||4):v="	";const a=(0,S.createScanner)(m,!1);let l=!1;function r(){return g+p(v,I+w)}function o(){let d=a.scan();for(D=!1;d===15||d===14;)D=D||d===14,d=a.scan();return l=d===16||a.getTokenError()!==0,d}const i=[];function n(d,y,A){!l&&y<b&&A>c&&h.substring(y,A)!==d&&i.push({offset:y,length:A-y,content:d})}let s=o();if(s!==17){const d=a.getTokenOffset()+u,y=p(v,I);n(y,u,d)}for(;s!==17;){let d=a.getTokenOffset()+a.getTokenLength()+u,y=o(),A="";for(;!D&&(y===12||y===13);){const R=a.getTokenOffset()+u;n(" ",d,R),d=a.getTokenOffset()+a.getTokenLength()+u,A=y===12?r():"",y=o()}if(y===2)s!==1&&(w--,A=r());else if(y===4)s!==3&&(w--,A=r());else{switch(s){case 3:case 1:w++,A=r();break;case 5:case 12:A=r();break;case 13:D?A=r():A=" ";break;case 6:A=" ";break;case 10:if(y===6){A="";break}case 7:case 8:case 9:case 11:case 2:case 4:y===12||y===13?A=" ":y!==5&&y!==17&&(l=!0);break;case 16:l=!0;break}D&&(y===12||y===13)&&(A=r())}const E=a.getTokenOffset()+u;n(A,d,E),s=y}return i}e.format=k;function p(h,f){let C="";for(let I=0;I<f;I++)C+=h;return C}function P(h,f){let C=0,I=0;const m=f.tabSize||4;for(;C<h.length;){const u=h.charAt(C);if(u===" ")I++;else if(u==="	")I+=m;else break;C++}return Math.floor(I/m)}function t(h,f){for(let C=0;C<f.length;C++){const I=f.charAt(C);if(I==="\r")return C+1<f.length&&f.charAt(C+1)===`
`?`\r
`:"\r";if(I===`
`)return`
`}return h&&h.eol||`
`}e.getEOL=t;function T(h,f){return`\r
`.indexOf(h.charAt(f))!==-1}e.isEOL=T}),define(ue[131],de([0,1,36,130]),function(Y,e,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function p(f,C,I){return P(f,C,void 0,I)}e.removeProperty=p;function P(f,C,I,m,u){const c=C.slice(),b=[],g=(0,S.parseTree)(f,b);let D,w;for(;c.length>0&&(w=c.pop(),D=(0,S.findNodeAtLocation)(g,c),D===void 0&&I!==void 0);)typeof w=="string"?I={[w]:I}:I=[I];if(D)if(D.type==="object"&&typeof w=="string"&&Array.isArray(D.children)){const v=(0,S.findNodeAtLocation)(D,[w]);if(v!==void 0)if(I===void 0){if(!v.parent)throw new Error("Malformed AST");const a=D.children.indexOf(v.parent);let l,r=v.parent.offset+v.parent.length;if(a>0){const o=D.children[a-1];l=o.offset+o.length}else l=D.offset+1,D.children.length>1&&(r=D.children[1].offset);return t(f,{offset:l,length:r-l,content:""},m)}else return t(f,{offset:v.offset,length:v.length,content:JSON.stringify(I)},m);else{if(I===void 0)return[];const a=`${JSON.stringify(w)}: ${JSON.stringify(I)}`,l=u?u(D.children.map(o=>o.children[0].value)):D.children.length;let r;if(l>0){const o=D.children[l-1];r={offset:o.offset+o.length,length:0,content:","+a}}else D.children.length===0?r={offset:D.offset+1,length:0,content:a}:r={offset:D.offset+1,length:0,content:a+","};return t(f,r,m)}}else if(D.type==="array"&&typeof w=="number"&&Array.isArray(D.children))if(I!==void 0){const v=`${JSON.stringify(I)}`;let a;if(D.children.length===0||w===0)a={offset:D.offset+1,length:0,content:D.children.length===0?v:v+","};else{const l=w===-1||w>D.children.length?D.children.length:w,r=D.children[l-1];a={offset:r.offset+r.length,length:0,content:","+v}}return t(f,a,m)}else{const v=w,a=D.children[v];let l;if(D.children.length===1)l={offset:D.offset+1,length:D.length-2,content:""};else if(D.children.length-1===v){const r=D.children[v-1],o=r.offset+r.length,i=D.offset+D.length;l={offset:o,length:i-2-o,content:""}}else l={offset:a.offset,length:D.children[v+1].offset-a.offset,content:""};return t(f,l,m)}else throw new Error(`Can not add ${typeof w!="number"?"index":"property"} to parent of type ${D.type}`);else{if(I===void 0)throw new Error("Can not delete in empty document");return t(f,{offset:g?g.offset:0,length:g?g.length:0,content:JSON.stringify(I)},m)}}e.setProperty=P;function t(f,C,I){let m=T(f,C),u=C.offset,c=C.offset+C.content.length;if(C.length===0||C.content.length===0){for(;u>0&&!(0,k.isEOL)(m,u-1);)u--;for(;c<m.length&&!(0,k.isEOL)(m,c);)c++}const b=(0,k.format)(m,{offset:u,length:c-u},I);for(let D=b.length-1;D>=0;D--){const w=b[D];m=T(m,w),u=Math.min(u,w.offset),c=Math.max(c,w.offset+w.length),c+=w.content.length-w.length}const g=f.length-(m.length-c)-u;return[{offset:u,length:g,content:m.substring(u,c)}]}e.withFormatting=t;function T(f,C){return f.substring(0,C.offset)+C.content+f.substring(C.offset+C.length)}e.applyEdit=T;function h(f,C){let I=C.slice(0).sort((u,c)=>{const b=u.offset-c.offset;return b===0?u.length-c.length:b}),m=f.length;for(let u=I.length-1;u>=0;u--){let c=I[u];if(c.offset+c.length<=m)f=T(f,c);else throw new Error("Overlapping edit");m=c.offset}return f}e.applyEdits=h}),define(ue[3],de([0,1,85,53]),function(Y,e,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const p=!1;let P=null;function t(n){P=n}if(e.setDisposableTracker=t,p){const n="__is_disposable_tracked__";t(new class{trackDisposable(s){const d=new Error("Potentially leaked disposable").stack;setTimeout(()=>{s[n]||console.log(d)},3e3)}setParent(s,d){if(s&&s!==w.None)try{s[n]=!0}catch{}}markAsDisposed(s){if(s&&s!==w.None)try{s[n]=!0}catch{}}markAsSingleton(s){}})}function T(n){return P?.trackDisposable(n),n}function h(n){P?.markAsDisposed(n)}function f(n,s){P?.setParent(n,s)}function C(n,s){if(!!P)for(const d of n)P.setParent(d,s)}function I(n){return P?.markAsSingleton(n),n}e.markAsSingleton=I;class m extends Error{constructor(s){super(`Encountered errors while disposing of store. Errors: [${s.join(", ")}]`);this.errors=s}}e.MultiDisposeError=m;function u(n){return typeof n.dispose=="function"&&n.dispose.length===0}e.isDisposable=u;function c(n){if(k.Iterable.is(n)){let s=[];for(const d of n)if(d)try{d.dispose()}catch(y){s.push(y)}if(s.length===1)throw s[0];if(s.length>1)throw new m(s);return Array.isArray(n)?[]:n}else if(n)return n.dispose(),n}e.dispose=c;function b(...n){const s=g(()=>c(n));return C(n,s),s}e.combinedDisposable=b;function g(n){const s=T({dispose:(0,S.once)(()=>{h(s),n()})});return s}e.toDisposable=g;class D{constructor(){this._toDispose=new Set,this._isDisposed=!1,T(this)}dispose(){this._isDisposed||(h(this),this._isDisposed=!0,this.clear())}clear(){try{c(this._toDispose.values())}finally{this._toDispose.clear()}}add(s){if(!s)return s;if(s===this)throw new Error("Cannot register a disposable on itself!");return f(s,this),this._isDisposed?D.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(s),s}}e.DisposableStore=D,D.DISABLE_DISPOSED_WARNING=!1;class w{constructor(){this._store=new D,T(this),f(this._store,this)}dispose(){h(this),this._store.dispose()}_register(s){if(s===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(s)}}e.Disposable=w,w.None=Object.freeze({dispose(){}});class v{constructor(){this._isDisposed=!1,T(this)}get value(){return this._isDisposed?void 0:this._value}set value(s){this._isDisposed||s===this._value||(this._value?.dispose(),s&&f(s,this),this._value=s)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,h(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const s=this._value;return this._value=void 0,s&&f(s,null),s}}e.MutableDisposable=v;class a{constructor(s){this._disposable=s,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=a;class l{constructor(){this.references=new Map}acquire(s,...d){let y=this.references.get(s);y||(y={counter:0,object:this.createReferencedObject(s,...d)},this.references.set(s,y));const{object:A}=y,E=(0,S.once)(()=>{--y.counter==0&&(this.destroyReferencedObject(s,y.object),this.references.delete(s))});return y.counter++,{object:A,dispose:E}}}e.ReferenceCollection=l;class r{constructor(s){this.referenceCollection=s}async acquire(s,...d){const y=this.referenceCollection.acquire(s,...d);try{return{object:await y.object,dispose:()=>y.dispose()}}catch(A){throw y.dispose(),A}}}e.AsyncReferenceCollection=r;class o{constructor(s){this.object=s}dispose(){}}e.ImmortalReference=o;function i(n){const s=new D;try{n(s)}finally{s.dispose()}}e.disposeOnReturn=i}),define(ue[132],de([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class S{constructor(P){this.element=P,this.next=S.Undefined,this.prev=S.Undefined}}S.Undefined=new S(void 0);class k{constructor(){this._first=S.Undefined,this._last=S.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===S.Undefined}clear(){let P=this._first;for(;P!==S.Undefined;){const t=P.next;P.prev=S.Undefined,P.next=S.Undefined,P=t}this._first=S.Undefined,this._last=S.Undefined,this._size=0}unshift(P){return this._insert(P,!1)}push(P){return this._insert(P,!0)}_insert(P,t){const T=new S(P);if(this._first===S.Undefined)this._first=T,this._last=T;else if(t){const f=this._last;this._last=T,T.prev=f,f.next=T}else{const f=this._first;this._first=T,T.next=f,f.prev=T}this._size+=1;let h=!1;return()=>{h||(h=!0,this._remove(T))}}shift(){if(this._first!==S.Undefined){const P=this._first.element;return this._remove(this._first),P}}pop(){if(this._last!==S.Undefined){const P=this._last.element;return this._remove(this._last),P}}_remove(P){if(P.prev!==S.Undefined&&P.next!==S.Undefined){const t=P.prev;t.next=P.next,P.next.prev=t}else P.prev===S.Undefined&&P.next===S.Undefined?(this._first=S.Undefined,this._last=S.Undefined):P.next===S.Undefined?(this._last=this._last.prev,this._last.next=S.Undefined):P.prev===S.Undefined&&(this._first=this._first.next,this._first.prev=S.Undefined);this._size-=1}*[Symbol.iterator](){let P=this._first;for(;P!==S.Undefined;)yield P.element,P=P.next}}e.LinkedList=k}),function(Y,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(Y=typeof globalThis!="undefined"?globalThis:Y||self,Y.marked=e())}(this,function(){"use strict";function Y(ve,fe){for(var pe=0;pe<fe.length;pe++){var J=fe[pe];J.enumerable=J.enumerable||!1,J.configurable=!0,"value"in J&&(J.writable=!0),Object.defineProperty(ve,J.key,J)}}function e(ve,fe,pe){return fe&&Y(ve.prototype,fe),pe&&Y(ve,pe),ve}function S(ve,fe){if(!!ve){if(typeof ve=="string")return k(ve,fe);var pe=Object.prototype.toString.call(ve).slice(8,-1);if(pe==="Object"&&ve.constructor&&(pe=ve.constructor.name),pe==="Map"||pe==="Set")return Array.from(ve);if(pe==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(pe))return k(ve,fe)}}function k(ve,fe){(fe==null||fe>ve.length)&&(fe=ve.length);for(var pe=0,J=new Array(fe);pe<fe;pe++)J[pe]=ve[pe];return J}function p(ve,fe){var pe=typeof Symbol!="undefined"&&ve[Symbol.iterator]||ve["@@iterator"];if(pe)return(pe=pe.call(ve)).next.bind(pe);if(Array.isArray(ve)||(pe=S(ve))||fe&&ve&&typeof ve.length=="number"){pe&&(ve=pe);var J=0;return function(){return J>=ve.length?{done:!0}:{done:!1,value:ve[J++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}var P={exports:{}};function t(){return{baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function T(ve){P.exports.defaults=ve}P.exports={defaults:t(),getDefaults:t,changeDefaults:T};var h=/[&<>"']/,f=/[&<>"']/g,C=/[<>"']|&(?!#?\w+;)/,I=/[<>"']|&(?!#?\w+;)/g,m={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},u=function(fe){return m[fe]};function c(ve,fe){if(fe){if(h.test(ve))return ve.replace(f,u)}else if(C.test(ve))return ve.replace(I,u);return ve}var b=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function g(ve){return ve.replace(b,function(fe,pe){return pe=pe.toLowerCase(),pe==="colon"?":":pe.charAt(0)==="#"?pe.charAt(1)==="x"?String.fromCharCode(parseInt(pe.substring(2),16)):String.fromCharCode(+pe.substring(1)):""})}var D=/(^|[^\[])\^/g;function w(ve,fe){ve=ve.source||ve,fe=fe||"";var pe={replace:function(x,Q){return Q=Q.source||Q,Q=Q.replace(D,"$1"),ve=ve.replace(x,Q),pe},getRegex:function(){return new RegExp(ve,fe)}};return pe}var v=/[^\w:]/g,a=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function l(ve,fe,pe){if(ve){var J;try{J=decodeURIComponent(g(pe)).replace(v,"").toLowerCase()}catch(x){return null}if(J.indexOf("javascript:")===0||J.indexOf("vbscript:")===0||J.indexOf("data:")===0)return null}fe&&!a.test(pe)&&(pe=s(fe,pe));try{pe=encodeURI(pe).replace(/%25/g,"%")}catch(x){return null}return pe}var r={},o=/^[^:]+:\/*[^/]*$/,i=/^([^:]+:)[\s\S]*$/,n=/^([^:]+:\/*[^/]*)[\s\S]*$/;function s(ve,fe){r[" "+ve]||(o.test(ve)?r[" "+ve]=ve+"/":r[" "+ve]=E(ve,"/",!0)),ve=r[" "+ve];var pe=ve.indexOf(":")===-1;return fe.substring(0,2)==="//"?pe?fe:ve.replace(i,"$1")+fe:fe.charAt(0)==="/"?pe?fe:ve.replace(n,"$1")+fe:ve+fe}var d={exec:function(){}};function y(ve){for(var fe=1,pe,J;fe<arguments.length;fe++){pe=arguments[fe];for(J in pe)Object.prototype.hasOwnProperty.call(pe,J)&&(ve[J]=pe[J])}return ve}function A(ve,fe){var pe=ve.replace(/\|/g,function(Q,re,Ee){for(var Ue=!1,_e=re;--_e>=0&&Ee[_e]==="\\";)Ue=!Ue;return Ue?"|":" |"}),J=pe.split(/ \|/),x=0;if(J[0].trim()||J.shift(),J[J.length-1].trim()||J.pop(),J.length>fe)J.splice(fe);else for(;J.length<fe;)J.push("");for(;x<J.length;x++)J[x]=J[x].trim().replace(/\\\|/g,"|");return J}function E(ve,fe,pe){var J=ve.length;if(J===0)return"";for(var x=0;x<J;){var Q=ve.charAt(J-x-1);if(Q===fe&&!pe)x++;else if(Q!==fe&&pe)x++;else break}return ve.substr(0,J-x)}function R(ve,fe){if(ve.indexOf(fe[1])===-1)return-1;for(var pe=ve.length,J=0,x=0;x<pe;x++)if(ve[x]==="\\")x++;else if(ve[x]===fe[0])J++;else if(ve[x]===fe[1]&&(J--,J<0))return x;return-1}function O(ve){ve&&ve.sanitize&&!ve.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function K(ve,fe){if(fe<1)return"";for(var pe="";fe>1;)fe&1&&(pe+=ve),fe>>=1,ve+=ve;return pe+ve}var te={escape:c,unescape:g,edit:w,cleanUrl:l,resolveUrl:s,noopTest:d,merge:y,splitCells:A,rtrim:E,findClosingBracket:R,checkSanitizeDeprecation:O,repeatString:K},j=P.exports.defaults,_=te.rtrim,U=te.splitCells,F=te.escape,M=te.findClosingBracket;function V(ve,fe,pe,J){var x=fe.href,Q=fe.title?F(fe.title):null,re=ve[1].replace(/\\([\[\]])/g,"$1");if(ve[0].charAt(0)!=="!"){J.state.inLink=!0;var Ee={type:"link",raw:pe,href:x,title:Q,text:re,tokens:J.inlineTokens(re,[])};return J.state.inLink=!1,Ee}else return{type:"image",raw:pe,href:x,title:Q,text:F(re)}}function ee(ve,fe){var pe=ve.match(/^(\s+)(?:```)/);if(pe===null)return fe;var J=pe[1];return fe.split(`
`).map(function(x){var Q=x.match(/^\s+/);if(Q===null)return x;var re=Q[0];return re.length>=J.length?x.slice(J.length):x}).join(`
`)}var G=function(){function ve(pe){this.options=pe||j}var fe=ve.prototype;return fe.space=function(J){var x=this.rules.block.newline.exec(J);if(x)return x[0].length>1?{type:"space",raw:x[0]}:{raw:`
`}},fe.code=function(J){var x=this.rules.block.code.exec(J);if(x){var Q=x[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:x[0],codeBlockStyle:"indented",text:this.options.pedantic?Q:_(Q,`
`)}}},fe.fences=function(J){var x=this.rules.block.fences.exec(J);if(x){var Q=x[0],re=ee(Q,x[3]||"");return{type:"code",raw:Q,lang:x[2]?x[2].trim():x[2],text:re}}},fe.heading=function(J){var x=this.rules.block.heading.exec(J);if(x){var Q=x[2].trim();if(/#$/.test(Q)){var re=_(Q,"#");(this.options.pedantic||!re||/ $/.test(re))&&(Q=re.trim())}var Ee={type:"heading",raw:x[0],depth:x[1].length,text:Q,tokens:[]};return this.lexer.inline(Ee.text,Ee.tokens),Ee}},fe.hr=function(J){var x=this.rules.block.hr.exec(J);if(x)return{type:"hr",raw:x[0]}},fe.blockquote=function(J){var x=this.rules.block.blockquote.exec(J);if(x){var Q=x[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:x[0],tokens:this.lexer.blockTokens(Q,[]),text:Q}}},fe.list=function(J){var x=this.rules.block.list.exec(J);if(x){var Q,re,Ee,Ue,_e,ze,We,Ke,le,he,X=x[1].trim(),$=X.length>1,ye={type:"list",raw:"",ordered:$,start:$?+X.slice(0,-1):"",loose:!1,items:[]};X=$?"\\d{1,9}\\"+X.slice(-1):"\\"+X,this.options.pedantic&&(X=$?X:"[*+-]");for(var Te=new RegExp("^( {0,3}"+X+")((?: [^\\n]*| *)(?:\\n[^\\n]*)*(?:\\n|$))");J&&!(this.rules.block.hr.test(J)||!(x=Te.exec(J)));){le=x[2].split(`
`),this.options.pedantic?(Ue=2,he=le[0].trimLeft()):(Ue=x[2].search(/[^ ]/),Ue=x[1].length+(Ue>4?1:Ue),he=le[0].slice(Ue-x[1].length)),ze=!1,Q=x[0],!le[0]&&/^ *$/.test(le[1])&&(Q=x[1]+le.slice(0,2).join(`
`)+`
`,ye.loose=!0,le=[]);var Ge=new RegExp("^ {0,"+Math.min(3,Ue-1)+"}(?:[*+-]|\\d{1,9}[.)])");for(_e=1;_e<le.length;_e++){if(Ke=le[_e],this.options.pedantic&&(Ke=Ke.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),Ge.test(Ke)){Q=x[1]+le.slice(0,_e).join(`
`)+`
`;break}if(!ze){Ke.trim()||(ze=!0),Ke.search(/[^ ]/)>=Ue?he+=`
`+Ke.slice(Ue):he+=`
`+Ke;continue}if(Ke.search(/[^ ]/)>=Ue||!Ke.trim()){he+=`
`+Ke.slice(Ue);continue}else{Q=x[1]+le.slice(0,_e).join(`
`)+`
`;break}}ye.loose||(We?ye.loose=!0:/\n *\n *$/.test(Q)&&(We=!0)),this.options.gfm&&(re=/^\[[ xX]\] /.exec(he),re&&(Ee=re[0]!=="[ ] ",he=he.replace(/^\[[ xX]\] +/,""))),ye.items.push({type:"list_item",raw:Q,task:!!re,checked:Ee,loose:!1,text:he}),ye.raw+=Q,J=J.slice(Q.length)}ye.items[ye.items.length-1].raw=Q.trimRight(),ye.items[ye.items.length-1].text=he.trimRight(),ye.raw=ye.raw.trimRight();var Me=ye.items.length;for(_e=0;_e<Me;_e++)this.lexer.state.top=!1,ye.items[_e].tokens=this.lexer.blockTokens(ye.items[_e].text,[]),ye.items[_e].tokens.some(function(it){return it.type==="space"})&&(ye.loose=!0,ye.items[_e].loose=!0);return ye}},fe.html=function(J){var x=this.rules.block.html.exec(J);if(x){var Q={type:"html",raw:x[0],pre:!this.options.sanitizer&&(x[1]==="pre"||x[1]==="script"||x[1]==="style"),text:x[0]};return this.options.sanitize&&(Q.type="paragraph",Q.text=this.options.sanitizer?this.options.sanitizer(x[0]):F(x[0]),Q.tokens=[],this.lexer.inline(Q.text,Q.tokens)),Q}},fe.def=function(J){var x=this.rules.block.def.exec(J);if(x){x[3]&&(x[3]=x[3].substring(1,x[3].length-1));var Q=x[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:Q,raw:x[0],href:x[2],title:x[3]}}},fe.table=function(J){var x=this.rules.block.table.exec(J);if(x){var Q={type:"table",header:U(x[1]).map(function(We){return{text:We}}),align:x[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:x[3]?x[3].replace(/\n$/,"").split(`
`):[]};if(Q.header.length===Q.align.length){Q.raw=x[0];var re=Q.align.length,Ee,Ue,_e,ze;for(Ee=0;Ee<re;Ee++)/^ *-+: *$/.test(Q.align[Ee])?Q.align[Ee]="right":/^ *:-+: *$/.test(Q.align[Ee])?Q.align[Ee]="center":/^ *:-+ *$/.test(Q.align[Ee])?Q.align[Ee]="left":Q.align[Ee]=null;for(re=Q.rows.length,Ee=0;Ee<re;Ee++)Q.rows[Ee]=U(Q.rows[Ee],Q.header.length).map(function(We){return{text:We}});for(re=Q.header.length,Ue=0;Ue<re;Ue++)Q.header[Ue].tokens=[],this.lexer.inlineTokens(Q.header[Ue].text,Q.header[Ue].tokens);for(re=Q.rows.length,Ue=0;Ue<re;Ue++)for(ze=Q.rows[Ue],_e=0;_e<ze.length;_e++)ze[_e].tokens=[],this.lexer.inlineTokens(ze[_e].text,ze[_e].tokens);return Q}}},fe.lheading=function(J){var x=this.rules.block.lheading.exec(J);if(x){var Q={type:"heading",raw:x[0],depth:x[2].charAt(0)==="="?1:2,text:x[1],tokens:[]};return this.lexer.inline(Q.text,Q.tokens),Q}},fe.paragraph=function(J){var x=this.rules.block.paragraph.exec(J);if(x){var Q={type:"paragraph",raw:x[0],text:x[1].charAt(x[1].length-1)===`
`?x[1].slice(0,-1):x[1],tokens:[]};return this.lexer.inline(Q.text,Q.tokens),Q}},fe.text=function(J){var x=this.rules.block.text.exec(J);if(x){var Q={type:"text",raw:x[0],text:x[0],tokens:[]};return this.lexer.inline(Q.text,Q.tokens),Q}},fe.escape=function(J){var x=this.rules.inline.escape.exec(J);if(x)return{type:"escape",raw:x[0],text:F(x[1])}},fe.tag=function(J){var x=this.rules.inline.tag.exec(J);if(x)return!this.lexer.state.inLink&&/^<a /i.test(x[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(x[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(x[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(x[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:x[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(x[0]):F(x[0]):x[0]}},fe.link=function(J){var x=this.rules.inline.link.exec(J);if(x){var Q=x[2].trim();if(!this.options.pedantic&&/^</.test(Q)){if(!/>$/.test(Q))return;var re=_(Q.slice(0,-1),"\\");if((Q.length-re.length)%2==0)return}else{var Ee=M(x[2],"()");if(Ee>-1){var Ue=x[0].indexOf("!")===0?5:4,_e=Ue+x[1].length+Ee;x[2]=x[2].substring(0,Ee),x[0]=x[0].substring(0,_e).trim(),x[3]=""}}var ze=x[2],We="";if(this.options.pedantic){var Ke=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(ze);Ke&&(ze=Ke[1],We=Ke[3])}else We=x[3]?x[3].slice(1,-1):"";return ze=ze.trim(),/^</.test(ze)&&(this.options.pedantic&&!/>$/.test(Q)?ze=ze.slice(1):ze=ze.slice(1,-1)),V(x,{href:ze&&ze.replace(this.rules.inline._escapes,"$1"),title:We&&We.replace(this.rules.inline._escapes,"$1")},x[0],this.lexer)}},fe.reflink=function(J,x){var Q;if((Q=this.rules.inline.reflink.exec(J))||(Q=this.rules.inline.nolink.exec(J))){var re=(Q[2]||Q[1]).replace(/\s+/g," ");if(re=x[re.toLowerCase()],!re||!re.href){var Ee=Q[0].charAt(0);return{type:"text",raw:Ee,text:Ee}}return V(Q,re,Q[0],this.lexer)}},fe.emStrong=function(J,x,Q){Q===void 0&&(Q="");var re=this.rules.inline.emStrong.lDelim.exec(J);if(!!re&&!(re[3]&&Q.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Ee=re[1]||re[2]||"";if(!Ee||Ee&&(Q===""||this.rules.inline.punctuation.exec(Q))){var Ue=re[0].length-1,_e,ze,We=Ue,Ke=0,le=re[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(le.lastIndex=0,x=x.slice(-1*J.length+Ue);(re=le.exec(x))!=null;)if(_e=re[1]||re[2]||re[3]||re[4]||re[5]||re[6],!!_e){if(ze=_e.length,re[3]||re[4]){We+=ze;continue}else if((re[5]||re[6])&&Ue%3&&!((Ue+ze)%3)){Ke+=ze;continue}if(We-=ze,!(We>0)){if(ze=Math.min(ze,ze+We+Ke),Math.min(Ue,ze)%2){var he=J.slice(1,Ue+re.index+ze);return{type:"em",raw:J.slice(0,Ue+re.index+ze+1),text:he,tokens:this.lexer.inlineTokens(he,[])}}var X=J.slice(2,Ue+re.index+ze-1);return{type:"strong",raw:J.slice(0,Ue+re.index+ze+1),text:X,tokens:this.lexer.inlineTokens(X,[])}}}}}},fe.codespan=function(J){var x=this.rules.inline.code.exec(J);if(x){var Q=x[2].replace(/\n/g," "),re=/[^ ]/.test(Q),Ee=/^ /.test(Q)&&/ $/.test(Q);return re&&Ee&&(Q=Q.substring(1,Q.length-1)),Q=F(Q,!0),{type:"codespan",raw:x[0],text:Q}}},fe.br=function(J){var x=this.rules.inline.br.exec(J);if(x)return{type:"br",raw:x[0]}},fe.del=function(J){var x=this.rules.inline.del.exec(J);if(x)return{type:"del",raw:x[0],text:x[2],tokens:this.lexer.inlineTokens(x[2],[])}},fe.autolink=function(J,x){var Q=this.rules.inline.autolink.exec(J);if(Q){var re,Ee;return Q[2]==="@"?(re=F(this.options.mangle?x(Q[1]):Q[1]),Ee="mailto:"+re):(re=F(Q[1]),Ee=re),{type:"link",raw:Q[0],text:re,href:Ee,tokens:[{type:"text",raw:re,text:re}]}}},fe.url=function(J,x){var Q;if(Q=this.rules.inline.url.exec(J)){var re,Ee;if(Q[2]==="@")re=F(this.options.mangle?x(Q[0]):Q[0]),Ee="mailto:"+re;else{var Ue;do Ue=Q[0],Q[0]=this.rules.inline._backpedal.exec(Q[0])[0];while(Ue!==Q[0]);re=F(Q[0]),Q[1]==="www."?Ee="http://"+re:Ee=re}return{type:"link",raw:Q[0],text:re,href:Ee,tokens:[{type:"text",raw:re,text:re}]}}},fe.inlineText=function(J,x){var Q=this.rules.inline.text.exec(J);if(Q){var re;return this.lexer.state.inRawBlock?re=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(Q[0]):F(Q[0]):Q[0]:re=F(this.options.smartypants?x(Q[0]):Q[0]),{type:"text",raw:Q[0],text:re}}},ve}(),H=te.noopTest,q=te.edit,z=te.merge,B={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)( [^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,table:H,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};B._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,B._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,B.def=q(B.def).replace("label",B._label).replace("title",B._title).getRegex(),B.bullet=/(?:[*+-]|\d{1,9}[.)])/,B.listItemStart=q(/^( *)(bull) */).replace("bull",B.bullet).getRegex(),B.list=q(B.list).replace(/bull/g,B.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+B.def.source+")").getRegex(),B._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",B._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,B.html=q(B.html,"i").replace("comment",B._comment).replace("tag",B._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),B.paragraph=q(B._paragraph).replace("hr",B.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",B._tag).getRegex(),B.blockquote=q(B.blockquote).replace("paragraph",B.paragraph).getRegex(),B.normal=z({},B),B.gfm=z({},B.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)\\|?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),B.gfm.table=q(B.gfm.table).replace("hr",B.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",B._tag).getRegex(),B.pedantic=z({},B.normal,{html:q(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",B._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:H,paragraph:q(B.normal._paragraph).replace("hr",B.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",B.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var W={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:H,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_*]*?\*[^_*]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^_*]*?\_[^_*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:H,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};W._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",W.punctuation=q(W.punctuation).replace(/punctuation/g,W._punctuation).getRegex(),W.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,W.escapedEmSt=/\\\*|\\_/g,W._comment=q(B._comment).replace("(?:-->|$)","-->").getRegex(),W.emStrong.lDelim=q(W.emStrong.lDelim).replace(/punct/g,W._punctuation).getRegex(),W.emStrong.rDelimAst=q(W.emStrong.rDelimAst,"g").replace(/punct/g,W._punctuation).getRegex(),W.emStrong.rDelimUnd=q(W.emStrong.rDelimUnd,"g").replace(/punct/g,W._punctuation).getRegex(),W._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,W._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,W._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,W.autolink=q(W.autolink).replace("scheme",W._scheme).replace("email",W._email).getRegex(),W._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,W.tag=q(W.tag).replace("comment",W._comment).replace("attribute",W._attribute).getRegex(),W._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,W._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,W._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,W.link=q(W.link).replace("label",W._label).replace("href",W._href).replace("title",W._title).getRegex(),W.reflink=q(W.reflink).replace("label",W._label).getRegex(),W.reflinkSearch=q(W.reflinkSearch,"g").replace("reflink",W.reflink).replace("nolink",W.nolink).getRegex(),W.normal=z({},W),W.pedantic=z({},W.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:q(/^!?\[(label)\]\((.*?)\)/).replace("label",W._label).getRegex(),reflink:q(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",W._label).getRegex()}),W.gfm=z({},W.normal,{escape:q(W.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),W.gfm.url=q(W.gfm.url,"i").replace("email",W.gfm._extended_email).getRegex(),W.breaks=z({},W.gfm,{br:q(W.br).replace("{2,}","*").getRegex(),text:q(W.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var ie={block:B,inline:W},oe=G,we=P.exports.defaults,se=ie.block,ae=ie.inline,ke=te.repeatString;function De(ve){return ve.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function Oe(ve){var fe="",pe,J,x=ve.length;for(pe=0;pe<x;pe++)J=ve.charCodeAt(pe),Math.random()>.5&&(J="x"+J.toString(16)),fe+="&#"+J+";";return fe}var Be=function(){function ve(pe){this.tokens=[],this.tokens.links=Object.create(null),this.options=pe||we,this.options.tokenizer=this.options.tokenizer||new oe,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var J={block:se.normal,inline:ae.normal};this.options.pedantic?(J.block=se.pedantic,J.inline=ae.pedantic):this.options.gfm&&(J.block=se.gfm,this.options.breaks?J.inline=ae.breaks:J.inline=ae.gfm),this.tokenizer.rules=J}ve.lex=function(J,x){var Q=new ve(x);return Q.lex(J)},ve.lexInline=function(J,x){var Q=new ve(x);return Q.inlineTokens(J)};var fe=ve.prototype;return fe.lex=function(J){J=J.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(J,this.tokens);for(var x;x=this.inlineQueue.shift();)this.inlineTokens(x.src,x.tokens);return this.tokens},fe.blockTokens=function(J,x){var Q=this;x===void 0&&(x=[]),this.options.pedantic&&(J=J.replace(/^ +$/gm,""));for(var re,Ee,Ue,_e;J;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(We){return(re=We.call({lexer:Q},J,x))?(J=J.substring(re.raw.length),x.push(re),!0):!1}))){if(re=this.tokenizer.space(J)){J=J.substring(re.raw.length),re.type&&x.push(re);continue}if(re=this.tokenizer.code(J)){J=J.substring(re.raw.length),Ee=x[x.length-1],Ee&&(Ee.type==="paragraph"||Ee.type==="text")?(Ee.raw+=`
`+re.raw,Ee.text+=`
`+re.text,this.inlineQueue[this.inlineQueue.length-1].src=Ee.text):x.push(re);continue}if(re=this.tokenizer.fences(J)){J=J.substring(re.raw.length),x.push(re);continue}if(re=this.tokenizer.heading(J)){J=J.substring(re.raw.length),x.push(re);continue}if(re=this.tokenizer.hr(J)){J=J.substring(re.raw.length),x.push(re);continue}if(re=this.tokenizer.blockquote(J)){J=J.substring(re.raw.length),x.push(re);continue}if(re=this.tokenizer.list(J)){J=J.substring(re.raw.length),x.push(re);continue}if(re=this.tokenizer.html(J)){J=J.substring(re.raw.length),x.push(re);continue}if(re=this.tokenizer.def(J)){J=J.substring(re.raw.length),Ee=x[x.length-1],Ee&&(Ee.type==="paragraph"||Ee.type==="text")?(Ee.raw+=`
`+re.raw,Ee.text+=`
`+re.raw,this.inlineQueue[this.inlineQueue.length-1].src=Ee.text):this.tokens.links[re.tag]||(this.tokens.links[re.tag]={href:re.href,title:re.title});continue}if(re=this.tokenizer.table(J)){J=J.substring(re.raw.length),x.push(re);continue}if(re=this.tokenizer.lheading(J)){J=J.substring(re.raw.length),x.push(re);continue}if(Ue=J,this.options.extensions&&this.options.extensions.startBlock&&function(){var We=Infinity,Ke=J.slice(1),le=void 0;Q.options.extensions.startBlock.forEach(function(he){le=he.call({lexer:this},Ke),typeof le=="number"&&le>=0&&(We=Math.min(We,le))}),We<Infinity&&We>=0&&(Ue=J.substring(0,We+1))}(),this.state.top&&(re=this.tokenizer.paragraph(Ue))){Ee=x[x.length-1],_e&&Ee.type==="paragraph"?(Ee.raw+=`
`+re.raw,Ee.text+=`
`+re.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Ee.text):x.push(re),_e=Ue.length!==J.length,J=J.substring(re.raw.length);continue}if(re=this.tokenizer.text(J)){J=J.substring(re.raw.length),Ee=x[x.length-1],Ee&&Ee.type==="text"?(Ee.raw+=`
`+re.raw,Ee.text+=`
`+re.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Ee.text):x.push(re);continue}if(J){var ze="Infinite loop on byte: "+J.charCodeAt(0);if(this.options.silent){console.error(ze);break}else throw new Error(ze)}}return this.state.top=!0,x},fe.inline=function(J,x){this.inlineQueue.push({src:J,tokens:x})},fe.inlineTokens=function(J,x){var Q=this;x===void 0&&(x=[]);var re,Ee,Ue,_e=J,ze,We,Ke;if(this.tokens.links){var le=Object.keys(this.tokens.links);if(le.length>0)for(;(ze=this.tokenizer.rules.inline.reflinkSearch.exec(_e))!=null;)le.includes(ze[0].slice(ze[0].lastIndexOf("[")+1,-1))&&(_e=_e.slice(0,ze.index)+"["+ke("a",ze[0].length-2)+"]"+_e.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(ze=this.tokenizer.rules.inline.blockSkip.exec(_e))!=null;)_e=_e.slice(0,ze.index)+"["+ke("a",ze[0].length-2)+"]"+_e.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(ze=this.tokenizer.rules.inline.escapedEmSt.exec(_e))!=null;)_e=_e.slice(0,ze.index)+"++"+_e.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;J;)if(We||(Ke=""),We=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(X){return(re=X.call({lexer:Q},J,x))?(J=J.substring(re.raw.length),x.push(re),!0):!1}))){if(re=this.tokenizer.escape(J)){J=J.substring(re.raw.length),x.push(re);continue}if(re=this.tokenizer.tag(J)){J=J.substring(re.raw.length),Ee=x[x.length-1],Ee&&re.type==="text"&&Ee.type==="text"?(Ee.raw+=re.raw,Ee.text+=re.text):x.push(re);continue}if(re=this.tokenizer.link(J)){J=J.substring(re.raw.length),x.push(re);continue}if(re=this.tokenizer.reflink(J,this.tokens.links)){J=J.substring(re.raw.length),Ee=x[x.length-1],Ee&&re.type==="text"&&Ee.type==="text"?(Ee.raw+=re.raw,Ee.text+=re.text):x.push(re);continue}if(re=this.tokenizer.emStrong(J,_e,Ke)){J=J.substring(re.raw.length),x.push(re);continue}if(re=this.tokenizer.codespan(J)){J=J.substring(re.raw.length),x.push(re);continue}if(re=this.tokenizer.br(J)){J=J.substring(re.raw.length),x.push(re);continue}if(re=this.tokenizer.del(J)){J=J.substring(re.raw.length),x.push(re);continue}if(re=this.tokenizer.autolink(J,Oe)){J=J.substring(re.raw.length),x.push(re);continue}if(!this.state.inLink&&(re=this.tokenizer.url(J,Oe))){J=J.substring(re.raw.length),x.push(re);continue}if(Ue=J,this.options.extensions&&this.options.extensions.startInline&&function(){var X=Infinity,$=J.slice(1),ye=void 0;Q.options.extensions.startInline.forEach(function(Te){ye=Te.call({lexer:this},$),typeof ye=="number"&&ye>=0&&(X=Math.min(X,ye))}),X<Infinity&&X>=0&&(Ue=J.substring(0,X+1))}(),re=this.tokenizer.inlineText(Ue,De)){J=J.substring(re.raw.length),re.raw.slice(-1)!=="_"&&(Ke=re.raw.slice(-1)),We=!0,Ee=x[x.length-1],Ee&&Ee.type==="text"?(Ee.raw+=re.raw,Ee.text+=re.text):x.push(re);continue}if(J){var he="Infinite loop on byte: "+J.charCodeAt(0);if(this.options.silent){console.error(he);break}else throw new Error(he)}}return x},e(ve,null,[{key:"rules",get:function(){return{block:se,inline:ae}}}]),ve}(),Xe=P.exports.defaults,Ze=te.cleanUrl,ge=te.escape,me=function(){function ve(pe){this.options=pe||Xe}var fe=ve.prototype;return fe.code=function(J,x,Q){var re=(x||"").match(/\S*/)[0];if(this.options.highlight){var Ee=this.options.highlight(J,re);Ee!=null&&Ee!==J&&(Q=!0,J=Ee)}return J=J.replace(/\n$/,"")+`
`,re?'<pre><code class="'+this.options.langPrefix+ge(re,!0)+'">'+(Q?J:ge(J,!0))+`</code></pre>
`:"<pre><code>"+(Q?J:ge(J,!0))+`</code></pre>
`},fe.blockquote=function(J){return`<blockquote>
`+J+`</blockquote>
`},fe.html=function(J){return J},fe.heading=function(J,x,Q,re){return this.options.headerIds?"<h"+x+' id="'+this.options.headerPrefix+re.slug(Q)+'">'+J+"</h"+x+`>
`:"<h"+x+">"+J+"</h"+x+`>
`},fe.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},fe.list=function(J,x,Q){var re=x?"ol":"ul",Ee=x&&Q!==1?' start="'+Q+'"':"";return"<"+re+Ee+`>
`+J+"</"+re+`>
`},fe.listitem=function(J){return"<li>"+J+`</li>
`},fe.checkbox=function(J){return"<input "+(J?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},fe.paragraph=function(J){return"<p>"+J+`</p>
`},fe.table=function(J,x){return x&&(x="<tbody>"+x+"</tbody>"),`<table>
<thead>
`+J+`</thead>
`+x+`</table>
`},fe.tablerow=function(J){return`<tr>
`+J+`</tr>
`},fe.tablecell=function(J,x){var Q=x.header?"th":"td",re=x.align?"<"+Q+' align="'+x.align+'">':"<"+Q+">";return re+J+"</"+Q+`>
`},fe.strong=function(J){return"<strong>"+J+"</strong>"},fe.em=function(J){return"<em>"+J+"</em>"},fe.codespan=function(J){return"<code>"+J+"</code>"},fe.br=function(){return this.options.xhtml?"<br/>":"<br>"},fe.del=function(J){return"<del>"+J+"</del>"},fe.link=function(J,x,Q){if(J=Ze(this.options.sanitize,this.options.baseUrl,J),J===null)return Q;var re='<a href="'+ge(J)+'"';return x&&(re+=' title="'+x+'"'),re+=">"+Q+"</a>",re},fe.image=function(J,x,Q){if(J=Ze(this.options.sanitize,this.options.baseUrl,J),J===null)return Q;var re='<img src="'+J+'" alt="'+Q+'"';return x&&(re+=' title="'+x+'"'),re+=this.options.xhtml?"/>":">",re},fe.text=function(J){return J},ve}(),Ie=function(){function ve(){}var fe=ve.prototype;return fe.strong=function(J){return J},fe.em=function(J){return J},fe.codespan=function(J){return J},fe.del=function(J){return J},fe.html=function(J){return J},fe.text=function(J){return J},fe.link=function(J,x,Q){return""+Q},fe.image=function(J,x,Q){return""+Q},fe.br=function(){return""},ve}(),Re=function(){function ve(){this.seen={}}var fe=ve.prototype;return fe.serialize=function(J){return J.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},fe.getNextSafeSlug=function(J,x){var Q=J,re=0;if(this.seen.hasOwnProperty(Q)){re=this.seen[J];do re++,Q=J+"-"+re;while(this.seen.hasOwnProperty(Q))}return x||(this.seen[J]=re,this.seen[Q]=0),Q},fe.slug=function(J,x){x===void 0&&(x={});var Q=this.serialize(J);return this.getNextSafeSlug(Q,x.dryrun)},ve}(),Le=me,He=Ie,Qe=Re,Je=P.exports.defaults,rt=te.unescape,ce=function(){function ve(pe){this.options=pe||Je,this.options.renderer=this.options.renderer||new Le,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new He,this.slugger=new Qe}ve.parse=function(J,x){var Q=new ve(x);return Q.parse(J)},ve.parseInline=function(J,x){var Q=new ve(x);return Q.parseInline(J)};var fe=ve.prototype;return fe.parse=function(J,x){x===void 0&&(x=!0);var Q="",re,Ee,Ue,_e,ze,We,Ke,le,he,X,$,ye,Te,Ge,Me,it,ct,ft,ht,mt=J.length;for(re=0;re<mt;re++){if(X=J[re],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[X.type]&&(ht=this.options.extensions.renderers[X.type].call({parser:this},X),ht!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(X.type))){Q+=ht||"";continue}switch(X.type){case"space":continue;case"hr":{Q+=this.renderer.hr();continue}case"heading":{Q+=this.renderer.heading(this.parseInline(X.tokens),X.depth,rt(this.parseInline(X.tokens,this.textRenderer)),this.slugger);continue}case"code":{Q+=this.renderer.code(X.text,X.lang,X.escaped);continue}case"table":{for(le="",Ke="",_e=X.header.length,Ee=0;Ee<_e;Ee++)Ke+=this.renderer.tablecell(this.parseInline(X.header[Ee].tokens),{header:!0,align:X.align[Ee]});for(le+=this.renderer.tablerow(Ke),he="",_e=X.rows.length,Ee=0;Ee<_e;Ee++){for(We=X.rows[Ee],Ke="",ze=We.length,Ue=0;Ue<ze;Ue++)Ke+=this.renderer.tablecell(this.parseInline(We[Ue].tokens),{header:!1,align:X.align[Ue]});he+=this.renderer.tablerow(Ke)}Q+=this.renderer.table(le,he);continue}case"blockquote":{he=this.parse(X.tokens),Q+=this.renderer.blockquote(he);continue}case"list":{for($=X.ordered,ye=X.start,Te=X.loose,_e=X.items.length,he="",Ee=0;Ee<_e;Ee++)Me=X.items[Ee],it=Me.checked,ct=Me.task,Ge="",Me.task&&(ft=this.renderer.checkbox(it),Te?Me.tokens.length>0&&Me.tokens[0].type==="paragraph"?(Me.tokens[0].text=ft+" "+Me.tokens[0].text,Me.tokens[0].tokens&&Me.tokens[0].tokens.length>0&&Me.tokens[0].tokens[0].type==="text"&&(Me.tokens[0].tokens[0].text=ft+" "+Me.tokens[0].tokens[0].text)):Me.tokens.unshift({type:"text",text:ft}):Ge+=ft),Ge+=this.parse(Me.tokens,Te),he+=this.renderer.listitem(Ge,ct,it);Q+=this.renderer.list(he,$,ye);continue}case"html":{Q+=this.renderer.html(X.text);continue}case"paragraph":{Q+=this.renderer.paragraph(this.parseInline(X.tokens));continue}case"text":{for(he=X.tokens?this.parseInline(X.tokens):X.text;re+1<mt&&J[re+1].type==="text";)X=J[++re],he+=`
`+(X.tokens?this.parseInline(X.tokens):X.text);Q+=x?this.renderer.paragraph(he):he;continue}default:{var vt='Token with "'+X.type+'" type was not found.';if(this.options.silent){console.error(vt);return}else throw new Error(vt)}}}return Q},fe.parseInline=function(J,x){x=x||this.renderer;var Q="",re,Ee,Ue,_e=J.length;for(re=0;re<_e;re++){if(Ee=J[re],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Ee.type]&&(Ue=this.options.extensions.renderers[Ee.type].call({parser:this},Ee),Ue!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Ee.type))){Q+=Ue||"";continue}switch(Ee.type){case"escape":{Q+=x.text(Ee.text);break}case"html":{Q+=x.html(Ee.text);break}case"link":{Q+=x.link(Ee.href,Ee.title,this.parseInline(Ee.tokens,x));break}case"image":{Q+=x.image(Ee.href,Ee.title,Ee.text);break}case"strong":{Q+=x.strong(this.parseInline(Ee.tokens,x));break}case"em":{Q+=x.em(this.parseInline(Ee.tokens,x));break}case"codespan":{Q+=x.codespan(Ee.text);break}case"br":{Q+=x.br();break}case"del":{Q+=x.del(this.parseInline(Ee.tokens,x));break}case"text":{Q+=x.text(Ee.text);break}default:{var ze='Token with "'+Ee.type+'" type was not found.';if(this.options.silent){console.error(ze);return}else throw new Error(ze)}}}return Q},ve}(),Se=Be,Pe=ce,$e=G,Ye=me,lt=Ie,tt=Re,at=te.merge,ot=te.checkSanitizeDeprecation,et=te.escape,ne=P.exports.getDefaults,be=P.exports.changeDefaults,Fe=P.exports.defaults;function Ae(ve,fe,pe){if(typeof ve=="undefined"||ve===null)throw new Error("marked(): input parameter is undefined or null");if(typeof ve!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(ve)+", string expected");if(typeof fe=="function"&&(pe=fe,fe=null),fe=at({},Ae.defaults,fe||{}),ot(fe),pe){var J=fe.highlight,x;try{x=Se.lex(ve,fe)}catch(Ue){return pe(Ue)}var Q=function(_e){var ze;if(!_e)try{fe.walkTokens&&Ae.walkTokens(x,fe.walkTokens),ze=Pe.parse(x,fe)}catch(We){_e=We}return fe.highlight=J,_e?pe(_e):pe(null,ze)};if(!J||J.length<3||(delete fe.highlight,!x.length))return Q();var re=0;Ae.walkTokens(x,function(Ue){Ue.type==="code"&&(re++,setTimeout(function(){J(Ue.text,Ue.lang,function(_e,ze){if(_e)return Q(_e);ze!=null&&ze!==Ue.text&&(Ue.text=ze,Ue.escaped=!0),re--,re===0&&Q()})},0))}),re===0&&Q();return}try{var Ee=Se.lex(ve,fe);return fe.walkTokens&&Ae.walkTokens(Ee,fe.walkTokens),Pe.parse(Ee,fe)}catch(Ue){if(Ue.message+=`
Please report this to https://github.com/markedjs/marked.`,fe.silent)return"<p>An error occurred:</p><pre>"+et(Ue.message+"",!0)+"</pre>";throw Ue}}Ae.options=Ae.setOptions=function(ve){return at(Ae.defaults,ve),be(Ae.defaults),Ae},Ae.getDefaults=ne,Ae.defaults=Fe,Ae.use=function(){for(var ve=this,fe=arguments.length,pe=new Array(fe),J=0;J<fe;J++)pe[J]=arguments[J];var x=at.apply(void 0,[{}].concat(pe)),Q=Ae.defaults.extensions||{renderers:{},childTokens:{}},re;pe.forEach(function(Ee){if(Ee.extensions&&(re=!0,Ee.extensions.forEach(function(_e){if(!_e.name)throw new Error("extension name required");if(_e.renderer){var ze=Q.renderers?Q.renderers[_e.name]:null;ze?Q.renderers[_e.name]=function(){for(var We=arguments.length,Ke=new Array(We),le=0;le<We;le++)Ke[le]=arguments[le];var he=_e.renderer.apply(this,Ke);return he===!1&&(he=ze.apply(this,Ke)),he}:Q.renderers[_e.name]=_e.renderer}if(_e.tokenizer){if(!_e.level||_e.level!=="block"&&_e.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");Q[_e.level]?Q[_e.level].unshift(_e.tokenizer):Q[_e.level]=[_e.tokenizer],_e.start&&(_e.level==="block"?Q.startBlock?Q.startBlock.push(_e.start):Q.startBlock=[_e.start]:_e.level==="inline"&&(Q.startInline?Q.startInline.push(_e.start):Q.startInline=[_e.start]))}_e.childTokens&&(Q.childTokens[_e.name]=_e.childTokens)})),Ee.renderer&&function(){var _e=Ae.defaults.renderer||new Ye,ze=function(le){var he=_e[le];_e[le]=function(){for(var X=arguments.length,$=new Array(X),ye=0;ye<X;ye++)$[ye]=arguments[ye];var Te=Ee.renderer[le].apply(_e,$);return Te===!1&&(Te=he.apply(_e,$)),Te}};for(var We in Ee.renderer)ze(We);x.renderer=_e}(),Ee.tokenizer&&function(){var _e=Ae.defaults.tokenizer||new $e,ze=function(le){var he=_e[le];_e[le]=function(){for(var X=arguments.length,$=new Array(X),ye=0;ye<X;ye++)$[ye]=arguments[ye];var Te=Ee.tokenizer[le].apply(_e,$);return Te===!1&&(Te=he.apply(_e,$)),Te}};for(var We in Ee.tokenizer)ze(We);x.tokenizer=_e}(),Ee.walkTokens){var Ue=Ae.defaults.walkTokens;x.walkTokens=function(_e){Ee.walkTokens.call(ve,_e),Ue&&Ue(_e)}}re&&(x.extensions=Q),Ae.setOptions(x)})},Ae.walkTokens=function(ve,fe){for(var pe=function(){var re=x.value;switch(fe(re),re.type){case"table":{for(var Ee=p(re.header),Ue;!(Ue=Ee()).done;){var _e=Ue.value;Ae.walkTokens(_e.tokens,fe)}for(var ze=p(re.rows),We;!(We=ze()).done;)for(var Ke=We.value,le=p(Ke),he;!(he=le()).done;){var X=he.value;Ae.walkTokens(X.tokens,fe)}break}case"list":{Ae.walkTokens(re.items,fe);break}default:Ae.defaults.extensions&&Ae.defaults.extensions.childTokens&&Ae.defaults.extensions.childTokens[re.type]?Ae.defaults.extensions.childTokens[re.type].forEach(function($){Ae.walkTokens(re[$],fe)}):re.tokens&&Ae.walkTokens(re.tokens,fe)}},J=p(ve),x;!(x=J()).done;)pe()},Ae.parseInline=function(ve,fe){if(typeof ve=="undefined"||ve===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof ve!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(ve)+", string expected");fe=at({},Ae.defaults,fe||{}),ot(fe);try{var pe=Se.lexInline(ve,fe);return fe.walkTokens&&Ae.walkTokens(pe,fe.walkTokens),Pe.parseInline(pe,fe)}catch(J){if(J.message+=`
Please report this to https://github.com/markedjs/marked.`,fe.silent)return"<p>An error occurred:</p><pre>"+et(J.message+"",!0)+"</pre>";throw J}},Ae.Parser=Pe,Ae.parser=Pe.parse,Ae.Renderer=Ye,Ae.TextRenderer=lt,Ae.Lexer=Se,Ae.lexer=Se.lex,Ae.Tokenizer=$e,Ae.Slugger=tt,Ae.parse=Ae;var Ve=Ae;return Ve}),define(ue[133],de([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function S(t,T,h){return Math.min(Math.max(t,T),h)}e.clamp=S;function k(t,T){return(T+t%T)%T}e.rot=k;class p{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=p;class P{constructor(){this._n=1,this._val=0}update(T){return this._val=this._val+(T-this._val)/this._n,this._n+=1,this}get value(){return this._val}}e.MovingAverage=P}),function(){function Y(p){const P=[];typeof p=="number"&&P.push("code/timeOrigin",p);function t(h){P.push(h,Date.now())}function T(){const h=[];for(let f=0;f<P.length;f+=2)h.push({name:P[f],startTime:P[f+1]});return h}return{mark:t,getMarks:T}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?Y():{mark(p){performance.mark(p)},getMarks(){let p=performance.timeOrigin;typeof p!="number"&&(p=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const P=[{name:"code/timeOrigin",startTime:Math.round(p)}];for(const t of performance.getEntriesByType("mark"))P.push({name:t.name,startTime:Math.round(p+t.startTime)});return P}};if(typeof process=="object"){const p=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return Y(p)}else return console.trace("perf-util loaded in UNKNOWN environment"),Y()}function S(p){return p.MonacoPerformanceMarks||(p.MonacoPerformanceMarks=e()),p.MonacoPerformanceMarks}var k;typeof global=="object"?k=global:typeof self=="object"?k=self:k={},typeof define=="function"?define("vs/base/common/performance",[],function(){return S(k)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=S(k):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),k.perf=S(k))}(),define(ue[2],de([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isElectronSandboxed=e.globals=void 0;const S="en";let k=!1,p=!1,P=!1,t=!1,T=!1,h=!1,f=!1,C,I=S,m,u;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let c;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?c=e.globals.vscode.process:typeof process!="undefined"&&(c=process);const b=typeof c?.versions?.electron=="string"&&c.type==="renderer";if(e.isElectronSandboxed=b&&c?.sandboxed,typeof navigator=="object"&&!b){u=navigator.userAgent,k=u.indexOf("Windows")>=0,p=u.indexOf("Macintosh")>=0,f=(u.indexOf("Macintosh")>=0||u.indexOf("iPad")>=0||u.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,P=u.indexOf("Linux")>=0,h=!0,C=navigator.language,I=C;const i=typeof document!="undefined"&&document.getElementById("vscode-remote-nls-configuration"),n=i&&i.getAttribute("data-settings");if(n)try{const s=JSON.parse(n);C=s.locale,m=s._translationsConfigFile,I=s.availableLanguages["*"]||S}catch(s){}}else if(typeof c=="object"){k=c.platform==="win32",p=c.platform==="darwin",P=c.platform==="linux",t=P&&!!c.env.SNAP&&!!c.env.SNAP_REVISION,C=S,I=S;const i=c.env.VSCODE_NLS_CONFIG;if(i)try{const n=JSON.parse(i),s=n.availableLanguages["*"];C=n.locale,I=s||S,m=n._translationsConfigFile}catch(n){}T=!0}else console.error("Unable to resolve platform.");var g;(function(i){i[i.Web=0]="Web",i[i.Mac=1]="Mac",i[i.Linux=2]="Linux",i[i.Windows=3]="Windows"})(g=e.Platform||(e.Platform={}));function D(i){switch(i){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=D;let w=0;p?w=1:k?w=3:P&&(w=2),e.isWindows=k,e.isMacintosh=p,e.isLinux=P,e.isLinuxSnap=t,e.isNative=T,e.isWeb=h,e.isIOS=f,e.platform=w,e.userAgent=u,e.language=I;var v;(function(i){function n(){return e.language}i.value=n;function s(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}i.isDefaultVariant=s;function d(){return e.language==="en"}i.isDefault=d})(v=e.Language||(e.Language={})),e.locale=C,e.translationsConfigFile=m,e.setTimeout0=(()=>{if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let i=[];e.globals.addEventListener("message",s=>{if(s.data&&s.data.vscodeScheduleAsyncWork)for(let d=0,y=i.length;d<y;d++){const A=i[d];if(A.id===s.data.vscodeScheduleAsyncWork){i.splice(d,1),A.callback();return}}});let n=0;return s=>{const d=++n;i.push({id:d,callback:s}),e.globals.postMessage({vscodeScheduleAsyncWork:d},"*")}}return i=>setTimeout(i)})();var a;(function(i){i[i.Windows=1]="Windows",i[i.Macintosh=2]="Macintosh",i[i.Linux=3]="Linux"})(a=e.OperatingSystem||(e.OperatingSystem={})),e.OS=p||f?2:k?1:3;let l=!0,r=!1;function o(){if(!r){r=!0;const i=new Uint8Array(2);i[0]=1,i[1]=2,l=new Uint16Array(i.buffer)[0]===(2<<8)+1}return l}e.isLittleEndian=o}),define(ue[23],de([0,1,2]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let k;if(typeof S.globals.vscode!="undefined"&&typeof S.globals.vscode.process!="undefined"){const p=S.globals.vscode.process;k={get platform(){return p.platform},get arch(){return p.arch},get env(){return p.env},cwd(){return p.cwd()}}}else typeof process!="undefined"?k={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:k={get platform(){return S.isWindows?"win32":S.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=k.cwd,e.env=k.env,e.platform=k.platform,e.arch=k.arch}),define(ue[4],de([0,1,23]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const k=65,p=97,P=90,t=122,T=46,h=47,f=92,C=58,I=63;class m extends Error{constructor(a,l,r){let o;typeof l=="string"&&l.indexOf("not ")===0?(o="must not be",l=l.replace(/^not /,"")):o="must be";const i=a.indexOf(".")!==-1?"property":"argument";let n=`The "${a}" ${i} ${o} of type ${l}`;n+=`. Received type ${typeof r}`,super(n),this.code="ERR_INVALID_ARG_TYPE"}}function u(v,a){if(typeof v!="string")throw new m(a,"string",v)}function c(v){return v===h||v===f}function b(v){return v===h}function g(v){return v>=k&&v<=P||v>=p&&v<=t}function D(v,a,l,r){let o="",i=0,n=-1,s=0,d=0;for(let y=0;y<=v.length;++y){if(y<v.length)d=v.charCodeAt(y);else{if(r(d))break;d=h}if(r(d)){if(!(n===y-1||s===1))if(s===2){if(o.length<2||i!==2||o.charCodeAt(o.length-1)!==T||o.charCodeAt(o.length-2)!==T){if(o.length>2){const A=o.lastIndexOf(l);A===-1?(o="",i=0):(o=o.slice(0,A),i=o.length-1-o.lastIndexOf(l)),n=y,s=0;continue}else if(o.length!==0){o="",i=0,n=y,s=0;continue}}a&&(o+=o.length>0?`${l}..`:"..",i=2)}else o.length>0?o+=`${l}${v.slice(n+1,y)}`:o=v.slice(n+1,y),i=y-n-1;n=y,s=0}else d===T&&s!==-1?++s:s=-1}return o}function w(v,a){if(a===null||typeof a!="object")throw new m("pathObject","Object",a);const l=a.dir||a.root,r=a.base||`${a.name||""}${a.ext||""}`;return l?l===a.root?`${l}${r}`:`${l}${v}${r}`:r}e.win32={resolve(...v){let a="",l="",r=!1;for(let o=v.length-1;o>=-1;o--){let i;if(o>=0){if(i=v[o],u(i,"path"),i.length===0)continue}else a.length===0?i=S.cwd():(i=S.env[`=${a}`]||S.cwd(),(i===void 0||i.slice(0,2).toLowerCase()!==a.toLowerCase()&&i.charCodeAt(2)===f)&&(i=`${a}\\`));const n=i.length;let s=0,d="",y=!1;const A=i.charCodeAt(0);if(n===1)c(A)&&(s=1,y=!0);else if(c(A))if(y=!0,c(i.charCodeAt(1))){let E=2,R=E;for(;E<n&&!c(i.charCodeAt(E));)E++;if(E<n&&E!==R){const O=i.slice(R,E);for(R=E;E<n&&c(i.charCodeAt(E));)E++;if(E<n&&E!==R){for(R=E;E<n&&!c(i.charCodeAt(E));)E++;(E===n||E!==R)&&(d=`\\\\${O}\\${i.slice(R,E)}`,s=E)}}}else s=1;else g(A)&&i.charCodeAt(1)===C&&(d=i.slice(0,2),s=2,n>2&&c(i.charCodeAt(2))&&(y=!0,s=3));if(d.length>0)if(a.length>0){if(d.toLowerCase()!==a.toLowerCase())continue}else a=d;if(r){if(a.length>0)break}else if(l=`${i.slice(s)}\\${l}`,r=y,y&&a.length>0)break}return l=D(l,!r,"\\",c),r?`${a}\\${l}`:`${a}${l}`||"."},normalize(v){u(v,"path");const a=v.length;if(a===0)return".";let l=0,r,o=!1;const i=v.charCodeAt(0);if(a===1)return b(i)?"\\":v;if(c(i))if(o=!0,c(v.charCodeAt(1))){let s=2,d=s;for(;s<a&&!c(v.charCodeAt(s));)s++;if(s<a&&s!==d){const y=v.slice(d,s);for(d=s;s<a&&c(v.charCodeAt(s));)s++;if(s<a&&s!==d){for(d=s;s<a&&!c(v.charCodeAt(s));)s++;if(s===a)return`\\\\${y}\\${v.slice(d)}\\`;s!==d&&(r=`\\\\${y}\\${v.slice(d,s)}`,l=s)}}}else l=1;else g(i)&&v.charCodeAt(1)===C&&(r=v.slice(0,2),l=2,a>2&&c(v.charCodeAt(2))&&(o=!0,l=3));let n=l<a?D(v.slice(l),!o,"\\",c):"";return n.length===0&&!o&&(n="."),n.length>0&&c(v.charCodeAt(a-1))&&(n+="\\"),r===void 0?o?`\\${n}`:n:o?`${r}\\${n}`:`${r}${n}`},isAbsolute(v){u(v,"path");const a=v.length;if(a===0)return!1;const l=v.charCodeAt(0);return c(l)||a>2&&g(l)&&v.charCodeAt(1)===C&&c(v.charCodeAt(2))},join(...v){if(v.length===0)return".";let a,l;for(let i=0;i<v.length;++i){const n=v[i];u(n,"path"),n.length>0&&(a===void 0?a=l=n:a+=`\\${n}`)}if(a===void 0)return".";let r=!0,o=0;if(typeof l=="string"&&c(l.charCodeAt(0))){++o;const i=l.length;i>1&&c(l.charCodeAt(1))&&(++o,i>2&&(c(l.charCodeAt(2))?++o:r=!1))}if(r){for(;o<a.length&&c(a.charCodeAt(o));)o++;o>=2&&(a=`\\${a.slice(o)}`)}return e.win32.normalize(a)},relative(v,a){if(u(v,"from"),u(a,"to"),v===a)return"";const l=e.win32.resolve(v),r=e.win32.resolve(a);if(l===r||(v=l.toLowerCase(),a=r.toLowerCase(),v===a))return"";let o=0;for(;o<v.length&&v.charCodeAt(o)===f;)o++;let i=v.length;for(;i-1>o&&v.charCodeAt(i-1)===f;)i--;const n=i-o;let s=0;for(;s<a.length&&a.charCodeAt(s)===f;)s++;let d=a.length;for(;d-1>s&&a.charCodeAt(d-1)===f;)d--;const y=d-s,A=n<y?n:y;let E=-1,R=0;for(;R<A;R++){const K=v.charCodeAt(o+R);if(K!==a.charCodeAt(s+R))break;K===f&&(E=R)}if(R!==A){if(E===-1)return r}else{if(y>A){if(a.charCodeAt(s+R)===f)return r.slice(s+R+1);if(R===2)return r.slice(s+R)}n>A&&(v.charCodeAt(o+R)===f?E=R:R===2&&(E=3)),E===-1&&(E=0)}let O="";for(R=o+E+1;R<=i;++R)(R===i||v.charCodeAt(R)===f)&&(O+=O.length===0?"..":"\\..");return s+=E,O.length>0?`${O}${r.slice(s,d)}`:(r.charCodeAt(s)===f&&++s,r.slice(s,d))},toNamespacedPath(v){if(typeof v!="string")return v;if(v.length===0)return"";const a=e.win32.resolve(v);if(a.length<=2)return v;if(a.charCodeAt(0)===f){if(a.charCodeAt(1)===f){const l=a.charCodeAt(2);if(l!==I&&l!==T)return`\\\\?\\UNC\\${a.slice(2)}`}}else if(g(a.charCodeAt(0))&&a.charCodeAt(1)===C&&a.charCodeAt(2)===f)return`\\\\?\\${a}`;return v},dirname(v){u(v,"path");const a=v.length;if(a===0)return".";let l=-1,r=0;const o=v.charCodeAt(0);if(a===1)return c(o)?v:".";if(c(o)){if(l=r=1,c(v.charCodeAt(1))){let s=2,d=s;for(;s<a&&!c(v.charCodeAt(s));)s++;if(s<a&&s!==d){for(d=s;s<a&&c(v.charCodeAt(s));)s++;if(s<a&&s!==d){for(d=s;s<a&&!c(v.charCodeAt(s));)s++;if(s===a)return v;s!==d&&(l=r=s+1)}}}}else g(o)&&v.charCodeAt(1)===C&&(l=a>2&&c(v.charCodeAt(2))?3:2,r=l);let i=-1,n=!0;for(let s=a-1;s>=r;--s)if(c(v.charCodeAt(s))){if(!n){i=s;break}}else n=!1;if(i===-1){if(l===-1)return".";i=l}return v.slice(0,i)},basename(v,a){a!==void 0&&u(a,"ext"),u(v,"path");let l=0,r=-1,o=!0,i;if(v.length>=2&&g(v.charCodeAt(0))&&v.charCodeAt(1)===C&&(l=2),a!==void 0&&a.length>0&&a.length<=v.length){if(a===v)return"";let n=a.length-1,s=-1;for(i=v.length-1;i>=l;--i){const d=v.charCodeAt(i);if(c(d)){if(!o){l=i+1;break}}else s===-1&&(o=!1,s=i+1),n>=0&&(d===a.charCodeAt(n)?--n==-1&&(r=i):(n=-1,r=s))}return l===r?r=s:r===-1&&(r=v.length),v.slice(l,r)}for(i=v.length-1;i>=l;--i)if(c(v.charCodeAt(i))){if(!o){l=i+1;break}}else r===-1&&(o=!1,r=i+1);return r===-1?"":v.slice(l,r)},extname(v){u(v,"path");let a=0,l=-1,r=0,o=-1,i=!0,n=0;v.length>=2&&v.charCodeAt(1)===C&&g(v.charCodeAt(0))&&(a=r=2);for(let s=v.length-1;s>=a;--s){const d=v.charCodeAt(s);if(c(d)){if(!i){r=s+1;break}continue}o===-1&&(i=!1,o=s+1),d===T?l===-1?l=s:n!==1&&(n=1):l!==-1&&(n=-1)}return l===-1||o===-1||n===0||n===1&&l===o-1&&l===r+1?"":v.slice(l,o)},format:w.bind(null,"\\"),parse(v){u(v,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(v.length===0)return a;const l=v.length;let r=0,o=v.charCodeAt(0);if(l===1)return c(o)?(a.root=a.dir=v,a):(a.base=a.name=v,a);if(c(o)){if(r=1,c(v.charCodeAt(1))){let E=2,R=E;for(;E<l&&!c(v.charCodeAt(E));)E++;if(E<l&&E!==R){for(R=E;E<l&&c(v.charCodeAt(E));)E++;if(E<l&&E!==R){for(R=E;E<l&&!c(v.charCodeAt(E));)E++;E===l?r=E:E!==R&&(r=E+1)}}}}else if(g(o)&&v.charCodeAt(1)===C){if(l<=2)return a.root=a.dir=v,a;if(r=2,c(v.charCodeAt(2))){if(l===3)return a.root=a.dir=v,a;r=3}}r>0&&(a.root=v.slice(0,r));let i=-1,n=r,s=-1,d=!0,y=v.length-1,A=0;for(;y>=r;--y){if(o=v.charCodeAt(y),c(o)){if(!d){n=y+1;break}continue}s===-1&&(d=!1,s=y+1),o===T?i===-1?i=y:A!==1&&(A=1):i!==-1&&(A=-1)}return s!==-1&&(i===-1||A===0||A===1&&i===s-1&&i===n+1?a.base=a.name=v.slice(n,s):(a.name=v.slice(n,i),a.base=v.slice(n,s),a.ext=v.slice(i,s))),n>0&&n!==r?a.dir=v.slice(0,n-1):a.dir=a.root,a},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...v){let a="",l=!1;for(let r=v.length-1;r>=-1&&!l;r--){const o=r>=0?v[r]:S.cwd();u(o,"path"),o.length!==0&&(a=`${o}/${a}`,l=o.charCodeAt(0)===h)}return a=D(a,!l,"/",b),l?`/${a}`:a.length>0?a:"."},normalize(v){if(u(v,"path"),v.length===0)return".";const a=v.charCodeAt(0)===h,l=v.charCodeAt(v.length-1)===h;return v=D(v,!a,"/",b),v.length===0?a?"/":l?"./":".":(l&&(v+="/"),a?`/${v}`:v)},isAbsolute(v){return u(v,"path"),v.length>0&&v.charCodeAt(0)===h},join(...v){if(v.length===0)return".";let a;for(let l=0;l<v.length;++l){const r=v[l];u(r,"path"),r.length>0&&(a===void 0?a=r:a+=`/${r}`)}return a===void 0?".":e.posix.normalize(a)},relative(v,a){if(u(v,"from"),u(a,"to"),v===a||(v=e.posix.resolve(v),a=e.posix.resolve(a),v===a))return"";const l=1,r=v.length,o=r-l,i=1,n=a.length-i,s=o<n?o:n;let d=-1,y=0;for(;y<s;y++){const E=v.charCodeAt(l+y);if(E!==a.charCodeAt(i+y))break;E===h&&(d=y)}if(y===s)if(n>s){if(a.charCodeAt(i+y)===h)return a.slice(i+y+1);if(y===0)return a.slice(i+y)}else o>s&&(v.charCodeAt(l+y)===h?d=y:y===0&&(d=0));let A="";for(y=l+d+1;y<=r;++y)(y===r||v.charCodeAt(y)===h)&&(A+=A.length===0?"..":"/..");return`${A}${a.slice(i+d)}`},toNamespacedPath(v){return v},dirname(v){if(u(v,"path"),v.length===0)return".";const a=v.charCodeAt(0)===h;let l=-1,r=!0;for(let o=v.length-1;o>=1;--o)if(v.charCodeAt(o)===h){if(!r){l=o;break}}else r=!1;return l===-1?a?"/":".":a&&l===1?"//":v.slice(0,l)},basename(v,a){a!==void 0&&u(a,"ext"),u(v,"path");let l=0,r=-1,o=!0,i;if(a!==void 0&&a.length>0&&a.length<=v.length){if(a===v)return"";let n=a.length-1,s=-1;for(i=v.length-1;i>=0;--i){const d=v.charCodeAt(i);if(d===h){if(!o){l=i+1;break}}else s===-1&&(o=!1,s=i+1),n>=0&&(d===a.charCodeAt(n)?--n==-1&&(r=i):(n=-1,r=s))}return l===r?r=s:r===-1&&(r=v.length),v.slice(l,r)}for(i=v.length-1;i>=0;--i)if(v.charCodeAt(i)===h){if(!o){l=i+1;break}}else r===-1&&(o=!1,r=i+1);return r===-1?"":v.slice(l,r)},extname(v){u(v,"path");let a=-1,l=0,r=-1,o=!0,i=0;for(let n=v.length-1;n>=0;--n){const s=v.charCodeAt(n);if(s===h){if(!o){l=n+1;break}continue}r===-1&&(o=!1,r=n+1),s===T?a===-1?a=n:i!==1&&(i=1):a!==-1&&(i=-1)}return a===-1||r===-1||i===0||i===1&&a===r-1&&a===l+1?"":v.slice(a,r)},format:w.bind(null,"/"),parse(v){u(v,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(v.length===0)return a;const l=v.charCodeAt(0)===h;let r;l?(a.root="/",r=1):r=0;let o=-1,i=0,n=-1,s=!0,d=v.length-1,y=0;for(;d>=r;--d){const A=v.charCodeAt(d);if(A===h){if(!s){i=d+1;break}continue}n===-1&&(s=!1,n=d+1),A===T?o===-1?o=d:y!==1&&(y=1):o!==-1&&(y=-1)}if(n!==-1){const A=i===0&&l?1:i;o===-1||y===0||y===1&&o===n-1&&o===i+1?a.base=a.name=v.slice(A,n):(a.name=v.slice(A,o),a.base=v.slice(A,n),a.ext=v.slice(o,n))}return i>0?a.dir=v.slice(0,i-1):l&&(a.dir="/"),a},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=S.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=S.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=S.platform==="win32"?e.win32.join:e.posix.join,e.resolve=S.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=S.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=S.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=S.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=S.platform==="win32"?e.win32.extname:e.posix.extname,e.format=S.platform==="win32"?e.win32.format:e.posix.format,e.parse=S.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=S.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=S.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=S.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(ue[86],de([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var S;(function(P){P[P.stdout=0]="stdout",P[P.stderr=1]="stderr"})(S=e.Source||(e.Source={}));var k;(function(P){P[P.Success=0]="Success",P[P.Unknown=1]="Unknown",P[P.AccessDenied=2]="AccessDenied",P[P.ProcessNotFound=3]="ProcessNotFound"})(k=e.TerminateResponseCode||(e.TerminateResponseCode={}));function p(P,...t){const T=t.reduce((C,I)=>(C[I]=!0,C),{}),h=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/,/^CODE_SERVER_.+$/,/^CS_.+$/];Object.keys(P).filter(C=>!T[C]).forEach(C=>{for(let I=0;I<h.length;I++)if(C.search(h[I])!==-1){delete P[C];break}})}e.sanitizeProcessEnvironment=p}),function(Y,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var S=e();for(var k in S)(typeof exports=="object"?exports:Y)[k]=S[k]}}(typeof self!="undefined"?self:this,function(){return function(Y){var e={};function S(k){if(e[k])return e[k].exports;var p=e[k]={i:k,l:!1,exports:{}};return Y[k].call(p.exports,p,p.exports,S),p.l=!0,p.exports}return S.m=Y,S.c=e,S.d=function(k,p,P){S.o(k,p)||Object.defineProperty(k,p,{enumerable:!0,get:P})},S.r=function(k){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(k,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(k,"__esModule",{value:!0})},S.t=function(k,p){if(1&p&&(k=S(k)),8&p||4&p&&typeof k=="object"&&k&&k.__esModule)return k;var P=Object.create(null);if(S.r(P),Object.defineProperty(P,"default",{enumerable:!0,value:k}),2&p&&typeof k!="string")for(var t in k)S.d(P,t,function(T){return k[T]}.bind(null,t));return P},S.n=function(k){var p=k&&k.__esModule?function(){return k.default}:function(){return k};return S.d(p,"a",p),p},S.o=function(k,p){return Object.prototype.hasOwnProperty.call(k,p)},S.p="",S(S.s=0)}([function(Y,e,S){(function(k){var p;e=Y.exports=oe,p=typeof k=="object"&&k.env&&k.env.NODE_DEBUG&&/\bsemver\b/i.test(k.env.NODE_DEBUG)?function(){var ce=Array.prototype.slice.call(arguments,0);ce.unshift("SEMVER"),console.log.apply(console,ce)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var P=256,t=Number.MAX_SAFE_INTEGER||9007199254740991,T=e.re=[],h=e.src=[],f=0,C=f++;h[C]="0|[1-9]\\d*";var I=f++;h[I]="[0-9]+";var m=f++;h[m]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var u=f++;h[u]="("+h[C]+")\\.("+h[C]+")\\.("+h[C]+")";var c=f++;h[c]="("+h[I]+")\\.("+h[I]+")\\.("+h[I]+")";var b=f++;h[b]="(?:"+h[C]+"|"+h[m]+")";var g=f++;h[g]="(?:"+h[I]+"|"+h[m]+")";var D=f++;h[D]="(?:-("+h[b]+"(?:\\."+h[b]+")*))";var w=f++;h[w]="(?:-?("+h[g]+"(?:\\."+h[g]+")*))";var v=f++;h[v]="[0-9A-Za-z-]+";var a=f++;h[a]="(?:\\+("+h[v]+"(?:\\."+h[v]+")*))";var l=f++,r="v?"+h[u]+h[D]+"?"+h[a]+"?";h[l]="^"+r+"$";var o="[v=\\s]*"+h[c]+h[w]+"?"+h[a]+"?",i=f++;h[i]="^"+o+"$";var n=f++;h[n]="((?:<|>)?=?)";var s=f++;h[s]=h[I]+"|x|X|\\*";var d=f++;h[d]=h[C]+"|x|X|\\*";var y=f++;h[y]="[v=\\s]*("+h[d]+")(?:\\.("+h[d]+")(?:\\.("+h[d]+")(?:"+h[D]+")?"+h[a]+"?)?)?";var A=f++;h[A]="[v=\\s]*("+h[s]+")(?:\\.("+h[s]+")(?:\\.("+h[s]+")(?:"+h[w]+")?"+h[a]+"?)?)?";var E=f++;h[E]="^"+h[n]+"\\s*"+h[y]+"$";var R=f++;h[R]="^"+h[n]+"\\s*"+h[A]+"$";var O=f++;h[O]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var K=f++;h[K]="(?:~>?)";var te=f++;h[te]="(\\s*)"+h[K]+"\\s+",T[te]=new RegExp(h[te],"g");var j=f++;h[j]="^"+h[K]+h[y]+"$";var _=f++;h[_]="^"+h[K]+h[A]+"$";var U=f++;h[U]="(?:\\^)";var F=f++;h[F]="(\\s*)"+h[U]+"\\s+",T[F]=new RegExp(h[F],"g");var M=f++;h[M]="^"+h[U]+h[y]+"$";var V=f++;h[V]="^"+h[U]+h[A]+"$";var ee=f++;h[ee]="^"+h[n]+"\\s*("+o+")$|^$";var G=f++;h[G]="^"+h[n]+"\\s*("+r+")$|^$";var H=f++;h[H]="(\\s*)"+h[n]+"\\s*("+o+"|"+h[y]+")",T[H]=new RegExp(h[H],"g");var q=f++;h[q]="^\\s*("+h[y]+")\\s+-\\s+("+h[y]+")\\s*$";var z=f++;h[z]="^\\s*("+h[A]+")\\s+-\\s+("+h[A]+")\\s*$";var B=f++;h[B]="(<|>)?=?\\s*\\*";for(var W=0;W<35;W++)p(W,h[W]),T[W]||(T[W]=new RegExp(h[W]));function ie(ce,Se){if(ce instanceof oe)return ce;if(typeof ce!="string"||ce.length>P||!(Se?T[i]:T[l]).test(ce))return null;try{return new oe(ce,Se)}catch(Pe){return null}}function oe(ce,Se){if(ce instanceof oe){if(ce.loose===Se)return ce;ce=ce.version}else if(typeof ce!="string")throw new TypeError("Invalid Version: "+ce);if(ce.length>P)throw new TypeError("version is longer than "+P+" characters");if(!(this instanceof oe))return new oe(ce,Se);p("SemVer",ce,Se),this.loose=Se;var Pe=ce.trim().match(Se?T[i]:T[l]);if(!Pe)throw new TypeError("Invalid Version: "+ce);if(this.raw=ce,this.major=+Pe[1],this.minor=+Pe[2],this.patch=+Pe[3],this.major>t||this.major<0)throw new TypeError("Invalid major version");if(this.minor>t||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>t||this.patch<0)throw new TypeError("Invalid patch version");Pe[4]?this.prerelease=Pe[4].split(".").map(function($e){if(/^[0-9]+$/.test($e)){var Ye=+$e;if(Ye>=0&&Ye<t)return Ye}return $e}):this.prerelease=[],this.build=Pe[5]?Pe[5].split("."):[],this.format()}e.parse=ie,e.valid=function(ce,Se){var Pe=ie(ce,Se);return Pe?Pe.version:null},e.clean=function(ce,Se){var Pe=ie(ce.trim().replace(/^[=v]+/,""),Se);return Pe?Pe.version:null},e.SemVer=oe,oe.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},oe.prototype.toString=function(){return this.version},oe.prototype.compare=function(ce){return p("SemVer.compare",this.version,this.loose,ce),ce instanceof oe||(ce=new oe(ce,this.loose)),this.compareMain(ce)||this.comparePre(ce)},oe.prototype.compareMain=function(ce){return ce instanceof oe||(ce=new oe(ce,this.loose)),se(this.major,ce.major)||se(this.minor,ce.minor)||se(this.patch,ce.patch)},oe.prototype.comparePre=function(ce){if(ce instanceof oe||(ce=new oe(ce,this.loose)),this.prerelease.length&&!ce.prerelease.length)return-1;if(!this.prerelease.length&&ce.prerelease.length)return 1;if(!this.prerelease.length&&!ce.prerelease.length)return 0;var Se=0;do{var Pe=this.prerelease[Se],$e=ce.prerelease[Se];if(p("prerelease compare",Se,Pe,$e),Pe===void 0&&$e===void 0)return 0;if($e===void 0)return 1;if(Pe===void 0)return-1;if(Pe!==$e)return se(Pe,$e)}while(++Se)},oe.prototype.inc=function(ce,Se){switch(ce){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",Se);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",Se);break;case"prepatch":this.prerelease.length=0,this.inc("patch",Se),this.inc("pre",Se);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",Se),this.inc("pre",Se);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var Pe=this.prerelease.length;--Pe>=0;)typeof this.prerelease[Pe]=="number"&&(this.prerelease[Pe]++,Pe=-2);Pe===-1&&this.prerelease.push(0)}Se&&(this.prerelease[0]===Se?isNaN(this.prerelease[1])&&(this.prerelease=[Se,0]):this.prerelease=[Se,0]);break;default:throw new Error("invalid increment argument: "+ce)}return this.format(),this.raw=this.version,this},e.inc=function(ce,Se,Pe,$e){typeof Pe=="string"&&($e=Pe,Pe=void 0);try{return new oe(ce,Pe).inc(Se,$e).version}catch(Ye){return null}},e.diff=function(ce,Se){if(Oe(ce,Se))return null;var Pe=ie(ce),$e=ie(Se);if(Pe.prerelease.length||$e.prerelease.length){for(var Ye in Pe)if((Ye==="major"||Ye==="minor"||Ye==="patch")&&Pe[Ye]!==$e[Ye])return"pre"+Ye;return"prerelease"}for(var Ye in Pe)if((Ye==="major"||Ye==="minor"||Ye==="patch")&&Pe[Ye]!==$e[Ye])return Ye},e.compareIdentifiers=se;var we=/^[0-9]+$/;function se(ce,Se){var Pe=we.test(ce),$e=we.test(Se);return Pe&&$e&&(ce=+ce,Se=+Se),Pe&&!$e?-1:$e&&!Pe?1:ce<Se?-1:ce>Se?1:0}function ae(ce,Se,Pe){return new oe(ce,Pe).compare(new oe(Se,Pe))}function ke(ce,Se,Pe){return ae(ce,Se,Pe)>0}function De(ce,Se,Pe){return ae(ce,Se,Pe)<0}function Oe(ce,Se,Pe){return ae(ce,Se,Pe)===0}function Be(ce,Se,Pe){return ae(ce,Se,Pe)!==0}function Xe(ce,Se,Pe){return ae(ce,Se,Pe)>=0}function Ze(ce,Se,Pe){return ae(ce,Se,Pe)<=0}function ge(ce,Se,Pe,$e){var Ye;switch(Se){case"===":typeof ce=="object"&&(ce=ce.version),typeof Pe=="object"&&(Pe=Pe.version),Ye=ce===Pe;break;case"!==":typeof ce=="object"&&(ce=ce.version),typeof Pe=="object"&&(Pe=Pe.version),Ye=ce!==Pe;break;case"":case"=":case"==":Ye=Oe(ce,Pe,$e);break;case"!=":Ye=Be(ce,Pe,$e);break;case">":Ye=ke(ce,Pe,$e);break;case">=":Ye=Xe(ce,Pe,$e);break;case"<":Ye=De(ce,Pe,$e);break;case"<=":Ye=Ze(ce,Pe,$e);break;default:throw new TypeError("Invalid operator: "+Se)}return Ye}function me(ce,Se){if(ce instanceof me){if(ce.loose===Se)return ce;ce=ce.value}if(!(this instanceof me))return new me(ce,Se);p("comparator",ce,Se),this.loose=Se,this.parse(ce),this.semver===Ie?this.value="":this.value=this.operator+this.semver.version,p("comp",this)}e.rcompareIdentifiers=function(ce,Se){return se(Se,ce)},e.major=function(ce,Se){return new oe(ce,Se).major},e.minor=function(ce,Se){return new oe(ce,Se).minor},e.patch=function(ce,Se){return new oe(ce,Se).patch},e.compare=ae,e.compareLoose=function(ce,Se){return ae(ce,Se,!0)},e.rcompare=function(ce,Se,Pe){return ae(Se,ce,Pe)},e.sort=function(ce,Se){return ce.sort(function(Pe,$e){return e.compare(Pe,$e,Se)})},e.rsort=function(ce,Se){return ce.sort(function(Pe,$e){return e.rcompare(Pe,$e,Se)})},e.gt=ke,e.lt=De,e.eq=Oe,e.neq=Be,e.gte=Xe,e.lte=Ze,e.cmp=ge,e.Comparator=me;var Ie={};function Re(ce,Se){if(ce instanceof Re)return ce.loose===Se?ce:new Re(ce.raw,Se);if(ce instanceof me)return new Re(ce.value,Se);if(!(this instanceof Re))return new Re(ce,Se);if(this.loose=Se,this.raw=ce,this.set=ce.split(/\s*\|\|\s*/).map(function(Pe){return this.parseRange(Pe.trim())},this).filter(function(Pe){return Pe.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ce);this.format()}function Le(ce){return!ce||ce.toLowerCase()==="x"||ce==="*"}function He(ce,Se,Pe,$e,Ye,lt,tt,at,ot,et,ne,be,Fe){return((Se=Le(Pe)?"":Le($e)?">="+Pe+".0.0":Le(Ye)?">="+Pe+"."+$e+".0":">="+Se)+" "+(at=Le(ot)?"":Le(et)?"<"+(+ot+1)+".0.0":Le(ne)?"<"+ot+"."+(+et+1)+".0":be?"<="+ot+"."+et+"."+ne+"-"+be:"<="+at)).trim()}function Qe(ce,Se){for(var Pe=0;Pe<ce.length;Pe++)if(!ce[Pe].test(Se))return!1;if(Se.prerelease.length){for(Pe=0;Pe<ce.length;Pe++)if(p(ce[Pe].semver),ce[Pe].semver!==Ie&&ce[Pe].semver.prerelease.length>0){var $e=ce[Pe].semver;if($e.major===Se.major&&$e.minor===Se.minor&&$e.patch===Se.patch)return!0}return!1}return!0}function Je(ce,Se,Pe){try{Se=new Re(Se,Pe)}catch($e){return!1}return Se.test(ce)}function rt(ce,Se,Pe,$e){var Ye,lt,tt,at,ot;switch(ce=new oe(ce,$e),Se=new Re(Se,$e),Pe){case">":Ye=ke,lt=Ze,tt=De,at=">",ot=">=";break;case"<":Ye=De,lt=Xe,tt=ke,at="<",ot="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Je(ce,Se,$e))return!1;for(var et=0;et<Se.set.length;++et){var ne=Se.set[et],be=null,Fe=null;if(ne.forEach(function(Ae){Ae.semver===Ie&&(Ae=new me(">=0.0.0")),be=be||Ae,Fe=Fe||Ae,Ye(Ae.semver,be.semver,$e)?be=Ae:tt(Ae.semver,Fe.semver,$e)&&(Fe=Ae)}),be.operator===at||be.operator===ot||(!Fe.operator||Fe.operator===at)&&lt(ce,Fe.semver)||Fe.operator===ot&&tt(ce,Fe.semver))return!1}return!0}me.prototype.parse=function(ce){var Se=this.loose?T[ee]:T[G],Pe=ce.match(Se);if(!Pe)throw new TypeError("Invalid comparator: "+ce);this.operator=Pe[1],this.operator==="="&&(this.operator=""),Pe[2]?this.semver=new oe(Pe[2],this.loose):this.semver=Ie},me.prototype.toString=function(){return this.value},me.prototype.test=function(ce){return p("Comparator.test",ce,this.loose),this.semver===Ie||(typeof ce=="string"&&(ce=new oe(ce,this.loose)),ge(ce,this.operator,this.semver,this.loose))},me.prototype.intersects=function(ce,Se){if(!(ce instanceof me))throw new TypeError("a Comparator is required");var Pe;if(this.operator==="")return Pe=new Re(ce.value,Se),Je(this.value,Pe,Se);if(ce.operator==="")return Pe=new Re(this.value,Se),Je(ce.semver,Pe,Se);var $e=!(this.operator!==">="&&this.operator!==">"||ce.operator!==">="&&ce.operator!==">"),Ye=!(this.operator!=="<="&&this.operator!=="<"||ce.operator!=="<="&&ce.operator!=="<"),lt=this.semver.version===ce.semver.version,tt=!(this.operator!==">="&&this.operator!=="<="||ce.operator!==">="&&ce.operator!=="<="),at=ge(this.semver,"<",ce.semver,Se)&&(this.operator===">="||this.operator===">")&&(ce.operator==="<="||ce.operator==="<"),ot=ge(this.semver,">",ce.semver,Se)&&(this.operator==="<="||this.operator==="<")&&(ce.operator===">="||ce.operator===">");return $e||Ye||lt&&tt||at||ot},e.Range=Re,Re.prototype.format=function(){return this.range=this.set.map(function(ce){return ce.join(" ").trim()}).join("||").trim(),this.range},Re.prototype.toString=function(){return this.range},Re.prototype.parseRange=function(ce){var Se=this.loose;ce=ce.trim(),p("range",ce,Se);var Pe=Se?T[z]:T[q];ce=ce.replace(Pe,He),p("hyphen replace",ce),ce=ce.replace(T[H],"$1$2$3"),p("comparator trim",ce,T[H]),ce=(ce=(ce=ce.replace(T[te],"$1~")).replace(T[F],"$1^")).split(/\s+/).join(" ");var $e=Se?T[ee]:T[G],Ye=ce.split(" ").map(function(lt){return function(tt,at){return p("comp",tt),tt=function(ot,et){return ot.trim().split(/\s+/).map(function(ne){return function(be,Fe){p("caret",be,Fe);var Ae=Fe?T[V]:T[M];return be.replace(Ae,function(Ve,ve,fe,pe,J){var x;return p("caret",be,Ve,ve,fe,pe,J),Le(ve)?x="":Le(fe)?x=">="+ve+".0.0 <"+(+ve+1)+".0.0":Le(pe)?x=ve==="0"?">="+ve+"."+fe+".0 <"+ve+"."+(+fe+1)+".0":">="+ve+"."+fe+".0 <"+(+ve+1)+".0.0":J?(p("replaceCaret pr",J),J.charAt(0)!=="-"&&(J="-"+J),x=ve==="0"?fe==="0"?">="+ve+"."+fe+"."+pe+J+" <"+ve+"."+fe+"."+(+pe+1):">="+ve+"."+fe+"."+pe+J+" <"+ve+"."+(+fe+1)+".0":">="+ve+"."+fe+"."+pe+J+" <"+(+ve+1)+".0.0"):(p("no pr"),x=ve==="0"?fe==="0"?">="+ve+"."+fe+"."+pe+" <"+ve+"."+fe+"."+(+pe+1):">="+ve+"."+fe+"."+pe+" <"+ve+"."+(+fe+1)+".0":">="+ve+"."+fe+"."+pe+" <"+(+ve+1)+".0.0"),p("caret return",x),x})}(ne,et)}).join(" ")}(tt,at),p("caret",tt),tt=function(ot,et){return ot.trim().split(/\s+/).map(function(ne){return function(be,Fe){var Ae=Fe?T[_]:T[j];return be.replace(Ae,function(Ve,ve,fe,pe,J){var x;return p("tilde",be,Ve,ve,fe,pe,J),Le(ve)?x="":Le(fe)?x=">="+ve+".0.0 <"+(+ve+1)+".0.0":Le(pe)?x=">="+ve+"."+fe+".0 <"+ve+"."+(+fe+1)+".0":J?(p("replaceTilde pr",J),J.charAt(0)!=="-"&&(J="-"+J),x=">="+ve+"."+fe+"."+pe+J+" <"+ve+"."+(+fe+1)+".0"):x=">="+ve+"."+fe+"."+pe+" <"+ve+"."+(+fe+1)+".0",p("tilde return",x),x})}(ne,et)}).join(" ")}(tt,at),p("tildes",tt),tt=function(ot,et){return p("replaceXRanges",ot,et),ot.split(/\s+/).map(function(ne){return function(be,Fe){be=be.trim();var Ae=Fe?T[R]:T[E];return be.replace(Ae,function(Ve,ve,fe,pe,J,x){p("xRange",be,Ve,ve,fe,pe,J,x);var Q=Le(fe),re=Q||Le(pe),Ee=re||Le(J);return ve==="="&&Ee&&(ve=""),Q?Ve=ve===">"||ve==="<"?"<0.0.0":"*":ve&&Ee?(re&&(pe=0),Ee&&(J=0),ve===">"?(ve=">=",re?(fe=+fe+1,pe=0,J=0):Ee&&(pe=+pe+1,J=0)):ve==="<="&&(ve="<",re?fe=+fe+1:pe=+pe+1),Ve=ve+fe+"."+pe+"."+J):re?Ve=">="+fe+".0.0 <"+(+fe+1)+".0.0":Ee&&(Ve=">="+fe+"."+pe+".0 <"+fe+"."+(+pe+1)+".0"),p("xRange return",Ve),Ve})}(ne,et)}).join(" ")}(tt,at),p("xrange",tt),tt=function(ot,et){return p("replaceStars",ot,et),ot.trim().replace(T[B],"")}(tt,at),p("stars",tt),tt}(lt,Se)}).join(" ").split(/\s+/);return this.loose&&(Ye=Ye.filter(function(lt){return!!lt.match($e)})),Ye=Ye.map(function(lt){return new me(lt,Se)})},Re.prototype.intersects=function(ce,Se){if(!(ce instanceof Re))throw new TypeError("a Range is required");return this.set.some(function(Pe){return Pe.every(function($e){return ce.set.some(function(Ye){return Ye.every(function(lt){return $e.intersects(lt,Se)})})})})},e.toComparators=function(ce,Se){return new Re(ce,Se).set.map(function(Pe){return Pe.map(function($e){return $e.value}).join(" ").trim().split(" ")})},Re.prototype.test=function(ce){if(!ce)return!1;typeof ce=="string"&&(ce=new oe(ce,this.loose));for(var Se=0;Se<this.set.length;Se++)if(Qe(this.set[Se],ce))return!0;return!1},e.satisfies=Je,e.maxSatisfying=function(ce,Se,Pe){var $e=null,Ye=null;try{var lt=new Re(Se,Pe)}catch(tt){return null}return ce.forEach(function(tt){lt.test(tt)&&($e&&Ye.compare(tt)!==-1||(Ye=new oe($e=tt,Pe)))}),$e},e.minSatisfying=function(ce,Se,Pe){var $e=null,Ye=null;try{var lt=new Re(Se,Pe)}catch(tt){return null}return ce.forEach(function(tt){lt.test(tt)&&($e&&Ye.compare(tt)!==1||(Ye=new oe($e=tt,Pe)))}),$e},e.validRange=function(ce,Se){try{return new Re(ce,Se).range||"*"}catch(Pe){return null}},e.ltr=function(ce,Se,Pe){return rt(ce,Se,"<",Pe)},e.gtr=function(ce,Se,Pe){return rt(ce,Se,">",Pe)},e.outside=rt,e.prerelease=function(ce,Se){var Pe=ie(ce,Se);return Pe&&Pe.prerelease.length?Pe.prerelease:null},e.intersects=function(ce,Se,Pe){return ce=new Re(ce,Pe),Se=new Re(Se,Pe),ce.intersects(Se)},e.coerce=function(ce){if(ce instanceof oe)return ce;if(typeof ce!="string")return null;var Se=ce.match(T[O]);return Se==null?null:ie((Se[1]||"0")+"."+(Se[2]||"0")+"."+(Se[3]||"0"))}}).call(this,S(1))},function(Y,e){var S,k,p=Y.exports={};function P(){throw new Error("setTimeout has not been defined")}function t(){throw new Error("clearTimeout has not been defined")}function T(g){if(S===setTimeout)return setTimeout(g,0);if((S===P||!S)&&setTimeout)return S=setTimeout,setTimeout(g,0);try{return S(g,0)}catch(D){try{return S.call(null,g,0)}catch(w){return S.call(this,g,0)}}}(function(){try{S=typeof setTimeout=="function"?setTimeout:P}catch(g){S=P}try{k=typeof clearTimeout=="function"?clearTimeout:t}catch(g){k=t}})();var h,f=[],C=!1,I=-1;function m(){C&&h&&(C=!1,h.length?f=h.concat(f):I=-1,f.length&&u())}function u(){if(!C){var g=T(m);C=!0;for(var D=f.length;D;){for(h=f,f=[];++I<D;)h&&h[I].run();I=-1,D=f.length}h=null,C=!1,function(w){if(k===clearTimeout)return clearTimeout(w);if((k===t||!k)&&clearTimeout)return k=clearTimeout,clearTimeout(w);try{k(w)}catch(v){try{return k.call(null,w)}catch(a){return k.call(this,w)}}}(g)}}function c(g,D){this.fun=g,this.array=D}function b(){}p.nextTick=function(g){var D=new Array(arguments.length-1);if(arguments.length>1)for(var w=1;w<arguments.length;w++)D[w-1]=arguments[w];f.push(new c(g,D)),f.length!==1||C||T(u)},c.prototype.run=function(){this.fun.apply(null,this.array)},p.title="browser",p.browser=!0,p.env={},p.argv=[],p.version="",p.versions={},p.on=b,p.addListener=b,p.once=b,p.off=b,p.removeListener=b,p.removeAllListeners=b,p.emit=b,p.prependListener=b,p.prependOnceListener=b,p.listeners=function(g){return[]},p.binding=function(g){throw new Error("process.binding is not supported")},p.cwd=function(){return"/"},p.chdir=function(g){throw new Error("process.chdir is not supported")},p.umask=function(){return 0}}])}),define(ue[134],de([0,1]),function(Y,e){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class k{constructor(T,h,f){this.level=T,this.key=h,this.value=f,this.forward=[]}}const p=void 0;class P{constructor(T,h=2**16){this.comparator=T,this[S]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(h)|0),this._header=new k(this._maxLevel,p,p)}get size(){return this._size}clear(){this._header=new k(this._maxLevel,p,p)}has(T){return Boolean(P._search(this,T,this.comparator))}get(T){return P._search(this,T,this.comparator)?.value}set(T,h){return P._insert(this,T,h,this.comparator)&&(this._size+=1),this}delete(T){const h=P._delete(this,T,this.comparator);return h&&(this._size-=1),h}forEach(T,h){let f=this._header.forward[0];for(;f;)T.call(h,f.value,f.key,this),f=f.forward[0]}[(S=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let T=this._header.forward[0];for(;T;)yield[T.key,T.value],T=T.forward[0]}*keys(){let T=this._header.forward[0];for(;T;)yield T.key,T=T.forward[0]}*values(){let T=this._header.forward[0];for(;T;)yield T.value,T=T.forward[0]}toString(){let T="[SkipList]:",h=this._header.forward[0];for(;h;)T+=`node(${h.key}, ${h.value}, lvl:${h.level})`,h=h.forward[0];return T}static _search(T,h,f){let C=T._header;for(let I=T._level-1;I>=0;I--)for(;C.forward[I]&&f(C.forward[I].key,h)<0;)C=C.forward[I];if(C=C.forward[0],C&&f(C.key,h)===0)return C}static _insert(T,h,f,C){let I=[],m=T._header;for(let u=T._level-1;u>=0;u--){for(;m.forward[u]&&C(m.forward[u].key,h)<0;)m=m.forward[u];I[u]=m}if(m=m.forward[0],m&&C(m.key,h)===0)return m.value=f,!1;{let u=P._randomLevel(T);if(u>T._level){for(let c=T._level;c<u;c++)I[c]=T._header;T._level=u}m=new k(u,h,f);for(let c=0;c<u;c++)m.forward[c]=I[c].forward[c],I[c].forward[c]=m;return!0}}static _randomLevel(T,h=.5){let f=1;for(;Math.random()<h&&f<T._maxLevel;)f+=1;return f}static _delete(T,h,f){let C=[],I=T._header;for(let m=T._level-1;m>=0;m--){for(;I.forward[m]&&f(I.forward[m].key,h)<0;)I=I.forward[m];C[m]=I}if(I=I.forward[0],!I||f(I.key,h)!==0)return!1;for(let m=0;m<T._level&&C[m].forward[m]===I;m++)C[m].forward[m]=I.forward[m];for(;T._level>0&&T._header.forward[T._level-1]===p;)T._level-=1;return!0}}e.SkipList=P}),define(ue[135],de([0,1,2]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const k=S.globals.performance&&typeof S.globals.performance.now=="function";class p{constructor(t){this._highResolution=k&&t,this._startTime=this._now(),this._stopTime=-1}static create(t=!0){return new p(t)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?S.globals.performance.now():Date.now()}}e.StopWatch=p}),define(ue[6],de([0,1,12,85,3,132,135]),function(Y,e,S,k,p,P,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var T;(function(a){a.None=()=>p.Disposable.None;function l(F){return(M,V=null,ee)=>{let G=!1,H;return H=F(q=>{if(!G)return H?H.dispose():G=!0,M.call(V,q)},null,ee),G&&H.dispose(),H}}a.once=l;function r(F,M){return y((V,ee=null,G)=>F(H=>V.call(ee,M(H)),null,G))}a.map=r;function o(F,M){return y((V,ee=null,G)=>F(H=>{M(H),V.call(ee,H)},null,G))}a.forEach=o;function i(F,M){return y((V,ee=null,G)=>F(H=>M(H)&&V.call(ee,H),null,G))}a.filter=i;function n(F){return F}a.signal=n;function s(...F){return(M,V=null,ee)=>(0,p.combinedDisposable)(...F.map(G=>G(H=>M.call(V,H),null,ee)))}a.any=s;function d(F,M,V){let ee=V;return r(F,G=>(ee=M(ee,G),ee))}a.reduce=d;function y(F){let M;const V=new m({onFirstListenerAdd(){M=F(V.fire,V)},onLastListenerRemove(){M.dispose()}});return V.event}function A(F,M,V=100,ee=!1,G){let H,q,z,B=0;const W=new m({leakWarningThreshold:G,onFirstListenerAdd(){H=F(ie=>{B++,q=M(q,ie),ee&&!z&&(W.fire(q),q=void 0),clearTimeout(z),z=setTimeout(()=>{const oe=q;q=void 0,z=void 0,(!ee||B>1)&&W.fire(oe),B=0},V)})},onLastListenerRemove(){H.dispose()}});return W.event}a.debounce=A;function E(F,M=(V,ee)=>V===ee){let V=!0,ee;return i(F,G=>{const H=V||!M(G,ee);return V=!1,ee=G,H})}a.latch=E;function R(F,M){return[a.filter(F,M),a.filter(F,V=>!M(V))]}a.split=R;function O(F,M=!1,V=[]){let ee=V.slice(),G=F(z=>{ee?ee.push(z):q.fire(z)});const H=()=>{ee&&ee.forEach(z=>q.fire(z)),ee=null},q=new m({onFirstListenerAdd(){G||(G=F(z=>q.fire(z)))},onFirstListenerDidAdd(){ee&&(M?setTimeout(H):H())},onLastListenerRemove(){G&&G.dispose(),G=null}});return q.event}a.buffer=O;class K{constructor(M){this.event=M}map(M){return new K(r(this.event,M))}forEach(M){return new K(o(this.event,M))}filter(M){return new K(i(this.event,M))}reduce(M,V){return new K(d(this.event,M,V))}latch(){return new K(E(this.event))}debounce(M,V=100,ee=!1,G){return new K(A(this.event,M,V,ee,G))}on(M,V,ee){return this.event(M,V,ee)}once(M,V,ee){return l(this.event)(M,V,ee)}}function te(F){return new K(F)}a.chain=te;function j(F,M,V=ee=>ee){const ee=(...z)=>q.fire(V(...z)),G=()=>F.on(M,ee),H=()=>F.removeListener(M,ee),q=new m({onFirstListenerAdd:G,onLastListenerRemove:H});return q.event}a.fromNodeEventEmitter=j;function _(F,M,V=ee=>ee){const ee=(...z)=>q.fire(V(...z)),G=()=>F.addEventListener(M,ee),H=()=>F.removeEventListener(M,ee),q=new m({onFirstListenerAdd:G,onLastListenerRemove:H});return q.event}a.fromDOMEventEmitter=_;function U(F){return new Promise(M=>l(F)(M))}a.toPromise=U})(T=e.Event||(e.Event={}));class h{constructor(l){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${l}_${h._idPool++}`}start(l){this._stopWatch=new t.StopWatch(!0),this._listenerCount=l}stop(){if(this._stopWatch){const l=this._stopWatch.elapsed();this._elapsedOverall+=l,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${l.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}h._idPool=0;let f=-1;function C(a){const l=f;return f=a,{dispose(){f=l}}}e.setGlobalLeakWarningThreshold=C;class I{constructor(l,r=Math.random().toString(18).slice(2,5)){this.customThreshold=l,this.name=r,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(l){let r=f;if(typeof this.customThreshold=="number"&&(r=this.customThreshold),r<=0||l<r)return;this._stacks||(this._stacks=new Map);const o=new Error().stack.split(`
`).slice(3).join(`
`),i=this._stacks.get(o)||0;if(this._stacks.set(o,i+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=r*.5;let n,s=0;for(const[d,y]of this._stacks)(!n||s<y)&&(n=d,s=y);console.warn(`[${this.name}] potential listener LEAK detected, having ${l} listeners already. MOST frequent listener (${s}):`),console.warn(n)}return()=>{const n=this._stacks.get(o)||0;this._stacks.set(o,n-1)}}}class m{constructor(l){this._disposed=!1,this._options=l,this._leakageMon=f>0?new I(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new h(this._options._profName):void 0}get event(){return this._event||(this._event=(l,r,o)=>{this._listeners||(this._listeners=new P.LinkedList);const i=this._listeners.isEmpty();i&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const n=this._listeners.push(r?[l,r]:l);i&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,l,r);const s=this._leakageMon?.check(this._listeners.size),d=(0,p.toDisposable)(()=>{s&&s(),this._disposed||(n(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return o instanceof p.DisposableStore?o.add(d):Array.isArray(o)&&o.push(d),d}),this._event}fire(l){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new P.LinkedList);for(let r of this._listeners)this._deliveryQueue.push([r,l]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[r,o]=this._deliveryQueue.shift();try{typeof r=="function"?r.call(void 0,o):r[0].call(r[1],o)}catch(i){(0,S.onUnexpectedError)(i)}}this._perfMon?.stop()}}dispose(){this._disposed||(this._disposed=!0,this._listeners?.clear(),this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose())}}e.Emitter=m;class u extends m{async fireAsync(l,r,o){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new P.LinkedList);for(const i of this._listeners)this._asyncDeliveryQueue.push([i,l]);for(;this._asyncDeliveryQueue.size>0&&!r.isCancellationRequested;){const[i,n]=this._asyncDeliveryQueue.shift(),s=[],d={...n,waitUntil:y=>{if(Object.isFrozen(s))throw new Error("waitUntil can NOT be called asynchronous");o&&(y=o(y,typeof i=="function"?i:i[0])),s.push(y)}};try{typeof i=="function"?i.call(void 0,d):i[0].call(i[1],d)}catch(y){(0,S.onUnexpectedError)(y);continue}Object.freeze(s),await Promise.allSettled(s).then(y=>{for(const A of y)A.status==="rejected"&&(0,S.onUnexpectedError)(A.reason)})}}}}e.AsyncEmitter=u;class c extends m{constructor(l){super(l);this._isPaused=0,this._eventQueue=new P.LinkedList,this._mergeFn=l?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const l=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(l))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(l){this._listeners&&(this._isPaused!==0?this._eventQueue.push(l):super.fire(l))}}e.PauseableEmitter=c;class b extends c{constructor(l){super(l);this._delay=l.delay??100}fire(l){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(l)}}e.DebounceEmitter=b;class g extends m{constructor(l){super(l);this._queuedEvents=[],this._mergeFn=l?.merge}fire(l){this._queuedEvents.push(l),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(r=>super.fire(r)),this._queuedEvents=[]})}}e.MicrotaskEmitter=g;class D{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new m({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(l){const r={event:l,listener:null};this.events.push(r),this.hasListeners&&this.hook(r);const o=()=>{this.hasListeners&&this.unhook(r);const i=this.events.indexOf(r);this.events.splice(i,1)};return(0,p.toDisposable)((0,k.once)(o))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(l=>this.hook(l))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(l=>this.unhook(l))}hook(l){l.listener=l.event(r=>this.emitter.fire(r))}unhook(l){l.listener&&l.listener.dispose(),l.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=D;class w{constructor(){this.buffers=[]}wrapEvent(l){return(r,o,i)=>l(n=>{const s=this.buffers[this.buffers.length-1];s?s.push(()=>r.call(o,n)):r.call(o,n)},void 0,i)}bufferEvents(l){const r=[];this.buffers.push(r);const o=l();return this.buffers.pop(),r.forEach(i=>i()),o}}e.EventBufferer=w;class v{constructor(){this.listening=!1,this.inputEvent=T.None,this.inputEventListener=p.Disposable.None,this.emitter=new m({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(l){this.inputEvent=l,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=l(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=v}),define(ue[24],de([0,1,6]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const k=Object.freeze(function(T,h){const f=setTimeout(T.bind(h),0);return{dispose(){clearTimeout(f)}}});var p;(function(T){function h(f){return f===T.None||f===T.Cancelled||f instanceof P?!0:!f||typeof f!="object"?!1:typeof f.isCancellationRequested=="boolean"&&typeof f.onCancellationRequested=="function"}T.isCancellationToken=h,T.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:S.Event.None}),T.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:k})})(p=e.CancellationToken||(e.CancellationToken={}));class P{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?k:(this._emitter||(this._emitter=new S.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class t{constructor(h){this._token=void 0,this._parentListener=void 0,this._parentListener=h&&h.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new P),this._token}cancel(){this._token?this._token instanceof P&&this._token.cancel():this._token=p.Cancelled}dispose(h=!1){h&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof P&&this._token.dispose():this._token=p.None}}e.CancellationTokenSource=t}),define(ue[40],de([0,1,6]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.iconRegistry=void 0;class k{constructor(){this._icons=new Map,this._onDidRegister=new S.Emitter}add(C){const I=this._icons.get(C.id);I?C.description?I.description=C.description:console.error(`Duplicate registration of codicon ${C.id}`):(this._icons.set(C.id,C),this._onDidRegister.fire(C))}get(C){return this._icons.get(C)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const p=new k;e.iconRegistry=p;function P(f){return f?f.replace(/\$\((.*?)\)/g,(C,I)=>` ${I} `).trim():""}e.getCodiconAriaLabel=P;class t{constructor(C,I,m){this.id=C,this.definition=I,this.description=m,p.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=t,t.add=new t("add",{fontCharacter:"\\ea60"}),t.plus=new t("plus",t.add.definition),t.gistNew=new t("gist-new",t.add.definition),t.repoCreate=new t("repo-create",t.add.definition),t.lightbulb=new t("lightbulb",{fontCharacter:"\\ea61"}),t.lightBulb=new t("light-bulb",{fontCharacter:"\\ea61"}),t.repo=new t("repo",{fontCharacter:"\\ea62"}),t.repoDelete=new t("repo-delete",{fontCharacter:"\\ea62"}),t.gistFork=new t("gist-fork",{fontCharacter:"\\ea63"}),t.repoForked=new t("repo-forked",{fontCharacter:"\\ea63"}),t.gitPullRequest=new t("git-pull-request",{fontCharacter:"\\ea64"}),t.gitPullRequestAbandoned=new t("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),t.recordKeys=new t("record-keys",{fontCharacter:"\\ea65"}),t.keyboard=new t("keyboard",{fontCharacter:"\\ea65"}),t.tag=new t("tag",{fontCharacter:"\\ea66"}),t.tagAdd=new t("tag-add",{fontCharacter:"\\ea66"}),t.tagRemove=new t("tag-remove",{fontCharacter:"\\ea66"}),t.person=new t("person",{fontCharacter:"\\ea67"}),t.personFollow=new t("person-follow",{fontCharacter:"\\ea67"}),t.personOutline=new t("person-outline",{fontCharacter:"\\ea67"}),t.personFilled=new t("person-filled",{fontCharacter:"\\ea67"}),t.gitBranch=new t("git-branch",{fontCharacter:"\\ea68"}),t.gitBranchCreate=new t("git-branch-create",{fontCharacter:"\\ea68"}),t.gitBranchDelete=new t("git-branch-delete",{fontCharacter:"\\ea68"}),t.sourceControl=new t("source-control",{fontCharacter:"\\ea68"}),t.mirror=new t("mirror",{fontCharacter:"\\ea69"}),t.mirrorPublic=new t("mirror-public",{fontCharacter:"\\ea69"}),t.star=new t("star",{fontCharacter:"\\ea6a"}),t.starAdd=new t("star-add",{fontCharacter:"\\ea6a"}),t.starDelete=new t("star-delete",{fontCharacter:"\\ea6a"}),t.starEmpty=new t("star-empty",{fontCharacter:"\\ea6a"}),t.comment=new t("comment",{fontCharacter:"\\ea6b"}),t.commentAdd=new t("comment-add",{fontCharacter:"\\ea6b"}),t.alert=new t("alert",{fontCharacter:"\\ea6c"}),t.warning=new t("warning",{fontCharacter:"\\ea6c"}),t.search=new t("search",{fontCharacter:"\\ea6d"}),t.searchSave=new t("search-save",{fontCharacter:"\\ea6d"}),t.logOut=new t("log-out",{fontCharacter:"\\ea6e"}),t.signOut=new t("sign-out",{fontCharacter:"\\ea6e"}),t.logIn=new t("log-in",{fontCharacter:"\\ea6f"}),t.signIn=new t("sign-in",{fontCharacter:"\\ea6f"}),t.eye=new t("eye",{fontCharacter:"\\ea70"}),t.eyeUnwatch=new t("eye-unwatch",{fontCharacter:"\\ea70"}),t.eyeWatch=new t("eye-watch",{fontCharacter:"\\ea70"}),t.circleFilled=new t("circle-filled",{fontCharacter:"\\ea71"}),t.primitiveDot=new t("primitive-dot",{fontCharacter:"\\ea71"}),t.closeDirty=new t("close-dirty",{fontCharacter:"\\ea71"}),t.debugBreakpoint=new t("debug-breakpoint",{fontCharacter:"\\ea71"}),t.debugBreakpointDisabled=new t("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),t.debugHint=new t("debug-hint",{fontCharacter:"\\ea71"}),t.primitiveSquare=new t("primitive-square",{fontCharacter:"\\ea72"}),t.edit=new t("edit",{fontCharacter:"\\ea73"}),t.pencil=new t("pencil",{fontCharacter:"\\ea73"}),t.info=new t("info",{fontCharacter:"\\ea74"}),t.issueOpened=new t("issue-opened",{fontCharacter:"\\ea74"}),t.gistPrivate=new t("gist-private",{fontCharacter:"\\ea75"}),t.gitForkPrivate=new t("git-fork-private",{fontCharacter:"\\ea75"}),t.lock=new t("lock",{fontCharacter:"\\ea75"}),t.mirrorPrivate=new t("mirror-private",{fontCharacter:"\\ea75"}),t.close=new t("close",{fontCharacter:"\\ea76"}),t.removeClose=new t("remove-close",{fontCharacter:"\\ea76"}),t.x=new t("x",{fontCharacter:"\\ea76"}),t.repoSync=new t("repo-sync",{fontCharacter:"\\ea77"}),t.sync=new t("sync",{fontCharacter:"\\ea77"}),t.clone=new t("clone",{fontCharacter:"\\ea78"}),t.desktopDownload=new t("desktop-download",{fontCharacter:"\\ea78"}),t.beaker=new t("beaker",{fontCharacter:"\\ea79"}),t.microscope=new t("microscope",{fontCharacter:"\\ea79"}),t.vm=new t("vm",{fontCharacter:"\\ea7a"}),t.deviceDesktop=new t("device-desktop",{fontCharacter:"\\ea7a"}),t.file=new t("file",{fontCharacter:"\\ea7b"}),t.fileText=new t("file-text",{fontCharacter:"\\ea7b"}),t.more=new t("more",{fontCharacter:"\\ea7c"}),t.ellipsis=new t("ellipsis",{fontCharacter:"\\ea7c"}),t.kebabHorizontal=new t("kebab-horizontal",{fontCharacter:"\\ea7c"}),t.mailReply=new t("mail-reply",{fontCharacter:"\\ea7d"}),t.reply=new t("reply",{fontCharacter:"\\ea7d"}),t.organization=new t("organization",{fontCharacter:"\\ea7e"}),t.organizationFilled=new t("organization-filled",{fontCharacter:"\\ea7e"}),t.organizationOutline=new t("organization-outline",{fontCharacter:"\\ea7e"}),t.newFile=new t("new-file",{fontCharacter:"\\ea7f"}),t.fileAdd=new t("file-add",{fontCharacter:"\\ea7f"}),t.newFolder=new t("new-folder",{fontCharacter:"\\ea80"}),t.fileDirectoryCreate=new t("file-directory-create",{fontCharacter:"\\ea80"}),t.trash=new t("trash",{fontCharacter:"\\ea81"}),t.trashcan=new t("trashcan",{fontCharacter:"\\ea81"}),t.history=new t("history",{fontCharacter:"\\ea82"}),t.clock=new t("clock",{fontCharacter:"\\ea82"}),t.folder=new t("folder",{fontCharacter:"\\ea83"}),t.fileDirectory=new t("file-directory",{fontCharacter:"\\ea83"}),t.symbolFolder=new t("symbol-folder",{fontCharacter:"\\ea83"}),t.logoGithub=new t("logo-github",{fontCharacter:"\\ea84"}),t.markGithub=new t("mark-github",{fontCharacter:"\\ea84"}),t.github=new t("github",{fontCharacter:"\\ea84"}),t.terminal=new t("terminal",{fontCharacter:"\\ea85"}),t.console=new t("console",{fontCharacter:"\\ea85"}),t.repl=new t("repl",{fontCharacter:"\\ea85"}),t.zap=new t("zap",{fontCharacter:"\\ea86"}),t.symbolEvent=new t("symbol-event",{fontCharacter:"\\ea86"}),t.error=new t("error",{fontCharacter:"\\ea87"}),t.stop=new t("stop",{fontCharacter:"\\ea87"}),t.variable=new t("variable",{fontCharacter:"\\ea88"}),t.symbolVariable=new t("symbol-variable",{fontCharacter:"\\ea88"}),t.array=new t("array",{fontCharacter:"\\ea8a"}),t.symbolArray=new t("symbol-array",{fontCharacter:"\\ea8a"}),t.symbolModule=new t("symbol-module",{fontCharacter:"\\ea8b"}),t.symbolPackage=new t("symbol-package",{fontCharacter:"\\ea8b"}),t.symbolNamespace=new t("symbol-namespace",{fontCharacter:"\\ea8b"}),t.symbolObject=new t("symbol-object",{fontCharacter:"\\ea8b"}),t.symbolMethod=new t("symbol-method",{fontCharacter:"\\ea8c"}),t.symbolFunction=new t("symbol-function",{fontCharacter:"\\ea8c"}),t.symbolConstructor=new t("symbol-constructor",{fontCharacter:"\\ea8c"}),t.symbolBoolean=new t("symbol-boolean",{fontCharacter:"\\ea8f"}),t.symbolNull=new t("symbol-null",{fontCharacter:"\\ea8f"}),t.symbolNumeric=new t("symbol-numeric",{fontCharacter:"\\ea90"}),t.symbolNumber=new t("symbol-number",{fontCharacter:"\\ea90"}),t.symbolStructure=new t("symbol-structure",{fontCharacter:"\\ea91"}),t.symbolStruct=new t("symbol-struct",{fontCharacter:"\\ea91"}),t.symbolParameter=new t("symbol-parameter",{fontCharacter:"\\ea92"}),t.symbolTypeParameter=new t("symbol-type-parameter",{fontCharacter:"\\ea92"}),t.symbolKey=new t("symbol-key",{fontCharacter:"\\ea93"}),t.symbolText=new t("symbol-text",{fontCharacter:"\\ea93"}),t.symbolReference=new t("symbol-reference",{fontCharacter:"\\ea94"}),t.goToFile=new t("go-to-file",{fontCharacter:"\\ea94"}),t.symbolEnum=new t("symbol-enum",{fontCharacter:"\\ea95"}),t.symbolValue=new t("symbol-value",{fontCharacter:"\\ea95"}),t.symbolRuler=new t("symbol-ruler",{fontCharacter:"\\ea96"}),t.symbolUnit=new t("symbol-unit",{fontCharacter:"\\ea96"}),t.activateBreakpoints=new t("activate-breakpoints",{fontCharacter:"\\ea97"}),t.archive=new t("archive",{fontCharacter:"\\ea98"}),t.arrowBoth=new t("arrow-both",{fontCharacter:"\\ea99"}),t.arrowDown=new t("arrow-down",{fontCharacter:"\\ea9a"}),t.arrowLeft=new t("arrow-left",{fontCharacter:"\\ea9b"}),t.arrowRight=new t("arrow-right",{fontCharacter:"\\ea9c"}),t.arrowSmallDown=new t("arrow-small-down",{fontCharacter:"\\ea9d"}),t.arrowSmallLeft=new t("arrow-small-left",{fontCharacter:"\\ea9e"}),t.arrowSmallRight=new t("arrow-small-right",{fontCharacter:"\\ea9f"}),t.arrowSmallUp=new t("arrow-small-up",{fontCharacter:"\\eaa0"}),t.arrowUp=new t("arrow-up",{fontCharacter:"\\eaa1"}),t.bell=new t("bell",{fontCharacter:"\\eaa2"}),t.bold=new t("bold",{fontCharacter:"\\eaa3"}),t.book=new t("book",{fontCharacter:"\\eaa4"}),t.bookmark=new t("bookmark",{fontCharacter:"\\eaa5"}),t.debugBreakpointConditionalUnverified=new t("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),t.debugBreakpointConditional=new t("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),t.debugBreakpointConditionalDisabled=new t("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),t.debugBreakpointDataUnverified=new t("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),t.debugBreakpointData=new t("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),t.debugBreakpointDataDisabled=new t("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),t.debugBreakpointLogUnverified=new t("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),t.debugBreakpointLog=new t("debug-breakpoint-log",{fontCharacter:"\\eaab"}),t.debugBreakpointLogDisabled=new t("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),t.briefcase=new t("briefcase",{fontCharacter:"\\eaac"}),t.broadcast=new t("broadcast",{fontCharacter:"\\eaad"}),t.browser=new t("browser",{fontCharacter:"\\eaae"}),t.bug=new t("bug",{fontCharacter:"\\eaaf"}),t.calendar=new t("calendar",{fontCharacter:"\\eab0"}),t.caseSensitive=new t("case-sensitive",{fontCharacter:"\\eab1"}),t.check=new t("check",{fontCharacter:"\\eab2"}),t.checklist=new t("checklist",{fontCharacter:"\\eab3"}),t.chevronDown=new t("chevron-down",{fontCharacter:"\\eab4"}),t.dropDownButton=new t("drop-down-button",t.chevronDown.definition),t.chevronLeft=new t("chevron-left",{fontCharacter:"\\eab5"}),t.chevronRight=new t("chevron-right",{fontCharacter:"\\eab6"}),t.chevronUp=new t("chevron-up",{fontCharacter:"\\eab7"}),t.chromeClose=new t("chrome-close",{fontCharacter:"\\eab8"}),t.chromeMaximize=new t("chrome-maximize",{fontCharacter:"\\eab9"}),t.chromeMinimize=new t("chrome-minimize",{fontCharacter:"\\eaba"}),t.chromeRestore=new t("chrome-restore",{fontCharacter:"\\eabb"}),t.circleOutline=new t("circle-outline",{fontCharacter:"\\eabc"}),t.debugBreakpointUnverified=new t("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),t.circleSlash=new t("circle-slash",{fontCharacter:"\\eabd"}),t.circuitBoard=new t("circuit-board",{fontCharacter:"\\eabe"}),t.clearAll=new t("clear-all",{fontCharacter:"\\eabf"}),t.clippy=new t("clippy",{fontCharacter:"\\eac0"}),t.closeAll=new t("close-all",{fontCharacter:"\\eac1"}),t.cloudDownload=new t("cloud-download",{fontCharacter:"\\eac2"}),t.cloudUpload=new t("cloud-upload",{fontCharacter:"\\eac3"}),t.code=new t("code",{fontCharacter:"\\eac4"}),t.collapseAll=new t("collapse-all",{fontCharacter:"\\eac5"}),t.colorMode=new t("color-mode",{fontCharacter:"\\eac6"}),t.commentDiscussion=new t("comment-discussion",{fontCharacter:"\\eac7"}),t.compareChanges=new t("compare-changes",{fontCharacter:"\\eafd"}),t.creditCard=new t("credit-card",{fontCharacter:"\\eac9"}),t.dash=new t("dash",{fontCharacter:"\\eacc"}),t.dashboard=new t("dashboard",{fontCharacter:"\\eacd"}),t.database=new t("database",{fontCharacter:"\\eace"}),t.debugContinue=new t("debug-continue",{fontCharacter:"\\eacf"}),t.debugDisconnect=new t("debug-disconnect",{fontCharacter:"\\ead0"}),t.debugPause=new t("debug-pause",{fontCharacter:"\\ead1"}),t.debugRestart=new t("debug-restart",{fontCharacter:"\\ead2"}),t.debugStart=new t("debug-start",{fontCharacter:"\\ead3"}),t.debugStepInto=new t("debug-step-into",{fontCharacter:"\\ead4"}),t.debugStepOut=new t("debug-step-out",{fontCharacter:"\\ead5"}),t.debugStepOver=new t("debug-step-over",{fontCharacter:"\\ead6"}),t.debugStop=new t("debug-stop",{fontCharacter:"\\ead7"}),t.debug=new t("debug",{fontCharacter:"\\ead8"}),t.deviceCameraVideo=new t("device-camera-video",{fontCharacter:"\\ead9"}),t.deviceCamera=new t("device-camera",{fontCharacter:"\\eada"}),t.deviceMobile=new t("device-mobile",{fontCharacter:"\\eadb"}),t.diffAdded=new t("diff-added",{fontCharacter:"\\eadc"}),t.diffIgnored=new t("diff-ignored",{fontCharacter:"\\eadd"}),t.diffModified=new t("diff-modified",{fontCharacter:"\\eade"}),t.diffRemoved=new t("diff-removed",{fontCharacter:"\\eadf"}),t.diffRenamed=new t("diff-renamed",{fontCharacter:"\\eae0"}),t.diff=new t("diff",{fontCharacter:"\\eae1"}),t.discard=new t("discard",{fontCharacter:"\\eae2"}),t.editorLayout=new t("editor-layout",{fontCharacter:"\\eae3"}),t.emptyWindow=new t("empty-window",{fontCharacter:"\\eae4"}),t.exclude=new t("exclude",{fontCharacter:"\\eae5"}),t.extensions=new t("extensions",{fontCharacter:"\\eae6"}),t.eyeClosed=new t("eye-closed",{fontCharacter:"\\eae7"}),t.fileBinary=new t("file-binary",{fontCharacter:"\\eae8"}),t.fileCode=new t("file-code",{fontCharacter:"\\eae9"}),t.fileMedia=new t("file-media",{fontCharacter:"\\eaea"}),t.filePdf=new t("file-pdf",{fontCharacter:"\\eaeb"}),t.fileSubmodule=new t("file-submodule",{fontCharacter:"\\eaec"}),t.fileSymlinkDirectory=new t("file-symlink-directory",{fontCharacter:"\\eaed"}),t.fileSymlinkFile=new t("file-symlink-file",{fontCharacter:"\\eaee"}),t.fileZip=new t("file-zip",{fontCharacter:"\\eaef"}),t.files=new t("files",{fontCharacter:"\\eaf0"}),t.filter=new t("filter",{fontCharacter:"\\eaf1"}),t.flame=new t("flame",{fontCharacter:"\\eaf2"}),t.foldDown=new t("fold-down",{fontCharacter:"\\eaf3"}),t.foldUp=new t("fold-up",{fontCharacter:"\\eaf4"}),t.fold=new t("fold",{fontCharacter:"\\eaf5"}),t.folderActive=new t("folder-active",{fontCharacter:"\\eaf6"}),t.folderOpened=new t("folder-opened",{fontCharacter:"\\eaf7"}),t.gear=new t("gear",{fontCharacter:"\\eaf8"}),t.gift=new t("gift",{fontCharacter:"\\eaf9"}),t.gistSecret=new t("gist-secret",{fontCharacter:"\\eafa"}),t.gist=new t("gist",{fontCharacter:"\\eafb"}),t.gitCommit=new t("git-commit",{fontCharacter:"\\eafc"}),t.gitCompare=new t("git-compare",{fontCharacter:"\\eafd"}),t.gitMerge=new t("git-merge",{fontCharacter:"\\eafe"}),t.githubAction=new t("github-action",{fontCharacter:"\\eaff"}),t.githubAlt=new t("github-alt",{fontCharacter:"\\eb00"}),t.globe=new t("globe",{fontCharacter:"\\eb01"}),t.grabber=new t("grabber",{fontCharacter:"\\eb02"}),t.graph=new t("graph",{fontCharacter:"\\eb03"}),t.gripper=new t("gripper",{fontCharacter:"\\eb04"}),t.heart=new t("heart",{fontCharacter:"\\eb05"}),t.home=new t("home",{fontCharacter:"\\eb06"}),t.horizontalRule=new t("horizontal-rule",{fontCharacter:"\\eb07"}),t.hubot=new t("hubot",{fontCharacter:"\\eb08"}),t.inbox=new t("inbox",{fontCharacter:"\\eb09"}),t.issueClosed=new t("issue-closed",{fontCharacter:"\\eba4"}),t.issueReopened=new t("issue-reopened",{fontCharacter:"\\eb0b"}),t.issues=new t("issues",{fontCharacter:"\\eb0c"}),t.italic=new t("italic",{fontCharacter:"\\eb0d"}),t.jersey=new t("jersey",{fontCharacter:"\\eb0e"}),t.json=new t("json",{fontCharacter:"\\eb0f"}),t.kebabVertical=new t("kebab-vertical",{fontCharacter:"\\eb10"}),t.key=new t("key",{fontCharacter:"\\eb11"}),t.law=new t("law",{fontCharacter:"\\eb12"}),t.lightbulbAutofix=new t("lightbulb-autofix",{fontCharacter:"\\eb13"}),t.linkExternal=new t("link-external",{fontCharacter:"\\eb14"}),t.link=new t("link",{fontCharacter:"\\eb15"}),t.listOrdered=new t("list-ordered",{fontCharacter:"\\eb16"}),t.listUnordered=new t("list-unordered",{fontCharacter:"\\eb17"}),t.liveShare=new t("live-share",{fontCharacter:"\\eb18"}),t.loading=new t("loading",{fontCharacter:"\\eb19"}),t.location=new t("location",{fontCharacter:"\\eb1a"}),t.mailRead=new t("mail-read",{fontCharacter:"\\eb1b"}),t.mail=new t("mail",{fontCharacter:"\\eb1c"}),t.markdown=new t("markdown",{fontCharacter:"\\eb1d"}),t.megaphone=new t("megaphone",{fontCharacter:"\\eb1e"}),t.mention=new t("mention",{fontCharacter:"\\eb1f"}),t.milestone=new t("milestone",{fontCharacter:"\\eb20"}),t.mortarBoard=new t("mortar-board",{fontCharacter:"\\eb21"}),t.move=new t("move",{fontCharacter:"\\eb22"}),t.multipleWindows=new t("multiple-windows",{fontCharacter:"\\eb23"}),t.mute=new t("mute",{fontCharacter:"\\eb24"}),t.noNewline=new t("no-newline",{fontCharacter:"\\eb25"}),t.note=new t("note",{fontCharacter:"\\eb26"}),t.octoface=new t("octoface",{fontCharacter:"\\eb27"}),t.openPreview=new t("open-preview",{fontCharacter:"\\eb28"}),t.package_=new t("package",{fontCharacter:"\\eb29"}),t.paintcan=new t("paintcan",{fontCharacter:"\\eb2a"}),t.pin=new t("pin",{fontCharacter:"\\eb2b"}),t.play=new t("play",{fontCharacter:"\\eb2c"}),t.run=new t("run",{fontCharacter:"\\eb2c"}),t.plug=new t("plug",{fontCharacter:"\\eb2d"}),t.preserveCase=new t("preserve-case",{fontCharacter:"\\eb2e"}),t.preview=new t("preview",{fontCharacter:"\\eb2f"}),t.project=new t("project",{fontCharacter:"\\eb30"}),t.pulse=new t("pulse",{fontCharacter:"\\eb31"}),t.question=new t("question",{fontCharacter:"\\eb32"}),t.quote=new t("quote",{fontCharacter:"\\eb33"}),t.radioTower=new t("radio-tower",{fontCharacter:"\\eb34"}),t.reactions=new t("reactions",{fontCharacter:"\\eb35"}),t.references=new t("references",{fontCharacter:"\\eb36"}),t.refresh=new t("refresh",{fontCharacter:"\\eb37"}),t.regex=new t("regex",{fontCharacter:"\\eb38"}),t.remoteExplorer=new t("remote-explorer",{fontCharacter:"\\eb39"}),t.remote=new t("remote",{fontCharacter:"\\eb3a"}),t.remove=new t("remove",{fontCharacter:"\\eb3b"}),t.replaceAll=new t("replace-all",{fontCharacter:"\\eb3c"}),t.replace=new t("replace",{fontCharacter:"\\eb3d"}),t.repoClone=new t("repo-clone",{fontCharacter:"\\eb3e"}),t.repoForcePush=new t("repo-force-push",{fontCharacter:"\\eb3f"}),t.repoPull=new t("repo-pull",{fontCharacter:"\\eb40"}),t.repoPush=new t("repo-push",{fontCharacter:"\\eb41"}),t.report=new t("report",{fontCharacter:"\\eb42"}),t.requestChanges=new t("request-changes",{fontCharacter:"\\eb43"}),t.rocket=new t("rocket",{fontCharacter:"\\eb44"}),t.rootFolderOpened=new t("root-folder-opened",{fontCharacter:"\\eb45"}),t.rootFolder=new t("root-folder",{fontCharacter:"\\eb46"}),t.rss=new t("rss",{fontCharacter:"\\eb47"}),t.ruby=new t("ruby",{fontCharacter:"\\eb48"}),t.saveAll=new t("save-all",{fontCharacter:"\\eb49"}),t.saveAs=new t("save-as",{fontCharacter:"\\eb4a"}),t.save=new t("save",{fontCharacter:"\\eb4b"}),t.screenFull=new t("screen-full",{fontCharacter:"\\eb4c"}),t.screenNormal=new t("screen-normal",{fontCharacter:"\\eb4d"}),t.searchStop=new t("search-stop",{fontCharacter:"\\eb4e"}),t.server=new t("server",{fontCharacter:"\\eb50"}),t.settingsGear=new t("settings-gear",{fontCharacter:"\\eb51"}),t.settings=new t("settings",{fontCharacter:"\\eb52"}),t.shield=new t("shield",{fontCharacter:"\\eb53"}),t.smiley=new t("smiley",{fontCharacter:"\\eb54"}),t.sortPrecedence=new t("sort-precedence",{fontCharacter:"\\eb55"}),t.splitHorizontal=new t("split-horizontal",{fontCharacter:"\\eb56"}),t.splitVertical=new t("split-vertical",{fontCharacter:"\\eb57"}),t.squirrel=new t("squirrel",{fontCharacter:"\\eb58"}),t.starFull=new t("star-full",{fontCharacter:"\\eb59"}),t.starHalf=new t("star-half",{fontCharacter:"\\eb5a"}),t.symbolClass=new t("symbol-class",{fontCharacter:"\\eb5b"}),t.symbolColor=new t("symbol-color",{fontCharacter:"\\eb5c"}),t.symbolConstant=new t("symbol-constant",{fontCharacter:"\\eb5d"}),t.symbolEnumMember=new t("symbol-enum-member",{fontCharacter:"\\eb5e"}),t.symbolField=new t("symbol-field",{fontCharacter:"\\eb5f"}),t.symbolFile=new t("symbol-file",{fontCharacter:"\\eb60"}),t.symbolInterface=new t("symbol-interface",{fontCharacter:"\\eb61"}),t.symbolKeyword=new t("symbol-keyword",{fontCharacter:"\\eb62"}),t.symbolMisc=new t("symbol-misc",{fontCharacter:"\\eb63"}),t.symbolOperator=new t("symbol-operator",{fontCharacter:"\\eb64"}),t.symbolProperty=new t("symbol-property",{fontCharacter:"\\eb65"}),t.wrench=new t("wrench",{fontCharacter:"\\eb65"}),t.wrenchSubaction=new t("wrench-subaction",{fontCharacter:"\\eb65"}),t.symbolSnippet=new t("symbol-snippet",{fontCharacter:"\\eb66"}),t.tasklist=new t("tasklist",{fontCharacter:"\\eb67"}),t.telescope=new t("telescope",{fontCharacter:"\\eb68"}),t.textSize=new t("text-size",{fontCharacter:"\\eb69"}),t.threeBars=new t("three-bars",{fontCharacter:"\\eb6a"}),t.thumbsdown=new t("thumbsdown",{fontCharacter:"\\eb6b"}),t.thumbsup=new t("thumbsup",{fontCharacter:"\\eb6c"}),t.tools=new t("tools",{fontCharacter:"\\eb6d"}),t.triangleDown=new t("triangle-down",{fontCharacter:"\\eb6e"}),t.triangleLeft=new t("triangle-left",{fontCharacter:"\\eb6f"}),t.triangleRight=new t("triangle-right",{fontCharacter:"\\eb70"}),t.triangleUp=new t("triangle-up",{fontCharacter:"\\eb71"}),t.twitter=new t("twitter",{fontCharacter:"\\eb72"}),t.unfold=new t("unfold",{fontCharacter:"\\eb73"}),t.unlock=new t("unlock",{fontCharacter:"\\eb74"}),t.unmute=new t("unmute",{fontCharacter:"\\eb75"}),t.unverified=new t("unverified",{fontCharacter:"\\eb76"}),t.verified=new t("verified",{fontCharacter:"\\eb77"}),t.versions=new t("versions",{fontCharacter:"\\eb78"}),t.vmActive=new t("vm-active",{fontCharacter:"\\eb79"}),t.vmOutline=new t("vm-outline",{fontCharacter:"\\eb7a"}),t.vmRunning=new t("vm-running",{fontCharacter:"\\eb7b"}),t.watch=new t("watch",{fontCharacter:"\\eb7c"}),t.whitespace=new t("whitespace",{fontCharacter:"\\eb7d"}),t.wholeWord=new t("whole-word",{fontCharacter:"\\eb7e"}),t.window=new t("window",{fontCharacter:"\\eb7f"}),t.wordWrap=new t("word-wrap",{fontCharacter:"\\eb80"}),t.zoomIn=new t("zoom-in",{fontCharacter:"\\eb81"}),t.zoomOut=new t("zoom-out",{fontCharacter:"\\eb82"}),t.listFilter=new t("list-filter",{fontCharacter:"\\eb83"}),t.listFlat=new t("list-flat",{fontCharacter:"\\eb84"}),t.listSelection=new t("list-selection",{fontCharacter:"\\eb85"}),t.selection=new t("selection",{fontCharacter:"\\eb85"}),t.listTree=new t("list-tree",{fontCharacter:"\\eb86"}),t.debugBreakpointFunctionUnverified=new t("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),t.debugBreakpointFunction=new t("debug-breakpoint-function",{fontCharacter:"\\eb88"}),t.debugBreakpointFunctionDisabled=new t("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),t.debugStackframeActive=new t("debug-stackframe-active",{fontCharacter:"\\eb89"}),t.debugStackframeDot=new t("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),t.debugStackframe=new t("debug-stackframe",{fontCharacter:"\\eb8b"}),t.debugStackframeFocused=new t("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),t.debugBreakpointUnsupported=new t("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),t.symbolString=new t("symbol-string",{fontCharacter:"\\eb8d"}),t.debugReverseContinue=new t("debug-reverse-continue",{fontCharacter:"\\eb8e"}),t.debugStepBack=new t("debug-step-back",{fontCharacter:"\\eb8f"}),t.debugRestartFrame=new t("debug-restart-frame",{fontCharacter:"\\eb90"}),t.callIncoming=new t("call-incoming",{fontCharacter:"\\eb92"}),t.callOutgoing=new t("call-outgoing",{fontCharacter:"\\eb93"}),t.menu=new t("menu",{fontCharacter:"\\eb94"}),t.expandAll=new t("expand-all",{fontCharacter:"\\eb95"}),t.feedback=new t("feedback",{fontCharacter:"\\eb96"}),t.groupByRefType=new t("group-by-ref-type",{fontCharacter:"\\eb97"}),t.ungroupByRefType=new t("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),t.account=new t("account",{fontCharacter:"\\eb99"}),t.bellDot=new t("bell-dot",{fontCharacter:"\\eb9a"}),t.debugConsole=new t("debug-console",{fontCharacter:"\\eb9b"}),t.library=new t("library",{fontCharacter:"\\eb9c"}),t.output=new t("output",{fontCharacter:"\\eb9d"}),t.runAll=new t("run-all",{fontCharacter:"\\eb9e"}),t.syncIgnored=new t("sync-ignored",{fontCharacter:"\\eb9f"}),t.pinned=new t("pinned",{fontCharacter:"\\eba0"}),t.githubInverted=new t("github-inverted",{fontCharacter:"\\eba1"}),t.debugAlt=new t("debug-alt",{fontCharacter:"\\eb91"}),t.serverProcess=new t("server-process",{fontCharacter:"\\eba2"}),t.serverEnvironment=new t("server-environment",{fontCharacter:"\\eba3"}),t.pass=new t("pass",{fontCharacter:"\\eba4"}),t.stopCircle=new t("stop-circle",{fontCharacter:"\\eba5"}),t.playCircle=new t("play-circle",{fontCharacter:"\\eba6"}),t.record=new t("record",{fontCharacter:"\\eba7"}),t.debugAltSmall=new t("debug-alt-small",{fontCharacter:"\\eba8"}),t.vmConnect=new t("vm-connect",{fontCharacter:"\\eba9"}),t.cloud=new t("cloud",{fontCharacter:"\\ebaa"}),t.merge=new t("merge",{fontCharacter:"\\ebab"}),t.exportIcon=new t("export",{fontCharacter:"\\ebac"}),t.graphLeft=new t("graph-left",{fontCharacter:"\\ebad"}),t.magnet=new t("magnet",{fontCharacter:"\\ebae"}),t.notebook=new t("notebook",{fontCharacter:"\\ebaf"}),t.redo=new t("redo",{fontCharacter:"\\ebb0"}),t.checkAll=new t("check-all",{fontCharacter:"\\ebb1"}),t.pinnedDirty=new t("pinned-dirty",{fontCharacter:"\\ebb2"}),t.passFilled=new t("pass-filled",{fontCharacter:"\\ebb3"}),t.circleLargeFilled=new t("circle-large-filled",{fontCharacter:"\\ebb4"}),t.circleLargeOutline=new t("circle-large-outline",{fontCharacter:"\\ebb5"}),t.combine=new t("combine",{fontCharacter:"\\ebb6"}),t.gather=new t("gather",{fontCharacter:"\\ebb6"}),t.table=new t("table",{fontCharacter:"\\ebb7"}),t.variableGroup=new t("variable-group",{fontCharacter:"\\ebb8"}),t.typeHierarchy=new t("type-hierarchy",{fontCharacter:"\\ebb9"}),t.typeHierarchySub=new t("type-hierarchy-sub",{fontCharacter:"\\ebba"}),t.typeHierarchySuper=new t("type-hierarchy-super",{fontCharacter:"\\ebbb"}),t.gitPullRequestCreate=new t("git-pull-request-create",{fontCharacter:"\\ebbc"}),t.runAbove=new t("run-above",{fontCharacter:"\\ebbd"}),t.runBelow=new t("run-below",{fontCharacter:"\\ebbe"}),t.notebookTemplate=new t("notebook-template",{fontCharacter:"\\ebbf"}),t.debugRerun=new t("debug-rerun",{fontCharacter:"\\ebc0"}),t.workspaceTrusted=new t("workspace-trusted",{fontCharacter:"\\ebc1"}),t.workspaceUntrusted=new t("workspace-untrusted",{fontCharacter:"\\ebc2"}),t.workspaceUnspecified=new t("workspace-unspecified",{fontCharacter:"\\ebc3"}),t.terminalCmd=new t("terminal-cmd",{fontCharacter:"\\ebc4"}),t.terminalDebian=new t("terminal-debian",{fontCharacter:"\\ebc5"}),t.terminalLinux=new t("terminal-linux",{fontCharacter:"\\ebc6"}),t.terminalPowershell=new t("terminal-powershell",{fontCharacter:"\\ebc7"}),t.terminalTmux=new t("terminal-tmux",{fontCharacter:"\\ebc8"}),t.terminalUbuntu=new t("terminal-ubuntu",{fontCharacter:"\\ebc9"}),t.terminalBash=new t("terminal-bash",{fontCharacter:"\\ebca"}),t.arrowSwap=new t("arrow-swap",{fontCharacter:"\\ebcb"}),t.copy=new t("copy",{fontCharacter:"\\ebcc"}),t.personAdd=new t("person-add",{fontCharacter:"\\ebcd"}),t.filterFilled=new t("filter-filled",{fontCharacter:"\\ebce"}),t.wand=new t("wand",{fontCharacter:"\\ebcf"}),t.debugLineByLine=new t("debug-line-by-line",{fontCharacter:"\\ebd0"}),t.inspect=new t("inspect",{fontCharacter:"\\ebd1"}),t.layers=new t("layers",{fontCharacter:"\\ebd2"}),t.layersDot=new t("layers-dot",{fontCharacter:"\\ebd3"}),t.layersActive=new t("layers-active",{fontCharacter:"\\ebd4"}),t.compass=new t("compass",{fontCharacter:"\\ebd5"}),t.compassDot=new t("compass-dot",{fontCharacter:"\\ebd6"}),t.compassActive=new t("compass-active",{fontCharacter:"\\ebd7"}),t.azure=new t("azure",{fontCharacter:"\\ebd8"}),t.issueDraft=new t("issue-draft",{fontCharacter:"\\ebd9"}),t.gitPullRequestClosed=new t("git-pull-request-closed",{fontCharacter:"\\ebda"}),t.gitPullRequestDraft=new t("git-pull-request-draft",{fontCharacter:"\\ebdb"}),t.debugAll=new t("debug-all",{fontCharacter:"\\ebdc"}),t.debugCoverage=new t("debug-coverage",{fontCharacter:"\\ebdd"}),t.runErrors=new t("run-errors",{fontCharacter:"\\ebde"}),t.folderLibrary=new t("folder-library",{fontCharacter:"\\ebdf"}),t.debugContinueSmall=new t("debug-continue-small",{fontCharacter:"\\ebe0"}),t.beakerStop=new t("beaker-stop",{fontCharacter:"\\ebe1"}),t.graphLine=new t("graph-line",{fontCharacter:"\\ebe2"}),t.graphScatter=new t("graph-scatter",{fontCharacter:"\\ebe3"}),t.pieChart=new t("pie-chart",{fontCharacter:"\\ebe4"}),t.bracket=new t("bracket",t.json.definition),t.bracketDot=new t("bracket-dot",{fontCharacter:"\\ebe5"}),t.bracketError=new t("bracket-error",{fontCharacter:"\\ebe6"}),t.lockSmall=new t("lock-small",{fontCharacter:"\\ebe7"}),t.azureDevops=new t("azure-devops",{fontCharacter:"\\ebe8"}),t.verifiedFilled=new t("verified-filled",{fontCharacter:"\\ebe9"}),t.newLine=new t("newline",{fontCharacter:"\\ebea"}),t.dialogError=new t("dialog-error",t.error.definition),t.dialogWarning=new t("dialog-warning",t.warning.definition),t.dialogInfo=new t("dialog-info",t.info.definition),t.dialogClose=new t("dialog-close",t.close.definition),t.treeItemExpanded=new t("tree-item-expanded",t.chevronDown.definition),t.treeFilterOnTypeOn=new t("tree-filter-on-type-on",t.listFilter.definition),t.treeFilterOnTypeOff=new t("tree-filter-on-type-off",t.listSelection.definition),t.treeFilterClear=new t("tree-filter-clear",t.close.definition),t.treeItemLoading=new t("tree-item-loading",t.loading.definition),t.menuSelection=new t("menu-selection",t.check.definition),t.menuSubmenu=new t("menu-submenu",t.chevronRight.definition),t.menuBarMore=new t("menubar-more",t.more.definition),t.scrollbarButtonLeft=new t("scrollbar-button-left",t.triangleLeft.definition),t.scrollbarButtonRight=new t("scrollbar-button-right",t.triangleRight.definition),t.scrollbarButtonUp=new t("scrollbar-button-up",t.triangleUp.definition),t.scrollbarButtonDown=new t("scrollbar-button-down",t.triangleDown.definition),t.toolBarMore=new t("toolbar-more",t.more.definition),t.quickInputBack=new t("quick-input-back",t.arrowLeft.definition);function T(f,C){const I=["codicon","codicon-"+f];return C&&I.push("codicon-modifier-"+C),I}e.getClassNamesArray=T;var h;(function(f){f.iconNameSegment="[A-Za-z0-9]+",f.iconNameExpression="[A-Za-z0-9-]+",f.iconModifierExpression="~[A-Za-z]+",f.iconNameCharacter="[A-Za-z0-9~-]";const C=new RegExp(`^(${f.iconNameExpression})(${f.iconModifierExpression})?$`);function I(c){if(c instanceof t)return["codicon","codicon-"+c.id];const b=C.exec(c.id);if(!b)return I(t.error);let[,g,D]=b;const w=["codicon","codicon-"+g];return D&&w.push("codicon-modifier-"+D.substr(1)),w}f.asClassNameArray=I;function m(c){return I(c).join(" ")}f.asClassName=m;function u(c){return"."+I(c).join(".")}f.asCSSSelector=u})(h=e.CSSIcon||(e.CSSIcon={}))}),define(ue[47],de([0,1,12,3]),function(Y,e,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function p(v){const a=v;return a?[a.on,a.pause,a.resume,a.destroy].every(l=>typeof l=="function"):!1}e.isReadableStream=p;function P(v){const a=v;return a?p(a.stream)&&Array.isArray(a.buffer)&&typeof a.ended=="boolean":!1}e.isReadableBufferedStream=P;function t(v,a){return new T(v,a)}e.newWriteableStream=t;class T{constructor(a,l){this.reducer=a,this.options=l,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(a){if(!this.state.destroyed){if(this.state.flowing)this.emitData(a);else if(this.buffer.data.push(a),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(l=>this.pendingWritePromises.push(l))}}error(a){this.state.destroyed||(this.state.flowing?this.emitError(a):this.buffer.error.push(a))}end(a){this.state.destroyed||(typeof a!="undefined"&&this.write(a),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(a){this.listeners.data.slice(0).forEach(l=>l(a))}emitError(a){this.listeners.error.length===0?(0,S.onUnexpectedError)(a):this.listeners.error.slice(0).forEach(l=>l(a))}emitEnd(){this.listeners.end.slice(0).forEach(a=>a())}on(a,l){if(!this.state.destroyed)switch(a){case"data":this.listeners.data.push(l),this.resume();break;case"end":this.listeners.end.push(l),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(l),this.state.flowing&&this.flowErrors();break}}removeListener(a,l){if(this.state.destroyed)return;let r;switch(a){case"data":r=this.listeners.data;break;case"end":r=this.listeners.end;break;case"error":r=this.listeners.error;break}if(r){const o=r.indexOf(l);o>=0&&r.splice(o,1)}}flowData(){if(this.buffer.data.length>0){const a=this.reducer(this.buffer.data);this.emitData(a),this.buffer.data.length=0;const l=[...this.pendingWritePromises];this.pendingWritePromises.length=0,l.forEach(r=>r())}}flowErrors(){if(this.listeners.error.length>0){for(const a of this.buffer.error)this.emitError(a);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function h(v,a){const l=[];let r;for(;(r=v.read())!==null;)l.push(r);return a(l)}e.consumeReadable=h;function f(v,a,l){const r=[];let o;for(;(o=v.read())!==null&&r.length<l;)r.push(o);return o===null&&r.length>0?a(r):{read:()=>{if(r.length>0)return r.shift();if(typeof o!="undefined"){const i=o;return o=void 0,i}return v.read()}}}e.peekReadable=f;function C(v,a){return new Promise((l,r)=>{const o=[];I(v,{onData:i=>{a&&o.push(i)},onError:i=>{a?r(i):l(void 0)},onEnd:()=>{l(a?a(o):void 0)}})})}e.consumeStream=C;function I(v,a){v.on("error",l=>a.onError(l)),v.on("end",()=>a.onEnd()),v.on("data",l=>a.onData(l))}e.listenStream=I;function m(v,a){return new Promise((l,r)=>{const o=new k.DisposableStore,i=[],n=y=>{if(i.push(y),i.length>a)return o.dispose(),v.pause(),l({stream:v,buffer:i,ended:!1})},s=y=>r(y),d=()=>l({stream:v,buffer:i,ended:!0});o.add((0,k.toDisposable)(()=>v.removeListener("error",s))),v.on("error",s),o.add((0,k.toDisposable)(()=>v.removeListener("end",d))),v.on("end",d),o.add((0,k.toDisposable)(()=>v.removeListener("data",n))),v.on("data",n)})}e.peekStream=m;function u(v,a){const l=t(a);return l.end(v),l}e.toStream=u;function c(){const v=t(()=>{throw new Error("not supported")});return v.end(),v}e.emptyStream=c;function b(v){let a=!1;return{read:()=>a?null:(a=!0,v)}}e.toReadable=b;function g(v,a,l){const r=t(l);return I(v,{onData:o=>r.write(a.data(o)),onError:o=>r.error(a.error?a.error(o):o),onEnd:()=>r.end()}),r}e.transform=g;function D(v,a,l){let r=!1;return{read:()=>{const o=a.read();return r?o:(r=!0,o!==null?l([v,o]):v)}}}e.prefixedReadable=D;function w(v,a,l){let r=!1;const o=t(l);return I(a,{onData:i=>r?o.write(i):(r=!0,o.write(l([v,i]))),onError:i=>o.error(i),onEnd:()=>{r||(r=!0,o.write(v)),o.end()}}),o}e.prefixedStream=w}),define(ue[18],de([0,1,47]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const k=typeof Buffer!="undefined";let p,P;class t{constructor(n){this.buffer=n,this.byteLength=this.buffer.byteLength}static alloc(n){return k?new t(Buffer.allocUnsafe(n)):new t(new Uint8Array(n))}static wrap(n){return k&&!Buffer.isBuffer(n)&&(n=Buffer.from(n.buffer,n.byteOffset,n.byteLength)),new t(n)}static fromString(n,s){return!(s?.dontUseNodeBuffer||!1)&&k?new t(Buffer.from(n)):(p||(p=new TextEncoder),new t(p.encode(n)))}static concat(n,s){if(typeof s=="undefined"){s=0;for(let A=0,E=n.length;A<E;A++)s+=n[A].byteLength}const d=t.alloc(s);let y=0;for(let A=0,E=n.length;A<E;A++){const R=n[A];d.set(R,y),y+=R.byteLength}return d}toString(){return k?this.buffer.toString():(P||(P=new TextDecoder),P.decode(this.buffer))}slice(n,s){return new t(this.buffer.subarray(n,s))}set(n,s){n instanceof t?this.buffer.set(n.buffer,s):this.buffer.set(n,s)}readUInt32BE(n){return f(this.buffer,n)}writeUInt32BE(n,s){C(this.buffer,n,s)}readUInt32LE(n){return I(this.buffer,n)}writeUInt32LE(n,s){m(this.buffer,n,s)}readUInt8(n){return u(this.buffer,n)}writeUInt8(n,s){c(this.buffer,n,s)}}e.VSBuffer=t;function T(i,n){return i[n+0]<<0>>>0|i[n+1]<<8>>>0}e.readUInt16LE=T;function h(i,n,s){i[s+0]=n&255,n=n>>>8,i[s+1]=n&255}e.writeUInt16LE=h;function f(i,n){return i[n]*2**24+i[n+1]*2**16+i[n+2]*2**8+i[n+3]}e.readUInt32BE=f;function C(i,n,s){i[s+3]=n,n=n>>>8,i[s+2]=n,n=n>>>8,i[s+1]=n,n=n>>>8,i[s]=n}e.writeUInt32BE=C;function I(i,n){return i[n+0]<<0>>>0|i[n+1]<<8>>>0|i[n+2]<<16>>>0|i[n+3]<<24>>>0}e.readUInt32LE=I;function m(i,n,s){i[s+0]=n&255,n=n>>>8,i[s+1]=n&255,n=n>>>8,i[s+2]=n&255,n=n>>>8,i[s+3]=n&255}e.writeUInt32LE=m;function u(i,n){return i[n]}e.readUInt8=u;function c(i,n,s){i[s]=n}e.writeUInt8=c;function b(i){return S.consumeReadable(i,n=>t.concat(n))}e.readableToBuffer=b;function g(i){return S.toReadable(i)}e.bufferToReadable=g;function D(i){return S.consumeStream(i,n=>t.concat(n))}e.streamToBuffer=D;async function w(i){return i.ended?t.concat(i.buffer):t.concat([...i.buffer,await D(i.stream)])}e.bufferedStreamToBuffer=w;function v(i){return S.toStream(i,n=>t.concat(n))}e.bufferToStream=v;function a(i){return S.transform(i,{data:n=>typeof n=="string"?t.fromString(n):t.wrap(n)},n=>t.concat(n))}e.streamToBufferReadableStream=a;function l(i){return S.newWriteableStream(n=>t.concat(n),i)}e.newWriteableBufferStream=l;function r(i,n){return S.prefixedReadable(i,n,s=>t.concat(s))}e.prefixedBufferReadable=r;function o(i,n){return S.prefixedStream(i,n,s=>t.concat(s))}e.prefixedBufferStream=o}),define(ue[14],de([0,1,2]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function k(ne){return!ne||typeof ne!="string"?!0:ne.trim().length===0}e.isFalsyOrWhitespace=k;const p=/{(\d+)}/g;function P(ne,...be){return be.length===0?ne:ne.replace(p,function(Fe,Ae){const Ve=parseInt(Ae,10);return isNaN(Ve)||Ve<0||Ve>=be.length?Fe:be[Ve]})}e.format=P;const t=/{([^}]+)}/g;function T(ne,be){return ne.replace(t,(Fe,Ae)=>be[Ae]??Fe)}e.format2=T;function h(ne){return ne.replace(/[<>&]/g,function(be){switch(be){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return be}})}e.escape=h;function f(ne){return ne.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=f;function C(ne,be){let Fe=0;const Ae=be.charCodeAt(0);for(let Ve=ne.length-1;Ve>=0;Ve--)ne.charCodeAt(Ve)===Ae&&Fe++;return Fe}e.count=C;function I(ne,be,Fe="\u2026"){return ne.length<=be?ne:`${ne.substr(0,be)}${Fe}`}e.truncate=I;function m(ne,be=" "){const Fe=u(ne,be);return c(Fe,be)}e.trim=m;function u(ne,be){if(!ne||!be)return ne;const Fe=be.length;if(Fe===0||ne.length===0)return ne;let Ae=0;for(;ne.indexOf(be,Ae)===Ae;)Ae=Ae+Fe;return ne.substring(Ae)}e.ltrim=u;function c(ne,be){if(!ne||!be)return ne;const Fe=be.length,Ae=ne.length;if(Fe===0||Ae===0)return ne;let Ve=Ae,ve=-1;for(;ve=ne.lastIndexOf(be,Ve-1),!(ve===-1||ve+Fe!==Ve);){if(ve===0)return"";Ve=ve}return ne.substring(0,Ve)}e.rtrim=c;function b(ne){return ne.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=b;function g(ne){return ne.replace(/\*/g,"")}e.stripWildcards=g;function D(ne,be,Fe={}){if(!ne)throw new Error("Cannot create regex from empty string");be||(ne=f(ne)),Fe.wholeWord&&(/\B/.test(ne.charAt(0))||(ne="\\b"+ne),/\B/.test(ne.charAt(ne.length-1))||(ne=ne+"\\b"));let Ae="";return Fe.global&&(Ae+="g"),Fe.matchCase||(Ae+="i"),Fe.multiline&&(Ae+="m"),Fe.unicode&&(Ae+="u"),new RegExp(ne,Ae)}e.createRegExp=D;function w(ne){return ne.source==="^"||ne.source==="^$"||ne.source==="$"||ne.source==="^\\s*$"?!1:!!(ne.exec("")&&ne.lastIndex===0)}e.regExpLeadsToEndlessLoop=w;function v(ne){return!!ne.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=v;function a(ne){return(ne.global?"g":"")+(ne.ignoreCase?"i":"")+(ne.multiline?"m":"")+(ne.unicode?"u":"")}e.regExpFlags=a;function l(ne){return ne.split(/\r\n|\r|\n/)}e.splitLines=l;function r(ne){for(let be=0,Fe=ne.length;be<Fe;be++){const Ae=ne.charCodeAt(be);if(Ae!==32&&Ae!==9)return be}return-1}e.firstNonWhitespaceIndex=r;function o(ne,be=0,Fe=ne.length){for(let Ae=be;Ae<Fe;Ae++){const Ve=ne.charCodeAt(Ae);if(Ve!==32&&Ve!==9)return ne.substring(be,Ae)}return ne.substring(be,Fe)}e.getLeadingWhitespace=o;function i(ne,be=ne.length-1){for(let Fe=be;Fe>=0;Fe--){const Ae=ne.charCodeAt(Fe);if(Ae!==32&&Ae!==9)return Fe}return-1}e.lastNonWhitespaceIndex=i;function n(ne,be){return ne<be?-1:ne>be?1:0}e.compare=n;function s(ne,be,Fe=0,Ae=ne.length,Ve=0,ve=be.length){for(;Fe<Ae&&Ve<ve;Fe++,Ve++){let J=ne.charCodeAt(Fe),x=be.charCodeAt(Ve);if(J<x)return-1;if(J>x)return 1}const fe=Ae-Fe,pe=ve-Ve;return fe<pe?-1:fe>pe?1:0}e.compareSubstring=s;function d(ne,be){return y(ne,be,0,ne.length,0,be.length)}e.compareIgnoreCase=d;function y(ne,be,Fe=0,Ae=ne.length,Ve=0,ve=be.length){for(;Fe<Ae&&Ve<ve;Fe++,Ve++){let J=ne.charCodeAt(Fe),x=be.charCodeAt(Ve);if(J===x)continue;if(J>=128||x>=128)return s(ne.toLowerCase(),be.toLowerCase(),Fe,Ae,Ve,ve);A(J)&&(J-=32),A(x)&&(x-=32);const Q=J-x;if(Q!==0)return Q}const fe=Ae-Fe,pe=ve-Ve;return fe<pe?-1:fe>pe?1:0}e.compareSubstringIgnoreCase=y;function A(ne){return ne>=97&&ne<=122}e.isLowerAsciiLetter=A;function E(ne){return ne>=65&&ne<=90}e.isUpperAsciiLetter=E;function R(ne,be){return ne.length===be.length&&y(ne,be)===0}e.equalsIgnoreCase=R;function O(ne,be){const Fe=be.length;return be.length>ne.length?!1:y(ne,be,0,Fe)===0}e.startsWithIgnoreCase=O;function K(ne,be){let Fe,Ae=Math.min(ne.length,be.length);for(Fe=0;Fe<Ae;Fe++)if(ne.charCodeAt(Fe)!==be.charCodeAt(Fe))return Fe;return Ae}e.commonPrefixLength=K;function te(ne,be){let Fe,Ae=Math.min(ne.length,be.length);const Ve=ne.length-1,ve=be.length-1;for(Fe=0;Fe<Ae;Fe++)if(ne.charCodeAt(Ve-Fe)!==be.charCodeAt(ve-Fe))return Fe;return Ae}e.commonSuffixLength=te;function j(ne){return 55296<=ne&&ne<=56319}e.isHighSurrogate=j;function _(ne){return 56320<=ne&&ne<=57343}e.isLowSurrogate=_;function U(ne,be){return(ne-55296<<10)+(be-56320)+65536}e.computeCodePoint=U;function F(ne,be,Fe){const Ae=ne.charCodeAt(Fe);if(j(Ae)&&Fe+1<be){const Ve=ne.charCodeAt(Fe+1);if(_(Ve))return U(Ae,Ve)}return Ae}e.getNextCodePoint=F;function M(ne,be){const Fe=ne.charCodeAt(be-1);if(_(Fe)&&be>1){const Ae=ne.charCodeAt(be-2);if(j(Ae))return U(Ae,Fe)}return Fe}function V(ne,be){const Fe=Se.getInstance(),Ae=be,Ve=ne.length,ve=F(ne,Ve,be);be+=ve>=65536?2:1;let fe=Fe.getGraphemeBreakType(ve);for(;be<Ve;){const pe=F(ne,Ve,be),J=Fe.getGraphemeBreakType(pe);if(rt(fe,J))break;be+=pe>=65536?2:1,fe=J}return be-Ae}e.nextCharLength=V;function ee(ne,be){const Fe=Se.getInstance(),Ae=be,Ve=M(ne,be);be-=Ve>=65536?2:1;let ve=Fe.getGraphemeBreakType(Ve);for(;be>0;){const fe=M(ne,be),pe=Fe.getGraphemeBreakType(fe);if(rt(pe,ve))break;be-=fe>=65536?2:1,ve=pe}return Ae-be}e.prevCharLength=ee;function G(ne,be){const Fe=Se.getInstance(),Ae=ne.length,Ve=be,ve=F(ne,Ae,be),fe=Fe.getGraphemeBreakType(ve);be+=ve>=65536?2:1;let pe=fe;for(;be<Ae;){const x=F(ne,Ae,be),Q=Fe.getGraphemeBreakType(x);if(rt(pe,Q))break;be+=x>=65536?2:1,pe=Q}const J=be;for(be=Ve,pe=fe;be>0;){const x=M(ne,be),Q=Fe.getGraphemeBreakType(x);if(rt(Q,pe))break;be-=x>=65536?2:1,pe=Q}return[be,J]}function H(ne,be){return be>0&&_(ne.charCodeAt(be))?G(ne,be-1):G(ne,be)}e.getCharContainingOffset=H;const q=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function z(ne){return q.test(ne)}e.containsRTL=z;const B=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFF0]|\uD83E[\uDD00-\uDDFF\uDE70-\uDEF6])/;function W(ne){return B.test(ne)}e.containsEmoji=W;const ie=/^[\t\n\r\x20-\x7E]*$/;function oe(ne){return ie.test(ne)}e.isBasicASCII=oe,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function we(ne){return e.UNUSUAL_LINE_TERMINATORS.test(ne)}e.containsUnusualLineTerminators=we;function se(ne){for(let be=0,Fe=ne.length;be<Fe;be++)if(ae(ne.charCodeAt(be)))return!0;return!1}e.containsFullWidthCharacter=se;function ae(ne){return ne>=11904&&ne<=55215||ne>=63744&&ne<=64255||ne>=65281&&ne<=65374}e.isFullWidthCharacter=ae;function ke(ne){return ne>=127462&&ne<=127487||ne===8986||ne===8987||ne===9200||ne===9203||ne>=9728&&ne<=10175||ne===11088||ne===11093||ne>=127744&&ne<=128591||ne>=128640&&ne<=128764||ne>=128992&&ne<=129008||ne>=129280&&ne<=129535||ne>=129648&&ne<=129782}e.isEmojiImprecise=ke;function De(ne,be){if(ne.length<be)return ne;const Fe=/\b/g;let Ae=0;for(;Fe.test(ne)&&!(ne.length-Fe.lastIndex<be);)Ae=Fe.lastIndex,Fe.lastIndex+=1;return ne.substring(Ae).replace(/^\s/,"")}e.lcut=De;const Oe=/\x1B\x5B[12]?K/g,Be=/\x1b\[\d+m/g,Xe=/\x1b\[0?m/g;function Ze(ne){return ne&&(ne=ne.replace(Oe,""),ne=ne.replace(Be,""),ne=ne.replace(Xe,"")),ne}e.removeAnsiEscapeCodes=Ze,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function ge(ne){return!!(ne&&ne.length>0&&ne.charCodeAt(0)===65279)}e.startsWithUTF8BOM=ge;function me(ne){return ge(ne)?ne.substr(1):ne}e.stripUTF8BOM=me;function Ie(ne,be){if(!ne||!be||ne.length<be.length)return!1;const Fe=be.length,Ae=ne.toLowerCase();let Ve=0,ve=-1;for(;Ve<Fe;){const fe=Ae.indexOf(be[Ve],ve+1);if(fe<0)return!1;ve=fe,Ve++}return!0}e.fuzzyContains=Ie;function Re(ne,be=!1){return ne?(be&&(ne=ne.replace(/\\./g,"")),ne.toLowerCase()!==ne):!1}e.containsUppercaseCharacter=Re;function Le(ne){return ne.charAt(0).toUpperCase()+ne.slice(1)}e.uppercaseFirstLetter=Le;function He(ne,be=1){if(be===0)return"";let Fe=-1;do Fe=ne.indexOf(`
`,Fe+1),be--;while(be>0&&Fe>=0);return Fe===-1?ne:(ne[Fe-1]==="\r"&&Fe--,ne.substr(0,Fe))}e.getNLines=He;function Qe(ne){const be=90-65+1;return ne=ne%(2*be),ne<be?String.fromCharCode(97+ne):String.fromCharCode(65+ne-be)}e.singleLetterHash=Qe;function Je(ne){return Se.getInstance().getGraphemeBreakType(ne)}e.getGraphemeBreakType=Je;function rt(ne,be){return ne===0?be!==5&&be!==7:ne===2&&be===3?!1:ne===4||ne===2||ne===3||be===4||be===2||be===3?!0:!(ne===8&&(be===8||be===9||be===11||be===12)||(ne===11||ne===9)&&(be===9||be===10)||(ne===12||ne===10)&&be===10||be===5||be===13||be===7||ne===1||ne===13&&be===14||ne===6&&be===6)}e.breakBetweenGraphemeBreakType=rt;var ce;(function(ne){ne[ne.Other=0]="Other",ne[ne.Prepend=1]="Prepend",ne[ne.CR=2]="CR",ne[ne.LF=3]="LF",ne[ne.Control=4]="Control",ne[ne.Extend=5]="Extend",ne[ne.Regional_Indicator=6]="Regional_Indicator",ne[ne.SpacingMark=7]="SpacingMark",ne[ne.L=8]="L",ne[ne.V=9]="V",ne[ne.T=10]="T",ne[ne.LV=11]="LV",ne[ne.LVT=12]="LVT",ne[ne.ZWJ=13]="ZWJ",ne[ne.Extended_Pictographic=14]="Extended_Pictographic"})(ce=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Se{constructor(){this._data=Pe()}static getInstance(){return Se._INSTANCE||(Se._INSTANCE=new Se),Se._INSTANCE}getGraphemeBreakType(be){if(be<32)return be===10?3:be===13?2:4;if(be<127)return 0;const Fe=this._data,Ae=Fe.length/3;let Ve=1;for(;Ve<=Ae;)if(be<Fe[3*Ve])Ve=2*Ve;else if(be>Fe[3*Ve+1])Ve=2*Ve+1;else return Fe[3*Ve+2];return 0}}Se._INSTANCE=null;function Pe(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function $e(ne,be){if(ne===0)return 0;const Fe=Ye(ne,be);if(Fe!==void 0)return Fe;const Ae=M(be,ne);return ne-=lt(Ae),ne}e.getLeftDeleteOffset=$e;function Ye(ne,be){let Fe=M(be,ne);for(ne-=lt(Fe);tt(Fe)||Fe===65039||Fe===8419;){if(ne===0)return;Fe=M(be,ne),ne-=lt(Fe)}if(!!ke(Fe)){if(ne>=0){const Ae=M(be,ne);Ae===8205&&(ne-=lt(Ae))}return ne}}function lt(ne){return ne>=65536?2:1}function tt(ne){return 127995<=ne&&ne<=127999}var at;(function(ne){ne[ne.zwj=8205]="zwj",ne[ne.emojiVariantSelector=65039]="emojiVariantSelector",ne[ne.enclosingKeyCap=8419]="enclosingKeyCap"})(at||(at={})),e.noBreakWhitespace="\xA0";class ot{static getData(){return JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,40,10088,40,10098,40,12308,40,64830,40,65341,41,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,124,8739,124,9213,124,65512,124,1633,124,1777,124,66336,124,125127,124,120783,124,120793,124,120803,124,120813,124,120823,124,130033,124,65321,124,8544,124,8464,124,8465,124,119816,124,119868,124,119920,124,120024,124,120128,124,120180,124,120232,124,120284,124,120336,124,120388,124,120440,124,406,124,65356,124,8572,124,8467,124,119845,124,119897,124,119949,124,120001,124,120053,124,120105,124,120157,124,120209,124,120261,124,120313,124,120365,124,120417,124,120469,124,448,124,120496,124,120554,124,120612,124,120670,124,120728,124,11410,124,1030,124,1216,124,1493,124,1503,124,1575,124,126464,124,126592,124,65166,124,65165,124,1994,124,11599,124,5825,124,42226,124,93992,124,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90],"_default":[160,32,8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"cs":[65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89],"de":[65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89],"es":[8211,45,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"fr":[65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"it":[160,32,8211,45,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"ko":[8211,45,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"pl":[65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"pt-BR":[65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"qps-ploc":[160,32,8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"ru":[65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,124,1009,112,215,120],"tr":[160,32,8211,45,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"zh-hans":[65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"zh-hant":[8211,45,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89]}')}static getConfusablesForCurrentLocale(){if(!ot.map){let Ae=function(fe){const pe=new Map;for(let J=0;J<fe.length;J+=2)pe.set(fe[J],fe[J+1]);return pe};const be=ot.getData();let Fe=S.locale;(!Fe||!(Fe in be))&&(Fe=S.language),(!Fe||!(Fe in be))&&(Fe="_default");const Ve=Ae(be._common),ve=Ae(be[Fe]);for(const[fe,pe]of ve)Ve.set(fe,pe);ot.map=Ve}return ot.map}static isAmbiguous(be){return ot.getConfusablesForCurrentLocale().has(be)}static getPrimaryConfusable(be){return ot.getConfusablesForCurrentLocale().get(be)}static getPrimaryConfusableCodePoints(){return new Set(ot.getConfusablesForCurrentLocale().keys())}}e.AmbiguousCharacters=ot;class et{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(et.getRawData())),this._data}static isInvisibleCharacter(be){return et.getData().has(be)}static get codePoints(){return et.getData()}}e.InvisibleCharacters=et,et._data=void 0}),define(ue[136],de([0,1,14]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function k(D){return p(D,0)}e.hash=k;function p(D,w){switch(typeof D){case"object":return D===null?P(349,w):Array.isArray(D)?h(D,w):f(D,w);case"string":return T(D,w);case"boolean":return t(D,w);case"number":return P(D,w);case"undefined":return P(937,w);default:return P(617,w)}}e.doHash=p;function P(D,w){return(w<<5)-w+D|0}e.numberHash=P;function t(D,w){return P(D?433:863,w)}function T(D,w){w=P(149417,w);for(let v=0,a=D.length;v<a;v++)w=P(D.charCodeAt(v),w);return w}e.stringHash=T;function h(D,w){return w=P(104579,w),D.reduce((v,a)=>p(a,v),w)}function f(D,w){return w=P(181387,w),Object.keys(D).sort().reduce((v,a)=>(v=T(a,v),p(D[a],v)),w)}class C{constructor(){this._value=0}get value(){return this._value}hash(w){return this._value=p(w,this._value),this._value}}e.Hasher=C;var I;(function(D){D[D.BLOCK_SIZE=64]="BLOCK_SIZE",D[D.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(I||(I={}));function m(D,w,v=32){const a=v-w,l=~((1<<a)-1);return(D<<w|(l&D)>>>a)>>>0}function u(D,w=0,v=D.byteLength,a=0){for(let l=0;l<v;l++)D[w+l]=a}function c(D,w,v="0"){for(;D.length<w;)D=v+D;return D}function b(D,w=32){return D instanceof ArrayBuffer?Array.from(new Uint8Array(D)).map(v=>v.toString(16).padStart(2,"0")).join(""):c((D>>>0).toString(16),w/4)}e.toHexString=b;class g{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(w){const v=w.length;if(v===0)return;const a=this._buff;let l=this._buffLen,r=this._leftoverHighSurrogate,o,i;for(r!==0?(o=r,i=-1,r=0):(o=w.charCodeAt(0),i=0);;){let n=o;if(S.isHighSurrogate(o))if(i+1<v){const s=w.charCodeAt(i+1);S.isLowSurrogate(s)?(i++,n=S.computeCodePoint(o,s)):n=65533}else{r=o;break}else S.isLowSurrogate(o)&&(n=65533);if(l=this._push(a,l,n),i++,i<v)o=w.charCodeAt(i);else break}this._buffLen=l,this._leftoverHighSurrogate=r}_push(w,v,a){return a<128?w[v++]=a:a<2048?(w[v++]=192|(a&1984)>>>6,w[v++]=128|(a&63)>>>0):a<65536?(w[v++]=224|(a&61440)>>>12,w[v++]=128|(a&4032)>>>6,w[v++]=128|(a&63)>>>0):(w[v++]=240|(a&1835008)>>>18,w[v++]=128|(a&258048)>>>12,w[v++]=128|(a&4032)>>>6,w[v++]=128|(a&63)>>>0),v>=64&&(this._step(),v-=64,this._totalLen+=64,w[0]=w[64+0],w[1]=w[64+1],w[2]=w[64+2]),v}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),b(this._h0)+b(this._h1)+b(this._h2)+b(this._h3)+b(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,u(this._buff,this._buffLen),this._buffLen>56&&(this._step(),u(this._buff));const w=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(w/4294967296),!1),this._buffDV.setUint32(60,w%4294967296,!1),this._step()}_step(){const w=g._bigBlock32,v=this._buffDV;for(let y=0;y<64;y+=4)w.setUint32(y,v.getUint32(y,!1),!1);for(let y=64;y<320;y+=4)w.setUint32(y,m(w.getUint32(y-12,!1)^w.getUint32(y-32,!1)^w.getUint32(y-56,!1)^w.getUint32(y-64,!1),1),!1);let a=this._h0,l=this._h1,r=this._h2,o=this._h3,i=this._h4,n,s,d;for(let y=0;y<80;y++)y<20?(n=l&r|~l&o,s=1518500249):y<40?(n=l^r^o,s=1859775393):y<60?(n=l&r|l&o|r&o,s=2400959708):(n=l^r^o,s=3395469782),d=m(a,5)+n+i+s+w.getUint32(y*4,!1)&4294967295,i=o,o=r,r=m(l,30),l=a,a=d;this._h0=this._h0+a&4294967295,this._h1=this._h1+l&4294967295,this._h2=this._h2+r&4294967295,this._h3=this._h3+o&4294967295,this._h4=this._h4+i&4294967295}}e.StringSHA1=g,g._bigBlock32=new DataView(new ArrayBuffer(320))});var Dt=this&&this.__classPrivateFieldSet||function(Y,e,S,k,p){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!p)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!p:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?p.call(Y,S):p?p.value=S:e.set(Y,S),S},ut=this&&this.__classPrivateFieldGet||function(Y,e,S,k){if(S==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!k:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return S==="m"?k:S==="a"?k.call(Y):k?k.value:e.get(Y)};define(ue[30],de([0,1,20,14]),function(Y,e,S,k){"use strict";var p,P,t;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function T(i,n,s){let d=i.get(n);return d===void 0&&(d=s,i.set(n,d)),d}e.getOrSet=T;function h(i){const n=[];return i.forEach((s,d)=>{n.push(`${d} => ${s}`)}),`Map(${i.size}) {${n.join(", ")}}`}e.mapToString=h;function f(i){const n=[];return i.forEach(s=>{n.push(s)}),`Set(${i.size}) {${n.join(", ")}}`}e.setToString=f;class C{constructor(){this._value="",this._pos=0}reset(n){return this._value=n,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(n){const s=n.charCodeAt(0),d=this._value.charCodeAt(this._pos);return s-d}value(){return this._value[this._pos]}}e.StringIterator=C;class I{constructor(n=!0){this._caseSensitive=n}reset(n){return this._value=n,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let n=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(n)this._from++;else break;else n=!1;return this}cmp(n){return this._caseSensitive?(0,k.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,k.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=I;class m{constructor(n=!0,s=!0){this._splitOnBackslash=n,this._caseSensitive=s}reset(n){return this._value=n.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let n=!0;for(;this._to<this._value.length;this._to++){const s=this._value.charCodeAt(this._to);if(s===47||this._splitOnBackslash&&s===92)if(n)this._from++;else break;else n=!1}return this}cmp(n){return this._caseSensitive?(0,k.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,k.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=m;var u;(function(i){i[i.Scheme=1]="Scheme",i[i.Authority=2]="Authority",i[i.Path=3]="Path",i[i.Query=4]="Query",i[i.Fragment=5]="Fragment"})(u||(u={}));class c{constructor(n){this._ignorePathCasing=n,this._states=[],this._stateIdx=0}reset(n){return this._value=n,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new m(!1,!this._ignorePathCasing(n)),this._pathIterator.reset(n.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(n){if(this._states[this._stateIdx]===1)return(0,k.compareIgnoreCase)(n,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,k.compareIgnoreCase)(n,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(n);if(this._states[this._stateIdx]===4)return(0,k.compare)(n,this._value.query);if(this._states[this._stateIdx]===5)return(0,k.compare)(n,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=c;class b{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const n=this.right;return this.right=n.left,n.left=this,this.updateHeight(),n.updateHeight(),n}rotateRight(){const n=this.left;return this.left=n.right,n.right=this,this.updateHeight(),n.updateHeight(),n}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var g;(function(i){i[i.Left=-1]="Left",i[i.Mid=0]="Mid",i[i.Right=1]="Right"})(g||(g={}));class D{constructor(n){this._iter=n}static forUris(n=()=>!1){return new D(new c(n))}static forPaths(){return new D(new m)}static forStrings(){return new D(new C)}static forConfigKeys(){return new D(new I)}clear(){this._root=void 0}fill(n,s){if(s){const d=s.slice(0);(0,S.shuffle)(d);for(let y of d)this.set(y,n)}else{const d=n.slice(0);(0,S.shuffle)(d);for(let y of d)this.set(y[0],y[1])}}set(n,s){const d=this._iter.reset(n);let y;this._root||(this._root=new b,this._root.segment=d.value());const A=[];for(y=this._root;;){const R=d.cmp(y.segment);if(R>0)y.left||(y.left=new b,y.left.segment=d.value()),A.push([-1,y]),y=y.left;else if(R<0)y.right||(y.right=new b,y.right.segment=d.value()),A.push([1,y]),y=y.right;else if(d.hasNext())d.next(),y.mid||(y.mid=new b,y.mid.segment=d.value()),A.push([0,y]),y=y.mid;else break}const E=y.value;y.value=s,y.key=n;for(let R=A.length-1;R>=0;R--){const O=A[R][1];O.updateHeight();const K=O.balanceFactor();if(K<-1||K>1){const te=A[R][0],j=A[R+1][0];if(te===1&&j===1)A[R][1]=O.rotateLeft();else if(te===-1&&j===-1)A[R][1]=O.rotateRight();else if(te===1&&j===-1)O.right=A[R+1][1]=A[R+1][1].rotateRight(),A[R][1]=O.rotateLeft();else if(te===-1&&j===1)O.left=A[R+1][1]=A[R+1][1].rotateLeft(),A[R][1]=O.rotateRight();else throw new Error;if(R>0)switch(A[R-1][0]){case-1:A[R-1][1].left=A[R][1];break;case 1:A[R-1][1].right=A[R][1];break;case 0:A[R-1][1].mid=A[R][1];break}else this._root=A[0][1]}}return E}get(n){return this._getNode(n)?.value}_getNode(n){const s=this._iter.reset(n);let d=this._root;for(;d;){const y=s.cmp(d.segment);if(y>0)d=d.left;else if(y<0)d=d.right;else if(s.hasNext())s.next(),d=d.mid;else break}return d}has(n){const s=this._getNode(n);return!(s?.value===void 0&&s?.mid===void 0)}delete(n){return this._delete(n,!1)}deleteSuperstr(n){return this._delete(n,!0)}_delete(n,s){const d=this._iter.reset(n),y=[];let A=this._root;for(;A;){const E=d.cmp(A.segment);if(E>0)y.push([-1,A]),A=A.left;else if(E<0)y.push([1,A]),A=A.right;else if(d.hasNext())d.next(),y.push([0,A]),A=A.mid;else break}if(!!A){if(s?(A.left=void 0,A.mid=void 0,A.right=void 0,A.height=1):(A.key=void 0,A.value=void 0),!A.mid&&!A.value)if(A.left&&A.right){const E=this._min(A.right),{key:R,value:O,segment:K}=E;this._delete(E.key,!1),A.key=R,A.value=O,A.segment=K}else{const E=A.left??A.right;if(y.length>0){const[R,O]=y[y.length-1];switch(R){case-1:O.left=E;break;case 0:O.mid=E;break;case 1:O.right=E;break}}else this._root=E}for(let E=y.length-1;E>=0;E--){const R=y[E][1];R.updateHeight();const O=R.balanceFactor();if(O>1?(R.right.balanceFactor()>=0||(R.right=y[E+1][1]=y[E+1][1].rotateRight()),y[E][1]=R.rotateLeft()):O<-1&&(R.left.balanceFactor()<=0||(R.left=y[E+1][1]=y[E+1][1].rotateLeft()),y[E][1]=R.rotateRight()),E>0)switch(y[E-1][0]){case-1:y[E-1][1].left=y[E][1];break;case 1:y[E-1][1].right=y[E][1];break;case 0:y[E-1][1].mid=y[E][1];break}else this._root=y[0][1]}}}_min(n){for(;n.left;)n=n.left;return n}findSubstr(n){const s=this._iter.reset(n);let d=this._root,y;for(;d;){const A=s.cmp(d.segment);if(A>0)d=d.left;else if(A<0)d=d.right;else if(s.hasNext())s.next(),y=d.value||y,d=d.mid;else break}return d&&d.value||y}findSuperstr(n){const s=this._iter.reset(n);let d=this._root;for(;d;){const y=s.cmp(d.segment);if(y>0)d=d.left;else if(y<0)d=d.right;else if(s.hasNext())s.next(),d=d.mid;else return d.mid?this._entries(d.mid):void 0}}forEach(n){for(const[s,d]of this)n(d,s)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(n){!n||(n.left&&(yield*this._entries(n.left)),n.value&&(yield[n.key,n.value]),n.mid&&(yield*this._entries(n.mid)),n.right&&(yield*this._entries(n.right)))}_isBalanced(){const n=s=>{if(!s)return!0;const d=s.balanceFactor();return d<-1||d>1?!1:n(s.left)&&n(s.right)};return n(this._root)}}e.TernarySearchTree=D;class w{constructor(n,s){this.uri=n,this.value=s}}class v{constructor(n,s){this[p]="ResourceMap",n instanceof v?(this.map=new Map(n.map),this.toKey=s??v.defaultToKey):(this.map=new Map,this.toKey=n??v.defaultToKey)}set(n,s){return this.map.set(this.toKey(n),new w(n,s)),this}get(n){return this.map.get(this.toKey(n))?.value}has(n){return this.map.has(this.toKey(n))}get size(){return this.map.size}clear(){this.map.clear()}delete(n){return this.map.delete(this.toKey(n))}forEach(n,s){typeof s!="undefined"&&(n=n.bind(s));for(let[d,y]of this.map)n(y.value,y.uri,this)}*values(){for(let n of this.map.values())yield n.value}*keys(){for(let n of this.map.values())yield n.uri}*entries(){for(let n of this.map.values())yield[n.uri,n.value]}*[(p=Symbol.toStringTag,Symbol.iterator)](){for(let[,n]of this.map)yield[n.uri,n.value]}}e.ResourceMap=v,v.defaultToKey=i=>i.toString();var a;(function(i){i[i.None=0]="None",i[i.AsOld=1]="AsOld",i[i.AsNew=2]="AsNew"})(a=e.Touch||(e.Touch={}));class l{constructor(){this[P]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(n){return this._map.has(n)}get(n,s=0){const d=this._map.get(n);if(!!d)return s!==0&&this.touch(d,s),d.value}set(n,s,d=0){let y=this._map.get(n);if(y)y.value=s,d!==0&&this.touch(y,d);else{switch(y={key:n,value:s,next:void 0,previous:void 0},d){case 0:this.addItemLast(y);break;case 1:this.addItemFirst(y);break;case 2:this.addItemLast(y);break;default:this.addItemLast(y);break}this._map.set(n,y),this._size++}return this}delete(n){return!!this.remove(n)}remove(n){const s=this._map.get(n);if(!!s)return this._map.delete(n),this.removeItem(s),this._size--,s.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const n=this._head;return this._map.delete(n.key),this.removeItem(n),this._size--,n.value}forEach(n,s){const d=this._state;let y=this._head;for(;y;){if(s?n.bind(s)(y.value,y.key,this):n(y.value,y.key,this),this._state!==d)throw new Error("LinkedMap got modified during iteration.");y=y.next}}keys(){const n=this,s=this._state;let d=this._head;const y={[Symbol.iterator](){return y},next(){if(n._state!==s)throw new Error("LinkedMap got modified during iteration.");if(d){const A={value:d.key,done:!1};return d=d.next,A}else return{value:void 0,done:!0}}};return y}values(){const n=this,s=this._state;let d=this._head;const y={[Symbol.iterator](){return y},next(){if(n._state!==s)throw new Error("LinkedMap got modified during iteration.");if(d){const A={value:d.value,done:!1};return d=d.next,A}else return{value:void 0,done:!0}}};return y}entries(){const n=this,s=this._state;let d=this._head;const y={[Symbol.iterator](){return y},next(){if(n._state!==s)throw new Error("LinkedMap got modified during iteration.");if(d){const A={value:[d.key,d.value],done:!1};return d=d.next,A}else return{value:void 0,done:!0}}};return y}[(P=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(n){if(n>=this.size)return;if(n===0){this.clear();return}let s=this._head,d=this.size;for(;s&&d>n;)this._map.delete(s.key),s=s.next,d--;this._head=s,this._size=d,s&&(s.previous=void 0),this._state++}addItemFirst(n){if(!this._head&&!this._tail)this._tail=n;else if(this._head)n.next=this._head,this._head.previous=n;else throw new Error("Invalid list");this._head=n,this._state++}addItemLast(n){if(!this._head&&!this._tail)this._head=n;else if(this._tail)n.previous=this._tail,this._tail.next=n;else throw new Error("Invalid list");this._tail=n,this._state++}removeItem(n){if(n===this._head&&n===this._tail)this._head=void 0,this._tail=void 0;else if(n===this._head){if(!n.next)throw new Error("Invalid list");n.next.previous=void 0,this._head=n.next}else if(n===this._tail){if(!n.previous)throw new Error("Invalid list");n.previous.next=void 0,this._tail=n.previous}else{const s=n.next,d=n.previous;if(!s||!d)throw new Error("Invalid list");s.previous=d,d.next=s}n.next=void 0,n.previous=void 0,this._state++}touch(n,s){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(s!==1&&s!==2)){if(s===1){if(n===this._head)return;const d=n.next,y=n.previous;n===this._tail?(y.next=void 0,this._tail=y):(d.previous=y,y.next=d),n.previous=void 0,n.next=this._head,this._head.previous=n,this._head=n,this._state++}else if(s===2){if(n===this._tail)return;const d=n.next,y=n.previous;n===this._head?(d.previous=void 0,this._head=d):(d.previous=y,y.next=d),n.next=void 0,n.previous=this._tail,this._tail.next=n,this._tail=n,this._state++}}}toJSON(){const n=[];return this.forEach((s,d)=>{n.push([d,s])}),n}fromJSON(n){this.clear();for(const[s,d]of n)this.set(s,d)}}e.LinkedMap=l;class r extends l{constructor(n,s=1){super();this._limit=n,this._ratio=Math.min(Math.max(0,s),1)}get limit(){return this._limit}set limit(n){this._limit=n,this.checkTrim()}get ratio(){return this._ratio}set ratio(n){this._ratio=Math.min(Math.max(0,n),1),this.checkTrim()}get(n,s=2){return super.get(n,s)}peek(n){return super.get(n,0)}set(n,s){return super.set(n,s,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=r;class o{constructor(n){t.set(this,void 0),Dt(this,t,n,"f")}get size(){return ut(this,t,"f").size}forEach(n,s){ut(this,t,"f").forEach(n,s)}get(n){return ut(this,t,"f").get(n)}has(n){return ut(this,t,"f").has(n)}entries(){return ut(this,t,"f").entries()}keys(){return ut(this,t,"f").keys()}values(){return ut(this,t,"f").values()}[(t=new WeakMap,Symbol.iterator)](){return ut(this,t,"f").entries()}}e.ReadonlyMapView=o}),define(ue[137],de([0,1,30,14]),function(Y,e,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function p(...ge){return function(me,Ie){for(let Re=0,Le=ge.length;Re<Le;Re++){const He=ge[Re](me,Ie);if(He)return He}return null}}e.or=p,e.matchesStrictPrefix=P.bind(void 0,!1),e.matchesPrefix=P.bind(void 0,!0);function P(ge,me,Ie){if(!Ie||Ie.length<me.length)return null;let Re;return ge?Re=k.startsWithIgnoreCase(Ie,me):Re=Ie.indexOf(me)===0,Re?me.length>0?[{start:0,end:me.length}]:[]:null}function t(ge,me){const Ie=me.toLowerCase().indexOf(ge.toLowerCase());return Ie===-1?null:[{start:Ie,end:Ie+ge.length}]}e.matchesContiguousSubString=t;function T(ge,me){return h(ge.toLowerCase(),me.toLowerCase(),0,0)}e.matchesSubString=T;function h(ge,me,Ie,Re){if(Ie===ge.length)return[];if(Re===me.length)return null;if(ge[Ie]===me[Re]){let Le=null;return(Le=h(ge,me,Ie+1,Re+1))?D({start:Re,end:Re+1},Le):null}return h(ge,me,Ie,Re+1)}function f(ge){return 97<=ge&&ge<=122}function C(ge){return 65<=ge&&ge<=90}e.isUpper=C;function I(ge){return 48<=ge&&ge<=57}function m(ge){return ge===32||ge===9||ge===10||ge===13}const u=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(ge=>u.add(ge.charCodeAt(0)));function c(ge){return m(ge)||u.has(ge)}function b(ge,me){return ge===me||c(ge)&&c(me)}function g(ge){return f(ge)||C(ge)||I(ge)}function D(ge,me){return me.length===0?me=[ge]:ge.end===me[0].start?me[0].start=ge.start:me.unshift(ge),me}function w(ge,me){for(let Ie=me;Ie<ge.length;Ie++){const Re=ge.charCodeAt(Ie);if(C(Re)||I(Re)||Ie>0&&!g(ge.charCodeAt(Ie-1)))return Ie}return ge.length}function v(ge,me,Ie,Re){if(Ie===ge.length)return[];if(Re===me.length)return null;if(ge[Ie]!==me[Re].toLowerCase())return null;{let Le=null,He=Re+1;for(Le=v(ge,me,Ie+1,Re+1);!Le&&(He=w(me,He))<me.length;)Le=v(ge,me,Ie+1,He),He++;return Le===null?null:D({start:Re,end:Re+1},Le)}}function a(ge){let me=0,Ie=0,Re=0,Le=0,He=0;for(let Se=0;Se<ge.length;Se++)He=ge.charCodeAt(Se),C(He)&&me++,f(He)&&Ie++,g(He)&&Re++,I(He)&&Le++;const Qe=me/ge.length,Je=Ie/ge.length,rt=Re/ge.length,ce=Le/ge.length;return{upperPercent:Qe,lowerPercent:Je,alphaPercent:rt,numericPercent:ce}}function l(ge){const{upperPercent:me,lowerPercent:Ie}=ge;return Ie===0&&me>.6}function r(ge){const{upperPercent:me,lowerPercent:Ie,alphaPercent:Re,numericPercent:Le}=ge;return Ie>.2&&me<.8&&Re>.6&&Le<.2}function o(ge){let me=0,Ie=0,Re=0,Le=0;for(let He=0;He<ge.length;He++)Re=ge.charCodeAt(He),C(Re)&&me++,f(Re)&&Ie++,m(Re)&&Le++;return(me===0||Ie===0)&&Le===0?ge.length<=30:me<=5}function i(ge,me){if(!me||(me=me.trim(),me.length===0)||!o(ge)||me.length>60)return null;const Ie=a(me);if(!r(Ie)){if(!l(Ie))return null;me=me.toLowerCase()}let Re=null,Le=0;for(ge=ge.toLowerCase();Le<me.length&&(Re=v(ge,me,0,Le))===null;)Le=w(me,Le+1);return Re}e.matchesCamelCase=i;function n(ge,me,Ie=!1){if(!me||me.length===0)return null;let Re=null,Le=0;for(ge=ge.toLowerCase(),me=me.toLowerCase();Le<me.length&&(Re=s(ge,me,0,Le,Ie))===null;)Le=d(me,Le+1);return Re}e.matchesWords=n;function s(ge,me,Ie,Re,Le){if(Ie===ge.length)return[];if(Re===me.length)return null;if(b(ge.charCodeAt(Ie),me.charCodeAt(Re))){let He=null,Qe=Re+1;if(He=s(ge,me,Ie+1,Re+1,Le),!Le)for(;!He&&(Qe=d(me,Qe))<me.length;)He=s(ge,me,Ie+1,Qe,Le),Qe++;return He===null?null:D({start:Re,end:Re+1},He)}else return null}function d(ge,me){for(let Ie=me;Ie<ge.length;Ie++)if(c(ge.charCodeAt(Ie))||Ie>0&&c(ge.charCodeAt(Ie-1)))return Ie;return ge.length}const y=p(e.matchesPrefix,i,t),A=p(e.matchesPrefix,i,T),E=new S.LRUCache(1e4);function R(ge,me,Ie=!1){if(typeof ge!="string"||typeof me!="string")return null;let Re=E.get(ge);Re||(Re=new RegExp(k.convertSimple2RegExpPattern(ge),"i"),E.set(ge,Re));const Le=Re.exec(me);return Le?[{start:Le.index,end:Le.index+Le[0].length}]:Ie?A(ge,me):y(ge,me)}e.matchesFuzzy=R;function O(ge,me){const Ie=ae(ge,ge.toLowerCase(),0,me,me.toLowerCase(),0,!0);return Ie?te(Ie):null}e.matchesFuzzy2=O;function K(ge,me,Ie,Re,Le,He){const Qe=Math.min(13,ge.length);for(;Ie<Qe;Ie++){const Je=ae(ge,me,Ie,Re,Le,He,!1);if(Je)return Je}return[0,He]}e.anyScore=K;function te(ge){if(typeof ge=="undefined")return[];const me=[],Ie=ge[1];for(let Re=ge.length-1;Re>1;Re--){const Le=ge[Re]+Ie,He=me[me.length-1];He&&He.end===Le?He.end=Le+1:me.push({start:Le,end:Le+1})}return me}e.createMatches=te;const j=128;function _(){const ge=[],me=[];for(let Ie=0;Ie<=j;Ie++)me[Ie]=0;for(let Ie=0;Ie<=j;Ie++)ge.push(me.slice(0));return ge}function U(ge){const me=[];for(let Ie=0;Ie<=ge;Ie++)me[Ie]=0;return me}const F=U(2*j),M=U(2*j),V=_(),ee=_(),G=_(),H=!1;function q(ge,me,Ie,Re,Le){function He(Je,rt,ce=" "){for(;Je.length<rt;)Je=ce+Je;return Je}let Qe=` |   |${Re.split("").map(Je=>He(Je,3)).join("|")}
`;for(let Je=0;Je<=Ie;Je++)Je===0?Qe+=" |":Qe+=`${me[Je-1]}|`,Qe+=ge[Je].slice(0,Le+1).map(rt=>He(rt.toString(),3)).join("|")+`
`;return Qe}function z(ge,me,Ie,Re){ge=ge.substr(me),Ie=Ie.substr(Re),console.log(q(ee,ge,ge.length,Ie,Ie.length)),console.log(q(G,ge,ge.length,Ie,Ie.length)),console.log(q(V,ge,ge.length,Ie,Ie.length))}function B(ge,me){if(me<0||me>=ge.length)return!1;const Ie=ge.codePointAt(me);switch(Ie){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!k.isEmojiImprecise(Ie)}}function W(ge,me){if(me<0||me>=ge.length)return!1;switch(ge.charCodeAt(me)){case 32:case 9:return!0;default:return!1}}function ie(ge,me,Ie){return me[ge]!==Ie[ge]}function oe(ge,me,Ie,Re,Le,He,Qe=!1){for(;me<Ie&&Le<He;)ge[me]===Re[Le]&&(Qe&&(F[me]=Le),me+=1),Le+=1;return me===Ie}e.isPatternInWord=oe;var we;(function(ge){ge[ge.Diag=1]="Diag",ge[ge.Left=2]="Left",ge[ge.LeftLeft=3]="LeftLeft"})(we||(we={}));var se;(function(ge){ge.Default=[-100,0];function me(Ie){return!Ie||Ie.length===2&&Ie[0]===-100&&Ie[1]===0}ge.isDefault=me})(se=e.FuzzyScore||(e.FuzzyScore={}));function ae(ge,me,Ie,Re,Le,He,Qe){const Je=ge.length>j?j:ge.length,rt=Re.length>j?j:Re.length;if(Ie>=Je||He>=rt||Je-Ie>rt-He||!oe(me,Ie,Je,Le,He,rt,!0))return;ke(Je,rt,Ie,He,me,Le);let ce=1,Se=1,Pe=Ie,$e=He;const Ye=[!1];for(ce=1,Pe=Ie;Pe<Je;ce++,Pe++){const et=F[Pe],ne=M[Pe],be=Pe+1<Je?M[Pe+1]:rt;for(Se=et-He+1,$e=et;$e<be;Se++,$e++){let Fe=Number.MIN_SAFE_INTEGER,Ae=!1;$e<=ne&&(Fe=De(ge,me,Pe,Ie,Re,Le,$e,rt,He,V[ce-1][Se-1]===0,Ye));let Ve=0;Fe!==Number.MAX_SAFE_INTEGER&&(Ae=!0,Ve=Fe+ee[ce-1][Se-1]);const ve=$e>et,fe=ve?ee[ce][Se-1]+(V[ce][Se-1]>0?-5:0):0,pe=$e>et+1&&V[ce][Se-1]>0,J=pe?ee[ce][Se-2]+(V[ce][Se-2]>0?-5:0):0;if(pe&&(!ve||J>=fe)&&(!Ae||J>=Ve))ee[ce][Se]=J,G[ce][Se]=3,V[ce][Se]=0;else if(ve&&(!Ae||fe>=Ve))ee[ce][Se]=fe,G[ce][Se]=2,V[ce][Se]=0;else if(Ae)ee[ce][Se]=Ve,G[ce][Se]=1,V[ce][Se]=V[ce-1][Se-1]+1;else throw new Error("not possible")}}if(H&&z(ge,Ie,Re,He),!Ye[0]&&!Qe)return;ce--,Se--;const lt=[ee[ce][Se],He];let tt=0,at=0;for(;ce>=1;){let et=Se;do{const ne=G[ce][et];if(ne===3)et=et-2;else if(ne===2)et=et-1;else break}while(et>=1);tt>1&&me[Ie+ce-1]===Le[He+Se-1]&&!ie(et+He-1,Re,Le)&&tt+1>V[ce][et]&&(et=Se),et===Se?tt++:tt=1,at||(at=et),ce--,Se=et-1,lt.push(Se)}rt===Je&&(lt[0]+=2);const ot=at-Je;return lt[0]-=ot,lt}e.fuzzyScore=ae;function ke(ge,me,Ie,Re,Le,He){let Qe=ge-1,Je=me-1;for(;Qe>=Ie&&Je>=Re;)Le[Qe]===He[Je]&&(M[Qe]=Je,Qe--),Je--}function De(ge,me,Ie,Re,Le,He,Qe,Je,rt,ce,Se){if(me[Ie]!==He[Qe])return Number.MIN_SAFE_INTEGER;let Pe=1,$e=!1;return Qe===Ie-Re?Pe=ge[Ie]===Le[Qe]?7:5:ie(Qe,Le,He)&&(Qe===0||!ie(Qe-1,Le,He))?(Pe=ge[Ie]===Le[Qe]?7:5,$e=!0):B(He,Qe)&&(Qe===0||!B(He,Qe-1))?Pe=5:(B(He,Qe-1)||W(He,Qe-1))&&(Pe=5,$e=!0),Pe>1&&Ie===Re&&(Se[0]=!0),$e||($e=ie(Qe,Le,He)||B(He,Qe-1)||W(He,Qe-1)),Ie===Re?Qe>rt&&(Pe-=$e?3:5):ce?Pe+=$e?2:0:Pe+=$e?0:1,Qe+1===Je&&(Pe-=$e?3:5),Pe}function Oe(ge,me,Ie,Re,Le,He,Qe){return Xe(ge,me,Ie,Re,Le,He,!0,Qe)}e.fuzzyScoreGracefulAggressive=Oe;function Be(ge,me,Ie,Re,Le,He,Qe){return Xe(ge,me,Ie,Re,Le,He,!1,Qe)}e.fuzzyScoreGraceful=Be;function Xe(ge,me,Ie,Re,Le,He,Qe,Je){let rt=ae(ge,me,Ie,Re,Le,He,Je);if(rt&&!Qe)return rt;if(ge.length>=3){const ce=Math.min(7,ge.length-1);for(let Se=Ie+1;Se<ce;Se++){const Pe=Ze(ge,Se);if(Pe){const $e=ae(Pe,Pe.toLowerCase(),Ie,Re,Le,He,Je);$e&&($e[0]-=3,(!rt||$e[0]>rt[0])&&(rt=$e))}}}return rt}function Ze(ge,me){if(me+1>=ge.length)return;const Ie=ge[me],Re=ge[me+1];if(Ie!==Re)return ge.slice(0,me)+Re+Ie+ge.slice(me+2)}}),define(ue[138],de([0,1,40,137,14]),function(Y,e,S,k,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const P=new RegExp(`\\$\\(${S.CSSIcon.iconNameExpression}(?:${S.CSSIcon.iconModifierExpression})?\\)`,"g"),t=new RegExp(S.CSSIcon.iconNameCharacter),T=new RegExp(`(\\\\)?${P.source}`,"g");function h(g){return g.replace(T,(D,w)=>w?D:`\\${D}`)}e.escapeIcons=h;const f=new RegExp(`\\\\${P.source}`,"g");function C(g){return g.replace(f,D=>`\\${D}`)}e.markdownEscapeEscapedIcons=C;const I=new RegExp(`(\\s)?(\\\\)?${P.source}(\\s)?`,"g");function m(g){return g.indexOf(e.iconStartMarker)===-1?g:g.replace(I,(D,w,v,a)=>v?D:w||a||"")}e.stripIcons=m;function u(g){const D=g.indexOf(e.iconStartMarker);return D===-1?{text:g}:c(g,D)}e.parseLabelWithIcons=u;function c(g,D){const w=[];let v="";function a(y){if(y){v+=y;for(const A of y)w.push(o)}}let l=-1,r="",o=0,i,n,s=D;const d=g.length;for(a(g.substr(0,D));s<d;)i=g[s],n=g[s+1],i===e.iconStartMarker[0]&&n===e.iconStartMarker[1]?(l=s,a(r),r=e.iconStartMarker,s++):i===")"&&l!==-1?(o+=s-l+1,l=-1,r=""):l!==-1?t.test(i)?r+=i:(a(r),l=-1,r=""):a(i),s++;return a(r),{text:v,iconOffsets:w}}function b(g,D,w=!1){const{text:v,iconOffsets:a}=D;if(!a||a.length===0)return(0,k.matchesFuzzy)(g,v,w);const l=(0,p.ltrim)(v," "),r=v.length-l.length,o=(0,k.matchesFuzzy)(g,l,w);if(o)for(const i of o){const n=a[i.start+r]+r;i.start+=n,i.end+=n}return o}e.matchesFuzzyIconAware=b}),define(ue[87],de([0,1,12,138]),function(Y,e,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var p;(function(m){m[m.Paragraph=0]="Paragraph",m[m.Break=1]="Break"})(p=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class P{constructor(u="",c=!1){if(this.value=u,typeof this.value!="string")throw(0,S.illegalArgument)("value");typeof c=="boolean"?(this.isTrusted=c,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=c.isTrusted??void 0,this.supportThemeIcons=c.supportThemeIcons??!1,this.supportHtml=c.supportHtml??!1)}appendText(u,c=0){return this.value+=f(this.supportThemeIcons?(0,k.escapeIcons)(u):u).replace(/([ \t]+)/g,(b,g)=>"&nbsp;".repeat(g.length)).replace(/\>/gm,"\\>").replace(/\n/g,c===1?`\\
`:`

`),this}appendMarkdown(u){return this.value+=u,this}appendCodeblock(u,c){return this.value+="\n```",this.value+=u,this.value+=`
`,this.value+=c,this.value+="\n```\n",this}}e.MarkdownString=P;function t(m){return T(m)?!m.value:Array.isArray(m)?m.every(t):!0}e.isEmptyMarkdownString=t;function T(m){return m instanceof P?!0:m&&typeof m=="object"?typeof m.value=="string"&&(typeof m.isTrusted=="boolean"||m.isTrusted===void 0)&&(typeof m.supportThemeIcons=="boolean"||m.supportThemeIcons===void 0):!1}e.isMarkdownString=T;function h(m,u){return m===u?!0:!m||!u?!1:m.value===u.value&&m.isTrusted===u.isTrusted&&m.supportThemeIcons===u.supportThemeIcons}e.markdownStringEqual=h;function f(m){return m.replace(/[\\`*_{}[\]()#+\-!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=f;function C(m){return m&&m.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=C;function I(m){const u=[],c=m.split("|").map(g=>g.trim());m=c[0];const b=c[1];if(b){const g=/height=(\d+)/.exec(b),D=/width=(\d+)/.exec(b),w=g?g[1]:"",v=D?D[1]:"",a=isFinite(parseInt(v)),l=isFinite(parseInt(w));a&&u.push(`width="${v}"`),l&&u.push(`height="${w}"`)}return{href:m,dimensions:u}}e.parseHrefAndDimensions=I}),define(ue[88],de([0,1,30]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const k=new S.LRUCache(1e4);function p(f){return h(f,"NFC",k)}e.normalizeNFC=p;const P=new S.LRUCache(1e4);function t(f){return h(f,"NFD",P)}e.normalizeNFD=t;const T=/[^\u0000-\u0080]/;function h(f,C,I){if(!f)return f;const m=I.get(f);if(m)return m;let u;return T.test(f)?u=f.normalize(C):u=f,I.set(f,u),u}e.removeAccents=function(){const f=/[\u0300-\u036f]/g;return function(C){return t(C).replace(f,"")}}()}),define(ue[62],de([0,1,14]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var k;(function(p){p[p.Ignore=0]="Ignore",p[p.Info=1]="Info",p[p.Warning=2]="Warning",p[p.Error=3]="Error"})(k||(k={})),function(p){const P="error",t="warning",T="warn",h="info",f="ignore";function C(m){return m?S.equalsIgnoreCase(P,m)?p.Error:S.equalsIgnoreCase(t,m)||S.equalsIgnoreCase(T,m)?p.Warning:S.equalsIgnoreCase(h,m)?p.Info:p.Ignore:p.Ignore}p.fromValue=C;function I(m){switch(m){case p.Error:return P;case p.Warning:return t;case p.Info:return h;default:return f}}p.toString=I}(k||(k={})),e.default=k}),define(ue[11],de([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPromise=e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function S(A){return Array.isArray(A)}e.isArray=S;function k(A){return typeof A=="string"}e.isString=k;function p(A){return Array.isArray(A)&&A.every(E=>k(E))}e.isStringArray=p;function P(A){return typeof A=="object"&&A!==null&&!Array.isArray(A)&&!(A instanceof RegExp)&&!(A instanceof Date)}e.isObject=P;function t(A){return typeof A=="number"&&!isNaN(A)}e.isNumber=t;function T(A){return!!A&&typeof A[Symbol.iterator]=="function"}e.isIterable=T;function h(A){return A===!0||A===!1}e.isBoolean=h;function f(A){return typeof A=="undefined"}e.isUndefined=f;function C(A){return!I(A)}e.isDefined=C;function I(A){return f(A)||A===null}e.isUndefinedOrNull=I;function m(A,E){if(!A)throw new Error(E?`Unexpected type, expected '${E}'`:"Unexpected type")}e.assertType=m;function u(A){if(I(A))throw new Error("Assertion Failed: argument is undefined or null");return A}e.assertIsDefined=u;function c(...A){const E=[];for(let R=0;R<A.length;R++){const O=A[R];if(I(O))throw new Error(`Assertion Failed: argument at index ${R} is undefined or null`);E.push(O)}return E}e.assertAllDefined=c;const b=Object.prototype.hasOwnProperty;function g(A){if(!P(A))return!1;for(let E in A)if(b.call(A,E))return!1;return!0}e.isEmptyObject=g;function D(A){return typeof A=="function"}e.isFunction=D;function w(...A){return A.length>0&&A.every(D)}e.areFunctions=w;function v(A,E){const R=Math.min(A.length,E.length);for(let O=0;O<R;O++)a(A[O],E[O])}e.validateConstraints=v;function a(A,E){if(k(E)){if(typeof A!==E)throw new Error(`argument does not match constraint: typeof ${E}`)}else if(D(E)){try{if(A instanceof E)return}catch{}if(!I(A)&&A.constructor===E||E.length===1&&E.call(void 0,A)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=a;function l(A){let E=[],R=Object.getPrototypeOf(A);for(;Object.prototype!==R;)E=E.concat(Object.getOwnPropertyNames(R)),R=Object.getPrototypeOf(R);return E}e.getAllPropertyNames=l;function r(A){const E=[];for(const R of l(A))typeof A[R]=="function"&&E.push(R);return E}e.getAllMethodNames=r;function o(A,E){const R=K=>function(){const te=Array.prototype.slice.call(arguments,0);return E(K,te)};let O={};for(const K of A)O[K]=R(K);return O}e.createProxyObject=o;function i(A){return A===null?void 0:A}e.withNullAsUndefined=i;function n(A){return typeof A=="undefined"?null:A}e.withUndefinedAsNull=n;function s(A){return class{constructor(){return new Proxy({},{get(E,R){if(E[R])return E[R];throw new Error(`Not Implemented: ${A}->${String(R)}`)}})}}}e.NotImplementedProxy=s;function d(A,E="Unreachable"){throw new Error(E)}e.assertNever=d;function y(A){return!!A&&typeof A.then=="function"&&typeof A.catch=="function"}e.isPromise=y}),define(ue[31],de([0,1,4,2,14,11]),function(Y,e,S,k,p,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function t(i){return i===47||i===92}e.isPathSeparator=t;function T(i){return i.replace(/[\\/]/g,S.posix.sep)}e.toSlashes=T;function h(i){return i.indexOf("/")===-1&&(i=T(i)),/^[a-zA-Z]:(\/|$)/.test(i)&&(i="/"+i),i}e.toPosixPath=h;function f(i,n=S.posix.sep){if(!i)return"";const s=i.length,d=i.charCodeAt(0);if(t(d)){if(t(i.charCodeAt(1))&&!t(i.charCodeAt(2))){let A=3;const E=A;for(;A<s&&!t(i.charCodeAt(A));A++);if(E!==A&&!t(i.charCodeAt(A+1))){for(A+=1;A<s;A++)if(t(i.charCodeAt(A)))return i.slice(0,A+1).replace(/[\\/]/g,n)}}return n}else if(D(d)&&i.charCodeAt(1)===58)return t(i.charCodeAt(2))?i.slice(0,2)+n:i.slice(0,2);let y=i.indexOf("://");if(y!==-1){for(y+=3;y<s;y++)if(t(i.charCodeAt(y)))return i.slice(0,y+1)}return""}e.getRoot=f;function C(i){if(!k.isWindows||!i||i.length<5)return!1;let n=i.charCodeAt(0);if(n!==92||(n=i.charCodeAt(1),n!==92))return!1;let s=2;const d=s;for(;s<i.length&&(n=i.charCodeAt(s),n!==92);s++);return!(d===s||(n=i.charCodeAt(s+1),isNaN(n)||n===92))}e.isUNC=C;const I=/[\\/:\*\?"<>\|]/g,m=/[\\/]/g,u=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function c(i,n=k.isWindows){const s=n?I:m;return!(!i||i.length===0||/^\s+$/.test(i)||(s.lastIndex=0,s.test(i))||n&&u.test(i)||i==="."||i===".."||n&&i[i.length-1]==="."||n&&i.length!==i.trim().length||i.length>255)}e.isValidBasename=c;function b(i,n,s){const d=i===n;return!s||d?d:!i||!n?!1:(0,p.equalsIgnoreCase)(i,n)}e.isEqual=b;function g(i,n,s,d=S.sep){if(i===n)return!0;if(!i||!n||n.length>i.length)return!1;if(s){if(!(0,p.startsWithIgnoreCase)(i,n))return!1;if(n.length===i.length)return!0;let A=n.length;return n.charAt(n.length-1)===d&&A--,i.charAt(A)===d}return n.charAt(n.length-1)!==d&&(n+=d),i.indexOf(n)===0}e.isEqualOrParent=g;function D(i){return i>=65&&i<=90||i>=97&&i<=122}e.isWindowsDriveLetter=D;function w(i,n){return k.isWindows&&i.endsWith(":")&&(i+=S.sep),(0,S.isAbsolute)(i)||(i=(0,S.join)(n,i)),i=(0,S.normalize)(i),k.isWindows?(i=(0,p.rtrim)(i,S.sep),i.endsWith(":")&&(i+=S.sep)):(i=(0,p.rtrim)(i,S.sep),i||(i=S.sep)),i}e.sanitizeFilePath=w;function v(i){const n=(0,S.normalize)(i);return k.isWindows?i.length>3?!1:a(n)&&(i.length===2||n.charCodeAt(2)===92):n===S.posix.sep}e.isRootOrDriveLetter=v;function a(i,n){return(n!==void 0?n:k.isWindows)?D(i.charCodeAt(0))&&i.charCodeAt(1)===58:!1}e.hasDriveLetter=a;function l(i){return a(i)?i[0]:void 0}e.getDriveLetter=l;function r(i,n,s){return n.length>i.length?-1:i===n?0:(s&&(i=i.toLowerCase(),n=n.toLowerCase()),i.indexOf(n))}e.indexOfPath=r;function o(i){const n=i.split(":");let s,d,y;if(n.forEach(A=>{const E=Number(A);(0,P.isNumber)(E)?d===void 0?d=E:y===void 0&&(y=E):s=s?[s,A].join(":"):A}),!s)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:s,line:d!==void 0?d:void 0,column:y!==void 0?y:d!==void 0?1:void 0}}e.parseLineAndColumnAware=o}),define(ue[21],de([0,1,11]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function k(b){if(!b||typeof b!="object"||b instanceof RegExp)return b;const g=Array.isArray(b)?[]:{};return Object.keys(b).forEach(D=>{b[D]&&typeof b[D]=="object"?g[D]=k(b[D]):g[D]=b[D]}),g}e.deepClone=k;function p(b){if(!b||typeof b!="object")return b;const g=[b];for(;g.length>0;){const D=g.shift();Object.freeze(D);for(const w in D)if(P.call(D,w)){const v=D[w];typeof v=="object"&&!Object.isFrozen(v)&&g.push(v)}}return b}e.deepFreeze=p;const P=Object.prototype.hasOwnProperty;function t(b,g){return T(b,g,new Set)}e.cloneAndChange=t;function T(b,g,D){if((0,S.isUndefinedOrNull)(b))return b;const w=g(b);if(typeof w!="undefined")return w;if((0,S.isArray)(b)){const v=[];for(const a of b)v.push(T(a,g,D));return v}if((0,S.isObject)(b)){if(D.has(b))throw new Error("Cannot clone recursive data-structure");D.add(b);const v={};for(let a in b)P.call(b,a)&&(v[a]=T(b[a],g,D));return D.delete(b),v}return b}function h(b,g,D=!0){return(0,S.isObject)(b)?((0,S.isObject)(g)&&Object.keys(g).forEach(w=>{w in b?D&&((0,S.isObject)(b[w])&&(0,S.isObject)(g[w])?h(b[w],g[w],D):b[w]=g[w]):b[w]=g[w]}),b):g}e.mixin=h;function f(b,g){if(b===g)return!0;if(b==null||g===null||g===void 0||typeof b!=typeof g||typeof b!="object"||Array.isArray(b)!==Array.isArray(g))return!1;let D,w;if(Array.isArray(b)){if(b.length!==g.length)return!1;for(D=0;D<b.length;D++)if(!f(b[D],g[D]))return!1}else{const v=[];for(w in b)v.push(w);v.sort();const a=[];for(w in g)a.push(w);if(a.sort(),!f(v,a))return!1;for(D=0;D<v.length;D++)if(!f(b[v[D]],g[v[D]]))return!1}return!0}e.equals=f;function C(b){const g=new Set;return JSON.stringify(b,(D,w)=>{if((0,S.isObject)(w)||Array.isArray(w)){if(g.has(w))return"[Circular]";g.add(w)}return w})}e.safeStringify=C;function I(b,g,D){const w=g(b);return typeof w=="undefined"?D:w}e.getOrDefault=I;function m(b,g){const D=Object.create(null);return!b||!g||Object.keys(g).forEach(v=>{const a=b[v],l=g[v];f(a,l)||(D[v]=l)}),D}e.distinct=m;function u(b,g){const D=g.toLowerCase(),w=Object.keys(b).find(v=>v.toLowerCase()===D);return w?b[w]:b[g]}e.getCaseInsensitive=u;function c(b,g){const D=Object.create(null);for(const[w,v]of Object.entries(b))g(w,v)&&(D[w]=v);return D}e.filter=c}),define(ue[5],de([0,1,4,2]),function(Y,e,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodePath=e.uriToFsPath=e.URI=void 0;const p=/^\w[\w\d+.-]*$/,P=/^\//,t=/^\/\//;function T(n,s){if(!n.scheme&&s)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${n.authority}", path: "${n.path}", query: "${n.query}", fragment: "${n.fragment}"}`);if(n.scheme&&!p.test(n.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(n.path){if(n.authority){if(!P.test(n.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(t.test(n.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function h(n,s){return!n&&!s?"file":n}function f(n,s){switch(n){case"https":case"http":case"file":s?s[0]!==I&&(s=I+s):s=I;break}return s}const C="",I="/",m=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class u{constructor(s,d,y,A,E,R=!1){typeof s=="object"?(this.scheme=s.scheme||C,this.authority=s.authority||C,this.path=s.path||C,this.query=s.query||C,this.fragment=s.fragment||C):(this.scheme=h(s,R),this.authority=d||C,this.path=f(this.scheme,y||C),this.query=A||C,this.fragment=E||C,T(this,R))}static isUri(s){return s instanceof u?!0:s?typeof s.authority=="string"&&typeof s.fragment=="string"&&typeof s.path=="string"&&typeof s.query=="string"&&typeof s.scheme=="string"&&typeof s.fsPath=="string"&&typeof s.with=="function"&&typeof s.toString=="function":!1}get fsPath(){return v(this,!1)}with(s){if(!s)return this;let{scheme:d,authority:y,path:A,query:E,fragment:R}=s;return d===void 0?d=this.scheme:d===null&&(d=C),y===void 0?y=this.authority:y===null&&(y=C),A===void 0?A=this.path:A===null&&(A=C),E===void 0?E=this.query:E===null&&(E=C),R===void 0?R=this.fragment:R===null&&(R=C),d===this.scheme&&y===this.authority&&A===this.path&&E===this.query&&R===this.fragment?this:new b(d,y,A,E,R)}static parse(s,d=!1){const y=m.exec(s);return y?new b(y[2]||C,o(y[4]||C),o(y[5]||C),o(y[7]||C),o(y[9]||C),d):new b(C,C,C,C,C)}static file(s){let d=C;if(k.isWindows&&(s=s.replace(/\\/g,I)),s[0]===I&&s[1]===I){const y=s.indexOf(I,2);y===-1?(d=s.substring(2),s=I):(d=s.substring(2,y),s=s.substring(y)||I)}return new b("file",d,s,C,C)}static from(s){const d=new b(s.scheme,s.authority,s.path,s.query,s.fragment);return T(d,!0),d}static joinPath(s,...d){if(!s.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let y;return k.isWindows&&s.scheme==="file"?y=u.file(S.win32.join(v(s,!0),...d)).path:y=S.posix.join(s.path,...d),s.with({path:y})}toString(s=!1){return a(this,s)}toJSON(){return this}static revive(s){if(s){if(s instanceof u)return s;{const d=new b(s);return d._formatted=s.external,d._fsPath=s._sep===c?s.fsPath:null,d}}else return s}}e.URI=u;const c=k.isWindows?1:void 0;class b extends u{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=v(this,!1)),this._fsPath}toString(s=!1){return s?a(this,!0):(this._formatted||(this._formatted=a(this,!1)),this._formatted)}toJSON(){const s={$mid:1};return this._fsPath&&(s.fsPath=this._fsPath,s._sep=c),this._formatted&&(s.external=this._formatted),this.path&&(s.path=this.path),this.scheme&&(s.scheme=this.scheme),this.authority&&(s.authority=this.authority),this.query&&(s.query=this.query),this.fragment&&(s.fragment=this.fragment),s}}const g={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function D(n,s){let d,y=-1;for(let A=0;A<n.length;A++){const E=n.charCodeAt(A);if(E>=97&&E<=122||E>=65&&E<=90||E>=48&&E<=57||E===45||E===46||E===95||E===126||s&&E===47)y!==-1&&(d+=encodeURIComponent(n.substring(y,A)),y=-1),d!==void 0&&(d+=n.charAt(A));else{d===void 0&&(d=n.substr(0,A));const R=g[E];R!==void 0?(y!==-1&&(d+=encodeURIComponent(n.substring(y,A)),y=-1),d+=R):y===-1&&(y=A)}}return y!==-1&&(d+=encodeURIComponent(n.substring(y))),d!==void 0?d:n}function w(n){let s;for(let d=0;d<n.length;d++){const y=n.charCodeAt(d);y===35||y===63?(s===void 0&&(s=n.substr(0,d)),s+=g[y]):s!==void 0&&(s+=n[d])}return s!==void 0?s:n}function v(n,s){let d;return n.authority&&n.path.length>1&&n.scheme==="file"?d=`//${n.authority}${n.path}`:n.path.charCodeAt(0)===47&&(n.path.charCodeAt(1)>=65&&n.path.charCodeAt(1)<=90||n.path.charCodeAt(1)>=97&&n.path.charCodeAt(1)<=122)&&n.path.charCodeAt(2)===58?s?d=n.path.substr(1):d=n.path[1].toLowerCase()+n.path.substr(2):d=n.path,k.isWindows&&(d=d.replace(/\//g,"\\")),d}e.uriToFsPath=v;function a(n,s){const d=s?w:D;let y="",{scheme:A,authority:E,path:R,query:O,fragment:K}=n;if(A&&(y+=A,y+=":"),(E||A==="file")&&(y+=I,y+=I),E){let te=E.indexOf("@");if(te!==-1){const j=E.substr(0,te);E=E.substr(te+1),te=j.indexOf(":"),te===-1?y+=d(j,!1):(y+=d(j.substr(0,te),!1),y+=":",y+=d(j.substr(te+1),!1)),y+="@"}E=E.toLowerCase(),te=E.indexOf(":"),te===-1?y+=d(E,!1):(y+=d(E.substr(0,te),!1),y+=E.substr(te))}if(R){if(R.length>=3&&R.charCodeAt(0)===47&&R.charCodeAt(2)===58){const te=R.charCodeAt(1);te>=65&&te<=90&&(R=`/${String.fromCharCode(te+32)}:${R.substr(3)}`)}else if(R.length>=2&&R.charCodeAt(1)===58){const te=R.charCodeAt(0);te>=65&&te<=90&&(R=`${String.fromCharCode(te+32)}:${R.substr(2)}`)}y+=d(R,!0)}return O&&(y+="?",y+=d(O,!1)),K&&(y+="#",y+=s?K:D(K,!1)),y}function l(n){try{return decodeURIComponent(n)}catch{return n.length>3?n.substr(0,3)+l(n.substr(3)):n}}const r=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function o(n){return n.match(r)?n.replace(r,s=>l(s)):n}const i=n=>n.split("/").map(s=>encodeURIComponent(s)).join("/");e.encodePath=i}),define(ue[89],de([0,1,5]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function k(f){const C=f;return C&&typeof C.type=="string"&&typeof C.severity=="string"}e.isRemoteConsoleLog=k;function p(f){const C=[];let I;try{const m=JSON.parse(f.arguments),u=m[m.length-1];u&&u.__$stack&&(m.pop(),I=u.__$stack),C.push(...m)}catch(m){C.push("Unable to log remote console arguments",f.arguments)}return{args:C,stack:I}}e.parse=p;function P(f){if(typeof f!="string")return P(p(f).stack);const C=f;if(C){const I=t(C),m=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(I||"");if(m&&m.length===4)return{uri:S.URI.file(m[1]),line:Number(m[2]),column:Number(m[3])}}}e.getFirstFrame=P;function t(f){if(!f)return f;const C=f.indexOf(`
`);return C===-1?f:f.substring(0,C)}function T(f,C){const{args:I,stack:m}=p(f),u=typeof I[0]=="string"&&I.length===1;let c=t(m);c&&(c=`(${c.trim()})`);let b=[];if(typeof I[0]=="string"?c&&u?b=[`%c[${C}] %c${I[0]} %c${c}`,h("blue"),h(""),h("grey")]:b=[`%c[${C}] %c${I[0]}`,h("blue"),h(""),...I.slice(1)]:b=[`%c[${C}]%`,h("blue"),...I],c&&!u&&b.push(c),typeof console[f.severity]!="function")throw new Error("Unknown console method");console[f.severity].apply(console,b)}e.log=T;function h(f){return`color: ${f}`}}),define(ue[54],de([0,1,18,14,5]),function(Y,e,S,k,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function P(C){return JSON.stringify(C,h)}e.stringify=P;function t(C){let I=JSON.parse(C);return I=f(I),I}e.parse=t;var T;(function(C){C[C.Uri=1]="Uri",C[C.Regexp=2]="Regexp",C[C.ScmResource=3]="ScmResource",C[C.ScmResourceGroup=4]="ScmResourceGroup",C[C.ScmProvider=5]="ScmProvider",C[C.CommentController=6]="CommentController",C[C.CommentThread=7]="CommentThread",C[C.CommentThreadReply=8]="CommentThreadReply",C[C.CommentNode=9]="CommentNode",C[C.CommentThreadNode=10]="CommentThreadNode",C[C.TimelineActionContext=11]="TimelineActionContext",C[C.NotebookCellActionContext=12]="NotebookCellActionContext",C[C.TestItemContext=13]="TestItemContext"})(T=e.MarshalledId||(e.MarshalledId={}));function h(C,I){return I instanceof RegExp?{$mid:2,source:I.source,flags:(0,k.regExpFlags)(I)}:I}function f(C,I=0){if(!C||I>200)return C;if(typeof C=="object"){switch(C.$mid){case 1:return p.URI.revive(C);case 2:return new RegExp(C.source,C.flags)}if(C instanceof S.VSBuffer||C instanceof Uint8Array)return C;if(Array.isArray(C))for(let m=0;m<C.length;++m)C[m]=f(C[m],I+1);else for(const m in C)Object.hasOwnProperty.call(C,m)&&(C[m]=f(C[m],I+1))}return C}e.revive=f});var Ne=this&&this.__decorate||function(Y,e,S,k){var p=arguments.length,P=p<3?e:k===null?k=Object.getOwnPropertyDescriptor(e,S):k,t;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")P=Reflect.decorate(Y,e,S,k);else for(var T=Y.length-1;T>=0;T--)(t=Y[T])&&(P=(p<3?t(P):p>3?t(e,S,P):t(e,S))||P);return p>3&&P&&Object.defineProperty(e,S,P),P};define(ue[10],de([0,1,52,2,5]),function(Y,e,S,k,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var P;(function(h){h.inMemory="inmemory",h.vscode="vscode",h.internal="private",h.walkThrough="walkThrough",h.walkThroughSnippet="walkThroughSnippet",h.http="http",h.https="https",h.file="file",h.mailto="mailto",h.untitled="untitled",h.data="data",h.command="command",h.vscodeRemote="vscode-remote",h.vscodeRemoteResource="vscode-remote-resource",h.userData="vscode-userdata",h.vscodeCustomEditor="vscode-custom-editor",h.vscodeNotebook="vscode-notebook",h.vscodeNotebookCell="vscode-notebook-cell",h.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",h.vscodeNotebookCellOutput="vscode-notebook-cell-output",h.vscodeInteractive="vscode-interactive",h.vscodeInteractiveInput="vscode-interactive-input",h.vscodeSettings="vscode-settings",h.vscodeWorkspaceTrust="vscode-workspace-trust",h.vscodeTerminal="vscode-terminal",h.webviewPanel="webview-panel",h.vscodeWebview="vscode-webview",h.extension="extension",h.vscodeFileResource="vscode-file",h.tmp="tmp",h.vsls="vsls"})(P=e.Schemas||(e.Schemas={}));class t{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(f){this._preferredWebSchema=f}setDelegate(f){this._delegate=f}set(f,C,I){this._hosts[f]=C,this._ports[f]=I}setConnectionToken(f,C){this._connectionTokens[f]=C}get remoteResourcePath(){if(k.isWeb){const f=p.URI.parse(window.location.toString());return p.URI.joinPath(f,P.vscodeRemoteResource).path}return`/${P.vscodeRemoteResource}`}rewrite(f){if(this._delegate)return this._delegate(f);const C=f.authority;let I=this._hosts[C];I&&I.indexOf(":")!==-1&&(I=`[${I}]`);const m=this._ports[C],u=this._connectionTokens[C];let c=`path=${encodeURIComponent(f.path)}`;return typeof u=="string"&&(c+=`&tkn=${encodeURIComponent(u)}`),p.URI.from({scheme:k.isWeb?this._preferredWebSchema:P.vscodeRemoteResource,authority:`${I}:${m}`,path:this.remoteResourcePath,query:c})}}Ne([S.memoize],t.prototype,"remoteResourcePath",null),e.RemoteAuthorities=new t;class T{asBrowserUri(f,C){const I=this.toUri(f,C);return I.scheme===P.vscodeRemote?e.RemoteAuthorities.rewrite(I):I.scheme===P.file&&(k.isNative||typeof k.globals.importScripts=="function"&&k.globals.origin===`${P.vscodeFileResource}://${T.FALLBACK_AUTHORITY}`)?I.with({scheme:P.vscodeFileResource,authority:I.authority||T.FALLBACK_AUTHORITY,query:null,fragment:null}):I}asFileUri(f,C){const I=this.toUri(f,C);return I.scheme===P.vscodeFileResource?I.with({scheme:P.file,authority:I.authority!==T.FALLBACK_AUTHORITY?I.authority:null,query:null,fragment:null}):I}toUri(f,C){return p.URI.isUri(f)?f:p.URI.parse(C.toUrl(f))}}T.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new T}),define(ue[19],de([0,1,31,10,4,2,14,5]),function(Y,e,S,k,p,P,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function h(u){return(0,T.uriToFsPath)(u,!0)}e.originalFSPath=h;class f{constructor(c){this._ignorePathCasing=c}compare(c,b,g=!1){return c===b?0:(0,t.compare)(this.getComparisonKey(c,g),this.getComparisonKey(b,g))}isEqual(c,b,g=!1){return c===b?!0:!c||!b?!1:this.getComparisonKey(c,g)===this.getComparisonKey(b,g)}getComparisonKey(c,b=!1){return c.with({path:this._ignorePathCasing(c)?c.path.toLowerCase():void 0,fragment:b?null:void 0}).toString()}ignorePathCasing(c){return this._ignorePathCasing(c)}isEqualOrParent(c,b,g=!1){if(c.scheme===b.scheme){if(c.scheme===k.Schemas.file)return S.isEqualOrParent(h(c),h(b),this._ignorePathCasing(c))&&c.query===b.query&&(g||c.fragment===b.fragment);if((0,e.isEqualAuthority)(c.authority,b.authority))return S.isEqualOrParent(c.path,b.path,this._ignorePathCasing(c),"/")&&c.query===b.query&&(g||c.fragment===b.fragment)}return!1}joinPath(c,...b){return T.URI.joinPath(c,...b)}basenameOrAuthority(c){return(0,e.basename)(c)||c.authority}basename(c){return p.posix.basename(c.path)}extname(c){return p.posix.extname(c.path)}dirname(c){if(c.path.length===0)return c;let b;return c.scheme===k.Schemas.file?b=T.URI.file(p.dirname(h(c))).path:(b=p.posix.dirname(c.path),c.authority&&b.length&&b.charCodeAt(0)!==47&&(console.error(`dirname("${c.toString})) resulted in a relative path`),b="/")),c.with({path:b})}normalizePath(c){if(!c.path.length)return c;let b;return c.scheme===k.Schemas.file?b=T.URI.file(p.normalize(h(c))).path:b=p.posix.normalize(c.path),c.with({path:b})}relativePath(c,b){if(c.scheme!==b.scheme||!(0,e.isEqualAuthority)(c.authority,b.authority))return;if(c.scheme===k.Schemas.file){const w=p.relative(h(c),h(b));return P.isWindows?S.toSlashes(w):w}let g=c.path||"/",D=b.path||"/";if(this._ignorePathCasing(c)){let w=0;for(const v=Math.min(g.length,D.length);w<v&&!(g.charCodeAt(w)!==D.charCodeAt(w)&&g.charAt(w).toLowerCase()!==D.charAt(w).toLowerCase());w++);g=D.substr(0,w)+g.substr(w)}return p.posix.relative(g,D)}resolvePath(c,b){if(c.scheme===k.Schemas.file){const g=T.URI.file(p.resolve(h(c),b));return c.with({authority:g.authority,path:g.path})}return b=S.toPosixPath(b),c.with({path:p.posix.resolve(c.path,b)})}isAbsolutePath(c){return!!c.path&&c.path[0]==="/"}isEqualAuthority(c,b){return c===b||c!==void 0&&b!==void 0&&(0,t.equalsIgnoreCase)(c,b)}hasTrailingPathSeparator(c,b=p.sep){if(c.scheme===k.Schemas.file){const g=h(c);return g.length>S.getRoot(g).length&&g[g.length-1]===b}else{const g=c.path;return g.length>1&&g.charCodeAt(g.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(c.fsPath)}}removeTrailingPathSeparator(c,b=p.sep){return(0,e.hasTrailingPathSeparator)(c,b)?c.with({path:c.path.substr(0,c.path.length-1)}):c}addTrailingPathSeparator(c,b=p.sep){let g=!1;if(c.scheme===k.Schemas.file){const D=h(c);g=D!==void 0&&D.length===S.getRoot(D).length&&D[D.length-1]===b}else{b="/";const D=c.path;g=D.length===1&&D.charCodeAt(D.length-1)===47}return!g&&!(0,e.hasTrailingPathSeparator)(c,b)?c.with({path:c.path+"/"}):c}}e.ExtUri=f,e.extUri=new f(()=>!1),e.extUriBiasedIgnorePathCase=new f(u=>u.scheme===k.Schemas.file?!P.isLinux:!0),e.extUriIgnorePathCase=new f(u=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function C(u,c){const b=[];for(let g=0;g<u.length;g++){const D=c(u[g]);u.some((w,v)=>v===g?!1:(0,e.isEqualOrParent)(D,c(w)))||b.push(u[g])}return b}e.distinctParents=C;var I;(function(u){u.META_DATA_LABEL="label",u.META_DATA_DESCRIPTION="description",u.META_DATA_SIZE="size",u.META_DATA_MIME="mime";function c(b){const g=new Map;b.path.substring(b.path.indexOf(";")+1,b.path.lastIndexOf(";")).split(";").forEach(v=>{const[a,l]=v.split(":");a&&l&&g.set(a,l)});const w=b.path.substring(0,b.path.indexOf(";"));return w&&g.set(u.META_DATA_MIME,w),g}u.parseMetaData=c})(I=e.DataUri||(e.DataUri={}));function m(u,c,b){if(c){let g=u.path;return g&&g[0]!==p.posix.sep&&(g=p.posix.sep+g),u.with({scheme:b,authority:c,path:g})}return u.with({scheme:b})}e.toLocalResource=m}),define(ue[13],de([0,1,24,12,6,3,19,2]),function(Y,e,S,k,p,P,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function h(z){return!!z&&typeof z.then=="function"}e.isThenable=h;function f(z){const B=new S.CancellationTokenSource,W=z(B.token),ie=new Promise((oe,we)=>{const se=B.token.onCancellationRequested(()=>{se.dispose(),B.dispose(),we((0,k.canceled)())});Promise.resolve(W).then(ae=>{se.dispose(),B.dispose(),oe(ae)},ae=>{se.dispose(),B.dispose(),we(ae)})});return new class{cancel(){B.cancel()}then(oe,we){return ie.then(oe,we)}catch(oe){return this.then(void 0,oe)}finally(oe){return ie.finally(oe)}}}e.createCancelablePromise=f;function C(z,B,W){return Promise.race([z,new Promise(ie=>B.onCancellationRequested(()=>ie(W)))])}e.raceCancellation=C;async function I(z){let B=-1;const W=z.map((oe,we)=>oe.then(se=>(B=we,se))),ie=await Promise.race(W);return z.forEach((oe,we)=>{we!==B&&oe.cancel()}),ie}e.raceCancellablePromises=I;function m(z,B,W){let ie;const oe=setTimeout(()=>{ie?.(void 0),W?.()},B);return Promise.race([z.finally(()=>clearTimeout(oe)),new Promise(we=>ie=we)])}e.raceTimeout=m;function u(z){return new Promise((B,W)=>{const ie=z();h(ie)?ie.then(B,W):B(ie)})}e.asPromise=u;class c{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(B){if(this.activePromise){if(this.queuedPromiseFactory=B,!this.queuedPromise){const W=()=>{this.queuedPromise=null;const ie=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,ie};this.queuedPromise=new Promise(ie=>{this.activePromise.then(W,W).then(ie)})}return new Promise((W,ie)=>{this.queuedPromise.then(W,ie)})}return this.activePromise=B(),new Promise((W,ie)=>{this.activePromise.then(oe=>{this.activePromise=null,W(oe)},oe=>{this.activePromise=null,ie(oe)})})}}e.Throttler=c;class b{constructor(){this.current=Promise.resolve(null)}queue(B){return this.current=this.current.then(()=>B(),()=>B())}}e.Sequencer=b;class g{constructor(){this.promiseMap=new Map}queue(B,W){const oe=(this.promiseMap.get(B)??Promise.resolve()).catch(()=>{}).then(W).finally(()=>{this.promiseMap.get(B)===oe&&this.promiseMap.delete(B)});return this.promiseMap.set(B,oe),oe}}e.SequencerByKey=g;class D{constructor(B){this.defaultDelay=B,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(B,W=this.defaultDelay){return this.task=B,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((ie,oe)=>{this.doResolve=ie,this.doReject=oe}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const ie=this.task;return this.task=null,ie()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},W),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,k.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=D;class w{constructor(B){this.delayer=new D(B),this.throttler=new c}trigger(B,W){return this.delayer.trigger(()=>this.throttler.queue(B),W)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=w;class v{constructor(){this._isOpen=!1,this._promise=new Promise((B,W)=>{this._completePromise=B})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=v;class a extends v{constructor(B){super();this._timeout=setTimeout(()=>this.open(),B)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=a;function l(z,B){return B?new Promise((W,ie)=>{const oe=setTimeout(()=>{we.dispose(),W()},z),we=B.onCancellationRequested(()=>{clearTimeout(oe),we.dispose(),ie((0,k.canceled)())})}):f(W=>l(z,W))}e.timeout=l;function r(z,B=0){const W=setTimeout(z,B);return(0,P.toDisposable)(()=>clearTimeout(W))}e.disposableTimeout=r;function o(z){const B=[];let W=0;const ie=z.length;function oe(){return W<ie?z[W++]():null}function we(se){se!=null&&B.push(se);const ae=oe();return ae?ae.then(we):Promise.resolve(B)}return Promise.resolve(null).then(we)}e.sequence=o;function i(z,B=ie=>!!ie,W=null){let ie=0;const oe=z.length,we=()=>{if(ie>=oe)return Promise.resolve(W);const se=z[ie++];return Promise.resolve(se()).then(ke=>B(ke)?Promise.resolve(ke):we())};return we()}e.first=i;function n(z,B=ie=>!!ie,W=null){if(z.length===0)return Promise.resolve(W);let ie=z.length;const oe=()=>{ie=-1;for(const we of z)we.cancel?.()};return new Promise((we,se)=>{for(const ae of z)ae.then(ke=>{--ie>=0&&B(ke)?(oe(),we(ke)):ie===0&&we(W)}).catch(ke=>{--ie>=0&&(oe(),se(ke))})})}e.firstParallel=n;class s{constructor(B){this._size=0,this.maxDegreeOfParalellism=B,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new p.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(B){return this._size++,new Promise((W,ie)=>{this.outstandingPromises.push({factory:B,c:W,e:ie}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const B=this.outstandingPromises.shift();this.runningPromises++;const W=B.factory();W.then(B.c,B.e),W.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=s;class d extends s{constructor(){super(1)}}e.Queue=d;class y{constructor(){this.queues=new Map}queueFor(B,W=t.extUri){const ie=W.getComparisonKey(B);let oe=this.queues.get(ie);return oe||(oe=new d,p.Event.once(oe.onFinished)(()=>{oe?.dispose(),this.queues.delete(ie)}),this.queues.set(ie,oe)),oe}dispose(){this.queues.forEach(B=>B.dispose()),this.queues.clear()}}e.ResourceQueue=y;class A{constructor(B,W){this._token=-1,typeof B=="function"&&typeof W=="number"&&this.setIfNotSet(B,W)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(B,W){this.cancel(),this._token=setTimeout(()=>{this._token=-1,B()},W)}setIfNotSet(B,W){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,B()},W))}}e.TimeoutTimer=A;class E{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(B,W){this.cancel(),this._token=setInterval(()=>{B()},W)}}e.IntervalTimer=E;class R{constructor(B,W){this.timeoutToken=-1,this.runner=B,this.timeout=W,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(B=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,B)}get delay(){return this.timeout}set delay(B){this.timeout=B}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=R;class O{constructor(B,W){W%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${W}ms is not a multiple of 1000ms.`),this.runner=B,this.timeout=W,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(B=this.timeout){B%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${B}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(B/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=O;class K extends R{constructor(B,W){super(B,W);this.units=[]}work(B){this.units.push(B),this.isScheduled()||this.schedule()}doRun(){const B=this.units;this.units=[],this.runner&&this.runner(B)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=K;class te extends P.Disposable{constructor(B,W,ie,oe){super();this.maxWorkChunkSize=B,this.maxPendingWork=W,this.throttleDelay=ie,this.handler=oe,this.pendingWork=[],this.throttler=this._register(new P.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(B){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+B.length>this.maxPendingWork)return!1}else if(this.pending+B.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...B),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new R(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=te,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=z=>{(0,T.setTimeout0)(()=>{if(B)return;const W=Date.now()+3;z(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,W-Date.now())}}))});let B=!1;return{dispose(){B||(B=!0)}}}:e.runWhenIdle=(z,B)=>{const W=requestIdleCallback(z,typeof B=="number"?{timeout:B}:void 0);let ie=!1;return{dispose(){ie||(ie=!0,cancelIdleCallback(W))}}}}();class j{constructor(B){this._didRun=!1,this._executor=()=>{try{this._value=B()}catch(W){this._error=W}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=j;async function _(z,B,W){let ie;for(let oe=0;oe<W;oe++)try{return await z()}catch(we){ie=we,await l(B)}throw ie}e.retry=_;class U{hasPending(B){return this._pending?typeof B=="number"?this._pending.taskId===B:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(B,W,ie){return this._pending={taskId:B,cancel:()=>ie?.(),promise:W},W.then(()=>this.donePending(B),()=>this.donePending(B)),W}donePending(B){this._pending&&B===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const B=this._next;this._next=void 0,B.run().then(B.promiseResolve,B.promiseReject)}}setNext(B){if(this._next)this._next.run=B;else{let W,ie;const oe=new Promise((we,se)=>{W=we,ie=se});this._next={run:B,promise:oe,promiseResolve:W,promiseReject:ie}}return this._next.promise}}e.TaskSequentializer=U;class F{constructor(B,W=()=>Date.now()){this.interval=B,this.nowFn=W,this.lastIncrementTime=0,this.value=0}increment(){const B=this.nowFn();return B-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=B,this.value=0),this.value++,this.value}}e.IntervalCounter=F;class M{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((B,W)=>{this.completeCallback=B,this.errorCallback=W})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(B){return new Promise(W=>{this.completeCallback(B),this.resolved=!0,W()})}error(B){return new Promise(W=>{this.errorCallback(B),this.rejected=!0,W()})}cancel(){new Promise(B=>{this.errorCallback((0,k.canceled)()),this.rejected=!0,B()})}}e.DeferredPromise=M;var V;(function(z){async function B(ie){let oe;const we=await Promise.all(ie.map(se=>se.then(ae=>ae,ae=>{oe||(oe=ae)})));if(typeof oe!="undefined")throw oe;return we}z.settled=B;function W(ie){return new Promise(async(oe,we)=>{try{await ie(oe,we)}catch(se){we(se)}})}z.withAsyncBody=W})(V=e.Promises||(e.Promises={}));var ee;(function(z){z[z.Initial=0]="Initial",z[z.DoneOK=1]="DoneOK",z[z.DoneError=2]="DoneError"})(ee||(ee={}));class G{constructor(B){this._state=0,this._results=[],this._error=null,this._onStateChanged=new p.Emitter,queueMicrotask(async()=>{const W={emitOne:ie=>this.emitOne(ie),emitMany:ie=>this.emitMany(ie),reject:ie=>this.reject(ie)};try{await Promise.resolve(B(W)),this.resolve()}catch(ie){this.reject(ie)}finally{W.emitOne=void 0,W.emitMany=void 0,W.reject=void 0}})}static fromArray(B){return new G(W=>{W.emitMany(B)})}static fromPromise(B){return new G(async W=>{W.emitMany(await B)})}static fromPromises(B){return new G(async W=>{await Promise.all(B.map(async ie=>W.emitOne(await ie)))})}static merge(B){return new G(async W=>{await Promise.all(B.map(async ie=>{for await(const oe of ie)W.emitOne(oe)}))})}[Symbol.asyncIterator](){let B=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(B<this._results.length)return{done:!1,value:this._results[B++]};if(this._state===1)return{done:!0,value:void 0};await p.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(B,W){return new G(async ie=>{for await(const oe of B)ie.emitOne(W(oe))})}map(B){return G.map(this,B)}static filter(B,W){return new G(async ie=>{for await(const oe of B)W(oe)&&ie.emitOne(oe)})}filter(B){return G.filter(this,B)}static coalesce(B){return G.filter(B,W=>!!W)}coalesce(){return G.coalesce(this)}static async toPromise(B){const W=[];for await(const ie of B)W.push(ie);return W}toPromise(){return G.toPromise(this)}emitOne(B){this._state===0&&(this._results.push(B),this._onStateChanged.fire())}emitMany(B){this._state===0&&(this._results=this._results.concat(B),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(B){this._state===0&&(this._state=2,this._error=B,this._onStateChanged.fire())}}e.AsyncIterableObject=G,G.EMPTY=G.fromArray([]);class H extends G{constructor(B,W){super(W);this._source=B}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=H;function q(z){const B=new S.CancellationTokenSource,W=z(B.token);return new H(B,async ie=>{const oe=B.token.onCancellationRequested(()=>{oe.dispose(),B.dispose(),ie.reject((0,k.canceled)())});try{for await(const we of W){if(B.token.isCancellationRequested)return;ie.emitOne(we)}oe.dispose(),B.dispose()}catch(we){oe.dispose(),B.dispose(),ie.reject(we)}})}e.createCancelableAsyncIterable=q}),define(ue[63],de([0,1,13,31,30,4,14]),function(Y,e,S,k,p,P,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function T(){return Object.create(null)}e.getEmptyExpression=T;const h="**",f="/",C="[/\\\\]",I="[^/\\\\]",m=/\//g;function u(H){switch(H){case 0:return"";case 1:return`${I}*?`;default:return`(?:${C}|${I}+${C}|${C}${I}+)*?`}}function c(H,q){if(!H)return[];const z=[];let B=!1,W=!1,ie="";for(const oe of H){switch(oe){case q:if(!B&&!W){z.push(ie),ie="";continue}break;case"{":B=!0;break;case"}":B=!1;break;case"[":W=!0;break;case"]":W=!1;break}ie+=oe}return ie&&z.push(ie),z}e.splitGlobAware=c;function b(H){if(!H)return"";let q="";const z=c(H,f);if(z.every(B=>B===h))q=".*";else{let B=!1;z.forEach((W,ie)=>{if(W===h){B||(q+=u(2),B=!0);return}let oe=!1,we="",se=!1,ae="";for(const ke of W){if(ke!=="}"&&oe){we+=ke;continue}if(se&&(ke!=="]"||!ae)){let De;ke==="-"?De=ke:(ke==="^"||ke==="!")&&!ae?De="^":ke===f?De="":De=t.escapeRegExpCharacters(ke),ae+=De;continue}switch(ke){case"{":oe=!0;continue;case"[":se=!0;continue;case"}":q+=`(?:${c(we,",").map(Be=>b(Be)).join("|")})`,oe=!1,we="";break;case"]":q+="["+ae+"]",se=!1,ae="";break;case"?":q+=I;continue;case"*":q+=u(1);continue;default:q+=t.escapeRegExpCharacters(ke)}}ie<z.length-1&&(z[ie+1]!==h||ie+2<z.length)&&(q+=C),B=!1})}return q}const g=/^\*\*\/\*\.[\w\.-]+$/,D=/^\*\*\/([\w\.-]+)\/?$/,w=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,v=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,a=/^\*\*((\/[\w\.-]+)+)\/?$/,l=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,r=new p.LRUCache(1e4),o=function(){return!1},i=function(){return null};function n(H,q){if(!H)return i;let z;typeof H!="string"?z=H.pattern:z=H,z=z.trim();const B=`${z}_${!!q.trimForExclusions}`;let W=r.get(B);if(W)return s(W,H);let ie;if(g.test(z)){const oe=z.substr(4);W=function(we,se){return typeof we=="string"&&we.endsWith(oe)?z:null}}else(ie=D.exec(d(z,q)))?W=y(ie[1],z):(q.trimForExclusions?v:w).test(z)?W=A(z,q):(ie=a.exec(d(z,q)))?W=E(ie[1].substr(1),z,!0):(ie=l.exec(d(z,q)))?W=E(ie[1],z,!1):W=R(z);return r.set(B,W),s(W,H)}function s(H,q){return typeof q=="string"?H:function(z,B){return k.isEqualOrParent(z,q.base)?H(P.relative(q.base,z),B):null}}function d(H,q){return q.trimForExclusions&&H.endsWith("/**")?H.substr(0,H.length-2):H}function y(H,q){const z=`/${H}`,B=`\\${H}`,W=function(oe,we){return typeof oe!="string"?null:we?we===H?q:null:oe===H||oe.endsWith(z)||oe.endsWith(B)?q:null},ie=[H];return W.basenames=ie,W.patterns=[q],W.allBasenames=ie,W}function A(H,q){const z=G(H.slice(1,-1).split(",").map(we=>n(we,q)).filter(we=>we!==i),H),B=z.length;if(!B)return i;if(B===1)return z[0];const W=function(we,se){for(let ae=0,ke=z.length;ae<ke;ae++)if(z[ae](we,se))return H;return null},ie=z.find(we=>!!we.allBasenames);ie&&(W.allBasenames=ie.allBasenames);const oe=z.reduce((we,se)=>se.allPaths?we.concat(se.allPaths):we,[]);return oe.length&&(W.allPaths=oe),W}function E(H,q,z){const B=P.sep===P.posix.sep,W=B?H:H.replace(m,P.sep),ie=P.sep+W,oe=P.posix.sep+H,we=z?function(se,ae){return typeof se=="string"&&(se===W||se.endsWith(ie)||!B&&(se===H||se.endsWith(oe)))?q:null}:function(se,ae){return typeof se=="string"&&(se===W||!B&&se===H)?q:null};return we.allPaths=[(z?"*/":"./")+H],we}function R(H){try{const q=new RegExp(`^${b(H)}$`);return function(z){return q.lastIndex=0,typeof z=="string"&&q.test(z)?H:null}}catch(q){return i}}function O(H,q,z){return!H||typeof q!="string"?!1:K(H)(q,void 0,z)}e.match=O;function K(H,q={}){if(!H)return o;if(typeof H=="string"||U(H)){const z=n(H,q);if(z===i)return o;const B=function(W,ie){return!!z(W,ie)};return z.allBasenames&&(B.allBasenames=z.allBasenames),z.allPaths&&(B.allPaths=z.allPaths),B}return V(H,q)}e.parse=K;function te(H){if(!H)return;let q;return z=>(q||(q=(H()||Promise.resolve([])).then(B=>B?_(B):{})),q.then(B=>!!B[z]))}e.hasSiblingPromiseFn=te;function j(H){if(!H)return;let q;return z=>{if(!q){const B=H();q=B?_(B):{}}return!!q[z]}}e.hasSiblingFn=j;function _(H){const q={};for(const z of H)q[z]=!0;return q}function U(H){const q=H;return q&&typeof q.base=="string"&&typeof q.pattern=="string"}e.isRelativePattern=U;function F(H){return H.allBasenames||[]}e.getBasenameTerms=F;function M(H){return H.allPaths||[]}e.getPathTerms=M;function V(H,q){const z=G(Object.getOwnPropertyNames(H).map(we=>ee(we,H[we],q)).filter(we=>we!==i)),B=z.length;if(!B)return i;if(!z.some(we=>!!we.requiresSiblings)){if(B===1)return z[0];const we=function(ke,De){for(let Oe=0,Be=z.length;Oe<Be;Oe++){const Xe=z[Oe](ke,De);if(Xe)return Xe}return null},se=z.find(ke=>!!ke.allBasenames);se&&(we.allBasenames=se.allBasenames);const ae=z.reduce((ke,De)=>De.allPaths?ke.concat(De.allPaths):ke,[]);return ae.length&&(we.allPaths=ae),we}const W=function(we,se,ae){let ke;for(let De=0,Oe=z.length;De<Oe;De++){const Be=z[De];Be.requiresSiblings&&ae&&(se||(se=P.basename(we)),ke||(ke=se.substr(0,se.length-P.extname(we).length)));const Xe=Be(we,se,ke,ae);if(Xe)return Xe}return null},ie=z.find(we=>!!we.allBasenames);ie&&(W.allBasenames=ie.allBasenames);const oe=z.reduce((we,se)=>se.allPaths?we.concat(se.allPaths):we,[]);return oe.length&&(W.allPaths=oe),W}function ee(H,q,z){if(q===!1)return i;const B=n(H,z);if(B===i)return i;if(typeof q=="boolean")return B;if(q){const W=q.when;if(typeof W=="string"){const ie=(oe,we,se,ae)=>{if(!ae||!B(oe,we))return null;const ke=W.replace("$(basename)",se),De=ae(ke);return(0,S.isThenable)(De)?De.then(Oe=>Oe?H:null):De?H:null};return ie.requiresSiblings=!0,ie}}return B}function G(H,q){const z=H.filter(we=>!!we.basenames);if(z.length<2)return H;const B=z.reduce((we,se)=>{const ae=se.basenames;return ae?we.concat(ae):we},[]);let W;if(q){W=[];for(let we=0,se=B.length;we<se;we++)W.push(q)}else W=z.reduce((we,se)=>{const ae=se.patterns;return ae?we.concat(ae):we},[]);const ie=function(we,se){if(typeof we!="string")return null;if(!se){let ke;for(ke=we.length;ke>0;ke--){const De=we.charCodeAt(ke-1);if(De===47||De===92)break}se=we.substr(ke)}const ae=B.indexOf(se);return ae!==-1?W[ae]:null};ie.basenames=B,ie.patterns=W,ie.allBasenames=B;const oe=H.filter(we=>!we.basenames);return oe.push(ie),oe}}),define(ue[64],de([0,1,31,10,4,2,19,14,5]),function(Y,e,S,k,p,P,t,T,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function f(n,s,d){if(typeof n=="string"&&(n=h.URI.file(n)),d){const A=d.getWorkspaceFolder(n);if(A){const E=d.getWorkspace().folders.length>1;let R;if((0,t.isEqual)(A.uri,n)?R="":R=(0,t.relativePath)(A.uri,n),E){const O=A.name?A.name:(0,t.basename)(A.uri);R=R?O+" \u2022 "+R:O}return R}}if(n.scheme!==k.Schemas.file&&n.scheme!==k.Schemas.untitled)return n.with({query:null,fragment:null}).toString(!0);if((0,S.hasDriveLetter)(n.fsPath))return(0,p.normalize)(I(n.fsPath));let y=(0,p.normalize)(n.fsPath);return!P.isWindows&&s?.userHome&&(y=u(y,s.userHome.fsPath)),y}e.getPathLabel=f;function C(n){if(!n)return;typeof n=="string"&&(n=h.URI.file(n));const s=(0,t.basename)(n)||(n.scheme===k.Schemas.file?n.fsPath:n.path);return P.isWindows&&(0,S.isRootOrDriveLetter)(s)?I(s):s}e.getBaseLabel=C;function I(n,s){return(0,S.hasDriveLetter)(n,s)?n.charAt(0).toUpperCase()+n.slice(1):n}e.normalizeDriveLetter=I;let m=Object.create(null);function u(n,s){if(P.isWindows||!n||!s)return n;let d=m.original===s?m.normalized:void 0;return d||(d=`${(0,T.rtrim)(s,p.posix.sep)}${p.posix.sep}`,m={original:s,normalized:d}),(P.isLinux?n.startsWith(d):(0,T.startsWithIgnoreCase)(n,d))&&(n=`~/${n.substr(d.length)}`),n}e.tildify=u;function c(n,s){return n.replace(/^~($|\/|\\)/,`${s}$1`)}e.untildify=c;const b="\u2026",g="\\\\",D="~";function w(n,s=p.sep){const d=new Array(n.length);let y=!1;for(let A=0;A<n.length;A++){let E=n[A];if(E===""){d[A]=`.${s}`;continue}if(!E){d[A]=E;continue}y=!0;let R="";E.indexOf(g)===0?(R=E.substr(0,E.indexOf(g)+g.length),E=E.substr(E.indexOf(g)+g.length)):E.indexOf(s)===0?(R=E.substr(0,E.indexOf(s)+s.length),E=E.substr(E.indexOf(s)+s.length)):E.indexOf(D)===0&&(R=E.substr(0,E.indexOf(D)+D.length),E=E.substr(E.indexOf(D)+D.length));const O=E.split(s);for(let K=1;y&&K<=O.length;K++)for(let te=O.length-K;y&&te>=0;te--){y=!1;let j=O.slice(te,te+K).join(s);for(let _=0;!y&&_<n.length;_++)if(_!==A&&n[_]&&n[_].indexOf(j)>-1){const U=te+K===O.length,F=te>0&&n[_].indexOf(s)>-1?s+j:j,M=n[_].endsWith(F);y=!U||M}if(!y){let _="";(O[0].endsWith(":")||R!=="")&&(te===1&&(te=0,K++,j=O[0]+s+j),te>0&&(_=O[0]+s),_=R+_),te>0&&(_=_+b+s),_=_+j,te+K<O.length&&(_=_+s+b),d[A]=_}}y&&(d[A]=E)}return d}e.shorten=w;var v;(function(n){n[n.TEXT=0]="TEXT",n[n.VARIABLE=1]="VARIABLE",n[n.SEPARATOR=2]="SEPARATOR"})(v||(v={}));function a(n,s=Object.create(null)){const d=[];let y=!1,A="";for(const E of n)if(E==="$"||y&&E==="{")A&&d.push({value:A,type:v.TEXT}),A="",y=!0;else if(E==="}"&&y){const R=s[A];if(typeof R=="string")R.length&&d.push({value:R,type:v.VARIABLE});else if(R){const O=d[d.length-1];(!O||O.type!==v.SEPARATOR)&&d.push({value:R.label,type:v.SEPARATOR})}A="",y=!1}else A+=E;return A&&!y&&d.push({value:A,type:v.TEXT}),d.filter((E,R)=>{if(E.type===v.SEPARATOR){const O=d[R-1],K=d[R+1];return[O,K].every(te=>te&&(te.type===v.VARIABLE||te.type===v.TEXT)&&te.value.length>0)}return!0}).map(E=>E.value).join("")}e.template=a;function l(n,s){return P.isMacintosh||s?n.replace(/\(&&\w\)|&&/g,"").replace(/&/g,P.isMacintosh?"&":"&&"):n.replace(/&&|&/g,d=>d==="&"?"&&":"&")}e.mnemonicMenuLabel=l;function r(n,s){return P.isMacintosh||s?n.replace(/\(&&\w\)|&&/g,""):P.isWindows?n.replace(/&&|&/g,d=>d==="&"?"&&":"&"):n.replace(/&&/g,"_")}e.mnemonicButtonLabel=r;function o(n){return n.replace(/&/g,"&&")}e.unmnemonicLabel=o;function i(n){const s=n.indexOf("/")!==-1?p.posix:p.win32,d=s.basename(n),y=s.dirname(n);return d.length?{name:d,parentPath:y}:{name:y,parentPath:""}}e.splitName=i}),define(ue[65],de([0,1,63,10,4,19,14]),function(Y,e,S,k,p,P,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.isUnspecific=e.guessMimeTypes=e.clearTextMimes=e.registerTextMime=e.Mimes=void 0;var T;(function(n){n.text="text/plain",n.binary="application/octet-stream",n.unknown="application/unknown",n.markdown="text/markdown",n.latex="text/latex"})(T=e.Mimes||(e.Mimes={}));let h=[],f=[],C=[];function I(n,s=!1){const d=m(n);h.push(d),d.userConfigured?C.push(d):f.push(d),s&&!d.userConfigured&&h.forEach(y=>{y.mime===d.mime||y.userConfigured||(d.extension&&y.extension===d.extension&&console.warn(`Overwriting extension <<${d.extension}>> to now point to mime <<${d.mime}>>`),d.filename&&y.filename===d.filename&&console.warn(`Overwriting filename <<${d.filename}>> to now point to mime <<${d.mime}>>`),d.filepattern&&y.filepattern===d.filepattern&&console.warn(`Overwriting filepattern <<${d.filepattern}>> to now point to mime <<${d.mime}>>`),d.firstline&&y.firstline===d.firstline&&console.warn(`Overwriting firstline <<${d.firstline}>> to now point to mime <<${d.mime}>>`))})}e.registerTextMime=I;function m(n){return{id:n.id,mime:n.mime,filename:n.filename,extension:n.extension,filepattern:n.filepattern,firstline:n.firstline,userConfigured:n.userConfigured,filenameLowercase:n.filename?n.filename.toLowerCase():void 0,extensionLowercase:n.extension?n.extension.toLowerCase():void 0,filepatternLowercase:n.filepattern?(0,S.parse)(n.filepattern.toLowerCase()):void 0,filepatternOnPath:n.filepattern?n.filepattern.indexOf(p.posix.sep)>=0:!1}}function u(n){n?(h=h.filter(s=>!s.userConfigured),C=[]):(h=[],f=[],C=[])}e.clearTextMimes=u;function c(n,s){let d;if(n)switch(n.scheme){case k.Schemas.file:d=n.fsPath;break;case k.Schemas.data:d=P.DataUri.parseMetaData(n).get(P.DataUri.META_DATA_LABEL);break;default:d=n.path}if(!d)return[T.unknown];d=d.toLowerCase();const y=(0,p.basename)(d),A=b(d,y,C);if(A)return[A,T.text];const E=b(d,y,f);if(E)return[E,T.text];if(s){const R=g(s);if(R)return[R,T.text]}return[T.unknown]}e.guessMimeTypes=c;function b(n,s,d){let y=null,A=null,E=null;for(let R=d.length-1;R>=0;R--){const O=d[R];if(s===O.filenameLowercase){y=O;break}if(O.filepattern&&(!A||O.filepattern.length>A.filepattern.length)){const K=O.filepatternOnPath?n:s;O.filepatternLowercase?.(K)&&(A=O)}O.extension&&(!E||O.extension.length>E.extension.length)&&s.endsWith(O.extensionLowercase)&&(E=O)}return y?y.mime:A?A.mime:E?E.mime:null}function g(n){if((0,t.startsWithUTF8BOM)(n)&&(n=n.substr(1)),n.length>0)for(let s=h.length-1;s>=0;s--){const d=h[s];if(!d.firstline)continue;const y=n.match(d.firstline);if(y&&y.length>0)return d.mime}return null}function D(n){return n?typeof n=="string"?n===T.binary||n===T.text||n===T.unknown:n.length===1&&D(n[0]):!0}e.isUnspecific=D;const w={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},v={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function a(n){const s=(0,p.extname)(n),d=w[s.toLowerCase()];return d!==void 0?d:l(n)}e.getMediaOrTextMime=a;function l(n){const s=(0,p.extname)(n);return v[s.toLowerCase()]}e.getMediaMime=l;function r(n){for(const s in v)if(v[s]===n)return s}e.getExtensionForMimeType=r;const o=/^(.+)\/(.+?)(;.+)?$/;function i(n,s){const d=o.exec(n);return d?`${d[1].toLowerCase()}/${d[2].toLowerCase()}${d[3]??""}`:s?void 0:n}e.normalizeMimeType=i}),define(ue[66],de([0,1,5]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function k(C){return C.toJSON()}class p{constructor(I){this._uriTransformer=I}transformIncoming(I){const m=this._uriTransformer.transformIncoming(I);return m===I?I:k(S.URI.from(m))}transformOutgoing(I){const m=this._uriTransformer.transformOutgoing(I);return m===I?I:k(S.URI.from(m))}transformOutgoingURI(I){const m=this._uriTransformer.transformOutgoing(I);return m===I?I:S.URI.from(m)}transformOutgoingScheme(I){return this._uriTransformer.transformOutgoingScheme(I)}}e.URITransformer=p,e.DefaultURITransformer=new class{transformIncoming(C){return C}transformOutgoing(C){return C}transformOutgoingURI(C){return C}transformOutgoingScheme(C){return C}};function P(C,I,m){if(!C||m>200)return null;if(typeof C=="object"){if(C instanceof S.URI)return I.transformOutgoing(C);for(let u in C)if(Object.hasOwnProperty.call(C,u)){const c=P(C[u],I,m+1);c!==null&&(C[u]=c)}}return null}function t(C,I){const m=P(C,I,0);return m===null?C:m}e.transformOutgoingURIs=t;function T(C,I,m,u){if(!C||u>200)return null;if(typeof C=="object"){if(C.$mid===1)return m?S.URI.revive(I.transformIncoming(C)):I.transformIncoming(C);for(let c in C)if(Object.hasOwnProperty.call(C,c)){const b=T(C[c],I,m,u+1);b!==null&&(C[c]=b)}}return null}function h(C,I){const m=T(C,I,!1,0);return m===null?C:m}e.transformIncomingURIs=h;function f(C,I){const m=T(C,I,!0,0);return m===null?C:m}e.transformAndReviveIncomingURIs=f}),define(ue[25],de([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const S=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function k(h){return S.test(h)}e.isUUID=k;const p=new Uint8Array(16),P=[];for(let h=0;h<256;h++)P.push(h.toString(16).padStart(2,"0"));let t;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?t=crypto.getRandomValues.bind(crypto):t=function(h){for(let f=0;f<h.length;f++)h[f]=Math.floor(Math.random()*256);return h};function T(){t(p),p[6]=p[6]&15|64,p[8]=p[8]&63|128;let h=0,f="";return f+=P[p[h++]],f+=P[p[h++]],f+=P[p[h++]],f+=P[p[h++]],f+="-",f+=P[p[h++]],f+=P[p[h++]],f+="-",f+=P[p[h++]],f+=P[p[h++]],f+="-",f+=P[p[h++]],f+=P[p[h++]],f+="-",f+=P[p[h++]],f+=P[p[h++]],f+=P[p[h++]],f+=P[p[h++]],f+=P[p[h++]],f+=P[p[h++]],f}e.generateUuid=T}),define(ue[139],de([0,1,278]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class k{constructor(P="utf8"){this.stringDecoder=new S.StringDecoder(P),this.remaining=null}write(P){const t=[],T=this.remaining?this.remaining+this.stringDecoder.write(P):this.stringDecoder.write(P);if(T.length<1)return t;let h=0,f,C=h;for(;C<T.length;)if(f=T.charCodeAt(C),f===13||f===10){if(t.push(T.substring(h,C)),C++,C<T.length){const I=f;f=T.charCodeAt(C),(I===13&&f===10||I===10&&f===13)&&C++}h=C}else C++;return this.remaining=h<T.length?T.substr(h):null,t}end(){return this.remaining}}e.LineDecoder=k}),function(){"use strict";function Y(e,S,k,p){function P(c){return new Promise(b=>k.exists(c,b))}function t(c){return new Promise((b,g)=>{const D=new Date;k.utimes(c,D,D,w=>w?g(w):b())})}function T(c){return new Promise((b,g)=>k.mkdir(c,{recursive:!0},D=>D&&D.code!=="EEXIST"?g(D):b(c)))}function h(c){return new Promise((b,g)=>k.rmdir(c,{recursive:!0},D=>D&&D.code!=="ENOENT"?g(D):b()))}function f(c){return new Promise((b,g)=>k.readFile(c,"utf8",(D,w)=>D?g(D):b(w)))}function C(c,b){return new Promise((g,D)=>k.writeFile(c,b,"utf8",w=>w?D(w):g()))}function I(c){const b=S.join(c,"languagepacks.json");try{return e(b)}catch(g){}}function m(c,b){try{for(;b;){if(c[b])return b;{const g=b.lastIndexOf("-");if(g>0)b=b.substring(0,g);else return}}}catch(g){console.error("Resolving language pack configuration failed.",g)}}function u(c,b,g,D){if(D==="pseudo")return Promise.resolve({locale:D,availableLanguages:{},pseudo:!0});if(process.env.VSCODE_DEV)return Promise.resolve({locale:D,availableLanguages:{}});if(D&&(D==="en"||D==="en-us"))return Promise.resolve({locale:D,availableLanguages:{}});const w=D;p.mark("code/willGenerateNls");const v=function(a){return p.mark("code/didGenerateNls"),Promise.resolve({locale:a,availableLanguages:{}})};try{if(!c)return v(w);const a=I(b);if(!a||(D=m(a,D),!D))return v(w);const l=a[D];let r;return!l||typeof l.hash!="string"||!l.translations||typeof(r=l.translations.vscode)!="string"?v(w):P(r).then(o=>{if(!o)return v(w);const i=l.hash+"."+D,n=S.join(b,"clp",i),s=S.join(n,c),d=S.join(n,"tcf.json"),y=S.join(n,"corrupted.info"),A={locale:w,availableLanguages:{"*":D},_languagePackId:i,_translationsConfigFile:d,_cacheRoot:n,_resolvedLanguagePackCoreLocation:s,_corruptedFile:y};return P(y).then(E=>{let R;return E?R=h(n):R=Promise.resolve(void 0),R.then(()=>P(s).then(O=>O?(t(s).catch(()=>{}),p.mark("code/didGenerateNls"),A):T(s).then(()=>Promise.all([f(g),f(r)])).then(K=>{const te=JSON.parse(K[0]),j=JSON.parse(K[1]).contents,_=Object.keys(te.bundles),U=[];for(const F of _){const M=te.bundles[F],V=Object.create(null);for(const ee of M){const G=te.keys[ee],H=te.messages[ee],q=j[ee];let z;if(q){z=[];for(let B=0;B<G.length;B++){const W=G[B],ie=typeof W=="string"?W:W.key;let oe=q[ie];oe===void 0&&(oe=H[B]),z.push(oe)}}else z=H;V[ee]=z}U.push(C(S.join(s,F.replace(/\//g,"!")+".nls.json"),JSON.stringify(V)))}return U.push(C(d,JSON.stringify(l.translations))),Promise.all(U)}).then(()=>(p.mark("code/didGenerateNls"),A)).catch(K=>(console.error("Generating translation files failed.",K),v(D)))))})})}catch(a){return console.error("Generating translation files failed.",a),v(D)}}return{getNLSConfiguration:u}}if(typeof define=="function")define(ue[140],de([0,90,32,48]),function(e,S,k,p){return Y(e.__$__nodeRequire,S,k,p)});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),S=require("fs"),k=require("../common/performance");module.exports=Y(require,e,S,k)}else throw new Error("Unknown context")}(),define(ue[141],de([0,1,26]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const k=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function p(t){const T=t.replace(/\-/g,":").toLowerCase();return!k.has(T)}function P(){const t=(0,S.networkInterfaces)();for(let T in t){const h=t[T];if(h){for(const{mac:f}of h)if(p(f))return f}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=P}),define(ue[91],de([0,1,26,12,30,25,141]),function(Y,e,S,k,p,P,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(C){return this._virtualMachineOUIs||(this._virtualMachineOUIs=p.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(C)}value(){if(this._value===void 0){let C=0,I=0;const m=(0,S.networkInterfaces)();for(let u in m){const c=m[u];if(c)for(const{mac:b,internal:g}of c)g||(I+=1,this._isVirtualMachineMacAddress(b.toUpperCase())&&(C+=1))}this._value=I>0?C/I:0}return this._value}};let T;async function h(){return T||(T=(async()=>await f()||P.generateUuid())()),T}e.getMachineId=h;async function f(){try{const C=await new Promise((m,u)=>{Y(["crypto"],m,u)}),I=(0,t.getMac)();return C.createHash("sha256").update(I,"utf8").digest("hex")}catch(C){k.onUnexpectedError(C);return}}}),define(ue[17],de([0,1,32,26,142,13,31,88,4,2,19,5,25]),function(Y,e,S,k,p,P,t,T,h,f,C,I,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var u;(function(F){F[F.UNLINK=0]="UNLINK",F[F.MOVE=1]="MOVE"})(u=e.RimRafMode||(e.RimRafMode={}));async function c(F,M=u.UNLINK){if((0,t.isRootOrDriveLetter)(F))throw new Error("rimraf - will refuse to recursively delete root");return M===u.UNLINK?g(F):b(F)}async function b(F){try{const M=(0,h.join)((0,k.tmpdir)(),(0,m.generateUuid)());try{await e.Promises.rename(F,M)}catch(V){return g(F)}g(M).catch(V=>{})}catch(M){if(M.code!=="ENOENT")throw M}}async function g(F){return e.Promises.rmdir(F,{recursive:!0,maxRetries:3})}function D(F){if((0,t.isRootOrDriveLetter)(F))throw new Error("rimraf - will refuse to recursively delete root");S.rmdirSync(F,{recursive:!0})}e.rimrafSync=D;async function w(F,M){return l(await(M?v(F):(0,p.promisify)(S.readdir)(F)))}async function v(F){try{return await(0,p.promisify)(S.readdir)(F,{withFileTypes:!0})}catch(ee){console.warn("[node.js fs] readdir with filetypes failed with error: ",ee)}const M=[],V=await w(F);for(const ee of V){let G=!1,H=!1,q=!1;try{const z=await e.Promises.lstat((0,h.join)(F,ee));G=z.isFile(),H=z.isDirectory(),q=z.isSymbolicLink()}catch(z){console.warn("[node.js fs] unexpected error from lstat after readdir: ",z)}M.push({name:ee,isFile:()=>G,isDirectory:()=>H,isSymbolicLink:()=>q})}return M}function a(F){return l(S.readdirSync(F))}e.readdirSync=a;function l(F){return F.map(M=>typeof M=="string"?f.isMacintosh?(0,T.normalizeNFC)(M):M:(M.name=f.isMacintosh?(0,T.normalizeNFC)(M.name):M.name,M))}async function r(F){const M=await w(F),V=[];for(const ee of M)await i.existsDirectory((0,h.join)(F,ee))&&V.push(ee);return V}function o(F,M=1e3){return new Promise(V=>{let ee=!1;const G=setInterval(()=>{ee||(ee=!0,S.access(F,H=>{ee=!1,H&&(clearInterval(G),V(void 0))}))},M)})}e.whenDeleted=o;var i;(function(F){async function M(G){let H;try{if(H=await e.Promises.lstat(G),!H.isSymbolicLink())return{stat:H}}catch(q){}try{return{stat:await e.Promises.stat(G),symbolicLink:H?.isSymbolicLink()?{dangling:!1}:void 0}}catch(q){if(q.code==="ENOENT"&&H)return{stat:H,symbolicLink:{dangling:!0}};if(f.isWindows&&q.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(G)),symbolicLink:{dangling:!1}}}catch(z){if(z.code==="ENOENT"&&H)return{stat:H,symbolicLink:{dangling:!0}};throw z}throw q}}F.stat=M;async function V(G){try{const{stat:H,symbolicLink:q}=await F.stat(G);return H.isFile()&&q?.dangling!==!0}catch(H){}return!1}F.existsFile=V;async function ee(G){try{const{stat:H,symbolicLink:q}=await F.stat(G);return H.isDirectory()&&q?.dangling!==!0}catch(H){}return!1}F.existsDirectory=ee})(i=e.SymlinkSupport||(e.SymlinkSupport={}));const n=new P.ResourceQueue;function s(F,M,V){return n.queueFor(I.URI.file(F),C.extUriBiasedIgnorePathCase).queue(()=>{const ee=E(V);return new Promise((G,H)=>y(F,M,ee,q=>q?H(q):G()))})}let d=!0;function y(F,M,V,ee){if(!d)return S.writeFile(F,M,{mode:V.mode,flag:V.flag},ee);S.open(F,V.flag,V.mode,(G,H)=>{if(G)return ee(G);S.writeFile(H,M,q=>{if(q)return S.close(H,()=>ee(q));S.fdatasync(H,z=>(z&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",z),d=!1),S.close(H,B=>ee(B))))})})}function A(F,M,V){const ee=E(V);if(!d)return S.writeFileSync(F,M,{mode:ee.mode,flag:ee.flag});const G=S.openSync(F,ee.flag,ee.mode);try{S.writeFileSync(G,M);try{S.fdatasyncSync(G)}catch(H){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",H),d=!1}}finally{S.closeSync(G)}}e.writeFileSync=A;function E(F){return F?{mode:typeof F.mode=="number"?F.mode:438,flag:typeof F.flag=="string"?F.flag:"w"}:{mode:438,flag:"w"}}async function R(F,M){if(F===M)return;async function V(ee){try{const G=await e.Promises.lstat(ee);if(G.isDirectory()||G.isSymbolicLink())return;await e.Promises.utimes(ee,G.atime,new Date)}catch(G){}}try{await e.Promises.rename(F,M),await V(M)}catch(ee){if(F.toLowerCase()!==M.toLowerCase()&&ee.code==="EXDEV"||F.endsWith("."))await O(F,M,{preserveSymlinks:!1}),await c(F,u.MOVE),await V(M);else throw ee}}async function O(F,M,V){return te(F,M,{root:{source:F,target:M},options:V,handledSourcePaths:new Set})}const K=511;async function te(F,M,V){if(V.handledSourcePaths.has(F))return;V.handledSourcePaths.add(F);const{stat:ee,symbolicLink:G}=await i.stat(F);if(G){if(V.options.preserveSymlinks)try{return await U(F,M,V)}catch(H){console.warn("[node.js fs] copy of symlink failed: ",H)}if(G.dangling)return}return ee.isDirectory()?j(F,M,ee.mode&K,V):_(F,M,ee.mode&K)}async function j(F,M,V,ee){await e.Promises.mkdir(M,{recursive:!0,mode:V});const G=await w(F);for(const H of G)await te((0,h.join)(F,H),(0,h.join)(M,H),ee)}async function _(F,M,V){await e.Promises.copyFile(F,M),await e.Promises.chmod(M,V)}async function U(F,M,V){let ee=await e.Promises.readlink(F);(0,t.isEqualOrParent)(ee,V.root.source,!f.isLinux)&&(ee=(0,h.join)(V.root.target,ee.substr(V.root.source.length+1))),await e.Promises.symlink(ee,M)}e.Promises=new class{get access(){return(0,p.promisify)(S.access)}get stat(){return(0,p.promisify)(S.stat)}get lstat(){return(0,p.promisify)(S.lstat)}get utimes(){return(0,p.promisify)(S.utimes)}get read(){return(0,p.promisify)(S.read)}get readFile(){return(0,p.promisify)(S.readFile)}get write(){return(0,p.promisify)(S.write)}get appendFile(){return(0,p.promisify)(S.appendFile)}get fdatasync(){return(0,p.promisify)(S.fdatasync)}get truncate(){return(0,p.promisify)(S.truncate)}get rename(){return(0,p.promisify)(S.rename)}get copyFile(){return(0,p.promisify)(S.copyFile)}get open(){return(0,p.promisify)(S.open)}get close(){return(0,p.promisify)(S.close)}get symlink(){return(0,p.promisify)(S.symlink)}get readlink(){return(0,p.promisify)(S.readlink)}get chmod(){return(0,p.promisify)(S.chmod)}get mkdir(){return(0,p.promisify)(S.mkdir)}get unlink(){return(0,p.promisify)(S.unlink)}get rmdir(){return(0,p.promisify)(S.rmdir)}get realpath(){return(0,p.promisify)(S.realpath)}async exists(F){try{return await e.Promises.access(F),!0}catch{return!1}}get readdir(){return w}get readDirsInDir(){return r}get writeFile(){return s}get rm(){return c}get move(){return R}get copy(){return O}}}),define(ue[143],de([0,1,32,4,14,17]),function(Y,e,S,k,p,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function t(C){const I=(0,k.dirname)(C);if(C===I)return C;const m=((0,k.basename)(C)||C).toLowerCase();try{const c=(0,P.readdirSync)(I).filter(b=>b.toLowerCase()===m);if(c.length===1){const b=t(I);if(b)return(0,k.join)(b,c[0])}else if(c.length>1){const b=c.indexOf(m);if(b>=0){const g=t(I);if(g)return(0,k.join)(g,c[b])}}}catch(u){}return null}e.realcaseSync=t;async function T(C){try{return await P.Promises.realpath(C)}catch(I){const m=f(C);return await P.Promises.access(m,S.constants.R_OK),m}}e.realpath=T;function h(C){try{return S.realpathSync(C)}catch(I){const m=f(C);return S.accessSync(m,S.constants.R_OK),m}}e.realpathSync=h;function f(C){return(0,p.rtrim)((0,k.normalize)(C),k.sep)}}),define(ue[144],de([0,1,92]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function k(T,h,f,C=1){let I=!1;return new Promise(m=>{const u=setTimeout(()=>{if(!I)return I=!0,m(0)},f);p(T,h,C,c=>{if(!I)return I=!0,clearTimeout(u),m(c)})})}e.findFreePort=k;function p(T,h,f,C){if(h===0)return C(0);const I=new S.Socket;I.once("connect",()=>(t(I),p(T+f,h-1,f,C))),I.once("data",()=>{}),I.once("error",m=>(t(I),m.code!=="ECONNREFUSED"?p(T+f,h-1,f,C):C(T))),I.connect(T,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function P(T,h,f){let C=!1,I,m=1;const u=S.createServer({pauseOnConnect:!0});function c(b,g){C||(C=!0,u.removeAllListeners(),u.close(),I&&clearTimeout(I),g(b))}return new Promise(b=>{I=setTimeout(()=>{c(0,b)},f),u.on("listening",()=>{c(T,b)}),u.on("error",g=>{g&&(g.code==="EADDRINUSE"||g.code==="EACCES")&&m<h?(T++,m++,u.listen(T,"127.0.0.1")):c(0,b)}),u.on("close",()=>{c(0,b)}),u.listen(T,"127.0.0.1")})}e.findFreePortFaster=P;function t(T){try{T.removeAllListeners("connect"),T.removeAllListeners("error"),T.end(),T.destroy(),T.unref()}catch(h){console.error(h)}}}),define(ue[93],de([0,1,26,4,17]),function(Y,e,S,k,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const P=/^\d+$/,t=/^Microsoft.PowerShell_.*/,T=/^Microsoft.PowerShellPreview_.*/;var h;(function(a){a[a.x64=0]="x64",a[a.x86=1]="x86",a[a.ARM=2]="ARM"})(h||(h={}));let f;switch(process.arch){case"ia32":case"x32":f=1;break;case"arm":case"arm64":f=2;break;default:f=0;break}let C;process.env.PROCESSOR_ARCHITEW6432?C=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?C=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?C=1:C=0;class I{constructor(l,r,o){this.exePath=l,this.displayName=r,this.knownToExist=o}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await p.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function m({useAlternateBitness:a=!1}={}){return a?f===0?process.env["ProgramFiles(x86)"]||null:C===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function u({useAlternateBitness:a=!1,findPreview:l=!1}={}){const r=m({useAlternateBitness:a});if(!r)return null;const o=k.join(r,"PowerShell");if(!await p.SymlinkSupport.existsDirectory(o))return null;let i=-1,n=null;for(const y of await p.Promises.readdir(o)){let A=-1;if(l){const R=y.indexOf("-");if(R<0)continue;const O=y.substring(0,R);if(!P.test(O)||y.substring(R+1)!=="preview")continue;A=parseInt(O,10)}else{if(!P.test(y))continue;A=parseInt(y,10)}if(A<=i)continue;const E=k.join(o,y,"pwsh.exe");!await p.SymlinkSupport.existsFile(E)||(n=E,i=A)}if(!n)return null;const s=r.includes("x86")?" (x86)":"",d=l?" Preview":"";return new I(n,`PowerShell${d}${s}`,!0)}async function c({findPreview:a}={}){if(!process.env.LOCALAPPDATA)return null;const l=k.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await p.SymlinkSupport.existsDirectory(l))return null;const{pwshMsixDirRegex:r,pwshMsixName:o}=a?{pwshMsixDirRegex:T,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:t,pwshMsixName:"PowerShell (Store)"};for(const i of await p.Promises.readdir(l))if(r.test(i)){const n=k.join(l,i,"pwsh.exe");return new I(n,o)}return null}function b(){const a=k.join(S.homedir(),".dotnet","tools","pwsh.exe");return new I(a,".NET Core PowerShell Global Tool")}function g(){const a=k.join(process.env.windir,f===1&&C!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new I(a,"Windows PowerShell",!0)}async function*D(){let a=await u();a&&(yield a),a=await u({useAlternateBitness:!0}),a&&(yield a),a=await c(),a&&(yield a),a=b(),a&&(yield a),a=await u({findPreview:!0}),a&&(yield a),a=await c({findPreview:!0}),a&&(yield a),a=await u({useAlternateBitness:!0,findPreview:!0}),a&&(yield a),a=g(),a&&(yield a)}async function*w(){for await(const a of D())await a.exists()&&(yield a)}e.enumeratePowerShellInstallations=w;async function v(){for await(const a of w())return a;return null}e.getFirstAvailablePowerShellInstallation=v}),define(ue[94],de([0,1,41,10]),function(Y,e,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function p(t){return new Promise((T,h)=>{let f;const C=new Map;function I(u,c,b,g,D){const w=C.get(c);if(u===t||w){const v={name:m(b),cmd:b,pid:u,ppid:c,load:g,mem:D};C.set(u,v),u===t&&(f=v),w&&(w.children||(w.children=[]),w.children.push(v),w.children.length>1&&(w.children=w.children.sort((a,l)=>a.pid-l.pid)))}}function m(u){const c=/--vscode-window-kind=shared-process/,b=/--vscode-window-kind=issue-reporter/,g=/--vscode-window-kind=process-explorer/,D=/--utility-sub-type=network/,w=/--crashes-directory/,v=/\\pipe\\winpty-control/,a=/conhost\.exe/,l=/--type=([a-zA-Z-]+)/;if(w.exec(u))return"electron-crash-reporter";if(v.exec(u))return"winpty-process";if(a.exec(u))return"console-window-host (Windows internal process)";let r=l.exec(u);if(r&&r.length===2)return r[1]==="renderer"?c.exec(u)?"shared-process":b.exec(u)?"issue-reporter":g.exec(u)?"process-explorer":"window":r[1]==="utility"&&D.exec(u)?"utility-network-service":r[1];const o=/[a-zA-Z-]+\.js/g;let i="";do r=o.exec(u),r&&(i+=r+" ");while(r);return i&&u.indexOf("node ")<0&&u.indexOf("node.exe")<0?`electron_node ${i}`:u}if(process.platform==="win32"){const u=c=>c.indexOf("\\\\?\\")===0||c.indexOf("\\??\\")===0?c.substr(4):c.indexOf('"\\\\?\\')===0||c.indexOf('"\\??\\')===0?'"'+c.substr(5):c;new Promise((c,b)=>{Y(["windows-process-tree"],c,b)}).then(c=>{c.getProcessList(t,b=>{c.getProcessCpuUsage(b,g=>{const D=new Map;g.forEach(w=>{const v=u(w.commandLine||"");D.set(w.pid,{name:m(v),cmd:v,pid:w.pid,ppid:w.ppid,load:w.cpu||0,mem:w.memory||0})}),f=D.get(t),f?(D.forEach(w=>{const v=D.get(w.ppid);v&&(v.children||(v.children=[]),v.children.push(w))}),D.forEach(w=>{w.children&&(w.children=w.children.sort((v,a)=>v.pid-a.pid))}),T(f)):h(new Error(`Root process ${t} not found`))})},c.ProcessDataFlag.CommandLine|c.ProcessDataFlag.Memory)})}else{let u=function(){let c=[f];const b=[];for(;c.length;){const D=c.shift();D&&(b.push(D.pid),D.children&&(c=c.concat(D.children)))}let g=JSON.stringify(k.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",Y).fsPath);g+=" "+b.join(" "),(0,S.exec)(g,{},(D,w,v)=>{if(D||v)h(D||new Error(v.toString()));else{const a=w.toString().split(`
`);for(let l=0;l<b.length;l++){const r=C.get(b[l]);r.load=parseFloat(a[l])}if(!f){h(new Error(`Root process ${t} not found`));return}T(f)}})};(0,S.exec)("which ps",{},(c,b,g)=>{if(c||g)if(process.platform!=="linux")h(c||new Error(g.toString()));else{const D=JSON.stringify(k.FileAccess.asFileUri("vs/base/node/ps.sh",Y).fsPath);(0,S.exec)(D,{},(w,v,a)=>{w||a?h(w||new Error(a.toString())):(P(v,I),u())})}else{const D=b.toString().trim(),w="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,S.exec)(`${D} ${w}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(v,a,l)=>{v||l&&!l.includes("screen size is bogus")?h(v||new Error(l.toString())):(P(a,I),process.platform==="linux"?u():f?T(f):h(new Error(`Root process ${t} not found`)))})}})}})}e.listProcesses=p;function P(t,T){const h=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,f=t.toString().split(`
`);for(const C of f){const I=h.exec(C.trim());I&&I.length===6&&T(parseInt(I[1]),parseInt(I[2]),I[5],parseFloat(I[3]),parseFloat(I[4]))}}}),define(ue[145],de([0,1,32,24,31,3,88,4,2,17]),function(Y,e,S,k,p,P,t,T,h,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.CHANGE_BUFFER_DELAY=e.watchFolder=e.watchFile=void 0;function C(c,b,g){return m({path:c,isDirectory:!1},b,g)}e.watchFile=C;function I(c,b,g){return m({path:c,isDirectory:!0},b,g)}e.watchFolder=I,e.CHANGE_BUFFER_DELAY=100;function m(c,b,g){if(h.isMacintosh&&(0,p.isEqualOrParent)(c.path,"/Volumes/"))return g(`Refusing to watch ${c.path} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),P.Disposable.None;const D=(0,T.basename)(c.path),w=new Map;let v=!1,a=[(0,P.toDisposable)(()=>{w.forEach(l=>(0,P.dispose)(l)),w.clear()})];try{const l=(0,S.watch)(c.path);a.push((0,P.toDisposable)(()=>{l.removeAllListeners(),l.close()}));const r=new Set;c.isDirectory&&f.Promises.readdir(c.path).then(o=>o.forEach(i=>r.add(i))),l.on("error",(o,i)=>{v||g(`Failed to watch ${c.path} for changes using fs.watch() (${o}, ${i})`)}),l.on("change",(o,i)=>{if(v)return;let n="";if(i&&(n=i.toString(),h.isMacintosh&&(n=(0,t.normalizeNFC)(n))),!n||o!=="change"&&o!=="rename")return;const s=c.isDirectory?(0,T.join)(c.path,n):c.path;if(c.isDirectory)if(o==="rename"){const d=w.get(s);d&&(0,P.dispose)(d);const y=setTimeout(async()=>{w.delete(s);const A=await f.Promises.exists(s);if(v)return;let E;A?r.has(n)?E="changed":(E="added",r.add(n)):(r.delete(n),E="deleted"),b(E,s)},e.CHANGE_BUFFER_DELAY);w.set(s,(0,P.toDisposable)(()=>clearTimeout(y)))}else{let d;r.has(n)?d="changed":(d="added",r.add(n)),b(d,s)}else if(o==="rename"||n!==D){const d=setTimeout(async()=>{const y=await f.Promises.exists(s);v||(y?(b("changed",s),a=[m(c,b,g)]):b("deleted",s))},e.CHANGE_BUFFER_DELAY);(0,P.dispose)(a),a=[(0,P.toDisposable)(()=>clearTimeout(d))]}else b("changed",s)})}catch(l){f.Promises.exists(c.path).then(r=>{r&&!v&&g(`Failed to watch ${c.path} for changes using fs.watch() (${l.toString()})`)})}return(0,P.toDisposable)(()=>{v=!0,a=(0,P.dispose)(a)})}async function u(c,b,g,D=512){const w=await f.Promises.open(c,"r"),v=Buffer.allocUnsafe(D),a=new k.CancellationTokenSource(g);let l,r=!1;const o=C(c,async i=>{if(i==="changed"){if(r)return;r=!0;try{for(;!a.token.isCancellationRequested;){const{bytesRead:n}=await f.Promises.read(w,v,0,D,null);if(!n||a.token.isCancellationRequested)break;b(v.slice(0,n))}}catch(n){l=new Error(n),a.dispose(!0)}finally{r=!1}}},i=>{l=new Error(i),a.dispose(!0)});return new Promise((i,n)=>{a.token.onCancellationRequested(async()=>{o.dispose(),await f.Promises.close(w),l?n(l):i()})})}e.watchFileContents=u}),define(ue[35],de([0,1,20,13,18,24,52,12,6,3,54,14,11]),function(Y,e,S,k,p,P,t,T,h,f,C,I,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var u;(function(G){G[G.Promise=100]="Promise",G[G.PromiseCancel=101]="PromiseCancel",G[G.EventListen=102]="EventListen",G[G.EventDispose=103]="EventDispose"})(u=e.RequestType||(e.RequestType={}));function c(G){switch(G){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var b;(function(G){G[G.Initialize=200]="Initialize",G[G.PromiseSuccess=201]="PromiseSuccess",G[G.PromiseError=202]="PromiseError",G[G.PromiseErrorObj=203]="PromiseErrorObj",G[G.EventFire=204]="EventFire"})(b=e.ResponseType||(e.ResponseType={}));function g(G){switch(G){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var D;(function(G){G[G.Uninitialized=0]="Uninitialized",G[G.Idle=1]="Idle"})(D||(D={}));class w{constructor(H){this.buffer=H,this.pos=0}read(H){const q=this.buffer.slice(this.pos,this.pos+H);return this.pos+=q.byteLength,q}}class v{constructor(){this.buffers=[]}get buffer(){return p.VSBuffer.concat(this.buffers)}write(H){this.buffers.push(H)}}var a;(function(G){G[G.Undefined=0]="Undefined",G[G.String=1]="String",G[G.Buffer=2]="Buffer",G[G.VSBuffer=3]="VSBuffer",G[G.Array=4]="Array",G[G.Object=5]="Object"})(a||(a={}));function l(G){const H=p.VSBuffer.alloc(4);return H.writeUInt32BE(G,0),H}function r(G){return G.read(4).readUInt32BE(0)}function o(G){const H=p.VSBuffer.alloc(1);return H.writeUInt8(G,0),H}const i={Undefined:o(a.Undefined),String:o(a.String),Buffer:o(a.Buffer),VSBuffer:o(a.VSBuffer),Array:o(a.Array),Object:o(a.Object)},n=typeof Buffer!="undefined";function s(G,H){if(typeof H=="undefined")G.write(i.Undefined);else if(typeof H=="string"){const q=p.VSBuffer.fromString(H);G.write(i.String),G.write(l(q.byteLength)),G.write(q)}else if(n&&Buffer.isBuffer(H)){const q=p.VSBuffer.wrap(H);G.write(i.Buffer),G.write(l(q.byteLength)),G.write(q)}else if(H instanceof p.VSBuffer)G.write(i.VSBuffer),G.write(l(H.byteLength)),G.write(H);else if(Array.isArray(H)){G.write(i.Array),G.write(l(H.length));for(const q of H)s(G,q)}else{const q=p.VSBuffer.fromString(JSON.stringify(H));G.write(i.Object),G.write(l(q.byteLength)),G.write(q)}}function d(G){switch(G.read(1).readUInt8(0)){case a.Undefined:return;case a.String:return G.read(r(G)).toString();case a.Buffer:return G.read(r(G)).buffer;case a.VSBuffer:return G.read(r(G));case a.Array:{const q=r(G),z=[];for(let B=0;B<q;B++)z.push(d(G));return z}case a.Object:return JSON.parse(G.read(r(G)).toString())}}class y{constructor(H,q,z=null,B=1e3){this.protocol=H,this.ctx=q,this.logger=z,this.timeoutDelay=B,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(W=>this.onRawMessage(W)),this.sendResponse({type:200})}registerChannel(H,q){this.channels.set(H,q),setTimeout(()=>this.flushPendingRequests(H),0)}sendResponse(H){switch(H.type){case 200:{const q=this.send([H.type]);this.logger&&this.logger.logOutgoing(q,0,1,g(H.type));return}case 201:case 202:case 204:case 203:{const q=this.send([H.type,H.id],H.data);this.logger&&this.logger.logOutgoing(q,H.id,1,g(H.type),H.data);return}}}send(H,q=void 0){const z=new v;return s(z,H),s(z,q),this.sendBuffer(z.buffer)}sendBuffer(H){try{return this.protocol.send(H),H.byteLength}catch(q){return 0}}onRawMessage(H){const q=new w(H),z=d(q),B=d(q),W=z[0];switch(W){case 100:return this.logger&&this.logger.logIncoming(H.byteLength,z[1],1,`${c(W)}: ${z[2]}.${z[3]}`,B),this.onPromise({type:W,id:z[1],channelName:z[2],name:z[3],arg:B});case 102:return this.logger&&this.logger.logIncoming(H.byteLength,z[1],1,`${c(W)}: ${z[2]}.${z[3]}`,B),this.onEventListen({type:W,id:z[1],channelName:z[2],name:z[3],arg:B});case 101:return this.logger&&this.logger.logIncoming(H.byteLength,z[1],1,`${c(W)}`),this.disposeActiveRequest({type:W,id:z[1]});case 103:return this.logger&&this.logger.logIncoming(H.byteLength,z[1],1,`${c(W)}`),this.disposeActiveRequest({type:W,id:z[1]})}}onPromise(H){const q=this.channels.get(H.channelName);if(!q){this.collectPendingRequest(H);return}const z=new P.CancellationTokenSource;let B;try{B=q.call(this.ctx,H.name,H.arg,z.token)}catch(oe){B=Promise.reject(oe)}const W=H.id;B.then(oe=>{this.sendResponse({id:W,data:oe,type:201}),this.activeRequests.delete(H.id)},oe=>{oe instanceof Error?this.sendResponse({id:W,data:{message:oe.message,name:oe.name,stack:oe.stack?oe.stack.split?oe.stack.split(`
`):oe.stack:void 0},type:202}):this.sendResponse({id:W,data:oe,type:203}),this.activeRequests.delete(H.id)});const ie=(0,f.toDisposable)(()=>z.cancel());this.activeRequests.set(H.id,ie)}onEventListen(H){const q=this.channels.get(H.channelName);if(!q){this.collectPendingRequest(H);return}const z=H.id,W=q.listen(this.ctx,H.name,H.arg)(ie=>this.sendResponse({id:z,data:ie,type:204}));this.activeRequests.set(H.id,W)}disposeActiveRequest(H){const q=this.activeRequests.get(H.id);q&&(q.dispose(),this.activeRequests.delete(H.id))}collectPendingRequest(H){let q=this.pendingRequests.get(H.channelName);q||(q=[],this.pendingRequests.set(H.channelName,q));const z=setTimeout(()=>{console.error(`Unknown channel: ${H.channelName}`),H.type===100&&this.sendResponse({id:H.id,data:{name:"Unknown channel",message:`Channel name '${H.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);q.push({request:H,timeoutTimer:z})}flushPendingRequests(H){const q=this.pendingRequests.get(H);if(q){for(const z of q)switch(clearTimeout(z.timeoutTimer),z.request.type){case 100:this.onPromise(z.request);break;case 102:this.onEventListen(z.request);break}this.pendingRequests.delete(H)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(H=>H.dispose()),this.activeRequests.clear()}}e.ChannelServer=y;var A;(function(G){G[G.LocalSide=0]="LocalSide",G[G.OtherSide=1]="OtherSide"})(A=e.RequestInitiator||(e.RequestInitiator={}));class E{constructor(H,q=null){this.protocol=H,this.isDisposed=!1,this.state=D.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new h.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(z=>this.onBuffer(z)),this.logger=q}getChannel(H){const q=this;return{call(z,B,W){return q.isDisposed?Promise.reject(T.canceled()):q.requestPromise(H,z,B,W)},listen(z,B){return q.isDisposed?Promise.reject(T.canceled()):q.requestEvent(H,z,B)}}}requestPromise(H,q,z,B=P.CancellationToken.None){const W=this.lastRequestId++,oe={id:W,type:100,channelName:H,name:q,arg:z};if(B.isCancellationRequested)return Promise.reject(T.canceled());let we;return new Promise((ae,ke)=>{if(B.isCancellationRequested)return ke(T.canceled());const De=()=>{const Ze=ge=>{switch(ge.type){case 201:this.handlers.delete(W),ae(ge.data);break;case 202:this.handlers.delete(W);const me=new Error(ge.data.message);me.stack=ge.data.stack,me.name=ge.data.name,ke(me);break;case 203:this.handlers.delete(W),ke(ge.data);break}};this.handlers.set(W,Ze),this.sendRequest(oe)};let Oe=null;this.state===D.Idle?De():(Oe=(0,k.createCancelablePromise)(Ze=>this.whenInitialized()),Oe.then(()=>{Oe=null,De()}));const Be=()=>{Oe?(Oe.cancel(),Oe=null):this.sendRequest({id:W,type:101}),ke(T.canceled())},Xe=B.onCancellationRequested(Be);we=(0,f.combinedDisposable)((0,f.toDisposable)(Be),Xe),this.activeRequests.add(we)}).finally(()=>{this.activeRequests.delete(we)})}requestEvent(H,q,z){const B=this.lastRequestId++,ie={id:B,type:102,channelName:H,name:q,arg:z};let oe=null;const we=new h.Emitter({onFirstListenerAdd:()=>{oe=(0,k.createCancelablePromise)(ae=>this.whenInitialized()),oe.then(()=>{oe=null,this.activeRequests.add(we),this.sendRequest(ie)})},onLastListenerRemove:()=>{oe?(oe.cancel(),oe=null):(this.activeRequests.delete(we),this.sendRequest({id:B,type:103}))}}),se=ae=>we.fire(ae.data);return this.handlers.set(B,se),we.event}sendRequest(H){switch(H.type){case 100:case 102:{const q=this.send([H.type,H.id,H.channelName,H.name],H.arg);this.logger&&this.logger.logOutgoing(q,H.id,0,`${c(H.type)}: ${H.channelName}.${H.name}`,H.arg);return}case 101:case 103:{const q=this.send([H.type,H.id]);this.logger&&this.logger.logOutgoing(q,H.id,0,c(H.type));return}}}send(H,q=void 0){const z=new v;return s(z,H),s(z,q),this.sendBuffer(z.buffer)}sendBuffer(H){try{return this.protocol.send(H),H.byteLength}catch(q){return 0}}onBuffer(H){const q=new w(H),z=d(q),B=d(q),W=z[0];switch(W){case 200:return this.logger&&this.logger.logIncoming(H.byteLength,0,0,g(W)),this.onResponse({type:z[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(H.byteLength,z[1],0,g(W),B),this.onResponse({type:z[0],id:z[1],data:B})}}onResponse(H){if(H.type===200){this.state=D.Idle,this._onDidInitialize.fire();return}const q=this.handlers.get(H.id);q&&q(H)}get onDidInitializePromise(){return h.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===D.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(H=>H.dispose()),this.activeRequests.clear()}}Ne([t.memoize],E.prototype,"onDidInitializePromise",null),e.ChannelClient=E;class R{constructor(H){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new h.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new h.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,H(({protocol:q,onDidClientDisconnect:z})=>{h.Event.once(q.onMessage)(W=>{const ie=new w(W),oe=d(ie),we=new y(q,oe),se=new E(q);this.channels.forEach((ke,De)=>we.registerChannel(De,ke));const ae={channelServer:we,channelClient:se,ctx:oe};this._connections.add(ae),this._onDidAddConnection.fire(ae),z(()=>{we.dispose(),se.dispose(),this._connections.delete(ae),this._onDidRemoveConnection.fire(ae)})})})}get connections(){const H=[];return this._connections.forEach(q=>H.push(q)),H}getChannel(H,q){const z=this;return{call(B,W,ie){let oe;if((0,m.isFunction)(q)){let se=(0,S.getRandomElement)(z.connections.filter(q));oe=se?Promise.resolve(se):h.Event.toPromise(h.Event.filter(z.onDidAddConnection,q))}else oe=q.routeCall(z,B,W);const we=oe.then(se=>se.channelClient.getChannel(H));return K(we).call(B,W,ie)},listen(B,W){if((0,m.isFunction)(q))return z.getMulticastEvent(H,q,B,W);const ie=q.routeEvent(z,B,W).then(oe=>oe.channelClient.getChannel(H));return K(ie).listen(B,W)}}}getMulticastEvent(H,q,z,B){const W=this;let ie=new f.DisposableStore;const oe=new h.Emitter({onFirstListenerAdd:()=>{ie=new f.DisposableStore;const we=new h.EventMultiplexer,se=new Map,ae=De=>{const Be=De.channelClient.getChannel(H).listen(z,B),Xe=we.add(Be);se.set(De,Xe)},ke=De=>{const Oe=se.get(De);!Oe||(Oe.dispose(),se.delete(De))};W.connections.filter(q).forEach(ae),h.Event.filter(W.onDidAddConnection,q)(ae,void 0,ie),W.onDidRemoveConnection(ke,void 0,ie),we.event(oe.fire,oe,ie),ie.add(we)},onLastListenerRemove:()=>{ie.dispose()}});return oe.event}registerChannel(H,q){this.channels.set(H,q),this._connections.forEach(z=>{z.channelServer.registerChannel(H,q)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=R;class O{constructor(H,q,z=null){const B=new v;s(B,q),H.send(B.buffer),this.channelClient=new E(H,z),this.channelServer=new y(H,q,z)}getChannel(H){return this.channelClient.getChannel(H)}registerChannel(H,q){this.channelServer.registerChannel(H,q)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=O;function K(G){return{call(H,q,z){return G.then(B=>B.call(H,q,z))},listen(H,q){const z=new h.Relay;return G.then(B=>z.input=B.listen(H,q)),z.event}}}e.getDelayedChannel=K;function te(G){let H=!1;return{call(q,z,B){return H?G.call(q,z,B):(0,k.timeout)(0).then(()=>H=!0).then(()=>G.call(q,z,B))},listen(q,z){if(H)return G.listen(q,z);const B=new h.Relay;return(0,k.timeout)(0).then(()=>H=!0).then(()=>B.input=G.listen(q,z)),B.event}}}e.getNextTickChannel=te;class j{constructor(H){this.fn=H}routeCall(H){return this.route(H)}routeEvent(H){return this.route(H)}async route(H){for(const q of H.connections)if(await Promise.resolve(this.fn(q.ctx)))return Promise.resolve(q);return await h.Event.toPromise(H.onDidAddConnection),await this.route(H)}}e.StaticRouter=j;var _;(function(G){function H(W,ie){const oe=W,we=ie&&ie.disableMarshalling,se=new Map;for(const ae in oe)z(ae)&&se.set(ae,h.Event.buffer(oe[ae],!0));return new class{listen(ae,ke,De){const Oe=se.get(ke);if(Oe)return Oe;if(B(ke)){const Be=oe[ke];if(typeof Be=="function")return Be.call(oe,De)}throw new Error(`Event not found: ${ke}`)}call(ae,ke,De){const Oe=oe[ke];if(typeof Oe=="function"){if(!we&&Array.isArray(De))for(let Be=0;Be<De.length;Be++)De[Be]=(0,C.revive)(De[Be]);return Oe.apply(oe,De)}throw new Error(`Method not found: ${ke}`)}}}G.fromService=H;function q(W,ie){const oe=ie&&ie.disableMarshalling;return new Proxy({},{get(we,se){if(typeof se=="string")return ie?.properties?.has(se)?ie.properties.get(se):B(se)?function(ae){return W.listen(se,ae)}:z(se)?W.listen(se):async function(...ae){let ke;ie&&!(0,m.isUndefinedOrNull)(ie.context)?ke=[ie.context,...ae]:ke=ae;const De=await W.call(se,ke);return oe?De:(0,C.revive)(De)};throw new Error(`Property not found: ${String(se)}`)}})}G.toService=q;function z(W){return W[0]==="o"&&W[1]==="n"&&I.isUpperAsciiLetter(W.charCodeAt(2))}function B(W){return/^onDynamic/.test(W)&&I.isUpperAsciiLetter(W.charCodeAt(9))}})(_=e.ProxyChannel||(e.ProxyChannel={}));const U=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function F(G){if(Array.isArray(G))return G;if(G&&typeof G=="object"&&typeof G.toString=="function"){let H=G.toString();if(H!=="[object Object]")return H}return G}function M(G){return Array.isArray(G)?G.map(F):F(G)}function V(G,H,q,z,B,W,ie){ie=M(ie);const oe=U[B],we=oe[z%oe.length];let se=[`%c[${G}]%c[${String(H).padStart(7," ")}]%c[len: ${String(q).padStart(5," ")}]%c${String(z).padStart(5," ")} - ${W}`,"color: darkgreen","color: grey","color: grey",`color: ${we}`];/\($/.test(W)?(se=se.concat(ie),se.push(")")):se.push(ie),console.log.apply(console,se)}e.logWithColors=V;class ee{constructor(H,q){this._outgoingPrefix=H,this._incomingPrefix=q,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(H,q,z,B,W){this._totalOutgoing+=H,V(this._outgoingPrefix,this._totalOutgoing,H,q,z,B,W)}logIncoming(H,q,z,B,W){this._totalIncoming+=H,V(this._incomingPrefix,this._totalIncoming,H,q,z,B,W)}}e.IPCLogger=ee}),define(ue[95],de([0,1,18,6,3,35]),function(Y,e,S,k,p,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=void 0;var t;(function(r){r[r.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",r[r.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(t=e.SocketCloseEventType||(e.SocketCloseEventType={}));let T=null;function h(){return T||(T=S.VSBuffer.alloc(0)),T}class f{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(o){this._chunks.push(o),this._totalLength+=o.byteLength}read(o){return this._read(o,!0)}peek(o){return this._read(o,!1)}_read(o,i){if(o===0)return h();if(o>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===o){const y=this._chunks[0];return i&&(this._chunks.shift(),this._totalLength-=o),y}if(this._chunks[0].byteLength>o){const y=this._chunks[0].slice(0,o);return i&&(this._chunks[0]=this._chunks[0].slice(o),this._totalLength-=o),y}let n=S.VSBuffer.alloc(o),s=0,d=0;for(;o>0;){const y=this._chunks[d];if(y.byteLength>o){const A=y.slice(0,o);n.set(A,s),s+=o,i&&(this._chunks[d]=y.slice(o),this._totalLength-=o),o-=o}else n.set(y,s),s+=y.byteLength,i?(this._chunks.shift(),this._totalLength-=y.byteLength):d++,o-=y.byteLength}return n}}e.ChunkStream=f;var C;(function(r){r[r.None=0]="None",r[r.Regular=1]="Regular",r[r.Control=2]="Control",r[r.Ack=3]="Ack",r[r.KeepAlive=4]="KeepAlive",r[r.Disconnect=5]="Disconnect",r[r.ReplayRequest=6]="ReplayRequest"})(C||(C={}));var I;(function(r){r[r.HeaderLength=13]="HeaderLength",r[r.AcknowledgeTime=2e3]="AcknowledgeTime",r[r.AcknowledgeTimeoutTime=2e4]="AcknowledgeTimeoutTime",r[r.KeepAliveTime=5e3]="KeepAliveTime",r[r.KeepAliveTimeoutTime=2e4]="KeepAliveTimeoutTime",r[r.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",r[r.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(I=e.ProtocolConstants||(e.ProtocolConstants={}));class m{constructor(o,i,n,s){this.type=o,this.id=i,this.ack=n,this.data=s,this.writtenTime=0}get size(){return this.data.byteLength}}class u extends p.Disposable{constructor(o){super();this._onMessage=this._register(new k.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=o,this._isDisposed=!1,this._incomingData=new f,this._register(this._socket.onData(i=>this.acceptChunk(i))),this.lastReadTime=Date.now()}acceptChunk(o){if(!(!o||o.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(o);this._incomingData.byteLength>=this._state.readLen;){const i=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=i.readUInt32BE(9),this._state.messageType=i.readUInt8(0),this._state.id=i.readUInt32BE(1),this._state.ack=i.readUInt32BE(5);else{const n=this._state.messageType,s=this._state.id,d=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._onMessage.fire(new m(n,s,d,i)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class c{constructor(o){this._isDisposed=!1,this._socket=o,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch(o){}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}write(o){if(this._isDisposed)return;o.writtenTime=Date.now(),this.lastWriteTime=Date.now();const i=S.VSBuffer.alloc(13);i.writeUInt8(o.type,0),i.writeUInt32BE(o.id,1),i.writeUInt32BE(o.ack,5),i.writeUInt32BE(o.data.byteLength,9),this._writeSoon(i,o.data)}_bufferAdd(o,i){const n=this._totalLength===0;return this._data.push(o,i),this._totalLength+=o.byteLength+i.byteLength,n}_bufferTake(){const o=S.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,o}_writeSoon(o,i){this._bufferAdd(o,i)&&setTimeout(()=>{this._writeNow()})}_writeNow(){this._totalLength!==0&&this._socket.write(this._bufferTake())}}class b extends p.Disposable{constructor(o){super();this._onMessage=new k.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new k.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=o,this._socketWriter=this._register(new c(this._socket)),this._socketReader=this._register(new u(this._socket)),this._register(this._socketReader.onMessage(i=>{i.type===1&&this._onMessage.fire(i.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(o){this._socketWriter.write(new m(1,0,0,o))}}e.Protocol=b;class g extends P.IPCClient{constructor(o,i,n=null){super(o,i,n);this.protocol=o}static fromSocket(o,i){return new g(new b(o),i)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const o=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),o.end()}}e.Client=g;class D{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new k.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(o){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(o):this._emitter.fire(o):this._bufferedMessages.push(o)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=D;class w{constructor(o){this.data=o,this.next=null}}class v{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let o=[],i=0,n=this._first;for(;n;)o[i++]=n.data,n=n.next;return o}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(o){const i=new w(o);if(!this._first){this._first=i,this._last=i;return}this._last.next=i,this._last=i}}class a{constructor(){this.lastRuns=[];const o=Date.now();for(let i=0;i<a._HISTORY_LENGTH;i++)this.lastRuns[i]=o-1e3*i;setInterval(()=>{for(let i=a._HISTORY_LENGTH;i>=1;i--)this.lastRuns[i]=this.lastRuns[i-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return a._INSTANCE||(a._INSTANCE=new a),a._INSTANCE}load(){const o=Date.now(),i=(1+a._HISTORY_LENGTH)*1e3;let n=0;for(let s=0;s<a._HISTORY_LENGTH;s++)o-this.lastRuns[s]<=i&&n++;return 1-n/a._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}a._HISTORY_LENGTH=10,a._INSTANCE=null;class l{constructor(o,i=null,n=a.getInstance()){this._onControlMessage=new D,this.onControlMessage=this._onControlMessage.event,this._onMessage=new D,this.onMessage=this._onMessage.event,this._onDidDispose=new D,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new D,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new D,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=n,this._isReconnecting=!1,this._outgoingUnackMsg=new v,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._outgoingKeepAliveTimeout=null,this._incomingKeepAliveTimeout=null,this._lastReplayRequestTime=0,this._socketDisposables=[],this._socket=o,this._socketWriter=new c(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new u(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(s=>this._receiveMessage(s))),this._socketDisposables.push(this._socket.onClose(s=>this._onSocketClose.fire(s))),i&&this._socketReader.acceptChunk(i),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._outgoingKeepAliveTimeout&&(clearTimeout(this._outgoingKeepAliveTimeout),this._outgoingKeepAliveTimeout=null),this._incomingKeepAliveTimeout&&(clearTimeout(this._incomingKeepAliveTimeout),this._incomingKeepAliveTimeout=null),this._socketDisposables=(0,p.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const o=new m(5,0,0,h());this._socketWriter.write(o),this._socketWriter.flush()}_sendKeepAliveCheck(){if(this._outgoingKeepAliveTimeout)return;const o=Date.now()-this._socketWriter.lastWriteTime;if(o>=5e3){const i=new m(4,0,0,h());this._socketWriter.write(i),this._sendKeepAliveCheck();return}this._outgoingKeepAliveTimeout=setTimeout(()=>{this._outgoingKeepAliveTimeout=null,this._sendKeepAliveCheck()},5e3-o+5)}_recvKeepAliveCheck(){if(this._incomingKeepAliveTimeout)return;const o=Date.now()-this._socketReader.lastReadTime;if(o>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._incomingKeepAliveTimeout=setTimeout(()=>{this._incomingKeepAliveTimeout=null,this._recvKeepAliveCheck()},Math.max(2e4-o,0)+5)}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(o,i){this._isReconnecting=!0,this._socketDisposables=(0,p.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._socket=o,this._socketWriter=new c(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new u(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(n=>this._receiveMessage(n))),this._socketDisposables.push(this._socket.onClose(n=>this._onSocketClose.fire(n))),this._socketReader.acceptChunk(i)}endAcceptReconnection(){this._isReconnecting=!1;const o=this._outgoingUnackMsg.toArray();for(let i=0,n=o.length;i<n;i++)this._socketWriter.write(o[i]);this._recvAckCheck(),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(o){if(o.ack>this._outgoingAckId){this._outgoingAckId=o.ack;do{const i=this._outgoingUnackMsg.peek();if(i&&i.id<=o.ack)this._outgoingUnackMsg.pop();else break}while(!0)}if(o.type===1){if(o.id>this._incomingMsgId)if(o.id!==this._incomingMsgId+1){const i=Date.now();i-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=i,this._socketWriter.write(new m(6,0,0,h())))}else this._incomingMsgId=o.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(o.data)}else if(o.type===2)this._onControlMessage.fire(o.data);else if(o.type===5)this._onDidDispose.fire();else if(o.type===6){const i=this._outgoingUnackMsg.toArray();for(let n=0,s=i.length;n<s;n++)this._socketWriter.write(i[n]);this._recvAckCheck()}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(o){const i=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const n=new m(1,i,this._incomingAckId,o);this._outgoingUnackMsg.push(n),this._isReconnecting||(this._socketWriter.write(n),this._recvAckCheck())}sendControl(o){const i=new m(2,0,0,o);this._socketWriter.write(i)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const o=Date.now()-this._incomingMsgLastTime;if(o>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-o+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const o=this._outgoingUnackMsg.peek(),i=Date.now()-o.writtenTime;if(i>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},Math.max(2e4-i,0)+5)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const o=new m(3,0,this._incomingAckId,h());this._socketWriter.write(o)}}e.PersistentProtocol=l}),define(ue[146],de([0,1,13,6,3,11]),function(Y,e,S,k,p,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var t;(function(I){I[I.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(t=e.StorageHint||(e.StorageHint={}));function T(I){const m=I;return m?.changed instanceof Map||m?.deleted instanceof Set}e.isStorageItemsChangeEvent=T;var h;(function(I){I[I.None=0]="None",I[I.Initialized=1]="Initialized",I[I.Closed=2]="Closed"})(h||(h={}));class f extends p.Disposable{constructor(m,u=Object.create(null)){super();this.database=m,this.options=u,this._onDidChangeStorage=this._register(new k.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=h.None,this.cache=new Map,this.flushDelayer=new S.ThrottledDelayer(f.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(m=>this.onDidChangeItemsExternal(m)))}onDidChangeItemsExternal(m){m.changed?.forEach((u,c)=>this.accept(c,u)),m.deleted?.forEach(u=>this.accept(u,void 0))}accept(m,u){if(this.state===h.Closed)return;let c=!1;(0,P.isUndefinedOrNull)(u)?c=this.cache.delete(m):this.cache.get(m)!==u&&(this.cache.set(m,u),c=!0),c&&this._onDidChangeStorage.fire(m)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===h.None&&(this.state=h.Initialized,this.options.hint!==t.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(m,u){const c=this.cache.get(m);return(0,P.isUndefinedOrNull)(c)?u:c}getBoolean(m,u){const c=this.get(m);return(0,P.isUndefinedOrNull)(c)?u:c==="true"}getNumber(m,u){const c=this.get(m);return(0,P.isUndefinedOrNull)(c)?u:parseInt(c,10)}async set(m,u){if(this.state===h.Closed)return;if((0,P.isUndefinedOrNull)(u))return this.delete(m);const c=String(u);if(this.cache.get(m)!==c)return this.cache.set(m,c),this.pendingInserts.set(m,c),this.pendingDeletes.delete(m),this._onDidChangeStorage.fire(m),this.doFlush()}async delete(m){if(!(this.state===h.Closed||!this.cache.delete(m)))return this.pendingDeletes.has(m)||this.pendingDeletes.add(m),this.pendingInserts.delete(m),this._onDidChangeStorage.fire(m),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=h.Closed;try{await this.doFlush(0)}catch(m){}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const m={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(m).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(m){if(!!this.hasPending)return this.doFlush(m)}async doFlush(m){return this.flushDelayer.trigger(()=>this.flushPending(),m)}async whenFlushed(){if(!!this.hasPending)return new Promise(m=>this.whenFlushedCallbacks.push(m))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=f,f.DEFAULT_FLUSH_DELAY=100;class C{constructor(){this.onDidChangeItemsExternal=k.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(m){m.insert&&m.insert.forEach((u,c)=>this.items.set(c,u)),m.delete&&m.delete.forEach(u=>this.items.delete(u))}async close(){}}e.InMemoryStorageDatabase=C}),define(ue[96],de([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class S{constructor(p,P){this.lineNumber=p,this.column=P}with(p=this.lineNumber,P=this.column){return p===this.lineNumber&&P===this.column?this:new S(p,P)}delta(p=0,P=0){return this.with(this.lineNumber+p,this.column+P)}equals(p){return S.equals(this,p)}static equals(p,P){return!p&&!P?!0:!!p&&!!P&&p.lineNumber===P.lineNumber&&p.column===P.column}isBefore(p){return S.isBefore(this,p)}static isBefore(p,P){return p.lineNumber<P.lineNumber?!0:P.lineNumber<p.lineNumber?!1:p.column<P.column}isBeforeOrEqual(p){return S.isBeforeOrEqual(this,p)}static isBeforeOrEqual(p,P){return p.lineNumber<P.lineNumber?!0:P.lineNumber<p.lineNumber?!1:p.column<=P.column}static compare(p,P){let t=p.lineNumber|0,T=P.lineNumber|0;if(t===T){let h=p.column|0,f=P.column|0;return h-f}return t-T}clone(){return new S(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(p){return new S(p.lineNumber,p.column)}static isIPosition(p){return p&&typeof p.lineNumber=="number"&&typeof p.column=="number"}}e.Position=S}),define(ue[67],de([0,1,96]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class k{constructor(P,t,T,h){P>T||P===T&&t>h?(this.startLineNumber=T,this.startColumn=h,this.endLineNumber=P,this.endColumn=t):(this.startLineNumber=P,this.startColumn=t,this.endLineNumber=T,this.endColumn=h)}isEmpty(){return k.isEmpty(this)}static isEmpty(P){return P.startLineNumber===P.endLineNumber&&P.startColumn===P.endColumn}containsPosition(P){return k.containsPosition(this,P)}static containsPosition(P,t){return!(t.lineNumber<P.startLineNumber||t.lineNumber>P.endLineNumber||t.lineNumber===P.startLineNumber&&t.column<P.startColumn||t.lineNumber===P.endLineNumber&&t.column>P.endColumn)}static strictContainsPosition(P,t){return!(t.lineNumber<P.startLineNumber||t.lineNumber>P.endLineNumber||t.lineNumber===P.startLineNumber&&t.column<=P.startColumn||t.lineNumber===P.endLineNumber&&t.column>=P.endColumn)}containsRange(P){return k.containsRange(this,P)}static containsRange(P,t){return!(t.startLineNumber<P.startLineNumber||t.endLineNumber<P.startLineNumber||t.startLineNumber>P.endLineNumber||t.endLineNumber>P.endLineNumber||t.startLineNumber===P.startLineNumber&&t.startColumn<P.startColumn||t.endLineNumber===P.endLineNumber&&t.endColumn>P.endColumn)}strictContainsRange(P){return k.strictContainsRange(this,P)}static strictContainsRange(P,t){return!(t.startLineNumber<P.startLineNumber||t.endLineNumber<P.startLineNumber||t.startLineNumber>P.endLineNumber||t.endLineNumber>P.endLineNumber||t.startLineNumber===P.startLineNumber&&t.startColumn<=P.startColumn||t.endLineNumber===P.endLineNumber&&t.endColumn>=P.endColumn)}plusRange(P){return k.plusRange(this,P)}static plusRange(P,t){let T,h,f,C;return t.startLineNumber<P.startLineNumber?(T=t.startLineNumber,h=t.startColumn):t.startLineNumber===P.startLineNumber?(T=t.startLineNumber,h=Math.min(t.startColumn,P.startColumn)):(T=P.startLineNumber,h=P.startColumn),t.endLineNumber>P.endLineNumber?(f=t.endLineNumber,C=t.endColumn):t.endLineNumber===P.endLineNumber?(f=t.endLineNumber,C=Math.max(t.endColumn,P.endColumn)):(f=P.endLineNumber,C=P.endColumn),new k(T,h,f,C)}intersectRanges(P){return k.intersectRanges(this,P)}static intersectRanges(P,t){let T=P.startLineNumber,h=P.startColumn,f=P.endLineNumber,C=P.endColumn,I=t.startLineNumber,m=t.startColumn,u=t.endLineNumber,c=t.endColumn;return T<I?(T=I,h=m):T===I&&(h=Math.max(h,m)),f>u?(f=u,C=c):f===u&&(C=Math.min(C,c)),T>f||T===f&&h>C?null:new k(T,h,f,C)}equalsRange(P){return k.equalsRange(this,P)}static equalsRange(P,t){return!!P&&!!t&&P.startLineNumber===t.startLineNumber&&P.startColumn===t.startColumn&&P.endLineNumber===t.endLineNumber&&P.endColumn===t.endColumn}getEndPosition(){return k.getEndPosition(this)}static getEndPosition(P){return new S.Position(P.endLineNumber,P.endColumn)}getStartPosition(){return k.getStartPosition(this)}static getStartPosition(P){return new S.Position(P.startLineNumber,P.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(P,t){return new k(this.startLineNumber,this.startColumn,P,t)}setStartPosition(P,t){return new k(P,t,this.endLineNumber,this.endColumn)}collapseToStart(){return k.collapseToStart(this)}static collapseToStart(P){return new k(P.startLineNumber,P.startColumn,P.startLineNumber,P.startColumn)}static fromPositions(P,t=P){return new k(P.lineNumber,P.column,t.lineNumber,t.column)}static lift(P){return P?new k(P.startLineNumber,P.startColumn,P.endLineNumber,P.endColumn):null}static isIRange(P){return P&&typeof P.startLineNumber=="number"&&typeof P.startColumn=="number"&&typeof P.endLineNumber=="number"&&typeof P.endColumn=="number"}static areIntersectingOrTouching(P,t){return!(P.endLineNumber<t.startLineNumber||P.endLineNumber===t.startLineNumber&&P.endColumn<t.startColumn||t.endLineNumber<P.startLineNumber||t.endLineNumber===P.startLineNumber&&t.endColumn<P.startColumn)}static areIntersecting(P,t){return!(P.endLineNumber<t.startLineNumber||P.endLineNumber===t.startLineNumber&&P.endColumn<=t.startColumn||t.endLineNumber<P.startLineNumber||t.endLineNumber===P.startLineNumber&&t.endColumn<=P.startColumn)}static compareRangesUsingStarts(P,t){if(P&&t){const f=P.startLineNumber|0,C=t.startLineNumber|0;if(f===C){const I=P.startColumn|0,m=t.startColumn|0;if(I===m){const u=P.endLineNumber|0,c=t.endLineNumber|0;if(u===c){const b=P.endColumn|0,g=t.endColumn|0;return b-g}return u-c}return I-m}return f-C}return(P?1:0)-(t?1:0)}static compareRangesUsingEnds(P,t){return P.endLineNumber===t.endLineNumber?P.endColumn===t.endColumn?P.startLineNumber===t.startLineNumber?P.startColumn-t.startColumn:P.startLineNumber-t.startLineNumber:P.endColumn-t.endColumn:P.endLineNumber-t.endLineNumber}static spansMultipleLines(P){return P.endLineNumber>P.startLineNumber}}e.Range=k}),define(ue[147],de([0,1,63,4]),function(Y,e,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function p(P,t,T,h){if(Array.isArray(P)){let f=0;for(const C of P){const I=p(C,t,T,h);if(I===10)return I;I>f&&(f=I)}return f}else{if(typeof P=="string")return h?P==="*"?5:P===T?10:0:0;if(P){const{language:f,pattern:C,scheme:I,hasAccessToAllModels:m}=P;if(!h&&!m)return 0;let u=0;if(I)if(I===t.scheme)u=10;else if(I==="*")u=5;else return 0;if(f)if(f===T)u=10;else if(f==="*")u=Math.max(u,5);else return 0;if(C){let c;if(typeof C=="string"?c=C:c={...C,base:(0,k.normalize)(C.base)},c===t.fsPath||(0,S.match)(c,t.fsPath))u=10;else return 0}return u}else return 0}}e.score=p}),define(ue[148],de([0,1,6,3]),function(Y,e,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistryImpl=void 0;class p{constructor(){this._map=new Map,this._promises=new Map,this._onDidChange=new S.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(t){this._onDidChange.fire({changedLanguages:t,changedColorMap:!1})}register(t,T){return this._map.set(t,T),this.fire([t]),(0,k.toDisposable)(()=>{this._map.get(t)===T&&(this._map.delete(t),this.fire([t]))})}registerPromise(t,T){let h=null,f=!1;return this._promises.set(t,T.then(C=>{this._promises.delete(t),!(f||!C)&&(h=this.register(t,C))})),(0,k.toDisposable)(()=>{f=!0,h&&h.dispose()})}getPromise(t){const T=this.get(t);if(T)return Promise.resolve(T);const h=this._promises.get(t);return h?h.then(f=>this.get(t)):null}get(t){return this._map.get(t)||null}setColorMap(t){this._colorMap=t,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistryImpl=p}),define(ue[149],de([8,9]),function(Y,e){return Y.create("vs/base/common/date",e)}),define(ue[150],de([0,1,149]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const k=60,p=k*60,P=p*24,t=P*7,T=P*30,h=P*365;function f(I,m){typeof I!="number"&&(I=I.getTime());const u=Math.round((new Date().getTime()-I)/1e3);if(u<-30)return(0,S.localize)(0,null,f(new Date().getTime()+u*1e3,!1));if(u<30)return(0,S.localize)(1,null);let c;return u<k?(c=u,m?c===1?(0,S.localize)(2,null,c):(0,S.localize)(3,null,c):c===1?(0,S.localize)(4,null,c):(0,S.localize)(5,null,c)):u<p?(c=Math.floor(u/k),m?c===1?(0,S.localize)(6,null,c):(0,S.localize)(7,null,c):c===1?(0,S.localize)(8,null,c):(0,S.localize)(9,null,c)):u<P?(c=Math.floor(u/p),m?c===1?(0,S.localize)(10,null,c):(0,S.localize)(11,null,c):c===1?(0,S.localize)(12,null,c):(0,S.localize)(13,null,c)):u<t?(c=Math.floor(u/P),m?c===1?(0,S.localize)(14,null,c):(0,S.localize)(15,null,c):c===1?(0,S.localize)(16,null,c):(0,S.localize)(17,null,c)):u<T?(c=Math.floor(u/t),m?c===1?(0,S.localize)(18,null,c):(0,S.localize)(19,null,c):c===1?(0,S.localize)(20,null,c):(0,S.localize)(21,null,c)):u<h?(c=Math.floor(u/T),m?c===1?(0,S.localize)(22,null,c):(0,S.localize)(23,null,c):c===1?(0,S.localize)(24,null,c):(0,S.localize)(25,null,c)):(c=Math.floor(u/h),m?c===1?(0,S.localize)(26,null,c):(0,S.localize)(27,null,c):c===1?(0,S.localize)(28,null,c):(0,S.localize)(29,null,c))}e.fromNow=f;function C(I){return I.getFullYear()+"-"+String(I.getMonth()+1).padStart(2,"0")+"-"+String(I.getDate()).padStart(2,"0")+"T"+String(I.getHours()).padStart(2,"0")+":"+String(I.getMinutes()).padStart(2,"0")+":"+String(I.getSeconds()).padStart(2,"0")+"."+(I.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=C}),define(ue[151],de([8,9]),function(Y,e){return Y.create("vs/base/common/errorMessage",e)}),define(ue[37],de([0,1,20,11,151]),function(Y,e,S,k,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function P(f,C){return C&&(f.stack||f.stacktrace)?p.localize(0,null,T(f),t(f.stack)||t(f.stacktrace)):T(f)}function t(f){return Array.isArray(f)?f.join(`
`):f}function T(f){return typeof f.code=="string"&&typeof f.errno=="number"&&typeof f.syscall=="string"?p.localize(1,null,f.message):f.message||p.localize(2,null)}function h(f=null,C=!1){if(!f)return p.localize(3,null);if(Array.isArray(f)){const I=S.coalesce(f),m=h(I[0],C);return I.length>1?p.localize(4,null,m,I.length):m}if(k.isString(f))return f;if(f.detail){const I=f.detail;if(I.error)return P(I.error,C);if(I.exception)return P(I.exception,C)}return f.stack?P(f,C):f.message?f.message:p.localize(5,null)}e.toErrorMessage=h}),define(ue[152],de([8,9]),function(Y,e){return Y.create("vs/base/common/jsonErrorMessages",e)}),define(ue[97],de([0,1,152]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function k(p){switch(p){case 1:return(0,S.localize)(0,null);case 2:return(0,S.localize)(1,null);case 3:return(0,S.localize)(2,null);case 4:return(0,S.localize)(3,null);case 5:return(0,S.localize)(4,null);case 6:return(0,S.localize)(5,null);case 7:return(0,S.localize)(6,null);case 8:return(0,S.localize)(7,null);case 9:return(0,S.localize)(8,null);default:return""}}e.getParseErrorMessage=k}),define(ue[153],de([8,9]),function(Y,e){return Y.create("vs/base/node/processes",e)}),define(ue[68],de([0,1,41,31,10,21,4,2,23,86,11,139,17,153]),function(Y,e,S,k,p,P,t,T,h,f,C,I,m,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.removeDangerousEnvVariables=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return f.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return f.TerminateResponseCode}});function c(r){switch(r){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function b(r,o){if(T.isWindows)try{const i={stdio:["pipe","pipe","ignore"]};o&&(i.cwd=o);const n=S.execFile("taskkill",["/T","/F","/PID",r.pid.toString()],i);return new Promise(s=>{n.once("error",d=>{s({success:!1,error:d})}),n.once("exit",(d,y)=>{s(d===0?{success:!0}:{success:!1,code:d!==null?d:1})})})}catch(i){return Promise.resolve({success:!1,error:i,code:i.status?c(i.status):1})}else if(T.isLinux||T.isMacintosh)try{const i=p.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",Y).fsPath;return new Promise(n=>{S.execFile(i,[r.pid.toString()],{encoding:"utf8",shell:!0},(s,d,y)=>{n(s?{success:!1,error:s}:{success:!0})})})}catch(i){return Promise.resolve({success:!1,error:i})}else r.kill("SIGKILL");return Promise.resolve({success:!0})}function g(r){!r||(delete r.DEBUG,T.isMacintosh&&delete r.DYLD_LIBRARY_PATH,T.isLinux&&delete r.LD_PRELOAD)}e.removeDangerousEnvVariables=g;function D(r=h.env){return r.comspec||"cmd.exe"}e.getWindowsShell=D;class w{constructor(o,i,n,s){if(i!==void 0&&n!==void 0&&s!==void 0)this.cmd=o,this.args=i,this.shell=n,this.options=s;else{const d=o;this.cmd=d.command,this.shell=d.isShellCommand,this.args=d.args.slice(0),this.options=d.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const d=Object.create(null);Object.keys(h.env).forEach(y=>{d[y]=h.env[y]}),Object.keys(this.options.env).forEach(y=>{d[y]=this.options.env[y]}),this.options.env=d}}getSanitizedCommand(){let o=this.cmd.toLowerCase();const i=o.lastIndexOf(t.sep);return i!==-1&&(o=o.substring(i+1)),w.WellKnowCommands[o]?o:"other"}start(o){return T.isWindows&&(this.options&&this.options.cwd&&k.isUNC(this.options.cwd)||!this.options&&k.isUNC(h.cwd()))?Promise.reject(new Error(u.localize(0,null))):this.useExec().then(i=>{let n,s;const d=new Promise((y,A)=>{n=y,s=A});if(i){let y=this.cmd;this.args&&(y=y+" "+this.args.join(" ")),this.childProcess=S.exec(y,this.options,(A,E,R)=>{this.childProcess=null;const O=A;O&&O.killed?s({killed:this.terminateRequested,stdout:E.toString(),stderr:R.toString()}):this.handleExec(n,o,A,E,R)})}else{let y=null;const A=E=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(E,n,o,s);const R={terminated:this.terminateRequested};C.isNumber(E)&&(R.cmdCode=E),n(R)};if(this.shell&&T.isWindows){const E=P.deepClone(this.options);E.windowsVerbatimArguments=!0,E.detached=!1;let R=!1,O=!1;const K=[];let te=this.ensureQuotes(this.cmd);K.push(te.value),R=te.quoted,this.args&&this.args.forEach(_=>{te=this.ensureQuotes(_),K.push(te.value),O=O&&te.quoted});const j=["/s","/c"];R?O?j.push('"'+K.join(" ")+'"'):K.length>1?j.push('"'+K[0]+'" '+K.slice(1).join(" ")):j.push('"'+K[0]+'"'):j.push(K.join(" ")),y=S.spawn(D(),j,E)}else this.cmd&&(y=S.spawn(this.cmd,this.args,this.options));y&&(this.childProcess=y,this.childProcessPromise=Promise.resolve(y),this.pidResolve&&(this.pidResolve(C.isNumber(y.pid)?y.pid:-1),this.pidResolve=void 0),y.on("error",E=>{this.childProcess=null,s({terminated:this.terminateRequested,error:E})}),y.pid&&(this.childProcess.on("close",A),this.handleSpawn(y,n,o,s,!0)))}return d})}handleClose(o,i,n,s){}ensureQuotes(o){return w.regexp.test(o)?{value:'"'+o+'"',quoted:!0}:{value:o,quoted:o.length>0&&o[0]==='"'&&o[o.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(o=>o.pid,o=>-1):new Promise(o=>{this.pidResolve=o})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(o=>(this.terminateRequested=!0,b(o,this.options.cwd).then(i=>(i.success&&(this.childProcess=null),i))),o=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(o=>{if(!this.shell||!T.isWindows)return o(!1);const i=S.spawn(D(),["/s","/c"]);i.on("error",n=>o(!0)),i.on("exit",n=>o(!1))})}}e.AbstractProcess=w,w.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},w.regexp=/^[^"].* .*[^"]/;class v extends w{constructor(o,i,n,s){super(o,i,n,s);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(o,i,n,s,d){[s,d].forEach((y,A)=>{const E=new I.LineDecoder;E.write(y).forEach(K=>{i({line:K,source:A===0?0:1})});const O=E.end();O&&i({line:O,source:A===0?0:1})}),o({terminated:this.terminateRequested,error:n})}handleSpawn(o,i,n,s,d){const y=new I.LineDecoder,A=new I.LineDecoder;o.stdout.on("data",E=>{y.write(E).forEach(O=>n({line:O,source:0}))}),o.stderr.on("data",E=>{A.write(E).forEach(O=>n({line:O,source:1}))}),this.stdoutLineDecoder=y,this.stderrLineDecoder=A}handleClose(o,i,n,s){const d=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;d&&n({line:d,source:0});const y=this.stderrLineDecoder?this.stderrLineDecoder.end():null;y&&n({line:y,source:1})}}e.LineProcess=v;function a(r){let o=[],i=!1;const n=function(s){if(i){o.push(s);return}(!r.send(s,y=>{if(y&&console.error(y),i=!1,o.length>0){const A=o.slice(0);o=[],A.forEach(E=>n(E))}})||T.isWindows)&&(i=!0)};return{send:n}}e.createQueuedSender=a;var l;(function(r){async function o(i,n,s){if(t.isAbsolute(i))return i;if(n===void 0&&(n=h.cwd()),t.dirname(i)!=="."||(s===void 0&&C.isString(h.env.PATH)&&(s=h.env.PATH.split(t.delimiter)),s===void 0||s.length===0))return t.join(n,i);async function y(A){if(await m.Promises.exists(A)){let E;try{E=await m.Promises.stat(A)}catch(R){R.message.startsWith("EACCES")&&(E=await m.Promises.lstat(A))}return E?!E.isDirectory():!1}return!1}for(let A of s){let E;if(t.isAbsolute(A)?E=t.join(A,i):E=t.join(n,A,i),await y(E))return E;let R=E+".com";if(await y(R)||(R=E+".exe",await y(R)))return R}return t.join(n,i)}r.findExecutable=o})(l=e.win32||(e.win32={}))}),define(ue[154],de([0,1,26,2,93,68]),function(Y,e,S,k,p,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function t(u,c){return u===1?k.isWindows?I():P.getWindowsShell(c):f(u,c)}e.getSystemShell=t;function T(u,c){return u===1?k.isWindows?m(c):P.getWindowsShell(c):f(u,c)}e.getSystemShellSync=T;let h=null;function f(u,c){if(k.isLinux&&u===2||k.isMacintosh&&u===3)return"/bin/bash";if(!h){let b;if(k.isWindows)b="/bin/bash";else{if(b=c.SHELL,!b)try{b=(0,S.userInfo)().shell}catch(g){}b||(b="sh"),b==="/bin/false"&&(b="/bin/bash")}h=b}return h}let C=null;async function I(){return C||(C=(await(0,p.getFirstAvailablePowerShellInstallation)()).exePath),C}function m(u){if(C)return C;const c=k.isWindows&&parseFloat((0,S.release)())>=10,b=u.hasOwnProperty("PROCESSOR_ARCHITEW6432"),g=`${u.windir}\\${b?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return c?g:P.getWindowsShell(u)}}),define(ue[69],de([0,1,41,13,18,24,89,12,6,3,21,68,35]),function(Y,e,S,k,p,P,t,T,h,f,C,I,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class u extends m.ChannelServer{constructor(g){super({send:D=>{try{process.send&&process.send(D.buffer.toString("base64"))}catch(w){}},onMessage:h.Event.fromNodeEventEmitter(process,"message",D=>p.VSBuffer.wrap(Buffer.from(D,"base64")))},g);process.once("disconnect",()=>this.dispose())}}e.Server=u;class c{constructor(g,D){this.modulePath=g,this.options=D,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new h.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const w=D&&D.timeout?D.timeout:6e4;this.disposeDelayer=new k.Delayer(w),this.child=null,this._client=null}getChannel(g){const D=this;return{call(w,v,a){return D.requestPromise(g,w,v,a)},listen(w,v){return D.requestEvent(g,w,v)}}}requestPromise(g,D,w,v=P.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(v.isCancellationRequested)return Promise.reject(T.canceled());this.disposeDelayer.cancel();const a=this.getCachedChannel(g),l=(0,k.createCancelablePromise)(i=>a.call(D,w,i)),r=v.onCancellationRequested(()=>l.cancel()),o=(0,f.toDisposable)(()=>l.cancel());return this.activeRequests.add(o),l.finally(()=>{r.dispose(),this.activeRequests.delete(o),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),l}requestEvent(g,D,w){if(!this.disposeDelayer)return h.Event.None;this.disposeDelayer.cancel();let v;const a=new h.Emitter({onFirstListenerAdd:()=>{v=this.getCachedChannel(g).listen(D,w)(a.fire,a),this.activeRequests.add(v)},onLastListenerRemove:()=>{this.activeRequests.delete(v),v.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return a.event}get client(){if(!this._client){const g=this.options&&this.options.args?this.options.args:[],D=Object.create(null);D.env={...(0,C.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(D.env={...D.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(D.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(D.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(D.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),D.execArgv===void 0&&(D.execArgv=process.execArgv.filter(n=>!/^--inspect(-brk)?=/.test(n))),(0,I.removeDangerousEnvVariables)(D.env),this.child=(0,S.fork)(this.modulePath,g,D);const w=new h.Emitter;h.Event.fromNodeEventEmitter(this.child,"message",n=>n)(n=>{if((0,t.isRemoteConsoleLog)(n)){(0,t.log)(n,`IPC Library: ${this.options.serverName}`);return}w.fire(p.VSBuffer.wrap(Buffer.from(n,"base64")))});const a=this.options.useQueue?(0,I.createQueuedSender)(this.child):this.child,l=n=>this.child&&this.child.connected&&a.send(n.buffer.toString("base64")),r=w.event,o={send:l,onMessage:r};this._client=new m.ChannelClient(o);const i=()=>this.disposeClient();process.once("exit",i),this.child.on("error",n=>console.warn('IPC "'+this.options.serverName+'" errored with '+n)),this.child.on("exit",(n,s)=>{process.removeListener("exit",i),this.activeRequests.forEach(d=>(0,f.dispose)(d)),this.activeRequests.clear(),n!==0&&s!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+n+" and signal "+s),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:n,signal:s})})}return this._client}getCachedChannel(g){let D=this.channels.get(g);return D||(D=this.client.getChannel(g),this.channels.set(g,D)),D}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=c}),define(ue[155],de([8,9]),function(Y,e){return Y.create("vs/base/node/zip",e)}),define(ue[156],de([8,9]),function(Y,e){return Y.create("vs/editor/common/view/editorColorRegistry",e)}),define(ue[157],de([8,9]),function(Y,e){return Y.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ue[158],de([8,9]),function(Y,e){return Y.create("vs/platform/environment/node/argv",e)}),define(ue[159],de([8,9]),function(Y,e){return Y.create("vs/platform/environment/node/argvHelper",e)}),define(ue[160],de([8,9]),function(Y,e){return Y.create("vs/platform/environment/node/shellEnv",e)}),define(ue[161],de([8,9]),function(Y,e){return Y.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(ue[162],de([8,9]),function(Y,e){return Y.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ue[163],de([8,9]),function(Y,e){return Y.create("vs/platform/extensionManagement/common/extensionManagementCLIService",e)}),define(ue[164],de([8,9]),function(Y,e){return Y.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(ue[165],de([8,9]),function(Y,e){return Y.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(ue[166],de([8,9]),function(Y,e){return Y.create("vs/platform/extensionManagement/node/extensionsScanner",e)}),define(ue[167],de([8,9]),function(Y,e){return Y.create("vs/platform/extensions/common/extensionValidator",e)}),define(ue[168],de([8,9]),function(Y,e){return Y.create("vs/platform/files/common/fileService",e)}),define(ue[169],de([8,9]),function(Y,e){return Y.create("vs/platform/files/common/files",e)}),define(ue[170],de([8,9]),function(Y,e){return Y.create("vs/platform/files/common/io",e)}),define(ue[171],de([8,9]),function(Y,e){return Y.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ue[172],de([8,9]),function(Y,e){return Y.create("vs/platform/markers/common/markers",e)}),define(ue[173],de([8,9]),function(Y,e){return Y.create("vs/platform/request/common/request",e)}),define(ue[174],de([8,9]),function(Y,e){return Y.create("vs/platform/telemetry/common/telemetryService",e)}),define(ue[175],de([8,9]),function(Y,e){return Y.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(ue[176],de([8,9]),function(Y,e){return Y.create("vs/platform/theme/common/colorRegistry",e)}),define(ue[177],de([8,9]),function(Y,e){return Y.create("vs/platform/theme/common/tokenClassificationRegistry",e)}),define(ue[178],de([8,9]),function(Y,e){return Y.create("vs/platform/workspaces/common/workspaces",e)}),define(ue[179],de([8,9]),function(Y,e){return Y.create("vs/server/remoteAgentEnvironmentImpl",e)}),define(ue[180],de([8,9]),function(Y,e){return Y.create("vs/server/serverEnvironmentService",e)}),define(ue[181],de([8,9]),function(Y,e){return Y.create("vs/workbench/common/editor",e)}),define(ue[182],de([8,9]),function(Y,e){return Y.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(ue[183],de([8,9]),function(Y,e){return Y.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(ue[184],de([8,9]),function(Y,e){return Y.create("vs/workbench/services/extensions/node/extensionPoints",e)}),define(ue[185],de([8,9]),function(Y,e){return Y.create("vs/workbench/services/themes/common/colorThemeData",e)}),define(ue[186],de([8,9]),function(Y,e){return Y.create("vs/workbench/services/themes/common/colorThemeSchema",e)}),define(ue[187],de([8,9]),function(Y,e){return Y.create("vs/workbench/services/themes/common/themeConfiguration",e)}),define(ue[188],de([8,9]),function(Y,e){return Y.create("vs/workbench/services/themes/common/themeExtensionPoints",e)}),define(ue[189],de([0,1,6,3]),function(Y,e,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class p{constructor(){this._onCloseEmitter=new S.Emitter,this._onReloadEmitter=new S.Emitter,this._onTerminateEmitter=new S.Emitter,this._onAttachEmitter=new S.Emitter}call(T,h,f){switch(h){case"close":return Promise.resolve(this._onCloseEmitter.fire({sessionId:f[0]}));case"reload":return Promise.resolve(this._onReloadEmitter.fire({sessionId:f[0]}));case"terminate":return Promise.resolve(this._onTerminateEmitter.fire({sessionId:f[0]}));case"attach":return Promise.resolve(this._onAttachEmitter.fire({sessionId:f[0],port:f[1],subId:f[2]}))}throw new Error("Method not implemented.")}listen(T,h,f){switch(h){case"close":return this._onCloseEmitter.event;case"reload":return this._onReloadEmitter.event;case"terminate":return this._onTerminateEmitter.event;case"attach":return this._onAttachEmitter.event}throw new Error("Method not implemented.")}}e.ExtensionHostDebugBroadcastChannel=p,p.ChannelName="extensionhostdebugservice";class P extends k.Disposable{constructor(T){super();this.channel=T}reload(T){this.channel.call("reload",[T])}get onReload(){return this.channel.listen("reload")}close(T){this.channel.call("close",[T])}get onClose(){return this.channel.listen("close")}attachSession(T,h,f){this.channel.call("attach",[T,h,f])}get onAttachSession(){return this.channel.listen("attach")}terminateSession(T,h){this.channel.call("terminate",[T,h])}get onTerminateSession(){return this.channel.listen("terminate")}openExtensionDevelopmentHostWindow(T,h){return this.channel.call("openExtensionDevelopmentHostWindow",[T,h])}}e.ExtensionHostDebugChannelClient=P}),define(ue[190],de([0,1,5]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadServiceChannelClient=e.DownloadServiceChannel=void 0;class k{constructor(t){this.service=t}listen(t,T,h){throw new Error("Invalid listen")}call(t,T,h){switch(T){case"download":return this.service.download(S.URI.revive(h[0]),S.URI.revive(h[1]))}throw new Error("Invalid call")}}e.DownloadServiceChannel=k;class p{constructor(t,T){this.channel=t,this.getUriTransformer=T}async download(t,T){const h=this.getUriTransformer();h&&(t=h.transformOutgoingURI(t),T=h.transformOutgoingURI(T)),await this.channel.call("download",[t,T])}}e.DownloadServiceChannelClient=p}),define(ue[191],de([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorResolution=e.EditorActivation=void 0;var S;(function(t){t[t.ACTIVATE=1]="ACTIVATE",t[t.RESTORE=2]="RESTORE",t[t.PRESERVE=3]="PRESERVE"})(S=e.EditorActivation||(e.EditorActivation={}));var k;(function(t){t[t.PICK=0]="PICK",t[t.DISABLED=1]="DISABLED",t[t.EXCLUSIVE_ONLY=2]="EXCLUSIVE_ONLY"})(k=e.EditorResolution||(e.EditorResolution={}));var p;(function(t){t[t.API=0]="API",t[t.USER=1]="USER"})(p=e.EditorOpenContext||(e.EditorOpenContext={}));var P;(function(t){t[t.Center=0]="Center",t[t.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",t[t.NearTop=2]="NearTop",t[t.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(P=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(ue[98],de([0,1,150,52,10,4,23,19,5]),function(Y,e,S,k,p,P,t,T,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class f{constructor(b,g,D){this._args=b,this.paths=g,this.productService=D}get appRoot(){return(0,P.dirname)(p.FileAccess.asFileUri("",Y).fsPath)}get userHome(){return h.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return h.URI.file((0,P.join)(this.userDataPath,"User"))}get tmpDir(){return h.URI.file(this.paths.tmpDir)}get cacheHome(){return h.URI.file(this.userDataPath)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,T.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,T.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const b=(0,S.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,P.join)(this.userDataPath,"logs",b)}return this.args.logsPath}get userDataSyncLogResource(){return h.URI.file((0,P.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,T.joinPath)(h.URI.file((0,P.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return h.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return h.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,T.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,T.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const b=t.env.VSCODE_PORTABLE;return b?h.URI.file((0,P.join)(b,"argv.json")):(0,T.joinPath)(this.appSettingsHome,"argv.json")}get snippetsHome(){return(0,T.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return h.URI.file((0,P.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,P.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const b=this.args["builtin-extensions-dir"];return b?(0,P.resolve)(b):(0,P.normalize)((0,P.join)(p.FileAccess.asFileUri("",Y).fsPath,"..","extensions"))}get extensionsDownloadPath(){const b=this.args["extensions-download-dir"];return b?(0,P.resolve)(b):(0,P.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const b=this.args["extensions-dir"];if(b)return(0,P.resolve)(b);const g=t.env.VSCODE_EXTENSIONS;if(g)return g;const D=t.env.VSCODE_PORTABLE;return D?(0,P.join)(D,"extensions"):(0,T.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const b=this.args.extensionDevelopmentPath;if(Array.isArray(b))return b.map(g=>/^[^:/?#]+?:\/\//.test(g)?h.URI.parse(g):h.URI.file((0,P.normalize)(g)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(b=>b==="ui"||b==="workspace"||b==="web"?b:"workspace")}get extensionTestsLocationURI(){const b=this.args.extensionTestsPath;if(b)return/^[^:/?#]+?:\/\//.test(b)?h.URI.parse(b):h.URI.file((0,P.normalize)(b))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const b=this.args["disable-extension"];if(b){if(typeof b=="string")return[b];if(Array.isArray(b)&&b.length>0)return b}return!1}get debugExtensionHost(){return C(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!t.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,T.joinPath)(h.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return h.URI.file((0,P.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}Ne([k.memoize],f.prototype,"appRoot",null),Ne([k.memoize],f.prototype,"userHome",null),Ne([k.memoize],f.prototype,"userDataPath",null),Ne([k.memoize],f.prototype,"appSettingsHome",null),Ne([k.memoize],f.prototype,"tmpDir",null),Ne([k.memoize],f.prototype,"cacheHome",null),Ne([k.memoize],f.prototype,"userRoamingDataHome",null),Ne([k.memoize],f.prototype,"settingsResource",null),Ne([k.memoize],f.prototype,"userDataSyncHome",null),Ne([k.memoize],f.prototype,"userDataSyncLogResource",null),Ne([k.memoize],f.prototype,"sync",null),Ne([k.memoize],f.prototype,"machineSettingsResource",null),Ne([k.memoize],f.prototype,"globalStorageHome",null),Ne([k.memoize],f.prototype,"workspaceStorageHome",null),Ne([k.memoize],f.prototype,"keybindingsResource",null),Ne([k.memoize],f.prototype,"keyboardLayoutResource",null),Ne([k.memoize],f.prototype,"argvResource",null),Ne([k.memoize],f.prototype,"snippetsHome",null),Ne([k.memoize],f.prototype,"isExtensionDevelopment",null),Ne([k.memoize],f.prototype,"untitledWorkspacesHome",null),Ne([k.memoize],f.prototype,"installSourcePath",null),Ne([k.memoize],f.prototype,"builtinExtensionsPath",null),Ne([k.memoize],f.prototype,"extensionsPath",null),Ne([k.memoize],f.prototype,"extensionDevelopmentLocationURI",null),Ne([k.memoize],f.prototype,"extensionDevelopmentKind",null),Ne([k.memoize],f.prototype,"extensionTestsLocationURI",null),Ne([k.memoize],f.prototype,"debugExtensionHost",null),Ne([k.memoize],f.prototype,"serviceMachineIdResource",null),Ne([k.memoize],f.prototype,"telemetryLogResource",null),Ne([k.memoize],f.prototype,"disableWorkspaceTrust",null),e.AbstractNativeEnvironmentService=f;function C(c,b){return u(c["inspect-extensions"],c["inspect-brk-extensions"],5870,b,c.debugId,c.extensionEnvironment)}e.parseExtensionHostPort=C;function I(c,b){return u(c["inspect-search"],c["inspect-brk-search"],5876,b,c.extensionEnvironment)}e.parseSearchPort=I;function m(c,b){return u(c["inspect-ptyhost"],c["inspect-brk-ptyhost"],5877,b,c.extensionEnvironment)}e.parsePtyHostPort=m;function u(c,b,g,D,w,v){const l=Number(b||c)||(D?null:g),r=l?Boolean(!!b):!1;let o;if(v)try{o=JSON.parse(v)}catch{}return{port:l,break:r,debugId:w,env:o}}}),define(ue[55],de([0,1,279,2,158]),function(Y,e,S,k,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const P={o:(0,p.localize)(0,null),e:(0,p.localize)(1,null),t:(0,p.localize)(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,p.localize)(3,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,p.localize)(4,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,p.localize)(5,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,p.localize)(6,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,p.localize)(7,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,p.localize)(8,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,p.localize)(9,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,p.localize)(10,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,p.localize)(11,null)},"extensions-dir":{type:"string",deprecates:"extensionHomePath",cat:"e",args:"dir",description:(0,p.localize)(12,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,p.localize)(13,null)},"show-versions":{type:"boolean",cat:"e",description:(0,p.localize)(14,null)},category:{type:"string",cat:"e",description:(0,p.localize)(15,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"extension-id[@version] | path-to-vsix",description:(0,p.localize)(16,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"extension-id",description:(0,p.localize)(17,null)},"enable-proposed-api":{type:"string[]",cat:"e",args:"extension-id",description:(0,p.localize)(18,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,p.localize)(19,null)},verbose:{type:"boolean",cat:"t",description:(0,p.localize)(20,null)},log:{type:"string",cat:"t",args:"level",description:(0,p.localize)(21,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,p.localize)(22,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,p.localize)(23,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:"disableExtensions",cat:"t",description:(0,p.localize)(24,null)},"disable-extension":{type:"string[]",cat:"t",args:"extension-id",description:(0,p.localize)(25,null)},sync:{type:"string",cat:"t",description:(0,p.localize)(26,null),args:["on","off"]},"inspect-extensions":{type:"string",deprecates:"debugPluginHost",args:"port",cat:"t",description:(0,p.localize)(27,null)},"inspect-brk-extensions":{type:"string",deprecates:"debugBrkPluginHost",args:"port",cat:"t",description:(0,p.localize)(28,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,p.localize)(29,null)},"ms-enable-electron-run-as-node":{type:"boolean"},"max-memory":{type:"string",cat:"t",description:(0,p.localize)(30,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,p.localize)(31,null)},remote:{type:"string"},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string"},"inspect-brk-ptyhost":{type:"string"},"inspect-search":{type:"string",deprecates:"debugSearch"},"inspect-brk-search":{type:"string",deprecates:"debugBrkSearch"},"export-default-configuration":{type:"string"},"install-source":{type:"string"},driver:{type:"string"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"driver-verbose":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},__sandbox:{type:"boolean"},logsPath:{type:"string"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string"},"inspect-brk":{type:"string"},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},_:{type:"string[]"}};const t={onUnknownOption:()=>{},onMultipleValues:()=>{}};function T(c,b,g=t){const D={},w=[],v=[];for(let o in b){const i=b[o];i.alias&&(D[o]=i.alias),i.type==="string"||i.type==="string[]"?(w.push(o),i.deprecates&&w.push(i.deprecates)):i.type==="boolean"&&(v.push(o),i.deprecates&&v.push(i.deprecates))}const a=S(c,{string:w,boolean:v,alias:D}),l={},r=a;l._=a._.map(o=>String(o)).filter(o=>o.length>0),delete r._;for(let o in b){const i=b[o];i.alias&&delete r[i.alias];let n=r[o];i.deprecates&&r.hasOwnProperty(i.deprecates)&&(n||(n=r[i.deprecates]),delete r[i.deprecates]),typeof n!="undefined"&&(i.type==="string[]"?n&&!Array.isArray(n)&&(n=[n]):i.type==="string"&&Array.isArray(n)&&(n=n.pop(),g.onMultipleValues(o,n)),l[o]=n),delete r[o]}for(let o in r)g.onUnknownOption(o);return l}e.parseArgs=T;function h(c,b){let g="";return b.args&&(Array.isArray(b.args)?g=` <${b.args.join("> <")}>`:g=` <${b.args}>`),b.alias?`-${b.alias} --${c}${g}`:`--${c}${g}`}function f(c,b){let g=0,D=[];for(const l in c){const r=c[l],o=h(l,r);g=Math.max(g,o.length),D.push([o,r.description])}let w=g+2+1;if(b-w<25)return D.reduce((l,r)=>l.concat([`  ${r[0]}`,`      ${r[1]}`]),[]);let v=b-w-1,a=[];for(const l of D){let r=l[0],o=I(l[1],v),i=C(w-r.length-2);a.push("  "+r+i+o[0]);for(let n=1;n<o.length;n++)a.push(C(w)+o[n])}return a}e.formatOptions=f;function C(c){return" ".repeat(c)}function I(c,b){let g=[];for(;c.length;){let D=c.length<b?c.length:c.lastIndexOf(" ",b),w=c.slice(0,D).trim();c=c.slice(D),g.push(w)}return g}function m(c,b,g,D,w){const v=process.stdout.isTTY&&process.stdout.columns||80,a=w?.noInputFiles!==!0?`[${(0,p.localize)(32,null)}...]`:"",l=[`${c} ${g}`];l.push(""),l.push(`${(0,p.localize)(33,null)}: ${b} [${(0,p.localize)(34,null)}]${a}`),l.push(""),w?.noPipe!==!0&&(k.isWindows?l.push((0,p.localize)(35,null,b)):l.push((0,p.localize)(36,null,b)),l.push(""));const r={};for(const o in D){const i=D[o];if(i.description&&i.cat){let n=r[i.cat];n||(r[i.cat]=n={}),n[o]=i}}for(let o in r){const i=o;let n=r[i];n&&(l.push(P[i]),l.push(...f(n,v)),l.push(""))}return l.join(`
`)}e.buildHelpMessage=m;function u(c,b){return`${c||(0,p.localize)(37,null)}
${b||(0,p.localize)(38,null)}
${process.arch}`}e.buildVersionMessage=u}),function(){"use strict";function Y(e,S,k,p){function P(T){const h=t(T),f=[h];return e.isAbsolute(h)||f.unshift(p),e.resolve(...f)}function t(T){const h=process.env.VSCODE_PORTABLE;if(h)return e.join(h,"user-data");let f=process.env.VSCODE_APPDATA;if(f)return e.join(f,k);const C=T["user-data-dir"];if(C)return C;switch(process.platform){case"win32":if(f=process.env.APPDATA,!f){const I=process.env.USERPROFILE;if(typeof I!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");f=e.join(I,"AppData","Roaming")}break;case"darwin":f=e.join(S.homedir(),"Library","Application Support");break;case"linux":f=process.env.XDG_CONFIG_HOME||e.join(S.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(f,k)}return{getUserDataPath:P}}if(typeof define=="function")define(ue[192],de([0,90,26,10,19,23]),function(e,S,k,p,P,t){const T=P.dirname(p.FileAccess.asFileUri("",e)),h=e.__$__nodeRequire(P.joinPath(T,"package.json").fsPath);return Y(S,k,h.name,t.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),S=require("path"),k=require("os");module.exports=Y(S,k,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ue[193],de([0,1,26,98,192]),function(Y,e,S,k,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class P extends k.AbstractNativeEnvironmentService{constructor(T,h){super(T,{homeDir:(0,S.homedir)(),tmpDir:(0,S.tmpdir)(),userDataDir:(0,p.getUserDataPath)(T)},h)}}e.NativeEnvironmentService=P}),define(ue[194],de([0,1,21]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;const k=/^%([\w\d.-]+)%$/i;function p(P,t){const T=h=>{if(typeof h!="string")return;const f=k.exec(h);if(!f)return;const C=t[f[1]]??h;return typeof C=="string"?C:typeof C.message=="string"?C.message:h};return(0,S.cloneAndChange)(P,T)}e.localizeManifest=p}),define(ue[70],de([0,1,167]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const k=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,p=/^-(\d{4})(\d{2})(\d{2})$/;function P(m){return m=m.trim(),m==="*"||k.test(m)}e.isValidVersionStr=P;function t(m){if(!P(m))return null;if(m=m.trim(),m==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let u=m.match(k);return u?{hasCaret:u[1]==="^",hasGreaterEquals:u[1]===">=",majorBase:u[2]==="x"?0:parseInt(u[2],10),majorMustEqual:u[2]!=="x",minorBase:u[4]==="x"?0:parseInt(u[4],10),minorMustEqual:u[4]!=="x",patchBase:u[6]==="x"?0:parseInt(u[6],10),patchMustEqual:u[6]!=="x",preRelease:u[8]||null}:null}e.parseVersion=t;function T(m){if(!m)return null;let u=m.majorBase,c=m.majorMustEqual,b=m.minorBase,g=m.minorMustEqual,D=m.patchBase,w=m.patchMustEqual;m.hasCaret&&(u===0||(g=!1),w=!1);let v=0;if(m.preRelease){const a=p.exec(m.preRelease);if(a){const[,l,r,o]=a;v=Date.UTC(Number(l),Number(r)-1,Number(o))}}return{majorBase:u,majorMustEqual:c,minorBase:b,minorMustEqual:g,patchBase:D,patchMustEqual:w,isMinimum:m.hasGreaterEquals,notBefore:v}}e.normalizeVersion=T;function h(m,u,c){let b;typeof m=="string"?b=T(t(m)):b=m;let g;u instanceof Date?g=u.getTime():typeof u=="string"&&(g=new Date(u).getTime());let D;if(typeof c=="string"?D=T(t(c)):D=c,!b||!D)return!1;let w=b.majorBase,v=b.minorBase,a=b.patchBase,l=D.majorBase,r=D.minorBase,o=D.patchBase,i=D.notBefore,n=D.majorMustEqual,s=D.minorMustEqual,d=D.patchMustEqual;return D.isMinimum?w>l?!0:w<l?!1:v>r?!0:v<r||g&&g<i?!1:a>=o:(w===1&&l===0&&(!n||!s||!d)&&(l=1,r=0,o=0,n=!0,s=!1,d=!1),w<l?!1:w>l?!n:v<r?!1:v>r?!s:a<o?!1:a>o?!d:!(g&&g<i))}e.isValidVersion=h;function f(m,u,c,b){return c.isBuiltin||typeof c.main=="undefined"?!0:I(m,u,c.engines.vscode,b)}e.isValidExtensionVersion=f;function C(m,u,c){return m==="*"||I(u,c,m)}e.isEngineValid=C;function I(m,u,c,b=[]){let g=T(t(c));if(!g)return b.push(S.localize(0,null,c)),!1;if(g.majorBase===0){if(!g.majorMustEqual||!g.minorMustEqual)return b.push(S.localize(1,null,c)),!1}else if(!g.majorMustEqual)return b.push(S.localize(2,null,c)),!1;return h(m,u,g)?!0:(b.push(S.localize(3,null,m,c)),!1)}}),define(ue[195],de([0,1,6,3,18,47,24]),function(Y,e,S,k,p,P,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProviderChannel=void 0;class T extends k.Disposable{constructor(f,C){super();this.provider=f,this.logService=C,this.sessionToWatcher=new Map,this.watchRequests=new Map}call(f,C,I){const m=this.getUriTransformer(f);switch(C){case"stat":return this.stat(m,I[0]);case"readdir":return this.readdir(m,I[0]);case"open":return this.open(m,I[0],I[1]);case"close":return this.close(I[0]);case"read":return this.read(I[0],I[1],I[2]);case"readFile":return this.readFile(m,I[0]);case"write":return this.write(I[0],I[1],I[2],I[3],I[4]);case"writeFile":return this.writeFile(m,I[0],I[1],I[2]);case"rename":return this.rename(m,I[0],I[1],I[2]);case"copy":return this.copy(m,I[0],I[1],I[2]);case"mkdir":return this.mkdir(m,I[0]);case"delete":return this.delete(m,I[0],I[1]);case"watch":return this.watch(m,I[0],I[1],I[2],I[3]);case"unwatch":return this.unwatch(I[0],I[1])}throw new Error(`IPC Command ${C} not found`)}listen(f,C,I){const m=this.getUriTransformer(f);switch(C){case"fileChange":return this.onFileChange(m,I[0]);case"readFileStream":return this.onReadFileStream(m,I[0],I[1])}throw new Error(`Unknown event ${C}`)}stat(f,C){const I=this.transformIncoming(f,C,!0);return this.provider.stat(I)}readdir(f,C){const I=this.transformIncoming(f,C);return this.provider.readdir(I)}async readFile(f,C){const I=this.transformIncoming(f,C,!0),m=await this.provider.readFile(I);return p.VSBuffer.wrap(m)}onReadFileStream(f,C,I){const m=this.transformIncoming(f,C,!0),u=new t.CancellationTokenSource,c=new S.Emitter({onLastListenerRemove:()=>{u.cancel()}}),b=this.provider.readFileStream(m,I,u.token);return(0,P.listenStream)(b,{onData:g=>c.fire(p.VSBuffer.wrap(g)),onError:g=>c.fire(g),onEnd:()=>{c.fire("end"),c.dispose(),u.dispose()}}),c.event}writeFile(f,C,I,m){const u=this.transformIncoming(f,C);return this.provider.writeFile(u,I.buffer,m)}open(f,C,I){const m=this.transformIncoming(f,C,!0);return this.provider.open(m,I)}close(f){return this.provider.close(f)}async read(f,C,I){const m=p.VSBuffer.alloc(I),u=0,c=await this.provider.read(f,C,m.buffer,u,I);return[m,c]}write(f,C,I,m,u){return this.provider.write(f,C,I.buffer,m,u)}mkdir(f,C){const I=this.transformIncoming(f,C);return this.provider.mkdir(I)}delete(f,C,I){const m=this.transformIncoming(f,C);return this.provider.delete(m,I)}rename(f,C,I,m){const u=this.transformIncoming(f,C),c=this.transformIncoming(f,I);return this.provider.rename(u,c,m)}copy(f,C,I,m){const u=this.transformIncoming(f,C),c=this.transformIncoming(f,I);return this.provider.copy(u,c,m)}onFileChange(f,C){const I=new S.Emitter({onFirstListenerAdd:()=>{this.sessionToWatcher.set(C,this.createSessionFileWatcher(f,I))},onLastListenerRemove:()=>{(0,k.dispose)(this.sessionToWatcher.get(C)),this.sessionToWatcher.delete(C)}});return I.event}async watch(f,C,I,m,u){const c=this.sessionToWatcher.get(C);if(c){const b=this.transformIncoming(f,m),g=c.watch(I,b,u);this.watchRequests.set(C+I,g)}}async unwatch(f,C){const I=f+C,m=this.watchRequests.get(I);m&&((0,k.dispose)(m),this.watchRequests.delete(I))}dispose(){super.dispose(),this.watchRequests.forEach(f=>(0,k.dispose)(f)),this.watchRequests.clear(),this.sessionToWatcher.forEach(f=>(0,k.dispose)(f)),this.sessionToWatcher.clear()}}e.AbstractDiskFileSystemProviderChannel=T}),define(ue[56],de([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class S{constructor(p,P=[],t=!1){this.ctor=p,this.staticArguments=P,this.supportsDelayedInstantiation=t}}e.SyncDescriptor=S}),define(ue[196],de([0,1,56]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const k=[];function p(t,T,h){T instanceof S.SyncDescriptor||(T=new S.SyncDescriptor(T,[],h)),k.push([t,T])}e.registerSingleton=p;function P(){return k}e.getSingletonServiceDescriptors=P}),define(ue[197],de([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class S{constructor(P){this.incoming=new Map,this.outgoing=new Map,this.data=P}}e.Node=S;class k{constructor(P){this._hashFn=P,this._nodes=new Map}roots(){const P=[];for(let t of this._nodes.values())t.outgoing.size===0&&P.push(t);return P}insertEdge(P,t){const T=this.lookupOrInsertNode(P),h=this.lookupOrInsertNode(t);T.outgoing.set(this._hashFn(t),h),h.incoming.set(this._hashFn(P),T)}removeNode(P){const t=this._hashFn(P);this._nodes.delete(t);for(let T of this._nodes.values())T.outgoing.delete(t),T.incoming.delete(t)}lookupOrInsertNode(P){const t=this._hashFn(P);let T=this._nodes.get(t);return T||(T=new S(P),this._nodes.set(t,T)),T}lookup(P){return this._nodes.get(this._hashFn(P))}isEmpty(){return this._nodes.size===0}toString(){let P=[];for(let[t,T]of this._nodes)P.push(`${t}, (incoming)[${[...T.incoming.keys()].join(", ")}], (outgoing)[${[...T.outgoing.keys()].join(",")}]`);return P.join(`
`)}findCycleSlow(){for(let[P,t]of this._nodes){const T=new Set([P]),h=this._findCycle(t,T);if(h)return h}}_findCycle(P,t){for(let[T,h]of P.outgoing){if(t.has(T))return[...t,T].join(" -> ");t.add(T);const f=this._findCycle(h,t);if(f)return f;t.delete(T)}}}e.Graph=k}),define(ue[7],de([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var S;(function(t){t.serviceIds=new Map,t.DI_TARGET="$di$target",t.DI_DEPENDENCIES="$di$dependencies";function T(h){return h[t.DI_DEPENDENCIES]||[]}t.getServiceDependencies=T})(S=e._util||(e._util={})),e.IInstantiationService=p("instantiationService");function k(t,T,h,f){T[S.DI_TARGET]===T?T[S.DI_DEPENDENCIES].push({id:t,index:h,optional:f}):(T[S.DI_DEPENDENCIES]=[{id:t,index:h,optional:f}],T[S.DI_TARGET]=T)}function p(t){if(S.serviceIds.has(t))return S.serviceIds.get(t);const T=function(h,f,C){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");k(T,h,C,!1)};return T.toString=()=>t,S.serviceIds.set(t,T),T}e.createDecorator=p;function P(t){return t}e.refineServiceDecorator=P}),define(ue[198],de([0,1,7]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=(0,S.createDecorator)("modelService");function k(p){return!p.isTooLargeForSyncing()&&!p.isForSimpleWidget}e.shouldSynchronizeModel=k}),define(ue[199],de([0,1,6,136,3,30,133,147,198]),function(Y,e,S,k,p,P,t,T,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRequestDelays=e.LanguageFeatureRegistry=void 0;function f(b){return typeof b=="string"?!1:Array.isArray(b)?b.every(f):!!b.exclusive}class C{constructor(){this._clock=0,this._entries=[],this._onDidChange=new S.Emitter}get onDidChange(){return this._onDidChange.event}register(g,D){let w={selector:g,provider:D,_score:-1,_time:this._clock++};return this._entries.push(w),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),(0,p.toDisposable)(()=>{if(w){let v=this._entries.indexOf(w);v>=0&&(this._entries.splice(v,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),w=void 0)}})}has(g){return this.all(g).length>0}all(g){if(!g)return[];this._updateScores(g);const D=[];for(let w of this._entries)w._score>0&&D.push(w.provider);return D}ordered(g){const D=[];return this._orderedForEach(g,w=>D.push(w.provider)),D}orderedGroups(g){const D=[];let w,v;return this._orderedForEach(g,a=>{w&&v===a._score?w.push(a.provider):(v=a._score,w=[a.provider],D.push(w))}),D}_orderedForEach(g,D){if(!!g){this._updateScores(g);for(const w of this._entries)w._score>0&&D(w)}}_updateScores(g){let D={uri:g.uri.toString(),language:g.getLanguageId()};if(!(this._lastCandidate&&this._lastCandidate.language===D.language&&this._lastCandidate.uri===D.uri)){this._lastCandidate=D;for(let w of this._entries)if(w._score=(0,T.score)(w.selector,g.uri,g.getLanguageId(),(0,h.shouldSynchronizeModel)(g)),f(w.selector)&&w._score>0){for(let v of this._entries)v._score=0;w._score=1e3;break}this._entries.sort(C._compareByScoreAndTime)}}static _compareByScoreAndTime(g,D){return g._score<D._score?1:g._score>D._score?-1:g._time<D._time?1:g._time>D._time?-1:0}}e.LanguageFeatureRegistry=C;const I=new WeakMap;let m=0;function u(b){let g=I.get(b);return g===void 0&&(g=++m,I.set(b,g)),g}class c{constructor(g,D,w=Number.MAX_SAFE_INTEGER){this._registry=g,this.min=D,this.max=w,this._cache=new P.LRUCache(50,.7)}_key(g){return g.id+this._registry.all(g).reduce((D,w)=>(0,k.doHash)(u(w),D),0)}_clamp(g){return g===void 0?this.min:Math.min(this.max,Math.max(this.min,Math.floor(g*1.3)))}get(g){const D=this._key(g),w=this._cache.get(D);return this._clamp(w?.value)}update(g,D){const w=this._key(g);let v=this._cache.get(w);return v||(v=new t.MovingAverage,this._cache.set(w,v)),v.update(D),this.get(g)}}e.LanguageFeatureRequestDelays=c}),define(ue[200],de([0,1,5,67,199,148,40]),function(Y,e,S,k,p,P,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlayHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.InlineCompletionsProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.completionKindFromString=e.completionKindToCssClass=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageId=void 0;var T;(function(E){E[E.Null=0]="Null",E[E.PlainText=1]="PlainText"})(T=e.LanguageId||(e.LanguageId={}));var h;(function(E){E[E.NotSet=-1]="NotSet",E[E.None=0]="None",E[E.Italic=1]="Italic",E[E.Bold=2]="Bold",E[E.Underline=4]="Underline"})(h=e.FontStyle||(e.FontStyle={}));var f;(function(E){E[E.None=0]="None",E[E.DefaultForeground=1]="DefaultForeground",E[E.DefaultBackground=2]="DefaultBackground"})(f=e.ColorId||(e.ColorId={}));var C;(function(E){E[E.Other=0]="Other",E[E.Comment=1]="Comment",E[E.String=2]="String",E[E.RegEx=4]="RegEx"})(C=e.StandardTokenType||(e.StandardTokenType={}));var I;(function(E){E[E.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",E[E.TOKEN_TYPE_MASK=1792]="TOKEN_TYPE_MASK",E[E.FONT_STYLE_MASK=14336]="FONT_STYLE_MASK",E[E.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",E[E.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",E[E.ITALIC_MASK=2048]="ITALIC_MASK",E[E.BOLD_MASK=4096]="BOLD_MASK",E[E.UNDERLINE_MASK=8192]="UNDERLINE_MASK",E[E.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",E[E.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",E[E.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",E[E.SEMANTIC_USE_FOREGROUND=8]="SEMANTIC_USE_FOREGROUND",E[E.SEMANTIC_USE_BACKGROUND=16]="SEMANTIC_USE_BACKGROUND",E[E.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",E[E.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",E[E.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",E[E.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",E[E.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(I=e.MetadataConsts||(e.MetadataConsts={}));class m{static getLanguageId(R){return(R&255)>>>0}static getTokenType(R){return(R&1792)>>>8}static getFontStyle(R){return(R&14336)>>>11}static getForeground(R){return(R&8372224)>>>14}static getBackground(R){return(R&4286578688)>>>23}static getClassNameFromMetadata(R){let O=this.getForeground(R),K="mtk"+O,te=this.getFontStyle(R);return te&1&&(K+=" mtki"),te&2&&(K+=" mtkb"),te&4&&(K+=" mtku"),K}static getInlineStyleFromMetadata(R,O){const K=this.getForeground(R),te=this.getFontStyle(R);let j=`color: ${O[K]};`;return te&1&&(j+="font-style: italic;"),te&2&&(j+="font-weight: bold;"),te&4&&(j+="text-decoration: underline;"),j}}e.TokenMetadata=m;var u;(function(E){E[E.Method=0]="Method",E[E.Function=1]="Function",E[E.Constructor=2]="Constructor",E[E.Field=3]="Field",E[E.Variable=4]="Variable",E[E.Class=5]="Class",E[E.Struct=6]="Struct",E[E.Interface=7]="Interface",E[E.Module=8]="Module",E[E.Property=9]="Property",E[E.Event=10]="Event",E[E.Operator=11]="Operator",E[E.Unit=12]="Unit",E[E.Value=13]="Value",E[E.Constant=14]="Constant",E[E.Enum=15]="Enum",E[E.EnumMember=16]="EnumMember",E[E.Keyword=17]="Keyword",E[E.Text=18]="Text",E[E.Color=19]="Color",E[E.File=20]="File",E[E.Reference=21]="Reference",E[E.Customcolor=22]="Customcolor",E[E.Folder=23]="Folder",E[E.TypeParameter=24]="TypeParameter",E[E.User=25]="User",E[E.Issue=26]="Issue",E[E.Snippet=27]="Snippet"})(u=e.CompletionItemKind||(e.CompletionItemKind={})),e.completionKindToCssClass=function(){let E=Object.create(null);return E[0]="symbol-method",E[1]="symbol-function",E[2]="symbol-constructor",E[3]="symbol-field",E[4]="symbol-variable",E[5]="symbol-class",E[6]="symbol-struct",E[7]="symbol-interface",E[8]="symbol-module",E[9]="symbol-property",E[10]="symbol-event",E[11]="symbol-operator",E[12]="symbol-unit",E[13]="symbol-value",E[14]="symbol-constant",E[15]="symbol-enum",E[16]="symbol-enum-member",E[17]="symbol-keyword",E[27]="symbol-snippet",E[18]="symbol-text",E[19]="symbol-color",E[20]="symbol-file",E[21]="symbol-reference",E[22]="symbol-customcolor",E[23]="symbol-folder",E[24]="symbol-type-parameter",E[25]="account",E[26]="issues",function(R){const O=E[R];let K=O&&t.iconRegistry.get(O);return K||(console.info("No codicon found for CompletionItemKind "+R),K=t.Codicon.symbolProperty),K.classNames}}(),e.completionKindFromString=function(){let E=Object.create(null);return E.method=0,E.function=1,E.constructor=2,E.field=3,E.variable=4,E.class=5,E.struct=6,E.interface=7,E.module=8,E.property=9,E.event=10,E.operator=11,E.unit=12,E.value=13,E.constant=14,E.enum=15,E["enum-member"]=16,E.enumMember=16,E.keyword=17,E.snippet=27,E.text=18,E.color=19,E.file=20,E.reference=21,E.customcolor=22,E.folder=23,E["type-parameter"]=24,E.typeParameter=24,E.account=25,E.issue=26,function(R,O){let K=E[R];return typeof K=="undefined"&&!O&&(K=9),K}}();var c;(function(E){E[E.Deprecated=1]="Deprecated"})(c=e.CompletionItemTag||(e.CompletionItemTag={}));var b;(function(E){E[E.KeepWhitespace=1]="KeepWhitespace",E[E.InsertAsSnippet=4]="InsertAsSnippet"})(b=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var g;(function(E){E[E.Invoke=0]="Invoke",E[E.TriggerCharacter=1]="TriggerCharacter",E[E.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(g=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var D;(function(E){E[E.Automatic=0]="Automatic",E[E.Explicit=1]="Explicit"})(D=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var w;(function(E){E[E.Invoke=1]="Invoke",E[E.Auto=2]="Auto"})(w=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var v;(function(E){E[E.Invoke=1]="Invoke",E[E.TriggerCharacter=2]="TriggerCharacter",E[E.ContentChange=3]="ContentChange"})(v=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var a;(function(E){E[E.Text=0]="Text",E[E.Read=1]="Read",E[E.Write=2]="Write"})(a=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function l(E){return E&&S.URI.isUri(E.uri)&&k.Range.isIRange(E.range)&&(k.Range.isIRange(E.originSelectionRange)||k.Range.isIRange(E.targetSelectionRange))}e.isLocationLink=l;var r;(function(E){E[E.File=0]="File",E[E.Module=1]="Module",E[E.Namespace=2]="Namespace",E[E.Package=3]="Package",E[E.Class=4]="Class",E[E.Method=5]="Method",E[E.Property=6]="Property",E[E.Field=7]="Field",E[E.Constructor=8]="Constructor",E[E.Enum=9]="Enum",E[E.Interface=10]="Interface",E[E.Function=11]="Function",E[E.Variable=12]="Variable",E[E.Constant=13]="Constant",E[E.String=14]="String",E[E.Number=15]="Number",E[E.Boolean=16]="Boolean",E[E.Array=17]="Array",E[E.Object=18]="Object",E[E.Key=19]="Key",E[E.Null=20]="Null",E[E.EnumMember=21]="EnumMember",E[E.Struct=22]="Struct",E[E.Event=23]="Event",E[E.Operator=24]="Operator",E[E.TypeParameter=25]="TypeParameter"})(r=e.SymbolKind||(e.SymbolKind={}));var o;(function(E){E[E.Deprecated=1]="Deprecated"})(o=e.SymbolTag||(e.SymbolTag={}));var i;(function(E){const R=new Map;R.set("file",0),R.set("module",1),R.set("namespace",2),R.set("package",3),R.set("class",4),R.set("method",5),R.set("property",6),R.set("field",7),R.set("constructor",8),R.set("enum",9),R.set("interface",10),R.set("function",11),R.set("variable",12),R.set("constant",13),R.set("string",14),R.set("number",15),R.set("boolean",16),R.set("array",17),R.set("object",18),R.set("key",19),R.set("null",20),R.set("enum-member",21),R.set("struct",22),R.set("event",23),R.set("operator",24),R.set("type-parameter",25);const O=new Map;O.set(0,"file"),O.set(1,"module"),O.set(2,"namespace"),O.set(3,"package"),O.set(4,"class"),O.set(5,"method"),O.set(6,"property"),O.set(7,"field"),O.set(8,"constructor"),O.set(9,"enum"),O.set(10,"interface"),O.set(11,"function"),O.set(12,"variable"),O.set(13,"constant"),O.set(14,"string"),O.set(15,"number"),O.set(16,"boolean"),O.set(17,"array"),O.set(18,"object"),O.set(19,"key"),O.set(20,"null"),O.set(21,"enum-member"),O.set(22,"struct"),O.set(23,"event"),O.set(24,"operator"),O.set(25,"type-parameter");function K(_){return R.get(_)}E.fromString=K;function te(_){return O.get(_)}E.toString=te;function j(_,U){const F=O.get(_);let M=F&&t.iconRegistry.get("symbol-"+F);return M||(console.info("No codicon found for SymbolKind "+_),M=t.Codicon.symbolProperty),`${U?"inline":"block"} ${M.classNames}`}E.toCssClassName=j})(i=e.SymbolKinds||(e.SymbolKinds={}));class n{constructor(R){this.value=R}}e.FoldingRangeKind=n,n.Comment=new n("comment"),n.Imports=new n("imports"),n.Region=new n("region");var s;(function(E){E[E.Collapsed=0]="Collapsed",E[E.Expanded=1]="Expanded"})(s=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var d;(function(E){E[E.Editing=0]="Editing",E[E.Preview=1]="Preview"})(d=e.CommentMode||(e.CommentMode={}));var y;(function(E){E[E.Other=0]="Other",E[E.Type=1]="Type",E[E.Parameter=2]="Parameter"})(y=e.InlayHintKind||(e.InlayHintKind={})),e.ReferenceProviderRegistry=new p.LanguageFeatureRegistry,e.RenameProviderRegistry=new p.LanguageFeatureRegistry,e.CompletionProviderRegistry=new p.LanguageFeatureRegistry,e.InlineCompletionsProviderRegistry=new p.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new p.LanguageFeatureRegistry,e.HoverProviderRegistry=new p.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new p.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new p.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new p.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new p.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new p.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new p.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new p.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new p.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new p.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new p.LanguageFeatureRegistry,e.InlayHintsProviderRegistry=new p.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new p.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new p.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new p.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new p.LanguageFeatureRegistry,e.LinkProviderRegistry=new p.LanguageFeatureRegistry,e.ColorProviderRegistry=new p.LanguageFeatureRegistry,e.SelectionRangeRegistry=new p.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new p.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new p.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new p.LanguageFeatureRegistry,e.TokenizationRegistry=new P.TokenizationRegistryImpl;var A;(function(E){E[E.None=0]="None",E[E.Option=1]="Option",E[E.Default=2]="Default",E[E.Preferred=3]="Preferred"})(A=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(ue[27],de([0,1,11,5,7]),function(Y,e,S,k,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,p.createDecorator)("configurationService");function P(g){return g&&typeof g=="object"&&(!g.overrideIdentifier||typeof g.overrideIdentifier=="string")&&(!g.resource||g.resource instanceof k.URI)}e.isConfigurationOverrides=P;function t(g){return g&&typeof g=="object"&&(!g.overrideIdentifiers||S.isArray(g.overrideIdentifiers))&&!g.overrideIdentifier&&(!g.resource||g.resource instanceof k.URI)}e.isConfigurationUpdateOverrides=t;var T;(function(g){g[g.USER=1]="USER",g[g.USER_LOCAL=2]="USER_LOCAL",g[g.USER_REMOTE=3]="USER_REMOTE",g[g.WORKSPACE=4]="WORKSPACE",g[g.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",g[g.DEFAULT=6]="DEFAULT",g[g.MEMORY=7]="MEMORY"})(T=e.ConfigurationTarget||(e.ConfigurationTarget={}));function h(g){switch(g){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=h;function f(g,D){const w=Object.create(null);for(let v in g)C(w,v,g[v],D);return w}e.toValuesTree=f;function C(g,D,w,v){const a=D.split("."),l=a.pop();let r=g;for(let o=0;o<a.length;o++){let i=a[o],n=r[i];switch(typeof n){case"undefined":n=r[i]=Object.create(null);break;case"object":break;default:v(`Ignoring ${D} as ${a.slice(0,o+1).join(".")} is ${JSON.stringify(n)}`);return}r=n}if(typeof r=="object"&&r!==null)try{r[l]=w}catch(o){v(`Ignoring ${D} as ${a.join(".")} is ${JSON.stringify(r)}`)}else v(`Ignoring ${D} as ${a.join(".")} is ${JSON.stringify(r)}`)}e.addToValueTree=C;function I(g,D){const w=D.split(".");m(g,w)}e.removeFromValueTree=I;function m(g,D){const w=D.shift();if(D.length===0){delete g[w];return}if(Object.keys(g).indexOf(w)!==-1){const v=g[w];typeof v=="object"&&!Array.isArray(v)&&(m(v,D),Object.keys(v).length===0&&delete g[w])}}function u(g,D,w){function v(r,o){let i=r;for(const n of o){if(typeof i!="object"||i===null)return;i=i[n]}return i}const a=D.split("."),l=v(g,a);return typeof l=="undefined"?w:l}e.getConfigurationValue=u;function c(g,D,w){Object.keys(D).forEach(v=>{v!=="__proto__"&&(v in g?S.isObject(g[v])&&S.isObject(D[v])?c(g[v],D[v],w):w&&(g[v]=D[v]):g[v]=D[v])})}e.merge=c;function b(g,D,w){const v=g.inspect(D),a=g.inspect(w);return typeof v.userValue!="undefined"||typeof v.workspaceValue!="undefined"||typeof v.workspaceFolderValue!="undefined"?v.value:typeof a.userValue!="undefined"||typeof a.workspaceValue!="undefined"||typeof a.workspaceFolderValue!="undefined"?a.value:v.defaultValue}e.getMigratedSettingValue=b}),define(ue[71],de([0,1,2,14,7]),function(Y,e,S,k,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let P=S.userAgent||"";const t=new Map;t.set("false",!1),t.set("true",!0),t.set("isMac",S.isMacintosh),t.set("isLinux",S.isLinux),t.set("isWindows",S.isWindows),t.set("isWeb",S.isWeb),t.set("isMacNative",S.isMacintosh&&!S.isWeb),t.set("isEdge",P.indexOf("Edg/")>=0),t.set("isFirefox",P.indexOf("Firefox")>=0),t.set("isChrome",P.indexOf("Chrome")>=0),t.set("isSafari",P.indexOf("Safari")>=0);const T=Object.prototype.hasOwnProperty;var h;(function(j){j[j.False=0]="False",j[j.True=1]="True",j[j.Defined=2]="Defined",j[j.Not=3]="Not",j[j.Equals=4]="Equals",j[j.NotEquals=5]="NotEquals",j[j.And=6]="And",j[j.Regex=7]="Regex",j[j.NotRegex=8]="NotRegex",j[j.Or=9]="Or",j[j.In=10]="In",j[j.NotIn=11]="NotIn",j[j.Greater=12]="Greater",j[j.GreaterEquals=13]="GreaterEquals",j[j.Smaller=14]="Smaller",j[j.SmallerEquals=15]="SmallerEquals"})(h=e.ContextKeyExprType||(e.ContextKeyExprType={}));class f{static false(){return m.INSTANCE}static true(){return u.INSTANCE}static has(_){return c.create(_)}static equals(_,U){return b.create(_,U)}static notEquals(_,U){return w.create(_,U)}static regex(_,U){return n.create(_,U)}static in(_,U){return g.create(_,U)}static not(_){return v.create(_)}static and(..._){return y.create(_,null)}static or(..._){return A.create(_,null,!0)}static greater(_,U){return l.create(_,U)}static greaterEquals(_,U){return r.create(_,U)}static smaller(_,U){return o.create(_,U)}static smallerEquals(_,U){return i.create(_,U)}static deserialize(_,U=!1){if(!!_)return this._deserializeOrExpression(_,U)}static _deserializeOrExpression(_,U){let F=_.split("||");return A.create(F.map(M=>this._deserializeAndExpression(M,U)),null,!0)}static _deserializeAndExpression(_,U){let F=_.split("&&");return y.create(F.map(M=>this._deserializeOne(M,U)),null)}static _deserializeOne(_,U){if(_=_.trim(),_.indexOf("!=")>=0){let F=_.split("!=");return w.create(F[0].trim(),this._deserializeValue(F[1],U))}if(_.indexOf("==")>=0){let F=_.split("==");return b.create(F[0].trim(),this._deserializeValue(F[1],U))}if(_.indexOf("=~")>=0){let F=_.split("=~");return n.create(F[0].trim(),this._deserializeRegexValue(F[1],U))}if(_.indexOf(" in ")>=0){let F=_.split(" in ");return g.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(_)){const F=_.split(">=");return r.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(_)){const F=_.split(">");return l.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(_)){const F=_.split("<=");return i.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(_)){const F=_.split("<");return o.create(F[0].trim(),F[1].trim())}return/^\!\s*/.test(_)?v.create(_.substr(1).trim()):c.create(_)}static _deserializeValue(_,U){if(_=_.trim(),_==="true")return!0;if(_==="false")return!1;let F=/^'([^']*)'$/.exec(_);return F?F[1].trim():_}static _deserializeRegexValue(_,U){if((0,k.isFalsyOrWhitespace)(_)){if(U)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let F=_.indexOf("/"),M=_.lastIndexOf("/");if(F===M||F<0){if(U)throw new Error(`bad regexp-value '${_}', missing /-enclosure`);return console.warn(`bad regexp-value '${_}', missing /-enclosure`),null}let V=_.slice(F+1,M),ee=_[M+1]==="i"?"i":"";try{return new RegExp(V,ee)}catch(G){if(U)throw new Error(`bad regexp-value '${_}', parse error: ${G}`);return console.warn(`bad regexp-value '${_}', parse error: ${G}`),null}}}e.ContextKeyExpr=f;function C(j,_){const U=j?j.substituteConstants():void 0,F=_?_.substituteConstants():void 0;return!U&&!F?!0:!U||!F?!1:U.equals(F)}e.expressionsAreEqualWithConstantSubstitution=C;function I(j,_){return j.cmp(_)}class m{constructor(){this.type=0}cmp(_){return this.type-_.type}equals(_){return _.type===this.type}substituteConstants(){return this}evaluate(_){return!1}serialize(){return"false"}keys(){return[]}map(_){return this}negate(){return u.INSTANCE}}e.ContextKeyFalseExpr=m,m.INSTANCE=new m;class u{constructor(){this.type=1}cmp(_){return this.type-_.type}equals(_){return _.type===this.type}substituteConstants(){return this}evaluate(_){return!0}serialize(){return"true"}keys(){return[]}map(_){return this}negate(){return m.INSTANCE}}e.ContextKeyTrueExpr=u,u.INSTANCE=new u;class c{constructor(_,U){this.key=_,this.negated=U,this.type=2}static create(_,U=null){const F=t.get(_);return typeof F=="boolean"?F?u.INSTANCE:m.INSTANCE:new c(_,U)}cmp(_){return _.type!==this.type?this.type-_.type:R(this.key,_.key)}equals(_){return _.type===this.type?this.key===_.key:!1}substituteConstants(){const _=t.get(this.key);return typeof _=="boolean"?_?u.INSTANCE:m.INSTANCE:this}evaluate(_){return!!_.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(_){return _.mapDefined(this.key)}negate(){return this.negated||(this.negated=v.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=c;class b{constructor(_,U,F){this.key=_,this.value=U,this.negated=F,this.type=4}static create(_,U,F=null){if(typeof U=="boolean")return U?c.create(_,F):v.create(_,F);const M=t.get(_);return typeof M=="boolean"?U===(M?"true":"false")?u.INSTANCE:m.INSTANCE:new b(_,U,F)}cmp(_){return _.type!==this.type?this.type-_.type:O(this.key,this.value,_.key,_.value)}equals(_){return _.type===this.type?this.key===_.key&&this.value===_.value:!1}substituteConstants(){const _=t.get(this.key);if(typeof _=="boolean"){const U=_?"true":"false";return this.value===U?u.INSTANCE:m.INSTANCE}return this}evaluate(_){return _.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(_){return _.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=w.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=b;class g{constructor(_,U){this.key=_,this.valueKey=U,this.type=10,this.negated=null}static create(_,U){return new g(_,U)}cmp(_){return _.type!==this.type?this.type-_.type:O(this.key,this.valueKey,_.key,_.valueKey)}equals(_){return _.type===this.type?this.key===_.key&&this.valueKey===_.valueKey:!1}substituteConstants(){return this}evaluate(_){const U=_.getValue(this.valueKey),F=_.getValue(this.key);return Array.isArray(U)?U.indexOf(F)>=0:typeof F=="string"&&typeof U=="object"&&U!==null?T.call(U,F):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(_){return _.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=D.create(this)),this.negated}}e.ContextKeyInExpr=g;class D{constructor(_){this._actual=_,this.type=11}static create(_){return new D(_)}cmp(_){return _.type!==this.type?this.type-_.type:this._actual.cmp(_._actual)}equals(_){return _.type===this.type?this._actual.equals(_._actual):!1}substituteConstants(){return this}evaluate(_){return!this._actual.evaluate(_)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(_){return new D(this._actual.map(_))}negate(){return this._actual}}e.ContextKeyNotInExpr=D;class w{constructor(_,U,F){this.key=_,this.value=U,this.negated=F,this.type=5}static create(_,U,F=null){if(typeof U=="boolean")return U?v.create(_,F):c.create(_,F);const M=t.get(_);return typeof M=="boolean"?U===(M?"true":"false")?m.INSTANCE:u.INSTANCE:new w(_,U,F)}cmp(_){return _.type!==this.type?this.type-_.type:O(this.key,this.value,_.key,_.value)}equals(_){return _.type===this.type?this.key===_.key&&this.value===_.value:!1}substituteConstants(){const _=t.get(this.key);if(typeof _=="boolean"){const U=_?"true":"false";return this.value===U?m.INSTANCE:u.INSTANCE}return this}evaluate(_){return _.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(_){return _.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=b.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=w;class v{constructor(_,U){this.key=_,this.negated=U,this.type=3}static create(_,U=null){const F=t.get(_);return typeof F=="boolean"?F?m.INSTANCE:u.INSTANCE:new v(_,U)}cmp(_){return _.type!==this.type?this.type-_.type:R(this.key,_.key)}equals(_){return _.type===this.type?this.key===_.key:!1}substituteConstants(){const _=t.get(this.key);return typeof _=="boolean"?_?m.INSTANCE:u.INSTANCE:this}evaluate(_){return!_.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(_){return _.mapNot(this.key)}negate(){return this.negated||(this.negated=c.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=v;function a(j,_){if(typeof j=="string"){const U=parseFloat(j);isNaN(U)||(j=U)}return typeof j=="string"||typeof j=="number"?_(j):m.INSTANCE}class l{constructor(_,U,F){this.key=_,this.value=U,this.negated=F,this.type=12}static create(_,U,F=null){return a(U,M=>new l(_,M,F))}cmp(_){return _.type!==this.type?this.type-_.type:O(this.key,this.value,_.key,_.value)}equals(_){return _.type===this.type?this.key===_.key&&this.value===_.value:!1}substituteConstants(){return this}evaluate(_){return typeof this.value=="string"?!1:parseFloat(_.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(_){return _.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=i.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=l;class r{constructor(_,U,F){this.key=_,this.value=U,this.negated=F,this.type=13}static create(_,U,F=null){return a(U,M=>new r(_,M,F))}cmp(_){return _.type!==this.type?this.type-_.type:O(this.key,this.value,_.key,_.value)}equals(_){return _.type===this.type?this.key===_.key&&this.value===_.value:!1}substituteConstants(){return this}evaluate(_){return typeof this.value=="string"?!1:parseFloat(_.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(_){return _.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=o.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=r;class o{constructor(_,U,F){this.key=_,this.value=U,this.negated=F,this.type=14}static create(_,U,F=null){return a(U,M=>new o(_,M,F))}cmp(_){return _.type!==this.type?this.type-_.type:O(this.key,this.value,_.key,_.value)}equals(_){return _.type===this.type?this.key===_.key&&this.value===_.value:!1}substituteConstants(){return this}evaluate(_){return typeof this.value=="string"?!1:parseFloat(_.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(_){return _.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=r.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=o;class i{constructor(_,U,F){this.key=_,this.value=U,this.negated=F,this.type=15}static create(_,U,F=null){return a(U,M=>new i(_,M,F))}cmp(_){return _.type!==this.type?this.type-_.type:O(this.key,this.value,_.key,_.value)}equals(_){return _.type===this.type?this.key===_.key&&this.value===_.value:!1}substituteConstants(){return this}evaluate(_){return typeof this.value=="string"?!1:parseFloat(_.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(_){return _.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=l.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=i;class n{constructor(_,U){this.key=_,this.regexp=U,this.type=7,this.negated=null}static create(_,U){return new n(_,U)}cmp(_){if(_.type!==this.type)return this.type-_.type;if(this.key<_.key)return-1;if(this.key>_.key)return 1;const U=this.regexp?this.regexp.source:"",F=_.regexp?_.regexp.source:"";return U<F?-1:U>F?1:0}equals(_){if(_.type===this.type){const U=this.regexp?this.regexp.source:"",F=_.regexp?_.regexp.source:"";return this.key===_.key&&U===F}return!1}substituteConstants(){return this}evaluate(_){let U=_.getValue(this.key);return this.regexp?this.regexp.test(U):!1}serialize(){const _=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${_}`}keys(){return[this.key]}map(_){return _.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=s.create(this)),this.negated}}e.ContextKeyRegexExpr=n;class s{constructor(_){this._actual=_,this.type=8}static create(_){return new s(_)}cmp(_){return _.type!==this.type?this.type-_.type:this._actual.cmp(_._actual)}equals(_){return _.type===this.type?this._actual.equals(_._actual):!1}substituteConstants(){return this}evaluate(_){return!this._actual.evaluate(_)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(_){return new s(this._actual.map(_))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=s;function d(j){let _=null;for(let U=0,F=j.length;U<F;U++){const M=j[U].substituteConstants();if(j[U]!==M&&_===null){_=[];for(let V=0;V<U;V++)_[V]=j[V]}_!==null&&(_[U]=M)}return _===null?j:_}class y{constructor(_,U){this.expr=_,this.negated=U,this.type=6}static create(_,U){return y._normalizeArr(_,U)}cmp(_){if(_.type!==this.type)return this.type-_.type;if(this.expr.length<_.expr.length)return-1;if(this.expr.length>_.expr.length)return 1;for(let U=0,F=this.expr.length;U<F;U++){const M=I(this.expr[U],_.expr[U]);if(M!==0)return M}return 0}equals(_){if(_.type===this.type){if(this.expr.length!==_.expr.length)return!1;for(let U=0,F=this.expr.length;U<F;U++)if(!this.expr[U].equals(_.expr[U]))return!1;return!0}return!1}substituteConstants(){const _=d(this.expr);return _===this.expr?this:y.create(_,this.negated)}evaluate(_){for(let U=0,F=this.expr.length;U<F;U++)if(!this.expr[U].evaluate(_))return!1;return!0}static _normalizeArr(_,U){const F=[];let M=!1;for(const V of _)if(!!V){if(V.type===1){M=!0;continue}if(V.type===0)return m.INSTANCE;if(V.type===6){F.push(...V.expr);continue}F.push(V)}if(F.length===0&&M)return u.INSTANCE;if(F.length!==0){if(F.length===1)return F[0];F.sort(I);for(let V=1;V<F.length;V++)F[V-1].equals(F[V])&&(F.splice(V,1),V--);if(F.length===1)return F[0];for(;F.length>1;){const V=F[F.length-1];if(V.type!==9)break;F.pop();const ee=F.pop(),G=F.length===0,H=A.create(V.expr.map(q=>y.create([q,ee],null)),null,G);H&&(F.push(H),F.sort(I))}return F.length===1?F[0]:new y(F,U)}}serialize(){return this.expr.map(_=>_.serialize()).join(" && ")}keys(){const _=[];for(let U of this.expr)_.push(...U.keys());return _}map(_){return new y(this.expr.map(U=>U.map(_)),null)}negate(){if(!this.negated){const _=[];for(let U of this.expr)_.push(U.negate());this.negated=A.create(_,this,!0)}return this.negated}}class A{constructor(_,U){this.expr=_,this.negated=U,this.type=9}static create(_,U,F){return A._normalizeArr(_,U,F)}cmp(_){if(_.type!==this.type)return this.type-_.type;if(this.expr.length<_.expr.length)return-1;if(this.expr.length>_.expr.length)return 1;for(let U=0,F=this.expr.length;U<F;U++){const M=I(this.expr[U],_.expr[U]);if(M!==0)return M}return 0}equals(_){if(_.type===this.type){if(this.expr.length!==_.expr.length)return!1;for(let U=0,F=this.expr.length;U<F;U++)if(!this.expr[U].equals(_.expr[U]))return!1;return!0}return!1}substituteConstants(){const _=d(this.expr);return _===this.expr?this:A.create(_,this.negated,!1)}evaluate(_){for(let U=0,F=this.expr.length;U<F;U++)if(this.expr[U].evaluate(_))return!0;return!1}static _normalizeArr(_,U,F){let M=[],V=!1;if(_){for(let ee=0,G=_.length;ee<G;ee++){const H=_[ee];if(!!H){if(H.type===0){V=!0;continue}if(H.type===1)return u.INSTANCE;if(H.type===9){M=M.concat(H.expr);continue}M.push(H)}}if(M.length===0&&V)return m.INSTANCE;M.sort(I)}if(M.length!==0){if(M.length===1)return M[0];for(let ee=1;ee<M.length;ee++)M[ee-1].equals(M[ee])&&(M.splice(ee,1),ee--);if(M.length===1)return M[0];if(F){for(let ee=0;ee<M.length;ee++)for(let G=ee+1;G<M.length;G++)K(M[ee],M[G])&&(M.splice(G,1),G--);if(M.length===1)return M[0]}return new A(M,U)}}serialize(){return this.expr.map(_=>_.serialize()).join(" || ")}keys(){const _=[];for(let U of this.expr)_.push(...U.keys());return _}map(_){return new A(this.expr.map(U=>U.map(_)),null)}negate(){if(!this.negated){let _=[];for(let U of this.expr)_.push(U.negate());for(;_.length>1;){const U=_.shift(),F=_.shift(),M=[];for(const ee of te(U))for(const G of te(F))M.push(y.create([ee,G],null));const V=_.length===0;_.unshift(A.create(M,null,V))}this.negated=_[0]}return this.negated}}class E extends c{constructor(_,U,F){super(_,null);this._defaultValue=U,typeof F=="object"?E._info.push({...F,key:_}):F!==!0&&E._info.push({key:_,description:F,type:U!=null?typeof U:void 0})}static all(){return E._info.values()}bindTo(_){return _.createKey(this.key,this._defaultValue)}getValue(_){return _.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(_){return b.create(this.key,_)}notEqualsTo(_){return w.create(this.key,_)}}e.RawContextKey=E,E._info=[],e.IContextKeyService=(0,p.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function R(j,_){return j<_?-1:j>_?1:0}function O(j,_,U,F){return j<U?-1:j>U?1:_<F?-1:_>F?1:0}function K(j,_){if(_.type===6&&j.type!==9&&j.type!==6){for(const M of _.expr)if(j.equals(M))return!0}const U=j.negate(),F=te(U).concat(te(_));F.sort(I);for(let M=0;M<F.length;M++){const ee=F[M].negate();for(let G=M+1;G<F.length;G++){const H=F[G];if(ee.equals(H))return!0}}return!1}e.implies=K;function te(j){return j.type===9?j.expr:[j]}}),define(ue[201],de([0,1,7]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,S.createDecorator)(e.ID);function k(p){return!!p.hostName&&!!p.errorMessage}e.isRemoteDiagnosticError=k}),define(ue[72],de([0,1,7]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,S.createDecorator)("downloadService")}),define(ue[28],de([0,1,7]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,S.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,S.refineServiceDecorator)(e.IEnvironmentService)}),define(ue[29],de([0,1,10,162,7]),function(Y,e,S,k,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.TargetPlatform=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";var P;(function(v){v.WIN32_X64="win32-x64",v.WIN32_IA32="win32-ia32",v.WIN32_ARM64="win32-arm64",v.LINUX_X64="linux-x64",v.LINUX_ARM64="linux-arm64",v.LINUX_ARMHF="linux-armhf",v.ALPINE_X64="alpine-x64",v.ALPINE_ARM64="alpine-arm64",v.DARWIN_X64="darwin-x64",v.DARWIN_ARM64="darwin-arm64",v.WEB="web",v.UNIVERSAL="universal",v.UNKNOWN="unknown",v.UNDEFINED="undefined"})(P=e.TargetPlatform||(e.TargetPlatform={}));function t(v){switch(v){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=t;function T(v){switch(v){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=T;function h(v,a){switch(v){case 3:return a==="x64"?"win32-x64":a==="ia32"?"win32-ia32":a==="arm64"?"win32-arm64":"unknown";case 2:return a==="x64"?"linux-x64":a==="arm64"?"linux-arm64":a==="arm"?"linux-armhf":"unknown";case"alpine":return a==="x64"?"alpine-x64":a==="arm64"?"alpine-arm64":"unknown";case 1:return a==="x64"?"darwin-x64":a==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=h;function f(v,a){return a==="web"&&!v.includes("web")}e.isNotWebExtensionInWebTargetPlatform=f;function C(v,a,l){return f(a,l)?!1:v==="undefined"||v==="universal"?!0:v==="unknown"?!1:v===l?!0:I(l).includes(v)}e.isTargetPlatformCompatible=C;function I(v){switch(v){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=I;function m(v){return v&&typeof v=="object"&&typeof v.id=="string"&&(!v.uuid||typeof v.uuid=="string")}e.isIExtensionIdentifier=m;var u;(function(v){v[v.NoneOrRelevance=0]="NoneOrRelevance",v[v.LastUpdatedDate=1]="LastUpdatedDate",v[v.Title=2]="Title",v[v.PublisherName=3]="PublisherName",v[v.InstallCount=4]="InstallCount",v[v.PublishedDate=10]="PublishedDate",v[v.AverageRating=6]="AverageRating",v[v.WeightedRating=12]="WeightedRating"})(u=e.SortBy||(e.SortBy={}));var c;(function(v){v[v.Default=0]="Default",v[v.Ascending=1]="Ascending",v[v.Descending=2]="Descending"})(c=e.SortOrder||(e.SortOrder={}));var b;(function(v){v.Install="install",v.Uninstall="uninstall"})(b=e.StatisticType||(e.StatisticType={}));var g;(function(v){v[v.None=0]="None",v[v.Install=1]="Install",v[v.Update=2]="Update"})(g=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,p.createDecorator)("extensionGalleryService");var D;(function(v){v.Unsupported="Unsupported",v.Malicious="Malicious",v.Incompatible="Incompatible",v.IncompatiblePreRelease="IncompatiblePreRelease",v.IncompatibleTargetPlatform="IncompatibleTargetPlatform",v.Invalid="Invalid",v.Download="Download",v.Extract="Extract",v.Delete="Delete",v.Rename="Rename",v.CorruptZip="CorruptZip",v.IncompleteZip="IncompleteZip",v.Internal="Internal"})(D=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class w extends Error{constructor(a,l){super(a);this.code=l,this.name=l}}e.ExtensionManagementError=w,e.IExtensionManagementService=(0,p.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,p.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,p.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=S.FileAccess.asBrowserUri("./media/defaultIcon.png",Y).toString(!0),e.ExtensionsLabel=(0,k.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,k.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,p.createDecorator)("IExtensionManagementCLIService")}),define(ue[202],de([0,1,6,3,21,5,66,29]),function(Y,e,S,k,p,P,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function h(b,g){return P.URI.revive(g?g.transformIncoming(b):b)}function f(b,g){return g?g.transformOutgoingURI(b):b}function C(b,g){g=g||t.DefaultURITransformer;const D=b.manifest;return{...(0,t.transformAndReviveIncomingURIs)({...b,manifest:void 0},g),manifest:D}}function I(b,g){return g?(0,p.cloneAndChange)(b,D=>D instanceof P.URI?g.transformOutgoingURI(D):void 0):b}class m{constructor(g,D){this.service=g,this.getUriTransformer=D,this.onInstallExtension=S.Event.buffer(g.onInstallExtension,!0),this.onDidInstallExtensions=S.Event.buffer(g.onDidInstallExtensions,!0),this.onUninstallExtension=S.Event.buffer(g.onUninstallExtension,!0),this.onDidUninstallExtension=S.Event.buffer(g.onDidUninstallExtension,!0)}listen(g,D){const w=this.getUriTransformer(g);switch(D){case"onInstallExtension":return this.onInstallExtension;case"onDidInstallExtensions":return S.Event.map(this.onDidInstallExtensions,v=>v.map(a=>({...a,local:a.local?I(a.local,w):a.local})));case"onUninstallExtension":return this.onUninstallExtension;case"onDidUninstallExtension":return this.onDidUninstallExtension}throw new Error("Invalid listen")}call(g,D,w){const v=this.getUriTransformer(g);switch(D){case"zip":return this.service.zip(C(w[0],v)).then(a=>f(a,v));case"unzip":return this.service.unzip(h(w[0],v));case"install":return this.service.install(h(w[0],v),w[1]);case"getManifest":return this.service.getManifest(h(w[0],v));case"getTargetPlatform":return this.service.getTargetPlatform();case"canInstall":return this.service.canInstall(w[0]);case"installFromGallery":return this.service.installFromGallery(w[0],w[1]);case"uninstall":return this.service.uninstall(C(w[0],v),w[1]);case"reinstallFromGallery":return this.service.reinstallFromGallery(C(w[0],v));case"getInstalled":return this.service.getInstalled(w[0]).then(a=>a.map(l=>I(l,v)));case"updateMetadata":return this.service.updateMetadata(C(w[0],v),w[1]).then(a=>I(a,v));case"updateExtensionScope":return this.service.updateExtensionScope(C(w[0],v),w[1]).then(a=>I(a,v));case"getExtensionsReport":return this.service.getExtensionsReport()}throw new Error("Invalid call")}}e.ExtensionManagementChannel=m;class u extends k.Disposable{constructor(g){super();this.channel=g,this._onInstallExtension=this._register(new S.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new S.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new S.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new S.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this._register(this.channel.listen("onInstallExtension")(D=>this._onInstallExtension.fire({identifier:D.identifier,source:this.isUriComponents(D.source)?P.URI.revive(D.source):D.source}))),this._register(this.channel.listen("onDidInstallExtensions")(D=>this._onDidInstallExtensions.fire(D.map(w=>({...w,local:w.local?C(w.local,null):w.local,source:this.isUriComponents(w.source)?P.URI.revive(w.source):w.source}))))),this._register(this.channel.listen("onUninstallExtension")(D=>this._onUninstallExtension.fire(D))),this._register(this.channel.listen("onDidUninstallExtension")(D=>this._onDidUninstallExtension.fire(D)))}isUriComponents(g){return g?typeof g.path=="string"&&typeof g.scheme=="string":!1}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=this.channel.call("getTargetPlatform")),this._targetPlatformPromise}async canInstall(g){const D=await this.getTargetPlatform();return g.allTargetPlatforms.some(w=>(0,T.isTargetPlatformCompatible)(w,g.allTargetPlatforms,D))}zip(g){return Promise.resolve(this.channel.call("zip",[g]).then(D=>P.URI.revive(D)))}unzip(g){return Promise.resolve(this.channel.call("unzip",[g]))}install(g,D){return Promise.resolve(this.channel.call("install",[g,D])).then(w=>C(w,null))}getManifest(g){return Promise.resolve(this.channel.call("getManifest",[g]))}installFromGallery(g,D){return Promise.resolve(this.channel.call("installFromGallery",[g,D])).then(w=>C(w,null))}uninstall(g,D){return Promise.resolve(this.channel.call("uninstall",[g,D]))}reinstallFromGallery(g){return Promise.resolve(this.channel.call("reinstallFromGallery",[g]))}getInstalled(g=null){return Promise.resolve(this.channel.call("getInstalled",[g])).then(D=>D.map(w=>C(w,null)))}updateMetadata(g,D){return Promise.resolve(this.channel.call("updateMetadata",[g,D])).then(w=>C(w,null))}updateExtensionScope(g,D){return Promise.resolve(this.channel.call("updateExtensionScope",[g,D])).then(w=>C(w,null))}getExtensionsReport(){return Promise.resolve(this.channel.call("getExtensionsReport"))}registerParticipant(){throw new Error("Not Supported")}}e.ExtensionManagementChannelClient=u;class c{constructor(g){this.service=g}listen(g,D){throw new Error("Invalid listen")}call(g,D,w){switch(D){case"getConfigBasedTips":return this.service.getConfigBasedTips(P.URI.revive(w[0]));case"getImportantExecutableBasedTips":return this.service.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.service.getOtherExecutableBasedTips();case"getAllWorkspacesTips":return this.service.getAllWorkspacesTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=c}),define(ue[15],de([0,1,30,4,14,11,5,169,7]),function(Y,e,S,k,p,P,t,T,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,h.createDecorator)("fileService");function f(F){return F.create===!0}e.isFileOpenForWriteOptions=f;var C;(function(F){F[F.Unknown=0]="Unknown",F[F.File=1]="File",F[F.Directory=2]="Directory",F[F.SymbolicLink=64]="SymbolicLink"})(C=e.FileType||(e.FileType={}));var I;(function(F){F[F.Readonly=1]="Readonly"})(I=e.FilePermission||(e.FilePermission={}));var m;(function(F){F[F.FileReadWrite=2]="FileReadWrite",F[F.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",F[F.FileReadStream=16]="FileReadStream",F[F.FileFolderCopy=8]="FileFolderCopy",F[F.PathCaseSensitive=1024]="PathCaseSensitive",F[F.Readonly=2048]="Readonly",F[F.Trash=4096]="Trash",F[F.FileWriteUnlock=8192]="FileWriteUnlock"})(m=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function u(F){return!!(F.capabilities&2)}e.hasReadWriteCapability=u;function c(F){return!!(F.capabilities&8)}e.hasFileFolderCopyCapability=c;function b(F){return!!(F.capabilities&4)}e.hasOpenReadWriteCloseCapability=b;function g(F){return!!(F.capabilities&16)}e.hasFileReadStreamCapability=g;var D;(function(F){F.FileExists="EntryExists",F.FileNotFound="EntryNotFound",F.FileNotADirectory="EntryNotADirectory",F.FileIsADirectory="EntryIsADirectory",F.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",F.FileTooLarge="EntryTooLarge",F.FileWriteLocked="EntryWriteLocked",F.NoPermissions="NoPermissions",F.Unavailable="Unavailable",F.Unknown="Unknown"})(D=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class w extends Error{constructor(M,V){super(M);this.code=V}}e.FileSystemProviderError=w;function v(F,M){const V=new w(F.toString(),M);return l(V,M),V}e.createFileSystemProviderError=v;function a(F){return F||v((0,T.localize)(0,null),D.Unknown)}e.ensureFileSystemProviderError=a;function l(F,M){return F.name=M?`${M} (FileSystemError)`:"FileSystemError",F}e.markAsFileSystemProviderError=l;function r(F){if(!F)return D.Unknown;if(F instanceof w)return F.code;const M=/^(.+) \(FileSystemError\)$/.exec(F.name);if(!M)return D.Unknown;switch(M[1]){case D.FileExists:return D.FileExists;case D.FileIsADirectory:return D.FileIsADirectory;case D.FileNotADirectory:return D.FileNotADirectory;case D.FileNotFound:return D.FileNotFound;case D.FileExceedsMemoryLimit:return D.FileExceedsMemoryLimit;case D.FileTooLarge:return D.FileTooLarge;case D.FileWriteLocked:return D.FileWriteLocked;case D.NoPermissions:return D.NoPermissions;case D.Unavailable:return D.Unavailable}return D.Unknown}e.toFileSystemProviderErrorCode=r;function o(F){if(F instanceof A)return F.fileOperationResult;switch(r(F)){case D.FileNotFound:return 1;case D.FileIsADirectory:return 0;case D.FileNotADirectory:return 10;case D.FileWriteLocked:return 5;case D.NoPermissions:return 6;case D.FileExists:return 4;case D.FileExceedsMemoryLimit:return 9;case D.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=o;var i;(function(F){F[F.CREATE=0]="CREATE",F[F.DELETE=1]="DELETE",F[F.MOVE=2]="MOVE",F[F.COPY=3]="COPY"})(i=e.FileOperation||(e.FileOperation={}));class n{constructor(M,V,ee){this.resource=M,this.operation=V,this.target=ee}isOperation(M){return this.operation===M}}e.FileOperationEvent=n;var s;(function(F){F[F.UPDATED=0]="UPDATED",F[F.ADDED=1]="ADDED",F[F.DELETED=2]="DELETED"})(s=e.FileChangeType||(e.FileChangeType={}));class d{constructor(M,V){this.added=void 0,this.updated=void 0,this.deleted=void 0;const ee=new Map;for(const G of M){const H=ee.get(G.type);H?H.push([G.resource,G]):ee.set(G.type,[[G.resource,G]])}for(const[G,H]of ee)switch(G){case 1:this.added=S.TernarySearchTree.forUris(()=>V),this.added.fill(H);break;case 0:this.updated=S.TernarySearchTree.forUris(()=>V),this.updated.fill(H);break;case 2:this.deleted=S.TernarySearchTree.forUris(()=>V),this.deleted.fill(H);break}}contains(M,...V){return this.doContains(M,{includeChildren:!1},...V)}affects(M,...V){return this.doContains(M,{includeChildren:!0},...V)}doContains(M,V,...ee){if(!M)return!1;const G=ee.length>0;return!!((!G||ee.includes(1))&&(this.added?.get(M)||V.includeChildren&&this.added?.findSuperstr(M))||(!G||ee.includes(0))&&(this.updated?.get(M)||V.includeChildren&&this.updated?.findSuperstr(M))||(!G||ee.includes(2))&&(this.deleted?.findSubstr(M)||V.includeChildren&&this.deleted?.findSuperstr(M)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=d;function y(F,M,V){return!F||!M||F===M||M.length>F.length?!1:(M.charAt(M.length-1)!==k.sep&&(M+=k.sep),V?(0,p.startsWithIgnoreCase)(F,M):F.indexOf(M)===0)}e.isParent=y;class A extends Error{constructor(M,V,ee){super(M);this.fileOperationResult=V,this.options=ee}}e.FileOperationError=A;class E extends A{constructor(M,V,ee){super(M,2,ee);this.stat=V}}e.NotModifiedSinceFileOperationError=E;var R;(function(F){F[F.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",F[F.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",F[F.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",F[F.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",F[F.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",F[F.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",F[F.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",F[F.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",F[F.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",F[F.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",F[F.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",F[F.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(R=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var O;(function(F){F[F.FILE=0]="FILE",F[F.FOLDER=1]="FOLDER",F[F.ROOT_FOLDER=2]="ROOT_FOLDER"})(O=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function K(F){if(!(typeof F.size!="number"||typeof F.mtime!="number"))return F.mtime.toString(29)+F.size.toString(31)}e.etag=K;async function te(F,M){if(!M.hasProvider(t.URI.from({scheme:F.scheme})))return new Promise(V=>{const ee=M.onDidChangeFileSystemProviderRegistrations(G=>{G.scheme===F.scheme&&G.added&&(ee.dispose(),V())})})}e.whenProviderRegistered=te,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class j{static formatSize(M){return(0,P.isNumber)(M)||(M=0),M<j.KB?(0,T.localize)(1,null,M.toFixed(0)):M<j.MB?(0,T.localize)(2,null,(M/j.KB).toFixed(2)):M<j.GB?(0,T.localize)(3,null,(M/j.MB).toFixed(2)):M<j.TB?(0,T.localize)(4,null,(M/j.GB).toFixed(2)):(0,T.localize)(5,null,(M/j.TB).toFixed(2))}}e.ByteSize=j,j.KB=1024,j.MB=j.KB*j.KB,j.GB=j.MB*j.KB,j.TB=j.GB*j.KB;var _;(function(F){F[F.IA32=0]="IA32",F[F.OTHER=1]="OTHER"})(_=e.Arch||(e.Arch={}));function U(F){return{maxFileSize:F===0?300*j.MB:16*j.GB,maxHeapSize:F===0?700*j.MB:2*700*j.MB}}e.getPlatformLimits=U}),define(ue[203],de([0,1,280,159,55,15]),function(Y,e,S,k,p,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;function t(m,u){const c={onUnknownOption:g=>{console.warn((0,k.localize)(0,null,g))},onMultipleValues:(g,D)=>{console.warn((0,k.localize)(1,null,g,D))}},b=(0,p.parseArgs)(m,p.OPTIONS,u?c:void 0);return b.goto&&b._.forEach(g=>S(/^(\w:)?[^:]+(:\d*){0,2}$/.test(g),(0,k.localize)(2,null))),b["max-memory"]&&S(parseInt(b["max-memory"])>=P.MIN_MAX_MEMORY_SIZE_MB,`The max-memory argument cannot be specified lower than ${P.MIN_MAX_MEMORY_SIZE_MB} MB.`),b}function T(m){const u=m.findIndex(c=>!/^-/.test(c));if(u>-1)return[...m.slice(0,u),...m.slice(u+1)]}function h(m){let[,...u]=m;process.env.VSCODE_DEV&&(u=T(u)||[]);const c=!I(process.env);return t(u,c)}e.parseMainProcessArgv=h;function f(m){const[,,...u]=m;return t(u,!0)}e.parseCLIProcessArgv=f;function C(m,...u){const c=m.indexOf("--");return c===-1?m.push(...u):m.splice(c,0,...u),m}e.addArg=C;function I(m){return m.VSCODE_CLI==="1"}e.isLaunchedFromCli=I}),define(ue[73],de([0,1,41,4,160,24,37,12,2,25,154,203,13]),function(Y,e,S,k,p,P,t,T,h,f,C,I,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveShellEnv=void 0;const u=1e4;let c;async function b(D,w,v){return w["force-disable-user-env"]?(D.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):h.isWindows?(D.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,I.isLaunchedFromCli)(v)&&!w["force-user-env"]?(D.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,I.isLaunchedFromCli)(v)?D.trace("resolveShellEnv(): running (--force-user-env)"):D.trace("resolveShellEnv(): running (macOS/Linux)"),c||(c=m.Promises.withAsyncBody(async(a,l)=>{const r=new P.CancellationTokenSource,o=setTimeout(()=>{r.dispose(!0),l(new Error((0,p.localize)(0,null)))},u);try{a(await g(D,r.token))}catch(i){!(0,T.isPromiseCanceledError)(i)&&!r.token.isCancellationRequested?l(new Error((0,p.localize)(1,null,(0,t.toErrorMessage)(i)))):a({})}finally{clearTimeout(o),r.dispose()}})),c)}e.resolveShellEnv=b;async function g(D,w){const v=process.env.ELECTRON_RUN_AS_NODE;D.trace("getUnixShellEnvironment#runAsNode",v);const a=process.env.ELECTRON_NO_ATTACH_CONSOLE;D.trace("getUnixShellEnvironment#noAttach",a);const l=(0,f.generateUuid)().replace(/-/g,"").substr(0,12),r=new RegExp(l+"(.*)"+l),o={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};D.trace("getUnixShellEnvironment#env",o);const i=await(0,C.getSystemShell)(h.OS,o);return D.trace("getUnixShellEnvironment#shell",i),new Promise((n,s)=>{if(w.isCancellationRequested)return s((0,T.canceled)());const d=(0,k.basename)(i);let y,A;const E=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(d)?(y=`& '${process.execPath}' ${E} -p '''${l}'' + JSON.stringify(process.env) + ''${l}'''`,A=["-Login","-Command"]):(y=`'${process.execPath}' ${E} -p '"${l}" + JSON.stringify(process.env) + "${l}"'`,d==="tcsh"?A=["-ic"]:A=["-ilc"]),D.trace("getUnixShellEnvironment#spawn",JSON.stringify(A),y);const R=(0,S.spawn)(i,[...A,y],{detached:!0,stdio:["ignore","pipe","pipe"],env:o});w.onCancellationRequested(()=>(R.kill(),s((0,T.canceled)()))),R.on("error",te=>{D.error("getUnixShellEnvironment#errorChildProcess",(0,t.toErrorMessage)(te)),s(te)});const O=[];R.stdout.on("data",te=>O.push(te));const K=[];R.stderr.on("data",te=>K.push(te)),R.on("close",(te,j)=>{const _=Buffer.concat(O).toString("utf8");D.trace("getUnixShellEnvironment#raw",_);const U=Buffer.concat(K).toString("utf8");if(U.trim()&&D.trace("getUnixShellEnvironment#stderr",U),te||j)return s(new Error((0,p.localize)(2,null,te,j)));const F=r.exec(_),M=F?F[1]:"{}";try{const V=JSON.parse(M);v?V.ELECTRON_RUN_AS_NODE=v:delete V.ELECTRON_RUN_AS_NODE,a?V.ELECTRON_NO_ATTACH_CONSOLE=a:delete V.ELECTRON_NO_ATTACH_CONSOLE,delete V.XDG_RUNTIME_DIR,D.trace("getUnixShellEnvironment#result",V),n(V)}catch(V){D.error("getUnixShellEnvironment#errorCaught",(0,t.toErrorMessage)(V)),s(V)}})})}}),define(ue[99],de([0,1,18,12,170,15]),function(Y,e,S,k,p,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function t(C,I,m,u,c,b){let g;try{await T(C,I,m,u,c,b)}catch(D){g=D}finally{g&&c.errorTransformer&&(g=c.errorTransformer(g)),typeof g!="undefined"&&m.error(g),m.end()}}e.readFileIntoStream=t;async function T(C,I,m,u,c,b){h(b);const g=await C.open(I,{create:!1});try{h(b);let D=0,w=0,v=c&&typeof c.length=="number"?c.length:void 0,a=S.VSBuffer.alloc(Math.min(c.bufferSize,typeof v=="number"?v:c.bufferSize)),l=c&&typeof c.position=="number"?c.position:0,r=0;do w=await C.read(g,l,a.buffer,r,a.byteLength-r),l+=w,r+=w,D+=w,typeof v=="number"&&(v-=w),r===a.byteLength&&(await m.write(u(a)),a=S.VSBuffer.alloc(Math.min(c.bufferSize,typeof v=="number"?v:c.bufferSize)),r=0);while(w>0&&(typeof v!="number"||v>0)&&h(b)&&f(D,c));if(r>0){let o=r;typeof v=="number"&&(o=Math.min(r,v)),m.write(u(a.slice(0,o)))}}catch(D){throw(0,P.ensureFileSystemProviderError)(D)}finally{await C.close(g)}}function h(C){if(C.isCancellationRequested)throw(0,k.canceled)();return!0}function f(C,I){if(I?.limits){if(typeof I.limits.memory=="number"&&C>I.limits.memory)throw(0,P.createFileSystemProviderError)((0,p.localize)(0,null),P.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof I.limits.size=="number"&&C>I.limits.size)throw(0,P.createFileSystemProviderError)((0,p.localize)(1,null),P.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(ue[204],de([0,1,18,37,12,6,3,47,5,25,15]),function(Y,e,S,k,p,P,t,T,h,f,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCFileSystemProvider=void 0;class I extends t.Disposable{constructor(u,c){super();this.channel=u,this.extraCapabilities=c,this.onDidChangeCapabilities=P.Event.None,this._onDidChange=this._register(new P.Emitter),this.onDidChangeFile=this._onDidChange.event,this._onDidErrorOccur=this._register(new P.Emitter),this.onDidErrorOccur=this._onDidErrorOccur.event,this.sessionId=(0,f.generateUuid)(),this.registerFileChangeListeners()}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192,this.extraCapabilities.pathCaseSensitive&&(this._capabilities|=1024),this.extraCapabilities.trash&&(this._capabilities|=4096)),this._capabilities}stat(u){return this.channel.call("stat",[u])}readdir(u){return this.channel.call("readdir",[u])}async readFile(u){const{buffer:c}=await this.channel.call("readFile",[u]);return c}readFileStream(u,c,b){const g=(0,T.newWriteableStream)(w=>S.VSBuffer.concat(w.map(v=>S.VSBuffer.wrap(v))).buffer),D=this.channel.listen("readFileStream",[u,c])(w=>{if(w instanceof S.VSBuffer)g.write(w.buffer);else{if(w==="end")g.end();else{let v=w;v instanceof Error||(v=(0,C.createFileSystemProviderError)((0,k.toErrorMessage)(v),C.FileSystemProviderErrorCode.Unknown)),g.error(v),g.end()}D.dispose()}});return b.onCancellationRequested(()=>{g.error((0,p.canceled)()),g.end(),D.dispose()}),g}writeFile(u,c,b){return this.channel.call("writeFile",[u,S.VSBuffer.wrap(c),b])}open(u,c){return this.channel.call("open",[u,c])}close(u){return this.channel.call("close",[u])}async read(u,c,b,g,D){const[w,v]=await this.channel.call("read",[u,c,D]);return b.set(w.buffer.slice(0,v),g),v}write(u,c,b,g,D){return this.channel.call("write",[u,c,S.VSBuffer.wrap(b),g,D])}mkdir(u){return this.channel.call("mkdir",[u])}delete(u,c){return this.channel.call("delete",[u,c])}rename(u,c,b){return this.channel.call("rename",[u,c,b])}copy(u,c,b){return this.channel.call("copy",[u,c,b])}registerFileChangeListeners(){this._register(this.channel.listen("fileChange",[this.sessionId])(u=>{if(Array.isArray(u)){const c=u;this._onDidChange.fire(c.map(b=>({resource:h.URI.revive(b.resource),type:b.type})))}else{const c=u;this._onDidErrorOccur.fire(c)}}))}watch(u,c){const b=(0,f.generateUuid)();return this.channel.call("watch",[this.sessionId,b,u,c]),(0,t.toDisposable)(()=>this.channel.call("unwatch",[this.sessionId,b]))}}e.IPCFileSystemProvider=I}),define(ue[57],de([0,1,3,2,5,15]),function(Y,e,S,k,p,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.coalesceEvents=e.toFileChanges=e.WatcherService=e.AbstractWatcherService=void 0;class t extends S.Disposable{constructor(m,u,c){super();this.onFileChanges=m,this.onLogMessage=u,this.verboseLogging=c,this.serviceDisposables=this._register(new S.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const m=new S.DisposableStore;this.serviceDisposables.value=m,this.service=this.createService(m),this.service.setVerboseLogging(this.verboseLogging),m.add(this.service.onDidChangeFile(u=>this.onFileChanges(u))),m.add(this.service.onDidLogMessage(u=>this.onLogMessage(u))),m.add(this.service.onDidError(u=>this.onError(u)))}onError(m){this.restartCounter<t.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${m}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${m}`)}restart(m){this.restartCounter++,this.init(),this.watch(m)}async watch(m){this.requests=m,await this.service?.watch(m)}async setVerboseLogging(m){this.verboseLogging=m,await this.service?.setVerboseLogging(m)}error(m){this.onLogMessage({type:"error",message:`[File Watcher (parcel)] ${m}`})}dispose(){return this.service=void 0,super.dispose()}}e.AbstractWatcherService=t,t.MAX_RESTARTS=5;class T extends S.Disposable{}e.WatcherService=T;function h(I){return I.map(m=>({type:m.type,resource:p.URI.file(m.path)}))}e.toFileChanges=h;function f(I){const m=new C;for(const u of I)m.processEvent(u);return m.coalesce()}e.coalesceEvents=f;class C{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(m){return k.isLinux?m.path:m.path.toLowerCase()}processEvent(m){const u=this.mapPathToChange.get(this.toKey(m));let c=!1;if(u){const b=u.type,g=m.type;u.path!==m.path&&m.type===2?c=!0:b===1&&g===2?(this.mapPathToChange.delete(this.toKey(m)),this.coalesced.delete(u)):b===2&&g===1?u.type=0:b===1&&g===0||(u.type=g)}else c=!0;c&&(this.coalesced.add(m),this.mapPathToChange.set(this.toKey(m),m))}coalesce(){const m=[],u=[];return Array.from(this.coalesced).filter(c=>c.type!==2?(m.push(c),!1):!0).sort((c,b)=>c.path.length-b.path.length).filter(c=>u.some(b=>(0,P.isParent)(c.path,b,!k.isLinux))?!1:(u.push(c.path),!0)).concat(m)}}}),define(ue[205],de([0,1,13,3,4,143,17,145,57]),function(Y,e,S,k,p,P,t,T,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class f extends k.Disposable{constructor(I,m,u,c){super();this.path=I,this.onDidFilesChange=m,this.onLogMessage=u,this.verboseLogging=c,this.fileChangesDelayer=this._register(new S.ThrottledDelayer(T.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(I){this.verboseLogging=I}async startWatching(){try{const{stat:I,symbolicLink:m}=await t.SymlinkSupport.stat(this.path);if(this.isDisposed)return;let u=this.path;if(m)try{u=await(0,P.realpath)(u)}catch(c){if(this.onError(c),m.dangling)return}I.isDirectory()?this._register((0,T.watchFolder)(u,(c,b)=>{this.onFileChange({type:c==="changed"?0:c==="added"?1:2,path:(0,p.join)(this.path,(0,p.basename)(b))})},c=>this.onError(c))):this._register((0,T.watchFile)(u,c=>{this.onFileChange({type:c==="changed"?0:2,path:this.path})},c=>this.onError(c)))}catch(I){I.code!=="ENOENT"&&this.onError(I)}}onFileChange(I){this.fileChangesBuffer.push(I),this.verboseLogging&&this.onVerbose(`${I.type===1?"[ADDED]":I.type===2?"[DELETED]":"[CHANGED]"} ${I.path}`),this.fileChangesDelayer.trigger(async()=>{const m=this.fileChangesBuffer;this.fileChangesBuffer=[];const u=(0,h.coalesceEvents)(m);if(this.verboseLogging)for(const c of u)this.onVerbose(`>> normalized ${c.type===1?"[ADDED]":c.type===2?"[DELETED]":"[CHANGED]"} ${c.path}`);u.length>0&&this.onDidFilesChange(u)})}onError(I){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${I}`})}onVerbose(I){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${I}`})}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=f}),define(ue[206],de([0,1,10,35,69,57]),function(Y,e,S,k,p,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class t extends P.WatcherService{constructor(h,f,C){super();this.onDidFilesChange=h,this.onLogMessage=f,this.verboseLogging=C,this.isDisposed=!1,this.startWatching()}startWatching(){const h=this._register(new p.Client(S.FileAccess.asFileUri("bootstrap-fork",Y).fsPath,{serverName:"File Watcher (nsfw)",args:["--type=watcherServiceNSFW"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/nsfw/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this.service=k.ProxyChannel.toService((0,k.getNextTickChannel)(h.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(f=>!this.isDisposed&&this.onDidFilesChange(f))),this._register(this.service.onDidLogMessage(f=>this.onLogMessage(f)))}async setVerboseLogging(h){this.verboseLogging=h,this.isDisposed||await this.service?.setVerboseLogging(h)}error(h){this.onLogMessage({type:"error",message:`[File Watcher (nsfw)] ${h}`})}async watch(h){this.isDisposed||await this.service?.watch(h)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=t}),define(ue[207],de([0,1,10,35,69,57]),function(Y,e,S,k,p,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class t extends P.AbstractWatcherService{constructor(h,f,C){super(h,f,C);this.init()}createService(h){const f=h.add(new p.Client(S.FileAccess.asFileUri("bootstrap-fork",Y).fsPath,{serverName:"File Watcher (parcel, node.js)",args:["--type=watcherServiceParcel"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/parcel/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return h.add(f.onDidProcessExit(({code:C,signal:I})=>this.onError(`terminated by itself with code ${C}, signal: ${I}`))),k.ProxyChannel.toService((0,k.getNextTickChannel)(f.getChannel("watcher")))}}e.FileWatcher=t}),define(ue[74],de([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class S{constructor(...p){this._entries=new Map;for(let[P,t]of p)this.set(P,t)}set(p,P){const t=this._entries.get(p);return this._entries.set(p,P),t}has(p){return this._entries.has(p)}get(p){return this._entries.get(p)}}e.ServiceCollection=S}),define(ue[100],de([0,1,13,12,56,197,7,74]),function(Y,e,S,k,p,P,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const h=!1;class f extends Error{constructor(c){super("cyclic dependency between services");this.message=c.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${c.toString()}`}}class C{constructor(c=new T.ServiceCollection,b=!1,g){this._activeInstantiations=new Set,this._services=c,this._strict=b,this._parent=g,this._services.set(t.IInstantiationService,this)}createChild(c){return new C(c,this._strict,this)}invokeFunction(c,...b){let g=m.traceInvocation(c),D=!1;try{return c({get:v=>{if(D)throw(0,k.illegalState)("service accessor is only valid during the invocation of its target method");const a=this._getOrCreateServiceInstance(v,g);if(!a)throw new Error(`[invokeFunction] unknown service '${v}'`);return a}},...b)}finally{D=!0,g.stop()}}createInstance(c,...b){let g,D;return c instanceof p.SyncDescriptor?(g=m.traceCreation(c.ctor),D=this._createInstance(c.ctor,c.staticArguments.concat(b),g)):(g=m.traceCreation(c),D=this._createInstance(c,b,g)),g.stop(),D}_createInstance(c,b=[],g){let D=t._util.getServiceDependencies(c).sort((a,l)=>a.index-l.index),w=[];for(const a of D){let l=this._getOrCreateServiceInstance(a.id,g);if(!l&&this._strict&&!a.optional)throw new Error(`[createInstance] ${c.name} depends on UNKNOWN service ${a.id}.`);w.push(l)}let v=D.length>0?D[0].index:b.length;if(b.length!==v){console.warn(`[createInstance] First service dependency of ${c.name} at position ${v+1} conflicts with ${b.length} static arguments`);let a=v-b.length;a>0?b=b.concat(new Array(a)):b=b.slice(0,v)}return new c(...[...b,...w])}_setServiceInstance(c,b){if(this._services.get(c)instanceof p.SyncDescriptor)this._services.set(c,b);else if(this._parent)this._parent._setServiceInstance(c,b);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(c){let b=this._services.get(c);return!b&&this._parent?this._parent._getServiceInstanceOrDescriptor(c):b}_getOrCreateServiceInstance(c,b){let g=this._getServiceInstanceOrDescriptor(c);return g instanceof p.SyncDescriptor?this._safeCreateAndCacheServiceInstance(c,g,b.branch(c,!0)):(b.branch(c,!1),g)}_safeCreateAndCacheServiceInstance(c,b,g){if(this._activeInstantiations.has(c))throw new Error(`illegal state - RECURSIVELY instantiating service '${c}'`);this._activeInstantiations.add(c);try{return this._createAndCacheServiceInstance(c,b,g)}finally{this._activeInstantiations.delete(c)}}_createAndCacheServiceInstance(c,b,g){const D=new P.Graph(a=>a.id.toString());let w=0;const v=[{id:c,desc:b,_trace:g}];for(;v.length;){const a=v.pop();if(D.lookupOrInsertNode(a),w++>1e3)throw new f(D);for(let l of t._util.getServiceDependencies(a.desc.ctor)){let r=this._getServiceInstanceOrDescriptor(l.id);if(!r&&!l.optional&&console.warn(`[createInstance] ${c} depends on ${l.id} which is NOT registered.`),r instanceof p.SyncDescriptor){const o={id:l.id,desc:r,_trace:a._trace.branch(l.id,!0)};D.insertEdge(a,o),v.push(o)}}}for(;;){const a=D.roots();if(a.length===0){if(!D.isEmpty())throw new f(D);break}for(const{data:l}of a){if(this._getServiceInstanceOrDescriptor(l.id)instanceof p.SyncDescriptor){const o=this._createServiceInstanceWithOwner(l.id,l.desc.ctor,l.desc.staticArguments,l.desc.supportsDelayedInstantiation,l._trace);this._setServiceInstance(l.id,o)}D.removeNode(l)}}return this._getServiceInstanceOrDescriptor(c)}_createServiceInstanceWithOwner(c,b,g=[],D,w){if(this._services.get(c)instanceof p.SyncDescriptor)return this._createServiceInstance(b,g,D,w);if(this._parent)return this._parent._createServiceInstanceWithOwner(c,b,g,D,w);throw new Error(`illegalState - creating UNKNOWN service instance ${b.name}`)}_createServiceInstance(c,b=[],g,D){if(g){const w=new S.IdleValue(()=>this._createInstance(c,b,D));return new Proxy(Object.create(null),{get(v,a){if(a in v)return v[a];let l=w.value,r=l[a];return typeof r!="function"||(r=r.bind(l),v[a]=r),r},set(v,a,l){return w.value[a]=l,!0}})}else return this._createInstance(c,b,D)}}e.InstantiationService=C;var I;(function(u){u[u.Creation=0]="Creation",u[u.Invocation=1]="Invocation",u[u.Branch=2]="Branch"})(I||(I={}));class m{constructor(c,b){this.type=c,this.name=b,this._start=Date.now(),this._dep=[]}static traceInvocation(c){return h?new m(1,c.name||c.toString().substring(0,42).replace(/\n/g,"")):m._None}static traceCreation(c){return h?new m(0,c.name):m._None}branch(c,b){let g=new m(2,c.toString());return this._dep.push([c,b,g]),g}stop(){let c=Date.now()-this._start;m._totals+=c;let b=!1;function g(w,v){let a=[],l=new Array(w+1).join("	");for(const[r,o,i]of v._dep)if(o&&i){b=!0,a.push(`${l}CREATES -> ${r}`);let n=g(w+1,i);n&&a.push(n)}else a.push(`${l}uses -> ${r}`);return a.join(`
`)}let D=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${g(1,this)}`,`DONE, took ${c.toFixed(2)}ms (grand total ${m._totals.toFixed(2)}ms)`];(c>2||b)&&console.log(D.join(`
`))}}m._None=new class extends m{constructor(){super(-1,null)}stop(){}branch(){return this}},m._totals=0}),define(ue[208],de([0,1,7]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ILabelService=void 0,e.ILabelService=(0,S.createDecorator)("labelService")}),define(ue[75],de([0,1,7]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isValidLocalization=e.ILocalizationsService=void 0,e.ILocalizationsService=(0,S.createDecorator)("localizationsService");function k(p){if(typeof p.languageId!="string"||!Array.isArray(p.translations)||p.translations.length===0)return!1;for(const P of p.translations)if(typeof P.id!="string"||typeof P.path!="string")return!1;return!(p.languageName&&typeof p.languageName!="string"||p.localizedLanguageName&&typeof p.localizedLanguageName!="string")}e.isValidLocalization=k}),define(ue[16],de([0,1,37,6,3,2,7]),function(Y,e,S,k,p,P,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,t.createDecorator)("logService"),e.ILoggerService=(0,t.createDecorator)("loggerService");function T(){return new Date().toISOString()}var h;(function(o){o[o.Trace=0]="Trace",o[o.Debug=1]="Debug",o[o.Info=2]="Info",o[o.Warning=3]="Warning",o[o.Error=4]="Error",o[o.Critical=5]="Critical",o[o.Off=6]="Off"})(h=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=h.Info;function f(o,i,n){switch(i){case h.Trace:o.trace(n);break;case h.Debug:o.debug(n);break;case h.Info:o.info(n);break;case h.Warning:o.warn(n);break;case h.Error:o.error(n);break;case h.Critical:o.critical(n);break;default:throw new Error("Invalid log level")}}e.log=f;function C(o){let i="";for(let n=0;n<o.length;n++){let s=o[n];if(typeof s=="object")try{s=JSON.stringify(s)}catch(d){}i+=(n>0?" ":"")+s}return i}e.format=C;class I extends p.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new k.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(i){this.level!==i&&(this.level=i,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=I;class m extends I{constructor(i){super();this.logAlways=i}checkLogLevel(i){return this.logAlways||this.getLevel()<=i}trace(i,...n){this.checkLogLevel(h.Trace)&&this.log(h.Trace,C([i,...n]))}debug(i,...n){this.checkLogLevel(h.Debug)&&this.log(h.Debug,C([i,...n]))}info(i,...n){this.checkLogLevel(h.Info)&&this.log(h.Info,C([i,...n]))}warn(i,...n){this.checkLogLevel(h.Warning)&&this.log(h.Warning,C([i,...n]))}error(i,...n){if(this.checkLogLevel(h.Error))if(i instanceof Error){const s=Array.prototype.slice.call(arguments);s[0]=i.stack,this.log(h.Error,C(s))}else this.log(h.Error,C([i,...n]))}critical(i,...n){this.checkLogLevel(h.Critical)&&this.log(h.Critical,C([i,...n]))}flush(){}}e.AbstractMessageLogger=m;class u extends I{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i),this.useColors=!P.isWindows}trace(i,...n){this.getLevel()<=h.Trace&&(this.useColors?console.log(`[90m[main ${T()}][0m`,i,...n):console.log(`[main ${T()}]`,i,...n))}debug(i,...n){this.getLevel()<=h.Debug&&(this.useColors?console.log(`[90m[main ${T()}][0m`,i,...n):console.log(`[main ${T()}]`,i,...n))}info(i,...n){this.getLevel()<=h.Info&&(this.useColors?console.log(`[90m[main ${T()}][0m`,i,...n):console.log(`[main ${T()}]`,i,...n))}warn(i,...n){this.getLevel()<=h.Warning&&(this.useColors?console.warn(`[93m[main ${T()}][0m`,i,...n):console.warn(`[main ${T()}]`,i,...n))}error(i,...n){this.getLevel()<=h.Error&&(this.useColors?console.error(`[91m[main ${T()}][0m`,i,...n):console.error(`[main ${T()}]`,i,...n))}critical(i,...n){this.getLevel()<=h.Critical&&(this.useColors?console.error(`[90m[main ${T()}][0m`,i,...n):console.error(`[main ${T()}]`,i,...n))}dispose(){}flush(){}}e.ConsoleMainLogger=u;class c extends I{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i)}trace(i,...n){this.getLevel()<=h.Trace&&console.log("%cTRACE","color: #888",i,...n)}debug(i,...n){this.getLevel()<=h.Debug&&console.log("%cDEBUG","background: #eee; color: #888",i,...n)}info(i,...n){this.getLevel()<=h.Info&&console.log("%c INFO","color: #33f",i,...n)}warn(i,...n){this.getLevel()<=h.Warning&&console.log("%c WARN","color: #993",i,...n)}error(i,...n){this.getLevel()<=h.Error&&console.log("%c  ERR","color: #f33",i,...n)}critical(i,...n){this.getLevel()<=h.Critical&&console.log("%cCRITI","background: #f33; color: white",i,...n)}dispose(){}flush(){}}e.ConsoleLogger=c;class b extends I{constructor(i,n=e.DEFAULT_LOG_LEVEL){super();this.adapter=i,this.setLevel(n)}trace(i,...n){this.getLevel()<=h.Trace&&this.adapter.log(h.Trace,[this.extractMessage(i),...n])}debug(i,...n){this.getLevel()<=h.Debug&&this.adapter.log(h.Debug,[this.extractMessage(i),...n])}info(i,...n){this.getLevel()<=h.Info&&this.adapter.log(h.Info,[this.extractMessage(i),...n])}warn(i,...n){this.getLevel()<=h.Warning&&this.adapter.log(h.Warning,[this.extractMessage(i),...n])}error(i,...n){this.getLevel()<=h.Error&&this.adapter.log(h.Error,[this.extractMessage(i),...n])}critical(i,...n){this.getLevel()<=h.Critical&&this.adapter.log(h.Critical,[this.extractMessage(i),...n])}extractMessage(i){return typeof i=="string"?i:(0,S.toErrorMessage)(i,this.getLevel()<=h.Trace)}dispose(){}flush(){}}e.AdapterLogger=b;class g extends I{constructor(i){super();this.logServices=i,i.length&&this.setLevel(i[0].getLevel())}setLevel(i){for(const n of this.logServices)n.setLevel(i);super.setLevel(i)}trace(i,...n){for(const s of this.logServices)s.trace(i,...n)}debug(i,...n){for(const s of this.logServices)s.debug(i,...n)}info(i,...n){for(const s of this.logServices)s.info(i,...n)}warn(i,...n){for(const s of this.logServices)s.warn(i,...n)}error(i,...n){for(const s of this.logServices)s.error(i,...n)}critical(i,...n){for(const s of this.logServices)s.critical(i,...n)}flush(){for(const i of this.logServices)i.flush()}dispose(){for(const i of this.logServices)i.dispose()}}e.MultiplexLogService=g;class D extends p.Disposable{constructor(i){super();this.logger=i,this._register(i)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(i){this.logger.setLevel(i)}getLevel(){return this.logger.getLevel()}trace(i,...n){this.logger.trace(i,...n)}debug(i,...n){this.logger.debug(i,...n)}info(i,...n){this.logger.info(i,...n)}warn(i,...n){this.logger.warn(i,...n)}error(i,...n){this.logger.error(i,...n)}critical(i,...n){this.logger.critical(i,...n)}flush(){this.logger.flush()}}e.LogService=D;class w extends p.Disposable{constructor(i,n){super();this.logLevel=i,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(n(s=>{this.logLevel=s,this.logLevelChangeableLoggers.forEach(d=>d.setLevel(s))}))}getLogger(i){return this.loggers.get(i.toString())}createLogger(i,n){let s=this.loggers.get(i.toString());return s||(s=this.doCreateLogger(i,n?.always?h.Trace:this.logLevel,n),this.loggers.set(i.toString(),s),n?.always||this.logLevelChangeableLoggers.push(s)),s}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(i=>i.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=w;class v{constructor(){this.onDidChangeLogLevel=new k.Emitter().event}setLevel(i){}getLevel(){return h.Info}trace(i,...n){}debug(i,...n){}info(i,...n){}warn(i,...n){}error(i,...n){}critical(i,...n){}dispose(){}flush(){}}e.NullLogService=v;function a(o){if(o.verbose)return h.Trace;if(typeof o.logLevel=="string"){const i=l(o.logLevel.toLowerCase());if(i!==void 0)return i}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=a;function l(o){switch(o){case"trace":return h.Trace;case"debug":return h.Debug;case"info":return h.Info;case"warn":return h.Warning;case"error":return h.Error;case"critical":return h.Critical;case"off":return h.Off}}e.parseLogLevel=l;function r(o){switch(o){case h.Trace:return"trace";case h.Debug:return"debug";case h.Info:return"info";case h.Warning:return"warn";case h.Error:return"error";case h.Critical:return"critical";case h.Off:return"off"}}e.LogLevelToString=r});var je=this&&this.__param||function(Y,e){return function(S,k){e(S,k,Y)}};define(ue[209],de([0,1,41,13,37,6,3,10,4,17,28,16]),function(Y,e,S,k,p,P,t,T,h,f,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let m=class extends t.Disposable{constructor(c,b){super();this.environmentService=c,this.logService=b,this.processesLimiter=new k.Limiter(5)}async postUninstall(c){const b=this.parseScript(c,"uninstall");return b&&(this.logService.info(c.identifier.id,c.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(b.script,"uninstall",b.args,!0,c).then(()=>this.logService.info(c.identifier.id,c.manifest.version,"Finished running post uninstall script"),g=>this.logService.error(c.identifier.id,c.manifest.version,`Failed to run post uninstall script: ${g}`)))),f.Promises.rm(this.getExtensionStoragePath(c)).then(void 0,g=>this.logService.error("Error while removing extension storage path",g))}parseScript(c,b){const g=`vscode:${b}`;if(c.location.scheme===T.Schemas.file&&c.manifest&&c.manifest.scripts&&typeof c.manifest.scripts[g]=="string"){const D=c.manifest.scripts[g].split(" ");return D.length<2||D[0]!=="node"||!D[1]?(this.logService.warn(c.identifier.id,c.manifest.version,`${g} should be a node script`),null):{script:(0,h.join)(c.location.fsPath,D[1]),args:D.slice(2)||[]}}return null}runLifecycleHook(c,b,g,D,w){return new Promise((v,a)=>{const l=this.start(c,b,g,w);let r;const o=i=>{r&&(clearTimeout(r),r=null),i?a(i):v(void 0)};l.on("error",i=>{o((0,p.toErrorMessage)(i)||"Unknown")}),l.on("exit",(i,n)=>{o(i?`post-${b} process exited with code ${i}`:void 0)}),D&&(r=setTimeout(()=>{r=null,l.kill(),a("timed out")},5e3))})}start(c,b,g,D){const w={silent:!0,execArgv:void 0},v=(0,S.fork)(c,[`--type=extension-post-${b}`,...g],w);v.stdout.setEncoding("utf8"),v.stderr.setEncoding("utf8");const a=P.Event.fromNodeEventEmitter(v.stdout,"data"),l=P.Event.fromNodeEventEmitter(v.stderr,"data");a(i=>this.logService.info(D.identifier.id,D.manifest.version,`post-${b}`,i)),l(i=>this.logService.error(D.identifier.id,D.manifest.version,`post-${b}`,i));const r=P.Event.any(P.Event.map(a,i=>({data:`%c${i}`,format:[""]})),P.Event.map(l,i=>({data:`%c${i}`,format:["color: red"]})));return P.Event.debounce(r,(i,n)=>i?{data:i.data+n.data,format:[...i.format,...n.format]}:{data:n.data,format:n.format},100)(i=>{console.group(D.identifier.id),console.log(i.data,...i.format),console.groupEnd()}),v}getExtensionStoragePath(c){return(0,h.join)(this.environmentService.globalStorageHome.fsPath,c.identifier.id.toLowerCase())}};m=Ne([je(0,C.IEnvironmentService),je(1,I.ILogService)],m),e.ExtensionsLifecycle=m}),define(ue[210],de([0,1,20,13,12,6,3,4,57,16]),function(Y,e,S,k,p,P,t,T,h,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class C extends t.Disposable{constructor(m){super();this.logService=m,this._onDidErrorOccur=this._register(new P.Emitter),this.onDidErrorOccur=this._onDidErrorOccur.event,this._onDidChangeFile=this._register(new P.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new k.ThrottledDelayer(0))}watch(m,u){return u.recursive?this.watchRecursive(m,u):this.watchNonRecursive(m)}watchRecursive(m,u){const c={path:this.toFilePath(m),excludes:u.excludes},b=(0,S.insert)(this.recursiveFoldersToWatch,c);return this.refreshRecursiveWatchers(),(0,t.toDisposable)(()=>{b(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(()=>this.doRefreshRecursiveWatchers()).catch(m=>(0,p.onUnexpectedError)(m))}doRefreshRecursiveWatchers(){return this.recursiveWatcher||(this.recursiveWatcher=this._register(this.createRecursiveWatcher(m=>this._onDidChangeFile.fire((0,h.toFileChanges)(m)),m=>this.onWatcherLogMessage(m),this.logService.getLevel()===f.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher?.setVerboseLogging(this.logService.getLevel()===f.LogLevel.Trace)}))),this.doWatch(this.recursiveWatcher,this.recursiveFoldersToWatch)}doWatch(m,u){return m.watch(u)}watchNonRecursive(m){const u=this.createNonRecursiveWatcher(this.toFilePath(m),b=>this._onDidChangeFile.fire((0,h.toFileChanges)(b)),b=>this.onWatcherLogMessage(b),this.logService.getLevel()===f.LogLevel.Trace),c=this.logService.onDidChangeLogLevel(()=>{u.setVerboseLogging(this.logService.getLevel()===f.LogLevel.Trace)});return(0,t.combinedDisposable)(u,c)}onWatcherLogMessage(m){m.type==="error"&&this._onDidErrorOccur.fire(m.message),this.logService[m.type](m.message)}toFilePath(m){return(0,T.normalize)(m.fsPath)}}e.AbstractDiskFileSystemProvider=C}),define(ue[101],de([0,1,20,13,18,24,6,53,3,30,10,48,19,47,168,15,99,16]),function(Y,e,S,k,p,P,t,T,h,f,C,I,m,u,c,b,g,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let w=class St extends h.Disposable{constructor(a){super();this.logService=a,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new t.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new t.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new t.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new t.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onError=this._register(new t.Emitter),this.onError=this._onError.event,this._onDidFilesChange=this._register(new t.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidChangeFilesRaw=this._register(new t.Emitter),this.onDidChangeFilesRaw=this._onDidChangeFilesRaw.event,this.activeWatchers=new Map,this.caseSensitiveFileEventsWorker=this._register(new k.ThrottledWorker(St.FILE_EVENTS_THROTTLING.maxChangesChunkSize,St.FILE_EVENTS_THROTTLING.maxChangesBufferSize,St.FILE_EVENTS_THROTTLING.coolDownDelay,l=>this._onDidFilesChange.fire(new b.FileChangesEvent(l,!1)))),this.caseInsensitiveFileEventsWorker=this._register(new k.ThrottledWorker(St.FILE_EVENTS_THROTTLING.maxChangesChunkSize,St.FILE_EVENTS_THROTTLING.maxChangesBufferSize,St.FILE_EVENTS_THROTTLING.coolDownDelay,l=>this._onDidFilesChange.fire(new b.FileChangesEvent(l,!0)))),this.watchedResources=f.TernarySearchTree.forUris(l=>{const r=this.getProvider(l.scheme);return r?!this.isPathCaseSensitive(r):!1}),this.writeQueue=this._register(new k.ResourceQueue)}registerProvider(a,l){if(this.provider.has(a))throw new Error(`A filesystem provider for the scheme '${a}' is already registered.`);(0,I.mark)(`code/registerFilesystem/${a}`),this.provider.set(a,l),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:a,provider:l});const r=new h.DisposableStore;return r.add(l.onDidChangeFile(o=>this.onDidChangeFile(o,this.isPathCaseSensitive(l)))),r.add(l.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:l,scheme:a}))),typeof l.onDidErrorOccur=="function"&&r.add(l.onDidErrorOccur(o=>this._onError.fire(new Error(o)))),(0,h.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:a,provider:l}),this.provider.delete(a),(0,h.dispose)(r)})}getProvider(a){return this.provider.get(a)}async activateProvider(a){const l=[];this._onWillActivateFileSystemProvider.fire({scheme:a,join(r){l.push(r)}}),!this.provider.has(a)&&await k.Promises.settled(l)}async canHandleResource(a){return await this.activateProvider(a.scheme),this.hasProvider(a)}hasProvider(a){return this.provider.has(a.scheme)}hasCapability(a,l){const r=this.provider.get(a.scheme);return!!(r&&r.capabilities&l)}listCapabilities(){return T.Iterable.map(this.provider,([a,l])=>({scheme:a,capabilities:l.capabilities}))}async withProvider(a){if(!(0,m.isAbsolutePath)(a))throw new b.FileOperationError((0,c.localize)(0,null,this.resourceForError(a)),8);await this.activateProvider(a.scheme);const l=this.provider.get(a.scheme);if(!l){const r=new Error;throw r.name="ENOPRO",r.message=(0,c.localize)(1,null,a.toString()),r}return l}async withReadProvider(a){const l=await this.withProvider(a);if((0,b.hasOpenReadWriteCloseCapability)(l)||(0,b.hasReadWriteCapability)(l)||(0,b.hasFileReadStreamCapability)(l))return l;throw new Error(`Filesystem provider for scheme '${a.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(a){const l=await this.withProvider(a);if((0,b.hasOpenReadWriteCloseCapability)(l)||(0,b.hasReadWriteCapability)(l))return l;throw new Error(`Filesystem provider for scheme '${a.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(a,l){try{return await this.doResolveFile(a,l)}catch(r){throw(0,b.toFileSystemProviderErrorCode)(r)===b.FileSystemProviderErrorCode.FileNotFound?new b.FileOperationError((0,c.localize)(2,null,this.resourceForError(a)),1):(0,b.ensureFileSystemProviderError)(r)}}async doResolveFile(a,l){const r=await this.withProvider(a),o=this.isPathCaseSensitive(r),i=l?.resolveTo,n=l?.resolveSingleChildDescendants,s=l?.resolveMetadata,d=await r.stat(a);let y;return this.toFileStat(r,a,d,void 0,!!s,(A,E)=>(y||(y=f.TernarySearchTree.forUris(()=>!o),y.set(a,!0),i&&y.fill(!0,i)),y.get(A.resource)||y.findSuperstr(A.resource.with({query:null,fragment:null}))?!0:A.isDirectory&&n?E===1:!1))}async toFileStat(a,l,r,o,i,n){const{providerExtUri:s}=this.getExtUri(a),d={resource:l,name:s.basename(l),isFile:(r.type&b.FileType.File)!=0,isDirectory:(r.type&b.FileType.Directory)!=0,isSymbolicLink:(r.type&b.FileType.SymbolicLink)!=0,mtime:r.mtime,ctime:r.ctime,size:r.size,readonly:Boolean((r.permissions??0)&b.FilePermission.Readonly)||Boolean(a.capabilities&2048),etag:(0,b.etag)({mtime:r.mtime,size:r.size})};if(d.isDirectory&&n(d,o)){try{const y=await a.readdir(l),A=await k.Promises.settled(y.map(async([E,R])=>{try{const O=s.joinPath(l,E),K=i?await a.stat(O):{type:R};return await this.toFileStat(a,O,K,y.length,i,n)}catch(O){return this.logService.trace(O),null}}));d.children=(0,S.coalesce)(A)}catch(y){this.logService.trace(y),d.children=[]}return d}return d}async resolveAll(a){return k.Promises.settled(a.map(async l=>{try{return{stat:await this.doResolveFile(l.resource,l.options),success:!0}}catch(r){return this.logService.trace(r),{stat:void 0,success:!1}}}))}async exists(a){const l=await this.withProvider(a);try{return!!await l.stat(a)}catch(r){return!1}}async canCreateFile(a,l){try{await this.doValidateCreateFile(a,l)}catch(r){return r}return!0}async doValidateCreateFile(a,l){if(!l?.overwrite&&await this.exists(a))throw new b.FileOperationError((0,c.localize)(3,null,this.resourceForError(a)),3,l)}async createFile(a,l=p.VSBuffer.fromString(""),r){await this.doValidateCreateFile(a,r);const o=await this.writeFile(a,l);return this._onDidRunOperation.fire(new b.FileOperationEvent(a,0,o)),o}async writeFile(a,l,r){const o=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a),{providerExtUri:i}=this.getExtUri(o);try{await this.validateWriteFile(o,a,r)||await this.mkdirp(o,i.dirname(a));let s;if((0,b.hasReadWriteCapability)(o)&&!(l instanceof p.VSBuffer))if((0,u.isReadableStream)(l)){const d=await(0,u.peekStream)(l,3);d.ended?s=p.VSBuffer.concat(d.buffer):s=d}else s=(0,u.peekReadable)(l,d=>p.VSBuffer.concat(d),3);else s=l;!(0,b.hasOpenReadWriteCloseCapability)(o)||(0,b.hasReadWriteCapability)(o)&&s instanceof p.VSBuffer?await this.doWriteUnbuffered(o,a,r,s):await this.doWriteBuffered(o,a,r,s instanceof p.VSBuffer?(0,p.bufferToReadable)(s):s)}catch(n){throw new b.FileOperationError((0,c.localize)(4,null,this.resourceForError(a),(0,b.ensureFileSystemProviderError)(n).toString()),(0,b.toFileOperationResult)(n),r)}return this.resolve(a,{resolveMetadata:!0})}async validateWriteFile(a,l,r){if(!!r?.unlock&&!(a.capabilities&8192))throw new Error((0,c.localize)(5,null,this.resourceForError(l)));let i;try{i=await a.stat(l)}catch(n){return}if((i.type&b.FileType.Directory)!=0)throw new b.FileOperationError((0,c.localize)(6,null,this.resourceForError(l)),0,r);if(this.throwIfFileIsReadonly(l,i),typeof r?.mtime=="number"&&typeof r.etag=="string"&&r.etag!==b.ETAG_DISABLED&&typeof i.mtime=="number"&&typeof i.size=="number"&&r.mtime<i.mtime&&r.etag!==(0,b.etag)({mtime:r.mtime,size:i.size}))throw new b.FileOperationError((0,c.localize)(7,null),3,r);return i}async readFile(a,l){const r=await this.withReadProvider(a);return l?.atomic?this.doReadFileAtomic(r,a,l):this.doReadFile(r,a,l)}async doReadFileAtomic(a,l,r){return new Promise((o,i)=>{this.writeQueue.queueFor(l,this.getExtUri(a).providerExtUri).queue(async()=>{try{const n=await this.doReadFile(a,l,r);o(n)}catch(n){i(n)}})})}async doReadFile(a,l,r){const o=await this.doReadFileStream(a,l,{...r,preferUnbuffered:!0});return{...o,value:await(0,p.streamToBuffer)(o.value)}}async readFileStream(a,l){const r=await this.withReadProvider(a);return this.doReadFileStream(r,a,l)}async doReadFileStream(a,l,r){const o=new P.CancellationTokenSource,i=this.validateReadFile(l,r).then(s=>s,s=>{throw o.cancel(),s});let n;try{return typeof r?.etag=="string"&&r.etag!==b.ETAG_DISABLED&&await i,!((0,b.hasOpenReadWriteCloseCapability)(a)||(0,b.hasFileReadStreamCapability)(a))||(0,b.hasReadWriteCapability)(a)&&r?.preferUnbuffered?n=this.readFileUnbuffered(a,l,r):(0,b.hasFileReadStreamCapability)(a)?n=this.readFileStreamed(a,l,o.token,r):n=this.readFileBuffered(a,l,o.token,r),{...await i,value:n}}catch(s){n&&await(0,u.consumeStream)(n);const d=(0,c.localize)(8,null,this.resourceForError(l),(0,b.ensureFileSystemProviderError)(s).toString());throw s instanceof b.NotModifiedSinceFileOperationError?new b.NotModifiedSinceFileOperationError(d,s.stat,r):new b.FileOperationError(d,(0,b.toFileOperationResult)(s),r)}}readFileStreamed(a,l,r,o=Object.create(null)){const i=a.readFileStream(l,o,r);return(0,u.transform)(i,{data:n=>n instanceof p.VSBuffer?n:p.VSBuffer.wrap(n),error:n=>new b.FileOperationError((0,c.localize)(9,null,this.resourceForError(l),(0,b.ensureFileSystemProviderError)(n).toString()),(0,b.toFileOperationResult)(n),o)},n=>p.VSBuffer.concat(n))}readFileBuffered(a,l,r,o=Object.create(null)){const i=(0,p.newWriteableBufferStream)();return(0,g.readFileIntoStream)(a,l,i,n=>n,{...o,bufferSize:this.BUFFER_SIZE,errorTransformer:n=>new b.FileOperationError((0,c.localize)(10,null,this.resourceForError(l),(0,b.ensureFileSystemProviderError)(n).toString()),(0,b.toFileOperationResult)(n),o)},r),i}readFileUnbuffered(a,l,r){const o=(0,u.newWriteableStream)(i=>p.VSBuffer.concat(i));return(async()=>{try{let i=await a.readFile(l);typeof r?.position=="number"&&(i=i.slice(r.position)),typeof r?.length=="number"&&(i=i.slice(0,r.length)),this.validateReadFileLimits(l,i.byteLength,r),o.end(p.VSBuffer.wrap(i))}catch(i){o.error(i),o.end()}})(),o}async validateReadFile(a,l){const r=await this.resolve(a,{resolveMetadata:!0});if(r.isDirectory)throw new b.FileOperationError((0,c.localize)(11,null,this.resourceForError(a)),0,l);if(typeof l?.etag=="string"&&l.etag!==b.ETAG_DISABLED&&l.etag===r.etag)throw new b.NotModifiedSinceFileOperationError((0,c.localize)(12,null),r,l);return this.validateReadFileLimits(a,r.size,l),r}validateReadFileLimits(a,l,r){if(r?.limits){let o;if(typeof r.limits.memory=="number"&&l>r.limits.memory&&(o=9),typeof r.limits.size=="number"&&l>r.limits.size&&(o=7),typeof o=="number")throw new b.FileOperationError((0,c.localize)(13,null,this.resourceForError(a)),o)}}async canMove(a,l,r){return this.doCanMoveCopy(a,l,"move",r)}async canCopy(a,l,r){return this.doCanMoveCopy(a,l,"copy",r)}async doCanMoveCopy(a,l,r,o){if(a.toString()!==l.toString())try{const i=r==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a):await this.withReadProvider(a),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l);await this.doValidateMoveCopy(i,a,n,l,r,o)}catch(i){return i}return!0}async move(a,l,r){const o=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l),n=await this.doMoveCopy(o,a,i,l,"move",!!r),s=await this.resolve(l,{resolveMetadata:!0});return this._onDidRunOperation.fire(new b.FileOperationEvent(a,n==="move"?2:3,s)),s}async copy(a,l,r){const o=await this.withReadProvider(a),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l),n=await this.doMoveCopy(o,a,i,l,"copy",!!r),s=await this.resolve(l,{resolveMetadata:!0});return this._onDidRunOperation.fire(new b.FileOperationEvent(a,n==="copy"?3:2,s)),s}async doMoveCopy(a,l,r,o,i,n){if(l.toString()===o.toString())return i;const{exists:s,isSameResourceWithDifferentPathCase:d}=await this.doValidateMoveCopy(a,l,r,o,i,n);if(s&&!d&&n&&await this.del(o,{recursive:!0}),await this.mkdirp(r,this.getExtUri(r).providerExtUri.dirname(o)),i==="copy"){if(a===r&&(0,b.hasFileFolderCopyCapability)(a))await a.copy(l,o,{overwrite:n});else{const y=await this.resolve(l);y.isDirectory?await this.doCopyFolder(a,y,r,o):await this.doCopyFile(a,l,r,o)}return i}else return a===r?(await a.rename(l,o,{overwrite:n}),i):(await this.doMoveCopy(a,l,r,o,"copy",n),await this.del(l,{recursive:!0}),"copy")}async doCopyFile(a,l,r,o){if((0,b.hasOpenReadWriteCloseCapability)(a)&&(0,b.hasOpenReadWriteCloseCapability)(r))return this.doPipeBuffered(a,l,r,o);if((0,b.hasOpenReadWriteCloseCapability)(a)&&(0,b.hasReadWriteCapability)(r))return this.doPipeBufferedToUnbuffered(a,l,r,o);if((0,b.hasReadWriteCapability)(a)&&(0,b.hasOpenReadWriteCloseCapability)(r))return this.doPipeUnbufferedToBuffered(a,l,r,o);if((0,b.hasReadWriteCapability)(a)&&(0,b.hasReadWriteCapability)(r))return this.doPipeUnbuffered(a,l,r,o)}async doCopyFolder(a,l,r,o){await r.mkdir(o),Array.isArray(l.children)&&await k.Promises.settled(l.children.map(async i=>{const n=this.getExtUri(r).providerExtUri.joinPath(o,i.name);return i.isDirectory?this.doCopyFolder(a,await this.resolve(i.resource),r,n):this.doCopyFile(a,i.resource,r,n)}))}async doValidateMoveCopy(a,l,r,o,i,n){let s=!1;if(a===r){const{providerExtUri:y,isPathCaseSensitive:A}=this.getExtUri(a);if(A||(s=y.isEqual(l,o)),s&&i==="copy")throw new Error((0,c.localize)(14,null,this.resourceForError(l),this.resourceForError(o)));if(!s&&y.isEqualOrParent(o,l))throw new Error((0,c.localize)(15,null,this.resourceForError(l),this.resourceForError(o)))}const d=await this.exists(o);if(d&&!s){if(!n)throw new b.FileOperationError((0,c.localize)(16,null,this.resourceForError(l),this.resourceForError(o)),4);if(a===r){const{providerExtUri:y}=this.getExtUri(a);if(y.isEqualOrParent(l,o))throw new Error((0,c.localize)(17,null,this.resourceForError(l),this.resourceForError(o)))}}return{exists:d,isSameResourceWithDifferentPathCase:s}}getExtUri(a){const l=this.isPathCaseSensitive(a);return{providerExtUri:l?m.extUri:m.extUriIgnorePathCase,isPathCaseSensitive:l}}isPathCaseSensitive(a){return!!(a.capabilities&1024)}async createFolder(a){const l=this.throwIfFileSystemIsReadonly(await this.withProvider(a),a);await this.mkdirp(l,a);const r=await this.resolve(a,{resolveMetadata:!0});return this._onDidRunOperation.fire(new b.FileOperationEvent(a,0,r)),r}async mkdirp(a,l){const r=[],{providerExtUri:o}=this.getExtUri(a);for(;!o.isEqual(l,o.dirname(l));)try{if(((await a.stat(l)).type&b.FileType.Directory)==0)throw new Error((0,c.localize)(18,null,this.resourceForError(l)));break}catch(i){if((0,b.toFileSystemProviderErrorCode)(i)!==b.FileSystemProviderErrorCode.FileNotFound)throw i;r.push(o.basename(l)),l=o.dirname(l)}for(let i=r.length-1;i>=0;i--){l=o.joinPath(l,r[i]);try{await a.mkdir(l)}catch(n){if((0,b.toFileSystemProviderErrorCode)(n)!==b.FileSystemProviderErrorCode.FileExists)throw n}}}async canDelete(a,l){try{await this.doValidateDelete(a,l)}catch(r){return r}return!0}async doValidateDelete(a,l){const r=this.throwIfFileSystemIsReadonly(await this.withProvider(a),a);if(!!l?.useTrash&&!(r.capabilities&4096))throw new Error((0,c.localize)(19,null,this.resourceForError(a)));let i;try{i=await r.stat(a)}catch(s){}if(i)this.throwIfFileIsReadonly(a,i);else throw new b.FileOperationError((0,c.localize)(20,null,this.resourceForError(a)),1);if(!!!l?.recursive){const s=await this.resolve(a);if(s.isDirectory&&Array.isArray(s.children)&&s.children.length>0)throw new Error((0,c.localize)(21,null,this.resourceForError(a)))}return r}async del(a,l){const r=await this.doValidateDelete(a,l),o=!!l?.useTrash,i=!!l?.recursive;await r.delete(a,{recursive:i,useTrash:o}),this._onDidRunOperation.fire(new b.FileOperationEvent(a,1))}onDidChangeFile(a,l){this._onDidChangeFilesRaw.fire({changes:a});let r,o;{for(const i of a)this.watchedResources.has(i.resource)?(r||(r=[]),r.push(i)):(o||(o=[]),o.push(i));r&&this._onDidFilesChange.fire(new b.FileChangesEvent(r,!l))}if(o){const i=l?this.caseSensitiveFileEventsWorker:this.caseInsensitiveFileEventsWorker;!i.work(o)&&St.FILE_EVENTS_THROTTLING.warningscounter++<10&&this.logService.warn(`[File watcher]: started ignoring events due to too many file change events at once (incoming: ${o.length}, most recent change: ${o[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`),i.pending>0&&this.logService.trace(`[File watcher]: started throttling events due to large amount of file change events at once (pending: ${i.pending}, most recent change: ${o[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}watch(a,l={recursive:!1,excludes:[]}){const r=new h.DisposableStore;let o=!1,i=()=>{o=!0};return r.add((0,h.toDisposable)(()=>i())),this.doWatch(a,l).then(n=>{o?(0,h.dispose)(n):i=()=>(0,h.dispose)(n)},n=>this.logService.error(n)),l.recursive||(this.watchedResources.set(a,(this.watchedResources.get(a)??0)+1),r.add((0,h.toDisposable)(()=>{const n=this.watchedResources.get(a);typeof n=="number"&&(n<=1?this.watchedResources.delete(a):this.watchedResources.set(a,n-1))}))),r}async doWatch(a,l){const r=await this.withProvider(a),o=this.toWatchKey(r,a,l);let i=this.activeWatchers.get(o);return i||(i={count:0,disposable:r.watch(a,l)},this.activeWatchers.set(o,i)),i.count+=1,(0,h.toDisposable)(()=>{i&&(i.count--,i.count===0&&((0,h.dispose)(i.disposable),this.activeWatchers.delete(o)))})}toWatchKey(a,l,r){const{providerExtUri:o}=this.getExtUri(a);return[o.getComparisonKey(l),String(r.recursive),r.excludes.join()].join()}dispose(){super.dispose();for(const[,a]of this.activeWatchers)(0,h.dispose)(a.disposable);this.activeWatchers.clear()}async doWriteBuffered(a,l,r,o){return this.writeQueue.queueFor(l,this.getExtUri(a).providerExtUri).queue(async()=>{const i=await a.open(l,{create:!0,unlock:r?.unlock??!1});try{(0,u.isReadableStream)(o)||(0,u.isReadableBufferedStream)(o)?await this.doWriteStreamBufferedQueued(a,i,o):await this.doWriteReadableBufferedQueued(a,i,o)}catch(n){throw(0,b.ensureFileSystemProviderError)(n)}finally{await a.close(i)}})}async doWriteStreamBufferedQueued(a,l,r){let o=0,i;if((0,u.isReadableBufferedStream)(r)){if(r.buffer.length>0){const n=p.VSBuffer.concat(r.buffer);await this.doWriteBuffer(a,l,n,n.byteLength,o,0),o+=n.byteLength}if(r.ended)return;i=r.stream}else i=r;return new Promise((n,s)=>{(0,u.listenStream)(i,{onData:async d=>{i.pause();try{await this.doWriteBuffer(a,l,d,d.byteLength,o,0)}catch(y){return s(y)}o+=d.byteLength,setTimeout(()=>i.resume())},onError:d=>s(d),onEnd:()=>n()})})}async doWriteReadableBufferedQueued(a,l,r){let o=0,i;for(;(i=r.read())!==null;)await this.doWriteBuffer(a,l,i,i.byteLength,o,0),o+=i.byteLength}async doWriteBuffer(a,l,r,o,i,n){let s=0;for(;s<o;)s+=await a.write(l,i+s,r.buffer,n+s,o-s)}async doWriteUnbuffered(a,l,r,o){return this.writeQueue.queueFor(l,this.getExtUri(a).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(a,l,r,o))}async doWriteUnbufferedQueued(a,l,r,o){let i;o instanceof p.VSBuffer?i=o:(0,u.isReadableStream)(o)?i=await(0,p.streamToBuffer)(o):(0,u.isReadableBufferedStream)(o)?i=await(0,p.bufferedStreamToBuffer)(o):i=(0,p.readableToBuffer)(o),await a.writeFile(l,i.buffer,{create:!0,overwrite:!0,unlock:r?.unlock??!1})}async doPipeBuffered(a,l,r,o){return this.writeQueue.queueFor(o,this.getExtUri(r).providerExtUri).queue(()=>this.doPipeBufferedQueued(a,l,r,o))}async doPipeBufferedQueued(a,l,r,o){let i,n;try{i=await a.open(l,{create:!1}),n=await r.open(o,{create:!0,unlock:!1});const s=p.VSBuffer.alloc(this.BUFFER_SIZE);let d=0,y=0,A=0;do A=await a.read(i,d,s.buffer,y,s.byteLength-y),await this.doWriteBuffer(r,n,s,A,d,y),d+=A,y+=A,y===s.byteLength&&(y=0);while(A>0)}catch(s){throw(0,b.ensureFileSystemProviderError)(s)}finally{await k.Promises.settled([typeof i=="number"?a.close(i):Promise.resolve(),typeof n=="number"?r.close(n):Promise.resolve()])}}async doPipeUnbuffered(a,l,r,o){return this.writeQueue.queueFor(o,this.getExtUri(r).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(a,l,r,o))}async doPipeUnbufferedQueued(a,l,r,o){return r.writeFile(o,await a.readFile(l),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(a,l,r,o){return this.writeQueue.queueFor(o,this.getExtUri(r).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(a,l,r,o))}async doPipeUnbufferedToBufferedQueued(a,l,r,o){const i=await r.open(o,{create:!0,unlock:!1});try{const n=await a.readFile(l);await this.doWriteBuffer(r,i,p.VSBuffer.wrap(n),n.byteLength,0,0)}catch(n){throw(0,b.ensureFileSystemProviderError)(n)}finally{await r.close(i)}}async doPipeBufferedToUnbuffered(a,l,r,o){const i=await(0,p.streamToBuffer)(this.readFileBuffered(a,l,P.CancellationToken.None));await this.doWriteUnbuffered(r,o,void 0,i)}throwIfFileSystemIsReadonly(a,l){if(a.capabilities&2048)throw new b.FileOperationError((0,c.localize)(22,null,this.resourceForError(l)),6);return a}throwIfFileIsReadonly(a,l){if((l.permissions??0)&b.FilePermission.Readonly)throw new b.FileOperationError((0,c.localize)(23,null,this.resourceForError(a)),6)}resourceForError(a){return a.scheme===C.Schemas.file?a.fsPath:a.toString(!0)}};w.FILE_EVENTS_THROTTLING={maxChangesChunkSize:500,maxChangesBufferSize:3e4,coolDownDelay:200,warningscounter:0},w=Ne([je(0,D.ILogService)],w),e.FileService=w}),define(ue[76],de([0,1,32,281,13,18,6,31,4,2,19,47,17,171,15,99,205,206,207,210,37]),function(Y,e,S,k,p,P,t,T,h,f,C,I,m,u,c,b,g,D,w,v,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,k.gracefulify)(S)}catch(r){console.error(`Error enabling graceful-fs: ${(0,a.toErrorMessage)(r)}`)}})();class l extends v.AbstractDiskFileSystemProvider{constructor(o,i){super(o);this.options=i,this.onDidChangeCapabilities=t.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Map,this.canFlush=!0}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192,f.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(o){try{const{stat:i,symbolicLink:n}=await m.SymlinkSupport.stat(this.toFilePath(o));return{type:this.toType(i,n),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size}}catch(i){throw this.toFileSystemProviderError(i)}}async readdir(o){try{const i=await m.Promises.readdir(this.toFilePath(o),{withFileTypes:!0}),n=[];return await Promise.all(i.map(async s=>{try{let d;s.isSymbolicLink()?d=(await this.stat((0,C.joinPath)(o,s.name))).type:d=this.toType(s),n.push([s.name,d])}catch(d){this.logService.trace(d)}})),n}catch(i){throw this.toFileSystemProviderError(i)}}toType(o,i){let n;return i?.dangling?n=c.FileType.Unknown:o.isFile()?n=c.FileType.File:o.isDirectory()?n=c.FileType.Directory:n=c.FileType.Unknown,i&&(n|=c.FileType.SymbolicLink),n}async readFile(o){try{const i=this.toFilePath(o);return await m.Promises.readFile(i)}catch(i){throw this.toFileSystemProviderError(i)}}readFileStream(o,i,n){const s=(0,I.newWriteableStream)(d=>P.VSBuffer.concat(d.map(y=>P.VSBuffer.wrap(y))).buffer);return(0,b.readFileIntoStream)(this,o,s,d=>d.buffer,{...i,bufferSize:256*1024},n),s}async writeFile(o,i,n){let s;try{const d=this.toFilePath(o);if(!n.create||!n.overwrite){if(await m.Promises.exists(d)){if(!n.overwrite)throw(0,c.createFileSystemProviderError)((0,u.localize)(0,null),c.FileSystemProviderErrorCode.FileExists)}else if(!n.create)throw(0,c.createFileSystemProviderError)((0,u.localize)(1,null),c.FileSystemProviderErrorCode.FileNotFound)}s=await this.open(o,{create:!0,unlock:n.unlock}),await this.write(s,0,i,0,i.byteLength)}catch(d){throw await this.toFileSystemProviderWriteError(o,d)}finally{typeof s=="number"&&await this.close(s)}}async open(o,i){try{const n=this.toFilePath(o);if((0,c.isFileOpenForWriteOptions)(i)&&i.unlock)try{const{stat:y}=await m.SymlinkSupport.stat(n);y.mode&128||await m.Promises.chmod(n,y.mode|128)}catch(y){this.logService.trace(y)}let s;if((0,c.isFileOpenForWriteOptions)(i)){if(f.isWindows)try{await m.Promises.truncate(n,0),s="r+"}catch(y){y.code!=="ENOENT"&&this.logService.trace(y)}s||(s="w")}else s="r";const d=await m.Promises.open(n,s);return this.mapHandleToPos.set(d,0),(0,c.isFileOpenForWriteOptions)(i)&&this.writeHandles.set(d,o),d}catch(n){throw(0,c.isFileOpenForWriteOptions)(i)?await this.toFileSystemProviderWriteError(o,n):this.toFileSystemProviderError(n)}}async close(o){try{if(this.mapHandleToPos.delete(o),this.writeHandles.delete(o)&&this.canFlush)try{await m.Promises.fdatasync(o)}catch(i){this.canFlush=!1,this.logService.error(i)}return await m.Promises.close(o)}catch(i){throw this.toFileSystemProviderError(i)}}async read(o,i,n,s,d){const y=this.normalizePos(o,i);let A=null;try{const E=await m.Promises.read(o,n,s,d,y);return typeof E=="number"?A=E:A=E.bytesRead,A}catch(E){throw this.toFileSystemProviderError(E)}finally{this.updatePos(o,y,A)}}normalizePos(o,i){return i===this.mapHandleToPos.get(o)?null:i}updatePos(o,i,n){const s=this.mapHandleToPos.get(o);typeof s=="number"&&(typeof i=="number"||(typeof n=="number"?this.mapHandleToPos.set(o,s+n):this.mapHandleToPos.delete(o)))}async write(o,i,n,s,d){return(0,p.retry)(()=>this.doWrite(o,i,n,s,d),100,3)}async doWrite(o,i,n,s,d){const y=this.normalizePos(o,i);let A=null;try{const E=await m.Promises.write(o,n,s,d,y);return typeof E=="number"?A=E:A=E.bytesWritten,A}catch(E){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(o),E)}finally{this.updatePos(o,y,A)}}async mkdir(o){try{await m.Promises.mkdir(this.toFilePath(o))}catch(i){throw this.toFileSystemProviderError(i)}}async delete(o,i){try{const n=this.toFilePath(o);await this.doDelete(n,i)}catch(n){throw this.toFileSystemProviderError(n)}}async doDelete(o,i){i.recursive?await m.Promises.rm(o,m.RimRafMode.MOVE):await m.Promises.unlink(o)}async rename(o,i,n){const s=this.toFilePath(o),d=this.toFilePath(i);if(s!==d)try{await this.validateTargetDeleted(o,i,"move",n.overwrite),await m.Promises.move(s,d)}catch(y){throw(y.code==="EINVAL"||y.code==="EBUSY"||y.code==="ENAMETOOLONG")&&(y=new Error((0,u.localize)(2,null,(0,h.basename)(s),(0,h.basename)((0,h.dirname)(d)),y.toString()))),this.toFileSystemProviderError(y)}}async copy(o,i,n){const s=this.toFilePath(o),d=this.toFilePath(i);if(s!==d)try{await this.validateTargetDeleted(o,i,"copy",n.overwrite),await m.Promises.copy(s,d,{preserveSymlinks:!0})}catch(y){throw(y.code==="EINVAL"||y.code==="EBUSY"||y.code==="ENAMETOOLONG")&&(y=new Error((0,u.localize)(3,null,(0,h.basename)(s),(0,h.basename)((0,h.dirname)(d)),y.toString()))),this.toFileSystemProviderError(y)}}async validateTargetDeleted(o,i,n,s){const d=this.toFilePath(o),y=this.toFilePath(i);let A=!1;if(!!(this.capabilities&1024)||(A=(0,T.isEqual)(d,y,!0)),A&&n==="copy")throw(0,c.createFileSystemProviderError)((0,u.localize)(4,null),c.FileSystemProviderErrorCode.FileExists);if(!A&&await m.Promises.exists(y)){if(!s)throw(0,c.createFileSystemProviderError)((0,u.localize)(5,null),c.FileSystemProviderErrorCode.FileExists);await this.delete(i,{recursive:!0,useTrash:!1})}}createRecursiveWatcher(o,i,n){let s,d=!1;return this.options?.watcher?.usePolling?d=!1:d=this.options?.legacyWatcher==="on",d?s=D.FileWatcher:s=w.FileWatcher,new s(y=>o(y),y=>i(y),n,this.options?.watcher)}doWatch(o,i){const n=this.options?.watcher?.usePolling;if(n===!0)for(const s of i)s.pollingInterval=this.options?.watcher?.pollingInterval??5e3;else if(Array.isArray(n))for(const s of i)n.includes(s.path)&&(s.pollingInterval=this.options?.watcher?.pollingInterval??5e3);return super.doWatch(o,i)}createNonRecursiveWatcher(o,i,n,s){return new g.FileWatcher(o,d=>i(d),d=>n(d),s)}toFileSystemProviderError(o){if(o instanceof c.FileSystemProviderError)return o;let i;switch(o.code){case"ENOENT":i=c.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":i=c.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":i=c.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":i=c.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":i=c.FileSystemProviderErrorCode.NoPermissions;break;default:i=c.FileSystemProviderErrorCode.Unknown}return(0,c.createFileSystemProviderError)(o,i)}async toFileSystemProviderWriteError(o,i){let n=this.toFileSystemProviderError(i);if(o&&n.code===c.FileSystemProviderErrorCode.NoPermissions)try{const{stat:s}=await m.SymlinkSupport.stat(this.toFilePath(o));s.mode&128||(n=(0,c.createFileSystemProviderError)(i,c.FileSystemProviderErrorCode.FileWriteLocked))}catch(s){this.logService.trace(s)}return n}}e.DiskFileSystemProvider=l}),define(ue[102],de([0,1,6,5,16]),function(Y,e,S,k,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class P{constructor(m){this.service=m,this.onDidChangeLogLevel=S.Event.buffer(m.onDidChangeLogLevel,!0)}listen(m,u){switch(u){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${u}`)}async call(m,u,c){switch(u){case"setLevel":return this.service.setLevel(c)}throw new Error(`Call not found: ${u}`)}}e.LogLevelChannel=P;class t{constructor(m){this.channel=m}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(m){t.setLevel(this.channel,m)}static setLevel(m,u){return m.call("setLevel",u)}}e.LogLevelChannelClient=t;class T{constructor(m){this.loggerService=m,this.loggers=new Map}listen(m,u){throw new Error(`Event not found: ${u}`)}async call(m,u,c){switch(u){case"createLogger":this.createLogger(k.URI.revive(c[0]),c[1]);return;case"log":return this.log(k.URI.revive(c[0]),c[1]);case"consoleLog":return this.consoleLog(c[0],c[1])}throw new Error(`Call not found: ${u}`)}createLogger(m,u){this.loggers.set(m.toString(),this.loggerService.createLogger(m,u))}consoleLog(m,u){let c=console.log;switch(m){case p.LogLevel.Error:c=console.error;break;case p.LogLevel.Warning:c=console.warn;break;case p.LogLevel.Info:c=console.info;break}c.call(console,...u)}log(m,u){const c=this.loggers.get(m.toString());if(!c)throw new Error("Create the logger before logging");for(const[b,g]of u)(0,p.log)(c,b,g)}}e.LoggerChannel=T;class h extends p.AbstractLoggerService{constructor(m,u,c){super(m,u);this.channel=c}createConsoleMainLogger(){return new p.AdapterLogger({log:(m,u)=>{this.channel.call("consoleLog",[m,u])}})}doCreateLogger(m,u,c){return new f(this.channel,m,u,c)}}e.LoggerChannelClient=h;class f extends p.AbstractMessageLogger{constructor(m,u,c,b){super(b?.always);this.channel=m,this.file=u,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(c),this.channel.call("createLogger",[u,b]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(m,u){const c=[[m,u]];this.isLoggerCreated?this.doLog(c):this.buffer.push(...c)}doLog(m){this.channel.call("log",[this.file,m])}}class C extends p.LogService{constructor(m,u){super(u);this.parent=m,this._register(m.onDidChangeLogLevel(c=>u.setLevel(c)))}setLevel(m){super.setLevel(m),this.parent.setLevel(m)}}e.FollowerLogService=C}),define(ue[103],de([0,1,15,16]),function(Y,e,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;async function p(T,h,f,C,I){try{const m=await new Promise((c,b)=>{Y(["spdlog"],c,b)});m.setFlushOn(k.LogLevel.Trace);const u=await m.createAsyncRotatingLogger(T,h,f,C);return I&&u.clearFormatters(),u}catch(m){console.error(m)}return null}function P(T,h,f){switch(h){case k.LogLevel.Trace:T.trace(f);break;case k.LogLevel.Debug:T.debug(f);break;case k.LogLevel.Info:T.info(f);break;case k.LogLevel.Warning:T.warn(f);break;case k.LogLevel.Error:T.error(f);break;case k.LogLevel.Critical:T.critical(f);break;default:throw new Error("Invalid log level")}}class t extends k.AbstractMessageLogger{constructor(h,f,C,I,m){super();this.buffer=[],this.setLevel(m),this._loggerCreationPromise=this._createSpdLogLogger(h,f,C,I),this._register(this.onDidChangeLogLevel(u=>{this._logger&&this._logger.setLevel(u)}))}async _createSpdLogLogger(h,f,C,I){const m=C?6:1,u=30/m*S.ByteSize.MB,c=await p(h,f,u,m,I);if(c){this._logger=c,this._logger.setLevel(this.getLevel());for(const{level:b,message:g}of this.buffer)P(this._logger,b,g);this.buffer=[]}}log(h,f){this._logger?P(this._logger,h,f):this.getLevel()<=h&&this.buffer.push({level:h,message:f})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=t}),define(ue[211],de([0,1,62,172,7]),function(Y,e,S,k,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var P;(function(h){h[h.Unnecessary=1]="Unnecessary",h[h.Deprecated=2]="Deprecated"})(P=e.MarkerTag||(e.MarkerTag={}));var t;(function(h){h[h.Hint=1]="Hint",h[h.Info=2]="Info",h[h.Warning=4]="Warning",h[h.Error=8]="Error"})(t=e.MarkerSeverity||(e.MarkerSeverity={})),function(h){function f(c,b){return b-c}h.compare=f;const C=Object.create(null);C[h.Error]=(0,k.localize)(0,null),C[h.Warning]=(0,k.localize)(1,null),C[h.Info]=(0,k.localize)(2,null);function I(c){return C[c]||""}h.toString=I;function m(c){switch(c){case S.default.Error:return h.Error;case S.default.Warning:return h.Warning;case S.default.Info:return h.Info;case S.default.Ignore:return h.Hint}}h.fromSeverity=m;function u(c){switch(c){case h.Error:return S.default.Error;case h.Warning:return S.default.Warning;case h.Info:return S.default.Info;case h.Hint:return S.default.Ignore}}h.toSeverity=u}(t=e.MarkerSeverity||(e.MarkerSeverity={}));var T;(function(h){const f="";function C(m){return I(m,!0)}h.makeKey=C;function I(m,u){let c=[f];return m.source?c.push(m.source.replace("\xA6","\\\xA6")):c.push(f),m.code?typeof m.code=="string"?c.push(m.code.replace("\xA6","\\\xA6")):c.push(m.code.value.replace("\xA6","\\\xA6")):c.push(f),m.severity!==void 0&&m.severity!==null?c.push(t.toString(m.severity)):c.push(f),m.message&&u?c.push(m.message.replace("\xA6","\\\xA6")):c.push(f),m.startLineNumber!==void 0&&m.startLineNumber!==null?c.push(m.startLineNumber.toString()):c.push(f),m.startColumn!==void 0&&m.startColumn!==null?c.push(m.startColumn.toString()):c.push(f),m.endLineNumber!==void 0&&m.endLineNumber!==null?c.push(m.endLineNumber.toString()):c.push(f),m.endColumn!==void 0&&m.endColumn!==null?c.push(m.endColumn.toString()):c.push(f),c.push(f),c.join("\xA6")}h.makeKeyOptionalMessage=I})(T=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,p.createDecorator)("markerService")}),define(ue[212],de([0,1,6,62,7]),function(Y,e,S,k,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=k.default,e.INotificationService=(0,p.createDecorator)("notificationService");var P;(function(f){f[f.WORKSPACE=0]="WORKSPACE",f[f.GLOBAL=1]="GLOBAL"})(P=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var t;(function(f){f[f.OFF=0]="OFF",f[f.SILENT=1]="SILENT",f[f.ERROR=2]="ERROR"})(t=e.NotificationsFilter||(e.NotificationsFilter={}));class T{constructor(){this.progress=new h,this.onDidClose=S.Event.None,this.onDidChangeVisibility=S.Event.None}updateSeverity(C){}updateMessage(C){}updateActions(C){}close(){}}e.NoOpNotification=T;class h{infinite(){}done(){}total(C){}worked(C){}}e.NoOpProgress=h}),define(ue[213],de([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseExtensionsGalleryEnv=void 0;function S(k){return{serviceUrl:"",itemUrl:"",resourceUrlTemplate:"",controlUrl:"",recommendationsUrl:"",...JSON.parse(k)}}e.parseExtensionsGalleryEnv=S}),define(ue[58],de([0,1,10,2,23,19,213]),function(Y,e,S,k,p,P,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let T;if(typeof k.globals.vscode!="undefined"&&typeof k.globals.vscode.context!="undefined"){const h=k.globals.vscode.context.configuration();if(h)T=h.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof Y?.__$__nodeRequire=="function"){const h=(0,P.dirname)(S.FileAccess.asFileUri("",Y));T=Y.__$__nodeRequire((0,P.joinPath)(h,"product.json").fsPath);const f=Y.__$__nodeRequire((0,P.joinPath)(h,"package.json").fsPath);p.env.VSCODE_DEV&&Object.assign(T,{nameShort:`${T.nameShort} Dev`,nameLong:`${T.nameLong} Dev`,dataFolderName:`${T.dataFolderName}-dev`}),Object.assign(T,{version:f.version})}else T={nameShort:"code-server",nameLong:"code-server",applicationName:"code-server",dataFolderName:".code-server",win32MutexName:"codeserver",licenseName:"MIT",licenseUrl:"https://github.com/cdr/code-server/blob/main/LICENSE.txt",serverGreeting:[],serverLicense:[],serverLicensePrompt:"",win32DirName:"Code Server OSS",win32NameVersion:"Code Server OSS",win32RegValueName:"CodeOSS",win32AppId:"{{E34003BB-9E10-4501-8C11-BE3FAA83F23F}",win32x64AppId:"{{D77B7E06-80BA-4137-BCF4-654B95CCEBC5}",win32arm64AppId:"{{D1ACE434-89C5-48D1-88D3-E2991DF85475}",win32UserAppId:"{{C6065F05-9603-4FC4-8101-B9781A25D88E}",win32x64UserAppId:"{{CC6B787D-37A0-49E8-AE24-8559A032BE0C}",win32arm64UserAppId:"{{3AEBF0C8-F733-4AD4-BADE-FDB816D53D7B}",win32AppUserModelId:"Coder.CodeServer",win32ShellNameShort:"C&ode Server",darwinBundleIdentifier:"com.coder.code.server",linuxIconName:"com.coder.code.server",licenseFileName:"LICENSE.txt",reportIssueUrl:"https://github.com/cdr/code-server/issues/new",urlProtocol:"code-oss",webviewContentExternalBaseUrlTemplate:"https://{{uuid}}.vscode-webview.net/insider/dc1a6699060423b8c4d2ced736ad70195378fddf/out/vs/workbench/contrib/webview/browser/pre/",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","GitHub.remotehub","GitHub.remotehub-insiders","coder.vscode-link"],builtInExtensions:[{name:"ms-vscode.references-view",version:"0.0.81",repo:"https://github.com/microsoft/vscode-references-view",metadata:{id:"dc489f46-520d-4556-ae85-1f9eab3c412d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.js-debug-companion",version:"1.0.15",repo:"https://github.com/microsoft/vscode-js-debug-companion",metadata:{id:"99cb0b7f-7354-4278-b8da-6cc79972169d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.js-debug",version:"1.62.0",repo:"https://github.com/microsoft/vscode-js-debug",metadata:{id:"25629058-ddac-4e17-abba-74678e126c5d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.vscode-js-profile-table",version:"0.0.18",repo:"https://github.com/microsoft/vscode-js-profile-visualizer",metadata:{id:"7e52b41b-71ad-457b-ab7e-0620f1fc4feb",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}}],"//":"https://github.com/VSCodium/vscodium/pull/155/files",documentationUrl:"https://go.microsoft.com/fwlink/?LinkID=533484#vscode",keyboardShortcutsUrlMac:"https://go.microsoft.com/fwlink/?linkid=832143",keyboardShortcutsUrlLinux:"https://go.microsoft.com/fwlink/?linkid=832144",keyboardShortcutsUrlWin:"https://go.microsoft.com/fwlink/?linkid=832145",introductoryVideosUrl:"https://go.microsoft.com/fwlink/?linkid=832146",tipsAndTricksUrl:"https://go.microsoft.com/fwlink/?linkid=852118",newsletterSignupUrl:"https://www.research.net/r/vsc-newsletter",extensionsGallery:{serviceUrl:"https://open-vsx.org/vscode/gallery",itemUrl:"https://open-vsx.org/vscode/item",resourceUrlTemplate:"https://open-vsx.org/vscode/asset/{publisher}/{name}/{version}/Microsoft.VisualStudio.Code.WebResources/{path}",controlUrl:"",recommendationsUrl:""},linkProtectionTrustedDomains:["https://open-vsx.org"],version:"1.63.0",date:"2022-01-05T17:44:17.895Z"},Object.keys(T).length===0&&Object.assign(T,{version:"1.63.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","GitHub.remotehub","GitHub.remotehub-insiders"]});if(typeof p.env.EXTENSIONS_GALLERY!="undefined"){console.log("Custom marketplace env found. Parsing...");try{Object.assign(T,{extensionsGallery:(0,t.parseExtensionsGalleryEnv)(p.env.EXTENSIONS_GALLERY)})}catch(h){console.error(h),console.info("Check that your env var is valid JSON and conforms to `IProductConfiguration['extensionsGallery']`>")}console.log("Custom marketplace enabled."),console.log(JSON.stringify(T.extensionsGallery,null,2))}e.default=T}),define(ue[38],de([0,1,7]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProductService=void 0,e.IProductService=(0,S.createDecorator)("productService")}),define(ue[22],de([0,1,127,11]),function(Y,e,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class p{constructor(){this.data=new Map}add(t,T){S.ok(k.isString(t)),S.ok(k.isObject(T)),S.ok(!this.data.has(t),"There is already an extension with this id"),this.data.set(t,T)}knows(t){return this.data.has(t)}as(t){return this.data.get(t)||null}}e.Registry=new p}),define(ue[49],de([0,1,6,22]),function(Y,e,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function p(T){return T.length>0&&T.charAt(T.length-1)==="#"?T.substring(0,T.length-1):T}class P{constructor(){this._onDidChangeSchema=new S.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(h,f){this.schemasById[p(h)]=f,this._onDidChangeSchema.fire(h)}notifySchemaChanged(h){this._onDidChangeSchema.fire(h)}getSchemaContributions(){return{schemas:this.schemasById}}}const t=new P;k.Registry.add(e.Extensions.JSONContribution,t)}),define(ue[42],de([0,1,20,6,11,157,49,22]),function(Y,e,S,k,p,P,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var h;(function(a){a.Multiline="multilineText",a.Singleline="singlelineText"})(h=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var f;(function(a){a[a.APPLICATION=1]="APPLICATION",a[a.MACHINE=2]="MACHINE",a[a.WINDOW=3]="WINDOW",a[a.RESOURCE=4]="RESOURCE",a[a.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",a[a.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(f=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const C=T.Registry.as(t.Extensions.JSONContribution);class I{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new k.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new k.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:P.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},C.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(l,r=!0){this.registerConfigurations([l],r)}registerConfigurations(l,r=!0){const o=this.doRegisterConfigurations(l,r);C.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o})}deregisterConfigurations(l){const r=this.doDeregisterConfigurations(l);C.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r})}updateConfigurations({add:l,remove:r}){const o=[];o.push(...this.doDeregisterConfigurations(r)),o.push(...this.doRegisterConfigurations(l,!1)),C.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,S.distinct)(o)})}registerDefaultConfigurations(l){const r=[],o=[];for(const i of l)for(const n in i)if(r.push(n),e.OVERRIDE_PROPERTY_REGEX.test(n)){this.configurationDefaultsOverrides[n]={...this.configurationDefaultsOverrides[n]||{},...i[n]};const s={type:"object",default:this.configurationDefaultsOverrides[n],description:P.localize(1,null,n),$ref:e.resourceLanguageSettingsSchemaId};o.push(...c(n)),this.configurationProperties[n]=s,this.defaultLanguageConfigurationOverridesNode.properties[n]=s}else{this.configurationDefaultsOverrides[n]=i[n];const s=this.configurationProperties[n];s&&(this.updatePropertyDefaultValue(n,s),this.updateSchema(n,s))}this.registerOverrideIdentifiers(o),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r,defaultsOverrides:!0})}deregisterDefaultConfigurations(l){const r=[];for(const o of l)for(const i in o)if(r.push(i),delete this.configurationDefaultsOverrides[i],e.OVERRIDE_PROPERTY_REGEX.test(i))delete this.configurationProperties[i],delete this.defaultLanguageConfigurationOverridesNode.properties[i];else{const n=this.configurationProperties[i];n&&(this.updatePropertyDefaultValue(i,n),this.updateSchema(i,n))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...l){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(l){for(const r of l)this.overrideIdentifiers.add(r);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(l,r){const o=[];return l.forEach(i=>{o.push(...this.validateAndRegisterProperties(i,r,i.extensionInfo)),this.configurationContributors.push(i),this.registerJSONConfiguration(i)}),o}doDeregisterConfigurations(l){const r=[],o=i=>{if(i.properties)for(const n in i.properties)r.push(n),delete this.configurationProperties[n],this.removeFromSchema(n,i.properties[n]);i.allOf&&i.allOf.forEach(n=>o(n))};for(const i of l){o(i);const n=this.configurationContributors.indexOf(i);n!==-1&&this.configurationContributors.splice(n,1)}return r}validateAndRegisterProperties(l,r=!0,o,i=3){i=p.isUndefinedOrNull(l.scope)?i:l.scope;let n=[],s=l.properties;if(s)for(let y in s){if(r&&w(y)){delete s[y];continue}const A=s[y];if(this.updatePropertyDefaultValue(y,A),e.OVERRIDE_PROPERTY_REGEX.test(y)?A.scope=void 0:(A.scope=p.isUndefinedOrNull(A.scope)?i:A.scope,A.restricted=p.isUndefinedOrNull(A.restricted)?!!o?.restrictedConfigurations?.includes(y):A.restricted),s[y].hasOwnProperty("included")&&!s[y].included){this.excludedConfigurationProperties[y]=s[y],delete s[y];continue}else this.configurationProperties[y]=s[y];!s[y].deprecationMessage&&s[y].markdownDeprecationMessage&&(s[y].deprecationMessage=s[y].markdownDeprecationMessage),n.push(y)}let d=l.allOf;if(d)for(let y of d)n.push(...this.validateAndRegisterProperties(y,r,o,i));return n}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(l){const r=o=>{let i=o.properties;if(i)for(const s in i)this.updateSchema(s,i[s]);let n=o.allOf;n&&n.forEach(r)};r(l)}updateSchema(l,r){switch(e.allSettings.properties[l]=r,r.scope){case 1:e.applicationSettings.properties[l]=r;break;case 2:e.machineSettings.properties[l]=r;break;case 6:e.machineOverridableSettings.properties[l]=r;break;case 3:e.windowSettings.properties[l]=r;break;case 4:e.resourceSettings.properties[l]=r;break;case 5:e.resourceSettings.properties[l]=r,this.resourceLanguageSettingsSchema.properties[l]=r;break}}removeFromSchema(l,r){switch(delete e.allSettings.properties[l],r.scope){case 1:delete e.applicationSettings.properties[l];break;case 2:delete e.machineSettings.properties[l];break;case 6:delete e.machineOverridableSettings.properties[l];break;case 3:delete e.windowSettings.properties[l];break;case 4:case 5:delete e.resourceSettings.properties[l],delete this.resourceLanguageSettingsSchema.properties[l];break}}updateOverridePropertyPatternKey(){for(const l of this.overrideIdentifiers.values()){const r=`[${l}]`,o={type:"object",description:P.localize(2,null),errorMessage:P.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(r,o),e.allSettings.properties[r]=o,e.applicationSettings.properties[r]=o,e.machineSettings.properties[r]=o,e.machineOverridableSettings.properties[r]=o,e.windowSettings.properties[r]=o,e.resourceSettings.properties[r]=o}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const l={type:"object",description:P.localize(4,null),errorMessage:P.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=l,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=l,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=l,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=l,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=l,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=l,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(l,r){let o=this.configurationDefaultsOverrides[l];p.isUndefined(o)&&(o=r.default),p.isUndefined(o)&&(o=g(r.type)),r.default=o}}const m="\\[([^\\]]+)\\]",u=new RegExp(m,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${m})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function c(a){const l=[];if(e.OVERRIDE_PROPERTY_REGEX.test(a)){let r=u.exec(a);for(;r?.length;){const o=r[1].trim();o&&l.push(o),r=u.exec(a)}}return(0,S.distinct)(l)}e.overrideIdentifiersFromKey=c;function b(a){return a.reduce((l,r)=>`${l}[${r}]`,"")}e.keyFromOverrideIdentifiers=b;function g(a){switch(Array.isArray(a)?a[0]:a){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=g;const D=new I;T.Registry.add(e.Extensions.Configuration,D);function w(a){return a.trim()?e.OVERRIDE_PROPERTY_REGEX.test(a)?P.localize(7,null,a):D.getConfigurationProperties()[a]!==void 0?P.localize(8,null,a):null:P.localize(6,null)}e.validateProperty=w;function v(){const a=[],l=D.getConfigurationProperties();for(const r of Object.keys(l))a.push([r,l[r].scope]);return a.push(["launch",4]),a.push(["task",4]),a}e.getScopes=v}),define(ue[214],de([0,1,20,6,36,3,30,21,11,5,27,42,22]),function(Y,e,S,k,p,P,t,T,h,f,C,I,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class u{constructor(i={},n=[],s=[]){this._contents=i,this._keys=n,this._overrides=s,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(i){return i?(0,C.getConfigurationValue)(this.contents,i):this.contents}getOverrideValue(i,n){const s=this.getContentsForOverrideIdentifer(n);return s?i?(0,C.getConfigurationValue)(s,i):s:void 0}getKeysForOverrideIdentifier(i){const n=[];for(const s of this.overrides)s.identifiers.includes(i)&&n.push(...s.keys);return S.distinct(n)}getAllOverrideIdentifiers(){const i=[];for(const n of this.overrides)i.push(...n.identifiers);return S.distinct(i)}override(i){let n=this.overrideConfigurations.get(i);return n||(n=this.createOverrideConfigurationModel(i),this.overrideConfigurations.set(i,n)),n}merge(...i){const n=T.deepClone(this.contents),s=T.deepClone(this.overrides),d=[...this.keys];for(const y of i){this.mergeContents(n,y.contents);for(const A of y.overrides){const[E]=s.filter(R=>S.equals(R.identifiers,A.identifiers));E?(this.mergeContents(E.contents,A.contents),E.keys.push(...A.keys),E.keys=S.distinct(E.keys)):s.push(T.deepClone(A))}for(const A of y.keys)d.indexOf(A)===-1&&d.push(A)}return new u(n,d,s)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(i){const n=this.getContentsForOverrideIdentifer(i);if(!n||typeof n!="object"||!Object.keys(n).length)return this;let s={};for(const d of S.distinct([...Object.keys(this.contents),...Object.keys(n)])){let y=this.contents[d],A=n[d];A&&(typeof y=="object"&&typeof A=="object"?(y=T.deepClone(y),this.mergeContents(y,A)):y=A),s[d]=y}return new u(s,this.keys,this.overrides)}mergeContents(i,n){for(const s of Object.keys(n)){if(s in i&&h.isObject(i[s])&&h.isObject(n[s])){this.mergeContents(i[s],n[s]);continue}i[s]=T.deepClone(n[s])}}checkAndFreeze(i){return this.isFrozen&&!Object.isFrozen(i)?T.deepFreeze(i):i}getContentsForOverrideIdentifer(i){let n=null,s=null;const d=y=>{y&&(s?this.mergeContents(s,y):s=T.deepClone(y))};for(const y of this.overrides)S.equals(y.identifiers,[i])?n=y.contents:y.identifiers.includes(i)&&d(y.contents);return d(n),s}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(i,n){this.addKey(i),(0,C.addToValueTree)(this.contents,i,n,s=>{throw new Error(s)})}removeValue(i){this.removeKey(i)&&(0,C.removeFromValueTree)(this.contents,i)}addKey(i){let n=this.keys.length;for(let s=0;s<n;s++)i.indexOf(this.keys[s])===0&&(n=s);this.keys.splice(n,1,i)}removeKey(i){let n=this.keys.indexOf(i);return n!==-1?(this.keys.splice(n,1),!0):!1}}e.ConfigurationModel=u;class c extends u{constructor(i={}){const n=m.Registry.as(I.Extensions.Configuration).getConfigurationProperties(),s=Object.keys(n),d=Object.create(null),y=[];for(const A in n){const E=i[A],R=E!==void 0?E:n[A].default;(0,C.addToValueTree)(d,A,R,O=>console.error(`Conflict in default settings: ${O}`))}for(const A of Object.keys(d))I.OVERRIDE_PROPERTY_REGEX.test(A)&&y.push({identifiers:(0,I.overrideIdentifiersFromKey)(A),keys:Object.keys(d[A]),contents:(0,C.toValuesTree)(d[A],E=>console.error(`Conflict in default settings file: ${E}`))});super(d,s,y)}}e.DefaultConfigurationModel=c;class b{constructor(i){this._name=i,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new u}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(i,n){if(!h.isUndefinedOrNull(i)){const s=this.doParseContent(i);this.parseRaw(s,n)}}reparse(i){this._raw&&this.parseRaw(this._raw,i)}parseRaw(i,n){this._raw=i;const{contents:s,keys:d,overrides:y,restricted:A}=this.doParseRaw(i,n);this._configurationModel=new u(s,d,y),this._restrictedConfigurations=A||[]}doParseContent(i){let n={},s=null,d=[],y=[],A=[];function E(O){Array.isArray(d)?d.push(O):s!==null&&(d[s]=O)}let R={onObjectBegin:()=>{let O={};E(O),y.push(d),d=O,s=null},onObjectProperty:O=>{s=O},onObjectEnd:()=>{d=y.pop()},onArrayBegin:()=>{let O=[];E(O),y.push(d),d=O,s=null},onArrayEnd:()=>{d=y.pop()},onLiteralValue:E,onError:(O,K,te)=>{A.push({error:O,offset:K,length:te})}};if(i)try{p.visit(i,R),n=d[0]||{}}catch(O){console.error(`Error while parsing settings file ${this._name}: ${O}`),this._parseErrors=[O]}return n}doParseRaw(i,n){const s=m.Registry.as(I.Extensions.Configuration).getConfigurationProperties(),d=this.filter(i,s,!0,n);i=d.raw;const y=(0,C.toValuesTree)(i,R=>console.error(`Conflict in settings file ${this._name}: ${R}`)),A=Object.keys(i),E=this.toOverrides(i,R=>console.error(`Conflict in settings file ${this._name}: ${R}`));return{contents:y,keys:A,overrides:E,restricted:d.restricted}}filter(i,n,s,d){if(!d?.scopes&&!d?.skipRestricted)return{raw:i,restricted:[]};const y={},A=[];for(let E in i)if(I.OVERRIDE_PROPERTY_REGEX.test(E)&&s){const R=this.filter(i[E],n,!1,d);y[E]=R.raw,A.push(...R.restricted)}else{const R=n[E],O=R?typeof R.scope!="undefined"?R.scope:3:void 0;R?.restricted&&A.push(E),(O===void 0||d.scopes===void 0||d.scopes.includes(O))&&(d.skipRestricted&&R?.restricted||(y[E]=i[E]))}return{raw:y,restricted:A}}toOverrides(i,n){const s=[];for(const d of Object.keys(i))if(I.OVERRIDE_PROPERTY_REGEX.test(d)){const y={};for(const A in i[d])y[A]=i[d][A];s.push({identifiers:(0,I.overrideIdentifiersFromKey)(d),keys:Object.keys(y),contents:(0,C.toValuesTree)(y,n)})}return s}}e.ConfigurationModelParser=b;class g extends P.Disposable{constructor(i,n,s,d){super();this.userSettingsResource=i,this.scopes=n,this.fileService=d,this._onDidChange=this._register(new k.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new b(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(s.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(k.Event.filter(this.fileService.onDidFilesChange,y=>y.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const i=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(i.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(i){return new u}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=g;class D{constructor(i,n,s=new u,d=new u,y=new t.ResourceMap,A=new u,E=new t.ResourceMap,R=!0){this._defaultConfiguration=i,this._localUserConfiguration=n,this._remoteUserConfiguration=s,this._workspaceConfiguration=d,this._folderConfigurations=y,this._memoryConfiguration=A,this._memoryConfigurationByResource=E,this._freeze=R,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new t.ResourceMap,this._userConfiguration=null}getValue(i,n,s){return this.getConsolidateConfigurationModel(n,s).getValue(i)}updateValue(i,n,s={}){let d;s.resource?(d=this._memoryConfigurationByResource.get(s.resource),d||(d=new u,this._memoryConfigurationByResource.set(s.resource,d))):d=this._memoryConfiguration,n===void 0?d.removeValue(i):d.setValue(i,n),s.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(i,n,s){const d=this.getConsolidateConfigurationModel(n,s),y=this.getFolderConfigurationModelForResource(n.resource,s),A=n.resource?this._memoryConfigurationByResource.get(n.resource)||this._memoryConfiguration:this._memoryConfiguration,E=n.overrideIdentifier?this._defaultConfiguration.freeze().override(n.overrideIdentifier).getValue(i):this._defaultConfiguration.freeze().getValue(i),R=n.overrideIdentifier?this.userConfiguration.freeze().override(n.overrideIdentifier).getValue(i):this.userConfiguration.freeze().getValue(i),O=n.overrideIdentifier?this.localUserConfiguration.freeze().override(n.overrideIdentifier).getValue(i):this.localUserConfiguration.freeze().getValue(i),K=n.overrideIdentifier?this.remoteUserConfiguration.freeze().override(n.overrideIdentifier).getValue(i):this.remoteUserConfiguration.freeze().getValue(i),te=s?n.overrideIdentifier?this._workspaceConfiguration.freeze().override(n.overrideIdentifier).getValue(i):this._workspaceConfiguration.freeze().getValue(i):void 0,j=y?n.overrideIdentifier?y.freeze().override(n.overrideIdentifier).getValue(i):y.freeze().getValue(i):void 0,_=n.overrideIdentifier?A.override(n.overrideIdentifier).getValue(i):A.getValue(i),U=d.getValue(i),F=S.distinct(S.flatten(d.overrides.map(M=>M.identifiers))).filter(M=>d.getOverrideValue(i,M)!==void 0);return{defaultValue:E,userValue:R,userLocalValue:O,userRemoteValue:K,workspaceValue:te,workspaceFolderValue:j,memoryValue:_,value:U,default:E!==void 0?{value:this._defaultConfiguration.freeze().getValue(i),override:n.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(i,n.overrideIdentifier):void 0}:void 0,user:R!==void 0?{value:this.userConfiguration.freeze().getValue(i),override:n.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(i,n.overrideIdentifier):void 0}:void 0,userLocal:O!==void 0?{value:this.localUserConfiguration.freeze().getValue(i),override:n.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(i,n.overrideIdentifier):void 0}:void 0,userRemote:K!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(i),override:n.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(i,n.overrideIdentifier):void 0}:void 0,workspace:te!==void 0?{value:this._workspaceConfiguration.freeze().getValue(i),override:n.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(i,n.overrideIdentifier):void 0}:void 0,workspaceFolder:j!==void 0?{value:y?.freeze().getValue(i),override:n.overrideIdentifier?y?.freeze().getOverrideValue(i,n.overrideIdentifier):void 0}:void 0,memory:_!==void 0?{value:A.getValue(i),override:n.overrideIdentifier?A.getOverrideValue(i,n.overrideIdentifier):void 0}:void 0,overrideIdentifiers:F.length?F:void 0}}keys(i){const n=this.getFolderConfigurationModelForResource(void 0,i);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:n?n.freeze().keys:[]}}updateDefaultConfiguration(i){this._defaultConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(i){this._localUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(i){this._remoteUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(i){this._workspaceConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(i,n){this._folderConfigurations.set(i,n),this._foldersConsolidatedConfigurations.delete(i)}deleteFolderConfiguration(i){this.folderConfigurations.delete(i),this._foldersConsolidatedConfigurations.delete(i)}compareAndUpdateDefaultConfiguration(i){const{added:n,updated:s,removed:d,overrides:y}=l(this._defaultConfiguration,i),A=[...n,...s,...d];return A.length&&this.updateDefaultConfiguration(i),{keys:A,overrides:y}}compareAndUpdateLocalUserConfiguration(i){const{added:n,updated:s,removed:d,overrides:y}=l(this.localUserConfiguration,i),A=[...n,...s,...d];return A.length&&this.updateLocalUserConfiguration(i),{keys:A,overrides:y}}compareAndUpdateRemoteUserConfiguration(i){const{added:n,updated:s,removed:d,overrides:y}=l(this.remoteUserConfiguration,i);let A=[...n,...s,...d];return A.length&&this.updateRemoteUserConfiguration(i),{keys:A,overrides:y}}compareAndUpdateWorkspaceConfiguration(i){const{added:n,updated:s,removed:d,overrides:y}=l(this.workspaceConfiguration,i);let A=[...n,...s,...d];return A.length&&this.updateWorkspaceConfiguration(i),{keys:A,overrides:y}}compareAndUpdateFolderConfiguration(i,n){const s=this.folderConfigurations.get(i),{added:d,updated:y,removed:A,overrides:E}=l(s,n);let R=[...d,...y,...A];return(R.length||!s)&&this.updateFolderConfiguration(i,n),{keys:R,overrides:E}}compareAndDeleteFolderConfiguration(i){const n=this.folderConfigurations.get(i);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(i);const{added:s,updated:d,removed:y,overrides:A}=l(n,void 0);return{keys:[...s,...d,...y],overrides:A}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(i,n){let s=this.getConsolidatedConfigurationModelForResource(i,n);return i.overrideIdentifier?s.override(i.overrideIdentifier):s}getConsolidatedConfigurationModelForResource({resource:i},n){let s=this.getWorkspaceConsolidatedConfiguration();if(n&&i){const d=n.getFolder(i);d&&(s=this.getFolderConsolidatedConfiguration(d.uri)||s);const y=this._memoryConfigurationByResource.get(i);y&&(s=s.merge(y))}return s}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(i){let n=this._foldersConsolidatedConfigurations.get(i);if(!n){const s=this.getWorkspaceConsolidatedConfiguration(),d=this._folderConfigurations.get(i);d?(n=s.merge(d),this._freeze&&(n=n.freeze()),this._foldersConsolidatedConfigurations.set(i,n)):n=s}return n}getFolderConfigurationModelForResource(i,n){if(n&&i){const s=n.getFolder(i);if(s)return this._folderConfigurations.get(s.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((i,n)=>{const{contents:s,overrides:d,keys:y}=this._folderConfigurations.get(n);return i.push([n,{contents:s,overrides:d,keys:y}]),i},[])}}allKeys(){const i=new Set;return this._defaultConfiguration.freeze().keys.forEach(n=>i.add(n)),this.userConfiguration.freeze().keys.forEach(n=>i.add(n)),this._workspaceConfiguration.freeze().keys.forEach(n=>i.add(n)),this._folderConfigurations.forEach(n=>n.freeze().keys.forEach(s=>i.add(s))),[...i.values()]}allOverrideIdentifiers(){const i=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(n=>i.add(n)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(n=>i.add(n)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(n=>i.add(n)),this._folderConfigurations.forEach(n=>n.freeze().getAllOverrideIdentifiers().forEach(s=>i.add(s))),[...i.values()]}getAllKeysForOverrideIdentifier(i){const n=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(i).forEach(s=>n.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(i).forEach(s=>n.add(s)),this._workspaceConfiguration.getKeysForOverrideIdentifier(i).forEach(s=>n.add(s)),this._folderConfigurations.forEach(s=>s.getKeysForOverrideIdentifier(i).forEach(d=>n.add(d))),[...n.values()]}static parse(i){const n=this.parseConfigurationModel(i.defaults),s=this.parseConfigurationModel(i.user),d=this.parseConfigurationModel(i.workspace),y=i.folders.reduce((A,E)=>(A.set(f.URI.revive(E[0]),this.parseConfigurationModel(E[1])),A),new t.ResourceMap);return new D(n,s,new u,d,y,new u,new t.ResourceMap,!1)}static parseConfigurationModel(i){return new u(i.contents,i.keys,i.overrides).freeze()}}e.Configuration=D;function w(...o){if(o.length===0)return{keys:[],overrides:[]};if(o.length===1)return o[0];const i=new Set,n=new Map;for(const d of o)d.keys.forEach(y=>i.add(y)),d.overrides.forEach(([y,A])=>{const E=(0,t.getOrSet)(n,y,new Set);A.forEach(R=>E.add(R))});const s=[];return n.forEach((d,y)=>s.push([y,[...d.values()]])),{keys:[...i.values()],overrides:s}}e.mergeChanges=w;class v{constructor(i,n,s,d){this.change=i,this.previous=n,this.currentConfiguraiton=s,this.currentWorkspace=d,this._previousConfiguration=void 0;const y=new Set;i.keys.forEach(E=>y.add(E)),i.overrides.forEach(([,E])=>E.forEach(R=>y.add(R))),this.affectedKeys=[...y.values()];const A=new u;this.affectedKeys.forEach(E=>A.setValue(E,{})),this.affectedKeysTree=A.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=D.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(i,n){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,i)){if(n){const s=this.previousConfiguration?this.previousConfiguration.getValue(i,n,this.previous?.workspace):void 0,d=this.currentConfiguraiton.getValue(i,n,this.currentWorkspace);return!T.equals(s,d)}return!0}return!1}doesAffectedKeysTreeContains(i,n){let s=(0,C.toValuesTree)({[n]:!0},()=>{}),d;for(;typeof s=="object"&&(d=Object.keys(s)[0]);){if(i=i[d],!i)return!1;s=s[d]}return!0}}e.ConfigurationChangeEvent=v;class a extends v{constructor(i,n,s,d){super({keys:i.allKeys(),overrides:[]},void 0,i,n);this.source=s,this.sourceConfig=d}}e.AllKeysConfigurationChangeEvent=a;function l(o,i){const{added:n,removed:s,updated:d}=r(i,o),y=[],A=o?.getAllOverrideIdentifiers()||[],E=i?.getAllOverrideIdentifiers()||[];if(i){const R=E.filter(O=>!A.includes(O));for(const O of R)y.push([O,i.getKeysForOverrideIdentifier(O)])}if(o){const R=A.filter(O=>!E.includes(O));for(const O of R)y.push([O,o.getKeysForOverrideIdentifier(O)])}if(i&&o){for(const R of A)if(E.includes(R)){const O=r({contents:o.getOverrideValue(void 0,R)||{},keys:o.getKeysForOverrideIdentifier(R)},{contents:i.getOverrideValue(void 0,R)||{},keys:i.getKeysForOverrideIdentifier(R)});y.push([R,[...O.added,...O.removed,...O.updated]])}}return{added:n,removed:s,updated:d,overrides:y}}function r(o,i){const n=o?i?o.keys.filter(y=>i.keys.indexOf(y)===-1):[...o.keys]:[],s=i?o?i.keys.filter(y=>o.keys.indexOf(y)===-1):[...i.keys]:[],d=[];if(o&&i){for(const y of i.keys)if(o.keys.indexOf(y)!==-1){const A=(0,C.getConfigurationValue)(i.contents,y),E=(0,C.getConfigurationValue)(o.contents,y);T.equals(A,E)||d.push(y)}}return{added:n,removed:s,updated:d}}}),define(ue[104],de([0,1,13,6,3,19,27,214,42,22]),function(Y,e,S,k,p,P,t,T,h,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class C extends p.Disposable{constructor(m,u){super();this.settingsResource=m,this._onDidChangeConfiguration=this._register(new k.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new T.UserSettings(this.settingsResource,void 0,P.extUriBiasedIgnorePathCase,u)),this.configuration=new T.Configuration(new T.DefaultConfigurationModel,new T.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new S.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(f.Registry.as(h.Extensions.Configuration).onDidUpdateConfiguration(()=>this.onDidDefaultConfigurationChange())),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const m=await this.userConfiguration.loadConfiguration();this.configuration=new T.Configuration(new T.DefaultConfigurationModel,m)}getConfigurationData(){return this.configuration.toData()}getValue(m,u){const c=typeof m=="string"?m:void 0,b=(0,t.isConfigurationOverrides)(m)?m:(0,t.isConfigurationOverrides)(u)?u:{};return this.configuration.getValue(c,b,void 0)}updateValue(m,u,c,b){return Promise.reject(new Error("not supported"))}inspect(m){return this.configuration.inspect(m,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const m=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(m)}onDidChangeUserConfiguration(m){const u=this.configuration.toData(),c=this.configuration.compareAndUpdateLocalUserConfiguration(m);this.trigger(c,u,1)}onDidDefaultConfigurationChange(){const m=this.configuration.toData(),u=this.configuration.compareAndUpdateDefaultConfiguration(new T.DefaultConfigurationModel);this.trigger(u,m,6)}trigger(m,u,c){const b=new T.ConfigurationChangeEvent(m,{data:u},this.configuration);b.source=c,b.sourceConfig=this.getTargetConfiguration(c),this._onDidChangeConfiguration.fire(b)}getTargetConfiguration(m){switch(m){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=C}),define(ue[105],de([0,1,7]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,S.createDecorator)("remoteAuthorityResolverService");var k;(function(P){P.Unknown="Unknown",P.NotAvailable="NotAvailable",P.TemporarilyNotAvailable="TemporarilyNotAvailable",P.NoResolverFound="NoResolverFound"})(k=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class p extends Error{constructor(t,T=k.Unknown,h){super(t);this._message=t,this._code=T,this._detail=h,this.isHandled=T===k.NotAvailable&&h===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,p.prototype)}static isTemporarilyNotAvailable(t){return t instanceof p&&t._code===k.TemporarilyNotAvailable}static isNoResolverFound(t){return t instanceof p&&t._code===k.NoResolverFound}static isHandled(t){return t instanceof p&&t.isHandled}}e.RemoteAuthorityResolverError=p}),define(ue[106],de([0,1,10]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function k(f){return f.scheme===S.Schemas.vscodeRemote?f.authority:void 0}e.getRemoteAuthority=k;function p(f){if(!f)return;const C=f.indexOf("+");return C<0?f:f.substr(0,C)}e.getRemoteName=p;function P(f){return f.scheme!==S.Schemas.file&&f.scheme!==S.Schemas.vscodeRemote}e.isVirtualResource=P;function t(f){if(f.folders.length)return f.folders.every(C=>P(C.uri))?f.folders[0].uri:void 0;if(f.configuration&&P(f.configuration))return f.configuration}e.getVirtualWorkspaceLocation=t;function T(f){return t(f)?.scheme}e.getVirtualWorkspaceScheme=T;function h(f){return t(f)!==void 0}e.isVirtualWorkspace=h}),define(ue[43],de([0,1,14,7,106]),function(Y,e,S,k,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function P(m){if(typeof m=="object"&&m!==null&&m.supported!==!0)return m.description}e.getWorkspaceSupportTypeMessage=P;function t(m){return m&&typeof m=="object"&&typeof m.id=="string"&&(!m.uuid||typeof m.uuid=="string")}e.isIExtensionIdentifier=t,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var T;(function(m){m[m.System=0]="System",m[m.User=1]="User"})(T=e.ExtensionType||(e.ExtensionType={}));class h{constructor(u){this.value=u,this._lower=u.toLowerCase()}static equals(u,c){if(typeof u=="undefined"||u===null)return typeof c=="undefined"||c===null;if(typeof c=="undefined"||c===null)return!1;if(typeof u=="string"||typeof c=="string"){let b=typeof u=="string"?u:u.value,g=typeof c=="string"?c:c.value;return S.equalsIgnoreCase(b,g)}return u._lower===c._lower}static toKey(u){return typeof u=="string"?u.toLowerCase():u._lower}}e.ExtensionIdentifier=h;function f(m){return m.contributes&&m.contributes.localizations?m.contributes.localizations.length>0:!1}e.isLanguagePackExtension=f;function C(m){return m.contributes&&m.contributes.authentication?m.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=C;function I(m,u){if(u){const c=`onResolveRemoteAuthority:${(0,p.getRemoteName)(u)}`;return m.activationEvents?.indexOf(c)!==-1}return!1}e.isResolverExtension=I,e.IBuiltinExtensionsScannerService=(0,k.createDecorator)("IBuiltinExtensionsScannerService")}),define(ue[34],de([0,1,14,43]),function(Y,e,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function p(c,b){return c.uuid&&b.uuid?c.uuid===b.uuid:c.id===b.id?!0:(0,S.compareIgnoreCase)(c.id,b.id)===0}e.areSameExtensions=p;class P{constructor(b,g){this.version=g,this.id=b.id,this.uuid=b.uuid}key(){return`${this.id}-${this.version}`}equals(b){return b instanceof P?p(this,b)&&this.version===b.version:!1}}e.ExtensionIdentifierWithVersion=P;function t(c,b){return`${c}.${b}`}e.getExtensionId=t;function T(c){return c.toLocaleLowerCase()}e.adoptToGalleryExtensionId=T;function h(c,b){return T(t(c,b))}e.getGalleryExtensionId=h;function f(c,b){const g=[],D=w=>{for(const v of g)if(v.some(a=>p(b(a),b(w))))return v;return null};for(const w of c){const v=D(w);v?v.push(w):g.push([w])}return g}e.groupByExtension=f;function C(c){return{id:c.identifier.id,name:c.manifest.name,galleryId:null,publisherId:c.publisherId,publisherName:c.manifest.publisher,publisherDisplayName:c.publisherDisplayName,dependencies:c.manifest.extensionDependencies&&c.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=C;function I(c){return{id:c.identifier.id,name:c.name,galleryId:c.identifier.uuid,publisherId:c.publisherId,publisherName:c.publisher,publisherDisplayName:c.publisherDisplayName,dependencies:!!(c.properties.dependencies&&c.properties.dependencies.length>0),...c.telemetryData}}e.getGalleryExtensionTelemetryData=I,e.BetterMergeId=new k.ExtensionIdentifier("pprice.better-merge");function m(c){const b=new Set;for(const g of c)g.malicious&&b.add(g.id.id);return b}e.getMaliciousExtensionsSet=m;function u(c,b){const g=[],D=b.manifest.extensionDependencies?.slice(0)??[];for(;D.length;){const w=D.shift();if(w&&g.every(v=>!p(v.identifier,{id:w}))){const v=c.filter(a=>p(a.identifier,{id:w}));v.length===1&&(g.push(v[0]),D.push(...v[0].manifest.extensionDependencies?.slice(0)??[]))}}return g}e.getExtensionDependencies=u}),define(ue[107],de([0,1,24,12,64,10,59,5,163,29,34,43]),function(Y,e,S,k,p,P,t,T,h,f,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementCLIService=e.getIdAndVersion=void 0;const m=w=>(0,h.localize)(0,null,w),u=(0,h.localize)(1,null,"ms-dotnettools.csharp");function c(w,v){return v?`${w.publisher}.${w.name}@${w.version}`:`${w.publisher}.${w.name}`}const b=/^([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;function g(w){const v=b.exec(w);return v&&v[1]?[(0,C.adoptToGalleryExtensionId)(v[1]),v[2]]:[(0,C.adoptToGalleryExtensionId)(w),void 0]}e.getIdAndVersion=g;let D=class{constructor(v,a){this.extensionManagementService=v,this.extensionGalleryService=a}get location(){}async listExtensions(v,a,l=console){let r=await this.extensionManagementService.getInstalled(1);const o=I.EXTENSION_CATEGORIES.map(n=>n.toLowerCase());if(a&&a!==""){if(o.indexOf(a.toLowerCase())<0){l.log("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}r=r.filter(n=>n.manifest.categories?n.manifest.categories.map(d=>d.toLowerCase()).indexOf(a.toLowerCase())>-1:!1)}else if(a===""){l.log("Possible Categories: "),o.forEach(n=>{l.log(n)});return}this.location&&l.log((0,h.localize)(2,null,this.location)),r=r.sort((n,s)=>n.identifier.id.localeCompare(s.identifier.id));let i;for(let n of r)i!==n.identifier.id&&(i=n.identifier.id,l.log(c(n.manifest,v)))}async installExtensions(v,a,l,r,o=console){const i=[],n=[];v.length&&o.log(this.location?(0,h.localize)(3,null,this.location):(0,h.localize)(4,null));const s=await this.extensionManagementService.getInstalled(1),d=(E,R)=>{const O=s.find(K=>(0,C.areSameExtensions)(K.identifier,{id:E}));if(O){if(!R&&!r)return o.log((0,h.localize)(5,null,E,O.manifest.version,E)),!1;if(R&&O.manifest.version===R)return o.log((0,h.localize)(6,null,`${E}@${R}`)),!1}return!0},y=[],A=[];for(const E of v)if(E instanceof T.URI)y.push(E);else{const[R,O]=g(E);d(R,O)&&A.push({id:R,version:O,installOptions:{isBuiltin:!1,isMachineScoped:l}})}for(const E of a){const[R,O]=g(E);d(R,O)&&A.push({id:R,version:O,installOptions:{isBuiltin:!0,isMachineScoped:!1}})}if(y.length&&await Promise.all(y.map(async E=>{try{const R=await this.installVSIX(E,{isBuiltin:!1,isMachineScoped:l},r,o);R&&n.push(R)}catch(R){o.error(R.message||R.stack||R),i.push(E.toString())}})),A.length){const E=await this.getGalleryExtensions(A);await Promise.all(A.map(async R=>{const O=E.get(R.id.toLowerCase());if(O)try{const K=await this.installFromGallery(R,O,s,r,o);K&&n.push(K)}catch(K){o.error(K.message||K.stack||K),i.push(R.id)}else o.error(`${m(R.version?`${R.id}@${R.version}`:R.id)}
${u}`),i.push(R.id)}))}if(i.length)throw new Error((0,h.localize)(7,null,i.join(", ")))}async installVSIX(v,a,l,r){const o=await this.extensionManagementService.getManifest(v);if(!o)throw new Error("Invalid vsix");if(await this.validateVSIX(o,l,r))try{return await this.extensionManagementService.install(v,a),r.log((0,h.localize)(8,null,(0,p.getBaseLabel)(v))),o}catch(n){if((0,k.isPromiseCanceledError)(n))return r.log((0,h.localize)(9,null,(0,p.getBaseLabel)(v))),null;throw n}return null}async getGalleryExtensions(v){const a=new Map,l=await this.extensionGalleryService.getExtensions(v,S.CancellationToken.None);for(const r of l)a.set(r.identifier.id.toLowerCase(),r);return a}async installFromGallery({id:v,version:a,installOptions:l},r,o,i,n){const s=await this.extensionGalleryService.getManifest(r,S.CancellationToken.None);if(s&&!this.validateExtensionKind(s,n))return null;const d=o.find(y=>(0,C.areSameExtensions)(y.identifier,r.identifier));if(d){if(r.version===d.manifest.version)return n.log((0,h.localize)(10,null,a?`${v}@${a}`:v)),null;n.log((0,h.localize)(11,null,v,r.version))}try{return l.isBuiltin?n.log(a?(0,h.localize)(12,null,v,a):(0,h.localize)(13,null,v)):n.log(a?(0,h.localize)(14,null,v,a):(0,h.localize)(15,null,v)),await this.extensionManagementService.installFromGallery(r,{...l,installGivenVersion:!!a}),n.log((0,h.localize)(16,null,v,r.version)),s}catch(y){if((0,k.isPromiseCanceledError)(y))return n.log((0,h.localize)(17,null,v)),null;throw y}}validateExtensionKind(v,a){return!0}async validateVSIX(v,a,l){const r={id:(0,C.getGalleryExtensionId)(v.publisher,v.name)},i=(await this.extensionManagementService.getInstalled(1)).find(n=>(0,C.areSameExtensions)(r,n.identifier)&&(0,t.gt)(n.manifest.version,v.version));return i&&!a?(l.log((0,h.localize)(18,null,i.identifier.id,i.manifest.version,v.version)),!1):this.validateExtensionKind(v,l)}async uninstallExtensions(v,a,l=console){const r=async i=>{if(i instanceof T.URI){const n=await this.extensionManagementService.getManifest(i);return c(n)}return i},o=[];for(const i of v){const n=await r(i),d=(await this.extensionManagementService.getInstalled()).filter(y=>(0,C.areSameExtensions)(y.identifier,{id:n}));if(!d.length)throw new Error(`${this.notInstalled(n)}
${u}`);if(d.some(y=>y.type===0)){l.log((0,h.localize)(19,null,n));return}if(!a&&d.some(y=>y.isBuiltin)){l.log((0,h.localize)(20,null,n));return}l.log((0,h.localize)(21,null,n));for(const y of d)await this.extensionManagementService.uninstall(y),o.push(y);this.location?l.log((0,h.localize)(22,null,n,this.location)):l.log((0,h.localize)(23,null,n))}}async locateExtension(v,a=console){const l=await this.extensionManagementService.getInstalled();v.forEach(r=>{l.forEach(o=>{if(o.identifier.id===r&&o.location.scheme===P.Schemas.file){a.log(o.location.fsPath);return}})})}notInstalled(v){return this.location?(0,h.localize)(24,null,v,this.location):(0,h.localize)(25,null,v)}};D=Ne([je(0,f.IExtensionManagementService),je(1,f.IExtensionGalleryService)],D),e.ExtensionManagementCLIService=D}),define(ue[215],de([0,1,13,12,3,2,19,59,5,25,17,28,29,34,15,16]),function(Y,e,S,k,p,P,t,T,h,f,C,I,m,u,c,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;const g=/^([^.]+\..+)-(\d+\.\d+\.\d+)$/;let D=class extends p.Disposable{constructor(v,a,l,r){super();this.fileService=a,this.extensionGalleryService=l,this.logService=r,this.extensionsDownloadDir=h.URI.file(v.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(v,a){await this.cleanUpPromise;const l=this.getName(v),r=(0,t.joinPath)(this.extensionsDownloadDir,l);if(!await this.fileService.exists(r)){const o=(0,t.joinPath)(this.extensionsDownloadDir,`.${(0,f.generateUuid)()}`);await this.fileService.exists(o)||await this.extensionGalleryService.download(v,o,a);try{await this.rename(o,r,Date.now()+2*60*1e3)}catch(i){try{await this.fileService.del(o)}catch(n){}if(i.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",v.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,k.getErrorMessage)(i)}. Deleted the vsix from downloaded location`,o.path),i}}return r}async delete(v){await this.cleanUpPromise,await this.fileService.del(v)}async rename(v,a,l){try{await C.Promises.rename(v.fsPath,a.fsPath)}catch(r){if(P.isWindows&&r&&r.code==="EPERM"&&Date.now()<l)return this.logService.info(`Failed renaming ${v} to ${a} with 'EPERM' error. Trying again...`),this.rename(v,a,l);throw r}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const v=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(v.children){const a=[],l=[];for(const i of v.children){const n=this.parse(i.name);n&&l.push([n,i])}const r=(0,u.groupByExtension)(l,([i])=>i),o=[];for(const i of r)i.sort((n,s)=>T.rcompare(n[0].version,s[0].version)),a.push(...i.slice(1).map(n=>n[1].resource)),o.push(i[0][1]);o.sort((i,n)=>i.mtime-n.mtime),a.push(...o.slice(0,Math.max(0,o.length-this.cache)).map(i=>i.resource)),await S.Promises.settled(a.map(i=>(this.logService.trace("Deleting vsix from cache",i.path),this.fileService.del(i))))}}catch(v){this.logService.error(v)}}getName(v){return this.cache?`${new u.ExtensionIdentifierWithVersion(v.identifier,v.version).key().toLowerCase()}${v.properties.targetPlatform!=="undefined"?`-${v.properties.targetPlatform}`:""}`:(0,f.generateUuid)()}parse(v){const a=g.exec(v);return a&&a[1]&&a[2]?new u.ExtensionIdentifierWithVersion({id:a[1]},a[2]):null}};D=Ne([je(0,I.INativeEnvironmentService),je(1,c.IFileService),je(2,m.IExtensionGalleryService),je(3,b.ILogService)],D),e.ExtensionsDownloader=D}),define(ue[216],de([0,1,3,4,17,43]),function(Y,e,S,k,p,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class t extends S.Disposable{constructor(h,f){super();this.environmentService=h,this.extensionsManifestCache=(0,k.join)(this.environmentService.userDataPath,P.MANIFEST_CACHE_FOLDER,P.USER_MANIFEST_CACHE_FILE),this._register(f.onDidInstallExtensions(C=>this.onDidInstallExtensions(C))),this._register(f.onDidUninstallExtension(C=>this.onDidUnInstallExtension(C)))}onDidInstallExtensions(h){h.some(f=>!!f.local)&&this.invalidate()}onDidUnInstallExtension(h){h.error||this.invalidate()}invalidate(){p.Promises.rm(this.extensionsManifestCache,p.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=t}),define(ue[108],de([0,1,77,20,13,3,10,4,17,28,29,34,75,16]),function(Y,e,S,k,p,P,t,T,h,f,C,I,m,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsService=void 0;let c=class extends P.Disposable{constructor(D,w,v){super();this.extensionManagementService=D,this.logService=v,this.cache=this._register(new b(w,v)),this.extensionManagementService.registerParticipant({postInstall:async a=>this.postInstallExtension(a),postUninstall:async a=>this.postUninstallExtension(a)})}async getLanguageIds(){const D=await this.cache.getLanguagePacks(),w=["en",...Object.keys(D)];return(0,k.distinct)(w)}async postInstallExtension(D){D&&D.manifest&&D.manifest.contributes&&D.manifest.contributes.localizations&&D.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",D.identifier.id),await this.update())}async postUninstallExtension(D){const w=await this.cache.getLanguagePacks();Object.keys(w).some(v=>w[v]&&w[v].extensions.some(a=>(0,I.areSameExtensions)(a.extensionIdentifier,D.identifier)))&&(this.logService.info("Removing language packs from the extension",D.identifier.id),await this.update())}async update(){const[D,w]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),v=await this.cache.update(w);return!(0,k.equals)(Object.keys(D),Object.keys(v))}};c=Ne([je(0,C.IExtensionManagementService),je(1,f.INativeEnvironmentService),je(2,u.ILogService)],c),e.LocalizationsService=c;let b=class extends P.Disposable{constructor(D,w){super();this.logService=w,this.languagePacks={},this.languagePacksFilePath=(0,T.join)(D.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new p.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(D){return this.withLanguagePacks(w=>{Object.keys(w).forEach(v=>delete w[v]),this.createLanguagePacksFromExtensions(w,...D)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(D,...w){for(const v of w)v&&v.manifest&&v.manifest.contributes&&v.manifest.contributes.localizations&&v.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(D,v);Object.keys(D).forEach(v=>this.updateHash(D[v]))}createLanguagePacksFromExtension(D,w){const v=w.identifier,a=w.manifest.contributes&&w.manifest.contributes.localizations?w.manifest.contributes.localizations:[];for(const l of a)if(w.location.scheme===t.Schemas.file&&(0,m.isValidLocalization)(l)){let r=D[l.languageId];r||(r={hash:"",extensions:[],translations:{}},D[l.languageId]=r);let o=r.extensions.filter(i=>(0,I.areSameExtensions)(i.extensionIdentifier,v))[0];o?o.version=w.manifest.version:r.extensions.push({extensionIdentifier:v,version:w.manifest.version});for(const i of l.translations)r.translations[i.id]=(0,T.join)(w.location.fsPath,i.path)}}updateHash(D){if(D){const w=(0,S.createHash)("md5");for(const v of D.extensions)w.update(v.extensionIdentifier.uuid||v.extensionIdentifier.id).update(v.version);D.hash=w.digest("hex")}}withLanguagePacks(D=()=>null){return this.languagePacksFileLimiter.queue(()=>{let w=null;return h.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,v=>v.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(v)).then(v=>{try{return JSON.parse(v)}catch(a){return{}}}).then(v=>(w=D(v),v)).then(v=>{for(const l of Object.keys(v))v[l]||delete v[l];this.languagePacks=v,this.initializedCache=!0;const a=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",a),h.Promises.writeFile(this.languagePacksFilePath,a)}).then(()=>w,v=>this.logService.error(v))})}};b=Ne([je(0,f.INativeEnvironmentService),je(1,u.ILogService)],b)}),define(ue[60],de([0,1,18,173,42,7,22]),function(Y,e,S,k,p,P,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,P.createDecorator)("requestService");function T(c){return c.res.statusCode&&c.res.statusCode>=200&&c.res.statusCode<300||c.res.statusCode===1223}e.isSuccess=T;function h(c){return c.res.statusCode===204}async function f(c){if(!T(c))throw new Error("Server returned "+c.res.statusCode);return h(c)?null:(await(0,S.streamToBuffer)(c.stream)).toString()}e.asText=f;async function C(c){if(!T(c))throw new Error("Server returned "+c.res.statusCode);if(h(c))return null;const g=(await(0,S.streamToBuffer)(c.stream)).toString();try{return JSON.parse(g)}catch(D){throw D.message+=`:
`+g,D}}e.asJson=C;function I(c){u(c)}e.updateProxyConfigurationsScope=I;let m;function u(c){const b=t.Registry.as(p.Extensions.Configuration),g=m;m={id:"http",order:15,title:(0,k.localize)(0,null),type:"object",scope:c,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,k.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,k.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,k.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,k.localize)(4,null),(0,k.localize)(5,null),(0,k.localize)(6,null),(0,k.localize)(7,null)],default:"override",description:(0,k.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,k.localize)(9,null),restricted:!0}}},b.updateConfigurations({add:[m],remove:g?[g]:[]})}u(2)}),define(ue[217],de([0,1,24,10,15,60]),function(Y,e,S,k,p,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let t=class{constructor(h,f){this.requestService=h,this.fileService=f}async download(h,f,C=S.CancellationToken.None){if(h.scheme===k.Schemas.file||h.scheme===k.Schemas.vscodeRemote){await this.fileService.copy(h,f);return}const I={type:"GET",url:h.toString()},m=await this.requestService.request(I,C);if(m.res.statusCode===200)await this.fileService.writeFile(f,m.stream);else{const u=await(0,P.asText)(m);throw new Error(`Expected 200, got back ${m.res.statusCode} instead.

${u}`)}}};t=Ne([je(0,P.IRequestService),je(1,p.IFileService)],t),e.DownloadService=t}),define(ue[218],de([0,1,18,24]),function(Y,e,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestChannelClient=e.RequestChannel=void 0;class p{constructor(T){this.service=T}listen(T,h){throw new Error("Invalid listen")}call(T,h,f){switch(h){case"request":return this.service.request(f[0],k.CancellationToken.None).then(async({res:C,stream:I})=>{const m=await(0,S.streamToBuffer)(I);return[{statusCode:C.statusCode,headers:C.headers},m]})}throw new Error("Invalid call")}}e.RequestChannel=p;class P{constructor(T){this.channel=T}async request(T,h){return P.request(this.channel,T,h)}static async request(T,h,f){const[C,I]=await T.call("request",[h]);return{res:C,stream:(0,S.bufferToStream)(I)}}}e.RequestChannelClient=P}),define(ue[219],de([0,1,78,11]),function(Y,e,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function p(t,T){return t.protocol==="http:"?T.HTTP_PROXY||T.http_proxy||null:t.protocol==="https:"&&(T.HTTPS_PROXY||T.https_proxy||T.HTTP_PROXY||T.http_proxy)||null}async function P(t,T,h={}){const f=(0,S.parse)(t),C=h.proxyUrl||p(f,T);if(!C)return null;const I=(0,S.parse)(C);if(!/^https?:$/.test(I.protocol||""))return null;const m={host:I.hostname||"",port:I.port||(I.protocol==="https"?"443":"80"),auth:I.auth,rejectUnauthorized:(0,k.isBoolean)(h.strictSSL)?h.strictSSL:!0};return f.protocol==="http:"?new(await new Promise((u,c)=>{Y(["http-proxy-agent"],u,c)}))(m):new(await new Promise((u,c)=>{Y(["https-proxy-agent"],u,c)}))(m)}e.getProxyAgent=P}),define(ue[109],de([0,1,18,25]),function(Y,e,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function p(P,t,T){let h=T&&T.get("storage.serviceMachineId",0)||null;if(h)return h;try{const C=(await t.readFile(P.serviceMachineIdResource)).value.toString();h=(0,k.isUUID)(C)?C:null}catch(f){h=null}if(!h){h=(0,k.generateUuid)();try{await t.writeFile(P.serviceMachineIdResource,S.VSBuffer.fromString(h))}catch(f){}}return T&&T.store("storage.serviceMachineId",h,0,1),h}e.getServiceMachineId=p}),define(ue[220],de([0,1,13,6,3,48,11,146,7]),function(Y,e,S,k,p,P,t,T,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const f="__$__targetStorageMarker";e.IStorageService=(0,h.createDecorator)("storageService");var C;(function(g){g[g.NONE=0]="NONE",g[g.SHUTDOWN=1]="SHUTDOWN"})(C=e.WillSaveStateReason||(e.WillSaveStateReason={}));var I;(function(g){g[g.GLOBAL=0]="GLOBAL",g[g.WORKSPACE=1]="WORKSPACE"})(I=e.StorageScope||(e.StorageScope={}));var m;(function(g){g[g.USER=0]="USER",g[g.MACHINE=1]="MACHINE"})(m=e.StorageTarget||(e.StorageTarget={}));class u extends p.Disposable{constructor(D={flushInterval:u.DEFAULT_FLUSH_INTERVAL}){super();this.options=D,this._onDidChangeValue=this._register(new k.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new k.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new k.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new S.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new p.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,S.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,p.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,P.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,P.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(D,w){w===f?(D===0?this._globalKeyTargets=void 0:D===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:D})):this._onDidChangeValue.fire({scope:D,key:w,target:this.getKeyTargets(D)[w]})}emitWillSaveState(D){this._onWillSaveState.fire({reason:D})}get(D,w,v){return this.getStorage(w)?.get(D,v)}getBoolean(D,w,v){return this.getStorage(w)?.getBoolean(D,v)}getNumber(D,w,v){return this.getStorage(w)?.getNumber(D,v)}store(D,w,v,a){if((0,t.isUndefinedOrNull)(w)){this.remove(D,v);return}this.withPausedEmitters(()=>{this.updateKeyTarget(D,v,a),this.getStorage(v)?.set(D,w)})}remove(D,w){this.withPausedEmitters(()=>{this.updateKeyTarget(D,w,void 0),this.getStorage(w)?.delete(D)})}withPausedEmitters(D){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{D()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(D,w){const v=[],a=this.getKeyTargets(D);for(const l of Object.keys(a))a[l]===w&&v.push(l);return v}updateKeyTarget(D,w,v){const a=this.getKeyTargets(w);typeof v=="number"?a[D]!==v&&(a[D]=v,this.getStorage(w)?.set(f,JSON.stringify(a))):typeof a[D]=="number"&&(delete a[D],this.getStorage(w)?.set(f,JSON.stringify(a)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(D){return D===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(D){const w=this.get(f,D);if(w)try{return JSON.parse(w)}catch(v){}return Object.create(null)}isNew(D){return this.getBoolean(e.IS_NEW_KEY,D)===!0}async flush(D=C.NONE){this._onWillSaveState.fire({reason:D});const w=this.getStorage(0),v=this.getStorage(1);switch(D){case C.NONE:await S.Promises.settled([w?.whenFlushed()??Promise.resolve(),v?.whenFlushed()??Promise.resolve()]);break;case C.SHUTDOWN:await S.Promises.settled([w?.flush(0)??Promise.resolve(),v?.flush(0)??Promise.resolve()]);break}}async logStorage(){const D=this.getStorage(0)?.items??new Map,w=this.getStorage(1)?.items??new Map;return b(D,w,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}e.AbstractStorageService=u,u.DEFAULT_FLUSH_INTERVAL=60*1e3;class c extends u{constructor(){super();this.globalStorage=this._register(new T.Storage(new T.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new T.Storage(new T.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(D=>this.emitDidChangeValue(1,D))),this._register(this.globalStorage.onDidChangeStorage(D=>this.emitDidChangeValue(0,D)))}getStorage(D){return D===0?this.globalStorage:this.workspaceStorage}getLogDetails(D){return D===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(D){}}e.InMemoryStorageService=c;async function b(g,D,w,v){const a=d=>{try{return JSON.parse(d)}catch(y){return d}},l=new Map,r=new Map;g.forEach((d,y)=>{l.set(y,d),r.set(y,a(d))});const o=new Map,i=new Map;D.forEach((d,y)=>{o.set(y,d),i.set(y,a(d))}),console.group(`Storage: Global (path: ${w})`);let n=[];l.forEach((d,y)=>{n.push({key:y,value:d})}),console.table(n),console.groupEnd(),console.log(r),console.group(`Storage: Workspace (path: ${v})`);let s=[];o.forEach((d,y)=>{s.push({key:y,value:d})}),console.table(s),console.groupEnd(),console.log(i)}e.logStorage=b}),define(ue[221],de([0,1,2,23,5,25]),function(Y,e,S,k,p,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function t(f){if(S.platform===2&&/^penguin(\.|$)/i.test(f))return"chromebook"}async function T(f,C,I,m,u,c,b,g,D,w){const v=Object.create(null);v["common.machineId"]=b,v.sessionID=(0,P.generateUuid)()+Date.now(),v.commitHash=u,v.version=c,v["common.platformVersion"]=(C||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),v["common.platform"]=(0,S.PlatformToString)(S.platform),v["common.nodePlatform"]=k.platform,v["common.nodeArch"]=m,v["common.product"]=w||"desktop";const a=h(g||[]);a&&(v["common.msftInternal"]=a);let l=0;const r=Date.now();Object.defineProperties(v,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-r,enumerable:!0},"common.sequence":{get:()=>l++,enumerable:!0}}),S.isLinuxSnap&&(v["common.snap"]="true");const o=t(I);o&&(v["common.platformDetail"]=o);try{const i=await f.readFile(p.URI.file(D));v["common.source"]=i.value.toString().slice(0,30)}catch(i){}return v}e.resolveCommonProperties=T;function h(f){const C=k.env.USERDNSDOMAIN;if(!C)return!1;const I=C.toLowerCase();return f.some(m=>I===m)}e.verifyMicrosoftInternalDomain=h}),define(ue[222],de([0,1,20,12,3,21]),function(Y,e,S,k,p,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ErrorEvent=void 0;var t;(function(h){function f(C,I){return C.callstack<I.callstack?-1:C.callstack>I.callstack?1:0}h.compare=f})(t=e.ErrorEvent||(e.ErrorEvent={}));class T{constructor(f,C=T.ERROR_FLUSH_TIMEOUT){this._flushHandle=-1,this._buffer=[],this._disposables=new p.DisposableStore,this._telemetryService=f,this._flushDelay=C;const I=k.errorHandler.addListener(m=>this._onErrorEvent(m));this._disposables.add((0,p.toDisposable)(I)),this.installErrorListeners()}dispose(){clearTimeout(this._flushHandle),this._flushBuffer(),this._disposables.dispose()}installErrorListeners(){}_onErrorEvent(f){if(!f)return;f.detail&&f.detail.stack&&(f=f.detail);let C=Array.isArray(f.stack)?f.stack.join(`
`):f.stack,I=f.message?f.message:(0,P.safeStringify)(f);!C||this._enqueue({msg:I,callstack:C})}_enqueue(f){const C=(0,S.binarySearch)(this._buffer,f,t.compare);C<0?(f.count=1,this._buffer.splice(~C,0,f)):(this._buffer[C].count||(this._buffer[C].count=0),this._buffer[C].count+=1),this._flushHandle===-1&&(this._flushHandle=setTimeout(()=>{this._flushBuffer(),this._flushHandle=-1},this._flushDelay))}_flushBuffer(){for(let f of this._buffer)this._telemetryService.publicLogError2("UnhandledError",f);this._buffer.length=0}}e.default=T,T.ERROR_FLUSH_TIMEOUT=5*1e3}),define(ue[33],de([0,1,7]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,S.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,S.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var k;(function(P){P[P.NONE=0]="NONE",P[P.CRASH=1]="CRASH",P[P.ERROR=2]="ERROR",P[P.USAGE=3]="USAGE"})(k=e.TelemetryLevel||(e.TelemetryLevel={}));var p;(function(P){P.OFF="off",P.CRASH="crash",P.ERROR="error",P.ON="all"})(p=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(ue[223],de([0,1,26,53,13,36,10,4,2,5,91,17,94,201,15,38,33]),function(Y,e,S,k,p,P,t,T,h,f,C,I,m,u,c,b,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;async function D(r,o){const i=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.yml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],n=new Map,s=new Map,d=2e4;function y(R,O,K,te){const j=O.substring(R.length+1);return p.Promises.withAsyncBody(async _=>{let U;try{U=await I.Promises.readdir(O,{withFileTypes:!0})}catch(V){_();return}if(te.count>=d){te.count+=U.length,te.maxReached=!0,_();return}let F=U.length;if(F===0){_();return}let M=U;te.count+U.length>d&&(te.maxReached=!0,F=d-te.count,M=U.slice(0,F)),te.count+=U.length;for(const V of M)if(V.isDirectory()){if(K.includes(V.name)||await y(R,(0,T.join)(O,V.name),K,te),--F==0){_();return}}else{const ee=V.name.lastIndexOf(".");if(ee>=0){const G=V.name.substring(ee+1);G&&n.set(G,(n.get(G)??0)+1)}for(const G of i)G.relativePathPattern?.test(j)!==!1&&G.filePattern.test(V.name)&&s.set(G.tag,(s.get(G.tag)??0)+1);if(--F==0){_();return}}})}const A={count:0,maxReached:!1};await y(r,r,o,A);const E=await a(r);return{configFiles:w(s),fileTypes:w(n),fileCount:A.count,maxFilesReached:A.maxReached,launchConfigFiles:E}}e.collectWorkspaceStats=D;function w(r){return[...k.Iterable.map(r.entries(),([o,i])=>({name:o,count:i}))].sort((o,i)=>i.count-o.count)}function v(){const r={os:`${S.type()} ${S.arch()} ${S.release()}`,memory:`${(S.totalmem()/c.ByteSize.GB).toFixed(2)}GB (${(S.freemem()/c.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(C.virtualMachineHint.value()*100)}%`},o=S.cpus();return o&&o.length>0&&(r.cpus=`${o[0].model} (${o.length} x ${o[0].speed})`),r}e.getMachineInfo=v;async function a(r){try{const o=new Map,i=(0,T.join)(r,".vscode","launch.json"),n=await I.Promises.readFile(i),s=[],d=(0,P.parse)(n.toString(),s);if(s.length)return console.log(`Unable to parse ${i}`),[];if((0,P.getNodeType)(d)==="object"&&d.configurations)for(const y of d.configurations){const A=y.type;A&&(o.has(A)?o.set(A,o.get(A)+1):o.set(A,1))}return w(o)}catch(o){return[]}}e.collectLaunchConfigs=a;let l=class{constructor(o,i){this.telemetryService=o,this.productService=i}formatMachineInfo(o){const i=[];return i.push(`OS Version:       ${o.os}`),i.push(`CPUs:             ${o.cpus}`),i.push(`Memory (System):  ${o.memory}`),i.push(`VM:               ${o.vmHint}`),i.join(`
`)}formatEnvironment(o){const i=[];i.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),i.push(`OS Version:       ${S.type()} ${S.arch()} ${S.release()}`);const n=S.cpus();return n&&n.length>0&&i.push(`CPUs:             ${n[0].model} (${n.length} x ${n[0].speed})`),i.push(`Memory (System):  ${(S.totalmem()/c.ByteSize.GB).toFixed(2)}GB (${(S.freemem()/c.ByteSize.GB).toFixed(2)}GB free)`),h.isWindows||i.push(`Load (avg):       ${S.loadavg().map(s=>Math.round(s)).join(", ")}`),i.push(`VM:               ${Math.round(C.virtualMachineHint.value()*100)}%`),i.push(`Screen Reader:    ${o.screenReader?"yes":"no"}`),i.push(`Process Argv:     ${o.mainArguments.join(" ")}`),i.push(`GPU Status:       ${this.expandGPUFeatures(o.gpuFeatureStatus)}`),i.join(`
`)}async getPerformanceInfo(o,i){return Promise.all([(0,m.listProcesses)(o.mainPID),this.formatWorkspaceMetadata(o)]).then(async n=>{let[s,d]=n,y=this.formatProcessList(o,s);return i.forEach(A=>{if((0,u.isRemoteDiagnosticError)(A))y+=`
${A.errorMessage}`,d+=`
${A.errorMessage}`;else if(y+=`

Remote: ${A.hostName}`,A.processes&&(y+=`
${this.formatProcessList(o,A.processes)}`),A.workspaceMetadata){d+=`
|  Remote: ${A.hostName}`;for(const E of Object.keys(A.workspaceMetadata)){const R=A.workspaceMetadata[E];let O=`${R.fileCount} files`;R.maxFilesReached&&(O=`more than ${O}`),d+=`|    Folder (${E}): ${O}`,d+=this.formatWorkspaceStats(R)}}}),{processInfo:y,workspaceInfo:d}})}async getSystemInfo(o,i){const{memory:n,vmHint:s,os:d,cpus:y}=v(),A={os:d,memory:n,cpus:y,vmHint:s,processArgs:`${o.mainArguments.join(" ")}`,gpuStatus:o.gpuFeatureStatus,screenReader:`${o.screenReader?"yes":"no"}`,remoteData:i};return h.isWindows||(A.load=`${S.loadavg().map(E=>Math.round(E)).join(", ")}`),h.isLinux&&(A.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(A)}async getDiagnostics(o,i){const n=[];return(0,m.listProcesses)(o.mainPID).then(async s=>(n.push(""),n.push(this.formatEnvironment(o)),n.push(""),n.push(this.formatProcessList(o,s)),o.windows.some(d=>d.folderURIs&&d.folderURIs.length>0&&!d.remoteAuthority)&&(n.push(""),n.push("Workspace Stats: "),n.push(await this.formatWorkspaceMetadata(o))),i.forEach(d=>{if((0,u.isRemoteDiagnosticError)(d))n.push(`
${d.errorMessage}`);else if(n.push(`

`),n.push(`Remote:           ${d.hostName}`),n.push(this.formatMachineInfo(d.machineInfo)),d.processes&&n.push(this.formatProcessList(o,d.processes)),d.workspaceMetadata)for(const y of Object.keys(d.workspaceMetadata)){const A=d.workspaceMetadata[y];let E=`${A.fileCount} files`;A.maxFilesReached&&(E=`more than ${E}`),n.push(`Folder (${y}): ${E}`),n.push(this.formatWorkspaceStats(A))}}),n.push(""),n.push(""),n.join(`
`)))}formatWorkspaceStats(o){const i=[],n=60;let s=0;const d=(R,O)=>{const K=` ${R}(${O})`;s+K.length>n?(i.push(y),y="|                 ",s=y.length):s+=K.length,y+=K};let y="|      File types:";const A=10;let E=o.fileTypes.length>A?A:o.fileTypes.length;for(let R=0;R<E;R++){const O=o.fileTypes[R];d(O.name,O.count)}if(i.push(y),o.configFiles.length>=0&&(y="|      Conf files:",s=0,o.configFiles.forEach(R=>{d(R.name,R.count)}),i.push(y)),o.launchConfigFiles.length>0){let R="|      Launch Configs:";o.launchConfigFiles.forEach(O=>{R+=O.count>1?` ${O.name}(${O.count})`:` ${O.name}`}),i.push(R)}return i.join(`
`)}expandGPUFeatures(o){const i=Math.max(...Object.keys(o).map(n=>n.length));return Object.keys(o).map(n=>`${n}:  ${" ".repeat(i-n.length)}  ${o[n]}`).join(`
                  `)}formatWorkspaceMetadata(o){const i=[],n=[];return o.windows.forEach(s=>{s.folderURIs.length===0||!!s.remoteAuthority||(i.push(`|  Window (${s.title})`),s.folderURIs.forEach(d=>{const y=f.URI.revive(d);if(y.scheme===t.Schemas.file){const A=y.fsPath;n.push(D(A,["node_modules",".git"]).then(E=>{let R=`${E.fileCount} files`;E.maxFilesReached&&(R=`more than ${R}`),i.push(`|    Folder (${(0,T.basename)(A)}): ${R}`),i.push(this.formatWorkspaceStats(E))}).catch(E=>{i.push(`|      Error: Unable to collect workspace stats for folder ${A} (${E.toString()})`)}))}else i.push(`|    Folder (${y.toString()}): Workspace stats not available.`)}))}),Promise.all(n).then(s=>i.join(`
`)).catch(s=>`Unable to collect workspace stats: ${s}`)}formatProcessList(o,i){const n=new Map;o.windows.forEach(d=>n.set(d.pid,d.title));const s=[];return s.push("CPU %	Mem MB	   PID	Process"),i&&this.formatProcessItem(o.mainPID,n,s,i,0),s.join(`
`)}formatProcessItem(o,i,n,s,d){const y=d===0;let A;y?A=s.pid===o?`${this.productService.applicationName} main`:"remote agent":(A=`${"  ".repeat(d)} ${s.name}`,s.name==="window"&&(A=`${A} (${i.get(s.pid)})`));const E=process.platform==="win32"?s.mem:S.totalmem()*(s.mem/100);n.push(`${s.load.toFixed(0).padStart(5," ")}	${(E/c.ByteSize.MB).toFixed(0).padStart(6," ")}	${s.pid.toFixed(0).padStart(6," ")}	${A}`),Array.isArray(s.children)&&s.children.forEach(R=>this.formatProcessItem(o,i,n,R,d+1))}async reportWorkspaceStats(o){for(const{uri:i}of o.folders){const n=f.URI.revive(i);if(n.scheme!==t.Schemas.file)continue;const s=n.fsPath;try{const d=await D(s,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":o.telemetryId,rendererSessionId:o.rendererSessionId}),d.fileTypes.forEach(y=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:o.rendererSessionId,type:y.name,count:y.count})}),d.launchConfigFiles.forEach(y=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:o.rendererSessionId,type:y.name,count:y.count})}),d.configFiles.forEach(y=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:o.rendererSessionId,type:y.name,count:y.count})})}catch{}}}};l=Ne([je(0,g.ITelemetryService),je(1,b.IProductService)],l),e.DiagnosticsService=l}),define(ue[224],de([0,1,20,13,24,12,6,3,2,5,161,29,34,16,38,33]),function(Y,e,S,k,p,P,t,T,h,f,C,I,m,u,c,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.reportTelemetry=e.joinErrors=e.AbstractExtensionManagementService=void 0;let g=class extends T.Disposable{constructor(r,o,i,n){super();this.galleryService=r,this.telemetryService=o,this.logService=i,this.productService=n,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new t.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new t.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new t.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new t.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this.participants=[],this._register((0,T.toDisposable)(()=>{this.installingExtensions.forEach(s=>s.cancel()),this.uninstallingExtensions.forEach(s=>s.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(r){const o=await this.getTargetPlatform();return r.allTargetPlatforms.some(i=>(0,I.isTargetPlatformCompatible)(i,r.allTargetPlatforms,o))}async installFromGallery(r,o={}){try{if(!this.galleryService.isEnabled())throw new I.ExtensionManagementError(C.localize(0,null),I.ExtensionManagementErrorCode.Internal);const i=await this.checkAndGetCompatibleVersion(r,!o.installGivenVersion,!!o.installPreReleaseVersion);return await this.installExtension(i.manifest,i.extension,o)}catch(i){throw v(this.telemetryService,"extensionGallery:install",(0,m.getGalleryExtensionTelemetryData)(r),void 0,i),this.logService.error("Failed to install extension.",r.identifier.id),this.logService.error(i),w(i)}}async uninstall(r,o={}){return this.logService.trace("ExtensionManagementService#uninstall",r.identifier.id),this.unininstallExtension(r,o)}async reinstallFromGallery(r){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",r.identifier.id),!this.galleryService.isEnabled())throw new Error(C.localize(1,null));const o=await this.findGalleryExtension(r);if(!o)throw new Error(C.localize(2,null));await this.createUninstallExtensionTask(r,{remove:!0,versionOnly:!0}).run(),await this.installFromGallery(o)}getExtensionsReport(){const r=new Date().getTime();return(!this.reportedExtensions||r-this.lastReportTimestamp>1e3*60*5)&&(this.reportedExtensions=this.updateReportCache(),this.lastReportTimestamp=r),this.reportedExtensions}registerParticipant(r){this.participants.push(r)}async installExtension(r,o,i){if(!f.URI.isUri(o)){let A=this.installingExtensions.get(new m.ExtensionIdentifierWithVersion(o.identifier,o.version).key());if(A)return this.logService.info("Extensions is already requested to install",o.identifier.id),A.waitUntilTaskIsFinished();i={...i,installOnlyNewlyAddedFromExtensionPack:!0}}const n=[],s=[],d=this.createInstallExtensionTask(r,o,i);f.URI.isUri(o)||this.installingExtensions.set(new m.ExtensionIdentifierWithVersion(d.identifier,r.version).key(),d),this._onInstallExtension.fire({identifier:d.identifier,source:o}),this.logService.info("Installing extension:",d.identifier.id),n.push({task:d,manifest:r});let y=!1;try{if(i.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",d.identifier.id);else try{const E=await this.getAllDepsAndPackExtensionsToInstall(d.identifier,r,!!i.installOnlyNewlyAddedFromExtensionPack,!!i.installPreReleaseVersion);for(const{gallery:R,manifest:O}of E)if(y=y||!!O.extensionDependencies?.some(K=>(0,m.areSameExtensions)({id:K},d.identifier)),this.installingExtensions.has(new m.ExtensionIdentifierWithVersion(R.identifier,R.version).key()))this.logService.info("Extension is already requested to install",R.identifier.id);else{const K=this.createInstallExtensionTask(O,R,{...i,donotIncludePackAndDependencies:!0});this.installingExtensions.set(new m.ExtensionIdentifierWithVersion(K.identifier,O.version).key(),K),this._onInstallExtension.fire({identifier:K.identifier,source:R}),this.logService.info("Installing extension:",K.identifier.id),n.push({task:K,manifest:O})}}catch(E){if(f.URI.isUri(d.source))(0,S.isNonEmptyArray)(r.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",d.identifier.id,E.message),(0,S.isNonEmptyArray)(r.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",d.identifier.id,E.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",d.identifier.id),E}const A=n.reduce((E,{task:R,manifest:O})=>(E.set(R.identifier.id.toLowerCase(),{task:R,manifest:O}),E),new Map);for(;A.size;){let E;const R=[...A.values()].filter(({manifest:O})=>!O.extensionDependencies?.some(K=>A.has(K.toLowerCase())));R.length?E=A.size===1?R:R.filter(({task:O})=>!(O===d&&!y)):(this.logService.info("Found extensions with circular dependencies",R.map(({task:O})=>O.identifier.id)),E=[...A.values()]),await this.joinAllSettled(E.map(async({task:O})=>{const K=new Date().getTime();try{const te=await O.run();if(await this.joinAllSettled(this.participants.map(j=>j.postInstall(te,O.source,i,p.CancellationToken.None))),!f.URI.isUri(O.source)&&(v(this.telemetryService,O.operation===2?"extensionGallery:update":"extensionGallery:install",(0,m.getGalleryExtensionTelemetryData)(O.source),new Date().getTime()-K,void 0),h.isWeb&&O.operation===1))try{await this.galleryService.reportStatistic(te.manifest.publisher,te.manifest.name,te.manifest.version,"install")}catch(j){}s.push({local:te,identifier:O.identifier,operation:O.operation,source:O.source})}catch(te){throw f.URI.isUri(O.source)||v(this.telemetryService,O.operation===2?"extensionGallery:update":"extensionGallery:install",(0,m.getGalleryExtensionTelemetryData)(O.source),new Date().getTime()-K,te),this.logService.error("Error while installing the extension:",O.identifier.id),te}finally{A.delete(O.identifier.id.toLowerCase())}}))}return s.forEach(({identifier:E})=>this.logService.info("Extension installed successfully:",E.id)),this._onDidInstallExtensions.fire(s),s.filter(({identifier:E})=>(0,m.areSameExtensions)(E,d.identifier))[0].local}catch(A){if(n.forEach(({task:E})=>E.cancel()),s.length)try{const E=await Promise.allSettled(s.map(({local:R})=>this.createUninstallExtensionTask(R,{versionOnly:!0}).run()));for(let R=0;R<E.length;R++){const O=E[R],{identifier:K}=s[R];O.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",K.id):this.logService.warn("Rollback: Error while uninstalling extension",K.id,(0,P.getErrorMessage)(O.reason))}}catch(E){this.logService.warn("Error while rolling back extensions",(0,P.getErrorMessage)(E),s.map(({identifier:R})=>R.id))}throw this._onDidInstallExtensions.fire(n.map(({task:E})=>({identifier:E.identifier,operation:1,source:E.source}))),A}finally{for(const{task:A,manifest:E}of n)if(!f.URI.isUri(A.source)){const R=new m.ExtensionIdentifierWithVersion(A.identifier,E.version).key();this.installingExtensions.delete(R)||this.logService.warn("Installation task is not found in the cache",R)}}}async joinAllSettled(r){const o=[],i=[],n=await Promise.allSettled(r);for(const s of n)s.status==="fulfilled"?o.push(s.value):i.push(s.reason);if(i.length)throw D(i);return o}async getAllDepsAndPackExtensionsToInstall(r,o,i,n){if(!this.galleryService.isEnabled())return[];let s=await this.getInstalled();const d=[r,...s.map(E=>E.identifier)],y=[],A=async(E,R)=>{const O=R.extensionDependencies||[],K=[...O];if(R.extensionPack){const te=i?s.find(j=>(0,m.areSameExtensions)(j.identifier,E)):void 0;for(const j of R.extensionPack)te&&te.manifest.extensionPack&&te.manifest.extensionPack.some(_=>(0,m.areSameExtensions)({id:_},{id:j}))||K.every(_=>!(0,m.areSameExtensions)({id:_},{id:j}))&&K.push(j)}if(K.length){const te=[...d,...y.map(_=>_.gallery.identifier)],j=K.filter(_=>te.every(U=>!(0,m.areSameExtensions)(U,{id:_})));if(j.length){const _=await this.galleryService.query({names:j,pageSize:K.length},p.CancellationToken.None);for(const U of _.firstPage){if(te.find(V=>(0,m.areSameExtensions)(V,U.identifier)))continue;const F=O.some(V=>(0,m.areSameExtensions)({id:V},U.identifier));let M;try{M=await this.checkAndGetCompatibleVersion(U,!0,n)}catch(V){if(V instanceof I.ExtensionManagementError&&V.code===I.ExtensionManagementErrorCode.IncompatibleTargetPlatform&&!F){this.logService.info("Skipping the packed extension as it cannot be installed",U.identifier.id);continue}else throw V}y.push({gallery:M.extension,manifest:M.manifest}),await A(M.extension.identifier,R)}}}};return await A(r,o),s=await this.getInstalled(),y.filter(E=>!s.some(R=>(0,m.areSameExtensions)(R.identifier,E.gallery.identifier)))}async checkAndGetCompatibleVersion(r,o,i){if(await this.isMalicious(r))throw new I.ExtensionManagementError(C.localize(3,null,r.identifier.id),I.ExtensionManagementErrorCode.Malicious);if(!await this.canInstall(r)){const d=await this.getTargetPlatform();throw new I.ExtensionManagementError(C.localize(4,null,r.identifier.id,this.productService.nameLong,(0,I.TargetPlatformToString)(d)),I.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const n=await this.getCompatibleVersion(r,o,i);if(n){if(i&&r.hasPreReleaseVersion&&!n.properties.isPreReleaseVersion)throw new I.ExtensionManagementError(C.localize(5,null,r.identifier.id,this.productService.nameLong,this.productService.version),I.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw new I.ExtensionManagementError(C.localize(6,null,r.identifier.id,this.productService.nameLong,this.productService.version),I.ExtensionManagementErrorCode.Incompatible);const s=await this.galleryService.getManifest(n,p.CancellationToken.None);if(s===null)throw new I.ExtensionManagementError(`Missing manifest for extension ${r.identifier.id}`,I.ExtensionManagementErrorCode.Invalid);if(s.version!==n.version)throw new I.ExtensionManagementError(`Cannot install '${r.identifier.id}' extension because of version mismatch in Marketplace`,I.ExtensionManagementErrorCode.Invalid);return{extension:n,manifest:s}}async getCompatibleVersion(r,o,i){const n=await this.getTargetPlatform();let s=null;return o&&r.hasPreReleaseVersion&&r.properties.isPreReleaseVersion!==i&&(s=await this.galleryService.getCompatibleExtension(r.identifier,i,n)),!s&&await this.galleryService.isExtensionCompatible(r,i,n)&&(s=r),!s&&o&&(s=await this.galleryService.getCompatibleExtension(r,i,n)),s}async isMalicious(r){const o=await this.getExtensionsReport();return(0,m.getMaliciousExtensionsSet)(o).has(r.identifier.id)}async unininstallExtension(r,o){const i=this.uninstallingExtensions.get(r.identifier.id.toLowerCase());if(i)return this.logService.info("Extensions is already requested to uninstall",r.identifier.id),i.waitUntilTaskIsFinished();const n=(A,E)=>{const R=this.createUninstallExtensionTask(A,E);return this.uninstallingExtensions.set(R.extension.identifier.id.toLowerCase(),R),this.logService.info("Uninstalling extension:",A.identifier.id),this._onUninstallExtension.fire(A.identifier),R},s=(A,E)=>{E?this.logService.error("Failed to uninstall extension:",A.identifier.id,E.message):this.logService.info("Successfully uninstalled extension:",A.identifier.id),v(this.telemetryService,"extensionGallery:uninstall",(0,m.getLocalExtensionTelemetryData)(A),void 0,E),this._onDidUninstallExtension.fire({identifier:A.identifier,error:E?.code})},d=[],y=[];try{d.push(n(r,{}));const A=await this.getInstalled(1);if(o.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",r.identifier.id);else{const E=this.getAllPackExtensionsToUninstall(r,A);for(const R of E)this.uninstallingExtensions.has(R.identifier.id.toLowerCase())?this.logService.info("Extensions is already requested to uninstall",R.identifier.id):d.push(n(R,{}))}o.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",r.identifier.id):this.checkForDependents(d.map(E=>E.extension),A,r),await this.joinAllSettled(d.map(async E=>{try{if(await E.run(),await this.joinAllSettled(this.participants.map(R=>R.postUninstall(E.extension,o,p.CancellationToken.None))),E.extension.identifier.uuid)try{await this.galleryService.reportStatistic(E.extension.manifest.publisher,E.extension.manifest.name,E.extension.manifest.version,"uninstall")}catch(R){}s(E.extension)}catch(R){const O=R instanceof I.ExtensionManagementError?R:new I.ExtensionManagementError((0,P.getErrorMessage)(R),I.ExtensionManagementErrorCode.Internal);throw s(E.extension,O),O}finally{y.push(E)}}))}catch(A){const E=A instanceof I.ExtensionManagementError?A:new I.ExtensionManagementError((0,P.getErrorMessage)(A),I.ExtensionManagementErrorCode.Internal);for(const R of d){try{R.cancel()}catch(O){}y.includes(R)||s(R.extension,E)}throw E}finally{for(const A of d)this.uninstallingExtensions.delete(A.extension.identifier.id.toLowerCase())||this.logService.warn("Uninstallation task is not found in the cache",A.extension.identifier.id)}}checkForDependents(r,o,i){for(const n of r){const s=this.getDependents(n,o);if(s.length){const d=s.filter(y=>!r.some(A=>(0,m.areSameExtensions)(A.identifier,y.identifier)));if(d.length)throw new Error(this.getDependentsErrorMessage(n,d,i))}}}getDependentsErrorMessage(r,o,i){return i===r?o.length===1?C.localize(7,null,i.manifest.displayName||i.manifest.name,o[0].manifest.displayName||o[0].manifest.name):o.length===2?C.localize(8,null,i.manifest.displayName||i.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):C.localize(9,null,i.manifest.displayName||i.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):o.length===1?C.localize(10,null,i.manifest.displayName||i.manifest.name,r.manifest.displayName||r.manifest.name,o[0].manifest.displayName||o[0].manifest.name):o.length===2?C.localize(11,null,i.manifest.displayName||i.manifest.name,r.manifest.displayName||r.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):C.localize(12,null,i.manifest.displayName||i.manifest.name,r.manifest.displayName||r.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name)}getAllPackExtensionsToUninstall(r,o,i=[]){if(i.indexOf(r)!==-1)return[];i.push(r);const n=r.manifest.extensionPack?r.manifest.extensionPack:[];if(n.length){const s=o.filter(y=>!y.isBuiltin&&n.some(A=>(0,m.areSameExtensions)({id:A},y.identifier))),d=[];for(const y of s)d.push(...this.getAllPackExtensionsToUninstall(y,o,i));return[...s,...d]}return[]}getDependents(r,o){return o.filter(i=>i.manifest.extensionDependencies&&i.manifest.extensionDependencies.some(n=>(0,m.areSameExtensions)({id:n},r.identifier)))}async findGalleryExtension(r){if(r.identifier.uuid){const o=await this.findGalleryExtensionById(r.identifier.uuid);return o||this.findGalleryExtensionByName(r.identifier.id)}return this.findGalleryExtensionByName(r.identifier.id)}async findGalleryExtensionById(r){return(await this.galleryService.query({ids:[r],pageSize:1},p.CancellationToken.None)).firstPage[0]}async findGalleryExtensionByName(r){return(await this.galleryService.query({names:[r],pageSize:1},p.CancellationToken.None)).firstPage[0]}async updateReportCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const r=await this.galleryService.getExtensionsReport();return this.logService.trace(`ExtensionManagementService.refreshReportedCache - got ${r.length} reported extensions from service`),r}catch(r){return this.logService.trace("ExtensionManagementService.refreshReportedCache - failed to get extension report"),[]}}};g=Ne([je(0,I.IExtensionGalleryService),je(1,b.ITelemetryService),je(2,u.ILogService),je(3,c.IProductService)],g),e.AbstractExtensionManagementService=g;function D(l){const r=Array.isArray(l)?l:[l];return r.length===1?r[0]instanceof Error?r[0]:new Error(r[0]):r.reduce((o,i)=>new Error(`${o.message}${o.message?",":""}${i instanceof Error?i.message:i}`),new Error(""))}e.joinErrors=D;function w(l){if(l instanceof I.ExtensionManagementError)return l;const r=new I.ExtensionManagementError(l.message,I.ExtensionManagementErrorCode.Internal);return r.stack=l.stack,r}function v(l,r,o,i,n){const s=n?n instanceof I.ExtensionManagementError?n.code:I.ExtensionManagementErrorCode.Internal:void 0;l.publicLogError(r,{...o,success:!n,duration:i,errorcode:s})}e.reportTelemetry=v;class a{constructor(){this.barrier=new k.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,k.createCancelablePromise)(r=>this.doRun(r))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,k.createCancelablePromise)(r=>new Promise((o,i)=>{const n=r.onCancellationRequested(()=>{n.dispose(),i((0,P.canceled)())})})),this.barrier.open()),this.cancellablePromise.cancel()}}e.AbstractExtensionTask=a}),define(ue[39],de([0,1,21,11,27,33]),function(Y,e,S,k,p,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=void 0;class t{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(D,w){return Promise.resolve(void 0)}publicLog2(D,w){return this.publicLog(D,w)}publicLogError(D,w){return Promise.resolve(void 0)}publicLogError2(D,w){return this.publicLogError(D,w)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=t,e.NullTelemetryService=new t;class T{async publicLog(D,w,v){}async publicLogError(D,w,v){}}e.NullEndpointTelemetryService=T,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function h(g,D){return D.onDidChangeConfiguration(w=>{w.source!==6&&g.publicLog2("updateConfiguration",{configurationSource:(0,p.ConfigurationTargetToString)(w.source),configurationKeys:c(w.sourceConfig)})})}e.configurationTelemetry=h;function f(g,D){return!(D.disableTelemetry||!g.enableTelemetry)}e.supportsTelemetry=f;function C(g){const D=g.getValue(P.TELEMETRY_SETTING_ID),w=g.getValue("telemetry.enableCrashReporter");if(g.getValue(P.TELEMETRY_OLD_SETTING_ID)===!1||w===!1)return 0;switch(D??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=C;function I(g){const D=Object.create(null),w=Object.create(null),v=Object.create(null);u(g,v);for(let a in v){a=a.length>150?a.substr(a.length-149):a;const l=v[a];typeof l=="number"?w[a]=l:typeof l=="boolean"?w[a]=l?1:0:typeof l=="string"?(l.length>8192&&console.warn(`Telemetry property: ${a} has been trimmed to 8192, the original length is ${l.length}`),D[a]=l.substring(0,8191)):typeof l!="undefined"&&l!==null&&(D[a]=l)}return{properties:D,measurements:w}}e.validateTelemetryData=I;function m(g){if(!g)return"none";let D="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(v=>{g.indexOf(`${v}+`)===0&&(D=v)}),D}e.cleanRemoteAuthority=m;function u(g,D,w=0,v){if(!!g)for(let a of Object.getOwnPropertyNames(g)){const l=g[a],r=v?v+a:a;Array.isArray(l)?D[r]=(0,S.safeStringify)(l):l instanceof Date?D[r]=l.toISOString():(0,k.isObject)(l)?w<2?u(l,D,w+1,r+"."):D[r]=(0,S.safeStringify)(l):D[r]=l}}function c(g){if(!g)return[];const D=[];return b(D,"",g),D}function b(g,D,w){w&&typeof w=="object"&&!Array.isArray(w)?Object.keys(w).forEach(v=>b(g,D?`${D}.${v}`:v,w[v])):g.push(D)}}),define(ue[110],de([0,1,20,24,12,21,2,23,11,5,27,28,29,34,70,15,16,38,60,109,220,33,39]),function(Y,e,S,k,p,P,t,T,h,f,C,I,m,u,c,b,g,D,w,v,a,l,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const o=t.isWeb?"web":(0,m.getTargetPlatform)(t.platform,T.arch);var i;(function(se){se[se.None=0]="None",se[se.IncludeVersions=1]="IncludeVersions",se[se.IncludeFiles=2]="IncludeFiles",se[se.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",se[se.IncludeSharedAccounts=8]="IncludeSharedAccounts",se[se.IncludeVersionProperties=16]="IncludeVersionProperties",se[se.ExcludeNonValidated=32]="ExcludeNonValidated",se[se.IncludeInstallationTargets=64]="IncludeInstallationTargets",se[se.IncludeAssetUri=128]="IncludeAssetUri",se[se.IncludeStatistics=256]="IncludeStatistics",se[se.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",se[se.Unpublished=4096]="Unpublished"})(i||(i={}));function n(...se){return String(se.reduce((ae,ke)=>ae|ke,0))}var s;(function(se){se[se.Tag=1]="Tag",se[se.ExtensionId=4]="ExtensionId",se[se.Category=5]="Category",se[se.ExtensionName=7]="ExtensionName",se[se.Target=8]="Target",se[se.Featured=9]="Featured",se[se.SearchText=10]="SearchText",se[se.ExcludeWithFlags=12]="ExcludeWithFlags"})(s||(s={}));const d={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},y={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},E={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:i.None,criteria:[],assetTypes:[]};class R{constructor(ae=E){this.state=ae}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(ae,ke=this.state.pageSize){return new R({...this.state,pageNumber:ae,pageSize:ke})}withFilter(ae,...ke){const De=[...this.state.criteria,...ke.length?ke.map(Oe=>({filterType:ae,value:Oe})):[{filterType:ae}]];return new R({...this.state,criteria:De})}withSortBy(ae){return new R({...this.state,sortBy:ae})}withSortOrder(ae){return new R({...this.state,sortOrder:ae})}withFlags(...ae){return new R({...this.state,flags:ae.reduce((ke,De)=>ke|De,0)})}withAssetTypes(...ae){return new R({...this.state,assetTypes:ae})}get raw(){const{criteria:ae,pageNumber:ke,pageSize:De,sortBy:Oe,sortOrder:Be,flags:Xe,assetTypes:Ze}=this.state;return{filters:[{criteria:ae,pageNumber:ke,pageSize:De,sortBy:Oe,sortOrder:Be}],assetTypes:Ze,flags:Xe}}get searchText(){const ae=this.state.criteria.filter(ke=>ke.filterType===s.SearchText)[0];return ae&&ae.value?ae.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(ae=>String(ae.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function O(se,ae){const ke=(se||[]).filter(De=>De.statisticName===ae)[0];return ke?ke.value:0}function K(se){const ae="Microsoft.VisualStudio.Code.Translation.";return se.files.filter(De=>De.assetType.indexOf(ae)===0).reduce((De,Oe)=>{const Be=U(se,Oe.assetType);return Be&&De.push([Oe.assetType.substring(ae.length),Be]),De},[])}function te(se){if(se.properties){const ae=se.properties.filter(Oe=>Oe.key===d.Repository),ke=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),De=ae.filter(Oe=>ke.test(Oe.value))[0];return De?{uri:De.value,fallbackUri:De.value}:null}return U(se,d.Repository)}function j(se){return{uri:`${se.fallbackAssetUri}/${d.VSIX}?redirect=true${se.targetPlatform?`&targetPlatform=${se.targetPlatform}`:""}`,fallbackUri:`${se.fallbackAssetUri}/${d.VSIX}${se.targetPlatform?`?targetPlatform=${se.targetPlatform}`:""}`}}function _(se){const ae=U(se,d.Icon);if(ae)return ae;const ke=m.DefaultIconPath;return{uri:ke,fallbackUri:ke}}function U(se,ae){return se.files.filter(De=>De.assetType===ae)[0]?{uri:`${se.assetUri}/${ae}`,fallbackUri:`${se.fallbackAssetUri}/${ae}`}:null}function F(se,ae){const ke=se.properties?se.properties.filter(Oe=>Oe.key===ae):[],De=ke.length>0&&ke[0].value;return De?De.split(",").map(Oe=>(0,u.adoptToGalleryExtensionId)(Oe)):[]}function M(se){const ae=se.properties?se.properties.filter(ke=>ke.key===y.Engine):[];return ae.length>0&&ae[0].value||""}function V(se){const ae=se.properties?se.properties.filter(ke=>ke.key===y.PreRelease):[];return ae.length>0&&ae[0].value==="true"}function ee(se){const ae=se.properties?se.properties.filter(De=>De.key===y.LocalizedLanguages):[],ke=ae.length>0&&ae[0].value||"";return ke?ke.split(","):[]}function G(se){return se.indexOf("preview")!==-1}function H(se){return se.targetPlatform?(0,m.toTargetPlatform)(se.targetPlatform):"undefined"}function q(se){const ae=(0,S.distinct)(se.versions.map(H)),ke=!!se.tags?.includes(m.WEB_EXTENSION_TAG),De=ae.indexOf("web");return ke?De===-1&&ae.push("web"):De!==-1&&ae.splice(De,1),ae}function z(se,ae){const ke=(0,m.getFallbackTargetPlarforms)(ae);for(let De=0;De<se.length;De++){const Oe=se[De];if(Oe.version===se[De-1]?.version){let Be=De;const Xe=H(Oe);if(Xe===ae)for(;Be>0&&se[Be-1].version===Oe.version;)Be--;else if(ke.includes(Xe))for(;Be>0&&se[Be-1].version===Oe.version&&H(se[Be-1])!==ae;)Be--;Be!==De&&(se.splice(De,1),se.splice(Be,0,Oe))}}return se}e.sortExtensionVersions=z;function B(se,ae,ke,De){const Oe=se.versions[0],Be={manifest:U(ae,d.Manifest),readme:U(ae,d.Details),changelog:U(ae,d.Changelog),license:U(ae,d.License),repository:te(ae),download:j(ae),icon:_(ae),coreTranslations:K(ae)};return{identifier:{id:(0,u.getGalleryExtensionId)(se.publisher.publisherName,se.extensionName),uuid:se.extensionId},name:se.extensionName,version:ae.version,displayName:se.displayName,publisherId:se.publisher.publisherId,publisher:se.publisher.publisherName,publisherDisplayName:se.publisher.displayName,publisherDomain:se.publisher.domain?{link:se.publisher.domain,verified:!!se.publisher.isDomainVerified}:void 0,description:se.shortDescription||"",installCount:O(se.statistics,"install"),rating:O(se.statistics,"averagerating"),ratingCount:O(se.statistics,"ratingcount"),categories:se.categories||[],tags:se.tags||[],releaseDate:Date.parse(se.releaseDate),lastUpdated:Date.parse(se.lastUpdated),allTargetPlatforms:ke,assets:Be,properties:{dependencies:F(ae,y.Dependency),extensionPack:F(ae,y.ExtensionPack),engine:M(ae),localizedLanguages:ee(ae),targetPlatform:H(ae),isPreReleaseVersion:V(ae)},hasPreReleaseVersion:V(Oe),preview:G(se.flags),telemetryData:De}}let W=class{constructor(ae,ke,De,Oe,Be,Xe,Ze,ge){this.requestService=ke,this.logService=De,this.environmentService=Oe,this.telemetryService=Be,this.fileService=Xe,this.productService=Ze,this.configurationService=ge;const me=Ze.extensionsGallery;this.extensionsGalleryUrl=me&&me.serviceUrl,this.extensionsControlUrl=me&&me.controlUrl,this.commonHeadersPromise=we(Ze.version,Ze,this.environmentService,this.configurationService,this.fileService,ae)}api(ae=""){return`${this.extensionsGalleryUrl}${ae}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(ae,ke,De){const Oe=(0,h.isBoolean)(ke)?ke:!1,Be=(0,h.isBoolean)(ke)?De:ke;let Xe=new R().withFlags(i.IncludeAssetUri,i.IncludeStatistics,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeVersionProperties).withPage(1,ae.length).withFilter(s.Target,"Microsoft.VisualStudio.Code").withFilter(s.ExtensionName,...ae.map(({id:me})=>me.toLowerCase()));ae.every(me=>!me.version)&&(Xe=Xe.withFlags(i.IncludeAssetUri,i.IncludeStatistics,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeVersionProperties,i.IncludeLatestVersionOnly));const{galleryExtensions:Ze}=await this.queryGallery(Xe,o,k.CancellationToken.None),ge=Ze.map(me=>{const Ie=(0,u.getGalleryExtensionId)(me.publisher.publisherName,me.extensionName);return{rawGalleryExtension:me,version:ae.find(Re=>(0,u.areSameExtensions)(Re,{id:Ie}))?.version}});return this.converToGalleryExtensions(ge,Oe,o,()=>{},Be)}async getCompatibleExtension(ae,ke,De){const Oe=(0,m.isIExtensionIdentifier)(ae)?null:ae;if(Oe){if((0,m.isNotWebExtensionInWebTargetPlatform)(Oe.allTargetPlatforms,De))return null;if(await this.isExtensionCompatible(Oe,ke,De))return Oe}const{id:Be,uuid:Xe}=Oe?Oe.identifier:ae;let Ze=new R().withFlags(i.IncludeAssetUri,i.IncludeStatistics,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeVersionProperties).withPage(1,1).withFilter(s.Target,"Microsoft.VisualStudio.Code");Xe?Ze=Ze.withFilter(s.ExtensionId,Xe):Ze=Ze.withFilter(s.ExtensionName,Be);const{galleryExtensions:ge}=await this.queryGallery(Ze,De,k.CancellationToken.None),[me]=ge;if(!me||!me.versions.length)return null;const Ie=q(me);if((0,m.isNotWebExtensionInWebTargetPlatform)(Ie,De))return null;for(let Re of me.versions){if(!M(Re)){const Le=await this.getEngine(Re);Re={...Re,properties:[...Re.properties||[],{key:y.Engine,value:Le}]}}if(await this.isRawExtensionVersionCompatible(Re,ke,Ie,De))return B(me,Re,Ie)}return null}async isExtensionCompatible(ae,ke,De){if(!(0,m.isTargetPlatformCompatible)(ae.properties.targetPlatform,ae.allTargetPlatforms,De)||!ke&&ae.properties.isPreReleaseVersion)return!1;let Oe=ae.properties.engine;if(!Oe){const Be=await this.getManifest(ae,k.CancellationToken.None);if(!Be)throw new Error("Manifest was not found");Oe=Be.engines.vscode}return(0,c.isEngineValid)(Oe,this.productService.version,this.productService.date)}async isRawExtensionVersionCompatible(ae,ke,De,Oe){if(!(0,m.isTargetPlatformCompatible)(H(ae),De,Oe)||!ke&&V(ae))return!1;const Be=await this.getEngine(ae);return(0,c.isEngineValid)(Be,this.productService.version,this.productService.date)}async query(ae,ke){if(!this.isEnabled())throw new Error("No extension gallery service configured.");let De=ae.text||"";const Oe=(0,P.getOrDefault)(ae,Re=>Re.pageSize,50);let Be=new R().withFlags(i.IncludeLatestVersionOnly,i.IncludeAssetUri,i.IncludeStatistics,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeVersionProperties).withPage(1,Oe).withFilter(s.Target,"Microsoft.VisualStudio.Code");De?(De=De.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(Re,Le,He)=>(Be=Be.withFilter(s.Category,He||Le),"")),De=De.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(Re,Le,He)=>(Be=Be.withFilter(s.Tag,He||Le),"")),De=De.replace(/\bfeatured(\s+|\b|$)/g,()=>(Be=Be.withFilter(s.Featured),"")),De=De.trim(),De&&(De=De.length<200?De:De.substring(0,200),Be=Be.withFilter(s.SearchText,De)),Be=Be.withSortBy(0)):ae.ids?Be=Be.withFilter(s.ExtensionId,...ae.ids):ae.names?Be=Be.withFilter(s.ExtensionName,...ae.names):Be=Be.withSortBy(4),typeof ae.sortBy=="number"&&(Be=Be.withSortBy(ae.sortBy)),typeof ae.sortOrder=="number"&&(Be=Be.withSortOrder(ae.sortOrder));const{galleryExtensions:Xe,total:Ze}=await this.queryGallery(Be,o,ke),ge=Re=>({index:(Be.pageNumber-1)*Be.pageSize+Re,querySource:ae.source}),me=await this.converToGalleryExtensions(Xe.map(Re=>({rawGalleryExtension:Re})),!!ae.includePreRelease,o,ge,ke),Ie=async(Re,Le)=>{if(Le.isCancellationRequested)throw(0,p.canceled)();const He=Be.withPage(Re+1),{galleryExtensions:Qe}=await this.queryGallery(He,o,Le);return await this.converToGalleryExtensions(Qe.map(Je=>({rawGalleryExtension:Je})),!!ae.includePreRelease,o,ge,ke)};return{firstPage:me,total:Ze,pageSize:Be.pageSize,getPage:Ie}}async converToGalleryExtensions(ae,ke,De,Oe,Be){const Xe=(me,Ie)=>{const Re=q(me);let Le=me.versions[0];return Le=me.versions.find(He=>He.version===Le.version&&(0,m.isTargetPlatformCompatible)(H(He),Re,De))||Le,!ke&&V(Le)&&(Le=me.versions.find(He=>He.version!==Le.version&&!V(He))||Le),B(me,Le,Re,Oe(Ie))},Ze=[],ge=new Map;for(let me=0;me<ae.length;me++){const{rawGalleryExtension:Ie,version:Re}=ae[me];if(Re){const Le=Ie.versions.find(He=>He.version===Re);Le&&Ze.push([me,B(Ie,Le,q(Ie))])}else{const Le=Xe(Ie,me);Le.properties.isPreReleaseVersion&&!ke?ge.set(Le.identifier.uuid,me):Ze.push([me,Le])}}if(ge.size){const me=new R().withFlags(i.IncludeVersions,i.IncludeAssetUri,i.IncludeStatistics,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeVersionProperties).withPage(1,ge.size).withFilter(s.Target,"Microsoft.VisualStudio.Code").withFilter(s.ExtensionId,...ge.keys()),{galleryExtensions:Ie}=await this.queryGallery(me,De,Be);if(Ie.length!==ge.size)throw new Error("Not all extensions with latest versions are returned");for(const Re of Ie){const Le=ge.get(Re.extensionId),He=Xe(Re,Le);Ze.push([Le,He])}}return Ze.sort((me,Ie)=>me[0]-Ie[0]).map(([,me])=>me)}async queryGallery(ae,ke,De){if(!this.isEnabled())throw new Error("No extension gallery service configured.");ae=ae.withFlags(ae.flags,i.ExcludeNonValidated).withFilter(s.ExcludeWithFlags,n(i.Unpublished));const Oe=await this.commonHeadersPromise,Be=JSON.stringify(ae.raw),Xe={...Oe,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(Be.length)},Ze=new Date().getTime();let ge,me,Ie=0;try{if(ge=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:Be,headers:Xe},De),ge.res.statusCode&&ge.res.statusCode>=400&&ge.res.statusCode<500)return{galleryExtensions:[],total:Ie};const Re=await(0,w.asJson)(ge);if(Re){const Le=Re.results[0],He=Le.extensions;He.forEach(Je=>z(Je.versions,ke));const Qe=Le.resultMetadata&&Le.resultMetadata.filter(Je=>Je.metadataType==="ResultCount")[0];return Ie=Qe&&Qe.metadataItems.filter(Je=>Je.name==="TotalCount")[0].count||0,{galleryExtensions:He,total:Ie}}return{galleryExtensions:[],total:Ie}}catch(Re){throw me=Re,Re}finally{this.telemetryService.publicLog2("galleryService:query",{...ae.telemetryData,requestBodySize:String(Be.length),duration:new Date().getTime()-Ze,success:!!ge&&(0,w.isSuccess)(ge),responseBodySize:ge?.res.headers["Content-Length"],statusCode:ge?String(ge.res.statusCode):void 0,errorCode:me?(0,p.isPromiseCanceledError)(me)?"canceled":(0,p.getErrorMessage)(me).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(Ie)})}}async reportStatistic(ae,ke,De,Oe){if(!this.isEnabled())return;const Be=t.isWeb?this.api(`/itemName/${ae}.${ke}/version/${De}/statType/${Oe==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${ae}/extensions/${ke}/${De}/stats?statType=${Oe}`),Xe=t.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",ge={...await this.commonHeadersPromise,Accept:Xe};try{await this.requestService.request({type:"POST",url:Be,headers:ge},k.CancellationToken.None)}catch(me){}}async download(ae,ke,De){this.logService.trace("ExtensionGalleryService#download",ae.identifier.id);const Oe=(0,u.getGalleryExtensionTelemetryData)(ae),Be=new Date().getTime(),Xe=Ie=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...Oe,duration:Ie}),Ze=De===1?"install":De===2?"update":"",ge=Ze?{uri:`${ae.assets.download.uri}${f.URI.parse(ae.assets.download.uri).query?"&":"?"}${Ze}=true`,fallbackUri:`${ae.assets.download.fallbackUri}${f.URI.parse(ae.assets.download.fallbackUri).query?"&":"?"}${Ze}=true`}:ae.assets.download,me=await this.getAsset(ge);await this.fileService.writeFile(ke,me.stream),Xe(new Date().getTime()-Be)}async getReadme(ae,ke){if(ae.assets.readme){const De=await this.getAsset(ae.assets.readme,{},ke);return await(0,w.asText)(De)||""}return""}async getManifest(ae,ke){if(ae.assets.manifest){const De=await this.getAsset(ae.assets.manifest,{},ke),Oe=await(0,w.asText)(De);return Oe?JSON.parse(Oe):null}return null}async getManifestFromRawExtensionVersion(ae,ke){const De=U(ae,d.Manifest);if(!De)throw new Error("Manifest was not found");const Oe={"Accept-Encoding":"gzip"},Be=await this.getAsset(De,{headers:Oe});return await(0,w.asJson)(Be)}async getCoreTranslation(ae,ke){const De=ae.assets.coreTranslations.filter(Oe=>Oe[0]===ke.toUpperCase())[0];if(De){const Oe=await this.getAsset(De[1]),Be=await(0,w.asText)(Oe);return Be?JSON.parse(Be):null}return null}async getChangelog(ae,ke){if(ae.assets.changelog){const De=await this.getAsset(ae.assets.changelog,{},ke);return await(0,w.asText)(De)||""}return""}async getAllCompatibleVersions(ae,ke,De){let Oe=new R().withFlags(i.IncludeVersions,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeVersionProperties).withPage(1,1).withFilter(s.Target,"Microsoft.VisualStudio.Code");ae.identifier.uuid?Oe=Oe.withFilter(s.ExtensionId,ae.identifier.uuid):Oe=Oe.withFilter(s.ExtensionName,ae.identifier.id);const{galleryExtensions:Be}=await this.queryGallery(Oe,De,k.CancellationToken.None);if(!Be.length)return[];const Xe=q(Be[0]);if((0,m.isNotWebExtensionInWebTargetPlatform)(Xe,De))return[];const Ze=[];for(const ge of Be[0].versions)try{Ze[Ze.length-1]?.version!==ge.version&&await this.isRawExtensionVersionCompatible(ge,ke,Xe,De)&&Ze.push({version:ge.version,date:ge.lastUpdated,isPreReleaseVersion:V(ge)})}catch(me){}return Ze}async getAsset(ae,ke={},De=k.CancellationToken.None){const Oe=await this.commonHeadersPromise,Be={type:"GET"},Xe={...Oe,...ke.headers||{}};ke={...ke,...Be,headers:Xe};const Ze=ae.uri,ge=ae.fallbackUri,me={...ke,url:Ze};try{const Ie=await this.requestService.request(me,De);if(Ie.res.statusCode===200)return Ie;const Re=await(0,w.asText)(Ie);throw new Error(`Expected 200, got back ${Ie.res.statusCode} instead.

${Re}`)}catch(Ie){if((0,p.isPromiseCanceledError)(Ie))throw Ie;const Re=(0,p.getErrorMessage)(Ie);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:Ze,message:Re});const Le={...ke,url:ge};return this.requestService.request(Le,De)}}async getEngine(ae){let ke=M(ae);if(!ke){const De=await this.getManifestFromRawExtensionVersion(ae,k.CancellationToken.None);if(!De)throw new Error("Manifest was not found");ke=De.engines.vscode}return ke}async getExtensionsReport(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return[];const ae=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},k.CancellationToken.None);if(ae.res.statusCode!==200)throw new Error("Could not get extensions report.");const ke=await(0,w.asJson)(ae),De=new Map;if(ke)for(const Oe of ke.malicious){const Be=De.get(Oe)||{id:{id:Oe},malicious:!0,slow:!1};Be.malicious=!0,De.set(Oe,Be)}return[...De.values()]}};W=Ne([je(1,w.IRequestService),je(2,g.ILogService),je(3,I.IEnvironmentService),je(4,l.ITelemetryService),je(5,b.IFileService),je(6,D.IProductService),je(7,C.IConfigurationService)],W);let ie=class extends W{constructor(ae,ke,De,Oe,Be,Xe,Ze,ge){super(ae,ke,De,Oe,Be,Xe,Ze,ge)}};ie=Ne([je(0,a.IStorageService),je(1,w.IRequestService),je(2,g.ILogService),je(3,I.IEnvironmentService),je(4,l.ITelemetryService),je(5,b.IFileService),je(6,D.IProductService),je(7,C.IConfigurationService)],ie),e.ExtensionGalleryService=ie;let oe=class extends W{constructor(ae,ke,De,Oe,Be,Xe,Ze){super(void 0,ae,ke,De,Oe,Be,Xe,Ze)}};oe=Ne([je(0,w.IRequestService),je(1,g.ILogService),je(2,I.IEnvironmentService),je(3,l.ITelemetryService),je(4,b.IFileService),je(5,D.IProductService),je(6,C.IConfigurationService)],oe),e.ExtensionGalleryServiceWithNoStorageService=oe;async function we(se,ae,ke,De,Oe,Be){const Xe={"X-Market-Client-Id":`VSCode ${se}`,"User-Agent":`VSCode ${se}`},Ze=await(0,v.getServiceMachineId)(ke,Oe,Be);return(0,r.supportsTelemetry)(ae,ke)&&(0,r.getTelemetryLevel)(De)===3&&(Xe["X-Market-User-Id"]=Ze),Xe}e.resolveMarketplaceHeaders=we}),define(ue[225],de([0,1,3,21,2,14,174,27,42,58,22,33,39]),function(Y,e,S,k,p,P,t,T,h,f,C,I,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let u=class{constructor(g,D){this._configurationService=D,this._experimentProperties={},this._disposables=new S.DisposableStore,this._cleanupPatterns=[],this._appenders=g.appenders,this._commonProperties=g.commonProperties||Promise.resolve({}),this._piiPaths=g.piiPaths||[],this._telemetryLevel=3,this.sendErrorTelemetry=!!g.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let w of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,P.escapeRegExpCharacters)(w),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._telemetryLevel===3}),this._commonProperties.then(w=>{const v=/^[a-f0-9]+$/i.test(w["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!v})})}setExperimentProperty(g,D){this._experimentProperties[g]=D}_updateTelemetryLevel(){this._telemetryLevel=(0,m.getTelemetryLevel)(this._configurationService)}get telemetryLevel(){return this._telemetryLevel}async getTelemetryInfo(){const g=await this._commonProperties;let D=g.sessionID,w=g["common.machineId"],v=g["common.firstSessionDate"],a=g["common.msftInternal"];return{sessionId:D,machineId:w,firstSessionDate:v,msftInternal:a}}dispose(){this._disposables.dispose()}_log(g,D,w,v){return this.telemetryLevel<D?Promise.resolve(void 0):this._commonProperties.then(a=>{w=(0,k.mixin)(w,a),w=(0,k.mixin)(w,this._experimentProperties),w=(0,k.cloneAndChange)(w,l=>{if(typeof l=="string")return this._cleanupInfo(l,v)}),this._appenders.forEach(l=>l.log(g,w))},a=>{console.error(a)})}publicLog(g,D,w){return this._log(g,3,D,w)}publicLog2(g,D,w){return this.publicLog(g,D,w)}publicLogError(g,D){return this.sendErrorTelemetry?this._log(g,2,D,!0):Promise.resolve(void 0)}publicLogError2(g,D){return this.publicLogError(g,D)}_anonymizeFilePaths(g){let D=g;const w=[];for(let r of this._cleanupPatterns)for(;;){const o=r.exec(g);if(!o)break;w.push([o.index,r.lastIndex])}const v=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,a=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let l=0;for(D="";;){const r=a.exec(g);if(!r)break;!v.test(r[0])&&w.every(([o,i])=>r.index<o||r.index>=i)&&(D+=g.substring(l,r.index)+"<REDACTED: user-file-path>",l=a.lastIndex)}return l<g.length&&(D+=g.substr(l)),D}_removePropertiesWithPossibleUserInfo(g){if(!g)return g;const D=g.toLowerCase(),w=/@[a-zA-Z0-9-.]+/;return/\S*(key|token|sig|password|passwd|pwd)[="':\s]+\S*/.test(D)?"<REDACTED: secret>":w.test(D)?"<REDACTED: email>":g}_cleanupInfo(g,D){let w=g;D&&(w=this._anonymizeFilePaths(w));for(let v of this._cleanupPatterns)w=w.replace(v,"");return w=this._removePropertiesWithPossibleUserInfo(w),w}};u.IDLE_START_EVENT_NAME="UserIdleStart",u.IDLE_STOP_EVENT_NAME="UserIdleStop",u=Ne([je(1,T.IConfigurationService)],u),e.TelemetryService=u;function c(){const b=(0,t.localize)(0,null,f.default.nameLong),g=f.default.privacyStatementUrl?(0,t.localize)(2,null,"https://aka.ms/vscode-telemetry",f.default.privacyStatementUrl):(0,t.localize)(1,null,"https://aka.ms/vscode-telemetry"),D=p.isWeb?"":(0,t.localize)(3,null),w=(0,t.localize)(4,null),v=(0,t.localize)(5,null),a=(0,t.localize)(6,null),l=(0,t.localize)(7,null),r=`
|       | ${w} | ${v} | ${a} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,o=(0,t.localize)(8,null);return`
${b} ${g} ${D}

&nbsp;

${l}
${r}

&nbsp;

${o}
`}C.Registry.as(h.Extensions.Configuration).registerConfiguration({id:I.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,t.localize)(9,null),properties:{[I.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,t.localize)(10,null),(0,t.localize)(11,null),(0,t.localize)(12,null),(0,t.localize)(13,null)],markdownDescription:c(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),C.Registry.as(h.Extensions.Configuration).registerConfiguration({id:I.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,t.localize)(14,null),properties:{[I.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:f.default.privacyStatementUrl?(0,t.localize)(16,null,f.default.nameLong,f.default.privacyStatementUrl):(0,t.localize)(15,null,f.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,t.localize)(17,null,`\`#${I.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(ue[226],de([0,1,12,21,39]),function(Y,e,S,k,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AppInsightsAppender=void 0;async function P(T,h){const f=await new Promise((I,m)=>{Y(["applicationinsights"],I,m)});let C;return f.defaultClient?(C=new f.TelemetryClient(T),C.channel.setUseDiskRetryCaching(!0)):(f.setup(T).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),C=f.defaultClient),T.indexOf("AIF-")===0&&(C.config.endpointUrl=h?"https://mobile.events.data.microsoft.com/collect/v1":"https://vortex.data.microsoft.com/collect/v1"),C}class t{constructor(h,f,C,I,m){this._eventPrefix=h,this._defaultData=f,this.testCollector=I,this.mirrored=m,this._defaultData||(this._defaultData=Object.create(null)),typeof C=="function"?this._aiClient=C():this._aiClient=C,this._asyncAIClient=null}_withAIClient(h){if(!!this._aiClient){if(typeof this._aiClient!="string"){h(this._aiClient);return}this._asyncAIClient||(this._asyncAIClient=P(this._aiClient,this.testCollector??!1)),this._asyncAIClient.then(f=>{h(f)},f=>{(0,S.onUnexpectedError)(f),console.error(f)})}}log(h,f){!this._aiClient||(f=(0,k.mixin)(f,this._defaultData),f=(0,p.validateTelemetryData)(f),this.testCollector&&(f.properties["common.useragent"]=this.mirrored?"mirror-collector++":"collector++"),this._withAIClient(C=>C.trackEvent({name:this._eventPrefix+"/"+h,properties:f.properties,measurements:f.measurements})))}flush(){return this._aiClient?new Promise(h=>{this._withAIClient(f=>{f.flush({callback:()=>{this._aiClient=void 0,h(void 0)}})})}):Promise.resolve(void 0)}}e.AppInsightsAppender=t}),define(ue[227],de([0,1,12,222]),function(Y,e,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class p extends k.default{installErrorListeners(){(0,S.setUnexpectedErrorHandler)(T=>console.error(T));const t=[];process.on("unhandledRejection",(T,h)=>{t.push(h),setTimeout(()=>{const f=t.indexOf(h);f>=0&&h.catch(C=>{t.splice(f,1),(0,S.isPromiseCanceledError)(C)||(console.warn(`rejected promise not handled within 1 second: ${C}`),C.stack&&console.warn(`stack trace: ${C.stack}`),T&&(0,S.onUnexpectedError)(T))})},1e3)}),process.on("rejectionHandled",T=>{const h=t.indexOf(T);h>=0&&t.splice(h,1)}),process.on("uncaughtException",T=>{(0,S.onUnexpectedError)(T)})}}e.default=p}),define(ue[228],de([0,1,13,24,6,3,16]),function(Y,e,S,k,p,P,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestStore=void 0;let T=class extends P.Disposable{constructor(f,C){super();this._logService=C,this._lastRequestId=0,this._pendingRequests=new Map,this._pendingRequestDisposables=new Map,this._onCreateRequest=this._register(new p.Emitter),this.onCreateRequest=this._onCreateRequest.event,this._timeout=f===void 0?15e3:f}createRequest(f){return new Promise((C,I)=>{const m=++this._lastRequestId;this._pendingRequests.set(m,C),this._onCreateRequest.fire({requestId:m,...f});const u=new k.CancellationTokenSource;(0,S.timeout)(this._timeout,u.token).then(()=>I(`Request ${m} timed out (${this._timeout}ms)`)),this._pendingRequestDisposables.set(m,[(0,P.toDisposable)(()=>u.cancel())])})}acceptReply(f,C){const I=this._pendingRequests.get(f);I?(this._pendingRequests.delete(f),(0,P.dispose)(this._pendingRequestDisposables.get(f)||[]),this._pendingRequestDisposables.delete(f),I(C)):this._logService.warn(`RequestStore#acceptReply was called without receiving a matching request ${f}`)}};T=Ne([je(1,t.ILogService)],T),e.RequestStore=T}),define(ue[111],de([0,1,7]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.ProcessCapability=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.ProcessPropertyType=e.IPtyService=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.TerminalSettingId=e.TerminalSettingPrefix=void 0;var k;(function(g){g.Shell="terminal.integrated.shell.",g.ShellArgs="terminal.integrated.shellArgs.",g.DefaultProfile="terminal.integrated.defaultProfile.",g.Profiles="terminal.integrated.profiles."})(k=e.TerminalSettingPrefix||(e.TerminalSettingPrefix={}));var p;(function(g){g.ShellLinux="terminal.integrated.shell.linux",g.ShellMacOs="terminal.integrated.shell.osx",g.ShellWindows="terminal.integrated.shell.windows",g.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",g.AutomationShellLinux="terminal.integrated.automationShell.linux",g.AutomationShellMacOs="terminal.integrated.automationShell.osx",g.AutomationShellWindows="terminal.integrated.automationShell.windows",g.AutomationProfileLinux="terminal.integrated.automationProfile.linux",g.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",g.AutomationProfileWindows="terminal.integrated.automationProfile.windows",g.ShellArgsLinux="terminal.integrated.shellArgs.linux",g.ShellArgsMacOs="terminal.integrated.shellArgs.osx",g.ShellArgsWindows="terminal.integrated.shellArgs.windows",g.ProfilesWindows="terminal.integrated.profiles.windows",g.ProfilesMacOs="terminal.integrated.profiles.osx",g.ProfilesLinux="terminal.integrated.profiles.linux",g.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",g.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",g.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",g.UseWslProfiles="terminal.integrated.useWslProfiles",g.TabsEnabled="terminal.integrated.tabs.enabled",g.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",g.TabsHideCondition="terminal.integrated.tabs.hideCondition",g.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",g.TabsShowActions="terminal.integrated.tabs.showActions",g.TabsLocation="terminal.integrated.tabs.location",g.TabsFocusMode="terminal.integrated.tabs.focusMode",g.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",g.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",g.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",g.CopyOnSelection="terminal.integrated.copyOnSelection",g.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",g.FontFamily="terminal.integrated.fontFamily",g.FontSize="terminal.integrated.fontSize",g.LetterSpacing="terminal.integrated.letterSpacing",g.LineHeight="terminal.integrated.lineHeight",g.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",g.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",g.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",g.BellDuration="terminal.integrated.bellDuration",g.FontWeight="terminal.integrated.fontWeight",g.FontWeightBold="terminal.integrated.fontWeightBold",g.CursorBlinking="terminal.integrated.cursorBlinking",g.CursorStyle="terminal.integrated.cursorStyle",g.CursorWidth="terminal.integrated.cursorWidth",g.Scrollback="terminal.integrated.scrollback",g.DetectLocale="terminal.integrated.detectLocale",g.DefaultLocation="terminal.integrated.defaultLocation",g.GpuAcceleration="terminal.integrated.gpuAcceleration",g.TerminalTitleSeparator="terminal.integrated.tabs.separator",g.TerminalTitle="terminal.integrated.tabs.title",g.TerminalDescription="terminal.integrated.tabs.description",g.RightClickBehavior="terminal.integrated.rightClickBehavior",g.Cwd="terminal.integrated.cwd",g.ConfirmOnExit="terminal.integrated.confirmOnExit",g.ConfirmOnKill="terminal.integrated.confirmOnKill",g.EnableBell="terminal.integrated.enableBell",g.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",g.AllowChords="terminal.integrated.allowChords",g.AllowMnemonics="terminal.integrated.allowMnemonics",g.EnvMacOs="terminal.integrated.env.osx",g.EnvLinux="terminal.integrated.env.linux",g.EnvWindows="terminal.integrated.env.windows",g.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",g.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",g.ShowExitAlert="terminal.integrated.showExitAlert",g.SplitCwd="terminal.integrated.splitCwd",g.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",g.WordSeparators="terminal.integrated.wordSeparators",g.EnableFileLinks="terminal.integrated.enableFileLinks",g.UnicodeVersion="terminal.integrated.unicodeVersion",g.ExperimentalLinkProvider="terminal.integrated.experimentalLinkProvider",g.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",g.LocalEchoEnabled="terminal.integrated.localEchoEnabled",g.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",g.LocalEchoStyle="terminal.integrated.localEchoStyle",g.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",g.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",g.CustomGlyphs="terminal.integrated.customGlyphs",g.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",g.InheritEnv="terminal.integrated.inheritEnv",g.ShowLinkHover="terminal.integrated.showLinkHover",g.IgnoreProcessNames="terminal.integrated.ignoreProcessNames"})(p=e.TerminalSettingId||(e.TerminalSettingId={}));var P;(function(g){g.CommandPrompt="cmd",g.PowerShell="pwsh",g.Wsl="wsl",g.GitBash="gitbash"})(P=e.WindowsShellType||(e.WindowsShellType={}));var t;(function(g){g[g.Api=0]="Api",g[g.Process=1]="Process",g[g.Sequence=2]="Sequence",g[g.Config=3]="Config"})(t=e.TitleEventSource||(e.TitleEventSource={}));var T;(function(g){g.LocalPty="localPty",g.PtyHost="ptyHost",g.Log="log",g.Heartbeat="heartbeat"})(T=e.TerminalIpcChannels||(e.TerminalIpcChannels={})),e.IPtyService=(0,S.createDecorator)("ptyService");var h;(function(g){g.Cwd="cwd",g.InitialCwd="initialCwd",g.FixedDimensions="fixedDimensions",g.Title="title",g.ShellType="shellType",g.HasChildProcesses="hasChildProcesses",g.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",g.OverrideDimensions="overrideDimensions"})(h=e.ProcessPropertyType||(e.ProcessPropertyType={}));var f;(function(g){g[g.BeatInterval=5e3]="BeatInterval",g[g.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",g[g.SecondWaitMultiplier=1]="SecondWaitMultiplier",g[g.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(f=e.HeartbeatConstants||(e.HeartbeatConstants={}));var C;(function(g){g[g.Panel=1]="Panel",g[g.Editor=2]="Editor"})(C=e.TerminalLocation||(e.TerminalLocation={}));var I;(function(g){g.TerminalView="view",g.Editor="editor"})(I=e.TerminalLocationString||(e.TerminalLocationString={}));var m;(function(g){g.CwdDetection="cwdDetection"})(m=e.ProcessCapability||(e.ProcessCapability={}));var u;(function(g){g[g.GraceTime=6e4]="GraceTime",g[g.ShortGraceTime=6e3]="ShortGraceTime"})(u=e.LocalReconnectConstants||(e.LocalReconnectConstants={}));var c;(function(g){g[g.HighWatermarkChars=1e5]="HighWatermarkChars",g[g.LowWatermarkChars=5e3]="LowWatermarkChars",g[g.CharCountAckSize=5e3]="CharCountAckSize"})(c=e.FlowControlConstants||(e.FlowControlConstants={}));var b;(function(g){g.GitBash="Git Bash",g.Pwsh="PowerShell"})(b=e.ProfileSource||(e.ProfileSource={}))}),define(ue[229],de([0,1,26,21,4,2,23,11,17]),function(Y,e,S,k,p,P,t,T,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findExecutable=e.getWindowsBuildNumber=void 0;function f(){const I=/(\d+)\.(\d+)\.(\d+)/g.exec(S.release());let m=0;return I&&I.length===4&&(m=parseInt(I[3])),m}e.getWindowsBuildNumber=f;async function C(I,m,u,c=t.env,b=h.Promises.exists){if(p.isAbsolute(I))return await b(I)?I:void 0;if(m===void 0&&(m=t.cwd()),p.dirname(I)!=="."){const v=p.join(m,I);return await b(v)?v:void 0}const D=(0,k.getCaseInsensitive)(c,"PATH");if(u===void 0&&(0,T.isString)(D)&&(u=D.split(p.delimiter)),u===void 0||u.length===0){const v=p.join(m,I);return await b(v)?v:void 0}for(let v of u){let a;if(p.isAbsolute(v)?a=p.join(v,I):a=p.join(m,v,I),await b(a))return a;if(P.isWindows){let l=a+".com";if(await b(l)||(l=a+".exe",await b(l)))return l}}const w=p.join(m,I);return await b(w)?w:void 0}e.findExecutable=C}),define(ue[44],de([0,1,13,46,6,11,176,49,22]),function(Y,e,S,k,p,P,t,T,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.workbenchColorsSchemaId=e.resolveColorValue=e.ifDefinedThenElse=e.oneOf=e.transparent=e.lighten=e.darken=e.executeTransform=e.chartsPurple=e.chartsGreen=e.chartsOrange=e.chartsYellow=e.chartsBlue=e.chartsRed=e.chartsLines=e.chartsForeground=e.problemsInfoIconForeground=e.problemsWarningIconForeground=e.problemsErrorIconForeground=e.minimapSliderActiveBackground=e.minimapSliderHoverBackground=e.minimapSliderBackground=e.minimapUnicodeHighlight=e.minimapForegroundOpacity=e.minimapBackground=e.minimapWarning=e.minimapError=e.minimapSelection=e.minimapSelectionOccurrenceHighlight=e.minimapFindMatch=e.overviewRulerUnicodeHighlightForeground=e.overviewRulerSelectionHighlightForeground=e.overviewRulerFindMatchForeground=e.overviewRulerCommonContentForeground=e.overviewRulerIncomingContentForeground=e.overviewRulerCurrentContentForeground=e.mergeBorder=e.mergeCommonContentBackground=e.mergeCommonHeaderBackground=e.mergeIncomingContentBackground=e.mergeIncomingHeaderBackground=e.mergeCurrentContentBackground=e.mergeCurrentHeaderBackground=e.breadcrumbsPickerBackground=e.breadcrumbsActiveSelectionForeground=e.breadcrumbsFocusForeground=e.breadcrumbsBackground=e.breadcrumbsForeground=e.snippetFinalTabstopHighlightBorder=e.snippetFinalTabstopHighlightBackground=e.snippetTabstopHighlightBorder=e.snippetTabstopHighlightBackground=e.toolbarActiveBackground=e.toolbarHoverOutline=e.toolbarHoverBackground=e.menuSeparatorBackground=e.menuSelectionBorder=e.menuSelectionBackground=e.menuSelectionForeground=e.menuBackground=e.menuForeground=e.menuBorder=e.quickInputListFocusBackground=e.quickInputListFocusIconForeground=e.quickInputListFocusForeground=e._deprecatedQuickInputListFocusBackground=e.listDeemphasizedForeground=e.tableOddRowsBackgroundColor=e.tableColumnsBorder=e.treeIndentGuidesStroke=e.listFilterMatchHighlightBorder=e.listFilterMatchHighlight=e.listFilterWidgetNoMatchesOutline=e.listFilterWidgetOutline=e.listFilterWidgetBackground=e.listWarningForeground=e.listErrorForeground=e.listInvalidItemForeground=e.listFocusHighlightForeground=e.listHighlightForeground=e.listDropBackground=e.listHoverForeground=e.listHoverBackground=e.listInactiveFocusOutline=e.listInactiveFocusBackground=e.listInactiveSelectionIconForeground=e.listInactiveSelectionForeground=e.listInactiveSelectionBackground=e.listActiveSelectionIconForeground=e.listActiveSelectionForeground=e.listActiveSelectionBackground=e.listFocusOutline=e.listFocusForeground=e.listFocusBackground=e.diffDiagonalFill=e.diffBorder=e.diffRemovedOutline=e.diffInsertedOutline=e.diffRemoved=e.diffInserted=e.defaultRemoveColor=e.defaultInsertColor=e.editorLightBulbAutoFixForeground=e.editorLightBulbForeground=e.editorInlayHintParameterBackground=e.editorInlayHintParameterForeground=e.editorInlayHintTypeBackground=e.editorInlayHintTypeForeground=e.editorInlayHintBackground=e.editorInlayHintForeground=e.editorActiveLinkForeground=e.editorHoverStatusBarBackground=e.editorHoverBorder=e.editorHoverForeground=e.editorHoverBackground=e.editorHoverHighlight=e.searchEditorFindMatchBorder=e.searchEditorFindMatch=e.editorFindRangeHighlightBorder=e.editorFindMatchHighlightBorder=e.editorFindMatchBorder=e.editorFindRangeHighlight=e.editorFindMatchHighlight=e.editorFindMatch=e.editorSelectionHighlightBorder=e.editorSelectionHighlight=e.editorInactiveSelection=e.editorSelectionForeground=e.editorSelectionBackground=e.keybindingLabelBottomBorder=e.keybindingLabelBorder=e.keybindingLabelForeground=e.keybindingLabelBackground=e.pickerGroupBorder=e.pickerGroupForeground=e.quickInputTitleBackground=e.quickInputForeground=e.quickInputBackground=e.editorWidgetResizeBorder=e.editorWidgetBorder=e.editorWidgetForeground=e.editorWidgetBackground=e.editorForeground=e.editorBackground=e.sashHoverBorder=e.editorHintBorder=e.editorHintForeground=e.editorInfoBorder=e.editorInfoForeground=e.editorInfoBackground=e.editorWarningBorder=e.editorWarningForeground=e.editorWarningBackground=e.editorErrorBorder=e.editorErrorForeground=e.editorErrorBackground=e.progressBarBackground=e.scrollbarSliderActiveBackground=e.scrollbarSliderHoverBackground=e.scrollbarSliderBackground=e.scrollbarShadow=e.badgeForeground=e.badgeBackground=e.buttonSecondaryHoverBackground=e.buttonSecondaryBackground=e.buttonSecondaryForeground=e.buttonBorder=e.buttonHoverBackground=e.buttonBackground=e.buttonForeground=e.simpleCheckboxBorder=e.simpleCheckboxForeground=e.simpleCheckboxBackground=e.selectBorder=e.selectForeground=e.selectListBackground=e.selectBackground=e.inputValidationErrorBorder=e.inputValidationErrorForeground=e.inputValidationErrorBackground=e.inputValidationWarningBorder=e.inputValidationWarningForeground=e.inputValidationWarningBackground=e.inputValidationInfoBorder=e.inputValidationInfoForeground=e.inputValidationInfoBackground=e.inputPlaceholderForeground=e.inputActiveOptionForeground=e.inputActiveOptionBackground=e.inputActiveOptionHoverBackground=e.inputActiveOptionBorder=e.inputBorder=e.inputForeground=e.inputBackground=e.widgetShadow=e.textCodeBlockBackground=e.textBlockQuoteBorder=e.textBlockQuoteBackground=e.textPreformatForeground=e.textLinkActiveForeground=e.textLinkForeground=e.textSeparatorForeground=e.selectionBackground=e.activeContrastBorder=e.contrastBorder=e.focusBorder=e.iconForeground=e.descriptionForeground=e.errorForeground=e.foreground=e.getColorRegistry=e.registerColor=e.Extensions=e.ColorTransformType=e.asCssVariableName=void 0;function f(R){return`--vscode-${R.replace(".","-")}`}e.asCssVariableName=f;var C;(function(R){R[R.Darken=0]="Darken",R[R.Lighten=1]="Lighten",R[R.Transparent=2]="Transparent",R[R.OneOf=3]="OneOf",R[R.LessProminent=4]="LessProminent",R[R.IfDefinedThenElse=5]="IfDefinedThenElse"})(C=e.ColorTransformType||(e.ColorTransformType={})),e.Extensions={ColorContribution:"base.contributions.colors"};class I{constructor(){this._onDidChangeSchema=new p.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.colorSchema={type:"object",properties:{}},this.colorReferenceSchema={type:"string",enum:[],enumDescriptions:[]},this.colorsById={}}registerColor(O,K,te,j=!1,_){let U={id:O,description:te,defaults:K,needsTransparency:j,deprecationMessage:_};this.colorsById[O]=U;let F={type:"string",description:te,format:"color-hex",defaultSnippets:[{body:"${1:#ff0000}"}]};return _&&(F.deprecationMessage=_),this.colorSchema.properties[O]=F,this.colorReferenceSchema.enum.push(O),this.colorReferenceSchema.enumDescriptions.push(te),this._onDidChangeSchema.fire(),O}deregisterColor(O){delete this.colorsById[O],delete this.colorSchema.properties[O];const K=this.colorReferenceSchema.enum.indexOf(O);K!==-1&&(this.colorReferenceSchema.enum.splice(K,1),this.colorReferenceSchema.enumDescriptions.splice(K,1)),this._onDidChangeSchema.fire()}getColors(){return Object.keys(this.colorsById).map(O=>this.colorsById[O])}resolveDefaultColor(O,K){const te=this.colorsById[O];if(te&&te.defaults){const j=te.defaults[K.type];return y(j,K)}}getColorSchema(){return this.colorSchema}getColorReferenceSchema(){return this.colorReferenceSchema}toString(){let O=(K,te)=>{let j=K.indexOf(".")===-1?0:1,_=te.indexOf(".")===-1?0:1;return j!==_?j-_:K.localeCompare(te)};return Object.keys(this.colorsById).sort(O).map(K=>`- \`${K}\`: ${this.colorsById[K].description}`).join(`
`)}}const m=new I;h.Registry.add(e.Extensions.ColorContribution,m);function u(R,O,K,te,j){return m.registerColor(R,O,K,te,j)}e.registerColor=u;function c(){return m}e.getColorRegistry=c,e.foreground=u("foreground",{dark:"#CCCCCC",light:"#616161",hc:"#FFFFFF"},t.localize(0,null)),e.errorForeground=u("errorForeground",{dark:"#F48771",light:"#A1260D",hc:"#F48771"},t.localize(1,null)),e.descriptionForeground=u("descriptionForeground",{light:"#717171",dark:i(e.foreground,.7),hc:i(e.foreground,.7)},t.localize(2,null)),e.iconForeground=u("icon.foreground",{dark:"#C5C5C5",light:"#424242",hc:"#FFFFFF"},t.localize(3,null)),e.focusBorder=u("focusBorder",{dark:"#007FD4",light:"#0090F1",hc:"#F38518"},t.localize(4,null)),e.contrastBorder=u("contrastBorder",{light:null,dark:null,hc:"#6FC3DF"},t.localize(5,null)),e.activeContrastBorder=u("contrastActiveBorder",{light:null,dark:null,hc:e.focusBorder},t.localize(6,null)),e.selectionBackground=u("selection.background",{light:null,dark:null,hc:null},t.localize(7,null)),e.textSeparatorForeground=u("textSeparator.foreground",{light:"#0000002e",dark:"#ffffff2e",hc:k.Color.black},t.localize(8,null)),e.textLinkForeground=u("textLink.foreground",{light:"#006AB1",dark:"#3794FF",hc:"#3794FF"},t.localize(9,null)),e.textLinkActiveForeground=u("textLink.activeForeground",{light:"#006AB1",dark:"#3794FF",hc:"#3794FF"},t.localize(10,null)),e.textPreformatForeground=u("textPreformat.foreground",{light:"#A31515",dark:"#D7BA7D",hc:"#D7BA7D"},t.localize(11,null)),e.textBlockQuoteBackground=u("textBlockQuote.background",{light:"#7f7f7f1a",dark:"#7f7f7f1a",hc:null},t.localize(12,null)),e.textBlockQuoteBorder=u("textBlockQuote.border",{light:"#007acc80",dark:"#007acc80",hc:k.Color.white},t.localize(13,null)),e.textCodeBlockBackground=u("textCodeBlock.background",{light:"#dcdcdc66",dark:"#0a0a0a66",hc:k.Color.black},t.localize(14,null)),e.widgetShadow=u("widget.shadow",{dark:i(k.Color.black,.36),light:i(k.Color.black,.16),hc:null},t.localize(15,null)),e.inputBackground=u("input.background",{dark:"#3C3C3C",light:k.Color.white,hc:k.Color.black},t.localize(16,null)),e.inputForeground=u("input.foreground",{dark:e.foreground,light:e.foreground,hc:e.foreground},t.localize(17,null)),e.inputBorder=u("input.border",{dark:null,light:null,hc:e.contrastBorder},t.localize(18,null)),e.inputActiveOptionBorder=u("inputOption.activeBorder",{dark:"#007ACC00",light:"#007ACC00",hc:e.contrastBorder},t.localize(19,null)),e.inputActiveOptionHoverBackground=u("inputOption.hoverBackground",{dark:"#5a5d5e80",light:"#b8b8b850",hc:null},t.localize(20,null)),e.inputActiveOptionBackground=u("inputOption.activeBackground",{dark:i(e.focusBorder,.4),light:i(e.focusBorder,.2),hc:k.Color.transparent},t.localize(21,null)),e.inputActiveOptionForeground=u("inputOption.activeForeground",{dark:k.Color.white,light:k.Color.black,hc:null},t.localize(22,null)),e.inputPlaceholderForeground=u("input.placeholderForeground",{light:i(e.foreground,.5),dark:i(e.foreground,.5),hc:i(e.foreground,.7)},t.localize(23,null)),e.inputValidationInfoBackground=u("inputValidation.infoBackground",{dark:"#063B49",light:"#D6ECF2",hc:k.Color.black},t.localize(24,null)),e.inputValidationInfoForeground=u("inputValidation.infoForeground",{dark:null,light:null,hc:null},t.localize(25,null)),e.inputValidationInfoBorder=u("inputValidation.infoBorder",{dark:"#007acc",light:"#007acc",hc:e.contrastBorder},t.localize(26,null)),e.inputValidationWarningBackground=u("inputValidation.warningBackground",{dark:"#352A05",light:"#F6F5D2",hc:k.Color.black},t.localize(27,null)),e.inputValidationWarningForeground=u("inputValidation.warningForeground",{dark:null,light:null,hc:null},t.localize(28,null)),e.inputValidationWarningBorder=u("inputValidation.warningBorder",{dark:"#B89500",light:"#B89500",hc:e.contrastBorder},t.localize(29,null)),e.inputValidationErrorBackground=u("inputValidation.errorBackground",{dark:"#5A1D1D",light:"#F2DEDE",hc:k.Color.black},t.localize(30,null)),e.inputValidationErrorForeground=u("inputValidation.errorForeground",{dark:null,light:null,hc:null},t.localize(31,null)),e.inputValidationErrorBorder=u("inputValidation.errorBorder",{dark:"#BE1100",light:"#BE1100",hc:e.contrastBorder},t.localize(32,null)),e.selectBackground=u("dropdown.background",{dark:"#3C3C3C",light:k.Color.white,hc:k.Color.black},t.localize(33,null)),e.selectListBackground=u("dropdown.listBackground",{dark:null,light:null,hc:k.Color.black},t.localize(34,null)),e.selectForeground=u("dropdown.foreground",{dark:"#F0F0F0",light:null,hc:k.Color.white},t.localize(35,null)),e.selectBorder=u("dropdown.border",{dark:e.selectBackground,light:"#CECECE",hc:e.contrastBorder},t.localize(36,null)),e.simpleCheckboxBackground=u("checkbox.background",{dark:e.selectBackground,light:e.selectBackground,hc:e.selectBackground},t.localize(37,null)),e.simpleCheckboxForeground=u("checkbox.foreground",{dark:e.selectForeground,light:e.selectForeground,hc:e.selectForeground},t.localize(38,null)),e.simpleCheckboxBorder=u("checkbox.border",{dark:e.selectBorder,light:e.selectBorder,hc:e.selectBorder},t.localize(39,null)),e.buttonForeground=u("button.foreground",{dark:k.Color.white,light:k.Color.white,hc:k.Color.white},t.localize(40,null)),e.buttonBackground=u("button.background",{dark:"#0E639C",light:"#007ACC",hc:null},t.localize(41,null)),e.buttonHoverBackground=u("button.hoverBackground",{dark:o(e.buttonBackground,.2),light:r(e.buttonBackground,.2),hc:null},t.localize(42,null)),e.buttonBorder=u("button.border",{dark:e.contrastBorder,light:e.contrastBorder,hc:e.contrastBorder},t.localize(43,null)),e.buttonSecondaryForeground=u("button.secondaryForeground",{dark:k.Color.white,light:k.Color.white,hc:k.Color.white},t.localize(44,null)),e.buttonSecondaryBackground=u("button.secondaryBackground",{dark:"#3A3D41",light:"#5F6A79",hc:null},t.localize(45,null)),e.buttonSecondaryHoverBackground=u("button.secondaryHoverBackground",{dark:o(e.buttonSecondaryBackground,.2),light:r(e.buttonSecondaryBackground,.2),hc:null},t.localize(46,null)),e.badgeBackground=u("badge.background",{dark:"#4D4D4D",light:"#C4C4C4",hc:k.Color.black},t.localize(47,null)),e.badgeForeground=u("badge.foreground",{dark:k.Color.white,light:"#333",hc:k.Color.white},t.localize(48,null)),e.scrollbarShadow=u("scrollbar.shadow",{dark:"#000000",light:"#DDDDDD",hc:null},t.localize(49,null)),e.scrollbarSliderBackground=u("scrollbarSlider.background",{dark:k.Color.fromHex("#797979").transparent(.4),light:k.Color.fromHex("#646464").transparent(.4),hc:i(e.contrastBorder,.6)},t.localize(50,null)),e.scrollbarSliderHoverBackground=u("scrollbarSlider.hoverBackground",{dark:k.Color.fromHex("#646464").transparent(.7),light:k.Color.fromHex("#646464").transparent(.7),hc:i(e.contrastBorder,.8)},t.localize(51,null)),e.scrollbarSliderActiveBackground=u("scrollbarSlider.activeBackground",{dark:k.Color.fromHex("#BFBFBF").transparent(.4),light:k.Color.fromHex("#000000").transparent(.6),hc:e.contrastBorder},t.localize(52,null)),e.progressBarBackground=u("progressBar.background",{dark:k.Color.fromHex("#0E70C0"),light:k.Color.fromHex("#0E70C0"),hc:e.contrastBorder},t.localize(53,null)),e.editorErrorBackground=u("editorError.background",{dark:null,light:null,hc:null},t.localize(54,null),!0),e.editorErrorForeground=u("editorError.foreground",{dark:"#F14C4C",light:"#E51400",hc:null},t.localize(55,null)),e.editorErrorBorder=u("editorError.border",{dark:null,light:null,hc:k.Color.fromHex("#E47777").transparent(.8)},t.localize(56,null)),e.editorWarningBackground=u("editorWarning.background",{dark:null,light:null,hc:null},t.localize(57,null),!0),e.editorWarningForeground=u("editorWarning.foreground",{dark:"#CCA700",light:"#BF8803",hc:null},t.localize(58,null)),e.editorWarningBorder=u("editorWarning.border",{dark:null,light:null,hc:k.Color.fromHex("#FFCC00").transparent(.8)},t.localize(59,null)),e.editorInfoBackground=u("editorInfo.background",{dark:null,light:null,hc:null},t.localize(60,null),!0),e.editorInfoForeground=u("editorInfo.foreground",{dark:"#3794FF",light:"#1a85ff",hc:"#3794FF"},t.localize(61,null)),e.editorInfoBorder=u("editorInfo.border",{dark:null,light:null,hc:k.Color.fromHex("#3794FF").transparent(.8)},t.localize(62,null)),e.editorHintForeground=u("editorHint.foreground",{dark:k.Color.fromHex("#eeeeee").transparent(.7),light:"#6c6c6c",hc:null},t.localize(63,null)),e.editorHintBorder=u("editorHint.border",{dark:null,light:null,hc:k.Color.fromHex("#eeeeee").transparent(.8)},t.localize(64,null)),e.sashHoverBorder=u("sash.hoverBorder",{dark:e.focusBorder,light:e.focusBorder,hc:e.focusBorder},t.localize(65,null)),e.editorBackground=u("editor.background",{light:"#fffffe",dark:"#1E1E1E",hc:k.Color.black},t.localize(66,null)),e.editorForeground=u("editor.foreground",{light:"#333333",dark:"#BBBBBB",hc:k.Color.white},t.localize(67,null)),e.editorWidgetBackground=u("editorWidget.background",{dark:"#252526",light:"#F3F3F3",hc:"#0C141F"},t.localize(68,null)),e.editorWidgetForeground=u("editorWidget.foreground",{dark:e.foreground,light:e.foreground,hc:e.foreground},t.localize(69,null)),e.editorWidgetBorder=u("editorWidget.border",{dark:"#454545",light:"#C8C8C8",hc:e.contrastBorder},t.localize(70,null)),e.editorWidgetResizeBorder=u("editorWidget.resizeBorder",{light:null,dark:null,hc:null},t.localize(71,null)),e.quickInputBackground=u("quickInput.background",{dark:e.editorWidgetBackground,light:e.editorWidgetBackground,hc:e.editorWidgetBackground},t.localize(72,null)),e.quickInputForeground=u("quickInput.foreground",{dark:e.editorWidgetForeground,light:e.editorWidgetForeground,hc:e.editorWidgetForeground},t.localize(73,null)),e.quickInputTitleBackground=u("quickInputTitle.background",{dark:new k.Color(new k.RGBA(255,255,255,.105)),light:new k.Color(new k.RGBA(0,0,0,.06)),hc:"#000000"},t.localize(74,null)),e.pickerGroupForeground=u("pickerGroup.foreground",{dark:"#3794FF",light:"#0066BF",hc:k.Color.white},t.localize(75,null)),e.pickerGroupBorder=u("pickerGroup.border",{dark:"#3F3F46",light:"#CCCEDB",hc:k.Color.white},t.localize(76,null)),e.keybindingLabelBackground=u("keybindingLabel.background",{dark:new k.Color(new k.RGBA(128,128,128,.17)),light:new k.Color(new k.RGBA(221,221,221,.4)),hc:k.Color.transparent},t.localize(77,null)),e.keybindingLabelForeground=u("keybindingLabel.foreground",{dark:k.Color.fromHex("#CCCCCC"),light:k.Color.fromHex("#555555"),hc:k.Color.white},t.localize(78,null)),e.keybindingLabelBorder=u("keybindingLabel.border",{dark:new k.Color(new k.RGBA(51,51,51,.6)),light:new k.Color(new k.RGBA(204,204,204,.4)),hc:new k.Color(new k.RGBA(111,195,223))},t.localize(79,null)),e.keybindingLabelBottomBorder=u("keybindingLabel.bottomBorder",{dark:new k.Color(new k.RGBA(68,68,68,.6)),light:new k.Color(new k.RGBA(187,187,187,.4)),hc:new k.Color(new k.RGBA(111,195,223))},t.localize(80,null)),e.editorSelectionBackground=u("editor.selectionBackground",{light:"#ADD6FF",dark:"#264F78",hc:"#f3f518"},t.localize(81,null)),e.editorSelectionForeground=u("editor.selectionForeground",{light:null,dark:null,hc:"#000000"},t.localize(82,null)),e.editorInactiveSelection=u("editor.inactiveSelectionBackground",{light:i(e.editorSelectionBackground,.5),dark:i(e.editorSelectionBackground,.5),hc:i(e.editorSelectionBackground,.5)},t.localize(83,null),!0),e.editorSelectionHighlight=u("editor.selectionHighlightBackground",{light:d(e.editorSelectionBackground,e.editorBackground,.3,.6),dark:d(e.editorSelectionBackground,e.editorBackground,.3,.6),hc:null},t.localize(84,null),!0),e.editorSelectionHighlightBorder=u("editor.selectionHighlightBorder",{light:null,dark:null,hc:e.activeContrastBorder},t.localize(85,null)),e.editorFindMatch=u("editor.findMatchBackground",{light:"#A8AC94",dark:"#515C6A",hc:null},t.localize(86,null)),e.editorFindMatchHighlight=u("editor.findMatchHighlightBackground",{light:"#EA5C0055",dark:"#EA5C0055",hc:null},t.localize(87,null),!0),e.editorFindRangeHighlight=u("editor.findRangeHighlightBackground",{dark:"#3a3d4166",light:"#b4b4b44d",hc:null},t.localize(88,null),!0),e.editorFindMatchBorder=u("editor.findMatchBorder",{light:null,dark:null,hc:e.activeContrastBorder},t.localize(89,null)),e.editorFindMatchHighlightBorder=u("editor.findMatchHighlightBorder",{light:null,dark:null,hc:e.activeContrastBorder},t.localize(90,null)),e.editorFindRangeHighlightBorder=u("editor.findRangeHighlightBorder",{dark:null,light:null,hc:i(e.activeContrastBorder,.4)},t.localize(91,null),!0),e.searchEditorFindMatch=u("searchEditor.findMatchBackground",{light:i(e.editorFindMatchHighlight,.66),dark:i(e.editorFindMatchHighlight,.66),hc:e.editorFindMatchHighlight},t.localize(92,null)),e.searchEditorFindMatchBorder=u("searchEditor.findMatchBorder",{light:i(e.editorFindMatchHighlightBorder,.66),dark:i(e.editorFindMatchHighlightBorder,.66),hc:e.editorFindMatchHighlightBorder},t.localize(93,null)),e.editorHoverHighlight=u("editor.hoverHighlightBackground",{light:"#ADD6FF26",dark:"#264f7840",hc:"#ADD6FF26"},t.localize(94,null),!0),e.editorHoverBackground=u("editorHoverWidget.background",{light:e.editorWidgetBackground,dark:e.editorWidgetBackground,hc:e.editorWidgetBackground},t.localize(95,null)),e.editorHoverForeground=u("editorHoverWidget.foreground",{light:e.editorWidgetForeground,dark:e.editorWidgetForeground,hc:e.editorWidgetForeground},t.localize(96,null)),e.editorHoverBorder=u("editorHoverWidget.border",{light:e.editorWidgetBorder,dark:e.editorWidgetBorder,hc:e.editorWidgetBorder},t.localize(97,null)),e.editorHoverStatusBarBackground=u("editorHoverWidget.statusBarBackground",{dark:o(e.editorHoverBackground,.2),light:r(e.editorHoverBackground,.05),hc:e.editorWidgetBackground},t.localize(98,null)),e.editorActiveLinkForeground=u("editorLink.activeForeground",{dark:"#4E94CE",light:k.Color.blue,hc:k.Color.cyan},t.localize(99,null)),e.editorInlayHintForeground=u("editorInlayHint.foreground",{dark:i(e.badgeForeground,.8),light:i(e.badgeForeground,.8),hc:e.badgeForeground},t.localize(100,null)),e.editorInlayHintBackground=u("editorInlayHint.background",{dark:i(e.badgeBackground,.6),light:i(e.badgeBackground,.3),hc:e.badgeBackground},t.localize(101,null)),e.editorInlayHintTypeForeground=u("editorInlayHint.typeForeground",{dark:e.editorInlayHintForeground,light:e.editorInlayHintForeground,hc:e.editorInlayHintForeground},t.localize(102,null)),e.editorInlayHintTypeBackground=u("editorInlayHint.typeBackground",{dark:e.editorInlayHintBackground,light:e.editorInlayHintBackground,hc:e.editorInlayHintBackground},t.localize(103,null)),e.editorInlayHintParameterForeground=u("editorInlayHint.parameterForeground",{dark:e.editorInlayHintForeground,light:e.editorInlayHintForeground,hc:e.editorInlayHintForeground},t.localize(104,null)),e.editorInlayHintParameterBackground=u("editorInlayHint.parameterBackground",{dark:e.editorInlayHintBackground,light:e.editorInlayHintBackground,hc:e.editorInlayHintBackground},t.localize(105,null)),e.editorLightBulbForeground=u("editorLightBulb.foreground",{dark:"#FFCC00",light:"#DDB100",hc:"#FFCC00"},t.localize(106,null)),e.editorLightBulbAutoFixForeground=u("editorLightBulbAutoFix.foreground",{dark:"#75BEFF",light:"#007ACC",hc:"#75BEFF"},t.localize(107,null)),e.defaultInsertColor=new k.Color(new k.RGBA(155,185,85,.2)),e.defaultRemoveColor=new k.Color(new k.RGBA(255,0,0,.2)),e.diffInserted=u("diffEditor.insertedTextBackground",{dark:e.defaultInsertColor,light:e.defaultInsertColor,hc:null},t.localize(108,null),!0),e.diffRemoved=u("diffEditor.removedTextBackground",{dark:e.defaultRemoveColor,light:e.defaultRemoveColor,hc:null},t.localize(109,null),!0),e.diffInsertedOutline=u("diffEditor.insertedTextBorder",{dark:null,light:null,hc:"#33ff2eff"},t.localize(110,null)),e.diffRemovedOutline=u("diffEditor.removedTextBorder",{dark:null,light:null,hc:"#FF008F"},t.localize(111,null)),e.diffBorder=u("diffEditor.border",{dark:null,light:null,hc:e.contrastBorder},t.localize(112,null)),e.diffDiagonalFill=u("diffEditor.diagonalFill",{dark:"#cccccc33",light:"#22222233",hc:null},t.localize(113,null)),e.listFocusBackground=u("list.focusBackground",{dark:null,light:null,hc:null},t.localize(114,null)),e.listFocusForeground=u("list.focusForeground",{dark:null,light:null,hc:null},t.localize(115,null)),e.listFocusOutline=u("list.focusOutline",{dark:e.focusBorder,light:e.focusBorder,hc:e.activeContrastBorder},t.localize(116,null)),e.listActiveSelectionBackground=u("list.activeSelectionBackground",{dark:"#094771",light:"#0060C0",hc:null},t.localize(117,null)),e.listActiveSelectionForeground=u("list.activeSelectionForeground",{dark:k.Color.white,light:k.Color.white,hc:null},t.localize(118,null)),e.listActiveSelectionIconForeground=u("list.activeSelectionIconForeground",{dark:null,light:null,hc:null},t.localize(119,null)),e.listInactiveSelectionBackground=u("list.inactiveSelectionBackground",{dark:"#37373D",light:"#E4E6F1",hc:null},t.localize(120,null)),e.listInactiveSelectionForeground=u("list.inactiveSelectionForeground",{dark:null,light:null,hc:null},t.localize(121,null)),e.listInactiveSelectionIconForeground=u("list.inactiveSelectionIconForeground",{dark:null,light:null,hc:null},t.localize(122,null)),e.listInactiveFocusBackground=u("list.inactiveFocusBackground",{dark:null,light:null,hc:null},t.localize(123,null)),e.listInactiveFocusOutline=u("list.inactiveFocusOutline",{dark:null,light:null,hc:null},t.localize(124,null)),e.listHoverBackground=u("list.hoverBackground",{dark:"#2A2D2E",light:"#F0F0F0",hc:null},t.localize(125,null)),e.listHoverForeground=u("list.hoverForeground",{dark:null,light:null,hc:null},t.localize(126,null)),e.listDropBackground=u("list.dropBackground",{dark:"#062F4A",light:"#D6EBFF",hc:null},t.localize(127,null)),e.listHighlightForeground=u("list.highlightForeground",{dark:"#18A3FF",light:"#0066BF",hc:e.focusBorder},t.localize(128,null)),e.listFocusHighlightForeground=u("list.focusHighlightForeground",{dark:e.listHighlightForeground,light:s(e.listActiveSelectionBackground,e.listHighlightForeground,"#9DDDFF"),hc:e.listHighlightForeground},t.localize(129,null)),e.listInvalidItemForeground=u("list.invalidItemForeground",{dark:"#B89500",light:"#B89500",hc:"#B89500"},t.localize(130,null)),e.listErrorForeground=u("list.errorForeground",{dark:"#F88070",light:"#B01011",hc:null},t.localize(131,null)),e.listWarningForeground=u("list.warningForeground",{dark:"#CCA700",light:"#855F00",hc:null},t.localize(132,null)),e.listFilterWidgetBackground=u("listFilterWidget.background",{light:"#efc1ad",dark:"#653723",hc:k.Color.black},t.localize(133,null)),e.listFilterWidgetOutline=u("listFilterWidget.outline",{dark:k.Color.transparent,light:k.Color.transparent,hc:"#f38518"},t.localize(134,null)),e.listFilterWidgetNoMatchesOutline=u("listFilterWidget.noMatchesOutline",{dark:"#BE1100",light:"#BE1100",hc:e.contrastBorder},t.localize(135,null)),e.listFilterMatchHighlight=u("list.filterMatchBackground",{dark:e.editorFindMatchHighlight,light:e.editorFindMatchHighlight,hc:null},t.localize(136,null)),e.listFilterMatchHighlightBorder=u("list.filterMatchBorder",{dark:e.editorFindMatchHighlightBorder,light:e.editorFindMatchHighlightBorder,hc:e.contrastBorder},t.localize(137,null)),e.treeIndentGuidesStroke=u("tree.indentGuidesStroke",{dark:"#585858",light:"#a9a9a9",hc:"#a9a9a9"},t.localize(138,null)),e.tableColumnsBorder=u("tree.tableColumnsBorder",{dark:"#CCCCCC20",light:"#61616120",hc:null},t.localize(139,null)),e.tableOddRowsBackgroundColor=u("tree.tableOddRowsBackground",{dark:i(e.foreground,.04),light:i(e.foreground,.04),hc:null},t.localize(140,null)),e.listDeemphasizedForeground=u("list.deemphasizedForeground",{dark:"#8C8C8C",light:"#8E8E90",hc:"#A7A8A9"},t.localize(141,null)),e._deprecatedQuickInputListFocusBackground=u("quickInput.list.focusBackground",{dark:null,light:null,hc:null},"",void 0,t.localize(142,null)),e.quickInputListFocusForeground=u("quickInputList.focusForeground",{dark:e.listActiveSelectionForeground,light:e.listActiveSelectionForeground,hc:e.listActiveSelectionForeground},t.localize(143,null)),e.quickInputListFocusIconForeground=u("quickInputList.focusIconForeground",{dark:e.listActiveSelectionIconForeground,light:e.listActiveSelectionIconForeground,hc:e.listActiveSelectionIconForeground},t.localize(144,null)),e.quickInputListFocusBackground=u("quickInputList.focusBackground",{dark:n(e._deprecatedQuickInputListFocusBackground,e.listActiveSelectionBackground),light:n(e._deprecatedQuickInputListFocusBackground,e.listActiveSelectionBackground),hc:null},t.localize(145,null)),e.menuBorder=u("menu.border",{dark:null,light:null,hc:e.contrastBorder},t.localize(146,null)),e.menuForeground=u("menu.foreground",{dark:e.selectForeground,light:e.foreground,hc:e.selectForeground},t.localize(147,null)),e.menuBackground=u("menu.background",{dark:e.selectBackground,light:e.selectBackground,hc:e.selectBackground},t.localize(148,null)),e.menuSelectionForeground=u("menu.selectionForeground",{dark:e.listActiveSelectionForeground,light:e.listActiveSelectionForeground,hc:e.listActiveSelectionForeground},t.localize(149,null)),e.menuSelectionBackground=u("menu.selectionBackground",{dark:e.listActiveSelectionBackground,light:e.listActiveSelectionBackground,hc:e.listActiveSelectionBackground},t.localize(150,null)),e.menuSelectionBorder=u("menu.selectionBorder",{dark:null,light:null,hc:e.activeContrastBorder},t.localize(151,null)),e.menuSeparatorBackground=u("menu.separatorBackground",{dark:"#BBBBBB",light:"#888888",hc:e.contrastBorder},t.localize(152,null)),e.toolbarHoverBackground=u("toolbar.hoverBackground",{dark:"#5a5d5e50",light:"#b8b8b850",hc:null},t.localize(153,null)),e.toolbarHoverOutline=u("toolbar.hoverOutline",{dark:null,light:null,hc:e.activeContrastBorder},t.localize(154,null)),e.toolbarActiveBackground=u("toolbar.activeBackground",{dark:o(e.toolbarHoverBackground,.1),light:r(e.toolbarHoverBackground,.1),hc:null},t.localize(155,null)),e.snippetTabstopHighlightBackground=u("editor.snippetTabstopHighlightBackground",{dark:new k.Color(new k.RGBA(124,124,124,.3)),light:new k.Color(new k.RGBA(10,50,100,.2)),hc:new k.Color(new k.RGBA(124,124,124,.3))},t.localize(156,null)),e.snippetTabstopHighlightBorder=u("editor.snippetTabstopHighlightBorder",{dark:null,light:null,hc:null},t.localize(157,null)),e.snippetFinalTabstopHighlightBackground=u("editor.snippetFinalTabstopHighlightBackground",{dark:null,light:null,hc:null},t.localize(158,null)),e.snippetFinalTabstopHighlightBorder=u("editor.snippetFinalTabstopHighlightBorder",{dark:"#525252",light:new k.Color(new k.RGBA(10,50,100,.5)),hc:"#525252"},t.localize(159,null)),e.breadcrumbsForeground=u("breadcrumb.foreground",{light:i(e.foreground,.8),dark:i(e.foreground,.8),hc:i(e.foreground,.8)},t.localize(160,null)),e.breadcrumbsBackground=u("breadcrumb.background",{light:e.editorBackground,dark:e.editorBackground,hc:e.editorBackground},t.localize(161,null)),e.breadcrumbsFocusForeground=u("breadcrumb.focusForeground",{light:r(e.foreground,.2),dark:o(e.foreground,.1),hc:o(e.foreground,.1)},t.localize(162,null)),e.breadcrumbsActiveSelectionForeground=u("breadcrumb.activeSelectionForeground",{light:r(e.foreground,.2),dark:o(e.foreground,.1),hc:o(e.foreground,.1)},t.localize(163,null)),e.breadcrumbsPickerBackground=u("breadcrumbPicker.background",{light:e.editorWidgetBackground,dark:e.editorWidgetBackground,hc:e.editorWidgetBackground},t.localize(164,null));const b=.5,g=k.Color.fromHex("#40C8AE").transparent(b),D=k.Color.fromHex("#40A6FF").transparent(b),w=k.Color.fromHex("#606060").transparent(.4),v=.4,a=1;e.mergeCurrentHeaderBackground=u("merge.currentHeaderBackground",{dark:g,light:g,hc:null},t.localize(165,null),!0),e.mergeCurrentContentBackground=u("merge.currentContentBackground",{dark:i(e.mergeCurrentHeaderBackground,v),light:i(e.mergeCurrentHeaderBackground,v),hc:i(e.mergeCurrentHeaderBackground,v)},t.localize(166,null),!0),e.mergeIncomingHeaderBackground=u("merge.incomingHeaderBackground",{dark:D,light:D,hc:null},t.localize(167,null),!0),e.mergeIncomingContentBackground=u("merge.incomingContentBackground",{dark:i(e.mergeIncomingHeaderBackground,v),light:i(e.mergeIncomingHeaderBackground,v),hc:i(e.mergeIncomingHeaderBackground,v)},t.localize(168,null),!0),e.mergeCommonHeaderBackground=u("merge.commonHeaderBackground",{dark:w,light:w,hc:null},t.localize(169,null),!0),e.mergeCommonContentBackground=u("merge.commonContentBackground",{dark:i(e.mergeCommonHeaderBackground,v),light:i(e.mergeCommonHeaderBackground,v),hc:i(e.mergeCommonHeaderBackground,v)},t.localize(170,null),!0),e.mergeBorder=u("merge.border",{dark:null,light:null,hc:"#C3DF6F"},t.localize(171,null)),e.overviewRulerCurrentContentForeground=u("editorOverviewRuler.currentContentForeground",{dark:i(e.mergeCurrentHeaderBackground,a),light:i(e.mergeCurrentHeaderBackground,a),hc:e.mergeBorder},t.localize(172,null)),e.overviewRulerIncomingContentForeground=u("editorOverviewRuler.incomingContentForeground",{dark:i(e.mergeIncomingHeaderBackground,a),light:i(e.mergeIncomingHeaderBackground,a),hc:e.mergeBorder},t.localize(173,null)),e.overviewRulerCommonContentForeground=u("editorOverviewRuler.commonContentForeground",{dark:i(e.mergeCommonHeaderBackground,a),light:i(e.mergeCommonHeaderBackground,a),hc:e.mergeBorder},t.localize(174,null)),e.overviewRulerFindMatchForeground=u("editorOverviewRuler.findMatchForeground",{dark:"#d186167e",light:"#d186167e",hc:"#AB5A00"},t.localize(175,null),!0),e.overviewRulerSelectionHighlightForeground=u("editorOverviewRuler.selectionHighlightForeground",{dark:"#A0A0A0CC",light:"#A0A0A0CC",hc:"#A0A0A0CC"},t.localize(176,null),!0),e.overviewRulerUnicodeHighlightForeground=u("editorOverviewRuler.unicodeForeground",{dark:"#d186167e",light:"#d186167e",hc:"#AB5A00"},t.localize(177,null),!0),e.minimapFindMatch=u("minimap.findMatchHighlight",{light:"#d18616",dark:"#d18616",hc:"#AB5A00"},t.localize(178,null),!0),e.minimapSelectionOccurrenceHighlight=u("minimap.selectionOccurrenceHighlight",{light:"#c9c9c9",dark:"#676767",hc:"#ffffff"},t.localize(179,null),!0),e.minimapSelection=u("minimap.selectionHighlight",{light:"#ADD6FF",dark:"#264F78",hc:"#ffffff"},t.localize(180,null),!0),e.minimapError=u("minimap.errorHighlight",{dark:new k.Color(new k.RGBA(255,18,18,.7)),light:new k.Color(new k.RGBA(255,18,18,.7)),hc:new k.Color(new k.RGBA(255,50,50,1))},t.localize(181,null)),e.minimapWarning=u("minimap.warningHighlight",{dark:e.editorWarningForeground,light:e.editorWarningForeground,hc:e.editorWarningBorder},t.localize(182,null)),e.minimapBackground=u("minimap.background",{dark:null,light:null,hc:null},t.localize(183,null)),e.minimapForegroundOpacity=u("minimap.foregroundOpacity",{dark:k.Color.fromHex("#000f"),light:k.Color.fromHex("#000f"),hc:k.Color.fromHex("#000f")},t.localize(184,null)),e.minimapUnicodeHighlight=u("minimap.unicodeHighlight",{light:"#d18616",dark:"#d18616",hc:"#AB5A00"},t.localize(185,null)),e.minimapSliderBackground=u("minimapSlider.background",{light:i(e.scrollbarSliderBackground,.5),dark:i(e.scrollbarSliderBackground,.5),hc:i(e.scrollbarSliderBackground,.5)},t.localize(186,null)),e.minimapSliderHoverBackground=u("minimapSlider.hoverBackground",{light:i(e.scrollbarSliderHoverBackground,.5),dark:i(e.scrollbarSliderHoverBackground,.5),hc:i(e.scrollbarSliderHoverBackground,.5)},t.localize(187,null)),e.minimapSliderActiveBackground=u("minimapSlider.activeBackground",{light:i(e.scrollbarSliderActiveBackground,.5),dark:i(e.scrollbarSliderActiveBackground,.5),hc:i(e.scrollbarSliderActiveBackground,.5)},t.localize(188,null)),e.problemsErrorIconForeground=u("problemsErrorIcon.foreground",{dark:e.editorErrorForeground,light:e.editorErrorForeground,hc:e.editorErrorForeground},t.localize(189,null)),e.problemsWarningIconForeground=u("problemsWarningIcon.foreground",{dark:e.editorWarningForeground,light:e.editorWarningForeground,hc:e.editorWarningForeground},t.localize(190,null)),e.problemsInfoIconForeground=u("problemsInfoIcon.foreground",{dark:e.editorInfoForeground,light:e.editorInfoForeground,hc:e.editorInfoForeground},t.localize(191,null)),e.chartsForeground=u("charts.foreground",{dark:e.foreground,light:e.foreground,hc:e.foreground},t.localize(192,null)),e.chartsLines=u("charts.lines",{dark:i(e.foreground,.5),light:i(e.foreground,.5),hc:i(e.foreground,.5)},t.localize(193,null)),e.chartsRed=u("charts.red",{dark:e.editorErrorForeground,light:e.editorErrorForeground,hc:e.editorErrorForeground},t.localize(194,null)),e.chartsBlue=u("charts.blue",{dark:e.editorInfoForeground,light:e.editorInfoForeground,hc:e.editorInfoForeground},t.localize(195,null)),e.chartsYellow=u("charts.yellow",{dark:e.editorWarningForeground,light:e.editorWarningForeground,hc:e.editorWarningForeground},t.localize(196,null)),e.chartsOrange=u("charts.orange",{dark:e.minimapFindMatch,light:e.minimapFindMatch,hc:e.minimapFindMatch},t.localize(197,null)),e.chartsGreen=u("charts.green",{dark:"#89D185",light:"#388A34",hc:"#89D185"},t.localize(198,null)),e.chartsPurple=u("charts.purple",{dark:"#B180D7",light:"#652D90",hc:"#B180D7"},t.localize(199,null));function l(R,O){switch(R.op){case 0:return y(R.value,O)?.darken(R.factor);case 1:return y(R.value,O)?.lighten(R.factor);case 2:return y(R.value,O)?.transparent(R.factor);case 3:for(const j of R.values){const _=y(j,O);if(_)return _}return;case 5:return y(O.defines(R.if)?R.then:R.else,O);case 4:const K=y(R.value,O);if(!K)return;const te=y(R.background,O);return te?K.isDarkerThan(te)?k.Color.getLighterColor(K,te,R.factor).transparent(R.transparency):k.Color.getDarkerColor(K,te,R.factor).transparent(R.transparency):K.transparent(R.factor*R.transparency);default:throw(0,P.assertNever)(R)}}e.executeTransform=l;function r(R,O){return{op:0,value:R,factor:O}}e.darken=r;function o(R,O){return{op:1,value:R,factor:O}}e.lighten=o;function i(R,O){return{op:2,value:R,factor:O}}e.transparent=i;function n(...R){return{op:3,values:R}}e.oneOf=n;function s(R,O,K){return{op:5,if:R,then:O,else:K}}e.ifDefinedThenElse=s;function d(R,O,K,te){return{op:4,value:R,background:O,factor:K,transparency:te}}function y(R,O){if(R!==null){if(typeof R=="string")return R[0]==="#"?k.Color.fromHex(R):O.getColor(R);if(R instanceof k.Color)return R;if(typeof R=="object")return l(R,O)}}e.resolveColorValue=y,e.workbenchColorsSchemaId="vscode://schemas/workbench-colors";let A=h.Registry.as(T.Extensions.JSONContribution);A.registerSchema(e.workbenchColorsSchemaId,m.getColorSchema());const E=new S.RunOnceScheduler(()=>A.notifySchemaChanged(e.workbenchColorsSchemaId),200);m.onDidChangeSchema(()=>{E.isScheduled()||E.schedule()})}),define(ue[79],de([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var S;(function(k){k.DARK="dark",k.LIGHT="light",k.HIGH_CONTRAST="hc"})(S=e.ColorScheme||(e.ColorScheme={}))}),define(ue[50],de([0,1,40,6,3,7,22,79]),function(Y,e,S,k,p,P,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,P.createDecorator)("themeService");var h;(function(g){function D(w){return w&&typeof w=="object"&&typeof w.id=="string"}g.isThemeColor=D})(h=e.ThemeColor||(e.ThemeColor={}));function f(g){return{id:g}}e.themeColorFromId=f;var C;(function(g){function D(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(typeof i.color=="undefined"||h.isThemeColor(i.color))}g.isThemeIcon=D;const w=new RegExp(`^\\$\\((${S.CSSIcon.iconNameExpression}(?:${S.CSSIcon.iconModifierExpression})?)\\)$`);function v(i){const n=w.exec(i);if(!n)return;let[,s]=n;return{id:s}}g.fromString=v;function a(i,n){let s=i.id;const d=s.lastIndexOf("~");return d!==-1&&(s=s.substring(0,d)),n&&(s=`${s}~${n}`),{id:s}}g.modify=a;function l(i){const n=i.id.lastIndexOf("~");if(n!==-1)return i.id.substring(n+1)}g.getModifier=l;function r(i,n){return i.id===n.id&&i.color?.id===n.color?.id}g.isEqual=r;function o(i,n){return{id:i.id,color:n?f(n):void 0}}g.asThemeIcon=o,g.asClassNameArray=S.CSSIcon.asClassNameArray,g.asClassName=S.CSSIcon.asClassName,g.asCSSSelector=S.CSSIcon.asCSSSelector})(C=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=S.Codicon.file,e.FolderThemeIcon=S.Codicon.folder;function I(g){switch(g){case T.ColorScheme.DARK:return"vs-dark";case T.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=I,e.Extensions={ThemingContribution:"base.contributions.theming"};class m{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new k.Emitter}onColorThemeChange(D){return this.themingParticipants.push(D),this.onThemingParticipantAddedEmitter.fire(D),(0,p.toDisposable)(()=>{const w=this.themingParticipants.indexOf(D);this.themingParticipants.splice(w,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let u=new m;t.Registry.add(e.Extensions.ThemingContribution,u);function c(g){return u.onColorThemeChange(g)}e.registerThemingParticipant=c;class b extends p.Disposable{constructor(D){super();this.themeService=D,this.theme=D.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(w=>this.onThemeChange(w)))}onThemeChange(D){this.theme=D,this.updateStyles()}updateStyles(){}getColor(D,w){let v=this.theme.getColor(D);return v&&w&&(v=w(v,this.theme)),v?v.toString():null}}e.Themable=b}),define(ue[230],de([0,1,156,46,44,50]),function(Y,e,S,k,p,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.editorUnicodeHighlightBorder=e.editorBracketPairGuideActiveBackground6=e.editorBracketPairGuideActiveBackground5=e.editorBracketPairGuideActiveBackground4=e.editorBracketPairGuideActiveBackground3=e.editorBracketPairGuideActiveBackground2=e.editorBracketPairGuideActiveBackground1=e.editorBracketPairGuideBackground6=e.editorBracketPairGuideBackground5=e.editorBracketPairGuideBackground4=e.editorBracketPairGuideBackground3=e.editorBracketPairGuideBackground2=e.editorBracketPairGuideBackground1=e.editorBracketHighlightingUnexpectedBracketForeground=e.editorBracketHighlightingForeground6=e.editorBracketHighlightingForeground5=e.editorBracketHighlightingForeground4=e.editorBracketHighlightingForeground3=e.editorBracketHighlightingForeground2=e.editorBracketHighlightingForeground1=e.overviewRulerInfo=e.overviewRulerWarning=e.overviewRulerError=e.overviewRulerRangeHighlight=e.ghostTextBackground=e.ghostTextForeground=e.ghostTextBorder=e.editorUnnecessaryCodeOpacity=e.editorUnnecessaryCodeBorder=e.editorGutter=e.editorOverviewRulerBackground=e.editorOverviewRulerBorder=e.editorBracketMatchBorder=e.editorBracketMatchBackground=e.editorCodeLensForeground=e.editorRuler=e.editorActiveLineNumber=e.editorLineNumbers=e.editorActiveIndentGuides=e.editorIndentGuides=e.editorWhitespaces=e.editorCursorBackground=e.editorCursorForeground=e.editorSymbolHighlightBorder=e.editorSymbolHighlight=e.editorRangeHighlightBorder=e.editorRangeHighlight=e.editorLineHighlightBorder=e.editorLineHighlight=void 0,e.editorLineHighlight=(0,p.registerColor)("editor.lineHighlightBackground",{dark:null,light:null,hc:null},S.localize(0,null)),e.editorLineHighlightBorder=(0,p.registerColor)("editor.lineHighlightBorder",{dark:"#282828",light:"#eeeeee",hc:"#f38518"},S.localize(1,null)),e.editorRangeHighlight=(0,p.registerColor)("editor.rangeHighlightBackground",{dark:"#ffffff0b",light:"#fdff0033",hc:null},S.localize(2,null),!0),e.editorRangeHighlightBorder=(0,p.registerColor)("editor.rangeHighlightBorder",{dark:null,light:null,hc:p.activeContrastBorder},S.localize(3,null),!0),e.editorSymbolHighlight=(0,p.registerColor)("editor.symbolHighlightBackground",{dark:p.editorFindMatchHighlight,light:p.editorFindMatchHighlight,hc:null},S.localize(4,null),!0),e.editorSymbolHighlightBorder=(0,p.registerColor)("editor.symbolHighlightBorder",{dark:null,light:null,hc:p.activeContrastBorder},S.localize(5,null),!0),e.editorCursorForeground=(0,p.registerColor)("editorCursor.foreground",{dark:"#AEAFAD",light:k.Color.black,hc:k.Color.white},S.localize(6,null)),e.editorCursorBackground=(0,p.registerColor)("editorCursor.background",null,S.localize(7,null)),e.editorWhitespaces=(0,p.registerColor)("editorWhitespace.foreground",{dark:"#e3e4e229",light:"#33333333",hc:"#e3e4e229"},S.localize(8,null)),e.editorIndentGuides=(0,p.registerColor)("editorIndentGuide.background",{dark:e.editorWhitespaces,light:e.editorWhitespaces,hc:e.editorWhitespaces},S.localize(9,null)),e.editorActiveIndentGuides=(0,p.registerColor)("editorIndentGuide.activeBackground",{dark:e.editorWhitespaces,light:e.editorWhitespaces,hc:e.editorWhitespaces},S.localize(10,null)),e.editorLineNumbers=(0,p.registerColor)("editorLineNumber.foreground",{dark:"#858585",light:"#237893",hc:k.Color.white},S.localize(11,null));const t=(0,p.registerColor)("editorActiveLineNumber.foreground",{dark:"#c6c6c6",light:"#0B216F",hc:p.activeContrastBorder},S.localize(12,null),!1,S.localize(13,null));e.editorActiveLineNumber=(0,p.registerColor)("editorLineNumber.activeForeground",{dark:t,light:t,hc:t},S.localize(14,null)),e.editorRuler=(0,p.registerColor)("editorRuler.foreground",{dark:"#5A5A5A",light:k.Color.lightgrey,hc:k.Color.white},S.localize(15,null)),e.editorCodeLensForeground=(0,p.registerColor)("editorCodeLens.foreground",{dark:"#999999",light:"#919191",hc:"#999999"},S.localize(16,null)),e.editorBracketMatchBackground=(0,p.registerColor)("editorBracketMatch.background",{dark:"#0064001a",light:"#0064001a",hc:"#0064001a"},S.localize(17,null)),e.editorBracketMatchBorder=(0,p.registerColor)("editorBracketMatch.border",{dark:"#888",light:"#B9B9B9",hc:p.contrastBorder},S.localize(18,null)),e.editorOverviewRulerBorder=(0,p.registerColor)("editorOverviewRuler.border",{dark:"#7f7f7f4d",light:"#7f7f7f4d",hc:"#7f7f7f4d"},S.localize(19,null)),e.editorOverviewRulerBackground=(0,p.registerColor)("editorOverviewRuler.background",null,S.localize(20,null)),e.editorGutter=(0,p.registerColor)("editorGutter.background",{dark:p.editorBackground,light:p.editorBackground,hc:p.editorBackground},S.localize(21,null)),e.editorUnnecessaryCodeBorder=(0,p.registerColor)("editorUnnecessaryCode.border",{dark:null,light:null,hc:k.Color.fromHex("#fff").transparent(.8)},S.localize(22,null)),e.editorUnnecessaryCodeOpacity=(0,p.registerColor)("editorUnnecessaryCode.opacity",{dark:k.Color.fromHex("#000a"),light:k.Color.fromHex("#0007"),hc:null},S.localize(23,null)),e.ghostTextBorder=(0,p.registerColor)("editorGhostText.border",{dark:null,light:null,hc:k.Color.fromHex("#fff").transparent(.8)},S.localize(24,null)),e.ghostTextForeground=(0,p.registerColor)("editorGhostText.foreground",{dark:k.Color.fromHex("#ffffff56"),light:k.Color.fromHex("#0007"),hc:null},S.localize(25,null)),e.ghostTextBackground=(0,p.registerColor)("editorGhostText.background",{dark:null,light:null,hc:null},S.localize(26,null));const T=new k.Color(new k.RGBA(0,122,204,.6));e.overviewRulerRangeHighlight=(0,p.registerColor)("editorOverviewRuler.rangeHighlightForeground",{dark:T,light:T,hc:T},S.localize(27,null),!0),e.overviewRulerError=(0,p.registerColor)("editorOverviewRuler.errorForeground",{dark:new k.Color(new k.RGBA(255,18,18,.7)),light:new k.Color(new k.RGBA(255,18,18,.7)),hc:new k.Color(new k.RGBA(255,50,50,1))},S.localize(28,null)),e.overviewRulerWarning=(0,p.registerColor)("editorOverviewRuler.warningForeground",{dark:p.editorWarningForeground,light:p.editorWarningForeground,hc:p.editorWarningBorder},S.localize(29,null)),e.overviewRulerInfo=(0,p.registerColor)("editorOverviewRuler.infoForeground",{dark:p.editorInfoForeground,light:p.editorInfoForeground,hc:p.editorInfoBorder},S.localize(30,null)),e.editorBracketHighlightingForeground1=(0,p.registerColor)("editorBracketHighlight.foreground1",{dark:"#FFD700",light:"#0431FAFF",hc:"#FFD700"},S.localize(31,null)),e.editorBracketHighlightingForeground2=(0,p.registerColor)("editorBracketHighlight.foreground2",{dark:"#DA70D6",light:"#319331FF",hc:"#DA70D6"},S.localize(32,null)),e.editorBracketHighlightingForeground3=(0,p.registerColor)("editorBracketHighlight.foreground3",{dark:"#179FFF",light:"#7B3814FF",hc:"#87CEFA"},S.localize(33,null)),e.editorBracketHighlightingForeground4=(0,p.registerColor)("editorBracketHighlight.foreground4",{dark:"#00000000",light:"#00000000",hc:"#00000000"},S.localize(34,null)),e.editorBracketHighlightingForeground5=(0,p.registerColor)("editorBracketHighlight.foreground5",{dark:"#00000000",light:"#00000000",hc:"#00000000"},S.localize(35,null)),e.editorBracketHighlightingForeground6=(0,p.registerColor)("editorBracketHighlight.foreground6",{dark:"#00000000",light:"#00000000",hc:"#00000000"},S.localize(36,null)),e.editorBracketHighlightingUnexpectedBracketForeground=(0,p.registerColor)("editorBracketHighlight.unexpectedBracket.foreground",{dark:new k.Color(new k.RGBA(255,18,18,.8)),light:new k.Color(new k.RGBA(255,18,18,.8)),hc:new k.Color(new k.RGBA(255,50,50,1))},S.localize(37,null)),e.editorBracketPairGuideBackground1=(0,p.registerColor)("editorBracketPairGuide.background1",{dark:"#00000000",light:"#00000000",hc:"#00000000"},S.localize(38,null)),e.editorBracketPairGuideBackground2=(0,p.registerColor)("editorBracketPairGuide.background2",{dark:"#00000000",light:"#00000000",hc:"#00000000"},S.localize(39,null)),e.editorBracketPairGuideBackground3=(0,p.registerColor)("editorBracketPairGuide.background3",{dark:"#00000000",light:"#00000000",hc:"#00000000"},S.localize(40,null)),e.editorBracketPairGuideBackground4=(0,p.registerColor)("editorBracketPairGuide.background4",{dark:"#00000000",light:"#00000000",hc:"#00000000"},S.localize(41,null)),e.editorBracketPairGuideBackground5=(0,p.registerColor)("editorBracketPairGuide.background5",{dark:"#00000000",light:"#00000000",hc:"#00000000"},S.localize(42,null)),e.editorBracketPairGuideBackground6=(0,p.registerColor)("editorBracketPairGuide.background6",{dark:"#00000000",light:"#00000000",hc:"#00000000"},S.localize(43,null)),e.editorBracketPairGuideActiveBackground1=(0,p.registerColor)("editorBracketPairGuide.activeBackground1",{dark:"#00000000",light:"#00000000",hc:"#00000000"},S.localize(44,null)),e.editorBracketPairGuideActiveBackground2=(0,p.registerColor)("editorBracketPairGuide.activeBackground2",{dark:"#00000000",light:"#00000000",hc:"#00000000"},S.localize(45,null)),e.editorBracketPairGuideActiveBackground3=(0,p.registerColor)("editorBracketPairGuide.activeBackground3",{dark:"#00000000",light:"#00000000",hc:"#00000000"},S.localize(46,null)),e.editorBracketPairGuideActiveBackground4=(0,p.registerColor)("editorBracketPairGuide.activeBackground4",{dark:"#00000000",light:"#00000000",hc:"#00000000"},S.localize(47,null)),e.editorBracketPairGuideActiveBackground5=(0,p.registerColor)("editorBracketPairGuide.activeBackground5",{dark:"#00000000",light:"#00000000",hc:"#00000000"},S.localize(48,null)),e.editorBracketPairGuideActiveBackground6=(0,p.registerColor)("editorBracketPairGuide.activeBackground6",{dark:"#00000000",light:"#00000000",hc:"#00000000"},S.localize(49,null)),e.editorUnicodeHighlightBorder=(0,p.registerColor)("editorUnicodeHighlight.border",{dark:"#ff0000",light:"#ff0000",hc:"#ff0000"},S.localize(50,null)),(0,P.registerThemingParticipant)((h,f)=>{const C=h.getColor(p.editorBackground);C&&f.addRule(`.monaco-editor, .monaco-editor-background, .monaco-editor .inputarea.ime-input { background-color: ${C}; }`);const I=h.getColor(p.editorForeground);I&&f.addRule(`.monaco-editor, .monaco-editor .inputarea.ime-input { color: ${I}; }`);const m=h.getColor(e.editorGutter);m&&f.addRule(`.monaco-editor .margin { background-color: ${m}; }`);const u=h.getColor(e.editorRangeHighlight);u&&f.addRule(`.monaco-editor .rangeHighlight { background-color: ${u}; }`);const c=h.getColor(e.editorRangeHighlightBorder);c&&f.addRule(`.monaco-editor .rangeHighlight { border: 1px ${h.type==="hc"?"dotted":"solid"} ${c}; }`);const b=h.getColor(e.editorSymbolHighlight);b&&f.addRule(`.monaco-editor .symbolHighlight { background-color: ${b}; }`);const g=h.getColor(e.editorSymbolHighlightBorder);g&&f.addRule(`.monaco-editor .symbolHighlight { border: 1px ${h.type==="hc"?"dotted":"solid"} ${g}; }`);const D=h.getColor(e.editorWhitespaces);D&&(f.addRule(`.monaco-editor .mtkw { color: ${D} !important; }`),f.addRule(`.monaco-editor .mtkz { color: ${D} !important; }`))})}),define(ue[231],de([0,1,40,5,50]),function(Y,e,S,k,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isUriComponents=e.terminalIconsEqual=e.terminalProfileArgsMatch=e.createProfileSchemaEnums=void 0;function P(I,m){const u=I.map(c=>({name:c.profileName,description:t(c)}));return m&&u.push(...m.map(c=>({name:c.title,description:T(c)}))),{values:u.map(c=>c.name),markdownDescriptions:u.map(c=>c.description)}}e.createProfileSchemaEnums=P;function t(I){let m=`$(${p.ThemeIcon.isThemeIcon(I.icon)?I.icon.id:I.icon?I.icon:S.Codicon.terminal.id}) ${I.profileName}
- path: ${I.path}`;return I.args&&(typeof I.args=="string"?m+=`
- args: "${I.args}"`:m+=`
- args: [${I.args.length===0?"":`'${I.args.join("','")}'`}]`),I.overrideName!==void 0&&(m+=`
- overrideName: ${I.overrideName}`),I.color&&(m+=`
- color: ${I.color}`),I.env&&(m+=`
- env: ${JSON.stringify(I.env)}`),m}function T(I){return`$(${p.ThemeIcon.isThemeIcon(I.icon)?I.icon.id:I.icon?I.icon:S.Codicon.terminal.id}) ${I.title}
- extensionIdenfifier: ${I.extensionIdentifier}`}function h(I,m){if(!I&&!m)return!0;if(typeof I=="string"&&typeof m=="string")return I===m;if(Array.isArray(I)&&Array.isArray(m)){if(I.length!==m.length)return!1;for(let u=0;u<I.length;u++)if(I[u]!==m[u])return!1;return!0}return!1}e.terminalProfileArgsMatch=h;function f(I,m){if(!I&&!m)return!0;if(!I||!m)return!1;if(p.ThemeIcon.isThemeIcon(I)&&p.ThemeIcon.isThemeIcon(m))return I.id===m.id&&I.color===m.color;if(typeof I=="object"&&I&&"light"in I&&"dark"in I&&typeof m=="object"&&m&&"light"in m&&"dark"in m){const u=I,c=m;if((k.URI.isUri(u.light)||C(u.light))&&(k.URI.isUri(u.dark)||C(u.dark))&&(k.URI.isUri(c.light)||C(c.light))&&(k.URI.isUri(c.dark)||C(c.dark)))return u.light.path===c.light.path&&u.dark.path===c.dark.path}if(k.URI.isUri(I)&&k.URI.isUri(m)||C(I)||C(m)){const u=I,c=m;return u.path===c.path&&u.scheme===c.scheme}return!1}e.terminalIconsEqual=f;function C(I){return I?typeof I.path=="string"&&typeof I.scheme=="string":!1}e.isUriComponents=C}),define(ue[232],de([0,1,40,175,42,22,231]),function(Y,e,S,k,p,P,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerTerminalDefaultProfileConfiguration=e.registerTerminalPlatformConfiguration=void 0;const T={args:{description:(0,k.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,k.localize)(1,null),type:"boolean"},icon:{description:(0,k.localize)(2,null),type:"string",enum:Array.from(S.iconRegistry.all,v=>v.id),markdownEnumDescriptions:Array.from(S.iconRegistry.all,v=>`$(${v.id})`)},color:{description:(0,k.localize)(3,null),type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},env:{markdownDescription:(0,k.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},h={type:"object",required:["path"],properties:{path:{description:(0,k.localize)(5,null),type:["string","array"],items:{type:"string"}},...T}},f=(0,k.localize)(6,null,"`#terminal.integrated.profiles.linux#`","`#terminal.integrated.defaultProfile.linux#`"),C=(0,k.localize)(7,null,"`#terminal.integrated.profiles.osx#`","`#terminal.integrated.defaultProfile.osx#`"),I=(0,k.localize)(8,null,"`#terminal.integrated.profiles.windows#`","`#terminal.integrated.defaultProfile.windows#`"),m=(0,k.localize)(9,null,"`#terminal.integrated.automationProfile.linux#`"),u=(0,k.localize)(10,null,"`#terminal.integrated.automationProfile.osx#`"),c=(0,k.localize)(11,null,"`#terminal.integrated.automationProfile.windows#`"),b={id:"terminal",order:100,title:(0,k.localize)(12,null),type:"object",properties:{["terminal.integrated.automationShell.linux"]:{restricted:!0,markdownDescription:(0,k.localize)(13,null,"`terminal.integrated.shell.linux`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:m},["terminal.integrated.automationShell.osx"]:{restricted:!0,markdownDescription:(0,k.localize)(14,null,"`terminal.integrated.shell.osx`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:u},["terminal.integrated.automationShell.windows"]:{restricted:!0,markdownDescription:(0,k.localize)(15,null,"`terminal.integrated.shell.windows`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:c},["terminal.integrated.automationProfile.linux"]:{restricted:!0,markdownDescription:(0,k.localize)(16,null,"#terminal.integrated.automationShell.linux#"),type:["object","null"],default:null,anyOf:[{type:"null"},h]},["terminal.integrated.automationProfile.osx"]:{restricted:!0,description:(0,k.localize)(17,null,"#terminal.integrated.automationShell.osx#"),type:["object","null"],default:null,anyOf:[{type:"null"},h]},["terminal.integrated.automationProfile.windows"]:{restricted:!0,description:(0,k.localize)(18,null,"#terminal.integrated.automationShell.windows#"),type:["object","null"],default:null,anyOf:[{type:"null"},h]},["terminal.integrated.shell.linux"]:{restricted:!0,markdownDescription:(0,k.localize)(19,null),type:["string","null"],default:null,markdownDeprecationMessage:f},["terminal.integrated.shell.osx"]:{restricted:!0,markdownDescription:(0,k.localize)(20,null),type:["string","null"],default:null,markdownDeprecationMessage:C},["terminal.integrated.shell.windows"]:{restricted:!0,markdownDescription:(0,k.localize)(21,null),type:["string","null"],default:null,markdownDeprecationMessage:I},["terminal.integrated.shellArgs.linux"]:{restricted:!0,markdownDescription:(0,k.localize)(22,null),type:"array",items:{type:"string"},default:[],markdownDeprecationMessage:f},["terminal.integrated.shellArgs.osx"]:{restricted:!0,markdownDescription:(0,k.localize)(23,null),type:"array",items:{type:"string"},default:["-l"],markdownDeprecationMessage:C},["terminal.integrated.shellArgs.windows"]:{restricted:!0,markdownDescription:(0,k.localize)(24,null),anyOf:[{type:"array",items:{type:"string",markdownDescription:(0,k.localize)(25,null)}},{type:"string",markdownDescription:(0,k.localize)(26,null)}],default:[],markdownDeprecationMessage:I},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:(0,k.localize)(27,null,"`source`","`path`","`args`","`null`",'`"Ubuntu-20.04 (WSL)": null`'),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,k.localize)(28,null),enum:["PowerShell","Git Bash"]},...T}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,k.localize)(29,null),type:"string"},id:{description:(0,k.localize)(30,null),type:"string"},title:{description:(0,k.localize)(31,null),type:"string"},...T}},{type:"null"},h]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:(0,k.localize)(32,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,k.localize)(33,null),type:"string"},id:{description:(0,k.localize)(34,null),type:"string"},title:{description:(0,k.localize)(35,null),type:"string"},...T}},{type:"null"},h]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:(0,k.localize)(36,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,k.localize)(37,null),type:"string"},id:{description:(0,k.localize)(38,null),type:"string"},title:{description:(0,k.localize)(39,null),type:"string"},...T}},{type:"null"},h]}},["terminal.integrated.useWslProfiles"]:{description:(0,k.localize)(40,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,k.localize)(41,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,k.localize)(42,null),type:"number",default:100},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,k.localize)(43,null),type:"boolean",default:!0},["terminal.integrated.ignoreProcessNames"]:{description:(0,k.localize)(44,null),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function g(){P.Registry.as(p.Extensions.Configuration).registerConfiguration(b),w()}e.registerTerminalPlatformConfiguration=g;let D;function w(v,a){const l=P.Registry.as(p.Extensions.Configuration);let r;v&&(r=(0,t.createProfileSchemaEnums)(v?.profiles,a));const o=D;D={id:"terminal",order:100,title:(0,k.localize)(45,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,k.localize)(46,null,"`terminal.integrated.shell.linux`","`terminal.integrated.shellArgs.linux`"),type:["string","null"],default:null,enum:v?.os===3?r?.values:void 0,markdownEnumDescriptions:v?.os===3?r?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,k.localize)(47,null,"`terminal.integrated.shell.osx`","`terminal.integrated.shellArgs.osx`"),type:["string","null"],default:null,enum:v?.os===2?r?.values:void 0,markdownEnumDescriptions:v?.os===2?r?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,k.localize)(48,null,"`terminal.integrated.shell.windows`","`terminal.integrated.shellArgs.windows`"),type:["string","null"],default:null,enum:v?.os===1?r?.values:void 0,markdownEnumDescriptions:v?.os===1?r?.markdownDescriptions:void 0}}},l.updateConfigurations({add:[D],remove:o?[o]:[]})}e.registerTerminalDefaultProfileConfiguration=w}),define(ue[233],de([0,1,41,40,4,2,17,93,229,50]),function(Y,e,S,k,p,P,t,T,h,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;let C,I=!0;function m(o,i,n,s,d=process.env,y,A,E,R){return y=y||{existsFile:t.SymlinkSupport.existsFile,readFile:t.Promises.readFile},P.isWindows?u(n,y,d,A,s.getValue("terminal.integrated.useWslProfiles")!==!1,o&&typeof o=="object"?{...o}:s.getValue("terminal.integrated.profiles.windows"),typeof i=="string"?i:s.getValue("terminal.integrated.defaultProfile.windows"),R,E):a(y,A,n,o&&typeof o=="object"?{...o}:s.getValue(P.isLinux?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof i=="string"?i:s.getValue(P.isLinux?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),R,E,d)}e.detectAvailableProfiles=m;async function u(o,i,n,s,d,y,A,E,R){const O=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),K=`${process.env.windir}\\${O?"Sysnative":"System32"}`;let te=!1;(0,h.getWindowsBuildNumber)()>=16299&&(te=!0),await g(E);const j=new Map;o&&(j.set("PowerShell",{source:"PowerShell",icon:k.Codicon.terminalPowershell,isAutoDetected:!0}),j.set("Windows PowerShell",{path:`${K}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:k.Codicon.terminalPowershell,isAutoDetected:!0}),j.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),j.set("Cygwin",{path:[`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`],args:["--login"],isAutoDetected:!0}),j.set("Command Prompt",{path:`${K}\\cmd.exe`,icon:k.Codicon.terminalCmd,isAutoDetected:!0})),l(y,j);const _=await c(j.entries(),A,i,n,s,R);if(o||!o&&d)try{const U=await w(`${K}\\${te?"wsl":"bash"}.exe`,A);for(const F of U)(!y||!(F.profileName in y))&&_.push(F)}catch(U){I&&(s?.info("WSL is not installed, so could not detect WSL profiles"),I=!1)}return _}async function c(o,i,n,s=process.env,d,y){const A=[];for(const[E,R]of o){if(R===null)continue;let O,K,te;if("source"in R){const U=C?.get(R.source);if(!U)continue;O=U.paths,K=R.args||U.args,R.icon?te=b(R.icon):U.icon&&(te=U.icon)}else O=Array.isArray(R.path)?R.path:[R.path],K=P.isWindows||Array.isArray(R.args)?R.args:void 0,te=b(R.icon)||void 0;const j=await y?.(O)||O.slice(),_=await r(E,i,j,n,s,K,R.env,R.overrideName,R.isAutoDetected,d);_?(_.isAutoDetected=R.isAutoDetected,_.icon=te,_.color=R.color,A.push(_)):d?.trace("profile not validated",E,O)}return A}function b(o){return typeof o=="string"?{id:o}:o}async function g(o){C&&!o||(C=new Map,C.set("Git Bash",{profileName:"Git Bash",paths:[`${process.env.ProgramW6432}\\Git\\bin\\bash.exe`,`${process.env.ProgramW6432}\\Git\\usr\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\usr\\bin\\bash.exe`,`${process.env.LocalAppData}\\Programs\\Git\\bin\\bash.exe`,`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`,`${process.env.AllUsersProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`],args:["--login"]}),C.set("PowerShell",{profileName:"PowerShell",paths:o||await D(),icon:f.ThemeIcon.asThemeIcon(k.Codicon.terminalPowershell)}))}async function D(){const o=[];for await(const i of(0,T.enumeratePowerShellInstallations)())o.push(i.exePath);return o}async function w(o,i){const n=[],s=await new Promise((A,E)=>{S.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(R,O)=>{if(R)return E("Problem occurred when getting wsl distros");A(O)})});if(!s)return[];const d=new RegExp(/[\r?\n]/),y=s.split(d).filter(A=>A.trim().length>0&&A!=="");for(const A of y){if(A===""||A.startsWith("docker-desktop"))continue;const E=`${A} (WSL)`,R={profileName:E,path:o,args:["-d",`${A}`],isDefault:E===i,icon:v(A)};n.push(R)}return n}function v(o){return o.includes("Ubuntu")?f.ThemeIcon.asThemeIcon(k.Codicon.terminalUbuntu):o.includes("Debian")?f.ThemeIcon.asThemeIcon(k.Codicon.terminalDebian):f.ThemeIcon.asThemeIcon(k.Codicon.terminalLinux)}async function a(o,i,n,s,d,y,A,E){const R=new Map;if(n){const O=(await o.readFile("/etc/shells")).toString(),K=y||O.split(`
`).filter(j=>j.trim().indexOf("#")!==0&&j.trim().length>0),te=new Map;for(const j of K){let _=(0,p.basename)(j),U=te.get(_)||0;U++,U>1&&(_=`${_} (${U})`),te.set(_,U),R.set(_,{path:j,isAutoDetected:!0})}}return l(s,R),await c(R.entries(),d,o,E,i,A)}function l(o,i){if(!!o)for(const[n,s]of Object.entries(o))s===null||!("path"in s)&&!("source"in s)?i.delete(n):i.set(n,s)}async function r(o,i,n,s,d,y,A,E,R,O){if(n.length===0)return Promise.resolve(void 0);const K=n.shift();if(K==="")return r(o,i,n,s,d,y,A,E,R);const te={profileName:o,path:K,args:y,env:A,overrideName:E,isAutoDetected:R,isDefault:o===i};if((0,p.basename)(K)===K){const _=d.PATH?d.PATH.split(p.delimiter):void 0;return await(0,h.findExecutable)(K,void 0,_,void 0,s.existsFile)?te:r(o,i,n,s,d,y)}return await s.existsFile((0,p.normalize)(K))?te:r(o,i,n,s,d,y,A,E,R)}}),define(ue[234],de([0,1,6,3,10,2,35,69,27,28,98,73,16,102,33,228,111,232,233]),function(Y,e,S,k,p,P,t,T,h,f,C,I,m,u,c,b,g,D,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var v;(function(r){r[r.MaxRestarts=5]="MaxRestarts"})(v||(v={}));let a=0,l=class extends k.Disposable{constructor(o,i,n,s,d){super();this._reconnectConstants=o,this._configurationService=i,this._environmentService=n,this._logService=s,this._telemetryService=d,this._restartCount=0,this._isResponsive=!0,this._isDisposed=!1,this._onPtyHostExit=this._register(new S.Emitter),this.onPtyHostExit=this._onPtyHostExit.event,this._onPtyHostStart=this._register(new S.Emitter),this.onPtyHostStart=this._onPtyHostStart.event,this._onPtyHostUnresponsive=this._register(new S.Emitter),this.onPtyHostUnresponsive=this._onPtyHostUnresponsive.event,this._onPtyHostResponsive=this._register(new S.Emitter),this.onPtyHostResponsive=this._onPtyHostResponsive.event,this._onPtyHostRequestResolveVariables=this._register(new S.Emitter),this.onPtyHostRequestResolveVariables=this._onPtyHostRequestResolveVariables.event,this._onProcessData=this._register(new S.Emitter),this.onProcessData=this._onProcessData.event,this._onProcessReady=this._register(new S.Emitter),this.onProcessReady=this._onProcessReady.event,this._onProcessReplay=this._register(new S.Emitter),this.onProcessReplay=this._onProcessReplay.event,this._onProcessOrphanQuestion=this._register(new S.Emitter),this.onProcessOrphanQuestion=this._onProcessOrphanQuestion.event,this._onDidRequestDetach=this._register(new S.Emitter),this.onDidRequestDetach=this._onDidRequestDetach.event,this._onDidChangeProperty=this._register(new S.Emitter),this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=this._register(new S.Emitter),this.onProcessExit=this._onProcessExit.event,(0,D.registerTerminalPlatformConfiguration)(),this._shellEnv=this._resolveShellEnv(),this._register((0,k.toDisposable)(()=>this._disposePtyHost())),this._resolveVariablesRequestStore=this._register(new b.RequestStore(void 0,this._logService)),this._resolveVariablesRequestStore.onCreateRequest(this._onPtyHostRequestResolveVariables.fire,this._onPtyHostRequestResolveVariables),[this._client,this._proxy]=this._startPtyHost(),this._register(this._configurationService.onDidChangeConfiguration(async y=>{y.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this._refreshIgnoreProcessNames()}))}async initialize(){await this._refreshIgnoreProcessNames()}get _ignoreProcessNames(){return this._configurationService.getValue("terminal.integrated.ignoreProcessNames")}async _refreshIgnoreProcessNames(){return this._proxy.refreshIgnoreProcessNames?.(this._ignoreProcessNames)}async _resolveShellEnv(){if(P.isWindows)return process.env;try{return await(0,I.resolveShellEnv)(this._logService,{_:[]},process.env)}catch(o){return this._logService.error("ptyHost was unable to resolve shell environment",o),{}}}_startPtyHost(){const o={serverName:"Pty Host",args:["--type=ptyHost"],env:{VSCODE_LAST_PTY_ID:a,VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:this._reconnectConstants.graceTime,VSCODE_RECONNECT_SHORT_GRACE_TIME:this._reconnectConstants.shortGraceTime,VSCODE_RECONNECT_SCROLLBACK:this._reconnectConstants.scrollback}},i=(0,C.parsePtyHostPort)(this._environmentService.args,this._environmentService.isBuilt);i&&(i.break&&i.port?o.debugBrk=i.port:!i.break&&i.port&&(o.debug=i.port));const n=new T.Client(p.FileAccess.asFileUri("bootstrap-fork",Y).fsPath,o);this._onPtyHostStart.fire(),t.ProxyChannel.toService(n.getChannel(g.TerminalIpcChannels.Heartbeat)).onBeat(()=>this._handleHeartbeat()),this._handleHeartbeat(),this._register(n.onDidProcessExit(A=>{this._telemetryService.publicLog("ptyHost/exit"),this._onPtyHostExit.fire(A.code),this._isDisposed||(this._restartCount<=v.MaxRestarts?(this._logService.error(`ptyHost terminated unexpectedly with code ${A.code}`),this._restartCount++,this.restartPtyHost()):this._logService.error(`ptyHost terminated unexpectedly with code ${A.code}, giving up`))}));const d=n.getChannel(g.TerminalIpcChannels.Log);u.LogLevelChannelClient.setLevel(d,this._logService.getLevel()),this._register(this._logService.onDidChangeLogLevel(()=>{u.LogLevelChannelClient.setLevel(d,this._logService.getLevel())}));const y=t.ProxyChannel.toService(n.getChannel(g.TerminalIpcChannels.PtyHost));return this._register(y.onProcessData(A=>this._onProcessData.fire(A))),this._register(y.onProcessReady(A=>this._onProcessReady.fire(A))),this._register(y.onProcessExit(A=>this._onProcessExit.fire(A))),this._register(y.onDidChangeProperty(A=>this._onDidChangeProperty.fire(A))),this._register(y.onProcessReplay(A=>this._onProcessReplay.fire(A))),this._register(y.onProcessOrphanQuestion(A=>this._onProcessOrphanQuestion.fire(A))),this._register(y.onDidRequestDetach(A=>this._onDidRequestDetach.fire(A))),[n,y]}dispose(){this._isDisposed=!0,super.dispose()}async createProcess(o,i,n,s,d,y,A,E,R,O,K){const te=setTimeout(()=>this._handleUnresponsiveCreateProcess(),g.HeartbeatConstants.CreateProcessTimeout),j=await this._proxy.createProcess(o,i,n,s,d,y,A,E,R,O,K);return clearTimeout(te),a=Math.max(a,j),j}updateTitle(o,i,n){return this._proxy.updateTitle(o,i,n)}updateIcon(o,i,n){return this._proxy.updateIcon(o,i,n)}attachToProcess(o){return this._proxy.attachToProcess(o)}detachFromProcess(o){return this._proxy.detachFromProcess(o)}listProcesses(){return this._proxy.listProcesses()}reduceConnectionGraceTime(){return this._proxy.reduceConnectionGraceTime()}start(o){return this._proxy.start(o)}shutdown(o,i){return this._proxy.shutdown(o,i)}input(o,i){return this._proxy.input(o,i)}processBinary(o,i){return this._proxy.processBinary(o,i)}resize(o,i,n){return this._proxy.resize(o,i,n)}acknowledgeDataEvent(o,i){return this._proxy.acknowledgeDataEvent(o,i)}setUnicodeVersion(o,i){return this._proxy.setUnicodeVersion(o,i)}getInitialCwd(o){return this._proxy.getInitialCwd(o)}getCwd(o){return this._proxy.getCwd(o)}getLatency(o){return this._proxy.getLatency(o)}orphanQuestionReply(o){return this._proxy.orphanQuestionReply(o)}getDefaultSystemShell(o){return this._proxy.getDefaultSystemShell(o)}async getProfiles(o,i,n,s=!1){const d=await this._shellEnv;return(0,w.detectAvailableProfiles)(i,n,s,this._configurationService,d,void 0,this._logService,this._resolveVariables.bind(this,o))}getEnvironment(){return this._proxy.getEnvironment()}getWslPath(o){return this._proxy.getWslPath(o)}setTerminalLayoutInfo(o){return this._proxy.setTerminalLayoutInfo(o)}async getTerminalLayoutInfo(o){return await this._proxy.getTerminalLayoutInfo(o)}async requestDetachInstance(o,i){return this._proxy.requestDetachInstance(o,i)}async acceptDetachInstanceReply(o,i){return this._proxy.acceptDetachInstanceReply(o,i)}async serializeTerminalState(o){return this._proxy.serializeTerminalState(o)}async reviveTerminalProcesses(o){return this._proxy.reviveTerminalProcesses(o)}async refreshProperty(o,i){return this._proxy.refreshProperty(o,i)}async updateProperty(o,i,n){return this._proxy.updateProperty(o,i,n)}async restartPtyHost(){this._telemetryService.publicLog("ptyHost/restart"),this._isResponsive=!0,this._disposePtyHost(),[this._client,this._proxy]=this._startPtyHost()}_disposePtyHost(){this._proxy.shutdownAll?.(),this._client.dispose()}_handleHeartbeat(){this._clearHeartbeatTimeouts(),this._heartbeatFirstTimeout=setTimeout(()=>this._handleHeartbeatFirstTimeout(),g.HeartbeatConstants.BeatInterval*g.HeartbeatConstants.FirstWaitMultiplier),this._isResponsive||(this._telemetryService.publicLog("ptyHost/responsive"),this._isResponsive=!0),this._onPtyHostResponsive.fire()}_handleHeartbeatFirstTimeout(){this._logService.warn(`No ptyHost heartbeat after ${g.HeartbeatConstants.BeatInterval*g.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this._heartbeatFirstTimeout=void 0,this._heartbeatSecondTimeout=setTimeout(()=>this._handleHeartbeatSecondTimeout(),g.HeartbeatConstants.BeatInterval*g.HeartbeatConstants.SecondWaitMultiplier)}_handleHeartbeatSecondTimeout(){this._logService.error(`No ptyHost heartbeat after ${(g.HeartbeatConstants.BeatInterval*g.HeartbeatConstants.FirstWaitMultiplier+g.HeartbeatConstants.BeatInterval*g.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this._heartbeatSecondTimeout=void 0,this._isResponsive&&(this._telemetryService.publicLog("ptyHost/unresponsive"),this._isResponsive=!1),this._onPtyHostUnresponsive.fire()}_handleUnresponsiveCreateProcess(){this._clearHeartbeatTimeouts(),this._logService.error(`No ptyHost response to createProcess after ${g.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this._telemetryService.publicLog("ptyHost/responsive"),this._onPtyHostUnresponsive.fire()}_clearHeartbeatTimeouts(){this._heartbeatFirstTimeout&&(clearTimeout(this._heartbeatFirstTimeout),this._heartbeatFirstTimeout=void 0),this._heartbeatSecondTimeout&&(clearTimeout(this._heartbeatSecondTimeout),this._heartbeatSecondTimeout=void 0)}_resolveVariables(o,i){return this._resolveVariablesRequestStore.createRequest({workspaceId:o,originalText:i})}async acceptPtyHostResolvedVariables(o,i){this._resolveVariablesRequestStore.acceptReply(o,i)}};l=Ne([je(1,h.IConfigurationService),je(2,f.IEnvironmentService),je(3,m.ILogService),je(4,c.ITelemetryService)],l),e.PtyHostService=l}),define(ue[80],de([0,1,13,46,6,177,49,22]),function(Y,e,S,k,p,P,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.tokenStylingSchemaId=e.getTokenClassificationRegistry=e.parseClassifierString=e.Extensions=e.SemanticTokenRule=e.TokenStyle=e.fontStylePattern=e.selectorPattern=e.typeAndModifierIdPattern=e.idPattern=e.CLASSIFIER_MODIFIER_SEPARATOR=e.TOKEN_CLASSIFIER_LANGUAGE_SEPARATOR=e.TOKEN_TYPE_WILDCARD=void 0,e.TOKEN_TYPE_WILDCARD="*",e.TOKEN_CLASSIFIER_LANGUAGE_SEPARATOR=":",e.CLASSIFIER_MODIFIER_SEPARATOR=".",e.idPattern="\\w+[-_\\w+]*",e.typeAndModifierIdPattern=`^${e.idPattern}$`,e.selectorPattern=`^(${e.idPattern}|\\*)(\\${e.CLASSIFIER_MODIFIER_SEPARATOR}${e.idPattern})*(${e.TOKEN_CLASSIFIER_LANGUAGE_SEPARATOR}${e.idPattern})?$`,e.fontStylePattern="^(\\s*(italic|bold|underline))*\\s*$";class h{constructor(l,r,o,i){this.foreground=l,this.bold=r,this.underline=o,this.italic=i}}e.TokenStyle=h,function(a){function l(d){return{_foreground:d.foreground===void 0?null:k.Color.Format.CSS.formatHexA(d.foreground,!0),_bold:d.bold===void 0?null:d.bold,_underline:d.underline===void 0?null:d.underline,_italic:d.italic===void 0?null:d.italic}}a.toJSONObject=l;function r(d){if(d){const y=E=>typeof E=="boolean"?E:void 0,A=E=>typeof E=="string"?k.Color.fromHex(E):void 0;return new a(A(d._foreground),y(d._bold),y(d._underline),y(d._italic))}}a.fromJSONObject=r;function o(d,y){return d===y?!0:d!==void 0&&y!==void 0&&(d.foreground instanceof k.Color?d.foreground.equals(y.foreground):y.foreground===void 0)&&d.bold===y.bold&&d.underline===y.underline&&d.italic===y.italic}a.equals=o;function i(d){return d instanceof a}a.is=i;function n(d){return new a(d.foreground,d.bold,d.underline,d.italic)}a.fromData=n;function s(d,y,A,E,R){let O;if(d!==void 0&&(O=k.Color.fromHex(d)),y!==void 0){A=R=E=!1;const K=/italic|bold|underline/g;let te;for(;te=K.exec(y);)switch(te[0]){case"bold":A=!0;break;case"italic":R=!0;break;case"underline":E=!0;break}}return new a(O,A,E,R)}a.fromSettings=s}(h=e.TokenStyle||(e.TokenStyle={}));var f;(function(a){function l(n,s){if(s&&typeof s._selector=="string"&&s._style){const d=h.fromJSONObject(s._style);if(d)try{return{selector:n.parseTokenSelector(s._selector),style:d}}catch(y){}}}a.fromJSONObject=l;function r(n){return{_selector:n.selector.id,_style:h.toJSONObject(n.style)}}a.toJSONObject=r;function o(n,s){return n===s?!0:n!==void 0&&s!==void 0&&n.selector&&s.selector&&n.selector.id===s.selector.id&&h.equals(n.style,s.style)}a.equals=o;function i(n){return n&&n.selector&&typeof n.selector.id=="string"&&h.is(n.style)}a.is=i})(f=e.SemanticTokenRule||(e.SemanticTokenRule={})),e.Extensions={TokenClassificationContribution:"base.contributions.tokenClassification"};class C{constructor(){this._onDidChangeSchema=new p.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.currentTypeNumber=0,this.currentModifierBit=1,this.tokenStylingDefaultRules=[],this.tokenStylingSchema={type:"object",properties:{},patternProperties:{[e.selectorPattern]:D()},additionalProperties:!1,definitions:{style:{type:"object",description:P.localize(0,null),properties:{foreground:{type:"string",description:P.localize(1,null),format:"color-hex",default:"#ff0000"},background:{type:"string",deprecationMessage:P.localize(2,null)},fontStyle:{type:"string",description:P.localize(3,null),pattern:e.fontStylePattern,patternErrorMessage:P.localize(4,null),defaultSnippets:[{label:P.localize(5,null),bodyText:'""'},{body:"italic"},{body:"bold"},{body:"underline"},{body:"italic underline"},{body:"bold underline"},{body:"italic bold underline"}]},bold:{type:"boolean",description:P.localize(6,null)},italic:{type:"boolean",description:P.localize(7,null)},underline:{type:"boolean",description:P.localize(8,null)}},defaultSnippets:[{body:{foreground:"${1:#FF0000}",fontStyle:"${2:bold}"}}]}}},this.tokenTypeById=Object.create(null),this.tokenModifierById=Object.create(null),this.typeHierarchy=Object.create(null)}registerTokenType(l,r,o,i){if(!l.match(e.typeAndModifierIdPattern))throw new Error("Invalid token type id.");if(o&&!o.match(e.typeAndModifierIdPattern))throw new Error("Invalid token super type id.");let s={num:this.currentTypeNumber++,id:l,superType:o,description:r,deprecationMessage:i};this.tokenTypeById[l]=s;const d=D(r,i);this.tokenStylingSchema.properties[l]=d,this.typeHierarchy=Object.create(null)}registerTokenModifier(l,r,o){if(!l.match(e.typeAndModifierIdPattern))throw new Error("Invalid token modifier id.");const i=this.currentModifierBit;this.currentModifierBit=this.currentModifierBit*2;let n={num:i,id:l,description:r,deprecationMessage:o};this.tokenModifierById[l]=n,this.tokenStylingSchema.properties[`*.${l}`]=D(r,o)}parseTokenSelector(l,r){const o=u(l,r);return o.type?{match:(i,n,s)=>{let d=0;if(o.language!==void 0){if(o.language!==s)return-1;d+=10}if(o.type!==e.TOKEN_TYPE_WILDCARD){const A=this.getTypeHierarchy(i).indexOf(o.type);if(A===-1)return-1;d+=100-A}for(const y of o.modifiers)if(n.indexOf(y)===-1)return-1;return d+o.modifiers.length*100},id:`${[o.type,...o.modifiers.sort()].join(".")}${o.language!==void 0?":"+o.language:""}`}:{match:()=>-1,id:"$invalid"}}registerTokenStyleDefault(l,r){this.tokenStylingDefaultRules.push({selector:l,defaults:r})}deregisterTokenStyleDefault(l){const r=l.id;this.tokenStylingDefaultRules=this.tokenStylingDefaultRules.filter(o=>o.selector.id!==r)}deregisterTokenType(l){delete this.tokenTypeById[l],delete this.tokenStylingSchema.properties[l],this.typeHierarchy=Object.create(null)}deregisterTokenModifier(l){delete this.tokenModifierById[l],delete this.tokenStylingSchema.properties[`*.${l}`]}getTokenTypes(){return Object.keys(this.tokenTypeById).map(l=>this.tokenTypeById[l])}getTokenModifiers(){return Object.keys(this.tokenModifierById).map(l=>this.tokenModifierById[l])}getTokenStylingSchema(){return this.tokenStylingSchema}getTokenStylingDefaultRules(){return this.tokenStylingDefaultRules}getTypeHierarchy(l){let r=this.typeHierarchy[l];if(!r){this.typeHierarchy[l]=r=[l];let o=this.tokenTypeById[l];for(;o&&o.superType;)r.push(o.superType),o=this.tokenTypeById[o.superType]}return r}toString(){let l=(r,o)=>{let i=r.indexOf(".")===-1?0:1,n=o.indexOf(".")===-1?0:1;return i!==n?i-n:r.localeCompare(o)};return Object.keys(this.tokenTypeById).sort(l).map(r=>`- \`${r}\`: ${this.tokenTypeById[r].description}`).join(`
`)}}const I=e.TOKEN_CLASSIFIER_LANGUAGE_SEPARATOR.charCodeAt(0),m=e.CLASSIFIER_MODIFIER_SEPARATOR.charCodeAt(0);function u(a,l){let r=a.length,o=l;const i=[];for(let s=r-1;s>=0;s--){const d=a.charCodeAt(s);if(d===I||d===m){const y=a.substring(s+1,r);r=s,d===I?o=y:i.push(y)}}return{type:a.substring(0,r),modifiers:i,language:o}}e.parseClassifierString=u;let c=b();T.Registry.add(e.Extensions.TokenClassificationContribution,c);function b(){const a=new C;function l(o,i,n=[],s,d){return a.registerTokenType(o,i,s,d),n&&r(o,n),o}function r(o,i){try{const n=a.parseTokenSelector(o);a.registerTokenStyleDefault(n,{scopesToProbe:i})}catch(n){console.log(n)}}return l("comment",P.localize(9,null),[["comment"]]),l("string",P.localize(10,null),[["string"]]),l("keyword",P.localize(11,null),[["keyword.control"]]),l("number",P.localize(12,null),[["constant.numeric"]]),l("regexp",P.localize(13,null),[["constant.regexp"]]),l("operator",P.localize(14,null),[["keyword.operator"]]),l("namespace",P.localize(15,null),[["entity.name.namespace"]]),l("type",P.localize(16,null),[["entity.name.type"],["support.type"]]),l("struct",P.localize(17,null),[["entity.name.type.struct"]]),l("class",P.localize(18,null),[["entity.name.type.class"],["support.class"]]),l("interface",P.localize(19,null),[["entity.name.type.interface"]]),l("enum",P.localize(20,null),[["entity.name.type.enum"]]),l("typeParameter",P.localize(21,null),[["entity.name.type.parameter"]]),l("function",P.localize(22,null),[["entity.name.function"],["support.function"]]),l("member",P.localize(23,null),[],"method","Deprecated use `method` instead"),l("method",P.localize(24,null),[["entity.name.function.member"],["support.function"]]),l("macro",P.localize(25,null),[["entity.name.function.preprocessor"]]),l("variable",P.localize(26,null),[["variable.other.readwrite"],["entity.name.variable"]]),l("parameter",P.localize(27,null),[["variable.parameter"]]),l("property",P.localize(28,null),[["variable.other.property"]]),l("enumMember",P.localize(29,null),[["variable.other.enummember"]]),l("event",P.localize(30,null),[["variable.other.event"]]),l("decorator",P.localize(31,null),[["entity.name.decorator"],["entity.name.function"]]),l("label",P.localize(32,null),void 0),a.registerTokenModifier("declaration",P.localize(33,null),void 0),a.registerTokenModifier("documentation",P.localize(34,null),void 0),a.registerTokenModifier("static",P.localize(35,null),void 0),a.registerTokenModifier("abstract",P.localize(36,null),void 0),a.registerTokenModifier("deprecated",P.localize(37,null),void 0),a.registerTokenModifier("modification",P.localize(38,null),void 0),a.registerTokenModifier("async",P.localize(39,null),void 0),a.registerTokenModifier("readonly",P.localize(40,null),void 0),r("variable.readonly",[["variable.other.constant"]]),r("property.readonly",[["variable.other.constant.property"]]),r("type.defaultLibrary",[["support.type"]]),r("class.defaultLibrary",[["support.class"]]),r("interface.defaultLibrary",[["support.class"]]),r("variable.defaultLibrary",[["support.variable"],["support.other.variable"]]),r("variable.defaultLibrary.readonly",[["support.constant"]]),r("property.defaultLibrary",[["support.variable.property"]]),r("property.defaultLibrary.readonly",[["support.constant.property"]]),r("function.defaultLibrary",[["support.function"]]),r("member.defaultLibrary",[["support.function"]]),a}function g(){return c}e.getTokenClassificationRegistry=g;function D(a,l){return{description:a,deprecationMessage:l,defaultSnippets:[{body:"${1:#ff0000}"}],anyOf:[{type:"string",format:"color-hex"},{$ref:"#definitions/style"}]}}e.tokenStylingSchemaId="vscode://schemas/token-styling";let w=T.Registry.as(t.Extensions.JSONContribution);w.registerSchema(e.tokenStylingSchemaId,c.getTokenStylingSchema());const v=new S.RunOnceScheduler(()=>w.notifySchemaChanged(e.tokenStylingSchemaId),200);c.onDidChangeSchema(()=>{v.isScheduled()||v.schedule()})}),define(ue[51],de([0,1,7]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,S.createDecorator)("IUriIdentityService")}),define(ue[235],de([0,1,6,3,5,28,34,15,16,51]),function(Y,e,S,k,p,P,t,T,h,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;let C=class extends k.Disposable{constructor(m,u,c,b,g){super();this.extensionsManagementService=m,this.logService=b,this.uriIdentityService=g,this._onDidChangeExtensionsByAnotherSource=this._register(new S.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled(1).then(w=>{this.installedExtensions=w.map(v=>v.identifier),this.startTimestamp=Date.now()}),this._register(m.onInstallExtension(w=>this.onInstallExtension(w))),this._register(m.onDidInstallExtensions(w=>this.onDidInstallExtensions(w))),this._register(m.onDidUninstallExtension(w=>this.onDidUninstallExtension(w)));const D=p.URI.file(c.extensionsPath);this._register(u.watch(D)),this._register(S.Event.filter(u.onDidChangeFilesRaw,w=>w.changes.some(v=>this.doesChangeAffects(v,D)))(()=>this.onDidChange()))}doesChangeAffects(m,u){return this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(m.resource),u)?this.uriIdentityService.extUri.isEqual(m.resource,this.uriIdentityService.extUri.joinPath(u,".obsolete"))?!0:!(m.type!==1&&m.type!==2||this.uriIdentityService.extUri.basename(m.resource).startsWith(".")):!1}onInstallExtension(m){this.addInstallingExtension(m.identifier)}onDidInstallExtensions(m){for(const u of m)this.removeInstallingExtension(u.identifier),u.local&&this.addInstalledExtension(u.identifier)}onDidUninstallExtension(m){m.error||this.removeInstalledExtension(m.identifier)}addInstallingExtension(m){this.removeInstallingExtension(m),this.installingExtensions.push(m)}removeInstallingExtension(m){this.installingExtensions=this.installingExtensions.filter(u=>!(0,t.areSameExtensions)(u,m))}addInstalledExtension(m){this.installedExtensions&&(this.removeInstalledExtension(m),this.installedExtensions.push(m))}removeInstalledExtension(m){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(u=>!(0,t.areSameExtensions)(u,m)))}async onDidChange(){if(this.installedExtensions){const m=await this.extensionsManagementService.getInstalled(1),u=m.filter(b=>[...this.installingExtensions,...this.installedExtensions].some(g=>(0,t.areSameExtensions)(g,b.identifier))?!1:b.installedTimestamp&&b.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",b.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",b.identifier.id),!1)),c=this.installedExtensions.filter(b=>this.installingExtensions.some(g=>(0,t.areSameExtensions)(g,b))?!1:m.every(g=>!(0,t.areSameExtensions)(g.identifier,b))?(this.logService.info("Detected extension removed from another source",b.id),!0):!1);this.installedExtensions=m.map(b=>b.identifier),(u.length||c.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:u,removed:c})}}};C=Ne([je(1,T.IFileService),je(2,P.INativeEnvironmentService),je(3,h.ILogService),je(4,f.IUriIdentityService)],C),e.ExtensionsWatcher=C}),define(ue[112],de([0,1,51,196,15,19,134,6,3]),function(Y,e,S,k,p,P,t,T,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class f{constructor(m){this.uri=m,this.time=f._clock++}touch(){return this.time=f._clock++,this}}f._clock=0;let C=class{constructor(m){this._fileService=m,this._dispooables=new h.DisposableStore,this._limit=2**16;const u=new Map,c=b=>{let g=u.get(b.scheme);return g===void 0&&(g=m.hasProvider(b)&&!this._fileService.hasCapability(b,1024),u.set(b.scheme,g)),g};this._dispooables.add(T.Event.any(m.onDidChangeFileSystemProviderRegistrations,m.onDidChangeFileSystemProviderCapabilities)(b=>{u.delete(b.scheme)})),this.extUri=new P.ExtUri(c),this._canonicalUris=new t.SkipList((b,g)=>this.extUri.compare(b,g,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(m){this._fileService.hasProvider(m)&&(m=(0,P.normalizePath)(m));let u=this._canonicalUris.get(m);return u?u.touch().uri.with({fragment:m.fragment}):(this._canonicalUris.set(m,new f(m)),this._checkTrim(),m)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const m=[...this._canonicalUris.entries()].sort((c,b)=>c[1].touch<b[1].touch?1:c[1].touch>b[1].touch?-1:0);f._clock=0,this._canonicalUris.clear();const u=this._limit*.5;for(let c=0;c<u;c++)this._canonicalUris.set(m[c][0],m[c][1].touch())}};C=Ne([je(0,p.IFileService)],C),e.UriIdentityService=C,(0,k.registerSingleton)(S.IUriIdentityService,C,!0)}),define(ue[113],de([0,1,30,19,5,7]),function(Y,e,S,k,p,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,P.createDecorator)("contextService");var t;(function(m){m[m.EMPTY=1]="EMPTY",m[m.FOLDER=2]="FOLDER",m[m.WORKSPACE=3]="WORKSPACE"})(t=e.WorkbenchState||(e.WorkbenchState={}));function T(m){const u=m;return!!(u&&typeof u=="object"&&typeof u.id=="string"&&Array.isArray(u.folders))}e.isWorkspace=T;function h(m){const u=m;return!!(u&&typeof u=="object"&&p.URI.isUri(u.uri)&&typeof u.name=="string"&&typeof u.toResource=="function")}e.isWorkspaceFolder=h;class f{constructor(u,c,b,g,D){this._id=u,this._transient=b,this._configuration=g,this._ignorePathCasing=D,this._foldersMap=S.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=c}update(u){this._id=u.id,this._configuration=u.configuration,this._transient=u.transient,this._ignorePathCasing=u._ignorePathCasing,this.folders=u.folders}get folders(){return this._folders}set folders(u){this._folders=u,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(u){this._configuration=u}getFolder(u){return u&&this._foldersMap.findSubstr(u.with({scheme:u.scheme,authority:u.authority,path:u.path}))||null}updateFoldersMap(){this._foldersMap=S.TernarySearchTree.forUris(this._ignorePathCasing);for(const u of this.folders)this._foldersMap.set(u.uri,u)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=f;class C{constructor(u,c){this.raw=c,this.uri=u.uri,this.index=u.index,this.name=u.name}toResource(u){return(0,k.joinPath)(this.uri,u)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=C;function I(m){return new C({uri:m,index:0,name:(0,k.basenameOrAuthority)(m)},{uri:m.toString()})}e.toWorkspaceFolder=I}),define(ue[236],de([0,1,31,36,131,64,10,4,2,19,5,178,7,106,113]),function(Y,e,S,k,p,P,t,T,h,f,C,I,m,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const b=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,I.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function g(F){return(typeof F=="string"?(0,T.extname)(F):(0,f.extname)(F))===b}e.hasWorkspaceFileExtension=g,e.IWorkspacesService=(0,m.createDecorator)("workspacesService");function D(F){return F.hasOwnProperty("workspace")}e.isRecentWorkspace=D;function w(F){return F.hasOwnProperty("folderUri")}e.isRecentFolder=w;function v(F){return F.hasOwnProperty("fileUri")}e.isRecentFile=v;function a(F){const M=F;return typeof M?.id=="string"&&C.URI.isUri(M.uri)}e.isSingleFolderWorkspaceIdentifier=a;function l(F){if(F.configuration)return{id:F.id,configPath:F.configuration};if(F.folders.length===1)return{id:F.id,uri:F.folders[0].uri}}e.toWorkspaceIdentifier=l;function r(F){const M=F;return typeof M?.id=="string"&&C.URI.isUri(M.configPath)}e.isWorkspaceIdentifier=r;function o(F){const M=F;if(M?.uri)return{id:M.id,uri:C.URI.revive(M.uri)};const V=F;if(V?.configPath)return{id:V.id,configPath:C.URI.revive(V.configPath)};if(F?.id)return{id:F.id}}e.reviveIdentifier=o;function i(F,M){return f.extUriBiasedIgnorePathCase.isEqualOrParent(F,M.untitledWorkspacesHome)}e.isUntitledWorkspace=i;function n(F){return s(F)||d(F)}e.isStoredWorkspaceFolder=n;function s(F){const M=F;return typeof M?.path=="string"&&(!M.name||typeof M.name=="string")}e.isRawFileWorkspaceFolder=s;function d(F){const M=F;return typeof M?.uri=="string"&&(!M.name||typeof M.name=="string")}e.isRawUriWorkspaceFolder=d;function y(F,M,V,ee,G=!h.isWindows,H){if(F.scheme!==ee.scheme)return{name:V,uri:F.toString(!0)};let q=M?void 0:H.relativePath(ee,F);if(q!==void 0)q.length===0?q=".":h.isWindows&&F.scheme===t.Schemas.file&&!G&&(q=q.replace(/\//g,"\\"));else if(F.scheme===t.Schemas.file)q=F.fsPath,h.isWindows&&(q=(0,P.normalizeDriveLetter)(q),G&&(q=(0,S.toSlashes)(q)));else{if(!H.isEqualAuthority(F.authority,ee.authority))return{name:V,uri:F.toString(!0)};q=F.path}return{name:V,path:q}}e.getStoredWorkspaceFolder=y;function A(F,M,V){let ee=[],G=new Set;const H=V.dirname(M);for(let q of F){let z;if(s(q))q.path&&(z=V.resolvePath(H,q.path));else if(d(q))try{z=C.URI.parse(q.uri),z.path[0]!=="/"&&(z=z.with({path:"/"+z.path}))}catch(B){console.warn(B)}if(z){let B=V.getComparisonKey(z);if(!G.has(B)){G.add(B);const W=q.name||V.basenameOrAuthority(z);ee.push(new c.WorkspaceFolder({uri:z,name:W,index:ee.length},q))}}}return ee}e.toWorkspaceFolders=A;function E(F,M,V,ee,G){let H=R(M,F);const q=G.dirname(M),z=G.dirname(ee),B=[],W=O(H.folders);for(const se of H.folders){const ae=s(se)?G.resolvePath(q,se.path):C.URI.parse(se.uri);let ke;V?ke=!1:ke=!s(se)||(0,T.isAbsolute)(se.path),B.push(y(ae,ke,se.name,z,W,G))}const ie={insertSpaces:!1,tabSize:4,eol:h.isLinux||h.isMacintosh?`
`:`\r
`},oe=p.setProperty(F,["folders"],B,ie);let we=p.applyEdits(F,oe);return(0,f.isEqualAuthority)(H.remoteAuthority,(0,u.getRemoteAuthority)(ee))&&(we=p.applyEdits(we,p.removeProperty(we,["remoteAuthority"],ie))),we}e.rewriteWorkspaceFileForNewLocation=E;function R(F,M){let V=k.parse(M);if(V&&Array.isArray(V.folders))V.folders=V.folders.filter(ee=>n(ee));else throw new Error(`${F} looks like an invalid workspace file.`);return V}function O(F){return h.isWindows?F.some(M=>s(M)&&M.path.indexOf("/")>=0):!0}e.useSlashForPath=O;function K(F){return F.workspace&&typeof F.workspace=="object"&&typeof F.workspace.id=="string"&&typeof F.workspace.configPath=="string"}function te(F){return typeof F.folderUri=="string"}function j(F){return typeof F.fileUri=="string"}function _(F,M){const V={workspaces:[],files:[]};if(F){const ee=function(H,q){for(let z=0;z<H.length;z++)try{q(H[z],z)}catch(B){M.warn(`Error restoring recent entry ${JSON.stringify(H[z])}: ${B.toString()}. Skip entry.`)}},G=F;if(Array.isArray(G.entries))ee(G.entries,H=>{const q=H.label,z=H.remoteAuthority;K(H)?V.workspaces.push({label:q,remoteAuthority:z,workspace:{id:H.workspace.id,configPath:C.URI.parse(H.workspace.configPath)}}):te(H)?V.workspaces.push({label:q,remoteAuthority:z,folderUri:C.URI.parse(H.folderUri)}):j(H)&&V.files.push({label:q,remoteAuthority:z,fileUri:C.URI.parse(H.fileUri)})});else{const H=F;Array.isArray(H.workspaces3)&&ee(H.workspaces3,(q,z)=>{const B=Array.isArray(H.workspaceLabels)&&H.workspaceLabels[z]||void 0;typeof q=="object"&&typeof q.id=="string"&&typeof q.configURIPath=="string"?V.workspaces.push({label:B,workspace:{id:q.id,configPath:C.URI.parse(q.configURIPath)}}):typeof q=="string"&&V.workspaces.push({label:B,folderUri:C.URI.parse(q)})}),Array.isArray(H.files2)&&ee(H.files2,(q,z)=>{const B=Array.isArray(H.fileLabels)&&H.fileLabels[z]||void 0;typeof q=="string"&&V.files.push({label:B,fileUri:C.URI.parse(q)})})}}return V}e.restoreRecentlyOpened=_;function U(F){const M={entries:[]};for(const V of F.workspaces)w(V)?M.entries.push({folderUri:V.folderUri.toString(),label:V.label,remoteAuthority:V.remoteAuthority}):M.entries.push({workspace:{id:V.workspace.id,configPath:V.workspace.configPath.toString()},label:V.label,remoteAuthority:V.remoteAuthority});for(const V of F.files)M.entries.push({fileUri:V.fileUri.toString(),label:V.label,remoteAuthority:V.remoteAuthority});return M}e.toStoreData=U}),define(ue[237],de([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getOriginalUrl=e.relativePath=e.relativeRoot=e.normalize=e.HTTPNotFoundError=e.ICON_SIZES=void 0,e.ICON_SIZES=[192,512];class S extends Error{constructor(f,C){super(f);this.code=C}}class k extends S{constructor(f){super(f,404)}}e.HTTPNotFoundError=k;const p=(h,f=!1)=>h.replace(/\/\/+/g,"/").replace(/\/+$/,f?"/":"");e.normalize=p;const P=h=>{const f=(h.split("?",1)[0].match(/\//g)||[]).length;return(0,e.normalize)("./"+(f>1?"../".repeat(f-1):""))};e.relativeRoot=P;const t=h=>{const f=h.split("?",1)[0].split("/");return(0,e.normalize)("./"+f[f.length-1])};e.relativePath=t;const T=h=>h.originalUrl||h.url;e.getOriginalUrl=T}),define(ue[238],de([0,1,6,13]),function(Y,e,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ManagementConnection=e.printTime=void 0;function p(t){let T=0,h=0,f=0;t>=1e3&&(f=Math.floor(t/1e3),t-=f*1e3),f>=60&&(h=Math.floor(f/60),f-=h*60),h>=60&&(T=Math.floor(h/60),h-=T*60);const C=T?`${T}h`:"",I=h?`${h}m`:"",m=f?`${f}s`:"",u=t?`${t}ms`:"";return`${C}${I}${m}${u}`}e.printTime=p;class P{constructor(T,h,f,C){this._logService=T,this._reconnectionToken=h,this._onClose=new S.Emitter,this.onClose=this._onClose.event,this._reconnectionGraceTime=108e5,this._reconnectionShortGraceTime=3e5,this._remoteAddress=f,this.protocol=C,this._disposed=!1,this._disconnectRunner1=new k.ProcessTimeRunOnceScheduler(()=>{this._log(`The reconnection grace time of ${p(this._reconnectionGraceTime)} has expired, so the connection will be disposed.`),this._cleanResources()},this._reconnectionGraceTime),this._disconnectRunner2=new k.ProcessTimeRunOnceScheduler(()=>{this._log(`The reconnection short grace time of ${p(this._reconnectionShortGraceTime)} has expired, so the connection will be disposed.`),this._cleanResources()},this._reconnectionShortGraceTime),this.protocol.onDidDispose(()=>{this._log("The client has disconnected gracefully, so the connection will be disposed."),this._cleanResources()}),this.protocol.onSocketClose(()=>{this._log(`The client has disconnected, will wait for reconnection ${p(this._reconnectionGraceTime)} before disposing...`),this._disconnectRunner1.schedule()}),this._log("New connection established.")}_log(T){this._logService.info(`[${this._remoteAddress}][${this._reconnectionToken.substr(0,8)}][ManagementConnection] ${T}`)}shortenReconnectionGraceTimeIfNecessary(){this._disconnectRunner2.isScheduled()||this._disconnectRunner1.isScheduled()&&(this._log(`Another client has connected, will shorten the wait for reconnection ${p(this._reconnectionShortGraceTime)} before disposing...`),this._disconnectRunner2.schedule())}_cleanResources(){if(this._disposed)return;this._disposed=!0,this._disconnectRunner1.dispose(),this._disconnectRunner2.dispose();const T=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),T.end(),this._onClose.fire(void 0)}acceptReconnection(T,h,f){this._remoteAddress=T,this._log("The client has reconnected."),this._disconnectRunner1.cancel(),this._disconnectRunner2.cancel(),this.protocol.beginAcceptReconnection(h,f),this.protocol.endAcceptReconnection()}}e.ManagementConnection=P}),define(ue[81],de([0,1,32,10,4,140,58]),function(Y,e,S,k,p,P,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLocaleFromConfig=e.InternalNLSConfiguration=e.getNLSConfiguration=void 0;const T=p.join(k.FileAccess.asFileUri("",Y).fsPath,"nls.metadata.json"),h=new Map;function f(c){return new Promise(b=>S.exists(c,b))}function C(c,b){return f(T).then(g=>{if(!g||!t.default.commit)return Promise.resolve({locale:"en",availableLanguages:{}});let D=`${c}||${b}`,w=h.get(D);return w||(w=P.getNLSConfiguration(t.default.commit,b,T,c).then(v=>(I.is(v)&&(v._languagePackSupport=!0),v.locale!=="en"&&v.locale!=="en-us"&&Object.keys(v.availableLanguages).length===0&&h.delete(D),v)),h.set(D,w)),w})}e.getNLSConfiguration=C;var I;(function(c){function b(g){let D=g;return D&&typeof D._languagePackId=="string"}c.is=b})(I=e.InternalNLSConfiguration||(e.InternalNLSConfiguration={}));const m=async c=>{try{const b=u(await S.promises.readFile(c.fsPath,"utf8"));return JSON.parse(b).locale}catch(b){return b.code!=="ENOENT"&&console.warn(b),"en"}};e.getLocaleFromConfig=m;const u=c=>{const b=/('(?:[^\\']*(?:\\.)?)*')|('(?:[^\\']*(?:\\.)?)*')|(\/\*(?:\r?\n|.)*?\*\/)|(\/{2,}.*?(?:(?:\r?\n)|$))/g;return c.replace(b,(g,D,w,v,a)=>{if(v)return"";if(a){const l=a.length;return l>2&&a[l-1]===`
`?a[l-2]==="\r"?`\r
`:`
`:""}else return g})}}),define(ue[239],de([0,1,27,7,33,225,39]),function(Y,e,S,k,p,P,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteTelemetryService=e.RemoteNullTelemetryService=e.RemoteTelemetryService=void 0;let T=class extends P.TelemetryService{constructor(f,C){super(f,C);this._isDisabled=!1}publicLog(f,C,I){return this._isDisabled?Promise.resolve(void 0):super.publicLog(f,C,I)}publicLog2(f,C,I){return this._isDisabled?Promise.resolve(void 0):super.publicLog2(f,C,I)}publicLogError(f,C){return this._isDisabled?Promise.resolve(void 0):super.publicLogError(f,C)}publicLogError2(f,C){return this._isDisabled?Promise.resolve(void 0):super.publicLogError2(f,C)}permanentlyDisableTelemetry(){this._isDisabled=!0,this.dispose()}};T=Ne([je(1,S.IConfigurationService)],T),e.RemoteTelemetryService=T,e.RemoteNullTelemetryService=new class extends t.NullTelemetryServiceShape{permanentlyDisableTelemetry(){}},e.IRemoteTelemetryService=(0,k.refineServiceDecorator)(p.ITelemetryService)}),define(ue[45],de([0,1,66,10]),function(Y,e,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createRemoteURITransformer=e.uriTransformerPath=void 0,e.uriTransformerPath=k.FileAccess.asFileUri("vs/server/uriTransformer.js",Y).fsPath;function p(P){const T=Y.__$__nodeRequire(e.uriTransformerPath)(P);return new S.URITransformer(T)}e.createRemoteURITransformer=p}),define(ue[240],de([0,1,6,3,5,45,76,4,195]),function(Y,e,S,k,p,P,t,T,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAgentFileSystemProviderChannel=void 0;class f extends h.AbstractDiskFileSystemProviderChannel{constructor(m,u){super(new t.DiskFileSystemProvider(m),m);this.environmentService=u,this.uriTransformerCache=new Map,this._register(this.provider)}getUriTransformer(m){let u=this.uriTransformerCache.get(m.remoteAuthority);return u||(u=(0,P.createRemoteURITransformer)(m.remoteAuthority),this.uriTransformerCache.set(m.remoteAuthority,u)),u}transformIncoming(m,u,c=!1){if(c&&u.path==="/vscode-resource"&&u.query){const b=JSON.parse(u.query).requestResourcePath;return p.URI.from({scheme:"file",path:b})}return p.URI.revive(m.transformIncoming(u))}createSessionFileWatcher(m,u){return new C(m,u,this.logService,this.environmentService)}}e.RemoteAgentFileSystemProviderChannel=f;class C extends k.Disposable{constructor(m,u,c,b){super();this.uriTransformer=m,this.logService=c,this.environmentService=b,this.watcherRequests=new Map,this.fileWatcher=this._register(new t.DiskFileSystemProvider(this.logService,{watcher:this.getWatcherOptions()})),this.registerListeners(u)}registerListeners(m){const u=this._register(new S.Emitter);this._register(u.event(c=>{m.fire(c.map(b=>({resource:this.uriTransformer.transformOutgoingURI(b.resource),type:b.type})))})),this._register(this.fileWatcher.onDidChangeFile(c=>u.fire(c))),this._register(this.fileWatcher.onDidErrorOccur(c=>m.fire(c)))}getWatcherOptions(){const m=this.environmentService.args.fileWatcherPolling;if(m){const u=m.split(T.delimiter),c=Number(u[0]);if(c>0)return{usePolling:u.length>1?u.slice(1):!0,pollingInterval:c}}}watch(m,u,c){return this.environmentService.extensionsPath&&(c.excludes=[...c.excludes||[],T.posix.join(this.environmentService.extensionsPath,"**")]),this.watcherRequests.set(m,this.fileWatcher.watch(u,c)),(0,k.toDisposable)(()=>{(0,k.dispose)(this.watcherRequests.get(m)),this.watcherRequests.delete(m)})}dispose(){super.dispose(),this.watcherRequests.forEach(m=>(0,k.dispose)(m)),this.watcherRequests.clear()}}}),define(ue[82],de([0,1,180,193,55,7,28,52,10,128]),function(Y,e,S,k,p,P,t,T,h,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServerEnvironmentService=e.IServerEnvironmentService=e.serverOptions=void 0,e.serverOptions={auth:{type:"string"},locale:{type:"string"},port:{type:"string"},"pick-port":{type:"string"},connectionToken:{type:"string"},"connection-token":{type:"string",description:S.localize(0,null)},"connection-secret":{type:"string",description:S.localize(1,null)},host:{type:"string"},"socket-path":{type:"string"},driver:{type:"string"},"start-server":{type:"boolean"},"print-startup-performance":{type:"boolean"},"print-ip-address":{type:"boolean"},"disable-websocket-compression":{type:"boolean"},fileWatcherPolling:{type:"string"},"enable-remote-auto-shutdown":{type:"boolean"},"remote-auto-shutdown-without-delay":{type:"boolean"},"without-browser-env-var":{type:"boolean"},"disable-telemetry":p.OPTIONS["disable-telemetry"],"extensions-dir":p.OPTIONS["extensions-dir"],"extensions-download-dir":p.OPTIONS["extensions-download-dir"],"install-extension":p.OPTIONS["install-extension"],"install-builtin-extension":p.OPTIONS["install-builtin-extension"],"uninstall-extension":p.OPTIONS["uninstall-extension"],"locate-extension":p.OPTIONS["locate-extension"],"list-extensions":p.OPTIONS["list-extensions"],force:p.OPTIONS.force,"show-versions":p.OPTIONS["show-versions"],category:p.OPTIONS.category,"do-not-sync":p.OPTIONS["do-not-sync"],"force-disable-user-env":p.OPTIONS["force-disable-user-env"],folder:{type:"string"},workspace:{type:"string"},"web-user-data-dir":{type:"string"},"use-host-proxy":{type:"string"},"enable-sync":{type:"boolean"},"github-auth":{type:"string"},log:{type:"string"},logsPath:{type:"string"},help:p.OPTIONS.help,version:p.OPTIONS.version,"accept-server-license-terms":{type:"boolean"},_:p.OPTIONS._},e.IServerEnvironmentService=(0,P.refineServiceDecorator)(t.IEnvironmentService);class C extends k.NativeEnvironmentService{get args(){return super.args}get auth(){return this.args.auth||f.AuthType.None}get serviceWorkerFileName(){return"service-worker.js"}get serviceWorkerPath(){return h.FileAccess.asFileUri(`vs/code/browser/workbench/${this.serviceWorkerFileName}`,Y).fsPath}get proxyUri(){return"/proxy/{port}"}}Ne([T.memoize],C.prototype,"serviceWorkerPath",null),e.ServerEnvironmentService=C}),define(ue[241],de([0,1,32,78,142,282,77,31,65,2,5,45,81,4,10,25,23,44,237]),function(Y,e,S,k,p,P,t,T,h,f,C,I,m,u,c,b,g,D,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebClientServer=e.serveFile=void 0;const v={".html":"text/html",".js":"text/javascript",".json":"application/json",".css":"text/css",".svg":"image/svg+xml"};async function a(o,i,n,s,d=Object.create(null)){try{const y=await p.promisify(S.stat)(s),A=`W/"${[y.ino,y.size,y.mtime.getTime()].join("-")}"`;if(i.headers["if-none-match"]===A)return n.writeHead(304),n.end();d["Content-Type"]=v[(0,u.extname)(s)]||(0,h.getMediaMime)(s)||"text/plain",d.Etag=A,n.writeHead(200,d),S.createReadStream(s).pipe(n)}catch(y){return y.code!=="ENOENT"&&(o.error(y),console.error(y.toString())),n.writeHead(404,{"Content-Type":"text/plain"}),n.end("Not found")}}e.serveFile=a;const l=(0,u.dirname)(c.FileAccess.asFileUri("",Y).fsPath);class r{constructor(i,n,s,d,y){this._connectionToken=i,this._environmentService=n,this._logService=s,this._themeService=d,this._productService=y,this._mapCallbackUriToRequestId=new Map,this._iconSizes=[192,512],this.serveError=async(A,E,R,O,K)=>{const{applicationName:te,commit:j="development",version:_}=this._productService;if(E.statusCode=R,E.statusMessage=O,K&&(this._logService.debug(`[${K.toString()}] ${R}: ${O}`),K.pathname?.endsWith(".json"))){E.setHeader("Content-Type","application/json"),E.end(JSON.stringify({code:R,message:O,commit:j}));return}const U=await this.fetchClientTheme();E.setHeader("Content-Type","text/html");const F=c.FileAccess.asFileUri("vs/code/browser/workbench/workbench-error.html",Y).fsPath,M=(await p.promisify(S.readFile)(F)).toString().replace(/{{ERROR_HEADER}}/g,()=>`${te}`).replace(/{{ERROR_CODE}}/g,()=>R.toString()).replace(/{{ERROR_MESSAGE}}/g,()=>O).replace(/{{ERROR_FOOTER}}/g,()=>`${_} - ${j}`).replace(/{{CLIENT_BACKGROUND_COLOR}}/g,()=>U.backgroundColor).replace(/{{CLIENT_FOREGROUND_COLOR}}/g,()=>U.foregroundColor).replace(/{{BASE}}/g,()=>(0,w.relativePath)((0,w.getOriginalUrl)(A)));E.end(M)}}async handle(i,n,s){try{const d=s.pathname;if(d==="/manifest.json"||d==="/webmanifest.json")return this._handleManifest(i,n,s);if(d==="/favicon.ico"||d==="/manifest.json"||d==="/code-192.png"||d==="/code-512.png")return a(this._logService,i,n,(0,u.join)(l,"resources","server",d.substr(1)));if(/^\/webview\//.test(d))return this._handleWebview(i,n,s);if(/^\/static\//.test(d))return this._handleStatic(i,n,s);if(d==="/"+this._environmentService.serviceWorkerFileName)return a(this._logService,i,n,this._environmentService.serviceWorkerPath);if(d==="/")return this._handleRoot(i,n,s);if(d==="/callback")return this._handleCallback(i,n,s);if(d==="/fetch-callback")return this._handleFetchCallback(i,n,s);const y=new w.HTTPNotFoundError(`"${s.pathname}" not found.`);i.emit("error",y);return}catch(d){return console.log("VS CODE ERRORED"),this._logService.error(d),console.error(d.toString()),this.serveError(i,n,500,"Internal Server Error.",s)}}async fetchClientTheme(){await this._themeService.readyPromise;const i=await this._themeService.fetchColorThemeData();return{backgroundColor:i.getColor(D.editorBackground,!0).toString(),foregroundColor:i.getColor(D.editorForeground,!0).toString()}}async _handleManifest(i,n,s){const d=await this.fetchClientTheme(),y={name:this._productService.nameLong,short_name:this._productService.nameShort,start_url:".",display:"fullscreen","background-color":d.backgroundColor,description:"Run editors on a remote server.",icons:this._iconSizes.map(A=>({src:`./static/resources/server/code-${A}.png`,type:"image/png",sizes:`${A}x${A}`}))};return n.writeHead(200,{"Content-Type":"application/manifest+json"}),n.end(JSON.stringify(y,null,2))}async _handleStatic(i,n,s){const d=Object.create(null),y=decodeURIComponent(s.pathname),A=(0,u.normalize)(y.substr("/static/".length)),E=(0,u.join)(l,A);return(0,T.isEqualOrParent)(E,l,!f.isLinux)?a(this._logService,i,n,E,d):this.serveError(i,n,400,"Bad request.",s)}async _handleWebview(i,n,s){const d=Object.create(null),y=decodeURIComponent(s.pathname),A=(0,u.normalize)(y.split("/").splice(3).join("/")),E=(0,u.join)(l,"out/vs/workbench/contrib/webview/browser/pre",A);return(0,T.isEqualOrParent)(E,l,!f.isLinux)?a(this._logService,i,n,E,d):this.serveError(i,n,400,"Bad request.",s)}async _handleRoot(i,n,s){if(!i.headers.host)return this.serveError(i,n,400,"Bad request.",s);const{backgroundColor:d,foregroundColor:y}=await this.fetchClientTheme(),A=s.query.tkn;if(typeof A=="string"){const q=Object.create(null);q["Set-Cookie"]=P.serialize("vscode-tkn",A,{sameSite:"strict",maxAge:60*60*24*7});const z=Object.create(null);for(let W in s.query)W!=="tkn"&&(z[W]=s.query[W]);const B=k.format({pathname:"/",query:z});return q.Location=B,n.writeHead(302,q),n.end()}const E="remote",R=(0,I.createRemoteURITransformer)(E),{workspacePath:O,isFolder:K}=await this._getWorkspaceFromCLI();function te(q){return q.replace(/"/g,"&quot;")}let j;this._environmentService.driverHandle&&(j=!1);const _=c.FileAccess.asFileUri(this._environmentService.isBuilt?"vs/code/browser/workbench/workbench.html":"vs/code/browser/workbench/workbench-dev.html",Y).fsPath,U=!this._environmentService.isBuilt&&this._environmentService.args["github-auth"]?{id:(0,b.generateUuid)(),providerId:"github",accessToken:this._environmentService.args["github-auth"],scopes:[["user:email"],["repo"]]}:void 0,F=this._environmentService.args.locale||await(0,m.getLocaleFromConfig)(this._environmentService.argvResource),M=await(0,m.getNLSConfiguration)(F,this._environmentService.userDataPath),V=(0,w.relativeRoot)((0,w.getOriginalUrl)(i)),ee=(0,w.relativePath)((0,w.getOriginalUrl)(i)),G=(await p.promisify(S.readFile)(_)).toString().replace("{{WORKBENCH_WEB_CONFIGURATION}}",te(JSON.stringify({productConfiguration:{...this._productService,auth:this._environmentService.auth,serviceWorker:{scope:ee+"/",url:ee+"/"+this._environmentService.serviceWorkerFileName},base:V,logoutEndpointUrl:V+"/logout",proxyEndpointUrlTemplate:V+"/proxy/{port}",webEndpointUrl:ee+"/static",webEndpointUrlTemplate:ee+"/static",webviewContentExternalBaseUrlTemplate:ee+"/webview/{{uuid}}/",updateUrl:V+"/update/check"},folderUri:O&&K?R.transformOutgoing(C.URI.file(O)):void 0,workspaceUri:O&&!K?R.transformOutgoing(C.URI.file(O)):void 0,remoteAuthority:E,_wrapWebWorkerExtHostInIframe:j,developmentOptions:{enableSmokeTestDriver:this._environmentService.driverHandle==="web"?!0:void 0,logLevel:this._logService.getLevel()},userDataPath:this._environmentService.userDataPath,settingsSyncOptions:!this._environmentService.isBuilt&&this._environmentService.args["enable-sync"]?{enabled:!0}:void 0}))).replace(/{{NLS_CONFIGURATION}}/g,()=>te(JSON.stringify(M))).replace(/{{CLIENT_BACKGROUND_COLOR}}/g,()=>d).replace(/{{CLIENT_FOREGROUND_COLOR}}/g,()=>y).replace("{{WORKBENCH_AUTH_SESSION}}",()=>U?te(JSON.stringify(U)):"").replace(/{{BASE}}/g,()=>ee),H=["default-src 'self';","img-src 'self' https: data: blob:;","media-src 'none';",`script-src 'self' 'unsafe-eval' ${this._getScriptCspHashes(G).join(" ")} 'sha256-cb2sg39EJV8ABaSNFfWu/ou8o1xVXYK7jp90oZ9vpcg=';`,"child-src 'self';",`frame-src 'self' ${this._productService.webEndpointUrl||""} data:;`,"worker-src 'self' data:;","style-src 'self' 'unsafe-inline';","connect-src 'self' ws: wss: https:;","font-src 'self' blob:;","manifest-src 'self' https://cloud.coder.com https://github.com;"].join(" ");return n.writeHead(200,{"Content-Type":"text/html","Set-Cookie":P.serialize("vscode-tkn",this._connectionToken,{sameSite:"strict",maxAge:60*60*24*7}),"Content-Security-Policy":H}),n.end(G)}_getScriptCspHashes(i){const n=/<script>([\s\S]+?)<\/script>/img,s=[];let d;for(;d=n.exec(i);){const y=t.createHash("sha256"),A=d[1].replace(/\r\n/g,`
`),E=y.update(Buffer.from(A)).digest().toString("base64");s.push(`'sha256-${E}'`)}return s}async _getWorkspaceFromCLI(){const i=this._environmentService.args.workspace;if(i&&i.length>0){const s=(0,T.sanitizeFilePath)(i,(0,g.cwd)());if(await p.promisify(S.exists)(s))return{workspacePath:s}}const n=this._environmentService.args.folder;if(n&&n.length>0){const s=(0,T.sanitizeFilePath)(n,(0,g.cwd)());if(await p.promisify(S.exists)(s))return{workspacePath:s,isFolder:!0}}return{}}_getFirstQueryValue(i,n){const s=i.query[n];return Array.isArray(s)?s[0]:s}_getFirstQueryValues(i,n){const s=new Map;for(const d in i.query){if(n&&n.indexOf(d)>=0)continue;const y=this._getFirstQueryValue(i,d);typeof y=="string"&&s.set(d,y)}return s}async _handleCallback(i,n,s){const d=["vscode-requestId","vscode-scheme","vscode-authority","vscode-path","vscode-query","vscode-fragment"],[y,A,E,R,O,K]=d.map(_=>{const U=this._getFirstQueryValue(s,_);return U&&decodeURIComponent(U)});if(!y)return n.writeHead(400,{"Content-Type":"text/plain"}),n.end("Bad request.");let te=O,j=0;return this._getFirstQueryValues(s,d).forEach((_,U)=>{te||(te=""),te+=`${j++==0?"":"&"}${U}=${_}`}),this._mapCallbackUriToRequestId.set(y,C.URI.from({scheme:A||this._productService.urlProtocol,authority:E,path:R,query:te,fragment:K}).toJSON()),a(this._logService,i,n,c.FileAccess.asFileUri("vs/code/browser/workbench/callback.html",Y).fsPath,{"Content-Type":"text/html"})}async _handleFetchCallback(i,n,s){const d=this._getFirstQueryValue(s,"vscode-requestId");if(!d)return n.writeHead(400,{"Content-Type":"text/plain"}),n.end("Bad request.");const y=this._mapCallbackUriToRequestId.get(d);return y&&this._mapCallbackUriToRequestId.delete(d),n.writeHead(200,{"Content-Type":"text/json"}),n.end(JSON.stringify(y))}}e.WebClientServer=r}),define(ue[242],de([0,1,7]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,S.createDecorator)("IExtHostRpcService");class k{constructor(P){this.getProxy=P.getProxy.bind(P),this.set=P.set.bind(P),this.assertRegistered=P.assertRegistered.bind(P),this.drain=P.drain.bind(P)}}e.ExtHostRpcService=k}),define(ue[114],de([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestItemRootImpl=e.TestItemImpl=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.diffTestItems=e.getPrivateApiFor=e.createPrivateApiFor=e.ExtHostTestItemEventOp=void 0;var S;(function(w){w[w.Upsert=0]="Upsert",w[w.RemoveChild=1]="RemoveChild",w[w.Invalidated=2]="Invalidated",w[w.SetProp=3]="SetProp",w[w.Bulk=4]="Bulk"})(S=e.ExtHostTestItemEventOp||(e.ExtHostTestItemEventOp={}));const k=new WeakMap,p=(w,v)=>{const a={controllerId:v};return k.set(w,a),a};e.createPrivateApiFor=p;const P=w=>k.get(w);e.getPrivateApiFor=P;const t=(w,v,a,l)=>{let r=a;return{enumerable:!0,configurable:!1,get(){return r},set(o){if(!l(r,o)){const i=r;r=o,w.listener?.({op:3,key:v,value:o,previous:i})}}}},T=(w,v)=>w===v,h={range:(w,v)=>w===v?!0:!w||!v?!1:w.isEqual(v),label:T,description:T,busy:T,error:T,canResolveChildren:T,tags:(w,v)=>!(w.length!==v.length||w.some(a=>!v.find(l=>a.id===l.id)))},f=Object.keys(h),C=(w,v)=>({range:t(w,"range",void 0,h.range),label:t(w,"label",v,h.label),description:t(w,"description",void 0,h.description),canResolveChildren:t(w,"canResolveChildren",!1,h.canResolveChildren),busy:t(w,"busy",!1,h.busy),error:t(w,"error",void 0,h.error),tags:t(w,"tags",[],h.tags)}),I=(w,v)=>{const a=new Map;for(const l of f)h[l](w[l],v[l])||a.set(l,v[l]);return a};e.diffTestItems=I;class m extends Error{constructor(v){super(`Attempted to insert a duplicate test item ID ${v}`)}}e.DuplicateTestItemError=m;class u extends Error{constructor(v){super(`TestItem with ID "${v}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=u;class c extends Error{constructor(v,a,l){super(`TestItem with ID "${v}" is from controller "${a}" and cannot be added as a child of an item from controller "${l}".`)}}e.MixedTestItemController=c;const b=w=>{const v=(0,e.getPrivateApiFor)(w);let a=new Map;return{get size(){return a.size},forEach(l,r){for(const o of a.values())l.call(r,o,this)},replace(l){const r=new Map,o=new Set(a.keys()),i={op:4,ops:[]};for(const n of l){if(!(n instanceof g))throw new u(n.id);const s=(0,e.getPrivateApiFor)(n).controllerId;if(s!==v.controllerId)throw new c(n.id,s,v.controllerId);if(r.has(n.id))throw new m(n.id);r.set(n.id,n),o.delete(n.id),i.ops.push({op:0,item:n})}for(const n of o.keys())i.ops.push({op:1,id:n});v.listener?.(i),a=r},add(l){if(!(l instanceof g))throw new u(l.id);a.set(l.id,l),v.listener?.({op:0,item:l})},delete(l){a.delete(l)&&v.listener?.({op:1,id:l})},get(l){return a.get(l)},toJSON(){return Array.from(a.values())},[Symbol.iterator](){return a.values()}}};class g{constructor(v,a,l,r){if(a.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(a)} symbol`);const o=(0,e.createPrivateApiFor)(this,v);Object.defineProperties(this,{id:{value:a,enumerable:!0,writable:!1},uri:{value:r,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return o.parent instanceof D?void 0:o.parent}},children:{value:b(this),enumerable:!0,writable:!1},...C(o,l)})}invalidateResults(){(0,e.getPrivateApiFor)(this).listener?.({op:2})}}e.TestItemImpl=g;class D extends g{constructor(v,a){super(v,v,a,void 0)}}e.TestItemRootImpl=D});var Dt=this&&this.__classPrivateFieldSet||function(Y,e,S,k,p){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!p)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!p:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?p.call(Y,S):p?p.value=S:e.set(Y,S),S},ut=this&&this.__classPrivateFieldGet||function(Y,e,S,k){if(S==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!k:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return S==="m"?k:S==="a"?k.call(Y):k?k.value:e.get(Y)};define(ue[115],de([0,1,20,12,87,30,65,14,11,5,25,15,105]),function(Y,e,S,k,p,P,t,T,h,f,C,I,m){"use strict";var u,c,b,g,D,w,v,a,l,r,o,i,n,s,d,y,A,E,R,O;Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeDataTransfer=e.TreeDataTransferItem=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestions=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function K(N){function L(){return Reflect.construct(N,arguments,this.constructor)}return Object.defineProperty(L,"name",Object.getOwnPropertyDescriptor(N,"name")),Object.setPrototypeOf(L,N),Object.setPrototypeOf(L.prototype,N.prototype),L}let te=D=class{constructor(L){u.set(this,void 0),Dt(this,u,L,"f")}static from(...L){let Z=L;return new D(function(){if(Z){for(const Ce of Z)Ce&&typeof Ce.dispose=="function"&&Ce.dispose();Z=void 0}})}dispose(){typeof ut(this,u,"f")=="function"&&(ut(this,u,"f").call(this),Dt(this,u,void 0,"f"))}};u=new WeakMap,te=D=Ne([K],te),e.Disposable=te;let j=w=class{constructor(L,Z){if(L<0)throw(0,k.illegalArgument)("line must be non-negative");if(Z<0)throw(0,k.illegalArgument)("character must be non-negative");this._line=L,this._character=Z}static Min(...L){if(L.length===0)throw new TypeError;let Z=L[0];for(let Ce=1;Ce<L.length;Ce++){const qe=L[Ce];qe.isBefore(Z)&&(Z=qe)}return Z}static Max(...L){if(L.length===0)throw new TypeError;let Z=L[0];for(let Ce=1;Ce<L.length;Ce++){const qe=L[Ce];qe.isAfter(Z)&&(Z=qe)}return Z}static isPosition(L){if(!L)return!1;if(L instanceof w)return!0;let{line:Z,character:Ce}=L;return typeof Z=="number"&&typeof Ce=="number"}get line(){return this._line}get character(){return this._character}isBefore(L){return this._line<L._line?!0:L._line<this._line?!1:this._character<L._character}isBeforeOrEqual(L){return this._line<L._line?!0:L._line<this._line?!1:this._character<=L._character}isAfter(L){return!this.isBeforeOrEqual(L)}isAfterOrEqual(L){return!this.isBefore(L)}isEqual(L){return this._line===L._line&&this._character===L._character}compareTo(L){return this._line<L._line?-1:this._line>L.line?1:this._character<L._character?-1:this._character>L._character?1:0}translate(L,Z=0){if(L===null||Z===null)throw(0,k.illegalArgument)();let Ce;return typeof L=="undefined"?Ce=0:typeof L=="number"?Ce=L:(Ce=typeof L.lineDelta=="number"?L.lineDelta:0,Z=typeof L.characterDelta=="number"?L.characterDelta:0),Ce===0&&Z===0?this:new w(this.line+Ce,this.character+Z)}with(L,Z=this.character){if(L===null||Z===null)throw(0,k.illegalArgument)();let Ce;return typeof L=="undefined"?Ce=this.line:typeof L=="number"?Ce=L:(Ce=typeof L.line=="number"?L.line:this.line,Z=typeof L.character=="number"?L.character:this.character),Ce===this.line&&Z===this.character?this:new w(Ce,Z)}toJSON(){return{line:this.line,character:this.character}}};j=w=Ne([K],j),e.Position=j;let _=v=class{constructor(L,Z,Ce,qe){let xe,nt;if(typeof L=="number"&&typeof Z=="number"&&typeof Ce=="number"&&typeof qe=="number"?(xe=new j(L,Z),nt=new j(Ce,qe)):L instanceof j&&Z instanceof j&&(xe=L,nt=Z),!xe||!nt)throw new Error("Invalid arguments");xe.isBefore(nt)?(this._start=xe,this._end=nt):(this._start=nt,this._end=xe)}static isRange(L){return L instanceof v?!0:L?j.isPosition(L.start)&&j.isPosition(L.end):!1}get start(){return this._start}get end(){return this._end}contains(L){return L instanceof v?this.contains(L._start)&&this.contains(L._end):L instanceof j?!(L.isBefore(this._start)||this._end.isBefore(L)):!1}isEqual(L){return this._start.isEqual(L._start)&&this._end.isEqual(L._end)}intersection(L){const Z=j.Max(L.start,this._start),Ce=j.Min(L.end,this._end);if(!Z.isAfter(Ce))return new v(Z,Ce)}union(L){if(this.contains(L))return this;if(L.contains(this))return L;const Z=j.Min(L.start,this._start),Ce=j.Max(L.end,this.end);return new v(Z,Ce)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(L,Z=this.end){if(L===null||Z===null)throw(0,k.illegalArgument)();let Ce;return L?j.isPosition(L)?Ce=L:(Ce=L.start||this.start,Z=L.end||this.end):Ce=this.start,Ce.isEqual(this._start)&&Z.isEqual(this.end)?this:new v(Ce,Z)}toJSON(){return[this.start,this.end]}};_=v=Ne([K],_),e.Range=_;let U=a=class extends _{constructor(L,Z,Ce,qe){let xe,nt;if(typeof L=="number"&&typeof Z=="number"&&typeof Ce=="number"&&typeof qe=="number"?(xe=new j(L,Z),nt=new j(Ce,qe)):L instanceof j&&Z instanceof j&&(xe=L,nt=Z),!xe||!nt)throw new Error("Invalid arguments");super(xe,nt);this._anchor=xe,this._active=nt}static isSelection(L){return L instanceof a?!0:L?_.isRange(L)&&j.isPosition(L.anchor)&&j.isPosition(L.active)&&typeof L.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};U=a=Ne([K],U),e.Selection=U;class F{constructor(L,Z,Ce){if(typeof L!="string"||L.length===0)throw(0,k.illegalArgument)("host");if(typeof Z!="number"||Z===0||Math.round(Z)!==Z)throw(0,k.illegalArgument)("port");if(typeof Ce!="undefined"&&(typeof Ce!="string"||Ce.length===0||!/^[0-9A-Za-z\-]+$/.test(Ce)))throw(0,k.illegalArgument)("connectionToken");this.host=L,this.port=Math.round(Z),this.connectionToken=Ce}}e.ResolvedAuthority=F;class M extends Error{constructor(L,Z=m.RemoteAuthorityResolverErrorCode.Unknown,Ce){super(L);this._message=L,this._code=Z,this._detail=Ce,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,M.prototype)}static NotAvailable(L,Z){return new M(L,m.RemoteAuthorityResolverErrorCode.NotAvailable,Z)}static TemporarilyNotAvailable(L){return new M(L,m.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=M;var V;(function(N){N[N.LF=1]="LF",N[N.CRLF=2]="CRLF"})(V=e.EndOfLine||(e.EndOfLine={}));var ee;(function(N){N[N.Replace=1]="Replace",N[N.Append=2]="Append",N[N.Prepend=3]="Prepend"})(ee=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let G=l=class{constructor(L,Z){this._range=L,this._newText=Z}static isTextEdit(L){return L instanceof l?!0:L?_.isRange(L)&&typeof L.newText=="string":!1}static replace(L,Z){return new l(L,Z)}static insert(L,Z){return l.replace(new _(L,L),Z)}static delete(L){return l.replace(L,"")}static setEndOfLine(L){const Z=new l(new _(new j(0,0),new j(0,0)),"");return Z.newEol=L,Z}get range(){return this._range}set range(L){if(L&&!_.isRange(L))throw(0,k.illegalArgument)("range");this._range=L}get newText(){return this._newText||""}set newText(L){if(L&&typeof L!="string")throw(0,k.illegalArgument)("newText");this._newText=L}get newEol(){return this._newEol}set newEol(L){if(L&&typeof L!="number")throw(0,k.illegalArgument)("newEol");this._newEol=L}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};G=l=Ne([K],G),e.TextEdit=G;var H;(function(N){N[N.File=1]="File",N[N.Text=2]="Text",N[N.Cell=3]="Cell",N[N.CellReplace=5]="CellReplace"})(H=e.FileEditType||(e.FileEditType={}));let q=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(L,Z,Ce,qe){this._edits.push({_type:1,from:L,to:Z,options:Ce,metadata:qe})}createFile(L,Z,Ce){this._edits.push({_type:1,from:void 0,to:L,options:Z,metadata:Ce})}deleteFile(L,Z,Ce){this._edits.push({_type:1,from:L,to:void 0,options:Z,metadata:Ce})}replaceNotebookMetadata(L,Z,Ce){this._edits.push({_type:3,metadata:Ce,uri:L,edit:{editType:5,metadata:Z},notebookMetadata:Z})}replaceNotebookCells(L,Z,Ce,qe,xe){let nt,st,dt=[],gt;if(Pt.isNotebookRange(Z)&&Ct.isNotebookCellDataArray(Ce)&&!Ct.isNotebookCellDataArray(qe)?(nt=Z.start,st=Z.end,dt=Ce,gt=qe):typeof Z=="number"&&typeof Ce=="number"&&Ct.isNotebookCellDataArray(qe)&&(nt=Z,st=Ce,dt=qe,gt=xe),nt===void 0||st===void 0)throw new Error("Invalid arguments");(nt!==st||dt.length>0)&&this._edits.push({_type:5,uri:L,index:nt,count:st-nt,cells:dt,metadata:gt})}replaceNotebookCellMetadata(L,Z,Ce,qe){this._edits.push({_type:3,metadata:qe,uri:L,edit:{editType:8,index:Z,metadata:Ce}})}replace(L,Z,Ce,qe){this._edits.push({_type:2,uri:L,edit:new G(Z,Ce),metadata:qe})}insert(L,Z,Ce,qe){this.replace(L,new _(Z,Z),Ce,qe)}delete(L,Z,Ce){this.replace(L,Z,"",Ce)}has(L){return this._edits.some(Z=>Z._type===2&&Z.uri.toString()===L.toString())}set(L,Z){if(Z)for(const Ce of Z)Ce&&this._edits.push({_type:2,uri:L,edit:Ce});else{for(let Ce=0;Ce<this._edits.length;Ce++){const qe=this._edits[Ce];qe._type===2&&qe.uri.toString()===L.toString()&&(this._edits[Ce]=void 0)}(0,S.coalesceInPlace)(this._edits)}}get(L){const Z=[];for(let Ce of this._edits)Ce._type===2&&Ce.uri.toString()===L.toString()&&Z.push(Ce.edit);return Z}entries(){const L=new P.ResourceMap;for(let Z of this._edits)if(Z._type===2){let Ce=L.get(Z.uri);Ce||(Ce=[Z.uri,[]],L.set(Z.uri,Ce)),Ce[1].push(Z.edit)}return[...L.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};q=Ne([K],q),e.WorkspaceEdit=q;let z=r=class{constructor(L){this._tabstop=1,this.value=L||""}static isSnippetString(L){return L instanceof r?!0:L?typeof L.value=="string":!1}static _escape(L){return L.replace(/\$|}|\\/g,"\\$&")}appendText(L){return this.value+=r._escape(L),this}appendTabstop(L=this._tabstop++){return this.value+="$",this.value+=L,this}appendPlaceholder(L,Z=this._tabstop++){if(typeof L=="function"){const Ce=new r;Ce._tabstop=this._tabstop,L(Ce),this._tabstop=Ce._tabstop,L=Ce.value}else L=r._escape(L);return this.value+="${",this.value+=Z,this.value+=":",this.value+=L,this.value+="}",this}appendChoice(L,Z=this._tabstop++){const Ce=L.map(qe=>qe.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=Z,this.value+="|",this.value+=Ce,this.value+="|}",this}appendVariable(L,Z){if(typeof Z=="function"){const Ce=new r;Ce._tabstop=this._tabstop,Z(Ce),this._tabstop=Ce._tabstop,Z=Ce.value}else typeof Z=="string"&&(Z=Z.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=L,Z&&(this.value+=":",this.value+=Z),this.value+="}",this}};z=r=Ne([K],z),e.SnippetString=z;var B;(function(N){N[N.Unnecessary=1]="Unnecessary",N[N.Deprecated=2]="Deprecated"})(B=e.DiagnosticTag||(e.DiagnosticTag={}));var W;(function(N){N[N.Hint=3]="Hint",N[N.Information=2]="Information",N[N.Warning=1]="Warning",N[N.Error=0]="Error"})(W=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let ie=o=class{constructor(L,Z){if(this.uri=L,Z)if(Z instanceof _)this.range=Z;else if(Z instanceof j)this.range=new _(Z,Z);else throw new Error("Illegal argument")}static isLocation(L){return L instanceof o?!0:L?_.isRange(L.range)&&f.URI.isUri(L.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};ie=o=Ne([K],ie),e.Location=ie;let oe=class{constructor(L,Z){this.location=L,this.message=Z}static is(L){return L?typeof L.message=="string"&&L.location&&_.isRange(L.location.range)&&f.URI.isUri(L.location.uri):!1}static isEqual(L,Z){return L===Z?!0:!L||!Z?!1:L.message===Z.message&&L.location.range.isEqual(Z.location.range)&&L.location.uri.toString()===Z.location.uri.toString()}};oe=Ne([K],oe),e.DiagnosticRelatedInformation=oe;let we=class{constructor(L,Z,Ce=W.Error){if(!_.isRange(L))throw new TypeError("range must be set");if(!Z)throw new TypeError("message must be set");this.range=L,this.message=Z,this.severity=Ce}toJSON(){return{severity:W[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(L,Z){return L===Z?!0:!L||!Z?!1:L.message===Z.message&&L.severity===Z.severity&&L.code===Z.code&&L.severity===Z.severity&&L.source===Z.source&&L.range.isEqual(Z.range)&&(0,S.equals)(L.tags,Z.tags)&&(0,S.equals)(L.relatedInformation,Z.relatedInformation,oe.isEqual)}};we=Ne([K],we),e.Diagnostic=we;let se=class{constructor(L,Z){if(!L)throw new Error("Illegal argument, contents must be defined");Array.isArray(L)?this.contents=L:this.contents=[L],this.range=Z}};se=Ne([K],se),e.Hover=se;var ae;(function(N){N[N.Text=0]="Text",N[N.Read=1]="Read",N[N.Write=2]="Write"})(ae=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let ke=class{constructor(L,Z=ae.Text){this.range=L,this.kind=Z}toJSON(){return{range:this.range,kind:ae[this.kind]}}};ke=Ne([K],ke),e.DocumentHighlight=ke;var De;(function(N){N[N.File=0]="File",N[N.Module=1]="Module",N[N.Namespace=2]="Namespace",N[N.Package=3]="Package",N[N.Class=4]="Class",N[N.Method=5]="Method",N[N.Property=6]="Property",N[N.Field=7]="Field",N[N.Constructor=8]="Constructor",N[N.Enum=9]="Enum",N[N.Interface=10]="Interface",N[N.Function=11]="Function",N[N.Variable=12]="Variable",N[N.Constant=13]="Constant",N[N.String=14]="String",N[N.Number=15]="Number",N[N.Boolean=16]="Boolean",N[N.Array=17]="Array",N[N.Object=18]="Object",N[N.Key=19]="Key",N[N.Null=20]="Null",N[N.EnumMember=21]="EnumMember",N[N.Struct=22]="Struct",N[N.Event=23]="Event",N[N.Operator=24]="Operator",N[N.TypeParameter=25]="TypeParameter"})(De=e.SymbolKind||(e.SymbolKind={}));var Oe;(function(N){N[N.Deprecated=1]="Deprecated"})(Oe=e.SymbolTag||(e.SymbolTag={}));let Be=i=class{constructor(L,Z,Ce,qe,xe){this.name=L,this.kind=Z,this.containerName=xe,typeof Ce=="string"&&(this.containerName=Ce),qe instanceof ie?this.location=qe:Ce instanceof _&&(this.location=new ie(qe,Ce)),i.validate(this)}static validate(L){if(!L.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:De[this.kind],location:this.location,containerName:this.containerName}}};Be=i=Ne([K],Be),e.SymbolInformation=Be;let Xe=n=class{constructor(L,Z,Ce,qe,xe){this.name=L,this.detail=Z,this.kind=Ce,this.range=qe,this.selectionRange=xe,this.children=[],n.validate(this)}static validate(L){if(!L.name)throw new Error("name must not be falsy");if(!L.range.contains(L.selectionRange))throw new Error("selectionRange must be contained in fullRange");L.children&&L.children.forEach(n.validate)}};Xe=n=Ne([K],Xe),e.DocumentSymbol=Xe;var Ze;(function(N){N[N.Invoke=1]="Invoke",N[N.Automatic=2]="Automatic"})(Ze=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let ge=class{constructor(L,Z){this.title=L,this.kind=Z}};ge=Ne([K],ge),e.CodeAction=ge;let me=s=class{constructor(L){this.value=L}append(L){return new s(this.value?this.value+s.sep+L:L)}intersects(L){return this.contains(L)||L.contains(this)}contains(L){return this.value===L.value||L.value.startsWith(this.value+s.sep)}};me.sep=".",me=s=Ne([K],me),e.CodeActionKind=me,me.Empty=new me(""),me.QuickFix=me.Empty.append("quickfix"),me.Refactor=me.Empty.append("refactor"),me.RefactorExtract=me.Refactor.append("extract"),me.RefactorInline=me.Refactor.append("inline"),me.RefactorRewrite=me.Refactor.append("rewrite"),me.Source=me.Empty.append("source"),me.SourceOrganizeImports=me.Source.append("organizeImports"),me.SourceFixAll=me.Source.append("fixAll");let Ie=class{constructor(L,Z){if(this.range=L,this.parent=Z,Z&&!Z.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};Ie=Ne([K],Ie),e.SelectionRange=Ie;class Re{constructor(L,Z,Ce,qe,xe,nt){this.kind=L,this.name=Z,this.detail=Ce,this.uri=qe,this.range=xe,this.selectionRange=nt}}e.CallHierarchyItem=Re;class Le{constructor(L,Z){this.fromRanges=Z,this.from=L}}e.CallHierarchyIncomingCall=Le;class He{constructor(L,Z){this.fromRanges=Z,this.to=L}}e.CallHierarchyOutgoingCall=He;var Qe;(function(N){N[N.Information=0]="Information",N[N.Warning=1]="Warning",N[N.Error=2]="Error"})(Qe=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let Je=class{constructor(L,Z){this.range=L,this.command=Z}get isResolved(){return!!this.command}};Je=Ne([K],Je),e.CodeLens=Je;let rt=d=class{constructor(L,Z=!1){c.set(this,void 0),Dt(this,c,new p.MarkdownString(L,{supportThemeIcons:Z}),"f")}static isMarkdownString(L){return L instanceof d?!0:L&&L.appendCodeblock&&L.appendMarkdown&&L.appendText&&L.value!==void 0}get value(){return ut(this,c,"f").value}set value(L){ut(this,c,"f").value=L}get isTrusted(){return ut(this,c,"f").isTrusted}set isTrusted(L){ut(this,c,"f").isTrusted=L}get supportThemeIcons(){return ut(this,c,"f").supportThemeIcons}set supportThemeIcons(L){ut(this,c,"f").supportThemeIcons=L}get supportHtml(){return ut(this,c,"f").supportHtml}set supportHtml(L){ut(this,c,"f").supportHtml=L}appendText(L){return ut(this,c,"f").appendText(L),this}appendMarkdown(L){return ut(this,c,"f").appendMarkdown(L),this}appendCodeblock(L,Z){return ut(this,c,"f").appendCodeblock(Z??"",L),this}};c=new WeakMap,rt=d=Ne([K],rt),e.MarkdownString=rt;let ce=class{constructor(L,Z){this.label=L,this.documentation=Z}};ce=Ne([K],ce),e.ParameterInformation=ce;let Se=class{constructor(L,Z){this.label=L,this.documentation=Z,this.parameters=[]}};Se=Ne([K],Se),e.SignatureInformation=Se;let Pe=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};Pe=Ne([K],Pe),e.SignatureHelp=Pe;var $e;(function(N){N[N.Invoke=1]="Invoke",N[N.TriggerCharacter=2]="TriggerCharacter",N[N.ContentChange=3]="ContentChange"})($e=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var Ye;(function(N){N[N.Other=0]="Other",N[N.Type=1]="Type",N[N.Parameter=2]="Parameter"})(Ye=e.InlayHintKind||(e.InlayHintKind={}));let lt=class{constructor(L,Z,Ce){this.text=L,this.position=Z,this.kind=Ce}};lt=Ne([K],lt),e.InlayHint=lt;var tt;(function(N){N[N.Invoke=0]="Invoke",N[N.TriggerCharacter=1]="TriggerCharacter",N[N.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(tt=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var at;(function(N){N[N.Text=0]="Text",N[N.Method=1]="Method",N[N.Function=2]="Function",N[N.Constructor=3]="Constructor",N[N.Field=4]="Field",N[N.Variable=5]="Variable",N[N.Class=6]="Class",N[N.Interface=7]="Interface",N[N.Module=8]="Module",N[N.Property=9]="Property",N[N.Unit=10]="Unit",N[N.Value=11]="Value",N[N.Enum=12]="Enum",N[N.Keyword=13]="Keyword",N[N.Snippet=14]="Snippet",N[N.Color=15]="Color",N[N.File=16]="File",N[N.Reference=17]="Reference",N[N.Folder=18]="Folder",N[N.EnumMember=19]="EnumMember",N[N.Constant=20]="Constant",N[N.Struct=21]="Struct",N[N.Event=22]="Event",N[N.Operator=23]="Operator",N[N.TypeParameter=24]="TypeParameter",N[N.User=25]="User",N[N.Issue=26]="Issue"})(at=e.CompletionItemKind||(e.CompletionItemKind={}));var ot;(function(N){N[N.Deprecated=1]="Deprecated"})(ot=e.CompletionItemTag||(e.CompletionItemTag={}));let et=class{constructor(L,Z){this.label=L,this.kind=Z}toJSON(){return{label:this.label,kind:this.kind&&at[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};et=Ne([K],et),e.CompletionItem=et;let ne=class{constructor(L=[],Z=!1){this.items=L,this.isIncomplete=Z}};ne=Ne([K],ne),e.CompletionList=ne;let be=class{constructor(L,Z,Ce){this.text=L,this.range=Z,this.command=Ce}};be=Ne([K],be),e.InlineSuggestion=be;let Fe=class{constructor(L){this.items=L}};Fe=Ne([K],Fe),e.InlineSuggestions=Fe;var Ae;(function(N){N[N.Active=-1]="Active",N[N.Beside=-2]="Beside",N[N.One=1]="One",N[N.Two=2]="Two",N[N.Three=3]="Three",N[N.Four=4]="Four",N[N.Five=5]="Five",N[N.Six=6]="Six",N[N.Seven=7]="Seven",N[N.Eight=8]="Eight",N[N.Nine=9]="Nine"})(Ae=e.ViewColumn||(e.ViewColumn={}));var Ve;(function(N){N[N.Left=1]="Left",N[N.Right=2]="Right"})(Ve=e.StatusBarAlignment||(e.StatusBarAlignment={}));var ve;(function(N){N[N.Off=0]="Off",N[N.On=1]="On",N[N.Relative=2]="Relative"})(ve=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var fe;(function(N){N[N.Manual=1]="Manual",N[N.AfterDelay=2]="AfterDelay",N[N.FocusOut=3]="FocusOut"})(fe=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var pe;(function(N){N[N.Default=0]="Default",N[N.InCenter=1]="InCenter",N[N.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",N[N.AtTop=3]="AtTop"})(pe=e.TextEditorRevealType||(e.TextEditorRevealType={}));var J;(function(N){N[N.Keyboard=1]="Keyboard",N[N.Mouse=2]="Mouse",N[N.Command=3]="Command"})(J=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var x;(function(N){N[N.Undo=1]="Undo",N[N.Redo=2]="Redo"})(x=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var Q;(function(N){N[N.OpenOpen=0]="OpenOpen",N[N.ClosedClosed=1]="ClosedClosed",N[N.OpenClosed=2]="OpenClosed",N[N.ClosedOpen=3]="ClosedOpen"})(Q=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(N){function L(Z){switch(Z){case"keyboard":return N.Keyboard;case"mouse":return N.Mouse;case"api":return N.Command}}N.fromValue=L}(J=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let re=class{constructor(L,Z){if(Z&&!f.URI.isUri(Z))throw(0,k.illegalArgument)("target");if(!_.isRange(L)||L.isEmpty)throw(0,k.illegalArgument)("range");this.range=L,this.target=Z}};re=Ne([K],re),e.DocumentLink=re;let Ee=class{constructor(L,Z,Ce,qe){this.red=L,this.green=Z,this.blue=Ce,this.alpha=qe}};Ee=Ne([K],Ee),e.Color=Ee;let Ue=class{constructor(L,Z){if(Z&&!(Z instanceof Ee))throw(0,k.illegalArgument)("color");if(!_.isRange(L)||L.isEmpty)throw(0,k.illegalArgument)("range");this.range=L,this.color=Z}};Ue=Ne([K],Ue),e.ColorInformation=Ue;let _e=class{constructor(L){if(!L||typeof L!="string")throw(0,k.illegalArgument)("label");this.label=L}};_e=Ne([K],_e),e.ColorPresentation=_e;var ze;(function(N){N[N.RGB=0]="RGB",N[N.HEX=1]="HEX",N[N.HSL=2]="HSL"})(ze=e.ColorFormat||(e.ColorFormat={}));var We;(function(N){N[N.Error=0]="Error",N[N.Warning=1]="Warning",N[N.Information=2]="Information"})(We=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));class Ke{constructor(L,Z,Ce){if(this.startIndex=L,this.length=Z,this.tooltip=Ce,typeof L!="number"||L<0)throw(0,k.illegalArgument)("startIndex");if(typeof Z!="number"||Z<1)throw(0,k.illegalArgument)("length");if(Ce!==void 0&&typeof Ce!="string")throw(0,k.illegalArgument)("tooltip")}}e.TerminalLink=Ke;var le;(function(N){N[N.Panel=1]="Panel",N[N.Editor=2]="Editor"})(le=e.TerminalLocation||(e.TerminalLocation={}));class he{constructor(L){this.options=L,typeof L!="object"&&(0,k.illegalArgument)("options")}}e.TerminalProfile=he;var X;(function(N){N[N.Always=1]="Always",N[N.Silent=2]="Silent",N[N.Never=3]="Never"})(X=e.TaskRevealKind||(e.TaskRevealKind={}));var $;(function(N){N[N.Shared=1]="Shared",N[N.Dedicated=2]="Dedicated",N[N.New=3]="New"})($=e.TaskPanelKind||(e.TaskPanelKind={}));let ye=y=class{constructor(L,Z){if(this.label=Z,typeof L!="string"||typeof Z!="string")throw(0,k.illegalArgument)("name");this._id=L}static from(L){switch(L){case"clean":return y.Clean;case"build":return y.Build;case"rebuild":return y.Rebuild;case"test":return y.Test;default:return}}get id(){return this._id}};ye.Clean=new y("clean","Clean"),ye.Build=new y("build","Build"),ye.Rebuild=new y("rebuild","Rebuild"),ye.Test=new y("test","Test"),ye=y=Ne([K],ye),e.TaskGroup=ye;function Te(N){let L="";for(let Z=0;Z<N.length;Z++)L+=N[Z].replace(/,/g,",,")+",";return L}let Ge=class{constructor(L,Z,Ce){if(typeof L!="string")throw(0,k.illegalArgument)("process");this._args=[],this._process=L,Z!==void 0&&(Array.isArray(Z)?(this._args=Z,this._options=Ce):this._options=Z)}get process(){return this._process}set process(L){if(typeof L!="string")throw(0,k.illegalArgument)("process");this._process=L}get args(){return this._args}set args(L){Array.isArray(L)||(L=[]),this._args=L}get options(){return this._options}set options(L){this._options=L}computeId(){const L=[];if(L.push("process"),this._process!==void 0&&L.push(this._process),this._args&&this._args.length>0)for(let Z of this._args)L.push(Z);return Te(L)}};Ge=Ne([K],Ge),e.ProcessExecution=Ge;let Me=class{constructor(L,Z,Ce){if(this._args=[],Array.isArray(Z)){if(!L)throw(0,k.illegalArgument)("command can't be undefined or null");if(typeof L!="string"&&typeof L.value!="string")throw(0,k.illegalArgument)("command");this._command=L,this._args=Z,this._options=Ce}else{if(typeof L!="string")throw(0,k.illegalArgument)("commandLine");this._commandLine=L,this._options=Z}}get commandLine(){return this._commandLine}set commandLine(L){if(typeof L!="string")throw(0,k.illegalArgument)("commandLine");this._commandLine=L}get command(){return this._command?this._command:""}set command(L){if(typeof L!="string"&&typeof L.value!="string")throw(0,k.illegalArgument)("command");this._command=L}get args(){return this._args}set args(L){this._args=L||[]}get options(){return this._options}set options(L){this._options=L}computeId(){const L=[];if(L.push("shell"),this._commandLine!==void 0&&L.push(this._commandLine),this._command!==void 0&&L.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let Z of this._args)L.push(typeof Z=="string"?Z:Z.value);return Te(L)}};Me=Ne([K],Me),e.ShellExecution=Me;var it;(function(N){N[N.Escape=1]="Escape",N[N.Strong=2]="Strong",N[N.Weak=3]="Weak"})(it=e.ShellQuoting||(e.ShellQuoting={}));var ct;(function(N){N[N.Global=1]="Global",N[N.Workspace=2]="Workspace"})(ct=e.TaskScope||(e.TaskScope={}));class ft{constructor(L){this._callback=L}computeId(){return"customExecution"+(0,C.generateUuid)()}set callback(L){this._callback=L}get callback(){return this._callback}}e.CustomExecution=ft;let ht=A=class{constructor(L,Z,Ce,qe,xe,nt){this.__deprecated=!1,this._definition=this.definition=L;let st;typeof Z=="string"?(this._name=this.name=Z,this._source=this.source=Ce,this.execution=qe,st=xe,this.__deprecated=!0):Z===ct.Global||Z===ct.Workspace?(this.target=Z,this._name=this.name=Ce,this._source=this.source=qe,this.execution=xe,st=nt):(this.target=Z,this._name=this.name=Ce,this._source=this.source=qe,this.execution=xe,st=nt),typeof st=="string"?(this._problemMatchers=[st],this._hasDefinedMatchers=!0):Array.isArray(st)?(this._problemMatchers=st,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(L){this.__id=L}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof Ge?this._definition={type:A.ProcessType,id:this._execution.computeId()}:this._execution instanceof Me?this._definition={type:A.ShellType,id:this._execution.computeId()}:this._execution instanceof ft?this._definition={type:A.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:A.EmptyType,id:(0,C.generateUuid)()}}get definition(){return this._definition}set definition(L){if(L==null)throw(0,k.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=L}get scope(){return this._scope}set target(L){this.clear(),this._scope=L}get name(){return this._name}set name(L){if(typeof L!="string")throw(0,k.illegalArgument)("name");this.clear(),this._name=L}get execution(){return this._execution}set execution(L){L===null&&(L=void 0),this.clear(),this._execution=L;const Z=this._definition.type;(A.EmptyType===Z||A.ProcessType===Z||A.ShellType===Z||A.ExtensionCallbackType===Z)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(L){if(Array.isArray(L))this.clear(),this._problemMatchers=L,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(L){L!==!0&&L!==!1&&(L=!1),this.clear(),this._isBackground=L}get source(){return this._source}set source(L){if(typeof L!="string"||L.length===0)throw(0,k.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=L}get group(){return this._group}set group(L){L===null&&(L=void 0),this.clear(),this._group=L}get detail(){return this._detail}set detail(L){L===null&&(L=void 0),this._detail=L}get presentationOptions(){return this._presentationOptions}set presentationOptions(L){L==null&&(L=Object.create(null)),this.clear(),this._presentationOptions=L}get runOptions(){return this._runOptions}set runOptions(L){L==null&&(L=Object.create(null)),this.clear(),this._runOptions=L}};ht.ExtensionCallbackType="customExecution",ht.ProcessType="process",ht.ShellType="shell",ht.EmptyType="$empty",ht=A=Ne([K],ht),e.Task=ht;var mt;(function(N){N[N.SourceControl=1]="SourceControl",N[N.Window=10]="Window",N[N.Notification=15]="Notification"})(mt=e.ProgressLocation||(e.ProgressLocation={}));let vt=class{constructor(L,Z=ln.None){this.collapsibleState=Z,f.URI.isUri(L)?this.resourceUri=L:this.label=L}};vt=Ne([K],vt),e.TreeItem=vt;var ln;(function(N){N[N.None=0]="None",N[N.Collapsed=1]="Collapsed",N[N.Expanded=2]="Expanded"})(ln=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let Ft=class{constructor(L){this._value=L}async asString(){return JSON.stringify(this._value)}};Ft=Ne([K],Ft),e.TreeDataTransferItem=Ft;let Lt=class{constructor(){this._items=new Map}get(L){return this._items.get(L)}set(L,Z){this._items.set(L,Z)}forEach(L){this._items.forEach(L)}};Lt=Ne([K],Lt),e.TreeDataTransfer=Lt;let bt=class{constructor(L,Z){this.id=L,this.color=Z}};bt=Ne([K],bt),e.ThemeIcon=bt,bt.File=new bt("file"),bt.Folder=new bt("folder");let Ot=class{constructor(L){this.id=L}};Ot=Ne([K],Ot),e.ThemeColor=Ot;var un;(function(N){N[N.Global=1]="Global",N[N.Workspace=2]="Workspace",N[N.WorkspaceFolder=3]="WorkspaceFolder"})(un=e.ConfigurationTarget||(e.ConfigurationTarget={}));let Mt=class{constructor(L,Z){if(typeof L!="string"&&(!L||!f.URI.isUri(L)&&!f.URI.isUri(L.uri)))throw(0,k.illegalArgument)("base");if(typeof Z!="string")throw(0,k.illegalArgument)("pattern");typeof L=="string"?(this.baseFolder=f.URI.file(L),this.base=L):f.URI.isUri(L)?(this.baseFolder=L,this.base=L.fsPath):(this.baseFolder=L.uri,this.base=L.uri.fsPath),this.pattern=Z}};Mt=Ne([K],Mt),e.RelativePattern=Mt;let kt=class{constructor(L,Z,Ce,qe){this.enabled=typeof L=="boolean"?L:!0,typeof Z=="string"&&(this.condition=Z),typeof Ce=="string"&&(this.hitCondition=Ce),typeof qe=="string"&&(this.logMessage=qe)}get id(){return this._id||(this._id=(0,C.generateUuid)()),this._id}};kt=Ne([K],kt),e.Breakpoint=kt;let Nt=class extends kt{constructor(L,Z,Ce,qe,xe){super(Z,Ce,qe,xe);if(L===null)throw(0,k.illegalArgument)("location");this.location=L}};Nt=Ne([K],Nt),e.SourceBreakpoint=Nt;let Bt=class extends kt{constructor(L,Z,Ce,qe,xe){super(Z,Ce,qe,xe);this.functionName=L}};Bt=Ne([K],Bt),e.FunctionBreakpoint=Bt;let Ut=class extends kt{constructor(L,Z,Ce,qe,xe,nt,st){super(qe,xe,nt,st);if(!Z)throw(0,k.illegalArgument)("dataId");this.label=L,this.dataId=Z,this.canPersist=Ce}};Ut=Ne([K],Ut),e.DataBreakpoint=Ut;let zt=class{constructor(L,Z,Ce){this.command=L,this.args=Z||[],this.options=Ce}};zt=Ne([K],zt),e.DebugAdapterExecutable=zt;let Ht=class{constructor(L,Z){this.port=L,this.host=Z}};Ht=Ne([K],Ht),e.DebugAdapterServer=Ht;let $t=class{constructor(L){this.path=L}};$t=Ne([K],$t),e.DebugAdapterNamedPipeServer=$t;let Wt=class{constructor(L){this.implementation=L}};Wt=Ne([K],Wt),e.DebugAdapterInlineImplementation=Wt;let jt=class{constructor(L,Z){this.range=L,this.expression=Z}};jt=Ne([K],jt),e.EvaluatableExpression=jt;var dn;(function(N){N[N.Automatic=0]="Automatic",N[N.Explicit=1]="Explicit"})(dn=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let qt=class{constructor(L,Z){this.range=L,this.text=Z}};qt=Ne([K],qt),e.InlineValueText=qt;let Vt=class{constructor(L,Z,Ce=!0){this.range=L,this.variableName=Z,this.caseSensitiveLookup=Ce}};Vt=Ne([K],Vt),e.InlineValueVariableLookup=Vt;let Gt=class{constructor(L,Z){this.range=L,this.expression=Z}};Gt=Ne([K],Gt),e.InlineValueEvaluatableExpression=Gt;let Kt=class{constructor(L,Z){this.frameId=L,this.stoppedLocation=Z}};Kt=Ne([K],Kt),e.InlineValueContext=Kt;var hn;(function(N){N[N.Changed=1]="Changed",N[N.Created=2]="Created",N[N.Deleted=3]="Deleted"})(hn=e.FileChangeType||(e.FileChangeType={}));let Xt=E=class extends Error{constructor(L,Z=I.FileSystemProviderErrorCode.Unknown,Ce){super(f.URI.isUri(L)?L.toString(!0):L);this.code=Ce?.name??"Unknown",(0,I.markAsFileSystemProviderError)(this,Z),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,E.prototype),typeof Error.captureStackTrace=="function"&&typeof Ce=="function"&&Error.captureStackTrace(this,Ce)}static FileExists(L){return new E(L,I.FileSystemProviderErrorCode.FileExists,E.FileExists)}static FileNotFound(L){return new E(L,I.FileSystemProviderErrorCode.FileNotFound,E.FileNotFound)}static FileNotADirectory(L){return new E(L,I.FileSystemProviderErrorCode.FileNotADirectory,E.FileNotADirectory)}static FileIsADirectory(L){return new E(L,I.FileSystemProviderErrorCode.FileIsADirectory,E.FileIsADirectory)}static NoPermissions(L){return new E(L,I.FileSystemProviderErrorCode.NoPermissions,E.NoPermissions)}static Unavailable(L){return new E(L,I.FileSystemProviderErrorCode.Unavailable,E.Unavailable)}};Xt=E=Ne([K],Xt),e.FileSystemError=Xt;let Yt=class{constructor(L,Z,Ce){this.start=L,this.end=Z,this.kind=Ce}};Yt=Ne([K],Yt),e.FoldingRange=Yt;var fn;(function(N){N[N.Comment=1]="Comment",N[N.Imports=2]="Imports",N[N.Region=3]="Region"})(fn=e.FoldingRangeKind||(e.FoldingRangeKind={}));var gn;(function(N){N[N.Collapsed=0]="Collapsed",N[N.Expanded=1]="Expanded"})(gn=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var mn;(function(N){N[N.Editing=0]="Editing",N[N.Preview=1]="Preview"})(mn=e.CommentMode||(e.CommentMode={}));class vn{constructor(L,Z=[]){this.tokenTypes=L,this.tokenModifiers=Z}}e.SemanticTokensLegend=vn;function pn(N){return typeof N=="undefined"||(0,h.isStringArray)(N)}class Jt{constructor(L){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,L){this._hasLegend=!0;for(let Z=0,Ce=L.tokenTypes.length;Z<Ce;Z++)this._tokenTypeStrToInt.set(L.tokenTypes[Z],Z);for(let Z=0,Ce=L.tokenModifiers.length;Z<Ce;Z++)this._tokenModifierStrToInt.set(L.tokenModifiers[Z],Z)}}push(L,Z,Ce,qe,xe){if(typeof L=="number"&&typeof Z=="number"&&typeof Ce=="number"&&typeof qe=="number"&&(typeof xe=="number"||typeof xe=="undefined"))return typeof xe=="undefined"&&(xe=0),this._pushEncoded(L,Z,Ce,qe,xe);if(_.isRange(L)&&typeof Z=="string"&&pn(Ce))return this._push(L,Z,Ce);throw(0,k.illegalArgument)()}_push(L,Z,Ce){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(L.start.line!==L.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(Z))throw new Error("`tokenType` is not in the provided legend");const qe=L.start.line,xe=L.start.character,nt=L.end.character-L.start.character,st=this._tokenTypeStrToInt.get(Z);let dt=0;if(Ce)for(const gt of Ce){if(!this._tokenModifierStrToInt.has(gt))throw new Error("`tokenModifier` is not in the provided legend");const yt=this._tokenModifierStrToInt.get(gt);dt|=1<<yt>>>0}this._pushEncoded(qe,xe,nt,st,dt)}_pushEncoded(L,Z,Ce,qe,xe){if(this._dataIsSortedAndDeltaEncoded&&(L<this._prevLine||L===this._prevLine&&Z<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const dt=this._data.length/5|0;let gt=0,yt=0;for(let Et=0;Et<dt;Et++){let wt=this._data[5*Et],Tt=this._data[5*Et+1];wt===0?(wt=gt,Tt+=yt):wt+=gt,this._data[5*Et]=wt,this._data[5*Et+1]=Tt,gt=wt,yt=Tt}}let nt=L,st=Z;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(nt-=this._prevLine,nt===0&&(st-=this._prevChar)),this._data[this._dataLen++]=nt,this._data[this._dataLen++]=st,this._data[this._dataLen++]=Ce,this._data[this._dataLen++]=qe,this._data[this._dataLen++]=xe,this._prevLine=L,this._prevChar=Z}static _sortAndDeltaEncode(L){let Z=[];const Ce=L.length/5|0;for(let st=0;st<Ce;st++)Z[st]=st;Z.sort((st,dt)=>{const gt=L[5*st],yt=L[5*dt];if(gt===yt){const Et=L[5*st+1],wt=L[5*dt+1];return Et-wt}return gt-yt});const qe=new Uint32Array(L.length);let xe=0,nt=0;for(let st=0;st<Ce;st++){const dt=5*Z[st],gt=L[dt+0],yt=L[dt+1],Et=L[dt+2],wt=L[dt+3],Tt=L[dt+4],cn=gt-xe,Vn=cn===0?yt-nt:yt,Rt=5*st;qe[Rt+0]=cn,qe[Rt+1]=Vn,qe[Rt+2]=Et,qe[Rt+3]=wt,qe[Rt+4]=Tt,xe=gt,nt=yt}return qe}build(L){return this._dataIsSortedAndDeltaEncoded?new Qt(new Uint32Array(this._data),L):new Qt(Jt._sortAndDeltaEncode(this._data),L)}}e.SemanticTokensBuilder=Jt;class Qt{constructor(L,Z){this.resultId=Z,this.data=L}}e.SemanticTokens=Qt;class yn{constructor(L,Z,Ce){this.start=L,this.deleteCount=Z,this.data=Ce}}e.SemanticTokensEdit=yn;class En{constructor(L,Z){this.resultId=Z,this.edits=L}}e.SemanticTokensEdits=En;var wn;(function(N){N[N.Separate=0]="Separate",N[N.MergeWithParent=1]="MergeWithParent"})(wn=e.DebugConsoleMode||(e.DebugConsoleMode={}));var bn;(function(N){N[N.Initial=1]="Initial",N[N.Dynamic=2]="Dynamic"})(bn=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let At=class{constructor(){}};At.Back={iconPath:new bt("arrow-left")},At=Ne([K],At),e.QuickInputButtons=At;var Sn;(function(N){N[N.Default=1]="Default",N[N.Separator=2]="Separator"})(Sn=e.QuickPickItemKind||(e.QuickPickItemKind={}));var Cn;(function(N){N[N.UI=1]="UI",N[N.Workspace=2]="Workspace"})(Cn=e.ExtensionKind||(e.ExtensionKind={}));class kn{constructor(L,Z,Ce){this.badge=L,this.tooltip=Z,this.color=Ce}static validate(L){if(L.badge){let Z=(0,T.nextCharLength)(L.badge,0);if(Z<L.badge.length&&(Z+=(0,T.nextCharLength)(L.badge,Z)),L.badge.length>Z)throw new Error("The 'badge'-property must be undefined or a short character")}if(!L.color&&!L.badge&&!L.tooltip)throw new Error("The decoration is empty");return!0}}e.FileDecoration=kn;let Zt=class{constructor(L){this.kind=L}};Zt=Ne([K],Zt),e.ColorTheme=Zt;var In;(function(N){N[N.Light=1]="Light",N[N.Dark=2]="Dark",N[N.HighContrast=3]="HighContrast"})(In=e.ColorThemeKind||(e.ColorThemeKind={}));class Pt{constructor(L,Z){if(L<0)throw(0,k.illegalArgument)("start must be positive");if(Z<0)throw(0,k.illegalArgument)("end must be positive");L<=Z?(this._start=L,this._end=Z):(this._start=Z,this._end=L)}static isNotebookRange(L){return L instanceof Pt?!0:L?typeof L.start=="number"&&typeof L.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(L){let Z=this._start,Ce=this._end;return L.start!==void 0&&(Z=L.start),L.end!==void 0&&(Ce=L.end),Z===this._start&&Ce===this._end?this:new Pt(Z,Ce)}}e.NotebookRange=Pt;class Ct{constructor(L,Z,Ce,qe,xe,nt,st){this.kind=L,this.value=Z,this.languageId=Ce,this.mime=qe,this.outputs=xe??[],this.metadata=nt,this.executionSummary=st,Ct.validate(this)}static validate(L){if(typeof L.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof L.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof L.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(L){return Array.isArray(L)&&L.every(Z=>Ct.isNotebookCellData(Z))}static isNotebookCellData(L){return!0}}e.NotebookCellData=Ct;class Dn{constructor(L){this.cells=L}}e.NotebookData=Dn;class pt{constructor(L,Z){this.data=L,this.mime=Z;const Ce=(0,t.normalizeMimeType)(Z,!0);if(!Ce)throw new Error(`INVALID mime type: ${Z}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Ce}static isNotebookCellOutputItem(L){return L instanceof pt?!0:L?typeof L.mime=="string"&&L.data instanceof Uint8Array:!1}static error(L){const Z={name:L.name,message:L.message,stack:L.stack};return pt.json(Z,"application/vnd.code.notebook.error")}static stdout(L){return pt.text(L,"application/vnd.code.notebook.stdout")}static stderr(L){return pt.text(L,"application/vnd.code.notebook.stderr")}static bytes(L,Z="application/octet-stream"){return new pt(L,Z)}static text(L,Z=t.Mimes.text){const Ce=ut(pt,b,"f",g).encode(String(L));return new pt(Ce,Z)}static json(L,Z="application/json"){const Ce=JSON.stringify(L,void 0,"	");return pt.text(Ce,Z)}}e.NotebookCellOutputItem=pt,b=pt,g={value:new TextEncoder};class _t{constructor(L,Z,Ce){this.items=_t.ensureUniqueMimeTypes(L,!0),typeof Z=="string"?(this.id=Z,this.metadata=Ce):(this.id=(0,C.generateUuid)(),this.metadata=Z??Ce)}static isNotebookCellOutput(L){return L instanceof _t?!0:!L||typeof L!="object"?!1:typeof L.id=="string"&&(0,h.isArray)(L.items)}static ensureUniqueMimeTypes(L,Z=!1){const Ce=new Set,qe=new Set;for(let xe=0;xe<L.length;xe++){const nt=L[xe],st=(0,t.normalizeMimeType)(nt.mime);if(!Ce.has(st)){Ce.add(st);continue}qe.add(xe),Z&&console.warn(`DUPLICATED mime type '${nt.mime}' will be dropped`)}return qe.size===0?L:L.filter((xe,nt)=>!qe.has(nt))}}e.NotebookCellOutput=_t;var Pn;(function(N){N[N.Markup=1]="Markup",N[N.Code=2]="Code"})(Pn=e.NotebookCellKind||(e.NotebookCellKind={}));var Tn;(function(N){N[N.Idle=1]="Idle",N[N.Pending=2]="Pending",N[N.Executing=3]="Executing"})(Tn=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var Rn;(function(N){N[N.Left=1]="Left",N[N.Right=2]="Right"})(Rn=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var An;(function(N){N[N.Default=0]="Default",N[N.InCenter=1]="InCenter",N[N.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",N[N.AtTop=3]="AtTop"})(An=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class _n{constructor(L,Z){this.text=L,this.alignment=Z}}e.NotebookCellStatusBarItem=_n;var Fn;(function(N){N[N.Default=1]="Default",N[N.Preferred=2]="Preferred"})(Fn=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class Ln{constructor(L,Z=[]){this.uri=L,this.provides=(0,S.asArray)(Z)}}e.NotebookRendererScript=Ln;let xt=class{constructor(L,Z){this.label=L,this.timestamp=Z}};xt=Ne([K],xt),e.TimelineItem=xt;var On;(function(N){N[N.Production=1]="Production",N[N.Development=2]="Development",N[N.Test=3]="Test"})(On=e.ExtensionMode||(e.ExtensionMode={}));var Mn;(function(N){N[N.Node=1]="Node",N[N.Webworker=2]="Webworker"})(Mn=e.ExtensionRuntime||(e.ExtensionRuntime={}));var Nn;(function(N){N[N.Other=0]="Other",N[N.Comment=1]="Comment",N[N.String=2]="String",N[N.RegEx=4]="RegEx"})(Nn=e.StandardTokenType||(e.StandardTokenType={}));class Bn{constructor(L,Z){this.ranges=L,this.wordPattern=Z}}e.LinkedEditingRanges=Bn;class Un{constructor(L,Z){this._port=L,this._autoForwardAction=Z}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=Un;var zn;(function(N){N[N.Queued=1]="Queued",N[N.Running=2]="Running",N[N.Passed=3]="Passed",N[N.Failed=4]="Failed",N[N.Skipped=5]="Skipped",N[N.Errored=6]="Errored"})(zn=e.TestResultState||(e.TestResultState={}));var Hn;(function(N){N[N.Run=1]="Run",N[N.Debug=2]="Debug",N[N.Coverage=3]="Coverage"})(Hn=e.TestRunProfileKind||(e.TestRunProfileKind={}));let en=class{constructor(L=void 0,Z=void 0,Ce=void 0){this.include=L,this.exclude=Z,this.profile=Ce}};en=Ne([K],en),e.TestRunRequest=en;let tn=R=class{constructor(L){this.message=L}static diff(L,Z,Ce){const qe=new R(L);return qe.expectedOutput=Z,qe.actualOutput=Ce,qe}};tn=R=Ne([K],tn),e.TestMessage=tn;let nn=class{constructor(L){this.id=L}};nn=Ne([K],nn),e.TestTag=nn;let It=class{constructor(L,Z){this.covered=L,this.total=Z}};It=Ne([K],It),e.CoveredCount=It;let rn=O=class{constructor(L,Z,Ce,qe){this.uri=L,this.statementCoverage=Z,this.branchCoverage=Ce,this.functionCoverage=qe}static fromDetails(L,Z){const Ce=new It(0,0),qe=new It(0,0),xe=new It(0,0);for(const st of Z)if("branches"in st){Ce.total+=1,Ce.covered+=st.executionCount>0?1:0;for(const dt of st.branches)qe.total+=1,qe.covered+=dt.executionCount>0?1:0}else xe.total+=1,xe.covered+=st.executionCount>0?1:0;const nt=new O(L,Ce,qe.total>0?qe:void 0,xe.total>0?xe:void 0);return nt.detailedCoverage=Z,nt}};rn=O=Ne([K],rn),e.FileCoverage=rn;let sn=class{constructor(L,Z,Ce=[]){this.executionCount=L,this.location=Z,this.branches=Ce}};sn=Ne([K],sn),e.StatementCoverage=sn;let on=class{constructor(L,Z){this.executionCount=L,this.location=Z}};on=Ne([K],on),e.BranchCoverage=on;let an=class{constructor(L,Z){this.executionCount=L,this.location=Z}};an=Ne([K],an),e.FunctionCoverage=an;var $n;(function(N){N[N.None=0]="None",N[N.Option=1]="Option",N[N.Default=2]="Default",N[N.Preferred=3]="Preferred"})($n=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var Wn;(function(N){N[N.Untrusted=0]="Untrusted",N[N.Trusted=1]="Trusted",N[N.Unspecified=2]="Unspecified"})(Wn=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var jn;(function(N){N[N.Notify=1]="Notify",N[N.OpenBrowser=2]="OpenBrowser",N[N.OpenPreview=3]="OpenPreview",N[N.Silent=4]="Silent",N[N.Ignore=5]="Ignore",N[N.OpenBrowserOnce=6]="OpenBrowserOnce"})(jn=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class qn{constructor(L,Z,Ce,qe,xe,nt){this.kind=L,this.name=Z,this.detail=Ce,this.uri=qe,this.range=xe,this.selectionRange=nt}}e.TypeHierarchyItem=qn}),define(ue[116],de([0,1,181,11,5,3,7,71,22,15,20,10]),function(Y,e,S,k,p,P,t,T,h,f,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveReason=e.Verbosity=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.EditorAreaVisibleContext=e.SplitEditorsVertically=e.IsCenteredLayoutContext=e.InEditorZenModeContext=e.EditorsVisibleContext=e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext=e.ActiveEditorGroupLockedContext=e.ActiveEditorGroupLastContext=e.ActiveEditorGroupIndexContext=e.ActiveEditorGroupEmptyContext=e.EditorGroupEditorsCountContext=e.SideBySideEditorActiveContext=e.TextCompareEditorActiveContext=e.TextCompareEditorVisibleContext=e.ActiveEditorAvailableEditorIdsContext=e.ActiveEditorContext=e.ActiveEditorCanSplitInGroupContext=e.ActiveEditorCanRevertContext=e.ActiveEditorReadonlyContext=e.ActiveEditorStickyContext=e.ActiveEditorPinnedContext=e.ActiveEditorDirtyContext=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,S.localize)(0,null),providerDisplayName:(0,S.localize)(1,null)},e.ActiveEditorDirtyContext=new T.RawContextKey("activeEditorIsDirty",!1,(0,S.localize)(2,null)),e.ActiveEditorPinnedContext=new T.RawContextKey("activeEditorIsNotPreview",!1,(0,S.localize)(3,null)),e.ActiveEditorStickyContext=new T.RawContextKey("activeEditorIsPinned",!1,(0,S.localize)(4,null)),e.ActiveEditorReadonlyContext=new T.RawContextKey("activeEditorIsReadonly",!1,(0,S.localize)(5,null)),e.ActiveEditorCanRevertContext=new T.RawContextKey("activeEditorCanRevert",!1,(0,S.localize)(6,null)),e.ActiveEditorCanSplitInGroupContext=new T.RawContextKey("activeEditorCanSplitInGroup",!0),e.ActiveEditorContext=new T.RawContextKey("activeEditor",null,{type:"string",description:(0,S.localize)(7,null)}),e.ActiveEditorAvailableEditorIdsContext=new T.RawContextKey("activeEditorAvailableEditorIds","",(0,S.localize)(8,null)),e.TextCompareEditorVisibleContext=new T.RawContextKey("textCompareEditorVisible",!1,(0,S.localize)(9,null)),e.TextCompareEditorActiveContext=new T.RawContextKey("textCompareEditorActive",!1,(0,S.localize)(10,null)),e.SideBySideEditorActiveContext=new T.RawContextKey("sideBySideEditorActive",!1,(0,S.localize)(11,null)),e.EditorGroupEditorsCountContext=new T.RawContextKey("groupEditorsCount",0,(0,S.localize)(12,null)),e.ActiveEditorGroupEmptyContext=new T.RawContextKey("activeEditorGroupEmpty",!1,(0,S.localize)(13,null)),e.ActiveEditorGroupIndexContext=new T.RawContextKey("activeEditorGroupIndex",0,(0,S.localize)(14,null)),e.ActiveEditorGroupLastContext=new T.RawContextKey("activeEditorGroupLast",!1,(0,S.localize)(15,null)),e.ActiveEditorGroupLockedContext=new T.RawContextKey("activeEditorGroupLocked",!1,(0,S.localize)(16,null)),e.MultipleEditorGroupsContext=new T.RawContextKey("multipleEditorGroups",!1,(0,S.localize)(17,null)),e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext.toNegated(),e.EditorsVisibleContext=new T.RawContextKey("editorIsOpen",!1,(0,S.localize)(18,null)),e.InEditorZenModeContext=new T.RawContextKey("inZenMode",!1,(0,S.localize)(19,null)),e.IsCenteredLayoutContext=new T.RawContextKey("isCenteredLayout",!1,(0,S.localize)(20,null)),e.SplitEditorsVertically=new T.RawContextKey("splitEditorsVertically",!1,(0,S.localize)(21,null)),e.EditorAreaVisibleContext=new T.RawContextKey("editorAreaVisible",!0,(0,S.localize)(22,null)),e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";function m(j,_,U){for(const F of U.visibleEditorPanes)if(F.group.id===_&&j.matches(F.input))return F.getViewState()}e.findViewStateForEditor=m;function u(j){if(l(j))return!1;const _=j;return p.URI.isUri(_?.resource)}e.isResourceEditorInput=u;function c(j){if(l(j))return!1;const _=j;return _?.original!==void 0&&_.modified!==void 0}e.isResourceDiffEditorInput=c;function b(j){if(l(j)||c(j))return!1;const _=j;return _?.primary!==void 0&&_.secondary!==void 0}e.isResourceSideBySideEditorInput=b;function g(j){if(l(j))return!1;const _=j;return _?_.resource===void 0||_.resource.scheme===I.Schemas.untitled||_.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=g;var D;(function(j){j[j.SHORT=0]="SHORT",j[j.MEDIUM=1]="MEDIUM",j[j.LONG=2]="LONG"})(D=e.Verbosity||(e.Verbosity={}));var w;(function(j){j[j.EXPLICIT=1]="EXPLICIT",j[j.AUTO=2]="AUTO",j[j.FOCUS_CHANGE=3]="FOCUS_CHANGE",j[j.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(w=e.SaveReason||(e.SaveReason={}));var v;(function(j){j[j.None=0]="None",j[j.Readonly=2]="Readonly",j[j.Untitled=4]="Untitled",j[j.Singleton=8]="Singleton",j[j.RequiresTrust=16]="RequiresTrust",j[j.CanSplitInGroup=32]="CanSplitInGroup",j[j.ForceDescription=64]="ForceDescription"})(v=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class a extends P.Disposable{}e.AbstractEditorInput=a;function l(j){return j instanceof a}e.isEditorInput=l;function r(j){const _=j;return p.URI.isUri(_?.preferredResource)}function o(j){const _=j;return l(_?.primary)&&l(_?.secondary)}e.isSideBySideEditorInput=o;function i(j){const _=j;return l(_?.modified)&&l(_?.original)}e.isDiffEditorInput=i;function n(j){return l(j?.editor)}e.isEditorInputWithOptions=n;function s(j){const _=j;return n(j)&&_?.group!==void 0}e.isEditorInputWithOptionsAndGroup=s;function d(j){const _=j;return typeof _?.groupId=="number"&&l(_.editor)}e.isEditorIdentifier=d;var y;(function(j){j[j.UNKNOWN=0]="UNKNOWN",j[j.REPLACE=1]="REPLACE",j[j.MOVE=2]="MOVE",j[j.UNPIN=3]="UNPIN"})(y=e.EditorCloseContext||(e.EditorCloseContext={}));var A;(function(j){j[j.PRIMARY=1]="PRIMARY",j[j.SECONDARY=2]="SECONDARY",j[j.BOTH=3]="BOTH",j[j.ANY=4]="ANY"})(A=e.SideBySideEditor||(e.SideBySideEditor={}));class E{getOriginalUri(_,U){if(!_)return;if(U?.supportSideBySide){const{primary:M,secondary:V}=this.getSideEditors(_);if(M&&V){if(U?.supportSideBySide===A.BOTH)return{primary:this.getOriginalUri(M,{filterByScheme:U.filterByScheme}),secondary:this.getOriginalUri(V,{filterByScheme:U.filterByScheme})};if(U?.supportSideBySide===A.ANY)return this.getOriginalUri(M,{filterByScheme:U.filterByScheme})??this.getOriginalUri(V,{filterByScheme:U.filterByScheme});_=U.supportSideBySide===A.PRIMARY?M:V}}if(c(_)||b(_))return;const F=r(_)?_.preferredResource:_.resource;return!F||!U||!U.filterByScheme?F:this.filterUri(F,U.filterByScheme)}getSideEditors(_){return o(_)||b(_)?{primary:_.primary,secondary:_.secondary}:i(_)||c(_)?{primary:_.modified,secondary:_.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(_,U){if(!_)return;if(U?.supportSideBySide){const{primary:M,secondary:V}=this.getSideEditors(_);if(M&&V){if(U?.supportSideBySide===A.BOTH)return{primary:this.getCanonicalUri(M,{filterByScheme:U.filterByScheme}),secondary:this.getCanonicalUri(V,{filterByScheme:U.filterByScheme})};if(U?.supportSideBySide===A.ANY)return this.getCanonicalUri(M,{filterByScheme:U.filterByScheme})??this.getCanonicalUri(V,{filterByScheme:U.filterByScheme});_=U.supportSideBySide===A.PRIMARY?M:V}}if(c(_)||b(_))return;const F=_.resource;return!F||!U||!U.filterByScheme?F:this.filterUri(F,U.filterByScheme)}filterUri(_,U){if(Array.isArray(U)){if(U.some(F=>_.scheme===F))return _}else if(U===_.scheme)return _}}e.EditorResourceAccessor=new E;var R;(function(j){j[j.LEFT=0]="LEFT",j[j.RIGHT=1]="RIGHT"})(R=e.CloseDirection||(e.CloseDirection={}));class O{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(_){const U=this.instantiationService=_.get(t.IInstantiationService);for(const[F,M]of this.editorSerializerConstructors)this.createEditorSerializer(F,M,U);this.editorSerializerConstructors.clear()}createEditorSerializer(_,U,F){const M=F.createInstance(U);this.editorSerializerInstances.set(_,M)}registerFileEditorFactory(_){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=_}getFileEditorFactory(){return(0,k.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(_,U){if(this.editorSerializerConstructors.has(_)||this.editorSerializerInstances.has(_))throw new Error(`A editor serializer with type ID '${_}' was already registered.`);return this.instantiationService?this.createEditorSerializer(_,U,this.instantiationService):this.editorSerializerConstructors.set(_,U),(0,P.toDisposable)(()=>{this.editorSerializerConstructors.delete(_),this.editorSerializerInstances.delete(_)})}getEditorSerializer(_){return this.editorSerializerInstances.get(typeof _=="string"?_:_.typeId)}}h.Registry.add(e.EditorExtensions.EditorFactory,new O);async function K(j,_){if(!j||!j.length)return[];const U=await Promise.all(j.map(async F=>{const M=p.URI.revive(F.fileUri);if(!M||!await _.canHandleResource(M))return;let ee=F.exists,G=F.type;if(typeof ee!="boolean"||typeof G!="number")try{G=(await _.resolve(M)).isFile?f.FileType.File:f.FileType.Unknown,ee=!0}catch{ee=!1}if(!ee&&F.openOnlyIfExists||G!==f.FileType.File)return;const H={selection:ee?F.selection:void 0,pinned:!0,override:F.editorOverrideId};let q;return ee?q={resource:M,options:H}:q={resource:M,options:H,forceUntitled:!0},q}));return(0,C.coalesce)(U)}e.pathsToEditors=K;var te;(function(j){j[j.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",j[j.SEQUENTIAL=1]="SEQUENTIAL"})(te=e.EditorsOrder||(e.EditorsOrder={}))}),define(ue[243],de([0,1,63,53,65,10,4,2,71]),function(Y,e,S,k,p,P,t,T,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var f;(function(R){R[R.Markup=1]="Markup",R[R.Code=2]="Code"})(f=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",p.Mimes.latex,p.Mimes.markdown,"image/png","image/jpeg",p.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[p.Mimes.latex,p.Mimes.markdown,"application/json",p.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var C;(function(R){R[R.Running=1]="Running",R[R.Idle=2]="Idle"})(C=e.NotebookRunState||(e.NotebookRunState={}));var I;(function(R){R[R.Pending=2]="Pending",R[R.Executing=3]="Executing"})(I=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var m;(function(R){R[R.WithHardKernelDependency=0]="WithHardKernelDependency",R[R.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",R[R.Pure=2]="Pure",R[R.Never=3]="Never"})(m=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var u;(function(R){R.Always="always",R.Never="never",R.Optional="optional"})(u=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var c;(function(R){R[R.ModelChange=1]="ModelChange",R[R.Move=2]="Move",R[R.ChangeLanguage=5]="ChangeLanguage",R[R.Initialize=6]="Initialize",R[R.ChangeCellMetadata=7]="ChangeCellMetadata",R[R.Output=8]="Output",R[R.OutputItem=9]="OutputItem",R[R.ChangeCellContent=10]="ChangeCellContent",R[R.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",R[R.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",R[R.ChangeCellMime=13]="ChangeCellMime",R[R.Unknown=100]="Unknown"})(c=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var b;(function(R){R[R.Handle=0]="Handle",R[R.Index=1]="Index"})(b=e.SelectionStateType||(e.SelectionStateType={}));var g;(function(R){R[R.Replace=1]="Replace",R[R.Output=2]="Output",R[R.Metadata=3]="Metadata",R[R.CellLanguage=4]="CellLanguage",R[R.DocumentMetadata=5]="DocumentMetadata",R[R.Move=6]="Move",R[R.OutputItems=7]="OutputItems",R[R.PartialMetadata=8]="PartialMetadata",R[R.PartialInternalMetadata=9]="PartialInternalMetadata"})(g=e.CellEditType||(e.CellEditType={}));var D;(function(R){R.scheme=P.Schemas.vscodeNotebookCell;const O=/^ch(\d{7,})/;function K(M,V){return M.with({scheme:R.scheme,fragment:`ch${V.toString().padStart(7,"0")}${M.scheme!==P.Schemas.file?M.scheme:""}`})}R.generate=K;function te(M){if(M.scheme!==R.scheme)return;const V=O.exec(M.fragment);return V?{handle:Number(V[1]),notebook:M.with({scheme:M.fragment.substr(V[0].length)||P.Schemas.file,fragment:null})}:void 0}R.parse=te;function j(M,V,ee){return M.with({scheme:P.Schemas.vscodeNotebookCellOutput,fragment:`ch${V.toString().padStart(7,"0")},${ee??""},${M.scheme!==P.Schemas.file?M.scheme:""}`})}R.generateCellOutputUri=j;function _(M){if(M.scheme!==P.Schemas.vscodeNotebookCellOutput)return;const V=/^ch(\d{7,})\,([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(M.fragment);if(!V)return;const ee=Number(V[1]),G=V[2]&&V[2]!==""?V[2]:void 0,H=V[3];return{handle:ee,outputId:G,notebook:M.with({scheme:H||P.Schemas.file,fragment:null})}}R.parseCellOutputUri=_;function U(M,V,ee){return M.with({scheme:ee,fragment:`ch${V.toString().padStart(7,"0")}${M.scheme!==P.Schemas.file?M.scheme:""}`})}R.generateCellUri=U;function F(M,V){if(M.scheme!==V)return;const ee=O.exec(M.fragment);return ee?{handle:Number(ee[1]),notebook:M.with({scheme:M.fragment.substr(ee[0].length)||P.Schemas.file,fragment:null})}:void 0}R.parseCellUri=F})(D=e.CellUri||(e.CellUri={}));const w=new Map([["application/javascript",{supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["image/jpeg",{alwaysSecure:!0,supportedByCore:!0}],["image/git",{alwaysSecure:!0,supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["application/json",{alwaysSecure:!0,supportedByCore:!0}],[p.Mimes.latex,{alwaysSecure:!0,supportedByCore:!0}],[p.Mimes.text,{alwaysSecure:!0,supportedByCore:!0}],["text/html",{supportedByCore:!0}],["text/x-javascript",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.error",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/vnd.code.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function v(R){return w.get(R)?.alwaysSecure??!1}e.mimeTypeIsAlwaysSecure=v;function a(R){return w.get(R)?.supportedByCore??!1}e.mimeTypeSupportedByCore=a;function l(R){return w.get(R)?.mergeable??!1}e.mimeTypeIsMergeable=l;const r=R=>T.isWindows?R.replace(/\//g,"\\"):R;class o{constructor(O=[],K=e.NOTEBOOK_DISPLAY_ORDER){this.defaultOrder=K,this.order=[...new Set(O)].map(te=>({pattern:te,matches:S.parse(r(te))}))}sort(O){const K=new Map(k.Iterable.map(O,j=>[j,r(j)]));let te=[];for(const{matches:j}of this.order)for(const[_,U]of K)if(j(U)){te.push(_),K.delete(_);break}return K.size&&(te=te.concat([...K.keys()].sort((j,_)=>this.defaultOrder.indexOf(j)-this.defaultOrder.indexOf(_)))),te}prioritize(O,K){const te=this.findIndex(O);if(te===-1){this.order.unshift({pattern:O,matches:S.parse(r(O))});return}const j=new Set(K.map(U=>this.findIndex(U,te)));j.delete(-1);const _=Array.from(j).sort();this.order.splice(te+1,0,..._.map(U=>this.order[U]));for(let U=_.length-1;U>=0;U--)this.order.splice(_[U],1)}toArray(){return this.order.map(O=>O.pattern)}findIndex(O,K=this.order.length){const te=r(O);for(let j=0;j<K;j++)if(this.order[j].matches(te))return j;return-1}}e.MimeTypeDisplayOrder=o;function i(R,O,K,te=(j,_)=>j===_){const j=[];function _(M,V,ee){if(V===0&&ee.length===0)return;const G=j[j.length-1];G&&G.start+G.deleteCount===M?(G.deleteCount+=V,G.toInsert.push(...ee)):j.push({start:M,deleteCount:V,toInsert:ee})}let U=0,F=0;for(;;){if(U===R.length){_(U,0,O.slice(F));break}if(F===O.length){_(U,R.length-U,[]);break}const M=R[U],V=O[F];if(te(M,V)){U+=1,F+=1;continue}K(V)?(_(U,1,[]),U+=1):(_(U,0,[V]),F+=1)}return j}e.diff=i,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new h.RawContextKey("notebookEditorCursorAtBoundary","none");var n;(function(R){R.default="default",R.option="option"})(n=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function s(R){const O=R;return!!((typeof O.include=="string"||S.isRelativePattern(O.include))&&(typeof O.exclude=="string"||S.isRelativePattern(O.exclude)))}e.isDocumentExcludePattern=s;function d(R,O,K){if(Array.isArray(R.viewType)&&R.viewType.indexOf(O)>=0||R.viewType===O)return!0;if(R.filenamePattern){let te=s(R.filenamePattern)?R.filenamePattern.include:R.filenamePattern,j=s(R.filenamePattern)?R.filenamePattern.exclude:void 0;if(S.match(te,(0,t.basename)(K.fsPath).toLowerCase()))return!(j&&S.match(j,(0,t.basename)(K.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=d;class y{constructor(O){this.textModel=O}getElements(){const O=new Int32Array(this.textModel.cells.length);for(let K=0;K<this.textModel.cells.length;K++)O[K]=this.textModel.cells[K].getHashValue();return O}}e.CellSequence=y,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize"};var A;(function(R){R[R.Left=1]="Left",R[R.Right=2]="Right"})(A=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class E{static create(O){return`${E._prefix}${O}`}static parse(O){if(O.startsWith(E._prefix))return O.substr(E._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=E,E._prefix="notebook/"}),define(ue[117],de([0,1,7]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=e.IEnvironmentVariableService=void 0,e.IEnvironmentVariableService=(0,S.createDecorator)("environmentVariableService");var k;(function(p){p[p.Replace=1]="Replace",p[p.Append=2]="Append",p[p.Prepend=3]="Prepend"})(k=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}))}),define(ue[244],de([0,1,2,117]),function(Y,e,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MergedEnvironmentVariableCollection=void 0;class p{constructor(h){this.map=new Map,h.forEach((f,C)=>{const I=f.map.entries();let m=I.next();for(;!m.done;){const u=m.value[0];let c=this.map.get(u);if(c||(c=[],this.map.set(u,c)),c.length>0&&c[0].type===k.EnvironmentVariableMutatorType.Replace){m=I.next();continue}const b=m.value[1];c.unshift({extensionIdentifier:C,value:b.value,type:b.type}),m=I.next()}})}applyToProcessEnvironment(h,f){let C;S.isWindows&&(C={},Object.keys(h).forEach(I=>C[I.toLowerCase()]=I)),this.map.forEach((I,m)=>{const u=S.isWindows&&C[m.toLowerCase()]||m;I.forEach(c=>{const b=f?f(c.value):c.value;switch(c.type){case k.EnvironmentVariableMutatorType.Append:h[u]=(h[u]||"")+b;break;case k.EnvironmentVariableMutatorType.Prepend:h[u]=b+(h[u]||"");break;case k.EnvironmentVariableMutatorType.Replace:h[u]=b;break}})})}diff(h){const f=new Map,C=new Map,I=new Map;if(h.map.forEach((m,u)=>{const c=this.map.get(u),b=P(m,c);b&&f.set(u,b)}),this.map.forEach((m,u)=>{const c=h.map.get(u),b=P(m,c);b&&I.set(u,b)}),this.map.forEach((m,u)=>{const c=h.map.get(u),b=t(m,c);b&&C.set(u,b)}),!(f.size===0&&C.size===0&&I.size===0))return{added:f,changed:C,removed:I}}}e.MergedEnvironmentVariableCollection=p;function P(T,h){if(!h)return T;const f=new Set;h.forEach(I=>f.add(I.extensionIdentifier));const C=[];return T.forEach(I=>{f.has(I.extensionIdentifier)||C.push(I)}),C.length===0?void 0:C}function t(T,h){if(!h)return;const f=new Map;h.forEach(I=>f.set(I.extensionIdentifier,I));const C=[];return T.forEach(I=>{const m=f.get(I.extensionIdentifier);m&&(I.type!==m.type||I.value!==m.value)&&C.push(m)}),C.length===0?void 0:C}}),define(ue[118],de([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function S(p){return[...p.entries()]}e.serializeEnvironmentVariableCollection=S;function k(p){return new Map(p)}e.deserializeEnvironmentVariableCollection=k}),define(ue[245],de([0,1,4,86,2]),function(Y,e,S,k,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTerminalEnvironment=e.getDefaultShellArgs=e.getDefaultShell=e.createVariableResolver=e.getCwd=e.getLangEnvVariable=e.shouldSetLangEnvVariable=e.addTerminalEnvironmentKeys=e.mergeEnvironments=void 0;function P(a,l){if(!!l)if(p.isWindows)for(const r in l){let o=r;for(const n in a)if(r.toLowerCase()===n.toLowerCase()){o=n;break}const i=l[r];i!==void 0&&t(a,o,i)}else Object.keys(l).forEach(r=>{const o=l[r];o!==void 0&&t(a,r,o)})}e.mergeEnvironments=P;function t(a,l,r){typeof r=="string"?a[l]=r:delete a[l]}function T(a,l,r,o){a.TERM_PROGRAM="vscode",l&&(a.TERM_PROGRAM_VERSION=l),C(a,o)&&(a.LANG=I(r)),a.COLORTERM="truecolor"}e.addTerminalEnvironmentKeys=T;function h(a,l){if(!!l)for(const r of Object.keys(l)){const o=l[r];o&&(a[r]=o)}}function f(a,l){return Object.keys(l).forEach(r=>{const o=l[r];if(typeof o=="string")try{l[r]=a(o)}catch(i){l[r]=o}}),l}function C(a,l){if(l==="on")return!0;if(l==="auto"){const r=a.LANG;return!r||r.search(/\.UTF\-8$/)===-1&&r.search(/\.utf8$/)===-1&&r.search(/\.euc.+/)===-1}return!1}e.shouldSetLangEnvVariable=C;function I(a){const l=a?a.split("-"):[],r=l.length;if(r===0)return"en_US.UTF-8";if(r===1){const o={af:"ZA",am:"ET",be:"BY",bg:"BG",ca:"ES",cs:"CZ",da:"DK",de:"DE",el:"GR",en:"US",es:"ES",et:"EE",eu:"ES",fi:"FI",fr:"FR",he:"IL",hr:"HR",hu:"HU",hy:"AM",is:"IS",it:"IT",ja:"JP",kk:"KZ",ko:"KR",lt:"LT",nl:"NL",no:"NO",pl:"PL",pt:"BR",ro:"RO",ru:"RU",sk:"SK",sl:"SI",sr:"YU",sv:"SE",tr:"TR",uk:"UA",zh:"CN"};l[0]in o&&l.push(o[l[0]])}else l[1]=l[1].toUpperCase();return l.join("_")+".UTF-8"}e.getLangEnvVariable=I;function m(a,l,r,o,i,n){if(a.cwd){const d=typeof a.cwd=="object"?a.cwd.fsPath:a.cwd,y=u(d,r);return c(y||d)}let s;return!a.ignoreConfigurationCwd&&i&&(r&&(i=u(i,r,n)),i&&(S.isAbsolute(i)?s=i:o&&(s=S.join(o.fsPath,i)))),s||(s=o?o.fsPath:l||""),c(s)}e.getCwd=m;function u(a,l,r){if(l)try{return l(a)}catch(o){r?.error("Could not resolve terminal cwd",o);return}return a}function c(a){return p.OS===1&&a&&a[1]===":"?a[0].toUpperCase()+a.substr(1):a}function b(a,l,r){if(!!r)return o=>r.resolveWithEnvironment(l,a,o)}e.createVariableResolver=b;function g(a,l,r,o,i,n,s,d=p.platform){let y;s&&(y=w(a,"automationShell",d)),y||(y=w(a,"shell",d));let A=y||l;if(d===3&&!r&&o){const E=S.join(o,"Sysnative").replace(/\//g,"\\").toLowerCase();A&&A.toLowerCase().indexOf(E)===0&&(A=S.join(o,"System32",A.substr(E.length+1)))}if(A&&d===3&&(A=A.replace(/\//g,"\\")),i)try{A=i(A)}catch(E){n.error("Could not resolve shell",E)}return A}e.getDefaultShell=g;function D(a,l,r,o,i=p.platform){if(l&&w(a,"automationShell",i))return[];const n=i===3?"windows":i===1?"osx":"linux";let s=a(`terminal.integrated.shellArgs.${n}`);if(!s)return[];if(typeof s=="string"&&i===3)return r?r(s):s;if(r){const d=[];for(const y of s)try{d.push(r(y))}catch(A){o.error(`Could not resolve terminal.integrated.shellArgs.${n}`,A),d.push(y)}s=d}return s}e.getDefaultShellArgs=D;function w(a,l,r=p.platform){return a(`terminal.integrated.${l}.${r===3?"windows":r===1?"osx":"linux"}`)}function v(a,l,r,o,i,n){const s={};if(a.strictEnv)h(s,a.env);else{h(s,n);const d={...l};r&&(d&&f(r,d),a.env&&f(r,a.env)),(0,k.sanitizeProcessEnvironment)(s,"VSCODE_IPC_HOOK_CLI","VSCODE_PROXY_URI"),P(s,d),P(s,a.env),T(s,o,p.locale,i)}return s}e.createTerminalEnvironment=v}),define(ue[246],de([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var S;(function(P){P.Delimiter="\0"})(S=e.TestIdPathParts||(e.TestIdPathParts={}));var k;(function(P){P[P.IsSame=0]="IsSame",P[P.Disconnected=1]="Disconnected",P[P.IsChild=2]="IsChild",P[P.IsParent=3]="IsParent"})(k=e.TestPosition||(e.TestPosition={}));class p{constructor(t,T=t.length){if(this.path=t,this.viewEnd=T,t.length===0||T<1)throw new Error("cannot create test with empty path")}static fromExtHostTestItem(t,T,h=t.parent){if(t.id===T)return new p([T]);let f=[t.id];for(let C=h;C&&C.id!==T;C=C.parent)f.push(C.id);return f.push(T),new p(f.reverse())}static isRoot(t){return!t.includes("\0")}static fromString(t){return new p(t.split("\0"))}static join(t,T){return new p([...t.path,T])}static joinToString(t,T){return t.toString()+"\0"+T}static compare(t,T){return t===T?0:T.startsWith(t+"\0")?2:t.startsWith(T+"\0")?3:1}get parentId(){return this.viewEnd>1?new p(this.path,this.viewEnd-1):this}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let t=1;t<=this.viewEnd;t++)yield new p(this.path,t)}compare(t){if(typeof t=="string")return p.compare(this.toString(),t);for(let T=0;T<t.viewEnd&&T<this.viewEnd;T++)if(t.path[T]!==this.path[T])return 1;return t.viewEnd>this.viewEnd?2:t.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let t=1;t<this.viewEnd;t++)this.stringifed+="\0",this.stringifed+=this.path[t]}return this.stringifed}}e.TestId=p}),define(ue[247],de([0,1,27,7]),function(Y,e,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TASKS_DEFAULT=e.IWorkbenchConfigurationService=e.USER_STANDALONE_CONFIGURATIONS=e.WORKSPACE_STANDALONE_CONFIGURATIONS=e.LAUNCH_CONFIGURATION_KEY=e.TASKS_CONFIGURATION_KEY=e.FOLDER_SCOPES=e.WORKSPACE_SCOPES=e.REMOTE_MACHINE_SCOPES=e.LOCAL_MACHINE_SCOPES=e.tasksSchemaId=e.launchSchemaId=e.folderSettingsSchemaId=e.workspaceSettingsSchemaId=e.machineSettingsSchemaId=e.userSettingsSchemaId=e.defaultSettingsSchemaId=e.FOLDER_SETTINGS_PATH=e.FOLDER_SETTINGS_NAME=e.FOLDER_CONFIG_FOLDER_NAME=void 0,e.FOLDER_CONFIG_FOLDER_NAME=".vscode",e.FOLDER_SETTINGS_NAME="settings",e.FOLDER_SETTINGS_PATH=`${e.FOLDER_CONFIG_FOLDER_NAME}/${e.FOLDER_SETTINGS_NAME}.json`,e.defaultSettingsSchemaId="vscode://schemas/settings/default",e.userSettingsSchemaId="vscode://schemas/settings/user",e.machineSettingsSchemaId="vscode://schemas/settings/machine",e.workspaceSettingsSchemaId="vscode://schemas/settings/workspace",e.folderSettingsSchemaId="vscode://schemas/settings/folder",e.launchSchemaId="vscode://schemas/launch",e.tasksSchemaId="vscode://schemas/tasks",e.LOCAL_MACHINE_SCOPES=[1,3,4,5],e.REMOTE_MACHINE_SCOPES=[2,3,4,5,6],e.WORKSPACE_SCOPES=[3,4,5,6],e.FOLDER_SCOPES=[4,5,6],e.TASKS_CONFIGURATION_KEY="tasks",e.LAUNCH_CONFIGURATION_KEY="launch",e.WORKSPACE_STANDALONE_CONFIGURATIONS=Object.create(null),e.WORKSPACE_STANDALONE_CONFIGURATIONS[e.TASKS_CONFIGURATION_KEY]=`${e.FOLDER_CONFIG_FOLDER_NAME}/${e.TASKS_CONFIGURATION_KEY}.json`,e.WORKSPACE_STANDALONE_CONFIGURATIONS[e.LAUNCH_CONFIGURATION_KEY]=`${e.FOLDER_CONFIG_FOLDER_NAME}/${e.LAUNCH_CONFIGURATION_KEY}.json`,e.USER_STANDALONE_CONFIGURATIONS=Object.create(null),e.USER_STANDALONE_CONFIGURATIONS[e.TASKS_CONFIGURATION_KEY]=`${e.TASKS_CONFIGURATION_KEY}.json`,e.IWorkbenchConfigurationService=(0,k.refineServiceDecorator)(S.IConfigurationService),e.TASKS_DEFAULT=`{
	"version": "2.0.0",
	"tasks": []
}`}),define(ue[248],de([0,1,7]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IConfigurationResolverService=void 0,e.IConfigurationResolverService=(0,S.createDecorator)("configurationResolverService")}),define(ue[249],de([0,1,4,23,11,21,2,64,182]),function(Y,e,S,k,p,P,t,T,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class f{constructor(I,m,u){this._contributedVariables=new Map,this._context=I,this._labelService=m,u&&(this._envVariablesPromise=u.then(c=>this.prepareEnv(c)))}prepareEnv(I){if(t.isWindows){const m=Object.create(null);return Object.keys(I).forEach(u=>{m[u.toLowerCase()]=I[u]}),m}return I}resolveWithEnvironment(I,m,u){return this.recursiveResolve(this.prepareEnv(I),m?m.uri:void 0,u)}async resolveAsync(I,m){return this.recursiveResolve(await this._envVariablesPromise,I?I.uri:void 0,m)}async resolveAnyBase(I,m,u,c){const b=P.deepClone(m);return t.isWindows&&b.windows?Object.keys(b.windows).forEach(g=>b[g]=b.windows[g]):t.isMacintosh&&b.osx?Object.keys(b.osx).forEach(g=>b[g]=b.osx[g]):t.isLinux&&b.linux&&Object.keys(b.linux).forEach(g=>b[g]=b.linux[g]),delete b.windows,delete b.osx,delete b.linux,this.recursiveResolve(await this._envVariablesPromise,I?I.uri:void 0,b,u,c)}async resolveAnyAsync(I,m,u){return this.resolveAnyBase(I,m,u)}async resolveAnyMap(I,m,u){const c=new Map;return{newConfig:await this.resolveAnyBase(I,m,u,c),resolvedVariables:c}}resolveWithInteractionReplace(I,m,u,c){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(I,m,u,c){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(I,m){if(this._contributedVariables.has(I))throw new Error("Variable "+I+" is contributed twice.");this._contributedVariables.set(I,m)}recursiveResolve(I,m,u,c,b){if(p.isString(u))return this.resolveString(I,m,u,c,b);if(p.isArray(u))return u.map(g=>this.recursiveResolve(I,m,g,c,b));if(p.isObject(u)){let g=Object.create(null);return Object.keys(u).forEach(D=>{const w=this.resolveString(I,m,D,c,b);g[w]=this.recursiveResolve(I,m,u[D],c,b)}),g}return u}resolveString(I,m,u,c,b){return u.replace(f.VARIABLE_REGEXP,(D,w)=>{if(w.includes(f.VARIABLE_LHS))return D;let v=this.evaluateSingleVariable(I,D,w,m,c);return b&&b.set(w,v),v!==D&&p.isString(v)&&v.match(f.VARIABLE_REGEXP)&&(v=this.resolveString(I,m,v,c,b)),v})}fsPath(I){return this._labelService?this._labelService.getUriLabel(I,{noPrefix:!0}):I.fsPath}evaluateSingleVariable(I,m,u,c,b){let g;const D=u.split(":");D.length>1&&(u=D[0],g=D[1]);const w=()=>{const l=this._context.getFilePath();if(l)return l;throw new Error((0,h.localize)(0,null,m))},v=()=>{const l=w();if(this._context.getWorkspaceFolderPathForFile){const r=this._context.getWorkspaceFolderPathForFile();if(r)return r}throw new Error((0,h.localize)(1,null,m,S.basename(l)))},a=()=>{if(g){const l=this._context.getFolderUri(g);if(l)return l;throw new Error((0,h.localize)(2,null,m,g))}if(c)return c;throw this._context.getWorkspaceFolderCount()>1?new Error((0,h.localize)(3,null,m)):new Error((0,h.localize)(4,null,m))};switch(u){case"env":if(g){if(I){const l=I[t.isWindows?g.toLowerCase():g];if(p.isString(l))return l}return""}throw new Error((0,h.localize)(5,null,m));case"config":if(g){const l=this._context.getConfigurationValue(c,g);if(p.isUndefinedOrNull(l))throw new Error((0,h.localize)(6,null,m,g));if(p.isObject(l))throw new Error((0,h.localize)(7,null,m,g));return l}throw new Error((0,h.localize)(8,null,m));case"command":return this.resolveFromMap(m,g,b,"command");case"input":return this.resolveFromMap(m,g,b,"input");default:switch(u){case"workspaceRoot":case"workspaceFolder":return(0,T.normalizeDriveLetter)(this.fsPath(a()));case"cwd":return c||g?(0,T.normalizeDriveLetter)(this.fsPath(a())):k.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return S.basename(this.fsPath(a()));case"lineNumber":const l=this._context.getLineNumber();if(l)return l;throw new Error((0,h.localize)(9,null,m));case"selectedText":const r=this._context.getSelectedText();if(r)return r;throw new Error((0,h.localize)(10,null,m));case"file":return w();case"fileWorkspaceFolder":return v();case"relativeFile":return c||g?S.relative(this.fsPath(a()),w()):w();case"relativeFileDirname":const o=S.dirname(w());if(c||g){const d=S.relative(this.fsPath(a()),o);return d.length===0?".":d}return o;case"fileDirname":return S.dirname(w());case"fileExtname":return S.extname(w());case"fileBasename":return S.basename(w());case"fileBasenameNoExtension":const i=S.basename(w());return i.slice(0,i.length-S.extname(i).length);case"fileDirnameBasename":return S.basename(S.dirname(w()));case"execPath":const n=this._context.getExecPath();return n||m;case"execInstallFolder":const s=this._context.getAppRoot();return s||m;case"pathSeparator":return S.sep;default:try{const d=g?`${u}:${g}`:u;return this.resolveFromMap(m,d,b,void 0)}catch(d){return m}}}}resolveFromMap(I,m,u,c){if(m&&u){const b=c===void 0?u[m]:u[c+":"+m];if(typeof b=="string")return b;throw new Error((0,h.localize)(11,null,I))}return I}}e.AbstractVariableResolverService=f,f.VARIABLE_LHS="${",f.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(ue[250],de([0,1,7,116]),function(Y,e,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupChangeKind=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,S.createDecorator)("editorGroupsService");var p;(function(b){b[b.UP=0]="UP",b[b.DOWN=1]="DOWN",b[b.LEFT=2]="LEFT",b[b.RIGHT=3]="RIGHT"})(p=e.GroupDirection||(e.GroupDirection={}));var P;(function(b){b[b.HORIZONTAL=0]="HORIZONTAL",b[b.VERTICAL=1]="VERTICAL"})(P=e.GroupOrientation||(e.GroupOrientation={}));var t;(function(b){b[b.FIRST=0]="FIRST",b[b.LAST=1]="LAST",b[b.NEXT=2]="NEXT",b[b.PREVIOUS=3]="PREVIOUS"})(t=e.GroupLocation||(e.GroupLocation={}));var T;(function(b){b[b.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",b[b.EVEN=1]="EVEN",b[b.TOGGLE=2]="TOGGLE"})(T=e.GroupsArrangement||(e.GroupsArrangement={}));var h;(function(b){b[b.COPY_EDITORS=0]="COPY_EDITORS",b[b.MOVE_EDITORS=1]="MOVE_EDITORS"})(h=e.MergeGroupMode||(e.MergeGroupMode={}));function f(b){const g=b;return(0,k.isEditorInput)(g?.editor)&&(0,k.isEditorInput)(g?.replacement)}e.isEditorReplacement=f;var C;(function(b){b[b.CREATION_TIME=0]="CREATION_TIME",b[b.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",b[b.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(C=e.GroupsOrder||(e.GroupsOrder={}));var I;(function(b){b[b.GROUP_ACTIVE=0]="GROUP_ACTIVE",b[b.GROUP_INDEX=1]="GROUP_INDEX",b[b.GROUP_LOCKED=2]="GROUP_LOCKED",b[b.EDITOR_OPEN=3]="EDITOR_OPEN",b[b.EDITOR_CLOSE=4]="EDITOR_CLOSE",b[b.EDITOR_MOVE=5]="EDITOR_MOVE",b[b.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",b[b.EDITOR_LABEL=7]="EDITOR_LABEL",b[b.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",b[b.EDITOR_PIN=9]="EDITOR_PIN",b[b.EDITOR_STICKY=10]="EDITOR_STICKY",b[b.EDITOR_DIRTY=11]="EDITOR_DIRTY"})(I=e.GroupChangeKind||(e.GroupChangeKind={}));var m;(function(b){b[b.NEW_EDITOR=1]="NEW_EDITOR",b[b.MOVE_EDITOR=2]="MOVE_EDITOR",b[b.COPY_EDITOR=3]="COPY_EDITOR"})(m=e.OpenEditorContext||(e.OpenEditorContext={}));function u(b){const g=b;return!!g&&typeof g.id=="number"&&Array.isArray(g.editors)}e.isEditorGroup=u;function c(b){return b.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=c}),define(ue[119],de([0,1,7,250]),function(Y,e,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,S.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function p(P){const t=P;return typeof P=="number"||(0,k.isEditorGroup)(t)}e.isPreferredGroup=p}),define(ue[251],de([0,1,20,18,87,283,54,21,11,5,67,200,191,211,114,243,246,119,115]),function(Y,e,S,k,p,P,t,T,h,f,C,I,m,u,c,b,g,D,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var v;(function(le){function he($){const{selectionStartLineNumber:ye,selectionStartColumn:Te,positionLineNumber:Ge,positionColumn:Me}=$,it=new w.Position(ye-1,Te-1),ct=new w.Position(Ge-1,Me-1);return new w.Selection(it,ct)}le.to=he;function X($){const{anchor:ye,active:Te}=$;return{selectionStartLineNumber:ye.line+1,selectionStartColumn:ye.character+1,positionLineNumber:Te.line+1,positionColumn:Te.character+1}}le.from=X})(v=e.Selection||(e.Selection={}));var a;(function(le){function he($){if(!$)return;const{start:ye,end:Te}=$;return{startLineNumber:ye.line+1,startColumn:ye.character+1,endLineNumber:Te.line+1,endColumn:Te.character+1}}le.from=he;function X($){if(!$)return;const{startLineNumber:ye,startColumn:Te,endLineNumber:Ge,endColumn:Me}=$;return new w.Range(ye-1,Te-1,Ge-1,Me-1)}le.to=X})(a=e.Range||(e.Range={}));var l;(function(le){function he(X){switch(X){case 1:return w.StandardTokenType.Comment;case 0:return w.StandardTokenType.Other;case 4:return w.StandardTokenType.RegEx;case 2:return w.StandardTokenType.String}}le.to=he})(l=e.TokenType||(e.TokenType={}));var r;(function(le){function he($){return new w.Position($.lineNumber-1,$.column-1)}le.to=he;function X($){return{lineNumber:$.line+1,column:$.character+1}}le.from=X})(r=e.Position||(e.Position={}));var o;(function(le){function he(ye,Te){return(0,S.coalesce)((0,S.asArray)(ye).map(Ge=>X(Ge,Te)))}le.from=he;function X(ye,Te){if(typeof ye=="string")return{$serialized:!0,language:ye};if(ye)return{$serialized:!0,language:ye.language,scheme:$(ye.scheme,Te),pattern:typeof ye.pattern=="undefined"?void 0:at.from(ye.pattern),exclusive:ye.exclusive}}function $(ye,Te){return Te&&typeof ye=="string"?Te.transformOutgoingScheme(ye):ye}})(o=e.DocumentSelector||(e.DocumentSelector={}));var i;(function(le){function he($){switch($){case w.DiagnosticTag.Unnecessary:return 1;case w.DiagnosticTag.Deprecated:return 2}}le.from=he;function X($){switch($){case 1:return w.DiagnosticTag.Unnecessary;case 2:return w.DiagnosticTag.Deprecated;default:return}}le.to=X})(i=e.DiagnosticTag||(e.DiagnosticTag={}));var n;(function(le){function he($){let ye;return $.code&&((0,h.isString)($.code)||(0,h.isNumber)($.code)?ye=String($.code):ye={value:String($.code.value),target:$.code.target}),{...a.from($.range),message:$.message,source:$.source,code:ye,severity:d.from($.severity),relatedInformation:$.relatedInformation&&$.relatedInformation.map(s.from),tags:Array.isArray($.tags)?(0,S.coalesce)($.tags.map(i.from)):void 0}}le.from=he;function X($){const ye=new w.Diagnostic(a.to($),$.message,d.to($.severity));return ye.source=$.source,ye.code=(0,h.isString)($.code)?$.code:$.code?.value,ye.relatedInformation=$.relatedInformation&&$.relatedInformation.map(s.to),ye.tags=$.tags&&(0,S.coalesce)($.tags.map(i.to)),ye}le.to=X})(n=e.Diagnostic||(e.Diagnostic={}));var s;(function(le){function he($){return{...a.from($.location.range),message:$.message,resource:$.location.uri}}le.from=he;function X($){return new w.DiagnosticRelatedInformation(new w.Location($.resource,a.to($)),$.message)}le.to=X})(s=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var d;(function(le){function he($){switch($){case w.DiagnosticSeverity.Error:return u.MarkerSeverity.Error;case w.DiagnosticSeverity.Warning:return u.MarkerSeverity.Warning;case w.DiagnosticSeverity.Information:return u.MarkerSeverity.Info;case w.DiagnosticSeverity.Hint:return u.MarkerSeverity.Hint}return u.MarkerSeverity.Error}le.from=he;function X($){switch($){case u.MarkerSeverity.Info:return w.DiagnosticSeverity.Information;case u.MarkerSeverity.Warning:return w.DiagnosticSeverity.Warning;case u.MarkerSeverity.Error:return w.DiagnosticSeverity.Error;case u.MarkerSeverity.Hint:return w.DiagnosticSeverity.Hint;default:return w.DiagnosticSeverity.Error}}le.to=X})(d=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var y;(function(le){function he($){return typeof $=="number"&&$>=w.ViewColumn.One?$-1:$===w.ViewColumn.Beside?D.SIDE_GROUP:D.ACTIVE_GROUP}le.from=he;function X($){if(typeof $=="number"&&$>=0)return $+1;throw new Error("invalid 'EditorGroupColumn'")}le.to=X})(y=e.ViewColumn||(e.ViewColumn={}));function A(le){return typeof le.range!="undefined"}function E(le){return le.length===0?!0:!!A(le[0])}e.isDecorationOptionsArr=E;var R;(function(le){function he(Me){return Me.map(le.from)}le.fromMany=he;function X(Me){return Me&&typeof Me=="object"&&typeof Me.language=="string"&&typeof Me.value=="string"}function $(Me){let it;if(X(Me)){const{language:mt,value:vt}=Me;it={value:"```"+mt+`
`+vt+"\n```\n"}}else w.MarkdownString.isMarkdownString(Me)?it={value:Me.value,isTrusted:Me.isTrusted,supportThemeIcons:Me.supportThemeIcons,supportHtml:Me.supportHtml}:typeof Me=="string"?it={value:Me}:it={value:""};const ct=Object.create(null);it.uris=ct;const ft=mt=>{try{let vt=f.URI.parse(mt,!0);vt=vt.with({query:ye(vt.query,ct)}),ct[mt]=vt}catch(vt){}return""},ht=new P.Renderer;return ht.link=ft,ht.image=mt=>ft(p.parseHrefAndDimensions(mt).href),P(it.value,{renderer:ht}),it}le.from=$;function ye(Me,it){if(!Me)return Me;let ct;try{ct=(0,t.parse)(Me)}catch(ht){}if(!ct)return Me;let ft=!1;return ct=(0,T.cloneAndChange)(ct,ht=>{if(f.URI.isUri(ht)){const mt=`__uri_${Math.random().toString(16).slice(2,8)}`;return it[mt]=ht,ft=!0,mt}else return}),ft?JSON.stringify(ct):Me}function Te(Me){const it=new w.MarkdownString(Me.value,Me.supportThemeIcons);return it.isTrusted=Me.isTrusted,it.supportHtml=Me.supportHtml,it}le.to=Te;function Ge(Me){if(!!Me)return typeof Me=="string"?Me:le.from(Me)}le.fromStrict=Ge})(R=e.MarkdownString||(e.MarkdownString={}));function O(le){return E(le)?le.map(he=>({range:a.from(he.range),hoverMessage:Array.isArray(he.hoverMessage)?R.fromMany(he.hoverMessage):he.hoverMessage?R.from(he.hoverMessage):void 0,renderOptions:he.renderOptions})):le.map(he=>({range:a.from(he)}))}e.fromRangeOrRangeWithMessage=O;function K(le){return typeof le=="undefined"?le:typeof le=="string"?f.URI.file(le):le}e.pathOrURIToURI=K;var te;(function(le){function he(X){return typeof X=="undefined"?X:{contentText:X.contentText,contentIconPath:X.contentIconPath?K(X.contentIconPath):void 0,border:X.border,borderColor:X.borderColor,fontStyle:X.fontStyle,fontWeight:X.fontWeight,textDecoration:X.textDecoration,color:X.color,backgroundColor:X.backgroundColor,margin:X.margin,width:X.width,height:X.height}}le.from=he})(te=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var j;(function(le){function he(X){return typeof X=="undefined"?X:{backgroundColor:X.backgroundColor,outline:X.outline,outlineColor:X.outlineColor,outlineStyle:X.outlineStyle,outlineWidth:X.outlineWidth,border:X.border,borderColor:X.borderColor,borderRadius:X.borderRadius,borderSpacing:X.borderSpacing,borderStyle:X.borderStyle,borderWidth:X.borderWidth,fontStyle:X.fontStyle,fontWeight:X.fontWeight,textDecoration:X.textDecoration,cursor:X.cursor,color:X.color,opacity:X.opacity,letterSpacing:X.letterSpacing,gutterIconPath:X.gutterIconPath?K(X.gutterIconPath):void 0,gutterIconSize:X.gutterIconSize,overviewRulerColor:X.overviewRulerColor,before:X.before?te.from(X.before):void 0,after:X.after?te.from(X.after):void 0}}le.from=he})(j=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var _;(function(le){function he(X){if(typeof X=="undefined")return X;switch(X){case w.DecorationRangeBehavior.OpenOpen:return 0;case w.DecorationRangeBehavior.ClosedClosed:return 1;case w.DecorationRangeBehavior.OpenClosed:return 2;case w.DecorationRangeBehavior.ClosedOpen:return 3}}le.from=he})(_=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var U;(function(le){function he(X){return{isWholeLine:X.isWholeLine,rangeBehavior:X.rangeBehavior?_.from(X.rangeBehavior):void 0,overviewRulerLane:X.overviewRulerLane,light:X.light?j.from(X.light):void 0,dark:X.dark?j.from(X.dark):void 0,backgroundColor:X.backgroundColor,outline:X.outline,outlineColor:X.outlineColor,outlineStyle:X.outlineStyle,outlineWidth:X.outlineWidth,border:X.border,borderColor:X.borderColor,borderRadius:X.borderRadius,borderSpacing:X.borderSpacing,borderStyle:X.borderStyle,borderWidth:X.borderWidth,fontStyle:X.fontStyle,fontWeight:X.fontWeight,textDecoration:X.textDecoration,cursor:X.cursor,color:X.color,opacity:X.opacity,letterSpacing:X.letterSpacing,gutterIconPath:X.gutterIconPath?K(X.gutterIconPath):void 0,gutterIconSize:X.gutterIconSize,overviewRulerColor:X.overviewRulerColor,before:X.before?te.from(X.before):void 0,after:X.after?te.from(X.after):void 0}}le.from=he})(U=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var F;(function(le){function he($){return{text:$.newText,eol:$.newEol&&Pe.from($.newEol),range:a.from($.range)}}le.from=he;function X($){const ye=new w.TextEdit(a.to($.range),$.text);return ye.newEol=typeof $.eol=="undefined"?void 0:Pe.to($.eol),ye}le.to=X})(F=e.TextEdit||(e.TextEdit={}));var M;(function(le){function he($,ye,Te){const Ge={edits:[]};if($ instanceof w.WorkspaceEdit)for(let Me of $._allEntries())if(Me._type===1)Ge.edits.push({_type:1,oldUri:Me.from,newUri:Me.to,options:Me.options,metadata:Me.metadata});else if(Me._type===2){const it=ye?.getDocument(Me.uri);Ge.edits.push({_type:2,resource:Me.uri,edit:F.from(Me.edit),modelVersionId:it?.version,metadata:Me.metadata})}else Me._type===3?Ge.edits.push({_type:3,metadata:Me.metadata,resource:Me.uri,edit:Me.edit,notebookMetadata:Me.notebookMetadata,notebookVersionId:Te?.getNotebookDocument(Me.uri,!0)?.apiNotebook.version}):Me._type===5&&Ge.edits.push({_type:3,metadata:Me.metadata,resource:Me.uri,notebookVersionId:Te?.getNotebookDocument(Me.uri,!0)?.apiNotebook.version,edit:{editType:1,index:Me.index,count:Me.count,cells:Me.cells.map(Ae.from)}});return Ge}le.from=he;function X($){const ye=new w.WorkspaceEdit;for(const Te of $.edits)Te.edit?ye.replace(f.URI.revive(Te.resource),a.to(Te.edit.range),Te.edit.text):ye.renameFile(f.URI.revive(Te.oldUri),f.URI.revive(Te.newUri),Te.options);return ye}le.to=X})(M=e.WorkspaceEdit||(e.WorkspaceEdit={}));var V;(function(le){const he=Object.create(null);he[w.SymbolKind.File]=0,he[w.SymbolKind.Module]=1,he[w.SymbolKind.Namespace]=2,he[w.SymbolKind.Package]=3,he[w.SymbolKind.Class]=4,he[w.SymbolKind.Method]=5,he[w.SymbolKind.Property]=6,he[w.SymbolKind.Field]=7,he[w.SymbolKind.Constructor]=8,he[w.SymbolKind.Enum]=9,he[w.SymbolKind.Interface]=10,he[w.SymbolKind.Function]=11,he[w.SymbolKind.Variable]=12,he[w.SymbolKind.Constant]=13,he[w.SymbolKind.String]=14,he[w.SymbolKind.Number]=15,he[w.SymbolKind.Boolean]=16,he[w.SymbolKind.Array]=17,he[w.SymbolKind.Object]=18,he[w.SymbolKind.Key]=19,he[w.SymbolKind.Null]=20,he[w.SymbolKind.EnumMember]=21,he[w.SymbolKind.Struct]=22,he[w.SymbolKind.Event]=23,he[w.SymbolKind.Operator]=24,he[w.SymbolKind.TypeParameter]=25;function X(ye){return typeof he[ye]=="number"?he[ye]:6}le.from=X;function $(ye){for(const Te in he)if(he[Te]===ye)return Number(Te);return w.SymbolKind.Property}le.to=$})(V=e.SymbolKind||(e.SymbolKind={}));var ee;(function(le){function he($){switch($){case w.SymbolTag.Deprecated:return 1}}le.from=he;function X($){switch($){case 1:return w.SymbolTag.Deprecated}}le.to=X})(ee=e.SymbolTag||(e.SymbolTag={}));var G;(function(le){function he($){return{name:$.name,kind:V.from($.kind),tags:$.tags&&$.tags.map(ee.from),containerName:$.containerName,location:W.from($.location)}}le.from=he;function X($){const ye=new w.SymbolInformation($.name,V.to($.kind),$.containerName,W.to($.location));return ye.tags=$.tags&&$.tags.map(ee.to),ye}le.to=X})(G=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var H;(function(le){function he($){const ye={name:$.name||"!!MISSING: name!!",detail:$.detail,range:a.from($.range),selectionRange:a.from($.selectionRange),kind:V.from($.kind),tags:$.tags?.map(ee.from)??[]};return $.children&&(ye.children=$.children.map(he)),ye}le.from=he;function X($){const ye=new w.DocumentSymbol($.name,$.detail,V.to($.kind),a.to($.range),a.to($.selectionRange));return(0,S.isNonEmptyArray)($.tags)&&(ye.tags=$.tags.map(ee.to)),$.children&&(ye.children=$.children.map(X)),ye}le.to=X})(H=e.DocumentSymbol||(e.DocumentSymbol={}));var q;(function(le){function he($){const ye=new w.CallHierarchyItem(V.to($.kind),$.name,$.detail||"",f.URI.revive($.uri),a.to($.range),a.to($.selectionRange));return ye._sessionId=$._sessionId,ye._itemId=$._itemId,ye}le.to=he;function X($,ye,Te){if(ye=ye??$._sessionId,Te=Te??$._itemId,ye===void 0||Te===void 0)throw new Error("invalid item");return{_sessionId:ye,_itemId:Te,name:$.name,detail:$.detail,kind:V.from($.kind),uri:$.uri,range:a.from($.range),selectionRange:a.from($.selectionRange),tags:$.tags?.map(ee.from)}}le.from=X})(q=e.CallHierarchyItem||(e.CallHierarchyItem={}));var z;(function(le){function he(X){return new w.CallHierarchyIncomingCall(q.to(X.from),X.fromRanges.map($=>a.to($)))}le.to=he})(z=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var B;(function(le){function he(X){return new w.CallHierarchyOutgoingCall(q.to(X.to),X.fromRanges.map($=>a.to($)))}le.to=he})(B=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var W;(function(le){function he($){return{range:$.range&&a.from($.range),uri:$.uri}}le.from=he;function X($){return new w.Location(f.URI.revive($.uri),a.to($.range))}le.to=X})(W=e.location||(e.location={}));var ie;(function(le){function he($){const ye=$,Te=$;return{originSelectionRange:ye.originSelectionRange?a.from(ye.originSelectionRange):void 0,uri:ye.targetUri?ye.targetUri:Te.uri,range:a.from(ye.targetRange?ye.targetRange:Te.range),targetSelectionRange:ye.targetSelectionRange?a.from(ye.targetSelectionRange):void 0}}le.from=he;function X($){return{targetUri:f.URI.revive($.uri),targetRange:a.to($.range),targetSelectionRange:$.targetSelectionRange?a.to($.targetSelectionRange):void 0,originSelectionRange:$.originSelectionRange?a.to($.originSelectionRange):void 0}}le.to=X})(ie=e.DefinitionLink||(e.DefinitionLink={}));var oe;(function(le){function he($){return{range:a.from($.range),contents:R.fromMany($.contents)}}le.from=he;function X($){return new w.Hover($.contents.map(R.to),a.to($.range))}le.to=X})(oe=e.Hover||(e.Hover={}));var we;(function(le){function he($){return{range:a.from($.range),expression:$.expression}}le.from=he;function X($){return new w.EvaluatableExpression(a.to($.range),$.expression)}le.to=X})(we=e.EvaluatableExpression||(e.EvaluatableExpression={}));var se;(function(le){function he($){if($ instanceof w.InlineValueText)return{type:"text",range:a.from($.range),text:$.text};if($ instanceof w.InlineValueVariableLookup)return{type:"variable",range:a.from($.range),variableName:$.variableName,caseSensitiveLookup:$.caseSensitiveLookup};if($ instanceof w.InlineValueEvaluatableExpression)return{type:"expression",range:a.from($.range),expression:$.expression};throw new Error("Unknown 'InlineValue' type")}le.from=he;function X($){switch($.type){case"text":return{range:a.to($.range),text:$.text};case"variable":return{range:a.to($.range),variableName:$.variableName,caseSensitiveLookup:$.caseSensitiveLookup};case"expression":return{range:a.to($.range),expression:$.expression}}}le.to=X})(se=e.InlineValue||(e.InlineValue={}));var ae;(function(le){function he($){return{frameId:$.frameId,stoppedLocation:a.from($.stoppedLocation)}}le.from=he;function X($){return new w.InlineValueContext($.frameId,a.to($.stoppedLocation))}le.to=X})(ae=e.InlineValueContext||(e.InlineValueContext={}));var ke;(function(le){function he($){return{range:a.from($.range),kind:$.kind}}le.from=he;function X($){return new w.DocumentHighlight(a.to($.range),$.kind)}le.to=X})(ke=e.DocumentHighlight||(e.DocumentHighlight={}));var De;(function(le){function he(X){switch(X){case 1:return w.CompletionTriggerKind.TriggerCharacter;case 2:return w.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return w.CompletionTriggerKind.Invoke}}le.to=he})(De=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Oe;(function(le){function he(X){return{triggerKind:De.to(X.triggerKind),triggerCharacter:X.triggerCharacter}}le.to=he})(Oe=e.CompletionContext||(e.CompletionContext={}));var Be;(function(le){function he($){switch($){case w.CompletionItemTag.Deprecated:return 1}}le.from=he;function X($){switch($){case 1:return w.CompletionItemTag.Deprecated}}le.to=X})(Be=e.CompletionItemTag||(e.CompletionItemTag={}));var Xe;(function(le){const he=new Map([[w.CompletionItemKind.Method,0],[w.CompletionItemKind.Function,1],[w.CompletionItemKind.Constructor,2],[w.CompletionItemKind.Field,3],[w.CompletionItemKind.Variable,4],[w.CompletionItemKind.Class,5],[w.CompletionItemKind.Interface,7],[w.CompletionItemKind.Struct,6],[w.CompletionItemKind.Module,8],[w.CompletionItemKind.Property,9],[w.CompletionItemKind.Unit,12],[w.CompletionItemKind.Value,13],[w.CompletionItemKind.Constant,14],[w.CompletionItemKind.Enum,15],[w.CompletionItemKind.EnumMember,16],[w.CompletionItemKind.Keyword,17],[w.CompletionItemKind.Snippet,27],[w.CompletionItemKind.Text,18],[w.CompletionItemKind.Color,19],[w.CompletionItemKind.File,20],[w.CompletionItemKind.Reference,21],[w.CompletionItemKind.Folder,23],[w.CompletionItemKind.Event,10],[w.CompletionItemKind.Operator,11],[w.CompletionItemKind.TypeParameter,24],[w.CompletionItemKind.Issue,26],[w.CompletionItemKind.User,25]]);function X(Te){return he.get(Te)??9}le.from=X;const $=new Map([[0,w.CompletionItemKind.Method],[1,w.CompletionItemKind.Function],[2,w.CompletionItemKind.Constructor],[3,w.CompletionItemKind.Field],[4,w.CompletionItemKind.Variable],[5,w.CompletionItemKind.Class],[7,w.CompletionItemKind.Interface],[6,w.CompletionItemKind.Struct],[8,w.CompletionItemKind.Module],[9,w.CompletionItemKind.Property],[12,w.CompletionItemKind.Unit],[13,w.CompletionItemKind.Value],[14,w.CompletionItemKind.Constant],[15,w.CompletionItemKind.Enum],[16,w.CompletionItemKind.EnumMember],[17,w.CompletionItemKind.Keyword],[27,w.CompletionItemKind.Snippet],[18,w.CompletionItemKind.Text],[19,w.CompletionItemKind.Color],[20,w.CompletionItemKind.File],[21,w.CompletionItemKind.Reference],[23,w.CompletionItemKind.Folder],[10,w.CompletionItemKind.Event],[11,w.CompletionItemKind.Operator],[24,w.CompletionItemKind.TypeParameter],[25,w.CompletionItemKind.User],[26,w.CompletionItemKind.Issue]]);function ye(Te){return $.get(Te)??w.CompletionItemKind.Property}le.to=ye})(Xe=e.CompletionItemKind||(e.CompletionItemKind={}));var Ze;(function(le){function he(X,$){const ye=new w.CompletionItem(X.label);return ye.insertText=X.insertText,ye.kind=Xe.to(X.kind),ye.tags=X.tags?.map(Be.to),ye.detail=X.detail,ye.documentation=p.isMarkdownString(X.documentation)?R.to(X.documentation):X.documentation,ye.sortText=X.sortText,ye.filterText=X.filterText,ye.preselect=X.preselect,ye.commitCharacters=X.commitCharacters,C.Range.isIRange(X.range)?ye.range=a.to(X.range):typeof X.range=="object"&&(ye.range={inserting:a.to(X.range.insert),replacing:a.to(X.range.replace)}),ye.keepWhitespace=typeof X.insertTextRules=="undefined"?!1:Boolean(X.insertTextRules&1),typeof X.insertTextRules!="undefined"&&X.insertTextRules&4?ye.insertText=new w.SnippetString(X.insertText):(ye.insertText=X.insertText,ye.textEdit=ye.range instanceof w.Range?new w.TextEdit(ye.range,ye.insertText):void 0),X.additionalTextEdits&&X.additionalTextEdits.length>0&&(ye.additionalTextEdits=X.additionalTextEdits.map(Te=>F.to(Te))),ye.command=$&&X.command?$.fromInternal(X.command):void 0,ye}le.to=he})(Ze=e.CompletionItem||(e.CompletionItem={}));var ge;(function(le){function he($){return{label:$.label,documentation:$.documentation?R.fromStrict($.documentation):void 0}}le.from=he;function X($){return{label:$.label,documentation:p.isMarkdownString($.documentation)?R.to($.documentation):$.documentation}}le.to=X})(ge=e.ParameterInformation||(e.ParameterInformation={}));var me;(function(le){function he($){return{label:$.label,documentation:$.documentation?R.fromStrict($.documentation):void 0,parameters:Array.isArray($.parameters)?$.parameters.map(ge.from):[],activeParameter:$.activeParameter}}le.from=he;function X($){return{label:$.label,documentation:p.isMarkdownString($.documentation)?R.to($.documentation):$.documentation,parameters:Array.isArray($.parameters)?$.parameters.map(ge.to):[],activeParameter:$.activeParameter}}le.to=X})(me=e.SignatureInformation||(e.SignatureInformation={}));var Ie;(function(le){function he($){return{activeSignature:$.activeSignature,activeParameter:$.activeParameter,signatures:Array.isArray($.signatures)?$.signatures.map(me.from):[]}}le.from=he;function X($){return{activeSignature:$.activeSignature,activeParameter:$.activeParameter,signatures:Array.isArray($.signatures)?$.signatures.map(me.to):[]}}le.to=X})(Ie=e.SignatureHelp||(e.SignatureHelp={}));var Re;(function(le){function he($){return{text:$.text,position:r.from($.position),kind:Le.from($.kind??w.InlayHintKind.Other),whitespaceBefore:$.whitespaceBefore,whitespaceAfter:$.whitespaceAfter}}le.from=he;function X($){const ye=new w.InlayHint($.text,r.to($.position),Le.to($.kind));return ye.whitespaceAfter=$.whitespaceAfter,ye.whitespaceBefore=$.whitespaceBefore,ye}le.to=X})(Re=e.InlayHint||(e.InlayHint={}));var Le;(function(le){function he($){return $}le.from=he;function X($){return $}le.to=X})(Le=e.InlayHintKind||(e.InlayHintKind={}));var He;(function(le){function he($){return{range:a.from($.range),url:$.target,tooltip:$.tooltip}}le.from=he;function X($){let ye;if($.url)try{ye=typeof $.url=="string"?f.URI.parse($.url,!0):f.URI.revive($.url)}catch(Te){}return new w.DocumentLink(a.to($.range),ye)}le.to=X})(He=e.DocumentLink||(e.DocumentLink={}));var Qe;(function(le){function he($){const ye=new w.ColorPresentation($.label);return $.textEdit&&(ye.textEdit=F.to($.textEdit)),$.additionalTextEdits&&(ye.additionalTextEdits=$.additionalTextEdits.map(Te=>F.to(Te))),ye}le.to=he;function X($){return{label:$.label,textEdit:$.textEdit?F.from($.textEdit):void 0,additionalTextEdits:$.additionalTextEdits?$.additionalTextEdits.map(ye=>F.from(ye)):void 0}}le.from=X})(Qe=e.ColorPresentation||(e.ColorPresentation={}));var Je;(function(le){function he($){return new w.Color($[0],$[1],$[2],$[3])}le.to=he;function X($){return[$.red,$.green,$.blue,$.alpha]}le.from=X})(Je=e.Color||(e.Color={}));var rt;(function(le){function he($){return{range:a.from($.range)}}le.from=he;function X($){return new w.SelectionRange(a.to($.range))}le.to=X})(rt=e.SelectionRange||(e.SelectionRange={}));var ce;(function(le){function he(X){switch(X){case 2:return w.TextDocumentSaveReason.AfterDelay;case 1:return w.TextDocumentSaveReason.Manual;case 3:case 4:return w.TextDocumentSaveReason.FocusOut}}le.to=he})(ce=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Se;(function(le){function he($){switch($){case w.TextEditorLineNumbersStyle.Off:return 0;case w.TextEditorLineNumbersStyle.Relative:return 2;case w.TextEditorLineNumbersStyle.On:default:return 1}}le.from=he;function X($){switch($){case 0:return w.TextEditorLineNumbersStyle.Off;case 2:return w.TextEditorLineNumbersStyle.Relative;case 1:default:return w.TextEditorLineNumbersStyle.On}}le.to=X})(Se=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Pe;(function(le){function he($){if($===w.EndOfLine.CRLF)return 1;if($===w.EndOfLine.LF)return 0}le.from=he;function X($){if($===1)return w.EndOfLine.CRLF;if($===0)return w.EndOfLine.LF}le.to=X})(Pe=e.EndOfLine||(e.EndOfLine={}));var $e;(function(le){function he(X){if(typeof X=="object")return X.viewId;switch(X){case w.ProgressLocation.SourceControl:return 3;case w.ProgressLocation.Window:return 10;case w.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}le.from=he})($e=e.ProgressLocation||(e.ProgressLocation={}));var Ye;(function(le){function he(X){const $={start:X.start+1,end:X.end+1};return X.kind&&($.kind=lt.from(X.kind)),$}le.from=he})(Ye=e.FoldingRange||(e.FoldingRange={}));var lt;(function(le){function he(X){if(X)switch(X){case w.FoldingRangeKind.Comment:return I.FoldingRangeKind.Comment;case w.FoldingRangeKind.Imports:return I.FoldingRangeKind.Imports;case w.FoldingRangeKind.Region:return I.FoldingRangeKind.Region}}le.from=he})(lt=e.FoldingRangeKind||(e.FoldingRangeKind={}));var tt;(function(le){function he(X){if(X)return{pinned:typeof X.preview=="boolean"?!X.preview:void 0,inactive:X.background,preserveFocus:X.preserveFocus,selection:typeof X.selection=="object"?a.from(X.selection):void 0,override:typeof X.override=="boolean"?m.EditorResolution.DISABLED:void 0}}le.from=he})(tt=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var at;(function(le){function he($){return $ instanceof w.RelativePattern||typeof $=="string"?$:X($)?new w.RelativePattern($.base,$.pattern):$}le.from=he;function X($){const ye=$;return ye&&typeof ye.base=="string"&&typeof ye.pattern=="string"}})(at=e.GlobPattern||(e.GlobPattern={}));var ot;(function(le){function he(X){if(X){if(Array.isArray(X))return X.map(he);if(typeof X=="string")return X;{const $=X;return{language:$.language,scheme:$.scheme,pattern:typeof $.pattern=="undefined"?void 0:at.from($.pattern),exclusive:$.exclusive}}}else return}le.from=he})(ot=e.LanguageSelector||(e.LanguageSelector={}));var et;(function(le){function he($){return{start:$.start,end:$.end}}le.from=he;function X($){return new w.NotebookRange($.start,$.end)}le.to=X})(et=e.NotebookRange||(e.NotebookRange={}));var ne;(function(le){function he($){return{timing:typeof $.runStartTime=="number"&&typeof $.runEndTime=="number"?{startTime:$.runStartTime,endTime:$.runEndTime}:void 0,executionOrder:$.executionOrder,success:$.lastRunSuccess}}le.to=he;function X($){return{lastRunSuccess:$.success,runStartTime:$.timing?.startTime,runEndTime:$.timing?.endTime,executionOrder:$.executionOrder}}le.from=X})(ne=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var be;(function(le){function he($){switch($){case w.NotebookCellKind.Markup:return b.CellKind.Markup;case w.NotebookCellKind.Code:default:return b.CellKind.Code}}le.from=he;function X($){switch($){case b.CellKind.Markup:return w.NotebookCellKind.Markup;case b.CellKind.Code:default:return w.NotebookCellKind.Code}}le.to=X})(be=e.NotebookCellKind||(e.NotebookCellKind={}));var Fe;(function(le){function he($){const ye={metadata:$.metadata??Object.create(null),cells:[]};for(let Te of $.cells)w.NotebookCellData.validate(Te),ye.cells.push(Ae.from(Te));return ye}le.from=he;function X($){const ye=new w.NotebookData($.cells.map(Ae.to));return(0,h.isEmptyObject)($.metadata)||(ye.metadata=$.metadata),ye}le.to=X})(Fe=e.NotebookData||(e.NotebookData={}));var Ae;(function(le){function he($){return{cellKind:be.from($.kind),language:$.languageId,mime:$.mime,source:$.value,metadata:$.metadata,internalMetadata:ne.from($.executionSummary??{}),outputs:$.outputs?$.outputs.map(ve.from):[]}}le.from=he;function X($){return new w.NotebookCellData(be.to($.cellKind),$.source,$.language,$.mime,$.outputs?$.outputs.map(ve.to):void 0,$.metadata,$.internalMetadata?ne.to($.internalMetadata):void 0)}le.to=X})(Ae=e.NotebookCellData||(e.NotebookCellData={}));var Ve;(function(le){function he($){return{mime:$.mime,valueBytes:k.VSBuffer.wrap($.data)}}le.from=he;function X($){return new w.NotebookCellOutputItem($.valueBytes.buffer,$.mime)}le.to=X})(Ve=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var ve;(function(le){function he($){return{outputId:$.id,items:$.items.map(Ve.from),metadata:$.metadata}}le.from=he;function X($){const ye=$.items.map(Ve.to);return new w.NotebookCellOutput(ye,$.outputId,$.metadata)}le.to=X})(ve=e.NotebookCellOutput||(e.NotebookCellOutput={}));var fe;(function(le){function he(Te){if(Te!=null){if(Te instanceof w.RelativePattern||typeof Te=="string")return Te;if(ye(Te))return new w.RelativePattern(Te.base,Te.pattern);if($(Te))return{include:at.from(Te.include)||void 0,exclude:at.from(Te.exclude)||void 0}}}le.from=he;function X(Te){return typeof Te=="string"?Te:ye(Te)?{base:Te.base,pattern:Te.pattern}:{include:Te.include,exclude:Te.exclude}}le.to=X;function $(Te){const Ge=Te,Me=at.from(Ge.include);if(!(Me&&Me instanceof w.RelativePattern||typeof Me=="string"))return!1;const it=at.from(Ge.exclude);return!!(it&&it instanceof w.RelativePattern||typeof it=="string")}function ye(Te){const Ge=Te;return Ge&&typeof Ge.base=="string"&&typeof Ge.pattern=="string"}})(fe=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var pe;(function(le){function he(X){return{backgroundColor:X.backgroundColor,borderColor:X.borderColor,top:X.top?te.from(X.top):void 0}}le.from=he})(pe=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var J;(function(le){function he(X,$,ye){const Te=typeof X.command=="string"?{title:"",command:X.command}:X.command;return{alignment:X.alignment===w.NotebookCellStatusBarAlignment.Left?1:2,command:$.toInternal(Te,ye),text:X.text,tooltip:X.tooltip,accessibilityInformation:X.accessibilityInformation,priority:X.priority}}le.from=he})(J=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var x;(function(le){function he(X){return{transientOutputs:X?.transientOutputs??!1,transientCellMetadata:X?.transientCellMetadata??{},transientDocumentMetadata:X?.transientDocumentMetadata??{}}}le.from=he})(x=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var Q;(function(le){function he($){return{uri:$.uri,provides:$.provides}}le.from=he;function X($){return new w.NotebookRendererScript(f.URI.revive($.uri),$.provides)}le.to=X})(Q=e.NotebookRendererScript||(e.NotebookRendererScript={}));var re;(function(le){function he($){return{message:R.fromStrict($.message)||"",type:0,expected:$.expectedOutput,actual:$.actualOutput,location:$.location?W.from($.location):void 0}}le.from=he;function X($){const ye=new w.TestMessage(typeof $.message=="string"?$.message:R.to($.message));return ye.actualOutput=$.actual,ye.expectedOutput=$.expected,ye.location=$.location?W.to($.location):void 0,ye}le.to=X})(re=e.TestMessage||(e.TestMessage={}));var Ee;(function(le){let he;(function(X){X.Delimiter="\0"})(he||(he={})),le.namespace=(X,$)=>X+"\0"+$,le.denamespace=X=>{const $=X.indexOf("\0");return{ctrlId:X.slice(0,$),tagId:X.slice($+1)}}})(Ee=e.TestTag||(e.TestTag={}));var Ue;(function(le){function he(Te){const Ge=(0,c.getPrivateApiFor)(Te).controllerId;return{extId:g.TestId.fromExtHostTestItem(Te,Ge).toString(),label:Te.label,uri:Te.uri,tags:Te.tags.map(Me=>Ee.namespace(Ge,Me.id)),range:a.from(Te.range)||null,description:Te.description||null,error:Te.error&&R.fromStrict(Te.error)||null}}le.from=he;function X(Te){return{parent:void 0,error:void 0,id:g.TestId.fromString(Te.extId).localId,label:Te.label,uri:f.URI.revive(Te.uri),tags:(Te.tags||[]).map(Ge=>{const{tagId:Me}=Ee.denamespace(Ge);return new w.TestTag(Me)}),range:a.to(Te.range||void 0),invalidateResults:()=>{},canResolveChildren:!1,busy:!1,description:Te.description||void 0}}le.toPlain=X;function $(Te){const Ge=g.TestId.fromString(Te.extId),Me=new c.TestItemImpl(Ge.controllerId,Ge.localId,Te.label,f.URI.revive(Te.uri));return Me.range=a.to(Te.range||void 0),Me.description=Te.description||void 0,Me}function ye(Te){let Ge;for(const Me of Te.tests){const it=$(Me.item);(0,c.getPrivateApiFor)(it).parent=Ge,Ge=it}return Ge}le.toItemFromContext=ye})(Ue=e.TestItem||(e.TestItem={})),function(le){function he($){return{id:$.id}}le.from=he;function X($){return new w.TestTag($.id)}le.to=X}(Ee=e.TestTag||(e.TestTag={}));var _e;(function(le){const he=($,ye)=>{const Te={...Ue.toPlain($.item),parent:void 0,taskStates:$.tasks.map(Ge=>({state:Ge.state,duration:Ge.duration,messages:Ge.messages.filter(Me=>Me.type===0).map(re.to)})),children:$.children.map(Ge=>ye.get(Ge)).filter(h.isDefined).map(Ge=>he(Ge,ye))};for(const Ge of Te.children)Ge.parent=Te;return Te};function X($){const ye=[],Te=new Map;for(const Ge of $.items)Te.set(Ge.item.extId,Ge),$.request.targets.some(Me=>Me.controllerId===Ge.controllerId&&Me.testIds.includes(Ge.item.extId))&&ye.push(Ge);return{completedAt:$.completedAt,results:ye.map(Ge=>he(Ge,Te))}}le.to=X})(_e=e.TestResults||(e.TestResults={}));var ze;(function(le){function he(Te){return{covered:Te.covered,total:Te.covered}}function X(Te){return"line"in Te?r.from(Te):a.from(Te)}function $(Te){return"branches"in Te?{count:Te.executionCount,location:X(Te.location),type:1,branches:Te.branches.length?Te.branches.map(Ge=>({count:Ge.executionCount,location:Ge.location&&X(Ge.location)})):void 0}:{type:0,count:Te.executionCount,location:X(Te.location)}}le.fromDetailed=$;function ye(Te){return{uri:Te.uri,statement:he(Te.statementCoverage),branch:Te.branchCoverage&&he(Te.branchCoverage),function:Te.functionCoverage&&he(Te.functionCoverage),details:Te.detailedCoverage?.map($)}}le.fromFile=ye})(ze=e.TestCoverage||(e.TestCoverage={}));var We;(function(le){function he(X){switch(X){case 1:return w.CodeActionTriggerKind.Invoke;case 2:return w.CodeActionTriggerKind.Automatic}}le.to=he})(We=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var Ke;(function(le){function he($){const ye=new w.TypeHierarchyItem(V.to($.kind),$.name,$.detail||"",f.URI.revive($.uri),a.to($.range),a.to($.selectionRange));return ye._sessionId=$._sessionId,ye._itemId=$._itemId,ye}le.to=he;function X($,ye,Te){if(ye=ye??$._sessionId,Te=Te??$._itemId,ye===void 0||Te===void 0)throw new Error("invalid item");return{_sessionId:ye,_itemId:Te,kind:V.from($.kind),name:$.name,detail:$.detail??"",uri:$.uri,range:a.from($.range),selectionRange:a.from($.selectionRange),tags:$.tags?.map(ee.from)}}le.from=X})(Ke=e.TypeHierarchyItem||(e.TypeHierarchyItem={}))}),define(ue[252],de([0,1,11,247,16,105,113,118,248,116,119,10,208,117]),function(Y,e,S,k,p,P,t,T,h,f,C,I,m,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteTerminalChannelClient=e.REMOTE_TERMINAL_CHANNEL_NAME=void 0,e.REMOTE_TERMINAL_CHANNEL_NAME="remoteterminal";let c=class{constructor(g,D,w,v,a,l,r,o,i,n){this._remoteAuthority=g,this._channel=D,this._configurationService=w,this._workspaceContextService=v,this._resolverService=a,this._environmentVariableService=l,this._remoteAuthorityResolverService=r,this._logService=o,this._editorService=i,this._labelService=n}get onPtyHostExit(){return this._channel.listen("$onPtyHostExitEvent")}get onPtyHostStart(){return this._channel.listen("$onPtyHostStartEvent")}get onPtyHostUnresponsive(){return this._channel.listen("$onPtyHostUnresponsiveEvent")}get onPtyHostResponsive(){return this._channel.listen("$onPtyHostResponsiveEvent")}get onPtyHostRequestResolveVariables(){return this._channel.listen("$onPtyHostRequestResolveVariablesEvent")}get onProcessData(){return this._channel.listen("$onProcessDataEvent")}get onProcessExit(){return this._channel.listen("$onProcessExitEvent")}get onProcessReady(){return this._channel.listen("$onProcessReadyEvent")}get onProcessReplay(){return this._channel.listen("$onProcessReplayEvent")}get onProcessOrphanQuestion(){return this._channel.listen("$onProcessOrphanQuestion")}get onExecuteCommand(){return this._channel.listen("$onExecuteCommand")}get onDidRequestDetach(){return this._channel.listen("$onDidRequestDetach")}get onDidChangeProperty(){return this._channel.listen("$onDidChangeProperty")}restartPtyHost(){return this._channel.call("$restartPtyHost",[])}async createProcess(g,D,w,v,a,l,r){await this._configurationService.whenRemoteConfigurationLoaded();const o=Object.create(null),i=w?(0,S.withNullAsUndefined)(this._workspaceContextService.getWorkspaceFolder(w)):void 0;let n;try{n=(await this._resolverService.resolveAnyMap(i,{shellLaunchConfig:g,configuration:D})).resolvedVariables}catch(te){this._logService.error(te)}if(n)for(const[te,j]of n.entries())(/^config:/.test(te)||te==="selectedText"||te==="lineNumber")&&(o[te]=j);const s=[];for(const[te,j]of this._environmentVariableService.collections.entries())s.push([te,(0,T.serializeEnvironmentVariableCollection)(j.map)]);const d=await this._remoteAuthorityResolverService.resolveAuthority(this._remoteAuthority),y=d.options&&d.options.extensionHostEnv,A=this._workspaceContextService.getWorkspace(),E=A.folders,R=w?this._workspaceContextService.getWorkspaceFolder(w):null,O=f.EditorResourceAccessor.getOriginalUri(this._editorService.activeEditor,{supportSideBySide:f.SideBySideEditor.PRIMARY,filterByScheme:[I.Schemas.file,I.Schemas.userData,I.Schemas.vscodeRemote]}),K={configuration:D,resolvedVariables:o,envVariableCollections:s,shellLaunchConfig:g,workspaceId:A.id,workspaceName:this._labelService.getWorkspaceLabel(A),workspaceFolders:E,activeWorkspaceFolder:R,activeFileResource:O,shouldPersistTerminal:v,cols:a,rows:l,unicodeVersion:r,resolverEnv:y};return await this._channel.call("$createProcess",K)}requestDetachInstance(g,D){return this._channel.call("$requestDetachInstance",[g,D])}acceptDetachInstanceReply(g,D){return this._channel.call("$acceptDetachInstanceReply",[g,D])}attachToProcess(g){return this._channel.call("$attachToProcess",[g])}detachFromProcess(g){return this._channel.call("$detachFromProcess",[g])}listProcesses(){return this._channel.call("$listProcesses")}reduceConnectionGraceTime(){return this._channel.call("$reduceConnectionGraceTime")}processBinary(g,D){return this._channel.call("$processBinary",[g,D])}start(g){return this._channel.call("$start",[g])}input(g,D){return this._channel.call("$input",[g,D])}acknowledgeDataEvent(g,D){return this._channel.call("$acknowledgeDataEvent",[g,D])}setUnicodeVersion(g,D){return this._channel.call("$setUnicodeVersion",[g,D])}shutdown(g,D){return this._channel.call("$shutdown",[g,D])}resize(g,D,w){return this._channel.call("$resize",[g,D,w])}getInitialCwd(g){return this._channel.call("$getInitialCwd",[g])}getCwd(g){return this._channel.call("$getCwd",[g])}orphanQuestionReply(g){return this._channel.call("$orphanQuestionReply",[g])}sendCommandResult(g,D,w){return this._channel.call("$sendCommandResult",[g,D,w])}getDefaultSystemShell(g){return this._channel.call("$getDefaultSystemShell",[g])}getProfiles(g,D,w){return this._channel.call("$getProfiles",[this._workspaceContextService.getWorkspace().id,g,D,w])}acceptPtyHostResolvedVariables(g,D){return this._channel.call("$acceptPtyHostResolvedVariables",[g,D])}getEnvironment(){return this._channel.call("$getEnvironment")}getWslPath(g){return this._channel.call("$getWslPath",[g])}setTerminalLayoutInfo(g){const w={workspaceId:this._workspaceContextService.getWorkspace().id,tabs:g?g.tabs:[]};return this._channel.call("$setTerminalLayoutInfo",w)}updateTitle(g,D,w){return this._channel.call("$updateTitle",[g,D,w])}updateIcon(g,D,w){return this._channel.call("$updateIcon",[g,D,w])}refreshProperty(g,D){return this._channel.call("$refreshProperty",[g,D])}updateProperty(g,D,w){return this._channel.call("$updateProperty",[g,D,w])}getTerminalLayoutInfo(){const D={workspaceId:this._workspaceContextService.getWorkspace().id};return this._channel.call("$getTerminalLayoutInfo",D)}reviveTerminalProcesses(g){return this._channel.call("$reviveTerminalProcesses",[g])}serializeTerminalState(g){return this._channel.call("$serializeTerminalState",[g])}};c=Ne([je(2,k.IWorkbenchConfigurationService),je(3,t.IWorkspaceContextService),je(4,h.IConfigurationResolverService),je(5,u.IEnvironmentVariableService),je(6,P.IRemoteAuthorityResolverService),je(7,p.ILogService),je(8,C.IEditorService),je(9,m.ILabelService)],c),e.RemoteTerminalChannelClient=c}),define(ue[253],de([0,1,2,14,5,7,109,39]),function(Y,e,S,k,p,P,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionResourceLoaderService=e.IExtensionResourceLoaderService=void 0,e.IExtensionResourceLoaderService=(0,P.createDecorator)("extensionResourceLoaderService");class h{constructor(C,I,m,u,c){this._fileService=C,this._storageService=I,this._productService=m,this._environmentService=u,this._configurationService=c,m.extensionsGallery&&(this._extensionGalleryResourceUrlTemplate=m.extensionsGallery.resourceUrlTemplate,this._extensionGalleryAuthority=this._extensionGalleryResourceUrlTemplate?this._getExtensionGalleryAuthority(p.URI.parse(this._extensionGalleryResourceUrlTemplate)):void 0)}get supportsExtensionGalleryResources(){return this._extensionGalleryResourceUrlTemplate!==void 0}getExtensionGalleryResourceURL(C,I){if(this._extensionGalleryResourceUrlTemplate)return p.URI.parse((0,k.format2)(this._extensionGalleryResourceUrlTemplate,{publisher:C.publisher,name:C.name,version:C.version,path:"extension"}))}isExtensionGalleryResource(C){return this._extensionGalleryAuthority&&this._extensionGalleryAuthority===this._getExtensionGalleryAuthority(C)}async getExtensionGalleryRequestHeaders(){const C={"X-Client-Name":`${this._productService.applicationName}${S.isWeb?"-web":""}`,"X-Client-Version":this._productService.version};return(0,T.supportsTelemetry)(this._productService,this._environmentService)&&(0,T.getTelemetryLevel)(this._configurationService)===3&&(C["X-Machine-Id"]=await this._getServiceMachineId()),this._productService.commit&&(C["X-Client-Commit"]=this._productService.commit),C}_getServiceMachineId(){return this._serviceMachineIdPromise||(this._serviceMachineIdPromise=(0,t.getServiceMachineId)(this._environmentService,this._fileService,this._storageService)),this._serviceMachineIdPromise}_getExtensionGalleryAuthority(C){const I=C.authority.indexOf(".");return I!==-1?C.authority.substring(I+1):void 0}}e.AbstractExtensionResourceLoaderService=h}),define(ue[254],de([0,1,212]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Logger=e.Translations=void 0;var k;(function(P){function t(T,h){if(T===h)return!0;let f=Object.keys(T),C=new Set;for(let I of Object.keys(h))C.add(I);if(f.length!==C.size)return!1;for(let I of f){if(T[I]!==h[I])return!1;C.delete(I)}return C.size===0}P.equals=t})(k=e.Translations||(e.Translations={}));class p{constructor(t){this._messageHandler=t}error(t,T){this._messageHandler(S.Severity.Error,t,T)}warn(t,T){this._messageHandler(S.Severity.Warning,t,T)}info(t,T){this._messageHandler(S.Severity.Info,t,T)}}e.Logger=p}),define(ue[255],de([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",contribIconFonts:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIconFonts.d.ts",contribIcons:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIcons.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",inlayHints:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlayHints.d.ts",inlineCompletions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletions.d.ts",languageStatus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatus.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookConcatTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookConcatTextDocument.d.ts",notebookContentProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookContentProvider.d.ts",notebookControllerKind:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerKind.d.ts",notebookDebugOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDebugOptions.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookEditor.d.ts",notebookEditorDecorationType:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookEditorDecorationType.d.ts",notebookEditorEdit:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookEditorEdit.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",quickPickSeparators:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSeparators.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",tabs:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabs.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalLocation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalLocation.d.ts",terminalNameChangeEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalNameChangeEvent.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textDocumentNotebook:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textDocumentNotebook.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewDragAndDrop:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewDragAndDrop.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(ue[120],de([0,1,183,12,62,29,49,22,43,255,129]),function(Y,e,S,k,p,P,t,T,h,f,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsRegistry=e.ExtensionsRegistryImpl=e.schema=e.ExtensionPoint=e.ExtensionPointUserDelta=e.ExtensionMessageCollector=void 0;const I=T.Registry.as(t.Extensions.JSONContribution);class m{constructor(a,l,r){this._messageHandler=a,this._extension=l,this._extensionPointId=r}_msg(a,l){this._messageHandler({type:a,message:l,extensionId:this._extension.identifier,extensionPointId:this._extensionPointId})}error(a){this._msg(p.default.Error,a)}warn(a){this._msg(p.default.Warning,a)}info(a){this._msg(p.default.Info,a)}}e.ExtensionMessageCollector=m;class u{constructor(a,l){this.added=a,this.removed=l}static _toSet(a){const l=new Set;for(let r=0,o=a.length;r<o;r++)l.add(h.ExtensionIdentifier.toKey(a[r].description.identifier));return l}static compute(a,l){if(!a||!a.length)return new u(l,[]);if(!l||!l.length)return new u([],a);const r=this._toSet(a),o=this._toSet(l);let i=l.filter(s=>!r.has(h.ExtensionIdentifier.toKey(s.description.identifier))),n=a.filter(s=>!o.has(h.ExtensionIdentifier.toKey(s.description.identifier)));return new u(i,n)}}e.ExtensionPointUserDelta=u;class c{constructor(a,l){this.name=a,this.defaultExtensionKind=l,this._handler=null,this._users=null,this._delta=null}setHandler(a){if(this._handler!==null)throw new Error("Handler already set!");this._handler=a,this._handle()}acceptUsers(a){this._delta=u.compute(this._users,a),this._users=a,this._handle()}_handle(){if(!(this._handler===null||this._users===null||this._delta===null))try{this._handler(this._users,this._delta)}catch(a){(0,k.onUnexpectedError)(a)}}}e.ExtensionPoint=c;const b={type:"string",enum:["ui","workspace"],enumDescriptions:[S.localize(0,null),S.localize(1,null)]},g="vscode://schemas/vscode-extensions";e.schema={properties:{engines:{type:"object",description:S.localize(2,null),properties:{vscode:{type:"string",description:S.localize(3,null),default:"^1.22.0"}}},publisher:{description:S.localize(4,null),type:"string"},displayName:{description:S.localize(5,null),type:"string"},categories:{description:S.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:h.EXTENSION_CATEGORIES},{type:"string",const:"Languages",deprecationMessage:S.localize(7,null)}]}},galleryBanner:{type:"object",description:S.localize(8,null),properties:{color:{description:S.localize(9,null),type:"string"},theme:{description:S.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:S.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:S.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:S.localize(13,null)},enabledApiProposals:{markdownDescription:S.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(f.allApiProposals),markdownEnumDescriptions:(0,C.values)(f.allApiProposals)}},activationEvents:{description:S.localize(15,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onLanguage",description:S.localize(16,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:S.localize(17,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:S.localize(18,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:S.localize(19,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:S.localize(20,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:S.localize(21,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:S.localize(22,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:S.localize(23,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:S.localize(24,null),body:"onStartupFinished"},{label:"onFileSystem",description:S.localize(25,null),body:"onFileSystem:${1:scheme}"},{label:"onSearch",description:S.localize(26,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:S.localize(27,null)},{label:"onIdentity",body:"onIdentity:${8:identity}",description:S.localize(28,null)},{label:"onUri",body:"onUri",description:S.localize(29,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:S.localize(30,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:S.localize(31,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:S.localize(32,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:S.localize(33,null)},{label:"onRenderer",description:S.localize(34,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:S.localize(35,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:S.localize(36,null)},{label:"*",description:S.localize(37,null),body:"*"}]}},badges:{type:"array",description:S.localize(38,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:S.localize(39,null)},href:{type:"string",description:S.localize(40,null)},description:{type:"string",description:S.localize(41,null)}}}},markdown:{type:"string",description:S.localize(42,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:S.localize(43,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:S.localize(44,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:P.EXTENSION_IDENTIFIER_PATTERN}},extensionPack:{description:S.localize(45,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:P.EXTENSION_IDENTIFIER_PATTERN}},extensionKind:{description:S.localize(46,null),type:"array",items:b,default:["workspace"],defaultSnippets:[{body:["ui"],description:S.localize(47,null)},{body:["workspace"],description:S.localize(48,null)},{body:["ui","workspace"],description:S.localize(49,null)},{body:["workspace","ui"],description:S.localize(50,null)},{body:[],description:S.localize(51,null)}]},capabilities:{description:S.localize(52,null),type:"object",properties:{virtualWorkspaces:{description:S.localize(53,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:S.localize(54,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[S.localize(55,null),S.localize(56,null),S.localize(57,null)]},description:{type:"string",markdownDescription:S.localize(58,null)}}},untrustedWorkspaces:{description:S.localize(59,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:S.localize(60,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[S.localize(61,null),S.localize(62,null),S.localize(63,null)]},restrictedConfigurations:{description:S.localize(64,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:S.localize(65,null)}}}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:S.localize(66,null),type:"string"},"vscode:uninstall":{description:S.localize(67,null),type:"string"}}},icon:{type:"string",description:S.localize(68,null)}}};class D{constructor(){this._extensionPoints=new Map}registerExtensionPoint(a){if(this._extensionPoints.has(a.extensionPoint))throw new Error("Duplicate extension point: "+a.extensionPoint);const l=new c(a.extensionPoint,a.defaultExtensionKind);return this._extensionPoints.set(a.extensionPoint,l),e.schema.properties.contributes.properties[a.extensionPoint]=a.jsonSchema,I.registerSchema(g,e.schema),l}getExtensionPoints(){return Array.from(this._extensionPoints.values())}}e.ExtensionsRegistryImpl=D;const w={ExtensionsRegistry:"ExtensionsRegistry"};T.Registry.add(w.ExtensionsRegistry,new D),e.ExtensionsRegistry=T.Registry.as(w.ExtensionsRegistry),I.registerSchema(g,e.schema)}),define(ue[121],de([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class S{constructor(f,C){this._proxyIdentifierBrand=void 0,this.isMain=f,this.sid=C,this.nid=++S.count}}e.ProxyIdentifier=S,S.count=0;const k=[];function p(h){const f=new S(!0,h);return k[f.nid]=f,f}e.createMainContextProxyIdentifier=p;function P(h){const f=new S(!1,h);return k[f.nid]=f,f}e.createExtHostContextProxyIdentifier=P;function t(h){return k[h].sid}e.getStringIdentifierForProxy=t;class T{constructor(f){this.value=f}}e.SerializableObjectWithBuffers=T}),define(ue[256],de([0,1,54,5,121]),function(Y,e,S,k,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var P;(function(v){v[v.Desktop=1]="Desktop",v[v.Web=2]="Web"})(P=e.UIKind||(e.UIKind={}));var t;(function(v){v[v.Default=0]="Default",v[v.InCenter=1]="InCenter",v[v.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",v[v.AtTop=3]="AtTop"})(t=e.TextEditorRevealType||(e.TextEditorRevealType={}));var T;(function(v){v[v.Editable=0]="Editable",v[v.SupportsHotExit=1]="SupportsHotExit"})(T=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var h;(function(v){v[v.Int8Array=1]="Int8Array",v[v.Uint8Array=2]="Uint8Array",v[v.Uint8ClampedArray=3]="Uint8ClampedArray",v[v.Int16Array=4]="Int16Array",v[v.Uint16Array=5]="Uint16Array",v[v.Int32Array=6]="Int32Array",v[v.Uint32Array=7]="Uint32Array",v[v.Float32Array=8]="Float32Array",v[v.Float64Array=9]="Float64Array",v[v.BigInt64Array=10]="BigInt64Array",v[v.BigUint64Array=11]="BigUint64Array"})(h=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var f;(function(v){v[v.Text=1]="Text",v[v.Error=2]="Error",v[v.Rich=3]="Rich"})(f=e.CellOutputKind||(e.CellOutputKind={}));var C;(function(v){v[v.Default=0]="Default",v[v.InCenter=1]="InCenter",v[v.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",v[v.AtTop=3]="AtTop"})(C=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var I;(function(v){v[v.None=0]="None",v[v.Process=1]="Process",v[v.Output=2]="Output"})(I=e.CandidatePortSource||(e.CandidatePortSource={}));var m;(function(v){v.name="$ident";function a(r,o){return Object.defineProperty(r,v.name,{value:o,enumerable:!0}),r}v.mixin=a;function l(r){return r[v.name]}v.of=l})(m=e.ObjectIdentifier||(e.ObjectIdentifier={}));class u{static mixin(a){return a._id=u._n++,a}}e.IdObject=u,u._n=0;var c;(function(v){v.label="a",v.kind="b",v.detail="c",v.documentation="d",v.sortText="e",v.filterText="f",v.preselect="g",v.insertText="h",v.insertTextRules="i",v.range="j",v.commitCharacters="k",v.additionalTextEdits="l",v.command="m",v.kindModifier="n"})(c=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var b;(function(v){v.defaultRanges="a",v.completions="b",v.isIncomplete="c",v.duration="d"})(b=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var g;(function(v){v[v.File=1]="File",v[v.Text=2]="Text",v[v.Cell=3]="Cell"})(g=e.WorkspaceEditType||(e.WorkspaceEditType={}));function D(v){if(v&&v.edits)for(const a of v.edits)typeof a.resource=="object"?a.resource=k.URI.revive(a.resource):(a.newUri=k.URI.revive(a.newUri),a.oldUri=k.URI.revive(a.oldUri)),a.metadata&&a.metadata.iconPath&&(a.metadata=(0,S.revive)(a.metadata));return v}e.reviveWorkspaceEditDto=D;var w;(function(v){v[v.Workspace=0]="Workspace",v[v.TextDocument=1]="TextDocument"})(w=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,p.createMainContextProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,p.createMainContextProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,p.createMainContextProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,p.createMainContextProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,p.createMainContextProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,p.createMainContextProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,p.createMainContextProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,p.createMainContextProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,p.createMainContextProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,p.createMainContextProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,p.createMainContextProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,p.createMainContextProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,p.createMainContextProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,p.createMainContextProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,p.createMainContextProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,p.createMainContextProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,p.createMainContextProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,p.createMainContextProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,p.createMainContextProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,p.createMainContextProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,p.createMainContextProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,p.createMainContextProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,p.createMainContextProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,p.createMainContextProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,p.createMainContextProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,p.createMainContextProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,p.createMainContextProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,p.createMainContextProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,p.createMainContextProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,p.createMainContextProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,p.createMainContextProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,p.createMainContextProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,p.createMainContextProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,p.createMainContextProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,p.createMainContextProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,p.createMainContextProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,p.createMainContextProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,p.createMainContextProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,p.createMainContextProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,p.createMainContextProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,p.createMainContextProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,p.createMainContextProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,p.createMainContextProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,p.createMainContextProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,p.createMainContextProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,p.createMainContextProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,p.createMainContextProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,p.createMainContextProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,p.createMainContextProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,p.createMainContextProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,p.createMainContextProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,p.createMainContextProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,p.createMainContextProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,p.createMainContextProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,p.createMainContextProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,p.createMainContextProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,p.createExtHostContextProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,p.createExtHostContextProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,p.createExtHostContextProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,p.createExtHostContextProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,p.createExtHostContextProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,p.createExtHostContextProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,p.createExtHostContextProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,p.createExtHostContextProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,p.createExtHostContextProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,p.createExtHostContextProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,p.createExtHostContextProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,p.createExtHostContextProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,p.createExtHostContextProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,p.createExtHostContextProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,p.createExtHostContextProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,p.createExtHostContextProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,p.createExtHostContextProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,p.createExtHostContextProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,p.createExtHostContextProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,p.createExtHostContextProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,p.createExtHostContextProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,p.createExtHostContextProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,p.createExtHostContextProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,p.createExtHostContextProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,p.createExtHostContextProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,p.createExtHostContextProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,p.createExtHostContextProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,p.createExtHostContextProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,p.createExtHostContextProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,p.createExtHostContextProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,p.createExtHostContextProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,p.createMainContextProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,p.createMainContextProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,p.createMainContextProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,p.createMainContextProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,p.createExtHostContextProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,p.createExtHostContextProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,p.createMainContextProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,p.createMainContextProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,p.createMainContextProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,p.createMainContextProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,p.createMainContextProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,p.createMainContextProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,p.createMainContextProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,p.createMainContextProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,p.createMainContextProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,p.createMainContextProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,p.createMainContextProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,p.createMainContextProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,p.createMainContextProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,p.createMainContextProxyIdentifier)("ExtHostTelemetry")}}),define(ue[257],de([0,1,11,115,251,21,256,20,16,54,67,96,5,3,7,242,114,18,121,37]),function(Y,e,S,k,p,P,t,T,h,f,C,I,m,u,c,b,g,D,w,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let a=class{constructor(s,d){this._commands=new Map,this._apiCommands=new Map,this._proxy=s.getProxy(t.MainContext.MainThreadCommands),this._logService=d,this.converter=new l(this,y=>{const A=this._apiCommands.get(y);return A?.result===o.Void?A:void 0},d),this._argumentProcessors=[{processArgument(y){return(0,f.revive)(y)}},{processArgument(y){return(0,P.cloneAndChange)(y,function(A){if(C.Range.isIRange(A))return p.Range.to(A);if(I.Position.isIPosition(A))return p.Position.to(A);if(C.Range.isIRange(A.range)&&m.URI.isUri(A.uri))return p.location.to(A);if(A instanceof D.VSBuffer)return A.buffer.buffer;if(!Array.isArray(A))return A})}}]}registerArgumentProcessor(s){this._argumentProcessors.push(s)}registerApiCommand(s){const d=this.registerCommand(!1,s.id,async(...y)=>{const A=s.args.map((R,O)=>{if(!R.validate(y[O]))throw new Error(`Invalid argument '${R.name}' when running '${s.id}', received: ${y[O]}`);return R.convert(y[O])}),E=await this.executeCommand(s.internalId,...A);return s.result.convert(E,y,this.converter)},void 0,{description:s.description,args:s.args,returns:s.result.description});return this._apiCommands.set(s.id,s),new k.Disposable(()=>{d.dispose(),this._apiCommands.delete(s.id)})}registerCommand(s,d,y,A,E,R){if(this._logService.trace("ExtHostCommands#registerCommand",d),!d.trim().length)throw new Error("invalid id");if(this._commands.has(d))throw new Error(`command '${d}' already exists`);return this._commands.set(d,{callback:y,thisArg:A,description:E,extension:R}),s&&this._proxy.$registerCommand(d),new k.Disposable(()=>{this._commands.delete(d)&&s&&this._proxy.$unregisterCommand(d)})}executeCommand(s,...d){return this._logService.trace("ExtHostCommands#executeCommand",s),this._doExecuteCommand(s,d,!0)}async _doExecuteCommand(s,d,y){if(this._commands.has(s))return this._executeContributedCommand(s,d,!1);{let A=!1;const E=(0,P.cloneAndChange)(d,function(R){if(R instanceof k.Position)return p.Position.from(R);if(R instanceof k.Range)return p.Range.from(R);if(R instanceof k.Location)return p.location.from(R);if(k.NotebookRange.isNotebookRange(R))return p.NotebookRange.from(R);if(R instanceof ArrayBuffer)return A=!0,D.VSBuffer.wrap(new Uint8Array(R));if(R instanceof Uint8Array)return A=!0,D.VSBuffer.wrap(R);if(!Array.isArray(R))return R});try{const R=await this._proxy.$executeCommand(s,A?new w.SerializableObjectWithBuffers(E):E,y);return(0,f.revive)(R)}catch(R){if(R instanceof Error&&R.message==="$executeCommand:retry")return this._doExecuteCommand(s,d,!1);throw R}}}async _executeContributedCommand(s,d,y){const A=this._commands.get(s);if(!A)throw new Error("Unknown command");let{callback:E,thisArg:R,description:O}=A;if(O)for(let K=0;K<O.args.length;K++)try{(0,S.validateConstraint)(d[K],O.args[K].constraint)}catch(te){throw new Error(`Running the contributed command: '${s}' failed. Illegal argument '${O.args[K].name}' - ${O.args[K].description}`)}try{return await E.apply(R,d)}catch(K){if(s===this.converter.delegatingCommandId){const te=this.converter.getActualCommand(...d);te&&(s=te.command)}throw this._logService.error(K,s,A.extension?.identifier),y?new class extends Error{constructor(){super((0,v.toErrorMessage)(K));this.id=s,this.source=A.extension?.displayName??A.extension?.name}}:K}}$executeContributedCommand(s,...d){return this._logService.trace("ExtHostCommands#$executeContributedCommand",s),this._commands.has(s)?(d=d.map(y=>this._argumentProcessors.reduce((A,E)=>E.processArgument(A),y)),this._executeContributedCommand(s,d,!0)):Promise.reject(new Error(`Contributed command '${s}' does not exist.`))}getCommands(s=!1){return this._logService.trace("ExtHostCommands#getCommands",s),this._proxy.$getCommands().then(d=>(s&&(d=d.filter(y=>y[0]!=="_")),d))}$getContributedCommandHandlerDescriptions(){const s=Object.create(null);for(let[d,y]of this._commands){let{description:A}=y;A&&(s[d]=A)}return Promise.resolve(s)}};a=Ne([je(0,b.IExtHostRpcService),je(1,h.ILogService)],a),e.ExtHostCommands=a,e.IExtHostCommands=(0,c.createDecorator)("IExtHostCommands");class l{constructor(s,d,y){this._commands=s,this._lookupApiCommand=d,this._logService=y,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(s,d){if(!s)return;const y={$ident:void 0,id:s.command,title:s.title,tooltip:s.tooltip};if(!s.command)return y;const A=this._lookupApiCommand(s.command);if(A)y.id=A.internalId,y.arguments=A.args.map((E,R)=>E.convert(s.arguments&&s.arguments[R]));else if((0,T.isNonEmptyArray)(s.arguments)){const E=++this._cachIdPool;this._cache.set(E,s),d.add((0,u.toDisposable)(()=>{this._cache.delete(E),this._logService.trace("CommandsConverter#DISPOSE",E)})),y.$ident=E,y.id=this.delegatingCommandId,y.arguments=[E],this._logService.trace("CommandsConverter#CREATE",s.command,E)}return y}fromInternal(s){const d=t.ObjectIdentifier.of(s);return typeof d=="number"?this._cache.get(d):{command:s.id,title:s.title,arguments:s.arguments}}getActualCommand(...s){return this._cache.get(s[0])}_executeConvertedCommand(...s){const d=this.getActualCommand(...s);return this._logService.trace("CommandsConverter#EXECUTE",s[0],d?d.command:"MISSING"),d?this._commands.executeCommand(d.command,...d.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=l;class r{constructor(s,d,y,A){this.name=s,this.description=d,this.validate=y,this.convert=A}optional(){return new r(this.name,`(optional) ${this.description}`,s=>s==null||this.validate(s),s=>s===void 0?void 0:s===null?null:this.convert(s))}with(s,d){return new r(s??this.name,d??this.description,this.validate,this.convert)}}e.ApiCommandArgument=r,r.Uri=new r("uri","Uri of a text document",n=>m.URI.isUri(n),n=>n),r.Position=new r("position","A position in a text document",n=>k.Position.isPosition(n),p.Position.from),r.Range=new r("range","A range in a text document",n=>k.Range.isRange(n),p.Range.from),r.Selection=new r("selection","A selection in a text document",n=>k.Selection.isSelection(n),p.Selection.from),r.Number=new r("number","",n=>typeof n=="number",n=>n),r.String=new r("string","",n=>typeof n=="string",n=>n),r.CallHierarchyItem=new r("item","A call hierarchy item",n=>n instanceof k.CallHierarchyItem,p.CallHierarchyItem.from),r.TypeHierarchyItem=new r("item","A type hierarchy item",n=>n instanceof k.TypeHierarchyItem,p.TypeHierarchyItem.from),r.TestItem=new r("testItem","A VS Code TestItem",n=>n instanceof g.TestItemImpl,p.TestItem.from);class o{constructor(s,d){this.description=s,this.convert=d}}e.ApiCommandResult=o,o.Void=new o("no result",n=>n);class i{constructor(s,d,y,A,E){this.id=s,this.internalId=d,this.description=y,this.args=A,this.result=E}}e.ApiCommand=i}),define(ue[258],de([0,1,89]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logRemoteEntryIfError=e.logRemoteEntry=void 0;function k(P,t,T=null){const h=(0,S.parse)(t).args;let f=h.shift();if(typeof f=="string")switch(t.severity||(t.severity="info"),T&&(/^\[/.test(T)||(T=`[${T}]`),/ $/.test(T)||(T=`${T} `),f=T+f),t.severity){case"log":case"info":P.info(f,...h);break;case"warn":P.warn(f,...h);break;case"error":P.error(f,...h);break}}e.logRemoteEntry=k;function p(P,t,T){const h=(0,S.parse)(t).args,f=h.shift();typeof f!="string"||t.severity!=="error"||(/^\[/.test(T)||(T=`[${T}]`),/ $/.test(T)||(T=`${T} `),P.error(T+f,...h))}e.logRemoteEntryIfError=p}),define(ue[259],de([0,1,184,4,59,36,20,97,11,5,17,34,70,43,254]),function(Y,e,S,k,p,P,t,T,h,f,C,I,m,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionScanner=e.ExtensionScannerInput=void 0;const b="package.json";class g{constructor(i,n,s,d,y,A){this._ourVersion=i,this._ourProductDate=n,this._log=s,this._absoluteFolderPath=d,this._isBuiltin=y,this._isUnderDevelopment=A,this._absoluteManifestPath=k.join(d,b)}}class D extends g{static _fastParseJSON(i,n){try{return JSON.parse(i)}catch(s){return P.parse(i,n)}}parse(){return C.Promises.readFile(this._absoluteManifestPath).then(i=>{const n=[],s=D._fastParseJSON(i.toString(),n);if(P.getNodeType(s)!=="object")this._log.error(this._absoluteFolderPath,S.localize(0,null,this._absoluteManifestPath));else{if(n.length===0)return s.__metadata&&(s.uuid=s.__metadata.id),s.isUserBuiltin=!!s.__metadata?.isBuiltin,delete s.__metadata,s;n.forEach(d=>{this._log.error(this._absoluteFolderPath,S.localize(1,null,this._absoluteManifestPath,d.offset,d.length,(0,T.getParseErrorMessage)(d.error)))})}return null},i=>(i.code==="ENOENT"||this._log.error(this._absoluteFolderPath,S.localize(2,null,this._absoluteManifestPath,i.message)),null))}}class w extends g{constructor(i,n,s,d,y,A,E){super(i,n,s,d,y,A);this._nlsConfig=E}replaceNLS(i){const n=(O,K)=>{K.forEach(te=>{this._log.error(this._absoluteFolderPath,S.localize(3,null,O,(0,T.getParseErrorMessage)(te.error)))})},s=O=>{this._log.error(this._absoluteFolderPath,S.localize(4,null,O))};let d=k.extname(this._absoluteManifestPath),y=this._absoluteManifestPath.substr(0,this._absoluteManifestPath.length-d.length);const A=`${i.publisher}.${i.name}`;let E=this._nlsConfig.translations[A],R;return E?R=C.Promises.readFile(E,"utf8").then(O=>{let K=[],te=P.parse(O,K);return K.length>0?(n(E,K),{values:void 0,default:`${y}.nls.json`}):P.getNodeType(te)!=="object"?(s(E),{values:void 0,default:`${y}.nls.json`}):{values:te.contents?te.contents.package:void 0,default:`${y}.nls.json`}},O=>({values:void 0,default:`${y}.nls.json`})):R=C.SymlinkSupport.existsFile(y+".nls"+d).then(O=>{if(!!O)return w.findMessageBundles(this._nlsConfig,y).then(K=>K.localized?C.Promises.readFile(K.localized,"utf8").then(te=>{let j=[],_=P.parse(te,j);return j.length>0?(n(K.localized,j),{values:void 0,default:K.original}):P.getNodeType(_)!=="object"?(s(K.localized),{values:void 0,default:K.original}):{values:_,default:K.original}},te=>({values:void 0,default:K.original})):{values:void 0,default:K.original},K=>{})}),R.then(O=>{if(O===void 0)return i;let K=[];return w.resolveOriginalMessageBundle(O.default,K).then(te=>{if(K.length>0)return n(O.default,K),i;if(P.getNodeType(O)!=="object")return s(O.default),i;const j=O.values||Object.create(null);return w._replaceNLStrings(this._nlsConfig,i,j,te,this._log,this._absoluteFolderPath),i})},O=>i)}static resolveOriginalMessageBundle(i,n){return new Promise((s,d)=>{i?C.Promises.readFile(i).then(y=>{s(P.parse(y.toString(),n))},y=>{s(null)}):s(null)})}static findMessageBundles(i,n){return new Promise((s,d)=>{function y(A,E){let R=`${A}.nls.${E}.json`;C.SymlinkSupport.existsFile(R).then(O=>{O&&s({localized:R,original:`${A}.nls.json`});let K=E.lastIndexOf("-");K===-1?s({localized:`${A}.nls.json`,original:null}):(E=E.substring(0,K),y(A,E))})}if(i.devMode||i.pseudo||!i.locale)return s({localized:n+".nls.json",original:null});y(n,i.locale)})}static _replaceNLStrings(i,n,s,d,y,A){function E(R,O,K){const te=R[O];if(h.isString(te)){const j=te,_=j.length;if(_>1&&j[0]==="%"&&j[_-1]==="%"){const U=j.substr(1,_-2);let F=s[U];F===void 0&&d&&(F=d[U]);let M=typeof F=="string"?F:typeof F?.message=="string"?F.message:void 0;M!==void 0?(i.pseudo&&(M="\uFF3B"+M.replace(/[aouei]/g,"$&$&")+"\uFF3D"),R[O]=K&&(O==="title"||O==="category")&&d?{value:M,original:d[U]}:M):y.warn(A,S.localize(5,null,U))}}else if(h.isObject(te))for(let j in te)te.hasOwnProperty(j)&&(j==="commands"?E(te,j,!0):E(te,j,K));else if(h.isArray(te))for(let j=0;j<te.length;j++)E(te,j,K)}for(let R in n)n.hasOwnProperty(R)&&E(n,R)}}class v extends g{validate(i){let n=i;n.isBuiltin=this._isBuiltin,n.isUserBuiltin=!this._isBuiltin&&!!n.isUserBuiltin,n.isUnderDevelopment=this._isUnderDevelopment;let s=[];return v.isValidExtensionDescription(this._ourVersion,this._ourProductDate,this._absoluteFolderPath,n,s)?(s.forEach(d=>{this._log.warn(this._absoluteFolderPath,d)}),n.publisher||(n.publisher="undefined_publisher"),n.id=(0,I.getExtensionId)(n.publisher,n.name),n.identifier=new u.ExtensionIdentifier(n.id),n.extensionLocation=f.URI.file(this._absoluteFolderPath),n):(s.forEach(d=>{this._log.error(this._absoluteFolderPath,d)}),null)}static isValidExtensionDescription(i,n,s,d,y){return v.baseIsValidExtensionDescription(s,d,y)?p.valid(d.version)?(0,m.isValidExtensionVersion)(i,n,d,y):(y.push(S.localize(6,null)),!1):!1}static baseIsValidExtensionDescription(i,n,s){if(!n)return s.push(S.localize(7,null)),!1;if(typeof n.publisher!="undefined"&&typeof n.publisher!="string")return s.push(S.localize(8,null)),!1;if(typeof n.name!="string")return s.push(S.localize(9,null,"name")),!1;if(typeof n.version!="string")return s.push(S.localize(10,null,"version")),!1;if(!n.engines)return s.push(S.localize(11,null,"engines")),!1;if(typeof n.engines.vscode!="string")return s.push(S.localize(12,null,"engines.vscode")),!1;if(typeof n.extensionDependencies!="undefined"&&!v._isStringArray(n.extensionDependencies))return s.push(S.localize(13,null,"extensionDependencies")),!1;if(typeof n.activationEvents!="undefined"){if(!v._isStringArray(n.activationEvents))return s.push(S.localize(14,null,"activationEvents")),!1;if(typeof n.main=="undefined"&&typeof n.browser=="undefined")return s.push(S.localize(15,null,"activationEvents","main")),!1}if(typeof n.main!="undefined"){if(typeof n.main!="string")return s.push(S.localize(16,null,"main")),!1;{const d=k.join(i,n.main);d.startsWith(i)||s.push(S.localize(17,null,d,i))}if(typeof n.activationEvents=="undefined")return s.push(S.localize(18,null,"activationEvents","main")),!1}if(typeof n.browser!="undefined"){if(typeof n.browser!="string")return s.push(S.localize(19,null,"browser")),!1;{const d=k.join(i,n.browser);d.startsWith(i)||s.push(S.localize(20,null,d,i))}if(typeof n.activationEvents=="undefined")return s.push(S.localize(21,null,"activationEvents","browser")),!1}return!0}static _isStringArray(i){if(!Array.isArray(i))return!1;for(let n=0,s=i.length;n<s;n++)if(typeof i[n]!="string")return!1;return!0}}class a{constructor(i,n,s,d,y,A,E,R,O){this.ourVersion=i,this.ourProductDate=n,this.commit=s,this.locale=d,this.devMode=y,this.absoluteFolderPath=A,this.isBuiltin=E,this.isUnderDevelopment=R,this.translations=O}static createNLSConfig(i){return{devMode:i.devMode,locale:i.locale,pseudo:i.locale==="pseudo",translations:i.translations}}static equals(i,n){return i.ourVersion===n.ourVersion&&i.ourProductDate===n.ourProductDate&&i.commit===n.commit&&i.locale===n.locale&&i.devMode===n.devMode&&i.absoluteFolderPath===n.absoluteFolderPath&&i.isBuiltin===n.isBuiltin&&i.isUnderDevelopment===n.isUnderDevelopment&&i.mtime===n.mtime&&c.Translations.equals(i.translations,n.translations)}}e.ExtensionScannerInput=a;class l{constructor(i){this.root=i}resolveExtensions(){return C.Promises.readDirsInDir(this.root).then(i=>i.map(n=>({name:n,path:k.join(this.root,n)})))}}class r{static scanExtension(i,n,s,d,y,A,E){return d=k.normalize(d),new D(i,n,s,d,y,A).parse().then(O=>O===null?null:new w(i,n,s,d,y,A,E).replaceNLS(O)).then(O=>O===null?null:new v(i,n,s,d,y,A).validate(O))}static async scanExtensions(i,n,s=null){const d=i.absoluteFolderPath,y=i.isBuiltin,A=i.isUnderDevelopment;s||(s=new l(d));try{let E={};if(!y)try{const j=await C.Promises.readFile(k.join(d,".obsolete"),"utf8");E=JSON.parse(j)}catch(j){}let R=await s.resolveExtensions();R.sort((j,_)=>j.name<_.name?-1:1),y||(R=R.filter(j=>j.name.indexOf(".")!==0));const O=a.createNLSConfig(i);let K=await Promise.all(R.map(j=>this.scanExtension(i.ourVersion,i.ourProductDate,n,j.path,y,A,O))),te=t.coalesce(K);return te=te.filter(j=>j!==null&&!E[new I.ExtensionIdentifierWithVersion({id:(0,I.getGalleryExtensionId)(j.publisher,j.name)},j.version).key()]),y||(te=(0,I.groupByExtension)(te,_=>({id:_.identifier.value,uuid:_.uuid})).map(_=>_.sort((U,F)=>p.rcompare(U.version,F.version))[0])),te.sort((j,_)=>j.extensionLocation.fsPath<_.extensionLocation.fsPath?-1:1),te}catch(E){return n.error(d,E),[]}}static scanOneOrMultipleExtensions(i,n){const s=i.absoluteFolderPath,d=i.isBuiltin,y=i.isUnderDevelopment;return C.SymlinkSupport.existsFile(k.join(s,b)).then(A=>{if(A){const E=a.createNLSConfig(i);return this.scanExtension(i.ourVersion,i.ourProductDate,n,s,d,y,E).then(R=>R===null?[]:[R])}return this.scanExtensions(i,n)},A=>(n.error(s,A),[]))}static scanSingleExtension(i,n){const s=i.absoluteFolderPath,d=i.isBuiltin,y=i.isUnderDevelopment,A=a.createNLSConfig(i);return this.scanExtension(i.ourVersion,i.ourProductDate,n,s,d,y,A)}static mergeBuiltinExtensions(i,n){return Promise.all([i,n]).then(([s,d])=>{let y=Object.create(null);for(let E=0,R=s.length;E<R;E++)y[u.ExtensionIdentifier.toKey(s[E].identifier)]=s[E];for(let E=0,R=d.length;E<R;E++)y[u.ExtensionIdentifier.toKey(d[E].identifier)]=d[E];let A=Object.keys(y).map(E=>y[E]);return A.sort((E,R)=>{const O=k.basename(E.extensionLocation.fsPath),K=k.basename(R.extensionLocation.fsPath);return O<K?-1:O>K?1:0}),A})}}e.ExtensionScanner=r}),define(ue[260],de([0,1,2,48,5,45,179,10,259,43,66,81,71,94,223,4,23,17]),function(Y,e,S,k,p,P,t,T,h,f,C,I,m,u,c,b,g,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAgentEnvironmentChannel=void 0;let w=null;function v(){return w||(w=(0,b.normalize)((0,b.join)(T.FileAccess.asFileUri("",Y).fsPath,"..","extensions"))),w}let a=null;function l(){return a||(a=(0,b.normalize)((0,b.join)(T.FileAccess.asFileUri("",Y).fsPath,"..",".build","builtInExtensions"))),a}class r{constructor(i,n,s,d,y,A,E){this._connectionToken=i,this.environmentService=n,this.logService=d,this.telemetryService=y,this.telemetryAppender=A,this.productService=E,this._logger=new class{error(O,K){d.error(O,K)}warn(O,K){d.warn(O,K)}info(O,K){d.info(O,K)}},n.args["install-builtin-extension"]?this.whenExtensionsReady=s.installExtensions([],n.args["install-builtin-extension"],!!n.args["do-not-sync"],!!n.args.force).then(null,O=>{d.error(O)}):this.whenExtensionsReady=Promise.resolve();const R=n.args["install-extension"];if(R){const O=R.map(K=>/\.vsix$/i.test(K)?p.URI.file((0,b.isAbsolute)(K)?K:(0,b.join)((0,g.cwd)(),K)):K);this.whenExtensionsReady.then(()=>s.installExtensions(O,[],!!n.args["do-not-sync"],!!n.args.force)).then(null,K=>{d.error(K)})}}async call(i,n,s){switch(n){case"disableTelemetry":{this.telemetryService.permanentlyDisableTelemetry();return}case"getEnvironmentData":{const d=s,y=(0,P.createRemoteURITransformer)(d.remoteAuthority);let A=await this._getEnvironmentData();return A=(0,C.transformOutgoingURIs)(A,y),A}case"whenExtensionsReady":{await this.whenExtensionsReady;return}case"scanExtensions":{await this.whenExtensionsReady;const d=s,y=d.language;this.logService.trace(`Scanning extensions using UI language: ${y}`);const A=(0,P.createRemoteURITransformer)(d.remoteAuthority),E=d.extensionDevelopmentPath&&d.extensionDevelopmentPath.map(K=>p.URI.revive(A.transformIncoming(K))),R=E?E.filter(K=>K.scheme===T.Schemas.file).map(K=>K.fsPath):void 0;let O=await this._scanExtensions(y,R);return O=(0,C.transformOutgoingURIs)(O,A),this.logService.trace("Scanned Extensions",O),r._massageWhenConditions(O),O}case"scanSingleExtension":{await this.whenExtensionsReady;const d=s,y=d.language,A=d.isBuiltin,E=(0,P.createRemoteURITransformer)(d.remoteAuthority),R=p.URI.revive(E.transformIncoming(d.extensionLocation)),O=R.scheme===T.Schemas.file?R.fsPath:null;if(!O)return null;const K=await this._getTranslations(y);let te=await this._scanSingleExtension(O,A,y,K);return te?(te=(0,C.transformOutgoingURIs)(te,E),r._massageWhenConditions([te]),te):null}case"getDiagnosticInfo":{const d=s,y={machineInfo:(0,c.getMachineInfo)()},A=d.includeProcesses?(0,u.listProcesses)(process.pid):Promise.resolve();let E=[];const R={};if(d.folders){const O=(0,P.createRemoteURITransformer)("");E=d.folders.map(te=>p.URI.revive(O.transformIncoming(te))).filter(te=>te.scheme==="file").map(te=>(0,c.collectWorkspaceStats)(te.fsPath,["node_modules",".git"]).then(j=>{R[(0,b.basename)(te.fsPath)]=j}))}return Promise.all([A,...E]).then(([O,K])=>(y.processes=O||void 0,y.workspaceMetadata=d.folders?R:void 0,y))}case"logTelemetry":{const{eventName:d,data:y}=s;return this.telemetryAppender?this.telemetryAppender.log(d,y):Promise.resolve()}case"flushTelemetry":return this.telemetryAppender?this.telemetryAppender.flush():Promise.resolve()}throw new Error(`IPC Command ${n} not found`)}listen(i,n,s){throw new Error("Not supported")}static _massageWhenConditions(i){const n=(R,O)=>R.replace(/file/g,"vscode-remote"),s=R=>{let O="";return O+=R.global?"g":"",O+=R.ignoreCase?"i":"",O+=R.multiline?"m":"",new RegExp(n(R.source,!0),O)},d=new class{mapDefined(R){return m.ContextKeyDefinedExpr.create(R)}mapNot(R){return m.ContextKeyNotExpr.create(R)}mapEquals(R,O){return R==="resourceScheme"&&typeof O=="string"?m.ContextKeyEqualsExpr.create(R,n(O,!1)):m.ContextKeyEqualsExpr.create(R,O)}mapNotEquals(R,O){return R==="resourceScheme"&&typeof O=="string"?m.ContextKeyNotEqualsExpr.create(R,n(O,!1)):m.ContextKeyNotEqualsExpr.create(R,O)}mapGreater(R,O){return m.ContextKeyGreaterExpr.create(R,O)}mapGreaterEquals(R,O){return m.ContextKeyGreaterEqualsExpr.create(R,O)}mapSmaller(R,O){return m.ContextKeySmallerExpr.create(R,O)}mapSmallerEquals(R,O){return m.ContextKeySmallerEqualsExpr.create(R,O)}mapRegex(R,O){return R==="resourceScheme"&&O?m.ContextKeyRegexExpr.create(R,s(O)):m.ContextKeyRegexExpr.create(R,O)}mapIn(R,O){return m.ContextKeyInExpr.create(R,O)}},y=R=>{if(!R||!R.when||!/resourceScheme/.test(R.when))return;const O=m.ContextKeyExpr.deserialize(R.when);if(!O)return;const K=O.map(d);R.when=K.serialize()},A=R=>{if(Array.isArray(R))for(let O of R)y(O);else y(R)},E=R=>{for(let O in R)A(R[O])};i.forEach(R=>{R.contributes&&(R.contributes.menus&&E(R.contributes.menus),R.contributes.keybindings&&A(R.contributes.keybindings),R.contributes.views&&E(R.contributes.views))})}async _getEnvironmentData(){return{pid:process.pid,connectionToken:this._connectionToken,appRoot:p.URI.file(this.environmentService.appRoot),settingsPath:this.environmentService.machineSettingsResource,logsPath:p.URI.file(this.environmentService.logsPath),extensionsPath:p.URI.file(this.environmentService.extensionsPath),extensionHostLogsPath:p.URI.file((0,b.join)(this.environmentService.logsPath,`exthost${r._namePool++}`)),globalStorageHome:this.environmentService.globalStorageHome,workspaceStorageHome:this.environmentService.workspaceStorageHome,userHome:this.environmentService.userHome,os:S.OS,arch:process.arch,marks:k.getMarks(),useHostProxy:this.environmentService.args["use-host-proxy"]!==void 0}}async _getTranslations(i){const n=await(0,I.getNLSConfiguration)(i,this.environmentService.userDataPath);if(I.InternalNLSConfiguration.is(n))try{const s=await D.Promises.readFile(n._translationsConfigFile,"utf8");return JSON.parse(s)}catch(s){return Object.create(null)}else return Object.create(null)}async _scanExtensions(i,n){const s=await this._getTranslations(i),[d,y,A]=await Promise.all([this._scanBuiltinExtensions(i,s),this._scanInstalledExtensions(i,s),this._scanDevelopedExtensions(i,s,n)]);let E=new Map;d.forEach(O=>{!O||E.set(f.ExtensionIdentifier.toKey(O.identifier),O)}),y.forEach(O=>{!O||(E.has(f.ExtensionIdentifier.toKey(O.identifier))&&console.warn(t.localize(0,null,E.get(f.ExtensionIdentifier.toKey(O.identifier)).extensionLocation.fsPath,O.extensionLocation.fsPath)),E.set(f.ExtensionIdentifier.toKey(O.identifier),O))}),A.forEach(O=>{!O||E.set(f.ExtensionIdentifier.toKey(O.identifier),O)});const R=[];return E.forEach(O=>R.push(O)),R}_scanDevelopedExtensions(i,n,s){if(s){const d=s.map(y=>h.ExtensionScanner.scanOneOrMultipleExtensions(new h.ExtensionScannerInput(this.productService.version,this.productService.date,this.productService.commit,i,!0,y,!1,!0,n),this._logger));return Promise.all(d).then(y=>{let A=[];for(let E of y)A=A.concat(E);return A})}return Promise.resolve([])}_scanBuiltinExtensions(i,n){const s=this.productService.version,d=this.productService.commit,y=this.productService.date,A=!!process.env.VSCODE_DEV,E=new h.ExtensionScannerInput(s,y,d,i,A,v(),!0,!1,n),R=h.ExtensionScanner.scanExtensions(E,this._logger);let O=R;if(A){class K{constructor(F){this.builtInExtensions=F}resolveExtensions(){return Promise.resolve(this.builtInExtensions.map(F=>({name:F.name,path:(0,b.join)(l(),F.name)})))}}const te=Promise.resolve(this.productService.builtInExtensions||[]),j=new h.ExtensionScannerInput(s,y,d,i,A,l(),!0,!1,{}),_=te.then(U=>new K(U)).then(U=>h.ExtensionScanner.scanExtensions(j,this._logger,U));O=h.ExtensionScanner.mergeBuiltinExtensions(R,_)}return O}_scanInstalledExtensions(i,n){const s=!!process.env.VSCODE_DEV,d=new h.ExtensionScannerInput(this.productService.version,this.productService.date,this.productService.commit,i,s,this.environmentService.extensionsPath,!1,!1,n);return h.ExtensionScanner.scanExtensions(d,this._logger)}_scanSingleExtension(i,n,s,d){const y=!!process.env.VSCODE_DEV,A=new h.ExtensionScannerInput(this.productService.version,this.productService.date,this.productService.commit,s,y,i,n,!1,d);return h.ExtensionScanner.scanSingleExtension(A,this._logger)}}e.RemoteAgentEnvironmentChannel=r,r._namePool=1}),define(ue[261],de([0,1,12,3,10,204]),function(Y,e,S,k,p,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteFileSystemProvider=e.REMOTE_FILE_SYSTEM_CHANNEL_NAME=void 0,e.REMOTE_FILE_SYSTEM_CHANNEL_NAME="remoteFilesystem";class t extends P.IPCFileSystemProvider{static register(h,f,C){const I=h.getConnection();if(!I)return k.Disposable.None;const m=new k.DisposableStore,u=(async()=>{try{const c=await h.getRawEnvironment();c?f.registerProvider(p.Schemas.vscodeRemote,m.add(new t(c,I))):C.error("Cannot register remote filesystem provider. Remote environment doesnot exist.")}catch(c){C.error("Cannot register remote filesystem provider. Error while fetching remote environment.",(0,S.getErrorMessage)(c))}})();return m.add(f.onWillActivateFileSystemProvider(c=>{c.scheme===p.Schemas.vscodeRemote&&c.join(u)})),m}constructor(h,f){super(f.getChannel(e.REMOTE_FILE_SYSTEM_CHANNEL_NAME),{pathCaseSensitive:h.os===3})}}e.RemoteFileSystemProvider=t}),define(ue[122],de([0,1,7]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,S.createDecorator)("remoteAgentService")}),define(ue[262],de([0,1,186,22,49,44,80]),function(Y,e,S,k,p,P,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerColorThemeSchemas=e.colorThemeSchemaId=e.textmateColorGroupSchemaId=e.textmateColorSettingsSchemaId=e.textmateColorsSchemaId=void 0;let T=["comment","comment.block","comment.block.documentation","comment.line","constant","constant.character","constant.character.escape","constant.numeric","constant.numeric.integer","constant.numeric.float","constant.numeric.hex","constant.numeric.octal","constant.other","constant.regexp","constant.rgb-value","emphasis","entity","entity.name","entity.name.class","entity.name.function","entity.name.method","entity.name.section","entity.name.selector","entity.name.tag","entity.name.type","entity.other","entity.other.attribute-name","entity.other.inherited-class","invalid","invalid.deprecated","invalid.illegal","keyword","keyword.control","keyword.operator","keyword.operator.new","keyword.operator.assignment","keyword.operator.arithmetic","keyword.operator.logical","keyword.other","markup","markup.bold","markup.changed","markup.deleted","markup.heading","markup.inline.raw","markup.inserted","markup.italic","markup.list","markup.list.numbered","markup.list.unnumbered","markup.other","markup.quote","markup.raw","markup.underline","markup.underline.link","meta","meta.block","meta.cast","meta.class","meta.function","meta.function-call","meta.preprocessor","meta.return-type","meta.selector","meta.tag","meta.type.annotation","meta.type","punctuation.definition.string.begin","punctuation.definition.string.end","punctuation.separator","punctuation.separator.continuation","punctuation.terminator","storage","storage.modifier","storage.type","string","string.interpolated","string.other","string.quoted","string.quoted.double","string.quoted.other","string.quoted.single","string.quoted.triple","string.regexp","string.unquoted","strong","support","support.class","support.constant","support.function","support.other","support.type","support.type.property-name","support.variable","variable","variable.language","variable.name","variable.other","variable.other.readwrite","variable.parameter"];e.textmateColorsSchemaId="vscode://schemas/textmate-colors",e.textmateColorSettingsSchemaId=`${e.textmateColorsSchemaId}#definitions/settings`,e.textmateColorGroupSchemaId=`${e.textmateColorsSchemaId}#definitions/colorGroup`;const h={type:"array",definitions:{colorGroup:{default:"#FF0000",anyOf:[{type:"string",format:"color-hex"},{$ref:"#definitions/settings"}]},settings:{type:"object",description:S.localize(0,null),properties:{foreground:{type:"string",description:S.localize(1,null),format:"color-hex",default:"#ff0000"},background:{type:"string",deprecationMessage:S.localize(2,null)},fontStyle:{type:"string",description:S.localize(3,null),pattern:"^(\\s*\\b(italic|bold|underline))*\\s*$",patternErrorMessage:S.localize(4,null),defaultSnippets:[{label:S.localize(5,null),bodyText:'""'},{body:"italic"},{body:"bold"},{body:"underline"},{body:"italic bold"},{body:"italic underline"},{body:"bold underline"},{body:"italic bold underline"}]}},additionalProperties:!1,defaultSnippets:[{body:{foreground:"${1:#FF0000}",fontStyle:"${2:bold}"}}]}},items:{type:"object",defaultSnippets:[{body:{scope:"${1:keyword.operator}",settings:{foreground:"${2:#FF0000}"}}}],properties:{name:{type:"string",description:S.localize(6,null)},scope:{description:S.localize(7,null),anyOf:[{enum:T},{type:"string"},{type:"array",items:{enum:T}},{type:"array",items:{type:"string"}}]},settings:{$ref:"#definitions/settings"}},required:["settings","scope"],additionalProperties:!1}};e.colorThemeSchemaId="vscode://schemas/color-theme";const f={type:"object",allowComments:!0,allowTrailingCommas:!0,properties:{colors:{description:S.localize(8,null),$ref:P.workbenchColorsSchemaId,additionalProperties:!1},tokenColors:{anyOf:[{type:"string",description:S.localize(9,null)},{description:S.localize(10,null),$ref:e.textmateColorsSchemaId}]},semanticHighlighting:{type:"boolean",description:S.localize(11,null)},semanticTokenColors:{type:"object",description:S.localize(12,null),$ref:t.tokenStylingSchemaId}}};function C(){let I=k.Registry.as(p.Extensions.JSONContribution);I.registerSchema(e.colorThemeSchemaId,f),I.registerSchema(e.textmateColorsSchemaId,h)}e.registerColorThemeSchemas=C}),define(ue[263],de([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parse=e.parseWithLocation=void 0;var S;(function(T){T[T.BOM=65279]="BOM",T[T.SPACE=32]="SPACE",T[T.TAB=9]="TAB",T[T.CARRIAGE_RETURN=13]="CARRIAGE_RETURN",T[T.LINE_FEED=10]="LINE_FEED",T[T.SLASH=47]="SLASH",T[T.LESS_THAN=60]="LESS_THAN",T[T.QUESTION_MARK=63]="QUESTION_MARK",T[T.EXCLAMATION_MARK=33]="EXCLAMATION_MARK"})(S||(S={}));var k;(function(T){T[T.ROOT_STATE=0]="ROOT_STATE",T[T.DICT_STATE=1]="DICT_STATE",T[T.ARR_STATE=2]="ARR_STATE"})(k||(k={}));function p(T,h,f){return t(T,h,f)}e.parseWithLocation=p;function P(T){return t(T,null,null)}e.parse=P;function t(T,h,f){const C=T.length;let I=0,m=1,u=0;C>0&&T.charCodeAt(0)===65279&&(I=1);function c(q){if(f===null)I=I+q;else for(;q>0;)T.charCodeAt(I)===10?(I++,m++,u=0):(I++,u++),q--}function b(q){f===null?I=q:c(q-I)}function g(){for(;I<C;){let q=T.charCodeAt(I);if(q!==32&&q!==9&&q!==13&&q!==10)break;c(1)}}function D(q){return T.substr(I,q.length)===q?(c(q.length),!0):!1}function w(q){let z=T.indexOf(q,I);b(z!==-1?z+q.length:C)}function v(q){let z=T.indexOf(q,I);if(z!==-1){let B=T.substring(I,z);return b(z+q.length),B}else{let B=T.substr(I);return b(C),B}}let a=0,l=null,r=[],o=[],i=null;function n(q,z){r.push(a),o.push(l),a=q,l=z}function s(){if(r.length===0)return d("illegal state stack");a=r.pop(),l=o.pop()}function d(q){throw new Error("Near offset "+I+": "+q+" ~~~"+T.substr(I,50)+"~~~")}const y={enterDict:function(){if(i===null)return d("missing <key>");let q={};f!==null&&(q[f]={filename:h,line:m,char:u}),l[i]=q,i=null,n(1,q)},enterArray:function(){if(i===null)return d("missing <key>");let q=[];l[i]=q,i=null,n(2,q)}},A={enterDict:function(){let q={};f!==null&&(q[f]={filename:h,line:m,char:u}),l.push(q),n(1,q)},enterArray:function(){let q=[];l.push(q),n(2,q)}};function E(){a===1?y.enterDict():a===2?A.enterDict():(l={},f!==null&&(l[f]={filename:h,line:m,char:u}),n(1,l))}function R(){if(a===1)s();else return d("unexpected </dict>")}function O(){a===1?y.enterArray():a===2?A.enterArray():(l=[],n(2,l))}function K(){if(a===1)return d("unexpected </array>");if(a===2)s();else return d("unexpected </array>")}function te(q){if(a===1){if(i!==null)return d("too many <key>");i=q}else return d("unexpected <key>")}function j(q){if(a===1){if(i===null)return d("missing <key>");l[i]=q,i=null}else a===2?l.push(q):l=q}function _(q){if(isNaN(q))return d("cannot parse float");if(a===1){if(i===null)return d("missing <key>");l[i]=q,i=null}else a===2?l.push(q):l=q}function U(q){if(isNaN(q))return d("cannot parse integer");if(a===1){if(i===null)return d("missing <key>");l[i]=q,i=null}else a===2?l.push(q):l=q}function F(q){if(a===1){if(i===null)return d("missing <key>");l[i]=q,i=null}else a===2?l.push(q):l=q}function M(q){if(a===1){if(i===null)return d("missing <key>");l[i]=q,i=null}else a===2?l.push(q):l=q}function V(q){if(a===1){if(i===null)return d("missing <key>");l[i]=q,i=null}else a===2?l.push(q):l=q}function ee(q){return q.replace(/&#([0-9]+);/g,function(z,B){return String.fromCodePoint(parseInt(B,10))}).replace(/&#x([0-9a-f]+);/g,function(z,B){return String.fromCodePoint(parseInt(B,16))}).replace(/&amp;|&lt;|&gt;|&quot;|&apos;/g,function(z){switch(z){case"&amp;":return"&";case"&lt;":return"<";case"&gt;":return">";case"&quot;":return'"';case"&apos;":return"'"}return z})}function G(){let q=v(">"),z=!1;return q.charCodeAt(q.length-1)===47&&(z=!0,q=q.substring(0,q.length-1)),{name:q.trim(),isClosed:z}}function H(q){if(q.isClosed)return"";let z=v("</");return w(">"),ee(z)}for(;I<C&&(g(),!(I>=C));){const q=T.charCodeAt(I);if(c(1),q!==60)return d("expected <");if(I>=C)return d("unexpected end of input");const z=T.charCodeAt(I);if(z===63){c(1),w("?>");continue}if(z===33){if(c(1),D("--")){w("-->");continue}w(">");continue}if(z===47){if(c(1),g(),D("plist")){w(">");continue}if(D("dict")){w(">"),R();continue}if(D("array")){w(">"),K();continue}return d("unexpected closed tag")}let B=G();switch(B.name){case"dict":E(),B.isClosed&&R();continue;case"array":O(),B.isClosed&&K();continue;case"key":te(H(B));continue;case"string":j(H(B));continue;case"real":_(parseFloat(H(B)));continue;case"integer":U(parseInt(H(B),10));continue;case"date":F(new Date(H(B)));continue;case"data":M(H(B));continue;case"true":H(B),V(!0);continue;case"false":H(B),V(!1);continue}if(!/^plist/.test(B.name))return d("unexpected opened tag "+B.name)}return l}}),define(ue[264],de([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createMatchers=void 0;function S(P,t,T){const h=p(P);let f=h.next();for(;f!==null;){let u=0;if(f.length===2&&f.charAt(1)===":"){switch(f.charAt(0)){case"R":u=1;break;case"L":u=-1;break;default:console.log(`Unknown priority ${f} in scope selector`)}f=h.next()}let c=I();if(c&&T.push({matcher:c,priority:u}),f!==",")break;f=h.next()}function C(){if(f==="-"){f=h.next();const u=C();return u?c=>u(c)<0?0:-1:null}if(f==="("){f=h.next();const u=m();return f===")"&&(f=h.next()),u}if(k(f)){const u=[];do u.push(f),f=h.next();while(k(f));return c=>t(u,c)}return null}function I(){let u=C();if(!u)return null;const c=[];for(;u;)c.push(u),u=C();return b=>{let g=c[0](b);for(let D=1;g>=0&&D<c.length;D++)g=Math.min(g,c[D](b));return g}}function m(){let u=I();if(!u)return null;const c=[];for(;u&&(c.push(u),f==="|"||f===",");){do f=h.next();while(f==="|"||f===",");u=I()}return b=>{let g=c[0](b);for(let D=1;D<c.length;D++)g=Math.max(g,c[D](b));return g}}}e.createMatchers=S;function k(P){return!!P&&!!P.match(/[\w\.:]+/)}function p(P){let t=/([LR]:|[\w\.:][\w\.:\-]*|[\,\|\-\(\)])/g,T=t.exec(P);return{next:()=>{if(!T)return null;const h=T[0];return T=t.exec(P),h}}}}),define(ue[265],de([0,1,46,44,230]),function(Y,e,S,k,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.convertSettings=void 0;const P={};function t(f,C){let I=P[f];I||(P[f]=I=[]),I.push(C)}function T(f,C){for(let I of f)if(C.textMateRules.push(I),!I.scope){let m=I.settings;if(!m)I.settings={};else for(const u in m){const c=u;let b=P[c];if(b){let g=m[c];if(typeof g=="string"){let D=S.Color.fromHex(g);for(let w of b)C.colors[w]=D}}c!=="foreground"&&c!=="background"&&c!=="fontStyle"&&delete m[c]}}}e.convertSettings=T,t("background",k.editorBackground),t("foreground",k.editorForeground),t("selection",k.editorSelectionBackground),t("inactiveSelection",k.editorInactiveSelection),t("selectionHighlightColor",k.editorSelectionHighlight),t("findMatchHighlight",k.editorFindMatchHighlight),t("currentFindMatchHighlight",k.editorFindMatch),t("hoverHighlight",k.editorHoverHighlight),t("wordHighlight","editor.wordHighlightBackground"),t("wordHighlightStrong","editor.wordHighlightStrongBackground"),t("findRangeHighlight",k.editorFindRangeHighlight),t("findMatchHighlight","peekViewResult.matchHighlightBackground"),t("referenceHighlight","peekViewEditor.matchHighlightBackground"),t("lineHighlight",p.editorLineHighlight),t("rangeHighlight",p.editorRangeHighlight),t("caret",p.editorCursorForeground),t("invisibles",p.editorWhitespaces),t("guide",p.editorIndentGuides),t("activeGuide",p.editorActiveIndentGuides);const h=["ansiBlack","ansiRed","ansiGreen","ansiYellow","ansiBlue","ansiMagenta","ansiCyan","ansiWhite","ansiBrightBlack","ansiBrightRed","ansiBrightGreen","ansiBrightYellow","ansiBrightBlue","ansiBrightMagenta","ansiBrightCyan","ansiBrightWhite"];for(const f of h)t(f,"terminal."+f)}),define(ue[83],de([0,1,7,50,11]),function(Y,e,S,k,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionData=e.ThemeSettings=e.themeScopeRegex=e.THEME_SCOPE_WILDCARD=e.THEME_SCOPE_CLOSE_PAREN=e.THEME_SCOPE_OPEN_PAREN=e.HC_THEME_ID=e.VS_HC_THEME=e.VS_DARK_THEME=e.VS_LIGHT_THEME=e.IWorkbenchThemeService=void 0,e.IWorkbenchThemeService=(0,S.refineServiceDecorator)(k.IThemeService),e.VS_LIGHT_THEME="vs",e.VS_DARK_THEME="vs-dark",e.VS_HC_THEME="hc-black",e.HC_THEME_ID="Default High Contrast",e.THEME_SCOPE_OPEN_PAREN="[",e.THEME_SCOPE_CLOSE_PAREN="]",e.THEME_SCOPE_WILDCARD="*",e.themeScopeRegex=/\[(.+?)\]/g;var P;(function(T){T.COLOR_THEME="workbench.colorTheme",T.FILE_ICON_THEME="workbench.iconTheme",T.PRODUCT_ICON_THEME="workbench.productIconTheme",T.COLOR_CUSTOMIZATIONS="workbench.colorCustomizations",T.TOKEN_COLOR_CUSTOMIZATIONS="editor.tokenColorCustomizations",T.SEMANTIC_TOKEN_COLOR_CUSTOMIZATIONS="editor.semanticTokenColorCustomizations",T.PREFERRED_DARK_THEME="workbench.preferredDarkColorTheme",T.PREFERRED_LIGHT_THEME="workbench.preferredLightColorTheme",T.PREFERRED_HC_THEME="workbench.preferredHighContrastColorTheme",T.DETECT_COLOR_SCHEME="window.autoDetectColorScheme",T.DETECT_HC="window.autoDetectHighContrast"})(P=e.ThemeSettings||(e.ThemeSettings={}));var t;(function(T){function h(C){return C&&{_extensionId:C.extensionId,_extensionIsBuiltin:C.extensionIsBuiltin,_extensionName:C.extensionName,_extensionPublisher:C.extensionPublisher}}T.toJSONObject=h;function f(C){if(C&&(0,p.isString)(C._extensionId)&&(0,p.isBoolean)(C._extensionIsBuiltin)&&(0,p.isString)(C._extensionName)&&(0,p.isString)(C._extensionPublisher))return{extensionId:C._extensionId,extensionIsBuiltin:C._extensionIsBuiltin,extensionName:C._extensionName,extensionPublisher:C._extensionPublisher}}T.fromJSONObject=f})(t=e.ExtensionData||(e.ExtensionData={}))}),define(ue[266],de([0,1,4,36,46,83,265,185,11,19,44,50,22,97,263,80,264,79]),function(Y,e,S,k,p,P,t,T,h,f,C,I,m,u,c,b,g,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorThemeData=void 0;let w=m.Registry.as(C.Extensions.ColorContribution),v=(0,b.getTokenClassificationRegistry)();const a={comments:["comment","punctuation.definition.comment"],strings:["string","meta.embedded.assembly"],keywords:["keyword - keyword.operator","keyword.control","storage","storage.type"],numbers:["constant.numeric"],types:["entity.name.type","entity.name.class","support.type","support.class"],functions:["entity.name.function","support.function"],variables:["variable","entity.name.variable"]};class l{constructor(_,U,F){this.themeTokenColors=[],this.customTokenColors=[],this.colorMap={},this.customColorMap={},this.semanticTokenRules=[],this.customSemanticTokenRules=[],this.textMateThemingRules=void 0,this.tokenColorIndex=void 0,this.id=_,this.label=U,this.settingsId=F,this.isLoaded=!1}get semanticHighlighting(){return this.customSemanticHighlighting!==void 0?this.customSemanticHighlighting:this.customSemanticHighlightingDeprecated!==void 0?this.customSemanticHighlightingDeprecated:!!this.themeSemanticHighlighting}get tokenColors(){if(!this.textMateThemingRules){let V=function(ee){ee.scope&&ee.settings&&(ee.scope==="token.info-token"&&(M=!0),_.push({scope:ee.scope,settings:{foreground:K(ee.settings.foreground),background:K(ee.settings.background),fontStyle:ee.settings.fontStyle}}))};const _=[],U=this.getColor(C.editorForeground)||this.getDefault(C.editorForeground),F=this.getColor(C.editorBackground)||this.getDefault(C.editorBackground);_.push({settings:{foreground:K(U),background:K(F)}});let M=!1;this.themeTokenColors.forEach(V),this.customTokenColors.forEach(V),M||n[this.type].forEach(V),this.textMateThemingRules=_}return this.textMateThemingRules}getColor(_,U){let F=this.customColorMap[_];return F||(F=this.colorMap[_],U!==!1&&h.isUndefined(F)&&(F=this.getDefault(_)),F)}getTokenStyle(_,U,F,M=!0,V={}){let ee={foreground:void 0,bold:void 0,underline:void 0,italic:void 0},G={foreground:-1,bold:-1,underline:-1,italic:-1};function H(B,W,ie){W.foreground&&G.foreground<=B&&(G.foreground=B,ee.foreground=W.foreground,V.foreground=ie);for(let oe of["bold","underline","italic"]){const we=oe,se=W[we];se!==void 0&&G[we]<=B&&(G[we]=B,ee[we]=se,V[we]=ie)}}function q(B){const W=B.selector.match(_,U,F);W>=0&&H(W,B.style,B)}this.semanticTokenRules.forEach(q),this.customSemanticTokenRules.forEach(q);let z=!1;for(let B in G){const W=B;G[W]===-1?z=!0:G[W]=Number.MAX_VALUE}if(z)for(const B of v.getTokenStylingDefaultRules()){const W=B.selector.match(_,U,F);if(W>=0){let ie;if(B.defaults.scopesToProbe&&(ie=this.resolveScopes(B.defaults.scopesToProbe),ie&&H(W,ie,B.defaults.scopesToProbe)),!ie&&M!==!1){const oe=B.defaults[this.type];ie=this.resolveTokenStyleValue(oe),ie&&H(W,ie,oe)}}}return b.TokenStyle.fromData(ee)}resolveTokenStyleValue(_){if(_!==void 0){if(typeof _=="string"){const{type:U,modifiers:F,language:M}=(0,b.parseClassifierString)(_,"");return this.getTokenStyle(U,F,M)}else if(typeof _=="object")return _}}getTokenColorIndex(){if(!this.tokenColorIndex){const _=new O;this.tokenColors.forEach(U=>{_.add(U.settings.foreground),_.add(U.settings.background)}),this.semanticTokenRules.forEach(U=>_.add(U.style.foreground)),v.getTokenStylingDefaultRules().forEach(U=>{const F=U.defaults[this.type];F&&typeof F=="object"&&_.add(F.foreground)}),this.customSemanticTokenRules.forEach(U=>_.add(U.style.foreground)),this.tokenColorIndex=_}return this.tokenColorIndex}get tokenColorMap(){return this.getTokenColorIndex().asArray()}getTokenStyleMetadata(_,U,F,M=!0,V={}){const{type:ee,language:G}=(0,b.parseClassifierString)(_,F);let H=this.getTokenStyle(ee,U,G,M,V);if(!!H)return{foreground:this.getTokenColorIndex().get(H.foreground),bold:H.bold,underline:H.underline,italic:H.italic}}getTokenStylingRuleScope(_){if(this.customSemanticTokenRules.indexOf(_)!==-1)return"setting";if(this.semanticTokenRules.indexOf(_)!==-1)return"theme"}getDefault(_){return w.resolveDefaultColor(_,this)}resolveScopes(_,U){this.themeTokenScopeMatchers||(this.themeTokenScopeMatchers=this.themeTokenColors.map(A)),this.customTokenScopeMatchers||(this.customTokenScopeMatchers=this.customTokenColors.map(A));for(let F of _){let z=function(B,W){for(let ie=0;ie<B.length;ie++){const oe=B[ie](F);if(oe>=0){const we=W[ie],se=W[ie].settings;oe>=ee&&se.foreground&&(M=se.foreground,ee=oe,q=we),oe>=G&&h.isString(se.fontStyle)&&(V=se.fontStyle,G=oe,H=we)}}},M,V,ee=-1,G=-1,H,q;if(z(this.themeTokenScopeMatchers,this.themeTokenColors),z(this.customTokenScopeMatchers,this.customTokenColors),M!==void 0||V!==void 0)return U&&(U.foreground=q,U.bold=U.italic=U.underline=H,U.scope=F),b.TokenStyle.fromSettings(M,V)}}defines(_){return this.customColorMap.hasOwnProperty(_)||this.colorMap.hasOwnProperty(_)}setCustomizations(_){this.setCustomColors(_.colorCustomizations),this.setCustomTokenColors(_.tokenColorCustomizations),this.setCustomSemanticTokenColors(_.semanticTokenColorCustomizations)}setCustomColors(_){this.customColorMap={},this.overwriteCustomColors(_);const U=this.getThemeSpecificColors(_);h.isObject(U)&&this.overwriteCustomColors(U),this.tokenColorIndex=void 0,this.textMateThemingRules=void 0,this.customTokenScopeMatchers=void 0}overwriteCustomColors(_){for(let U in _){let F=_[U];typeof F=="string"&&(this.customColorMap[U]=p.Color.fromHex(F))}}setCustomTokenColors(_){this.customTokenColors=[],this.customSemanticHighlightingDeprecated=void 0,this.addCustomTokenColors(_);const U=this.getThemeSpecificColors(_);h.isObject(U)&&this.addCustomTokenColors(U),this.tokenColorIndex=void 0,this.textMateThemingRules=void 0,this.customTokenScopeMatchers=void 0}setCustomSemanticTokenColors(_){if(this.customSemanticTokenRules=[],this.customSemanticHighlighting=void 0,_){this.customSemanticHighlighting=_.enabled,_.rules&&this.readSemanticTokenRules(_.rules);const U=this.getThemeSpecificColors(_);h.isObject(U)&&(U.enabled!==void 0&&(this.customSemanticHighlighting=U.enabled),U.rules&&this.readSemanticTokenRules(U.rules))}this.tokenColorIndex=void 0,this.textMateThemingRules=void 0}isThemeScope(_){return _.charAt(0)===P.THEME_SCOPE_OPEN_PAREN&&_.charAt(_.length-1)===P.THEME_SCOPE_CLOSE_PAREN}isThemeScopeMatch(_){const U=_.charAt(0),F=_.charAt(_.length-1),M=_.slice(0,-1),V=_.slice(1,-1),ee=_.slice(1);return _===this.settingsId||this.settingsId.includes(V)&&U===P.THEME_SCOPE_WILDCARD&&F===P.THEME_SCOPE_WILDCARD||this.settingsId.startsWith(M)&&F===P.THEME_SCOPE_WILDCARD||this.settingsId.endsWith(ee)&&U===P.THEME_SCOPE_WILDCARD}getThemeSpecificColors(_){let U;for(let F in _){const M=_[F];if(this.isThemeScope(F)&&M instanceof Object&&!h.isArray(M)){const V=F.match(P.themeScopeRegex)||[];for(let ee of V){const G=ee.substring(1,ee.length-1);if(this.isThemeScopeMatch(G)){U||(U={});const H=M;for(let q in H){const z=U[q],B=H[q];h.isArray(z)&&h.isArray(B)?U[q]=z.concat(B):B&&(U[q]=B)}}}}}return U}readSemanticTokenRules(_){for(let U in _)if(!this.isThemeScope(U))try{const F=E(U,_[U]);F&&this.customSemanticTokenRules.push(F)}catch(F){}}addCustomTokenColors(_){for(let U in a){const F=U;let M=_[F];if(M){let V=typeof M=="string"?{foreground:M}:M,ee=a[F];for(let G of ee)this.customTokenColors.push({scope:G,settings:V})}}if(Array.isArray(_.textMateRules))for(let U of _.textMateRules)U.scope&&U.settings&&this.customTokenColors.push(U);_.semanticHighlighting!==void 0&&(this.customSemanticHighlightingDeprecated=_.semanticHighlighting)}ensureLoaded(_){return this.isLoaded?Promise.resolve(void 0):this.load(_)}reload(_){return this.load(_)}load(_){if(!this.location)return Promise.resolve(void 0);this.themeTokenColors=[],this.clearCaches();const U={colors:{},textMateRules:[],semanticTokenRules:[],semanticHighlighting:!1};return o(_,this.location,U).then(F=>{this.isLoaded=!0,this.semanticTokenRules=U.semanticTokenRules,this.colorMap=U.colors,this.themeTokenColors=U.textMateRules,this.themeSemanticHighlighting=U.semanticHighlighting})}clearCaches(){this.tokenColorIndex=void 0,this.textMateThemingRules=void 0,this.themeTokenScopeMatchers=void 0,this.customTokenScopeMatchers=void 0}toStorage(_){let U={};for(let M in this.colorMap)U[M]=p.Color.Format.CSS.formatHexA(this.colorMap[M],!0);const F=JSON.stringify({id:this.id,label:this.label,settingsId:this.settingsId,themeTokenColors:this.themeTokenColors.map(M=>({settings:M.settings,scope:M.scope})),semanticTokenRules:this.semanticTokenRules.map(b.SemanticTokenRule.toJSONObject),extensionData:P.ExtensionData.toJSONObject(this.extensionData),themeSemanticHighlighting:this.themeSemanticHighlighting,colorMap:U,watch:this.watch});_.store(l.STORAGE_KEY,F,0,0)}get baseTheme(){return this.classNames[0]}get classNames(){return this.id.split(" ")}get type(){switch(this.baseTheme){case P.VS_LIGHT_THEME:return D.ColorScheme.LIGHT;case P.VS_HC_THEME:return D.ColorScheme.HIGH_CONTRAST;default:return D.ColorScheme.DARK}}static createUnloadedThemeForThemeType(_,U){return l.createUnloadedTheme((0,I.getThemeTypeSelector)(_),U)}static createUnloadedTheme(_,U){let F=new l(_,"","__"+_);if(F.isLoaded=!1,F.themeTokenColors=[],F.watch=!1,U)for(let M in U)F.colorMap[M]=p.Color.fromHex(U[M]);return F}static createLoadedEmptyTheme(_,U){let F=new l(_,"",U);return F.isLoaded=!0,F.themeTokenColors=[],F.watch=!1,F}static fromStorageData(_){const U=_.get(l.STORAGE_KEY,0);if(!!U)try{let F=JSON.parse(U),M=new l("","","");for(let V in F)switch(V){case"colorMap":let ee=F[V];for(let H in ee)M.colorMap[H]=p.Color.fromHex(ee[H]);break;case"themeTokenColors":case"id":case"label":case"settingsId":case"watch":case"themeSemanticHighlighting":M[V]=F[V];break;case"semanticTokenRules":const G=F[V];if(Array.isArray(G))for(let H of G){const q=b.SemanticTokenRule.fromJSONObject(v,H);q&&M.semanticTokenRules.push(q)}break;case"location":break;case"extensionData":M.extensionData=P.ExtensionData.fromJSONObject(F.extensionData);break}return!M.id||!M.settingsId?void 0:M}catch(F){return}}static fromExtensionTheme(_,U,F){const M=_.uiTheme||"vs-dark",V=r(F.extensionId,_.path),ee=`${M} ${V}`,G=_.label||(0,S.basename)(_.path),H=_.id||G,q=new l(ee,G,H);return q.description=_.description,q.watch=_._watch===!0,q.location=U,q.extensionData=F,q.isLoaded=!1,q}}e.ColorThemeData=l,l.STORAGE_KEY="colorThemeData";function r(j,_){_.startsWith("./")&&(_=_.substr(2));let U=`${j}-${_}`;return U=U.replace(/[^_a-zA-Z0-9-]/g,"-"),U.charAt(0).match(/[0-9-]/)&&(U="_"+U),U}async function o(j,_,U){if(f.extname(_)===".json"){const F=await j.readExtensionResource(_);let M=[],V=k.parse(F,M);if(M.length>0)return Promise.reject(new Error(T.localize(0,null,M.map(q=>(0,u.getParseErrorMessage)(q.error)).join(", "))));if(k.getNodeType(V)!=="object")return Promise.reject(new Error(T.localize(1,null)));if(V.include&&await o(j,f.joinPath(f.dirname(_),V.include),U),Array.isArray(V.settings))return(0,t.convertSettings)(V.settings,U),null;U.semanticHighlighting=U.semanticHighlighting||V.semanticHighlighting;let ee=V.colors;if(ee){if(typeof ee!="object")return Promise.reject(new Error(T.localize(2,null,_.toString())));for(let q in ee)typeof ee[q]=="string"&&(U.colors[q]=p.Color.fromHex(ee[q]))}let G=V.tokenColors;if(G)if(Array.isArray(G))U.textMateRules.push(...G);else if(typeof G=="string")await i(j,f.joinPath(f.dirname(_),G),U);else return Promise.reject(new Error(T.localize(3,null,_.toString())));let H=V.semanticTokenColors;if(H&&typeof H=="object")for(let q in H)try{const z=E(q,H[q]);z&&U.semanticTokenRules.push(z)}catch(z){return Promise.reject(new Error(T.localize(4,null,_.toString())))}}else return i(j,_,U)}function i(j,_,U){return j.readExtensionResource(_).then(F=>{try{let V=(0,c.parse)(F).settings;return Array.isArray(V)?((0,t.convertSettings)(V,U),Promise.resolve(null)):Promise.reject(new Error(T.localize(5,null)))}catch(M){return Promise.reject(new Error(T.localize(6,null,M.message)))}},F=>Promise.reject(new Error(T.localize(7,null,_.toString(),F.message))))}let n={light:[{scope:"token.info-token",settings:{foreground:"#316bcd"}},{scope:"token.warn-token",settings:{foreground:"#cd9731"}},{scope:"token.error-token",settings:{foreground:"#cd3131"}},{scope:"token.debug-token",settings:{foreground:"#800080"}}],dark:[{scope:"token.info-token",settings:{foreground:"#6796e6"}},{scope:"token.warn-token",settings:{foreground:"#cd9731"}},{scope:"token.error-token",settings:{foreground:"#f44747"}},{scope:"token.debug-token",settings:{foreground:"#b267e6"}}],hc:[{scope:"token.info-token",settings:{foreground:"#6796e6"}},{scope:"token.warn-token",settings:{foreground:"#008000"}},{scope:"token.error-token",settings:{foreground:"#FF0000"}},{scope:"token.debug-token",settings:{foreground:"#b267e6"}}]};const s=j=>-1;function d(j,_){function U(V,ee){for(let G=ee-1;G>=0;G--)if(y(V,j[G]))return G;return-1}if(_.length<j.length)return-1;let F=_.length-1,M=U(_[F--],j.length);if(M>=0){const V=(M+1)*65536+j[M].length;for(;F>=0;)if(M=U(_[F--],M),M===-1)return-1;return V}return-1}function y(j,_){if(!j)return!1;if(j===_)return!0;const U=_.length;return j.length>U&&j.substr(0,U)===_&&j[U]==="."}function A(j){const _=j.scope;if(!_||!j.settings)return s;const U=[];if(Array.isArray(_))for(let F of _)(0,g.createMatchers)(F,d,U);else(0,g.createMatchers)(_,d,U);return U.length===0?s:F=>{let M=U[0].matcher(F);for(let V=1;V<U.length;V++)M=Math.max(M,U[V].matcher(F));return M}}function E(j,_){const U=v.parseTokenSelector(j);let F;if(typeof _=="string"?F=b.TokenStyle.fromSettings(_,void 0):R(_)&&(F=b.TokenStyle.fromSettings(_.foreground,_.fontStyle,_.bold,_.underline,_.italic)),F)return{selector:U,style:F}}function R(j){return j&&(h.isString(j.foreground)||h.isString(j.fontStyle)||h.isBoolean(j.italic)||h.isBoolean(j.underline)||h.isBoolean(j.bold))}class O{constructor(){this._lastColorId=0,this._id2color=[],this._color2id=Object.create(null)}add(_){if(_=K(_),_===void 0)return 0;let U=this._color2id[_];return U||(U=++this._lastColorId,this._color2id[_]=U,this._id2color[U]=_,U)}get(_){if(_=K(_),_===void 0)return 0;let U=this._color2id[_];return U||(console.log(`Color ${_} not in index.`),0)}asArray(){return this._id2color.slice(0)}}function K(j){if(!j)return;typeof j!="string"&&(j=p.Color.Format.CSS.formatHexA(j,!0));const _=j.length;if(j.charCodeAt(0)!==35||_!==4&&_!==5&&_!==7&&_!==9)return;let U=[35];for(let F=1;F<_;F++){const M=te(j.charCodeAt(F));if(!M)return;U.push(M),(_===4||_===5)&&U.push(M)}return U.length===9&&U[7]===70&&U[8]===70&&(U.length=7),String.fromCharCode(...U)}function te(j){return j>=48&&j<=57||j>=65&&j<=70?j:j>=97&&j<=102?j-97+65:0}}),define(ue[267],de([0,1,187,11,22,42,262,44,80,83,2]),function(Y,e,S,k,p,P,t,T,h,f,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeConfiguration=e.updateProductIconThemeConfigurationSchemas=e.updateFileIconThemeConfigurationSchemas=e.updateColorThemeConfigurationSchemas=e.DEFAULT_PRODUCT_ICON_THEME_SETTING_VALUE=void 0;const I="Default Dark+",m="Default Light+",u="Default High Contrast",c="vs-seti";e.DEFAULT_PRODUCT_ICON_THEME_SETTING_VALUE="Default";const b=p.Registry.as(P.Extensions.Configuration),g=[],D=[],w=[],v={type:"string",description:S.localize(0,null),default:C.isWeb?m:I,enum:g,enumDescriptions:w,enumItemLabels:D,errorMessage:S.localize(1,null)},a={type:"string",markdownDescription:S.localize(2,null,f.ThemeSettings.DETECT_COLOR_SCHEME),default:I,enum:g,enumDescriptions:w,enumItemLabels:D,errorMessage:S.localize(3,null)},l={type:"string",markdownDescription:S.localize(4,null,f.ThemeSettings.DETECT_COLOR_SCHEME),default:m,enum:g,enumDescriptions:w,enumItemLabels:D,errorMessage:S.localize(5,null)},r={type:"string",markdownDescription:S.localize(6,null,f.ThemeSettings.DETECT_HC),default:u,enum:g,enumDescriptions:w,enumItemLabels:D,included:C.isWindows||C.isMacintosh,errorMessage:S.localize(7,null)},o={type:"boolean",markdownDescription:S.localize(8,null,f.ThemeSettings.PREFERRED_DARK_THEME,f.ThemeSettings.PREFERRED_LIGHT_THEME),default:!1},i={type:"object",description:S.localize(9,null),allOf:[{$ref:T.workbenchColorsSchemaId}],default:{},defaultSnippets:[{body:{}}]},n={type:["string","null"],default:c,description:S.localize(10,null),enum:[null],enumItemLabels:[S.localize(11,null)],enumDescriptions:[S.localize(12,null)],errorMessage:S.localize(13,null)},s={type:["string","null"],default:e.DEFAULT_PRODUCT_ICON_THEME_SETTING_VALUE,description:S.localize(14,null),enum:[e.DEFAULT_PRODUCT_ICON_THEME_SETTING_VALUE],enumItemLabels:[S.localize(15,null)],enumDescriptions:[S.localize(16,null)],errorMessage:S.localize(17,null)},d={type:"boolean",default:!0,markdownDescription:S.localize(18,null,f.ThemeSettings.PREFERRED_HC_THEME),scope:1},y={id:"workbench",order:7.1,type:"object",properties:{[f.ThemeSettings.COLOR_THEME]:v,[f.ThemeSettings.PREFERRED_DARK_THEME]:a,[f.ThemeSettings.PREFERRED_LIGHT_THEME]:l,[f.ThemeSettings.PREFERRED_HC_THEME]:r,[f.ThemeSettings.FILE_ICON_THEME]:n,[f.ThemeSettings.COLOR_CUSTOMIZATIONS]:i,[f.ThemeSettings.PRODUCT_ICON_THEME]:s}};b.registerConfiguration(y);const A={id:"window",order:8.1,type:"object",properties:{[f.ThemeSettings.DETECT_HC]:d,[f.ThemeSettings.DETECT_COLOR_SCHEME]:o}};b.registerConfiguration(A);function E(ee){return{description:ee,$ref:t.textmateColorGroupSchemaId}}const R="^\\[[^\\]]*(\\]\\s*\\[[^\\]]*)*\\]$",O={type:"object",properties:{comments:E(S.localize(19,null)),strings:E(S.localize(20,null)),keywords:E(S.localize(21,null)),numbers:E(S.localize(22,null)),types:E(S.localize(23,null)),functions:E(S.localize(24,null)),variables:E(S.localize(25,null)),textMateRules:{description:S.localize(26,null),$ref:t.textmateColorsSchemaId},semanticHighlighting:{description:S.localize(27,null),deprecationMessage:S.localize(28,null),markdownDeprecationMessage:S.localize(29,null),type:"boolean"}},additionalProperties:!1},K={description:S.localize(30,null),default:{},allOf:[{...O,patternProperties:{"^\\[":{}}}]},te={type:"object",properties:{enabled:{type:"boolean",description:S.localize(31,null),suggestSortText:"0_enabled"},rules:{$ref:h.tokenStylingSchemaId,description:S.localize(32,null),suggestSortText:"0_rules"}},additionalProperties:!1},j={description:S.localize(33,null),default:{},allOf:[{...te,patternProperties:{"^\\[":{}}}]},_={id:"editor",order:7.2,type:"object",properties:{[f.ThemeSettings.TOKEN_COLOR_CUSTOMIZATIONS]:K,[f.ThemeSettings.SEMANTIC_TOKEN_COLOR_CUSTOMIZATIONS]:j}};b.registerConfiguration(_);function U(ee){g.splice(0,g.length,...ee.map(W=>W.settingsId)),w.splice(0,w.length,...ee.map(W=>W.description||"")),D.splice(0,D.length,...ee.map(W=>W.label||""));const G={properties:{}},H={properties:{}},q={properties:{}},z={$ref:T.workbenchColorsSchemaId,additionalProperties:!1},B={properties:O.properties,additionalProperties:!1};for(let W of ee){const ie=`[${W.settingsId}]`;G.properties[ie]=z,H.properties[ie]=B,q.properties[ie]=te}G.patternProperties={[R]:z},H.patternProperties={[R]:B},q.patternProperties={[R]:te},i.allOf[1]=G,K.allOf[1]=H,j.allOf[1]=q,b.notifyConfigurationSchemaUpdated(y,_)}e.updateColorThemeConfigurationSchemas=U;function F(ee){n.enum.splice(1,Number.MAX_VALUE,...ee.map(G=>G.settingsId)),n.enumItemLabels.splice(1,Number.MAX_VALUE,...ee.map(G=>G.label)),n.enumDescriptions.splice(1,Number.MAX_VALUE,...ee.map(G=>G.description||"")),b.notifyConfigurationSchemaUpdated(y)}e.updateFileIconThemeConfigurationSchemas=F;function M(ee){s.enum.splice(1,Number.MAX_VALUE,...ee.map(G=>G.settingsId)),s.enumItemLabels.splice(1,Number.MAX_VALUE,...ee.map(G=>G.label)),s.enumDescriptions.splice(1,Number.MAX_VALUE,...ee.map(G=>G.description||"")),b.notifyConfigurationSchemaUpdated(y)}e.updateProductIconThemeConfigurationSchemas=M;class V{constructor(G){this.configurationService=G}get colorTheme(){return this.configurationService.getValue(f.ThemeSettings.COLOR_THEME)}get fileIconTheme(){return this.configurationService.getValue(f.ThemeSettings.FILE_ICON_THEME)}get productIconTheme(){return this.configurationService.getValue(f.ThemeSettings.PRODUCT_ICON_THEME)}get colorCustomizations(){return this.configurationService.getValue(f.ThemeSettings.COLOR_CUSTOMIZATIONS)||{}}get tokenColorCustomizations(){return this.configurationService.getValue(f.ThemeSettings.TOKEN_COLOR_CUSTOMIZATIONS)||{}}get semanticTokenColorCustomizations(){return this.configurationService.getValue(f.ThemeSettings.SEMANTIC_TOKEN_COLOR_CUSTOMIZATIONS)}async setColorTheme(G,H){return await this.writeConfiguration(f.ThemeSettings.COLOR_THEME,G.settingsId,H),G}async setFileIconTheme(G,H){return await this.writeConfiguration(f.ThemeSettings.FILE_ICON_THEME,G.settingsId,H),G}async setProductIconTheme(G,H){return await this.writeConfiguration(f.ThemeSettings.PRODUCT_ICON_THEME,G.settingsId,H),G}isDefaultColorTheme(){let G=this.configurationService.inspect(f.ThemeSettings.COLOR_THEME);return G&&G.default?.value===G.value}findAutoConfigurationTarget(G){let H=this.configurationService.inspect(G);if(k.isUndefined(H.workspaceFolderValue))if(k.isUndefined(H.workspaceValue)){if(!k.isUndefined(H.userRemote))return 3}else return 4;else return 5;return 1}async writeConfiguration(G,H,q){if(q===void 0||q==="preview")return;let z=this.configurationService.inspect(G);if(q==="auto")return this.configurationService.updateValue(G,H);if(q===1){if(H===z.userValue)return Promise.resolve(void 0);if(H===z.defaultValue){if(k.isUndefined(z.userValue))return Promise.resolve(void 0);H=void 0}}else if((q===4||q===5||q===3)&&H===z.value)return Promise.resolve(void 0);return this.configurationService.updateValue(G,H,q)}}e.ThemeConfiguration=V}),define(ue[268],de([0,1,188,11,19,120,83,6]),function(Y,e,S,k,p,P,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeRegistry=e.registerProductIconThemeExtensionPoint=e.registerFileIconThemeExtensionPoint=e.registerColorThemeExtensionPoint=void 0;function h(){return P.ExtensionsRegistry.registerExtensionPoint({extensionPoint:"themes",jsonSchema:{description:S.localize(0,null),type:"array",items:{type:"object",defaultSnippets:[{body:{label:"${1:label}",id:"${2:id}",uiTheme:t.VS_DARK_THEME,path:"./themes/${3:id}.tmTheme."}}],properties:{id:{description:S.localize(1,null),type:"string"},label:{description:S.localize(2,null),type:"string"},uiTheme:{description:S.localize(3,null),enum:[t.VS_LIGHT_THEME,t.VS_DARK_THEME,t.VS_HC_THEME]},path:{description:S.localize(4,null),type:"string"}},required:["path","uiTheme"]}}})}e.registerColorThemeExtensionPoint=h;function f(){return P.ExtensionsRegistry.registerExtensionPoint({extensionPoint:"iconThemes",jsonSchema:{description:S.localize(5,null),type:"array",items:{type:"object",defaultSnippets:[{body:{id:"${1:id}",label:"${2:label}",path:"./fileicons/${3:id}-icon-theme.json"}}],properties:{id:{description:S.localize(6,null),type:"string"},label:{description:S.localize(7,null),type:"string"},path:{description:S.localize(8,null),type:"string"}},required:["path","id"]}}})}e.registerFileIconThemeExtensionPoint=f;function C(){return P.ExtensionsRegistry.registerExtensionPoint({extensionPoint:"productIconThemes",jsonSchema:{description:S.localize(9,null),type:"array",items:{type:"object",defaultSnippets:[{body:{id:"${1:id}",label:"${2:label}",path:"./producticons/${3:id}-product-icon-theme.json"}}],properties:{id:{description:S.localize(10,null),type:"string"},label:{description:S.localize(11,null),type:"string"},path:{description:S.localize(12,null),type:"string"}},required:["path","id"]}}})}e.registerProductIconThemeExtensionPoint=C;class I{constructor(u,c,b=!1,g=void 0){this.themesExtPoint=u,this.create=c,this.idRequired=b,this.builtInTheme=g,this.onDidChangeEmitter=new T.Emitter,this.onDidChange=this.onDidChangeEmitter.event,this.extensionThemes=[],this.initialize()}initialize(){this.themesExtPoint.setHandler((u,c)=>{const b={},g=[];for(const w of this.extensionThemes)b[w.id]=w;this.extensionThemes.length=0;for(let w of u){let v={extensionId:w.description.identifier.value,extensionPublisher:w.description.publisher,extensionName:w.description.name,extensionIsBuiltin:w.description.isBuiltin};this.onThemes(v,w.description.extensionLocation,w.value,this.extensionThemes,w.collector)}for(const w of this.extensionThemes)b[w.id]?delete b[w.id]:g.push(w);const D=Object.values(b);this.onDidChangeEmitter.fire({themes:this.extensionThemes,added:g,removed:D})})}onThemes(u,c,b,g=[],D){return Array.isArray(b)?(b.forEach(w=>{if(!w.path||!k.isString(w.path)){D?.error(S.localize(14,null,this.themesExtPoint.name,String(w.path)));return}if(this.idRequired&&(!w.id||!k.isString(w.id))){D?.error(S.localize(15,null,this.themesExtPoint.name,String(w.id)));return}const v=p.joinPath(c,w.path);p.isEqualOrParent(v,c)||D?.warn(S.localize(16,null,this.themesExtPoint.name,v.path,c.path));let a=this.create(w,v,u);g.push(a)}),g):(D?.error(S.localize(13,null,this.themesExtPoint.name)),g)}findThemeById(u,c){if(this.builtInTheme&&this.builtInTheme.id===u)return this.builtInTheme;const b=this.getThemes();let g;for(let D of b){if(D.id===u)return D;D.id===c&&(g=D)}return g}findThemeBySettingsId(u,c){if(this.builtInTheme&&this.builtInTheme.settingsId===u)return this.builtInTheme;const b=this.getThemes();let g;for(let D of b){if(D.settingsId===u)return D;D.id===c&&(g=D)}return g}findThemeByExtensionLocation(u){return u?this.getThemes().filter(c=>c.location&&p.isEqualOrParent(c.location,u)):[]}getThemes(){return this.extensionThemes}getMarketplaceThemes(u,c,b){const g=u?.contributes?.[this.themesExtPoint.name];return Array.isArray(g)?this.onThemes(b,c,g):[]}}e.ThemeRegistry=I}),define(ue[269],de([0,1,2,15,7,79,120,266,267,268]),function(Y,e,S,k,p,P,t,T,h,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionResourceLoaderService=e.ServerThemeService=e.IServerThemeService=void 0,e.IServerThemeService=(0,p.createDecorator)("IServerThemeService");let C,I;try{C=(0,f.registerColorThemeExtensionPoint)(),I=new f.ThemeRegistry(C,T.ColorThemeData.fromExtensionTheme)}catch(b){throw b instanceof Error&&b.message.includes("Handler already set"),b}const m=C.name;class u{constructor(g,D,w,v){this.logService=g,this.machineConfigurationService=D,this.extensionScannerService=w,this.extensionResourceLoaderService=v,this.logPrefix="[Theme Service]",this.machineThemeConfiguration=new h.ThemeConfiguration(this.machineConfigurationService),this.readyPromise=new Promise(a=>{this.refreshThemeExtensions().then(a)})}async refreshThemeExtensions(){const g=await this.extensionScannerService._scanExtensions(S.locale||"en-us");this.logService.debug(this.logPrefix,"Scanning for theme extension...");const D=g.filter(w=>w.contributes&&Object.hasOwnProperty.call(w.contributes,m)).map(w=>(this.logService.debug(this.logPrefix,w.name),{description:w,value:w.contributes[m],collector:new t.ExtensionMessageCollector(()=>{},w,m)}));C.acceptUsers(D)}async fetchColorThemeData(){const g=this.machineThemeConfiguration.colorTheme;this.logService.debug(this.logPrefix,`Attempting to find user's active theme: ${g}`);let D=I.findThemeBySettingsId(g);return D||(this.logService.warn("User's active theme not found the registry. Was it mispelled or uninstalled?"),D=T.ColorThemeData.createUnloadedThemeForThemeType(P.ColorScheme.LIGHT)),await D.ensureLoaded(this.extensionResourceLoaderService),D}}e.ServerThemeService=u;let c=class{constructor(g){this._fileService=g,this.supportsExtensionGalleryResources=!1}async readExtensionResource(g){return(await this._fileService.readFile(g)).value.toString()}getExtensionGalleryResourceURL(g,D){}};c=Ne([je(0,k.IFileService)],c),e.ExtensionResourceLoaderService=c}),define(ue[84],de([0,1,32,13,4,11,17,155,284,285]),function(Y,e,S,k,p,P,t,T,h,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=void 0;class C extends Error{constructor(r,o){let i=o.message;switch(r){case"CorruptZip":i=`Corrupt ZIP: ${i}`;break}super(i);this.type=r,this.cause=o}}e.ExtractError=C;function I(l){const r=l.externalFileAttributes>>16||33188;return[448,56,7].map(o=>r&o).reduce((o,i)=>o+i,r&61440)}function m(l){if(l instanceof C)return l;let r;return/end of central directory record signature not found/.test(l.message)&&(r="CorruptZip"),new C(r,l)}function u(l,r,o,i,n,s){const d=p.dirname(r),y=p.join(i,d);if(!y.startsWith(i))return Promise.reject(new Error(T.localize(0,null,r)));const A=p.join(i,r);let E;return s.onCancellationRequested(()=>{E&&E.destroy()}),Promise.resolve(t.Promises.mkdir(y,{recursive:!0})).then(()=>new Promise((R,O)=>{if(!s.isCancellationRequested)try{E=(0,S.createWriteStream)(A,{mode:o}),E.once("close",()=>R()),E.once("error",O),l.once("error",O),l.pipe(E)}catch(K){O(K)}}))}function c(l,r,o,i){let n=(0,k.createCancelablePromise)(()=>Promise.resolve()),s=0;return i.onCancellationRequested(()=>{n.cancel(),l.close()}),new Promise((d,y)=>{const A=new k.Sequencer,E=R=>{R.isCancellationRequested||(s++,l.readEntry())};l.once("error",y),l.once("close",()=>n.then(()=>{i.isCancellationRequested||l.entryCount===s?d():y(new C("Incomplete",new Error(T.localize(1,null,s,l.entryCount))))},y)),l.readEntry(),l.on("entry",R=>{if(i.isCancellationRequested)return;if(!o.sourcePathRegex.test(R.fileName)){E(i);return}const O=R.fileName.replace(o.sourcePathRegex,"");if(/\/$/.test(O)){const j=p.join(r,O);n=(0,k.createCancelablePromise)(_=>t.Promises.mkdir(j,{recursive:!0}).then(()=>E(_)).then(void 0,y));return}const K=g(l,R),te=I(R);n=(0,k.createCancelablePromise)(j=>A.queue(()=>K.then(_=>u(_,O,te,r,o,j).then(()=>E(j)))).then(null,y))})})}function b(l,r=!1){return new Promise((o,i)=>{(0,h.open)(l,r?{lazyEntries:!0}:void 0,(n,s)=>{n?i(m(n)):o((0,P.assertIsDefined)(s))})})}function g(l,r){return new Promise((o,i)=>{l.openReadStream(r,(n,s)=>{n?i(m(n)):o((0,P.assertIsDefined)(s))})})}function D(l,r){return new Promise((o,i)=>{const n=new f.ZipFile;r.forEach(d=>{d.contents?n.addBuffer(typeof d.contents=="string"?Buffer.from(d.contents,"utf8"):d.contents,d.path):d.localPath&&n.addFile(d.localPath,d.path)}),n.end();const s=(0,S.createWriteStream)(l);n.outputStream.pipe(s),n.outputStream.once("error",i),s.once("error",i),s.once("finish",()=>o(l))})}e.zip=D;function w(l,r,o={},i){const n=new RegExp(o.sourcePath?`^${o.sourcePath}`:"");let s=b(l,!0);return o.overwrite&&(s=s.then(d=>t.Promises.rm(r).then(()=>d))),s.then(d=>c(d,r,{sourcePathRegex:n},i))}e.extract=w;function v(l,r){return b(l).then(o=>new Promise((i,n)=>{o.on("entry",s=>{s.fileName===r&&g(o,s).then(d=>i(d),d=>n(d))}),o.once("close",()=>n(new Error(T.localize(2,null,r))))}))}function a(l,r){return v(l,r).then(o=>new Promise((i,n)=>{const s=[];o.once("error",n),o.on("data",d=>s.push(d)),o.on("end",()=>i(Buffer.concat(s)))}))}e.buffer=a}),define(ue[270],de([0,1,84,165]),function(Y,e,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function p(P){return(0,S.buffer)(P,"extension/package.json").then(t=>{try{return JSON.parse(t.toString("utf8"))}catch(T){throw new Error((0,k.localize)(0,null))}})}e.getManifest=p}),define(ue[271],de([0,1,20,13,12,3,10,4,2,19,59,5,25,17,84,166,28,29,34,194,15,16,38]),function(Y,e,S,k,p,P,t,T,h,f,C,I,m,u,c,b,g,D,w,v,a,l,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScanner=void 0;let o=class extends P.Disposable{constructor(n,s,d,y,A){super();this.beforeRemovingExtension=n,this.fileService=s,this.logService=d,this.environmentService=y,this.productService=A,this._devSystemExtensionsPath=null,this.systemExtensionsPath=y.builtinExtensionsPath,this.extensionsPath=y.extensionsPath,this.uninstalledPath=T.join(this.extensionsPath,".obsolete"),this.uninstalledFileLimiter=new k.Queue}async cleanUp(){await this.removeUninstalledExtensions(),await this.removeOutdatedExtensions()}async scanExtensions(n){const s=[];(n===null||n===0)&&s.push(this.scanSystemExtensions().then(null,d=>Promise.reject(new D.ExtensionManagementError(this.joinErrors(d).message,D.ExtensionManagementErrorCode.Internal)))),(n===null||n===1)&&s.push(this.scanUserExtensions(!0).then(null,d=>Promise.reject(new D.ExtensionManagementError(this.joinErrors(d).message,D.ExtensionManagementErrorCode.Internal))));try{const d=await Promise.all(s);return(0,S.flatten)(d)}catch(d){throw this.joinErrors(d)}}async scanUserExtensions(n){this.logService.trace("Started scanning user extensions");let[s,d]=await Promise.all([this.getUninstalledExtensions(),this.scanAllUserExtensions()]);return d=d.filter(y=>!s[new w.ExtensionIdentifierWithVersion(y.identifier,y.manifest.version).key()]),n&&(d=(0,w.groupByExtension)(d,A=>A.identifier).map(A=>A.sort((E,R)=>C.rcompare(E.manifest.version,R.manifest.version))[0])),this.logService.trace("Scanned user extensions:",d.length),d}async scanAllUserExtensions(){return this.scanExtensionsInDir(this.extensionsPath,1)}async extractUserExtension(n,s,d,y){const A=n.key(),E=T.join(this.extensionsPath,`.${(0,m.generateUuid)()}`),R=T.join(this.extensionsPath,A);try{await u.Promises.rm(R)}catch(K){try{await u.Promises.rm(R)}catch(te){}throw new D.ExtensionManagementError((0,b.localize)(0,null,R,n.id),D.ExtensionManagementErrorCode.Delete)}await this.extractAtLocation(n,s,E,y);let O=await this.scanExtension(I.URI.file(E),1);if(!O)throw new Error((0,b.localize)(1,null,E));await this.storeMetadata(O,{...d,installedTimestamp:Date.now()});try{await this.rename(n,E,R,Date.now()+2*60*1e3),this.logService.info("Renamed to",R)}catch(K){try{await u.Promises.rm(E)}catch(te){}if(K.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",n.id);else throw this.logService.info(`Rename failed because of ${(0,p.getErrorMessage)(K)}. Deleted from extracted location`,E),K}try{O=await this.scanExtension(I.URI.file(R),1)}catch(K){}if(O)return O;throw new Error((0,b.localize)(2,null,this.extensionsPath))}async saveMetadataForLocalExtension(n,s){return this.setMetadata(n,s),await this.storeMetadata(n,{...s,installedTimestamp:n.installedTimestamp}),n}async storeMetadata(n,s){s.isMachineScoped=s.isMachineScoped||void 0,s.isBuiltin=s.isBuiltin||void 0,s.installedTimestamp=s.installedTimestamp||void 0;const d=T.join(n.location.fsPath,"package.json"),y=await u.Promises.readFile(d,"utf8"),{manifest:A}=await this.parseManifest(y);return A.__metadata=s,await u.Promises.writeFile(d,JSON.stringify(A,null,"	")),n}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...n){const s=n.map(d=>new w.ExtensionIdentifierWithVersion(d.identifier,d.manifest.version));await this.withUninstalledExtensions(d=>{s.forEach(y=>d[y.key()]=!0)})}async setInstalled(n){await this.withUninstalledExtensions(y=>delete y[n.key()]);const d=(await this.scanExtensions(1)).find(y=>new w.ExtensionIdentifierWithVersion(y.identifier,y.manifest.version).equals(n))||null;return d?(await this.storeMetadata(d,{installedTimestamp:Date.now()}),this.scanExtension(d.location,1)):null}async withUninstalledExtensions(n){return this.uninstalledFileLimiter.queue(async()=>{let s;try{s=await u.Promises.readFile(this.uninstalledPath,"utf8")}catch(y){if(y.code!=="ENOENT")throw y}let d={};if(s)try{d=JSON.parse(s)}catch(y){}return n&&(n(d),Object.keys(d).length?await u.Promises.writeFile(this.uninstalledPath,JSON.stringify(d)):await u.Promises.rm(this.uninstalledPath)),d})}async removeExtension(n,s){this.logService.trace(`Deleting ${s} extension from disk`,n.identifier.id,n.location.fsPath),await u.Promises.rm(n.location.fsPath),this.logService.info("Deleted from disk",n.identifier.id,n.location.fsPath)}async removeUninstalledExtension(n){await this.removeExtension(n,"uninstalled"),await this.withUninstalledExtensions(s=>delete s[new w.ExtensionIdentifierWithVersion(n.identifier,n.manifest.version).key()])}async extractAtLocation(n,s,d,y){this.logService.trace(`Started extracting the extension from ${s} to ${d}`);try{await u.Promises.rm(d)}catch(A){throw new D.ExtensionManagementError(this.joinErrors(A).message,D.ExtensionManagementErrorCode.Delete)}try{await(0,c.extract)(s,d,{sourcePath:"extension",overwrite:!0},y),this.logService.info(`Extracted extension to ${d}:`,n.id)}catch(A){try{await u.Promises.rm(d)}catch(R){}let E=D.ExtensionManagementErrorCode.Extract;throw A instanceof c.ExtractError&&(A.type==="CorruptZip"?E=D.ExtensionManagementErrorCode.CorruptZip:A.type==="Incomplete"&&(E=D.ExtensionManagementErrorCode.IncompleteZip)),new D.ExtensionManagementError(A.message,E)}}async rename(n,s,d,y){try{await u.Promises.rename(s,d)}catch(A){if(h.isWindows&&A&&A.code==="EPERM"&&Date.now()<y)return this.logService.info(`Failed renaming ${s} to ${d} with 'EPERM' error. Trying again...`,n.id),this.rename(n,s,d,y);throw new D.ExtensionManagementError(A.message||(0,b.localize)(3,null,s,d),A.code||D.ExtensionManagementErrorCode.Rename)}}async scanSystemExtensions(){this.logService.trace("Started scanning system extensions");const n=this.scanDefaultSystemExtensions();if(this.environmentService.isBuilt)return n;const s=this.scanDevSystemExtensions(),[d,y]=await Promise.all([n,s]);return[...d,...y]}async scanExtensionsInDir(n,s){const d=new k.Limiter(10),y=await this.fileService.resolve(I.URI.file(n));return y.children?(await Promise.all(y.children.filter(E=>E.isDirectory).map(E=>d.queue(async()=>s===1&&(0,f.basename)(E.resource).indexOf(".")===0?null:this.scanExtension(E.resource,s))))).filter(E=>E&&E.identifier):[]}async scanExtension(n,s){try{const d=await this.fileService.resolve(n);if(d.children){const{manifest:y,metadata:A}=await this.readManifest(n.fsPath),E=d.children.find(({name:te})=>/^readme(\.txt|\.md|)$/i.test(te))?.resource,R=d.children.find(({name:te})=>/^changelog(\.txt|\.md|)$/i.test(te))?.resource,O={id:(0,w.getGalleryExtensionId)(y.publisher,y.name)},K={type:s,identifier:O,manifest:y,location:n,readmeUrl:E,changelogUrl:R,publisherDisplayName:null,publisherId:null,isMachineScoped:!1,isBuiltin:s===0};return A&&this.setMetadata(K,A),K}}catch(d){s!==0&&this.logService.trace(d)}return null}async scanDefaultSystemExtensions(){const n=await this.scanExtensionsInDir(this.systemExtensionsPath,0);return this.logService.trace("Scanned system extensions:",n.length),n}async scanDevSystemExtensions(){const n=this.getDevSystemExtensionsList();if(n.length){const s=await this.scanExtensionsInDir(this.devSystemExtensionsPath,0);return this.logService.trace("Scanned dev system extensions:",s.length),s.filter(d=>n.some(y=>(0,w.areSameExtensions)(d.identifier,{id:y})))}else return[]}setMetadata(n,s){n.publisherDisplayName=s.publisherDisplayName||null,n.publisherId=s.publisherId||null,n.identifier.uuid=s.id,n.isMachineScoped=!!s.isMachineScoped,n.isPreReleaseVersion=!!s.isPreReleaseVersion,n.hadPreReleaseVersion=!!s.hadPreReleaseVersion,n.isBuiltin=n.type===0||!!s.isBuiltin,n.installedTimestamp=s.installedTimestamp}async removeUninstalledExtensions(){const n=await this.getUninstalledExtensions(),s=await this.scanAllUserExtensions(),d=new Set;for(const E of s)n[new w.ExtensionIdentifierWithVersion(E.identifier,E.manifest.version).key()]||d.add(E.identifier.id.toLowerCase());const y=(0,w.groupByExtension)(s,E=>E.identifier);await k.Promises.settled(y.map(async E=>{const R=E.sort((O,K)=>C.rcompare(O.manifest.version,K.manifest.version))[0];d.has(R.identifier.id.toLowerCase())||await this.beforeRemovingExtension(R)}));const A=s.filter(E=>n[new w.ExtensionIdentifierWithVersion(E.identifier,E.manifest.version).key()]);await k.Promises.settled(A.map(E=>this.removeUninstalledExtension(E)))}async removeOutdatedExtensions(){const n=await this.scanAllUserExtensions(),s=[],d=(0,w.groupByExtension)(n,y=>y.identifier);s.push(...(0,S.flatten)(d.map(y=>y.sort((A,E)=>C.rcompare(A.manifest.version,E.manifest.version)).slice(1)))),await k.Promises.settled(s.map(y=>this.removeExtension(y,"outdated")))}getDevSystemExtensionsList(){return(this.productService.builtInExtensions||[]).map(n=>n.name)}joinErrors(n){const s=Array.isArray(n)?n:[n];return s.length===1?s[0]instanceof Error?s[0]:new Error(s[0]):s.reduce((d,y)=>new Error(`${d.message}${d.message?",":""}${y instanceof Error?y.message:y}`),new Error(""))}get devSystemExtensionsPath(){return this._devSystemExtensionsPath||(this._devSystemExtensionsPath=T.normalize(T.join(t.FileAccess.asFileUri("",Y).fsPath,"..",".build","builtInExtensions"))),this._devSystemExtensionsPath}async readManifest(n){const s=[u.Promises.readFile(T.join(n,"package.json"),"utf8").then(E=>this.parseManifest(E)),u.Promises.readFile(T.join(n,"package.nls.json"),"utf8").then(void 0,E=>E.code!=="ENOENT"?Promise.reject(E):"{}").then(E=>JSON.parse(E))],[{manifest:d,metadata:y},A]=await Promise.all(s);return{manifest:(0,v.localizeManifest)(d,A),metadata:y}}parseManifest(n){return new Promise((s,d)=>{try{const y=JSON.parse(n),A=y.__metadata||null;s({manifest:y,metadata:A})}catch(y){d(new Error((0,b.localize)(4,null)))}})}};o=Ne([je(1,a.IFileService),je(2,l.ILogService),je(3,g.INativeEnvironmentService),je(4,r.IProductService)],o),e.ExtensionsScanner=o}),define(ue[123],de([0,1,37,12,10,4,2,23,19,59,5,25,17,84,164,72,28,224,29,34,215,209,270,216,271,235,70,15,7,16,38,33,51]),function(Y,e,S,k,p,P,t,T,h,f,C,I,m,u,c,b,g,D,w,v,a,l,r,o,i,n,s,d,y,A,E,R,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementService=void 0;let K=class extends D.AbstractExtensionManagementService{constructor(M,V,ee,G,H,q,z,B,W){super(M,V,ee,B);this.environmentService=G,this.downloadService=H,this.fileService=z;const ie=this._register(q.createInstance(l.ExtensionsLifecycle));this.extensionsScanner=this._register(q.createInstance(i.ExtensionsScanner,we=>ie.postUninstall(we))),this.manifestCache=this._register(new o.ExtensionsManifestCache(G,this)),this.extensionsDownloader=this._register(q.createInstance(a.ExtensionsDownloader));const oe=this._register(new n.ExtensionsWatcher(this,z,G,ee,W));this._register(oe.onDidChangeExtensionsByAnotherSource(({added:we,removed:se})=>{we.length&&this._onDidInstallExtensions.fire(we.map(ae=>({identifier:ae.identifier,operation:0,local:ae}))),se.forEach(ae=>this._onDidUninstallExtension.fire({identifier:ae}))}))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(async()=>{const M=await this.isAlpineLinux(),V=(0,w.getTargetPlatform)(M?"alpine":t.platform,T.arch);return this.logService.debug("ExtensionManagementService#TargetPlatform:",V),V})()),this._targetPlatformPromise}async isAlpineLinux(){if(!t.isLinux)return!1;let M;try{M=(await this.fileService.readFile(C.URI.file("/etc/os-release"))).value.toString()}catch(V){try{M=(await this.fileService.readFile(C.URI.file("/usr/lib/os-release"))).value.toString()}catch(ee){this.logService.debug("Error while getting the os-release file.",(0,k.getErrorMessage)(ee))}}return!!M&&(M.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async zip(M){this.logService.trace("ExtensionManagementService#zip",M.identifier.id);const V=await this.collectFiles(M),ee=await(0,u.zip)((0,h.joinPath)(this.environmentService.tmpDir,(0,I.generateUuid)()).fsPath,V);return C.URI.file(ee)}async unzip(M){return this.logService.trace("ExtensionManagementService#unzip",M.toString()),(await this.install(M)).identifier}async getManifest(M){const V=await this.downloadVsix(M),ee=P.resolve(V.fsPath);return(0,r.getManifest)(ee)}getInstalled(M=null){return this.extensionsScanner.scanExtensions(M)}async install(M,V={}){this.logService.trace("ExtensionManagementService#install",M.toString());const ee=await this.downloadVsix(M),G=await(0,r.getManifest)(P.resolve(ee.fsPath));if(G.engines&&G.engines.vscode&&!(0,s.isEngineValid)(G.engines.vscode,this.productService.version,this.productService.date))throw new Error(c.localize(0,null,(0,v.getGalleryExtensionId)(G.publisher,G.name),this.productService.version));return this.installExtension(G,ee,V)}async updateMetadata(M,V){return this.logService.trace("ExtensionManagementService#updateMetadata",M.identifier.id),M=await this.extensionsScanner.saveMetadataForLocalExtension(M,{...M.manifest.__metadata||{},...V}),this.manifestCache.invalidate(),M}async updateExtensionScope(M,V){return this.logService.trace("ExtensionManagementService#updateExtensionScope",M.identifier.id),M=await this.extensionsScanner.saveMetadataForLocalExtension(M,{...M.manifest.__metadata||{},isMachineScoped:V}),this.manifestCache.invalidate(),M}removeDeprecatedExtensions(){return this.extensionsScanner.cleanUp()}async downloadVsix(M){if(M.scheme===p.Schemas.file)return M;const V=(0,h.joinPath)(this.environmentService.tmpDir,(0,I.generateUuid)());return await this.downloadService.download(M,V),V}createInstallExtensionTask(M,V,ee){return C.URI.isUri(V)?new _(M,V,ee,this.galleryService,this.extensionsScanner,this.logService):new j(V,ee,this.extensionsDownloader,this.extensionsScanner,this.logService)}createUninstallExtensionTask(M,V){return new U(M,V,this.extensionsScanner)}async collectFiles(M){const V=async G=>{let H=await m.Promises.readdir(G);H=H.map(B=>P.join(G,B));const q=await Promise.all(H.map(B=>m.Promises.stat(B)));let z=Promise.resolve([]);return q.forEach((B,W)=>{const ie=H[W];B.isFile()&&(z=z.then(oe=>[...oe,ie])),B.isDirectory()&&(z=z.then(oe=>V(ie).then(we=>[...oe,...we])))}),z};return(await V(M.location.fsPath)).map(G=>({path:`extension/${P.relative(M.location.fsPath,G)}`,localPath:G}))}};K=Ne([je(0,w.IExtensionGalleryService),je(1,R.ITelemetryService),je(2,A.ILogService),je(3,g.INativeEnvironmentService),je(4,b.IDownloadService),je(5,y.IInstantiationService),je(6,d.IFileService),je(7,E.IProductService),je(8,O.IUriIdentityService)],K),e.ExtensionManagementService=K;class te extends D.AbstractExtensionTask{constructor(M,V,ee,G){super();this.identifier=M,this.source=V,this.extensionsScanner=ee,this.logService=G,this._operation=1}get operation(){return this._operation}async installExtension(M,V){try{const ee=await this.unsetUninstalledAndGetLocal(M.identifierWithVersion);if(ee)return M.metadata?this.extensionsScanner.saveMetadataForLocalExtension(ee,{...ee.manifest.__metadata||{},...M.metadata}):ee}catch(ee){throw t.isMacintosh?new w.ExtensionManagementError(c.localize(1,null),w.ExtensionManagementErrorCode.Internal):new w.ExtensionManagementError(c.localize(2,null),w.ExtensionManagementErrorCode.Internal)}return this.extract(M,V)}async unsetUninstalledAndGetLocal(M){if(!await this.isUninstalled(M))return null;this.logService.trace("Removing the extension from uninstalled list:",M.id);const ee=await this.extensionsScanner.setInstalled(M);return this.logService.info("Removed the extension from uninstalled list:",M.id),ee}async isUninstalled(M){return!!(await this.extensionsScanner.getUninstalledExtensions())[M.key()]}async extract({zipPath:M,identifierWithVersion:V,metadata:ee},G){let H=await this.extensionsScanner.extractUserExtension(V,M,ee,G);return this.logService.info("Extracting completed.",V.id),H}}class j extends te{constructor(M,V,ee,G,H){super(M.identifier,M,G,H);this.gallery=M,this.options=V,this.extensionsDownloader=ee}async doRun(M){const ee=(await this.extensionsScanner.scanExtensions(null)).find(H=>(0,v.areSameExtensions)(H.identifier,this.gallery.identifier));ee&&(this._operation=2);const G=await this.downloadInstallableExtension(this.gallery,this._operation);G.metadata.isMachineScoped=this.options.isMachineScoped||ee?.isMachineScoped,G.metadata.isBuiltin=this.options.isBuiltin||ee?.isBuiltin,G.metadata.isPreReleaseVersion=this.gallery.properties.isPreReleaseVersion,G.metadata.hadPreReleaseVersion=this.gallery.properties.isPreReleaseVersion||ee?.hadPreReleaseVersion;try{const H=await this.installExtension(G,M);return ee&&f.neq(ee.manifest.version,this.gallery.version)&&await this.extensionsScanner.setUninstalled(ee),H}catch(H){throw await this.deleteDownloadedVSIX(G.zipPath),H}}async deleteDownloadedVSIX(M){try{await this.extensionsDownloader.delete(C.URI.file(M))}catch(V){this.logService.warn("Error while deleting the downloaded vsix",M.toString(),(0,k.getErrorMessage)(V))}}async downloadInstallableExtension(M,V){const ee={id:M.identifier.uuid,publisherId:M.publisherId,publisherDisplayName:M.publisherDisplayName};let G;try{this.logService.trace("Started downloading extension:",M.identifier.id),G=(await this.extensionsDownloader.downloadExtension(M,V)).fsPath,this.logService.info("Downloaded extension:",M.identifier.id,G)}catch(H){throw new w.ExtensionManagementError((0,D.joinErrors)(H).message,w.ExtensionManagementErrorCode.Download)}try{const H=await(0,r.getManifest)(G);return{zipPath:G,identifierWithVersion:new v.ExtensionIdentifierWithVersion(M.identifier,H.version),metadata:ee}}catch(H){throw await this.deleteDownloadedVSIX(G),new w.ExtensionManagementError((0,D.joinErrors)(H).message,w.ExtensionManagementErrorCode.Invalid)}}}class _ extends te{constructor(M,V,ee,G,H,q){super({id:(0,v.getGalleryExtensionId)(M.publisher,M.name)},V,H,q);this.manifest=M,this.location=V,this.options=ee,this.galleryService=G}async doRun(M){const V=new v.ExtensionIdentifierWithVersion(this.identifier,this.manifest.version),G=(await this.extensionsScanner.scanExtensions(1)).find(q=>(0,v.areSameExtensions)(this.identifier,q.identifier)),H=await this.getMetadata(this.identifier.id,M);if(H.isMachineScoped=this.options.isMachineScoped||G?.isMachineScoped,H.isBuiltin=this.options.isBuiltin||G?.isBuiltin,G)if(this._operation=2,V.equals(new v.ExtensionIdentifierWithVersion(G.identifier,G.manifest.version)))try{await this.extensionsScanner.removeExtension(G,"existing")}catch(q){throw new Error(c.localize(3,null,this.manifest.displayName||this.manifest.name))}else f.gt(G.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(G);else{const q=await this.unsetUninstalledAndGetLocal(V);if(q)try{await this.extensionsScanner.removeExtension(q,"existing")}catch(z){throw new Error(c.localize(4,null,this.manifest.displayName||this.manifest.name))}}return this.installExtension({zipPath:P.resolve(this.location.fsPath),identifierWithVersion:V,metadata:H},M)}async getMetadata(M,V){try{const ee=(await this.galleryService.query({names:[M],pageSize:1},V)).firstPage[0];if(ee)return{id:ee.identifier.uuid,publisherDisplayName:ee.publisherDisplayName,publisherId:ee.publisherId}}catch(ee){}return{}}}class U extends D.AbstractExtensionTask{constructor(M,V,ee){super();this.extension=M,this.options=V,this.extensionsScanner=ee}async doRun(M){const V=[],ee=await this.extensionsScanner.scanUserExtensions(!1);if(this.options.versionOnly){const G=new v.ExtensionIdentifierWithVersion(this.extension.identifier,this.extension.manifest.version);V.push(...ee.filter(H=>G.equals(new v.ExtensionIdentifierWithVersion(H.identifier,H.manifest.version))))}else V.push(...ee.filter(G=>(0,v.areSameExtensions)(G.identifier,this.extension.identifier)));if(!V.length)throw new Error(c.localize(5,null,this.extension.manifest.displayName||this.extension.manifest.name));if(await this.extensionsScanner.setUninstalled(...V),this.options.remove)for(const G of V)try{M.isCancellationRequested||await this.extensionsScanner.removeUninstalledExtension(G)}catch(H){throw new Error(c.localize(6,null,(0,S.toErrorMessage)(H)))}}}}),define(ue[61],de([0,1,77,92,26,18,12,6,3,4,2,25,35,95,272]),function(Y,e,S,k,p,P,t,T,h,f,C,I,m,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class b{constructor(y){this.socket=y,this._errorListener=A=>{if(A){if(A.code==="EPIPE")return;(0,t.onUnexpectedError)(A)}},this.socket.on("error",this._errorListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(y){const A=E=>y(P.VSBuffer.wrap(E));return this.socket.on("data",A),{dispose:()=>this.socket.off("data",A)}}onClose(y){const A=E=>{y({type:0,hadError:E,error:void 0})};return this.socket.on("close",A),{dispose:()=>this.socket.off("close",A)}}onEnd(y){return this.socket.on("end",y),{dispose:()=>this.socket.off("end",y)}}write(y){if(!this.socket.destroyed)try{this.socket.write(y.buffer,A=>{if(A){if(A.code==="EPIPE")return;(0,t.onUnexpectedError)(A)}})}catch(A){if(A.code==="EPIPE")return;(0,t.onUnexpectedError)(A)}}end(){this.socket.end()}drain(){return new Promise((y,A)=>{if(this.socket.bufferSize===0){y();return}const E=()=>{this.socket.off("close",E),this.socket.off("end",E),this.socket.off("error",E),this.socket.off("timeout",E),this.socket.off("drain",E),y()};this.socket.on("close",E),this.socket.on("end",E),this.socket.on("error",E),this.socket.on("timeout",E),this.socket.on("drain",E)})}}e.NodeSocket=b;var g;(function(d){d[d.MinHeaderByteSize=2]="MinHeaderByteSize"})(g||(g={}));var D;(function(d){d[d.PeekHeader=1]="PeekHeader",d[d.ReadHeader=2]="ReadHeader",d[d.ReadBody=3]="ReadBody",d[d.Fin=4]="Fin"})(D||(D={}));class w extends h.Disposable{constructor(y,A,E,R){super();this._onDidZlibFlush=this._register(new T.Emitter),this._recordedInflateBytes=[],this._pendingInflateData=[],this._pendingDeflateData=[],this._onData=this._register(new T.Emitter),this._onClose=this._register(new T.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=y,this._totalIncomingWireBytes=0,this._totalIncomingDataBytes=0,this._totalOutgoingWireBytes=0,this._totalOutgoingDataBytes=0,this.permessageDeflate=A,this._recordInflateBytes=R,A?(this._zlibInflate=c.createInflateRaw({windowBits:15}),this._zlibInflate.on("error",O=>{console.error(O),(0,t.onUnexpectedError)(O),this._onClose.fire({type:0,hadError:!0,error:O})}),this._zlibInflate.on("data",O=>{this._pendingInflateData.push(O)}),E&&(this._zlibInflate.write(E.buffer),this._zlibInflate.flush(()=>{this._pendingInflateData.length=0})),this._zlibDeflate=c.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",O=>{console.error(O),(0,t.onUnexpectedError)(O),this._onClose.fire({type:0,hadError:!0,error:O})}),this._zlibDeflate.on("data",O=>{this._pendingDeflateData.push(O)})):(this._zlibInflate=null,this._zlibDeflate=null),this._zlibDeflateFlushWaitingCount=0,this._incomingData=new u.ChunkStream,this._register(this.socket.onData(O=>this._acceptChunk(O))),this._register(this.socket.onClose(O=>this._onClose.fire(O)))}get totalIncomingWireBytes(){return this._totalIncomingWireBytes}get totalIncomingDataBytes(){return this._totalIncomingDataBytes}get totalOutgoingWireBytes(){return this._totalOutgoingWireBytes}get totalOutgoingDataBytes(){return this._totalOutgoingDataBytes}get recordedInflateBytes(){return this._recordInflateBytes?P.VSBuffer.wrap(Buffer.concat(this._recordedInflateBytes)):P.VSBuffer.alloc(0)}dispose(){this._zlibDeflateFlushWaitingCount>0?this._register(this._onDidZlibFlush.event(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(y){return this._onData.event(y)}onClose(y){return this._onClose.event(y)}onEnd(y){return this.socket.onEnd(y)}write(y){this._totalOutgoingDataBytes+=y.byteLength,this._zlibDeflate?(this._zlibDeflate.write(y.buffer),this._zlibDeflateFlushWaitingCount++,this._zlibDeflate.flush(2,()=>{this._zlibDeflateFlushWaitingCount--;let A=Buffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,A=A.slice(0,A.length-4),this._isEnded||this._write(P.VSBuffer.wrap(A),!0),this._zlibDeflateFlushWaitingCount===0&&this._onDidZlibFlush.fire()})):this._write(y,!1)}_write(y,A){let E=2;y.byteLength<126?E+=0:y.byteLength<2**16?E+=2:E+=8;const R=P.VSBuffer.alloc(E);if(A?R.writeUInt8(194,0):R.writeUInt8(130,0),y.byteLength<126)R.writeUInt8(y.byteLength,1);else if(y.byteLength<2**16){R.writeUInt8(126,1);let O=1;R.writeUInt8(y.byteLength>>>8&255,++O),R.writeUInt8(y.byteLength>>>0&255,++O)}else{R.writeUInt8(127,1);let O=1;R.writeUInt8(0,++O),R.writeUInt8(0,++O),R.writeUInt8(0,++O),R.writeUInt8(0,++O),R.writeUInt8(y.byteLength>>>24&255,++O),R.writeUInt8(y.byteLength>>>16&255,++O),R.writeUInt8(y.byteLength>>>8&255,++O),R.writeUInt8(y.byteLength>>>0&255,++O)}this._totalOutgoingWireBytes+=R.byteLength+y.byteLength,this.socket.write(P.VSBuffer.concat([R,y]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(y){if(y.byteLength!==0){for(this._totalIncomingWireBytes+=y.byteLength,this._incomingData.acceptChunk(y);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const A=this._incomingData.peek(this._state.readLen),E=A.readUInt8(0),R=(E&128)>>>7,O=(E&64)>>>6,K=A.readUInt8(1),te=(K&128)>>>7,j=K&127;this._state.state=2,this._state.readLen=2+(te?4:0)+(j===126?2:0)+(j===127?8:0),this._state.fin=R,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(O)),this._state.firstFrameOfMessage=Boolean(R),this._state.mask=0}else if(this._state.state===2){const A=this._incomingData.read(this._state.readLen),E=A.readUInt8(1),R=(E&128)>>>7;let O=E&127,K=1;O===126?O=A.readUInt8(++K)*2**8+A.readUInt8(++K):O===127&&(O=A.readUInt8(++K)*0+A.readUInt8(++K)*0+A.readUInt8(++K)*0+A.readUInt8(++K)*0+A.readUInt8(++K)*2**24+A.readUInt8(++K)*2**16+A.readUInt8(++K)*2**8+A.readUInt8(++K));let te=0;R&&(te=A.readUInt8(++K)*2**24+A.readUInt8(++K)*2**16+A.readUInt8(++K)*2**8+A.readUInt8(++K)),this._state.state=3,this._state.readLen=O,this._state.mask=te}else if(this._state.state===3){const A=this._incomingData.read(this._state.readLen);v(A,this._state.mask),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._zlibInflate&&this._state.compressed?(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from(A.buffer)),this._zlibInflate.write(A.buffer),this._state.fin&&(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from([0,0,255,255])),this._zlibInflate.write(Buffer.from([0,0,255,255]))),this._zlibInflate.flush(()=>{const E=Buffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,this._totalIncomingDataBytes+=E.length,this._onData.fire(P.VSBuffer.wrap(E))})):(this._totalIncomingDataBytes+=A.byteLength,this._onData.fire(A))}}}async drain(){this._zlibDeflateFlushWaitingCount>0&&await T.Event.toPromise(this._onDidZlibFlush.event),await this.socket.drain()}}e.WebSocketNodeSocket=w;function v(d,y){if(y===0)return;let A=d.byteLength>>>2;for(let j=0;j<A;j++){const _=d.readUInt32BE(j*4);d.writeUInt32BE(_^y,j*4)}let E=A*4,R=d.byteLength-E;const O=y>>>24&255,K=y>>>16&255,te=y>>>8&255;R>=1&&d.writeUInt8(d.readUInt8(E)^O,E),R>=2&&d.writeUInt8(d.readUInt8(E+1)^K,E+1),R>=3&&d.writeUInt8(d.readUInt8(E+2)^te,E+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const a={[2]:107,[1]:103};function l(){const d=(0,I.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${d}-sock`;let y;return e.XDG_RUNTIME_DIR?y=(0,f.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${d}.sock`):y=(0,f.join)((0,p.tmpdir)(),`vscode-ipc-${d}.sock`),o(y),y}e.createRandomIPCHandle=l;function r(d,y,A){const E=(0,S.createHash)("md5").update(d).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${E}-${A}-${y}-sock`;let R;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?R=(0,f.join)(e.XDG_RUNTIME_DIR,`vscode-${E.substr(0,8)}-${A}-${y}.sock`):R=(0,f.join)(d,`${A}-${y}.sock`),o(R),R}e.createStaticIPCHandle=r;function o(d){const y=a[C.platform];typeof y=="number"&&d.length>=y&&console.warn(`WARNING: IPC handle "${d}" is longer than ${y} chars, try a shorter --user-data-dir`)}class i extends m.IPCServer{constructor(y){super(i.toClientConnectionEvent(y));this.server=y}static toClientConnectionEvent(y){const A=T.Event.fromNodeEventEmitter(y,"connection");return T.Event.map(A,E=>({protocol:new u.Protocol(new b(E)),onDidClientDisconnect:T.Event.once(T.Event.fromNodeEventEmitter(E,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=i;function n(d){return new Promise((y,A)=>{const E=(0,k.createServer)();E.on("error",A),E.listen(d,()=>{E.removeListener("error",A),y(new i(E))})})}e.serve=n;function s(d,y){return new Promise((A,E)=>{const R=(0,k.createConnection)(d,()=>{R.removeListener("error",E),A(u.Client.fromSocket(new b(R),y))});R.once("error",E)})}e.connect=s}),define(ue[124],de([0,1,78,13,18,12,3,11,27,28,73,16,219,272]),function(Y,e,S,k,p,P,t,T,h,f,C,I,m,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let c=class extends t.Disposable{constructor(g,D,w){super();this.environmentService=D,this.logService=w,this.configure(g.getValue()),this._register(g.onDidChangeConfiguration(()=>this.configure(g.getValue()),this))}configure(g){this.proxyUrl=g.http&&g.http.proxy,this.strictSSL=!!(g.http&&g.http.proxyStrictSSL),this.authorization=g.http&&g.http.proxyAuthorization}async request(g,D){this.logService.trace("RequestService#request",g.url);const{proxyUrl:w,strictSSL:v}=this;let a;try{a=await(0,C.resolveShellEnv)(this.logService,this.environmentService.args,process.env)}catch(o){this.logService.error("RequestService#request resolving shell environment failed",o)}const l={...process.env,...a},r=g.agent?g.agent:await(0,m.getProxyAgent)(g.url||"",l,{proxyUrl:w,strictSSL:v});return g.agent=r,g.strictSSL=v,this.authorization&&(g.headers={...g.headers||{},"Proxy-Authorization":this.authorization}),this._request(g,D)}async getNodeRequest(g){return((0,S.parse)(g.url).protocol==="https:"?await new Promise((v,a)=>{Y(["https"],v,a)}):await new Promise((v,a)=>{Y(["http"],v,a)})).request}_request(g,D){return k.Promises.withAsyncBody(async(w,v)=>{let a;const l=(0,S.parse)(g.url),r=g.getRawRequest?g.getRawRequest(g):await this.getNodeRequest(g),o={hostname:l.hostname,port:l.port?parseInt(l.port):l.protocol==="https:"?443:80,protocol:l.protocol,path:l.path,method:g.type||"GET",headers:g.headers,agent:g.agent,rejectUnauthorized:(0,T.isBoolean)(g.strictSSL)?g.strictSSL:!0};g.user&&g.password&&(o.auth=g.user+":"+g.password),a=r(o,i=>{const n=(0,T.isNumber)(g.followRedirects)?g.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&n>0&&i.headers.location)this._request({...g,url:i.headers.location,followRedirects:n-1},D).then(w,v);else{let s=i;i.headers["content-encoding"]==="gzip"&&(s=i.pipe((0,u.createGunzip)())),w({res:i,stream:(0,p.streamToBufferReadableStream)(s)})}}),a.on("error",v),g.timeout&&a.setTimeout(g.timeout),g.data&&typeof g.data=="string"&&a.write(g.data),a.end(),D.onCancellationRequested(()=>{a.abort(),v((0,P.canceled)())})})}async resolveProxy(g){}};c=Ne([je(0,h.IConfigurationService),je(1,f.INativeEnvironmentService),je(2,I.ILogService)],c),e.RequestService=c}),define(ue[125],de([0,1,41,81,45,10,4,18,6,61,73,2,258,68]),function(Y,e,S,k,p,P,t,T,h,f,C,I,m,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostConnection=e.buildUserEnvironment=void 0;async function c(v={},a,l,r,o){const i=await(0,k.getNLSConfiguration)(a,r.userDataPath);let n;try{n=await(0,C.resolveShellEnv)(o,r.args,process.env)}catch(E){o.error("ExtensionHostConnection#buildUserEnvironment resolving shell environment failed",E),n={}}const s=r.isBuilt?(0,t.join)(r.appRoot,"bin"):(0,t.join)(r.appRoot,"resources","server","bin-dev"),d=process.env;let y=v.PATH||(n?n.PATH:void 0)||d.PATH;y?y=s+t.delimiter+y:y=s;const A={...d,...n,VSCODE_LOG_NATIVE:String(l),VSCODE_AMD_ENTRYPOINT:"vs/server/remoteExtensionHostProcess",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_EXTHOST_WILL_SEND_SOCKET:"true",VSCODE_HANDLES_UNCAUGHT_ERRORS:"true",VSCODE_LOG_STACK:"false",VSCODE_NLS_CONFIG:JSON.stringify(i,void 0,0),...v};return r.args["without-browser-env-var"]||(A.BROWSER=(0,t.join)(s,"helpers",I.isWindows?"browser.cmd":"browser.sh")),D(A,"PATH",y),w(A),A}e.buildUserEnvironment=c;class b{constructor(a,l,r,o,i,n){this.socket=a,this.socketDrain=l,this.initialDataChunk=r,this.skipWebSocketFrames=o,this.permessageDeflate=i,this.inflateBytes=n}toIExtHostSocketMessage(){return{type:"VSCODE_EXTHOST_IPC_SOCKET",initialDataChunk:this.initialDataChunk.buffer.toString("base64"),skipWebSocketFrames:this.skipWebSocketFrames,permessageDeflate:this.permessageDeflate,inflateBytes:this.inflateBytes.buffer.toString("base64")}}}class g{constructor(a,l,r,o,i,n){this._environmentService=a,this._logService=l,this._reconnectionToken=r,this._onClose=new h.Emitter,this.onClose=this._onClose.event,this._disposed=!1,this._remoteAddress=o,this._extensionHostProcess=null,this._connectionData=g._toConnectionData(i,n),this._connectionData.socket.pause(),this._log("New connection established.")}get _logPrefix(){return`[${this._remoteAddress}][${this._reconnectionToken.substr(0,8)}][ExtensionHostConnection] `}_log(a){this._logService.info(`${this._logPrefix}${a}`)}_logError(a){this._logService.error(`${this._logPrefix}${a}`)}static _toConnectionData(a,l){return a instanceof f.NodeSocket?new b(a.socket,a.drain(),l,!0,!1,T.VSBuffer.alloc(0)):new b(a.socket.socket,a.drain(),l,!1,a.permessageDeflate,a.recordedInflateBytes)}async _sendSocketToExtensionHost(a,l){await l.socketDrain;const r=l.toIExtHostSocketMessage();a.send(r,l.socket)}shortenReconnectionGraceTimeIfNecessary(){if(!this._extensionHostProcess)return;const a={type:"VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"};this._extensionHostProcess.send(a)}acceptReconnection(a,l,r){this._remoteAddress=a,this._log("The client has reconnected.");const o=g._toConnectionData(l,r);if(o.socket.pause(),!this._extensionHostProcess){this._connectionData=o;return}this._sendSocketToExtensionHost(this._extensionHostProcess,o)}_cleanResources(){this._disposed||(this._disposed=!0,this._connectionData&&(this._connectionData.socket.end(),this._connectionData=null),this._extensionHostProcess&&(this._extensionHostProcess.kill(),this._extensionHostProcess=null),this._onClose.fire(void 0))}async start(a){try{let l=[];a.port&&!process.pkg&&(l=[`--inspect${a.break?"-brk":""}=0.0.0.0:${a.port}`]);const r=await c(a.env,a.language,!!a.debugId,this._environmentService,this._logService);(0,u.removeDangerousEnvVariables)(r);const o={env:r,execArgv:l,silent:!0},i=["--type=extensionHost",`--uriTransformerPath=${p.uriTransformerPath}`],n=this._environmentService.args["use-host-proxy"];n!==void 0&&i.push(`--useHostProxy=${n}`),this._extensionHostProcess=S.fork(P.FileAccess.asFileUri("bootstrap-fork",Y).fsPath,i,o);const s=this._extensionHostProcess.pid;this._log(`<${s}> Launched Extension Host Process.`),this._extensionHostProcess.stdout.setEncoding("utf8"),this._extensionHostProcess.stderr.setEncoding("utf8");const d=h.Event.fromNodeEventEmitter(this._extensionHostProcess.stdout,"data"),y=h.Event.fromNodeEventEmitter(this._extensionHostProcess.stderr,"data");d(E=>this._log(`<${s}> ${E}`)),y(E=>this._log(`<${s}><stderr> ${E}`)),this._extensionHostProcess.on("message",E=>{E&&E.type==="__$console"&&(0,m.logRemoteEntry)(this._logService,E,`${this._logPrefix}<${s}>`)}),this._extensionHostProcess.on("error",E=>{this._logError(`<${s}> Extension Host Process had an error`),this._logService.error(E),this._cleanResources()}),this._extensionHostProcess.on("exit",(E,R)=>{this._log(`<${s}> Extension Host Process exited with code: ${E}, signal: ${R}.`),this._cleanResources()});const A=E=>{E.type==="VSCODE_EXTHOST_IPC_READY"&&(this._extensionHostProcess.removeListener("message",A),this._sendSocketToExtensionHost(this._extensionHostProcess,this._connectionData),this._connectionData=null)};this._extensionHostProcess.on("message",A)}catch(l){console.error("ExtensionHostConnection errored"),l&&console.error(l)}}}e.ExtensionHostConnection=g;function D(v,a,l){const r=Object.keys(v).filter(i=>i.toLowerCase()===a.toLowerCase()),o=r.length>0?r[0]:a;v[o]=l}function w(v){for(let a of Object.keys(v))v[a]===null&&delete v[a]}}),define(ue[273],de([0,1,74,16,56,104,27,60,124,39,33,29,110,123,100,58,3,101,76,10,15,38,103,122,82,107,75,108,12,5,4,23,217,72,51,112,55,2]),function(Y,e,S,k,p,P,t,T,h,f,C,I,m,u,c,b,g,D,w,v,a,l,r,o,i,n,s,d,y,A,E,R,O,K,te,j,_,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.run=void 0;class F extends g.Disposable{constructor(G,H){super();this.args=G,this.remoteDataFolder=H,this.registerListeners()}registerListeners(){process.once("exit",()=>this.dispose())}async run(){await(await this.initServices()).invokeFunction(async H=>{const q=H.get(k.ILogService),z=H.get(I.IExtensionManagementCLIService);try{await this.doRun(z)}catch(B){throw q.error(B),console.error((0,y.getErrorMessage)(B)),B}})}async initServices(){const G=new S.ServiceCollection,H={_serviceBrand:void 0,...b.default};G.set(l.IProductService,H);const q=new i.ServerEnvironmentService(this.args,H);G.set(i.IServerEnvironmentService,q);const z=new k.LogService(new r.SpdLogLogger(o.RemoteExtensionLogFileName,(0,E.join)(q.logsPath,`${o.RemoteExtensionLogFileName}.log`),!0,!1,(0,k.getLogLevel)(q)));G.set(k.ILogService,z),z.trace(`Remote configuration data at ${this.remoteDataFolder}`),z.trace("process arguments:",this.args);const B=this._register(new D.FileService(z));G.set(a.IFileService,B),B.registerProvider(v.Schemas.file,this._register(new w.DiskFileSystemProvider(z)));const W=this._register(new P.ConfigurationService(q.settingsResource,B));return await W.initialize(),G.set(t.IConfigurationService,W),G.set(te.IUriIdentityService,new j.UriIdentityService(B)),G.set(T.IRequestService,new p.SyncDescriptor(h.RequestService)),G.set(K.IDownloadService,new p.SyncDescriptor(O.DownloadService)),G.set(C.ITelemetryService,f.NullTelemetryService),G.set(I.IExtensionGalleryService,new p.SyncDescriptor(m.ExtensionGalleryServiceWithNoStorageService)),G.set(I.IExtensionManagementService,new p.SyncDescriptor(u.ExtensionManagementService)),G.set(I.IExtensionManagementCLIService,new p.SyncDescriptor(n.ExtensionManagementCLIService)),G.set(s.ILocalizationsService,new p.SyncDescriptor(d.LocalizationsService)),new c.InstantiationService(G)}async doRun(G){if(this.args["list-extensions"])return G.listExtensions(!!this.args["show-versions"],this.args.category);if(this.args["install-extension"]||this.args["install-builtin-extension"])return G.installExtensions(this.asExtensionIdOrVSIX(this.args["install-extension"]||[]),this.args["install-builtin-extension"]||[],!!this.args["do-not-sync"],!!this.args.force);if(this.args["uninstall-extension"])return G.uninstallExtensions(this.asExtensionIdOrVSIX(this.args["uninstall-extension"]),!!this.args.force);if(this.args["locate-extension"])return G.locateExtension(this.args["locate-extension"])}asExtensionIdOrVSIX(G){return G.map(H=>/\.vsix$/i.test(H)?A.URI.file((0,E.isAbsolute)(H)?H:(0,E.join)((0,R.cwd)(),H)):H)}}function M(ee){setTimeout(()=>process.exit(ee),0)}async function V(ee,G,H){if(ee.help){const z=`server${U.isWindows?".bat":".sh"}`;console.log((0,_.buildHelpMessage)(b.default.nameLong,z,b.default.version,H,{noInputFiles:!0,noPipe:!0}));return}if(ee.version){console.log((0,_.buildVersionMessage)(b.default.version,b.default.commit));return}const q=new F(ee,G);try{await q.run(),M(0)}catch(z){M(1)}finally{q.dispose()}}e.run=V}),define(ue[274],de([0,1,61,286,32,257,5,236,16]),function(Y,e,S,k,p,P,t,T,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class f{constructor(m,u,c){this._commands=m,this.logService=u,this._ipcHandlePath=c,this._server=k.createServer((b,g)=>this.onRequest(b,g)),this.setup().catch(b=>(u.error(b),""))}get ipcHandlePath(){return this._ipcHandlePath}async setup(){try{this._server.listen(this.ipcHandlePath),this._server.on("error",m=>this.logService.error(m))}catch(m){this.logService.error("Could not start open from terminal server.")}return this._ipcHandlePath}onRequest(m,u){const c=[];m.setEncoding("utf8"),m.on("data",b=>c.push(b)),m.on("end",()=>{const b=JSON.parse(c.join(""));switch(b.type){case"open":this.open(b,u);break;case"openExternal":this.openExternal(b,u);break;case"status":this.getStatus(b,u);break;case"extensionManagement":this.manageExtensions(b,u).catch(this.logService.error);break;default:u.writeHead(404),u.write(`Unknown message type: ${b.type}`,g=>{g&&this.logService.error(g)}),u.end();break}})}open(m,u){const{fileURIs:c,folderURIs:b,forceNewWindow:g,diffMode:D,addMode:w,forceReuseWindow:v,gotoLineMode:a,waitMarkerFilePath:l,remoteAuthority:r}=m,o=[];if(Array.isArray(b))for(const d of b)try{o.push({folderUri:t.URI.parse(d)})}catch(y){}if(Array.isArray(c))for(const d of c)try{(0,T.hasWorkspaceFileExtension)(d)?o.push({workspaceUri:t.URI.parse(d)}):o.push({fileUri:t.URI.parse(d)})}catch(y){}const i=l?t.URI.file(l):void 0,s={forceNewWindow:g,diffMode:D,addMode:w,gotoLineMode:a,forceReuseWindow:v,preferNewWindow:!v&&!i&&!w,waitMarkerFileURI:i,remoteAuthority:r};this._commands.executeCommand("_remoteCLI.windowOpen",o,s),u.writeHead(200),u.end()}async openExternal(m,u){for(const c of m.uris){const b=t.URI.parse(c),g=b.scheme==="file"?b:c;await this._commands.executeCommand("_remoteCLI.openExternal",g)}u.writeHead(200),u.end()}async manageExtensions(m,u){try{const c=D=>D?.map(w=>/\.vsix$/i.test(w)?t.URI.parse(w):w),b={list:m.list,install:c(m.install),uninstall:c(m.uninstall),force:m.force},g=await this._commands.executeCommand("_remoteCLI.manageExtensions",b);u.writeHead(200),u.write(g)}catch(c){u.writeHead(500),u.write(String(c),b=>{b&&this.logService.error(b)})}u.end()}async getStatus(m,u){try{const c=await this._commands.executeCommand("_remoteCLI.getSystemStatus");u.writeHead(200),u.write(c),u.end()}catch(c){u.writeHead(500),u.write(String(c),b=>{b&&this.logService.error(b)}),u.end()}}dispose(){this._server.close(),this._ipcHandlePath&&process.platform!=="win32"&&p.existsSync(this._ipcHandlePath)&&p.unlinkSync(this._ipcHandlePath)}}e.CLIServerBase=f;let C=class extends f{constructor(m,u){super(m,u,(0,S.createRandomIPCHandle)())}};C=Ne([je(0,P.IExtHostCommands),je(1,h.ILogService)],C),e.CLIServer=C}),define(ue[275],de([0,1,26,6,21,3,4,2,5,61,45,274,244,118,245,249,125]),function(Y,e,S,k,p,P,t,T,h,f,C,I,m,u,c,b,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteTerminalChannel=void 0;class D extends b.AbstractVariableResolverService{constructor(a,l,r,o){super({getFolderUri:i=>{const n=l.filter(s=>s.name===i);if(n&&n.length>0)return n[0].uri},getWorkspaceFolderCount:()=>l.length,getConfigurationValue:(i,n)=>o[`config:${n}`],getExecPath:()=>a.VSCODE_EXEC_PATH,getAppRoot:()=>a.VSCODE_CWD,getFilePath:()=>{if(r)return t.normalize(r.fsPath)},getSelectedText:()=>o.selectedText,getLineNumber:()=>o.lineNumber},void 0,Promise.resolve(a))}}class w extends P.Disposable{constructor(a,l,r,o){super();this._environmentService=a,this._logService=l,this._ptyService=r,this._productService=o,this._lastReqId=0,this._pendingCommands=new Map,this._onExecuteCommand=this._register(new k.Emitter),this.onExecuteCommand=this._onExecuteCommand.event}async call(a,l,r){switch(l){case"$restartPtyHost":return this._ptyService.restartPtyHost?.apply(this._ptyService,r);case"$createProcess":{const o=(0,C.createRemoteURITransformer)(a.remoteAuthority);return this._createProcess(o,r)}case"$attachToProcess":return this._ptyService.attachToProcess.apply(this._ptyService,r);case"$detachFromProcess":return this._ptyService.detachFromProcess.apply(this._ptyService,r);case"$listProcesses":return this._ptyService.listProcesses.apply(this._ptyService,r);case"$orphanQuestionReply":return this._ptyService.orphanQuestionReply.apply(this._ptyService,r);case"$acceptPtyHostResolvedVariables":return this._ptyService.acceptPtyHostResolvedVariables?.apply(this._ptyService,r);case"$start":return this._ptyService.start.apply(this._ptyService,r);case"$input":return this._ptyService.input.apply(this._ptyService,r);case"$acknowledgeDataEvent":return this._ptyService.acknowledgeDataEvent.apply(this._ptyService,r);case"$shutdown":return this._ptyService.shutdown.apply(this._ptyService,r);case"$resize":return this._ptyService.resize.apply(this._ptyService,r);case"$getInitialCwd":return this._ptyService.getInitialCwd.apply(this._ptyService,r);case"$getCwd":return this._ptyService.getCwd.apply(this._ptyService,r);case"$processBinary":return this._ptyService.processBinary.apply(this._ptyService,r);case"$sendCommandResult":return this._sendCommandResult(r[0],r[1],r[2]);case"$getDefaultSystemShell":return this._getDefaultSystemShell.apply(this,r);case"$getProfiles":return this._getProfiles.apply(this,r);case"$getEnvironment":return this._getEnvironment();case"$getWslPath":return this._getWslPath(r[0]);case"$getTerminalLayoutInfo":return this._ptyService.getTerminalLayoutInfo(r);case"$setTerminalLayoutInfo":return this._ptyService.setTerminalLayoutInfo(r);case"$serializeTerminalState":return this._ptyService.serializeTerminalState.apply(this._ptyService,r);case"$reviveTerminalProcesses":return this._ptyService.reviveTerminalProcesses.apply(this._ptyService,r);case"$setUnicodeVersion":return this._ptyService.setUnicodeVersion.apply(this._ptyService,r);case"$reduceConnectionGraceTime":return this._reduceConnectionGraceTime();case"$updateIcon":return this._ptyService.updateIcon.apply(this._ptyService,r);case"$updateTitle":return this._ptyService.updateTitle.apply(this._ptyService,r);case"$updateProperty":return this._ptyService.updateProperty.apply(this._ptyService,r);case"$refreshProperty":return this._ptyService.refreshProperty.apply(this._ptyService,r);case"$requestDetachInstance":return this._ptyService.requestDetachInstance(r[0],r[1]);case"$acceptDetachedInstance":return this._ptyService.acceptDetachInstanceReply(r[0],r[1])}throw new Error(`IPC Command ${l} not found`)}listen(a,l,r){switch(l){case"$onPtyHostExitEvent":return this._ptyService.onPtyHostExit||k.Event.None;case"$onPtyHostStartEvent":return this._ptyService.onPtyHostStart||k.Event.None;case"$onPtyHostUnresponsiveEvent":return this._ptyService.onPtyHostUnresponsive||k.Event.None;case"$onPtyHostResponsiveEvent":return this._ptyService.onPtyHostResponsive||k.Event.None;case"$onPtyHostRequestResolveVariablesEvent":return this._ptyService.onPtyHostRequestResolveVariables||k.Event.None;case"$onProcessDataEvent":return this._ptyService.onProcessData;case"$onProcessReadyEvent":return this._ptyService.onProcessReady;case"$onProcessExitEvent":return this._ptyService.onProcessExit;case"$onProcessReplayEvent":return this._ptyService.onProcessReplay;case"$onProcessOrphanQuestion":return this._ptyService.onProcessOrphanQuestion;case"$onExecuteCommand":return this.onExecuteCommand;case"$onDidRequestDetach":return this._ptyService.onDidRequestDetach||k.Event.None;case"$onDidChangeProperty":return this._ptyService.onDidChangeProperty;default:break}throw new Error("Not supported")}async _createProcess(a,l){const r={name:l.shellLaunchConfig.name,executable:l.shellLaunchConfig.executable,args:l.shellLaunchConfig.args,cwd:typeof l.shellLaunchConfig.cwd=="string"||typeof l.shellLaunchConfig.cwd=="undefined"?l.shellLaunchConfig.cwd:h.URI.revive(a.transformIncoming(l.shellLaunchConfig.cwd)),env:l.shellLaunchConfig.env,useShellEnvironment:l.shellLaunchConfig.useShellEnvironment};let o;l.shellLaunchConfig.useShellEnvironment?(this._logService.trace("*"),o=await(0,g.buildUserEnvironment)(l.resolverEnv,T.language,!1,this._environmentService,this._logService)):o=this._getEnvironment(),this._logService.trace("baseEnv",o);const i=F=>({uri:h.URI.revive(a.transformIncoming(F.uri)),name:F.name,index:F.index,toResource:()=>{throw new Error("Not implemented")}}),n=l.workspaceFolders.map(i),s=l.activeWorkspaceFolder?i(l.activeWorkspaceFolder):void 0,d=l.activeFileResource?h.URI.revive(a.transformIncoming(l.activeFileResource)):void 0,y=new D(o,n,d,l.resolvedVariables),A=c.createVariableResolver(s,process.env,y),E=c.getCwd(r,S.homedir(),A,s?.uri,l.configuration["terminal.integrated.cwd"],this._logService);r.cwd=E;const R=T.isWindows?"terminal.integrated.env.windows":T.isMacintosh?"terminal.integrated.env.osx":"terminal.integrated.env.linux",O=l.configuration[R],K=c.createTerminalEnvironment(r,O,A,this._productService.version,l.configuration["terminal.integrated.detectLocale"],o);if(!r.strictEnv){const F=[];for(const[ee,G]of l.envVariableCollections)F.push([ee,{map:(0,u.deserializeEnvironmentVariableCollection)(G)}]);const M=new Map(F);new m.MergedEnvironmentVariableCollection(M).applyToProcessEnvironment(K)}this._logService.debug("Terminal process launching on remote agent",{shellLaunchConfig:r,initialCwd:E,cols:l.cols,rows:l.rows,env:K});const te=(0,f.createRandomIPCHandle)();K.VSCODE_IPC_HOOK_CLI=te;const j={executeCommand:(F,...M)=>this._executeCommand(F,M,a)},_=new I.CLIServerBase(j,this._logService,te),U=await this._ptyService.createProcess(r,E,l.cols,l.rows,l.unicodeVersion,K,o,!1,l.shouldPersistTerminal,l.workspaceId,l.workspaceName);return this._ptyService.onProcessExit(F=>F.id===U&&_.dispose()),{persistentTerminalId:U,resolvedShellLaunchConfig:r}}_executeCommand(a,l,r){let o,i;const n=new Promise((y,A)=>{o=y,i=A}),s=++this._lastReqId;this._pendingCommands.set(s,{resolve:o,reject:i,uriTransformer:r});const d=(0,p.cloneAndChange)(l,y=>{if(y&&y.$mid===1)return r.transformOutgoing(y);if(y&&y instanceof h.URI)return r.transformOutgoingURI(y)});return this._onExecuteCommand.fire({reqId:s,commandId:a,commandArgs:d}),n}_sendCommandResult(a,l,r){const o=this._pendingCommands.get(a);if(!o)return;this._pendingCommands.delete(a);const i=(0,p.cloneAndChange)(r,n=>{if(n&&n.$mid===1)return o.uriTransformer.transformIncoming(n)});l?o.reject(i):o.resolve(i)}_getDefaultSystemShell(a){return this._ptyService.getDefaultSystemShell(a)}async _getProfiles(a,l,r,o){return this._ptyService.getProfiles?.(a,l,r,o)||[]}_getEnvironment(){return{...process.env}}_getWslPath(a){return this._ptyService.getWslPath(a)}_reduceConnectionGraceTime(){return this._ptyService.reduceConnectionGraceTime()}}e.RemoteTerminalChannel=w}),define(ue[276],de([0,1,77,32,90,92,78,26,48,277,18,3,25,17,144,2,35,95,61,125,238,45,16,10,58,28,74,56,104,27,60,124,39,33,29,110,123,100,72,190,75,108,226,221,91,101,76,15,38,35,6,260,240,261,218,202,227,189,102,241,5,31,82,4,252,275,126,122,107,103,111,234,239,51,112,269,253]),function(Y,e,S,k,p,P,t,T,h,f,C,I,m,u,c,b,g,D,w,v,a,l,r,o,i,n,s,d,y,A,E,R,O,K,te,j,_,U,F,M,V,ee,G,H,q,z,B,W,ie,oe,we,se,ae,ke,De,Oe,Be,Xe,Ze,ge,me,Ie,Re,Le,He,Qe,Je,rt,ce,Se,Pe,$e,Ye,lt,tt,at,ot){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createServer=e.RemoteExtensionHostAgentServer=void 0;const et=5*60*1e3,ne="monacoworkbench";class be extends oe.IPCServer{constructor(){const Q=new we.Emitter;super(Q.event);this._onDidConnectEmitter=Q}acceptConnection(Q,re){this._onDidConnectEmitter.fire({protocol:Q,onDidClientDisconnect:re})}}function Fe(x){return x<10?`0${x}`:String(x)}function Ae(){const x=new Date;return`${Fe(x.getHours())}:${Fe(x.getMinutes())}:${Fe(x.getSeconds())}`}class Ve extends r.AbstractLogger{constructor(Q=r.DEFAULT_LOG_LEVEL){super();this.setLevel(Q),this.useColors=Boolean(process.stdout.isTTY)}trace(Q,...re){this.getLevel()<=r.LogLevel.Trace&&(this.useColors?console.log(`[90m[${Ae()}][0m`,Q,...re):console.log(`[${Ae()}]`,Q,...re))}debug(Q,...re){this.getLevel()<=r.LogLevel.Debug&&(this.useColors?console.log(`[90m[${Ae()}][0m`,Q,...re):console.log(`[${Ae()}]`,Q,...re))}info(Q,...re){this.getLevel()<=r.LogLevel.Info&&(this.useColors?console.log(`[90m[${Ae()}][0m`,Q,...re):console.log(`[${Ae()}]`,Q,...re))}warn(Q,...re){this.getLevel()<=r.LogLevel.Warning&&(this.useColors?console.warn(`[93m[${Ae()}][0m`,Q,...re):console.warn(`[${Ae()}]`,Q,...re))}error(Q,...re){this.getLevel()<=r.LogLevel.Error&&(this.useColors?console.error(`[91m[${Ae()}][0m`,Q,...re):console.error(`[${Ae()}]`,Q,...re))}critical(Q,...re){this.getLevel()<=r.LogLevel.Critical&&(this.useColors?console.error(`[90m[${Ae()}][0m`,Q,...re):console.error(`[${Ae()}]`,Q,...re))}dispose(){}flush(){}}class ve extends I.Disposable{constructor(Q,re,Ee,Ue,_e,ze){super();this._environmentService=Q,this._productService=re,this._connectionToken=Ee,this._connectionTokenIsMandatory=Ue,this.hasWebClient=_e,this._webClientServer=null;const We=J(this._environmentService);We.trace(`Remote configuration data at ${ze}`),We.trace("process arguments:",this._environmentService.args);const Ke=re.serverGreeting.join(`
`);Ke&&We.info(`

${Ke}

`),this._logService=new r.MultiplexLogService([new Ve((0,r.getLogLevel)(this._environmentService)),We]),this._socketServer=new be,this._uriTransformerCache=Object.create(null),this._extHostConnections=Object.create(null),this._managementConnections=Object.create(null),this._allReconnectionTokens=new Set,this._logService.info("Extension host agent started.")}async initialize(){const Q=await this._createServices();return setTimeout(()=>this._cleanupOlderLogs(this._environmentService.logsPath).then(null,re=>this._logService.error(re)),1e4),Q}async _createServices(){const Q=new s.ServiceCollection;this._socketServer.registerChannel(Xe.ExtensionHostDebugBroadcastChannel.ChannelName,new Xe.ExtensionHostDebugBroadcastChannel);const re=new oe.StaticRouter(X=>X.clientId==="renderer");this._socketServer.registerChannel("logger",new Ze.LogLevelChannel(this._logService)),Q.set(n.IEnvironmentService,this._environmentService),Q.set(n.INativeEnvironmentService,this._environmentService),Q.set(r.ILogService,this._logService),Q.set(ie.IProductService,this._productService);const Ee=this._register(new z.FileService(this._logService));Q.set(W.IFileService,Ee),Ee.registerProvider(o.Schemas.file,this._register(new B.DiskFileSystemProvider(this._logService)));const Ue=new y.ConfigurationService(this._environmentService.machineSettingsResource,Ee);await Ue.initialize(),Q.set(A.IConfigurationService,Ue),Q.set(lt.IUriIdentityService,new tt.UriIdentityService(Ee)),Q.set(E.IRequestService,new d.SyncDescriptor(R.RequestService));let _e=O.NullAppender;if((0,O.supportsTelemetry)(this._productService,this._environmentService)){this._productService.aiConfig&&this._productService.aiConfig.asimovKey&&(_e=new G.AppInsightsAppender(ne,null,this._productService.aiConfig.asimovKey),this._register((0,I.toDisposable)(()=>_e.flush())));const X=await(0,q.getMachineId)(),$={appenders:[_e],commonProperties:(0,H.resolveCommonProperties)(Ee,(0,T.release)(),(0,T.hostname)(),process.arch,this._productService.commit,this._productService.version+"-remote",X,this._productService.msftInternalDomains,this._environmentService.installSourcePath,"remoteAgent"),piiPaths:[this._environmentService.appRoot]};Q.set(Ye.IRemoteTelemetryService,new d.SyncDescriptor(Ye.RemoteTelemetryService,[$]))}else Q.set(Ye.IRemoteTelemetryService,Ye.RemoteNullTelemetryService);Q.set(te.IExtensionGalleryService,new d.SyncDescriptor(j.ExtensionGalleryServiceWithNoStorageService));const ze=this._socketServer.getChannel("download",re);Q.set(F.IDownloadService,new M.DownloadServiceChannelClient(ze,()=>this._getUriTransformer("renderer"))),Q.set(te.IExtensionManagementService,new d.SyncDescriptor(_.ExtensionManagementService));const We=new U.InstantiationService(Q);Q.set(V.ILocalizationsService,We.createInstance(ee.LocalizationsService));const Ke=We.createInstance(ce.ExtensionManagementCLIService);Q.set(te.IExtensionManagementCLIService,Ke);const le=new at.ExtensionResourceLoaderService(Ee);Q.set(ot.IExtensionResourceLoaderService,le);const he=We.createInstance($e.PtyHostService,{graceTime:108e5,shortGraceTime:3e5,scrollback:Ue.getValue("terminal.integrated.persistentSessionScrollback")??100});return Q.set(Pe.IPtyService,he),We.invokeFunction(X=>{const $=new se.RemoteAgentEnvironmentChannel(this._connectionToken,this._environmentService,Ke,this._logService,X.get(Ye.IRemoteTelemetryService),_e,this._productService);this._socketServer.registerChannel("remoteextensionsenvironment",$),this._socketServer.registerChannel(He.REMOTE_TERMINAL_CHANNEL_NAME,new Qe.RemoteTerminalChannel(this._environmentService,this._logService,he,this._productService));const ye=new ae.RemoteAgentFileSystemProviderChannel(this._logService,this._environmentService);this._socketServer.registerChannel(ke.REMOTE_FILE_SYSTEM_CHANNEL_NAME,ye),this._socketServer.registerChannel("request",new De.RequestChannel(X.get(E.IRequestService)));const Te=X.get(te.IExtensionManagementService),Ge=new Oe.ExtensionManagementChannel(Te,ct=>this._getUriTransformer(ct.remoteAuthority));this._socketServer.registerChannel("extensions",Ge);const Me=g.ProxyChannel.fromService(X.get(V.ILocalizationsService));this._socketServer.registerChannel("localizations",Me),Te.removeDeprecatedExtensions(),this._register(new Be.default(X.get(K.ITelemetryService)));const it=new at.ServerThemeService(this._logService,Ue,$,le);return Q.set(at.IServerThemeService,it),this.hasWebClient?this._webClientServer=new ge.WebClientServer(this._connectionToken,this._environmentService,this._logService,it,this._productService):this._webClientServer=null,{telemetryService:X.get(K.ITelemetryService)}})}_getUriTransformer(Q){return this._uriTransformerCache[Q]||(this._uriTransformerCache[Q]=(0,l.createRemoteURITransformer)(Q)),this._uriTransformerCache[Q]}async handleRequest(Q,re){if(!this._webClientServer)throw new Error("Web client server not initialized");if(Q.method!=="GET")return this._webClientServer.serveError(Q,re,405,`Unsupported method ${Q.method}`);if(!Q.url)return this._webClientServer.serveError(Q,re,400,"Bad request.");const Ee=t.parse(Q.url,!0),Ue=Ee.pathname;if(!Ue)return this._webClientServer.serveError(Q,re,400,"Bad request.");const _e=p.parse(Ue);if(_e.base==="version")return re.writeHead(200,{"Content-Type":"text/plain"}),re.end(this._productService.commit||"");if(_e.base==="delay-shutdown")return this._delayShutdown(),re.writeHead(200),re.end("OK");if(_e.base==="vscode-remote-resource"){const ze=Ee.query.path;if(typeof ze!="string")return this._webClientServer.serveError(Q,re,400,"Bad request.");let We;try{We=me.URI.from({scheme:o.Schemas.file,path:ze}).fsPath}catch(le){return this._webClientServer.serveError(Q,re,400,"Bad request.")}const Ke=Object.create(null);return this._environmentService.isBuilt&&((0,Ie.isEqualOrParent)(We,this._environmentService.builtinExtensionsPath,!b.isLinux)||(0,Ie.isEqualOrParent)(We,this._environmentService.extensionsPath,!b.isLinux))&&(Ke["Cache-Control"]="public, max-age=31536000"),(0,ge.serveFile)(this._logService,Q,re,We,Ke)}return this._webClientServer.handle(Q,re,Ee)}handleUpgrade(Q,re){let Ee=(0,m.generateUuid)(),Ue=!1,_e=!1;if(Q.url){const X=t.parse(Q.url,!0).query;typeof X.reconnectionToken=="string"&&(Ee=X.reconnectionToken),X.reconnection==="true"&&(Ue=!0),X.skipWebSocketFrames==="true"&&(_e=!0)}if(Q.headers.upgrade!=="websocket"){re.end("HTTP/1.1 400 Bad Request");return}const ze=Q.headers["sec-websocket-key"],We=S.createHash("sha1");We.update(ze+"258EAFA5-E914-47DA-95CA-C5AB0DC85B11");const Ke=We.digest("base64"),le=["HTTP/1.1 101 Switching Protocols","Upgrade: websocket","Connection: Upgrade",`Sec-WebSocket-Accept: ${Ke}`];let he=!1;if(!_e&&!this._environmentService.args["disable-websocket-compression"]&&Q.headers["sec-websocket-extensions"]){const X=Array.isArray(Q.headers["sec-websocket-extensions"])?Q.headers["sec-websocket-extensions"]:[Q.headers["sec-websocket-extensions"]];for(const $ of X)if(!/\b((server_max_window_bits)|(server_no_context_takeover)|(client_no_context_takeover))\b/.test($)){if(/\b(permessage-deflate)\b/.test($)){he=!0,le.push("Sec-WebSocket-Extensions: permessage-deflate");break}if(/\b(x-webkit-deflate-frame)\b/.test($)){he=!0,le.push("Sec-WebSocket-Extensions: x-webkit-deflate-frame");break}}}re.write(le.join(`\r
`)+`\r
\r
`),re.setTimeout(0),_e?this._handleWebSocketConnection(new w.NodeSocket(re),Ue,Ee):this._handleWebSocketConnection(new w.WebSocketNodeSocket(new w.NodeSocket(re),he,null,!0),Ue,Ee)}handleServerError(Q){this._logService.error("Error occurred in server"),this._logService.error(Q)}async _cleanupOlderLogs(Q){const re=(0,Le.basename)(Q),Ee=(0,Le.dirname)(Q),ze=(await u.Promises.readdir(Ee)).filter(Ke=>/^\d{8}T\d{6}$/.test(Ke)).sort().filter(Ke=>Ke!==re),We=ze.slice(0,Math.max(0,ze.length-9));await Promise.all(We.map(Ke=>u.Promises.rm((0,Le.join)(Ee,Ke))))}_getRemoteAddress(Q){let re;return Q instanceof w.NodeSocket?re=Q.socket:re=Q.socket.socket,re.remoteAddress||"<unknown>"}async _rejectWebSocketConnection(Q,re,Ee){const Ue=re.getSocket();this._logService.error(`${Q} ${Ee}.`);const _e={type:"error",reason:Ee};re.sendControl(C.VSBuffer.fromString(JSON.stringify(_e))),re.dispose(),await Ue.drain(),Ue.dispose()}_handleWebSocketConnection(Q,re,Ee){const Ue=this._getRemoteAddress(Q),_e=`[${Ue}][${Ee.substr(0,8)}]`,ze=new D.PersistentProtocol(Q);let We,Ke;try{const ye=Y.__$__nodeRequire("vsda");We=new ye.validator,Ke=new ye.signer}catch(ye){}let le;(function(ye){ye[ye.WaitingForAuth=0]="WaitingForAuth",ye[ye.WaitingForConnectionType=1]="WaitingForConnectionType",ye[ye.Done=2]="Done",ye[ye.Error=3]="Error"})(le||(le={}));let he=0;const X=ye=>{he=3,$.dispose(),this._rejectWebSocketConnection(_e,ze,ye)},$=ze.onControlMessage(ye=>{if(he===0){let Te;try{Te=JSON.parse(ye.toString())}catch(ct){return X("Malformed first message")}if(Te.type!=="auth")return X("Invalid first message");if(this._connectionTokenIsMandatory&&Te.auth!==this._connectionToken)return X("Unauthorized client refused: auth mismatch");let Ge=(0,m.generateUuid)();if(Ke)try{Ge=Ke.sign(Te.data)}catch(ct){}let Me=(0,m.generateUuid)();if(We)try{Me=We.createNewMessage(Me)}catch(ct){}const it={type:"sign",data:Me,signedData:Ge};ze.sendControl(C.VSBuffer.fromString(JSON.stringify(it))),he=1}else if(he===1){let Te;try{Te=JSON.parse(ye.toString())}catch(ct){return X("Malformed second message")}if(Te.type!=="connectionType")return X("Invalid second message");if(typeof Te.signedData!="string")return X("Invalid second message field type");const Ge=Te.commit,Me=this._productService.commit;if(Ge&&Me&&Ge!==Me)return X("Client refused: version mismatch");let it=!1;if(!We)it=!0;else if(Te.signedData===this._connectionToken)it=!0;else try{it=We.validate(Te.signedData)==="ok"}catch(ct){}if(!it){if(this._environmentService.isBuilt)return X("Unauthorized client refused");this._logService.error(`${_e} Unauthorized client handshake failed but we proceed because of dev mode.`)}for(let ct in this._managementConnections)this._managementConnections[ct].shortenReconnectionGraceTimeIfNecessary();for(let ct in this._extHostConnections)this._extHostConnections[ct].shortenReconnectionGraceTimeIfNecessary();he=2,$.dispose(),this._handleConnectionType(Ue,_e,ze,Q,re,Ee,Te)}})}async _handleConnectionType(Q,re,Ee,Ue,_e,ze,We){const Ke=We.desiredConnectionType===1?`${re}[ManagementConnection]`:We.desiredConnectionType===2?`${re}[ExtensionHostConnection]`:re;if(We.desiredConnectionType===1)if(_e){if(!this._managementConnections[ze])return this._allReconnectionTokens.has(ze)?this._rejectWebSocketConnection(Ke,Ee,"Unknown reconnection token (seen before)"):this._rejectWebSocketConnection(Ke,Ee,"Unknown reconnection token (never seen)");Ee.sendControl(C.VSBuffer.fromString(JSON.stringify({type:"ok"})));const le=Ee.readEntireBuffer();Ee.dispose(),this._managementConnections[ze].acceptReconnection(Q,Ue,le)}else{if(this._managementConnections[ze])return this._rejectWebSocketConnection(Ke,Ee,"Duplicate reconnection token");Ee.sendControl(C.VSBuffer.fromString(JSON.stringify({type:"ok"})));const le=new a.ManagementConnection(this._logService,ze,Q,Ee);this._socketServer.acceptConnection(le.protocol,le.onClose),this._managementConnections[ze]=le,this._allReconnectionTokens.add(ze),le.onClose(()=>{delete this._managementConnections[ze]})}else if(We.desiredConnectionType===2){const le=We.args||{language:"en"},he=await this._updateWithFreeDebugPort(le);if(he.port&&this._logService.trace(`${Ke} - startParams debug port ${he.port}`),this._logService.trace(`${Ke} - startParams language: ${he.language}`),this._logService.trace(`${Ke} - startParams env: ${JSON.stringify(he.env)}`),_e){if(!this._extHostConnections[ze])return this._allReconnectionTokens.has(ze)?this._rejectWebSocketConnection(Ke,Ee,"Unknown reconnection token (seen before)"):this._rejectWebSocketConnection(Ke,Ee,"Unknown reconnection token (never seen)");Ee.sendControl(C.VSBuffer.fromString(JSON.stringify(he.port?{debugPort:he.port}:{})));const X=Ee.readEntireBuffer();Ee.dispose(),this._extHostConnections[ze].acceptReconnection(Q,Ue,X)}else{if(this._extHostConnections[ze])return this._rejectWebSocketConnection(Ke,Ee,"Duplicate reconnection token");Ee.sendControl(C.VSBuffer.fromString(JSON.stringify(he.port?{debugPort:he.port}:{})));const X=Ee.readEntireBuffer();Ee.dispose();const $=new v.ExtensionHostConnection(this._environmentService,this._logService,ze,Q,Ue,X);this._extHostConnections[ze]=$,this._allReconnectionTokens.add(ze),$.onClose(()=>{delete this._extHostConnections[ze],this._onDidCloseExtHostConnection()}),$.start(he)}}else if(We.desiredConnectionType===3){const le=We.args;this._createTunnel(Ee,le)}else return this._rejectWebSocketConnection(Ke,Ee,"Unknown initial data received")}async _createTunnel(Q,re){const Ee=Q.getSocket().socket,Ue=Q.readEntireBuffer();Q.dispose(),Ee.pause();const _e=await this._connectTunnelSocket(re.host,re.port);Ue.byteLength>0&&_e.write(Ue.buffer),_e.on("end",()=>Ee.end()),_e.on("close",()=>Ee.end()),_e.on("error",()=>Ee.destroy()),Ee.on("end",()=>_e.end()),Ee.on("close",()=>_e.end()),Ee.on("error",()=>_e.destroy()),_e.pipe(Ee),Ee.pipe(_e)}_connectTunnelSocket(Q,re){return new Promise((Ee,Ue)=>{const _e=P.createConnection({host:Q,port:re},()=>{_e.removeListener("error",Ue),_e.pause(),Ee(_e)});_e.once("error",Ue)})}_updateWithFreeDebugPort(Q){return typeof Q.port=="number"?(0,c.findFreePort)(Q.port,10,5e3).then(re=>(Q.port=re,Q)):(Q.debugId=void 0,Q.port=void 0,Q.break=void 0,Promise.resolve(Q))}async _onDidCloseExtHostConnection(){if(!this._environmentService.args["enable-remote-auto-shutdown"])return;this._cancelShutdown(),!!Object.keys(this._extHostConnections).length||(console.log("Last EH closed, waiting before shutting down"),this._logService.info("Last EH closed, waiting before shutting down"),this._waitThenShutdown())}_waitThenShutdown(){!this._environmentService.args["enable-remote-auto-shutdown"]||(this._environmentService.args["remote-auto-shutdown-without-delay"]?this._shutdown():this.shutdownTimer=setTimeout(()=>{this.shutdownTimer=void 0,this._shutdown()},et))}_shutdown(){if(!!Object.keys(this._extHostConnections).length){console.log("New EH opened, aborting shutdown"),this._logService.info("New EH opened, aborting shutdown");return}else console.log("Last EH closed, shutting down"),this._logService.info("Last EH closed, shutting down"),this.dispose(),process.exit(0)}_delayShutdown(){this.shutdownTimer&&(console.log("Got delay-shutdown request while in shutdown timeout, delaying"),this._logService.info("Got delay-shutdown request while in shutdown timeout, delaying"),this._cancelShutdown(),this._waitThenShutdown())}_cancelShutdown(){this.shutdownTimer&&(console.log("Cancelling previous shutdown timeout"),this._logService.info("Cancelling previous shutdown timeout"),clearTimeout(this.shutdownTimer),this.shutdownTimer=void 0)}}e.RemoteExtensionHostAgentServer=ve;function fe(x){if(x.connectionToken&&console.warn("The argument '--connectionToken' is deprecated, please use '--connection-token' instead"),x["connection-secret"]){x["connection-token"]&&(console.warn("Please do not use the argument '--connection-token' at the same time as '--connection-secret'."),process.exit(1));let Q=k.readFileSync(x["connection-secret"]).toString();return Q=Q.replace(/\r?\n$/,""),/^[0-9A-Za-z\-]+$/.test(Q)||(console.warn(`The secret defined in ${x["connection-secret"]} does not adhere to the characters 0-9, a-z, A-Z or -.`),process.exit(1)),{connectionToken:Q,connectionTokenIsMandatory:!0}}else return{connectionToken:x["connection-token"]||x.connectionToken||(0,m.generateUuid)(),connectionTokenIsMandatory:!1}}async function pe(x,Q,re){const Ee={_serviceBrand:void 0,...i.default},Ue=new Re.ServerEnvironmentService(Q,Ee);if(process.platform==="win32"&&process.env.HOMEDRIVE&&process.env.HOMEPATH){const Ge=(0,Le.join)(process.env.HOMEDRIVE,"node_modules"),Me=(0,Le.dirname)((0,Le.join)(process.env.HOMEDRIVE,process.env.HOMEPATH)),it=(0,Le.join)(Me,"node_modules");if(k.existsSync(Ge)||k.existsSync(it)){const ct=`

*
* !!!! Server terminated due to presence of CVE-2020-1416 !!!!
*
* Please remove the following directories and re-try
* ${Ge}
* ${it}
*
* For more information on the vulnerability https://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2020-1416
*

`;J(Ue).warn(ct),console.warn(ct),process.exit(0)}}const{connectionToken:_e,connectionTokenIsMandatory:ze}=fe(Q),We=k.existsSync(o.FileAccess.asFileUri("vs/code/browser/workbench/workbench.html",Y).fsPath);We&&x&&typeof x!="string"&&console.log(`Web UI available at http://localhost${x.port===80?"":`:${x.port}`}/?tkn=${_e}`);const Ke=new ve(Ue,Ee,_e,ze,We,re),le=await Ke.initialize(),{telemetryService:he}=le;h.mark("code/server/ready");const X=f.performance.now(),$=global.vscodeServerStartTime,ye=global.vscodeServerListenTime,Te=global.vscodeServerCodeLoadedTime;if(he.publicLog2("serverStart",{startTime:$,startedTime:ye,codeLoadedTime:Te,readyTime:X}),Q["print-startup-performance"]){const Ge=Je.LoaderStats.get();let Me="";Me+=`

### Load AMD-module
`,Me+=Je.LoaderStats.toMarkdownTable(["Module","Duration"],Ge.amdLoad),Me+=`

### Load commonjs-module
`,Me+=Je.LoaderStats.toMarkdownTable(["Module","Duration"],Ge.nodeRequire),Me+=`

### Invoke AMD-module factory
`,Me+=Je.LoaderStats.toMarkdownTable(["Module","Duration"],Ge.amdInvoke),Me+=`

### Invoke commonjs-module
`,Me+=Je.LoaderStats.toMarkdownTable(["Module","Duration"],Ge.nodeEval),Me+=`Start-up time: ${ye-$}
`,Me+=`Code loading time: ${Te-$}
`,Me+=`Initialized time: ${X-$}
`,Me+=`
`,console.log(Me)}return Ke}e.createServer=pe;const J=function(){let x;return function(re){return x||(x=new r.LogService(new Se.SpdLogLogger(rt.RemoteExtensionLogFileName,(0,Le.join)(re.logsPath,`${rt.RemoteExtensionLogFileName}.log`),!0,!1,(0,r.getLogLevel)(re)))),x}}()}),define(ue[287],de([0,1,26,32,10,273,276,55,4,277,82,48]),function(Y,e,S,k,p,P,t,T,h,f,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createServer=e.spawnCli=e.createDirs=void 0,I.mark("code/server/codeLoaded"),global.vscodeServerCodeLoadedTime=f.performance.now();const m={onMultipleValues:(i,n)=>{console.error(`Option ${i} can only be defined once. Using value ${n}.`)},onUnknownOption:i=>{console.error(`Ignoring option ${i}: not supported for server.`)}};function u(){return(0,T.parseArgs)(process.argv.slice(2),C.serverOptions,m)}const c=process.env.VSCODE_AGENT_FOLDER||(0,h.join)(S.homedir(),".vscode-remote"),b=(0,h.join)(c,"data"),g=(0,h.join)(b,"User"),D=(0,h.join)(g,"globalStorage"),w=(0,h.join)(b,"Machine"),v=(0,h.dirname)(p.FileAccess.asFileUri("",Y).fsPath),a=(0,h.join)(v,"extensions");function l(i){i["user-data-dir"]=i["user-data-dir"]||b,i["builtin-extensions-dir"]=i["builtin-extensions-dir"]||a,i["extensions-dir"]=i["extensions-dir"]||(0,h.join)(c,"extensions"),[c,i["extensions-dir"],b,g,w,D].forEach(n=>{try{k.existsSync(n)||k.mkdirSync(n)}catch(s){console.error(s)}})}e.createDirs=l;function r(i=u()){return l(i),(0,P.run)(i,i["user-data-dir"]||c,C.serverOptions)}e.spawnCli=r;function o(i,n=u()){return l(n),(0,t.createServer)(i,n,n["user-data-dir"]||c)}e.createServer=o})}).call(this);

//# sourceMappingURL=remoteExtensionHostAgent.js.map
