/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Ee=["require","exports","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/base/common/strings","vs/base/common/network","vs/base/common/types","vs/platform/log/common/log","vs/workbench/api/common/extHostRpcService","vs/base/common/async","vs/base/common/errors","vs/base/common/arrays","vs/base/common/path","vs/nls","vs/nls!vs/workbench/services/extensions/worker/extensionHostWorker","vs/base/common/cancellation","vs/base/common/map","vs/base/common/buffer","vs/base/common/platform","vs/base/common/resources","vs/platform/extensions/common/extensions","vs/workbench/services/extensions/common/extensions","vs/base/common/objects","vs/workbench/api/common/extHostInitDataService","vs/base/common/glob","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/severity","vs/base/common/uuid","vs/platform/registry/common/platform","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostTerminalService","vs/workbench/services/search/common/search","vs/base/common/assert","vs/base/common/decorators","vs/base/common/extpath","vs/base/common/errorMessage","vs/platform/contextkey/common/contextkey","vs/platform/files/common/files","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostWebview","vs/base/common/idGenerator","vs/base/common/codicons","vs/base/common/marshalling","vs/editor/common/modes/languageSelector","vs/platform/instantiation/common/extensions","vs/base/common/hash","vs/editor/common/modes","vs/editor/common/core/range","vs/platform/instantiation/common/serviceCollection","vs/platform/remote/common/remoteHosts","vs/platform/theme/common/themeService","vs/workbench/api/common/cache","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/shared/webview","vs/workbench/contrib/testing/common/testId","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/base/common/performance","vs/base/common/collections","vs/base/common/numbers","vs/base/common/htmlContent","vs/base/common/labels","vs/base/common/mime","vs/editor/common/services/semanticTokensDto","vs/platform/instantiation/common/descriptors","vs/platform/configuration/common/configuration","vs/platform/markers/common/markers","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testCollection","vs/base/common/process","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/lazy","vs/base/common/stream","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/modes/languageConfiguration","vs/editor/common/modes/tokenizationRegistry","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/model/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/editor/common/services/modelService","vs/editor/common/modes/languageFeatureRegistry","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/opener/common/opener","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/remote/common/tunnel","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/shared/treeDataTransfer","vs/workbench/api/common/extHostCodeInsets","vs/workbench/common/editor","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debugUtils","vs/base/common/iterator","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/output/common/output","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostLogService","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/base/common/stopwatch","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/editor/common/model/mirrorTextModel","vs/editor/common/viewModel/prefixSumComputer","vs/base/common/marked/marked","vs/base/common/linkedList","vs/editor/common/core/position","vs/editor/common/modes/linkComputer","vs/editor/common/core/selection","vs/base/common/functional","vs/editor/common/model/textModelSearch","vs/editor/common/model","vs/workbench/services/extensions/worker/extensionHostWorker"],_e=function(oe){for(var e=[],c=0,F=oe.length;c<F;c++)e[c]=Ee[oe[c]];return e};define(Ee[41],_e([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function c(F,w){if(!F)throw new Error(w?`Assertion failed (${w})`:"Assertion Failed")}e.ok=c}),define(Ee[74],_e([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const c=Object.prototype.hasOwnProperty;function F(A){const _=[];for(let n in A)c.call(A,n)&&_.push(A[n]);return _}e.values=F;function w(A,_){for(let n in A)if(c.call(A,n)&&_({key:n,value:A[n]},function(){delete A[n]})===!1)return}e.forEach=w;function I(A,_){const n=Object.create(null);for(const h of A){const s=_(h);let l=n[s];l||(l=n[s]=[]),l.push(h)}return n}e.groupBy=I;function t(A){const _=Object.create(null);return A&&A.forEach((n,h)=>{_[h]=n}),_}e.fromMap=t;function R(A,_){const n=[],h=[];for(let s of A)_.has(s)||n.push(s);for(let s of _)A.has(s)||h.push(s);return{removed:n,added:h}}e.diffSets=R;function S(A,_){const n=[],h=[];for(let[s,l]of A)_.has(s)||n.push(l);for(let[s,l]of _)A.has(s)||h.push(l);return{removed:n,added:h}}e.diffMaps=S;class C{constructor(){this.map=new Map}add(_,n){let h=this.map.get(_);h||(h=new Set,this.map.set(_,h)),h.add(n)}delete(_,n){const h=this.map.get(_);!h||(h.delete(n),h.size===0&&this.map.delete(_))}forEach(_,n){const h=this.map.get(_);!h||h.forEach(n)}}e.SetMap=C}),define(Ee[42],_e([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function c(t){return(R,S,C)=>{let A=null,_=null;if(typeof C.value=="function"?(A="value",_=C.value):typeof C.get=="function"&&(A="get",_=C.get),!_)throw new Error("not supported");C[A]=t(_,S)}}e.createDecorator=c;function F(t,R,S){let C=null,A=null;if(typeof S.value=="function"?(C="value",A=S.value,A.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof S.get=="function"&&(C="get",A=S.get),!A)throw new Error("not supported");const _=`$memoize$${R}`;S[C]=function(...n){return this.hasOwnProperty(_)||Object.defineProperty(this,_,{configurable:!1,enumerable:!1,writable:!1,value:A.apply(this,n)}),this[_]}}e.memoize=F;function w(t,R,S){return c((C,A)=>{const _=`$debounce$${A}`,n=`$debounce$result$${A}`;return function(...h){this[n]||(this[n]=S?S():void 0),clearTimeout(this[_]),R&&(this[n]=R(this[n],...h),h=[this[n]]),this[_]=setTimeout(()=>{C.apply(this,h),this[n]=S?S():void 0},t)}})}e.debounce=w;function I(t,R,S){return c((C,A)=>{const _=`$throttle$timer$${A}`,n=`$throttle$result$${A}`,h=`$throttle$lastRun$${A}`,s=`$throttle$pending$${A}`;return function(...l){if(this[n]||(this[n]=S?S():void 0),(this[h]===null||this[h]===void 0)&&(this[h]=-Number.MAX_VALUE),R&&(this[n]=R(this[n],...l)),this[s])return;const d=this[h]+t;d<=Date.now()?(this[h]=Date.now(),C.apply(this,[this[n]]),this[n]=S?S():void 0):(this[s]=!0,this[_]=setTimeout(()=>{this[s]=!1,this[h]=Date.now(),C.apply(this,[this[n]]),this[n]=S?S():void 0},d-Date.now()))}})}e.throttle=I}),define(Ee[52],_e([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class c{constructor(w){this._prefix=w,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=c,e.defaultGenerator=new c("id#")}),define(Ee[100],_e([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var c;(function(u){u[u.None=0]="None",u[u.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",u[u.UnexpectedEndOfString=2]="UnexpectedEndOfString",u[u.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",u[u.InvalidUnicode=4]="InvalidUnicode",u[u.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",u[u.InvalidCharacter=6]="InvalidCharacter"})(c=e.ScanError||(e.ScanError={}));var F;(function(u){u[u.OpenBraceToken=1]="OpenBraceToken",u[u.CloseBraceToken=2]="CloseBraceToken",u[u.OpenBracketToken=3]="OpenBracketToken",u[u.CloseBracketToken=4]="CloseBracketToken",u[u.CommaToken=5]="CommaToken",u[u.ColonToken=6]="ColonToken",u[u.NullKeyword=7]="NullKeyword",u[u.TrueKeyword=8]="TrueKeyword",u[u.FalseKeyword=9]="FalseKeyword",u[u.StringLiteral=10]="StringLiteral",u[u.NumericLiteral=11]="NumericLiteral",u[u.LineCommentTrivia=12]="LineCommentTrivia",u[u.BlockCommentTrivia=13]="BlockCommentTrivia",u[u.LineBreakTrivia=14]="LineBreakTrivia",u[u.Trivia=15]="Trivia",u[u.Unknown=16]="Unknown",u[u.EOF=17]="EOF"})(F=e.SyntaxKind||(e.SyntaxKind={}));var w;(function(u){u[u.InvalidSymbol=1]="InvalidSymbol",u[u.InvalidNumberFormat=2]="InvalidNumberFormat",u[u.PropertyNameExpected=3]="PropertyNameExpected",u[u.ValueExpected=4]="ValueExpected",u[u.ColonExpected=5]="ColonExpected",u[u.CommaExpected=6]="CommaExpected",u[u.CloseBraceExpected=7]="CloseBraceExpected",u[u.CloseBracketExpected=8]="CloseBracketExpected",u[u.EndOfFileExpected=9]="EndOfFileExpected",u[u.InvalidCommentToken=10]="InvalidCommentToken",u[u.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",u[u.UnexpectedEndOfString=12]="UnexpectedEndOfString",u[u.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",u[u.InvalidUnicode=14]="InvalidUnicode",u[u.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",u[u.InvalidCharacter=16]="InvalidCharacter"})(w=e.ParseErrorCode||(e.ParseErrorCode={}));var I;(function(u){u.DEFAULT={allowTrailingComma:!0}})(I=e.ParseOptions||(e.ParseOptions={}));function t(u,M=!1){let r=0,i=u.length,p="",m=0,o=16,b=0;function a(x){let N=0,z=0;for(;N<x;){const H=u.charCodeAt(r);if(H>=48&&H<=57)z=z*16+H-48;else if(H>=65&&H<=70)z=z*16+H-65+10;else if(H>=97&&H<=102)z=z*16+H-97+10;else break;r++,N++}return N<x&&(z=-1),z}function E(x){r=x,p="",m=0,o=16,b=0}function P(){const x=r;if(u.charCodeAt(r)===48)r++;else for(r++;r<u.length&&C(u.charCodeAt(r));)r++;if(r<u.length&&u.charCodeAt(r)===46)if(r++,r<u.length&&C(u.charCodeAt(r)))for(r++;r<u.length&&C(u.charCodeAt(r));)r++;else return b=3,u.substring(x,r);let N=r;if(r<u.length&&(u.charCodeAt(r)===69||u.charCodeAt(r)===101))if(r++,(r<u.length&&u.charCodeAt(r)===43||u.charCodeAt(r)===45)&&r++,r<u.length&&C(u.charCodeAt(r))){for(r++;r<u.length&&C(u.charCodeAt(r));)r++;N=r}else b=3;return u.substring(x,N)}function k(){let x="",N=r;for(;;){if(r>=i){x+=u.substring(N,r),b=2;break}const z=u.charCodeAt(r);if(z===34){x+=u.substring(N,r),r++;break}if(z===92){if(x+=u.substring(N,r),r++,r>=i){b=2;break}switch(u.charCodeAt(r++)){case 34:x+='"';break;case 92:x+="\\";break;case 47:x+="/";break;case 98:x+="\b";break;case 102:x+="\f";break;case 110:x+=`
`;break;case 114:x+="\r";break;case 116:x+="	";break;case 117:const q=a(4);q>=0?x+=String.fromCharCode(q):b=4;break;default:b=5}N=r;continue}if(z>=0&&z<=31)if(S(z)){x+=u.substring(N,r),b=2;break}else b=6;r++}return x}function B(){if(p="",b=0,m=r,r>=i)return m=i,o=17;let x=u.charCodeAt(r);if(R(x)){do r++,p+=String.fromCharCode(x),x=u.charCodeAt(r);while(R(x));return o=15}if(S(x))return r++,p+=String.fromCharCode(x),x===13&&u.charCodeAt(r)===10&&(r++,p+=`
`),o=14;switch(x){case 123:return r++,o=1;case 125:return r++,o=2;case 91:return r++,o=3;case 93:return r++,o=4;case 58:return r++,o=6;case 44:return r++,o=5;case 34:return r++,p=k(),o=10;case 47:const N=r-1;if(u.charCodeAt(r+1)===47){for(r+=2;r<i&&!S(u.charCodeAt(r));)r++;return p=u.substring(N,r),o=12}if(u.charCodeAt(r+1)===42){r+=2;const z=i-1;let H=!1;for(;r<z;){if(u.charCodeAt(r)===42&&u.charCodeAt(r+1)===47){r+=2,H=!0;break}r++}return H||(r++,b=1),p=u.substring(N,r),o=13}return p+=String.fromCharCode(x),r++,o=16;case 45:if(p+=String.fromCharCode(x),r++,r===i||!C(u.charCodeAt(r)))return o=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return p+=P(),o=11;default:for(;r<i&&L(x);)r++,x=u.charCodeAt(r);if(m!==r){switch(p=u.substring(m,r),p){case"true":return o=8;case"false":return o=9;case"null":return o=7}return o=16}return p+=String.fromCharCode(x),r++,o=16}}function L(x){if(R(x)||S(x))return!1;switch(x){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function y(){let x;do x=B();while(x>=12&&x<=15);return x}return{setPosition:E,getPosition:()=>r,scan:M?y:B,getToken:()=>o,getTokenValue:()=>p,getTokenOffset:()=>m,getTokenLength:()=>r-m,getTokenError:()=>b}}e.createScanner=t;function R(u){return u===32||u===9||u===11||u===12||u===160||u===5760||u>=8192&&u<=8203||u===8239||u===8287||u===12288||u===65279}function S(u){return u===10||u===13||u===8232||u===8233}function C(u){return u>=48&&u<=57}var A;(function(u){u[u.nullCharacter=0]="nullCharacter",u[u.maxAsciiCharacter=127]="maxAsciiCharacter",u[u.lineFeed=10]="lineFeed",u[u.carriageReturn=13]="carriageReturn",u[u.lineSeparator=8232]="lineSeparator",u[u.paragraphSeparator=8233]="paragraphSeparator",u[u.nextLine=133]="nextLine",u[u.space=32]="space",u[u.nonBreakingSpace=160]="nonBreakingSpace",u[u.enQuad=8192]="enQuad",u[u.emQuad=8193]="emQuad",u[u.enSpace=8194]="enSpace",u[u.emSpace=8195]="emSpace",u[u.threePerEmSpace=8196]="threePerEmSpace",u[u.fourPerEmSpace=8197]="fourPerEmSpace",u[u.sixPerEmSpace=8198]="sixPerEmSpace",u[u.figureSpace=8199]="figureSpace",u[u.punctuationSpace=8200]="punctuationSpace",u[u.thinSpace=8201]="thinSpace",u[u.hairSpace=8202]="hairSpace",u[u.zeroWidthSpace=8203]="zeroWidthSpace",u[u.narrowNoBreakSpace=8239]="narrowNoBreakSpace",u[u.ideographicSpace=12288]="ideographicSpace",u[u.mathematicalSpace=8287]="mathematicalSpace",u[u.ogham=5760]="ogham",u[u._=95]="_",u[u.$=36]="$",u[u._0=48]="_0",u[u._1=49]="_1",u[u._2=50]="_2",u[u._3=51]="_3",u[u._4=52]="_4",u[u._5=53]="_5",u[u._6=54]="_6",u[u._7=55]="_7",u[u._8=56]="_8",u[u._9=57]="_9",u[u.a=97]="a",u[u.b=98]="b",u[u.c=99]="c",u[u.d=100]="d",u[u.e=101]="e",u[u.f=102]="f",u[u.g=103]="g",u[u.h=104]="h",u[u.i=105]="i",u[u.j=106]="j",u[u.k=107]="k",u[u.l=108]="l",u[u.m=109]="m",u[u.n=110]="n",u[u.o=111]="o",u[u.p=112]="p",u[u.q=113]="q",u[u.r=114]="r",u[u.s=115]="s",u[u.t=116]="t",u[u.u=117]="u",u[u.v=118]="v",u[u.w=119]="w",u[u.x=120]="x",u[u.y=121]="y",u[u.z=122]="z",u[u.A=65]="A",u[u.B=66]="B",u[u.C=67]="C",u[u.D=68]="D",u[u.E=69]="E",u[u.F=70]="F",u[u.G=71]="G",u[u.H=72]="H",u[u.I=73]="I",u[u.J=74]="J",u[u.K=75]="K",u[u.L=76]="L",u[u.M=77]="M",u[u.N=78]="N",u[u.O=79]="O",u[u.P=80]="P",u[u.Q=81]="Q",u[u.R=82]="R",u[u.S=83]="S",u[u.T=84]="T",u[u.U=85]="U",u[u.V=86]="V",u[u.W=87]="W",u[u.X=88]="X",u[u.Y=89]="Y",u[u.Z=90]="Z",u[u.ampersand=38]="ampersand",u[u.asterisk=42]="asterisk",u[u.at=64]="at",u[u.backslash=92]="backslash",u[u.bar=124]="bar",u[u.caret=94]="caret",u[u.closeBrace=125]="closeBrace",u[u.closeBracket=93]="closeBracket",u[u.closeParen=41]="closeParen",u[u.colon=58]="colon",u[u.comma=44]="comma",u[u.dot=46]="dot",u[u.doubleQuote=34]="doubleQuote",u[u.equals=61]="equals",u[u.exclamation=33]="exclamation",u[u.greaterThan=62]="greaterThan",u[u.lessThan=60]="lessThan",u[u.minus=45]="minus",u[u.openBrace=123]="openBrace",u[u.openBracket=91]="openBracket",u[u.openParen=40]="openParen",u[u.percent=37]="percent",u[u.plus=43]="plus",u[u.question=63]="question",u[u.semicolon=59]="semicolon",u[u.singleQuote=39]="singleQuote",u[u.slash=47]="slash",u[u.tilde=126]="tilde",u[u.backspace=8]="backspace",u[u.formFeed=12]="formFeed",u[u.byteOrderMark=65279]="byteOrderMark",u[u.tab=9]="tab",u[u.verticalTab=11]="verticalTab"})(A||(A={}));function _(u,M){const r=[],i=new Object;let p;const m={value:{},offset:0,length:0,type:"object",parent:void 0};let o=!1;function b(a,E,P,k){m.value=a,m.offset=E,m.length=P,m.type=k,m.colonOffset=void 0,p=m}try{f(u,{onObjectBegin:(a,E)=>{if(M<=a)throw i;p=void 0,o=M>a,r.push("")},onObjectProperty:(a,E,P)=>{if(M<E||(b(a,E,P,"property"),r[r.length-1]=a,M<=E+P))throw i},onObjectEnd:(a,E)=>{if(M<=a)throw i;p=void 0,r.pop()},onArrayBegin:(a,E)=>{if(M<=a)throw i;p=void 0,r.push(0)},onArrayEnd:(a,E)=>{if(M<=a)throw i;p=void 0,r.pop()},onLiteralValue:(a,E,P)=>{if(M<E||(b(a,E,P,T(a)),M<=E+P))throw i},onSeparator:(a,E,P)=>{if(M<=E)throw i;if(a===":"&&p&&p.type==="property")p.colonOffset=E,o=!1,p=void 0;else if(a===","){const k=r[r.length-1];typeof k=="number"?r[r.length-1]=k+1:(o=!0,r[r.length-1]=""),p=void 0}}})}catch(a){if(a!==i)throw a}return{path:r,previousNode:p,isAtPropertyKey:o,matches:a=>{let E=0;for(let P=0;E<a.length&&P<r.length;P++)if(a[E]===r[P]||a[E]==="*")E++;else if(a[E]!=="**")return!1;return E===a.length}}}e.getLocation=_;function n(u,M=[],r=I.DEFAULT){let i=null,p=[];const m=[];function o(a){Array.isArray(p)?p.push(a):i!==null&&(p[i]=a)}return f(u,{onObjectBegin:()=>{const a={};o(a),m.push(p),p=a,i=null},onObjectProperty:a=>{i=a},onObjectEnd:()=>{p=m.pop()},onArrayBegin:()=>{const a=[];o(a),m.push(p),p=a,i=null},onArrayEnd:()=>{p=m.pop()},onLiteralValue:o,onError:(a,E,P)=>{M.push({error:a,offset:E,length:P})}},r),p[0]}e.parse=n;function h(u,M=[],r=I.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function p(a){i.type==="property"&&(i.length=a-i.offset,i=i.parent)}function m(a){return i.children.push(a),a}f(u,{onObjectBegin:a=>{i=m({type:"object",offset:a,length:-1,parent:i,children:[]})},onObjectProperty:(a,E,P)=>{i=m({type:"property",offset:E,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:a,offset:E,length:P,parent:i})},onObjectEnd:(a,E)=>{i.length=a+E-i.offset,i=i.parent,p(a+E)},onArrayBegin:(a,E)=>{i=m({type:"array",offset:a,length:-1,parent:i,children:[]})},onArrayEnd:(a,E)=>{i.length=a+E-i.offset,i=i.parent,p(a+E)},onLiteralValue:(a,E,P)=>{m({type:T(a),offset:E,length:P,parent:i,value:a}),p(E+P)},onSeparator:(a,E,P)=>{i.type==="property"&&(a===":"?i.colonOffset=E:a===","&&p(E))},onError:(a,E,P)=>{M.push({error:a,offset:E,length:P})}},r);const b=i.children[0];return b&&delete b.parent,b}e.parseTree=h;function s(u,M){if(!u)return;let r=u;for(let i of M)if(typeof i=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let p=!1;for(const m of r.children)if(Array.isArray(m.children)&&m.children[0].value===i){r=m.children[1],p=!0;break}if(!p)return}else{const p=i;if(r.type!=="array"||p<0||!Array.isArray(r.children)||p>=r.children.length)return;r=r.children[p]}return r}e.findNodeAtLocation=s;function l(u){if(!u.parent||!u.parent.children)return[];const M=l(u.parent);if(u.parent.type==="property"){const r=u.parent.children[0].value;M.push(r)}else if(u.parent.type==="array"){const r=u.parent.children.indexOf(u);r!==-1&&M.push(r)}return M}e.getNodePath=l;function d(u){switch(u.type){case"array":return u.children.map(d);case"object":const M=Object.create(null);for(let r of u.children){const i=r.children[1];i&&(M[r.children[0].value]=d(i))}return M;case"null":case"string":case"number":case"boolean":return u.value;default:return}}e.getNodeValue=d;function D(u,M,r=!1){return M>=u.offset&&M<u.offset+u.length||r&&M===u.offset+u.length}e.contains=D;function v(u,M,r=!1){if(D(u,M,r)){const i=u.children;if(Array.isArray(i))for(let p=0;p<i.length&&i[p].offset<=M;p++){const m=v(i[p],M,r);if(m)return m}return u}}e.findNodeAtOffset=v;function f(u,M,r=I.DEFAULT){const i=t(u,!1);function p(ie){return ie?()=>ie(i.getTokenOffset(),i.getTokenLength()):()=>!0}function m(ie){return ie?we=>ie(we,i.getTokenOffset(),i.getTokenLength()):()=>!0}const o=p(M.onObjectBegin),b=m(M.onObjectProperty),a=p(M.onObjectEnd),E=p(M.onArrayBegin),P=p(M.onArrayEnd),k=m(M.onLiteralValue),B=m(M.onSeparator),L=p(M.onComment),y=m(M.onError),x=r&&r.disallowComments,N=r&&r.allowTrailingComma;function z(){for(;;){const ie=i.scan();switch(i.getTokenError()){case 4:H(14);break;case 5:H(15);break;case 3:H(13);break;case 1:x||H(11);break;case 2:H(12);break;case 6:H(16);break}switch(ie){case 12:case 13:x?H(10):L();break;case 16:H(1);break;case 15:case 14:break;default:return ie}}}function H(ie,we=[],Me=[]){if(y(ie),we.length+Me.length>0){let Fe=i.getToken();for(;Fe!==17;){if(we.indexOf(Fe)!==-1){z();break}else if(Me.indexOf(Fe)!==-1)break;Fe=z()}}}function q(ie){const we=i.getTokenValue();return ie?k(we):b(we),z(),!0}function ue(){switch(i.getToken()){case 11:let ie=0;try{ie=JSON.parse(i.getTokenValue()),typeof ie!="number"&&(H(2),ie=0)}catch(we){H(2)}k(ie);break;case 7:k(null);break;case 8:k(!0);break;case 9:k(!1);break;default:return!1}return z(),!0}function K(){return i.getToken()!==10?(H(3,[],[2,5]),!1):(q(!1),i.getToken()===6?(B(":"),z(),Q()||H(4,[],[2,5])):H(5,[],[2,5]),!0)}function ce(){o(),z();let ie=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(ie||H(4,[],[]),B(","),z(),i.getToken()===2&&N)break}else ie&&H(6,[],[]);K()||H(4,[],[2,5]),ie=!0}return a(),i.getToken()!==2?H(7,[2],[]):z(),!0}function de(){E(),z();let ie=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(ie||H(4,[],[]),B(","),z(),i.getToken()===4&&N)break}else ie&&H(6,[],[]);Q()||H(4,[],[4,5]),ie=!0}return P(),i.getToken()!==4?H(8,[4],[]):z(),!0}function Q(){switch(i.getToken()){case 3:return de();case 1:return ce();case 10:return q(!0);default:return ue()}}return z(),i.getToken()===17?r.allowEmptyContent?!0:(H(4,[],[]),!1):Q()?(i.getToken()!==17&&H(9,[],[]),!0):(H(4,[],[]),!1)}e.visit=f;function g(u,M){let r=t(u),i=[],p,m=0,o;do switch(o=r.getPosition(),p=r.scan(),p){case 12:case 13:case 17:m!==o&&i.push(u.substring(m,o)),M!==void 0&&i.push(r.getTokenValue().replace(/[^\r\n]/g,M)),m=r.getPosition();break}while(p!==17);return i.join("")}e.stripComments=g;function T(u){switch(typeof u){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(u){if(Array.isArray(u))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=T}),define(Ee[101],_e([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class c{constructor(w){this.executor=w,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(w){this._error=w}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(w){return new c(()=>w(this.getValue()))}}e.Lazy=c}),function(oe,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(oe=typeof globalThis!="undefined"?globalThis:oe||self,oe.marked=e())}(this,function(){"use strict";function oe(Pe,Se){for(var ve=0;ve<Se.length;ve++){var re=Se[ve];re.enumerable=re.enumerable||!1,re.configurable=!0,"value"in re&&(re.writable=!0),Object.defineProperty(Pe,re.key,re)}}function e(Pe,Se,ve){return Se&&oe(Pe.prototype,Se),ve&&oe(Pe,ve),Pe}function c(Pe,Se){if(!!Pe){if(typeof Pe=="string")return F(Pe,Se);var ve=Object.prototype.toString.call(Pe).slice(8,-1);if(ve==="Object"&&Pe.constructor&&(ve=Pe.constructor.name),ve==="Map"||ve==="Set")return Array.from(Pe);if(ve==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(ve))return F(Pe,Se)}}function F(Pe,Se){(Se==null||Se>Pe.length)&&(Se=Pe.length);for(var ve=0,re=new Array(Se);ve<Se;ve++)re[ve]=Pe[ve];return re}function w(Pe,Se){var ve=typeof Symbol!="undefined"&&Pe[Symbol.iterator]||Pe["@@iterator"];if(ve)return(ve=ve.call(Pe)).next.bind(ve);if(Array.isArray(Pe)||(ve=c(Pe))||Se&&Pe&&typeof Pe.length=="number"){ve&&(Pe=ve);var re=0;return function(){return re>=Pe.length?{done:!0}:{done:!1,value:Pe[re++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}var I={exports:{}};function t(){return{baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function R(Pe){I.exports.defaults=Pe}I.exports={defaults:t(),getDefaults:t,changeDefaults:R};var S=/[&<>"']/,C=/[&<>"']/g,A=/[<>"']|&(?!#?\w+;)/,_=/[<>"']|&(?!#?\w+;)/g,n={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},h=function(Se){return n[Se]};function s(Pe,Se){if(Se){if(S.test(Pe))return Pe.replace(C,h)}else if(A.test(Pe))return Pe.replace(_,h);return Pe}var l=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function d(Pe){return Pe.replace(l,function(Se,ve){return ve=ve.toLowerCase(),ve==="colon"?":":ve.charAt(0)==="#"?ve.charAt(1)==="x"?String.fromCharCode(parseInt(ve.substring(2),16)):String.fromCharCode(+ve.substring(1)):""})}var D=/(^|[^\[])\^/g;function v(Pe,Se){Pe=Pe.source||Pe,Se=Se||"";var ve={replace:function(ae,he){return he=he.source||he,he=he.replace(D,"$1"),Pe=Pe.replace(ae,he),ve},getRegex:function(){return new RegExp(Pe,Se)}};return ve}var f=/[^\w:]/g,g=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function T(Pe,Se,ve){if(Pe){var re;try{re=decodeURIComponent(d(ve)).replace(f,"").toLowerCase()}catch(ae){return null}if(re.indexOf("javascript:")===0||re.indexOf("vbscript:")===0||re.indexOf("data:")===0)return null}Se&&!g.test(ve)&&(ve=p(Se,ve));try{ve=encodeURI(ve).replace(/%25/g,"%")}catch(ae){return null}return ve}var u={},M=/^[^:]+:\/*[^/]*$/,r=/^([^:]+:)[\s\S]*$/,i=/^([^:]+:\/*[^/]*)[\s\S]*$/;function p(Pe,Se){u[" "+Pe]||(M.test(Pe)?u[" "+Pe]=Pe+"/":u[" "+Pe]=a(Pe,"/",!0)),Pe=u[" "+Pe];var ve=Pe.indexOf(":")===-1;return Se.substring(0,2)==="//"?ve?Se:Pe.replace(r,"$1")+Se:Se.charAt(0)==="/"?ve?Se:Pe.replace(i,"$1")+Se:Pe+Se}var m={exec:function(){}};function o(Pe){for(var Se=1,ve,re;Se<arguments.length;Se++){ve=arguments[Se];for(re in ve)Object.prototype.hasOwnProperty.call(ve,re)&&(Pe[re]=ve[re])}return Pe}function b(Pe,Se){var ve=Pe.replace(/\|/g,function(he,me,Ie){for(var ze=!1,Oe=me;--Oe>=0&&Ie[Oe]==="\\";)ze=!ze;return ze?"|":" |"}),re=ve.split(/ \|/),ae=0;if(re[0].trim()||re.shift(),re[re.length-1].trim()||re.pop(),re.length>Se)re.splice(Se);else for(;re.length<Se;)re.push("");for(;ae<re.length;ae++)re[ae]=re[ae].trim().replace(/\\\|/g,"|");return re}function a(Pe,Se,ve){var re=Pe.length;if(re===0)return"";for(var ae=0;ae<re;){var he=Pe.charAt(re-ae-1);if(he===Se&&!ve)ae++;else if(he!==Se&&ve)ae++;else break}return Pe.substr(0,re-ae)}function E(Pe,Se){if(Pe.indexOf(Se[1])===-1)return-1;for(var ve=Pe.length,re=0,ae=0;ae<ve;ae++)if(Pe[ae]==="\\")ae++;else if(Pe[ae]===Se[0])re++;else if(Pe[ae]===Se[1]&&(re--,re<0))return ae;return-1}function P(Pe){Pe&&Pe.sanitize&&!Pe.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function k(Pe,Se){if(Se<1)return"";for(var ve="";Se>1;)Se&1&&(ve+=Pe),Se>>=1,Pe+=Pe;return ve+Pe}var B={escape:s,unescape:d,edit:v,cleanUrl:T,resolveUrl:p,noopTest:m,merge:o,splitCells:b,rtrim:a,findClosingBracket:E,checkSanitizeDeprecation:P,repeatString:k},L=I.exports.defaults,y=B.rtrim,x=B.splitCells,N=B.escape,z=B.findClosingBracket;function H(Pe,Se,ve,re){var ae=Se.href,he=Se.title?N(Se.title):null,me=Pe[1].replace(/\\([\[\]])/g,"$1");if(Pe[0].charAt(0)!=="!"){re.state.inLink=!0;var Ie={type:"link",raw:ve,href:ae,title:he,text:me,tokens:re.inlineTokens(me,[])};return re.state.inLink=!1,Ie}else return{type:"image",raw:ve,href:ae,title:he,text:N(me)}}function q(Pe,Se){var ve=Pe.match(/^(\s+)(?:```)/);if(ve===null)return Se;var re=ve[1];return Se.split(`
`).map(function(ae){var he=ae.match(/^\s+/);if(he===null)return ae;var me=he[0];return me.length>=re.length?ae.slice(re.length):ae}).join(`
`)}var ue=function(){function Pe(ve){this.options=ve||L}var Se=Pe.prototype;return Se.space=function(re){var ae=this.rules.block.newline.exec(re);if(ae)return ae[0].length>1?{type:"space",raw:ae[0]}:{raw:`
`}},Se.code=function(re){var ae=this.rules.block.code.exec(re);if(ae){var he=ae[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ae[0],codeBlockStyle:"indented",text:this.options.pedantic?he:y(he,`
`)}}},Se.fences=function(re){var ae=this.rules.block.fences.exec(re);if(ae){var he=ae[0],me=q(he,ae[3]||"");return{type:"code",raw:he,lang:ae[2]?ae[2].trim():ae[2],text:me}}},Se.heading=function(re){var ae=this.rules.block.heading.exec(re);if(ae){var he=ae[2].trim();if(/#$/.test(he)){var me=y(he,"#");(this.options.pedantic||!me||/ $/.test(me))&&(he=me.trim())}var Ie={type:"heading",raw:ae[0],depth:ae[1].length,text:he,tokens:[]};return this.lexer.inline(Ie.text,Ie.tokens),Ie}},Se.hr=function(re){var ae=this.rules.block.hr.exec(re);if(ae)return{type:"hr",raw:ae[0]}},Se.blockquote=function(re){var ae=this.rules.block.blockquote.exec(re);if(ae){var he=ae[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:ae[0],tokens:this.lexer.blockTokens(he,[]),text:he}}},Se.list=function(re){var ae=this.rules.block.list.exec(re);if(ae){var he,me,Ie,ze,Oe,We,it,ot,ne,ge,te=ae[1].trim(),W=te.length>1,be={type:"list",raw:"",ordered:W,start:W?+te.slice(0,-1):"",loose:!1,items:[]};te=W?"\\d{1,9}\\"+te.slice(-1):"\\"+te,this.options.pedantic&&(te=W?te:"[*+-]");for(var ke=new RegExp("^( {0,3}"+te+")((?: [^\\n]*| *)(?:\\n[^\\n]*)*(?:\\n|$))");re&&!(this.rules.block.hr.test(re)||!(ae=ke.exec(re)));){ne=ae[2].split(`
`),this.options.pedantic?(ze=2,ge=ne[0].trimLeft()):(ze=ae[2].search(/[^ ]/),ze=ae[1].length+(ze>4?1:ze),ge=ne[0].slice(ze-ae[1].length)),We=!1,he=ae[0],!ne[0]&&/^ *$/.test(ne[1])&&(he=ae[1]+ne.slice(0,2).join(`
`)+`
`,be.loose=!0,ne=[]);var qe=new RegExp("^ {0,"+Math.min(3,ze-1)+"}(?:[*+-]|\\d{1,9}[.)])");for(Oe=1;Oe<ne.length;Oe++){if(ot=ne[Oe],this.options.pedantic&&(ot=ot.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),qe.test(ot)){he=ae[1]+ne.slice(0,Oe).join(`
`)+`
`;break}if(!We){ot.trim()||(We=!0),ot.search(/[^ ]/)>=ze?ge+=`
`+ot.slice(ze):ge+=`
`+ot;continue}if(ot.search(/[^ ]/)>=ze||!ot.trim()){ge+=`
`+ot.slice(ze);continue}else{he=ae[1]+ne.slice(0,Oe).join(`
`)+`
`;break}}be.loose||(it?be.loose=!0:/\n *\n *$/.test(he)&&(it=!0)),this.options.gfm&&(me=/^\[[ xX]\] /.exec(ge),me&&(Ie=me[0]!=="[ ] ",ge=ge.replace(/^\[[ xX]\] +/,""))),be.items.push({type:"list_item",raw:he,task:!!me,checked:Ie,loose:!1,text:ge}),be.raw+=he,re=re.slice(he.length)}be.items[be.items.length-1].raw=he.trimRight(),be.items[be.items.length-1].text=ge.trimRight(),be.raw=be.raw.trimRight();var Le=be.items.length;for(Oe=0;Oe<Le;Oe++)this.lexer.state.top=!1,be.items[Oe].tokens=this.lexer.blockTokens(be.items[Oe].text,[]),be.items[Oe].tokens.some(function(dt){return dt.type==="space"})&&(be.loose=!0,be.items[Oe].loose=!0);return be}},Se.html=function(re){var ae=this.rules.block.html.exec(re);if(ae){var he={type:"html",raw:ae[0],pre:!this.options.sanitizer&&(ae[1]==="pre"||ae[1]==="script"||ae[1]==="style"),text:ae[0]};return this.options.sanitize&&(he.type="paragraph",he.text=this.options.sanitizer?this.options.sanitizer(ae[0]):N(ae[0]),he.tokens=[],this.lexer.inline(he.text,he.tokens)),he}},Se.def=function(re){var ae=this.rules.block.def.exec(re);if(ae){ae[3]&&(ae[3]=ae[3].substring(1,ae[3].length-1));var he=ae[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:he,raw:ae[0],href:ae[2],title:ae[3]}}},Se.table=function(re){var ae=this.rules.block.table.exec(re);if(ae){var he={type:"table",header:x(ae[1]).map(function(it){return{text:it}}),align:ae[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:ae[3]?ae[3].replace(/\n$/,"").split(`
`):[]};if(he.header.length===he.align.length){he.raw=ae[0];var me=he.align.length,Ie,ze,Oe,We;for(Ie=0;Ie<me;Ie++)/^ *-+: *$/.test(he.align[Ie])?he.align[Ie]="right":/^ *:-+: *$/.test(he.align[Ie])?he.align[Ie]="center":/^ *:-+ *$/.test(he.align[Ie])?he.align[Ie]="left":he.align[Ie]=null;for(me=he.rows.length,Ie=0;Ie<me;Ie++)he.rows[Ie]=x(he.rows[Ie],he.header.length).map(function(it){return{text:it}});for(me=he.header.length,ze=0;ze<me;ze++)he.header[ze].tokens=[],this.lexer.inlineTokens(he.header[ze].text,he.header[ze].tokens);for(me=he.rows.length,ze=0;ze<me;ze++)for(We=he.rows[ze],Oe=0;Oe<We.length;Oe++)We[Oe].tokens=[],this.lexer.inlineTokens(We[Oe].text,We[Oe].tokens);return he}}},Se.lheading=function(re){var ae=this.rules.block.lheading.exec(re);if(ae){var he={type:"heading",raw:ae[0],depth:ae[2].charAt(0)==="="?1:2,text:ae[1],tokens:[]};return this.lexer.inline(he.text,he.tokens),he}},Se.paragraph=function(re){var ae=this.rules.block.paragraph.exec(re);if(ae){var he={type:"paragraph",raw:ae[0],text:ae[1].charAt(ae[1].length-1)===`
`?ae[1].slice(0,-1):ae[1],tokens:[]};return this.lexer.inline(he.text,he.tokens),he}},Se.text=function(re){var ae=this.rules.block.text.exec(re);if(ae){var he={type:"text",raw:ae[0],text:ae[0],tokens:[]};return this.lexer.inline(he.text,he.tokens),he}},Se.escape=function(re){var ae=this.rules.inline.escape.exec(re);if(ae)return{type:"escape",raw:ae[0],text:N(ae[1])}},Se.tag=function(re){var ae=this.rules.inline.tag.exec(re);if(ae)return!this.lexer.state.inLink&&/^<a /i.test(ae[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(ae[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(ae[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ae[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:ae[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ae[0]):N(ae[0]):ae[0]}},Se.link=function(re){var ae=this.rules.inline.link.exec(re);if(ae){var he=ae[2].trim();if(!this.options.pedantic&&/^</.test(he)){if(!/>$/.test(he))return;var me=y(he.slice(0,-1),"\\");if((he.length-me.length)%2==0)return}else{var Ie=z(ae[2],"()");if(Ie>-1){var ze=ae[0].indexOf("!")===0?5:4,Oe=ze+ae[1].length+Ie;ae[2]=ae[2].substring(0,Ie),ae[0]=ae[0].substring(0,Oe).trim(),ae[3]=""}}var We=ae[2],it="";if(this.options.pedantic){var ot=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(We);ot&&(We=ot[1],it=ot[3])}else it=ae[3]?ae[3].slice(1,-1):"";return We=We.trim(),/^</.test(We)&&(this.options.pedantic&&!/>$/.test(he)?We=We.slice(1):We=We.slice(1,-1)),H(ae,{href:We&&We.replace(this.rules.inline._escapes,"$1"),title:it&&it.replace(this.rules.inline._escapes,"$1")},ae[0],this.lexer)}},Se.reflink=function(re,ae){var he;if((he=this.rules.inline.reflink.exec(re))||(he=this.rules.inline.nolink.exec(re))){var me=(he[2]||he[1]).replace(/\s+/g," ");if(me=ae[me.toLowerCase()],!me||!me.href){var Ie=he[0].charAt(0);return{type:"text",raw:Ie,text:Ie}}return H(he,me,he[0],this.lexer)}},Se.emStrong=function(re,ae,he){he===void 0&&(he="");var me=this.rules.inline.emStrong.lDelim.exec(re);if(!!me&&!(me[3]&&he.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Ie=me[1]||me[2]||"";if(!Ie||Ie&&(he===""||this.rules.inline.punctuation.exec(he))){var ze=me[0].length-1,Oe,We,it=ze,ot=0,ne=me[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(ne.lastIndex=0,ae=ae.slice(-1*re.length+ze);(me=ne.exec(ae))!=null;)if(Oe=me[1]||me[2]||me[3]||me[4]||me[5]||me[6],!!Oe){if(We=Oe.length,me[3]||me[4]){it+=We;continue}else if((me[5]||me[6])&&ze%3&&!((ze+We)%3)){ot+=We;continue}if(it-=We,!(it>0)){if(We=Math.min(We,We+it+ot),Math.min(ze,We)%2){var ge=re.slice(1,ze+me.index+We);return{type:"em",raw:re.slice(0,ze+me.index+We+1),text:ge,tokens:this.lexer.inlineTokens(ge,[])}}var te=re.slice(2,ze+me.index+We-1);return{type:"strong",raw:re.slice(0,ze+me.index+We+1),text:te,tokens:this.lexer.inlineTokens(te,[])}}}}}},Se.codespan=function(re){var ae=this.rules.inline.code.exec(re);if(ae){var he=ae[2].replace(/\n/g," "),me=/[^ ]/.test(he),Ie=/^ /.test(he)&&/ $/.test(he);return me&&Ie&&(he=he.substring(1,he.length-1)),he=N(he,!0),{type:"codespan",raw:ae[0],text:he}}},Se.br=function(re){var ae=this.rules.inline.br.exec(re);if(ae)return{type:"br",raw:ae[0]}},Se.del=function(re){var ae=this.rules.inline.del.exec(re);if(ae)return{type:"del",raw:ae[0],text:ae[2],tokens:this.lexer.inlineTokens(ae[2],[])}},Se.autolink=function(re,ae){var he=this.rules.inline.autolink.exec(re);if(he){var me,Ie;return he[2]==="@"?(me=N(this.options.mangle?ae(he[1]):he[1]),Ie="mailto:"+me):(me=N(he[1]),Ie=me),{type:"link",raw:he[0],text:me,href:Ie,tokens:[{type:"text",raw:me,text:me}]}}},Se.url=function(re,ae){var he;if(he=this.rules.inline.url.exec(re)){var me,Ie;if(he[2]==="@")me=N(this.options.mangle?ae(he[0]):he[0]),Ie="mailto:"+me;else{var ze;do ze=he[0],he[0]=this.rules.inline._backpedal.exec(he[0])[0];while(ze!==he[0]);me=N(he[0]),he[1]==="www."?Ie="http://"+me:Ie=me}return{type:"link",raw:he[0],text:me,href:Ie,tokens:[{type:"text",raw:me,text:me}]}}},Se.inlineText=function(re,ae){var he=this.rules.inline.text.exec(re);if(he){var me;return this.lexer.state.inRawBlock?me=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(he[0]):N(he[0]):he[0]:me=N(this.options.smartypants?ae(he[0]):he[0]),{type:"text",raw:he[0],text:me}}},Pe}(),K=B.noopTest,ce=B.edit,de=B.merge,Q={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)( [^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,table:K,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};Q._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,Q._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,Q.def=ce(Q.def).replace("label",Q._label).replace("title",Q._title).getRegex(),Q.bullet=/(?:[*+-]|\d{1,9}[.)])/,Q.listItemStart=ce(/^( *)(bull) */).replace("bull",Q.bullet).getRegex(),Q.list=ce(Q.list).replace(/bull/g,Q.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+Q.def.source+")").getRegex(),Q._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",Q._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,Q.html=ce(Q.html,"i").replace("comment",Q._comment).replace("tag",Q._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),Q.paragraph=ce(Q._paragraph).replace("hr",Q.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",Q._tag).getRegex(),Q.blockquote=ce(Q.blockquote).replace("paragraph",Q.paragraph).getRegex(),Q.normal=de({},Q),Q.gfm=de({},Q.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)\\|?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),Q.gfm.table=ce(Q.gfm.table).replace("hr",Q.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",Q._tag).getRegex(),Q.pedantic=de({},Q.normal,{html:ce(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",Q._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:K,paragraph:ce(Q.normal._paragraph).replace("hr",Q.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",Q.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var ie={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:K,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_*]*?\*[^_*]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^_*]*?\_[^_*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:K,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};ie._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",ie.punctuation=ce(ie.punctuation).replace(/punctuation/g,ie._punctuation).getRegex(),ie.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,ie.escapedEmSt=/\\\*|\\_/g,ie._comment=ce(Q._comment).replace("(?:-->|$)","-->").getRegex(),ie.emStrong.lDelim=ce(ie.emStrong.lDelim).replace(/punct/g,ie._punctuation).getRegex(),ie.emStrong.rDelimAst=ce(ie.emStrong.rDelimAst,"g").replace(/punct/g,ie._punctuation).getRegex(),ie.emStrong.rDelimUnd=ce(ie.emStrong.rDelimUnd,"g").replace(/punct/g,ie._punctuation).getRegex(),ie._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,ie._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,ie._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,ie.autolink=ce(ie.autolink).replace("scheme",ie._scheme).replace("email",ie._email).getRegex(),ie._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,ie.tag=ce(ie.tag).replace("comment",ie._comment).replace("attribute",ie._attribute).getRegex(),ie._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,ie._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,ie._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,ie.link=ce(ie.link).replace("label",ie._label).replace("href",ie._href).replace("title",ie._title).getRegex(),ie.reflink=ce(ie.reflink).replace("label",ie._label).getRegex(),ie.reflinkSearch=ce(ie.reflinkSearch,"g").replace("reflink",ie.reflink).replace("nolink",ie.nolink).getRegex(),ie.normal=de({},ie),ie.pedantic=de({},ie.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:ce(/^!?\[(label)\]\((.*?)\)/).replace("label",ie._label).getRegex(),reflink:ce(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",ie._label).getRegex()}),ie.gfm=de({},ie.normal,{escape:ce(ie.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),ie.gfm.url=ce(ie.gfm.url,"i").replace("email",ie.gfm._extended_email).getRegex(),ie.breaks=de({},ie.gfm,{br:ce(ie.br).replace("{2,}","*").getRegex(),text:ce(ie.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var we={block:Q,inline:ie},Me=ue,Fe=I.exports.defaults,Be=we.block,Ge=we.inline,je=B.repeatString;function Qe(Pe){return Pe.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function $(Pe){var Se="",ve,re,ae=Pe.length;for(ve=0;ve<ae;ve++)re=Pe.charCodeAt(ve),Math.random()>.5&&(re="x"+re.toString(16)),Se+="&#"+re+";";return Se}var G=function(){function Pe(ve){this.tokens=[],this.tokens.links=Object.create(null),this.options=ve||Fe,this.options.tokenizer=this.options.tokenizer||new Me,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var re={block:Be.normal,inline:Ge.normal};this.options.pedantic?(re.block=Be.pedantic,re.inline=Ge.pedantic):this.options.gfm&&(re.block=Be.gfm,this.options.breaks?re.inline=Ge.breaks:re.inline=Ge.gfm),this.tokenizer.rules=re}Pe.lex=function(re,ae){var he=new Pe(ae);return he.lex(re)},Pe.lexInline=function(re,ae){var he=new Pe(ae);return he.inlineTokens(re)};var Se=Pe.prototype;return Se.lex=function(re){re=re.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(re,this.tokens);for(var ae;ae=this.inlineQueue.shift();)this.inlineTokens(ae.src,ae.tokens);return this.tokens},Se.blockTokens=function(re,ae){var he=this;ae===void 0&&(ae=[]),this.options.pedantic&&(re=re.replace(/^ +$/gm,""));for(var me,Ie,ze,Oe;re;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(it){return(me=it.call({lexer:he},re,ae))?(re=re.substring(me.raw.length),ae.push(me),!0):!1}))){if(me=this.tokenizer.space(re)){re=re.substring(me.raw.length),me.type&&ae.push(me);continue}if(me=this.tokenizer.code(re)){re=re.substring(me.raw.length),Ie=ae[ae.length-1],Ie&&(Ie.type==="paragraph"||Ie.type==="text")?(Ie.raw+=`
`+me.raw,Ie.text+=`
`+me.text,this.inlineQueue[this.inlineQueue.length-1].src=Ie.text):ae.push(me);continue}if(me=this.tokenizer.fences(re)){re=re.substring(me.raw.length),ae.push(me);continue}if(me=this.tokenizer.heading(re)){re=re.substring(me.raw.length),ae.push(me);continue}if(me=this.tokenizer.hr(re)){re=re.substring(me.raw.length),ae.push(me);continue}if(me=this.tokenizer.blockquote(re)){re=re.substring(me.raw.length),ae.push(me);continue}if(me=this.tokenizer.list(re)){re=re.substring(me.raw.length),ae.push(me);continue}if(me=this.tokenizer.html(re)){re=re.substring(me.raw.length),ae.push(me);continue}if(me=this.tokenizer.def(re)){re=re.substring(me.raw.length),Ie=ae[ae.length-1],Ie&&(Ie.type==="paragraph"||Ie.type==="text")?(Ie.raw+=`
`+me.raw,Ie.text+=`
`+me.raw,this.inlineQueue[this.inlineQueue.length-1].src=Ie.text):this.tokens.links[me.tag]||(this.tokens.links[me.tag]={href:me.href,title:me.title});continue}if(me=this.tokenizer.table(re)){re=re.substring(me.raw.length),ae.push(me);continue}if(me=this.tokenizer.lheading(re)){re=re.substring(me.raw.length),ae.push(me);continue}if(ze=re,this.options.extensions&&this.options.extensions.startBlock&&function(){var it=Infinity,ot=re.slice(1),ne=void 0;he.options.extensions.startBlock.forEach(function(ge){ne=ge.call({lexer:this},ot),typeof ne=="number"&&ne>=0&&(it=Math.min(it,ne))}),it<Infinity&&it>=0&&(ze=re.substring(0,it+1))}(),this.state.top&&(me=this.tokenizer.paragraph(ze))){Ie=ae[ae.length-1],Oe&&Ie.type==="paragraph"?(Ie.raw+=`
`+me.raw,Ie.text+=`
`+me.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Ie.text):ae.push(me),Oe=ze.length!==re.length,re=re.substring(me.raw.length);continue}if(me=this.tokenizer.text(re)){re=re.substring(me.raw.length),Ie=ae[ae.length-1],Ie&&Ie.type==="text"?(Ie.raw+=`
`+me.raw,Ie.text+=`
`+me.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Ie.text):ae.push(me);continue}if(re){var We="Infinite loop on byte: "+re.charCodeAt(0);if(this.options.silent){console.error(We);break}else throw new Error(We)}}return this.state.top=!0,ae},Se.inline=function(re,ae){this.inlineQueue.push({src:re,tokens:ae})},Se.inlineTokens=function(re,ae){var he=this;ae===void 0&&(ae=[]);var me,Ie,ze,Oe=re,We,it,ot;if(this.tokens.links){var ne=Object.keys(this.tokens.links);if(ne.length>0)for(;(We=this.tokenizer.rules.inline.reflinkSearch.exec(Oe))!=null;)ne.includes(We[0].slice(We[0].lastIndexOf("[")+1,-1))&&(Oe=Oe.slice(0,We.index)+"["+je("a",We[0].length-2)+"]"+Oe.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(We=this.tokenizer.rules.inline.blockSkip.exec(Oe))!=null;)Oe=Oe.slice(0,We.index)+"["+je("a",We[0].length-2)+"]"+Oe.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(We=this.tokenizer.rules.inline.escapedEmSt.exec(Oe))!=null;)Oe=Oe.slice(0,We.index)+"++"+Oe.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;re;)if(it||(ot=""),it=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(te){return(me=te.call({lexer:he},re,ae))?(re=re.substring(me.raw.length),ae.push(me),!0):!1}))){if(me=this.tokenizer.escape(re)){re=re.substring(me.raw.length),ae.push(me);continue}if(me=this.tokenizer.tag(re)){re=re.substring(me.raw.length),Ie=ae[ae.length-1],Ie&&me.type==="text"&&Ie.type==="text"?(Ie.raw+=me.raw,Ie.text+=me.text):ae.push(me);continue}if(me=this.tokenizer.link(re)){re=re.substring(me.raw.length),ae.push(me);continue}if(me=this.tokenizer.reflink(re,this.tokens.links)){re=re.substring(me.raw.length),Ie=ae[ae.length-1],Ie&&me.type==="text"&&Ie.type==="text"?(Ie.raw+=me.raw,Ie.text+=me.text):ae.push(me);continue}if(me=this.tokenizer.emStrong(re,Oe,ot)){re=re.substring(me.raw.length),ae.push(me);continue}if(me=this.tokenizer.codespan(re)){re=re.substring(me.raw.length),ae.push(me);continue}if(me=this.tokenizer.br(re)){re=re.substring(me.raw.length),ae.push(me);continue}if(me=this.tokenizer.del(re)){re=re.substring(me.raw.length),ae.push(me);continue}if(me=this.tokenizer.autolink(re,$)){re=re.substring(me.raw.length),ae.push(me);continue}if(!this.state.inLink&&(me=this.tokenizer.url(re,$))){re=re.substring(me.raw.length),ae.push(me);continue}if(ze=re,this.options.extensions&&this.options.extensions.startInline&&function(){var te=Infinity,W=re.slice(1),be=void 0;he.options.extensions.startInline.forEach(function(ke){be=ke.call({lexer:this},W),typeof be=="number"&&be>=0&&(te=Math.min(te,be))}),te<Infinity&&te>=0&&(ze=re.substring(0,te+1))}(),me=this.tokenizer.inlineText(ze,Qe)){re=re.substring(me.raw.length),me.raw.slice(-1)!=="_"&&(ot=me.raw.slice(-1)),it=!0,Ie=ae[ae.length-1],Ie&&Ie.type==="text"?(Ie.raw+=me.raw,Ie.text+=me.text):ae.push(me);continue}if(re){var ge="Infinite loop on byte: "+re.charCodeAt(0);if(this.options.silent){console.error(ge);break}else throw new Error(ge)}}return ae},e(Pe,null,[{key:"rules",get:function(){return{block:Be,inline:Ge}}}]),Pe}(),X=I.exports.defaults,se=B.cleanUrl,j=B.escape,Z=function(){function Pe(ve){this.options=ve||X}var Se=Pe.prototype;return Se.code=function(re,ae,he){var me=(ae||"").match(/\S*/)[0];if(this.options.highlight){var Ie=this.options.highlight(re,me);Ie!=null&&Ie!==re&&(he=!0,re=Ie)}return re=re.replace(/\n$/,"")+`
`,me?'<pre><code class="'+this.options.langPrefix+j(me,!0)+'">'+(he?re:j(re,!0))+`</code></pre>
`:"<pre><code>"+(he?re:j(re,!0))+`</code></pre>
`},Se.blockquote=function(re){return`<blockquote>
`+re+`</blockquote>
`},Se.html=function(re){return re},Se.heading=function(re,ae,he,me){return this.options.headerIds?"<h"+ae+' id="'+this.options.headerPrefix+me.slug(he)+'">'+re+"</h"+ae+`>
`:"<h"+ae+">"+re+"</h"+ae+`>
`},Se.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},Se.list=function(re,ae,he){var me=ae?"ol":"ul",Ie=ae&&he!==1?' start="'+he+'"':"";return"<"+me+Ie+`>
`+re+"</"+me+`>
`},Se.listitem=function(re){return"<li>"+re+`</li>
`},Se.checkbox=function(re){return"<input "+(re?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},Se.paragraph=function(re){return"<p>"+re+`</p>
`},Se.table=function(re,ae){return ae&&(ae="<tbody>"+ae+"</tbody>"),`<table>
<thead>
`+re+`</thead>
`+ae+`</table>
`},Se.tablerow=function(re){return`<tr>
`+re+`</tr>
`},Se.tablecell=function(re,ae){var he=ae.header?"th":"td",me=ae.align?"<"+he+' align="'+ae.align+'">':"<"+he+">";return me+re+"</"+he+`>
`},Se.strong=function(re){return"<strong>"+re+"</strong>"},Se.em=function(re){return"<em>"+re+"</em>"},Se.codespan=function(re){return"<code>"+re+"</code>"},Se.br=function(){return this.options.xhtml?"<br/>":"<br>"},Se.del=function(re){return"<del>"+re+"</del>"},Se.link=function(re,ae,he){if(re=se(this.options.sanitize,this.options.baseUrl,re),re===null)return he;var me='<a href="'+j(re)+'"';return ae&&(me+=' title="'+ae+'"'),me+=">"+he+"</a>",me},Se.image=function(re,ae,he){if(re=se(this.options.sanitize,this.options.baseUrl,re),re===null)return he;var me='<img src="'+re+'" alt="'+he+'"';return ae&&(me+=' title="'+ae+'"'),me+=this.options.xhtml?"/>":">",me},Se.text=function(re){return re},Pe}(),fe=function(){function Pe(){}var Se=Pe.prototype;return Se.strong=function(re){return re},Se.em=function(re){return re},Se.codespan=function(re){return re},Se.del=function(re){return re},Se.html=function(re){return re},Se.text=function(re){return re},Se.link=function(re,ae,he){return""+he},Se.image=function(re,ae,he){return""+he},Se.br=function(){return""},Pe}(),Te=function(){function Pe(){this.seen={}}var Se=Pe.prototype;return Se.serialize=function(re){return re.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},Se.getNextSafeSlug=function(re,ae){var he=re,me=0;if(this.seen.hasOwnProperty(he)){me=this.seen[re];do me++,he=re+"-"+me;while(this.seen.hasOwnProperty(he))}return ae||(this.seen[re]=me,this.seen[he]=0),he},Se.slug=function(re,ae){ae===void 0&&(ae={});var he=this.serialize(re);return this.getNextSafeSlug(he,ae.dryrun)},Pe}(),Ne=Z,He=fe,Ke=Te,tt=I.exports.defaults,st=B.unescape,Xe=function(){function Pe(ve){this.options=ve||tt,this.options.renderer=this.options.renderer||new Ne,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new He,this.slugger=new Ke}Pe.parse=function(re,ae){var he=new Pe(ae);return he.parse(re)},Pe.parseInline=function(re,ae){var he=new Pe(ae);return he.parseInline(re)};var Se=Pe.prototype;return Se.parse=function(re,ae){ae===void 0&&(ae=!0);var he="",me,Ie,ze,Oe,We,it,ot,ne,ge,te,W,be,ke,qe,Le,dt,bt,Ct,pt,ht=re.length;for(me=0;me<ht;me++){if(te=re[me],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[te.type]&&(pt=this.options.extensions.renderers[te.type].call({parser:this},te),pt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(te.type))){he+=pt||"";continue}switch(te.type){case"space":continue;case"hr":{he+=this.renderer.hr();continue}case"heading":{he+=this.renderer.heading(this.parseInline(te.tokens),te.depth,st(this.parseInline(te.tokens,this.textRenderer)),this.slugger);continue}case"code":{he+=this.renderer.code(te.text,te.lang,te.escaped);continue}case"table":{for(ne="",ot="",Oe=te.header.length,Ie=0;Ie<Oe;Ie++)ot+=this.renderer.tablecell(this.parseInline(te.header[Ie].tokens),{header:!0,align:te.align[Ie]});for(ne+=this.renderer.tablerow(ot),ge="",Oe=te.rows.length,Ie=0;Ie<Oe;Ie++){for(it=te.rows[Ie],ot="",We=it.length,ze=0;ze<We;ze++)ot+=this.renderer.tablecell(this.parseInline(it[ze].tokens),{header:!1,align:te.align[ze]});ge+=this.renderer.tablerow(ot)}he+=this.renderer.table(ne,ge);continue}case"blockquote":{ge=this.parse(te.tokens),he+=this.renderer.blockquote(ge);continue}case"list":{for(W=te.ordered,be=te.start,ke=te.loose,Oe=te.items.length,ge="",Ie=0;Ie<Oe;Ie++)Le=te.items[Ie],dt=Le.checked,bt=Le.task,qe="",Le.task&&(Ct=this.renderer.checkbox(dt),ke?Le.tokens.length>0&&Le.tokens[0].type==="paragraph"?(Le.tokens[0].text=Ct+" "+Le.tokens[0].text,Le.tokens[0].tokens&&Le.tokens[0].tokens.length>0&&Le.tokens[0].tokens[0].type==="text"&&(Le.tokens[0].tokens[0].text=Ct+" "+Le.tokens[0].tokens[0].text)):Le.tokens.unshift({type:"text",text:Ct}):qe+=Ct),qe+=this.parse(Le.tokens,ke),ge+=this.renderer.listitem(qe,bt,dt);he+=this.renderer.list(ge,W,be);continue}case"html":{he+=this.renderer.html(te.text);continue}case"paragraph":{he+=this.renderer.paragraph(this.parseInline(te.tokens));continue}case"text":{for(ge=te.tokens?this.parseInline(te.tokens):te.text;me+1<ht&&re[me+1].type==="text";)te=re[++me],ge+=`
`+(te.tokens?this.parseInline(te.tokens):te.text);he+=ae?this.renderer.paragraph(ge):ge;continue}default:{var vt='Token with "'+te.type+'" type was not found.';if(this.options.silent){console.error(vt);return}else throw new Error(vt)}}}return he},Se.parseInline=function(re,ae){ae=ae||this.renderer;var he="",me,Ie,ze,Oe=re.length;for(me=0;me<Oe;me++){if(Ie=re[me],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Ie.type]&&(ze=this.options.extensions.renderers[Ie.type].call({parser:this},Ie),ze!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Ie.type))){he+=ze||"";continue}switch(Ie.type){case"escape":{he+=ae.text(Ie.text);break}case"html":{he+=ae.html(Ie.text);break}case"link":{he+=ae.link(Ie.href,Ie.title,this.parseInline(Ie.tokens,ae));break}case"image":{he+=ae.image(Ie.href,Ie.title,Ie.text);break}case"strong":{he+=ae.strong(this.parseInline(Ie.tokens,ae));break}case"em":{he+=ae.em(this.parseInline(Ie.tokens,ae));break}case"codespan":{he+=ae.codespan(Ie.text);break}case"br":{he+=ae.br();break}case"del":{he+=ae.del(this.parseInline(Ie.tokens,ae));break}case"text":{he+=ae.text(Ie.text);break}default:{var We='Token with "'+Ie.type+'" type was not found.';if(this.options.silent){console.error(We);return}else throw new Error(We)}}}return he},Pe}(),rt=G,De=Xe,gt=ue,V=Z,J=fe,pe=Te,Ue=B.merge,Ye=B.checkSanitizeDeprecation,Je=B.escape,lt=I.exports.getDefaults,Et=I.exports.changeDefaults,It=I.exports.defaults;function et(Pe,Se,ve){if(typeof Pe=="undefined"||Pe===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Pe!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Pe)+", string expected");if(typeof Se=="function"&&(ve=Se,Se=null),Se=Ue({},et.defaults,Se||{}),Ye(Se),ve){var re=Se.highlight,ae;try{ae=rt.lex(Pe,Se)}catch(ze){return ve(ze)}var he=function(Oe){var We;if(!Oe)try{Se.walkTokens&&et.walkTokens(ae,Se.walkTokens),We=De.parse(ae,Se)}catch(it){Oe=it}return Se.highlight=re,Oe?ve(Oe):ve(null,We)};if(!re||re.length<3||(delete Se.highlight,!ae.length))return he();var me=0;et.walkTokens(ae,function(ze){ze.type==="code"&&(me++,setTimeout(function(){re(ze.text,ze.lang,function(Oe,We){if(Oe)return he(Oe);We!=null&&We!==ze.text&&(ze.text=We,ze.escaped=!0),me--,me===0&&he()})},0))}),me===0&&he();return}try{var Ie=rt.lex(Pe,Se);return Se.walkTokens&&et.walkTokens(Ie,Se.walkTokens),De.parse(Ie,Se)}catch(ze){if(ze.message+=`
Please report this to https://github.com/markedjs/marked.`,Se.silent)return"<p>An error occurred:</p><pre>"+Je(ze.message+"",!0)+"</pre>";throw ze}}et.options=et.setOptions=function(Pe){return Ue(et.defaults,Pe),Et(et.defaults),et},et.getDefaults=lt,et.defaults=It,et.use=function(){for(var Pe=this,Se=arguments.length,ve=new Array(Se),re=0;re<Se;re++)ve[re]=arguments[re];var ae=Ue.apply(void 0,[{}].concat(ve)),he=et.defaults.extensions||{renderers:{},childTokens:{}},me;ve.forEach(function(Ie){if(Ie.extensions&&(me=!0,Ie.extensions.forEach(function(Oe){if(!Oe.name)throw new Error("extension name required");if(Oe.renderer){var We=he.renderers?he.renderers[Oe.name]:null;We?he.renderers[Oe.name]=function(){for(var it=arguments.length,ot=new Array(it),ne=0;ne<it;ne++)ot[ne]=arguments[ne];var ge=Oe.renderer.apply(this,ot);return ge===!1&&(ge=We.apply(this,ot)),ge}:he.renderers[Oe.name]=Oe.renderer}if(Oe.tokenizer){if(!Oe.level||Oe.level!=="block"&&Oe.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");he[Oe.level]?he[Oe.level].unshift(Oe.tokenizer):he[Oe.level]=[Oe.tokenizer],Oe.start&&(Oe.level==="block"?he.startBlock?he.startBlock.push(Oe.start):he.startBlock=[Oe.start]:Oe.level==="inline"&&(he.startInline?he.startInline.push(Oe.start):he.startInline=[Oe.start]))}Oe.childTokens&&(he.childTokens[Oe.name]=Oe.childTokens)})),Ie.renderer&&function(){var Oe=et.defaults.renderer||new V,We=function(ne){var ge=Oe[ne];Oe[ne]=function(){for(var te=arguments.length,W=new Array(te),be=0;be<te;be++)W[be]=arguments[be];var ke=Ie.renderer[ne].apply(Oe,W);return ke===!1&&(ke=ge.apply(Oe,W)),ke}};for(var it in Ie.renderer)We(it);ae.renderer=Oe}(),Ie.tokenizer&&function(){var Oe=et.defaults.tokenizer||new gt,We=function(ne){var ge=Oe[ne];Oe[ne]=function(){for(var te=arguments.length,W=new Array(te),be=0;be<te;be++)W[be]=arguments[be];var ke=Ie.tokenizer[ne].apply(Oe,W);return ke===!1&&(ke=ge.apply(Oe,W)),ke}};for(var it in Ie.tokenizer)We(it);ae.tokenizer=Oe}(),Ie.walkTokens){var ze=et.defaults.walkTokens;ae.walkTokens=function(Oe){Ie.walkTokens.call(Pe,Oe),ze&&ze(Oe)}}me&&(ae.extensions=he),et.setOptions(ae)})},et.walkTokens=function(Pe,Se){for(var ve=function(){var me=ae.value;switch(Se(me),me.type){case"table":{for(var Ie=w(me.header),ze;!(ze=Ie()).done;){var Oe=ze.value;et.walkTokens(Oe.tokens,Se)}for(var We=w(me.rows),it;!(it=We()).done;)for(var ot=it.value,ne=w(ot),ge;!(ge=ne()).done;){var te=ge.value;et.walkTokens(te.tokens,Se)}break}case"list":{et.walkTokens(me.items,Se);break}default:et.defaults.extensions&&et.defaults.extensions.childTokens&&et.defaults.extensions.childTokens[me.type]?et.defaults.extensions.childTokens[me.type].forEach(function(W){et.walkTokens(me[W],Se)}):me.tokens&&et.walkTokens(me.tokens,Se)}},re=w(Pe),ae;!(ae=re()).done;)ve()},et.parseInline=function(Pe,Se){if(typeof Pe=="undefined"||Pe===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Pe!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Pe)+", string expected");Se=Ue({},et.defaults,Se||{}),Ye(Se);try{var ve=rt.lexInline(Pe,Se);return Se.walkTokens&&et.walkTokens(ve,Se.walkTokens),De.parseInline(ve,Se)}catch(re){if(re.message+=`
Please report this to https://github.com/markedjs/marked.`,Se.silent)return"<p>An error occurred:</p><pre>"+Je(re.message+"",!0)+"</pre>";throw re}},et.Parser=De,et.parser=De.parse,et.Renderer=V,et.TextRenderer=J,et.Lexer=rt,et.lexer=rt.lex,et.Tokenizer=gt,et.Slugger=pe,et.parse=et;var Tt=et;return Tt}),define(Ee[75],_e([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function c(t,R,S){return Math.min(Math.max(t,R),S)}e.clamp=c;function F(t,R){return(R+t%R)%R}e.rot=F;class w{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=w;class I{constructor(){this._n=1,this._val=0}update(R){return this._val=this._val+(R-this._val)/this._n,this._n+=1,this}get value(){return this._val}}e.MovingAverage=I}),function(){function oe(w){const I=[];typeof w=="number"&&I.push("code/timeOrigin",w);function t(S){I.push(S,Date.now())}function R(){const S=[];for(let C=0;C<I.length;C+=2)S.push({name:I[C],startTime:I[C+1]});return S}return{mark:t,getMarks:R}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?oe():{mark(w){performance.mark(w)},getMarks(){let w=performance.timeOrigin;typeof w!="number"&&(w=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const I=[{name:"code/timeOrigin",startTime:Math.round(w)}];for(const t of performance.getEntriesByType("mark"))I.push({name:t.name,startTime:Math.round(w+t.startTime)});return I}};if(typeof process=="object"){const w=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return oe(w)}else return console.trace("perf-util loaded in UNKNOWN environment"),oe()}function c(w){return w.MonacoPerformanceMarks||(w.MonacoPerformanceMarks=e()),w.MonacoPerformanceMarks}var F;typeof global=="object"?F=global:typeof self=="object"?F=self:F={},typeof define=="function"?define("vs/base/common/performance",[],function(){return c(F)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=c(F):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),F.perf=c(F))}(),define(Ee[53],_e([0,1,3]),function(oe,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.iconRegistry=void 0;class F{constructor(){this._icons=new Map,this._onDidRegister=new c.Emitter}add(A){const _=this._icons.get(A.id);_?A.description?_.description=A.description:console.error(`Duplicate registration of codicon ${A.id}`):(this._icons.set(A.id,A),this._onDidRegister.fire(A))}get(A){return this._icons.get(A)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const w=new F;e.iconRegistry=w;function I(C){return C?C.replace(/\$\((.*?)\)/g,(A,_)=>` ${_} `).trim():""}e.getCodiconAriaLabel=I;class t{constructor(A,_,n){this.id=A,this.definition=_,this.description=n,w.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=t,t.add=new t("add",{fontCharacter:"\\ea60"}),t.plus=new t("plus",t.add.definition),t.gistNew=new t("gist-new",t.add.definition),t.repoCreate=new t("repo-create",t.add.definition),t.lightbulb=new t("lightbulb",{fontCharacter:"\\ea61"}),t.lightBulb=new t("light-bulb",{fontCharacter:"\\ea61"}),t.repo=new t("repo",{fontCharacter:"\\ea62"}),t.repoDelete=new t("repo-delete",{fontCharacter:"\\ea62"}),t.gistFork=new t("gist-fork",{fontCharacter:"\\ea63"}),t.repoForked=new t("repo-forked",{fontCharacter:"\\ea63"}),t.gitPullRequest=new t("git-pull-request",{fontCharacter:"\\ea64"}),t.gitPullRequestAbandoned=new t("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),t.recordKeys=new t("record-keys",{fontCharacter:"\\ea65"}),t.keyboard=new t("keyboard",{fontCharacter:"\\ea65"}),t.tag=new t("tag",{fontCharacter:"\\ea66"}),t.tagAdd=new t("tag-add",{fontCharacter:"\\ea66"}),t.tagRemove=new t("tag-remove",{fontCharacter:"\\ea66"}),t.person=new t("person",{fontCharacter:"\\ea67"}),t.personFollow=new t("person-follow",{fontCharacter:"\\ea67"}),t.personOutline=new t("person-outline",{fontCharacter:"\\ea67"}),t.personFilled=new t("person-filled",{fontCharacter:"\\ea67"}),t.gitBranch=new t("git-branch",{fontCharacter:"\\ea68"}),t.gitBranchCreate=new t("git-branch-create",{fontCharacter:"\\ea68"}),t.gitBranchDelete=new t("git-branch-delete",{fontCharacter:"\\ea68"}),t.sourceControl=new t("source-control",{fontCharacter:"\\ea68"}),t.mirror=new t("mirror",{fontCharacter:"\\ea69"}),t.mirrorPublic=new t("mirror-public",{fontCharacter:"\\ea69"}),t.star=new t("star",{fontCharacter:"\\ea6a"}),t.starAdd=new t("star-add",{fontCharacter:"\\ea6a"}),t.starDelete=new t("star-delete",{fontCharacter:"\\ea6a"}),t.starEmpty=new t("star-empty",{fontCharacter:"\\ea6a"}),t.comment=new t("comment",{fontCharacter:"\\ea6b"}),t.commentAdd=new t("comment-add",{fontCharacter:"\\ea6b"}),t.alert=new t("alert",{fontCharacter:"\\ea6c"}),t.warning=new t("warning",{fontCharacter:"\\ea6c"}),t.search=new t("search",{fontCharacter:"\\ea6d"}),t.searchSave=new t("search-save",{fontCharacter:"\\ea6d"}),t.logOut=new t("log-out",{fontCharacter:"\\ea6e"}),t.signOut=new t("sign-out",{fontCharacter:"\\ea6e"}),t.logIn=new t("log-in",{fontCharacter:"\\ea6f"}),t.signIn=new t("sign-in",{fontCharacter:"\\ea6f"}),t.eye=new t("eye",{fontCharacter:"\\ea70"}),t.eyeUnwatch=new t("eye-unwatch",{fontCharacter:"\\ea70"}),t.eyeWatch=new t("eye-watch",{fontCharacter:"\\ea70"}),t.circleFilled=new t("circle-filled",{fontCharacter:"\\ea71"}),t.primitiveDot=new t("primitive-dot",{fontCharacter:"\\ea71"}),t.closeDirty=new t("close-dirty",{fontCharacter:"\\ea71"}),t.debugBreakpoint=new t("debug-breakpoint",{fontCharacter:"\\ea71"}),t.debugBreakpointDisabled=new t("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),t.debugHint=new t("debug-hint",{fontCharacter:"\\ea71"}),t.primitiveSquare=new t("primitive-square",{fontCharacter:"\\ea72"}),t.edit=new t("edit",{fontCharacter:"\\ea73"}),t.pencil=new t("pencil",{fontCharacter:"\\ea73"}),t.info=new t("info",{fontCharacter:"\\ea74"}),t.issueOpened=new t("issue-opened",{fontCharacter:"\\ea74"}),t.gistPrivate=new t("gist-private",{fontCharacter:"\\ea75"}),t.gitForkPrivate=new t("git-fork-private",{fontCharacter:"\\ea75"}),t.lock=new t("lock",{fontCharacter:"\\ea75"}),t.mirrorPrivate=new t("mirror-private",{fontCharacter:"\\ea75"}),t.close=new t("close",{fontCharacter:"\\ea76"}),t.removeClose=new t("remove-close",{fontCharacter:"\\ea76"}),t.x=new t("x",{fontCharacter:"\\ea76"}),t.repoSync=new t("repo-sync",{fontCharacter:"\\ea77"}),t.sync=new t("sync",{fontCharacter:"\\ea77"}),t.clone=new t("clone",{fontCharacter:"\\ea78"}),t.desktopDownload=new t("desktop-download",{fontCharacter:"\\ea78"}),t.beaker=new t("beaker",{fontCharacter:"\\ea79"}),t.microscope=new t("microscope",{fontCharacter:"\\ea79"}),t.vm=new t("vm",{fontCharacter:"\\ea7a"}),t.deviceDesktop=new t("device-desktop",{fontCharacter:"\\ea7a"}),t.file=new t("file",{fontCharacter:"\\ea7b"}),t.fileText=new t("file-text",{fontCharacter:"\\ea7b"}),t.more=new t("more",{fontCharacter:"\\ea7c"}),t.ellipsis=new t("ellipsis",{fontCharacter:"\\ea7c"}),t.kebabHorizontal=new t("kebab-horizontal",{fontCharacter:"\\ea7c"}),t.mailReply=new t("mail-reply",{fontCharacter:"\\ea7d"}),t.reply=new t("reply",{fontCharacter:"\\ea7d"}),t.organization=new t("organization",{fontCharacter:"\\ea7e"}),t.organizationFilled=new t("organization-filled",{fontCharacter:"\\ea7e"}),t.organizationOutline=new t("organization-outline",{fontCharacter:"\\ea7e"}),t.newFile=new t("new-file",{fontCharacter:"\\ea7f"}),t.fileAdd=new t("file-add",{fontCharacter:"\\ea7f"}),t.newFolder=new t("new-folder",{fontCharacter:"\\ea80"}),t.fileDirectoryCreate=new t("file-directory-create",{fontCharacter:"\\ea80"}),t.trash=new t("trash",{fontCharacter:"\\ea81"}),t.trashcan=new t("trashcan",{fontCharacter:"\\ea81"}),t.history=new t("history",{fontCharacter:"\\ea82"}),t.clock=new t("clock",{fontCharacter:"\\ea82"}),t.folder=new t("folder",{fontCharacter:"\\ea83"}),t.fileDirectory=new t("file-directory",{fontCharacter:"\\ea83"}),t.symbolFolder=new t("symbol-folder",{fontCharacter:"\\ea83"}),t.logoGithub=new t("logo-github",{fontCharacter:"\\ea84"}),t.markGithub=new t("mark-github",{fontCharacter:"\\ea84"}),t.github=new t("github",{fontCharacter:"\\ea84"}),t.terminal=new t("terminal",{fontCharacter:"\\ea85"}),t.console=new t("console",{fontCharacter:"\\ea85"}),t.repl=new t("repl",{fontCharacter:"\\ea85"}),t.zap=new t("zap",{fontCharacter:"\\ea86"}),t.symbolEvent=new t("symbol-event",{fontCharacter:"\\ea86"}),t.error=new t("error",{fontCharacter:"\\ea87"}),t.stop=new t("stop",{fontCharacter:"\\ea87"}),t.variable=new t("variable",{fontCharacter:"\\ea88"}),t.symbolVariable=new t("symbol-variable",{fontCharacter:"\\ea88"}),t.array=new t("array",{fontCharacter:"\\ea8a"}),t.symbolArray=new t("symbol-array",{fontCharacter:"\\ea8a"}),t.symbolModule=new t("symbol-module",{fontCharacter:"\\ea8b"}),t.symbolPackage=new t("symbol-package",{fontCharacter:"\\ea8b"}),t.symbolNamespace=new t("symbol-namespace",{fontCharacter:"\\ea8b"}),t.symbolObject=new t("symbol-object",{fontCharacter:"\\ea8b"}),t.symbolMethod=new t("symbol-method",{fontCharacter:"\\ea8c"}),t.symbolFunction=new t("symbol-function",{fontCharacter:"\\ea8c"}),t.symbolConstructor=new t("symbol-constructor",{fontCharacter:"\\ea8c"}),t.symbolBoolean=new t("symbol-boolean",{fontCharacter:"\\ea8f"}),t.symbolNull=new t("symbol-null",{fontCharacter:"\\ea8f"}),t.symbolNumeric=new t("symbol-numeric",{fontCharacter:"\\ea90"}),t.symbolNumber=new t("symbol-number",{fontCharacter:"\\ea90"}),t.symbolStructure=new t("symbol-structure",{fontCharacter:"\\ea91"}),t.symbolStruct=new t("symbol-struct",{fontCharacter:"\\ea91"}),t.symbolParameter=new t("symbol-parameter",{fontCharacter:"\\ea92"}),t.symbolTypeParameter=new t("symbol-type-parameter",{fontCharacter:"\\ea92"}),t.symbolKey=new t("symbol-key",{fontCharacter:"\\ea93"}),t.symbolText=new t("symbol-text",{fontCharacter:"\\ea93"}),t.symbolReference=new t("symbol-reference",{fontCharacter:"\\ea94"}),t.goToFile=new t("go-to-file",{fontCharacter:"\\ea94"}),t.symbolEnum=new t("symbol-enum",{fontCharacter:"\\ea95"}),t.symbolValue=new t("symbol-value",{fontCharacter:"\\ea95"}),t.symbolRuler=new t("symbol-ruler",{fontCharacter:"\\ea96"}),t.symbolUnit=new t("symbol-unit",{fontCharacter:"\\ea96"}),t.activateBreakpoints=new t("activate-breakpoints",{fontCharacter:"\\ea97"}),t.archive=new t("archive",{fontCharacter:"\\ea98"}),t.arrowBoth=new t("arrow-both",{fontCharacter:"\\ea99"}),t.arrowDown=new t("arrow-down",{fontCharacter:"\\ea9a"}),t.arrowLeft=new t("arrow-left",{fontCharacter:"\\ea9b"}),t.arrowRight=new t("arrow-right",{fontCharacter:"\\ea9c"}),t.arrowSmallDown=new t("arrow-small-down",{fontCharacter:"\\ea9d"}),t.arrowSmallLeft=new t("arrow-small-left",{fontCharacter:"\\ea9e"}),t.arrowSmallRight=new t("arrow-small-right",{fontCharacter:"\\ea9f"}),t.arrowSmallUp=new t("arrow-small-up",{fontCharacter:"\\eaa0"}),t.arrowUp=new t("arrow-up",{fontCharacter:"\\eaa1"}),t.bell=new t("bell",{fontCharacter:"\\eaa2"}),t.bold=new t("bold",{fontCharacter:"\\eaa3"}),t.book=new t("book",{fontCharacter:"\\eaa4"}),t.bookmark=new t("bookmark",{fontCharacter:"\\eaa5"}),t.debugBreakpointConditionalUnverified=new t("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),t.debugBreakpointConditional=new t("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),t.debugBreakpointConditionalDisabled=new t("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),t.debugBreakpointDataUnverified=new t("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),t.debugBreakpointData=new t("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),t.debugBreakpointDataDisabled=new t("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),t.debugBreakpointLogUnverified=new t("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),t.debugBreakpointLog=new t("debug-breakpoint-log",{fontCharacter:"\\eaab"}),t.debugBreakpointLogDisabled=new t("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),t.briefcase=new t("briefcase",{fontCharacter:"\\eaac"}),t.broadcast=new t("broadcast",{fontCharacter:"\\eaad"}),t.browser=new t("browser",{fontCharacter:"\\eaae"}),t.bug=new t("bug",{fontCharacter:"\\eaaf"}),t.calendar=new t("calendar",{fontCharacter:"\\eab0"}),t.caseSensitive=new t("case-sensitive",{fontCharacter:"\\eab1"}),t.check=new t("check",{fontCharacter:"\\eab2"}),t.checklist=new t("checklist",{fontCharacter:"\\eab3"}),t.chevronDown=new t("chevron-down",{fontCharacter:"\\eab4"}),t.dropDownButton=new t("drop-down-button",t.chevronDown.definition),t.chevronLeft=new t("chevron-left",{fontCharacter:"\\eab5"}),t.chevronRight=new t("chevron-right",{fontCharacter:"\\eab6"}),t.chevronUp=new t("chevron-up",{fontCharacter:"\\eab7"}),t.chromeClose=new t("chrome-close",{fontCharacter:"\\eab8"}),t.chromeMaximize=new t("chrome-maximize",{fontCharacter:"\\eab9"}),t.chromeMinimize=new t("chrome-minimize",{fontCharacter:"\\eaba"}),t.chromeRestore=new t("chrome-restore",{fontCharacter:"\\eabb"}),t.circleOutline=new t("circle-outline",{fontCharacter:"\\eabc"}),t.debugBreakpointUnverified=new t("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),t.circleSlash=new t("circle-slash",{fontCharacter:"\\eabd"}),t.circuitBoard=new t("circuit-board",{fontCharacter:"\\eabe"}),t.clearAll=new t("clear-all",{fontCharacter:"\\eabf"}),t.clippy=new t("clippy",{fontCharacter:"\\eac0"}),t.closeAll=new t("close-all",{fontCharacter:"\\eac1"}),t.cloudDownload=new t("cloud-download",{fontCharacter:"\\eac2"}),t.cloudUpload=new t("cloud-upload",{fontCharacter:"\\eac3"}),t.code=new t("code",{fontCharacter:"\\eac4"}),t.collapseAll=new t("collapse-all",{fontCharacter:"\\eac5"}),t.colorMode=new t("color-mode",{fontCharacter:"\\eac6"}),t.commentDiscussion=new t("comment-discussion",{fontCharacter:"\\eac7"}),t.compareChanges=new t("compare-changes",{fontCharacter:"\\eafd"}),t.creditCard=new t("credit-card",{fontCharacter:"\\eac9"}),t.dash=new t("dash",{fontCharacter:"\\eacc"}),t.dashboard=new t("dashboard",{fontCharacter:"\\eacd"}),t.database=new t("database",{fontCharacter:"\\eace"}),t.debugContinue=new t("debug-continue",{fontCharacter:"\\eacf"}),t.debugDisconnect=new t("debug-disconnect",{fontCharacter:"\\ead0"}),t.debugPause=new t("debug-pause",{fontCharacter:"\\ead1"}),t.debugRestart=new t("debug-restart",{fontCharacter:"\\ead2"}),t.debugStart=new t("debug-start",{fontCharacter:"\\ead3"}),t.debugStepInto=new t("debug-step-into",{fontCharacter:"\\ead4"}),t.debugStepOut=new t("debug-step-out",{fontCharacter:"\\ead5"}),t.debugStepOver=new t("debug-step-over",{fontCharacter:"\\ead6"}),t.debugStop=new t("debug-stop",{fontCharacter:"\\ead7"}),t.debug=new t("debug",{fontCharacter:"\\ead8"}),t.deviceCameraVideo=new t("device-camera-video",{fontCharacter:"\\ead9"}),t.deviceCamera=new t("device-camera",{fontCharacter:"\\eada"}),t.deviceMobile=new t("device-mobile",{fontCharacter:"\\eadb"}),t.diffAdded=new t("diff-added",{fontCharacter:"\\eadc"}),t.diffIgnored=new t("diff-ignored",{fontCharacter:"\\eadd"}),t.diffModified=new t("diff-modified",{fontCharacter:"\\eade"}),t.diffRemoved=new t("diff-removed",{fontCharacter:"\\eadf"}),t.diffRenamed=new t("diff-renamed",{fontCharacter:"\\eae0"}),t.diff=new t("diff",{fontCharacter:"\\eae1"}),t.discard=new t("discard",{fontCharacter:"\\eae2"}),t.editorLayout=new t("editor-layout",{fontCharacter:"\\eae3"}),t.emptyWindow=new t("empty-window",{fontCharacter:"\\eae4"}),t.exclude=new t("exclude",{fontCharacter:"\\eae5"}),t.extensions=new t("extensions",{fontCharacter:"\\eae6"}),t.eyeClosed=new t("eye-closed",{fontCharacter:"\\eae7"}),t.fileBinary=new t("file-binary",{fontCharacter:"\\eae8"}),t.fileCode=new t("file-code",{fontCharacter:"\\eae9"}),t.fileMedia=new t("file-media",{fontCharacter:"\\eaea"}),t.filePdf=new t("file-pdf",{fontCharacter:"\\eaeb"}),t.fileSubmodule=new t("file-submodule",{fontCharacter:"\\eaec"}),t.fileSymlinkDirectory=new t("file-symlink-directory",{fontCharacter:"\\eaed"}),t.fileSymlinkFile=new t("file-symlink-file",{fontCharacter:"\\eaee"}),t.fileZip=new t("file-zip",{fontCharacter:"\\eaef"}),t.files=new t("files",{fontCharacter:"\\eaf0"}),t.filter=new t("filter",{fontCharacter:"\\eaf1"}),t.flame=new t("flame",{fontCharacter:"\\eaf2"}),t.foldDown=new t("fold-down",{fontCharacter:"\\eaf3"}),t.foldUp=new t("fold-up",{fontCharacter:"\\eaf4"}),t.fold=new t("fold",{fontCharacter:"\\eaf5"}),t.folderActive=new t("folder-active",{fontCharacter:"\\eaf6"}),t.folderOpened=new t("folder-opened",{fontCharacter:"\\eaf7"}),t.gear=new t("gear",{fontCharacter:"\\eaf8"}),t.gift=new t("gift",{fontCharacter:"\\eaf9"}),t.gistSecret=new t("gist-secret",{fontCharacter:"\\eafa"}),t.gist=new t("gist",{fontCharacter:"\\eafb"}),t.gitCommit=new t("git-commit",{fontCharacter:"\\eafc"}),t.gitCompare=new t("git-compare",{fontCharacter:"\\eafd"}),t.gitMerge=new t("git-merge",{fontCharacter:"\\eafe"}),t.githubAction=new t("github-action",{fontCharacter:"\\eaff"}),t.githubAlt=new t("github-alt",{fontCharacter:"\\eb00"}),t.globe=new t("globe",{fontCharacter:"\\eb01"}),t.grabber=new t("grabber",{fontCharacter:"\\eb02"}),t.graph=new t("graph",{fontCharacter:"\\eb03"}),t.gripper=new t("gripper",{fontCharacter:"\\eb04"}),t.heart=new t("heart",{fontCharacter:"\\eb05"}),t.home=new t("home",{fontCharacter:"\\eb06"}),t.horizontalRule=new t("horizontal-rule",{fontCharacter:"\\eb07"}),t.hubot=new t("hubot",{fontCharacter:"\\eb08"}),t.inbox=new t("inbox",{fontCharacter:"\\eb09"}),t.issueClosed=new t("issue-closed",{fontCharacter:"\\eba4"}),t.issueReopened=new t("issue-reopened",{fontCharacter:"\\eb0b"}),t.issues=new t("issues",{fontCharacter:"\\eb0c"}),t.italic=new t("italic",{fontCharacter:"\\eb0d"}),t.jersey=new t("jersey",{fontCharacter:"\\eb0e"}),t.json=new t("json",{fontCharacter:"\\eb0f"}),t.kebabVertical=new t("kebab-vertical",{fontCharacter:"\\eb10"}),t.key=new t("key",{fontCharacter:"\\eb11"}),t.law=new t("law",{fontCharacter:"\\eb12"}),t.lightbulbAutofix=new t("lightbulb-autofix",{fontCharacter:"\\eb13"}),t.linkExternal=new t("link-external",{fontCharacter:"\\eb14"}),t.link=new t("link",{fontCharacter:"\\eb15"}),t.listOrdered=new t("list-ordered",{fontCharacter:"\\eb16"}),t.listUnordered=new t("list-unordered",{fontCharacter:"\\eb17"}),t.liveShare=new t("live-share",{fontCharacter:"\\eb18"}),t.loading=new t("loading",{fontCharacter:"\\eb19"}),t.location=new t("location",{fontCharacter:"\\eb1a"}),t.mailRead=new t("mail-read",{fontCharacter:"\\eb1b"}),t.mail=new t("mail",{fontCharacter:"\\eb1c"}),t.markdown=new t("markdown",{fontCharacter:"\\eb1d"}),t.megaphone=new t("megaphone",{fontCharacter:"\\eb1e"}),t.mention=new t("mention",{fontCharacter:"\\eb1f"}),t.milestone=new t("milestone",{fontCharacter:"\\eb20"}),t.mortarBoard=new t("mortar-board",{fontCharacter:"\\eb21"}),t.move=new t("move",{fontCharacter:"\\eb22"}),t.multipleWindows=new t("multiple-windows",{fontCharacter:"\\eb23"}),t.mute=new t("mute",{fontCharacter:"\\eb24"}),t.noNewline=new t("no-newline",{fontCharacter:"\\eb25"}),t.note=new t("note",{fontCharacter:"\\eb26"}),t.octoface=new t("octoface",{fontCharacter:"\\eb27"}),t.openPreview=new t("open-preview",{fontCharacter:"\\eb28"}),t.package_=new t("package",{fontCharacter:"\\eb29"}),t.paintcan=new t("paintcan",{fontCharacter:"\\eb2a"}),t.pin=new t("pin",{fontCharacter:"\\eb2b"}),t.play=new t("play",{fontCharacter:"\\eb2c"}),t.run=new t("run",{fontCharacter:"\\eb2c"}),t.plug=new t("plug",{fontCharacter:"\\eb2d"}),t.preserveCase=new t("preserve-case",{fontCharacter:"\\eb2e"}),t.preview=new t("preview",{fontCharacter:"\\eb2f"}),t.project=new t("project",{fontCharacter:"\\eb30"}),t.pulse=new t("pulse",{fontCharacter:"\\eb31"}),t.question=new t("question",{fontCharacter:"\\eb32"}),t.quote=new t("quote",{fontCharacter:"\\eb33"}),t.radioTower=new t("radio-tower",{fontCharacter:"\\eb34"}),t.reactions=new t("reactions",{fontCharacter:"\\eb35"}),t.references=new t("references",{fontCharacter:"\\eb36"}),t.refresh=new t("refresh",{fontCharacter:"\\eb37"}),t.regex=new t("regex",{fontCharacter:"\\eb38"}),t.remoteExplorer=new t("remote-explorer",{fontCharacter:"\\eb39"}),t.remote=new t("remote",{fontCharacter:"\\eb3a"}),t.remove=new t("remove",{fontCharacter:"\\eb3b"}),t.replaceAll=new t("replace-all",{fontCharacter:"\\eb3c"}),t.replace=new t("replace",{fontCharacter:"\\eb3d"}),t.repoClone=new t("repo-clone",{fontCharacter:"\\eb3e"}),t.repoForcePush=new t("repo-force-push",{fontCharacter:"\\eb3f"}),t.repoPull=new t("repo-pull",{fontCharacter:"\\eb40"}),t.repoPush=new t("repo-push",{fontCharacter:"\\eb41"}),t.report=new t("report",{fontCharacter:"\\eb42"}),t.requestChanges=new t("request-changes",{fontCharacter:"\\eb43"}),t.rocket=new t("rocket",{fontCharacter:"\\eb44"}),t.rootFolderOpened=new t("root-folder-opened",{fontCharacter:"\\eb45"}),t.rootFolder=new t("root-folder",{fontCharacter:"\\eb46"}),t.rss=new t("rss",{fontCharacter:"\\eb47"}),t.ruby=new t("ruby",{fontCharacter:"\\eb48"}),t.saveAll=new t("save-all",{fontCharacter:"\\eb49"}),t.saveAs=new t("save-as",{fontCharacter:"\\eb4a"}),t.save=new t("save",{fontCharacter:"\\eb4b"}),t.screenFull=new t("screen-full",{fontCharacter:"\\eb4c"}),t.screenNormal=new t("screen-normal",{fontCharacter:"\\eb4d"}),t.searchStop=new t("search-stop",{fontCharacter:"\\eb4e"}),t.server=new t("server",{fontCharacter:"\\eb50"}),t.settingsGear=new t("settings-gear",{fontCharacter:"\\eb51"}),t.settings=new t("settings",{fontCharacter:"\\eb52"}),t.shield=new t("shield",{fontCharacter:"\\eb53"}),t.smiley=new t("smiley",{fontCharacter:"\\eb54"}),t.sortPrecedence=new t("sort-precedence",{fontCharacter:"\\eb55"}),t.splitHorizontal=new t("split-horizontal",{fontCharacter:"\\eb56"}),t.splitVertical=new t("split-vertical",{fontCharacter:"\\eb57"}),t.squirrel=new t("squirrel",{fontCharacter:"\\eb58"}),t.starFull=new t("star-full",{fontCharacter:"\\eb59"}),t.starHalf=new t("star-half",{fontCharacter:"\\eb5a"}),t.symbolClass=new t("symbol-class",{fontCharacter:"\\eb5b"}),t.symbolColor=new t("symbol-color",{fontCharacter:"\\eb5c"}),t.symbolConstant=new t("symbol-constant",{fontCharacter:"\\eb5d"}),t.symbolEnumMember=new t("symbol-enum-member",{fontCharacter:"\\eb5e"}),t.symbolField=new t("symbol-field",{fontCharacter:"\\eb5f"}),t.symbolFile=new t("symbol-file",{fontCharacter:"\\eb60"}),t.symbolInterface=new t("symbol-interface",{fontCharacter:"\\eb61"}),t.symbolKeyword=new t("symbol-keyword",{fontCharacter:"\\eb62"}),t.symbolMisc=new t("symbol-misc",{fontCharacter:"\\eb63"}),t.symbolOperator=new t("symbol-operator",{fontCharacter:"\\eb64"}),t.symbolProperty=new t("symbol-property",{fontCharacter:"\\eb65"}),t.wrench=new t("wrench",{fontCharacter:"\\eb65"}),t.wrenchSubaction=new t("wrench-subaction",{fontCharacter:"\\eb65"}),t.symbolSnippet=new t("symbol-snippet",{fontCharacter:"\\eb66"}),t.tasklist=new t("tasklist",{fontCharacter:"\\eb67"}),t.telescope=new t("telescope",{fontCharacter:"\\eb68"}),t.textSize=new t("text-size",{fontCharacter:"\\eb69"}),t.threeBars=new t("three-bars",{fontCharacter:"\\eb6a"}),t.thumbsdown=new t("thumbsdown",{fontCharacter:"\\eb6b"}),t.thumbsup=new t("thumbsup",{fontCharacter:"\\eb6c"}),t.tools=new t("tools",{fontCharacter:"\\eb6d"}),t.triangleDown=new t("triangle-down",{fontCharacter:"\\eb6e"}),t.triangleLeft=new t("triangle-left",{fontCharacter:"\\eb6f"}),t.triangleRight=new t("triangle-right",{fontCharacter:"\\eb70"}),t.triangleUp=new t("triangle-up",{fontCharacter:"\\eb71"}),t.twitter=new t("twitter",{fontCharacter:"\\eb72"}),t.unfold=new t("unfold",{fontCharacter:"\\eb73"}),t.unlock=new t("unlock",{fontCharacter:"\\eb74"}),t.unmute=new t("unmute",{fontCharacter:"\\eb75"}),t.unverified=new t("unverified",{fontCharacter:"\\eb76"}),t.verified=new t("verified",{fontCharacter:"\\eb77"}),t.versions=new t("versions",{fontCharacter:"\\eb78"}),t.vmActive=new t("vm-active",{fontCharacter:"\\eb79"}),t.vmOutline=new t("vm-outline",{fontCharacter:"\\eb7a"}),t.vmRunning=new t("vm-running",{fontCharacter:"\\eb7b"}),t.watch=new t("watch",{fontCharacter:"\\eb7c"}),t.whitespace=new t("whitespace",{fontCharacter:"\\eb7d"}),t.wholeWord=new t("whole-word",{fontCharacter:"\\eb7e"}),t.window=new t("window",{fontCharacter:"\\eb7f"}),t.wordWrap=new t("word-wrap",{fontCharacter:"\\eb80"}),t.zoomIn=new t("zoom-in",{fontCharacter:"\\eb81"}),t.zoomOut=new t("zoom-out",{fontCharacter:"\\eb82"}),t.listFilter=new t("list-filter",{fontCharacter:"\\eb83"}),t.listFlat=new t("list-flat",{fontCharacter:"\\eb84"}),t.listSelection=new t("list-selection",{fontCharacter:"\\eb85"}),t.selection=new t("selection",{fontCharacter:"\\eb85"}),t.listTree=new t("list-tree",{fontCharacter:"\\eb86"}),t.debugBreakpointFunctionUnverified=new t("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),t.debugBreakpointFunction=new t("debug-breakpoint-function",{fontCharacter:"\\eb88"}),t.debugBreakpointFunctionDisabled=new t("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),t.debugStackframeActive=new t("debug-stackframe-active",{fontCharacter:"\\eb89"}),t.debugStackframeDot=new t("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),t.debugStackframe=new t("debug-stackframe",{fontCharacter:"\\eb8b"}),t.debugStackframeFocused=new t("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),t.debugBreakpointUnsupported=new t("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),t.symbolString=new t("symbol-string",{fontCharacter:"\\eb8d"}),t.debugReverseContinue=new t("debug-reverse-continue",{fontCharacter:"\\eb8e"}),t.debugStepBack=new t("debug-step-back",{fontCharacter:"\\eb8f"}),t.debugRestartFrame=new t("debug-restart-frame",{fontCharacter:"\\eb90"}),t.callIncoming=new t("call-incoming",{fontCharacter:"\\eb92"}),t.callOutgoing=new t("call-outgoing",{fontCharacter:"\\eb93"}),t.menu=new t("menu",{fontCharacter:"\\eb94"}),t.expandAll=new t("expand-all",{fontCharacter:"\\eb95"}),t.feedback=new t("feedback",{fontCharacter:"\\eb96"}),t.groupByRefType=new t("group-by-ref-type",{fontCharacter:"\\eb97"}),t.ungroupByRefType=new t("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),t.account=new t("account",{fontCharacter:"\\eb99"}),t.bellDot=new t("bell-dot",{fontCharacter:"\\eb9a"}),t.debugConsole=new t("debug-console",{fontCharacter:"\\eb9b"}),t.library=new t("library",{fontCharacter:"\\eb9c"}),t.output=new t("output",{fontCharacter:"\\eb9d"}),t.runAll=new t("run-all",{fontCharacter:"\\eb9e"}),t.syncIgnored=new t("sync-ignored",{fontCharacter:"\\eb9f"}),t.pinned=new t("pinned",{fontCharacter:"\\eba0"}),t.githubInverted=new t("github-inverted",{fontCharacter:"\\eba1"}),t.debugAlt=new t("debug-alt",{fontCharacter:"\\eb91"}),t.serverProcess=new t("server-process",{fontCharacter:"\\eba2"}),t.serverEnvironment=new t("server-environment",{fontCharacter:"\\eba3"}),t.pass=new t("pass",{fontCharacter:"\\eba4"}),t.stopCircle=new t("stop-circle",{fontCharacter:"\\eba5"}),t.playCircle=new t("play-circle",{fontCharacter:"\\eba6"}),t.record=new t("record",{fontCharacter:"\\eba7"}),t.debugAltSmall=new t("debug-alt-small",{fontCharacter:"\\eba8"}),t.vmConnect=new t("vm-connect",{fontCharacter:"\\eba9"}),t.cloud=new t("cloud",{fontCharacter:"\\ebaa"}),t.merge=new t("merge",{fontCharacter:"\\ebab"}),t.exportIcon=new t("export",{fontCharacter:"\\ebac"}),t.graphLeft=new t("graph-left",{fontCharacter:"\\ebad"}),t.magnet=new t("magnet",{fontCharacter:"\\ebae"}),t.notebook=new t("notebook",{fontCharacter:"\\ebaf"}),t.redo=new t("redo",{fontCharacter:"\\ebb0"}),t.checkAll=new t("check-all",{fontCharacter:"\\ebb1"}),t.pinnedDirty=new t("pinned-dirty",{fontCharacter:"\\ebb2"}),t.passFilled=new t("pass-filled",{fontCharacter:"\\ebb3"}),t.circleLargeFilled=new t("circle-large-filled",{fontCharacter:"\\ebb4"}),t.circleLargeOutline=new t("circle-large-outline",{fontCharacter:"\\ebb5"}),t.combine=new t("combine",{fontCharacter:"\\ebb6"}),t.gather=new t("gather",{fontCharacter:"\\ebb6"}),t.table=new t("table",{fontCharacter:"\\ebb7"}),t.variableGroup=new t("variable-group",{fontCharacter:"\\ebb8"}),t.typeHierarchy=new t("type-hierarchy",{fontCharacter:"\\ebb9"}),t.typeHierarchySub=new t("type-hierarchy-sub",{fontCharacter:"\\ebba"}),t.typeHierarchySuper=new t("type-hierarchy-super",{fontCharacter:"\\ebbb"}),t.gitPullRequestCreate=new t("git-pull-request-create",{fontCharacter:"\\ebbc"}),t.runAbove=new t("run-above",{fontCharacter:"\\ebbd"}),t.runBelow=new t("run-below",{fontCharacter:"\\ebbe"}),t.notebookTemplate=new t("notebook-template",{fontCharacter:"\\ebbf"}),t.debugRerun=new t("debug-rerun",{fontCharacter:"\\ebc0"}),t.workspaceTrusted=new t("workspace-trusted",{fontCharacter:"\\ebc1"}),t.workspaceUntrusted=new t("workspace-untrusted",{fontCharacter:"\\ebc2"}),t.workspaceUnspecified=new t("workspace-unspecified",{fontCharacter:"\\ebc3"}),t.terminalCmd=new t("terminal-cmd",{fontCharacter:"\\ebc4"}),t.terminalDebian=new t("terminal-debian",{fontCharacter:"\\ebc5"}),t.terminalLinux=new t("terminal-linux",{fontCharacter:"\\ebc6"}),t.terminalPowershell=new t("terminal-powershell",{fontCharacter:"\\ebc7"}),t.terminalTmux=new t("terminal-tmux",{fontCharacter:"\\ebc8"}),t.terminalUbuntu=new t("terminal-ubuntu",{fontCharacter:"\\ebc9"}),t.terminalBash=new t("terminal-bash",{fontCharacter:"\\ebca"}),t.arrowSwap=new t("arrow-swap",{fontCharacter:"\\ebcb"}),t.copy=new t("copy",{fontCharacter:"\\ebcc"}),t.personAdd=new t("person-add",{fontCharacter:"\\ebcd"}),t.filterFilled=new t("filter-filled",{fontCharacter:"\\ebce"}),t.wand=new t("wand",{fontCharacter:"\\ebcf"}),t.debugLineByLine=new t("debug-line-by-line",{fontCharacter:"\\ebd0"}),t.inspect=new t("inspect",{fontCharacter:"\\ebd1"}),t.layers=new t("layers",{fontCharacter:"\\ebd2"}),t.layersDot=new t("layers-dot",{fontCharacter:"\\ebd3"}),t.layersActive=new t("layers-active",{fontCharacter:"\\ebd4"}),t.compass=new t("compass",{fontCharacter:"\\ebd5"}),t.compassDot=new t("compass-dot",{fontCharacter:"\\ebd6"}),t.compassActive=new t("compass-active",{fontCharacter:"\\ebd7"}),t.azure=new t("azure",{fontCharacter:"\\ebd8"}),t.issueDraft=new t("issue-draft",{fontCharacter:"\\ebd9"}),t.gitPullRequestClosed=new t("git-pull-request-closed",{fontCharacter:"\\ebda"}),t.gitPullRequestDraft=new t("git-pull-request-draft",{fontCharacter:"\\ebdb"}),t.debugAll=new t("debug-all",{fontCharacter:"\\ebdc"}),t.debugCoverage=new t("debug-coverage",{fontCharacter:"\\ebdd"}),t.runErrors=new t("run-errors",{fontCharacter:"\\ebde"}),t.folderLibrary=new t("folder-library",{fontCharacter:"\\ebdf"}),t.debugContinueSmall=new t("debug-continue-small",{fontCharacter:"\\ebe0"}),t.beakerStop=new t("beaker-stop",{fontCharacter:"\\ebe1"}),t.graphLine=new t("graph-line",{fontCharacter:"\\ebe2"}),t.graphScatter=new t("graph-scatter",{fontCharacter:"\\ebe3"}),t.pieChart=new t("pie-chart",{fontCharacter:"\\ebe4"}),t.bracket=new t("bracket",t.json.definition),t.bracketDot=new t("bracket-dot",{fontCharacter:"\\ebe5"}),t.bracketError=new t("bracket-error",{fontCharacter:"\\ebe6"}),t.lockSmall=new t("lock-small",{fontCharacter:"\\ebe7"}),t.azureDevops=new t("azure-devops",{fontCharacter:"\\ebe8"}),t.verifiedFilled=new t("verified-filled",{fontCharacter:"\\ebe9"}),t.newLine=new t("newline",{fontCharacter:"\\ebea"}),t.dialogError=new t("dialog-error",t.error.definition),t.dialogWarning=new t("dialog-warning",t.warning.definition),t.dialogInfo=new t("dialog-info",t.info.definition),t.dialogClose=new t("dialog-close",t.close.definition),t.treeItemExpanded=new t("tree-item-expanded",t.chevronDown.definition),t.treeFilterOnTypeOn=new t("tree-filter-on-type-on",t.listFilter.definition),t.treeFilterOnTypeOff=new t("tree-filter-on-type-off",t.listSelection.definition),t.treeFilterClear=new t("tree-filter-clear",t.close.definition),t.treeItemLoading=new t("tree-item-loading",t.loading.definition),t.menuSelection=new t("menu-selection",t.check.definition),t.menuSubmenu=new t("menu-submenu",t.chevronRight.definition),t.menuBarMore=new t("menubar-more",t.more.definition),t.scrollbarButtonLeft=new t("scrollbar-button-left",t.triangleLeft.definition),t.scrollbarButtonRight=new t("scrollbar-button-right",t.triangleRight.definition),t.scrollbarButtonUp=new t("scrollbar-button-up",t.triangleUp.definition),t.scrollbarButtonDown=new t("scrollbar-button-down",t.triangleDown.definition),t.toolBarMore=new t("toolbar-more",t.more.definition),t.quickInputBack=new t("quick-input-back",t.arrowLeft.definition);function R(C,A){const _=["codicon","codicon-"+C];return A&&_.push("codicon-modifier-"+A),_}e.getClassNamesArray=R;var S;(function(C){C.iconNameSegment="[A-Za-z0-9]+",C.iconNameExpression="[A-Za-z0-9-]+",C.iconModifierExpression="~[A-Za-z]+",C.iconNameCharacter="[A-Za-z0-9~-]";const A=new RegExp(`^(${C.iconNameExpression})(${C.iconModifierExpression})?$`);function _(s){if(s instanceof t)return["codicon","codicon-"+s.id];const l=A.exec(s.id);if(!l)return _(t.error);let[,d,D]=l;const v=["codicon","codicon-"+d];return D&&v.push("codicon-modifier-"+D.substr(1)),v}C.asClassNameArray=_;function n(s){return _(s).join(" ")}C.asClassName=n;function h(s){return"."+_(s).join(".")}C.asCSSSelector=h})(S=e.CSSIcon||(e.CSSIcon={}))}),define(Ee[102],_e([0,1,15,6]),function(oe,e,c,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function w(f){const g=f;return g?[g.on,g.pause,g.resume,g.destroy].every(T=>typeof T=="function"):!1}e.isReadableStream=w;function I(f){const g=f;return g?w(g.stream)&&Array.isArray(g.buffer)&&typeof g.ended=="boolean":!1}e.isReadableBufferedStream=I;function t(f,g){return new R(f,g)}e.newWriteableStream=t;class R{constructor(g,T){this.reducer=g,this.options=T,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(g){if(!this.state.destroyed){if(this.state.flowing)this.emitData(g);else if(this.buffer.data.push(g),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(T=>this.pendingWritePromises.push(T))}}error(g){this.state.destroyed||(this.state.flowing?this.emitError(g):this.buffer.error.push(g))}end(g){this.state.destroyed||(typeof g!="undefined"&&this.write(g),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(g){this.listeners.data.slice(0).forEach(T=>T(g))}emitError(g){this.listeners.error.length===0?(0,c.onUnexpectedError)(g):this.listeners.error.slice(0).forEach(T=>T(g))}emitEnd(){this.listeners.end.slice(0).forEach(g=>g())}on(g,T){if(!this.state.destroyed)switch(g){case"data":this.listeners.data.push(T),this.resume();break;case"end":this.listeners.end.push(T),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(T),this.state.flowing&&this.flowErrors();break}}removeListener(g,T){if(this.state.destroyed)return;let u;switch(g){case"data":u=this.listeners.data;break;case"end":u=this.listeners.end;break;case"error":u=this.listeners.error;break}if(u){const M=u.indexOf(T);M>=0&&u.splice(M,1)}}flowData(){if(this.buffer.data.length>0){const g=this.reducer(this.buffer.data);this.emitData(g),this.buffer.data.length=0;const T=[...this.pendingWritePromises];this.pendingWritePromises.length=0,T.forEach(u=>u())}}flowErrors(){if(this.listeners.error.length>0){for(const g of this.buffer.error)this.emitError(g);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function S(f,g){const T=[];let u;for(;(u=f.read())!==null;)T.push(u);return g(T)}e.consumeReadable=S;function C(f,g,T){const u=[];let M;for(;(M=f.read())!==null&&u.length<T;)u.push(M);return M===null&&u.length>0?g(u):{read:()=>{if(u.length>0)return u.shift();if(typeof M!="undefined"){const r=M;return M=void 0,r}return f.read()}}}e.peekReadable=C;function A(f,g){return new Promise((T,u)=>{const M=[];_(f,{onData:r=>{g&&M.push(r)},onError:r=>{g?u(r):T(void 0)},onEnd:()=>{T(g?g(M):void 0)}})})}e.consumeStream=A;function _(f,g){f.on("error",T=>g.onError(T)),f.on("end",()=>g.onEnd()),f.on("data",T=>g.onData(T))}e.listenStream=_;function n(f,g){return new Promise((T,u)=>{const M=new F.DisposableStore,r=[],i=o=>{if(r.push(o),r.length>g)return M.dispose(),f.pause(),T({stream:f,buffer:r,ended:!1})},p=o=>u(o),m=()=>T({stream:f,buffer:r,ended:!0});M.add((0,F.toDisposable)(()=>f.removeListener("error",p))),f.on("error",p),M.add((0,F.toDisposable)(()=>f.removeListener("end",m))),f.on("end",m),M.add((0,F.toDisposable)(()=>f.removeListener("data",i))),f.on("data",i)})}e.peekStream=n;function h(f,g){const T=t(g);return T.end(f),T}e.toStream=h;function s(){const f=t(()=>{throw new Error("not supported")});return f.end(),f}e.emptyStream=s;function l(f){let g=!1;return{read:()=>g?null:(g=!0,f)}}e.toReadable=l;function d(f,g,T){const u=t(T);return _(f,{onData:M=>u.write(g.data(M)),onError:M=>u.error(g.error?g.error(M):M),onEnd:()=>u.end()}),u}e.transform=d;function D(f,g,T){let u=!1;return{read:()=>{const M=g.read();return u?M:(u=!0,M!==null?T([f,M]):f)}}}e.prefixedReadable=D;function v(f,g,T){let u=!1;const M=t(T);return _(g,{onData:r=>u?M.write(r):(u=!0,M.write(T([f,r]))),onError:r=>M.error(r),onEnd:()=>{u||(u=!0,M.write(f)),M.end()}}),M}e.prefixedStream=v}),define(Ee[22],_e([0,1,102]),function(oe,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const F=typeof Buffer!="undefined";let w,I;class t{constructor(i){this.buffer=i,this.byteLength=this.buffer.byteLength}static alloc(i){return F?new t(Buffer.allocUnsafe(i)):new t(new Uint8Array(i))}static wrap(i){return F&&!Buffer.isBuffer(i)&&(i=Buffer.from(i.buffer,i.byteOffset,i.byteLength)),new t(i)}static fromString(i,p){return!(p?.dontUseNodeBuffer||!1)&&F?new t(Buffer.from(i)):(w||(w=new TextEncoder),new t(w.encode(i)))}static concat(i,p){if(typeof p=="undefined"){p=0;for(let b=0,a=i.length;b<a;b++)p+=i[b].byteLength}const m=t.alloc(p);let o=0;for(let b=0,a=i.length;b<a;b++){const E=i[b];m.set(E,o),o+=E.byteLength}return m}toString(){return F?this.buffer.toString():(I||(I=new TextDecoder),I.decode(this.buffer))}slice(i,p){return new t(this.buffer.subarray(i,p))}set(i,p){i instanceof t?this.buffer.set(i.buffer,p):this.buffer.set(i,p)}readUInt32BE(i){return C(this.buffer,i)}writeUInt32BE(i,p){A(this.buffer,i,p)}readUInt32LE(i){return _(this.buffer,i)}writeUInt32LE(i,p){n(this.buffer,i,p)}readUInt8(i){return h(this.buffer,i)}writeUInt8(i,p){s(this.buffer,i,p)}}e.VSBuffer=t;function R(r,i){return r[i+0]<<0>>>0|r[i+1]<<8>>>0}e.readUInt16LE=R;function S(r,i,p){r[p+0]=i&255,i=i>>>8,r[p+1]=i&255}e.writeUInt16LE=S;function C(r,i){return r[i]*2**24+r[i+1]*2**16+r[i+2]*2**8+r[i+3]}e.readUInt32BE=C;function A(r,i,p){r[p+3]=i,i=i>>>8,r[p+2]=i,i=i>>>8,r[p+1]=i,i=i>>>8,r[p]=i}e.writeUInt32BE=A;function _(r,i){return r[i+0]<<0>>>0|r[i+1]<<8>>>0|r[i+2]<<16>>>0|r[i+3]<<24>>>0}e.readUInt32LE=_;function n(r,i,p){r[p+0]=i&255,i=i>>>8,r[p+1]=i&255,i=i>>>8,r[p+2]=i&255,i=i>>>8,r[p+3]=i&255}e.writeUInt32LE=n;function h(r,i){return r[i]}e.readUInt8=h;function s(r,i,p){r[p]=i}e.writeUInt8=s;function l(r){return c.consumeReadable(r,i=>t.concat(i))}e.readableToBuffer=l;function d(r){return c.toReadable(r)}e.bufferToReadable=d;function D(r){return c.consumeStream(r,i=>t.concat(i))}e.streamToBuffer=D;async function v(r){return r.ended?t.concat(r.buffer):t.concat([...r.buffer,await D(r.stream)])}e.bufferedStreamToBuffer=v;function f(r){return c.toStream(r,i=>t.concat(i))}e.bufferToStream=f;function g(r){return c.transform(r,{data:i=>typeof i=="string"?t.fromString(i):t.wrap(i)},i=>t.concat(i))}e.streamToBufferReadableStream=g;function T(r){return c.newWriteableStream(i=>t.concat(i),r)}e.newWriteableBufferStream=T;function u(r,i){return c.prefixedReadable(r,i,p=>t.concat(p))}e.prefixedBufferReadable=u;function M(r,i){return c.prefixedStream(r,i,p=>t.concat(p))}e.prefixedBufferStream=M});var Ze=this&&this.__classPrivateFieldSet||function(oe,e,c,F,w){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?oe!==e||!w:!e.has(oe))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?w.call(oe,c):w?w.value=c:e.set(oe,c),c},Ae=this&&this.__classPrivateFieldGet||function(oe,e,c,F){if(c==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?oe!==e||!F:!e.has(oe))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?F:c==="a"?F.call(oe):F?F.value:e.get(oe)};define(Ee[21],_e([0,1,16,9]),function(oe,e,c,F){"use strict";var w,I,t;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function R(r,i,p){let m=r.get(i);return m===void 0&&(m=p,r.set(i,m)),m}e.getOrSet=R;function S(r){const i=[];return r.forEach((p,m)=>{i.push(`${m} => ${p}`)}),`Map(${r.size}) {${i.join(", ")}}`}e.mapToString=S;function C(r){const i=[];return r.forEach(p=>{i.push(p)}),`Set(${r.size}) {${i.join(", ")}}`}e.setToString=C;class A{constructor(){this._value="",this._pos=0}reset(i){return this._value=i,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(i){const p=i.charCodeAt(0),m=this._value.charCodeAt(this._pos);return p-m}value(){return this._value[this._pos]}}e.StringIterator=A;class _{constructor(i=!0){this._caseSensitive=i}reset(i){return this._value=i,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let i=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(i)this._from++;else break;else i=!1;return this}cmp(i){return this._caseSensitive?(0,F.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,F.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=_;class n{constructor(i=!0,p=!0){this._splitOnBackslash=i,this._caseSensitive=p}reset(i){return this._value=i.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let i=!0;for(;this._to<this._value.length;this._to++){const p=this._value.charCodeAt(this._to);if(p===47||this._splitOnBackslash&&p===92)if(i)this._from++;else break;else i=!1}return this}cmp(i){return this._caseSensitive?(0,F.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,F.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=n;var h;(function(r){r[r.Scheme=1]="Scheme",r[r.Authority=2]="Authority",r[r.Path=3]="Path",r[r.Query=4]="Query",r[r.Fragment=5]="Fragment"})(h||(h={}));class s{constructor(i){this._ignorePathCasing=i,this._states=[],this._stateIdx=0}reset(i){return this._value=i,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new n(!1,!this._ignorePathCasing(i)),this._pathIterator.reset(i.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(i){if(this._states[this._stateIdx]===1)return(0,F.compareIgnoreCase)(i,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,F.compareIgnoreCase)(i,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(i);if(this._states[this._stateIdx]===4)return(0,F.compare)(i,this._value.query);if(this._states[this._stateIdx]===5)return(0,F.compare)(i,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=s;class l{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const i=this.right;return this.right=i.left,i.left=this,this.updateHeight(),i.updateHeight(),i}rotateRight(){const i=this.left;return this.left=i.right,i.right=this,this.updateHeight(),i.updateHeight(),i}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var d;(function(r){r[r.Left=-1]="Left",r[r.Mid=0]="Mid",r[r.Right=1]="Right"})(d||(d={}));class D{constructor(i){this._iter=i}static forUris(i=()=>!1){return new D(new s(i))}static forPaths(){return new D(new n)}static forStrings(){return new D(new A)}static forConfigKeys(){return new D(new _)}clear(){this._root=void 0}fill(i,p){if(p){const m=p.slice(0);(0,c.shuffle)(m);for(let o of m)this.set(o,i)}else{const m=i.slice(0);(0,c.shuffle)(m);for(let o of m)this.set(o[0],o[1])}}set(i,p){const m=this._iter.reset(i);let o;this._root||(this._root=new l,this._root.segment=m.value());const b=[];for(o=this._root;;){const E=m.cmp(o.segment);if(E>0)o.left||(o.left=new l,o.left.segment=m.value()),b.push([-1,o]),o=o.left;else if(E<0)o.right||(o.right=new l,o.right.segment=m.value()),b.push([1,o]),o=o.right;else if(m.hasNext())m.next(),o.mid||(o.mid=new l,o.mid.segment=m.value()),b.push([0,o]),o=o.mid;else break}const a=o.value;o.value=p,o.key=i;for(let E=b.length-1;E>=0;E--){const P=b[E][1];P.updateHeight();const k=P.balanceFactor();if(k<-1||k>1){const B=b[E][0],L=b[E+1][0];if(B===1&&L===1)b[E][1]=P.rotateLeft();else if(B===-1&&L===-1)b[E][1]=P.rotateRight();else if(B===1&&L===-1)P.right=b[E+1][1]=b[E+1][1].rotateRight(),b[E][1]=P.rotateLeft();else if(B===-1&&L===1)P.left=b[E+1][1]=b[E+1][1].rotateLeft(),b[E][1]=P.rotateRight();else throw new Error;if(E>0)switch(b[E-1][0]){case-1:b[E-1][1].left=b[E][1];break;case 1:b[E-1][1].right=b[E][1];break;case 0:b[E-1][1].mid=b[E][1];break}else this._root=b[0][1]}}return a}get(i){return this._getNode(i)?.value}_getNode(i){const p=this._iter.reset(i);let m=this._root;for(;m;){const o=p.cmp(m.segment);if(o>0)m=m.left;else if(o<0)m=m.right;else if(p.hasNext())p.next(),m=m.mid;else break}return m}has(i){const p=this._getNode(i);return!(p?.value===void 0&&p?.mid===void 0)}delete(i){return this._delete(i,!1)}deleteSuperstr(i){return this._delete(i,!0)}_delete(i,p){const m=this._iter.reset(i),o=[];let b=this._root;for(;b;){const a=m.cmp(b.segment);if(a>0)o.push([-1,b]),b=b.left;else if(a<0)o.push([1,b]),b=b.right;else if(m.hasNext())m.next(),o.push([0,b]),b=b.mid;else break}if(!!b){if(p?(b.left=void 0,b.mid=void 0,b.right=void 0,b.height=1):(b.key=void 0,b.value=void 0),!b.mid&&!b.value)if(b.left&&b.right){const a=this._min(b.right),{key:E,value:P,segment:k}=a;this._delete(a.key,!1),b.key=E,b.value=P,b.segment=k}else{const a=b.left??b.right;if(o.length>0){const[E,P]=o[o.length-1];switch(E){case-1:P.left=a;break;case 0:P.mid=a;break;case 1:P.right=a;break}}else this._root=a}for(let a=o.length-1;a>=0;a--){const E=o[a][1];E.updateHeight();const P=E.balanceFactor();if(P>1?(E.right.balanceFactor()>=0||(E.right=o[a+1][1]=o[a+1][1].rotateRight()),o[a][1]=E.rotateLeft()):P<-1&&(E.left.balanceFactor()<=0||(E.left=o[a+1][1]=o[a+1][1].rotateLeft()),o[a][1]=E.rotateRight()),a>0)switch(o[a-1][0]){case-1:o[a-1][1].left=o[a][1];break;case 1:o[a-1][1].right=o[a][1];break;case 0:o[a-1][1].mid=o[a][1];break}else this._root=o[0][1]}}}_min(i){for(;i.left;)i=i.left;return i}findSubstr(i){const p=this._iter.reset(i);let m=this._root,o;for(;m;){const b=p.cmp(m.segment);if(b>0)m=m.left;else if(b<0)m=m.right;else if(p.hasNext())p.next(),o=m.value||o,m=m.mid;else break}return m&&m.value||o}findSuperstr(i){const p=this._iter.reset(i);let m=this._root;for(;m;){const o=p.cmp(m.segment);if(o>0)m=m.left;else if(o<0)m=m.right;else if(p.hasNext())p.next(),m=m.mid;else return m.mid?this._entries(m.mid):void 0}}forEach(i){for(const[p,m]of this)i(m,p)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(i){!i||(i.left&&(yield*this._entries(i.left)),i.value&&(yield[i.key,i.value]),i.mid&&(yield*this._entries(i.mid)),i.right&&(yield*this._entries(i.right)))}_isBalanced(){const i=p=>{if(!p)return!0;const m=p.balanceFactor();return m<-1||m>1?!1:i(p.left)&&i(p.right)};return i(this._root)}}e.TernarySearchTree=D;class v{constructor(i,p){this.uri=i,this.value=p}}class f{constructor(i,p){this[w]="ResourceMap",i instanceof f?(this.map=new Map(i.map),this.toKey=p??f.defaultToKey):(this.map=new Map,this.toKey=i??f.defaultToKey)}set(i,p){return this.map.set(this.toKey(i),new v(i,p)),this}get(i){return this.map.get(this.toKey(i))?.value}has(i){return this.map.has(this.toKey(i))}get size(){return this.map.size}clear(){this.map.clear()}delete(i){return this.map.delete(this.toKey(i))}forEach(i,p){typeof p!="undefined"&&(i=i.bind(p));for(let[m,o]of this.map)i(o.value,o.uri,this)}*values(){for(let i of this.map.values())yield i.value}*keys(){for(let i of this.map.values())yield i.uri}*entries(){for(let i of this.map.values())yield[i.uri,i.value]}*[(w=Symbol.toStringTag,Symbol.iterator)](){for(let[,i]of this.map)yield[i.uri,i.value]}}e.ResourceMap=f,f.defaultToKey=r=>r.toString();var g;(function(r){r[r.None=0]="None",r[r.AsOld=1]="AsOld",r[r.AsNew=2]="AsNew"})(g=e.Touch||(e.Touch={}));class T{constructor(){this[I]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(i){return this._map.has(i)}get(i,p=0){const m=this._map.get(i);if(!!m)return p!==0&&this.touch(m,p),m.value}set(i,p,m=0){let o=this._map.get(i);if(o)o.value=p,m!==0&&this.touch(o,m);else{switch(o={key:i,value:p,next:void 0,previous:void 0},m){case 0:this.addItemLast(o);break;case 1:this.addItemFirst(o);break;case 2:this.addItemLast(o);break;default:this.addItemLast(o);break}this._map.set(i,o),this._size++}return this}delete(i){return!!this.remove(i)}remove(i){const p=this._map.get(i);if(!!p)return this._map.delete(i),this.removeItem(p),this._size--,p.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const i=this._head;return this._map.delete(i.key),this.removeItem(i),this._size--,i.value}forEach(i,p){const m=this._state;let o=this._head;for(;o;){if(p?i.bind(p)(o.value,o.key,this):i(o.value,o.key,this),this._state!==m)throw new Error("LinkedMap got modified during iteration.");o=o.next}}keys(){const i=this,p=this._state;let m=this._head;const o={[Symbol.iterator](){return o},next(){if(i._state!==p)throw new Error("LinkedMap got modified during iteration.");if(m){const b={value:m.key,done:!1};return m=m.next,b}else return{value:void 0,done:!0}}};return o}values(){const i=this,p=this._state;let m=this._head;const o={[Symbol.iterator](){return o},next(){if(i._state!==p)throw new Error("LinkedMap got modified during iteration.");if(m){const b={value:m.value,done:!1};return m=m.next,b}else return{value:void 0,done:!0}}};return o}entries(){const i=this,p=this._state;let m=this._head;const o={[Symbol.iterator](){return o},next(){if(i._state!==p)throw new Error("LinkedMap got modified during iteration.");if(m){const b={value:[m.key,m.value],done:!1};return m=m.next,b}else return{value:void 0,done:!0}}};return o}[(I=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(i){if(i>=this.size)return;if(i===0){this.clear();return}let p=this._head,m=this.size;for(;p&&m>i;)this._map.delete(p.key),p=p.next,m--;this._head=p,this._size=m,p&&(p.previous=void 0),this._state++}addItemFirst(i){if(!this._head&&!this._tail)this._tail=i;else if(this._head)i.next=this._head,this._head.previous=i;else throw new Error("Invalid list");this._head=i,this._state++}addItemLast(i){if(!this._head&&!this._tail)this._head=i;else if(this._tail)i.previous=this._tail,this._tail.next=i;else throw new Error("Invalid list");this._tail=i,this._state++}removeItem(i){if(i===this._head&&i===this._tail)this._head=void 0,this._tail=void 0;else if(i===this._head){if(!i.next)throw new Error("Invalid list");i.next.previous=void 0,this._head=i.next}else if(i===this._tail){if(!i.previous)throw new Error("Invalid list");i.previous.next=void 0,this._tail=i.previous}else{const p=i.next,m=i.previous;if(!p||!m)throw new Error("Invalid list");p.previous=m,m.next=p}i.next=void 0,i.previous=void 0,this._state++}touch(i,p){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(p!==1&&p!==2)){if(p===1){if(i===this._head)return;const m=i.next,o=i.previous;i===this._tail?(o.next=void 0,this._tail=o):(m.previous=o,o.next=m),i.previous=void 0,i.next=this._head,this._head.previous=i,this._head=i,this._state++}else if(p===2){if(i===this._tail)return;const m=i.next,o=i.previous;i===this._head?(m.previous=void 0,this._head=m):(m.previous=o,o.next=m),i.next=void 0,i.previous=this._tail,this._tail.next=i,this._tail=i,this._state++}}}toJSON(){const i=[];return this.forEach((p,m)=>{i.push([m,p])}),i}fromJSON(i){this.clear();for(const[p,m]of i)this.set(p,m)}}e.LinkedMap=T;class u extends T{constructor(i,p=1){super();this._limit=i,this._ratio=Math.min(Math.max(0,p),1)}get limit(){return this._limit}set limit(i){this._limit=i,this.checkTrim()}get ratio(){return this._ratio}set ratio(i){this._ratio=Math.min(Math.max(0,i),1),this.checkTrim()}get(i,p=2){return super.get(i,p)}peek(i){return super.get(i,0)}set(i,p){return super.set(i,p,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=u;class M{constructor(i){t.set(this,void 0),Ze(this,t,i,"f")}get size(){return Ae(this,t,"f").size}forEach(i,p){Ae(this,t,"f").forEach(i,p)}get(i){return Ae(this,t,"f").get(i)}has(i){return Ae(this,t,"f").has(i)}entries(){return Ae(this,t,"f").entries()}keys(){return Ae(this,t,"f").keys()}values(){return Ae(this,t,"f").values()}[(t=new WeakMap,Symbol.iterator)](){return Ae(this,t,"f").entries()}}e.ReadonlyMapView=M}),define(Ee[103],_e([0,1,21,9]),function(oe,e,c,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function w(...j){return function(Z,fe){for(let Te=0,Ne=j.length;Te<Ne;Te++){const He=j[Te](Z,fe);if(He)return He}return null}}e.or=w,e.matchesStrictPrefix=I.bind(void 0,!1),e.matchesPrefix=I.bind(void 0,!0);function I(j,Z,fe){if(!fe||fe.length<Z.length)return null;let Te;return j?Te=F.startsWithIgnoreCase(fe,Z):Te=fe.indexOf(Z)===0,Te?Z.length>0?[{start:0,end:Z.length}]:[]:null}function t(j,Z){const fe=Z.toLowerCase().indexOf(j.toLowerCase());return fe===-1?null:[{start:fe,end:fe+j.length}]}e.matchesContiguousSubString=t;function R(j,Z){return S(j.toLowerCase(),Z.toLowerCase(),0,0)}e.matchesSubString=R;function S(j,Z,fe,Te){if(fe===j.length)return[];if(Te===Z.length)return null;if(j[fe]===Z[Te]){let Ne=null;return(Ne=S(j,Z,fe+1,Te+1))?D({start:Te,end:Te+1},Ne):null}return S(j,Z,fe,Te+1)}function C(j){return 97<=j&&j<=122}function A(j){return 65<=j&&j<=90}e.isUpper=A;function _(j){return 48<=j&&j<=57}function n(j){return j===32||j===9||j===10||j===13}const h=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(j=>h.add(j.charCodeAt(0)));function s(j){return n(j)||h.has(j)}function l(j,Z){return j===Z||s(j)&&s(Z)}function d(j){return C(j)||A(j)||_(j)}function D(j,Z){return Z.length===0?Z=[j]:j.end===Z[0].start?Z[0].start=j.start:Z.unshift(j),Z}function v(j,Z){for(let fe=Z;fe<j.length;fe++){const Te=j.charCodeAt(fe);if(A(Te)||_(Te)||fe>0&&!d(j.charCodeAt(fe-1)))return fe}return j.length}function f(j,Z,fe,Te){if(fe===j.length)return[];if(Te===Z.length)return null;if(j[fe]!==Z[Te].toLowerCase())return null;{let Ne=null,He=Te+1;for(Ne=f(j,Z,fe+1,Te+1);!Ne&&(He=v(Z,He))<Z.length;)Ne=f(j,Z,fe+1,He),He++;return Ne===null?null:D({start:Te,end:Te+1},Ne)}}function g(j){let Z=0,fe=0,Te=0,Ne=0,He=0;for(let rt=0;rt<j.length;rt++)He=j.charCodeAt(rt),A(He)&&Z++,C(He)&&fe++,d(He)&&Te++,_(He)&&Ne++;const Ke=Z/j.length,tt=fe/j.length,st=Te/j.length,Xe=Ne/j.length;return{upperPercent:Ke,lowerPercent:tt,alphaPercent:st,numericPercent:Xe}}function T(j){const{upperPercent:Z,lowerPercent:fe}=j;return fe===0&&Z>.6}function u(j){const{upperPercent:Z,lowerPercent:fe,alphaPercent:Te,numericPercent:Ne}=j;return fe>.2&&Z<.8&&Te>.6&&Ne<.2}function M(j){let Z=0,fe=0,Te=0,Ne=0;for(let He=0;He<j.length;He++)Te=j.charCodeAt(He),A(Te)&&Z++,C(Te)&&fe++,n(Te)&&Ne++;return(Z===0||fe===0)&&Ne===0?j.length<=30:Z<=5}function r(j,Z){if(!Z||(Z=Z.trim(),Z.length===0)||!M(j)||Z.length>60)return null;const fe=g(Z);if(!u(fe)){if(!T(fe))return null;Z=Z.toLowerCase()}let Te=null,Ne=0;for(j=j.toLowerCase();Ne<Z.length&&(Te=f(j,Z,0,Ne))===null;)Ne=v(Z,Ne+1);return Te}e.matchesCamelCase=r;function i(j,Z,fe=!1){if(!Z||Z.length===0)return null;let Te=null,Ne=0;for(j=j.toLowerCase(),Z=Z.toLowerCase();Ne<Z.length&&(Te=p(j,Z,0,Ne,fe))===null;)Ne=m(Z,Ne+1);return Te}e.matchesWords=i;function p(j,Z,fe,Te,Ne){if(fe===j.length)return[];if(Te===Z.length)return null;if(l(j.charCodeAt(fe),Z.charCodeAt(Te))){let He=null,Ke=Te+1;if(He=p(j,Z,fe+1,Te+1,Ne),!Ne)for(;!He&&(Ke=m(Z,Ke))<Z.length;)He=p(j,Z,fe+1,Ke,Ne),Ke++;return He===null?null:D({start:Te,end:Te+1},He)}else return null}function m(j,Z){for(let fe=Z;fe<j.length;fe++)if(s(j.charCodeAt(fe))||fe>0&&s(j.charCodeAt(fe-1)))return fe;return j.length}const o=w(e.matchesPrefix,r,t),b=w(e.matchesPrefix,r,R),a=new c.LRUCache(1e4);function E(j,Z,fe=!1){if(typeof j!="string"||typeof Z!="string")return null;let Te=a.get(j);Te||(Te=new RegExp(F.convertSimple2RegExpPattern(j),"i"),a.set(j,Te));const Ne=Te.exec(Z);return Ne?[{start:Ne.index,end:Ne.index+Ne[0].length}]:fe?b(j,Z):o(j,Z)}e.matchesFuzzy=E;function P(j,Z){const fe=Ge(j,j.toLowerCase(),0,Z,Z.toLowerCase(),0,!0);return fe?B(fe):null}e.matchesFuzzy2=P;function k(j,Z,fe,Te,Ne,He){const Ke=Math.min(13,j.length);for(;fe<Ke;fe++){const tt=Ge(j,Z,fe,Te,Ne,He,!1);if(tt)return tt}return[0,He]}e.anyScore=k;function B(j){if(typeof j=="undefined")return[];const Z=[],fe=j[1];for(let Te=j.length-1;Te>1;Te--){const Ne=j[Te]+fe,He=Z[Z.length-1];He&&He.end===Ne?He.end=Ne+1:Z.push({start:Ne,end:Ne+1})}return Z}e.createMatches=B;const L=128;function y(){const j=[],Z=[];for(let fe=0;fe<=L;fe++)Z[fe]=0;for(let fe=0;fe<=L;fe++)j.push(Z.slice(0));return j}function x(j){const Z=[];for(let fe=0;fe<=j;fe++)Z[fe]=0;return Z}const N=x(2*L),z=x(2*L),H=y(),q=y(),ue=y(),K=!1;function ce(j,Z,fe,Te,Ne){function He(tt,st,Xe=" "){for(;tt.length<st;)tt=Xe+tt;return tt}let Ke=` |   |${Te.split("").map(tt=>He(tt,3)).join("|")}
`;for(let tt=0;tt<=fe;tt++)tt===0?Ke+=" |":Ke+=`${Z[tt-1]}|`,Ke+=j[tt].slice(0,Ne+1).map(st=>He(st.toString(),3)).join("|")+`
`;return Ke}function de(j,Z,fe,Te){j=j.substr(Z),fe=fe.substr(Te),console.log(ce(q,j,j.length,fe,fe.length)),console.log(ce(ue,j,j.length,fe,fe.length)),console.log(ce(H,j,j.length,fe,fe.length))}function Q(j,Z){if(Z<0||Z>=j.length)return!1;const fe=j.codePointAt(Z);switch(fe){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!F.isEmojiImprecise(fe)}}function ie(j,Z){if(Z<0||Z>=j.length)return!1;switch(j.charCodeAt(Z)){case 32:case 9:return!0;default:return!1}}function we(j,Z,fe){return Z[j]!==fe[j]}function Me(j,Z,fe,Te,Ne,He,Ke=!1){for(;Z<fe&&Ne<He;)j[Z]===Te[Ne]&&(Ke&&(N[Z]=Ne),Z+=1),Ne+=1;return Z===fe}e.isPatternInWord=Me;var Fe;(function(j){j[j.Diag=1]="Diag",j[j.Left=2]="Left",j[j.LeftLeft=3]="LeftLeft"})(Fe||(Fe={}));var Be;(function(j){j.Default=[-100,0];function Z(fe){return!fe||fe.length===2&&fe[0]===-100&&fe[1]===0}j.isDefault=Z})(Be=e.FuzzyScore||(e.FuzzyScore={}));function Ge(j,Z,fe,Te,Ne,He,Ke){const tt=j.length>L?L:j.length,st=Te.length>L?L:Te.length;if(fe>=tt||He>=st||tt-fe>st-He||!Me(Z,fe,tt,Ne,He,st,!0))return;je(tt,st,fe,He,Z,Ne);let Xe=1,rt=1,De=fe,gt=He;const V=[!1];for(Xe=1,De=fe;De<tt;Xe++,De++){const Je=N[De],lt=z[De],Et=De+1<tt?z[De+1]:st;for(rt=Je-He+1,gt=Je;gt<Et;rt++,gt++){let It=Number.MIN_SAFE_INTEGER,et=!1;gt<=lt&&(It=Qe(j,Z,De,fe,Te,Ne,gt,st,He,H[Xe-1][rt-1]===0,V));let Tt=0;It!==Number.MAX_SAFE_INTEGER&&(et=!0,Tt=It+q[Xe-1][rt-1]);const Pe=gt>Je,Se=Pe?q[Xe][rt-1]+(H[Xe][rt-1]>0?-5:0):0,ve=gt>Je+1&&H[Xe][rt-1]>0,re=ve?q[Xe][rt-2]+(H[Xe][rt-2]>0?-5:0):0;if(ve&&(!Pe||re>=Se)&&(!et||re>=Tt))q[Xe][rt]=re,ue[Xe][rt]=3,H[Xe][rt]=0;else if(Pe&&(!et||Se>=Tt))q[Xe][rt]=Se,ue[Xe][rt]=2,H[Xe][rt]=0;else if(et)q[Xe][rt]=Tt,ue[Xe][rt]=1,H[Xe][rt]=H[Xe-1][rt-1]+1;else throw new Error("not possible")}}if(K&&de(j,fe,Te,He),!V[0]&&!Ke)return;Xe--,rt--;const J=[q[Xe][rt],He];let pe=0,Ue=0;for(;Xe>=1;){let Je=rt;do{const lt=ue[Xe][Je];if(lt===3)Je=Je-2;else if(lt===2)Je=Je-1;else break}while(Je>=1);pe>1&&Z[fe+Xe-1]===Ne[He+rt-1]&&!we(Je+He-1,Te,Ne)&&pe+1>H[Xe][Je]&&(Je=rt),Je===rt?pe++:pe=1,Ue||(Ue=Je),Xe--,rt=Je-1,J.push(rt)}st===tt&&(J[0]+=2);const Ye=Ue-tt;return J[0]-=Ye,J}e.fuzzyScore=Ge;function je(j,Z,fe,Te,Ne,He){let Ke=j-1,tt=Z-1;for(;Ke>=fe&&tt>=Te;)Ne[Ke]===He[tt]&&(z[Ke]=tt,Ke--),tt--}function Qe(j,Z,fe,Te,Ne,He,Ke,tt,st,Xe,rt){if(Z[fe]!==He[Ke])return Number.MIN_SAFE_INTEGER;let De=1,gt=!1;return Ke===fe-Te?De=j[fe]===Ne[Ke]?7:5:we(Ke,Ne,He)&&(Ke===0||!we(Ke-1,Ne,He))?(De=j[fe]===Ne[Ke]?7:5,gt=!0):Q(He,Ke)&&(Ke===0||!Q(He,Ke-1))?De=5:(Q(He,Ke-1)||ie(He,Ke-1))&&(De=5,gt=!0),De>1&&fe===Te&&(rt[0]=!0),gt||(gt=we(Ke,Ne,He)||Q(He,Ke-1)||ie(He,Ke-1)),fe===Te?Ke>st&&(De-=gt?3:5):Xe?De+=gt?2:0:De+=gt?0:1,Ke+1===tt&&(De-=gt?3:5),De}function $(j,Z,fe,Te,Ne,He,Ke){return X(j,Z,fe,Te,Ne,He,!0,Ke)}e.fuzzyScoreGracefulAggressive=$;function G(j,Z,fe,Te,Ne,He,Ke){return X(j,Z,fe,Te,Ne,He,!1,Ke)}e.fuzzyScoreGraceful=G;function X(j,Z,fe,Te,Ne,He,Ke,tt){let st=Ge(j,Z,fe,Te,Ne,He,tt);if(st&&!Ke)return st;if(j.length>=3){const Xe=Math.min(7,j.length-1);for(let rt=fe+1;rt<Xe;rt++){const De=se(j,rt);if(De){const gt=Ge(De,De.toLowerCase(),fe,Te,Ne,He,tt);gt&&(gt[0]-=3,(!st||gt[0]>st[0])&&(st=gt))}}}return st}function se(j,Z){if(Z+1>=j.length)return;const fe=j[Z],Te=j[Z+1];if(fe!==Te)return j.slice(0,Z)+Te+fe+j.slice(Z+2)}}),define(Ee[104],_e([0,1,53,103,9]),function(oe,e,c,F,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const I=new RegExp(`\\$\\(${c.CSSIcon.iconNameExpression}(?:${c.CSSIcon.iconModifierExpression})?\\)`,"g"),t=new RegExp(c.CSSIcon.iconNameCharacter),R=new RegExp(`(\\\\)?${I.source}`,"g");function S(d){return d.replace(R,(D,v)=>v?D:`\\${D}`)}e.escapeIcons=S;const C=new RegExp(`\\\\${I.source}`,"g");function A(d){return d.replace(C,D=>`\\${D}`)}e.markdownEscapeEscapedIcons=A;const _=new RegExp(`(\\s)?(\\\\)?${I.source}(\\s)?`,"g");function n(d){return d.indexOf(e.iconStartMarker)===-1?d:d.replace(_,(D,v,f,g)=>f?D:v||g||"")}e.stripIcons=n;function h(d){const D=d.indexOf(e.iconStartMarker);return D===-1?{text:d}:s(d,D)}e.parseLabelWithIcons=h;function s(d,D){const v=[];let f="";function g(o){if(o){f+=o;for(const b of o)v.push(M)}}let T=-1,u="",M=0,r,i,p=D;const m=d.length;for(g(d.substr(0,D));p<m;)r=d[p],i=d[p+1],r===e.iconStartMarker[0]&&i===e.iconStartMarker[1]?(T=p,g(u),u=e.iconStartMarker,p++):r===")"&&T!==-1?(M+=p-T+1,T=-1,u=""):T!==-1?t.test(r)?u+=r:(g(u),T=-1,u=""):g(r),p++;return g(u),{text:f,iconOffsets:v}}function l(d,D,v=!1){const{text:f,iconOffsets:g}=D;if(!g||g.length===0)return(0,F.matchesFuzzy)(d,f,v);const T=(0,w.ltrim)(f," "),u=f.length-T.length,M=(0,F.matchesFuzzy)(d,T,v);if(M)for(const r of M){const i=g[r.start+u]+u;r.start+=i,r.end+=i}return M}e.matchesFuzzyIconAware=l}),define(Ee[76],_e([0,1,15,104]),function(oe,e,c,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var w;(function(n){n[n.Paragraph=0]="Paragraph",n[n.Break=1]="Break"})(w=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class I{constructor(h="",s=!1){if(this.value=h,typeof this.value!="string")throw(0,c.illegalArgument)("value");typeof s=="boolean"?(this.isTrusted=s,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=s.isTrusted??void 0,this.supportThemeIcons=s.supportThemeIcons??!1,this.supportHtml=s.supportHtml??!1)}appendText(h,s=0){return this.value+=C(this.supportThemeIcons?(0,F.escapeIcons)(h):h).replace(/([ \t]+)/g,(l,d)=>"&nbsp;".repeat(d.length)).replace(/\>/gm,"\\>").replace(/\n/g,s===1?`\\
`:`

`),this}appendMarkdown(h){return this.value+=h,this}appendCodeblock(h,s){return this.value+="\n```",this.value+=h,this.value+=`
`,this.value+=s,this.value+="\n```\n",this}}e.MarkdownString=I;function t(n){return R(n)?!n.value:Array.isArray(n)?n.every(t):!0}e.isEmptyMarkdownString=t;function R(n){return n instanceof I?!0:n&&typeof n=="object"?typeof n.value=="string"&&(typeof n.isTrusted=="boolean"||n.isTrusted===void 0)&&(typeof n.supportThemeIcons=="boolean"||n.supportThemeIcons===void 0):!1}e.isMarkdownString=R;function S(n,h){return n===h?!0:!n||!h?!1:n.value===h.value&&n.isTrusted===h.isTrusted&&n.supportThemeIcons===h.supportThemeIcons}e.markdownStringEqual=S;function C(n){return n.replace(/[\\`*_{}[\]()#+\-!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=C;function A(n){return n&&n.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=A;function _(n){const h=[],s=n.split("|").map(d=>d.trim());n=s[0];const l=s[1];if(l){const d=/height=(\d+)/.exec(l),D=/width=(\d+)/.exec(l),v=d?d[1]:"",f=D?D[1]:"",g=isFinite(parseInt(f)),T=isFinite(parseInt(v));g&&h.push(`width="${f}"`),T&&h.push(`height="${v}"`)}return{href:n,dimensions:h}}e.parseHrefAndDimensions=_}),define(Ee[34],_e([0,1,9]),function(oe,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var F;(function(w){w[w.Ignore=0]="Ignore",w[w.Info=1]="Info",w[w.Warning=2]="Warning",w[w.Error=3]="Error"})(F||(F={})),function(w){const I="error",t="warning",R="warn",S="info",C="ignore";function A(n){return n?c.equalsIgnoreCase(I,n)?w.Error:c.equalsIgnoreCase(t,n)||c.equalsIgnoreCase(R,n)?w.Warning:c.equalsIgnoreCase(S,n)?w.Info:w.Ignore:w.Ignore}w.fromValue=A;function _(n){switch(n){case w.Error:return I;case w.Warning:return t;case w.Info:return S;default:return C}}w.toString=_}(F||(F={})),e.default=F}),define(Ee[43],_e([0,1,17,23,9,11]),function(oe,e,c,F,w,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function t(r){return r===47||r===92}e.isPathSeparator=t;function R(r){return r.replace(/[\\/]/g,c.posix.sep)}e.toSlashes=R;function S(r){return r.indexOf("/")===-1&&(r=R(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}e.toPosixPath=S;function C(r,i=c.posix.sep){if(!r)return"";const p=r.length,m=r.charCodeAt(0);if(t(m)){if(t(r.charCodeAt(1))&&!t(r.charCodeAt(2))){let b=3;const a=b;for(;b<p&&!t(r.charCodeAt(b));b++);if(a!==b&&!t(r.charCodeAt(b+1))){for(b+=1;b<p;b++)if(t(r.charCodeAt(b)))return r.slice(0,b+1).replace(/[\\/]/g,i)}}return i}else if(D(m)&&r.charCodeAt(1)===58)return t(r.charCodeAt(2))?r.slice(0,2)+i:r.slice(0,2);let o=r.indexOf("://");if(o!==-1){for(o+=3;o<p;o++)if(t(r.charCodeAt(o)))return r.slice(0,o+1)}return""}e.getRoot=C;function A(r){if(!F.isWindows||!r||r.length<5)return!1;let i=r.charCodeAt(0);if(i!==92||(i=r.charCodeAt(1),i!==92))return!1;let p=2;const m=p;for(;p<r.length&&(i=r.charCodeAt(p),i!==92);p++);return!(m===p||(i=r.charCodeAt(p+1),isNaN(i)||i===92))}e.isUNC=A;const _=/[\\/:\*\?"<>\|]/g,n=/[\\/]/g,h=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function s(r,i=F.isWindows){const p=i?_:n;return!(!r||r.length===0||/^\s+$/.test(r)||(p.lastIndex=0,p.test(r))||i&&h.test(r)||r==="."||r===".."||i&&r[r.length-1]==="."||i&&r.length!==r.trim().length||r.length>255)}e.isValidBasename=s;function l(r,i,p){const m=r===i;return!p||m?m:!r||!i?!1:(0,w.equalsIgnoreCase)(r,i)}e.isEqual=l;function d(r,i,p,m=c.sep){if(r===i)return!0;if(!r||!i||i.length>r.length)return!1;if(p){if(!(0,w.startsWithIgnoreCase)(r,i))return!1;if(i.length===r.length)return!0;let b=i.length;return i.charAt(i.length-1)===m&&b--,r.charAt(b)===m}return i.charAt(i.length-1)!==m&&(i+=m),r.indexOf(i)===0}e.isEqualOrParent=d;function D(r){return r>=65&&r<=90||r>=97&&r<=122}e.isWindowsDriveLetter=D;function v(r,i){return F.isWindows&&r.endsWith(":")&&(r+=c.sep),(0,c.isAbsolute)(r)||(r=(0,c.join)(i,r)),r=(0,c.normalize)(r),F.isWindows?(r=(0,w.rtrim)(r,c.sep),r.endsWith(":")&&(r+=c.sep)):(r=(0,w.rtrim)(r,c.sep),r||(r=c.sep)),r}e.sanitizeFilePath=v;function f(r){const i=(0,c.normalize)(r);return F.isWindows?r.length>3?!1:g(i)&&(r.length===2||i.charCodeAt(2)===92):i===c.posix.sep}e.isRootOrDriveLetter=f;function g(r,i){return(i!==void 0?i:F.isWindows)?D(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.hasDriveLetter=g;function T(r){return g(r)?r[0]:void 0}e.getDriveLetter=T;function u(r,i,p){return i.length>r.length?-1:r===i?0:(p&&(r=r.toLowerCase(),i=i.toLowerCase()),r.indexOf(i))}e.indexOfPath=u;function M(r){const i=r.split(":");let p,m,o;if(i.forEach(b=>{const a=Number(b);(0,I.isNumber)(a)?m===void 0?m=a:o===void 0&&(o=a):p=p?[p,b].join(":"):b}),!p)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:p,line:m!==void 0?m:void 0,column:o!==void 0?o:m!==void 0?1:void 0}}e.parseLineAndColumnAware=M}),define(Ee[54],_e([0,1,22,9,2]),function(oe,e,c,F,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function I(A){return JSON.stringify(A,S)}e.stringify=I;function t(A){let _=JSON.parse(A);return _=C(_),_}e.parse=t;var R;(function(A){A[A.Uri=1]="Uri",A[A.Regexp=2]="Regexp",A[A.ScmResource=3]="ScmResource",A[A.ScmResourceGroup=4]="ScmResourceGroup",A[A.ScmProvider=5]="ScmProvider",A[A.CommentController=6]="CommentController",A[A.CommentThread=7]="CommentThread",A[A.CommentThreadReply=8]="CommentThreadReply",A[A.CommentNode=9]="CommentNode",A[A.CommentThreadNode=10]="CommentThreadNode",A[A.TimelineActionContext=11]="TimelineActionContext",A[A.NotebookCellActionContext=12]="NotebookCellActionContext",A[A.TestItemContext=13]="TestItemContext"})(R=e.MarshalledId||(e.MarshalledId={}));function S(A,_){return _ instanceof RegExp?{$mid:2,source:_.source,flags:(0,F.regExpFlags)(_)}:_}function C(A,_=0){if(!A||_>200)return A;if(typeof A=="object"){switch(A.$mid){case 1:return w.URI.revive(A);case 2:return new RegExp(A.source,A.flags)}if(A instanceof c.VSBuffer||A instanceof Uint8Array)return A;if(Array.isArray(A))for(let n=0;n<A.length;++n)A[n]=C(A[n],_+1);else for(const n in A)Object.hasOwnProperty.call(A,n)&&(A[n]=C(A[n],_+1))}return A}e.revive=C});var xe=this&&this.__decorate||function(oe,e,c,F){var w=arguments.length,I=w<3?e:F===null?F=Object.getOwnPropertyDescriptor(e,c):F,t;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")I=Reflect.decorate(oe,e,c,F);else for(var R=oe.length-1;R>=0;R--)(t=oe[R])&&(I=(w<3?t(I):w>3?t(e,c,I):t(e,c))||I);return w>3&&I&&Object.defineProperty(e,c,I),I};define(Ee[10],_e([0,1,42,23,2]),function(oe,e,c,F,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var I;(function(S){S.inMemory="inmemory",S.vscode="vscode",S.internal="private",S.walkThrough="walkThrough",S.walkThroughSnippet="walkThroughSnippet",S.http="http",S.https="https",S.file="file",S.mailto="mailto",S.untitled="untitled",S.data="data",S.command="command",S.vscodeRemote="vscode-remote",S.vscodeRemoteResource="vscode-remote-resource",S.userData="vscode-userdata",S.vscodeCustomEditor="vscode-custom-editor",S.vscodeNotebook="vscode-notebook",S.vscodeNotebookCell="vscode-notebook-cell",S.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",S.vscodeNotebookCellOutput="vscode-notebook-cell-output",S.vscodeInteractive="vscode-interactive",S.vscodeInteractiveInput="vscode-interactive-input",S.vscodeSettings="vscode-settings",S.vscodeWorkspaceTrust="vscode-workspace-trust",S.vscodeTerminal="vscode-terminal",S.webviewPanel="webview-panel",S.vscodeWebview="vscode-webview",S.extension="extension",S.vscodeFileResource="vscode-file",S.tmp="tmp",S.vsls="vsls"})(I=e.Schemas||(e.Schemas={}));class t{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(C){this._preferredWebSchema=C}setDelegate(C){this._delegate=C}set(C,A,_){this._hosts[C]=A,this._ports[C]=_}setConnectionToken(C,A){this._connectionTokens[C]=A}get remoteResourcePath(){if(F.isWeb){const C=w.URI.parse(window.location.toString());return w.URI.joinPath(C,I.vscodeRemoteResource).path}return`/${I.vscodeRemoteResource}`}rewrite(C){if(this._delegate)return this._delegate(C);const A=C.authority;let _=this._hosts[A];_&&_.indexOf(":")!==-1&&(_=`[${_}]`);const n=this._ports[A],h=this._connectionTokens[A];let s=`path=${encodeURIComponent(C.path)}`;return typeof h=="string"&&(s+=`&tkn=${encodeURIComponent(h)}`),w.URI.from({scheme:F.isWeb?this._preferredWebSchema:I.vscodeRemoteResource,authority:`${_}:${n}`,path:this.remoteResourcePath,query:s})}}xe([c.memoize],t.prototype,"remoteResourcePath",null),e.RemoteAuthorities=new t;class R{asBrowserUri(C,A){const _=this.toUri(C,A);return _.scheme===I.vscodeRemote?e.RemoteAuthorities.rewrite(_):_.scheme===I.file&&(F.isNative||typeof F.globals.importScripts=="function"&&F.globals.origin===`${I.vscodeFileResource}://${R.FALLBACK_AUTHORITY}`)?_.with({scheme:I.vscodeFileResource,authority:_.authority||R.FALLBACK_AUTHORITY,query:null,fragment:null}):_}asFileUri(C,A){const _=this.toUri(C,A);return _.scheme===I.vscodeFileResource?_.with({scheme:I.file,authority:_.authority!==R.FALLBACK_AUTHORITY?_.authority:null,query:null,fragment:null}):_}toUri(C,A){return w.URI.isUri(C)?C:w.URI.parse(A.toUrl(C))}}R.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new R}),define(Ee[24],_e([0,1,43,10,17,23,9,2]),function(oe,e,c,F,w,I,t,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function S(h){return(0,R.uriToFsPath)(h,!0)}e.originalFSPath=S;class C{constructor(s){this._ignorePathCasing=s}compare(s,l,d=!1){return s===l?0:(0,t.compare)(this.getComparisonKey(s,d),this.getComparisonKey(l,d))}isEqual(s,l,d=!1){return s===l?!0:!s||!l?!1:this.getComparisonKey(s,d)===this.getComparisonKey(l,d)}getComparisonKey(s,l=!1){return s.with({path:this._ignorePathCasing(s)?s.path.toLowerCase():void 0,fragment:l?null:void 0}).toString()}ignorePathCasing(s){return this._ignorePathCasing(s)}isEqualOrParent(s,l,d=!1){if(s.scheme===l.scheme){if(s.scheme===F.Schemas.file)return c.isEqualOrParent(S(s),S(l),this._ignorePathCasing(s))&&s.query===l.query&&(d||s.fragment===l.fragment);if((0,e.isEqualAuthority)(s.authority,l.authority))return c.isEqualOrParent(s.path,l.path,this._ignorePathCasing(s),"/")&&s.query===l.query&&(d||s.fragment===l.fragment)}return!1}joinPath(s,...l){return R.URI.joinPath(s,...l)}basenameOrAuthority(s){return(0,e.basename)(s)||s.authority}basename(s){return w.posix.basename(s.path)}extname(s){return w.posix.extname(s.path)}dirname(s){if(s.path.length===0)return s;let l;return s.scheme===F.Schemas.file?l=R.URI.file(w.dirname(S(s))).path:(l=w.posix.dirname(s.path),s.authority&&l.length&&l.charCodeAt(0)!==47&&(console.error(`dirname("${s.toString})) resulted in a relative path`),l="/")),s.with({path:l})}normalizePath(s){if(!s.path.length)return s;let l;return s.scheme===F.Schemas.file?l=R.URI.file(w.normalize(S(s))).path:l=w.posix.normalize(s.path),s.with({path:l})}relativePath(s,l){if(s.scheme!==l.scheme||!(0,e.isEqualAuthority)(s.authority,l.authority))return;if(s.scheme===F.Schemas.file){const v=w.relative(S(s),S(l));return I.isWindows?c.toSlashes(v):v}let d=s.path||"/",D=l.path||"/";if(this._ignorePathCasing(s)){let v=0;for(const f=Math.min(d.length,D.length);v<f&&!(d.charCodeAt(v)!==D.charCodeAt(v)&&d.charAt(v).toLowerCase()!==D.charAt(v).toLowerCase());v++);d=D.substr(0,v)+d.substr(v)}return w.posix.relative(d,D)}resolvePath(s,l){if(s.scheme===F.Schemas.file){const d=R.URI.file(w.resolve(S(s),l));return s.with({authority:d.authority,path:d.path})}return l=c.toPosixPath(l),s.with({path:w.posix.resolve(s.path,l)})}isAbsolutePath(s){return!!s.path&&s.path[0]==="/"}isEqualAuthority(s,l){return s===l||s!==void 0&&l!==void 0&&(0,t.equalsIgnoreCase)(s,l)}hasTrailingPathSeparator(s,l=w.sep){if(s.scheme===F.Schemas.file){const d=S(s);return d.length>c.getRoot(d).length&&d[d.length-1]===l}else{const d=s.path;return d.length>1&&d.charCodeAt(d.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(s.fsPath)}}removeTrailingPathSeparator(s,l=w.sep){return(0,e.hasTrailingPathSeparator)(s,l)?s.with({path:s.path.substr(0,s.path.length-1)}):s}addTrailingPathSeparator(s,l=w.sep){let d=!1;if(s.scheme===F.Schemas.file){const D=S(s);d=D!==void 0&&D.length===c.getRoot(D).length&&D[D.length-1]===l}else{l="/";const D=s.path;d=D.length===1&&D.charCodeAt(D.length-1)===47}return!d&&!(0,e.hasTrailingPathSeparator)(s,l)?s.with({path:s.path+"/"}):s}}e.ExtUri=C,e.extUri=new C(()=>!1),e.extUriBiasedIgnorePathCase=new C(h=>h.scheme===F.Schemas.file?!I.isLinux:!0),e.extUriIgnorePathCase=new C(h=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function A(h,s){const l=[];for(let d=0;d<h.length;d++){const D=s(h[d]);h.some((v,f)=>f===d?!1:(0,e.isEqualOrParent)(D,s(v)))||l.push(h[d])}return l}e.distinctParents=A;var _;(function(h){h.META_DATA_LABEL="label",h.META_DATA_DESCRIPTION="description",h.META_DATA_SIZE="size",h.META_DATA_MIME="mime";function s(l){const d=new Map;l.path.substring(l.path.indexOf(";")+1,l.path.lastIndexOf(";")).split(";").forEach(f=>{const[g,T]=f.split(":");g&&T&&d.set(g,T)});const v=l.path.substring(0,l.path.indexOf(";"));return v&&d.set(h.META_DATA_MIME,v),d}h.parseMetaData=s})(_=e.DataUri||(e.DataUri={}));function n(h,s,l){if(s){let d=h.path;return d&&d[0]!==w.posix.sep&&(d=w.posix.sep+d),h.with({scheme:l,authority:s,path:d})}return h.with({scheme:l})}e.toLocalResource=n}),define(Ee[14],_e([0,1,20,15,3,6,24,23]),function(oe,e,c,F,w,I,t,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function S(de){return!!de&&typeof de.then=="function"}e.isThenable=S;function C(de){const Q=new c.CancellationTokenSource,ie=de(Q.token),we=new Promise((Me,Fe)=>{const Be=Q.token.onCancellationRequested(()=>{Be.dispose(),Q.dispose(),Fe((0,F.canceled)())});Promise.resolve(ie).then(Ge=>{Be.dispose(),Q.dispose(),Me(Ge)},Ge=>{Be.dispose(),Q.dispose(),Fe(Ge)})});return new class{cancel(){Q.cancel()}then(Me,Fe){return we.then(Me,Fe)}catch(Me){return this.then(void 0,Me)}finally(Me){return we.finally(Me)}}}e.createCancelablePromise=C;function A(de,Q,ie){return Promise.race([de,new Promise(we=>Q.onCancellationRequested(()=>we(ie)))])}e.raceCancellation=A;async function _(de){let Q=-1;const ie=de.map((Me,Fe)=>Me.then(Be=>(Q=Fe,Be))),we=await Promise.race(ie);return de.forEach((Me,Fe)=>{Fe!==Q&&Me.cancel()}),we}e.raceCancellablePromises=_;function n(de,Q,ie){let we;const Me=setTimeout(()=>{we?.(void 0),ie?.()},Q);return Promise.race([de.finally(()=>clearTimeout(Me)),new Promise(Fe=>we=Fe)])}e.raceTimeout=n;function h(de){return new Promise((Q,ie)=>{const we=de();S(we)?we.then(Q,ie):Q(we)})}e.asPromise=h;class s{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(Q){if(this.activePromise){if(this.queuedPromiseFactory=Q,!this.queuedPromise){const ie=()=>{this.queuedPromise=null;const we=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,we};this.queuedPromise=new Promise(we=>{this.activePromise.then(ie,ie).then(we)})}return new Promise((ie,we)=>{this.queuedPromise.then(ie,we)})}return this.activePromise=Q(),new Promise((ie,we)=>{this.activePromise.then(Me=>{this.activePromise=null,ie(Me)},Me=>{this.activePromise=null,we(Me)})})}}e.Throttler=s;class l{constructor(){this.current=Promise.resolve(null)}queue(Q){return this.current=this.current.then(()=>Q(),()=>Q())}}e.Sequencer=l;class d{constructor(){this.promiseMap=new Map}queue(Q,ie){const Me=(this.promiseMap.get(Q)??Promise.resolve()).catch(()=>{}).then(ie).finally(()=>{this.promiseMap.get(Q)===Me&&this.promiseMap.delete(Q)});return this.promiseMap.set(Q,Me),Me}}e.SequencerByKey=d;class D{constructor(Q){this.defaultDelay=Q,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(Q,ie=this.defaultDelay){return this.task=Q,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((we,Me)=>{this.doResolve=we,this.doReject=Me}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const we=this.task;return this.task=null,we()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},ie),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,F.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=D;class v{constructor(Q){this.delayer=new D(Q),this.throttler=new s}trigger(Q,ie){return this.delayer.trigger(()=>this.throttler.queue(Q),ie)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=v;class f{constructor(){this._isOpen=!1,this._promise=new Promise((Q,ie)=>{this._completePromise=Q})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=f;class g extends f{constructor(Q){super();this._timeout=setTimeout(()=>this.open(),Q)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=g;function T(de,Q){return Q?new Promise((ie,we)=>{const Me=setTimeout(()=>{Fe.dispose(),ie()},de),Fe=Q.onCancellationRequested(()=>{clearTimeout(Me),Fe.dispose(),we((0,F.canceled)())})}):C(ie=>T(de,ie))}e.timeout=T;function u(de,Q=0){const ie=setTimeout(de,Q);return(0,I.toDisposable)(()=>clearTimeout(ie))}e.disposableTimeout=u;function M(de){const Q=[];let ie=0;const we=de.length;function Me(){return ie<we?de[ie++]():null}function Fe(Be){Be!=null&&Q.push(Be);const Ge=Me();return Ge?Ge.then(Fe):Promise.resolve(Q)}return Promise.resolve(null).then(Fe)}e.sequence=M;function r(de,Q=we=>!!we,ie=null){let we=0;const Me=de.length,Fe=()=>{if(we>=Me)return Promise.resolve(ie);const Be=de[we++];return Promise.resolve(Be()).then(je=>Q(je)?Promise.resolve(je):Fe())};return Fe()}e.first=r;function i(de,Q=we=>!!we,ie=null){if(de.length===0)return Promise.resolve(ie);let we=de.length;const Me=()=>{we=-1;for(const Fe of de)Fe.cancel?.()};return new Promise((Fe,Be)=>{for(const Ge of de)Ge.then(je=>{--we>=0&&Q(je)?(Me(),Fe(je)):we===0&&Fe(ie)}).catch(je=>{--we>=0&&(Me(),Be(je))})})}e.firstParallel=i;class p{constructor(Q){this._size=0,this.maxDegreeOfParalellism=Q,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new w.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(Q){return this._size++,new Promise((ie,we)=>{this.outstandingPromises.push({factory:Q,c:ie,e:we}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const Q=this.outstandingPromises.shift();this.runningPromises++;const ie=Q.factory();ie.then(Q.c,Q.e),ie.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=p;class m extends p{constructor(){super(1)}}e.Queue=m;class o{constructor(){this.queues=new Map}queueFor(Q,ie=t.extUri){const we=ie.getComparisonKey(Q);let Me=this.queues.get(we);return Me||(Me=new m,w.Event.once(Me.onFinished)(()=>{Me?.dispose(),this.queues.delete(we)}),this.queues.set(we,Me)),Me}dispose(){this.queues.forEach(Q=>Q.dispose()),this.queues.clear()}}e.ResourceQueue=o;class b{constructor(Q,ie){this._token=-1,typeof Q=="function"&&typeof ie=="number"&&this.setIfNotSet(Q,ie)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(Q,ie){this.cancel(),this._token=setTimeout(()=>{this._token=-1,Q()},ie)}setIfNotSet(Q,ie){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,Q()},ie))}}e.TimeoutTimer=b;class a{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(Q,ie){this.cancel(),this._token=setInterval(()=>{Q()},ie)}}e.IntervalTimer=a;class E{constructor(Q,ie){this.timeoutToken=-1,this.runner=Q,this.timeout=ie,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(Q=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,Q)}get delay(){return this.timeout}set delay(Q){this.timeout=Q}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=E;class P{constructor(Q,ie){ie%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ie}ms is not a multiple of 1000ms.`),this.runner=Q,this.timeout=ie,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(Q=this.timeout){Q%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Q}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(Q/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=P;class k extends E{constructor(Q,ie){super(Q,ie);this.units=[]}work(Q){this.units.push(Q),this.isScheduled()||this.schedule()}doRun(){const Q=this.units;this.units=[],this.runner&&this.runner(Q)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=k;class B extends I.Disposable{constructor(Q,ie,we,Me){super();this.maxWorkChunkSize=Q,this.maxPendingWork=ie,this.throttleDelay=we,this.handler=Me,this.pendingWork=[],this.throttler=this._register(new I.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(Q){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+Q.length>this.maxPendingWork)return!1}else if(this.pending+Q.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...Q),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new E(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=B,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=de=>{(0,R.setTimeout0)(()=>{if(Q)return;const ie=Date.now()+3;de(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,ie-Date.now())}}))});let Q=!1;return{dispose(){Q||(Q=!0)}}}:e.runWhenIdle=(de,Q)=>{const ie=requestIdleCallback(de,typeof Q=="number"?{timeout:Q}:void 0);let we=!1;return{dispose(){we||(we=!0,cancelIdleCallback(ie))}}}}();class L{constructor(Q){this._didRun=!1,this._executor=()=>{try{this._value=Q()}catch(ie){this._error=ie}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=L;async function y(de,Q,ie){let we;for(let Me=0;Me<ie;Me++)try{return await de()}catch(Fe){we=Fe,await T(Q)}throw we}e.retry=y;class x{hasPending(Q){return this._pending?typeof Q=="number"?this._pending.taskId===Q:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(Q,ie,we){return this._pending={taskId:Q,cancel:()=>we?.(),promise:ie},ie.then(()=>this.donePending(Q),()=>this.donePending(Q)),ie}donePending(Q){this._pending&&Q===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const Q=this._next;this._next=void 0,Q.run().then(Q.promiseResolve,Q.promiseReject)}}setNext(Q){if(this._next)this._next.run=Q;else{let ie,we;const Me=new Promise((Fe,Be)=>{ie=Fe,we=Be});this._next={run:Q,promise:Me,promiseResolve:ie,promiseReject:we}}return this._next.promise}}e.TaskSequentializer=x;class N{constructor(Q,ie=()=>Date.now()){this.interval=Q,this.nowFn=ie,this.lastIncrementTime=0,this.value=0}increment(){const Q=this.nowFn();return Q-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=Q,this.value=0),this.value++,this.value}}e.IntervalCounter=N;class z{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((Q,ie)=>{this.completeCallback=Q,this.errorCallback=ie})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(Q){return new Promise(ie=>{this.completeCallback(Q),this.resolved=!0,ie()})}error(Q){return new Promise(ie=>{this.errorCallback(Q),this.rejected=!0,ie()})}cancel(){new Promise(Q=>{this.errorCallback((0,F.canceled)()),this.rejected=!0,Q()})}}e.DeferredPromise=z;var H;(function(de){async function Q(we){let Me;const Fe=await Promise.all(we.map(Be=>Be.then(Ge=>Ge,Ge=>{Me||(Me=Ge)})));if(typeof Me!="undefined")throw Me;return Fe}de.settled=Q;function ie(we){return new Promise(async(Me,Fe)=>{try{await we(Me,Fe)}catch(Be){Fe(Be)}})}de.withAsyncBody=ie})(H=e.Promises||(e.Promises={}));var q;(function(de){de[de.Initial=0]="Initial",de[de.DoneOK=1]="DoneOK",de[de.DoneError=2]="DoneError"})(q||(q={}));class ue{constructor(Q){this._state=0,this._results=[],this._error=null,this._onStateChanged=new w.Emitter,queueMicrotask(async()=>{const ie={emitOne:we=>this.emitOne(we),emitMany:we=>this.emitMany(we),reject:we=>this.reject(we)};try{await Promise.resolve(Q(ie)),this.resolve()}catch(we){this.reject(we)}finally{ie.emitOne=void 0,ie.emitMany=void 0,ie.reject=void 0}})}static fromArray(Q){return new ue(ie=>{ie.emitMany(Q)})}static fromPromise(Q){return new ue(async ie=>{ie.emitMany(await Q)})}static fromPromises(Q){return new ue(async ie=>{await Promise.all(Q.map(async we=>ie.emitOne(await we)))})}static merge(Q){return new ue(async ie=>{await Promise.all(Q.map(async we=>{for await(const Me of we)ie.emitOne(Me)}))})}[Symbol.asyncIterator](){let Q=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(Q<this._results.length)return{done:!1,value:this._results[Q++]};if(this._state===1)return{done:!0,value:void 0};await w.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(Q,ie){return new ue(async we=>{for await(const Me of Q)we.emitOne(ie(Me))})}map(Q){return ue.map(this,Q)}static filter(Q,ie){return new ue(async we=>{for await(const Me of Q)ie(Me)&&we.emitOne(Me)})}filter(Q){return ue.filter(this,Q)}static coalesce(Q){return ue.filter(Q,ie=>!!ie)}coalesce(){return ue.coalesce(this)}static async toPromise(Q){const ie=[];for await(const we of Q)ie.push(we);return ie}toPromise(){return ue.toPromise(this)}emitOne(Q){this._state===0&&(this._results.push(Q),this._onStateChanged.fire())}emitMany(Q){this._state===0&&(this._results=this._results.concat(Q),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(Q){this._state===0&&(this._state=2,this._error=Q,this._onStateChanged.fire())}}e.AsyncIterableObject=ue,ue.EMPTY=ue.fromArray([]);class K extends ue{constructor(Q,ie){super(ie);this._source=Q}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=K;function ce(de){const Q=new c.CancellationTokenSource,ie=de(Q.token);return new K(Q,async we=>{const Me=Q.token.onCancellationRequested(()=>{Me.dispose(),Q.dispose(),we.reject((0,F.canceled)())});try{for await(const Fe of ie){if(Q.token.isCancellationRequested)return;we.emitOne(Fe)}Me.dispose(),Q.dispose()}catch(Fe){Me.dispose(),Q.dispose(),we.reject(Fe)}})}e.createCancelableAsyncIterable=ce}),define(Ee[105],_e([0,1,14,17]),function(oe,e,c,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const w=new c.IdleValue(()=>{const a=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:a,collatorIsNumeric:a.resolvedOptions().numeric}}),I=new c.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),t=new c.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function R(a,E,P=!1){const k=a||"",B=E||"",L=w.value.collator.compare(k,B);return w.value.collatorIsNumeric&&L===0&&k!==B?k<B?-1:1:L}e.compareFileNames=R;function S(a,E){const P=I.value.collator;return a=a||"",E=E||"",T(P,a,E)}e.compareFileNamesDefault=S;function C(a,E){const P=I.value.collator;return a=a||"",E=E||"",i(a,E)||T(P,a,E)}e.compareFileNamesUpper=C;function A(a,E){const P=I.value.collator;return a=a||"",E=E||"",r(a,E)||T(P,a,E)}e.compareFileNamesLower=A;function _(a,E){return a=a||"",E=E||"",a===E?0:a<E?-1:1}e.compareFileNamesUnicode=_;function n(a,E,P=!1){P||(a=a&&a.toLowerCase(),E=E&&E.toLowerCase());const[k,B]=f(a),[L,y]=f(E);return k!==L?k<L?-1:1:B===y?0:B<y?-1:1}e.noIntlCompareFileNames=n;function h(a,E){const[P,k]=f(a),[B,L]=f(E);let y=w.value.collator.compare(k,L);if(y===0){if(w.value.collatorIsNumeric&&k!==L)return k<L?-1:1;if(y=w.value.collator.compare(P,B),w.value.collatorIsNumeric&&y===0&&P!==B)return P<B?-1:1}return y}e.compareFileExtensions=h;function s(a,E){a=a||"",E=E||"";const P=g(a),k=g(E),B=I.value.collator,L=t.value.collator;return T(L,P,k)||T(B,a,E)}e.compareFileExtensionsDefault=s;function l(a,E){a=a||"",E=E||"";const P=g(a),k=g(E),B=I.value.collator,L=t.value.collator;return T(L,P,k)||i(a,E)||T(B,a,E)}e.compareFileExtensionsUpper=l;function d(a,E){a=a||"",E=E||"";const P=g(a),k=g(E),B=I.value.collator,L=t.value.collator;return T(L,P,k)||r(a,E)||T(B,a,E)}e.compareFileExtensionsLower=d;function D(a,E){a=a||"",E=E||"";const P=g(a).toLowerCase(),k=g(E).toLowerCase();return P!==k?P<k?-1:1:a!==E?a<E?-1:1:0}e.compareFileExtensionsUnicode=D;const v=/^(.*?)(\.([^.]*))?$/;function f(a,E=!1){const P=a?v.exec(a):[];let k=[P&&P[1]||"",P&&P[3]||""];return E&&(!k[0]&&k[1]||k[0]&&k[0].charAt(0)===".")&&(k=[k[0]+"."+k[1],""]),k}function g(a){const E=a?v.exec(a):[];return E&&E[1]&&E[1].charAt(0)!=="."&&E[3]||""}function T(a,E,P){let k=a.compare(E,P);return k!==0?k:E.length!==P.length?E.length<P.length?-1:1:0}function u(a){const E=a.charAt(0);return E.toLocaleUpperCase()!==E}function M(a){const E=a.charAt(0);return E.toLocaleLowerCase()!==E}function r(a,E){return u(a)&&M(E)?-1:M(a)&&u(E)?1:0}function i(a,E){return M(a)&&u(E)?-1:u(a)&&M(E)?1:0}function p(a,E,P=!1){return P||(a=a&&a.toLowerCase(),E=E&&E.toLowerCase()),a===E?0:a<E?-1:1}function m(a,E,P=!1){const k=a.split(F.sep),B=E.split(F.sep),L=k.length-1,y=B.length-1;let x,N;for(let z=0;;z++){if(x=L===z,N=y===z,x&&N)return R(k[z],B[z],P);if(x)return-1;if(N)return 1;const H=p(k[z],B[z],P);if(H!==0)return H}}e.comparePaths=m;function o(a,E,P){const k=a.toLowerCase(),B=E.toLowerCase(),L=b(a,E,P);if(L)return L;const y=k.endsWith(P),x=B.endsWith(P);if(y!==x)return y?-1:1;const N=R(k,B);return N!==0?N:k.localeCompare(B)}e.compareAnything=o;function b(a,E,P){const k=a.toLowerCase(),B=E.toLowerCase(),L=k.startsWith(P),y=B.startsWith(P);if(L!==y)return L?-1:1;if(L&&y){if(k.length<B.length)return-1;if(k.length>B.length)return 1}return 0}e.compareByPrefix=b}),define(Ee[29],_e([0,1,14,43,21,17,9]),function(oe,e,c,F,w,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function R(){return Object.create(null)}e.getEmptyExpression=R;const S="**",C="/",A="[/\\\\]",_="[^/\\\\]",n=/\//g;function h(K){switch(K){case 0:return"";case 1:return`${_}*?`;default:return`(?:${A}|${_}+${A}|${A}${_}+)*?`}}function s(K,ce){if(!K)return[];const de=[];let Q=!1,ie=!1,we="";for(const Me of K){switch(Me){case ce:if(!Q&&!ie){de.push(we),we="";continue}break;case"{":Q=!0;break;case"}":Q=!1;break;case"[":ie=!0;break;case"]":ie=!1;break}we+=Me}return we&&de.push(we),de}e.splitGlobAware=s;function l(K){if(!K)return"";let ce="";const de=s(K,C);if(de.every(Q=>Q===S))ce=".*";else{let Q=!1;de.forEach((ie,we)=>{if(ie===S){Q||(ce+=h(2),Q=!0);return}let Me=!1,Fe="",Be=!1,Ge="";for(const je of ie){if(je!=="}"&&Me){Fe+=je;continue}if(Be&&(je!=="]"||!Ge)){let Qe;je==="-"?Qe=je:(je==="^"||je==="!")&&!Ge?Qe="^":je===C?Qe="":Qe=t.escapeRegExpCharacters(je),Ge+=Qe;continue}switch(je){case"{":Me=!0;continue;case"[":Be=!0;continue;case"}":ce+=`(?:${s(Fe,",").map(G=>l(G)).join("|")})`,Me=!1,Fe="";break;case"]":ce+="["+Ge+"]",Be=!1,Ge="";break;case"?":ce+=_;continue;case"*":ce+=h(1);continue;default:ce+=t.escapeRegExpCharacters(je)}}we<de.length-1&&(de[we+1]!==S||we+2<de.length)&&(ce+=A),Q=!1})}return ce}const d=/^\*\*\/\*\.[\w\.-]+$/,D=/^\*\*\/([\w\.-]+)\/?$/,v=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,f=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,g=/^\*\*((\/[\w\.-]+)+)\/?$/,T=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,u=new w.LRUCache(1e4),M=function(){return!1},r=function(){return null};function i(K,ce){if(!K)return r;let de;typeof K!="string"?de=K.pattern:de=K,de=de.trim();const Q=`${de}_${!!ce.trimForExclusions}`;let ie=u.get(Q);if(ie)return p(ie,K);let we;if(d.test(de)){const Me=de.substr(4);ie=function(Fe,Be){return typeof Fe=="string"&&Fe.endsWith(Me)?de:null}}else(we=D.exec(m(de,ce)))?ie=o(we[1],de):(ce.trimForExclusions?f:v).test(de)?ie=b(de,ce):(we=g.exec(m(de,ce)))?ie=a(we[1].substr(1),de,!0):(we=T.exec(m(de,ce)))?ie=a(we[1],de,!1):ie=E(de);return u.set(Q,ie),p(ie,K)}function p(K,ce){return typeof ce=="string"?K:function(de,Q){return F.isEqualOrParent(de,ce.base)?K(I.relative(ce.base,de),Q):null}}function m(K,ce){return ce.trimForExclusions&&K.endsWith("/**")?K.substr(0,K.length-2):K}function o(K,ce){const de=`/${K}`,Q=`\\${K}`,ie=function(Me,Fe){return typeof Me!="string"?null:Fe?Fe===K?ce:null:Me===K||Me.endsWith(de)||Me.endsWith(Q)?ce:null},we=[K];return ie.basenames=we,ie.patterns=[ce],ie.allBasenames=we,ie}function b(K,ce){const de=ue(K.slice(1,-1).split(",").map(Fe=>i(Fe,ce)).filter(Fe=>Fe!==r),K),Q=de.length;if(!Q)return r;if(Q===1)return de[0];const ie=function(Fe,Be){for(let Ge=0,je=de.length;Ge<je;Ge++)if(de[Ge](Fe,Be))return K;return null},we=de.find(Fe=>!!Fe.allBasenames);we&&(ie.allBasenames=we.allBasenames);const Me=de.reduce((Fe,Be)=>Be.allPaths?Fe.concat(Be.allPaths):Fe,[]);return Me.length&&(ie.allPaths=Me),ie}function a(K,ce,de){const Q=I.sep===I.posix.sep,ie=Q?K:K.replace(n,I.sep),we=I.sep+ie,Me=I.posix.sep+K,Fe=de?function(Be,Ge){return typeof Be=="string"&&(Be===ie||Be.endsWith(we)||!Q&&(Be===K||Be.endsWith(Me)))?ce:null}:function(Be,Ge){return typeof Be=="string"&&(Be===ie||!Q&&Be===K)?ce:null};return Fe.allPaths=[(de?"*/":"./")+K],Fe}function E(K){try{const ce=new RegExp(`^${l(K)}$`);return function(de){return ce.lastIndex=0,typeof de=="string"&&ce.test(de)?K:null}}catch(ce){return r}}function P(K,ce,de){return!K||typeof ce!="string"?!1:k(K)(ce,void 0,de)}e.match=P;function k(K,ce={}){if(!K)return M;if(typeof K=="string"||x(K)){const de=i(K,ce);if(de===r)return M;const Q=function(ie,we){return!!de(ie,we)};return de.allBasenames&&(Q.allBasenames=de.allBasenames),de.allPaths&&(Q.allPaths=de.allPaths),Q}return H(K,ce)}e.parse=k;function B(K){if(!K)return;let ce;return de=>(ce||(ce=(K()||Promise.resolve([])).then(Q=>Q?y(Q):{})),ce.then(Q=>!!Q[de]))}e.hasSiblingPromiseFn=B;function L(K){if(!K)return;let ce;return de=>{if(!ce){const Q=K();ce=Q?y(Q):{}}return!!ce[de]}}e.hasSiblingFn=L;function y(K){const ce={};for(const de of K)ce[de]=!0;return ce}function x(K){const ce=K;return ce&&typeof ce.base=="string"&&typeof ce.pattern=="string"}e.isRelativePattern=x;function N(K){return K.allBasenames||[]}e.getBasenameTerms=N;function z(K){return K.allPaths||[]}e.getPathTerms=z;function H(K,ce){const de=ue(Object.getOwnPropertyNames(K).map(Fe=>q(Fe,K[Fe],ce)).filter(Fe=>Fe!==r)),Q=de.length;if(!Q)return r;if(!de.some(Fe=>!!Fe.requiresSiblings)){if(Q===1)return de[0];const Fe=function(je,Qe){for(let $=0,G=de.length;$<G;$++){const X=de[$](je,Qe);if(X)return X}return null},Be=de.find(je=>!!je.allBasenames);Be&&(Fe.allBasenames=Be.allBasenames);const Ge=de.reduce((je,Qe)=>Qe.allPaths?je.concat(Qe.allPaths):je,[]);return Ge.length&&(Fe.allPaths=Ge),Fe}const ie=function(Fe,Be,Ge){let je;for(let Qe=0,$=de.length;Qe<$;Qe++){const G=de[Qe];G.requiresSiblings&&Ge&&(Be||(Be=I.basename(Fe)),je||(je=Be.substr(0,Be.length-I.extname(Fe).length)));const X=G(Fe,Be,je,Ge);if(X)return X}return null},we=de.find(Fe=>!!Fe.allBasenames);we&&(ie.allBasenames=we.allBasenames);const Me=de.reduce((Fe,Be)=>Be.allPaths?Fe.concat(Be.allPaths):Fe,[]);return Me.length&&(ie.allPaths=Me),ie}function q(K,ce,de){if(ce===!1)return r;const Q=i(K,de);if(Q===r)return r;if(typeof ce=="boolean")return Q;if(ce){const ie=ce.when;if(typeof ie=="string"){const we=(Me,Fe,Be,Ge)=>{if(!Ge||!Q(Me,Fe))return null;const je=ie.replace("$(basename)",Be),Qe=Ge(je);return(0,c.isThenable)(Qe)?Qe.then($=>$?K:null):Qe?K:null};return we.requiresSiblings=!0,we}}return Q}function ue(K,ce){const de=K.filter(Fe=>!!Fe.basenames);if(de.length<2)return K;const Q=de.reduce((Fe,Be)=>{const Ge=Be.basenames;return Ge?Fe.concat(Ge):Fe},[]);let ie;if(ce){ie=[];for(let Fe=0,Be=Q.length;Fe<Be;Fe++)ie.push(ce)}else ie=de.reduce((Fe,Be)=>{const Ge=Be.patterns;return Ge?Fe.concat(Ge):Fe},[]);const we=function(Fe,Be){if(typeof Fe!="string")return null;if(!Be){let je;for(je=Fe.length;je>0;je--){const Qe=Fe.charCodeAt(je-1);if(Qe===47||Qe===92)break}Be=Fe.substr(je)}const Ge=Q.indexOf(Be);return Ge!==-1?ie[Ge]:null};we.basenames=Q,we.patterns=ie,we.allBasenames=Q;const Me=K.filter(Fe=>!Fe.basenames);return Me.push(we),Me}}),define(Ee[77],_e([0,1,43,10,17,23,24,9,2]),function(oe,e,c,F,w,I,t,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function C(i,p,m){if(typeof i=="string"&&(i=S.URI.file(i)),m){const b=m.getWorkspaceFolder(i);if(b){const a=m.getWorkspace().folders.length>1;let E;if((0,t.isEqual)(b.uri,i)?E="":E=(0,t.relativePath)(b.uri,i),a){const P=b.name?b.name:(0,t.basename)(b.uri);E=E?P+" \u2022 "+E:P}return E}}if(i.scheme!==F.Schemas.file&&i.scheme!==F.Schemas.untitled)return i.with({query:null,fragment:null}).toString(!0);if((0,c.hasDriveLetter)(i.fsPath))return(0,w.normalize)(_(i.fsPath));let o=(0,w.normalize)(i.fsPath);return!I.isWindows&&p?.userHome&&(o=h(o,p.userHome.fsPath)),o}e.getPathLabel=C;function A(i){if(!i)return;typeof i=="string"&&(i=S.URI.file(i));const p=(0,t.basename)(i)||(i.scheme===F.Schemas.file?i.fsPath:i.path);return I.isWindows&&(0,c.isRootOrDriveLetter)(p)?_(p):p}e.getBaseLabel=A;function _(i,p){return(0,c.hasDriveLetter)(i,p)?i.charAt(0).toUpperCase()+i.slice(1):i}e.normalizeDriveLetter=_;let n=Object.create(null);function h(i,p){if(I.isWindows||!i||!p)return i;let m=n.original===p?n.normalized:void 0;return m||(m=`${(0,R.rtrim)(p,w.posix.sep)}${w.posix.sep}`,n={original:p,normalized:m}),(I.isLinux?i.startsWith(m):(0,R.startsWithIgnoreCase)(i,m))&&(i=`~/${i.substr(m.length)}`),i}e.tildify=h;function s(i,p){return i.replace(/^~($|\/|\\)/,`${p}$1`)}e.untildify=s;const l="\u2026",d="\\\\",D="~";function v(i,p=w.sep){const m=new Array(i.length);let o=!1;for(let b=0;b<i.length;b++){let a=i[b];if(a===""){m[b]=`.${p}`;continue}if(!a){m[b]=a;continue}o=!0;let E="";a.indexOf(d)===0?(E=a.substr(0,a.indexOf(d)+d.length),a=a.substr(a.indexOf(d)+d.length)):a.indexOf(p)===0?(E=a.substr(0,a.indexOf(p)+p.length),a=a.substr(a.indexOf(p)+p.length)):a.indexOf(D)===0&&(E=a.substr(0,a.indexOf(D)+D.length),a=a.substr(a.indexOf(D)+D.length));const P=a.split(p);for(let k=1;o&&k<=P.length;k++)for(let B=P.length-k;o&&B>=0;B--){o=!1;let L=P.slice(B,B+k).join(p);for(let y=0;!o&&y<i.length;y++)if(y!==b&&i[y]&&i[y].indexOf(L)>-1){const x=B+k===P.length,N=B>0&&i[y].indexOf(p)>-1?p+L:L,z=i[y].endsWith(N);o=!x||z}if(!o){let y="";(P[0].endsWith(":")||E!=="")&&(B===1&&(B=0,k++,L=P[0]+p+L),B>0&&(y=P[0]+p),y=E+y),B>0&&(y=y+l+p),y=y+L,B+k<P.length&&(y=y+p+l),m[b]=y}}o&&(m[b]=a)}return m}e.shorten=v;var f;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(f||(f={}));function g(i,p=Object.create(null)){const m=[];let o=!1,b="";for(const a of i)if(a==="$"||o&&a==="{")b&&m.push({value:b,type:f.TEXT}),b="",o=!0;else if(a==="}"&&o){const E=p[b];if(typeof E=="string")E.length&&m.push({value:E,type:f.VARIABLE});else if(E){const P=m[m.length-1];(!P||P.type!==f.SEPARATOR)&&m.push({value:E.label,type:f.SEPARATOR})}b="",o=!1}else b+=a;return b&&!o&&m.push({value:b,type:f.TEXT}),m.filter((a,E)=>{if(a.type===f.SEPARATOR){const P=m[E-1],k=m[E+1];return[P,k].every(B=>B&&(B.type===f.VARIABLE||B.type===f.TEXT)&&B.value.length>0)}return!0}).map(a=>a.value).join("")}e.template=g;function T(i,p){return I.isMacintosh||p?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,I.isMacintosh?"&":"&&"):i.replace(/&&|&/g,m=>m==="&"?"&&":"&")}e.mnemonicMenuLabel=T;function u(i,p){return I.isMacintosh||p?i.replace(/\(&&\w\)|&&/g,""):I.isWindows?i.replace(/&&|&/g,m=>m==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.mnemonicButtonLabel=u;function M(i){return i.replace(/&/g,"&&")}e.unmnemonicLabel=M;function r(i){const p=i.indexOf("/")!==-1?w.posix:w.win32,m=p.basename(i),o=p.dirname(i);return m.length?{name:m,parentPath:o}:{name:o,parentPath:""}}e.splitName=r}),define(Ee[78],_e([0,1,29,10,17,24,9]),function(oe,e,c,F,w,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.isUnspecific=e.guessMimeTypes=e.clearTextMimes=e.registerTextMime=e.Mimes=void 0;var R;(function(i){i.text="text/plain",i.binary="application/octet-stream",i.unknown="application/unknown",i.markdown="text/markdown",i.latex="text/latex"})(R=e.Mimes||(e.Mimes={}));let S=[],C=[],A=[];function _(i,p=!1){const m=n(i);S.push(m),m.userConfigured?A.push(m):C.push(m),p&&!m.userConfigured&&S.forEach(o=>{o.mime===m.mime||o.userConfigured||(m.extension&&o.extension===m.extension&&console.warn(`Overwriting extension <<${m.extension}>> to now point to mime <<${m.mime}>>`),m.filename&&o.filename===m.filename&&console.warn(`Overwriting filename <<${m.filename}>> to now point to mime <<${m.mime}>>`),m.filepattern&&o.filepattern===m.filepattern&&console.warn(`Overwriting filepattern <<${m.filepattern}>> to now point to mime <<${m.mime}>>`),m.firstline&&o.firstline===m.firstline&&console.warn(`Overwriting firstline <<${m.firstline}>> to now point to mime <<${m.mime}>>`))})}e.registerTextMime=_;function n(i){return{id:i.id,mime:i.mime,filename:i.filename,extension:i.extension,filepattern:i.filepattern,firstline:i.firstline,userConfigured:i.userConfigured,filenameLowercase:i.filename?i.filename.toLowerCase():void 0,extensionLowercase:i.extension?i.extension.toLowerCase():void 0,filepatternLowercase:i.filepattern?(0,c.parse)(i.filepattern.toLowerCase()):void 0,filepatternOnPath:i.filepattern?i.filepattern.indexOf(w.posix.sep)>=0:!1}}function h(i){i?(S=S.filter(p=>!p.userConfigured),A=[]):(S=[],C=[],A=[])}e.clearTextMimes=h;function s(i,p){let m;if(i)switch(i.scheme){case F.Schemas.file:m=i.fsPath;break;case F.Schemas.data:m=I.DataUri.parseMetaData(i).get(I.DataUri.META_DATA_LABEL);break;default:m=i.path}if(!m)return[R.unknown];m=m.toLowerCase();const o=(0,w.basename)(m),b=l(m,o,A);if(b)return[b,R.text];const a=l(m,o,C);if(a)return[a,R.text];if(p){const E=d(p);if(E)return[E,R.text]}return[R.unknown]}e.guessMimeTypes=s;function l(i,p,m){let o=null,b=null,a=null;for(let E=m.length-1;E>=0;E--){const P=m[E];if(p===P.filenameLowercase){o=P;break}if(P.filepattern&&(!b||P.filepattern.length>b.filepattern.length)){const k=P.filepatternOnPath?i:p;P.filepatternLowercase?.(k)&&(b=P)}P.extension&&(!a||P.extension.length>a.extension.length)&&p.endsWith(P.extensionLowercase)&&(a=P)}return o?o.mime:b?b.mime:a?a.mime:null}function d(i){if((0,t.startsWithUTF8BOM)(i)&&(i=i.substr(1)),i.length>0)for(let p=S.length-1;p>=0;p--){const m=S[p];if(!m.firstline)continue;const o=i.match(m.firstline);if(o&&o.length>0)return m.mime}return null}function D(i){return i?typeof i=="string"?i===R.binary||i===R.text||i===R.unknown:i.length===1&&D(i[0]):!0}e.isUnspecific=D;const v={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},f={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function g(i){const p=(0,w.extname)(i),m=v[p.toLowerCase()];return m!==void 0?m:T(i)}e.getMediaOrTextMime=g;function T(i){const p=(0,w.extname)(i);return f[p.toLowerCase()]}e.getMediaMime=T;function u(i){for(const p in f)if(f[p]===i)return p}e.getExtensionForMimeType=u;const M=/^(.+)\/(.+?)(;.+)?$/;function r(i,p){const m=M.exec(i);return m?`${m[1].toLowerCase()}/${m[2].toLowerCase()}${m[3]??""}`:p?void 0:i}e.normalizeMimeType=r}),define(Ee[106],_e([0,1,2]),function(oe,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function F(A){return A.toJSON()}class w{constructor(_){this._uriTransformer=_}transformIncoming(_){const n=this._uriTransformer.transformIncoming(_);return n===_?_:F(c.URI.from(n))}transformOutgoing(_){const n=this._uriTransformer.transformOutgoing(_);return n===_?_:F(c.URI.from(n))}transformOutgoingURI(_){const n=this._uriTransformer.transformOutgoing(_);return n===_?_:c.URI.from(n)}transformOutgoingScheme(_){return this._uriTransformer.transformOutgoingScheme(_)}}e.URITransformer=w,e.DefaultURITransformer=new class{transformIncoming(A){return A}transformOutgoing(A){return A}transformOutgoingURI(A){return A}transformOutgoingScheme(A){return A}};function I(A,_,n){if(!A||n>200)return null;if(typeof A=="object"){if(A instanceof c.URI)return _.transformOutgoing(A);for(let h in A)if(Object.hasOwnProperty.call(A,h)){const s=I(A[h],_,n+1);s!==null&&(A[h]=s)}}return null}function t(A,_){const n=I(A,_,0);return n===null?A:n}e.transformOutgoingURIs=t;function R(A,_,n,h){if(!A||h>200)return null;if(typeof A=="object"){if(A.$mid===1)return n?c.URI.revive(_.transformIncoming(A)):_.transformIncoming(A);for(let s in A)if(Object.hasOwnProperty.call(A,s)){const l=R(A[s],_,n,h+1);l!==null&&(A[s]=l)}}return null}function S(A,_){const n=R(A,_,!1,0);return n===null?A:n}e.transformIncomingURIs=S;function C(A,_){const n=R(A,_,!0,0);return n===null?A:n}e.transformAndReviveIncomingURIs=C}),define(Ee[35],_e([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const c=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function F(S){return c.test(S)}e.isUUID=F;const w=new Uint8Array(16),I=[];for(let S=0;S<256;S++)I.push(S.toString(16).padStart(2,"0"));let t;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?t=crypto.getRandomValues.bind(crypto):t=function(S){for(let C=0;C<S.length;C++)S[C]=Math.floor(Math.random()*256);return S};function R(){t(w),w[6]=w[6]&15|64,w[8]=w[8]&63|128;let S=0,C="";return C+=I[w[S++]],C+=I[w[S++]],C+=I[w[S++]],C+=I[w[S++]],C+="-",C+=I[w[S++]],C+=I[w[S++]],C+="-",C+=I[w[S++]],C+=I[w[S++]],C+="-",C+=I[w[S++]],C+=I[w[S++]],C+="-",C+=I[w[S++]],C+=I[w[S++]],C+=I[w[S++]],C+=I[w[S++]],C+=I[w[S++]],C+=I[w[S++]],C}e.generateUuid=R}),define(Ee[107],_e([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var c;(function(t){t[t.None=0]="None",t[t.Indent=1]="Indent",t[t.IndentOutdent=2]="IndentOutdent",t[t.Outdent=3]="Outdent"})(c=e.IndentAction||(e.IndentAction={}));class F{constructor(R){if(this._neutralCharacter=null,this._neutralCharacterSearched=!1,this.open=R.open,this.close=R.close,this._standardTokenMask=0,Array.isArray(R.notIn))for(let S=0,C=R.notIn.length;S<C;S++)switch(R.notIn[S]){case"string":this._standardTokenMask|=2;break;case"comment":this._standardTokenMask|=1;break;case"regex":this._standardTokenMask|=4;break}}isOK(R){return(this._standardTokenMask&R)==0}shouldAutoClose(R,S){if(R.getTokenCount()===0)return!0;const C=R.findTokenIndexAtOffset(S-2),A=R.getStandardTokenType(C);return this.isOK(A)}_findNeutralCharacterInRange(R,S){for(let C=R;C<=S;C++){const A=String.fromCharCode(C);if(!this.open.includes(A)&&!this.close.includes(A))return A}return null}findNeutralCharacter(){return this._neutralCharacterSearched||(this._neutralCharacterSearched=!0,this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(48,57)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(97,122)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(65,90))),this._neutralCharacter}}e.StandardAutoClosingPairConditional=F;class w{constructor(R){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const S of R)I(this.autoClosingPairsOpenByStart,S.open.charAt(0),S),I(this.autoClosingPairsOpenByEnd,S.open.charAt(S.open.length-1),S),I(this.autoClosingPairsCloseByStart,S.close.charAt(0),S),I(this.autoClosingPairsCloseByEnd,S.close.charAt(S.close.length-1),S),S.close.length===1&&S.open.length===1&&I(this.autoClosingPairsCloseSingleChar,S.close,S)}}e.AutoClosingPairs=w;function I(t,R,S){t.has(R)?t.get(R).push(S):t.set(R,[S])}}),define(Ee[55],_e([0,1,29,17]),function(oe,e,c,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function w(I,t,R,S){if(Array.isArray(I)){let C=0;for(const A of I){const _=w(A,t,R,S);if(_===10)return _;_>C&&(C=_)}return C}else{if(typeof I=="string")return S?I==="*"?5:I===R?10:0:0;if(I){const{language:C,pattern:A,scheme:_,hasAccessToAllModels:n}=I;if(!S&&!n)return 0;let h=0;if(_)if(_===t.scheme)h=10;else if(_==="*")h=5;else return 0;if(C)if(C===R)h=10;else if(C==="*")h=Math.max(h,5);else return 0;if(A){let s;if(typeof A=="string"?s=A:s={...A,base:(0,F.normalize)(A.base)},s===t.fsPath||(0,c.match)(s,t.fsPath))h=10;else return 0}return h}else return 0}}e.score=w}),define(Ee[108],_e([0,1,3,6]),function(oe,e,c,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistryImpl=void 0;class w{constructor(){this._map=new Map,this._promises=new Map,this._onDidChange=new c.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(t){this._onDidChange.fire({changedLanguages:t,changedColorMap:!1})}register(t,R){return this._map.set(t,R),this.fire([t]),(0,F.toDisposable)(()=>{this._map.get(t)===R&&(this._map.delete(t),this.fire([t]))})}registerPromise(t,R){let S=null,C=!1;return this._promises.set(t,R.then(A=>{this._promises.delete(t),!(C||!A)&&(S=this.register(t,A))})),(0,F.toDisposable)(()=>{C=!0,S&&S.dispose()})}getPromise(t){const R=this.get(t);if(R)return Promise.resolve(R);const S=this._promises.get(t);return S?S.then(C=>this.get(t)):null}get(t){return this._map.get(t)||null}setColorMap(t){this._colorMap=t,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistryImpl=w}),define(Ee[79],_e([0,1,22,23]),function(oe,e,c,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var w;(function(_){_[_.Full=1]="Full",_[_.Delta=2]="Delta"})(w||(w={}));function I(_){for(let n=0,h=_.length;n<h;n+=4){const s=_[n+0],l=_[n+1],d=_[n+2],D=_[n+3];_[n+0]=D,_[n+1]=d,_[n+2]=l,_[n+3]=s}}function t(_){const n=new Uint8Array(_.buffer,_.byteOffset,_.length*4);return F.isLittleEndian()||I(n),c.VSBuffer.wrap(n)}function R(_){const n=_.buffer;if(F.isLittleEndian()||I(n),n.byteOffset%4==0)return new Uint32Array(n.buffer,n.byteOffset,n.length/4);{const h=new Uint8Array(n.byteLength);return h.set(n),new Uint32Array(h.buffer,h.byteOffset,h.length/4)}}function S(_){const n=new Uint32Array(C(_));let h=0;if(n[h++]=_.id,_.type==="full")n[h++]=1,n[h++]=_.data.length,n.set(_.data,h),h+=_.data.length;else{n[h++]=2,n[h++]=_.deltas.length;for(const s of _.deltas)n[h++]=s.start,n[h++]=s.deleteCount,s.data?(n[h++]=s.data.length,n.set(s.data,h),h+=s.data.length):n[h++]=0}return t(n)}e.encodeSemanticTokensDto=S;function C(_){let n=0;if(n+=1+1,_.type==="full")n+=1+_.data.length;else{n+=1,n+=(1+1+1)*_.deltas.length;for(const h of _.deltas)h.data&&(n+=h.data.length)}return n}function A(_){const n=R(_);let h=0;const s=n[h++];if(n[h++]===1){const v=n[h++],f=n.subarray(h,h+v);return h+=v,{id:s,type:"full",data:f}}const d=n[h++];let D=[];for(let v=0;v<d;v++){const f=n[h++],g=n[h++],T=n[h++];let u;T>0&&(u=n.subarray(h,h+T),h+=T),D[v]={start:f,deleteCount:g,data:u}}return{id:s,type:"delta",deltas:D}}e.decodeSemanticTokensDto=A}),define(Ee[109],_e([18,19]),function(oe,e){return oe.create("vs/base/common/date",e)}),define(Ee[110],_e([0,1,109]),function(oe,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const F=60,w=F*60,I=w*24,t=I*7,R=I*30,S=I*365;function C(_,n){typeof _!="number"&&(_=_.getTime());const h=Math.round((new Date().getTime()-_)/1e3);if(h<-30)return(0,c.localize)(0,null,C(new Date().getTime()+h*1e3,!1));if(h<30)return(0,c.localize)(1,null);let s;return h<F?(s=h,n?s===1?(0,c.localize)(2,null,s):(0,c.localize)(3,null,s):s===1?(0,c.localize)(4,null,s):(0,c.localize)(5,null,s)):h<w?(s=Math.floor(h/F),n?s===1?(0,c.localize)(6,null,s):(0,c.localize)(7,null,s):s===1?(0,c.localize)(8,null,s):(0,c.localize)(9,null,s)):h<I?(s=Math.floor(h/w),n?s===1?(0,c.localize)(10,null,s):(0,c.localize)(11,null,s):s===1?(0,c.localize)(12,null,s):(0,c.localize)(13,null,s)):h<t?(s=Math.floor(h/I),n?s===1?(0,c.localize)(14,null,s):(0,c.localize)(15,null,s):s===1?(0,c.localize)(16,null,s):(0,c.localize)(17,null,s)):h<R?(s=Math.floor(h/t),n?s===1?(0,c.localize)(18,null,s):(0,c.localize)(19,null,s):s===1?(0,c.localize)(20,null,s):(0,c.localize)(21,null,s)):h<S?(s=Math.floor(h/R),n?s===1?(0,c.localize)(22,null,s):(0,c.localize)(23,null,s):s===1?(0,c.localize)(24,null,s):(0,c.localize)(25,null,s)):(s=Math.floor(h/S),n?s===1?(0,c.localize)(26,null,s):(0,c.localize)(27,null,s):s===1?(0,c.localize)(28,null,s):(0,c.localize)(29,null,s))}e.fromNow=C;function A(_){return _.getFullYear()+"-"+String(_.getMonth()+1).padStart(2,"0")+"-"+String(_.getDate()).padStart(2,"0")+"T"+String(_.getHours()).padStart(2,"0")+":"+String(_.getMinutes()).padStart(2,"0")+":"+String(_.getSeconds()).padStart(2,"0")+"."+(_.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=A}),define(Ee[111],_e([18,19]),function(oe,e){return oe.create("vs/base/common/errorMessage",e)}),define(Ee[44],_e([0,1,16,11,111]),function(oe,e,c,F,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function I(C,A){return A&&(C.stack||C.stacktrace)?w.localize(0,null,R(C),t(C.stack)||t(C.stacktrace)):R(C)}function t(C){return Array.isArray(C)?C.join(`
`):C}function R(C){return typeof C.code=="string"&&typeof C.errno=="number"&&typeof C.syscall=="string"?w.localize(1,null,C.message):C.message||w.localize(2,null)}function S(C=null,A=!1){if(!C)return w.localize(3,null);if(Array.isArray(C)){const _=c.coalesce(C),n=S(_[0],A);return _.length>1?w.localize(4,null,n,_.length):n}if(F.isString(C))return C;if(C.detail){const _=C.detail;if(_.error)return I(_.error,A);if(_.exception)return I(_.exception,A)}return C.stack?I(C,A):C.message?C.message:w.localize(5,null)}e.toErrorMessage=S}),define(Ee[112],_e([18,19]),function(oe,e){return oe.create("vs/editor/common/config/editorOptions",e)}),define(Ee[113],_e([0,1,112,23,114]),function(oe,e,c,F,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.deriveFromWorkspaceTrust=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ComputeOptionsMemory=e.ValidatedEditorOptions=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var I;(function(V){V[V.None=0]="None",V[V.Keep=1]="Keep",V[V.Brackets=2]="Brackets",V[V.Advanced=3]="Advanced",V[V.Full=4]="Full"})(I=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class t{constructor(J){this._values=J}hasChanged(J){return this._values[J]}}e.ConfigurationChangedEvent=t;class R{constructor(){this._values=[]}_read(J){return this._values[J]}get(J){return this._values[J]}_write(J,pe){this._values[J]=pe}}e.ValidatedEditorOptions=R;class S{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=S;class C{constructor(J,pe,Ue,Ye){this.id=J,this.name=pe,this.defaultValue=Ue,this.schema=Ye}compute(J,pe,Ue){return Ue}}class A{constructor(J,pe=null){this.schema=void 0,this.id=J,this.name="_never_",this.defaultValue=void 0,this.deps=pe}validate(J){return this.defaultValue}}class _{constructor(J,pe,Ue,Ye){this.id=J,this.name=pe,this.defaultValue=Ue,this.schema=Ye}validate(J){return typeof J=="undefined"?this.defaultValue:J}compute(J,pe,Ue){return Ue}}function n(V,J){return typeof V=="undefined"?J:V==="false"?!1:Boolean(V)}e.boolean=n;class h extends _{constructor(J,pe,Ue,Ye=void 0){typeof Ye!="undefined"&&(Ye.type="boolean",Ye.default=Ue),super(J,pe,Ue,Ye)}validate(J){return n(J,this.defaultValue)}}function s(V,J,pe,Ue){if(typeof V=="undefined")return J;let Ye=parseInt(V,10);return isNaN(Ye)?J:(Ye=Math.max(pe,Ye),Ye=Math.min(Ue,Ye),Ye|0)}e.clampedInt=s;class l extends _{constructor(J,pe,Ue,Ye,Je,lt=void 0){typeof lt!="undefined"&&(lt.type="integer",lt.default=Ue,lt.minimum=Ye,lt.maximum=Je),super(J,pe,Ue,lt),this.minimum=Ye,this.maximum=Je}static clampedInt(J,pe,Ue,Ye){return s(J,pe,Ue,Ye)}validate(J){return l.clampedInt(J,this.defaultValue,this.minimum,this.maximum)}}class d extends _{constructor(J,pe,Ue,Ye,Je){typeof Je!="undefined"&&(Je.type="number",Je.default=Ue),super(J,pe,Ue,Je),this.validationFn=Ye}static clamp(J,pe,Ue){return J<pe?pe:J>Ue?Ue:J}static float(J,pe){if(typeof J=="number")return J;if(typeof J=="undefined")return pe;const Ue=parseFloat(J);return isNaN(Ue)?pe:Ue}validate(J){return this.validationFn(d.float(J,this.defaultValue))}}class D extends _{static string(J,pe){return typeof J!="string"?pe:J}constructor(J,pe,Ue,Ye=void 0){typeof Ye!="undefined"&&(Ye.type="string",Ye.default=Ue),super(J,pe,Ue,Ye)}validate(J){return D.string(J,this.defaultValue)}}function v(V,J,pe){return typeof V!="string"||pe.indexOf(V)===-1?J:V}e.stringSet=v;class f extends _{constructor(J,pe,Ue,Ye,Je=void 0){typeof Je!="undefined"&&(Je.type="string",Je.enum=Ye,Je.default=Ue),super(J,pe,Ue,Je),this._allowedValues=Ye}validate(J){return v(J,this.defaultValue,this._allowedValues)}}class g extends C{constructor(J,pe,Ue,Ye,Je,lt,Et=void 0){typeof Et!="undefined"&&(Et.type="string",Et.enum=Je,Et.default=Ye),super(J,pe,Ue,Et),this._allowedValues=Je,this._convert=lt}validate(J){return typeof J!="string"?this.defaultValue:this._allowedValues.indexOf(J)===-1?this.defaultValue:this._convert(J)}}function T(V){switch(V){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class u extends C{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[c.localize(0,null),c.localize(1,null),c.localize(2,null)],default:"auto",description:c.localize(3,null)})}validate(J){switch(J){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(J,pe,Ue){return Ue===0?J.accessibilitySupport:Ue}}class M extends C{constructor(){const J={insertSpace:!0,ignoreEmptyLines:!0};super(19,"comments",J,{"editor.comments.insertSpace":{type:"boolean",default:J.insertSpace,description:c.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:J.ignoreEmptyLines,description:c.localize(5,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const pe=J;return{insertSpace:n(pe.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:n(pe.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var r;(function(V){V[V.Hidden=0]="Hidden",V[V.Blink=1]="Blink",V[V.Smooth=2]="Smooth",V[V.Phase=3]="Phase",V[V.Expand=4]="Expand",V[V.Solid=5]="Solid"})(r=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function i(V){switch(V){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var p;(function(V){V[V.Line=1]="Line",V[V.Block=2]="Block",V[V.Underline=3]="Underline",V[V.LineThin=4]="LineThin",V[V.BlockOutline=5]="BlockOutline",V[V.UnderlineThin=6]="UnderlineThin"})(p=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function m(V){switch(V){case p.Line:return"line";case p.Block:return"block";case p.Underline:return"underline";case p.LineThin:return"line-thin";case p.BlockOutline:return"block-outline";case p.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=m;function o(V){switch(V){case"line":return p.Line;case"block":return p.Block;case"underline":return p.Underline;case"line-thin":return p.LineThin;case"block-outline":return p.BlockOutline;case"underline-thin":return p.UnderlineThin}}class b extends A{constructor(){super(127,[65,33])}compute(J,pe,Ue){const Ye=["monaco-editor"];return pe.get(33)&&Ye.push(pe.get(33)),J.extraEditorClassName&&Ye.push(J.extraEditorClassName),pe.get(65)==="default"?Ye.push("mouse-default"):pe.get(65)==="copy"&&Ye.push("mouse-copy"),pe.get(99)&&Ye.push("showUnused"),pe.get(125)&&Ye.push("showDeprecated"),Ye.join(" ")}}class a extends h{constructor(){super(32,"emptySelectionClipboard",!0,{description:c.localize(6,null)})}compute(J,pe,Ue){return Ue&&J.emptySelectionClipboard}}class E extends C{constructor(){const J={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(35,"find",J,{"editor.find.cursorMoveOnType":{type:"boolean",default:J.cursorMoveOnType,description:c.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:J.seedSearchStringFromSelection,enumDescriptions:[c.localize(8,null),c.localize(9,null),c.localize(10,null)],description:c.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:J.autoFindInSelection,enumDescriptions:[c.localize(12,null),c.localize(13,null),c.localize(14,null)],description:c.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:J.globalFindClipboard,description:c.localize(16,null),included:F.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:J.addExtraSpaceOnTop,description:c.localize(17,null)},"editor.find.loop":{type:"boolean",default:J.loop,description:c.localize(18,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const pe=J;return{cursorMoveOnType:n(pe.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof J.seedSearchStringFromSelection=="boolean"?J.seedSearchStringFromSelection?"always":"never":v(pe.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof J.autoFindInSelection=="boolean"?J.autoFindInSelection?"always":"never":v(pe.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:n(pe.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:n(pe.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:n(pe.loop,this.defaultValue.loop)}}}class P extends C{constructor(){super(44,"fontLigatures",P.OFF,{anyOf:[{type:"boolean",description:c.localize(19,null)},{type:"string",description:c.localize(20,null)}],description:c.localize(21,null),default:!1})}validate(J){return typeof J=="undefined"?this.defaultValue:typeof J=="string"?J==="false"?P.OFF:J==="true"?P.ON:J:Boolean(J)?P.ON:P.OFF}}e.EditorFontLigatures=P,P.OFF='"liga" off, "calt" off',P.ON='"liga" on, "calt" on';class k extends A{constructor(){super(43)}compute(J,pe,Ue){return J.fontInfo}}class B extends _{constructor(){super(45,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:c.localize(22,null)})}validate(J){let pe=d.float(J,this.defaultValue);return pe===0?e.EDITOR_FONT_DEFAULTS.fontSize:d.clamp(pe,6,100)}compute(J,pe,Ue){return J.fontInfo.fontSize}}class L extends C{constructor(){super(46,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:L.MINIMUM_VALUE,maximum:L.MAXIMUM_VALUE,errorMessage:c.localize(23,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:L.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:c.localize(24,null)})}validate(J){return J==="normal"||J==="bold"?J:String(l.clampedInt(J,e.EDITOR_FONT_DEFAULTS.fontWeight,L.MINIMUM_VALUE,L.MAXIMUM_VALUE))}}L.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],L.MINIMUM_VALUE=1,L.MAXIMUM_VALUE=1e3;class y extends C{constructor(){const J={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},pe={type:"string",enum:["peek","gotoAndPeek","goto"],default:J.multiple,enumDescriptions:[c.localize(25,null),c.localize(26,null),c.localize(27,null)]},Ue=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(50,"gotoLocation",J,{"editor.gotoLocation.multiple":{deprecationMessage:c.localize(28,null)},"editor.gotoLocation.multipleDefinitions":{description:c.localize(29,null),...pe},"editor.gotoLocation.multipleTypeDefinitions":{description:c.localize(30,null),...pe},"editor.gotoLocation.multipleDeclarations":{description:c.localize(31,null),...pe},"editor.gotoLocation.multipleImplementations":{description:c.localize(32,null),...pe},"editor.gotoLocation.multipleReferences":{description:c.localize(33,null),...pe},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:J.alternativeDefinitionCommand,enum:Ue,description:c.localize(34,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:J.alternativeTypeDefinitionCommand,enum:Ue,description:c.localize(35,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:J.alternativeDeclarationCommand,enum:Ue,description:c.localize(36,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:J.alternativeImplementationCommand,enum:Ue,description:c.localize(37,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:J.alternativeReferenceCommand,enum:Ue,description:c.localize(38,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const pe=J;return{multiple:v(pe.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:pe.multipleDefinitions??v(pe.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:pe.multipleTypeDefinitions??v(pe.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:pe.multipleDeclarations??v(pe.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:pe.multipleImplementations??v(pe.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:pe.multipleReferences??v(pe.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:D.string(pe.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:D.string(pe.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:D.string(pe.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:D.string(pe.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:D.string(pe.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class x extends C{constructor(){const J={enabled:!0,delay:300,sticky:!0,above:!0};super(52,"hover",J,{"editor.hover.enabled":{type:"boolean",default:J.enabled,description:c.localize(39,null)},"editor.hover.delay":{type:"number",default:J.delay,description:c.localize(40,null)},"editor.hover.sticky":{type:"boolean",default:J.sticky,description:c.localize(41,null)},"editor.hover.above":{type:"boolean",default:J.above,description:c.localize(42,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const pe=J;return{enabled:n(pe.enabled,this.defaultValue.enabled),delay:l.clampedInt(pe.delay,this.defaultValue.delay,0,1e4),sticky:n(pe.sticky,this.defaultValue.sticky),above:n(pe.above,this.defaultValue.above)}}}var N;(function(V){V[V.None=0]="None",V[V.Text=1]="Text",V[V.Blocks=2]="Blocks"})(N=e.RenderMinimap||(e.RenderMinimap={}));class z extends A{constructor(){super(130,[49,57,37,64,91,59,60,93,117,120,121,122,2])}compute(J,pe,Ue){return z.computeLayout(pe,{memory:J.memory,outerWidth:J.outerWidth,outerHeight:J.outerHeight,isDominatedByLongLines:J.isDominatedByLongLines,lineHeight:J.fontInfo.lineHeight,viewLineCount:J.viewLineCount,lineNumbersDigitCount:J.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:J.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:J.fontInfo.maxDigitWidth,pixelRatio:J.pixelRatio})}static computeContainedMinimapLineCount(J){const pe=J.height/J.lineHeight,Ue=J.scrollBeyondLastLine?pe-1:0,Ye=(J.viewLineCount+Ue)/(J.pixelRatio*J.height),Je=Math.floor(J.viewLineCount/Ye);return{typicalViewportLineCount:pe,extraLinesBeyondLastLine:Ue,desiredRatio:Ye,minimapLineCount:Je}}static _computeMinimapLayout(J,pe){const Ue=J.outerWidth,Ye=J.outerHeight,Je=J.pixelRatio;if(!J.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Je*Ye),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Ye};const lt=pe.stableMinimapLayoutInput,Et=lt&&J.outerHeight===lt.outerHeight&&J.lineHeight===lt.lineHeight&&J.typicalHalfwidthCharacterWidth===lt.typicalHalfwidthCharacterWidth&&J.pixelRatio===lt.pixelRatio&&J.scrollBeyondLastLine===lt.scrollBeyondLastLine&&J.minimap.enabled===lt.minimap.enabled&&J.minimap.side===lt.minimap.side&&J.minimap.size===lt.minimap.size&&J.minimap.showSlider===lt.minimap.showSlider&&J.minimap.renderCharacters===lt.minimap.renderCharacters&&J.minimap.maxColumn===lt.minimap.maxColumn&&J.minimap.scale===lt.minimap.scale&&J.verticalScrollbarWidth===lt.verticalScrollbarWidth&&J.isViewportWrapping===lt.isViewportWrapping,It=J.lineHeight,et=J.typicalHalfwidthCharacterWidth,Tt=J.scrollBeyondLastLine,Pe=J.minimap.renderCharacters;let Se=Je>=2?Math.round(J.minimap.scale*2):J.minimap.scale;const ve=J.minimap.maxColumn,re=J.minimap.size,ae=J.minimap.side,he=J.verticalScrollbarWidth,me=J.viewLineCount,Ie=J.remainingWidth,ze=J.isViewportWrapping,Oe=Pe?2:3;let We=Math.floor(Je*Ye);const it=We/Je;let ot=!1,ne=!1,ge=Oe*Se,te=Se/Je,W=1;if(re==="fill"||re==="fit"){const{typicalViewportLineCount:Ct,extraLinesBeyondLastLine:pt,desiredRatio:ht,minimapLineCount:vt}=z.computeContainedMinimapLineCount({viewLineCount:me,scrollBeyondLastLine:Tt,height:Ye,lineHeight:It,pixelRatio:Je});if(me/vt>1)ot=!0,ne=!0,Se=1,ge=1,te=Se/Je;else{let Ft=!1,yt=Se+1;if(re==="fit"){const At=Math.ceil((me+pt)*ge);ze&&Et&&Ie<=pe.stableFitRemainingWidth?(Ft=!0,yt=pe.stableFitMaxMinimapScale):Ft=At>We}if(re==="fill"||Ft){ot=!0;const At=Se;ge=Math.min(It*Je,Math.max(1,Math.floor(1/ht))),ze&&Et&&Ie<=pe.stableFitRemainingWidth&&(yt=pe.stableFitMaxMinimapScale),Se=Math.min(yt,Math.max(1,Math.floor(ge/Oe))),Se>At&&(W=Math.min(2,Se/At)),te=Se/Je/W,We=Math.ceil(Math.max(Ct,me+pt)*ge),ze?(pe.stableMinimapLayoutInput=J,pe.stableFitRemainingWidth=Ie,pe.stableFitMaxMinimapScale=Se):(pe.stableMinimapLayoutInput=null,pe.stableFitRemainingWidth=0)}}}const be=Math.floor(ve*te),ke=Math.min(be,Math.max(0,Math.floor((Ie-he-2)*te/(et+te)))+e.MINIMAP_GUTTER_WIDTH);let qe=Math.floor(Je*ke);const Le=qe/Je;qe=Math.floor(qe*W);const dt=Pe?1:2,bt=ae==="left"?0:Ue-ke-he;return{renderMinimap:dt,minimapLeft:bt,minimapWidth:ke,minimapHeightIsEditorHeight:ot,minimapIsSampling:ne,minimapScale:Se,minimapLineHeight:ge,minimapCanvasInnerWidth:qe,minimapCanvasInnerHeight:We,minimapCanvasOuterWidth:Le,minimapCanvasOuterHeight:it}}static computeLayout(J,pe){const Ue=pe.outerWidth|0,Ye=pe.outerHeight|0,Je=pe.lineHeight|0,lt=pe.lineNumbersDigitCount|0,Et=pe.typicalHalfwidthCharacterWidth,It=pe.maxDigitWidth,et=pe.pixelRatio,Tt=pe.viewLineCount,Pe=J.get(122),Se=Pe==="inherit"?J.get(121):Pe,ve=Se==="inherit"?J.get(117):Se,re=J.get(120),ae=J.get(2),he=pe.isDominatedByLongLines,me=J.get(49),Ie=J.get(59).renderType!==0,ze=J.get(60),Oe=J.get(93),We=J.get(64),it=J.get(91),ot=it.verticalScrollbarSize,ne=it.verticalHasArrows,ge=it.arrowSize,te=it.horizontalScrollbarSize,W=J.get(57),be=J.get(37);let ke;if(typeof W=="string"&&/^\d+(\.\d+)?ch$/.test(W)){const Bt=parseFloat(W.substr(0,W.length-2));ke=l.clampedInt(Bt*Et,0,0,1e3)}else ke=l.clampedInt(W,0,0,1e3);be&&(ke+=16);let qe=0;if(Ie){const Bt=Math.max(lt,ze);qe=Math.round(Bt*It)}let Le=0;me&&(Le=Je);let dt=0,bt=dt+Le,Ct=bt+qe,pt=Ct+ke;const ht=Ue-Le-qe-ke;let vt=!1,_t=!1,Ft=-1;ae!==2&&(Se==="inherit"&&he?(vt=!0,_t=!0):ve==="on"||ve==="bounded"?_t=!0:ve==="wordWrapColumn"&&(Ft=re));const yt=z._computeMinimapLayout({outerWidth:Ue,outerHeight:Ye,lineHeight:Je,typicalHalfwidthCharacterWidth:Et,pixelRatio:et,scrollBeyondLastLine:Oe,minimap:We,verticalScrollbarWidth:ot,viewLineCount:Tt,remainingWidth:ht,isViewportWrapping:_t},pe.memory||new S);yt.renderMinimap!==0&&yt.minimapLeft===0&&(dt+=yt.minimapWidth,bt+=yt.minimapWidth,Ct+=yt.minimapWidth,pt+=yt.minimapWidth);const At=ht-yt.minimapWidth,Ut=Math.max(1,Math.floor((At-ot-2)/Et)),Pt=ne?ge:0;return _t&&(Ft=Math.max(1,Ut),ve==="bounded"&&(Ft=Math.min(Ft,re))),{width:Ue,height:Ye,glyphMarginLeft:dt,glyphMarginWidth:Le,lineNumbersLeft:bt,lineNumbersWidth:qe,decorationsLeft:Ct,decorationsWidth:ke,contentLeft:pt,contentWidth:At,minimap:yt,viewportColumn:Ut,isWordWrapMinified:vt,isViewportWrapping:_t,wrappingColumn:Ft,verticalScrollbarWidth:ot,horizontalScrollbarHeight:te,overviewRuler:{top:Pt,width:ot,height:Ye-2*Pt,right:0}}}}e.EditorLayoutInfoComputer=z;class H extends C{constructor(){const J={enabled:!0};super(56,"lightbulb",J,{"editor.lightbulb.enabled":{type:"boolean",default:J.enabled,description:c.localize(43,null)}})}validate(J){return!J||typeof J!="object"?this.defaultValue:{enabled:n(J.enabled,this.defaultValue.enabled)}}}class q extends C{constructor(){const J={enabled:!0,fontSize:0,fontFamily:""};super(126,"inlayHints",J,{"editor.inlayHints.enabled":{type:"boolean",default:J.enabled,description:c.localize(44,null)},"editor.inlayHints.fontSize":{type:"number",default:J.fontSize,markdownDescription:c.localize(45,null)},"editor.inlayHints.fontFamily":{type:"string",default:J.fontFamily,markdownDescription:c.localize(46,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const pe=J;return{enabled:n(pe.enabled,this.defaultValue.enabled),fontSize:l.clampedInt(pe.fontSize,this.defaultValue.fontSize,0,100),fontFamily:D.string(pe.fontFamily,this.defaultValue.fontFamily)}}}class ue extends d{constructor(){super(58,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,J=>d.clamp(J,0,150),{markdownDescription:c.localize(47,null)})}compute(J,pe,Ue){return J.fontInfo.lineHeight}}class K extends C{constructor(){const J={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(64,"minimap",J,{"editor.minimap.enabled":{type:"boolean",default:J.enabled,description:c.localize(48,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[c.localize(49,null),c.localize(50,null),c.localize(51,null)],default:J.size,description:c.localize(52,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:J.side,description:c.localize(53,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:J.showSlider,description:c.localize(54,null)},"editor.minimap.scale":{type:"number",default:J.scale,minimum:1,maximum:3,enum:[1,2,3],description:c.localize(55,null)},"editor.minimap.renderCharacters":{type:"boolean",default:J.renderCharacters,description:c.localize(56,null)},"editor.minimap.maxColumn":{type:"number",default:J.maxColumn,description:c.localize(57,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const pe=J;return{enabled:n(pe.enabled,this.defaultValue.enabled),size:v(pe.size,this.defaultValue.size,["proportional","fill","fit"]),side:v(pe.side,this.defaultValue.side,["right","left"]),showSlider:v(pe.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:n(pe.renderCharacters,this.defaultValue.renderCharacters),scale:l.clampedInt(pe.scale,1,1,3),maxColumn:l.clampedInt(pe.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function ce(V){return V==="ctrlCmd"?F.isMacintosh?"metaKey":"ctrlKey":"altKey"}class de extends C{constructor(){super(74,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:c.localize(58,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:c.localize(59,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const pe=J;return{top:l.clampedInt(pe.top,0,0,1e3),bottom:l.clampedInt(pe.bottom,0,0,1e3)}}}class Q extends C{constructor(){const J={enabled:!0,cycle:!1};super(75,"parameterHints",J,{"editor.parameterHints.enabled":{type:"boolean",default:J.enabled,description:c.localize(60,null)},"editor.parameterHints.cycle":{type:"boolean",default:J.cycle,description:c.localize(61,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const pe=J;return{enabled:n(pe.enabled,this.defaultValue.enabled),cycle:n(pe.cycle,this.defaultValue.cycle)}}}class ie extends A{constructor(){super(128)}compute(J,pe,Ue){return J.pixelRatio}}class we extends C{constructor(){const J={other:!0,comments:!1,strings:!1};super(78,"quickSuggestions",J,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:J.strings,description:c.localize(62,null)},comments:{type:"boolean",default:J.comments,description:c.localize(63,null)},other:{type:"boolean",default:J.other,description:c.localize(64,null)}}}],default:J,description:c.localize(65,null)});this.defaultValue=J}validate(J){if(typeof J=="boolean")return J;if(J&&typeof J=="object"){const pe=J,Ue={other:n(pe.other,this.defaultValue.other),comments:n(pe.comments,this.defaultValue.comments),strings:n(pe.strings,this.defaultValue.strings)};return Ue.other&&Ue.comments&&Ue.strings?!0:!Ue.other&&!Ue.comments&&!Ue.strings?!1:Ue}return this.defaultValue}}var Me;(function(V){V[V.Off=0]="Off",V[V.On=1]="On",V[V.Relative=2]="Relative",V[V.Interval=3]="Interval",V[V.Custom=4]="Custom"})(Me=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class Fe extends C{constructor(){super(59,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[c.localize(66,null),c.localize(67,null),c.localize(68,null),c.localize(69,null)],default:"on",description:c.localize(70,null)})}validate(J){let pe=this.defaultValue.renderType,Ue=this.defaultValue.renderFn;return typeof J!="undefined"&&(typeof J=="function"?(pe=4,Ue=J):J==="interval"?pe=3:J==="relative"?pe=2:J==="on"?pe=1:pe=0),{renderType:pe,renderFn:Ue}}}function Be(V){const J=V.get(86);return J==="editable"?V.get(80):J!=="on"}e.filterValidationDecorations=Be;class Ge extends C{constructor(){const J=[],pe={type:"number",description:c.localize(71,null)};super(90,"rulers",J,{type:"array",items:{anyOf:[pe,{type:["object"],properties:{column:pe,color:{type:"string",description:c.localize(72,null),format:"color-hex"}}}]},default:J,description:c.localize(73,null)})}validate(J){if(Array.isArray(J)){let pe=[];for(let Ue of J)if(typeof Ue=="number")pe.push({column:l.clampedInt(Ue,0,0,1e4),color:null});else if(Ue&&typeof Ue=="object"){const Ye=Ue;pe.push({column:l.clampedInt(Ye.column,0,0,1e4),color:Ye.color})}return pe.sort((Ue,Ye)=>Ue.column-Ye.column),pe}return this.defaultValue}}function je(V,J){if(typeof V!="string")return J;switch(V){case"hidden":return 2;case"visible":return 3;default:return 1}}class Qe extends C{constructor(){const J={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(91,"scrollbar",J,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[c.localize(74,null),c.localize(75,null),c.localize(76,null)],default:"auto",description:c.localize(77,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[c.localize(78,null),c.localize(79,null),c.localize(80,null)],default:"auto",description:c.localize(81,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:J.verticalScrollbarSize,description:c.localize(82,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:J.horizontalScrollbarSize,description:c.localize(83,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:J.scrollByPage,description:c.localize(84,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const pe=J,Ue=l.clampedInt(pe.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Ye=l.clampedInt(pe.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:l.clampedInt(pe.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:je(pe.vertical,this.defaultValue.vertical),horizontal:je(pe.horizontal,this.defaultValue.horizontal),useShadows:n(pe.useShadows,this.defaultValue.useShadows),verticalHasArrows:n(pe.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:n(pe.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:n(pe.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:n(pe.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ue,horizontalSliderSize:l.clampedInt(pe.horizontalSliderSize,Ue,0,1e3),verticalScrollbarSize:Ye,verticalSliderSize:l.clampedInt(pe.verticalSliderSize,Ye,0,1e3),scrollByPage:n(pe.scrollByPage,this.defaultValue.scrollByPage)}}}e.deriveFromWorkspaceTrust="deriveFromWorkspaceTrust",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments"};class $ extends C{constructor(){const J={nonBasicASCII:e.deriveFromWorkspaceTrust,invisibleCharacters:e.deriveFromWorkspaceTrust,ambiguousCharacters:e.deriveFromWorkspaceTrust,includeComments:e.deriveFromWorkspaceTrust,allowedCharacters:""};super(112,"unicodeHighlight",J,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.deriveFromWorkspaceTrust],default:J.nonBasicASCII,description:c.localize(85,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.deriveFromWorkspaceTrust],default:J.invisibleCharacters,description:c.localize(86,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.deriveFromWorkspaceTrust],default:J.ambiguousCharacters,description:c.localize(87,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.deriveFromWorkspaceTrust],default:J.includeComments,description:c.localize(88,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"string",default:J.allowedCharacters,description:c.localize(89,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const pe=J;return{nonBasicASCII:Z(pe.nonBasicASCII,e.deriveFromWorkspaceTrust,[!0,!1,e.deriveFromWorkspaceTrust]),invisibleCharacters:Z(pe.invisibleCharacters,e.deriveFromWorkspaceTrust,[!0,!1,e.deriveFromWorkspaceTrust]),ambiguousCharacters:Z(pe.ambiguousCharacters,e.deriveFromWorkspaceTrust,[!0,!1,e.deriveFromWorkspaceTrust]),includeComments:Z(pe.includeComments,e.deriveFromWorkspaceTrust,[!0,!1,e.deriveFromWorkspaceTrust]),allowedCharacters:G(pe.allowedCharacters,"")}}}function G(V,J){return typeof V!="string"?J:V}class X extends C{constructor(){const J={enabled:!0,mode:"subwordSmart"};super(54,"inlineSuggest",J,{"editor.inlineSuggest.enabled":{type:"boolean",default:J.enabled,description:c.localize(90,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const pe=J;return{enabled:n(pe.enabled,this.defaultValue.enabled),mode:v(pe.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class se extends C{constructor(){const J={enabled:e.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled};super(12,"bracketPairColorization",J,{"editor.bracketPairColorization.enabled":{type:"boolean",default:J.enabled,description:c.localize(91,null)}})}validate(J){return!J||typeof J!="object"?this.defaultValue:{enabled:n(J.enabled,this.defaultValue.enabled)}}}class j extends C{constructor(){const J={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",J,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[c.localize(92,null),c.localize(93,null),c.localize(94,null)],default:J.bracketPairs,description:c.localize(95,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[c.localize(96,null),c.localize(97,null),c.localize(98,null)],default:J.bracketPairsHorizontal,description:c.localize(99,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:J.highlightActiveBracketPair,description:c.localize(100,null)},"editor.guides.indentation":{type:"boolean",default:J.indentation,description:c.localize(101,null)},"editor.guides.highlightActiveIndentation":{type:"boolean",default:J.highlightActiveIndentation,description:c.localize(102,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const pe=J;return{bracketPairs:Z(pe.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:Z(pe.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:n(pe.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:n(pe.indentation,this.defaultValue.indentation),highlightActiveIndentation:n(pe.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation)}}}function Z(V,J,pe){const Ue=pe.indexOf(V);return Ue===-1?J:pe[Ue]}class fe extends C{constructor(){const J={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(105,"suggest",J,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[c.localize(103,null),c.localize(104,null)],default:J.insertMode,description:c.localize(105,null)},"editor.suggest.filterGraceful":{type:"boolean",default:J.filterGraceful,description:c.localize(106,null)},"editor.suggest.localityBonus":{type:"boolean",default:J.localityBonus,description:c.localize(107,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:J.shareSuggestSelections,markdownDescription:c.localize(108,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:J.snippetsPreventQuickSuggestions,description:c.localize(109,null)},"editor.suggest.showIcons":{type:"boolean",default:J.showIcons,description:c.localize(110,null)},"editor.suggest.showStatusBar":{type:"boolean",default:J.showStatusBar,description:c.localize(111,null)},"editor.suggest.preview":{type:"boolean",default:J.preview,description:c.localize(112,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:J.showInlineDetails,description:c.localize(113,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:c.localize(114,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:c.localize(115,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:c.localize(116,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:c.localize(117,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:c.localize(118,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:c.localize(119,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:c.localize(120,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:c.localize(121,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:c.localize(122,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:c.localize(123,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:c.localize(124,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:c.localize(125,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:c.localize(126,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:c.localize(127,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:c.localize(128,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:c.localize(129,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:c.localize(130,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:c.localize(131,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:c.localize(132,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:c.localize(133,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:c.localize(134,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:c.localize(135,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:c.localize(136,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:c.localize(137,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:c.localize(138,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:c.localize(139,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:c.localize(140,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:c.localize(141,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:c.localize(142,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:c.localize(143,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:c.localize(144,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const pe=J;return{insertMode:v(pe.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:n(pe.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:n(pe.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:n(pe.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:n(pe.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:n(pe.showIcons,this.defaultValue.showIcons),showStatusBar:n(pe.showStatusBar,this.defaultValue.showStatusBar),preview:n(pe.preview,this.defaultValue.preview),previewMode:v(pe.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:n(pe.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:n(pe.showMethods,this.defaultValue.showMethods),showFunctions:n(pe.showFunctions,this.defaultValue.showFunctions),showConstructors:n(pe.showConstructors,this.defaultValue.showConstructors),showDeprecated:n(pe.showDeprecated,this.defaultValue.showDeprecated),showFields:n(pe.showFields,this.defaultValue.showFields),showVariables:n(pe.showVariables,this.defaultValue.showVariables),showClasses:n(pe.showClasses,this.defaultValue.showClasses),showStructs:n(pe.showStructs,this.defaultValue.showStructs),showInterfaces:n(pe.showInterfaces,this.defaultValue.showInterfaces),showModules:n(pe.showModules,this.defaultValue.showModules),showProperties:n(pe.showProperties,this.defaultValue.showProperties),showEvents:n(pe.showEvents,this.defaultValue.showEvents),showOperators:n(pe.showOperators,this.defaultValue.showOperators),showUnits:n(pe.showUnits,this.defaultValue.showUnits),showValues:n(pe.showValues,this.defaultValue.showValues),showConstants:n(pe.showConstants,this.defaultValue.showConstants),showEnums:n(pe.showEnums,this.defaultValue.showEnums),showEnumMembers:n(pe.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:n(pe.showKeywords,this.defaultValue.showKeywords),showWords:n(pe.showWords,this.defaultValue.showWords),showColors:n(pe.showColors,this.defaultValue.showColors),showFiles:n(pe.showFiles,this.defaultValue.showFiles),showReferences:n(pe.showReferences,this.defaultValue.showReferences),showFolders:n(pe.showFolders,this.defaultValue.showFolders),showTypeParameters:n(pe.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:n(pe.showSnippets,this.defaultValue.showSnippets),showUsers:n(pe.showUsers,this.defaultValue.showUsers),showIssues:n(pe.showIssues,this.defaultValue.showIssues)}}}class Te extends C{constructor(){super(101,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:c.localize(145,null),default:!0,type:"boolean"}})}validate(J){return!J||typeof J!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:n(J.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class Ne extends A{constructor(){super(129,[80])}compute(J,pe,Ue){return pe.get(80)?!0:J.tabFocusMode}}var He;(function(V){V[V.None=0]="None",V[V.Same=1]="Same",V[V.Indent=2]="Indent",V[V.DeepIndent=3]="DeepIndent"})(He=e.WrappingIndent||(e.WrappingIndent={}));function Ke(V){switch(V){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class tt extends A{constructor(){super(131,[130])}compute(J,pe,Ue){const Ye=pe.get(130);return{isDominatedByLongLines:J.isDominatedByLongLines,isWordWrapMinified:Ye.isWordWrapMinified,isViewportWrapping:Ye.isViewportWrapping,wrappingColumn:Ye.wrappingColumn}}}const st="Consolas, 'Courier New', monospace",Xe="Menlo, Monaco, 'Courier New', monospace",rt="'Droid Sans Mono', 'monospace', monospace, 'Droid Sans Fallback'";e.EDITOR_FONT_DEFAULTS={fontFamily:F.isMacintosh?Xe:F.isLinux?rt:st,fontWeight:"normal",fontSize:F.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!1}},e.editorOptionsRegistry=[];function De(V){return e.editorOptionsRegistry[V.id]=V,V}var gt;(function(V){V[V.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",V[V.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",V[V.accessibilitySupport=2]="accessibilitySupport",V[V.accessibilityPageSize=3]="accessibilityPageSize",V[V.ariaLabel=4]="ariaLabel",V[V.autoClosingBrackets=5]="autoClosingBrackets",V[V.autoClosingDelete=6]="autoClosingDelete",V[V.autoClosingOvertype=7]="autoClosingOvertype",V[V.autoClosingQuotes=8]="autoClosingQuotes",V[V.autoIndent=9]="autoIndent",V[V.automaticLayout=10]="automaticLayout",V[V.autoSurround=11]="autoSurround",V[V.bracketPairColorization=12]="bracketPairColorization",V[V.guides=13]="guides",V[V.codeLens=14]="codeLens",V[V.codeLensFontFamily=15]="codeLensFontFamily",V[V.codeLensFontSize=16]="codeLensFontSize",V[V.colorDecorators=17]="colorDecorators",V[V.columnSelection=18]="columnSelection",V[V.comments=19]="comments",V[V.contextmenu=20]="contextmenu",V[V.copyWithSyntaxHighlighting=21]="copyWithSyntaxHighlighting",V[V.cursorBlinking=22]="cursorBlinking",V[V.cursorSmoothCaretAnimation=23]="cursorSmoothCaretAnimation",V[V.cursorStyle=24]="cursorStyle",V[V.cursorSurroundingLines=25]="cursorSurroundingLines",V[V.cursorSurroundingLinesStyle=26]="cursorSurroundingLinesStyle",V[V.cursorWidth=27]="cursorWidth",V[V.disableLayerHinting=28]="disableLayerHinting",V[V.disableMonospaceOptimizations=29]="disableMonospaceOptimizations",V[V.domReadOnly=30]="domReadOnly",V[V.dragAndDrop=31]="dragAndDrop",V[V.emptySelectionClipboard=32]="emptySelectionClipboard",V[V.extraEditorClassName=33]="extraEditorClassName",V[V.fastScrollSensitivity=34]="fastScrollSensitivity",V[V.find=35]="find",V[V.fixedOverflowWidgets=36]="fixedOverflowWidgets",V[V.folding=37]="folding",V[V.foldingStrategy=38]="foldingStrategy",V[V.foldingHighlight=39]="foldingHighlight",V[V.foldingImportsByDefault=40]="foldingImportsByDefault",V[V.unfoldOnClickAfterEndOfLine=41]="unfoldOnClickAfterEndOfLine",V[V.fontFamily=42]="fontFamily",V[V.fontInfo=43]="fontInfo",V[V.fontLigatures=44]="fontLigatures",V[V.fontSize=45]="fontSize",V[V.fontWeight=46]="fontWeight",V[V.formatOnPaste=47]="formatOnPaste",V[V.formatOnType=48]="formatOnType",V[V.glyphMargin=49]="glyphMargin",V[V.gotoLocation=50]="gotoLocation",V[V.hideCursorInOverviewRuler=51]="hideCursorInOverviewRuler",V[V.hover=52]="hover",V[V.inDiffEditor=53]="inDiffEditor",V[V.inlineSuggest=54]="inlineSuggest",V[V.letterSpacing=55]="letterSpacing",V[V.lightbulb=56]="lightbulb",V[V.lineDecorationsWidth=57]="lineDecorationsWidth",V[V.lineHeight=58]="lineHeight",V[V.lineNumbers=59]="lineNumbers",V[V.lineNumbersMinChars=60]="lineNumbersMinChars",V[V.linkedEditing=61]="linkedEditing",V[V.links=62]="links",V[V.matchBrackets=63]="matchBrackets",V[V.minimap=64]="minimap",V[V.mouseStyle=65]="mouseStyle",V[V.mouseWheelScrollSensitivity=66]="mouseWheelScrollSensitivity",V[V.mouseWheelZoom=67]="mouseWheelZoom",V[V.multiCursorMergeOverlapping=68]="multiCursorMergeOverlapping",V[V.multiCursorModifier=69]="multiCursorModifier",V[V.multiCursorPaste=70]="multiCursorPaste",V[V.occurrencesHighlight=71]="occurrencesHighlight",V[V.overviewRulerBorder=72]="overviewRulerBorder",V[V.overviewRulerLanes=73]="overviewRulerLanes",V[V.padding=74]="padding",V[V.parameterHints=75]="parameterHints",V[V.peekWidgetDefaultFocus=76]="peekWidgetDefaultFocus",V[V.definitionLinkOpensInPeek=77]="definitionLinkOpensInPeek",V[V.quickSuggestions=78]="quickSuggestions",V[V.quickSuggestionsDelay=79]="quickSuggestionsDelay",V[V.readOnly=80]="readOnly",V[V.renameOnType=81]="renameOnType",V[V.renderControlCharacters=82]="renderControlCharacters",V[V.renderFinalNewline=83]="renderFinalNewline",V[V.renderLineHighlight=84]="renderLineHighlight",V[V.renderLineHighlightOnlyWhenFocus=85]="renderLineHighlightOnlyWhenFocus",V[V.renderValidationDecorations=86]="renderValidationDecorations",V[V.renderWhitespace=87]="renderWhitespace",V[V.revealHorizontalRightPadding=88]="revealHorizontalRightPadding",V[V.roundedSelection=89]="roundedSelection",V[V.rulers=90]="rulers",V[V.scrollbar=91]="scrollbar",V[V.scrollBeyondLastColumn=92]="scrollBeyondLastColumn",V[V.scrollBeyondLastLine=93]="scrollBeyondLastLine",V[V.scrollPredominantAxis=94]="scrollPredominantAxis",V[V.selectionClipboard=95]="selectionClipboard",V[V.selectionHighlight=96]="selectionHighlight",V[V.selectOnLineNumbers=97]="selectOnLineNumbers",V[V.showFoldingControls=98]="showFoldingControls",V[V.showUnused=99]="showUnused",V[V.snippetSuggestions=100]="snippetSuggestions",V[V.smartSelect=101]="smartSelect",V[V.smoothScrolling=102]="smoothScrolling",V[V.stickyTabStops=103]="stickyTabStops",V[V.stopRenderingLineAfter=104]="stopRenderingLineAfter",V[V.suggest=105]="suggest",V[V.suggestFontSize=106]="suggestFontSize",V[V.suggestLineHeight=107]="suggestLineHeight",V[V.suggestOnTriggerCharacters=108]="suggestOnTriggerCharacters",V[V.suggestSelection=109]="suggestSelection",V[V.tabCompletion=110]="tabCompletion",V[V.tabIndex=111]="tabIndex",V[V.unicodeHighlighting=112]="unicodeHighlighting",V[V.unusualLineTerminators=113]="unusualLineTerminators",V[V.useShadowDOM=114]="useShadowDOM",V[V.useTabStops=115]="useTabStops",V[V.wordSeparators=116]="wordSeparators",V[V.wordWrap=117]="wordWrap",V[V.wordWrapBreakAfterCharacters=118]="wordWrapBreakAfterCharacters",V[V.wordWrapBreakBeforeCharacters=119]="wordWrapBreakBeforeCharacters",V[V.wordWrapColumn=120]="wordWrapColumn",V[V.wordWrapOverride1=121]="wordWrapOverride1",V[V.wordWrapOverride2=122]="wordWrapOverride2",V[V.wrappingIndent=123]="wrappingIndent",V[V.wrappingStrategy=124]="wrappingStrategy",V[V.showDeprecated=125]="showDeprecated",V[V.inlayHints=126]="inlayHints",V[V.editorClassName=127]="editorClassName",V[V.pixelRatio=128]="pixelRatio",V[V.tabFocusMode=129]="tabFocusMode",V[V.layoutInfo=130]="layoutInfo",V[V.wrappingInfo=131]="wrappingInfo"})(gt=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:De(new h(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:c.localize(146,null)})),acceptSuggestionOnEnter:De(new f(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",c.localize(147,null),""],markdownDescription:c.localize(148,null)})),accessibilitySupport:De(new u),accessibilityPageSize:De(new l(3,"accessibilityPageSize",10,1,1073741824,{description:c.localize(149,null)})),ariaLabel:De(new D(4,"ariaLabel",c.localize(150,null))),autoClosingBrackets:De(new f(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",c.localize(151,null),c.localize(152,null),""],description:c.localize(153,null)})),autoClosingDelete:De(new f(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",c.localize(154,null),""],description:c.localize(155,null)})),autoClosingOvertype:De(new f(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",c.localize(156,null),""],description:c.localize(157,null)})),autoClosingQuotes:De(new f(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",c.localize(158,null),c.localize(159,null),""],description:c.localize(160,null)})),autoIndent:De(new g(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],T,{enumDescriptions:[c.localize(161,null),c.localize(162,null),c.localize(163,null),c.localize(164,null),c.localize(165,null)],description:c.localize(166,null)})),automaticLayout:De(new h(10,"automaticLayout",!1)),autoSurround:De(new f(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[c.localize(167,null),c.localize(168,null),c.localize(169,null),""],description:c.localize(170,null)})),bracketPairColorization:De(new se),bracketPairGuides:De(new j),stickyTabStops:De(new h(103,"stickyTabStops",!1,{description:c.localize(171,null)})),codeLens:De(new h(14,"codeLens",!0,{description:c.localize(172,null)})),codeLensFontFamily:De(new D(15,"codeLensFontFamily","",{description:c.localize(173,null)})),codeLensFontSize:De(new l(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:c.localize(174,null)})),colorDecorators:De(new h(17,"colorDecorators",!0,{description:c.localize(175,null)})),columnSelection:De(new h(18,"columnSelection",!1,{description:c.localize(176,null)})),comments:De(new M),contextmenu:De(new h(20,"contextmenu",!0)),copyWithSyntaxHighlighting:De(new h(21,"copyWithSyntaxHighlighting",!0,{description:c.localize(177,null)})),cursorBlinking:De(new g(22,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],i,{description:c.localize(178,null)})),cursorSmoothCaretAnimation:De(new h(23,"cursorSmoothCaretAnimation",!1,{description:c.localize(179,null)})),cursorStyle:De(new g(24,"cursorStyle",p.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],o,{description:c.localize(180,null)})),cursorSurroundingLines:De(new l(25,"cursorSurroundingLines",0,0,1073741824,{description:c.localize(181,null)})),cursorSurroundingLinesStyle:De(new f(26,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[c.localize(182,null),c.localize(183,null)],description:c.localize(184,null)})),cursorWidth:De(new l(27,"cursorWidth",0,0,1073741824,{markdownDescription:c.localize(185,null)})),disableLayerHinting:De(new h(28,"disableLayerHinting",!1)),disableMonospaceOptimizations:De(new h(29,"disableMonospaceOptimizations",!1)),domReadOnly:De(new h(30,"domReadOnly",!1)),dragAndDrop:De(new h(31,"dragAndDrop",!0,{description:c.localize(186,null)})),emptySelectionClipboard:De(new a),extraEditorClassName:De(new D(33,"extraEditorClassName","")),fastScrollSensitivity:De(new d(34,"fastScrollSensitivity",5,V=>V<=0?5:V,{markdownDescription:c.localize(187,null)})),find:De(new E),fixedOverflowWidgets:De(new h(36,"fixedOverflowWidgets",!1)),folding:De(new h(37,"folding",!0,{description:c.localize(188,null)})),foldingStrategy:De(new f(38,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[c.localize(189,null),c.localize(190,null)],description:c.localize(191,null)})),foldingHighlight:De(new h(39,"foldingHighlight",!0,{description:c.localize(192,null)})),foldingImportsByDefault:De(new h(40,"foldingImportsByDefault",!1,{description:c.localize(193,null)})),unfoldOnClickAfterEndOfLine:De(new h(41,"unfoldOnClickAfterEndOfLine",!1,{description:c.localize(194,null)})),fontFamily:De(new D(42,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:c.localize(195,null)})),fontInfo:De(new k),fontLigatures2:De(new P),fontSize:De(new B),fontWeight:De(new L),formatOnPaste:De(new h(47,"formatOnPaste",!1,{description:c.localize(196,null)})),formatOnType:De(new h(48,"formatOnType",!1,{description:c.localize(197,null)})),glyphMargin:De(new h(49,"glyphMargin",!0,{description:c.localize(198,null)})),gotoLocation:De(new y),hideCursorInOverviewRuler:De(new h(51,"hideCursorInOverviewRuler",!1,{description:c.localize(199,null)})),hover:De(new x),inDiffEditor:De(new h(53,"inDiffEditor",!1)),letterSpacing:De(new d(55,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,V=>d.clamp(V,-5,20),{description:c.localize(200,null)})),lightbulb:De(new H),lineDecorationsWidth:De(new _(57,"lineDecorationsWidth",10)),lineHeight:De(new ue),lineNumbers:De(new Fe),lineNumbersMinChars:De(new l(60,"lineNumbersMinChars",5,1,300)),linkedEditing:De(new h(61,"linkedEditing",!1,{description:c.localize(201,null)})),links:De(new h(62,"links",!0,{description:c.localize(202,null)})),matchBrackets:De(new f(63,"matchBrackets","always",["always","near","never"],{description:c.localize(203,null)})),minimap:De(new K),mouseStyle:De(new f(65,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:De(new d(66,"mouseWheelScrollSensitivity",1,V=>V===0?1:V,{markdownDescription:c.localize(204,null)})),mouseWheelZoom:De(new h(67,"mouseWheelZoom",!1,{markdownDescription:c.localize(205,null)})),multiCursorMergeOverlapping:De(new h(68,"multiCursorMergeOverlapping",!0,{description:c.localize(206,null)})),multiCursorModifier:De(new g(69,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],ce,{markdownEnumDescriptions:[c.localize(207,null),c.localize(208,null)],markdownDescription:c.localize(209,null)})),multiCursorPaste:De(new f(70,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[c.localize(210,null),c.localize(211,null)],markdownDescription:c.localize(212,null)})),occurrencesHighlight:De(new h(71,"occurrencesHighlight",!0,{description:c.localize(213,null)})),overviewRulerBorder:De(new h(72,"overviewRulerBorder",!0,{description:c.localize(214,null)})),overviewRulerLanes:De(new l(73,"overviewRulerLanes",3,0,3)),padding:De(new de),parameterHints:De(new Q),peekWidgetDefaultFocus:De(new f(76,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[c.localize(215,null),c.localize(216,null)],description:c.localize(217,null)})),definitionLinkOpensInPeek:De(new h(77,"definitionLinkOpensInPeek",!1,{description:c.localize(218,null)})),quickSuggestions:De(new we),quickSuggestionsDelay:De(new l(79,"quickSuggestionsDelay",10,0,1073741824,{description:c.localize(219,null)})),readOnly:De(new h(80,"readOnly",!1)),renameOnType:De(new h(81,"renameOnType",!1,{description:c.localize(220,null),markdownDeprecationMessage:c.localize(221,null)})),renderControlCharacters:De(new h(82,"renderControlCharacters",!0,{description:c.localize(222,null),restricted:!0})),renderFinalNewline:De(new h(83,"renderFinalNewline",!0,{description:c.localize(223,null)})),renderLineHighlight:De(new f(84,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",c.localize(224,null)],description:c.localize(225,null)})),renderLineHighlightOnlyWhenFocus:De(new h(85,"renderLineHighlightOnlyWhenFocus",!1,{description:c.localize(226,null)})),renderValidationDecorations:De(new f(86,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:De(new f(87,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",c.localize(227,null),c.localize(228,null),c.localize(229,null),""],description:c.localize(230,null)})),revealHorizontalRightPadding:De(new l(88,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:De(new h(89,"roundedSelection",!0,{description:c.localize(231,null)})),rulers:De(new Ge),scrollbar:De(new Qe),scrollBeyondLastColumn:De(new l(92,"scrollBeyondLastColumn",5,0,1073741824,{description:c.localize(232,null)})),scrollBeyondLastLine:De(new h(93,"scrollBeyondLastLine",!0,{description:c.localize(233,null)})),scrollPredominantAxis:De(new h(94,"scrollPredominantAxis",!0,{description:c.localize(234,null)})),selectionClipboard:De(new h(95,"selectionClipboard",!0,{description:c.localize(235,null),included:F.isLinux})),selectionHighlight:De(new h(96,"selectionHighlight",!0,{description:c.localize(236,null)})),selectOnLineNumbers:De(new h(97,"selectOnLineNumbers",!0)),showFoldingControls:De(new f(98,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[c.localize(237,null),c.localize(238,null)],description:c.localize(239,null)})),showUnused:De(new h(99,"showUnused",!0,{description:c.localize(240,null)})),showDeprecated:De(new h(125,"showDeprecated",!0,{description:c.localize(241,null)})),inlayHints:De(new q),snippetSuggestions:De(new f(100,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[c.localize(242,null),c.localize(243,null),c.localize(244,null),c.localize(245,null)],description:c.localize(246,null)})),smartSelect:De(new Te),smoothScrolling:De(new h(102,"smoothScrolling",!1,{description:c.localize(247,null)})),stopRenderingLineAfter:De(new l(104,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:De(new fe),inlineSuggest:De(new X),suggestFontSize:De(new l(106,"suggestFontSize",0,0,1e3,{markdownDescription:c.localize(248,null)})),suggestLineHeight:De(new l(107,"suggestLineHeight",0,0,1e3,{markdownDescription:c.localize(249,null)})),suggestOnTriggerCharacters:De(new h(108,"suggestOnTriggerCharacters",!0,{description:c.localize(250,null)})),suggestSelection:De(new f(109,"suggestSelection","recentlyUsed",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[c.localize(251,null),c.localize(252,null),c.localize(253,null)],description:c.localize(254,null)})),tabCompletion:De(new f(110,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[c.localize(255,null),c.localize(256,null),c.localize(257,null)],description:c.localize(258,null)})),tabIndex:De(new l(111,"tabIndex",0,-1,1073741824)),unicodeHighlight:De(new $),unusualLineTerminators:De(new f(113,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[c.localize(259,null),c.localize(260,null),c.localize(261,null)],description:c.localize(262,null)})),useShadowDOM:De(new h(114,"useShadowDOM",!0)),useTabStops:De(new h(115,"useTabStops",!0,{description:c.localize(263,null)})),wordSeparators:De(new D(116,"wordSeparators",w.USUAL_WORD_SEPARATORS,{description:c.localize(264,null)})),wordWrap:De(new f(117,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[c.localize(265,null),c.localize(266,null),c.localize(267,null),c.localize(268,null)],description:c.localize(269,null)})),wordWrapBreakAfterCharacters:De(new D(118,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:De(new D(119,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:De(new l(120,"wordWrapColumn",80,1,1073741824,{markdownDescription:c.localize(270,null)})),wordWrapOverride1:De(new f(121,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:De(new f(122,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:De(new g(123,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],Ke,{enumDescriptions:[c.localize(271,null),c.localize(272,null),c.localize(273,null),c.localize(274,null)],description:c.localize(275,null)})),wrappingStrategy:De(new f(124,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[c.localize(276,null),c.localize(277,null)],description:c.localize(278,null)})),editorClassName:De(new b),pixelRatio:De(new ie),tabFocusMode:De(new Ne),layoutInfo:De(new z),wrappingInfo:De(new tt)}}),define(Ee[115],_e([18,19]),function(oe,e){return oe.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Ee[116],_e([18,19]),function(oe,e){return oe.create("vs/platform/extensions/common/extensionValidator",e)}),define(Ee[117],_e([18,19]),function(oe,e){return oe.create("vs/platform/files/common/files",e)}),define(Ee[118],_e([18,19]),function(oe,e){return oe.create("vs/platform/markers/common/markers",e)}),define(Ee[119],_e([18,19]),function(oe,e){return oe.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Ee[120],_e([18,19]),function(oe,e){return oe.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Ee[121],_e([18,19]),function(oe,e){return oe.create("vs/workbench/api/common/extHostProgress",e)}),define(Ee[122],_e([18,19]),function(oe,e){return oe.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Ee[123],_e([18,19]),function(oe,e){return oe.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Ee[124],_e([18,19]),function(oe,e){return oe.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Ee[125],_e([18,19]),function(oe,e){return oe.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Ee[126],_e([18,19]),function(oe,e){return oe.create("vs/workbench/common/editor",e)}),define(Ee[127],_e([18,19]),function(oe,e){return oe.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Ee[128],_e([18,19]),function(oe,e){return oe.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(Ee[129],_e([18,19]),function(oe,e){return oe.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(Ee[130],_e([18,19]),function(oe,e){return oe.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Ee[131],_e([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorResolution=e.EditorActivation=void 0;var c;(function(t){t[t.ACTIVATE=1]="ACTIVATE",t[t.RESTORE=2]="RESTORE",t[t.PRESERVE=3]="PRESERVE"})(c=e.EditorActivation||(e.EditorActivation={}));var F;(function(t){t[t.PICK=0]="PICK",t[t.DISABLED=1]="DISABLED",t[t.EXCLUSIVE_ONLY=2]="EXCLUSIVE_ONLY"})(F=e.EditorResolution||(e.EditorResolution={}));var w;(function(t){t[t.API=0]="API",t[t.USER=1]="USER"})(w=e.EditorOpenContext||(e.EditorOpenContext={}));var I;(function(t){t[t.Center=0]="Center",t[t.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",t[t.NearTop=2]="NearTop",t[t.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(I=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(Ee[132],_e([0,1,116]),function(oe,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const F=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,w=/^-(\d{4})(\d{2})(\d{2})$/;function I(n){return n=n.trim(),n==="*"||F.test(n)}e.isValidVersionStr=I;function t(n){if(!I(n))return null;if(n=n.trim(),n==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let h=n.match(F);return h?{hasCaret:h[1]==="^",hasGreaterEquals:h[1]===">=",majorBase:h[2]==="x"?0:parseInt(h[2],10),majorMustEqual:h[2]!=="x",minorBase:h[4]==="x"?0:parseInt(h[4],10),minorMustEqual:h[4]!=="x",patchBase:h[6]==="x"?0:parseInt(h[6],10),patchMustEqual:h[6]!=="x",preRelease:h[8]||null}:null}e.parseVersion=t;function R(n){if(!n)return null;let h=n.majorBase,s=n.majorMustEqual,l=n.minorBase,d=n.minorMustEqual,D=n.patchBase,v=n.patchMustEqual;n.hasCaret&&(h===0||(d=!1),v=!1);let f=0;if(n.preRelease){const g=w.exec(n.preRelease);if(g){const[,T,u,M]=g;f=Date.UTC(Number(T),Number(u)-1,Number(M))}}return{majorBase:h,majorMustEqual:s,minorBase:l,minorMustEqual:d,patchBase:D,patchMustEqual:v,isMinimum:n.hasGreaterEquals,notBefore:f}}e.normalizeVersion=R;function S(n,h,s){let l;typeof n=="string"?l=R(t(n)):l=n;let d;h instanceof Date?d=h.getTime():typeof h=="string"&&(d=new Date(h).getTime());let D;if(typeof s=="string"?D=R(t(s)):D=s,!l||!D)return!1;let v=l.majorBase,f=l.minorBase,g=l.patchBase,T=D.majorBase,u=D.minorBase,M=D.patchBase,r=D.notBefore,i=D.majorMustEqual,p=D.minorMustEqual,m=D.patchMustEqual;return D.isMinimum?v>T?!0:v<T?!1:f>u?!0:f<u||d&&d<r?!1:g>=M:(v===1&&T===0&&(!i||!p||!m)&&(T=1,u=0,M=0,i=!0,p=!1,m=!1),v<T?!1:v>T?!i:f<u?!1:f>u?!p:g<M?!1:g>M?!m:!(d&&d<r))}e.isValidVersion=S;function C(n,h,s,l){return s.isBuiltin||typeof s.main=="undefined"?!0:_(n,h,s.engines.vscode,l)}e.isValidExtensionVersion=C;function A(n,h,s){return n==="*"||_(h,s,n)}e.isEngineValid=A;function _(n,h,s,l=[]){let d=R(t(s));if(!d)return l.push(c.localize(0,null,s)),!1;if(d.majorBase===0){if(!d.majorMustEqual||!d.minorMustEqual)return l.push(c.localize(1,null,s)),!1}else if(!d.majorMustEqual)return l.push(c.localize(2,null,s)),!1;return S(n,h,d)?!0:(l.push(c.localize(3,null,n,s)),!1)}}),define(Ee[80],_e([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class c{constructor(w,I=[],t=!1){this.ctor=w,this.staticArguments=I,this.supportsDelayedInstantiation=t}}e.SyncDescriptor=c}),define(Ee[56],_e([0,1,80]),function(oe,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const F=[];function w(t,R,S){R instanceof c.SyncDescriptor||(R=new c.SyncDescriptor(R,[],S)),F.push([t,R])}e.registerSingleton=w;function I(){return F}e.getSingletonServiceDescriptors=I}),define(Ee[133],_e([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class c{constructor(I){this.incoming=new Map,this.outgoing=new Map,this.data=I}}e.Node=c;class F{constructor(I){this._hashFn=I,this._nodes=new Map}roots(){const I=[];for(let t of this._nodes.values())t.outgoing.size===0&&I.push(t);return I}insertEdge(I,t){const R=this.lookupOrInsertNode(I),S=this.lookupOrInsertNode(t);R.outgoing.set(this._hashFn(t),S),S.incoming.set(this._hashFn(I),R)}removeNode(I){const t=this._hashFn(I);this._nodes.delete(t);for(let R of this._nodes.values())R.outgoing.delete(t),R.incoming.delete(t)}lookupOrInsertNode(I){const t=this._hashFn(I);let R=this._nodes.get(t);return R||(R=new c(I),this._nodes.set(t,R)),R}lookup(I){return this._nodes.get(this._hashFn(I))}isEmpty(){return this._nodes.size===0}toString(){let I=[];for(let[t,R]of this._nodes)I.push(`${t}, (incoming)[${[...R.incoming.keys()].join(", ")}], (outgoing)[${[...R.outgoing.keys()].join(",")}]`);return I.join(`
`)}findCycleSlow(){for(let[I,t]of this._nodes){const R=new Set([I]),S=this._findCycle(t,R);if(S)return S}}_findCycle(I,t){for(let[R,S]of I.outgoing){if(t.has(R))return[...t,R].join(" -> ");t.add(R);const C=this._findCycle(S,t);if(C)return C;t.delete(R)}}}e.Graph=F}),define(Ee[4],_e([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var c;(function(t){t.serviceIds=new Map,t.DI_TARGET="$di$target",t.DI_DEPENDENCIES="$di$dependencies";function R(S){return S[t.DI_DEPENDENCIES]||[]}t.getServiceDependencies=R})(c=e._util||(e._util={})),e.IInstantiationService=w("instantiationService");function F(t,R,S,C){R[c.DI_TARGET]===R?R[c.DI_DEPENDENCIES].push({id:t,index:S,optional:C}):(R[c.DI_DEPENDENCIES]=[{id:t,index:S,optional:C}],R[c.DI_TARGET]=R)}function w(t){if(c.serviceIds.has(t))return c.serviceIds.get(t);const R=function(S,C,A){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");F(R,S,A,!1)};return R.toString=()=>t,c.serviceIds.set(t,R),R}e.createDecorator=w;function I(t){return t}e.refineServiceDecorator=I}),define(Ee[134],_e([0,1,4]),function(oe,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=(0,c.createDecorator)("modelService");function F(w){return!w.isTooLargeForSyncing()&&!w.isForSimpleWidget}e.shouldSynchronizeModel=F}),define(Ee[135],_e([0,1,3,57,6,21,75,55,134]),function(oe,e,c,F,w,I,t,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRequestDelays=e.LanguageFeatureRegistry=void 0;function C(l){return typeof l=="string"?!1:Array.isArray(l)?l.every(C):!!l.exclusive}class A{constructor(){this._clock=0,this._entries=[],this._onDidChange=new c.Emitter}get onDidChange(){return this._onDidChange.event}register(d,D){let v={selector:d,provider:D,_score:-1,_time:this._clock++};return this._entries.push(v),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),(0,w.toDisposable)(()=>{if(v){let f=this._entries.indexOf(v);f>=0&&(this._entries.splice(f,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),v=void 0)}})}has(d){return this.all(d).length>0}all(d){if(!d)return[];this._updateScores(d);const D=[];for(let v of this._entries)v._score>0&&D.push(v.provider);return D}ordered(d){const D=[];return this._orderedForEach(d,v=>D.push(v.provider)),D}orderedGroups(d){const D=[];let v,f;return this._orderedForEach(d,g=>{v&&f===g._score?v.push(g.provider):(f=g._score,v=[g.provider],D.push(v))}),D}_orderedForEach(d,D){if(!!d){this._updateScores(d);for(const v of this._entries)v._score>0&&D(v)}}_updateScores(d){let D={uri:d.uri.toString(),language:d.getLanguageId()};if(!(this._lastCandidate&&this._lastCandidate.language===D.language&&this._lastCandidate.uri===D.uri)){this._lastCandidate=D;for(let v of this._entries)if(v._score=(0,R.score)(v.selector,d.uri,d.getLanguageId(),(0,S.shouldSynchronizeModel)(d)),C(v.selector)&&v._score>0){for(let f of this._entries)f._score=0;v._score=1e3;break}this._entries.sort(A._compareByScoreAndTime)}}static _compareByScoreAndTime(d,D){return d._score<D._score?1:d._score>D._score?-1:d._time<D._time?1:d._time>D._time?-1:0}}e.LanguageFeatureRegistry=A;const _=new WeakMap;let n=0;function h(l){let d=_.get(l);return d===void 0&&(d=++n,_.set(l,d)),d}class s{constructor(d,D,v=Number.MAX_SAFE_INTEGER){this._registry=d,this.min=D,this.max=v,this._cache=new I.LRUCache(50,.7)}_key(d){return d.id+this._registry.all(d).reduce((D,v)=>(0,F.doHash)(h(v),D),0)}_clamp(d){return d===void 0?this.min:Math.min(this.max,Math.max(this.min,Math.floor(d*1.3)))}get(d){const D=this._key(d),v=this._cache.get(D);return this._clamp(v?.value)}update(d,D){const v=this._key(d);let f=this._cache.get(v);return f||(f=new t.MovingAverage,this._cache.set(v,f)),f.update(D),this.get(d)}}e.LanguageFeatureRequestDelays=s}),define(Ee[58],_e([0,1,2,59,135,108,53]),function(oe,e,c,F,w,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlayHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.InlineCompletionsProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.completionKindFromString=e.completionKindToCssClass=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageId=void 0;var R;(function(a){a[a.Null=0]="Null",a[a.PlainText=1]="PlainText"})(R=e.LanguageId||(e.LanguageId={}));var S;(function(a){a[a.NotSet=-1]="NotSet",a[a.None=0]="None",a[a.Italic=1]="Italic",a[a.Bold=2]="Bold",a[a.Underline=4]="Underline"})(S=e.FontStyle||(e.FontStyle={}));var C;(function(a){a[a.None=0]="None",a[a.DefaultForeground=1]="DefaultForeground",a[a.DefaultBackground=2]="DefaultBackground"})(C=e.ColorId||(e.ColorId={}));var A;(function(a){a[a.Other=0]="Other",a[a.Comment=1]="Comment",a[a.String=2]="String",a[a.RegEx=4]="RegEx"})(A=e.StandardTokenType||(e.StandardTokenType={}));var _;(function(a){a[a.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",a[a.TOKEN_TYPE_MASK=1792]="TOKEN_TYPE_MASK",a[a.FONT_STYLE_MASK=14336]="FONT_STYLE_MASK",a[a.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",a[a.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",a[a.ITALIC_MASK=2048]="ITALIC_MASK",a[a.BOLD_MASK=4096]="BOLD_MASK",a[a.UNDERLINE_MASK=8192]="UNDERLINE_MASK",a[a.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",a[a.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",a[a.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",a[a.SEMANTIC_USE_FOREGROUND=8]="SEMANTIC_USE_FOREGROUND",a[a.SEMANTIC_USE_BACKGROUND=16]="SEMANTIC_USE_BACKGROUND",a[a.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",a[a.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",a[a.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",a[a.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",a[a.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(_=e.MetadataConsts||(e.MetadataConsts={}));class n{static getLanguageId(E){return(E&255)>>>0}static getTokenType(E){return(E&1792)>>>8}static getFontStyle(E){return(E&14336)>>>11}static getForeground(E){return(E&8372224)>>>14}static getBackground(E){return(E&4286578688)>>>23}static getClassNameFromMetadata(E){let P=this.getForeground(E),k="mtk"+P,B=this.getFontStyle(E);return B&1&&(k+=" mtki"),B&2&&(k+=" mtkb"),B&4&&(k+=" mtku"),k}static getInlineStyleFromMetadata(E,P){const k=this.getForeground(E),B=this.getFontStyle(E);let L=`color: ${P[k]};`;return B&1&&(L+="font-style: italic;"),B&2&&(L+="font-weight: bold;"),B&4&&(L+="text-decoration: underline;"),L}}e.TokenMetadata=n;var h;(function(a){a[a.Method=0]="Method",a[a.Function=1]="Function",a[a.Constructor=2]="Constructor",a[a.Field=3]="Field",a[a.Variable=4]="Variable",a[a.Class=5]="Class",a[a.Struct=6]="Struct",a[a.Interface=7]="Interface",a[a.Module=8]="Module",a[a.Property=9]="Property",a[a.Event=10]="Event",a[a.Operator=11]="Operator",a[a.Unit=12]="Unit",a[a.Value=13]="Value",a[a.Constant=14]="Constant",a[a.Enum=15]="Enum",a[a.EnumMember=16]="EnumMember",a[a.Keyword=17]="Keyword",a[a.Text=18]="Text",a[a.Color=19]="Color",a[a.File=20]="File",a[a.Reference=21]="Reference",a[a.Customcolor=22]="Customcolor",a[a.Folder=23]="Folder",a[a.TypeParameter=24]="TypeParameter",a[a.User=25]="User",a[a.Issue=26]="Issue",a[a.Snippet=27]="Snippet"})(h=e.CompletionItemKind||(e.CompletionItemKind={})),e.completionKindToCssClass=function(){let a=Object.create(null);return a[0]="symbol-method",a[1]="symbol-function",a[2]="symbol-constructor",a[3]="symbol-field",a[4]="symbol-variable",a[5]="symbol-class",a[6]="symbol-struct",a[7]="symbol-interface",a[8]="symbol-module",a[9]="symbol-property",a[10]="symbol-event",a[11]="symbol-operator",a[12]="symbol-unit",a[13]="symbol-value",a[14]="symbol-constant",a[15]="symbol-enum",a[16]="symbol-enum-member",a[17]="symbol-keyword",a[27]="symbol-snippet",a[18]="symbol-text",a[19]="symbol-color",a[20]="symbol-file",a[21]="symbol-reference",a[22]="symbol-customcolor",a[23]="symbol-folder",a[24]="symbol-type-parameter",a[25]="account",a[26]="issues",function(E){const P=a[E];let k=P&&t.iconRegistry.get(P);return k||(console.info("No codicon found for CompletionItemKind "+E),k=t.Codicon.symbolProperty),k.classNames}}(),e.completionKindFromString=function(){let a=Object.create(null);return a.method=0,a.function=1,a.constructor=2,a.field=3,a.variable=4,a.class=5,a.struct=6,a.interface=7,a.module=8,a.property=9,a.event=10,a.operator=11,a.unit=12,a.value=13,a.constant=14,a.enum=15,a["enum-member"]=16,a.enumMember=16,a.keyword=17,a.snippet=27,a.text=18,a.color=19,a.file=20,a.reference=21,a.customcolor=22,a.folder=23,a["type-parameter"]=24,a.typeParameter=24,a.account=25,a.issue=26,function(E,P){let k=a[E];return typeof k=="undefined"&&!P&&(k=9),k}}();var s;(function(a){a[a.Deprecated=1]="Deprecated"})(s=e.CompletionItemTag||(e.CompletionItemTag={}));var l;(function(a){a[a.KeepWhitespace=1]="KeepWhitespace",a[a.InsertAsSnippet=4]="InsertAsSnippet"})(l=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var d;(function(a){a[a.Invoke=0]="Invoke",a[a.TriggerCharacter=1]="TriggerCharacter",a[a.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(d=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var D;(function(a){a[a.Automatic=0]="Automatic",a[a.Explicit=1]="Explicit"})(D=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var v;(function(a){a[a.Invoke=1]="Invoke",a[a.Auto=2]="Auto"})(v=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var f;(function(a){a[a.Invoke=1]="Invoke",a[a.TriggerCharacter=2]="TriggerCharacter",a[a.ContentChange=3]="ContentChange"})(f=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var g;(function(a){a[a.Text=0]="Text",a[a.Read=1]="Read",a[a.Write=2]="Write"})(g=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function T(a){return a&&c.URI.isUri(a.uri)&&F.Range.isIRange(a.range)&&(F.Range.isIRange(a.originSelectionRange)||F.Range.isIRange(a.targetSelectionRange))}e.isLocationLink=T;var u;(function(a){a[a.File=0]="File",a[a.Module=1]="Module",a[a.Namespace=2]="Namespace",a[a.Package=3]="Package",a[a.Class=4]="Class",a[a.Method=5]="Method",a[a.Property=6]="Property",a[a.Field=7]="Field",a[a.Constructor=8]="Constructor",a[a.Enum=9]="Enum",a[a.Interface=10]="Interface",a[a.Function=11]="Function",a[a.Variable=12]="Variable",a[a.Constant=13]="Constant",a[a.String=14]="String",a[a.Number=15]="Number",a[a.Boolean=16]="Boolean",a[a.Array=17]="Array",a[a.Object=18]="Object",a[a.Key=19]="Key",a[a.Null=20]="Null",a[a.EnumMember=21]="EnumMember",a[a.Struct=22]="Struct",a[a.Event=23]="Event",a[a.Operator=24]="Operator",a[a.TypeParameter=25]="TypeParameter"})(u=e.SymbolKind||(e.SymbolKind={}));var M;(function(a){a[a.Deprecated=1]="Deprecated"})(M=e.SymbolTag||(e.SymbolTag={}));var r;(function(a){const E=new Map;E.set("file",0),E.set("module",1),E.set("namespace",2),E.set("package",3),E.set("class",4),E.set("method",5),E.set("property",6),E.set("field",7),E.set("constructor",8),E.set("enum",9),E.set("interface",10),E.set("function",11),E.set("variable",12),E.set("constant",13),E.set("string",14),E.set("number",15),E.set("boolean",16),E.set("array",17),E.set("object",18),E.set("key",19),E.set("null",20),E.set("enum-member",21),E.set("struct",22),E.set("event",23),E.set("operator",24),E.set("type-parameter",25);const P=new Map;P.set(0,"file"),P.set(1,"module"),P.set(2,"namespace"),P.set(3,"package"),P.set(4,"class"),P.set(5,"method"),P.set(6,"property"),P.set(7,"field"),P.set(8,"constructor"),P.set(9,"enum"),P.set(10,"interface"),P.set(11,"function"),P.set(12,"variable"),P.set(13,"constant"),P.set(14,"string"),P.set(15,"number"),P.set(16,"boolean"),P.set(17,"array"),P.set(18,"object"),P.set(19,"key"),P.set(20,"null"),P.set(21,"enum-member"),P.set(22,"struct"),P.set(23,"event"),P.set(24,"operator"),P.set(25,"type-parameter");function k(y){return E.get(y)}a.fromString=k;function B(y){return P.get(y)}a.toString=B;function L(y,x){const N=P.get(y);let z=N&&t.iconRegistry.get("symbol-"+N);return z||(console.info("No codicon found for SymbolKind "+y),z=t.Codicon.symbolProperty),`${x?"inline":"block"} ${z.classNames}`}a.toCssClassName=L})(r=e.SymbolKinds||(e.SymbolKinds={}));class i{constructor(E){this.value=E}}e.FoldingRangeKind=i,i.Comment=new i("comment"),i.Imports=new i("imports"),i.Region=new i("region");var p;(function(a){a[a.Collapsed=0]="Collapsed",a[a.Expanded=1]="Expanded"})(p=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var m;(function(a){a[a.Editing=0]="Editing",a[a.Preview=1]="Preview"})(m=e.CommentMode||(e.CommentMode={}));var o;(function(a){a[a.Other=0]="Other",a[a.Type=1]="Type",a[a.Parameter=2]="Parameter"})(o=e.InlayHintKind||(e.InlayHintKind={})),e.ReferenceProviderRegistry=new w.LanguageFeatureRegistry,e.RenameProviderRegistry=new w.LanguageFeatureRegistry,e.CompletionProviderRegistry=new w.LanguageFeatureRegistry,e.InlineCompletionsProviderRegistry=new w.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new w.LanguageFeatureRegistry,e.HoverProviderRegistry=new w.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new w.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new w.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new w.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new w.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new w.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new w.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new w.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new w.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new w.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new w.LanguageFeatureRegistry,e.InlayHintsProviderRegistry=new w.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new w.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new w.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new w.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new w.LanguageFeatureRegistry,e.LinkProviderRegistry=new w.LanguageFeatureRegistry,e.ColorProviderRegistry=new w.LanguageFeatureRegistry,e.SelectionRangeRegistry=new w.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new w.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new w.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new w.LanguageFeatureRegistry,e.TokenizationRegistry=new I.TokenizationRegistryImpl;var b;(function(a){a[a.None=0]="None",a[a.Option=1]="Option",a[a.Default=2]="Default",a[a.Preferred=3]="Preferred"})(b=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(Ee[81],_e([0,1,11,2,4]),function(oe,e,c,F,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,w.createDecorator)("configurationService");function I(d){return d&&typeof d=="object"&&(!d.overrideIdentifier||typeof d.overrideIdentifier=="string")&&(!d.resource||d.resource instanceof F.URI)}e.isConfigurationOverrides=I;function t(d){return d&&typeof d=="object"&&(!d.overrideIdentifiers||c.isArray(d.overrideIdentifiers))&&!d.overrideIdentifier&&(!d.resource||d.resource instanceof F.URI)}e.isConfigurationUpdateOverrides=t;var R;(function(d){d[d.USER=1]="USER",d[d.USER_LOCAL=2]="USER_LOCAL",d[d.USER_REMOTE=3]="USER_REMOTE",d[d.WORKSPACE=4]="WORKSPACE",d[d.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",d[d.DEFAULT=6]="DEFAULT",d[d.MEMORY=7]="MEMORY"})(R=e.ConfigurationTarget||(e.ConfigurationTarget={}));function S(d){switch(d){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=S;function C(d,D){const v=Object.create(null);for(let f in d)A(v,f,d[f],D);return v}e.toValuesTree=C;function A(d,D,v,f){const g=D.split("."),T=g.pop();let u=d;for(let M=0;M<g.length;M++){let r=g[M],i=u[r];switch(typeof i){case"undefined":i=u[r]=Object.create(null);break;case"object":break;default:f(`Ignoring ${D} as ${g.slice(0,M+1).join(".")} is ${JSON.stringify(i)}`);return}u=i}if(typeof u=="object"&&u!==null)try{u[T]=v}catch(M){f(`Ignoring ${D} as ${g.join(".")} is ${JSON.stringify(u)}`)}else f(`Ignoring ${D} as ${g.join(".")} is ${JSON.stringify(u)}`)}e.addToValueTree=A;function _(d,D){const v=D.split(".");n(d,v)}e.removeFromValueTree=_;function n(d,D){const v=D.shift();if(D.length===0){delete d[v];return}if(Object.keys(d).indexOf(v)!==-1){const f=d[v];typeof f=="object"&&!Array.isArray(f)&&(n(f,D),Object.keys(f).length===0&&delete d[v])}}function h(d,D,v){function f(u,M){let r=u;for(const i of M){if(typeof r!="object"||r===null)return;r=r[i]}return r}const g=D.split("."),T=f(d,g);return typeof T=="undefined"?v:T}e.getConfigurationValue=h;function s(d,D,v){Object.keys(D).forEach(f=>{f!=="__proto__"&&(f in d?c.isObject(d[f])&&c.isObject(D[f])?s(d[f],D[f],v):v&&(d[f]=D[f]):d[f]=D[f])})}e.merge=s;function l(d,D,v){const f=d.inspect(D),g=d.inspect(v);return typeof f.userValue!="undefined"||typeof f.workspaceValue!="undefined"||typeof f.workspaceFolderValue!="undefined"?f.value:typeof g.userValue!="undefined"||typeof g.workspaceValue!="undefined"||typeof g.workspaceFolderValue!="undefined"?g.value:f.defaultValue}e.getMigratedSettingValue=l}),define(Ee[45],_e([0,1,23,9,4]),function(oe,e,c,F,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let I=c.userAgent||"";const t=new Map;t.set("false",!1),t.set("true",!0),t.set("isMac",c.isMacintosh),t.set("isLinux",c.isLinux),t.set("isWindows",c.isWindows),t.set("isWeb",c.isWeb),t.set("isMacNative",c.isMacintosh&&!c.isWeb),t.set("isEdge",I.indexOf("Edg/")>=0),t.set("isFirefox",I.indexOf("Firefox")>=0),t.set("isChrome",I.indexOf("Chrome")>=0),t.set("isSafari",I.indexOf("Safari")>=0);const R=Object.prototype.hasOwnProperty;var S;(function(L){L[L.False=0]="False",L[L.True=1]="True",L[L.Defined=2]="Defined",L[L.Not=3]="Not",L[L.Equals=4]="Equals",L[L.NotEquals=5]="NotEquals",L[L.And=6]="And",L[L.Regex=7]="Regex",L[L.NotRegex=8]="NotRegex",L[L.Or=9]="Or",L[L.In=10]="In",L[L.NotIn=11]="NotIn",L[L.Greater=12]="Greater",L[L.GreaterEquals=13]="GreaterEquals",L[L.Smaller=14]="Smaller",L[L.SmallerEquals=15]="SmallerEquals"})(S=e.ContextKeyExprType||(e.ContextKeyExprType={}));class C{static false(){return n.INSTANCE}static true(){return h.INSTANCE}static has(y){return s.create(y)}static equals(y,x){return l.create(y,x)}static notEquals(y,x){return v.create(y,x)}static regex(y,x){return i.create(y,x)}static in(y,x){return d.create(y,x)}static not(y){return f.create(y)}static and(...y){return o.create(y,null)}static or(...y){return b.create(y,null,!0)}static greater(y,x){return T.create(y,x)}static greaterEquals(y,x){return u.create(y,x)}static smaller(y,x){return M.create(y,x)}static smallerEquals(y,x){return r.create(y,x)}static deserialize(y,x=!1){if(!!y)return this._deserializeOrExpression(y,x)}static _deserializeOrExpression(y,x){let N=y.split("||");return b.create(N.map(z=>this._deserializeAndExpression(z,x)),null,!0)}static _deserializeAndExpression(y,x){let N=y.split("&&");return o.create(N.map(z=>this._deserializeOne(z,x)),null)}static _deserializeOne(y,x){if(y=y.trim(),y.indexOf("!=")>=0){let N=y.split("!=");return v.create(N[0].trim(),this._deserializeValue(N[1],x))}if(y.indexOf("==")>=0){let N=y.split("==");return l.create(N[0].trim(),this._deserializeValue(N[1],x))}if(y.indexOf("=~")>=0){let N=y.split("=~");return i.create(N[0].trim(),this._deserializeRegexValue(N[1],x))}if(y.indexOf(" in ")>=0){let N=y.split(" in ");return d.create(N[0].trim(),N[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(y)){const N=y.split(">=");return u.create(N[0].trim(),N[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(y)){const N=y.split(">");return T.create(N[0].trim(),N[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(y)){const N=y.split("<=");return r.create(N[0].trim(),N[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(y)){const N=y.split("<");return M.create(N[0].trim(),N[1].trim())}return/^\!\s*/.test(y)?f.create(y.substr(1).trim()):s.create(y)}static _deserializeValue(y,x){if(y=y.trim(),y==="true")return!0;if(y==="false")return!1;let N=/^'([^']*)'$/.exec(y);return N?N[1].trim():y}static _deserializeRegexValue(y,x){if((0,F.isFalsyOrWhitespace)(y)){if(x)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let N=y.indexOf("/"),z=y.lastIndexOf("/");if(N===z||N<0){if(x)throw new Error(`bad regexp-value '${y}', missing /-enclosure`);return console.warn(`bad regexp-value '${y}', missing /-enclosure`),null}let H=y.slice(N+1,z),q=y[z+1]==="i"?"i":"";try{return new RegExp(H,q)}catch(ue){if(x)throw new Error(`bad regexp-value '${y}', parse error: ${ue}`);return console.warn(`bad regexp-value '${y}', parse error: ${ue}`),null}}}e.ContextKeyExpr=C;function A(L,y){const x=L?L.substituteConstants():void 0,N=y?y.substituteConstants():void 0;return!x&&!N?!0:!x||!N?!1:x.equals(N)}e.expressionsAreEqualWithConstantSubstitution=A;function _(L,y){return L.cmp(y)}class n{constructor(){this.type=0}cmp(y){return this.type-y.type}equals(y){return y.type===this.type}substituteConstants(){return this}evaluate(y){return!1}serialize(){return"false"}keys(){return[]}map(y){return this}negate(){return h.INSTANCE}}e.ContextKeyFalseExpr=n,n.INSTANCE=new n;class h{constructor(){this.type=1}cmp(y){return this.type-y.type}equals(y){return y.type===this.type}substituteConstants(){return this}evaluate(y){return!0}serialize(){return"true"}keys(){return[]}map(y){return this}negate(){return n.INSTANCE}}e.ContextKeyTrueExpr=h,h.INSTANCE=new h;class s{constructor(y,x){this.key=y,this.negated=x,this.type=2}static create(y,x=null){const N=t.get(y);return typeof N=="boolean"?N?h.INSTANCE:n.INSTANCE:new s(y,x)}cmp(y){return y.type!==this.type?this.type-y.type:E(this.key,y.key)}equals(y){return y.type===this.type?this.key===y.key:!1}substituteConstants(){const y=t.get(this.key);return typeof y=="boolean"?y?h.INSTANCE:n.INSTANCE:this}evaluate(y){return!!y.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(y){return y.mapDefined(this.key)}negate(){return this.negated||(this.negated=f.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=s;class l{constructor(y,x,N){this.key=y,this.value=x,this.negated=N,this.type=4}static create(y,x,N=null){if(typeof x=="boolean")return x?s.create(y,N):f.create(y,N);const z=t.get(y);return typeof z=="boolean"?x===(z?"true":"false")?h.INSTANCE:n.INSTANCE:new l(y,x,N)}cmp(y){return y.type!==this.type?this.type-y.type:P(this.key,this.value,y.key,y.value)}equals(y){return y.type===this.type?this.key===y.key&&this.value===y.value:!1}substituteConstants(){const y=t.get(this.key);if(typeof y=="boolean"){const x=y?"true":"false";return this.value===x?h.INSTANCE:n.INSTANCE}return this}evaluate(y){return y.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(y){return y.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=v.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=l;class d{constructor(y,x){this.key=y,this.valueKey=x,this.type=10,this.negated=null}static create(y,x){return new d(y,x)}cmp(y){return y.type!==this.type?this.type-y.type:P(this.key,this.valueKey,y.key,y.valueKey)}equals(y){return y.type===this.type?this.key===y.key&&this.valueKey===y.valueKey:!1}substituteConstants(){return this}evaluate(y){const x=y.getValue(this.valueKey),N=y.getValue(this.key);return Array.isArray(x)?x.indexOf(N)>=0:typeof N=="string"&&typeof x=="object"&&x!==null?R.call(x,N):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(y){return y.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=D.create(this)),this.negated}}e.ContextKeyInExpr=d;class D{constructor(y){this._actual=y,this.type=11}static create(y){return new D(y)}cmp(y){return y.type!==this.type?this.type-y.type:this._actual.cmp(y._actual)}equals(y){return y.type===this.type?this._actual.equals(y._actual):!1}substituteConstants(){return this}evaluate(y){return!this._actual.evaluate(y)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(y){return new D(this._actual.map(y))}negate(){return this._actual}}e.ContextKeyNotInExpr=D;class v{constructor(y,x,N){this.key=y,this.value=x,this.negated=N,this.type=5}static create(y,x,N=null){if(typeof x=="boolean")return x?f.create(y,N):s.create(y,N);const z=t.get(y);return typeof z=="boolean"?x===(z?"true":"false")?n.INSTANCE:h.INSTANCE:new v(y,x,N)}cmp(y){return y.type!==this.type?this.type-y.type:P(this.key,this.value,y.key,y.value)}equals(y){return y.type===this.type?this.key===y.key&&this.value===y.value:!1}substituteConstants(){const y=t.get(this.key);if(typeof y=="boolean"){const x=y?"true":"false";return this.value===x?n.INSTANCE:h.INSTANCE}return this}evaluate(y){return y.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(y){return y.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=l.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=v;class f{constructor(y,x){this.key=y,this.negated=x,this.type=3}static create(y,x=null){const N=t.get(y);return typeof N=="boolean"?N?n.INSTANCE:h.INSTANCE:new f(y,x)}cmp(y){return y.type!==this.type?this.type-y.type:E(this.key,y.key)}equals(y){return y.type===this.type?this.key===y.key:!1}substituteConstants(){const y=t.get(this.key);return typeof y=="boolean"?y?n.INSTANCE:h.INSTANCE:this}evaluate(y){return!y.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(y){return y.mapNot(this.key)}negate(){return this.negated||(this.negated=s.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=f;function g(L,y){if(typeof L=="string"){const x=parseFloat(L);isNaN(x)||(L=x)}return typeof L=="string"||typeof L=="number"?y(L):n.INSTANCE}class T{constructor(y,x,N){this.key=y,this.value=x,this.negated=N,this.type=12}static create(y,x,N=null){return g(x,z=>new T(y,z,N))}cmp(y){return y.type!==this.type?this.type-y.type:P(this.key,this.value,y.key,y.value)}equals(y){return y.type===this.type?this.key===y.key&&this.value===y.value:!1}substituteConstants(){return this}evaluate(y){return typeof this.value=="string"?!1:parseFloat(y.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(y){return y.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=r.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=T;class u{constructor(y,x,N){this.key=y,this.value=x,this.negated=N,this.type=13}static create(y,x,N=null){return g(x,z=>new u(y,z,N))}cmp(y){return y.type!==this.type?this.type-y.type:P(this.key,this.value,y.key,y.value)}equals(y){return y.type===this.type?this.key===y.key&&this.value===y.value:!1}substituteConstants(){return this}evaluate(y){return typeof this.value=="string"?!1:parseFloat(y.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(y){return y.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=M.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=u;class M{constructor(y,x,N){this.key=y,this.value=x,this.negated=N,this.type=14}static create(y,x,N=null){return g(x,z=>new M(y,z,N))}cmp(y){return y.type!==this.type?this.type-y.type:P(this.key,this.value,y.key,y.value)}equals(y){return y.type===this.type?this.key===y.key&&this.value===y.value:!1}substituteConstants(){return this}evaluate(y){return typeof this.value=="string"?!1:parseFloat(y.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(y){return y.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=u.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=M;class r{constructor(y,x,N){this.key=y,this.value=x,this.negated=N,this.type=15}static create(y,x,N=null){return g(x,z=>new r(y,z,N))}cmp(y){return y.type!==this.type?this.type-y.type:P(this.key,this.value,y.key,y.value)}equals(y){return y.type===this.type?this.key===y.key&&this.value===y.value:!1}substituteConstants(){return this}evaluate(y){return typeof this.value=="string"?!1:parseFloat(y.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(y){return y.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=T.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=r;class i{constructor(y,x){this.key=y,this.regexp=x,this.type=7,this.negated=null}static create(y,x){return new i(y,x)}cmp(y){if(y.type!==this.type)return this.type-y.type;if(this.key<y.key)return-1;if(this.key>y.key)return 1;const x=this.regexp?this.regexp.source:"",N=y.regexp?y.regexp.source:"";return x<N?-1:x>N?1:0}equals(y){if(y.type===this.type){const x=this.regexp?this.regexp.source:"",N=y.regexp?y.regexp.source:"";return this.key===y.key&&x===N}return!1}substituteConstants(){return this}evaluate(y){let x=y.getValue(this.key);return this.regexp?this.regexp.test(x):!1}serialize(){const y=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${y}`}keys(){return[this.key]}map(y){return y.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=p.create(this)),this.negated}}e.ContextKeyRegexExpr=i;class p{constructor(y){this._actual=y,this.type=8}static create(y){return new p(y)}cmp(y){return y.type!==this.type?this.type-y.type:this._actual.cmp(y._actual)}equals(y){return y.type===this.type?this._actual.equals(y._actual):!1}substituteConstants(){return this}evaluate(y){return!this._actual.evaluate(y)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(y){return new p(this._actual.map(y))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=p;function m(L){let y=null;for(let x=0,N=L.length;x<N;x++){const z=L[x].substituteConstants();if(L[x]!==z&&y===null){y=[];for(let H=0;H<x;H++)y[H]=L[H]}y!==null&&(y[x]=z)}return y===null?L:y}class o{constructor(y,x){this.expr=y,this.negated=x,this.type=6}static create(y,x){return o._normalizeArr(y,x)}cmp(y){if(y.type!==this.type)return this.type-y.type;if(this.expr.length<y.expr.length)return-1;if(this.expr.length>y.expr.length)return 1;for(let x=0,N=this.expr.length;x<N;x++){const z=_(this.expr[x],y.expr[x]);if(z!==0)return z}return 0}equals(y){if(y.type===this.type){if(this.expr.length!==y.expr.length)return!1;for(let x=0,N=this.expr.length;x<N;x++)if(!this.expr[x].equals(y.expr[x]))return!1;return!0}return!1}substituteConstants(){const y=m(this.expr);return y===this.expr?this:o.create(y,this.negated)}evaluate(y){for(let x=0,N=this.expr.length;x<N;x++)if(!this.expr[x].evaluate(y))return!1;return!0}static _normalizeArr(y,x){const N=[];let z=!1;for(const H of y)if(!!H){if(H.type===1){z=!0;continue}if(H.type===0)return n.INSTANCE;if(H.type===6){N.push(...H.expr);continue}N.push(H)}if(N.length===0&&z)return h.INSTANCE;if(N.length!==0){if(N.length===1)return N[0];N.sort(_);for(let H=1;H<N.length;H++)N[H-1].equals(N[H])&&(N.splice(H,1),H--);if(N.length===1)return N[0];for(;N.length>1;){const H=N[N.length-1];if(H.type!==9)break;N.pop();const q=N.pop(),ue=N.length===0,K=b.create(H.expr.map(ce=>o.create([ce,q],null)),null,ue);K&&(N.push(K),N.sort(_))}return N.length===1?N[0]:new o(N,x)}}serialize(){return this.expr.map(y=>y.serialize()).join(" && ")}keys(){const y=[];for(let x of this.expr)y.push(...x.keys());return y}map(y){return new o(this.expr.map(x=>x.map(y)),null)}negate(){if(!this.negated){const y=[];for(let x of this.expr)y.push(x.negate());this.negated=b.create(y,this,!0)}return this.negated}}class b{constructor(y,x){this.expr=y,this.negated=x,this.type=9}static create(y,x,N){return b._normalizeArr(y,x,N)}cmp(y){if(y.type!==this.type)return this.type-y.type;if(this.expr.length<y.expr.length)return-1;if(this.expr.length>y.expr.length)return 1;for(let x=0,N=this.expr.length;x<N;x++){const z=_(this.expr[x],y.expr[x]);if(z!==0)return z}return 0}equals(y){if(y.type===this.type){if(this.expr.length!==y.expr.length)return!1;for(let x=0,N=this.expr.length;x<N;x++)if(!this.expr[x].equals(y.expr[x]))return!1;return!0}return!1}substituteConstants(){const y=m(this.expr);return y===this.expr?this:b.create(y,this.negated,!1)}evaluate(y){for(let x=0,N=this.expr.length;x<N;x++)if(this.expr[x].evaluate(y))return!0;return!1}static _normalizeArr(y,x,N){let z=[],H=!1;if(y){for(let q=0,ue=y.length;q<ue;q++){const K=y[q];if(!!K){if(K.type===0){H=!0;continue}if(K.type===1)return h.INSTANCE;if(K.type===9){z=z.concat(K.expr);continue}z.push(K)}}if(z.length===0&&H)return n.INSTANCE;z.sort(_)}if(z.length!==0){if(z.length===1)return z[0];for(let q=1;q<z.length;q++)z[q-1].equals(z[q])&&(z.splice(q,1),q--);if(z.length===1)return z[0];if(N){for(let q=0;q<z.length;q++)for(let ue=q+1;ue<z.length;ue++)k(z[q],z[ue])&&(z.splice(ue,1),ue--);if(z.length===1)return z[0]}return new b(z,x)}}serialize(){return this.expr.map(y=>y.serialize()).join(" || ")}keys(){const y=[];for(let x of this.expr)y.push(...x.keys());return y}map(y){return new b(this.expr.map(x=>x.map(y)),null)}negate(){if(!this.negated){let y=[];for(let x of this.expr)y.push(x.negate());for(;y.length>1;){const x=y.shift(),N=y.shift(),z=[];for(const q of B(x))for(const ue of B(N))z.push(o.create([q,ue],null));const H=y.length===0;y.unshift(b.create(z,null,H))}this.negated=y[0]}return this.negated}}class a extends s{constructor(y,x,N){super(y,null);this._defaultValue=x,typeof N=="object"?a._info.push({...N,key:y}):N!==!0&&a._info.push({key:y,description:N,type:x!=null?typeof x:void 0})}static all(){return a._info.values()}bindTo(y){return y.createKey(this.key,this._defaultValue)}getValue(y){return y.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(y){return l.create(this.key,y)}notEqualsTo(y){return v.create(this.key,y)}}e.RawContextKey=a,a._info=[],e.IContextKeyService=(0,w.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function E(L,y){return L<y?-1:L>y?1:0}function P(L,y,x,N){return L<x?-1:L>x?1:y<N?-1:y>N?1:0}function k(L,y){if(y.type===6&&L.type!==9&&L.type!==6){for(const z of y.expr)if(L.equals(z))return!0}const x=L.negate(),N=B(x).concat(B(y));N.sort(_);for(let z=0;z<N.length;z++){const q=N[z].negate();for(let ue=z+1;ue<N.length;ue++){const K=N[ue];if(q.equals(K))return!0}}return!1}e.implies=k;function B(L){return L.type===9?L.expr:[L]}}),define(Ee[136],_e([0,1,4]),function(oe,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,c.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,c.refineServiceDecorator)(e.IEnvironmentService)}),define(Ee[46],_e([0,1,21,17,9,11,2,117,4]),function(oe,e,c,F,w,I,t,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,S.createDecorator)("fileService");function C(N){return N.create===!0}e.isFileOpenForWriteOptions=C;var A;(function(N){N[N.Unknown=0]="Unknown",N[N.File=1]="File",N[N.Directory=2]="Directory",N[N.SymbolicLink=64]="SymbolicLink"})(A=e.FileType||(e.FileType={}));var _;(function(N){N[N.Readonly=1]="Readonly"})(_=e.FilePermission||(e.FilePermission={}));var n;(function(N){N[N.FileReadWrite=2]="FileReadWrite",N[N.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",N[N.FileReadStream=16]="FileReadStream",N[N.FileFolderCopy=8]="FileFolderCopy",N[N.PathCaseSensitive=1024]="PathCaseSensitive",N[N.Readonly=2048]="Readonly",N[N.Trash=4096]="Trash",N[N.FileWriteUnlock=8192]="FileWriteUnlock"})(n=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function h(N){return!!(N.capabilities&2)}e.hasReadWriteCapability=h;function s(N){return!!(N.capabilities&8)}e.hasFileFolderCopyCapability=s;function l(N){return!!(N.capabilities&4)}e.hasOpenReadWriteCloseCapability=l;function d(N){return!!(N.capabilities&16)}e.hasFileReadStreamCapability=d;var D;(function(N){N.FileExists="EntryExists",N.FileNotFound="EntryNotFound",N.FileNotADirectory="EntryNotADirectory",N.FileIsADirectory="EntryIsADirectory",N.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",N.FileTooLarge="EntryTooLarge",N.FileWriteLocked="EntryWriteLocked",N.NoPermissions="NoPermissions",N.Unavailable="Unavailable",N.Unknown="Unknown"})(D=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class v extends Error{constructor(z,H){super(z);this.code=H}}e.FileSystemProviderError=v;function f(N,z){const H=new v(N.toString(),z);return T(H,z),H}e.createFileSystemProviderError=f;function g(N){return N||f((0,R.localize)(0,null),D.Unknown)}e.ensureFileSystemProviderError=g;function T(N,z){return N.name=z?`${z} (FileSystemError)`:"FileSystemError",N}e.markAsFileSystemProviderError=T;function u(N){if(!N)return D.Unknown;if(N instanceof v)return N.code;const z=/^(.+) \(FileSystemError\)$/.exec(N.name);if(!z)return D.Unknown;switch(z[1]){case D.FileExists:return D.FileExists;case D.FileIsADirectory:return D.FileIsADirectory;case D.FileNotADirectory:return D.FileNotADirectory;case D.FileNotFound:return D.FileNotFound;case D.FileExceedsMemoryLimit:return D.FileExceedsMemoryLimit;case D.FileTooLarge:return D.FileTooLarge;case D.FileWriteLocked:return D.FileWriteLocked;case D.NoPermissions:return D.NoPermissions;case D.Unavailable:return D.Unavailable}return D.Unknown}e.toFileSystemProviderErrorCode=u;function M(N){if(N instanceof b)return N.fileOperationResult;switch(u(N)){case D.FileNotFound:return 1;case D.FileIsADirectory:return 0;case D.FileNotADirectory:return 10;case D.FileWriteLocked:return 5;case D.NoPermissions:return 6;case D.FileExists:return 4;case D.FileExceedsMemoryLimit:return 9;case D.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=M;var r;(function(N){N[N.CREATE=0]="CREATE",N[N.DELETE=1]="DELETE",N[N.MOVE=2]="MOVE",N[N.COPY=3]="COPY"})(r=e.FileOperation||(e.FileOperation={}));class i{constructor(z,H,q){this.resource=z,this.operation=H,this.target=q}isOperation(z){return this.operation===z}}e.FileOperationEvent=i;var p;(function(N){N[N.UPDATED=0]="UPDATED",N[N.ADDED=1]="ADDED",N[N.DELETED=2]="DELETED"})(p=e.FileChangeType||(e.FileChangeType={}));class m{constructor(z,H){this.added=void 0,this.updated=void 0,this.deleted=void 0;const q=new Map;for(const ue of z){const K=q.get(ue.type);K?K.push([ue.resource,ue]):q.set(ue.type,[[ue.resource,ue]])}for(const[ue,K]of q)switch(ue){case 1:this.added=c.TernarySearchTree.forUris(()=>H),this.added.fill(K);break;case 0:this.updated=c.TernarySearchTree.forUris(()=>H),this.updated.fill(K);break;case 2:this.deleted=c.TernarySearchTree.forUris(()=>H),this.deleted.fill(K);break}}contains(z,...H){return this.doContains(z,{includeChildren:!1},...H)}affects(z,...H){return this.doContains(z,{includeChildren:!0},...H)}doContains(z,H,...q){if(!z)return!1;const ue=q.length>0;return!!((!ue||q.includes(1))&&(this.added?.get(z)||H.includeChildren&&this.added?.findSuperstr(z))||(!ue||q.includes(0))&&(this.updated?.get(z)||H.includeChildren&&this.updated?.findSuperstr(z))||(!ue||q.includes(2))&&(this.deleted?.findSubstr(z)||H.includeChildren&&this.deleted?.findSuperstr(z)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=m;function o(N,z,H){return!N||!z||N===z||z.length>N.length?!1:(z.charAt(z.length-1)!==F.sep&&(z+=F.sep),H?(0,w.startsWithIgnoreCase)(N,z):N.indexOf(z)===0)}e.isParent=o;class b extends Error{constructor(z,H,q){super(z);this.fileOperationResult=H,this.options=q}}e.FileOperationError=b;class a extends b{constructor(z,H,q){super(z,2,q);this.stat=H}}e.NotModifiedSinceFileOperationError=a;var E;(function(N){N[N.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",N[N.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",N[N.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",N[N.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",N[N.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",N[N.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",N[N.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",N[N.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",N[N.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",N[N.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",N[N.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",N[N.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(E=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var P;(function(N){N[N.FILE=0]="FILE",N[N.FOLDER=1]="FOLDER",N[N.ROOT_FOLDER=2]="ROOT_FOLDER"})(P=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function k(N){if(!(typeof N.size!="number"||typeof N.mtime!="number"))return N.mtime.toString(29)+N.size.toString(31)}e.etag=k;async function B(N,z){if(!z.hasProvider(t.URI.from({scheme:N.scheme})))return new Promise(H=>{const q=z.onDidChangeFileSystemProviderRegistrations(ue=>{ue.scheme===N.scheme&&ue.added&&(q.dispose(),H())})})}e.whenProviderRegistered=B,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class L{static formatSize(z){return(0,I.isNumber)(z)||(z=0),z<L.KB?(0,R.localize)(1,null,z.toFixed(0)):z<L.MB?(0,R.localize)(2,null,(z/L.KB).toFixed(2)):z<L.GB?(0,R.localize)(3,null,(z/L.MB).toFixed(2)):z<L.TB?(0,R.localize)(4,null,(z/L.GB).toFixed(2)):(0,R.localize)(5,null,(z/L.TB).toFixed(2))}}e.ByteSize=L,L.KB=1024,L.MB=L.KB*L.KB,L.GB=L.MB*L.KB,L.TB=L.GB*L.KB;var y;(function(N){N[N.IA32=0]="IA32",N[N.OTHER=1]="OTHER"})(y=e.Arch||(e.Arch={}));function x(N){return{maxFileSize:N===0?300*L.MB:16*L.GB,maxHeapSize:N===0?700*L.MB:2*700*L.MB}}e.getPlatformLimits=x}),define(Ee[60],_e([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class c{constructor(...w){this._entries=new Map;for(let[I,t]of w)this.set(I,t)}set(w,I){const t=this._entries.get(w);return this._entries.set(w,I),t}has(w){return this._entries.has(w)}get(w){return this._entries.get(w)}}e.ServiceCollection=c}),define(Ee[137],_e([0,1,14,15,80,133,4,60]),function(oe,e,c,F,w,I,t,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const S=!1;class C extends Error{constructor(s){super("cyclic dependency between services");this.message=s.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${s.toString()}`}}class A{constructor(s=new R.ServiceCollection,l=!1,d){this._activeInstantiations=new Set,this._services=s,this._strict=l,this._parent=d,this._services.set(t.IInstantiationService,this)}createChild(s){return new A(s,this._strict,this)}invokeFunction(s,...l){let d=n.traceInvocation(s),D=!1;try{return s({get:f=>{if(D)throw(0,F.illegalState)("service accessor is only valid during the invocation of its target method");const g=this._getOrCreateServiceInstance(f,d);if(!g)throw new Error(`[invokeFunction] unknown service '${f}'`);return g}},...l)}finally{D=!0,d.stop()}}createInstance(s,...l){let d,D;return s instanceof w.SyncDescriptor?(d=n.traceCreation(s.ctor),D=this._createInstance(s.ctor,s.staticArguments.concat(l),d)):(d=n.traceCreation(s),D=this._createInstance(s,l,d)),d.stop(),D}_createInstance(s,l=[],d){let D=t._util.getServiceDependencies(s).sort((g,T)=>g.index-T.index),v=[];for(const g of D){let T=this._getOrCreateServiceInstance(g.id,d);if(!T&&this._strict&&!g.optional)throw new Error(`[createInstance] ${s.name} depends on UNKNOWN service ${g.id}.`);v.push(T)}let f=D.length>0?D[0].index:l.length;if(l.length!==f){console.warn(`[createInstance] First service dependency of ${s.name} at position ${f+1} conflicts with ${l.length} static arguments`);let g=f-l.length;g>0?l=l.concat(new Array(g)):l=l.slice(0,f)}return new s(...[...l,...v])}_setServiceInstance(s,l){if(this._services.get(s)instanceof w.SyncDescriptor)this._services.set(s,l);else if(this._parent)this._parent._setServiceInstance(s,l);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(s){let l=this._services.get(s);return!l&&this._parent?this._parent._getServiceInstanceOrDescriptor(s):l}_getOrCreateServiceInstance(s,l){let d=this._getServiceInstanceOrDescriptor(s);return d instanceof w.SyncDescriptor?this._safeCreateAndCacheServiceInstance(s,d,l.branch(s,!0)):(l.branch(s,!1),d)}_safeCreateAndCacheServiceInstance(s,l,d){if(this._activeInstantiations.has(s))throw new Error(`illegal state - RECURSIVELY instantiating service '${s}'`);this._activeInstantiations.add(s);try{return this._createAndCacheServiceInstance(s,l,d)}finally{this._activeInstantiations.delete(s)}}_createAndCacheServiceInstance(s,l,d){const D=new I.Graph(g=>g.id.toString());let v=0;const f=[{id:s,desc:l,_trace:d}];for(;f.length;){const g=f.pop();if(D.lookupOrInsertNode(g),v++>1e3)throw new C(D);for(let T of t._util.getServiceDependencies(g.desc.ctor)){let u=this._getServiceInstanceOrDescriptor(T.id);if(!u&&!T.optional&&console.warn(`[createInstance] ${s} depends on ${T.id} which is NOT registered.`),u instanceof w.SyncDescriptor){const M={id:T.id,desc:u,_trace:g._trace.branch(T.id,!0)};D.insertEdge(g,M),f.push(M)}}}for(;;){const g=D.roots();if(g.length===0){if(!D.isEmpty())throw new C(D);break}for(const{data:T}of g){if(this._getServiceInstanceOrDescriptor(T.id)instanceof w.SyncDescriptor){const M=this._createServiceInstanceWithOwner(T.id,T.desc.ctor,T.desc.staticArguments,T.desc.supportsDelayedInstantiation,T._trace);this._setServiceInstance(T.id,M)}D.removeNode(T)}}return this._getServiceInstanceOrDescriptor(s)}_createServiceInstanceWithOwner(s,l,d=[],D,v){if(this._services.get(s)instanceof w.SyncDescriptor)return this._createServiceInstance(l,d,D,v);if(this._parent)return this._parent._createServiceInstanceWithOwner(s,l,d,D,v);throw new Error(`illegalState - creating UNKNOWN service instance ${l.name}`)}_createServiceInstance(s,l=[],d,D){if(d){const v=new c.IdleValue(()=>this._createInstance(s,l,D));return new Proxy(Object.create(null),{get(f,g){if(g in f)return f[g];let T=v.value,u=T[g];return typeof u!="function"||(u=u.bind(T),f[g]=u),u},set(f,g,T){return v.value[g]=T,!0}})}else return this._createInstance(s,l,D)}}e.InstantiationService=A;var _;(function(h){h[h.Creation=0]="Creation",h[h.Invocation=1]="Invocation",h[h.Branch=2]="Branch"})(_||(_={}));class n{constructor(s,l){this.type=s,this.name=l,this._start=Date.now(),this._dep=[]}static traceInvocation(s){return S?new n(1,s.name||s.toString().substring(0,42).replace(/\n/g,"")):n._None}static traceCreation(s){return S?new n(0,s.name):n._None}branch(s,l){let d=new n(2,s.toString());return this._dep.push([s,l,d]),d}stop(){let s=Date.now()-this._start;n._totals+=s;let l=!1;function d(v,f){let g=[],T=new Array(v+1).join("	");for(const[u,M,r]of f._dep)if(M&&r){l=!0,g.push(`${T}CREATES -> ${u}`);let i=d(v+1,r);i&&g.push(i)}else g.push(`${T}uses -> ${u}`);return g.join(`
`)}let D=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${d(1,this)}`,`DONE, took ${s.toFixed(2)}ms (grand total ${n._totals.toFixed(2)}ms)`];(s>2||l)&&console.log(D.join(`
`))}}n._None=new class extends n{constructor(){super(-1,null)}stop(){}branch(){return this}},n._totals=0}),define(Ee[12],_e([0,1,44,3,6,23,4]),function(oe,e,c,F,w,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,t.createDecorator)("logService"),e.ILoggerService=(0,t.createDecorator)("loggerService");function R(){return new Date().toISOString()}var S;(function(M){M[M.Trace=0]="Trace",M[M.Debug=1]="Debug",M[M.Info=2]="Info",M[M.Warning=3]="Warning",M[M.Error=4]="Error",M[M.Critical=5]="Critical",M[M.Off=6]="Off"})(S=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=S.Info;function C(M,r,i){switch(r){case S.Trace:M.trace(i);break;case S.Debug:M.debug(i);break;case S.Info:M.info(i);break;case S.Warning:M.warn(i);break;case S.Error:M.error(i);break;case S.Critical:M.critical(i);break;default:throw new Error("Invalid log level")}}e.log=C;function A(M){let r="";for(let i=0;i<M.length;i++){let p=M[i];if(typeof p=="object")try{p=JSON.stringify(p)}catch(m){}r+=(i>0?" ":"")+p}return r}e.format=A;class _ extends w.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new F.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(r){this.level!==r&&(this.level=r,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=_;class n extends _{constructor(r){super();this.logAlways=r}checkLogLevel(r){return this.logAlways||this.getLevel()<=r}trace(r,...i){this.checkLogLevel(S.Trace)&&this.log(S.Trace,A([r,...i]))}debug(r,...i){this.checkLogLevel(S.Debug)&&this.log(S.Debug,A([r,...i]))}info(r,...i){this.checkLogLevel(S.Info)&&this.log(S.Info,A([r,...i]))}warn(r,...i){this.checkLogLevel(S.Warning)&&this.log(S.Warning,A([r,...i]))}error(r,...i){if(this.checkLogLevel(S.Error))if(r instanceof Error){const p=Array.prototype.slice.call(arguments);p[0]=r.stack,this.log(S.Error,A(p))}else this.log(S.Error,A([r,...i]))}critical(r,...i){this.checkLogLevel(S.Critical)&&this.log(S.Critical,A([r,...i]))}flush(){}}e.AbstractMessageLogger=n;class h extends _{constructor(r=e.DEFAULT_LOG_LEVEL){super();this.setLevel(r),this.useColors=!I.isWindows}trace(r,...i){this.getLevel()<=S.Trace&&(this.useColors?console.log(`[90m[main ${R()}][0m`,r,...i):console.log(`[main ${R()}]`,r,...i))}debug(r,...i){this.getLevel()<=S.Debug&&(this.useColors?console.log(`[90m[main ${R()}][0m`,r,...i):console.log(`[main ${R()}]`,r,...i))}info(r,...i){this.getLevel()<=S.Info&&(this.useColors?console.log(`[90m[main ${R()}][0m`,r,...i):console.log(`[main ${R()}]`,r,...i))}warn(r,...i){this.getLevel()<=S.Warning&&(this.useColors?console.warn(`[93m[main ${R()}][0m`,r,...i):console.warn(`[main ${R()}]`,r,...i))}error(r,...i){this.getLevel()<=S.Error&&(this.useColors?console.error(`[91m[main ${R()}][0m`,r,...i):console.error(`[main ${R()}]`,r,...i))}critical(r,...i){this.getLevel()<=S.Critical&&(this.useColors?console.error(`[90m[main ${R()}][0m`,r,...i):console.error(`[main ${R()}]`,r,...i))}dispose(){}flush(){}}e.ConsoleMainLogger=h;class s extends _{constructor(r=e.DEFAULT_LOG_LEVEL){super();this.setLevel(r)}trace(r,...i){this.getLevel()<=S.Trace&&console.log("%cTRACE","color: #888",r,...i)}debug(r,...i){this.getLevel()<=S.Debug&&console.log("%cDEBUG","background: #eee; color: #888",r,...i)}info(r,...i){this.getLevel()<=S.Info&&console.log("%c INFO","color: #33f",r,...i)}warn(r,...i){this.getLevel()<=S.Warning&&console.log("%c WARN","color: #993",r,...i)}error(r,...i){this.getLevel()<=S.Error&&console.log("%c  ERR","color: #f33",r,...i)}critical(r,...i){this.getLevel()<=S.Critical&&console.log("%cCRITI","background: #f33; color: white",r,...i)}dispose(){}flush(){}}e.ConsoleLogger=s;class l extends _{constructor(r,i=e.DEFAULT_LOG_LEVEL){super();this.adapter=r,this.setLevel(i)}trace(r,...i){this.getLevel()<=S.Trace&&this.adapter.log(S.Trace,[this.extractMessage(r),...i])}debug(r,...i){this.getLevel()<=S.Debug&&this.adapter.log(S.Debug,[this.extractMessage(r),...i])}info(r,...i){this.getLevel()<=S.Info&&this.adapter.log(S.Info,[this.extractMessage(r),...i])}warn(r,...i){this.getLevel()<=S.Warning&&this.adapter.log(S.Warning,[this.extractMessage(r),...i])}error(r,...i){this.getLevel()<=S.Error&&this.adapter.log(S.Error,[this.extractMessage(r),...i])}critical(r,...i){this.getLevel()<=S.Critical&&this.adapter.log(S.Critical,[this.extractMessage(r),...i])}extractMessage(r){return typeof r=="string"?r:(0,c.toErrorMessage)(r,this.getLevel()<=S.Trace)}dispose(){}flush(){}}e.AdapterLogger=l;class d extends _{constructor(r){super();this.logServices=r,r.length&&this.setLevel(r[0].getLevel())}setLevel(r){for(const i of this.logServices)i.setLevel(r);super.setLevel(r)}trace(r,...i){for(const p of this.logServices)p.trace(r,...i)}debug(r,...i){for(const p of this.logServices)p.debug(r,...i)}info(r,...i){for(const p of this.logServices)p.info(r,...i)}warn(r,...i){for(const p of this.logServices)p.warn(r,...i)}error(r,...i){for(const p of this.logServices)p.error(r,...i)}critical(r,...i){for(const p of this.logServices)p.critical(r,...i)}flush(){for(const r of this.logServices)r.flush()}dispose(){for(const r of this.logServices)r.dispose()}}e.MultiplexLogService=d;class D extends w.Disposable{constructor(r){super();this.logger=r,this._register(r)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(r){this.logger.setLevel(r)}getLevel(){return this.logger.getLevel()}trace(r,...i){this.logger.trace(r,...i)}debug(r,...i){this.logger.debug(r,...i)}info(r,...i){this.logger.info(r,...i)}warn(r,...i){this.logger.warn(r,...i)}error(r,...i){this.logger.error(r,...i)}critical(r,...i){this.logger.critical(r,...i)}flush(){this.logger.flush()}}e.LogService=D;class v extends w.Disposable{constructor(r,i){super();this.logLevel=r,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(i(p=>{this.logLevel=p,this.logLevelChangeableLoggers.forEach(m=>m.setLevel(p))}))}getLogger(r){return this.loggers.get(r.toString())}createLogger(r,i){let p=this.loggers.get(r.toString());return p||(p=this.doCreateLogger(r,i?.always?S.Trace:this.logLevel,i),this.loggers.set(r.toString(),p),i?.always||this.logLevelChangeableLoggers.push(p)),p}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(r=>r.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=v;class f{constructor(){this.onDidChangeLogLevel=new F.Emitter().event}setLevel(r){}getLevel(){return S.Info}trace(r,...i){}debug(r,...i){}info(r,...i){}warn(r,...i){}error(r,...i){}critical(r,...i){}dispose(){}flush(){}}e.NullLogService=f;function g(M){if(M.verbose)return S.Trace;if(typeof M.logLevel=="string"){const r=T(M.logLevel.toLowerCase());if(r!==void 0)return r}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=g;function T(M){switch(M){case"trace":return S.Trace;case"debug":return S.Debug;case"info":return S.Info;case"warn":return S.Warning;case"error":return S.Error;case"critical":return S.Critical;case"off":return S.Off}}e.parseLogLevel=T;function u(M){switch(M){case S.Trace:return"trace";case S.Debug:return"debug";case S.Info:return"info";case S.Warning:return"warn";case S.Error:return"error";case S.Critical:return"critical";case S.Off:return"off"}}e.LogLevelToString=u}),define(Ee[82],_e([0,1,34,118,4]),function(oe,e,c,F,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var I;(function(S){S[S.Unnecessary=1]="Unnecessary",S[S.Deprecated=2]="Deprecated"})(I=e.MarkerTag||(e.MarkerTag={}));var t;(function(S){S[S.Hint=1]="Hint",S[S.Info=2]="Info",S[S.Warning=4]="Warning",S[S.Error=8]="Error"})(t=e.MarkerSeverity||(e.MarkerSeverity={})),function(S){function C(s,l){return l-s}S.compare=C;const A=Object.create(null);A[S.Error]=(0,F.localize)(0,null),A[S.Warning]=(0,F.localize)(1,null),A[S.Info]=(0,F.localize)(2,null);function _(s){return A[s]||""}S.toString=_;function n(s){switch(s){case c.default.Error:return S.Error;case c.default.Warning:return S.Warning;case c.default.Info:return S.Info;case c.default.Ignore:return S.Hint}}S.fromSeverity=n;function h(s){switch(s){case S.Error:return c.default.Error;case S.Warning:return c.default.Warning;case S.Info:return c.default.Info;case S.Hint:return c.default.Ignore}}S.toSeverity=h}(t=e.MarkerSeverity||(e.MarkerSeverity={}));var R;(function(S){const C="";function A(n){return _(n,!0)}S.makeKey=A;function _(n,h){let s=[C];return n.source?s.push(n.source.replace("\xA6","\\\xA6")):s.push(C),n.code?typeof n.code=="string"?s.push(n.code.replace("\xA6","\\\xA6")):s.push(n.code.value.replace("\xA6","\\\xA6")):s.push(C),n.severity!==void 0&&n.severity!==null?s.push(t.toString(n.severity)):s.push(C),n.message&&h?s.push(n.message.replace("\xA6","\\\xA6")):s.push(C),n.startLineNumber!==void 0&&n.startLineNumber!==null?s.push(n.startLineNumber.toString()):s.push(C),n.startColumn!==void 0&&n.startColumn!==null?s.push(n.startColumn.toString()):s.push(C),n.endLineNumber!==void 0&&n.endLineNumber!==null?s.push(n.endLineNumber.toString()):s.push(C),n.endColumn!==void 0&&n.endColumn!==null?s.push(n.endColumn.toString()):s.push(C),s.push(C),s.join("\xA6")}S.makeKeyOptionalMessage=_})(R=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,w.createDecorator)("markerService")}),define(Ee[138],_e([0,1,3,34,4]),function(oe,e,c,F,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=F.default,e.INotificationService=(0,w.createDecorator)("notificationService");var I;(function(C){C[C.WORKSPACE=0]="WORKSPACE",C[C.GLOBAL=1]="GLOBAL"})(I=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var t;(function(C){C[C.OFF=0]="OFF",C[C.SILENT=1]="SILENT",C[C.ERROR=2]="ERROR"})(t=e.NotificationsFilter||(e.NotificationsFilter={}));class R{constructor(){this.progress=new S,this.onDidClose=c.Event.None,this.onDidChangeVisibility=c.Event.None}updateSeverity(A){}updateMessage(A){}updateActions(A){}close(){}}e.NoOpNotification=R;class S{infinite(){}done(){}total(A){}worked(A){}}e.NoOpProgress=S}),define(Ee[139],_e([0,1,6,9,2,4]),function(oe,e,c,F,w,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesSomeScheme=e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=(0,I.createDecorator)("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return c.Disposable.None},registerValidator(){return c.Disposable.None},registerExternalUriResolver(){return c.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return c.Disposable.None},async open(){return!1},async resolveExternalUri(S){return{resolved:S,dispose(){}}}});function t(S,C){return w.URI.isUri(S)?(0,F.equalsIgnoreCase)(S.scheme,C):(0,F.startsWithIgnoreCase)(S,C+":")}e.matchesScheme=t;function R(S,...C){return C.some(A=>t(S,A))}e.matchesSomeScheme=R});var $e=this&&this.__param||function(oe,e){return function(c,F){e(c,F,oe)}};define(Ee[140],_e([0,1,14,20,6,4]),function(oe,e,c,F,w,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,I.createDecorator)("progressService");var t;(function(A){A[A.Explorer=1]="Explorer",A[A.Scm=3]="Scm",A[A.Extensions=5]="Extensions",A[A.Window=10]="Window",A[A.Notification=15]="Notification",A[A.Dialog=20]="Dialog"})(t=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class R{constructor(_){this.callback=_}get value(){return this._value}report(_){this._value=_,this.callback(this._value)}}e.Progress=R,R.None=Object.freeze({report(){}});let S=class extends w.Disposable{constructor(_,n){super();this.deferred=new c.DeferredPromise,n.withProgress(_,h=>(this.reporter=h,this.lastStep&&h.report(this.lastStep),this.deferred.p)),this._register((0,w.toDisposable)(()=>this.deferred.complete()))}report(_){this.reporter?this.reporter.report(_):this.lastStep=_}};S=xe([$e(1,e.IProgressService)],S),e.UnmanagedProgress=S;class C extends w.Disposable{constructor(_){super();this.progressIndicator=_,this.currentOperationId=0,this.currentOperationDisposables=this._register(new w.DisposableStore)}start(_){this.stop();const n=++this.currentOperationId,h=new F.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{n===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},_),this.currentOperationDisposables.add((0,w.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,w.toDisposable)(()=>h.cancel())),this.currentOperationDisposables.add((0,w.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:n,token:h.token,stop:()=>this.doStop(n),isCurrent:()=>this.currentOperationId===n}}stop(){this.doStop(this.currentOperationId)}doStop(_){this.currentOperationId===_&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=C,e.IEditorProgressService=(0,I.createDecorator)("editorProgressService")}),define(Ee[36],_e([0,1,41,11]),function(oe,e,c,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class w{constructor(){this.data=new Map}add(t,R){c.ok(F.isString(t)),c.ok(F.isObject(R)),c.ok(!this.data.has(t),"There is already an extension with this id"),this.data.set(t,R)}knows(t){return this.data.has(t)}as(t){return this.data.get(t)||null}}e.Registry=new w}),define(Ee[141],_e([0,1,3,36]),function(oe,e,c,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function w(R){return R.length>0&&R.charAt(R.length-1)==="#"?R.substring(0,R.length-1):R}class I{constructor(){this._onDidChangeSchema=new c.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(S,C){this.schemasById[w(S)]=C,this._onDidChangeSchema.fire(S)}notifySchemaChanged(S){this._onDidChangeSchema.fire(S)}getSchemaContributions(){return{schemas:this.schemasById}}}const t=new I;F.Registry.add(e.Extensions.JSONContribution,t)}),define(Ee[83],_e([0,1,16,3,11,115,141,36]),function(oe,e,c,F,w,I,t,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var S;(function(g){g.Multiline="multilineText",g.Singleline="singlelineText"})(S=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var C;(function(g){g[g.APPLICATION=1]="APPLICATION",g[g.MACHINE=2]="MACHINE",g[g.WINDOW=3]="WINDOW",g[g.RESOURCE=4]="RESOURCE",g[g.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",g[g.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(C=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const A=R.Registry.as(t.Extensions.JSONContribution);class _{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new F.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new F.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:I.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},A.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(T,u=!0){this.registerConfigurations([T],u)}registerConfigurations(T,u=!0){const M=this.doRegisterConfigurations(T,u);A.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:M})}deregisterConfigurations(T){const u=this.doDeregisterConfigurations(T);A.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:u})}updateConfigurations({add:T,remove:u}){const M=[];M.push(...this.doDeregisterConfigurations(u)),M.push(...this.doRegisterConfigurations(T,!1)),A.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,c.distinct)(M)})}registerDefaultConfigurations(T){const u=[],M=[];for(const r of T)for(const i in r)if(u.push(i),e.OVERRIDE_PROPERTY_REGEX.test(i)){this.configurationDefaultsOverrides[i]={...this.configurationDefaultsOverrides[i]||{},...r[i]};const p={type:"object",default:this.configurationDefaultsOverrides[i],description:I.localize(1,null,i),$ref:e.resourceLanguageSettingsSchemaId};M.push(...s(i)),this.configurationProperties[i]=p,this.defaultLanguageConfigurationOverridesNode.properties[i]=p}else{this.configurationDefaultsOverrides[i]=r[i];const p=this.configurationProperties[i];p&&(this.updatePropertyDefaultValue(i,p),this.updateSchema(i,p))}this.registerOverrideIdentifiers(M),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:u,defaultsOverrides:!0})}deregisterDefaultConfigurations(T){const u=[];for(const M of T)for(const r in M)if(u.push(r),delete this.configurationDefaultsOverrides[r],e.OVERRIDE_PROPERTY_REGEX.test(r))delete this.configurationProperties[r],delete this.defaultLanguageConfigurationOverridesNode.properties[r];else{const i=this.configurationProperties[r];i&&(this.updatePropertyDefaultValue(r,i),this.updateSchema(r,i))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:u,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...T){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(T){for(const u of T)this.overrideIdentifiers.add(u);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(T,u){const M=[];return T.forEach(r=>{M.push(...this.validateAndRegisterProperties(r,u,r.extensionInfo)),this.configurationContributors.push(r),this.registerJSONConfiguration(r)}),M}doDeregisterConfigurations(T){const u=[],M=r=>{if(r.properties)for(const i in r.properties)u.push(i),delete this.configurationProperties[i],this.removeFromSchema(i,r.properties[i]);r.allOf&&r.allOf.forEach(i=>M(i))};for(const r of T){M(r);const i=this.configurationContributors.indexOf(r);i!==-1&&this.configurationContributors.splice(i,1)}return u}validateAndRegisterProperties(T,u=!0,M,r=3){r=w.isUndefinedOrNull(T.scope)?r:T.scope;let i=[],p=T.properties;if(p)for(let o in p){if(u&&v(o)){delete p[o];continue}const b=p[o];if(this.updatePropertyDefaultValue(o,b),e.OVERRIDE_PROPERTY_REGEX.test(o)?b.scope=void 0:(b.scope=w.isUndefinedOrNull(b.scope)?r:b.scope,b.restricted=w.isUndefinedOrNull(b.restricted)?!!M?.restrictedConfigurations?.includes(o):b.restricted),p[o].hasOwnProperty("included")&&!p[o].included){this.excludedConfigurationProperties[o]=p[o],delete p[o];continue}else this.configurationProperties[o]=p[o];!p[o].deprecationMessage&&p[o].markdownDeprecationMessage&&(p[o].deprecationMessage=p[o].markdownDeprecationMessage),i.push(o)}let m=T.allOf;if(m)for(let o of m)i.push(...this.validateAndRegisterProperties(o,u,M,r));return i}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(T){const u=M=>{let r=M.properties;if(r)for(const p in r)this.updateSchema(p,r[p]);let i=M.allOf;i&&i.forEach(u)};u(T)}updateSchema(T,u){switch(e.allSettings.properties[T]=u,u.scope){case 1:e.applicationSettings.properties[T]=u;break;case 2:e.machineSettings.properties[T]=u;break;case 6:e.machineOverridableSettings.properties[T]=u;break;case 3:e.windowSettings.properties[T]=u;break;case 4:e.resourceSettings.properties[T]=u;break;case 5:e.resourceSettings.properties[T]=u,this.resourceLanguageSettingsSchema.properties[T]=u;break}}removeFromSchema(T,u){switch(delete e.allSettings.properties[T],u.scope){case 1:delete e.applicationSettings.properties[T];break;case 2:delete e.machineSettings.properties[T];break;case 6:delete e.machineOverridableSettings.properties[T];break;case 3:delete e.windowSettings.properties[T];break;case 4:case 5:delete e.resourceSettings.properties[T],delete this.resourceLanguageSettingsSchema.properties[T];break}}updateOverridePropertyPatternKey(){for(const T of this.overrideIdentifiers.values()){const u=`[${T}]`,M={type:"object",description:I.localize(2,null),errorMessage:I.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(u,M),e.allSettings.properties[u]=M,e.applicationSettings.properties[u]=M,e.machineSettings.properties[u]=M,e.machineOverridableSettings.properties[u]=M,e.windowSettings.properties[u]=M,e.resourceSettings.properties[u]=M}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const T={type:"object",description:I.localize(4,null),errorMessage:I.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=T,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=T,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=T,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=T,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=T,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=T,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(T,u){let M=this.configurationDefaultsOverrides[T];w.isUndefined(M)&&(M=u.default),w.isUndefined(M)&&(M=d(u.type)),u.default=M}}const n="\\[([^\\]]+)\\]",h=new RegExp(n,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${n})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function s(g){const T=[];if(e.OVERRIDE_PROPERTY_REGEX.test(g)){let u=h.exec(g);for(;u?.length;){const M=u[1].trim();M&&T.push(M),u=h.exec(g)}}return(0,c.distinct)(T)}e.overrideIdentifiersFromKey=s;function l(g){return g.reduce((T,u)=>`${T}[${u}]`,"")}e.keyFromOverrideIdentifiers=l;function d(g){switch(Array.isArray(g)?g[0]:g){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=d;const D=new _;R.Registry.add(e.Extensions.Configuration,D);function v(g){return g.trim()?e.OVERRIDE_PROPERTY_REGEX.test(g)?I.localize(7,null,g):D.getConfigurationProperties()[g]!==void 0?I.localize(8,null,g):null:I.localize(6,null)}e.validateProperty=v;function f(){const g=[],T=D.getConfigurationProperties();for(const u of Object.keys(T))g.push([u,T[u].scope]);return g.push(["launch",4]),g.push(["task",4]),g}e.getScopes=f}),define(Ee[142],_e([0,1,16,3,100,6,21,27,11,2,81,83,36]),function(oe,e,c,F,w,I,t,R,S,C,A,_,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class h{constructor(r={},i=[],p=[]){this._contents=r,this._keys=i,this._overrides=p,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(r){return r?(0,A.getConfigurationValue)(this.contents,r):this.contents}getOverrideValue(r,i){const p=this.getContentsForOverrideIdentifer(i);return p?r?(0,A.getConfigurationValue)(p,r):p:void 0}getKeysForOverrideIdentifier(r){const i=[];for(const p of this.overrides)p.identifiers.includes(r)&&i.push(...p.keys);return c.distinct(i)}getAllOverrideIdentifiers(){const r=[];for(const i of this.overrides)r.push(...i.identifiers);return c.distinct(r)}override(r){let i=this.overrideConfigurations.get(r);return i||(i=this.createOverrideConfigurationModel(r),this.overrideConfigurations.set(r,i)),i}merge(...r){const i=R.deepClone(this.contents),p=R.deepClone(this.overrides),m=[...this.keys];for(const o of r){this.mergeContents(i,o.contents);for(const b of o.overrides){const[a]=p.filter(E=>c.equals(E.identifiers,b.identifiers));a?(this.mergeContents(a.contents,b.contents),a.keys.push(...b.keys),a.keys=c.distinct(a.keys)):p.push(R.deepClone(b))}for(const b of o.keys)m.indexOf(b)===-1&&m.push(b)}return new h(i,m,p)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(r){const i=this.getContentsForOverrideIdentifer(r);if(!i||typeof i!="object"||!Object.keys(i).length)return this;let p={};for(const m of c.distinct([...Object.keys(this.contents),...Object.keys(i)])){let o=this.contents[m],b=i[m];b&&(typeof o=="object"&&typeof b=="object"?(o=R.deepClone(o),this.mergeContents(o,b)):o=b),p[m]=o}return new h(p,this.keys,this.overrides)}mergeContents(r,i){for(const p of Object.keys(i)){if(p in r&&S.isObject(r[p])&&S.isObject(i[p])){this.mergeContents(r[p],i[p]);continue}r[p]=R.deepClone(i[p])}}checkAndFreeze(r){return this.isFrozen&&!Object.isFrozen(r)?R.deepFreeze(r):r}getContentsForOverrideIdentifer(r){let i=null,p=null;const m=o=>{o&&(p?this.mergeContents(p,o):p=R.deepClone(o))};for(const o of this.overrides)c.equals(o.identifiers,[r])?i=o.contents:o.identifiers.includes(r)&&m(o.contents);return m(i),p}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(r,i){this.addKey(r),(0,A.addToValueTree)(this.contents,r,i,p=>{throw new Error(p)})}removeValue(r){this.removeKey(r)&&(0,A.removeFromValueTree)(this.contents,r)}addKey(r){let i=this.keys.length;for(let p=0;p<i;p++)r.indexOf(this.keys[p])===0&&(i=p);this.keys.splice(i,1,r)}removeKey(r){let i=this.keys.indexOf(r);return i!==-1?(this.keys.splice(i,1),!0):!1}}e.ConfigurationModel=h;class s extends h{constructor(r={}){const i=n.Registry.as(_.Extensions.Configuration).getConfigurationProperties(),p=Object.keys(i),m=Object.create(null),o=[];for(const b in i){const a=r[b],E=a!==void 0?a:i[b].default;(0,A.addToValueTree)(m,b,E,P=>console.error(`Conflict in default settings: ${P}`))}for(const b of Object.keys(m))_.OVERRIDE_PROPERTY_REGEX.test(b)&&o.push({identifiers:(0,_.overrideIdentifiersFromKey)(b),keys:Object.keys(m[b]),contents:(0,A.toValuesTree)(m[b],a=>console.error(`Conflict in default settings file: ${a}`))});super(m,p,o)}}e.DefaultConfigurationModel=s;class l{constructor(r){this._name=r,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new h}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(r,i){if(!S.isUndefinedOrNull(r)){const p=this.doParseContent(r);this.parseRaw(p,i)}}reparse(r){this._raw&&this.parseRaw(this._raw,r)}parseRaw(r,i){this._raw=r;const{contents:p,keys:m,overrides:o,restricted:b}=this.doParseRaw(r,i);this._configurationModel=new h(p,m,o),this._restrictedConfigurations=b||[]}doParseContent(r){let i={},p=null,m=[],o=[],b=[];function a(P){Array.isArray(m)?m.push(P):p!==null&&(m[p]=P)}let E={onObjectBegin:()=>{let P={};a(P),o.push(m),m=P,p=null},onObjectProperty:P=>{p=P},onObjectEnd:()=>{m=o.pop()},onArrayBegin:()=>{let P=[];a(P),o.push(m),m=P,p=null},onArrayEnd:()=>{m=o.pop()},onLiteralValue:a,onError:(P,k,B)=>{b.push({error:P,offset:k,length:B})}};if(r)try{w.visit(r,E),i=m[0]||{}}catch(P){console.error(`Error while parsing settings file ${this._name}: ${P}`),this._parseErrors=[P]}return i}doParseRaw(r,i){const p=n.Registry.as(_.Extensions.Configuration).getConfigurationProperties(),m=this.filter(r,p,!0,i);r=m.raw;const o=(0,A.toValuesTree)(r,E=>console.error(`Conflict in settings file ${this._name}: ${E}`)),b=Object.keys(r),a=this.toOverrides(r,E=>console.error(`Conflict in settings file ${this._name}: ${E}`));return{contents:o,keys:b,overrides:a,restricted:m.restricted}}filter(r,i,p,m){if(!m?.scopes&&!m?.skipRestricted)return{raw:r,restricted:[]};const o={},b=[];for(let a in r)if(_.OVERRIDE_PROPERTY_REGEX.test(a)&&p){const E=this.filter(r[a],i,!1,m);o[a]=E.raw,b.push(...E.restricted)}else{const E=i[a],P=E?typeof E.scope!="undefined"?E.scope:3:void 0;E?.restricted&&b.push(a),(P===void 0||m.scopes===void 0||m.scopes.includes(P))&&(m.skipRestricted&&E?.restricted||(o[a]=r[a]))}return{raw:o,restricted:b}}toOverrides(r,i){const p=[];for(const m of Object.keys(r))if(_.OVERRIDE_PROPERTY_REGEX.test(m)){const o={};for(const b in r[m])o[b]=r[m][b];p.push({identifiers:(0,_.overrideIdentifiersFromKey)(m),keys:Object.keys(o),contents:(0,A.toValuesTree)(o,i)})}return p}}e.ConfigurationModelParser=l;class d extends I.Disposable{constructor(r,i,p,m){super();this.userSettingsResource=r,this.scopes=i,this.fileService=m,this._onDidChange=this._register(new F.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new l(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(p.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(F.Event.filter(this.fileService.onDidFilesChange,o=>o.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const r=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(r.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(r){return new h}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=d;class D{constructor(r,i,p=new h,m=new h,o=new t.ResourceMap,b=new h,a=new t.ResourceMap,E=!0){this._defaultConfiguration=r,this._localUserConfiguration=i,this._remoteUserConfiguration=p,this._workspaceConfiguration=m,this._folderConfigurations=o,this._memoryConfiguration=b,this._memoryConfigurationByResource=a,this._freeze=E,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new t.ResourceMap,this._userConfiguration=null}getValue(r,i,p){return this.getConsolidateConfigurationModel(i,p).getValue(r)}updateValue(r,i,p={}){let m;p.resource?(m=this._memoryConfigurationByResource.get(p.resource),m||(m=new h,this._memoryConfigurationByResource.set(p.resource,m))):m=this._memoryConfiguration,i===void 0?m.removeValue(r):m.setValue(r,i),p.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(r,i,p){const m=this.getConsolidateConfigurationModel(i,p),o=this.getFolderConfigurationModelForResource(i.resource,p),b=i.resource?this._memoryConfigurationByResource.get(i.resource)||this._memoryConfiguration:this._memoryConfiguration,a=i.overrideIdentifier?this._defaultConfiguration.freeze().override(i.overrideIdentifier).getValue(r):this._defaultConfiguration.freeze().getValue(r),E=i.overrideIdentifier?this.userConfiguration.freeze().override(i.overrideIdentifier).getValue(r):this.userConfiguration.freeze().getValue(r),P=i.overrideIdentifier?this.localUserConfiguration.freeze().override(i.overrideIdentifier).getValue(r):this.localUserConfiguration.freeze().getValue(r),k=i.overrideIdentifier?this.remoteUserConfiguration.freeze().override(i.overrideIdentifier).getValue(r):this.remoteUserConfiguration.freeze().getValue(r),B=p?i.overrideIdentifier?this._workspaceConfiguration.freeze().override(i.overrideIdentifier).getValue(r):this._workspaceConfiguration.freeze().getValue(r):void 0,L=o?i.overrideIdentifier?o.freeze().override(i.overrideIdentifier).getValue(r):o.freeze().getValue(r):void 0,y=i.overrideIdentifier?b.override(i.overrideIdentifier).getValue(r):b.getValue(r),x=m.getValue(r),N=c.distinct(c.flatten(m.overrides.map(z=>z.identifiers))).filter(z=>m.getOverrideValue(r,z)!==void 0);return{defaultValue:a,userValue:E,userLocalValue:P,userRemoteValue:k,workspaceValue:B,workspaceFolderValue:L,memoryValue:y,value:x,default:a!==void 0?{value:this._defaultConfiguration.freeze().getValue(r),override:i.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,user:E!==void 0?{value:this.userConfiguration.freeze().getValue(r),override:i.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,userLocal:P!==void 0?{value:this.localUserConfiguration.freeze().getValue(r),override:i.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,userRemote:k!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(r),override:i.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,workspace:B!==void 0?{value:this._workspaceConfiguration.freeze().getValue(r),override:i.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,workspaceFolder:L!==void 0?{value:o?.freeze().getValue(r),override:i.overrideIdentifier?o?.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,memory:y!==void 0?{value:b.getValue(r),override:i.overrideIdentifier?b.getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,overrideIdentifiers:N.length?N:void 0}}keys(r){const i=this.getFolderConfigurationModelForResource(void 0,r);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:i?i.freeze().keys:[]}}updateDefaultConfiguration(r){this._defaultConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(r){this._localUserConfiguration=r,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(r){this._remoteUserConfiguration=r,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(r){this._workspaceConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(r,i){this._folderConfigurations.set(r,i),this._foldersConsolidatedConfigurations.delete(r)}deleteFolderConfiguration(r){this.folderConfigurations.delete(r),this._foldersConsolidatedConfigurations.delete(r)}compareAndUpdateDefaultConfiguration(r){const{added:i,updated:p,removed:m,overrides:o}=T(this._defaultConfiguration,r),b=[...i,...p,...m];return b.length&&this.updateDefaultConfiguration(r),{keys:b,overrides:o}}compareAndUpdateLocalUserConfiguration(r){const{added:i,updated:p,removed:m,overrides:o}=T(this.localUserConfiguration,r),b=[...i,...p,...m];return b.length&&this.updateLocalUserConfiguration(r),{keys:b,overrides:o}}compareAndUpdateRemoteUserConfiguration(r){const{added:i,updated:p,removed:m,overrides:o}=T(this.remoteUserConfiguration,r);let b=[...i,...p,...m];return b.length&&this.updateRemoteUserConfiguration(r),{keys:b,overrides:o}}compareAndUpdateWorkspaceConfiguration(r){const{added:i,updated:p,removed:m,overrides:o}=T(this.workspaceConfiguration,r);let b=[...i,...p,...m];return b.length&&this.updateWorkspaceConfiguration(r),{keys:b,overrides:o}}compareAndUpdateFolderConfiguration(r,i){const p=this.folderConfigurations.get(r),{added:m,updated:o,removed:b,overrides:a}=T(p,i);let E=[...m,...o,...b];return(E.length||!p)&&this.updateFolderConfiguration(r,i),{keys:E,overrides:a}}compareAndDeleteFolderConfiguration(r){const i=this.folderConfigurations.get(r);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(r);const{added:p,updated:m,removed:o,overrides:b}=T(i,void 0);return{keys:[...p,...m,...o],overrides:b}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(r,i){let p=this.getConsolidatedConfigurationModelForResource(r,i);return r.overrideIdentifier?p.override(r.overrideIdentifier):p}getConsolidatedConfigurationModelForResource({resource:r},i){let p=this.getWorkspaceConsolidatedConfiguration();if(i&&r){const m=i.getFolder(r);m&&(p=this.getFolderConsolidatedConfiguration(m.uri)||p);const o=this._memoryConfigurationByResource.get(r);o&&(p=p.merge(o))}return p}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(r){let i=this._foldersConsolidatedConfigurations.get(r);if(!i){const p=this.getWorkspaceConsolidatedConfiguration(),m=this._folderConfigurations.get(r);m?(i=p.merge(m),this._freeze&&(i=i.freeze()),this._foldersConsolidatedConfigurations.set(r,i)):i=p}return i}getFolderConfigurationModelForResource(r,i){if(i&&r){const p=i.getFolder(r);if(p)return this._folderConfigurations.get(p.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((r,i)=>{const{contents:p,overrides:m,keys:o}=this._folderConfigurations.get(i);return r.push([i,{contents:p,overrides:m,keys:o}]),r},[])}}allKeys(){const r=new Set;return this._defaultConfiguration.freeze().keys.forEach(i=>r.add(i)),this.userConfiguration.freeze().keys.forEach(i=>r.add(i)),this._workspaceConfiguration.freeze().keys.forEach(i=>r.add(i)),this._folderConfigurations.forEach(i=>i.freeze().keys.forEach(p=>r.add(p))),[...r.values()]}allOverrideIdentifiers(){const r=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>r.add(i)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>r.add(i)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>r.add(i)),this._folderConfigurations.forEach(i=>i.freeze().getAllOverrideIdentifiers().forEach(p=>r.add(p))),[...r.values()]}getAllKeysForOverrideIdentifier(r){const i=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(r).forEach(p=>i.add(p)),this.userConfiguration.getKeysForOverrideIdentifier(r).forEach(p=>i.add(p)),this._workspaceConfiguration.getKeysForOverrideIdentifier(r).forEach(p=>i.add(p)),this._folderConfigurations.forEach(p=>p.getKeysForOverrideIdentifier(r).forEach(m=>i.add(m))),[...i.values()]}static parse(r){const i=this.parseConfigurationModel(r.defaults),p=this.parseConfigurationModel(r.user),m=this.parseConfigurationModel(r.workspace),o=r.folders.reduce((b,a)=>(b.set(C.URI.revive(a[0]),this.parseConfigurationModel(a[1])),b),new t.ResourceMap);return new D(i,p,new h,m,o,new h,new t.ResourceMap,!1)}static parseConfigurationModel(r){return new h(r.contents,r.keys,r.overrides).freeze()}}e.Configuration=D;function v(...M){if(M.length===0)return{keys:[],overrides:[]};if(M.length===1)return M[0];const r=new Set,i=new Map;for(const m of M)m.keys.forEach(o=>r.add(o)),m.overrides.forEach(([o,b])=>{const a=(0,t.getOrSet)(i,o,new Set);b.forEach(E=>a.add(E))});const p=[];return i.forEach((m,o)=>p.push([o,[...m.values()]])),{keys:[...r.values()],overrides:p}}e.mergeChanges=v;class f{constructor(r,i,p,m){this.change=r,this.previous=i,this.currentConfiguraiton=p,this.currentWorkspace=m,this._previousConfiguration=void 0;const o=new Set;r.keys.forEach(a=>o.add(a)),r.overrides.forEach(([,a])=>a.forEach(E=>o.add(E))),this.affectedKeys=[...o.values()];const b=new h;this.affectedKeys.forEach(a=>b.setValue(a,{})),this.affectedKeysTree=b.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=D.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(r,i){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,r)){if(i){const p=this.previousConfiguration?this.previousConfiguration.getValue(r,i,this.previous?.workspace):void 0,m=this.currentConfiguraiton.getValue(r,i,this.currentWorkspace);return!R.equals(p,m)}return!0}return!1}doesAffectedKeysTreeContains(r,i){let p=(0,A.toValuesTree)({[i]:!0},()=>{}),m;for(;typeof p=="object"&&(m=Object.keys(p)[0]);){if(r=r[m],!r)return!1;p=p[m]}return!0}}e.ConfigurationChangeEvent=f;class g extends f{constructor(r,i,p,m){super({keys:r.allKeys(),overrides:[]},void 0,r,i);this.source=p,this.sourceConfig=m}}e.AllKeysConfigurationChangeEvent=g;function T(M,r){const{added:i,removed:p,updated:m}=u(r,M),o=[],b=M?.getAllOverrideIdentifiers()||[],a=r?.getAllOverrideIdentifiers()||[];if(r){const E=a.filter(P=>!b.includes(P));for(const P of E)o.push([P,r.getKeysForOverrideIdentifier(P)])}if(M){const E=b.filter(P=>!a.includes(P));for(const P of E)o.push([P,M.getKeysForOverrideIdentifier(P)])}if(r&&M){for(const E of b)if(a.includes(E)){const P=u({contents:M.getOverrideValue(void 0,E)||{},keys:M.getKeysForOverrideIdentifier(E)},{contents:r.getOverrideValue(void 0,E)||{},keys:r.getKeysForOverrideIdentifier(E)});o.push([E,[...P.added,...P.removed,...P.updated]])}}return{added:i,removed:p,updated:m,overrides:o}}function u(M,r){const i=M?r?M.keys.filter(o=>r.keys.indexOf(o)===-1):[...M.keys]:[],p=r?M?r.keys.filter(o=>M.keys.indexOf(o)===-1):[...r.keys]:[],m=[];if(M&&r){for(const o of r.keys)if(M.keys.indexOf(o)!==-1){const b=(0,A.getConfigurationValue)(r.contents,o),a=(0,A.getConfigurationValue)(M.contents,o);R.equals(b,a)||m.push(o)}}return{added:i,removed:p,updated:m}}}),define(Ee[84],_e([0,1,4]),function(oe,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,c.createDecorator)("remoteAuthorityResolverService");var F;(function(I){I.Unknown="Unknown",I.NotAvailable="NotAvailable",I.TemporarilyNotAvailable="TemporarilyNotAvailable",I.NoResolverFound="NoResolverFound"})(F=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class w extends Error{constructor(t,R=F.Unknown,S){super(t);this._message=t,this._code=R,this._detail=S,this.isHandled=R===F.NotAvailable&&S===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,w.prototype)}static isTemporarilyNotAvailable(t){return t instanceof w&&t._code===F.TemporarilyNotAvailable}static isNoResolverFound(t){return t instanceof w&&t._code===F.NoResolverFound}static isHandled(t){return t instanceof w&&t.isHandled}}e.RemoteAuthorityResolverError=w}),define(Ee[61],_e([0,1,10]),function(oe,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function F(C){return C.scheme===c.Schemas.vscodeRemote?C.authority:void 0}e.getRemoteAuthority=F;function w(C){if(!C)return;const A=C.indexOf("+");return A<0?C:C.substr(0,A)}e.getRemoteName=w;function I(C){return C.scheme!==c.Schemas.file&&C.scheme!==c.Schemas.vscodeRemote}e.isVirtualResource=I;function t(C){if(C.folders.length)return C.folders.every(A=>I(A.uri))?C.folders[0].uri:void 0;if(C.configuration&&I(C.configuration))return C.configuration}e.getVirtualWorkspaceLocation=t;function R(C){return t(C)?.scheme}e.getVirtualWorkspaceScheme=R;function S(C){return t(C)!==void 0}e.isVirtualWorkspace=S}),define(Ee[25],_e([0,1,9,4,61]),function(oe,e,c,F,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function I(n){if(typeof n=="object"&&n!==null&&n.supported!==!0)return n.description}e.getWorkspaceSupportTypeMessage=I;function t(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(!n.uuid||typeof n.uuid=="string")}e.isIExtensionIdentifier=t,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var R;(function(n){n[n.System=0]="System",n[n.User=1]="User"})(R=e.ExtensionType||(e.ExtensionType={}));class S{constructor(h){this.value=h,this._lower=h.toLowerCase()}static equals(h,s){if(typeof h=="undefined"||h===null)return typeof s=="undefined"||s===null;if(typeof s=="undefined"||s===null)return!1;if(typeof h=="string"||typeof s=="string"){let l=typeof h=="string"?h:h.value,d=typeof s=="string"?s:s.value;return c.equalsIgnoreCase(l,d)}return h._lower===s._lower}static toKey(h){return typeof h=="string"?h.toLowerCase():h._lower}}e.ExtensionIdentifier=S;function C(n){return n.contributes&&n.contributes.localizations?n.contributes.localizations.length>0:!1}e.isLanguagePackExtension=C;function A(n){return n.contributes&&n.contributes.authentication?n.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=A;function _(n,h){if(h){const s=`onResolveRemoteAuthority:${(0,w.getRemoteName)(h)}`;return n.activationEvents?.indexOf(s)!==-1}return!1}e.isResolverExtension=_,e.IBuiltinExtensionsScannerService=(0,F.createDecorator)("IBuiltinExtensionsScannerService")}),define(Ee[143],_e([0,1,9,25]),function(oe,e,c,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function w(s,l){return s.uuid&&l.uuid?s.uuid===l.uuid:s.id===l.id?!0:(0,c.compareIgnoreCase)(s.id,l.id)===0}e.areSameExtensions=w;class I{constructor(l,d){this.version=d,this.id=l.id,this.uuid=l.uuid}key(){return`${this.id}-${this.version}`}equals(l){return l instanceof I?w(this,l)&&this.version===l.version:!1}}e.ExtensionIdentifierWithVersion=I;function t(s,l){return`${s}.${l}`}e.getExtensionId=t;function R(s){return s.toLocaleLowerCase()}e.adoptToGalleryExtensionId=R;function S(s,l){return R(t(s,l))}e.getGalleryExtensionId=S;function C(s,l){const d=[],D=v=>{for(const f of d)if(f.some(g=>w(l(g),l(v))))return f;return null};for(const v of s){const f=D(v);f?f.push(v):d.push([v])}return d}e.groupByExtension=C;function A(s){return{id:s.identifier.id,name:s.manifest.name,galleryId:null,publisherId:s.publisherId,publisherName:s.manifest.publisher,publisherDisplayName:s.publisherDisplayName,dependencies:s.manifest.extensionDependencies&&s.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=A;function _(s){return{id:s.identifier.id,name:s.name,galleryId:s.identifier.uuid,publisherId:s.publisherId,publisherName:s.publisher,publisherDisplayName:s.publisherDisplayName,dependencies:!!(s.properties.dependencies&&s.properties.dependencies.length>0),...s.telemetryData}}e.getGalleryExtensionTelemetryData=_,e.BetterMergeId=new F.ExtensionIdentifier("pprice.better-merge");function n(s){const l=new Set;for(const d of s)d.malicious&&l.add(d.id.id);return l}e.getMaliciousExtensionsSet=n;function h(s,l){const d=[],D=l.manifest.extensionDependencies?.slice(0)??[];for(;D.length;){const v=D.shift();if(v&&d.every(f=>!w(f.identifier,{id:v}))){const f=s.filter(g=>w(g.identifier,{id:v}));f.length===1&&(d.push(f[0]),D.push(...f[0].manifest.extensionDependencies?.slice(0)??[]))}}return d}e.getExtensionDependencies=h}),define(Ee[144],_e([0,1,3,23,4,12]),function(oe,e,c,F,w,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,w.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,w.createDecorator)("sharedTunnelsService");var t;(function(s){s.Http="http",s.Https="https"})(t=e.TunnelProtocol||(e.TunnelProtocol={}));var R;(function(s){s.ConstantPrivate="constantPrivate",s.Private="private",s.Public="public"})(R=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var S;(function(s){s[s.Notify=1]="Notify",s[s.OpenBrowser=2]="OpenBrowser",s[s.OpenPreview=3]="OpenPreview",s[s.Silent=4]="Silent",s[s.Ignore=5]="Ignore",s[s.OpenBrowserOnce=6]="OpenBrowserOnce"})(S=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function C(s){if(s.scheme!=="http"&&s.scheme!=="https")return;const l=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(s.authority);if(!!l)return{address:l[1],port:+l[2]}}e.extractLocalHostUriMetaDataForPortMapping=C,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function A(s){return e.LOCALHOST_ADDRESSES.indexOf(s)>=0}e.isLocalhost=A,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function _(s){return e.ALL_INTERFACES_ADDRESSES.indexOf(s)>=0}e.isAllInterfaces=_;function n(s,l){return l?l!==1&&s<1024:!F.isWindows&&s<1024}e.isPortPrivileged=n;let h=class{constructor(l){this.logService=l,this._onTunnelOpened=new c.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new c.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new c.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[]}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(l,d){return this._tunnelProvider=l,l?(this._canElevate=d.elevation,this._privacyOptions=d.privacyOptions,this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const l=[],d=Array.from(this._tunnels.values());for(let D of d){const v=Array.from(D.values());for(let f of v){const g=await f.value;g&&l.push(g)}}return l}async dispose(){for(const l of this._tunnels.values()){for(const{value:d}of l.values())await d.then(D=>D?.dispose());l.clear()}this._tunnels.clear()}openTunnel(l,d,D,v,f=!1,g=R.Private,T){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${d}:${D} on local port ${v}.`),!l)return;d||(d="localhost");const u=this.retainOrCreateTunnel(l,d,D,v,f,g,T);return u?u.then(M=>{if(!M){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(d,D);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const r=this.makeTunnel(M);return(M.tunnelRemoteHost!==d||M.tunnelRemotePort!==D)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(r),r}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),u)}makeTunnel(l){return{tunnelRemotePort:l.tunnelRemotePort,tunnelRemoteHost:l.tunnelRemoteHost,tunnelLocalPort:l.tunnelLocalPort,localAddress:l.localAddress,privacy:l.privacy,protocol:l.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${l.tunnelRemoteHost}:${l.tunnelRemotePort} `);const d=this._tunnels.get(l.tunnelRemoteHost);if(d){const D=d.get(l.tunnelRemotePort);D&&(D.refcount--,await this.tryDisposeTunnel(l.tunnelRemoteHost,l.tunnelRemotePort,D))}}}}async tryDisposeTunnel(l,d,D){if(D.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${l}:${d}.`);const v=D.value.then(async f=>{f&&(await f.dispose(!0),this._onTunnelClosed.fire({host:f.tunnelRemoteHost,port:f.tunnelRemotePort}))});return this._tunnels.has(l)&&this._tunnels.get(l).delete(d),v}}async closeTunnel(l,d){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${l}:${d} `);const D=this._tunnels.get(l);if(D&&D.has(d)){const v=D.get(d);v.refcount=0,await this.tryDisposeTunnel(l,d,v)}}addTunnelToMap(l,d,D){this._tunnels.has(l)||this._tunnels.set(l,new Map),this._tunnels.get(l).set(d,{refcount:1,value:D})}async removeEmptyTunnelFromMap(l,d){const D=this._tunnels.get(l);D&&(await D.get(d)||D.delete(d),D.size===0&&this._tunnels.delete(l))}getTunnelFromMap(l,d){let D=[l];A(l)?(D.push(...e.LOCALHOST_ADDRESSES),D.push(...e.ALL_INTERFACES_ADDRESSES)):_(l)&&D.push(...e.ALL_INTERFACES_ADDRESSES);const v=D.map(f=>this._tunnels.get(f));for(const f of v){const g=f?.get(d);if(g)return g}}canTunnel(l){return!!C(l)}createWithProvider(l,d,D,v,f,g,T){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${d}:${D} on local port ${v}.`);const M={elevationRequired:f?n(v===void 0?D:v):!1},r={remoteAddress:{host:d,port:D},localAddressPort:v,privacy:g,public:g!==R.Private,protocol:T},i=l.forwardPort(r,M);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),i&&this.addTunnelToMap(d,D,i),i}};h=xe([$e(0,I.ILogService)],h),e.AbstractTunnelService=h}),define(Ee[145],_e([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class c{constructor(w){this._callback=w,this._terminalBufferMap=new Map}dispose(){for(const w of this._terminalBufferMap.values())w.dispose()}startBuffering(w,I,t=5){let R;return R=I(S=>{const C=typeof S=="string"?S:S.data;let A=this._terminalBufferMap.get(w);if(A){A.data.push(C);return}const _=setTimeout(()=>this.flushBuffer(w),t);A={data:[C],timeoutId:_,dispose:()=>{clearTimeout(_),this.flushBuffer(w),R.dispose()}},this._terminalBufferMap.set(w,A)}),R}stopBuffering(w){const I=this._terminalBufferMap.get(w);I&&I.dispose()}flushBuffer(w){const I=this._terminalBufferMap.get(w);I&&(this._terminalBufferMap.delete(w),this._callback(w,I.data.join("")))}}e.TerminalDataBufferer=c}),define(Ee[146],_e([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var c;(function(F){F.DARK="dark",F.LIGHT="light",F.HIGH_CONTRAST="hc"})(c=e.ColorScheme||(e.ColorScheme={}))}),define(Ee[62],_e([0,1,53,3,6,4,36,146]),function(oe,e,c,F,w,I,t,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,I.createDecorator)("themeService");var S;(function(d){function D(v){return v&&typeof v=="object"&&typeof v.id=="string"}d.isThemeColor=D})(S=e.ThemeColor||(e.ThemeColor={}));function C(d){return{id:d}}e.themeColorFromId=C;var A;(function(d){function D(r){return r&&typeof r=="object"&&typeof r.id=="string"&&(typeof r.color=="undefined"||S.isThemeColor(r.color))}d.isThemeIcon=D;const v=new RegExp(`^\\$\\((${c.CSSIcon.iconNameExpression}(?:${c.CSSIcon.iconModifierExpression})?)\\)$`);function f(r){const i=v.exec(r);if(!i)return;let[,p]=i;return{id:p}}d.fromString=f;function g(r,i){let p=r.id;const m=p.lastIndexOf("~");return m!==-1&&(p=p.substring(0,m)),i&&(p=`${p}~${i}`),{id:p}}d.modify=g;function T(r){const i=r.id.lastIndexOf("~");if(i!==-1)return r.id.substring(i+1)}d.getModifier=T;function u(r,i){return r.id===i.id&&r.color?.id===i.color?.id}d.isEqual=u;function M(r,i){return{id:r.id,color:i?C(i):void 0}}d.asThemeIcon=M,d.asClassNameArray=c.CSSIcon.asClassNameArray,d.asClassName=c.CSSIcon.asClassName,d.asCSSSelector=c.CSSIcon.asCSSSelector})(A=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=c.Codicon.file,e.FolderThemeIcon=c.Codicon.folder;function _(d){switch(d){case R.ColorScheme.DARK:return"vs-dark";case R.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=_,e.Extensions={ThemingContribution:"base.contributions.theming"};class n{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new F.Emitter}onColorThemeChange(D){return this.themingParticipants.push(D),this.onThemingParticipantAddedEmitter.fire(D),(0,w.toDisposable)(()=>{const v=this.themingParticipants.indexOf(D);this.themingParticipants.splice(v,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let h=new n;t.Registry.add(e.Extensions.ThemingContribution,h);function s(d){return h.onColorThemeChange(d)}e.registerThemingParticipant=s;class l extends w.Disposable{constructor(D){super();this.themeService=D,this.theme=D.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(v=>this.onThemeChange(v)))}onThemeChange(D){this.theme=D,this.updateStyles()}updateStyles(){}getColor(D,v){let f=this.theme.getColor(D);return f&&v&&(f=v(f,this.theme)),f?f.toString():null}}e.Themable=l}),define(Ee[47],_e([0,1,21,24,2,4]),function(oe,e,c,F,w,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,I.createDecorator)("contextService");var t;(function(n){n[n.EMPTY=1]="EMPTY",n[n.FOLDER=2]="FOLDER",n[n.WORKSPACE=3]="WORKSPACE"})(t=e.WorkbenchState||(e.WorkbenchState={}));function R(n){const h=n;return!!(h&&typeof h=="object"&&typeof h.id=="string"&&Array.isArray(h.folders))}e.isWorkspace=R;function S(n){const h=n;return!!(h&&typeof h=="object"&&w.URI.isUri(h.uri)&&typeof h.name=="string"&&typeof h.toResource=="function")}e.isWorkspaceFolder=S;class C{constructor(h,s,l,d,D){this._id=h,this._transient=l,this._configuration=d,this._ignorePathCasing=D,this._foldersMap=c.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=s}update(h){this._id=h.id,this._configuration=h.configuration,this._transient=h.transient,this._ignorePathCasing=h._ignorePathCasing,this.folders=h.folders}get folders(){return this._folders}set folders(h){this._folders=h,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(h){this._configuration=h}getFolder(h){return h&&this._foldersMap.findSubstr(h.with({scheme:h.scheme,authority:h.authority,path:h.path}))||null}updateFoldersMap(){this._foldersMap=c.TernarySearchTree.forUris(this._ignorePathCasing);for(const h of this.folders)this._foldersMap.set(h.uri,h)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=C;class A{constructor(h,s){this.raw=s,this.uri=h.uri,this.index=h.index,this.name=h.name}toResource(h){return(0,F.joinPath)(this.uri,h)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=A;function _(n){return new A({uri:n,index:0,name:(0,F.basenameOrAuthority)(n)},{uri:n.toString()})}e.toWorkspaceFolder=_}),define(Ee[63],_e([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class c{constructor(w){this.id=w,this._data=new Map,this._idPool=1}add(w){const I=this._idPool++;return this._data.set(I,w),this.logDebugInfo(),I}get(w,I){return this._data.has(w)?this._data.get(w)[I]:void 0}delete(w){this._data.delete(w),this.logDebugInfo()}logDebugInfo(){!c.enableDebugLogging||console.log(`${this.id} cache size - ${this._data.size}`)}}e.Cache=c,c.enableDebugLogging=!1}),define(Ee[30],_e([0,1,10,24,4]),function(oe,e,c,F,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class I{constructor(){this._systemSchemes=new Set(Object.keys(c.Schemas)),this._providerInfo=new Map,this.extUri=new F.ExtUri(R=>{const S=this._providerInfo.get(R.scheme);return!(S===void 0||S&1024)})}$acceptProviderInfos(R,S){S===null?this._providerInfo.delete(R):this._providerInfo.set(R,S)}isFreeScheme(R){return!this._providerInfo.has(R)&&!this._systemSchemes.has(R)}getCapabilities(R){return this._providerInfo.get(R)}}e.ExtHostFileSystemInfo=I,e.IExtHostFileSystemInfo=(0,w.createDecorator)("IExtHostFileSystemInfo")}),define(Ee[28],_e([0,1,4]),function(oe,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,c.createDecorator)("IExtHostInitDataService")}),define(Ee[147],_e([0,1,14]),function(oe,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class F{constructor(t,R,S){this._deferredPromises=new Map,this._id=t,this._shared=R,this._storage=S,this._init=this._storage.getValue(this._shared,this._id,Object.create(null)).then(C=>(this._value=C,this)),this._storageListener=this._storage.onDidChangeStorage(C=>{C.shared===this._shared&&C.key===this._id&&(this._value=C.value)}),this._scheduler=new c.RunOnceScheduler(()=>{const C=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const A of C.values())A.complete()}catch(A){for(const _ of C.values())_.error(A)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,t])=>t!==void 0).map(([t])=>t)}get whenReady(){return this._init}get(t,R){let S=this._value[t];return typeof S=="undefined"&&(S=R),S}update(t,R){this._value[t]=R;let S=this._deferredPromises.get(t);if(S!==void 0)return S.p;const C=new c.DeferredPromise;return this._deferredPromises.set(t,C),this._scheduler.isScheduled()||this._scheduler.schedule(),C.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=F;class w extends F{constructor(t,R){super(t.identifier.value,!0,R);this._extension=t}setKeysForSync(t){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},t)}}e.ExtensionGlobalMemento=w}),define(Ee[148],_e([0,1,3,2,12]),function(oe,e,c,F,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;let I=class{constructor(R,S){this._logService=R,this._notebooksAndEditors=S,this._onDidChangeNotebookDocumentMetadata=new c.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidSaveNotebookDocument=new c.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event}$acceptModelChanged(R,S,C){this._notebooksAndEditors.getNotebookDocument(F.URI.revive(R)).acceptModelChanged(S.value,C)}$acceptDirtyStateChanged(R,S){this._notebooksAndEditors.getNotebookDocument(F.URI.revive(R)).acceptDirty(S)}$acceptModelSaved(R){const S=this._notebooksAndEditors.getNotebookDocument(F.URI.revive(R));this._onDidSaveNotebookDocument.fire(S.apiNotebook)}$acceptDocumentPropertiesChanged(R,S){this._logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",R.path,S);const C=this._notebooksAndEditors.getNotebookDocument(F.URI.revive(R));C.acceptDocumentPropertiesChanged(S),S.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:C.apiNotebook})}};I=xe([$e(0,w.ILogService)],I),e.ExtHostNotebookDocuments=I}),define(Ee[13],_e([0,1,4]),function(oe,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,c.createDecorator)("IExtHostRpcService");class F{constructor(I){this.getProxy=I.getProxy.bind(I),this.set=I.set.bind(I),this.assertRegistered=I.assertRegistered.bind(I),this.drain=I.drain.bind(I)}}e.ExtHostRpcService=F});var Ze=this&&this.__classPrivateFieldSet||function(oe,e,c,F,w){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?oe!==e||!w:!e.has(oe))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?w.call(oe,c):w?w.value=c:e.set(oe,c),c},Ae=this&&this.__classPrivateFieldGet||function(oe,e,c,F){if(c==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?oe!==e||!F:!e.has(oe))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?F:c==="a"?F.call(oe):F?F.value:e.get(oe)};define(Ee[149],_e([0,1,25,3]),function(oe,e,c,F){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class I{constructor(R,S){w.set(this,void 0),this._onDidChange=new F.Emitter,this.onDidChange=this._onDidChange.event,this._id=c.ExtensionIdentifier.toKey(R.identifier),Ze(this,w,S,"f"),Ae(this,w,"f").onDidChangePassword(C=>{C.extensionId===this._id&&this._onDidChange.fire({key:C.key})})}get(R){return Ae(this,w,"f").get(this._id,R)}store(R,S){return Ae(this,w,"f").store(this._id,R,S)}delete(R){return Ae(this,w,"f").delete(this._id,R)}}e.ExtensionSecrets=I,w=new WeakMap}),define(Ee[85],_e([0,1,4,3]),function(oe,e,c,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class w{constructor(){this._onDidChangeTelemetryEnabled=new F.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._enabled=!1}getTelemetryEnabled(){return this._enabled}$initializeTelemetryEnabled(t){this._enabled=t}$onDidChangeTelemetryEnabled(t){this._enabled=t,this._onDidChangeTelemetryEnabled.fire(t)}}e.ExtHostTelemetry=w,e.IExtHostTelemetry=(0,c.createDecorator)("IExtHostTelemetry")}),define(Ee[48],_e([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestItemRootImpl=e.TestItemImpl=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.diffTestItems=e.getPrivateApiFor=e.createPrivateApiFor=e.ExtHostTestItemEventOp=void 0;var c;(function(v){v[v.Upsert=0]="Upsert",v[v.RemoveChild=1]="RemoveChild",v[v.Invalidated=2]="Invalidated",v[v.SetProp=3]="SetProp",v[v.Bulk=4]="Bulk"})(c=e.ExtHostTestItemEventOp||(e.ExtHostTestItemEventOp={}));const F=new WeakMap,w=(v,f)=>{const g={controllerId:f};return F.set(v,g),g};e.createPrivateApiFor=w;const I=v=>F.get(v);e.getPrivateApiFor=I;const t=(v,f,g,T)=>{let u=g;return{enumerable:!0,configurable:!1,get(){return u},set(M){if(!T(u,M)){const r=u;u=M,v.listener?.({op:3,key:f,value:M,previous:r})}}}},R=(v,f)=>v===f,S={range:(v,f)=>v===f?!0:!v||!f?!1:v.isEqual(f),label:R,description:R,busy:R,error:R,canResolveChildren:R,tags:(v,f)=>!(v.length!==f.length||v.some(g=>!f.find(T=>g.id===T.id)))},C=Object.keys(S),A=(v,f)=>({range:t(v,"range",void 0,S.range),label:t(v,"label",f,S.label),description:t(v,"description",void 0,S.description),canResolveChildren:t(v,"canResolveChildren",!1,S.canResolveChildren),busy:t(v,"busy",!1,S.busy),error:t(v,"error",void 0,S.error),tags:t(v,"tags",[],S.tags)}),_=(v,f)=>{const g=new Map;for(const T of C)S[T](v[T],f[T])||g.set(T,f[T]);return g};e.diffTestItems=_;class n extends Error{constructor(f){super(`Attempted to insert a duplicate test item ID ${f}`)}}e.DuplicateTestItemError=n;class h extends Error{constructor(f){super(`TestItem with ID "${f}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=h;class s extends Error{constructor(f,g,T){super(`TestItem with ID "${f}" is from controller "${g}" and cannot be added as a child of an item from controller "${T}".`)}}e.MixedTestItemController=s;const l=v=>{const f=(0,e.getPrivateApiFor)(v);let g=new Map;return{get size(){return g.size},forEach(T,u){for(const M of g.values())T.call(u,M,this)},replace(T){const u=new Map,M=new Set(g.keys()),r={op:4,ops:[]};for(const i of T){if(!(i instanceof d))throw new h(i.id);const p=(0,e.getPrivateApiFor)(i).controllerId;if(p!==f.controllerId)throw new s(i.id,p,f.controllerId);if(u.has(i.id))throw new n(i.id);u.set(i.id,i),M.delete(i.id),r.ops.push({op:0,item:i})}for(const i of M.keys())r.ops.push({op:1,id:i});f.listener?.(r),g=u},add(T){if(!(T instanceof d))throw new h(T.id);g.set(T.id,T),f.listener?.({op:0,item:T})},delete(T){g.delete(T)&&f.listener?.({op:1,id:T})},get(T){return g.get(T)},toJSON(){return Array.from(g.values())},[Symbol.iterator](){return g.values()}}};class d{constructor(f,g,T,u){if(g.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(g)} symbol`);const M=(0,e.createPrivateApiFor)(this,f);Object.defineProperties(this,{id:{value:g,enumerable:!0,writable:!1},uri:{value:u,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return M.parent instanceof D?void 0:M.parent}},children:{value:l(this),enumerable:!0,writable:!1},...A(M,T)})}invalidateResults(){(0,e.getPrivateApiFor)(this).listener?.({op:2})}}e.TestItemImpl=d;class D extends d{constructor(f,g){super(f,f,g,void 0)}}e.TestItemRootImpl=D}),define(Ee[64],_e([0,1,4,144,3,13]),function(oe,e,c,F,w,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var t;(function(S){function C(_){return{remoteAddress:_.remoteAddress,localAddress:_.localAddress,public:!!_.public,privacy:_.privacy??(_.public?F.TunnelPrivacyId.Public:F.TunnelPrivacyId.Private),protocol:_.protocol}}S.fromApiTunnel=C;function A(_){return{remoteAddress:{host:_.tunnelRemoteHost,port:_.tunnelRemotePort},localAddress:_.localAddress,public:_.privacy!==F.TunnelPrivacyId.ConstantPrivate&&_.privacy!==F.TunnelPrivacyId.ConstantPrivate,privacy:_.privacy,protocol:_.protocol}}S.fromServiceTunnel=A})(t=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=(0,c.createDecorator)("IExtHostTunnelService");let R=class{constructor(C){this.onDidChangeTunnels=new w.Emitter().event}async $applyCandidateFilter(C){return C}async openTunnel(C,A){}async getTunnels(){return[]}async setTunnelExtensionFunctions(C){return{dispose:()=>{}}}registerPortsAttributesProvider(C,A){return{dispose:()=>{}}}async $providePortAttributes(C,A,_,n,h){return[]}async $forwardPort(C,A){}async $closeTunnel(C){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};R=xe([$e(0,I.IExtHostRpcService)],R),e.ExtHostTunnelService=R});var Ze=this&&this.__classPrivateFieldSet||function(oe,e,c,F,w){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?oe!==e||!w:!e.has(oe))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?w.call(oe,c):w?w.value=c:e.set(oe,c),c},Ae=this&&this.__classPrivateFieldGet||function(oe,e,c,F){if(c==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?oe!==e||!F:!e.has(oe))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?F:c==="a"?F.call(oe):F?F.value:e.get(oe)};define(Ee[7],_e([0,1,16,15,76,21,78,9,11,2,35,46,84]),function(oe,e,c,F,w,I,t,R,S,C,A,_,n){"use strict";var h,s,l,d,D,v,f,g,T,u,M,r,i,p,m,o,b,a,E,P;Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeDataTransfer=e.TreeDataTransferItem=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestions=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function k(U){function O(){return Reflect.construct(U,arguments,this.constructor)}return Object.defineProperty(O,"name",Object.getOwnPropertyDescriptor(U,"name")),Object.setPrototypeOf(O,U),Object.setPrototypeOf(O.prototype,U.prototype),O}let B=D=class{constructor(O){h.set(this,void 0),Ze(this,h,O,"f")}static from(...O){let ee=O;return new D(function(){if(ee){for(const ye of ee)ye&&typeof ye.dispose=="function"&&ye.dispose();ee=void 0}})}dispose(){typeof Ae(this,h,"f")=="function"&&(Ae(this,h,"f").call(this),Ze(this,h,void 0,"f"))}};h=new WeakMap,B=D=xe([k],B),e.Disposable=B;let L=v=class{constructor(O,ee){if(O<0)throw(0,F.illegalArgument)("line must be non-negative");if(ee<0)throw(0,F.illegalArgument)("character must be non-negative");this._line=O,this._character=ee}static Min(...O){if(O.length===0)throw new TypeError;let ee=O[0];for(let ye=1;ye<O.length;ye++){const Ve=O[ye];Ve.isBefore(ee)&&(ee=Ve)}return ee}static Max(...O){if(O.length===0)throw new TypeError;let ee=O[0];for(let ye=1;ye<O.length;ye++){const Ve=O[ye];Ve.isAfter(ee)&&(ee=Ve)}return ee}static isPosition(O){if(!O)return!1;if(O instanceof v)return!0;let{line:ee,character:ye}=O;return typeof ee=="number"&&typeof ye=="number"}get line(){return this._line}get character(){return this._character}isBefore(O){return this._line<O._line?!0:O._line<this._line?!1:this._character<O._character}isBeforeOrEqual(O){return this._line<O._line?!0:O._line<this._line?!1:this._character<=O._character}isAfter(O){return!this.isBeforeOrEqual(O)}isAfterOrEqual(O){return!this.isBefore(O)}isEqual(O){return this._line===O._line&&this._character===O._character}compareTo(O){return this._line<O._line?-1:this._line>O.line?1:this._character<O._character?-1:this._character>O._character?1:0}translate(O,ee=0){if(O===null||ee===null)throw(0,F.illegalArgument)();let ye;return typeof O=="undefined"?ye=0:typeof O=="number"?ye=O:(ye=typeof O.lineDelta=="number"?O.lineDelta:0,ee=typeof O.characterDelta=="number"?O.characterDelta:0),ye===0&&ee===0?this:new v(this.line+ye,this.character+ee)}with(O,ee=this.character){if(O===null||ee===null)throw(0,F.illegalArgument)();let ye;return typeof O=="undefined"?ye=this.line:typeof O=="number"?ye=O:(ye=typeof O.line=="number"?O.line:this.line,ee=typeof O.character=="number"?O.character:this.character),ye===this.line&&ee===this.character?this:new v(ye,ee)}toJSON(){return{line:this.line,character:this.character}}};L=v=xe([k],L),e.Position=L;let y=f=class{constructor(O,ee,ye,Ve){let nt,at;if(typeof O=="number"&&typeof ee=="number"&&typeof ye=="number"&&typeof Ve=="number"?(nt=new L(O,ee),at=new L(ye,Ve)):O instanceof L&&ee instanceof L&&(nt=O,at=ee),!nt||!at)throw new Error("Invalid arguments");nt.isBefore(at)?(this._start=nt,this._end=at):(this._start=at,this._end=nt)}static isRange(O){return O instanceof f?!0:O?L.isPosition(O.start)&&L.isPosition(O.end):!1}get start(){return this._start}get end(){return this._end}contains(O){return O instanceof f?this.contains(O._start)&&this.contains(O._end):O instanceof L?!(O.isBefore(this._start)||this._end.isBefore(O)):!1}isEqual(O){return this._start.isEqual(O._start)&&this._end.isEqual(O._end)}intersection(O){const ee=L.Max(O.start,this._start),ye=L.Min(O.end,this._end);if(!ee.isAfter(ye))return new f(ee,ye)}union(O){if(this.contains(O))return this;if(O.contains(this))return O;const ee=L.Min(O.start,this._start),ye=L.Max(O.end,this.end);return new f(ee,ye)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(O,ee=this.end){if(O===null||ee===null)throw(0,F.illegalArgument)();let ye;return O?L.isPosition(O)?ye=O:(ye=O.start||this.start,ee=O.end||this.end):ye=this.start,ye.isEqual(this._start)&&ee.isEqual(this.end)?this:new f(ye,ee)}toJSON(){return[this.start,this.end]}};y=f=xe([k],y),e.Range=y;let x=g=class extends y{constructor(O,ee,ye,Ve){let nt,at;if(typeof O=="number"&&typeof ee=="number"&&typeof ye=="number"&&typeof Ve=="number"?(nt=new L(O,ee),at=new L(ye,Ve)):O instanceof L&&ee instanceof L&&(nt=O,at=ee),!nt||!at)throw new Error("Invalid arguments");super(nt,at);this._anchor=nt,this._active=at}static isSelection(O){return O instanceof g?!0:O?y.isRange(O)&&L.isPosition(O.anchor)&&L.isPosition(O.active)&&typeof O.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};x=g=xe([k],x),e.Selection=x;class N{constructor(O,ee,ye){if(typeof O!="string"||O.length===0)throw(0,F.illegalArgument)("host");if(typeof ee!="number"||ee===0||Math.round(ee)!==ee)throw(0,F.illegalArgument)("port");if(typeof ye!="undefined"&&(typeof ye!="string"||ye.length===0||!/^[0-9A-Za-z\-]+$/.test(ye)))throw(0,F.illegalArgument)("connectionToken");this.host=O,this.port=Math.round(ee),this.connectionToken=ye}}e.ResolvedAuthority=N;class z extends Error{constructor(O,ee=n.RemoteAuthorityResolverErrorCode.Unknown,ye){super(O);this._message=O,this._code=ee,this._detail=ye,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,z.prototype)}static NotAvailable(O,ee){return new z(O,n.RemoteAuthorityResolverErrorCode.NotAvailable,ee)}static TemporarilyNotAvailable(O){return new z(O,n.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=z;var H;(function(U){U[U.LF=1]="LF",U[U.CRLF=2]="CRLF"})(H=e.EndOfLine||(e.EndOfLine={}));var q;(function(U){U[U.Replace=1]="Replace",U[U.Append=2]="Append",U[U.Prepend=3]="Prepend"})(q=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let ue=T=class{constructor(O,ee){this._range=O,this._newText=ee}static isTextEdit(O){return O instanceof T?!0:O?y.isRange(O)&&typeof O.newText=="string":!1}static replace(O,ee){return new T(O,ee)}static insert(O,ee){return T.replace(new y(O,O),ee)}static delete(O){return T.replace(O,"")}static setEndOfLine(O){const ee=new T(new y(new L(0,0),new L(0,0)),"");return ee.newEol=O,ee}get range(){return this._range}set range(O){if(O&&!y.isRange(O))throw(0,F.illegalArgument)("range");this._range=O}get newText(){return this._newText||""}set newText(O){if(O&&typeof O!="string")throw(0,F.illegalArgument)("newText");this._newText=O}get newEol(){return this._newEol}set newEol(O){if(O&&typeof O!="number")throw(0,F.illegalArgument)("newEol");this._newEol=O}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};ue=T=xe([k],ue),e.TextEdit=ue;var K;(function(U){U[U.File=1]="File",U[U.Text=2]="Text",U[U.Cell=3]="Cell",U[U.CellReplace=5]="CellReplace"})(K=e.FileEditType||(e.FileEditType={}));let ce=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(O,ee,ye,Ve){this._edits.push({_type:1,from:O,to:ee,options:ye,metadata:Ve})}createFile(O,ee,ye){this._edits.push({_type:1,from:void 0,to:O,options:ee,metadata:ye})}deleteFile(O,ee,ye){this._edits.push({_type:1,from:O,to:void 0,options:ee,metadata:ye})}replaceNotebookMetadata(O,ee,ye){this._edits.push({_type:3,metadata:ye,uri:O,edit:{editType:5,metadata:ee},notebookMetadata:ee})}replaceNotebookCells(O,ee,ye,Ve,nt){let at,ut,kt=[],Mt;if(Re.isNotebookRange(ee)&&Lt.isNotebookCellDataArray(ye)&&!Lt.isNotebookCellDataArray(Ve)?(at=ee.start,ut=ee.end,kt=ye,Mt=Ve):typeof ee=="number"&&typeof ye=="number"&&Lt.isNotebookCellDataArray(Ve)&&(at=ee,ut=ye,kt=Ve,Mt=nt),at===void 0||ut===void 0)throw new Error("Invalid arguments");(at!==ut||kt.length>0)&&this._edits.push({_type:5,uri:O,index:at,count:ut-at,cells:kt,metadata:Mt})}replaceNotebookCellMetadata(O,ee,ye,Ve){this._edits.push({_type:3,metadata:Ve,uri:O,edit:{editType:8,index:ee,metadata:ye}})}replace(O,ee,ye,Ve){this._edits.push({_type:2,uri:O,edit:new ue(ee,ye),metadata:Ve})}insert(O,ee,ye,Ve){this.replace(O,new y(ee,ee),ye,Ve)}delete(O,ee,ye){this.replace(O,ee,"",ye)}has(O){return this._edits.some(ee=>ee._type===2&&ee.uri.toString()===O.toString())}set(O,ee){if(ee)for(const ye of ee)ye&&this._edits.push({_type:2,uri:O,edit:ye});else{for(let ye=0;ye<this._edits.length;ye++){const Ve=this._edits[ye];Ve._type===2&&Ve.uri.toString()===O.toString()&&(this._edits[ye]=void 0)}(0,c.coalesceInPlace)(this._edits)}}get(O){const ee=[];for(let ye of this._edits)ye._type===2&&ye.uri.toString()===O.toString()&&ee.push(ye.edit);return ee}entries(){const O=new I.ResourceMap;for(let ee of this._edits)if(ee._type===2){let ye=O.get(ee.uri);ye||(ye=[ee.uri,[]],O.set(ee.uri,ye)),ye[1].push(ee.edit)}return[...O.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};ce=xe([k],ce),e.WorkspaceEdit=ce;let de=u=class{constructor(O){this._tabstop=1,this.value=O||""}static isSnippetString(O){return O instanceof u?!0:O?typeof O.value=="string":!1}static _escape(O){return O.replace(/\$|}|\\/g,"\\$&")}appendText(O){return this.value+=u._escape(O),this}appendTabstop(O=this._tabstop++){return this.value+="$",this.value+=O,this}appendPlaceholder(O,ee=this._tabstop++){if(typeof O=="function"){const ye=new u;ye._tabstop=this._tabstop,O(ye),this._tabstop=ye._tabstop,O=ye.value}else O=u._escape(O);return this.value+="${",this.value+=ee,this.value+=":",this.value+=O,this.value+="}",this}appendChoice(O,ee=this._tabstop++){const ye=O.map(Ve=>Ve.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=ee,this.value+="|",this.value+=ye,this.value+="|}",this}appendVariable(O,ee){if(typeof ee=="function"){const ye=new u;ye._tabstop=this._tabstop,ee(ye),this._tabstop=ye._tabstop,ee=ye.value}else typeof ee=="string"&&(ee=ee.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=O,ee&&(this.value+=":",this.value+=ee),this.value+="}",this}};de=u=xe([k],de),e.SnippetString=de;var Q;(function(U){U[U.Unnecessary=1]="Unnecessary",U[U.Deprecated=2]="Deprecated"})(Q=e.DiagnosticTag||(e.DiagnosticTag={}));var ie;(function(U){U[U.Hint=3]="Hint",U[U.Information=2]="Information",U[U.Warning=1]="Warning",U[U.Error=0]="Error"})(ie=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let we=M=class{constructor(O,ee){if(this.uri=O,ee)if(ee instanceof y)this.range=ee;else if(ee instanceof L)this.range=new y(ee,ee);else throw new Error("Illegal argument")}static isLocation(O){return O instanceof M?!0:O?y.isRange(O.range)&&C.URI.isUri(O.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};we=M=xe([k],we),e.Location=we;let Me=class{constructor(O,ee){this.location=O,this.message=ee}static is(O){return O?typeof O.message=="string"&&O.location&&y.isRange(O.location.range)&&C.URI.isUri(O.location.uri):!1}static isEqual(O,ee){return O===ee?!0:!O||!ee?!1:O.message===ee.message&&O.location.range.isEqual(ee.location.range)&&O.location.uri.toString()===ee.location.uri.toString()}};Me=xe([k],Me),e.DiagnosticRelatedInformation=Me;let Fe=class{constructor(O,ee,ye=ie.Error){if(!y.isRange(O))throw new TypeError("range must be set");if(!ee)throw new TypeError("message must be set");this.range=O,this.message=ee,this.severity=ye}toJSON(){return{severity:ie[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(O,ee){return O===ee?!0:!O||!ee?!1:O.message===ee.message&&O.severity===ee.severity&&O.code===ee.code&&O.severity===ee.severity&&O.source===ee.source&&O.range.isEqual(ee.range)&&(0,c.equals)(O.tags,ee.tags)&&(0,c.equals)(O.relatedInformation,ee.relatedInformation,Me.isEqual)}};Fe=xe([k],Fe),e.Diagnostic=Fe;let Be=class{constructor(O,ee){if(!O)throw new Error("Illegal argument, contents must be defined");Array.isArray(O)?this.contents=O:this.contents=[O],this.range=ee}};Be=xe([k],Be),e.Hover=Be;var Ge;(function(U){U[U.Text=0]="Text",U[U.Read=1]="Read",U[U.Write=2]="Write"})(Ge=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let je=class{constructor(O,ee=Ge.Text){this.range=O,this.kind=ee}toJSON(){return{range:this.range,kind:Ge[this.kind]}}};je=xe([k],je),e.DocumentHighlight=je;var Qe;(function(U){U[U.File=0]="File",U[U.Module=1]="Module",U[U.Namespace=2]="Namespace",U[U.Package=3]="Package",U[U.Class=4]="Class",U[U.Method=5]="Method",U[U.Property=6]="Property",U[U.Field=7]="Field",U[U.Constructor=8]="Constructor",U[U.Enum=9]="Enum",U[U.Interface=10]="Interface",U[U.Function=11]="Function",U[U.Variable=12]="Variable",U[U.Constant=13]="Constant",U[U.String=14]="String",U[U.Number=15]="Number",U[U.Boolean=16]="Boolean",U[U.Array=17]="Array",U[U.Object=18]="Object",U[U.Key=19]="Key",U[U.Null=20]="Null",U[U.EnumMember=21]="EnumMember",U[U.Struct=22]="Struct",U[U.Event=23]="Event",U[U.Operator=24]="Operator",U[U.TypeParameter=25]="TypeParameter"})(Qe=e.SymbolKind||(e.SymbolKind={}));var $;(function(U){U[U.Deprecated=1]="Deprecated"})($=e.SymbolTag||(e.SymbolTag={}));let G=r=class{constructor(O,ee,ye,Ve,nt){this.name=O,this.kind=ee,this.containerName=nt,typeof ye=="string"&&(this.containerName=ye),Ve instanceof we?this.location=Ve:ye instanceof y&&(this.location=new we(Ve,ye)),r.validate(this)}static validate(O){if(!O.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:Qe[this.kind],location:this.location,containerName:this.containerName}}};G=r=xe([k],G),e.SymbolInformation=G;let X=i=class{constructor(O,ee,ye,Ve,nt){this.name=O,this.detail=ee,this.kind=ye,this.range=Ve,this.selectionRange=nt,this.children=[],i.validate(this)}static validate(O){if(!O.name)throw new Error("name must not be falsy");if(!O.range.contains(O.selectionRange))throw new Error("selectionRange must be contained in fullRange");O.children&&O.children.forEach(i.validate)}};X=i=xe([k],X),e.DocumentSymbol=X;var se;(function(U){U[U.Invoke=1]="Invoke",U[U.Automatic=2]="Automatic"})(se=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let j=class{constructor(O,ee){this.title=O,this.kind=ee}};j=xe([k],j),e.CodeAction=j;let Z=p=class{constructor(O){this.value=O}append(O){return new p(this.value?this.value+p.sep+O:O)}intersects(O){return this.contains(O)||O.contains(this)}contains(O){return this.value===O.value||O.value.startsWith(this.value+p.sep)}};Z.sep=".",Z=p=xe([k],Z),e.CodeActionKind=Z,Z.Empty=new Z(""),Z.QuickFix=Z.Empty.append("quickfix"),Z.Refactor=Z.Empty.append("refactor"),Z.RefactorExtract=Z.Refactor.append("extract"),Z.RefactorInline=Z.Refactor.append("inline"),Z.RefactorRewrite=Z.Refactor.append("rewrite"),Z.Source=Z.Empty.append("source"),Z.SourceOrganizeImports=Z.Source.append("organizeImports"),Z.SourceFixAll=Z.Source.append("fixAll");let fe=class{constructor(O,ee){if(this.range=O,this.parent=ee,ee&&!ee.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};fe=xe([k],fe),e.SelectionRange=fe;class Te{constructor(O,ee,ye,Ve,nt,at){this.kind=O,this.name=ee,this.detail=ye,this.uri=Ve,this.range=nt,this.selectionRange=at}}e.CallHierarchyItem=Te;class Ne{constructor(O,ee){this.fromRanges=ee,this.from=O}}e.CallHierarchyIncomingCall=Ne;class He{constructor(O,ee){this.fromRanges=ee,this.to=O}}e.CallHierarchyOutgoingCall=He;var Ke;(function(U){U[U.Information=0]="Information",U[U.Warning=1]="Warning",U[U.Error=2]="Error"})(Ke=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let tt=class{constructor(O,ee){this.range=O,this.command=ee}get isResolved(){return!!this.command}};tt=xe([k],tt),e.CodeLens=tt;let st=m=class{constructor(O,ee=!1){s.set(this,void 0),Ze(this,s,new w.MarkdownString(O,{supportThemeIcons:ee}),"f")}static isMarkdownString(O){return O instanceof m?!0:O&&O.appendCodeblock&&O.appendMarkdown&&O.appendText&&O.value!==void 0}get value(){return Ae(this,s,"f").value}set value(O){Ae(this,s,"f").value=O}get isTrusted(){return Ae(this,s,"f").isTrusted}set isTrusted(O){Ae(this,s,"f").isTrusted=O}get supportThemeIcons(){return Ae(this,s,"f").supportThemeIcons}set supportThemeIcons(O){Ae(this,s,"f").supportThemeIcons=O}get supportHtml(){return Ae(this,s,"f").supportHtml}set supportHtml(O){Ae(this,s,"f").supportHtml=O}appendText(O){return Ae(this,s,"f").appendText(O),this}appendMarkdown(O){return Ae(this,s,"f").appendMarkdown(O),this}appendCodeblock(O,ee){return Ae(this,s,"f").appendCodeblock(ee??"",O),this}};s=new WeakMap,st=m=xe([k],st),e.MarkdownString=st;let Xe=class{constructor(O,ee){this.label=O,this.documentation=ee}};Xe=xe([k],Xe),e.ParameterInformation=Xe;let rt=class{constructor(O,ee){this.label=O,this.documentation=ee,this.parameters=[]}};rt=xe([k],rt),e.SignatureInformation=rt;let De=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};De=xe([k],De),e.SignatureHelp=De;var gt;(function(U){U[U.Invoke=1]="Invoke",U[U.TriggerCharacter=2]="TriggerCharacter",U[U.ContentChange=3]="ContentChange"})(gt=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var V;(function(U){U[U.Other=0]="Other",U[U.Type=1]="Type",U[U.Parameter=2]="Parameter"})(V=e.InlayHintKind||(e.InlayHintKind={}));let J=class{constructor(O,ee,ye){this.text=O,this.position=ee,this.kind=ye}};J=xe([k],J),e.InlayHint=J;var pe;(function(U){U[U.Invoke=0]="Invoke",U[U.TriggerCharacter=1]="TriggerCharacter",U[U.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(pe=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Ue;(function(U){U[U.Text=0]="Text",U[U.Method=1]="Method",U[U.Function=2]="Function",U[U.Constructor=3]="Constructor",U[U.Field=4]="Field",U[U.Variable=5]="Variable",U[U.Class=6]="Class",U[U.Interface=7]="Interface",U[U.Module=8]="Module",U[U.Property=9]="Property",U[U.Unit=10]="Unit",U[U.Value=11]="Value",U[U.Enum=12]="Enum",U[U.Keyword=13]="Keyword",U[U.Snippet=14]="Snippet",U[U.Color=15]="Color",U[U.File=16]="File",U[U.Reference=17]="Reference",U[U.Folder=18]="Folder",U[U.EnumMember=19]="EnumMember",U[U.Constant=20]="Constant",U[U.Struct=21]="Struct",U[U.Event=22]="Event",U[U.Operator=23]="Operator",U[U.TypeParameter=24]="TypeParameter",U[U.User=25]="User",U[U.Issue=26]="Issue"})(Ue=e.CompletionItemKind||(e.CompletionItemKind={}));var Ye;(function(U){U[U.Deprecated=1]="Deprecated"})(Ye=e.CompletionItemTag||(e.CompletionItemTag={}));let Je=class{constructor(O,ee){this.label=O,this.kind=ee}toJSON(){return{label:this.label,kind:this.kind&&Ue[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};Je=xe([k],Je),e.CompletionItem=Je;let lt=class{constructor(O=[],ee=!1){this.items=O,this.isIncomplete=ee}};lt=xe([k],lt),e.CompletionList=lt;let Et=class{constructor(O,ee,ye){this.text=O,this.range=ee,this.command=ye}};Et=xe([k],Et),e.InlineSuggestion=Et;let It=class{constructor(O){this.items=O}};It=xe([k],It),e.InlineSuggestions=It;var et;(function(U){U[U.Active=-1]="Active",U[U.Beside=-2]="Beside",U[U.One=1]="One",U[U.Two=2]="Two",U[U.Three=3]="Three",U[U.Four=4]="Four",U[U.Five=5]="Five",U[U.Six=6]="Six",U[U.Seven=7]="Seven",U[U.Eight=8]="Eight",U[U.Nine=9]="Nine"})(et=e.ViewColumn||(e.ViewColumn={}));var Tt;(function(U){U[U.Left=1]="Left",U[U.Right=2]="Right"})(Tt=e.StatusBarAlignment||(e.StatusBarAlignment={}));var Pe;(function(U){U[U.Off=0]="Off",U[U.On=1]="On",U[U.Relative=2]="Relative"})(Pe=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Se;(function(U){U[U.Manual=1]="Manual",U[U.AfterDelay=2]="AfterDelay",U[U.FocusOut=3]="FocusOut"})(Se=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var ve;(function(U){U[U.Default=0]="Default",U[U.InCenter=1]="InCenter",U[U.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",U[U.AtTop=3]="AtTop"})(ve=e.TextEditorRevealType||(e.TextEditorRevealType={}));var re;(function(U){U[U.Keyboard=1]="Keyboard",U[U.Mouse=2]="Mouse",U[U.Command=3]="Command"})(re=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var ae;(function(U){U[U.Undo=1]="Undo",U[U.Redo=2]="Redo"})(ae=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var he;(function(U){U[U.OpenOpen=0]="OpenOpen",U[U.ClosedClosed=1]="ClosedClosed",U[U.OpenClosed=2]="OpenClosed",U[U.ClosedOpen=3]="ClosedOpen"})(he=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(U){function O(ee){switch(ee){case"keyboard":return U.Keyboard;case"mouse":return U.Mouse;case"api":return U.Command}}U.fromValue=O}(re=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let me=class{constructor(O,ee){if(ee&&!C.URI.isUri(ee))throw(0,F.illegalArgument)("target");if(!y.isRange(O)||O.isEmpty)throw(0,F.illegalArgument)("range");this.range=O,this.target=ee}};me=xe([k],me),e.DocumentLink=me;let Ie=class{constructor(O,ee,ye,Ve){this.red=O,this.green=ee,this.blue=ye,this.alpha=Ve}};Ie=xe([k],Ie),e.Color=Ie;let ze=class{constructor(O,ee){if(ee&&!(ee instanceof Ie))throw(0,F.illegalArgument)("color");if(!y.isRange(O)||O.isEmpty)throw(0,F.illegalArgument)("range");this.range=O,this.color=ee}};ze=xe([k],ze),e.ColorInformation=ze;let Oe=class{constructor(O){if(!O||typeof O!="string")throw(0,F.illegalArgument)("label");this.label=O}};Oe=xe([k],Oe),e.ColorPresentation=Oe;var We;(function(U){U[U.RGB=0]="RGB",U[U.HEX=1]="HEX",U[U.HSL=2]="HSL"})(We=e.ColorFormat||(e.ColorFormat={}));var it;(function(U){U[U.Error=0]="Error",U[U.Warning=1]="Warning",U[U.Information=2]="Information"})(it=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));class ot{constructor(O,ee,ye){if(this.startIndex=O,this.length=ee,this.tooltip=ye,typeof O!="number"||O<0)throw(0,F.illegalArgument)("startIndex");if(typeof ee!="number"||ee<1)throw(0,F.illegalArgument)("length");if(ye!==void 0&&typeof ye!="string")throw(0,F.illegalArgument)("tooltip")}}e.TerminalLink=ot;var ne;(function(U){U[U.Panel=1]="Panel",U[U.Editor=2]="Editor"})(ne=e.TerminalLocation||(e.TerminalLocation={}));class ge{constructor(O){this.options=O,typeof O!="object"&&(0,F.illegalArgument)("options")}}e.TerminalProfile=ge;var te;(function(U){U[U.Always=1]="Always",U[U.Silent=2]="Silent",U[U.Never=3]="Never"})(te=e.TaskRevealKind||(e.TaskRevealKind={}));var W;(function(U){U[U.Shared=1]="Shared",U[U.Dedicated=2]="Dedicated",U[U.New=3]="New"})(W=e.TaskPanelKind||(e.TaskPanelKind={}));let be=o=class{constructor(O,ee){if(this.label=ee,typeof O!="string"||typeof ee!="string")throw(0,F.illegalArgument)("name");this._id=O}static from(O){switch(O){case"clean":return o.Clean;case"build":return o.Build;case"rebuild":return o.Rebuild;case"test":return o.Test;default:return}}get id(){return this._id}};be.Clean=new o("clean","Clean"),be.Build=new o("build","Build"),be.Rebuild=new o("rebuild","Rebuild"),be.Test=new o("test","Test"),be=o=xe([k],be),e.TaskGroup=be;function ke(U){let O="";for(let ee=0;ee<U.length;ee++)O+=U[ee].replace(/,/g,",,")+",";return O}let qe=class{constructor(O,ee,ye){if(typeof O!="string")throw(0,F.illegalArgument)("process");this._args=[],this._process=O,ee!==void 0&&(Array.isArray(ee)?(this._args=ee,this._options=ye):this._options=ee)}get process(){return this._process}set process(O){if(typeof O!="string")throw(0,F.illegalArgument)("process");this._process=O}get args(){return this._args}set args(O){Array.isArray(O)||(O=[]),this._args=O}get options(){return this._options}set options(O){this._options=O}computeId(){const O=[];if(O.push("process"),this._process!==void 0&&O.push(this._process),this._args&&this._args.length>0)for(let ee of this._args)O.push(ee);return ke(O)}};qe=xe([k],qe),e.ProcessExecution=qe;let Le=class{constructor(O,ee,ye){if(this._args=[],Array.isArray(ee)){if(!O)throw(0,F.illegalArgument)("command can't be undefined or null");if(typeof O!="string"&&typeof O.value!="string")throw(0,F.illegalArgument)("command");this._command=O,this._args=ee,this._options=ye}else{if(typeof O!="string")throw(0,F.illegalArgument)("commandLine");this._commandLine=O,this._options=ee}}get commandLine(){return this._commandLine}set commandLine(O){if(typeof O!="string")throw(0,F.illegalArgument)("commandLine");this._commandLine=O}get command(){return this._command?this._command:""}set command(O){if(typeof O!="string"&&typeof O.value!="string")throw(0,F.illegalArgument)("command");this._command=O}get args(){return this._args}set args(O){this._args=O||[]}get options(){return this._options}set options(O){this._options=O}computeId(){const O=[];if(O.push("shell"),this._commandLine!==void 0&&O.push(this._commandLine),this._command!==void 0&&O.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let ee of this._args)O.push(typeof ee=="string"?ee:ee.value);return ke(O)}};Le=xe([k],Le),e.ShellExecution=Le;var dt;(function(U){U[U.Escape=1]="Escape",U[U.Strong=2]="Strong",U[U.Weak=3]="Weak"})(dt=e.ShellQuoting||(e.ShellQuoting={}));var bt;(function(U){U[U.Global=1]="Global",U[U.Workspace=2]="Workspace"})(bt=e.TaskScope||(e.TaskScope={}));class Ct{constructor(O){this._callback=O}computeId(){return"customExecution"+(0,A.generateUuid)()}set callback(O){this._callback=O}get callback(){return this._callback}}e.CustomExecution=Ct;let pt=b=class{constructor(O,ee,ye,Ve,nt,at){this.__deprecated=!1,this._definition=this.definition=O;let ut;typeof ee=="string"?(this._name=this.name=ee,this._source=this.source=ye,this.execution=Ve,ut=nt,this.__deprecated=!0):ee===bt.Global||ee===bt.Workspace?(this.target=ee,this._name=this.name=ye,this._source=this.source=Ve,this.execution=nt,ut=at):(this.target=ee,this._name=this.name=ye,this._source=this.source=Ve,this.execution=nt,ut=at),typeof ut=="string"?(this._problemMatchers=[ut],this._hasDefinedMatchers=!0):Array.isArray(ut)?(this._problemMatchers=ut,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(O){this.__id=O}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof qe?this._definition={type:b.ProcessType,id:this._execution.computeId()}:this._execution instanceof Le?this._definition={type:b.ShellType,id:this._execution.computeId()}:this._execution instanceof Ct?this._definition={type:b.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:b.EmptyType,id:(0,A.generateUuid)()}}get definition(){return this._definition}set definition(O){if(O==null)throw(0,F.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=O}get scope(){return this._scope}set target(O){this.clear(),this._scope=O}get name(){return this._name}set name(O){if(typeof O!="string")throw(0,F.illegalArgument)("name");this.clear(),this._name=O}get execution(){return this._execution}set execution(O){O===null&&(O=void 0),this.clear(),this._execution=O;const ee=this._definition.type;(b.EmptyType===ee||b.ProcessType===ee||b.ShellType===ee||b.ExtensionCallbackType===ee)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(O){if(Array.isArray(O))this.clear(),this._problemMatchers=O,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(O){O!==!0&&O!==!1&&(O=!1),this.clear(),this._isBackground=O}get source(){return this._source}set source(O){if(typeof O!="string"||O.length===0)throw(0,F.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=O}get group(){return this._group}set group(O){O===null&&(O=void 0),this.clear(),this._group=O}get detail(){return this._detail}set detail(O){O===null&&(O=void 0),this._detail=O}get presentationOptions(){return this._presentationOptions}set presentationOptions(O){O==null&&(O=Object.create(null)),this.clear(),this._presentationOptions=O}get runOptions(){return this._runOptions}set runOptions(O){O==null&&(O=Object.create(null)),this.clear(),this._runOptions=O}};pt.ExtensionCallbackType="customExecution",pt.ProcessType="process",pt.ShellType="shell",pt.EmptyType="$empty",pt=b=xe([k],pt),e.Task=pt;var ht;(function(U){U[U.SourceControl=1]="SourceControl",U[U.Window=10]="Window",U[U.Notification=15]="Notification"})(ht=e.ProgressLocation||(e.ProgressLocation={}));let vt=class{constructor(O,ee=_t.None){this.collapsibleState=ee,C.URI.isUri(O)?this.resourceUri=O:this.label=O}};vt=xe([k],vt),e.TreeItem=vt;var _t;(function(U){U[U.None=0]="None",U[U.Collapsed=1]="Collapsed",U[U.Expanded=2]="Expanded"})(_t=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let Ft=class{constructor(O){this._value=O}async asString(){return JSON.stringify(this._value)}};Ft=xe([k],Ft),e.TreeDataTransferItem=Ft;let yt=class{constructor(){this._items=new Map}get(O){return this._items.get(O)}set(O,ee){this._items.set(O,ee)}forEach(O){this._items.forEach(O)}};yt=xe([k],yt),e.TreeDataTransfer=yt;let At=class{constructor(O,ee){this.id=O,this.color=ee}};At=xe([k],At),e.ThemeIcon=At,At.File=new At("file"),At.Folder=new At("folder");let Ut=class{constructor(O){this.id=O}};Ut=xe([k],Ut),e.ThemeColor=Ut;var Pt;(function(U){U[U.Global=1]="Global",U[U.Workspace=2]="Workspace",U[U.WorkspaceFolder=3]="WorkspaceFolder"})(Pt=e.ConfigurationTarget||(e.ConfigurationTarget={}));let Bt=class{constructor(O,ee){if(typeof O!="string"&&(!O||!C.URI.isUri(O)&&!C.URI.isUri(O.uri)))throw(0,F.illegalArgument)("base");if(typeof ee!="string")throw(0,F.illegalArgument)("pattern");typeof O=="string"?(this.baseFolder=C.URI.file(O),this.base=O):C.URI.isUri(O)?(this.baseFolder=O,this.base=O.fsPath):(this.baseFolder=O.uri,this.base=O.uri.fsPath),this.pattern=ee}};Bt=xe([k],Bt),e.RelativePattern=Bt;let zt=class{constructor(O,ee,ye,Ve){this.enabled=typeof O=="boolean"?O:!0,typeof ee=="string"&&(this.condition=ee),typeof ye=="string"&&(this.hitCondition=ye),typeof Ve=="string"&&(this.logMessage=Ve)}get id(){return this._id||(this._id=(0,A.generateUuid)()),this._id}};zt=xe([k],zt),e.Breakpoint=zt;let wt=class extends zt{constructor(O,ee,ye,Ve,nt){super(ee,ye,Ve,nt);if(O===null)throw(0,F.illegalArgument)("location");this.location=O}};wt=xe([k],wt),e.SourceBreakpoint=wt;let Qt=class extends zt{constructor(O,ee,ye,Ve,nt){super(ee,ye,Ve,nt);this.functionName=O}};Qt=xe([k],Qt),e.FunctionBreakpoint=Qt;let Vt=class extends zt{constructor(O,ee,ye,Ve,nt,at,ut){super(Ve,nt,at,ut);if(!ee)throw(0,F.illegalArgument)("dataId");this.label=O,this.dataId=ee,this.canPersist=ye}};Vt=xe([k],Vt),e.DataBreakpoint=Vt;let oi=class{constructor(O,ee,ye){this.command=O,this.args=ee||[],this.options=ye}};oi=xe([k],oi),e.DebugAdapterExecutable=oi;let si=class{constructor(O,ee){this.port=O,this.host=ee}};si=xe([k],si),e.DebugAdapterServer=si;let Rt=class{constructor(O){this.path=O}};Rt=xe([k],Rt),e.DebugAdapterNamedPipeServer=Rt;let Yt=class{constructor(O){this.implementation=O}};Yt=xe([k],Yt),e.DebugAdapterInlineImplementation=Yt;let ai=class{constructor(O,ee){this.range=O,this.expression=ee}};ai=xe([k],ai),e.EvaluatableExpression=ai;var Xt;(function(U){U[U.Automatic=0]="Automatic",U[U.Explicit=1]="Explicit"})(Xt=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let Wt=class{constructor(O,ee){this.range=O,this.text=ee}};Wt=xe([k],Wt),e.InlineValueText=Wt;let mt=class{constructor(O,ee,ye=!0){this.range=O,this.variableName=ee,this.caseSensitiveLookup=ye}};mt=xe([k],mt),e.InlineValueVariableLookup=mt;let ci=class{constructor(O,ee){this.range=O,this.expression=ee}};ci=xe([k],ci),e.InlineValueEvaluatableExpression=ci;let Ot=class{constructor(O,ee){this.frameId=O,this.stoppedLocation=ee}};Ot=xe([k],Ot),e.InlineValueContext=Ot;var jt;(function(U){U[U.Changed=1]="Changed",U[U.Created=2]="Created",U[U.Deleted=3]="Deleted"})(jt=e.FileChangeType||(e.FileChangeType={}));let Jt=a=class extends Error{constructor(O,ee=_.FileSystemProviderErrorCode.Unknown,ye){super(C.URI.isUri(O)?O.toString(!0):O);this.code=ye?.name??"Unknown",(0,_.markAsFileSystemProviderError)(this,ee),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,a.prototype),typeof Error.captureStackTrace=="function"&&typeof ye=="function"&&Error.captureStackTrace(this,ye)}static FileExists(O){return new a(O,_.FileSystemProviderErrorCode.FileExists,a.FileExists)}static FileNotFound(O){return new a(O,_.FileSystemProviderErrorCode.FileNotFound,a.FileNotFound)}static FileNotADirectory(O){return new a(O,_.FileSystemProviderErrorCode.FileNotADirectory,a.FileNotADirectory)}static FileIsADirectory(O){return new a(O,_.FileSystemProviderErrorCode.FileIsADirectory,a.FileIsADirectory)}static NoPermissions(O){return new a(O,_.FileSystemProviderErrorCode.NoPermissions,a.NoPermissions)}static Unavailable(O){return new a(O,_.FileSystemProviderErrorCode.Unavailable,a.Unavailable)}};Jt=a=xe([k],Jt),e.FileSystemError=Jt;let li=class{constructor(O,ee,ye){this.start=O,this.end=ee,this.kind=ye}};li=xe([k],li),e.FoldingRange=li;var fi;(function(U){U[U.Comment=1]="Comment",U[U.Imports=2]="Imports",U[U.Region=3]="Region"})(fi=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Ei;(function(U){U[U.Collapsed=0]="Collapsed",U[U.Expanded=1]="Expanded"})(Ei=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var mi;(function(U){U[U.Editing=0]="Editing",U[U.Preview=1]="Preview"})(mi=e.CommentMode||(e.CommentMode={}));class Zt{constructor(O,ee=[]){this.tokenTypes=O,this.tokenModifiers=ee}}e.SemanticTokensLegend=Zt;function _i(U){return typeof U=="undefined"||(0,S.isStringArray)(U)}class qt{constructor(O){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,O){this._hasLegend=!0;for(let ee=0,ye=O.tokenTypes.length;ee<ye;ee++)this._tokenTypeStrToInt.set(O.tokenTypes[ee],ee);for(let ee=0,ye=O.tokenModifiers.length;ee<ye;ee++)this._tokenModifierStrToInt.set(O.tokenModifiers[ee],ee)}}push(O,ee,ye,Ve,nt){if(typeof O=="number"&&typeof ee=="number"&&typeof ye=="number"&&typeof Ve=="number"&&(typeof nt=="number"||typeof nt=="undefined"))return typeof nt=="undefined"&&(nt=0),this._pushEncoded(O,ee,ye,Ve,nt);if(y.isRange(O)&&typeof ee=="string"&&_i(ye))return this._push(O,ee,ye);throw(0,F.illegalArgument)()}_push(O,ee,ye){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(O.start.line!==O.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(ee))throw new Error("`tokenType` is not in the provided legend");const Ve=O.start.line,nt=O.start.character,at=O.end.character-O.start.character,ut=this._tokenTypeStrToInt.get(ee);let kt=0;if(ye)for(const Mt of ye){if(!this._tokenModifierStrToInt.has(Mt))throw new Error("`tokenModifier` is not in the provided legend");const Nt=this._tokenModifierStrToInt.get(Mt);kt|=1<<Nt>>>0}this._pushEncoded(Ve,nt,at,ut,kt)}_pushEncoded(O,ee,ye,Ve,nt){if(this._dataIsSortedAndDeltaEncoded&&(O<this._prevLine||O===this._prevLine&&ee<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const kt=this._data.length/5|0;let Mt=0,Nt=0;for(let xt=0;xt<kt;xt++){let $t=this._data[5*xt],di=this._data[5*xt+1];$t===0?($t=Mt,di+=Nt):$t+=Mt,this._data[5*xt]=$t,this._data[5*xt+1]=di,Mt=$t,Nt=di}}let at=O,ut=ee;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(at-=this._prevLine,at===0&&(ut-=this._prevChar)),this._data[this._dataLen++]=at,this._data[this._dataLen++]=ut,this._data[this._dataLen++]=ye,this._data[this._dataLen++]=Ve,this._data[this._dataLen++]=nt,this._prevLine=O,this._prevChar=ee}static _sortAndDeltaEncode(O){let ee=[];const ye=O.length/5|0;for(let ut=0;ut<ye;ut++)ee[ut]=ut;ee.sort((ut,kt)=>{const Mt=O[5*ut],Nt=O[5*kt];if(Mt===Nt){const xt=O[5*ut+1],$t=O[5*kt+1];return xt-$t}return Mt-Nt});const Ve=new Uint32Array(O.length);let nt=0,at=0;for(let ut=0;ut<ye;ut++){const kt=5*ee[ut],Mt=O[kt+0],Nt=O[kt+1],xt=O[kt+2],$t=O[kt+3],di=O[kt+4],Hi=Mt-nt,Yi=Hi===0?Nt-at:Nt,hi=5*ut;Ve[hi+0]=Hi,Ve[hi+1]=Yi,Ve[hi+2]=xt,Ve[hi+3]=$t,Ve[hi+4]=di,nt=Mt,at=Nt}return Ve}build(O){return this._dataIsSortedAndDeltaEncoded?new Gt(new Uint32Array(this._data),O):new Gt(qt._sortAndDeltaEncode(this._data),O)}}e.SemanticTokensBuilder=qt;class Gt{constructor(O,ee){this.resultId=ee,this.data=O}}e.SemanticTokens=Gt;class yi{constructor(O,ee,ye){this.start=O,this.deleteCount=ee,this.data=ye}}e.SemanticTokensEdit=yi;class Si{constructor(O,ee){this.resultId=ee,this.edits=O}}e.SemanticTokensEdits=Si;var Kt;(function(U){U[U.Separate=0]="Separate",U[U.MergeWithParent=1]="MergeWithParent"})(Kt=e.DebugConsoleMode||(e.DebugConsoleMode={}));var Ci;(function(U){U[U.Initial=1]="Initial",U[U.Dynamic=2]="Dynamic"})(Ci=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let ei=class{constructor(){}};ei.Back={iconPath:new At("arrow-left")},ei=xe([k],ei),e.QuickInputButtons=ei;var Di;(function(U){U[U.Default=1]="Default",U[U.Separator=2]="Separator"})(Di=e.QuickPickItemKind||(e.QuickPickItemKind={}));var ki;(function(U){U[U.UI=1]="UI",U[U.Workspace=2]="Workspace"})(ki=e.ExtensionKind||(e.ExtensionKind={}));class ui{constructor(O,ee,ye){this.badge=O,this.tooltip=ee,this.color=ye}static validate(O){if(O.badge){let ee=(0,R.nextCharLength)(O.badge,0);if(ee<O.badge.length&&(ee+=(0,R.nextCharLength)(O.badge,ee)),O.badge.length>ee)throw new Error("The 'badge'-property must be undefined or a short character")}if(!O.color&&!O.badge&&!O.tooltip)throw new Error("The decoration is empty");return!0}}e.FileDecoration=ui;let ti=class{constructor(O){this.kind=O}};ti=xe([k],ti),e.ColorTheme=ti;var gi;(function(U){U[U.Light=1]="Light",U[U.Dark=2]="Dark",U[U.HighContrast=3]="HighContrast"})(gi=e.ColorThemeKind||(e.ColorThemeKind={}));class Re{constructor(O,ee){if(O<0)throw(0,F.illegalArgument)("start must be positive");if(ee<0)throw(0,F.illegalArgument)("end must be positive");O<=ee?(this._start=O,this._end=ee):(this._start=ee,this._end=O)}static isNotebookRange(O){return O instanceof Re?!0:O?typeof O.start=="number"&&typeof O.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(O){let ee=this._start,ye=this._end;return O.start!==void 0&&(ee=O.start),O.end!==void 0&&(ye=O.end),ee===this._start&&ye===this._end?this:new Re(ee,ye)}}e.NotebookRange=Re;class Lt{constructor(O,ee,ye,Ve,nt,at,ut){this.kind=O,this.value=ee,this.languageId=ye,this.mime=Ve,this.outputs=nt??[],this.metadata=at,this.executionSummary=ut,Lt.validate(this)}static validate(O){if(typeof O.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof O.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof O.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(O){return Array.isArray(O)&&O.every(ee=>Lt.isNotebookCellData(ee))}static isNotebookCellData(O){return!0}}e.NotebookCellData=Lt;class pi{constructor(O){this.cells=O}}e.NotebookData=pi;class ft{constructor(O,ee){this.data=O,this.mime=ee;const ye=(0,t.normalizeMimeType)(ee,!0);if(!ye)throw new Error(`INVALID mime type: ${ee}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=ye}static isNotebookCellOutputItem(O){return O instanceof ft?!0:O?typeof O.mime=="string"&&O.data instanceof Uint8Array:!1}static error(O){const ee={name:O.name,message:O.message,stack:O.stack};return ft.json(ee,"application/vnd.code.notebook.error")}static stdout(O){return ft.text(O,"application/vnd.code.notebook.stdout")}static stderr(O){return ft.text(O,"application/vnd.code.notebook.stderr")}static bytes(O,ee="application/octet-stream"){return new ft(O,ee)}static text(O,ee=t.Mimes.text){const ye=Ae(ft,l,"f",d).encode(String(O));return new ft(ye,ee)}static json(O,ee="application/json"){const ye=JSON.stringify(O,void 0,"	");return ft.text(ye,ee)}}e.NotebookCellOutputItem=ft,l=ft,d={value:new TextEncoder};class ii{constructor(O,ee,ye){this.items=ii.ensureUniqueMimeTypes(O,!0),typeof ee=="string"?(this.id=ee,this.metadata=ye):(this.id=(0,A.generateUuid)(),this.metadata=ee??ye)}static isNotebookCellOutput(O){return O instanceof ii?!0:!O||typeof O!="object"?!1:typeof O.id=="string"&&(0,S.isArray)(O.items)}static ensureUniqueMimeTypes(O,ee=!1){const ye=new Set,Ve=new Set;for(let nt=0;nt<O.length;nt++){const at=O[nt],ut=(0,t.normalizeMimeType)(at.mime);if(!ye.has(ut)){ye.add(ut);continue}Ve.add(nt),ee&&console.warn(`DUPLICATED mime type '${at.mime}' will be dropped`)}return Ve.size===0?O:O.filter((nt,at)=>!Ve.has(at))}}e.NotebookCellOutput=ii;var Ii;(function(U){U[U.Markup=1]="Markup",U[U.Code=2]="Code"})(Ii=e.NotebookCellKind||(e.NotebookCellKind={}));var vi;(function(U){U[U.Idle=1]="Idle",U[U.Pending=2]="Pending",U[U.Executing=3]="Executing"})(vi=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var bi;(function(U){U[U.Left=1]="Left",U[U.Right=2]="Right"})(bi=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var Pi;(function(U){U[U.Default=0]="Default",U[U.InCenter=1]="InCenter",U[U.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",U[U.AtTop=3]="AtTop"})(Pi=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class Ti{constructor(O,ee){this.text=O,this.alignment=ee}}e.NotebookCellStatusBarItem=Ti;var Ai;(function(U){U[U.Default=1]="Default",U[U.Preferred=2]="Preferred"})(Ai=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class Ri{constructor(O,ee=[]){this.uri=O,this.provides=(0,c.asArray)(ee)}}e.NotebookRendererScript=Ri;let ni=class{constructor(O,ee){this.label=O,this.timestamp=ee}};ni=xe([k],ni),e.TimelineItem=ni;var Fi;(function(U){U[U.Production=1]="Production",U[U.Development=2]="Development",U[U.Test=3]="Test"})(Fi=e.ExtensionMode||(e.ExtensionMode={}));var Mi;(function(U){U[U.Node=1]="Node",U[U.Webworker=2]="Webworker"})(Mi=e.ExtensionRuntime||(e.ExtensionRuntime={}));var Oi;(function(U){U[U.Other=0]="Other",U[U.Comment=1]="Comment",U[U.String=2]="String",U[U.RegEx=4]="RegEx"})(Oi=e.StandardTokenType||(e.StandardTokenType={}));class Li{constructor(O,ee){this.ranges=O,this.wordPattern=ee}}e.LinkedEditingRanges=Li;class Ni{constructor(O,ee){this._port=O,this._autoForwardAction=ee}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=Ni;var Y;(function(U){U[U.Queued=1]="Queued",U[U.Running=2]="Running",U[U.Passed=3]="Passed",U[U.Failed=4]="Failed",U[U.Skipped=5]="Skipped",U[U.Errored=6]="Errored"})(Y=e.TestResultState||(e.TestResultState={}));var le;(function(U){U[U.Run=1]="Run",U[U.Debug=2]="Debug",U[U.Coverage=3]="Coverage"})(le=e.TestRunProfileKind||(e.TestRunProfileKind={}));let Ce=class{constructor(O=void 0,ee=void 0,ye=void 0){this.include=O,this.exclude=ee,this.profile=ye}};Ce=xe([k],Ce),e.TestRunRequest=Ce;let ct=E=class{constructor(O){this.message=O}static diff(O,ee,ye){const Ve=new E(O);return Ve.expectedOutput=ee,Ve.actualOutput=ye,Ve}};ct=E=xe([k],ct),e.TestMessage=ct;let St=class{constructor(O){this.id=O}};St=xe([k],St),e.TestTag=St;let Dt=class{constructor(O,ee){this.covered=O,this.total=ee}};Dt=xe([k],Dt),e.CoveredCount=Dt;let xi=P=class{constructor(O,ee,ye,Ve){this.uri=O,this.statementCoverage=ee,this.branchCoverage=ye,this.functionCoverage=Ve}static fromDetails(O,ee){const ye=new Dt(0,0),Ve=new Dt(0,0),nt=new Dt(0,0);for(const ut of ee)if("branches"in ut){ye.total+=1,ye.covered+=ut.executionCount>0?1:0;for(const kt of ut.branches)Ve.total+=1,Ve.covered+=kt.executionCount>0?1:0}else nt.total+=1,nt.covered+=ut.executionCount>0?1:0;const at=new P(O,ye,Ve.total>0?Ve:void 0,nt.total>0?nt:void 0);return at.detailedCoverage=ee,at}};xi=P=xe([k],xi),e.FileCoverage=xi;let Ui=class{constructor(O,ee,ye=[]){this.executionCount=O,this.location=ee,this.branches=ye}};Ui=xe([k],Ui),e.StatementCoverage=Ui;let Bi=class{constructor(O,ee){this.executionCount=O,this.location=ee}};Bi=xe([k],Bi),e.BranchCoverage=Bi;let $i=class{constructor(O,ee){this.executionCount=O,this.location=ee}};$i=xe([k],$i),e.FunctionCoverage=$i;var qi;(function(U){U[U.None=0]="None",U[U.Option=1]="Option",U[U.Default=2]="Default",U[U.Preferred=3]="Preferred"})(qi=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var Gi;(function(U){U[U.Untrusted=0]="Untrusted",U[U.Trusted=1]="Trusted",U[U.Unspecified=2]="Unspecified"})(Gi=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var Ki;(function(U){U[U.Notify=1]="Notify",U[U.OpenBrowser=2]="OpenBrowser",U[U.OpenPreview=3]="OpenPreview",U[U.Silent=4]="Silent",U[U.Ignore=5]="Ignore",U[U.OpenBrowserOnce=6]="OpenBrowserOnce"})(Ki=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class Qi{constructor(O,ee,ye,Ve,nt,at){this.kind=O,this.name=ee,this.detail=ye,this.uri=Ve,this.range=nt,this.selectionRange=at}}e.TypeHierarchyItem=Qi}),define(Ee[86],_e([0,1,41,10,9,223,114,7,16]),function(oe,e,c,F,w,I,t,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const C=new Map;function A(s,l){l?C.set(s,l):C.delete(s)}e.setWordDefinitionFor=A;function _(s){return C.get(s)}e.getWordDefinitionFor=_;class n extends I.MirrorTextModel{constructor(l,d,D,v,f,g,T,u){super(d,D,v,f);this._proxy=l,this._languageId=g,this._isDirty=T,this._notebook=u,this._isDisposed=!1}dispose(){(0,c.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(l){return(0,S.equals)(this._lines,l)}get document(){if(!this._document){const l=this;this._document={get uri(){return l._uri},get fileName(){return l._uri.fsPath},get isUntitled(){return l._uri.scheme===F.Schemas.untitled},get languageId(){return l._languageId},get version(){return l._versionId},get isClosed(){return l._isDisposed},get isDirty(){return l._isDirty},get notebook(){return l._notebook},save(){return l._save()},getText(d){return d?l._getTextInRange(d):l.getText()},get eol(){return l._eol===`
`?R.EndOfLine.LF:R.EndOfLine.CRLF},get lineCount(){return l._lines.length},lineAt(d){return l._lineAt(d)},offsetAt(d){return l._offsetAt(d)},positionAt(d){return l._positionAt(d)},validateRange(d){return l._validateRange(d)},validatePosition(d){return l._validatePosition(d)},getWordRangeAtPosition(d,D){return l._getWordRangeAtPosition(d,D)}}}return Object.freeze(this._document)}_acceptLanguageId(l){(0,c.ok)(!this._isDisposed),this._languageId=l}_acceptIsDirty(l){(0,c.ok)(!this._isDisposed),this._isDirty=l}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(l){const d=this._validateRange(l);if(d.isEmpty)return"";if(d.isSingleLine)return this._lines[d.start.line].substring(d.start.character,d.end.character);const D=this._eol,v=d.start.line,f=d.end.line,g=[];g.push(this._lines[v].substring(d.start.character));for(let T=v+1;T<f;T++)g.push(this._lines[T]);return g.push(this._lines[f].substring(0,d.end.character)),g.join(D)}_lineAt(l){let d;if(l instanceof R.Position?d=l.line:typeof l=="number"&&(d=l),typeof d!="number"||d<0||d>=this._lines.length||Math.floor(d)!==d)throw new Error("Illegal value for `line`");return new h(d,this._lines[d],d===this._lines.length-1)}_offsetAt(l){return l=this._validatePosition(l),this._ensureLineStarts(),this._lineStarts.getPrefixSum(l.line-1)+l.character}_positionAt(l){l=Math.floor(l),l=Math.max(0,l),this._ensureLineStarts();const d=this._lineStarts.getIndexOf(l),D=this._lines[d.index].length;return new R.Position(d.index,Math.min(d.remainder,D))}_validateRange(l){if(!(l instanceof R.Range))throw new Error("Invalid argument");const d=this._validatePosition(l.start),D=this._validatePosition(l.end);return d===l.start&&D===l.end?l:new R.Range(d.line,d.character,D.line,D.character)}_validatePosition(l){if(!(l instanceof R.Position))throw new Error("Invalid argument");if(this._lines.length===0)return l.with(0,0);let{line:d,character:D}=l,v=!1;if(d<0)d=0,D=0,v=!0;else if(d>=this._lines.length)d=this._lines.length-1,D=this._lines[d].length,v=!0;else{const f=this._lines[d].length;D<0?(D=0,v=!0):D>f&&(D=f,v=!0)}return v?new R.Position(d,D):l}_getWordRangeAtPosition(l,d){const D=this._validatePosition(l);if(!d)d=_(this._languageId);else if((0,w.regExpLeadsToEndlessLoop)(d))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${d.source}' because it matches the empty string.`);const v=(0,t.getWordAtText)(D.character+1,(0,t.ensureValidWordDefinition)(d),this._lines[D.line],0);if(v)return new R.Range(D.line,v.startColumn-1,D.line,v.endColumn-1)}}e.ExtHostDocumentData=n;class h{constructor(l,d,D){this._line=l,this._text=d,this._isLastLine=D}get lineNumber(){return this._line}get text(){return this._text}get range(){return new R.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new R.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=h}),define(Ee[150],_e([0,1,7,3,224,6,55,21,2,35]),function(oe,e,c,F,w,I,t,R,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class A{constructor(n,h,s,l){this._notebook=s,this._selector=l,this._disposables=new I.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new F.Emitter,this.onDidChange=this._onDidChange.event,this.uri=S.URI.from({scheme:"vscode-concat-doc",path:(0,C.generateUuid)()}),this._init(),this._disposables.add(h.onDidChangeDocument(D=>{const v=this._cellUris.get(D.document.uri);v!==void 0&&(this._cellLengths.setValue(v,this._cells[v].document.getText().length+1),this._cellLines.setValue(v,this._cells[v].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const d=D=>{D===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(n.onDidChangeNotebookCells(D=>d(D.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new R.ResourceMap;const n=[],h=[];for(const s of this._notebook.getCells())s.kind===c.NotebookCellKind.Code&&(!this._selector||(0,t.score)(this._selector,s.document.uri,s.document.languageId,!0))&&(this._cellUris.set(s.document.uri,this._cells.length),this._cells.push(s),n.push(s.document.getText().length+1),h.push(s.document.lineCount));this._cellLengths=new w.PrefixSumComputer(new Uint32Array(n)),this._cellLines=new w.PrefixSumComputer(new Uint32Array(h))}get version(){return this._versionId}getText(n){if(!n){let v="";for(const f of this._cells)v+=f.document.getText()+`
`;return v=v.slice(0,-1),v}if(n.isEmpty)return"";const h=this.locationAt(n.start),s=this.locationAt(n.end),l=this._cellUris.get(h.uri),d=this._cellUris.get(s.uri);if(l===void 0||d===void 0)return"";if(l===d)return this._cells[l].document.getText(new c.Range(h.range.start,s.range.end));const D=[this._cells[l].document.getText(new c.Range(h.range.start,new c.Position(this._cells[l].document.lineCount,0)))];for(let v=l+1;v<d;v++)D.push(this._cells[v].document.getText());return D.push(this._cells[d].document.getText(new c.Range(new c.Position(0,0),s.range.end))),D.join(`
`)}offsetAt(n){const h=this._cellLines.getIndexOf(n.line),s=this._cellLengths.getPrefixSum(h.index-1),l=this._cells[h.index].document.offsetAt(n.with(h.remainder));return s+l}positionAt(n){if(typeof n=="number"){const s=this._cellLengths.getIndexOf(n),l=this._cellLines.getPrefixSum(s.index-1);return this._cells[s.index].document.positionAt(s.remainder).translate(l)}const h=this._cellUris.get(n.uri);if(h!==void 0){const s=this._cellLines.getPrefixSum(h-1);return new c.Position(s+n.range.start.line,n.range.start.character)}return new c.Position(0,0)}locationAt(n){c.Range.isRange(n)||(n=new c.Range(n,n));const h=this._cellLines.getIndexOf(n.start.line);let s=h;n.isEmpty||(s=this._cellLines.getIndexOf(n.end.line));const l=new c.Position(h.remainder,n.start.character),d=new c.Position(s.remainder,n.end.character),D=new c.Range(l,d),v=this._cells[h.index];return new c.Location(v.document.uri,v.document.validateRange(D))}contains(n){return this._cellUris.has(n)}validateRange(n){const h=this.validatePosition(n.start),s=this.validatePosition(n.end);return n.with(h,s)}validatePosition(n){const h=this._cellLines.getIndexOf(n.line),s=new c.Position(h.remainder,n.character),l=this._cells[h.index].document.validatePosition(s),d=this._cellLines.getPrefixSum(h.index-1);return new c.Position(d+l.line,l.character)}}e.ExtHostNotebookConcatDocument=A}),define(Ee[151],_e([0,1,7,13,3]),function(oe,e,c,F,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let I=class{constructor(R){this._actual=new c.ColorTheme(c.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new w.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(R){let S=R==="light"?c.ColorThemeKind.Light:R==="dark"?c.ColorThemeKind.Dark:c.ColorThemeKind.HighContrast;this._actual=new c.ColorTheme(S),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};I=xe([$e(0,F.IExtHostRpcService)],I),e.ExtHostTheming=I}),define(Ee[65],_e([0,1,4]),function(oe,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,c.createDecorator)("IURITransformerService");class F{constructor(I){I?(this.transformIncoming=I.transformIncoming.bind(I),this.transformOutgoing=I.transformOutgoing.bind(I),this.transformOutgoingURI=I.transformOutgoingURI.bind(I),this.transformOutgoingScheme=I.transformOutgoingScheme.bind(I)):(this.transformIncoming=t=>t,this.transformOutgoing=t=>t,this.transformOutgoingURI=t=>t,this.transformOutgoingScheme=t=>t)}}e.URITransformerService=F}),define(Ee[152],_e([0,1,22]),function(oe,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class F{constructor(){this.buffers=[]}add(S){let C=this.buffers.indexOf(S);return C<0&&(C=this.buffers.length,this.buffers.push(S)),C}}function w(R,S){if(S.serializeBuffersForPostMessage){const C=new F,A=(h,s)=>{if(s instanceof ArrayBuffer){const l=C.add(s);return{$$vscode_array_buffer_reference$$:!0,index:l}}else if(ArrayBuffer.isView(s)){const l=I(s);if(l){const d=C.add(s.buffer);return{$$vscode_array_buffer_reference$$:!0,index:d,view:{type:l,byteLength:s.byteLength,byteOffset:s.byteOffset}}}}return s},_=JSON.stringify(R,A),n=C.buffers.map(h=>{const s=new Uint8Array(h);return c.VSBuffer.wrap(s)});return{message:_,buffers:n}}else return{message:JSON.stringify(R),buffers:[]}}e.serializeWebviewMessage=w;function I(R){switch(R.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function t(R,S){const C=S.map(n=>{const h=new ArrayBuffer(n.byteLength);return new Uint8Array(h).set(n.buffer),h}),A=S.length?(n,h)=>{if(typeof h=="object"&&h.$$vscode_array_buffer_reference$$){const s=h,{index:l}=s,d=C[l];if(s.view)switch(s.view.type){case 1:return new Int8Array(d,s.view.byteOffset,s.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(d,s.view.byteOffset,s.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(d,s.view.byteOffset,s.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(d,s.view.byteOffset,s.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(d,s.view.byteOffset,s.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(d,s.view.byteOffset,s.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(d,s.view.byteOffset,s.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(d,s.view.byteOffset,s.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(d,s.view.byteOffset,s.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(d,s.view.byteOffset,s.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(d,s.view.byteOffset,s.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return d}return h}:void 0;return{message:JSON.parse(R,A),arrayBuffers:C}}e.deserializeWebviewMessage=t}),define(Ee[153],_e([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeDataTransferConverter=void 0;var c;(function(F){function w(t){const R=new Map;return t.types.forEach((S,C)=>{R.set(S,{asString:async()=>t.items[C].asString})}),R}F.toITreeDataTransfer=w;async function I(t){const R={types:[],items:[]},S=Array.from(t.entries());for(const C of S)R.types.push(C[0]),R.items.push({asString:await C[1].asString()});return R}F.toTreeDataTransferDTO=I})(c=e.TreeDataTransferConverter||(e.TreeDataTransferConverter={}))}),define(Ee[66],_e([0,1,10,2]),function(oe,e,c,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-webview.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`https://*.${e.webviewResourceBaseHost}`;function w(R,S){return R.scheme===c.Schemas.http||R.scheme===c.Schemas.https?R:(S&&S.authority&&S.isRemote&&R.scheme===c.Schemas.file&&(R=F.URI.from({scheme:c.Schemas.vscodeRemote,authority:S.authority,path:R.path})),F.URI.from({scheme:c.Schemas.https,authority:`${R.scheme}+${I(R.authority)}.${e.webviewRootResourceAuthority}`,path:R.path,fragment:R.fragment,query:R.query}))}e.asWebviewUri=w;function I(R){return R.replace(/./g,S=>{const C=S.charCodeAt(0);return C>=97&&C<=122||C>=65&&C<=90||C>=48&&C<=57?S:"-"+C.toString(16).padStart(4,"0")})}function t(R){return R.replace(/-([0-9a-f]{4})/g,(S,C)=>String.fromCharCode(parseInt(C,16)))}e.decodeAuthority=t}),define(Ee[154],_e([0,1,3,6,66]),function(oe,e,c,F,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class I{constructor(R,S,C){this._proxy=R,this._editors=S,this._initData=C,this._handlePool=0,this._disposables=new F.DisposableStore,this._insets=new Map,this._disposables.add(S.onDidChangeVisibleTextEditors(()=>{const A=S.getVisibleTextEditors();for(const _ of this._insets.values())A.indexOf(_.editor)<0&&_.inset.dispose()}))}dispose(){this._insets.forEach(R=>R.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(R,S,C,A,_){let n;for(const f of this._editors.getVisibleTextEditors(!0))if(f.value===R){n=f;break}if(!n)throw new Error("not a visible editor");const h=this,s=this._handlePool++,l=new c.Emitter,d=new c.Emitter,D=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(f){return(0,w.asWebviewUri)(f,h._initData.remote)}get cspSource(){return w.webviewGenericCspSource}set options(f){this._options=f,h._proxy.$setOptions(s,f)}get options(){return this._options}set html(f){this._html=f,h._proxy.$setHtml(s,f)}get html(){return this._html}get onDidReceiveMessage(){return l.event}postMessage(f){return h._proxy.$postMessage(s,f)}},v=new class{constructor(){this.editor=R,this.line=S,this.height=C,this.webview=D,this.onDidDispose=d.event}dispose(){h._insets.has(s)&&(h._insets.delete(s),h._proxy.$disposeEditorInset(s),d.fire(),d.dispose(),l.dispose())}};return this._proxy.$createEditorInset(s,n.id,n.value.document.uri,S+1,C,A||{},_.identifier,_.extensionLocation),this._insets.set(s,{editor:R,inset:v,onDidReceiveMessage:l}),v}$onDidDispose(R){const S=this._insets.get(R);S&&S.inset.dispose()}$onDidReceiveMessage(R,S){const C=this._insets.get(R);C&&C.onDidReceiveMessage.fire(S)}}e.ExtHostEditorInsets=I}),define(Ee[155],_e([0,1,126,11,2,6,4,45,36,46,16,10]),function(oe,e,c,F,w,I,t,R,S,C,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveReason=e.Verbosity=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.EditorAreaVisibleContext=e.SplitEditorsVertically=e.IsCenteredLayoutContext=e.InEditorZenModeContext=e.EditorsVisibleContext=e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext=e.ActiveEditorGroupLockedContext=e.ActiveEditorGroupLastContext=e.ActiveEditorGroupIndexContext=e.ActiveEditorGroupEmptyContext=e.EditorGroupEditorsCountContext=e.SideBySideEditorActiveContext=e.TextCompareEditorActiveContext=e.TextCompareEditorVisibleContext=e.ActiveEditorAvailableEditorIdsContext=e.ActiveEditorContext=e.ActiveEditorCanSplitInGroupContext=e.ActiveEditorCanRevertContext=e.ActiveEditorReadonlyContext=e.ActiveEditorStickyContext=e.ActiveEditorPinnedContext=e.ActiveEditorDirtyContext=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,c.localize)(0,null),providerDisplayName:(0,c.localize)(1,null)},e.ActiveEditorDirtyContext=new R.RawContextKey("activeEditorIsDirty",!1,(0,c.localize)(2,null)),e.ActiveEditorPinnedContext=new R.RawContextKey("activeEditorIsNotPreview",!1,(0,c.localize)(3,null)),e.ActiveEditorStickyContext=new R.RawContextKey("activeEditorIsPinned",!1,(0,c.localize)(4,null)),e.ActiveEditorReadonlyContext=new R.RawContextKey("activeEditorIsReadonly",!1,(0,c.localize)(5,null)),e.ActiveEditorCanRevertContext=new R.RawContextKey("activeEditorCanRevert",!1,(0,c.localize)(6,null)),e.ActiveEditorCanSplitInGroupContext=new R.RawContextKey("activeEditorCanSplitInGroup",!0),e.ActiveEditorContext=new R.RawContextKey("activeEditor",null,{type:"string",description:(0,c.localize)(7,null)}),e.ActiveEditorAvailableEditorIdsContext=new R.RawContextKey("activeEditorAvailableEditorIds","",(0,c.localize)(8,null)),e.TextCompareEditorVisibleContext=new R.RawContextKey("textCompareEditorVisible",!1,(0,c.localize)(9,null)),e.TextCompareEditorActiveContext=new R.RawContextKey("textCompareEditorActive",!1,(0,c.localize)(10,null)),e.SideBySideEditorActiveContext=new R.RawContextKey("sideBySideEditorActive",!1,(0,c.localize)(11,null)),e.EditorGroupEditorsCountContext=new R.RawContextKey("groupEditorsCount",0,(0,c.localize)(12,null)),e.ActiveEditorGroupEmptyContext=new R.RawContextKey("activeEditorGroupEmpty",!1,(0,c.localize)(13,null)),e.ActiveEditorGroupIndexContext=new R.RawContextKey("activeEditorGroupIndex",0,(0,c.localize)(14,null)),e.ActiveEditorGroupLastContext=new R.RawContextKey("activeEditorGroupLast",!1,(0,c.localize)(15,null)),e.ActiveEditorGroupLockedContext=new R.RawContextKey("activeEditorGroupLocked",!1,(0,c.localize)(16,null)),e.MultipleEditorGroupsContext=new R.RawContextKey("multipleEditorGroups",!1,(0,c.localize)(17,null)),e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext.toNegated(),e.EditorsVisibleContext=new R.RawContextKey("editorIsOpen",!1,(0,c.localize)(18,null)),e.InEditorZenModeContext=new R.RawContextKey("inZenMode",!1,(0,c.localize)(19,null)),e.IsCenteredLayoutContext=new R.RawContextKey("isCenteredLayout",!1,(0,c.localize)(20,null)),e.SplitEditorsVertically=new R.RawContextKey("splitEditorsVertically",!1,(0,c.localize)(21,null)),e.EditorAreaVisibleContext=new R.RawContextKey("editorAreaVisible",!0,(0,c.localize)(22,null)),e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";function n(L,y,x){for(const N of x.visibleEditorPanes)if(N.group.id===y&&L.matches(N.input))return N.getViewState()}e.findViewStateForEditor=n;function h(L){if(T(L))return!1;const y=L;return w.URI.isUri(y?.resource)}e.isResourceEditorInput=h;function s(L){if(T(L))return!1;const y=L;return y?.original!==void 0&&y.modified!==void 0}e.isResourceDiffEditorInput=s;function l(L){if(T(L)||s(L))return!1;const y=L;return y?.primary!==void 0&&y.secondary!==void 0}e.isResourceSideBySideEditorInput=l;function d(L){if(T(L))return!1;const y=L;return y?y.resource===void 0||y.resource.scheme===_.Schemas.untitled||y.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=d;var D;(function(L){L[L.SHORT=0]="SHORT",L[L.MEDIUM=1]="MEDIUM",L[L.LONG=2]="LONG"})(D=e.Verbosity||(e.Verbosity={}));var v;(function(L){L[L.EXPLICIT=1]="EXPLICIT",L[L.AUTO=2]="AUTO",L[L.FOCUS_CHANGE=3]="FOCUS_CHANGE",L[L.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(v=e.SaveReason||(e.SaveReason={}));var f;(function(L){L[L.None=0]="None",L[L.Readonly=2]="Readonly",L[L.Untitled=4]="Untitled",L[L.Singleton=8]="Singleton",L[L.RequiresTrust=16]="RequiresTrust",L[L.CanSplitInGroup=32]="CanSplitInGroup",L[L.ForceDescription=64]="ForceDescription"})(f=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class g extends I.Disposable{}e.AbstractEditorInput=g;function T(L){return L instanceof g}e.isEditorInput=T;function u(L){const y=L;return w.URI.isUri(y?.preferredResource)}function M(L){const y=L;return T(y?.primary)&&T(y?.secondary)}e.isSideBySideEditorInput=M;function r(L){const y=L;return T(y?.modified)&&T(y?.original)}e.isDiffEditorInput=r;function i(L){return T(L?.editor)}e.isEditorInputWithOptions=i;function p(L){const y=L;return i(L)&&y?.group!==void 0}e.isEditorInputWithOptionsAndGroup=p;function m(L){const y=L;return typeof y?.groupId=="number"&&T(y.editor)}e.isEditorIdentifier=m;var o;(function(L){L[L.UNKNOWN=0]="UNKNOWN",L[L.REPLACE=1]="REPLACE",L[L.MOVE=2]="MOVE",L[L.UNPIN=3]="UNPIN"})(o=e.EditorCloseContext||(e.EditorCloseContext={}));var b;(function(L){L[L.PRIMARY=1]="PRIMARY",L[L.SECONDARY=2]="SECONDARY",L[L.BOTH=3]="BOTH",L[L.ANY=4]="ANY"})(b=e.SideBySideEditor||(e.SideBySideEditor={}));class a{getOriginalUri(y,x){if(!y)return;if(x?.supportSideBySide){const{primary:z,secondary:H}=this.getSideEditors(y);if(z&&H){if(x?.supportSideBySide===b.BOTH)return{primary:this.getOriginalUri(z,{filterByScheme:x.filterByScheme}),secondary:this.getOriginalUri(H,{filterByScheme:x.filterByScheme})};if(x?.supportSideBySide===b.ANY)return this.getOriginalUri(z,{filterByScheme:x.filterByScheme})??this.getOriginalUri(H,{filterByScheme:x.filterByScheme});y=x.supportSideBySide===b.PRIMARY?z:H}}if(s(y)||l(y))return;const N=u(y)?y.preferredResource:y.resource;return!N||!x||!x.filterByScheme?N:this.filterUri(N,x.filterByScheme)}getSideEditors(y){return M(y)||l(y)?{primary:y.primary,secondary:y.secondary}:r(y)||s(y)?{primary:y.modified,secondary:y.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(y,x){if(!y)return;if(x?.supportSideBySide){const{primary:z,secondary:H}=this.getSideEditors(y);if(z&&H){if(x?.supportSideBySide===b.BOTH)return{primary:this.getCanonicalUri(z,{filterByScheme:x.filterByScheme}),secondary:this.getCanonicalUri(H,{filterByScheme:x.filterByScheme})};if(x?.supportSideBySide===b.ANY)return this.getCanonicalUri(z,{filterByScheme:x.filterByScheme})??this.getCanonicalUri(H,{filterByScheme:x.filterByScheme});y=x.supportSideBySide===b.PRIMARY?z:H}}if(s(y)||l(y))return;const N=y.resource;return!N||!x||!x.filterByScheme?N:this.filterUri(N,x.filterByScheme)}filterUri(y,x){if(Array.isArray(x)){if(x.some(N=>y.scheme===N))return y}else if(x===y.scheme)return y}}e.EditorResourceAccessor=new a;var E;(function(L){L[L.LEFT=0]="LEFT",L[L.RIGHT=1]="RIGHT"})(E=e.CloseDirection||(e.CloseDirection={}));class P{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(y){const x=this.instantiationService=y.get(t.IInstantiationService);for(const[N,z]of this.editorSerializerConstructors)this.createEditorSerializer(N,z,x);this.editorSerializerConstructors.clear()}createEditorSerializer(y,x,N){const z=N.createInstance(x);this.editorSerializerInstances.set(y,z)}registerFileEditorFactory(y){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=y}getFileEditorFactory(){return(0,F.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(y,x){if(this.editorSerializerConstructors.has(y)||this.editorSerializerInstances.has(y))throw new Error(`A editor serializer with type ID '${y}' was already registered.`);return this.instantiationService?this.createEditorSerializer(y,x,this.instantiationService):this.editorSerializerConstructors.set(y,x),(0,I.toDisposable)(()=>{this.editorSerializerConstructors.delete(y),this.editorSerializerInstances.delete(y)})}getEditorSerializer(y){return this.editorSerializerInstances.get(typeof y=="string"?y:y.typeId)}}S.Registry.add(e.EditorExtensions.EditorFactory,new P);async function k(L,y){if(!L||!L.length)return[];const x=await Promise.all(L.map(async N=>{const z=w.URI.revive(N.fileUri);if(!z||!await y.canHandleResource(z))return;let q=N.exists,ue=N.type;if(typeof q!="boolean"||typeof ue!="number")try{ue=(await y.resolve(z)).isFile?C.FileType.File:C.FileType.Unknown,q=!0}catch{q=!1}if(!q&&N.openOnlyIfExists||ue!==C.FileType.File)return;const K={selection:q?N.selection:void 0,pinned:!0,override:N.editorOverrideId};let ce;return q?ce={resource:z,options:K}:ce={resource:z,options:K,forceUntitled:!0},ce}));return(0,A.coalesce)(x)}e.pathsToEditors=k;var B;(function(L){L[L.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",L[L.SEQUENTIAL=1]="SEQUENTIAL"})(B=e.EditorsOrder||(e.EditorsOrder={}))}),define(Ee[156],_e([0,1,3,14,127]),function(oe,e,c,F,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class I{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new c.Emitter,this._onExit=new c.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(R){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=R}onEvent(R){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=R}onRequest(R){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=R}sendResponse(R){R.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${R.command}`)):this.internalSend("response",R)}sendRequest(R,S,C,A){const _={command:R};if(S&&Object.keys(S).length>0&&(_.arguments=S),this.internalSend("request",_),typeof A=="number"){const n=setTimeout(()=>{clearTimeout(n);const h=this.pendingRequests.get(_.seq);if(h){this.pendingRequests.delete(_.seq);const s={type:"response",seq:0,request_seq:_.seq,success:!1,command:R,message:(0,w.localize)(0,null,A,R)};h(s)}},A)}return C&&this.pendingRequests.set(_.seq,C),_.seq}acceptMessage(R){this.messageCallback?this.messageCallback(R):(this.queue.push(R),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(R,S){return R.type!=="event"||S.type!=="event"}async processQueue(){let R;for(;this.queue.length;){if((!R||this.needsTaskBoundaryBetween(this.queue[0],R))&&await(0,F.timeout)(0),R=this.queue.shift(),!R)return;switch(R.type){case"event":this.eventCallback&&this.eventCallback(R);break;case"request":this.requestCallback&&this.requestCallback(R);break;case"response":const S=R,C=this.pendingRequests.get(S.request_seq);C&&(this.pendingRequests.delete(S.request_seq),C(S));break}}}internalSend(R,S){S.type=R,S.seq=this.sequence++,this.sendMessage(S)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const R=new Map;this.pendingRequests.forEach((S,C)=>R.set(C,S)),await(0,F.timeout)(500),R.forEach((S,C)=>{S({type:"response",seq:0,request_seq:C,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(C)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=I}),define(Ee[157],_e([0,1,9,2,17,27,10]),function(oe,e,c,F,w,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const R=/{([^}]+)}/g;function S(r,i,p){return r.replace(R,function(m,o){return i&&o.length>0&&o[0]!=="_"?m:p&&p.hasOwnProperty(o)?p[o]:m})}e.formatPII=S;function C(r){const i={};for(const p of Object.keys(r))p.startsWith("!")||(i[p]=r[p]);return i}e.filterExceptionsFromTelemetry=C;function A(r){return r.configuration.request==="attach"&&!_(r)&&(!r.parentSession||A(r.parentSession))}e.isSessionAttach=A;function _(r){let i=r.configuration.type;if(!!i)return i==="vslsShare"&&(i=r.configuration.adapterProxy.configuration.type),(0,c.equalsIgnoreCase)(i,"extensionhost")||(0,c.equalsIgnoreCase)(i,"pwa-extensionhost")?r:r.parentSession?_(r.parentSession):void 0}e.getExtensionHostDebugSession=_;function n(r){return r.type&&(r.label||r.program||r.runtime)}e.isDebuggerMainContribution=n;function h(r,i,p){let m,o=0,b=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g,a=null;for(;a=b.exec(r);){let E=a.index+1,P=E+a[0].length;if(E<=i&&P>=p){m=a[0],o=E;break}}if(m){let E=/\w+/g,P=null;for(;(P=E.exec(m))&&!(P.index+1+o+P[0].length>=p););P&&(m=m.substring(0,E.lastIndex))}return m?{start:o,end:o+m.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=h;const s=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function l(r){return!!(r&&r.match(s))}e.isUri=l;function d(r){if(typeof r.path=="string"&&!(typeof r.sourceReference=="number"&&r.sourceReference>0)){if(l(r.path))return F.URI.parse(r.path);if((0,w.isAbsolute)(r.path))return F.URI.file(r.path)}return r.path}function D(r){if(typeof r.path=="object"){const i=F.URI.revive(r.path);if(i)return i.scheme===t.Schemas.file?i.fsPath:i.toString()}return r.path}function v(r,i){const p=i?d:D,m=(0,I.deepClone)(r);return g(m,(o,b)=>{o&&b&&(b.path=p(b))}),m}e.convertToDAPaths=v;function f(r,i){const p=i?d:D,m=(0,I.deepClone)(r);return g(m,(o,b)=>{!o&&b&&(b.path=p(b))}),m}e.convertToVSCPaths=f;function g(r,i){switch(r.type){case"event":const p=r;switch(p.event){case"output":i(!1,p.body.source);break;case"loadedSource":i(!1,p.body.source);break;case"breakpoint":i(!1,p.body.breakpoint.source);break;default:break}break;case"request":const m=r;switch(m.command){case"setBreakpoints":i(!0,m.arguments.source);break;case"breakpointLocations":i(!0,m.arguments.source);break;case"source":i(!0,m.arguments.source);break;case"gotoTargets":i(!0,m.arguments.source);break;case"launchVSCode":m.arguments.args.forEach(b=>i(!1,b));break;default:break}break;case"response":const o=r;if(o.success&&o.body)switch(o.command){case"stackTrace":o.body.stackFrames.forEach(b=>i(!1,b.source));break;case"loadedSources":o.body.sources.forEach(b=>i(!1,b));break;case"scopes":o.body.scopes.forEach(b=>i(!1,b.source));break;case"setFunctionBreakpoints":o.body.breakpoints.forEach(b=>i(!1,b.source));break;case"setBreakpoints":o.body.breakpoints.forEach(b=>i(!1,b.source));break;default:break}break}}function T(r){return r.filter(i=>!i.presentation?.hidden).sort((i,p)=>i.presentation?p.presentation?i.presentation.group?p.presentation.group?i.presentation.group!==p.presentation.group?i.presentation.group.localeCompare(p.presentation.group):u(i.presentation.order,p.presentation.order):-1:p.presentation.group?1:u(i.presentation.order,p.presentation.order):-1:p.presentation?1:0)}e.getVisibleAndSorted=T;function u(r,i){return typeof r!="number"?typeof i!="number"?0:1:typeof i!="number"?-1:r-i}async function M(r,i){const p=r.getValue("debug.saveBeforeStart",{overrideIdentifier:i.activeTextEditorMode});if(p!=="none"&&(await i.saveAll(),p==="allEditorsInActiveGroup")){const m=i.activeEditorPane;m&&await i.save({editor:m.input,groupId:m.group.id})}await r.reloadConfiguration()}e.saveAllBeforeDebugStart=M}),define(Ee[87],_e([0,1,29,158,78,10,17,23,45]),function(oe,e,c,F,w,I,t,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var C;(function(E){E[E.Markup=1]="Markup",E[E.Code=2]="Code"})(C=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",w.Mimes.latex,w.Mimes.markdown,"image/png","image/jpeg",w.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[w.Mimes.latex,w.Mimes.markdown,"application/json",w.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var A;(function(E){E[E.Running=1]="Running",E[E.Idle=2]="Idle"})(A=e.NotebookRunState||(e.NotebookRunState={}));var _;(function(E){E[E.Pending=2]="Pending",E[E.Executing=3]="Executing"})(_=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var n;(function(E){E[E.WithHardKernelDependency=0]="WithHardKernelDependency",E[E.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",E[E.Pure=2]="Pure",E[E.Never=3]="Never"})(n=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var h;(function(E){E.Always="always",E.Never="never",E.Optional="optional"})(h=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var s;(function(E){E[E.ModelChange=1]="ModelChange",E[E.Move=2]="Move",E[E.ChangeLanguage=5]="ChangeLanguage",E[E.Initialize=6]="Initialize",E[E.ChangeCellMetadata=7]="ChangeCellMetadata",E[E.Output=8]="Output",E[E.OutputItem=9]="OutputItem",E[E.ChangeCellContent=10]="ChangeCellContent",E[E.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",E[E.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",E[E.ChangeCellMime=13]="ChangeCellMime",E[E.Unknown=100]="Unknown"})(s=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var l;(function(E){E[E.Handle=0]="Handle",E[E.Index=1]="Index"})(l=e.SelectionStateType||(e.SelectionStateType={}));var d;(function(E){E[E.Replace=1]="Replace",E[E.Output=2]="Output",E[E.Metadata=3]="Metadata",E[E.CellLanguage=4]="CellLanguage",E[E.DocumentMetadata=5]="DocumentMetadata",E[E.Move=6]="Move",E[E.OutputItems=7]="OutputItems",E[E.PartialMetadata=8]="PartialMetadata",E[E.PartialInternalMetadata=9]="PartialInternalMetadata"})(d=e.CellEditType||(e.CellEditType={}));var D;(function(E){E.scheme=I.Schemas.vscodeNotebookCell;const P=/^ch(\d{7,})/;function k(z,H){return z.with({scheme:E.scheme,fragment:`ch${H.toString().padStart(7,"0")}${z.scheme!==I.Schemas.file?z.scheme:""}`})}E.generate=k;function B(z){if(z.scheme!==E.scheme)return;const H=P.exec(z.fragment);return H?{handle:Number(H[1]),notebook:z.with({scheme:z.fragment.substr(H[0].length)||I.Schemas.file,fragment:null})}:void 0}E.parse=B;function L(z,H,q){return z.with({scheme:I.Schemas.vscodeNotebookCellOutput,fragment:`ch${H.toString().padStart(7,"0")},${q??""},${z.scheme!==I.Schemas.file?z.scheme:""}`})}E.generateCellOutputUri=L;function y(z){if(z.scheme!==I.Schemas.vscodeNotebookCellOutput)return;const H=/^ch(\d{7,})\,([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(z.fragment);if(!H)return;const q=Number(H[1]),ue=H[2]&&H[2]!==""?H[2]:void 0,K=H[3];return{handle:q,outputId:ue,notebook:z.with({scheme:K||I.Schemas.file,fragment:null})}}E.parseCellOutputUri=y;function x(z,H,q){return z.with({scheme:q,fragment:`ch${H.toString().padStart(7,"0")}${z.scheme!==I.Schemas.file?z.scheme:""}`})}E.generateCellUri=x;function N(z,H){if(z.scheme!==H)return;const q=P.exec(z.fragment);return q?{handle:Number(q[1]),notebook:z.with({scheme:z.fragment.substr(q[0].length)||I.Schemas.file,fragment:null})}:void 0}E.parseCellUri=N})(D=e.CellUri||(e.CellUri={}));const v=new Map([["application/javascript",{supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["image/jpeg",{alwaysSecure:!0,supportedByCore:!0}],["image/git",{alwaysSecure:!0,supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["application/json",{alwaysSecure:!0,supportedByCore:!0}],[w.Mimes.latex,{alwaysSecure:!0,supportedByCore:!0}],[w.Mimes.text,{alwaysSecure:!0,supportedByCore:!0}],["text/html",{supportedByCore:!0}],["text/x-javascript",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.error",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/vnd.code.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function f(E){return v.get(E)?.alwaysSecure??!1}e.mimeTypeIsAlwaysSecure=f;function g(E){return v.get(E)?.supportedByCore??!1}e.mimeTypeSupportedByCore=g;function T(E){return v.get(E)?.mergeable??!1}e.mimeTypeIsMergeable=T;const u=E=>R.isWindows?E.replace(/\//g,"\\"):E;class M{constructor(P=[],k=e.NOTEBOOK_DISPLAY_ORDER){this.defaultOrder=k,this.order=[...new Set(P)].map(B=>({pattern:B,matches:c.parse(u(B))}))}sort(P){const k=new Map(F.Iterable.map(P,L=>[L,u(L)]));let B=[];for(const{matches:L}of this.order)for(const[y,x]of k)if(L(x)){B.push(y),k.delete(y);break}return k.size&&(B=B.concat([...k.keys()].sort((L,y)=>this.defaultOrder.indexOf(L)-this.defaultOrder.indexOf(y)))),B}prioritize(P,k){const B=this.findIndex(P);if(B===-1){this.order.unshift({pattern:P,matches:c.parse(u(P))});return}const L=new Set(k.map(x=>this.findIndex(x,B)));L.delete(-1);const y=Array.from(L).sort();this.order.splice(B+1,0,...y.map(x=>this.order[x]));for(let x=y.length-1;x>=0;x--)this.order.splice(y[x],1)}toArray(){return this.order.map(P=>P.pattern)}findIndex(P,k=this.order.length){const B=u(P);for(let L=0;L<k;L++)if(this.order[L].matches(B))return L;return-1}}e.MimeTypeDisplayOrder=M;function r(E,P,k,B=(L,y)=>L===y){const L=[];function y(z,H,q){if(H===0&&q.length===0)return;const ue=L[L.length-1];ue&&ue.start+ue.deleteCount===z?(ue.deleteCount+=H,ue.toInsert.push(...q)):L.push({start:z,deleteCount:H,toInsert:q})}let x=0,N=0;for(;;){if(x===E.length){y(x,0,P.slice(N));break}if(N===P.length){y(x,E.length-x,[]);break}const z=E[x],H=P[N];if(B(z,H)){x+=1,N+=1;continue}k(H)?(y(x,1,[]),x+=1):(y(x,0,[H]),N+=1)}return L}e.diff=r,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new S.RawContextKey("notebookEditorCursorAtBoundary","none");var i;(function(E){E.default="default",E.option="option"})(i=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function p(E){const P=E;return!!((typeof P.include=="string"||c.isRelativePattern(P.include))&&(typeof P.exclude=="string"||c.isRelativePattern(P.exclude)))}e.isDocumentExcludePattern=p;function m(E,P,k){if(Array.isArray(E.viewType)&&E.viewType.indexOf(P)>=0||E.viewType===P)return!0;if(E.filenamePattern){let B=p(E.filenamePattern)?E.filenamePattern.include:E.filenamePattern,L=p(E.filenamePattern)?E.filenamePattern.exclude:void 0;if(c.match(B,(0,t.basename)(k.fsPath).toLowerCase()))return!(L&&c.match(L,(0,t.basename)(k.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=m;class o{constructor(P){this.textModel=P}getElements(){const P=new Int32Array(this.textModel.cells.length);for(let k=0;k<this.textModel.cells.length;k++)P[k]=this.textModel.cells[k].getHashValue();return P}}e.CellSequence=o,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize"};var b;(function(E){E[E.Left=1]="Left",E[E.Right=2]="Right"})(b=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class a{static create(P){return`${a._prefix}${P}`}static parse(P){if(P.startsWith(a._prefix))return P.substr(a._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=a,a._prefix="notebook/"}),define(Ee[159],_e([0,1,4]),function(oe,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var F;(function(w){w[w.Output=1]="Output",w[w.OutputItems=2]="OutputItems",w[w.ExecutionState=3]="ExecutionState",w[w.Complete=4]="Complete"})(F=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,c.createDecorator)("INotebookExecutionService")}),define(Ee[160],_e([0,1,4,45]),function(oe,e,c,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.MAX_OUTPUT_LENGTH=e.OUTPUT_SERVICE_ID=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.OUTPUT_SERVICE_ID="outputService",e.MAX_OUTPUT_LENGTH=1e4*100,e.CONTEXT_IN_OUTPUT=new F.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new F.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new F.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,c.createDecorator)(e.OUTPUT_SERVICE_ID);var w;(function(I){I[I.Append=1]="Append",I[I.Replace=2]="Replace",I[I.Clear=3]="Clear"})(w=e.OutputChannelUpdateMode||(e.OutputChannelUpdateMode={}))}),define(Ee[161],_e([0,1,129,4,45]),function(oe,e,c,F,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new w.RawContextKey("customExecutionSupported",!0,c.localize(0,null)),e.ShellExecutionSupportedContext=new w.RawContextKey("shellExecutionSupported",!1,c.localize(1,null)),e.ProcessExecutionSupportedContext=new w.RawContextKey("processExecutionSupported",!1,c.localize(2,null)),e.ITaskService=(0,F.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(Ee[162],_e([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function c(w){return[...w.entries()]}e.serializeEnvironmentVariableCollection=c;function F(w){return new Map(w)}e.deserializeEnvironmentVariableCollection=F}),define(Ee[88],_e([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestDiffOpType=e.DetailType=e.applyTestItemUpdate=e.TestItemExpandState=e.TestMessageType=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var c;(function(_){_[_.Unset=0]="Unset",_[_.Queued=1]="Queued",_[_.Running=2]="Running",_[_.Passed=3]="Passed",_[_.Failed=4]="Failed",_[_.Skipped=5]="Skipped",_[_.Errored=6]="Errored"})(c=e.TestResultState||(e.TestResultState={}));var F;(function(_){_[_.Run=2]="Run",_[_.Debug=4]="Debug",_[_.Coverage=8]="Coverage",_[_.HasNonDefaultProfile=16]="HasNonDefaultProfile",_[_.HasConfigurable=32]="HasConfigurable"})(F=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var w;(function(_){_[_.Error=0]="Error",_[_.Info=1]="Info"})(w=e.TestMessageType||(e.TestMessageType={}));var I;(function(_){_[_.NotExpandable=0]="NotExpandable",_[_.Expandable=1]="Expandable",_[_.BusyExpanding=2]="BusyExpanding",_[_.Expanded=3]="Expanded"})(I=e.TestItemExpandState||(e.TestItemExpandState={}));const t=(_,n)=>{n.expand!==void 0&&(_.expand=n.expand),n.item!==void 0&&(_.item=_.item?Object.assign(_.item,n.item):n.item)};e.applyTestItemUpdate=t;var R;(function(_){_[_.Function=0]="Function",_[_.Statement=1]="Statement"})(R=e.DetailType||(e.DetailType={}));var S;(function(_){_[_.Add=0]="Add",_[_.Update=1]="Update",_[_.Remove=2]="Remove",_[_.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",_[_.Retire=4]="Retire",_[_.AddTag=5]="AddTag",_[_.RemoveTag=6]="RemoveTag"})(S=e.TestDiffOpType||(e.TestDiffOpType={}));class C{add(n){}update(n){}remove(n,h){}complete(){}}e.IncrementalChangeCollector=C;class A{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(n){const h=this.createChangeCollector();for(const s of n)switch(s[0]){case 0:{const l=s[1];if(l.parent){if(this.items.has(l.parent)){const d=this.items.get(l.parent);d.children.add(l.item.extId);const D=this.createItem(l,d);this.items.set(l.item.extId,D),h.add(D)}}else{const d=this.createItem(l);this.roots.add(d),this.items.set(l.item.extId,d),h.add(d)}l.expand===2&&this.busyControllerCount++;break}case 1:{const l=s[1],d=this.items.get(l.extId);if(!d)break;l.expand!==void 0&&(d.expand===2&&this.busyControllerCount--,l.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(d,l),h.update(d);break}case 2:{const l=this.items.get(s[1]);if(!l)break;l.parent?this.items.get(l.parent).children.delete(l.item.extId):this.roots.delete(l);const d=[[s[1]]];for(;d.length;)for(const D of d.pop()){const v=this.items.get(D);v&&(d.push(v.children),this.items.delete(D),h.remove(v,v!==l),v.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(s[1]);break;case 3:this.updatePendingRoots(s[1]);break;case 5:this._tags.set(s[1].id,s[1]);break;case 6:this._tags.delete(s[1]);break}h.complete()}retireTest(n){}updatePendingRoots(n){this.pendingRootCount+=n}createChangeCollector(){return new C}}e.AbstractIncrementalTestCollection=A}),define(Ee[67],_e([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var c;(function(I){I.Delimiter="\0"})(c=e.TestIdPathParts||(e.TestIdPathParts={}));var F;(function(I){I[I.IsSame=0]="IsSame",I[I.Disconnected=1]="Disconnected",I[I.IsChild=2]="IsChild",I[I.IsParent=3]="IsParent"})(F=e.TestPosition||(e.TestPosition={}));class w{constructor(t,R=t.length){if(this.path=t,this.viewEnd=R,t.length===0||R<1)throw new Error("cannot create test with empty path")}static fromExtHostTestItem(t,R,S=t.parent){if(t.id===R)return new w([R]);let C=[t.id];for(let A=S;A&&A.id!==R;A=A.parent)C.push(A.id);return C.push(R),new w(C.reverse())}static isRoot(t){return!t.includes("\0")}static fromString(t){return new w(t.split("\0"))}static join(t,R){return new w([...t.path,R])}static joinToString(t,R){return t.toString()+"\0"+R}static compare(t,R){return t===R?0:R.startsWith(t+"\0")?2:t.startsWith(R+"\0")?3:1}get parentId(){return this.viewEnd>1?new w(this.path,this.viewEnd-1):this}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let t=1;t<=this.viewEnd;t++)yield new w(this.path,t)}compare(t){if(typeof t=="string")return w.compare(this.toString(),t);for(let R=0;R<t.viewEnd&&R<this.viewEnd;R++)if(t.path[R]!==this.path[R])return 1;return t.viewEnd>this.viewEnd?2:t.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let t=1;t<this.viewEnd;t++)this.stringifed+="\0",this.stringifed+=this.path[t]}return this.stringifed}}e.TestId=w}),define(Ee[163],_e([0,1,17,89,11,27,23,77,130]),function(oe,e,c,F,w,I,t,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class C{constructor(_,n,h){this._contributedVariables=new Map,this._context=_,this._labelService=n,h&&(this._envVariablesPromise=h.then(s=>this.prepareEnv(s)))}prepareEnv(_){if(t.isWindows){const n=Object.create(null);return Object.keys(_).forEach(h=>{n[h.toLowerCase()]=_[h]}),n}return _}resolveWithEnvironment(_,n,h){return this.recursiveResolve(this.prepareEnv(_),n?n.uri:void 0,h)}async resolveAsync(_,n){return this.recursiveResolve(await this._envVariablesPromise,_?_.uri:void 0,n)}async resolveAnyBase(_,n,h,s){const l=I.deepClone(n);return t.isWindows&&l.windows?Object.keys(l.windows).forEach(d=>l[d]=l.windows[d]):t.isMacintosh&&l.osx?Object.keys(l.osx).forEach(d=>l[d]=l.osx[d]):t.isLinux&&l.linux&&Object.keys(l.linux).forEach(d=>l[d]=l.linux[d]),delete l.windows,delete l.osx,delete l.linux,this.recursiveResolve(await this._envVariablesPromise,_?_.uri:void 0,l,h,s)}async resolveAnyAsync(_,n,h){return this.resolveAnyBase(_,n,h)}async resolveAnyMap(_,n,h){const s=new Map;return{newConfig:await this.resolveAnyBase(_,n,h,s),resolvedVariables:s}}resolveWithInteractionReplace(_,n,h,s){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(_,n,h,s){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(_,n){if(this._contributedVariables.has(_))throw new Error("Variable "+_+" is contributed twice.");this._contributedVariables.set(_,n)}recursiveResolve(_,n,h,s,l){if(w.isString(h))return this.resolveString(_,n,h,s,l);if(w.isArray(h))return h.map(d=>this.recursiveResolve(_,n,d,s,l));if(w.isObject(h)){let d=Object.create(null);return Object.keys(h).forEach(D=>{const v=this.resolveString(_,n,D,s,l);d[v]=this.recursiveResolve(_,n,h[D],s,l)}),d}return h}resolveString(_,n,h,s,l){return h.replace(C.VARIABLE_REGEXP,(D,v)=>{if(v.includes(C.VARIABLE_LHS))return D;let f=this.evaluateSingleVariable(_,D,v,n,s);return l&&l.set(v,f),f!==D&&w.isString(f)&&f.match(C.VARIABLE_REGEXP)&&(f=this.resolveString(_,n,f,s,l)),f})}fsPath(_){return this._labelService?this._labelService.getUriLabel(_,{noPrefix:!0}):_.fsPath}evaluateSingleVariable(_,n,h,s,l){let d;const D=h.split(":");D.length>1&&(h=D[0],d=D[1]);const v=()=>{const T=this._context.getFilePath();if(T)return T;throw new Error((0,S.localize)(0,null,n))},f=()=>{const T=v();if(this._context.getWorkspaceFolderPathForFile){const u=this._context.getWorkspaceFolderPathForFile();if(u)return u}throw new Error((0,S.localize)(1,null,n,c.basename(T)))},g=()=>{if(d){const T=this._context.getFolderUri(d);if(T)return T;throw new Error((0,S.localize)(2,null,n,d))}if(s)return s;throw this._context.getWorkspaceFolderCount()>1?new Error((0,S.localize)(3,null,n)):new Error((0,S.localize)(4,null,n))};switch(h){case"env":if(d){if(_){const T=_[t.isWindows?d.toLowerCase():d];if(w.isString(T))return T}return""}throw new Error((0,S.localize)(5,null,n));case"config":if(d){const T=this._context.getConfigurationValue(s,d);if(w.isUndefinedOrNull(T))throw new Error((0,S.localize)(6,null,n,d));if(w.isObject(T))throw new Error((0,S.localize)(7,null,n,d));return T}throw new Error((0,S.localize)(8,null,n));case"command":return this.resolveFromMap(n,d,l,"command");case"input":return this.resolveFromMap(n,d,l,"input");default:switch(h){case"workspaceRoot":case"workspaceFolder":return(0,R.normalizeDriveLetter)(this.fsPath(g()));case"cwd":return s||d?(0,R.normalizeDriveLetter)(this.fsPath(g())):F.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return c.basename(this.fsPath(g()));case"lineNumber":const T=this._context.getLineNumber();if(T)return T;throw new Error((0,S.localize)(9,null,n));case"selectedText":const u=this._context.getSelectedText();if(u)return u;throw new Error((0,S.localize)(10,null,n));case"file":return v();case"fileWorkspaceFolder":return f();case"relativeFile":return s||d?c.relative(this.fsPath(g()),v()):v();case"relativeFileDirname":const M=c.dirname(v());if(s||d){const m=c.relative(this.fsPath(g()),M);return m.length===0?".":m}return M;case"fileDirname":return c.dirname(v());case"fileExtname":return c.extname(v());case"fileBasename":return c.basename(v());case"fileBasenameNoExtension":const r=c.basename(v());return r.slice(0,r.length-c.extname(r).length);case"fileDirnameBasename":return c.basename(c.dirname(v()));case"execPath":const i=this._context.getExecPath();return i||n;case"execInstallFolder":const p=this._context.getAppRoot();return p||n;case"pathSeparator":return c.sep;default:try{const m=d?`${h}:${d}`:h;return this.resolveFromMap(n,m,l,void 0)}catch(m){return n}}}}resolveFromMap(_,n,h,s){if(n&&h){const l=s===void 0?h[n]:h[s+":"+n];if(typeof l=="string")return l;throw new Error((0,S.localize)(11,null,_))}return _}}e.AbstractVariableResolverService=C,C.VARIABLE_LHS="${",C.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(Ee[90],_e([0,1,4,155]),function(oe,e,c,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupChangeKind=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,c.createDecorator)("editorGroupsService");var w;(function(l){l[l.UP=0]="UP",l[l.DOWN=1]="DOWN",l[l.LEFT=2]="LEFT",l[l.RIGHT=3]="RIGHT"})(w=e.GroupDirection||(e.GroupDirection={}));var I;(function(l){l[l.HORIZONTAL=0]="HORIZONTAL",l[l.VERTICAL=1]="VERTICAL"})(I=e.GroupOrientation||(e.GroupOrientation={}));var t;(function(l){l[l.FIRST=0]="FIRST",l[l.LAST=1]="LAST",l[l.NEXT=2]="NEXT",l[l.PREVIOUS=3]="PREVIOUS"})(t=e.GroupLocation||(e.GroupLocation={}));var R;(function(l){l[l.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",l[l.EVEN=1]="EVEN",l[l.TOGGLE=2]="TOGGLE"})(R=e.GroupsArrangement||(e.GroupsArrangement={}));var S;(function(l){l[l.COPY_EDITORS=0]="COPY_EDITORS",l[l.MOVE_EDITORS=1]="MOVE_EDITORS"})(S=e.MergeGroupMode||(e.MergeGroupMode={}));function C(l){const d=l;return(0,F.isEditorInput)(d?.editor)&&(0,F.isEditorInput)(d?.replacement)}e.isEditorReplacement=C;var A;(function(l){l[l.CREATION_TIME=0]="CREATION_TIME",l[l.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",l[l.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(A=e.GroupsOrder||(e.GroupsOrder={}));var _;(function(l){l[l.GROUP_ACTIVE=0]="GROUP_ACTIVE",l[l.GROUP_INDEX=1]="GROUP_INDEX",l[l.GROUP_LOCKED=2]="GROUP_LOCKED",l[l.EDITOR_OPEN=3]="EDITOR_OPEN",l[l.EDITOR_CLOSE=4]="EDITOR_CLOSE",l[l.EDITOR_MOVE=5]="EDITOR_MOVE",l[l.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",l[l.EDITOR_LABEL=7]="EDITOR_LABEL",l[l.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",l[l.EDITOR_PIN=9]="EDITOR_PIN",l[l.EDITOR_STICKY=10]="EDITOR_STICKY",l[l.EDITOR_DIRTY=11]="EDITOR_DIRTY"})(_=e.GroupChangeKind||(e.GroupChangeKind={}));var n;(function(l){l[l.NEW_EDITOR=1]="NEW_EDITOR",l[l.MOVE_EDITOR=2]="MOVE_EDITOR",l[l.COPY_EDITOR=3]="COPY_EDITOR"})(n=e.OpenEditorContext||(e.OpenEditorContext={}));function h(l){const d=l;return!!d&&typeof d.id=="number"&&Array.isArray(d.editors)}e.isEditorGroup=h;function s(l){return l.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=s}),define(Ee[164],_e([0,1,4,90]),function(oe,e,c,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,c.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function w(I){const t=I;return typeof I=="number"||(0,F.isEditorGroup)(t)}e.isPreferredGroup=w}),define(Ee[8],_e([0,1,16,22,76,225,54,27,11,2,59,58,131,82,48,87,67,164,7]),function(oe,e,c,F,w,I,t,R,S,C,A,_,n,h,s,l,d,D,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var f;(function(ne){function ge(W){const{selectionStartLineNumber:be,selectionStartColumn:ke,positionLineNumber:qe,positionColumn:Le}=W,dt=new v.Position(be-1,ke-1),bt=new v.Position(qe-1,Le-1);return new v.Selection(dt,bt)}ne.to=ge;function te(W){const{anchor:be,active:ke}=W;return{selectionStartLineNumber:be.line+1,selectionStartColumn:be.character+1,positionLineNumber:ke.line+1,positionColumn:ke.character+1}}ne.from=te})(f=e.Selection||(e.Selection={}));var g;(function(ne){function ge(W){if(!W)return;const{start:be,end:ke}=W;return{startLineNumber:be.line+1,startColumn:be.character+1,endLineNumber:ke.line+1,endColumn:ke.character+1}}ne.from=ge;function te(W){if(!W)return;const{startLineNumber:be,startColumn:ke,endLineNumber:qe,endColumn:Le}=W;return new v.Range(be-1,ke-1,qe-1,Le-1)}ne.to=te})(g=e.Range||(e.Range={}));var T;(function(ne){function ge(te){switch(te){case 1:return v.StandardTokenType.Comment;case 0:return v.StandardTokenType.Other;case 4:return v.StandardTokenType.RegEx;case 2:return v.StandardTokenType.String}}ne.to=ge})(T=e.TokenType||(e.TokenType={}));var u;(function(ne){function ge(W){return new v.Position(W.lineNumber-1,W.column-1)}ne.to=ge;function te(W){return{lineNumber:W.line+1,column:W.character+1}}ne.from=te})(u=e.Position||(e.Position={}));var M;(function(ne){function ge(be,ke){return(0,c.coalesce)((0,c.asArray)(be).map(qe=>te(qe,ke)))}ne.from=ge;function te(be,ke){if(typeof be=="string")return{$serialized:!0,language:be};if(be)return{$serialized:!0,language:be.language,scheme:W(be.scheme,ke),pattern:typeof be.pattern=="undefined"?void 0:Ue.from(be.pattern),exclusive:be.exclusive}}function W(be,ke){return ke&&typeof be=="string"?ke.transformOutgoingScheme(be):be}})(M=e.DocumentSelector||(e.DocumentSelector={}));var r;(function(ne){function ge(W){switch(W){case v.DiagnosticTag.Unnecessary:return 1;case v.DiagnosticTag.Deprecated:return 2}}ne.from=ge;function te(W){switch(W){case 1:return v.DiagnosticTag.Unnecessary;case 2:return v.DiagnosticTag.Deprecated;default:return}}ne.to=te})(r=e.DiagnosticTag||(e.DiagnosticTag={}));var i;(function(ne){function ge(W){let be;return W.code&&((0,S.isString)(W.code)||(0,S.isNumber)(W.code)?be=String(W.code):be={value:String(W.code.value),target:W.code.target}),{...g.from(W.range),message:W.message,source:W.source,code:be,severity:m.from(W.severity),relatedInformation:W.relatedInformation&&W.relatedInformation.map(p.from),tags:Array.isArray(W.tags)?(0,c.coalesce)(W.tags.map(r.from)):void 0}}ne.from=ge;function te(W){const be=new v.Diagnostic(g.to(W),W.message,m.to(W.severity));return be.source=W.source,be.code=(0,S.isString)(W.code)?W.code:W.code?.value,be.relatedInformation=W.relatedInformation&&W.relatedInformation.map(p.to),be.tags=W.tags&&(0,c.coalesce)(W.tags.map(r.to)),be}ne.to=te})(i=e.Diagnostic||(e.Diagnostic={}));var p;(function(ne){function ge(W){return{...g.from(W.location.range),message:W.message,resource:W.location.uri}}ne.from=ge;function te(W){return new v.DiagnosticRelatedInformation(new v.Location(W.resource,g.to(W)),W.message)}ne.to=te})(p=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var m;(function(ne){function ge(W){switch(W){case v.DiagnosticSeverity.Error:return h.MarkerSeverity.Error;case v.DiagnosticSeverity.Warning:return h.MarkerSeverity.Warning;case v.DiagnosticSeverity.Information:return h.MarkerSeverity.Info;case v.DiagnosticSeverity.Hint:return h.MarkerSeverity.Hint}return h.MarkerSeverity.Error}ne.from=ge;function te(W){switch(W){case h.MarkerSeverity.Info:return v.DiagnosticSeverity.Information;case h.MarkerSeverity.Warning:return v.DiagnosticSeverity.Warning;case h.MarkerSeverity.Error:return v.DiagnosticSeverity.Error;case h.MarkerSeverity.Hint:return v.DiagnosticSeverity.Hint;default:return v.DiagnosticSeverity.Error}}ne.to=te})(m=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var o;(function(ne){function ge(W){return typeof W=="number"&&W>=v.ViewColumn.One?W-1:W===v.ViewColumn.Beside?D.SIDE_GROUP:D.ACTIVE_GROUP}ne.from=ge;function te(W){if(typeof W=="number"&&W>=0)return W+1;throw new Error("invalid 'EditorGroupColumn'")}ne.to=te})(o=e.ViewColumn||(e.ViewColumn={}));function b(ne){return typeof ne.range!="undefined"}function a(ne){return ne.length===0?!0:!!b(ne[0])}e.isDecorationOptionsArr=a;var E;(function(ne){function ge(Le){return Le.map(ne.from)}ne.fromMany=ge;function te(Le){return Le&&typeof Le=="object"&&typeof Le.language=="string"&&typeof Le.value=="string"}function W(Le){let dt;if(te(Le)){const{language:ht,value:vt}=Le;dt={value:"```"+ht+`
`+vt+"\n```\n"}}else v.MarkdownString.isMarkdownString(Le)?dt={value:Le.value,isTrusted:Le.isTrusted,supportThemeIcons:Le.supportThemeIcons,supportHtml:Le.supportHtml}:typeof Le=="string"?dt={value:Le}:dt={value:""};const bt=Object.create(null);dt.uris=bt;const Ct=ht=>{try{let vt=C.URI.parse(ht,!0);vt=vt.with({query:be(vt.query,bt)}),bt[ht]=vt}catch(vt){}return""},pt=new I.Renderer;return pt.link=Ct,pt.image=ht=>Ct(w.parseHrefAndDimensions(ht).href),I(dt.value,{renderer:pt}),dt}ne.from=W;function be(Le,dt){if(!Le)return Le;let bt;try{bt=(0,t.parse)(Le)}catch(pt){}if(!bt)return Le;let Ct=!1;return bt=(0,R.cloneAndChange)(bt,pt=>{if(C.URI.isUri(pt)){const ht=`__uri_${Math.random().toString(16).slice(2,8)}`;return dt[ht]=pt,Ct=!0,ht}else return}),Ct?JSON.stringify(bt):Le}function ke(Le){const dt=new v.MarkdownString(Le.value,Le.supportThemeIcons);return dt.isTrusted=Le.isTrusted,dt.supportHtml=Le.supportHtml,dt}ne.to=ke;function qe(Le){if(!!Le)return typeof Le=="string"?Le:ne.from(Le)}ne.fromStrict=qe})(E=e.MarkdownString||(e.MarkdownString={}));function P(ne){return a(ne)?ne.map(ge=>({range:g.from(ge.range),hoverMessage:Array.isArray(ge.hoverMessage)?E.fromMany(ge.hoverMessage):ge.hoverMessage?E.from(ge.hoverMessage):void 0,renderOptions:ge.renderOptions})):ne.map(ge=>({range:g.from(ge)}))}e.fromRangeOrRangeWithMessage=P;function k(ne){return typeof ne=="undefined"?ne:typeof ne=="string"?C.URI.file(ne):ne}e.pathOrURIToURI=k;var B;(function(ne){function ge(te){return typeof te=="undefined"?te:{contentText:te.contentText,contentIconPath:te.contentIconPath?k(te.contentIconPath):void 0,border:te.border,borderColor:te.borderColor,fontStyle:te.fontStyle,fontWeight:te.fontWeight,textDecoration:te.textDecoration,color:te.color,backgroundColor:te.backgroundColor,margin:te.margin,width:te.width,height:te.height}}ne.from=ge})(B=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var L;(function(ne){function ge(te){return typeof te=="undefined"?te:{backgroundColor:te.backgroundColor,outline:te.outline,outlineColor:te.outlineColor,outlineStyle:te.outlineStyle,outlineWidth:te.outlineWidth,border:te.border,borderColor:te.borderColor,borderRadius:te.borderRadius,borderSpacing:te.borderSpacing,borderStyle:te.borderStyle,borderWidth:te.borderWidth,fontStyle:te.fontStyle,fontWeight:te.fontWeight,textDecoration:te.textDecoration,cursor:te.cursor,color:te.color,opacity:te.opacity,letterSpacing:te.letterSpacing,gutterIconPath:te.gutterIconPath?k(te.gutterIconPath):void 0,gutterIconSize:te.gutterIconSize,overviewRulerColor:te.overviewRulerColor,before:te.before?B.from(te.before):void 0,after:te.after?B.from(te.after):void 0}}ne.from=ge})(L=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var y;(function(ne){function ge(te){if(typeof te=="undefined")return te;switch(te){case v.DecorationRangeBehavior.OpenOpen:return 0;case v.DecorationRangeBehavior.ClosedClosed:return 1;case v.DecorationRangeBehavior.OpenClosed:return 2;case v.DecorationRangeBehavior.ClosedOpen:return 3}}ne.from=ge})(y=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var x;(function(ne){function ge(te){return{isWholeLine:te.isWholeLine,rangeBehavior:te.rangeBehavior?y.from(te.rangeBehavior):void 0,overviewRulerLane:te.overviewRulerLane,light:te.light?L.from(te.light):void 0,dark:te.dark?L.from(te.dark):void 0,backgroundColor:te.backgroundColor,outline:te.outline,outlineColor:te.outlineColor,outlineStyle:te.outlineStyle,outlineWidth:te.outlineWidth,border:te.border,borderColor:te.borderColor,borderRadius:te.borderRadius,borderSpacing:te.borderSpacing,borderStyle:te.borderStyle,borderWidth:te.borderWidth,fontStyle:te.fontStyle,fontWeight:te.fontWeight,textDecoration:te.textDecoration,cursor:te.cursor,color:te.color,opacity:te.opacity,letterSpacing:te.letterSpacing,gutterIconPath:te.gutterIconPath?k(te.gutterIconPath):void 0,gutterIconSize:te.gutterIconSize,overviewRulerColor:te.overviewRulerColor,before:te.before?B.from(te.before):void 0,after:te.after?B.from(te.after):void 0}}ne.from=ge})(x=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var N;(function(ne){function ge(W){return{text:W.newText,eol:W.newEol&&De.from(W.newEol),range:g.from(W.range)}}ne.from=ge;function te(W){const be=new v.TextEdit(g.to(W.range),W.text);return be.newEol=typeof W.eol=="undefined"?void 0:De.to(W.eol),be}ne.to=te})(N=e.TextEdit||(e.TextEdit={}));var z;(function(ne){function ge(W,be,ke){const qe={edits:[]};if(W instanceof v.WorkspaceEdit)for(let Le of W._allEntries())if(Le._type===1)qe.edits.push({_type:1,oldUri:Le.from,newUri:Le.to,options:Le.options,metadata:Le.metadata});else if(Le._type===2){const dt=be?.getDocument(Le.uri);qe.edits.push({_type:2,resource:Le.uri,edit:N.from(Le.edit),modelVersionId:dt?.version,metadata:Le.metadata})}else Le._type===3?qe.edits.push({_type:3,metadata:Le.metadata,resource:Le.uri,edit:Le.edit,notebookMetadata:Le.notebookMetadata,notebookVersionId:ke?.getNotebookDocument(Le.uri,!0)?.apiNotebook.version}):Le._type===5&&qe.edits.push({_type:3,metadata:Le.metadata,resource:Le.uri,notebookVersionId:ke?.getNotebookDocument(Le.uri,!0)?.apiNotebook.version,edit:{editType:1,index:Le.index,count:Le.count,cells:Le.cells.map(et.from)}});return qe}ne.from=ge;function te(W){const be=new v.WorkspaceEdit;for(const ke of W.edits)ke.edit?be.replace(C.URI.revive(ke.resource),g.to(ke.edit.range),ke.edit.text):be.renameFile(C.URI.revive(ke.oldUri),C.URI.revive(ke.newUri),ke.options);return be}ne.to=te})(z=e.WorkspaceEdit||(e.WorkspaceEdit={}));var H;(function(ne){const ge=Object.create(null);ge[v.SymbolKind.File]=0,ge[v.SymbolKind.Module]=1,ge[v.SymbolKind.Namespace]=2,ge[v.SymbolKind.Package]=3,ge[v.SymbolKind.Class]=4,ge[v.SymbolKind.Method]=5,ge[v.SymbolKind.Property]=6,ge[v.SymbolKind.Field]=7,ge[v.SymbolKind.Constructor]=8,ge[v.SymbolKind.Enum]=9,ge[v.SymbolKind.Interface]=10,ge[v.SymbolKind.Function]=11,ge[v.SymbolKind.Variable]=12,ge[v.SymbolKind.Constant]=13,ge[v.SymbolKind.String]=14,ge[v.SymbolKind.Number]=15,ge[v.SymbolKind.Boolean]=16,ge[v.SymbolKind.Array]=17,ge[v.SymbolKind.Object]=18,ge[v.SymbolKind.Key]=19,ge[v.SymbolKind.Null]=20,ge[v.SymbolKind.EnumMember]=21,ge[v.SymbolKind.Struct]=22,ge[v.SymbolKind.Event]=23,ge[v.SymbolKind.Operator]=24,ge[v.SymbolKind.TypeParameter]=25;function te(be){return typeof ge[be]=="number"?ge[be]:6}ne.from=te;function W(be){for(const ke in ge)if(ge[ke]===be)return Number(ke);return v.SymbolKind.Property}ne.to=W})(H=e.SymbolKind||(e.SymbolKind={}));var q;(function(ne){function ge(W){switch(W){case v.SymbolTag.Deprecated:return 1}}ne.from=ge;function te(W){switch(W){case 1:return v.SymbolTag.Deprecated}}ne.to=te})(q=e.SymbolTag||(e.SymbolTag={}));var ue;(function(ne){function ge(W){return{name:W.name,kind:H.from(W.kind),tags:W.tags&&W.tags.map(q.from),containerName:W.containerName,location:ie.from(W.location)}}ne.from=ge;function te(W){const be=new v.SymbolInformation(W.name,H.to(W.kind),W.containerName,ie.to(W.location));return be.tags=W.tags&&W.tags.map(q.to),be}ne.to=te})(ue=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var K;(function(ne){function ge(W){const be={name:W.name||"!!MISSING: name!!",detail:W.detail,range:g.from(W.range),selectionRange:g.from(W.selectionRange),kind:H.from(W.kind),tags:W.tags?.map(q.from)??[]};return W.children&&(be.children=W.children.map(ge)),be}ne.from=ge;function te(W){const be=new v.DocumentSymbol(W.name,W.detail,H.to(W.kind),g.to(W.range),g.to(W.selectionRange));return(0,c.isNonEmptyArray)(W.tags)&&(be.tags=W.tags.map(q.to)),W.children&&(be.children=W.children.map(te)),be}ne.to=te})(K=e.DocumentSymbol||(e.DocumentSymbol={}));var ce;(function(ne){function ge(W){const be=new v.CallHierarchyItem(H.to(W.kind),W.name,W.detail||"",C.URI.revive(W.uri),g.to(W.range),g.to(W.selectionRange));return be._sessionId=W._sessionId,be._itemId=W._itemId,be}ne.to=ge;function te(W,be,ke){if(be=be??W._sessionId,ke=ke??W._itemId,be===void 0||ke===void 0)throw new Error("invalid item");return{_sessionId:be,_itemId:ke,name:W.name,detail:W.detail,kind:H.from(W.kind),uri:W.uri,range:g.from(W.range),selectionRange:g.from(W.selectionRange),tags:W.tags?.map(q.from)}}ne.from=te})(ce=e.CallHierarchyItem||(e.CallHierarchyItem={}));var de;(function(ne){function ge(te){return new v.CallHierarchyIncomingCall(ce.to(te.from),te.fromRanges.map(W=>g.to(W)))}ne.to=ge})(de=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var Q;(function(ne){function ge(te){return new v.CallHierarchyOutgoingCall(ce.to(te.to),te.fromRanges.map(W=>g.to(W)))}ne.to=ge})(Q=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var ie;(function(ne){function ge(W){return{range:W.range&&g.from(W.range),uri:W.uri}}ne.from=ge;function te(W){return new v.Location(C.URI.revive(W.uri),g.to(W.range))}ne.to=te})(ie=e.location||(e.location={}));var we;(function(ne){function ge(W){const be=W,ke=W;return{originSelectionRange:be.originSelectionRange?g.from(be.originSelectionRange):void 0,uri:be.targetUri?be.targetUri:ke.uri,range:g.from(be.targetRange?be.targetRange:ke.range),targetSelectionRange:be.targetSelectionRange?g.from(be.targetSelectionRange):void 0}}ne.from=ge;function te(W){return{targetUri:C.URI.revive(W.uri),targetRange:g.to(W.range),targetSelectionRange:W.targetSelectionRange?g.to(W.targetSelectionRange):void 0,originSelectionRange:W.originSelectionRange?g.to(W.originSelectionRange):void 0}}ne.to=te})(we=e.DefinitionLink||(e.DefinitionLink={}));var Me;(function(ne){function ge(W){return{range:g.from(W.range),contents:E.fromMany(W.contents)}}ne.from=ge;function te(W){return new v.Hover(W.contents.map(E.to),g.to(W.range))}ne.to=te})(Me=e.Hover||(e.Hover={}));var Fe;(function(ne){function ge(W){return{range:g.from(W.range),expression:W.expression}}ne.from=ge;function te(W){return new v.EvaluatableExpression(g.to(W.range),W.expression)}ne.to=te})(Fe=e.EvaluatableExpression||(e.EvaluatableExpression={}));var Be;(function(ne){function ge(W){if(W instanceof v.InlineValueText)return{type:"text",range:g.from(W.range),text:W.text};if(W instanceof v.InlineValueVariableLookup)return{type:"variable",range:g.from(W.range),variableName:W.variableName,caseSensitiveLookup:W.caseSensitiveLookup};if(W instanceof v.InlineValueEvaluatableExpression)return{type:"expression",range:g.from(W.range),expression:W.expression};throw new Error("Unknown 'InlineValue' type")}ne.from=ge;function te(W){switch(W.type){case"text":return{range:g.to(W.range),text:W.text};case"variable":return{range:g.to(W.range),variableName:W.variableName,caseSensitiveLookup:W.caseSensitiveLookup};case"expression":return{range:g.to(W.range),expression:W.expression}}}ne.to=te})(Be=e.InlineValue||(e.InlineValue={}));var Ge;(function(ne){function ge(W){return{frameId:W.frameId,stoppedLocation:g.from(W.stoppedLocation)}}ne.from=ge;function te(W){return new v.InlineValueContext(W.frameId,g.to(W.stoppedLocation))}ne.to=te})(Ge=e.InlineValueContext||(e.InlineValueContext={}));var je;(function(ne){function ge(W){return{range:g.from(W.range),kind:W.kind}}ne.from=ge;function te(W){return new v.DocumentHighlight(g.to(W.range),W.kind)}ne.to=te})(je=e.DocumentHighlight||(e.DocumentHighlight={}));var Qe;(function(ne){function ge(te){switch(te){case 1:return v.CompletionTriggerKind.TriggerCharacter;case 2:return v.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return v.CompletionTriggerKind.Invoke}}ne.to=ge})(Qe=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var $;(function(ne){function ge(te){return{triggerKind:Qe.to(te.triggerKind),triggerCharacter:te.triggerCharacter}}ne.to=ge})($=e.CompletionContext||(e.CompletionContext={}));var G;(function(ne){function ge(W){switch(W){case v.CompletionItemTag.Deprecated:return 1}}ne.from=ge;function te(W){switch(W){case 1:return v.CompletionItemTag.Deprecated}}ne.to=te})(G=e.CompletionItemTag||(e.CompletionItemTag={}));var X;(function(ne){const ge=new Map([[v.CompletionItemKind.Method,0],[v.CompletionItemKind.Function,1],[v.CompletionItemKind.Constructor,2],[v.CompletionItemKind.Field,3],[v.CompletionItemKind.Variable,4],[v.CompletionItemKind.Class,5],[v.CompletionItemKind.Interface,7],[v.CompletionItemKind.Struct,6],[v.CompletionItemKind.Module,8],[v.CompletionItemKind.Property,9],[v.CompletionItemKind.Unit,12],[v.CompletionItemKind.Value,13],[v.CompletionItemKind.Constant,14],[v.CompletionItemKind.Enum,15],[v.CompletionItemKind.EnumMember,16],[v.CompletionItemKind.Keyword,17],[v.CompletionItemKind.Snippet,27],[v.CompletionItemKind.Text,18],[v.CompletionItemKind.Color,19],[v.CompletionItemKind.File,20],[v.CompletionItemKind.Reference,21],[v.CompletionItemKind.Folder,23],[v.CompletionItemKind.Event,10],[v.CompletionItemKind.Operator,11],[v.CompletionItemKind.TypeParameter,24],[v.CompletionItemKind.Issue,26],[v.CompletionItemKind.User,25]]);function te(ke){return ge.get(ke)??9}ne.from=te;const W=new Map([[0,v.CompletionItemKind.Method],[1,v.CompletionItemKind.Function],[2,v.CompletionItemKind.Constructor],[3,v.CompletionItemKind.Field],[4,v.CompletionItemKind.Variable],[5,v.CompletionItemKind.Class],[7,v.CompletionItemKind.Interface],[6,v.CompletionItemKind.Struct],[8,v.CompletionItemKind.Module],[9,v.CompletionItemKind.Property],[12,v.CompletionItemKind.Unit],[13,v.CompletionItemKind.Value],[14,v.CompletionItemKind.Constant],[15,v.CompletionItemKind.Enum],[16,v.CompletionItemKind.EnumMember],[17,v.CompletionItemKind.Keyword],[27,v.CompletionItemKind.Snippet],[18,v.CompletionItemKind.Text],[19,v.CompletionItemKind.Color],[20,v.CompletionItemKind.File],[21,v.CompletionItemKind.Reference],[23,v.CompletionItemKind.Folder],[10,v.CompletionItemKind.Event],[11,v.CompletionItemKind.Operator],[24,v.CompletionItemKind.TypeParameter],[25,v.CompletionItemKind.User],[26,v.CompletionItemKind.Issue]]);function be(ke){return W.get(ke)??v.CompletionItemKind.Property}ne.to=be})(X=e.CompletionItemKind||(e.CompletionItemKind={}));var se;(function(ne){function ge(te,W){const be=new v.CompletionItem(te.label);return be.insertText=te.insertText,be.kind=X.to(te.kind),be.tags=te.tags?.map(G.to),be.detail=te.detail,be.documentation=w.isMarkdownString(te.documentation)?E.to(te.documentation):te.documentation,be.sortText=te.sortText,be.filterText=te.filterText,be.preselect=te.preselect,be.commitCharacters=te.commitCharacters,A.Range.isIRange(te.range)?be.range=g.to(te.range):typeof te.range=="object"&&(be.range={inserting:g.to(te.range.insert),replacing:g.to(te.range.replace)}),be.keepWhitespace=typeof te.insertTextRules=="undefined"?!1:Boolean(te.insertTextRules&1),typeof te.insertTextRules!="undefined"&&te.insertTextRules&4?be.insertText=new v.SnippetString(te.insertText):(be.insertText=te.insertText,be.textEdit=be.range instanceof v.Range?new v.TextEdit(be.range,be.insertText):void 0),te.additionalTextEdits&&te.additionalTextEdits.length>0&&(be.additionalTextEdits=te.additionalTextEdits.map(ke=>N.to(ke))),be.command=W&&te.command?W.fromInternal(te.command):void 0,be}ne.to=ge})(se=e.CompletionItem||(e.CompletionItem={}));var j;(function(ne){function ge(W){return{label:W.label,documentation:W.documentation?E.fromStrict(W.documentation):void 0}}ne.from=ge;function te(W){return{label:W.label,documentation:w.isMarkdownString(W.documentation)?E.to(W.documentation):W.documentation}}ne.to=te})(j=e.ParameterInformation||(e.ParameterInformation={}));var Z;(function(ne){function ge(W){return{label:W.label,documentation:W.documentation?E.fromStrict(W.documentation):void 0,parameters:Array.isArray(W.parameters)?W.parameters.map(j.from):[],activeParameter:W.activeParameter}}ne.from=ge;function te(W){return{label:W.label,documentation:w.isMarkdownString(W.documentation)?E.to(W.documentation):W.documentation,parameters:Array.isArray(W.parameters)?W.parameters.map(j.to):[],activeParameter:W.activeParameter}}ne.to=te})(Z=e.SignatureInformation||(e.SignatureInformation={}));var fe;(function(ne){function ge(W){return{activeSignature:W.activeSignature,activeParameter:W.activeParameter,signatures:Array.isArray(W.signatures)?W.signatures.map(Z.from):[]}}ne.from=ge;function te(W){return{activeSignature:W.activeSignature,activeParameter:W.activeParameter,signatures:Array.isArray(W.signatures)?W.signatures.map(Z.to):[]}}ne.to=te})(fe=e.SignatureHelp||(e.SignatureHelp={}));var Te;(function(ne){function ge(W){return{text:W.text,position:u.from(W.position),kind:Ne.from(W.kind??v.InlayHintKind.Other),whitespaceBefore:W.whitespaceBefore,whitespaceAfter:W.whitespaceAfter}}ne.from=ge;function te(W){const be=new v.InlayHint(W.text,u.to(W.position),Ne.to(W.kind));return be.whitespaceAfter=W.whitespaceAfter,be.whitespaceBefore=W.whitespaceBefore,be}ne.to=te})(Te=e.InlayHint||(e.InlayHint={}));var Ne;(function(ne){function ge(W){return W}ne.from=ge;function te(W){return W}ne.to=te})(Ne=e.InlayHintKind||(e.InlayHintKind={}));var He;(function(ne){function ge(W){return{range:g.from(W.range),url:W.target,tooltip:W.tooltip}}ne.from=ge;function te(W){let be;if(W.url)try{be=typeof W.url=="string"?C.URI.parse(W.url,!0):C.URI.revive(W.url)}catch(ke){}return new v.DocumentLink(g.to(W.range),be)}ne.to=te})(He=e.DocumentLink||(e.DocumentLink={}));var Ke;(function(ne){function ge(W){const be=new v.ColorPresentation(W.label);return W.textEdit&&(be.textEdit=N.to(W.textEdit)),W.additionalTextEdits&&(be.additionalTextEdits=W.additionalTextEdits.map(ke=>N.to(ke))),be}ne.to=ge;function te(W){return{label:W.label,textEdit:W.textEdit?N.from(W.textEdit):void 0,additionalTextEdits:W.additionalTextEdits?W.additionalTextEdits.map(be=>N.from(be)):void 0}}ne.from=te})(Ke=e.ColorPresentation||(e.ColorPresentation={}));var tt;(function(ne){function ge(W){return new v.Color(W[0],W[1],W[2],W[3])}ne.to=ge;function te(W){return[W.red,W.green,W.blue,W.alpha]}ne.from=te})(tt=e.Color||(e.Color={}));var st;(function(ne){function ge(W){return{range:g.from(W.range)}}ne.from=ge;function te(W){return new v.SelectionRange(g.to(W.range))}ne.to=te})(st=e.SelectionRange||(e.SelectionRange={}));var Xe;(function(ne){function ge(te){switch(te){case 2:return v.TextDocumentSaveReason.AfterDelay;case 1:return v.TextDocumentSaveReason.Manual;case 3:case 4:return v.TextDocumentSaveReason.FocusOut}}ne.to=ge})(Xe=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var rt;(function(ne){function ge(W){switch(W){case v.TextEditorLineNumbersStyle.Off:return 0;case v.TextEditorLineNumbersStyle.Relative:return 2;case v.TextEditorLineNumbersStyle.On:default:return 1}}ne.from=ge;function te(W){switch(W){case 0:return v.TextEditorLineNumbersStyle.Off;case 2:return v.TextEditorLineNumbersStyle.Relative;case 1:default:return v.TextEditorLineNumbersStyle.On}}ne.to=te})(rt=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var De;(function(ne){function ge(W){if(W===v.EndOfLine.CRLF)return 1;if(W===v.EndOfLine.LF)return 0}ne.from=ge;function te(W){if(W===1)return v.EndOfLine.CRLF;if(W===0)return v.EndOfLine.LF}ne.to=te})(De=e.EndOfLine||(e.EndOfLine={}));var gt;(function(ne){function ge(te){if(typeof te=="object")return te.viewId;switch(te){case v.ProgressLocation.SourceControl:return 3;case v.ProgressLocation.Window:return 10;case v.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}ne.from=ge})(gt=e.ProgressLocation||(e.ProgressLocation={}));var V;(function(ne){function ge(te){const W={start:te.start+1,end:te.end+1};return te.kind&&(W.kind=J.from(te.kind)),W}ne.from=ge})(V=e.FoldingRange||(e.FoldingRange={}));var J;(function(ne){function ge(te){if(te)switch(te){case v.FoldingRangeKind.Comment:return _.FoldingRangeKind.Comment;case v.FoldingRangeKind.Imports:return _.FoldingRangeKind.Imports;case v.FoldingRangeKind.Region:return _.FoldingRangeKind.Region}}ne.from=ge})(J=e.FoldingRangeKind||(e.FoldingRangeKind={}));var pe;(function(ne){function ge(te){if(te)return{pinned:typeof te.preview=="boolean"?!te.preview:void 0,inactive:te.background,preserveFocus:te.preserveFocus,selection:typeof te.selection=="object"?g.from(te.selection):void 0,override:typeof te.override=="boolean"?n.EditorResolution.DISABLED:void 0}}ne.from=ge})(pe=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var Ue;(function(ne){function ge(W){return W instanceof v.RelativePattern||typeof W=="string"?W:te(W)?new v.RelativePattern(W.base,W.pattern):W}ne.from=ge;function te(W){const be=W;return be&&typeof be.base=="string"&&typeof be.pattern=="string"}})(Ue=e.GlobPattern||(e.GlobPattern={}));var Ye;(function(ne){function ge(te){if(te){if(Array.isArray(te))return te.map(ge);if(typeof te=="string")return te;{const W=te;return{language:W.language,scheme:W.scheme,pattern:typeof W.pattern=="undefined"?void 0:Ue.from(W.pattern),exclusive:W.exclusive}}}else return}ne.from=ge})(Ye=e.LanguageSelector||(e.LanguageSelector={}));var Je;(function(ne){function ge(W){return{start:W.start,end:W.end}}ne.from=ge;function te(W){return new v.NotebookRange(W.start,W.end)}ne.to=te})(Je=e.NotebookRange||(e.NotebookRange={}));var lt;(function(ne){function ge(W){return{timing:typeof W.runStartTime=="number"&&typeof W.runEndTime=="number"?{startTime:W.runStartTime,endTime:W.runEndTime}:void 0,executionOrder:W.executionOrder,success:W.lastRunSuccess}}ne.to=ge;function te(W){return{lastRunSuccess:W.success,runStartTime:W.timing?.startTime,runEndTime:W.timing?.endTime,executionOrder:W.executionOrder}}ne.from=te})(lt=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var Et;(function(ne){function ge(W){switch(W){case v.NotebookCellKind.Markup:return l.CellKind.Markup;case v.NotebookCellKind.Code:default:return l.CellKind.Code}}ne.from=ge;function te(W){switch(W){case l.CellKind.Markup:return v.NotebookCellKind.Markup;case l.CellKind.Code:default:return v.NotebookCellKind.Code}}ne.to=te})(Et=e.NotebookCellKind||(e.NotebookCellKind={}));var It;(function(ne){function ge(W){const be={metadata:W.metadata??Object.create(null),cells:[]};for(let ke of W.cells)v.NotebookCellData.validate(ke),be.cells.push(et.from(ke));return be}ne.from=ge;function te(W){const be=new v.NotebookData(W.cells.map(et.to));return(0,S.isEmptyObject)(W.metadata)||(be.metadata=W.metadata),be}ne.to=te})(It=e.NotebookData||(e.NotebookData={}));var et;(function(ne){function ge(W){return{cellKind:Et.from(W.kind),language:W.languageId,mime:W.mime,source:W.value,metadata:W.metadata,internalMetadata:lt.from(W.executionSummary??{}),outputs:W.outputs?W.outputs.map(Pe.from):[]}}ne.from=ge;function te(W){return new v.NotebookCellData(Et.to(W.cellKind),W.source,W.language,W.mime,W.outputs?W.outputs.map(Pe.to):void 0,W.metadata,W.internalMetadata?lt.to(W.internalMetadata):void 0)}ne.to=te})(et=e.NotebookCellData||(e.NotebookCellData={}));var Tt;(function(ne){function ge(W){return{mime:W.mime,valueBytes:F.VSBuffer.wrap(W.data)}}ne.from=ge;function te(W){return new v.NotebookCellOutputItem(W.valueBytes.buffer,W.mime)}ne.to=te})(Tt=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var Pe;(function(ne){function ge(W){return{outputId:W.id,items:W.items.map(Tt.from),metadata:W.metadata}}ne.from=ge;function te(W){const be=W.items.map(Tt.to);return new v.NotebookCellOutput(be,W.outputId,W.metadata)}ne.to=te})(Pe=e.NotebookCellOutput||(e.NotebookCellOutput={}));var Se;(function(ne){function ge(ke){if(ke!=null){if(ke instanceof v.RelativePattern||typeof ke=="string")return ke;if(be(ke))return new v.RelativePattern(ke.base,ke.pattern);if(W(ke))return{include:Ue.from(ke.include)||void 0,exclude:Ue.from(ke.exclude)||void 0}}}ne.from=ge;function te(ke){return typeof ke=="string"?ke:be(ke)?{base:ke.base,pattern:ke.pattern}:{include:ke.include,exclude:ke.exclude}}ne.to=te;function W(ke){const qe=ke,Le=Ue.from(qe.include);if(!(Le&&Le instanceof v.RelativePattern||typeof Le=="string"))return!1;const dt=Ue.from(qe.exclude);return!!(dt&&dt instanceof v.RelativePattern||typeof dt=="string")}function be(ke){const qe=ke;return qe&&typeof qe.base=="string"&&typeof qe.pattern=="string"}})(Se=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var ve;(function(ne){function ge(te){return{backgroundColor:te.backgroundColor,borderColor:te.borderColor,top:te.top?B.from(te.top):void 0}}ne.from=ge})(ve=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var re;(function(ne){function ge(te,W,be){const ke=typeof te.command=="string"?{title:"",command:te.command}:te.command;return{alignment:te.alignment===v.NotebookCellStatusBarAlignment.Left?1:2,command:W.toInternal(ke,be),text:te.text,tooltip:te.tooltip,accessibilityInformation:te.accessibilityInformation,priority:te.priority}}ne.from=ge})(re=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var ae;(function(ne){function ge(te){return{transientOutputs:te?.transientOutputs??!1,transientCellMetadata:te?.transientCellMetadata??{},transientDocumentMetadata:te?.transientDocumentMetadata??{}}}ne.from=ge})(ae=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var he;(function(ne){function ge(W){return{uri:W.uri,provides:W.provides}}ne.from=ge;function te(W){return new v.NotebookRendererScript(C.URI.revive(W.uri),W.provides)}ne.to=te})(he=e.NotebookRendererScript||(e.NotebookRendererScript={}));var me;(function(ne){function ge(W){return{message:E.fromStrict(W.message)||"",type:0,expected:W.expectedOutput,actual:W.actualOutput,location:W.location?ie.from(W.location):void 0}}ne.from=ge;function te(W){const be=new v.TestMessage(typeof W.message=="string"?W.message:E.to(W.message));return be.actualOutput=W.actual,be.expectedOutput=W.expected,be.location=W.location?ie.to(W.location):void 0,be}ne.to=te})(me=e.TestMessage||(e.TestMessage={}));var Ie;(function(ne){let ge;(function(te){te.Delimiter="\0"})(ge||(ge={})),ne.namespace=(te,W)=>te+"\0"+W,ne.denamespace=te=>{const W=te.indexOf("\0");return{ctrlId:te.slice(0,W),tagId:te.slice(W+1)}}})(Ie=e.TestTag||(e.TestTag={}));var ze;(function(ne){function ge(ke){const qe=(0,s.getPrivateApiFor)(ke).controllerId;return{extId:d.TestId.fromExtHostTestItem(ke,qe).toString(),label:ke.label,uri:ke.uri,tags:ke.tags.map(Le=>Ie.namespace(qe,Le.id)),range:g.from(ke.range)||null,description:ke.description||null,error:ke.error&&E.fromStrict(ke.error)||null}}ne.from=ge;function te(ke){return{parent:void 0,error:void 0,id:d.TestId.fromString(ke.extId).localId,label:ke.label,uri:C.URI.revive(ke.uri),tags:(ke.tags||[]).map(qe=>{const{tagId:Le}=Ie.denamespace(qe);return new v.TestTag(Le)}),range:g.to(ke.range||void 0),invalidateResults:()=>{},canResolveChildren:!1,busy:!1,description:ke.description||void 0}}ne.toPlain=te;function W(ke){const qe=d.TestId.fromString(ke.extId),Le=new s.TestItemImpl(qe.controllerId,qe.localId,ke.label,C.URI.revive(ke.uri));return Le.range=g.to(ke.range||void 0),Le.description=ke.description||void 0,Le}function be(ke){let qe;for(const Le of ke.tests){const dt=W(Le.item);(0,s.getPrivateApiFor)(dt).parent=qe,qe=dt}return qe}ne.toItemFromContext=be})(ze=e.TestItem||(e.TestItem={})),function(ne){function ge(W){return{id:W.id}}ne.from=ge;function te(W){return new v.TestTag(W.id)}ne.to=te}(Ie=e.TestTag||(e.TestTag={}));var Oe;(function(ne){const ge=(W,be)=>{const ke={...ze.toPlain(W.item),parent:void 0,taskStates:W.tasks.map(qe=>({state:qe.state,duration:qe.duration,messages:qe.messages.filter(Le=>Le.type===0).map(me.to)})),children:W.children.map(qe=>be.get(qe)).filter(S.isDefined).map(qe=>ge(qe,be))};for(const qe of ke.children)qe.parent=ke;return ke};function te(W){const be=[],ke=new Map;for(const qe of W.items)ke.set(qe.item.extId,qe),W.request.targets.some(Le=>Le.controllerId===qe.controllerId&&Le.testIds.includes(qe.item.extId))&&be.push(qe);return{completedAt:W.completedAt,results:be.map(qe=>ge(qe,ke))}}ne.to=te})(Oe=e.TestResults||(e.TestResults={}));var We;(function(ne){function ge(ke){return{covered:ke.covered,total:ke.covered}}function te(ke){return"line"in ke?u.from(ke):g.from(ke)}function W(ke){return"branches"in ke?{count:ke.executionCount,location:te(ke.location),type:1,branches:ke.branches.length?ke.branches.map(qe=>({count:qe.executionCount,location:qe.location&&te(qe.location)})):void 0}:{type:0,count:ke.executionCount,location:te(ke.location)}}ne.fromDetailed=W;function be(ke){return{uri:ke.uri,statement:ge(ke.statementCoverage),branch:ke.branchCoverage&&ge(ke.branchCoverage),function:ke.functionCoverage&&ge(ke.functionCoverage),details:ke.detailedCoverage?.map(W)}}ne.fromFile=be})(We=e.TestCoverage||(e.TestCoverage={}));var it;(function(ne){function ge(te){switch(te){case 1:return v.CodeActionTriggerKind.Invoke;case 2:return v.CodeActionTriggerKind.Automatic}}ne.to=ge})(it=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var ot;(function(ne){function ge(W){const be=new v.TypeHierarchyItem(H.to(W.kind),W.name,W.detail||"",C.URI.revive(W.uri),g.to(W.range),g.to(W.selectionRange));return be._sessionId=W._sessionId,be._itemId=W._itemId,be}ne.to=ge;function te(W,be,ke){if(be=be??W._sessionId,ke=ke??W._itemId,be===void 0||ke===void 0)throw new Error("invalid item");return{_sessionId:be,_itemId:ke,kind:H.from(W.kind),name:W.name,detail:W.detail??"",uri:W.uri,range:g.from(W.range),selectionRange:g.from(W.selectionRange),tags:W.tags?.map(q.from)}}ne.from=te})(ot=e.TypeHierarchyItem||(e.TypeHierarchyItem={}))}),define(Ee[165],_e([0,1,2,15,7,8,226]),function(oe,e,c,F,w,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class R{constructor(C,A,_,n={timeout:1500,errors:3}){this._logService=C,this._documents=A,this._mainThreadBulkEdits=_,this._thresholds=n,this._callbacks=new t.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(C){return(A,_,n)=>{const s={dispose:this._callbacks.push([A,_,C])};return Array.isArray(n)&&n.push(s),s}}async $participateInSave(C,A){const _=c.URI.revive(C);let n=!1;const h=setTimeout(()=>n=!0,this._thresholds.timeout),s=[];try{for(let l of[...this._callbacks]){if(n)break;const d=this._documents.getDocument(_),D=await this._deliverEventAsyncAndBlameBadListeners(l,{document:d,reason:I.TextDocumentSaveReason.to(A)});s.push(D)}}finally{clearTimeout(h)}return s}_deliverEventAsyncAndBlameBadListeners([C,A,_],n){const h=this._badListeners.get(C);return typeof h=="number"&&h>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(_,C,A,n).then(()=>!0,s=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${_.identifier.value}' threw ERROR`),this._logService.error(s),!(s instanceof Error)||s.message!=="concurrent_edits"){const l=this._badListeners.get(C);this._badListeners.set(C,l?l+1:1),typeof l=="number"&&l>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${_.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(C,A,_,n){const h=[],s=Date.now(),{document:l,reason:d}=n,{version:D}=l,v=Object.freeze({document:l,reason:d,waitUntil(f){if(Object.isFrozen(h))throw(0,F.illegalState)("waitUntil can not be called async");h.push(Promise.resolve(f))}});try{A.apply(_,[v])}catch(f){return Promise.reject(f)}return Object.freeze(h),new Promise((f,g)=>{const T=setTimeout(()=>g(new Error("timeout")),this._thresholds.timeout);return Promise.all(h).then(u=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${C.identifier.value}' finished after ${Date.now()-s}ms`),clearTimeout(T),f(u)}).catch(u=>{clearTimeout(T),g(u)})}).then(f=>{const g={edits:[]};for(const T of f)if(Array.isArray(T)&&T.every(u=>u instanceof w.TextEdit))for(const{newText:u,newEol:M,range:r}of T)g.edits.push({_type:2,resource:l.uri,edit:{range:r&&I.Range.from(r),text:u,eol:M&&I.EndOfLine.from(M)}});if(g.edits.length!==0)return D===l.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(g):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=R}),define(Ee[166],_e([0,1,3,29,2,8,7]),function(oe,e,c,F,w,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class R{constructor(A,_,n,h,s){this._onDidCreate=new c.Emitter,this._onDidChange=new c.Emitter,this._onDidDelete=new c.Emitter,this._config=0,n&&(this._config+=1),h&&(this._config+=2),s&&(this._config+=4);const l=(0,F.parse)(_),d=A(D=>{if(!n)for(let v of D.created){const f=w.URI.revive(v);l(f.fsPath)&&this._onDidCreate.fire(f)}if(!h)for(let v of D.changed){const f=w.URI.revive(v);l(f.fsPath)&&this._onDidChange.fire(f)}if(!s)for(let v of D.deleted){const f=w.URI.revive(v);l(f.fsPath)&&this._onDidDelete.fire(f)}});this._disposable=t.Disposable.from(this._onDidCreate,this._onDidChange,this._onDidDelete,d)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class S{constructor(A,_,n){this._logService=_,this._extHostDocumentsAndEditors=n,this._onFileSystemEvent=new c.Emitter,this._onDidRenameFile=new c.Emitter,this._onDidCreateFile=new c.Emitter,this._onDidDeleteFile=new c.Emitter,this._onWillRenameFile=new c.AsyncEmitter,this._onWillCreateFile=new c.AsyncEmitter,this._onWillDeleteFile=new c.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(A,_,n,h){return new R(this._onFileSystemEvent.event,A,_,n,h)}$onFileEvent(A){this._onFileSystemEvent.fire(A)}$onDidRunFileOperation(A,_){switch(A){case 2:this._onDidRenameFile.fire(Object.freeze({files:_.map(n=>({oldUri:w.URI.revive(n.source),newUri:w.URI.revive(n.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:_.map(n=>w.URI.revive(n.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:_.map(n=>w.URI.revive(n.target))}));break;default:}}getOnWillRenameFileEvent(A){return this._createWillExecuteEvent(A,this._onWillRenameFile)}getOnWillCreateFileEvent(A){return this._createWillExecuteEvent(A,this._onWillCreateFile)}getOnWillDeleteFileEvent(A){return this._createWillExecuteEvent(A,this._onWillDeleteFile)}_createWillExecuteEvent(A,_){return(n,h,s)=>{const l=function(D){n.call(h,D)};return l.extension=A,_.event(l,void 0,s)}}async $onWillRunFileOperation(A,_,n,h){switch(A){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:_.map(s=>({oldUri:w.URI.revive(s.source),newUri:w.URI.revive(s.target)}))},n,h);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:_.map(s=>w.URI.revive(s.target))},n,h);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:_.map(s=>w.URI.revive(s.target))},n,h)}}async _fireWillEvent(A,_,n,h){const s=new Set,l=[];if(await A.fireAsync(_,h,async(D,v)=>{const f=Date.now(),g=await Promise.resolve(D);g instanceof t.WorkspaceEdit&&(l.push(g),s.add(v.extension.displayName??v.extension.identifier.value)),Date.now()-f>n&&this._logService.warn("SLOW file-participant",v.extension.identifier)}),h.isCancellationRequested||l.length===0)return;const d={edits:[]};for(let D of l){let{edits:v}=I.WorkspaceEdit.from(D,this._extHostDocumentsAndEditors);d.edits=d.edits.concat(v)}return{edit:d,extensionNames:Array.from(s)}}}e.ExtHostFileSystemEventService=S}),define(Ee[167],_e([0,1,10,27,2,8,7,87]),function(oe,e,c,F,w,I,t,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class S{constructor(n,h,s,l){this.start=n,this.deletedCount=h,this.deletedItems=s,this.items=l}static asApiEvents(n){return n.map(h=>({start:h.start,deletedCount:h.deletedCount,deletedItems:h.deletedItems,items:h.items.map(s=>s.apiCell)}))}}class C{constructor(n,h,s){this.notebook=n,this._extHostDocument=h,this._cellData=s,this.handle=s.handle,this.uri=w.URI.revive(s.uri),this.cellKind=s.cellKind,this._outputs=s.outputs.map(I.NotebookCellOutput.to),this._internalMetadata=s.internalMetadata??{},this._metadata=Object.freeze(s.metadata??{}),this._previousResult=Object.freeze(I.NotebookCellExecutionSummary.to(s.internalMetadata??{}))}static asModelAddData(n,h){return{EOL:h.eol,lines:h.source,languageId:h.language,uri:h.uri,isDirty:!1,versionId:1,notebook:n}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const n=this,h=this._extHostDocument.getDocument(this.uri);if(!h)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._apiCell=Object.freeze({get index(){return n.notebook.getCellIndex(n)},notebook:n.notebook.apiNotebook,kind:I.NotebookCellKind.to(this._cellData.cellKind),document:h.document,get mime(){return n._mime},set mime(s){n._mime=s},get outputs(){return n._outputs.slice(0)},get metadata(){return n._metadata},get executionSummary(){return n._previousResult}})}return this._apiCell}setOutputs(n){this._outputs=n.map(I.NotebookCellOutput.to)}setOutputItems(n,h,s){const l=s.map(I.NotebookCellOutputItem.to),d=this._outputs.find(D=>D.id===n);d&&(h||(d.items.length=0),d.items.push(...l))}setMetadata(n){this._metadata=Object.freeze(n)}setInternalMetadata(n){this._internalMetadata=n,this._previousResult=Object.freeze(I.NotebookCellExecutionSummary.to(n))}setMime(n){}}e.ExtHostCell=C;class A{constructor(n,h,s,l,d,D){this._proxy=n,this._textDocumentsAndEditors=h,this._textDocuments=s,this._emitter=l,this.uri=d,this.handle=A._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=D.viewType,this._metadata=Object.freeze(D.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,D.cells]],!0),this._versionId=D.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const n=this;this._notebook={get uri(){return n.uri},get version(){return n._versionId},get notebookType(){return n._notebookType},get isDirty(){return n._isDirty},get isUntitled(){return n.uri.scheme===c.Schemas.untitled},get isClosed(){return n._disposed},get metadata(){return n._metadata},get cellCount(){return n._cells.length},cellAt(h){return h=n._validateIndex(h),n._cells[h].apiCell},getCells(h){return(h?n._getCells(h):n._cells).map(l=>l.apiCell)},save(){return n._save()}}}return this._notebook}updateBackup(n){this._backup?.delete(),this._backup=n}disposeBackup(){this._backup?.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(n){n.metadata&&(this._metadata=Object.freeze({...this._metadata,...n.metadata}))}acceptDirty(n){this._isDirty=n}acceptModelChanged(n,h){this._versionId=n.versionId,this._isDirty=h;for(const s of n.rawEvents)s.kind===R.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(s.changes,!1):s.kind===R.NotebookCellsChangeType.Move?this._moveCell(s.index,s.newIdx):s.kind===R.NotebookCellsChangeType.Output?this._setCellOutputs(s.index,s.outputs):s.kind===R.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(s.index,s.outputId,s.append,s.outputItems):s.kind===R.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(s.index,s.language):s.kind===R.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(s.index,s.mime):s.kind===R.NotebookCellsChangeType.ChangeCellMetadata?this._changeCellMetadata(s.index,s.metadata):s.kind===R.NotebookCellsChangeType.ChangeCellInternalMetadata&&this._changeCellInternalMetadata(s.index,s.internalMetadata)}_validateIndex(n){return n=n|0,n<0?0:n>=this._cells.length?this._cells.length-1:n}_validateRange(n){let h=n.start|0,s=n.end|0;return h<0&&(h=0),s>this._cells.length&&(s=this._cells.length),n.with({start:h,end:s})}_getCells(n){n=this._validateRange(n);const h=[];for(let s=n.start;s<n.end;s++)h.push(this._cells[s]);return h}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(n,h){if(this._disposed)return;const s=[],l=[],d=[];n.reverse().forEach(D=>{const f=D[2].map(u=>{const M=new C(this,this._textDocumentsAndEditors,u);return h||l.push(C.asModelAddData(this.apiNotebook,u)),M}),g=new S(D[0],D[1],[],f),T=this._cells.splice(D[0],D[1],...f);for(const u of T)d.push(u.uri),g.deletedItems.push(u.apiCell);s.push(g)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:l,removedDocuments:d}),h||this._emitter.emitModelChange((0,F.deepFreeze)({document:this.apiNotebook,changes:S.asApiEvents(s)}))}_moveCell(n,h){const s=this._cells.splice(n,1);this._cells.splice(h,0,...s);const l=[new S(n,1,s.map(d=>d.apiCell),[]),new S(h,0,[],s)];this._emitter.emitModelChange((0,F.deepFreeze)({document:this.apiNotebook,changes:S.asApiEvents(l)}))}_setCellOutputs(n,h){const s=this._cells[n];s.setOutputs(h),this._emitter.emitCellOutputsChange((0,F.deepFreeze)({document:this.apiNotebook,cells:[s.apiCell]}))}_setCellOutputItems(n,h,s,l){const d=this._cells[n];d.setOutputItems(h,s,l),this._emitter.emitCellOutputsChange((0,F.deepFreeze)({document:this.apiNotebook,cells:[d.apiCell]}))}_changeCellLanguage(n,h){const s=this._cells[n];s.apiCell.document.languageId!==h&&this._textDocuments.$acceptModelModeChanged(s.uri,h)}_changeCellMime(n,h){const s=this._cells[n];s.apiCell.mime=h}_changeCellMetadata(n,h){const s=this._cells[n],l=s.apiCell.metadata;s.setMetadata(h);const d=s.apiCell.metadata;(0,F.equals)(l,d)||this._emitter.emitCellMetadataChange((0,F.deepFreeze)({document:this.apiNotebook,cell:s.apiCell}))}_changeCellInternalMetadata(n,h){const s=this._cells[n],l=s.internalMetadata;if(s.setInternalMetadata(h),l.runState!==h.runState){const d=h.runState??t.NotebookCellExecutionState.Idle;this._emitter.emitCellExecutionStateChange((0,F.deepFreeze)({document:this.apiNotebook,cell:s.apiCell,state:d}))}}getCellFromApiCell(n){return this._cells.find(h=>h.apiCell===n)}getCellFromIndex(n){return this._cells[n]}getCell(n){return this._cells.find(h=>h.handle===n)}getCellIndex(n){return this._cells.indexOf(n)}}e.ExtHostNotebookDocument=A,A._handlePool=0}),define(Ee[91],_e([0,1,7,8,15]),function(oe,e,c,F,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class I{constructor(S){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=S}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(S){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:S})}replaceCellMetadata(S,C){this._throwIfFinalized(),this._collectedEdits.push({editType:8,index:S,metadata:C})}replaceCells(S,C,A){this._throwIfFinalized(),!(S===C&&A.length===0)&&this._collectedEdits.push({editType:1,index:S,count:C-S,cells:A.map(F.NotebookCellData.from)})}}class t{constructor(S,C,A,_,n,h){this.id=S,this._proxy=C,this.notebookData=A,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=n,this._visibleRanges=_,this._viewColumn=h}get apiEditor(){if(!this._editor){const S=this;this._editor={get document(){return S.notebookData.apiNotebook},get selections(){return S._selections},set selections(C){if(!Array.isArray(C)||!C.every(c.NotebookRange.isNotebookRange))throw(0,w.illegalArgument)("selections");S._selections=C,S._trySetSelections(C)},get visibleRanges(){return S._visibleRanges},revealRange(C,A){S._proxy.$tryRevealRange(S.id,F.NotebookRange.from(C),A??c.NotebookEditorRevealType.Default)},get viewColumn(){return S._viewColumn},edit(C){const A=new I(this.document.version);return C(A),S._applyEdit(A.finalize())},setDecorations(C,A){return S.setDecorations(C,A)}},t.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(S){this._visible=S}_acceptVisibleRanges(S){this._visibleRanges=S}_acceptSelections(S){this._selections=S}_trySetSelections(S){this._proxy.$trySetSelections(this.id,S.map(F.NotebookRange.from))}_acceptViewColumn(S){this._viewColumn=S}_applyEdit(S){if(S.cellEdits.length===0)return Promise.resolve(!0);const C=[];let A=-1;for(let _=0;_<S.cellEdits.length;_++){if(A<0){C.push(S.cellEdits[_]),A++;continue}const h=C[A],s=S.cellEdits[_];if(h.editType===1&&s.editType===1&&h.index===s.index){h.cells.push(...S.cellEdits[_].cells),h.count+=S.cellEdits[_].count;continue}C.push(S.cellEdits[_]),A++}return this._proxy.$tryApplyEdits(this.id,S.documentVersionId,C)}setDecorations(S,C){if(!(C.isEmpty&&!this._hasDecorationsForKey.has(S.key)))return C.isEmpty?this._hasDecorationsForKey.delete(S.key):this._hasDecorationsForKey.add(S.key),this._proxy.$trySetDecorations(this.id,F.NotebookRange.from(C),S.key)}}e.ExtHostNotebookEditor=t,t.apiEditorsToExtHost=new WeakMap}),define(Ee[168],_e([0,1,8,140,121,20,42,15]),function(oe,e,c,F,w,I,t,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class S{constructor(n){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=n}async withProgress(n,h,s){const l=this._handles++,{title:d,location:D,cancellable:v}=h,f={label:(0,w.localize)(0,null,n.displayName||n.name),id:n.identifier.value};return this._proxy.$startProgress(l,{location:c.ProgressLocation.from(D),title:d,source:f,cancellable:v},n).catch(R.onUnexpectedExternalError),this._withProgress(l,s,!!v)}_withProgress(n,h,s){let l;s&&(l=new I.CancellationTokenSource,this._mapHandleToCancellationSource.set(n,l));const d=v=>{this._proxy.$progressEnd(v),this._mapHandleToCancellationSource.delete(v),l&&l.dispose()};let D;try{D=h(new A(this._proxy,n),s&&l?l.token:I.CancellationToken.None)}catch(v){throw d(n),v}return D.then(v=>d(n),v=>d(n)),D}$acceptProgressCanceled(n){const h=this._mapHandleToCancellationSource.get(n);h&&(h.cancel(),this._mapHandleToCancellationSource.delete(n))}}e.ExtHostProgress=S;function C(_,n){return _.message=n.message,typeof n.increment=="number"&&(typeof _.increment=="number"?_.increment+=n.increment:_.increment=n.increment),_}class A extends F.Progress{constructor(n,h){super(s=>this.throttledReport(s));this._proxy=n,this._handle=h}throttledReport(n){this._proxy.$progressReport(this._handle,n)}}xe([(0,t.throttle)(100,(_,n)=>C(_,n),()=>Object.create(null))],A.prototype,"throttledReport",null)}),define(Ee[92],_e([0,1,41,15,52,8,7]),function(oe,e,c,F,w,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class R{constructor(n,h,s){const l=R._Keys.nextId();n.$registerTextEditorDecorationType(h.identifier,l,I.DecorationRenderOptions.from(s)),this.value=Object.freeze({key:l,dispose(){n.$removeTextEditorDecorationType(l)}})}}e.TextEditorDecorationType=R,R._Keys=new w.IdGenerator("TextEditorDecorationType");class S{constructor(n,h){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=n,this._documentVersionId=n.version,this._undoStopBefore=h.undoStopBefore,this._undoStopAfter=h.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(n,h){this._throwIfFinalized();let s=null;if(n instanceof t.Position)s=new t.Range(n,n);else if(n instanceof t.Range)s=n;else throw new Error("Unrecognized location");this._pushEdit(s,h,!1)}insert(n,h){this._throwIfFinalized(),this._pushEdit(new t.Range(n,n),h,!0)}delete(n){this._throwIfFinalized();let h=null;if(n instanceof t.Range)h=n;else throw new Error("Unrecognized location");this._pushEdit(h,null,!0)}_pushEdit(n,h,s){const l=this._document.validateRange(n);this._collectedEdits.push({range:l,text:h,forceMoveMarkers:s})}setEndOfLine(n){if(this._throwIfFinalized(),n!==t.EndOfLine.LF&&n!==t.EndOfLine.CRLF)throw(0,F.illegalArgument)("endOfLine");this._setEndOfLine=n}}e.TextEditorEdit=S;class C{constructor(n,h,s,l){this._proxy=n,this._id=h,this._accept(s),this._logService=l;const d=this;this.value={get tabSize(){return d._tabSize},set tabSize(D){d._setTabSize(D)},get insertSpaces(){return d._insertSpaces},set insertSpaces(D){d._setInsertSpaces(D)},get cursorStyle(){return d._cursorStyle},set cursorStyle(D){d._setCursorStyle(D)},get lineNumbers(){return d._lineNumbers},set lineNumbers(D){d._setLineNumbers(D)}}}_accept(n){this._tabSize=n.tabSize,this._insertSpaces=n.insertSpaces,this._cursorStyle=n.cursorStyle,this._lineNumbers=I.TextEditorLineNumbersStyle.to(n.lineNumbers)}_validateTabSize(n){if(n==="auto")return"auto";if(typeof n=="number"){const h=Math.floor(n);return h>0?h:null}if(typeof n=="string"){const h=parseInt(n,10);return isNaN(h)?null:h>0?h:null}return null}_setTabSize(n){const h=this._validateTabSize(n);if(h!==null){if(typeof h=="number"){if(this._tabSize===h)return;this._tabSize=h}this._warnOnError("setTabSize",this._proxy.$trySetOptions(this._id,{tabSize:h}))}}_validateInsertSpaces(n){return n==="auto"?"auto":n==="false"?!1:Boolean(n)}_setInsertSpaces(n){const h=this._validateInsertSpaces(n);if(typeof h=="boolean"){if(this._insertSpaces===h)return;this._insertSpaces=h}this._warnOnError("setInsertSpaces",this._proxy.$trySetOptions(this._id,{insertSpaces:h}))}_setCursorStyle(n){this._cursorStyle!==n&&(this._cursorStyle=n,this._warnOnError("setCursorStyle",this._proxy.$trySetOptions(this._id,{cursorStyle:n})))}_setLineNumbers(n){this._lineNumbers!==n&&(this._lineNumbers=n,this._warnOnError("setLineNumbers",this._proxy.$trySetOptions(this._id,{lineNumbers:I.TextEditorLineNumbersStyle.from(n)})))}assign(n){const h={};let s=!1;if(typeof n.tabSize!="undefined"){const l=this._validateTabSize(n.tabSize);l==="auto"?(s=!0,h.tabSize=l):typeof l=="number"&&this._tabSize!==l&&(this._tabSize=l,s=!0,h.tabSize=l)}if(typeof n.insertSpaces!="undefined"){const l=this._validateInsertSpaces(n.insertSpaces);l==="auto"?(s=!0,h.insertSpaces=l):this._insertSpaces!==l&&(this._insertSpaces=l,s=!0,h.insertSpaces=l)}typeof n.cursorStyle!="undefined"&&this._cursorStyle!==n.cursorStyle&&(this._cursorStyle=n.cursorStyle,s=!0,h.cursorStyle=n.cursorStyle),typeof n.lineNumbers!="undefined"&&this._lineNumbers!==n.lineNumbers&&(this._lineNumbers=n.lineNumbers,s=!0,h.lineNumbers=I.TextEditorLineNumbersStyle.from(n.lineNumbers)),s&&this._warnOnError("setOptions",this._proxy.$trySetOptions(this._id,h))}_warnOnError(n,h){h.catch(s=>{this._logService.warn(`ExtHostTextEditorOptions '${n}' failed:'`),this._logService.warn(s)})}}e.ExtHostTextEditorOptions=C;class A{constructor(n,h,s,l,d,D,v,f){this.id=n,this._proxy=h,this._logService=s,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=d,this._options=new C(this._proxy,this.id,D,s),this._visibleRanges=v,this._viewColumn=f;const g=this;this.value=Object.freeze({get document(){return l.getValue()},set document(T){throw(0,F.readonly)("document")},get selection(){return g._selections&&g._selections[0]},set selection(T){if(!(T instanceof t.Selection))throw(0,F.illegalArgument)("selection");g._selections=[T],g._trySetSelection()},get selections(){return g._selections},set selections(T){if(!Array.isArray(T)||T.some(u=>!(u instanceof t.Selection)))throw(0,F.illegalArgument)("selections");g._selections=T,g._trySetSelection()},get visibleRanges(){return g._visibleRanges},set visibleRanges(T){throw(0,F.readonly)("visibleRanges")},get options(){return g._options.value},set options(T){g._disposed||g._options.assign(T)},get viewColumn(){return g._viewColumn},set viewColumn(T){throw(0,F.readonly)("viewColumn")},edit(T,u={undoStopBefore:!0,undoStopAfter:!0}){if(g._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const M=new S(l.getValue(),u);return T(M),g._applyEdit(M)},insertSnippet(T,u,M={undoStopBefore:!0,undoStopAfter:!0}){if(g._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let r;if(!u||Array.isArray(u)&&u.length===0)r=g._selections.map(i=>I.Range.from(i));else if(u instanceof t.Position){const{lineNumber:i,column:p}=I.Position.from(u);r=[{startLineNumber:i,startColumn:p,endLineNumber:i,endColumn:p}]}else if(u instanceof t.Range)r=[I.Range.from(u)];else{r=[];for(const i of u)if(i instanceof t.Range)r.push(I.Range.from(i));else{const{lineNumber:p,column:m}=I.Position.from(i);r.push({startLineNumber:p,startColumn:m,endLineNumber:p,endColumn:m})}}return h.$tryInsertSnippet(n,T.value,r,M)},setDecorations(T,u){const M=u.length===0;M&&!g._hasDecorationsForKey.has(T.key)||(M?g._hasDecorationsForKey.delete(T.key):g._hasDecorationsForKey.add(T.key),g._runOnProxy(()=>{if(I.isDecorationOptionsArr(u))return h.$trySetDecorations(n,T.key,I.fromRangeOrRangeWithMessage(u));{const r=new Array(4*u.length);for(let i=0,p=u.length;i<p;i++){const m=u[i];r[4*i]=m.start.line+1,r[4*i+1]=m.start.character+1,r[4*i+2]=m.end.line+1,r[4*i+3]=m.end.character+1}return h.$trySetDecorationsFast(n,T.key,r)}}))},revealRange(T,u){g._runOnProxy(()=>h.$tryRevealRange(n,I.Range.from(T),u||t.TextEditorRevealType.Default))},show(T){h.$tryShowEditor(n,I.ViewColumn.from(T))},hide(){h.$tryHideEditor(n)}})}dispose(){(0,c.ok)(!this._disposed),this._disposed=!0}_acceptOptions(n){(0,c.ok)(!this._disposed),this._options._accept(n)}_acceptVisibleRanges(n){(0,c.ok)(!this._disposed),this._visibleRanges=n}_acceptViewColumn(n){(0,c.ok)(!this._disposed),this._viewColumn=n}_acceptSelections(n){(0,c.ok)(!this._disposed),this._selections=n}async _trySetSelection(){const n=this._selections.map(I.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,n)),this.value}_applyEdit(n){const h=n.finalize();if(h.edits.length===0&&!h.setEndOfLine)return Promise.resolve(!0);const s=h.edits.map(d=>d.range);s.sort((d,D)=>d.end.line===D.end.line?d.end.character===D.end.character?d.start.line===D.start.line?d.start.character-D.start.character:d.start.line-D.start.line:d.end.character-D.end.character:d.end.line-D.end.line);for(let d=0,D=s.length-1;d<D;d++){const v=s[d].end;if(s[d+1].start.isBefore(v))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const l=h.edits.map(d=>({range:I.Range.from(d.range),text:d.text,forceMoveMarkers:d.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,h.documentVersionId,l,{setEndOfLine:typeof h.setEndOfLine=="number"?I.EndOfLine.from(h.setEndOfLine):void 0,undoStopBefore:h.undoStopBefore,undoStopAfter:h.undoStopAfter})}_runOnProxy(n){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):n().then(()=>this,h=>(h instanceof Error&&h.name==="DISPOSED"||this._logService.warn(h),null))}}e.ExtHostTextEditor=A}),define(Ee[169],_e([0,1,124,24,2,3,6,14,7,11,16,8,20,153]),function(oe,e,c,F,w,I,t,R,S,C,A,_,n,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function s(D,v){if((0,C.isString)(D))return{label:D};if(D&&typeof D=="object"&&typeof D.label=="string"){let f;return Array.isArray(D.highlights)&&(f=D.highlights.filter(g=>g.length===2&&typeof g[0]=="number"&&typeof g[1]=="number"),f=f.length?f:void 0),{label:D.label,highlights:f}}}class l{constructor(v,f,g){this._proxy=v,this.commands=f,this.logService=g,this.treeViews=new Map;function T(u){return u&&u.$treeViewId&&u.$treeItemHandle}f.registerArgumentProcessor({processArgument:u=>T(u)?this.convertArgument(u):Array.isArray(u)&&u.length>0?u.map(M=>T(M)?this.convertArgument(M):M):u})}registerTreeDataProvider(v,f,g){const T=this.createTreeView(v,{treeDataProvider:f},g);return{dispose:()=>T.dispose()}}createTreeView(v,f,g){if(!f||!f.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const T=f.dragAndDropController?.supportedMimeTypes,u=this._proxy.$registerTreeViewDataProvider(v,{showCollapseAll:!!f.showCollapseAll,canSelectMany:!!f.canSelectMany,dragAndDropMimeTypes:T}),M=this.createExtHostTreeView(v,f,g);return{get onDidCollapseElement(){return M.onDidCollapseElement},get onDidExpandElement(){return M.onDidExpandElement},get selection(){return M.selectedElements},get onDidChangeSelection(){return M.onDidChangeSelection},get visible(){return M.visible},get onDidChangeVisibility(){return M.onDidChangeVisibility},get message(){return M.message},set message(r){M.message=r},get title(){return M.title},set title(r){M.title=r},get description(){return M.description},set description(r){M.description=r},reveal:(r,i)=>M.reveal(r,i),dispose:async()=>{await u,this.treeViews.delete(v),M.dispose()}}}$getChildren(v,f){const g=this.treeViews.get(v);return g?g.getChildren(f):Promise.reject(new Error((0,c.localize)(0,null,v)))}async $onDrop(v,f,g,T,u){const M=this.treeViews.get(v);if(!M)return Promise.reject(new Error((0,c.localize)(1,null,v)));const r=h.TreeDataTransferConverter.toITreeDataTransfer(f);if(T===v&&u){const i=await M.onWillDrop(u);i&&i.forEach((p,m)=>{p&&r.set(m,p)})}return M.onDrop(r,g)}async $hasResolve(v){const f=this.treeViews.get(v);if(!f)throw new Error((0,c.localize)(2,null,v));return f.hasResolve}$resolve(v,f,g){const T=this.treeViews.get(v);if(!T)throw new Error((0,c.localize)(3,null,v));return T.resolveTreeItem(f,g)}$setExpanded(v,f,g){const T=this.treeViews.get(v);if(!T)throw new Error((0,c.localize)(4,null,v));T.setExpanded(f,g)}$setSelection(v,f){const g=this.treeViews.get(v);if(!g)throw new Error((0,c.localize)(5,null,v));g.setSelection(f)}$setVisible(v,f){const g=this.treeViews.get(v);if(!g)throw new Error((0,c.localize)(6,null,v));g.setVisible(f)}createExtHostTreeView(v,f,g){const T=new d(v,f,this._proxy,this.commands.converter,this.logService,g);return this.treeViews.set(v,T),T}convertArgument(v){const f=this.treeViews.get(v.$treeViewId);return f?f.getExtensionElement(v.$treeItemHandle):null}}e.ExtHostTreeViews=l;class d extends t.Disposable{constructor(v,f,g,T,u,M){super();if(this.viewId=v,this.proxy=g,this.commands=T,this.logService=u,this.extension=M,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new I.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new I.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new I.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new I.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new I.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new n.CancellationTokenSource,M.contributes&&M.contributes.views)for(const p in M.contributes.views)for(const m of M.contributes.views[p])m.id===v&&(this._title=m.name);this.dataProvider=f.treeDataProvider,this.dndController=f.dragAndDropController,this.dataProvider.onDidChangeTreeData2?this._register(this.dataProvider.onDidChangeTreeData2(p=>this._onDidChangeData.fire({message:!1,element:p}))):this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(p=>this._onDidChangeData.fire({message:!1,element:p})));let r,i;this._register(I.Event.debounce(this._onDidChangeData.event,(p,m)=>(p||(p={message:!1,elements:[]}),m.element!==!1&&(r||(r=new Promise(o=>i=o),this.refreshPromise=this.refreshPromise.then(()=>r)),Array.isArray(m.element)?p.elements.push(...m.element):p.elements.push(m.element)),m.message&&(p.message=!0),p),200,!0)(({message:p,elements:m})=>{m.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const o=i;return r=null,this.refresh(m).then(()=>o())})),p&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(v=>this.getExtensionElement(v)).filter(v=>!(0,C.isUndefinedOrNull)(v))}async getChildren(v){const f=v?this.getExtensionElement(v):void 0;if(v&&!f)return this.logService.error(`No tree item with id '${v}' found.`),Promise.resolve([]);let g=this.getChildrenNodes(v);return g||(g=await this.fetchChildrenNodes(f)),g?g.map(T=>T.item):void 0}getExtensionElement(v){return this.elements.get(v)}reveal(v,f){f=f||{select:!0,focus:!1};const g=(0,C.isUndefinedOrNull)(f.select)?!0:f.select,T=(0,C.isUndefinedOrNull)(f.focus)?!1:f.focus,u=(0,C.isUndefinedOrNull)(f.expand)?!1:f.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):v?this.refreshPromise.then(()=>this.resolveUnknownParentChain(v)).then(M=>this.resolveTreeNode(v,M[M.length-1]).then(r=>this.proxy.$reveal(this.viewId,{item:r.item,parentChain:M.map(i=>i.item)},{select:g,focus:T,expand:u})),M=>this.logService.error(M)):this.proxy.$reveal(this.viewId,void 0,{select:g,focus:T,expand:u})}get message(){return this._message}set message(v){this._message=v,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(v){this._title=v,this.proxy.$setTitle(this.viewId,v,this._description)}get description(){return this._description}set description(v){this._description=v,this.proxy.$setTitle(this.viewId,this._title,v)}setExpanded(v,f){const g=this.getExtensionElement(v);g&&(f?this._onDidExpandElement.fire(Object.freeze({element:g})):this._onDidCollapseElement.fire(Object.freeze({element:g})))}setSelection(v){(0,A.equals)(this._selectedHandles,v)||(this._selectedHandles=v,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(v){v!==this._visible&&(this._visible=v,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async onWillDrop(v){const f=[];for(const g of v){const T=this.getExtensionElement(g);T&&f.push(T)}if(!(!this.dndController?.onWillDrop||f.length===0))return this.dndController.onWillDrop(f)}async onDrop(v,f){const g=this.getExtensionElement(f);if(!!g)return(0,R.asPromise)(()=>this.dndController?.onDrop(v,g))}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(v,f){if(!this.dataProvider.resolveTreeItem)return;const g=this.elements.get(v);if(g){const T=this.nodes.get(g);if(T){const u=await this.dataProvider.resolveTreeItem(T.extensionItem,g,f)??T.extensionItem;return T.item.tooltip=this.getTooltip(u.tooltip),T.item.command=this.getCommand(T.disposableStore,u.command),T.item}}}resolveUnknownParentChain(v){return this.resolveParent(v).then(f=>f?this.resolveUnknownParentChain(f).then(g=>this.resolveTreeNode(f,g[g.length-1]).then(T=>(g.push(T),g))):Promise.resolve([]))}resolveParent(v){const f=this.nodes.get(v);return f?Promise.resolve(f.parent?this.elements.get(f.parent.item.handle):void 0):(0,R.asPromise)(()=>this.dataProvider.getParent(v))}resolveTreeNode(v,f){const g=this.nodes.get(v);return g?Promise.resolve(g):(0,R.asPromise)(()=>this.dataProvider.getTreeItem(v)).then(T=>this.createHandle(v,T,f,!0)).then(T=>this.getChildren(f?f.item.handle:void 0).then(()=>{const u=this.getExtensionElement(T);if(u){const M=this.nodes.get(u);if(M)return Promise.resolve(M)}throw new Error(`Cannot resolve tree item for element ${T}`)}))}getChildrenNodes(v){if(v){let f;if(typeof v=="string"){const g=this.getExtensionElement(v);f=g?this.nodes.get(g):void 0}else f=v;return f&&f.children||void 0}return this.roots}async fetchChildrenNodes(v){this.clearChildren(v);const f=new n.CancellationTokenSource(this._refreshCancellationSource.token);try{const g=v?this.nodes.get(v):void 0,T=await this.dataProvider.getChildren(v);if(f.token.isCancellationRequested)return;const u=await Promise.all((0,A.coalesce)(T||[]).map(async M=>{const r=await this.dataProvider.getTreeItem(M);return r&&!f.token.isCancellationRequested?this.createAndRegisterTreeNode(M,r,g):null}));return f.token.isCancellationRequested?void 0:(0,A.coalesce)(u)}finally{f.dispose()}}refresh(v){if(v.some(g=>!g))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new n.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const g=this.getHandlesToRefresh(v);if(g.length)return this.refreshHandles(g)}return Promise.resolve(void 0)}getHandlesToRefresh(v){const f=new Set,g=v.map(u=>this.nodes.get(u));for(const u of g)if(u&&!f.has(u.item.handle)){let M=u;for(;M&&M.parent&&g.findIndex(r=>M&&M.parent&&r&&r.item.handle===M.parent.item.handle)===-1;){const r=this.elements.get(M.parent.item.handle);M=r?this.nodes.get(r):void 0}M&&!M.parent&&f.add(u.item.handle)}const T=[];return f.forEach(u=>{const M=this.elements.get(u);if(M){const r=this.nodes.get(M);r&&(!r.parent||!f.has(r.parent.item.handle))&&T.push(u)}}),T}refreshHandles(v){const f={};return Promise.all(v.map(g=>this.refreshNode(g).then(T=>{T&&(f[g]=T.item)}))).then(()=>Object.keys(f).length?this.proxy.$refresh(this.viewId,f):void 0)}refreshNode(v){const f=this.getExtensionElement(v);if(f){const g=this.nodes.get(f);if(g)return this.clearChildren(f),(0,R.asPromise)(()=>this.dataProvider.getTreeItem(f)).then(T=>{if(T){const u=this.createTreeNode(f,T,g.parent);return this.updateNodeCache(f,u,g,g.parent),g.dispose(),u}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(v,f,g){const T=this.createTreeNode(v,f,g);if(f.id&&this.elements.has(T.item.handle))throw new Error((0,c.localize)(7,null,f.id));return this.addNodeToCache(v,T),this.addNodeToParentCache(T,g),T}getTooltip(v){return S.MarkdownString.isMarkdownString(v)?_.MarkdownString.from(v):v}getCommand(v,f){return f?this.commands.toInternal(f,v):void 0}createTreeNode(v,f,g){const T=new t.DisposableStore,u=this.createHandle(v,f,g),M=this.getLightIconPath(f);return{item:{handle:u,parentHandle:g?g.item.handle:void 0,label:s(f.label,this.extension),description:f.description,resourceUri:f.resourceUri,tooltip:this.getTooltip(f.tooltip),command:this.getCommand(T,f.command),contextValue:f.contextValue,icon:M,iconDark:this.getDarkIconPath(f)||M,themeIcon:this.getThemeIcon(f),collapsibleState:(0,C.isUndefinedOrNull)(f.collapsibleState)?S.TreeItemCollapsibleState.None:f.collapsibleState,accessibilityInformation:f.accessibilityInformation},extensionItem:f,parent:g,children:void 0,disposableStore:T,dispose(){T.dispose()}}}getThemeIcon(v){return v.iconPath instanceof S.ThemeIcon?v.iconPath:void 0}createHandle(v,{id:f,label:g,resourceUri:T},u,M){if(f)return`${d.ID_HANDLE_PREFIX}/${f}`;const r=s(g,this.extension),i=u?u.item.handle:d.LABEL_HANDLE_PREFIX;let p=r?r.label:T?(0,F.basename)(T):"";p=p.indexOf("/")!==-1?p.replace("/","//"):p;const m=this.nodes.has(v)?this.nodes.get(v).item.handle:void 0,o=this.getChildrenNodes(u)||[];let b,a=0;do{if(b=`${i}/${a}:${p}`,M||!this.elements.has(b)||m===b)break;a++}while(a<=o.length);return b}getLightIconPath(v){if(v.iconPath&&!(v.iconPath instanceof S.ThemeIcon))return typeof v.iconPath=="string"||w.URI.isUri(v.iconPath)?this.getIconPath(v.iconPath):this.getIconPath(v.iconPath.light)}getDarkIconPath(v){if(v.iconPath&&!(v.iconPath instanceof S.ThemeIcon)&&v.iconPath.dark)return this.getIconPath(v.iconPath.dark)}getIconPath(v){return w.URI.isUri(v)?v:w.URI.file(v)}addNodeToCache(v,f){this.elements.set(f.item.handle,v),this.nodes.set(v,f)}updateNodeCache(v,f,g,T){this.elements.delete(f.item.handle),this.nodes.delete(v),f.item.handle!==g.item.handle&&this.elements.delete(g.item.handle),this.addNodeToCache(v,f);const u=this.getChildrenNodes(T)||[],M=u.filter(r=>r.item.handle===g.item.handle)[0];M&&u.splice(u.indexOf(M),1,f)}addNodeToParentCache(v,f){f?(f.children||(f.children=[]),f.children.push(v)):(this.roots||(this.roots=[]),this.roots.push(v))}clearChildren(v){if(v){const f=this.nodes.get(v);if(f){if(f.children)for(const g of f.children){const T=this.elements.get(g.item.handle);T&&this.clear(T)}f.children=void 0}}else this.clearAll()}clear(v){const f=this.nodes.get(v);if(f){if(f.children)for(const g of f.children){const T=this.elements.get(g.item.handle);T&&this.clear(T)}this.nodes.delete(v),this.elements.delete(f.item.handle),f.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(v=>v.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}d.LABEL_HANDLE_PREFIX="0",d.ID_HANDLE_PREFIX="1"}),define(Ee[170],_e([0,1,14,3,6,11,48,8,88,67]),function(oe,e,c,F,w,I,t,R,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=void 0;class A extends w.Disposable{constructor(n){super();this.controllerId=n,this.debounceSendDiff=this._register(new c.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new F.Emitter),this.root=new t.TestItemRootImpl(this.controllerId,this.controllerId),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(n){this._resolveHandler=n;for(const h of this.tree.values())this.updateExpandability(h)}collectDiff(){const n=this.diff;return this.diff=[],n}pushDiff(n){const h=this.diff[this.diff.length-1];if(h&&n[0]===1){if(h[0]===1&&h[1].extId===n[1].extId){(0,S.applyTestItemUpdate)(h[1],n[1]);return}if(h[0]===0&&h[1].item.extId===n[1].extId){(0,S.applyTestItemUpdate)(h[1],n[1]);return}}this.diff.push(n),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(n,h){const s=this.tree.get(n);if(!!s){if((s.expandLevels===void 0||h>s.expandLevels)&&(s.expandLevels=h),s.expand===1){const l=this.resolveChildren(s);return l.isOpen()?this.expandChildren(s,h-1):l.wait().then(()=>this.expandChildren(s,h-1))}else if(s.expand===3)return s.resolveBarrier?.isOpen()===!1?s.resolveBarrier.wait().then(()=>this.expandChildren(s,h-1)):this.expandChildren(s,h-1)}}dispose(){for(const n of this.tree.values())(0,t.getPrivateApiFor)(n.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(n,h){switch(h.op){case 2:this.pushDiff([4,n.fullId.toString()]);break;case 1:this.removeItem(C.TestId.joinToString(n.fullId,h.id));break;case 0:this.upsertItem(h.item,n);break;case 4:for(const v of h.ops)this.onTestItemEvent(n,v);break;case 3:const{key:s,value:l,previous:d}=h,D=n.fullId.toString();switch(s){case"canResolveChildren":this.updateExpandability(n);break;case"tags":this.diffTagRefs(l,d,D);break;case"range":this.pushDiff([1,{extId:D,item:{range:R.Range.from(l)}}]);break;case"error":this.pushDiff([1,{extId:D,item:{error:R.MarkdownString.fromStrict(l)||null}}]);break;default:this.pushDiff([1,{extId:D,item:{[s]:l??null}}]);break}break;default:(0,I.assertNever)(h)}}upsertItem(n,h){if(!(n instanceof t.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${n.id} did not`);const s=C.TestId.fromExtHostTestItem(n,this.root.id,h?.actual),l=(0,t.getPrivateApiFor)(n);l.parent&&l.parent!==h?.actual&&l.parent.children.delete(n.id);let d=this.tree.get(s.toString());if(!d){d={fullId:s,actual:n,parent:h?s.parentId:null,expandLevels:h?.expandLevels?h.expandLevels-1:void 0,expand:0},n.tags.forEach(this.incrementTagRefs,this),this.tree.set(d.fullId.toString(),d),this.setItemParent(n,h),this.pushDiff([0,{parent:d.parent&&d.parent.toString(),controllerId:this.controllerId,expand:d.expand,item:R.TestItem.from(n)}]),this.connectItemAndChildren(n,d,h);return}if(d.actual===n){this.connectItem(n,d,h);return}const D=d.actual.children,v=d.actual,f=(0,t.diffTestItems)(v,n);(0,t.getPrivateApiFor)(v).listener=void 0,d.actual=n,d.expand=0;for(const[g,T]of f)this.onTestItemEvent(d,{op:3,key:g,value:T,previous:v[g]});this.connectItemAndChildren(n,d,h);for(const g of D)n.children.get(g.id)||this.removeItem(C.TestId.joinToString(s,g.id))}diffTagRefs(n,h,s){const l=new Set(h.map(d=>d.id));for(const d of n)l.delete(d.id)||this.incrementTagRefs(d);this.pushDiff([1,{extId:s,item:{tags:n.map(d=>R.TestTag.namespace(this.controllerId,d.id))}}]),l.forEach(this.decrementTagRefs,this)}incrementTagRefs(n){const h=this.tags.get(n.id);h?h.refCount++:(this.tags.set(n.id,{refCount:1}),this.pushDiff([5,{id:R.TestTag.namespace(this.controllerId,n.id),ctrlLabel:this.root.label}]))}decrementTagRefs(n){const h=this.tags.get(n);h&&!--h.refCount&&(this.tags.delete(n),this.pushDiff([6,R.TestTag.namespace(this.controllerId,n)]))}setItemParent(n,h){(0,t.getPrivateApiFor)(n).parent=h&&h.actual!==this.root?h.actual:void 0}connectItem(n,h,s){this.setItemParent(n,s);const l=(0,t.getPrivateApiFor)(n);l.parent=s?.actual,l.listener=d=>this.onTestItemEvent(h,d),this.updateExpandability(h)}connectItemAndChildren(n,h,s){this.connectItem(n,h,s);for(const l of n.children)this.upsertItem(l,h)}updateExpandability(n){let h;this._resolveHandler?n.resolveBarrier?h=n.resolveBarrier.isOpen()?3:2:h=n.actual.canResolveChildren?1:0:h=0,h!==n.expand&&(n.expand=h,this.pushDiff([1,{extId:n.fullId.toString(),expand:h}]),h===1&&n.expandLevels!==void 0&&this.resolveChildren(n))}expandChildren(n,h){if(h<0)return;const s=[];for(const l of n.actual.children){const d=this.expand(C.TestId.joinToString(n.fullId,l.id),h);(0,c.isThenable)(d)&&s.push(d)}if(s.length)return Promise.all(s).then(()=>{})}resolveChildren(n){if(n.resolveBarrier)return n.resolveBarrier;if(!this._resolveHandler){const d=new c.Barrier;return d.open(),d}n.expand=2,this.pushExpandStateUpdate(n);const h=n.resolveBarrier=new c.Barrier,s=d=>{console.error(`Unhandled error in resolveHandler of test controller "${this.controllerId}"`),n.actual!==this.root&&(n.actual.error=d.stack||d.message||String(d))};let l;try{l=this._resolveHandler(n.actual===this.root?void 0:n.actual)}catch(d){s(d)}return(0,c.isThenable)(l)?l.catch(s).then(()=>{h.open(),this.updateExpandability(n)}):(h.open(),this.updateExpandability(n)),n.resolveBarrier}pushExpandStateUpdate(n){this.pushDiff([1,{extId:n.fullId.toString(),expand:n.expand}])}removeItem(n){const h=this.tree.get(n);if(!h)throw new Error("attempting to remove non-existent child");this.pushDiff([2,n]);const s=[h];for(;s.length;){const l=s.pop();if(!!l){(0,t.getPrivateApiFor)(l.actual).listener=void 0;for(const d of l.actual.tags)this.decrementTagRefs(d.id);this.tree.delete(l.fullId.toString());for(const d of l.actual.children)s.push(this.tree.get(C.TestId.joinToString(l.fullId,d.id)))}}}flushDiff(){const n=this.collectDiff();n.length&&this.diffOpEmitter.fire(n)}}e.SingleUseTestCollection=A}),define(Ee[171],_e([0,1,4,136]),function(oe,e,c,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,c.refineServiceDecorator)(F.IEnvironmentService)}),define(Ee[172],_e([0,1,25,3,17]),function(oe,e,c,F,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class I{constructor(A){this.removedDueToLooping=A}}e.DeltaExtensionsResult=I;class t{constructor(A){this._onDidChange=new F.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=A,this._initialize()}_initialize(){this._extensionDescriptions.sort(S),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const A of this._extensionDescriptions){if(this._extensionsMap.has(c.ExtensionIdentifier.toKey(A.identifier))){console.error("Extension `"+A.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(c.ExtensionIdentifier.toKey(A.identifier),A),this._extensionsArr.push(A),Array.isArray(A.activationEvents))for(let _ of A.activationEvents)_==="onUri"&&(_=`onUri:${c.ExtensionIdentifier.toKey(A.identifier)}`),this._activationMap.has(_)||this._activationMap.set(_,[]),this._activationMap.get(_).push(A)}}keepOnly(A){const _=new Set;A.forEach(n=>_.add(c.ExtensionIdentifier.toKey(n))),this._extensionDescriptions=this._extensionDescriptions.filter(n=>_.has(c.ExtensionIdentifier.toKey(n.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(A,_){A.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(A));const n=t._findLoopingExtensions(this._extensionDescriptions);if(_=_.concat(n.map(h=>h.identifier)),_.length>0){const h=new Set;_.forEach(s=>h.add(c.ExtensionIdentifier.toKey(s))),this._extensionDescriptions=this._extensionDescriptions.filter(s=>!h.has(c.ExtensionIdentifier.toKey(s.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new I(n)}static _findLoopingExtensions(A){const _=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(d){this._nodesSet.has(d)||(this._nodesSet.add(d),this._nodesArr.push(d))}addArc(d,D){this.addNode(d),this.addNode(D),this._arcs.has(d)?this._arcs.get(d).push(D):this._arcs.set(d,[D])}getArcs(d){return this._arcs.has(d)?this._arcs.get(d):[]}hasOnlyGoodArcs(d,D){const v=_.getArcs(d);for(let f=0;f<v.length;f++)if(!D.has(v[f]))return!1;return!0}getNodes(){return this._nodesArr}};let n=new Map;for(let d of A){const D=c.ExtensionIdentifier.toKey(d.identifier);if(n.set(D,d),d.extensionDependencies)for(let v of d.extensionDependencies){const f=c.ExtensionIdentifier.toKey(v);_.addArc(D,f)}}let h=new Set;_.getNodes().filter(d=>_.getArcs(d).length===0).forEach(d=>h.add(d));let s=_.getNodes().filter(d=>!h.has(d)),l;do{l=!1;for(let d=0;d<s.length;d++){const D=s[d];_.hasOnlyGoodArcs(D,h)&&(s.splice(d,1),d--,h.add(D),l=!0)}}while(l);return s.map(d=>n.get(d))}containsActivationEvent(A){return this._activationMap.has(A)}containsExtension(A){return this._extensionsMap.has(c.ExtensionIdentifier.toKey(A))}getExtensionDescriptionsForActivationEvent(A){const _=this._activationMap.get(A);return _?_.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(A){const _=this._extensionsMap.get(c.ExtensionIdentifier.toKey(A));return _||void 0}}e.ExtensionDescriptionRegistry=t;var R;(function(C){C[C.Builtin=0]="Builtin",C[C.User=1]="User",C[C.Dev=2]="Dev"})(R||(R={}));function S(C,A){const _=C.isBuiltin?0:C.isUnderDevelopment?2:1,n=A.isBuiltin?0:A.isUnderDevelopment?2:1;if(_!==n)return _-n;const h=w.posix.basename(C.extensionLocation.path),s=w.posix.basename(A.extensionLocation.path);return h<s?-1:h>s?1:0}}),define(Ee[173],_e([0,1,22]),function(oe,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var F;(function(R){R[R.VersionMismatch=55]="VersionMismatch",R[R.UnexpectedError=81]="UnexpectedError"})(F=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var w;(function(R){R[R.Initialized=0]="Initialized",R[R.Ready=1]="Ready",R[R.Terminate=2]="Terminate"})(w=e.MessageType||(e.MessageType={}));function I(R){const S=c.VSBuffer.alloc(1);switch(R){case 0:S.writeUInt8(1,0);break;case 1:S.writeUInt8(2,0);break;case 2:S.writeUInt8(3,0);break}return S}e.createMessageOfType=I;function t(R,S){if(R.byteLength!==1)return!1;switch(R.readUInt8(0)){case 1:return S===0;case 2:return S===1;case 3:return S===2;default:return!1}}e.isMessageOfType=t}),define(Ee[26],_e([0,1,3,2,4,25,143]),function(oe,e,c,F,w,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.extensionRunningLocationToString=e.ExtensionRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new I.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:F.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,w.createDecorator)("extensionService");var R;(function(g){g[g.None=0]="None",g[g.LocalProcess=1]="LocalProcess",g[g.LocalWebWorker=2]="LocalWebWorker",g[g.Remote=3]="Remote"})(R=e.ExtensionRunningLocation||(e.ExtensionRunningLocation={}));function S(g){switch(g){case 0:return"None";case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionRunningLocationToString=S;class C{constructor(T){this.dependency=T}}e.MissingExtensionDependency=C;var A;(function(g){g[g.LocalProcess=0]="LocalProcess",g[g.LocalWebWorker=1]="LocalWebWorker",g[g.Remote=2]="Remote"})(A=e.ExtensionHostKind||(e.ExtensionHostKind={}));function _(g){switch(g){case 0:return"LocalProcess";case 1:return"LocalWebWorker";case 2:return"Remote"}}e.extensionHostKindToString=_;function n(g,T){return!0}e.isProposedApiEnabled=n;function h(g,T){if(!n(g,T))throw new Error(`Extension '${g.identifier.value}' CANNOT use API proposal: ${T}.
Its package.json#enabledApiProposals-property declares: ${g.enabledApiProposals?.join(", ")??"[]"} but NOT ${T}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${g.identifier.value}`)}e.checkProposedApiEnabled=h;class s{constructor(T,u,M,r){this.codeLoadingTime=T,this.activateCallTime=u,this.activateResolvedTime=M,this.activationReason=r}}e.ActivationTimes=s;class l{constructor(T,u){this.description=T,this.value=u}}e.ExtensionPointContribution=l,e.ExtensionHostLogFileName="exthost";var d;(function(g){g[g.Normal=0]="Normal",g[g.Immediate=1]="Immediate"})(d=e.ActivationKind||(e.ActivationKind={}));function D(g){return{type:g.isBuiltin?0:1,isBuiltin:g.isBuiltin||g.isUserBuiltin,identifier:{id:(0,t.getGalleryExtensionId)(g.publisher,g.name),uuid:g.uuid},manifest:g,location:g.extensionLocation}}e.toExtension=D;function v(g,T){return{identifier:new I.ExtensionIdentifier(g.identifier.id),isBuiltin:g.type===0,isUserBuiltin:g.type===1&&g.isBuiltin,isUnderDevelopment:!!T,extensionLocation:g.location,...g.manifest,uuid:g.identifier.uuid}}e.toExtensionDescription=v;class f{constructor(){this.onDidRegisterExtensions=c.Event.None,this.onDidChangeExtensionsStatus=c.Event.None,this.onDidChangeExtensions=c.Event.None,this.onWillActivateByEvent=c.Event.None,this.onDidChangeResponsiveChange=c.Event.None}activateByEvent(T){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(T){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(T){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(T){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(T,u){return Promise.resolve()}_onWillActivateExtension(T){}_onDidActivateExtension(T,u,M,r,i){}_onDidActivateExtensionError(T,u){}_onExtensionRuntimeError(T,u){}_onExtensionHostExit(T){}}e.NullExtensionService=f}),define(Ee[174],_e([0,1,15,25,26,12]),function(oe,e,c,F,w,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const t=Promise.resolve(void 0);class R{constructor(l,d,D,v){this.startup=l,this.codeLoadingTime=d,this.activateCallTime=D,this.activateResolvedTime=v}}e.ExtensionActivationTimes=R,R.NONE=new R(!1,-1,-1,-1);class S{constructor(l){this._startup=l,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(l,d){return l===-1||d===-1?-1:d-l}build(){return new R(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=S;class C{constructor(l,d,D,v,f,g){this.activationFailed=l,this.activationFailedError=d,this.activationTimes=D,this.module=v,this.exports=f,this.subscriptions=g}}e.ActivatedExtension=C;class A extends C{constructor(l){super(!1,null,l,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=A;class _ extends C{constructor(){super(!1,null,R.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=_;class n extends C{constructor(l){super(!0,l,R.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=n;let h=class{constructor(l,d,D,v,f){this._logService=f,this._isDisposed=!1,this._registry=l,this._resolvedExtensionsSet=new Set,d.forEach(g=>this._resolvedExtensionsSet.add(F.ExtensionIdentifier.toKey(g))),this._hostExtensionsMap=new Map,D.forEach(g=>this._hostExtensionsMap.set(F.ExtensionIdentifier.toKey(g),g)),this._host=v,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}dispose(){this._isDisposed=!0}isActivated(l){const d=F.ExtensionIdentifier.toKey(l);return this._activatedExtensions.has(d)}getActivatedExtension(l){const d=F.ExtensionIdentifier.toKey(l),D=this._activatedExtensions.get(d);if(!D)throw new Error("Extension `"+l.value+"` is not known or not activated");return D}activateByEvent(l,d){if(this._alreadyActivatedEvents[l])return t;const D=this._registry.getExtensionDescriptionsForActivationEvent(l);return this._activateExtensions(D.map(v=>({id:v.identifier,reason:{startup:d,extensionId:v.identifier,activationEvent:l}}))).then(()=>{this._alreadyActivatedEvents[l]=!0})}activateById(l,d){const D=this._registry.getExtensionDescription(l);if(!D)throw new Error("Extension `"+l+"` is not known");return this._activateExtensions([{id:D.identifier,reason:d}])}_handleActivateRequest(l,d,D){if(this._hostExtensionsMap.has(F.ExtensionIdentifier.toKey(l.id))){d[F.ExtensionIdentifier.toKey(l.id)]=l;return}const v=this._registry.getExtensionDescription(l.id);if(!v){const T=new Error(`Cannot activate unknown extension '${l.id.value}'`);this._host.onExtensionActivationError(l.id,T,new w.MissingExtensionDependency(l.id.value)),this._activatedExtensions.set(F.ExtensionIdentifier.toKey(l.id),new n(T));return}const f=typeof v.extensionDependencies=="undefined"?[]:v.extensionDependencies;let g=!0;for(let T=0,u=f.length;T<u;T++){const M=f[T];if(this._resolvedExtensionsSet.has(F.ExtensionIdentifier.toKey(M)))continue;const r=this._activatedExtensions.get(F.ExtensionIdentifier.toKey(M));if(r&&!r.activationFailed)continue;if(r&&r.activationFailed){const o=v.displayName||v.identifier.value,b=this._registry.getExtensionDescription(M),a=b&&b.displayName||M,E=new Error(`Cannot activate the '${o}' extension because its dependency '${a}' failed to activate`);E.detail=r.activationFailedError,this._host.onExtensionActivationError(v.identifier,E,null),this._activatedExtensions.set(F.ExtensionIdentifier.toKey(v.identifier),new n(E));return}if(this._hostExtensionsMap.has(F.ExtensionIdentifier.toKey(M))){g=!1,d[F.ExtensionIdentifier.toKey(M)]={id:this._hostExtensionsMap.get(F.ExtensionIdentifier.toKey(M)),reason:l.reason};continue}const i=this._registry.getExtensionDescription(M);if(i){if(!i.main&&!i.browser)continue;g=!1,d[F.ExtensionIdentifier.toKey(M)]={id:i.identifier,reason:l.reason};continue}const p=v.displayName||v.identifier.value,m=new Error(`Cannot activate the '${p}' extension because it depends on unknown extension '${M}'`);this._host.onExtensionActivationError(v.identifier,m,new w.MissingExtensionDependency(M)),this._activatedExtensions.set(F.ExtensionIdentifier.toKey(v.identifier),new n(m));return}g?d[F.ExtensionIdentifier.toKey(v.identifier)]=l:D.push(l)}_activateExtensions(l){if(l.length===0||(l=l.filter(f=>!this._activatedExtensions.has(F.ExtensionIdentifier.toKey(f.id))),l.length===0))return Promise.resolve(void 0);const d=Object.create(null),D=[];for(let f=0,g=l.length;f<g;f++)this._handleActivateRequest(l[f],d,D);for(let f=0,g=D.length;f<g;f++){const T=F.ExtensionIdentifier.toKey(D[f].id);d[T]&&delete d[T]}const v=Object.keys(d).map(f=>d[f]);return D.length===0?Promise.all(v.map(f=>this._activateExtension(f.id,f.reason))).then(f=>{}):this._activateExtensions(v).then(f=>this._activateExtensions(D))}_activateExtension(l,d){const D=F.ExtensionIdentifier.toKey(l);if(this._activatedExtensions.has(D))return Promise.resolve(void 0);const v=this._activatingExtensions.get(D);if(v)return v;const f=this._host.actualActivateExtension(l,d).then(void 0,g=>{const T=new Error;return g&&g.name&&(T.name=g.name),g&&g.message?T.message=`Activating extension '${l.value}' failed: ${g.message}.`:T.message=`Activating extension '${l.value}' failed: ${g}.`,g&&g.stack&&(T.stack=g.stack),this._isDisposed&&c.isPromiseCanceledError(g)?new n(g):(this._host.onExtensionActivationError(l,T,null),this._logService.error(`Activating extension ${l.value} failed due to an error:`),this._logService.error(g),new n(g))}).then(g=>{this._activatedExtensions.set(D,g),this._activatingExtensions.delete(D)});return this._activatingExtensions.set(D,f),f}};h=xe([$e(4,I.ILogService)],h),e.ExtensionsActivator=h}),define(Ee[175],_e([0,1,12,28,26]),function(oe,e,c,F,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let I=class extends c.LogService{constructor(R,S){super(R.createLogger(S.logFile,{name:w.ExtensionHostLogFileName}))}};I=xe([$e(0,c.ILoggerService),$e(1,F.IExtHostInitDataService)],I),e.ExtHostLogService=I}),define(Ee[176],_e([0,1,15]),function(oe,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class F{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((I,t)=>{this._actualOk=I,this._actualErr=t,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(I){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=I,this._actual&&this._actualOk(I))}resolveErr(I){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=I,this._actual?this._actualErr(I):(0,c.onUnexpectedError)(I))}then(I,t){return this._ensureActual().then(I,t)}catch(I){return this._ensureActual().then(void 0,I)}finally(I){return this._ensureActual().finally(I)}}e.LazyPromise=F}),define(Ee[37],_e([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class c{constructor(C,A){this._proxyIdentifierBrand=void 0,this.isMain=C,this.sid=A,this.nid=++c.count}}e.ProxyIdentifier=c,c.count=0;const F=[];function w(S){const C=new c(!0,S);return F[C.nid]=C,C}e.createMainContextProxyIdentifier=w;function I(S){const C=new c(!1,S);return F[C.nid]=C,C}e.createExtHostContextProxyIdentifier=I;function t(S){return F[S].sid}e.getStringIdentifierForProxy=t;class R{constructor(C){this.value=C}}e.SerializableObjectWithBuffers=R}),define(Ee[5],_e([0,1,54,2,37]),function(oe,e,c,F,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var I;(function(f){f[f.Desktop=1]="Desktop",f[f.Web=2]="Web"})(I=e.UIKind||(e.UIKind={}));var t;(function(f){f[f.Default=0]="Default",f[f.InCenter=1]="InCenter",f[f.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",f[f.AtTop=3]="AtTop"})(t=e.TextEditorRevealType||(e.TextEditorRevealType={}));var R;(function(f){f[f.Editable=0]="Editable",f[f.SupportsHotExit=1]="SupportsHotExit"})(R=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var S;(function(f){f[f.Int8Array=1]="Int8Array",f[f.Uint8Array=2]="Uint8Array",f[f.Uint8ClampedArray=3]="Uint8ClampedArray",f[f.Int16Array=4]="Int16Array",f[f.Uint16Array=5]="Uint16Array",f[f.Int32Array=6]="Int32Array",f[f.Uint32Array=7]="Uint32Array",f[f.Float32Array=8]="Float32Array",f[f.Float64Array=9]="Float64Array",f[f.BigInt64Array=10]="BigInt64Array",f[f.BigUint64Array=11]="BigUint64Array"})(S=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var C;(function(f){f[f.Text=1]="Text",f[f.Error=2]="Error",f[f.Rich=3]="Rich"})(C=e.CellOutputKind||(e.CellOutputKind={}));var A;(function(f){f[f.Default=0]="Default",f[f.InCenter=1]="InCenter",f[f.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",f[f.AtTop=3]="AtTop"})(A=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var _;(function(f){f[f.None=0]="None",f[f.Process=1]="Process",f[f.Output=2]="Output"})(_=e.CandidatePortSource||(e.CandidatePortSource={}));var n;(function(f){f.name="$ident";function g(u,M){return Object.defineProperty(u,f.name,{value:M,enumerable:!0}),u}f.mixin=g;function T(u){return u[f.name]}f.of=T})(n=e.ObjectIdentifier||(e.ObjectIdentifier={}));class h{static mixin(g){return g._id=h._n++,g}}e.IdObject=h,h._n=0;var s;(function(f){f.label="a",f.kind="b",f.detail="c",f.documentation="d",f.sortText="e",f.filterText="f",f.preselect="g",f.insertText="h",f.insertTextRules="i",f.range="j",f.commitCharacters="k",f.additionalTextEdits="l",f.command="m",f.kindModifier="n"})(s=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var l;(function(f){f.defaultRanges="a",f.completions="b",f.isIncomplete="c",f.duration="d"})(l=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var d;(function(f){f[f.File=1]="File",f[f.Text=2]="Text",f[f.Cell=3]="Cell"})(d=e.WorkspaceEditType||(e.WorkspaceEditType={}));function D(f){if(f&&f.edits)for(const g of f.edits)typeof g.resource=="object"?g.resource=F.URI.revive(g.resource):(g.newUri=F.URI.revive(g.newUri),g.oldUri=F.URI.revive(g.oldUri)),g.metadata&&g.metadata.iconPath&&(g.metadata=(0,c.revive)(g.metadata));return f}e.reviveWorkspaceEditDto=D;var v;(function(f){f[f.Workspace=0]="Workspace",f[f.TextDocument=1]="TextDocument"})(v=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,w.createMainContextProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,w.createMainContextProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,w.createMainContextProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,w.createMainContextProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,w.createMainContextProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,w.createMainContextProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,w.createMainContextProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,w.createMainContextProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,w.createMainContextProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,w.createMainContextProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,w.createMainContextProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,w.createMainContextProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,w.createMainContextProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,w.createMainContextProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,w.createMainContextProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,w.createMainContextProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,w.createMainContextProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,w.createMainContextProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,w.createMainContextProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,w.createMainContextProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,w.createMainContextProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,w.createMainContextProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,w.createMainContextProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,w.createMainContextProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,w.createMainContextProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,w.createMainContextProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,w.createMainContextProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,w.createMainContextProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,w.createMainContextProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,w.createMainContextProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,w.createMainContextProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,w.createMainContextProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,w.createMainContextProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,w.createMainContextProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,w.createMainContextProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,w.createMainContextProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,w.createMainContextProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,w.createMainContextProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,w.createMainContextProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,w.createMainContextProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,w.createMainContextProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,w.createMainContextProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,w.createMainContextProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,w.createMainContextProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,w.createMainContextProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,w.createMainContextProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,w.createMainContextProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,w.createMainContextProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,w.createMainContextProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,w.createMainContextProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,w.createMainContextProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,w.createMainContextProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,w.createMainContextProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,w.createMainContextProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,w.createMainContextProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,w.createMainContextProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,w.createExtHostContextProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,w.createExtHostContextProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,w.createExtHostContextProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,w.createExtHostContextProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,w.createExtHostContextProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,w.createExtHostContextProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,w.createExtHostContextProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,w.createExtHostContextProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,w.createExtHostContextProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,w.createExtHostContextProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,w.createExtHostContextProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,w.createExtHostContextProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,w.createExtHostContextProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,w.createExtHostContextProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,w.createExtHostContextProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,w.createExtHostContextProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,w.createExtHostContextProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,w.createExtHostContextProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,w.createExtHostContextProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,w.createExtHostContextProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,w.createExtHostContextProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,w.createExtHostContextProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,w.createExtHostContextProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,w.createExtHostContextProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,w.createExtHostContextProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,w.createExtHostContextProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,w.createExtHostContextProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,w.createExtHostContextProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,w.createExtHostContextProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,w.createExtHostContextProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,w.createExtHostContextProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,w.createMainContextProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,w.createMainContextProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,w.createMainContextProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,w.createMainContextProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,w.createExtHostContextProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,w.createExtHostContextProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,w.createMainContextProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,w.createMainContextProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,w.createMainContextProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,w.createMainContextProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,w.createMainContextProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,w.createMainContextProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,w.createMainContextProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,w.createMainContextProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,w.createMainContextProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,w.createMainContextProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,w.createMainContextProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,w.createMainContextProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,w.createMainContextProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,w.createMainContextProxyIdentifier)("ExtHostTelemetry")}}),define(Ee[68],_e([0,1,5,3,4]),function(oe,e,c,F,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class I{constructor(R){this._onDidChangePassword=new F.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=R.getProxy(c.MainContext.MainThreadSecretState)}async $onDidChangePassword(R){this._onDidChangePassword.fire(R)}get(R,S){return this._proxy.$getPassword(R,S)}store(R,S,C){return this._proxy.$setPassword(R,S,C)}delete(R,S){return this._proxy.$deletePassword(R,S)}}e.ExtHostSecretState=I,e.IExtHostSecretState=(0,w.createDecorator)("IExtHostSecretState")}),define(Ee[69],_e([0,1,4,12,5,13]),function(oe,e,c,F,w,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,c.createDecorator)("IExtHostApiDeprecationService");let t=class{constructor(S,C){this._extHostLogService=C,this._reportedUsages=new Set,this._telemetryShape=S.getProxy(w.MainContext.MainThreadTelemetry)}report(S,C,A){const _=this.getUsageKey(S,C);this._reportedUsages.has(_)||(this._reportedUsages.add(_),C.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${S}' is deprecated. ${A}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:C.identifier.value,apiId:S}))}getUsageKey(S,C){return`${S}-${C.identifier.value}`}};t=xe([$e(0,I.IExtHostRpcService),$e(1,F.ILogService)],t),e.ExtHostApiDeprecationService=t,e.NullApiDeprecationService=Object.freeze(new class{report(R,S,C){}})}),define(Ee[177],_e([0,1,3,5,7,25]),function(oe,e,c,F,w,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class t{constructor(S){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new c.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=S.getProxy(F.MainContext.MainThreadAuthentication)}$setProviders(S){return this._providers=S,Promise.resolve()}async getSession(S,C,A,_={}){const n=I.ExtensionIdentifier.toKey(S.identifier),h=this._inFlightRequests.get(n)||[],s=[...A].sort().join(" ");let l=h.find(d=>d.scopes===s);if(l)return l.result;{const d=this._getSession(S,n,C,A,_);l={scopes:s,result:d},h.push(l),this._inFlightRequests.set(n,h);try{await d}finally{const D=h.findIndex(v=>v.scopes===s);D>-1&&(h.splice(D),this._inFlightRequests.set(n,h))}return d}}async _getSession(S,C,A,_,n={}){await this._proxy.$ensureProvider(A);const h=S.displayName||S.name;return this._proxy.$getSession(A,_,C,h,n)}async removeSession(S,C){const A=this._authenticationProviders.get(S);return A?A.provider.removeSession(C):this._proxy.$removeSession(S,C)}registerAuthenticationProvider(S,C,A,_){if(this._authenticationProviders.get(S))throw new Error(`An authentication provider with id '${S}' is already registered.`);this._authenticationProviders.set(S,{label:C,provider:A,options:_??{supportsMultipleAccounts:!1}}),this._providers.find(h=>h.id===S)||this._providers.push({id:S,label:C});const n=A.onDidChangeSessions(h=>{this._proxy.$sendDidChangeSessions(S,{added:h.added??[],changed:h.changed??[],removed:h.removed??[]})});return this._proxy.$registerAuthenticationProvider(S,C,_?.supportsMultipleAccounts??!1),new w.Disposable(()=>{n.dispose(),this._authenticationProviders.delete(S);const h=this._providers.findIndex(s=>s.id===S);h>-1&&this._providers.splice(h),this._proxy.$unregisterAuthenticationProvider(S)})}$createSession(S,C){const A=this._authenticationProviders.get(S);if(A)return Promise.resolve(A.provider.createSession(C));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$removeSession(S,C){const A=this._authenticationProviders.get(S);if(A)return Promise.resolve(A.provider.removeSession(C));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$getSessions(S,C){const A=this._authenticationProviders.get(S);if(A)return Promise.resolve(A.provider.getSessions(C));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$onDidChangeAuthenticationSessions(S,C){return this._onDidChangeSessions.fire({provider:{id:S,label:C}}),Promise.resolve()}}e.ExtHostAuthentication=t}),define(Ee[178],_e([0,1,5,13,8]),function(oe,e,c,F,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let I=class{constructor(R,S){this._extHostDocumentsAndEditors=S,this._proxy=R.getProxy(c.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(R){const S=w.WorkspaceEdit.from(R,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(S)}};I=xe([$e(0,F.IExtHostRpcService)],I),e.ExtHostBulkEdits=I}),define(Ee[179],_e([0,1,5]),function(oe,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class F{constructor(I){const t=I.getProxy(c.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return t.$readText()},writeText(R){return t.$writeText(R)}})}}e.ExtHostClipboard=F}),define(Ee[38],_e([0,1,11,7,8,27,5,16,12,54,59,227,2,6,4,13,48,22,37,44]),function(oe,e,c,F,w,I,t,R,S,C,A,_,n,h,s,l,d,D,v,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let g=class{constructor(p,m){this._commands=new Map,this._apiCommands=new Map,this._proxy=p.getProxy(t.MainContext.MainThreadCommands),this._logService=m,this.converter=new T(this,o=>{const b=this._apiCommands.get(o);return b?.result===M.Void?b:void 0},m),this._argumentProcessors=[{processArgument(o){return(0,C.revive)(o)}},{processArgument(o){return(0,I.cloneAndChange)(o,function(b){if(A.Range.isIRange(b))return w.Range.to(b);if(_.Position.isIPosition(b))return w.Position.to(b);if(A.Range.isIRange(b.range)&&n.URI.isUri(b.uri))return w.location.to(b);if(b instanceof D.VSBuffer)return b.buffer.buffer;if(!Array.isArray(b))return b})}}]}registerArgumentProcessor(p){this._argumentProcessors.push(p)}registerApiCommand(p){const m=this.registerCommand(!1,p.id,async(...o)=>{const b=p.args.map((E,P)=>{if(!E.validate(o[P]))throw new Error(`Invalid argument '${E.name}' when running '${p.id}', received: ${o[P]}`);return E.convert(o[P])}),a=await this.executeCommand(p.internalId,...b);return p.result.convert(a,o,this.converter)},void 0,{description:p.description,args:p.args,returns:p.result.description});return this._apiCommands.set(p.id,p),new F.Disposable(()=>{m.dispose(),this._apiCommands.delete(p.id)})}registerCommand(p,m,o,b,a,E){if(this._logService.trace("ExtHostCommands#registerCommand",m),!m.trim().length)throw new Error("invalid id");if(this._commands.has(m))throw new Error(`command '${m}' already exists`);return this._commands.set(m,{callback:o,thisArg:b,description:a,extension:E}),p&&this._proxy.$registerCommand(m),new F.Disposable(()=>{this._commands.delete(m)&&p&&this._proxy.$unregisterCommand(m)})}executeCommand(p,...m){return this._logService.trace("ExtHostCommands#executeCommand",p),this._doExecuteCommand(p,m,!0)}async _doExecuteCommand(p,m,o){if(this._commands.has(p))return this._executeContributedCommand(p,m,!1);{let b=!1;const a=(0,I.cloneAndChange)(m,function(E){if(E instanceof F.Position)return w.Position.from(E);if(E instanceof F.Range)return w.Range.from(E);if(E instanceof F.Location)return w.location.from(E);if(F.NotebookRange.isNotebookRange(E))return w.NotebookRange.from(E);if(E instanceof ArrayBuffer)return b=!0,D.VSBuffer.wrap(new Uint8Array(E));if(E instanceof Uint8Array)return b=!0,D.VSBuffer.wrap(E);if(!Array.isArray(E))return E});try{const E=await this._proxy.$executeCommand(p,b?new v.SerializableObjectWithBuffers(a):a,o);return(0,C.revive)(E)}catch(E){if(E instanceof Error&&E.message==="$executeCommand:retry")return this._doExecuteCommand(p,m,!1);throw E}}}async _executeContributedCommand(p,m,o){const b=this._commands.get(p);if(!b)throw new Error("Unknown command");let{callback:a,thisArg:E,description:P}=b;if(P)for(let k=0;k<P.args.length;k++)try{(0,c.validateConstraint)(m[k],P.args[k].constraint)}catch(B){throw new Error(`Running the contributed command: '${p}' failed. Illegal argument '${P.args[k].name}' - ${P.args[k].description}`)}try{return await a.apply(E,m)}catch(k){if(p===this.converter.delegatingCommandId){const B=this.converter.getActualCommand(...m);B&&(p=B.command)}throw this._logService.error(k,p,b.extension?.identifier),o?new class extends Error{constructor(){super((0,f.toErrorMessage)(k));this.id=p,this.source=b.extension?.displayName??b.extension?.name}}:k}}$executeContributedCommand(p,...m){return this._logService.trace("ExtHostCommands#$executeContributedCommand",p),this._commands.has(p)?(m=m.map(o=>this._argumentProcessors.reduce((b,a)=>a.processArgument(b),o)),this._executeContributedCommand(p,m,!0)):Promise.reject(new Error(`Contributed command '${p}' does not exist.`))}getCommands(p=!1){return this._logService.trace("ExtHostCommands#getCommands",p),this._proxy.$getCommands().then(m=>(p&&(m=m.filter(o=>o[0]!=="_")),m))}$getContributedCommandHandlerDescriptions(){const p=Object.create(null);for(let[m,o]of this._commands){let{description:b}=o;b&&(p[m]=b)}return Promise.resolve(p)}};g=xe([$e(0,l.IExtHostRpcService),$e(1,S.ILogService)],g),e.ExtHostCommands=g,e.IExtHostCommands=(0,s.createDecorator)("IExtHostCommands");class T{constructor(p,m,o){this._commands=p,this._lookupApiCommand=m,this._logService=o,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(p,m){if(!p)return;const o={$ident:void 0,id:p.command,title:p.title,tooltip:p.tooltip};if(!p.command)return o;const b=this._lookupApiCommand(p.command);if(b)o.id=b.internalId,o.arguments=b.args.map((a,E)=>a.convert(p.arguments&&p.arguments[E]));else if((0,R.isNonEmptyArray)(p.arguments)){const a=++this._cachIdPool;this._cache.set(a,p),m.add((0,h.toDisposable)(()=>{this._cache.delete(a),this._logService.trace("CommandsConverter#DISPOSE",a)})),o.$ident=a,o.id=this.delegatingCommandId,o.arguments=[a],this._logService.trace("CommandsConverter#CREATE",p.command,a)}return o}fromInternal(p){const m=t.ObjectIdentifier.of(p);return typeof m=="number"?this._cache.get(m):{command:p.id,title:p.title,arguments:p.arguments}}getActualCommand(...p){return this._cache.get(p[0])}_executeConvertedCommand(...p){const m=this.getActualCommand(...p);return this._logService.trace("CommandsConverter#EXECUTE",p[0],m?m.command:"MISSING"),m?this._commands.executeCommand(m.command,...m.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=T;class u{constructor(p,m,o,b){this.name=p,this.description=m,this.validate=o,this.convert=b}optional(){return new u(this.name,`(optional) ${this.description}`,p=>p==null||this.validate(p),p=>p===void 0?void 0:p===null?null:this.convert(p))}with(p,m){return new u(p??this.name,m??this.description,this.validate,this.convert)}}e.ApiCommandArgument=u,u.Uri=new u("uri","Uri of a text document",i=>n.URI.isUri(i),i=>i),u.Position=new u("position","A position in a text document",i=>F.Position.isPosition(i),w.Position.from),u.Range=new u("range","A range in a text document",i=>F.Range.isRange(i),w.Range.from),u.Selection=new u("selection","A selection in a text document",i=>F.Selection.isSelection(i),w.Selection.from),u.Number=new u("number","",i=>typeof i=="number",i=>i),u.String=new u("string","",i=>typeof i=="string",i=>i),u.CallHierarchyItem=new u("item","A call hierarchy item",i=>i instanceof F.CallHierarchyItem,w.CallHierarchyItem.from),u.TypeHierarchyItem=new u("item","A type hierarchy item",i=>i instanceof F.TypeHierarchyItem,w.TypeHierarchyItem.from),u.TestItem=new u("testItem","A VS Code TestItem",i=>i instanceof d.TestItemImpl,w.TestItem.from);class M{constructor(p,m){this.description=p,this.convert=m}}e.ApiCommandResult=M,M.Void=new M("no result",i=>i);class r{constructor(p,m,o,b,a){this.id=p,this.internalId=m,this.description=o,this.args=b,this.result=a}}e.ApiCommand=r}),define(Ee[180],_e([0,1,8,7,58,38,16,79]),function(oe,e,c,F,w,I,t,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const S=[new I.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",A(c.DocumentHighlight.to))),new I.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[I.ApiCommandArgument.Uri],new I.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(n,h)=>{if((0,t.isFalsyOrEmpty)(n))return;class s extends F.SymbolInformation{static to(d){const D=new s(d.name,c.SymbolKind.to(d.kind),d.containerName||"",new F.Location(h[0],c.Range.to(d.range)));return D.detail=d.detail,D.range=D.location.range,D.selectionRange=c.Range.to(d.selectionRange),D.children=d.children?d.children.map(s.to):[],D}}return n.map(s.to)})),new I.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[I.ApiCommandArgument.Uri,new I.ApiCommandArgument("options","Formatting options",n=>!0,n=>n)],new I.ApiCommandResult("A promise that resolves to an array of TextEdits.",A(c.TextEdit.to))),new I.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Range,new I.ApiCommandArgument("options","Formatting options",n=>!0,n=>n)],new I.ApiCommandResult("A promise that resolves to an array of TextEdits.",A(c.TextEdit.to))),new I.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position,new I.ApiCommandArgument("ch","Trigger character",n=>typeof n=="string",n=>n),new I.ApiCommandArgument("options","Formatting options",n=>!0,n=>n)],new I.ApiCommandResult("A promise that resolves to an array of TextEdits.",A(c.TextEdit.to))),new I.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",_)),new I.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",_)),new I.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",_)),new I.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",_)),new I.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A promise that resolves to an array of Location-instances.",A(c.location.to))),new I.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A promise that resolves to an array of Hover-instances.",A(c.Hover.to))),new I.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[I.ApiCommandArgument.Uri,new I.ApiCommandArgument("position","A position in a text document",n=>Array.isArray(n)&&n.every(h=>F.Position.isPosition(h)),n=>n.map(c.Position.from))],new I.ApiCommandResult("A promise that resolves to an array of ranges.",n=>n.map(h=>{let s;for(const l of h.reverse())s=new F.SelectionRange(c.Range.to(l),s);return s}))),new I.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[I.ApiCommandArgument.String.with("query","Search string")],new I.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",n=>n.map(c.WorkspaceSymbol.to))),new I.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A CallHierarchyItem or undefined",n=>n.map(c.CallHierarchyItem.to))),new I.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[I.ApiCommandArgument.CallHierarchyItem],new I.ApiCommandResult("A CallHierarchyItem or undefined",n=>n.map(c.CallHierarchyIncomingCall.to))),new I.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[I.ApiCommandArgument.CallHierarchyItem],new I.ApiCommandResult("A CallHierarchyItem or undefined",n=>n.map(c.CallHierarchyOutgoingCall.to))),new I.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A promise that resolves to a range and placeholder text.",n=>{if(!!n)return{range:c.Range.to(n.range),placeholder:n.text}})),new I.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position,I.ApiCommandArgument.String.with("newName","The new symbol name")],new I.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",n=>{if(!!n){if(n.rejectReason)throw new Error(n.rejectReason);return c.WorkspaceEdit.to(n)}})),new I.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new I.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",n=>n.map(c.DocumentLink.to))),new I.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[I.ApiCommandArgument.Uri],new I.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",n=>{if(!!n)return new F.SemanticTokensLegend(n.tokenTypes,n.tokenModifiers)})),new I.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[I.ApiCommandArgument.Uri],new I.ApiCommandResult("A promise that resolves to SemanticTokens.",n=>{if(!n)return;const h=(0,R.decodeSemanticTokensDto)(n);if(h.type==="full")return new F.SemanticTokens(h.data,void 0)})),new I.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Range.optional()],new I.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",n=>{if(!!n)return new F.SemanticTokensLegend(n.tokenTypes,n.tokenModifiers)})),new I.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Range],new I.ApiCommandResult("A promise that resolves to SemanticTokens.",n=>{if(!n)return;const h=(0,R.decodeSemanticTokensDto)(n);if(h.type==="full")return new F.SemanticTokens(h.data,void 0)})),new I.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position,I.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),I.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new I.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(n,h,s)=>{if(!n)return new F.CompletionList([]);const l=n.suggestions.map(d=>c.CompletionItem.to(d,s));return new F.CompletionList(l,n.incomplete)})),new I.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position,I.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new I.ApiCommandResult("A promise that resolves to SignatureHelp.",n=>{if(n)return c.SignatureHelp.to(n)})),new I.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new I.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(n,h,s)=>A(l=>new F.CodeLens(c.Range.to(l.range),l.command&&s.fromInternal(l.command)))(n))),new I.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[I.ApiCommandArgument.Uri,new I.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",n=>F.Range.isRange(n),n=>F.Selection.isSelection(n)?c.Selection.from(n):c.Range.from(n)),I.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),I.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new I.ApiCommandResult("A promise that resolves to an array of Command-instances.",(n,h,s)=>A(l=>{if(l._isSynthetic){if(!l.command)throw new Error("Synthetic code actions must have a command");return s.fromInternal(l.command)}else{const d=new F.CodeAction(l.title,l.kind?new F.CodeActionKind(l.kind):void 0);return l.edit&&(d.edit=c.WorkspaceEdit.to(l.edit)),l.command&&(d.command=s.fromInternal(l.command)),d.isPreferred=l.isPreferred,d}})(n))),new I.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[I.ApiCommandArgument.Uri],new I.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",n=>n?n.map(h=>new F.ColorInformation(c.Range.to(h.range),c.Color.to(h.color))):[])),new I.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new I.ApiCommandArgument("color","The color to show and insert",n=>n instanceof F.Color,c.Color.from),new I.ApiCommandArgument("context","Context object with uri and range",n=>!0,n=>({uri:n.uri,range:c.Range.from(n.range)}))],new I.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",n=>n?n.map(c.ColorPresentation.to):[])),new I.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Range],new I.ApiCommandResult("A promise that resolves to an array of Inlay objects",n=>n.map(c.InlayHint.to))),new I.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new I.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",A(n=>({viewType:n.viewType,displayName:n.displayName,options:{transientOutputs:n.options.transientOutputs,transientCellMetadata:n.options.transientCellMetadata,transientDocumentMetadata:n.options.transientDocumentMetadata},filenamePattern:n.filenamePattern.map(h=>c.NotebookExclusiveDocumentPattern.to(h))})))),new I.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Range],new I.ApiCommandResult("A promise that resolves to an array of InlineValue objects",n=>n.map(c.InlineValue.to))),new I.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[I.ApiCommandArgument.Uri,new I.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="number"||typeof n=="object",n=>n&&(typeof n=="number"?[n,void 0]:[c.ViewColumn.from(n.viewColumn),c.TextEditorOpenOptions.from(n)])).optional(),I.ApiCommandArgument.String.with("label","").optional()],I.ApiCommandResult.Void),new I.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[I.ApiCommandArgument.Uri.with("resource","Resource to open"),I.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new I.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="number"||typeof n=="object",n=>n&&(typeof n=="number"?[n,void 0]:[c.ViewColumn.from(n.viewColumn),c.TextEditorOpenOptions.from(n)])).optional()],I.ApiCommandResult.Void),new I.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[I.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),I.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),I.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new I.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="object",n=>n&&[c.ViewColumn.from(n.viewColumn),c.TextEditorOpenOptions.from(n)]).optional()],I.ApiCommandResult.Void),new I.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A TypeHierarchyItem or undefined",n=>n.map(c.TypeHierarchyItem.to))),new I.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[I.ApiCommandArgument.TypeHierarchyItem],new I.ApiCommandResult("A TypeHierarchyItem or undefined",n=>n.map(c.TypeHierarchyItem.to))),new I.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[I.ApiCommandArgument.TypeHierarchyItem],new I.ApiCommandResult("A TypeHierarchyItem or undefined",n=>n.map(c.TypeHierarchyItem.to))),new I.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[I.ApiCommandArgument.TestItem],I.ApiCommandResult.Void)];class C{static register(h){S.forEach(h.registerApiCommand,h)}}e.ExtHostApiCommands=C;function A(n){return h=>{if(Array.isArray(h))return h.map(n)}}function _(n){if(!Array.isArray(n))return;const h=[];for(const s of n)w.isLocationLink(s)?h.push(c.DefinitionLink.to(s)):h.push(c.location.to(s));return h}}),define(Ee[181],_e([0,1,14,42,3,6,2,58,25,8,7,5]),function(oe,e,c,F,w,I,t,R,S,C,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function n(h,s,l){const d=h.getProxy(_.MainContext.MainThreadComments);class D{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new Map,s.registerArgumentProcessor({processArgument:i=>{if(i&&i.$mid===6){const p=this._commentControllers.get(i.handle);return p||i}else if(i&&i.$mid===7){const p=this._commentControllers.get(i.commentControlHandle);if(!p)return i;const m=p.getCommentThread(i.commentThreadHandle);return m||i}else if(i&&i.$mid===8){const p=this._commentControllers.get(i.thread.commentControlHandle);if(!p)return i;const m=p.getCommentThread(i.thread.commentThreadHandle);return m?{thread:m,text:i.text}:i}else if(i&&i.$mid===9){const p=this._commentControllers.get(i.thread.commentControlHandle);if(!p)return i;const m=p.getCommentThread(i.thread.commentThreadHandle);if(!m)return i;let o=i.commentUniqueId,b=m.getCommentByUniqueId(o);return b||i}else if(i&&i.$mid===10){const p=this._commentControllers.get(i.thread.commentControlHandle);if(!p)return i;const m=p.getCommentThread(i.thread.commentThreadHandle);if(!m)return i;let o=i.text,b=i.commentUniqueId,a=m.getCommentByUniqueId(b);return a?(a.body=o,a):i}return i}})}createCommentController(i,p,m){const o=D.handlePool++,b=new f(i,o,p,m);this._commentControllers.set(b.handle,b);const a=this._commentControllersByExtension.get(S.ExtensionIdentifier.toKey(i.identifier))||[];return a.push(b),this._commentControllersByExtension.set(S.ExtensionIdentifier.toKey(i.identifier),a),b.value}$createCommentThreadTemplate(i,p,m){const o=this._commentControllers.get(i);!o||o.$createCommentThreadTemplate(p,m)}async $updateCommentThreadTemplate(i,p,m){const o=this._commentControllers.get(i);!o||o.$updateCommentThreadTemplate(p,m)}$deleteCommentThread(i,p){const m=this._commentControllers.get(i);m&&m.$deleteCommentThread(p)}$provideCommentingRanges(i,p,m){const o=this._commentControllers.get(i);if(!o||!o.commentingRangeProvider)return Promise.resolve(void 0);const b=l.getDocument(t.URI.revive(p));return(0,c.asPromise)(()=>o.commentingRangeProvider.provideCommentingRanges(b,m)).then(a=>a?a.map(E=>C.Range.from(E)):void 0)}$toggleReaction(i,p,m,o,b){const a=this._commentControllers.get(i);return!a||!a.reactionHandler?Promise.resolve(void 0):(0,c.asPromise)(()=>{const E=a.getCommentThread(p);if(E){const P=E.getCommentByUniqueId(o.uniqueIdInThread);if(a!==void 0&&P&&a.reactionHandler)return a.reactionHandler(P,u(b))}return Promise.resolve(void 0)})}dispose(){}}D.handlePool=0;class v{constructor(i,p,m,o,b,a,E){this._commentControllerHandle=p,this._id=m,this._uri=o,this._range=b,this._comments=a,this.handle=v._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new w.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new I.MutableDisposable,this._acceptInputDisposables.value=new I.DisposableStore,this._id===void 0&&(this._id=`${i}.${this.handle}`),d.$createCommentThread(p,this.handle,this._id,this._uri,C.Range.from(this._range),E),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=a,this._localDisposables.push({dispose:()=>{d.$deleteCommentThread(p,this.handle)}});const P=this;this.value={get uri(){return P.uri},get range(){return P.range},set range(k){P.range=k},get comments(){return P.comments},set comments(k){P.comments=k},get collapsibleState(){return P.collapsibleState},set collapsibleState(k){P.collapsibleState=k},get canReply(){return P.canReply},set canReply(k){P.canReply=k},get contextValue(){return P.contextValue},set contextValue(k){P.contextValue=k},get label(){return P.label},set label(k){P.label=k},dispose:()=>{P.dispose()}}}set threadId(i){this._id=i}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(i){i.isEqual(this._range)||(this._range=i,this.modifications.range=i,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(i){this._canReply!==i&&(this._canReply=i,this.modifications.canReply=i,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(i){this._label=i,this.modifications.label=i,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(i){this._contextValue=i,this.modifications.contextValue=i,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(i){this._comments=i,this.modifications.comments=i,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(i){this._collapseState=i,this.modifications.collapsibleState=i,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new I.DisposableStore);const i=m=>Object.prototype.hasOwnProperty.call(this.modifications,m),p={};i("range")&&(p.range=C.Range.from(this._range)),i("label")&&(p.label=this.label),i("contextValue")&&(p.contextValue=this.contextValue??null),i("comments")&&(p.comments=this._comments.map(m=>g(this,m,this._commentsMap))),i("collapsibleState")&&(p.collapseState=M(this._collapseState)),i("canReply")&&(p.canReply=this.canReply),this.modifications={},d.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,p)}getCommentByUniqueId(i){for(let p of this._commentsMap){let m=p[0],o=p[1];if(i===o)return m}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(i=>i.dispose())}}v._handlePool=0,xe([(0,F.debounce)(100)],v.prototype,"eventuallyUpdateCommentThread",null);class f{constructor(i,p,m,o){this._extension=i,this._handle=p,this._id=m,this._label=o,this._threads=new Map,d.$registerCommentController(this.handle,m,o);const b=this;this.value=Object.freeze({id:b.id,label:b.label,get options(){return b.options},set options(a){b.options=a},get commentingRangeProvider(){return b.commentingRangeProvider},set commentingRangeProvider(a){b.commentingRangeProvider=a},get reactionHandler(){return b.reactionHandler},set reactionHandler(a){b.reactionHandler=a},createCommentThread(a,E,P){return b.createCommentThread(a,E,P).value},dispose:()=>{b.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{d.$unregisterCommentController(this.handle)}})}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get commentingRangeProvider(){return this._commentingRangeProvider}set commentingRangeProvider(i){this._commentingRangeProvider=i,d.$updateCommentingRanges(this.handle)}get reactionHandler(){return this._reactionHandler}set reactionHandler(i){this._reactionHandler=i,d.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!i})}get options(){return this._options}set options(i){this._options=i,d.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(i,p,m,o){if(typeof i=="string"){const b=new v(this.id,this.handle,i,p,m,o,this._extension.identifier);return this._threads.set(b.handle,b),b}else{const b=new v(this.id,this.handle,void 0,i,p,m,this._extension.identifier);return this._threads.set(b.handle,b),b}}$createCommentThreadTemplate(i,p){const m=new v(this.id,this.handle,void 0,t.URI.revive(i),C.Range.to(p),[],this._extension.identifier);return m.collapsibleState=R.CommentThreadCollapsibleState.Expanded,this._threads.set(m.handle,m),m}$updateCommentThreadTemplate(i,p){let m=this._threads.get(i);m&&(m.range=C.Range.to(p))}$deleteCommentThread(i){let p=this._threads.get(i);p&&p.dispose(),this._threads.delete(i)}getCommentThread(i){return this._threads.get(i)}dispose(){this._threads.forEach(i=>{i.dispose()}),this._localDisposables.forEach(i=>i.dispose())}}function g(r,i,p){let m=p.get(i);m||(m=++r.commentHandle,p.set(i,m));const o=i.author&&i.author.iconPath?i.author.iconPath.toString():void 0;return{mode:i.mode,contextValue:i.contextValue,uniqueIdInThread:m,body:C.MarkdownString.from(i.body),userName:i.author.name,userIconPath:o,label:i.label,commentReactions:i.reactions?i.reactions.map(b=>T(b)):void 0}}function T(r){return{label:r.label,iconPath:r.iconPath?C.pathOrURIToURI(r.iconPath):void 0,count:r.count,hasReacted:r.authorHasReacted}}function u(r){return{label:r.label||"",count:r.count||0,iconPath:r.iconPath?t.URI.revive(r.iconPath):"",authorHasReacted:r.hasReacted||!1}}function M(r){if(r!==void 0)switch(r){case A.CommentThreadCollapsibleState.Expanded:return R.CommentThreadCollapsibleState.Expanded;case A.CommentThreadCollapsibleState.Collapsed:return R.CommentThreadCollapsibleState.Collapsed}return R.CommentThreadCollapsibleState.Collapsed}return new D}e.createExtHostComments=n}),define(Ee[93],_e([0,1,2,5,7,4,13,12,16,9,17]),function(oe,e,c,F,w,I,t,R,S,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let _=class wi{constructor(h,s){this._logService=s,this._provider=new Map,this._proxy=h.getProxy(F.MainContext.MainThreadDecorations)}registerFileDecorationProvider(h,s){const l=wi._handlePool++;this._provider.set(l,{provider:h,extensionId:s}),this._proxy.$registerDecorationProvider(l,s.value);const d=h.onDidChangeFileDecorations&&h.onDidChangeFileDecorations(D=>{if(!D){this._proxy.$onDidChange(l,null);return}let v=(0,S.asArray)(D);if(v.length<=wi._maxEventSize){this._proxy.$onDidChange(l,v);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",s.value,v.length);const f=v.map(u=>({uri:u,rank:(0,C.count)(u.path,"/")})),g=(0,S.groupBy)(f,(u,M)=>u.rank-M.rank||(0,C.compare)(u.uri.path,M.uri.path));let T=[];e:for(let u of g){let M;for(let r of u){let i=(0,A.dirname)(r.uri.path);if(M!==i&&(M=i,T.push(r.uri)>=wi._maxEventSize))break e}}this._proxy.$onDidChange(l,T)});return new w.Disposable(()=>{d?.dispose(),this._proxy.$unregisterDecorationProvider(l),this._provider.delete(l)})}async $provideDecorations(h,s,l){if(!this._provider.has(h))return Object.create(null);const d=Object.create(null),{provider:D,extensionId:v}=this._provider.get(h);return await Promise.all(s.map(async f=>{try{const{uri:g,id:T}=f,u=await Promise.resolve(D.provideFileDecoration(c.URI.revive(g),l));if(!u)return;try{w.FileDecoration.validate(u),d[T]=[u.propagate,u.tooltip,u.badge,u.color]}catch(M){this._logService.warn(`INVALID decoration from extension '${v.value}': ${M}`)}}catch(g){this._logService.error(g)}})),d}};_._handlePool=0,_._maxEventSize=250,_=xe([$e(0,t.IExtHostRpcService),$e(1,R.ILogService)],_),e.ExtHostDecorations=_,e.IExtHostDecorations=(0,I.createDecorator)("IExtHostDecorations")});var Ze=this&&this.__classPrivateFieldSet||function(oe,e,c,F,w){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?oe!==e||!w:!e.has(oe))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?w.call(oe,c):w?w.value=c:e.set(oe,c),c},Ae=this&&this.__classPrivateFieldGet||function(oe,e,c,F){if(c==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?oe!==e||!F:!e.has(oe))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?F:c==="a"?F.call(oe):F?F.value:e.get(oe)};define(Ee[182],_e([0,1,119,82,2,5,7,8,3,12,21,30]),function(oe,e,c,F,w,I,t,R,S,C,A,_){"use strict";var n,h,s;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class l{constructor(v,f,g,T,u,M){this._name=v,this._owner=f,this._maxDiagnosticsPerFile=g,n.set(this,void 0),h.set(this,void 0),s.set(this,void 0),this._isDisposed=!1,Ze(this,s,new A.ResourceMap(r=>T.getComparisonKey(r)),"f"),Ze(this,n,u,"f"),Ze(this,h,M,"f")}dispose(){this._isDisposed||(Ae(this,h,"f").fire([...Ae(this,s,"f").keys()]),Ae(this,n,"f")&&Ae(this,n,"f").$clear(this._owner),Ae(this,s,"f").clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(v,f){if(!v){this.clear();return}this._checkDisposed();let g=[];if(w.URI.isUri(v)){if(!f){this.delete(v);return}Ae(this,s,"f").set(v,f.slice()),g=[v]}else if(Array.isArray(v)){g=[];let u;v=[...v].sort(l._compareIndexedTuplesByUri);for(const M of v){const[r,i]=M;if((!u||r.toString()!==u.toString())&&(u&&Ae(this,s,"f").get(u).length===0&&Ae(this,s,"f").delete(u),u=r,g.push(r),Ae(this,s,"f").set(r,[])),i){const p=Ae(this,s,"f").get(r);p&&p.push(...i)}else{const p=Ae(this,s,"f").get(r);p&&(p.length=0)}}}if(Ae(this,h,"f").fire(g),!Ae(this,n,"f"))return;const T=[];for(let u of g){let M=[];const r=Ae(this,s,"f").get(u);if(r)if(r.length>this._maxDiagnosticsPerFile){M=[];const i=[t.DiagnosticSeverity.Error,t.DiagnosticSeverity.Warning,t.DiagnosticSeverity.Information,t.DiagnosticSeverity.Hint];e:for(let p=0;p<4;p++)for(let m of r)if(m.severity===i[p]&&M.push(R.Diagnostic.from(m))===this._maxDiagnosticsPerFile)break e;M.push({severity:F.MarkerSeverity.Info,message:(0,c.localize)(0,null,r.length-this._maxDiagnosticsPerFile),startLineNumber:M[M.length-1].startLineNumber,startColumn:M[M.length-1].startColumn,endLineNumber:M[M.length-1].endLineNumber,endColumn:M[M.length-1].endColumn})}else M=r.map(i=>R.Diagnostic.from(i));T.push([u,M])}Ae(this,n,"f").$changeMany(this._owner,T)}delete(v){this._checkDisposed(),Ae(this,h,"f").fire([v]),Ae(this,s,"f").delete(v),Ae(this,n,"f")&&Ae(this,n,"f").$changeMany(this._owner,[[v,void 0]])}clear(){this._checkDisposed(),Ae(this,h,"f").fire([...Ae(this,s,"f").keys()]),Ae(this,s,"f").clear(),Ae(this,n,"f")&&Ae(this,n,"f").$clear(this._owner)}forEach(v,f){this._checkDisposed();for(let g of Ae(this,s,"f").keys())v.apply(f,[g,this.get(g),this])}get(v){this._checkDisposed();const f=Ae(this,s,"f").get(v);return Array.isArray(f)?Object.freeze(f.slice(0)):[]}has(v){return this._checkDisposed(),Array.isArray(Ae(this,s,"f").get(v))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(v,f){return v[0].toString()<f[0].toString()?-1:v[0].toString()>f[0].toString()?1:0}}e.DiagnosticCollection=l,n=new WeakMap,h=new WeakMap,s=new WeakMap;let d=class ri{constructor(v,f,g){this._logService=f,this._fileSystemInfoService=g,this._collections=new Map,this._onDidChangeDiagnostics=new S.DebounceEmitter({merge:T=>T.flat(),delay:50}),this.onDidChangeDiagnostics=S.Event.map(this._onDidChangeDiagnostics.event,ri._mapper),this._proxy=v.getProxy(I.MainContext.MainThreadDiagnostics)}static _mapper(v){const f=new A.ResourceMap;for(const g of v)f.set(g,g);return{uris:Object.freeze(Array.from(f.values()))}}createDiagnosticCollection(v,f){const{_collections:g,_proxy:T,_onDidChangeDiagnostics:u,_logService:M,_fileSystemInfoService:r}=this,i=new class{$changeMany(o,b){T.$changeMany(o,b),M.trace("[DiagnosticCollection] change many (extension, owner, uris)",v.value,o,b.length===0?"CLEARING":b)}$clear(o){T.$clear(o),M.trace("[DiagnosticCollection] remove all (extension, owner)",v.value,o)}dispose(){T.dispose()}};let p;if(!f)f="_generated_diagnostic_collection_name_#"+ri._idPool++,p=f;else if(!g.has(f))p=f;else{this._logService.warn(`DiagnosticCollection with name '${f}' does already exist.`);do p=f+ri._idPool++;while(g.has(p))}return new class extends l{constructor(){super(f,p,ri._maxDiagnosticsPerFile,r.extUri,i,u);g.set(p,this)}dispose(){super.dispose(),g.delete(p)}}}getDiagnostics(v){if(v)return this._getDiagnostics(v);{const f=new Map,g=[];for(const T of this._collections.values())T.forEach((u,M)=>{let r=f.get(u.toString());typeof r=="undefined"&&(r=g.length,f.set(u.toString(),r),g.push([u,[]])),g[r][1]=g[r][1].concat(...M)});return g}}_getDiagnostics(v){let f=[];for(let g of this._collections.values())g.has(v)&&(f=f.concat(g.get(v)));return f}$acceptMarkersChange(v){if(!this._mirrorCollection){const f="_generated_mirror",g=new l(f,f,ri._maxDiagnosticsPerFile,this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(f,g),this._mirrorCollection=g}for(const[f,g]of v)this._mirrorCollection.set(w.URI.revive(f),g.map(R.Diagnostic.to))}};d._idPool=0,d._maxDiagnosticsPerFile=1e3,d=xe([$e(1,C.ILogService),$e(2,_.IExtHostFileSystemInfo)],d),e.ExtHostDiagnostics=d}),define(Ee[183],_e([0,1,2,5]),function(oe,e,c,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class w{constructor(t){this._proxy=t.getProxy(F.MainContext.MainThreadDialogs)}showOpenDialog(t){return this._proxy.$showOpenDialog(t).then(R=>R?R.map(S=>c.URI.revive(S)):void 0)}showSaveDialog(t){return this._proxy.$showSaveDialog(t).then(R=>R?c.URI.revive(R):void 0)}}e.ExtHostDialogs=w}),define(Ee[184],_e([0,1,15,2,7,5,10,20,9]),function(oe,e,c,F,w,I,t,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class C{constructor(_,n,h){this._documentsAndEditors=n,this._logService=h,this._documentContentProviders=new Map,this._proxy=_.getProxy(I.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(_,n){if(Object.keys(t.Schemas).indexOf(_)>=0)throw new Error(`scheme '${_}' already registered`);const h=C._handlePool++;this._documentContentProviders.set(h,n),this._proxy.$registerTextContentProvider(h,_);let s;return typeof n.onDidChange=="function"&&(s=n.onDidChange(l=>{if(l.scheme!==_){this._logService.warn(`Provider for scheme '${_}' is firing event for schema '${l.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(l)&&this.$provideTextDocumentContent(h,l).then(d=>{if(!d&&typeof d!="string")return;const D=this._documentsAndEditors.getDocument(l);if(!D)return;const v=(0,S.splitLines)(d);if(!D.equalLines(v))return this._proxy.$onVirtualDocumentChange(l,d)},c.onUnexpectedError)})),new w.Disposable(()=>{this._documentContentProviders.delete(h)&&this._proxy.$unregisterTextContentProvider(h),s&&(s.dispose(),s=void 0)})}$provideTextDocumentContent(_,n){const h=this._documentContentProviders.get(_);return h?Promise.resolve(h.provideTextDocumentContent(F.URI.revive(n),R.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${n.scheme}`))}}e.ExtHostDocumentContentProvider=C,C._handlePool=0}),define(Ee[185],_e([0,1,3,6,2,5,86,8,11,27,7]),function(oe,e,c,F,w,I,t,R,S,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class _{constructor(h,s){this._onDidAddDocument=new c.Emitter,this._onDidRemoveDocument=new c.Emitter,this._onDidChangeDocument=new c.Emitter,this._onDidSaveDocument=new c.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new F.DisposableStore,this._documentLoader=new Map,this._proxy=h.getProxy(I.MainContext.MainThreadDocuments),this._documentsAndEditors=s,this._documentsAndEditors.onDidRemoveDocuments(l=>{for(const d of l)this._onDidRemoveDocument.fire(d.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(l=>{for(const d of l)this._onDidAddDocument.fire(d.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(h){if(!h)return;const s=this._documentsAndEditors.getDocument(h);if(s)return s}getDocument(h){const s=this.getDocumentData(h);if(!s?.document)throw new Error(`Unable to retrieve document from URI '${h}'`);return s.document}ensureDocumentData(h){const s=this._documentsAndEditors.getDocument(h);if(s)return Promise.resolve(s);let l=this._documentLoader.get(h.toString());return l||(l=this._proxy.$tryOpenDocument(h).then(d=>{this._documentLoader.delete(h.toString());const D=w.URI.revive(d);return(0,S.assertIsDefined)(this._documentsAndEditors.getDocument(D))},d=>(this._documentLoader.delete(h.toString()),Promise.reject(d))),this._documentLoader.set(h.toString(),l)),l}createDocumentData(h){return this._proxy.$tryCreateDocument(h).then(s=>w.URI.revive(s))}$acceptModelModeChanged(h,s){const l=w.URI.revive(h),d=this._documentsAndEditors.getDocument(l);if(!d)throw new Error("unknown document");this._onDidRemoveDocument.fire(d.document),d._acceptLanguageId(s),this._onDidAddDocument.fire(d.document)}$acceptModelSaved(h){const s=w.URI.revive(h),l=this._documentsAndEditors.getDocument(s);if(!l)throw new Error("unknown document");this.$acceptDirtyStateChanged(h,!1),this._onDidSaveDocument.fire(l.document)}$acceptDirtyStateChanged(h,s){const l=w.URI.revive(h),d=this._documentsAndEditors.getDocument(l);if(!d)throw new Error("unknown document");d._acceptIsDirty(s),this._onDidChangeDocument.fire({document:d.document,contentChanges:[],reason:void 0})}$acceptModelChanged(h,s,l){const d=w.URI.revive(h),D=this._documentsAndEditors.getDocument(d);if(!D)throw new Error("unknown document");D._acceptIsDirty(l),D.onEvents(s);let v;s.isUndoing?v=A.TextDocumentChangeReason.Undo:s.isRedoing&&(v=A.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,C.deepFreeze)({document:D.document,contentChanges:s.changes.map(f=>({range:R.Range.to(f.range),rangeOffset:f.rangeOffset,rangeLength:f.rangeLength,text:f.text})),reason:v}))}setWordDefinitionFor(h,s){(0,t.setWordDefinitionFor)(h,s)}}e.ExtHostDocuments=_}),define(Ee[49],_e([0,1,41,3,6,2,4,5,86,13,92,8,12,21,10,158,101]),function(oe,e,c,F,w,I,t,R,S,C,A,_,n,h,s,l,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class D{constructor(g){this.value=g,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let v=class{constructor(g,T){this._extHostRpc=g,this._logService=T,this._activeEditorId=null,this._editors=new Map,this._documents=new h.ResourceMap,this._onDidAddDocuments=new F.Emitter,this._onDidRemoveDocuments=new F.Emitter,this._onDidChangeVisibleTextEditors=new F.Emitter,this._onDidChangeActiveTextEditor=new F.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(g){this.acceptDocumentsAndEditorsDelta(g)}acceptDocumentsAndEditorsDelta(g){const T=[],u=[],M=[];if(g.removedDocuments)for(const r of g.removedDocuments){const i=I.URI.revive(r),p=this._documents.get(i);p?.unref()&&(this._documents.delete(i),T.push(p.value))}if(g.addedDocuments)for(const r of g.addedDocuments){const i=I.URI.revive(r.uri);let p=this._documents.get(i);if(p&&i.scheme!==s.Schemas.vscodeNotebookCell&&i.scheme!==s.Schemas.vscodeInteractiveInput)throw new Error(`document '${i} already exists!'`);p||(p=new D(new S.ExtHostDocumentData(this._extHostRpc.getProxy(R.MainContext.MainThreadDocuments),i,r.lines,r.EOL,r.versionId,r.languageId,r.isDirty,r.notebook)),this._documents.set(i,p),u.push(p.value)),p.ref()}if(g.removedEditors)for(const r of g.removedEditors){const i=this._editors.get(r);this._editors.delete(r),i&&M.push(i)}if(g.addedEditors)for(const r of g.addedEditors){const i=I.URI.revive(r.documentUri);c.ok(this._documents.has(i),`document '${i}' does not exist`),c.ok(!this._editors.has(r.id),`editor '${r.id}' already exists!`);const p=this._documents.get(i).value,m=new A.ExtHostTextEditor(r.id,this._extHostRpc.getProxy(R.MainContext.MainThreadTextEditors),this._logService,new d.Lazy(()=>p.document),r.selections.map(_.Selection.to),r.options,r.visibleRanges.map(o=>_.Range.to(o)),typeof r.editorPosition=="number"?_.ViewColumn.to(r.editorPosition):void 0);this._editors.set(r.id,m)}g.newActiveEditor!==void 0&&(c.ok(g.newActiveEditor===null||this._editors.has(g.newActiveEditor),`active editor '${g.newActiveEditor}' does not exist`),this._activeEditorId=g.newActiveEditor),(0,w.dispose)(T),(0,w.dispose)(M),g.removedDocuments&&this._onDidRemoveDocuments.fire(T),g.addedDocuments&&this._onDidAddDocuments.fire(u),(g.removedEditors||g.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(r=>r.value)),g.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(g){return this._documents.get(g)?.value}allDocuments(){return l.Iterable.map(this._documents.values(),g=>g.value)}getEditor(g){return this._editors.get(g)}activeEditor(g){if(!this._activeEditorId)return;const T=this._editors.get(this._activeEditorId);return g?T:T?.value}allEditors(){return[...this._editors.values()]}};v=xe([$e(0,C.IExtHostRpcService),$e(1,n.ILogService)],v),e.ExtHostDocumentsAndEditors=v,e.IExtHostDocumentsAndEditors=(0,t.createDecorator)("IExtHostDocumentsAndEditors")}),define(Ee[70],_e([0,1,8,5,2,3,4,13,14]),function(oe,e,c,F,w,I,t,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,t.createDecorator)("IExtHostEditorTabs");let C=class{constructor(_){this._onDidChangeTabs=new I.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._onDidChangeActiveTab=new I.Emitter,this.onDidChangeActiveTab=this._onDidChangeActiveTab.event,this._tabs=[],this._proxy=_.getProxy(F.MainContext.MainThreadEditorTabs)}get tabs(){return this._tabs}get activeTab(){return this._activeTab}$acceptEditorTabs(_){let n=-1;this._tabs=_.map((s,l)=>(s.isActive&&(n=l),Object.freeze({label:s.label,viewColumn:c.ViewColumn.to(s.viewColumn),index:l,resource:w.URI.revive(s.resource),additionalResourcesAndViewIds:s.additionalResourcesAndViewIds.map(({resource:d,viewId:D})=>({resource:w.URI.revive(d),viewId:D})),viewId:s.editorId,isActive:s.isActive,move:async(d,D)=>{this._proxy.$moveTab(s,d,c.ViewColumn.from(D)),await(0,S.raceTimeout)(I.Event.toPromise(this._onDidChangeTabs.event),1e3)},close:async()=>{await this._proxy.$closeTab(s),await(0,S.raceTimeout)(I.Event.toPromise(this._onDidChangeTabs.event),1e3)}}))),this._tabs=this._tabs.sort((s,l)=>s.viewColumn===l.viewColumn?s.index-l.index:s.viewColumn-l.viewColumn);const h=this._activeTab;this._activeTab=n===-1?void 0:this._tabs[n],this._activeTab!==h&&this._onDidChangeActiveTab.fire(this._activeTab),this._onDidChangeTabs.fire(this._tabs)}};C=xe([$e(0,R.IExtHostRpcService)],C),e.ExtHostEditorTabs=C}),define(Ee[186],_e([0,1,2,5,6,7,8,228,9,22,26]),function(oe,e,c,F,w,I,t,R,S,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class _{constructor(){this._schemes=[]}add(s){this._stateMachine=void 0,this._schemes.push(s)}delete(s){const l=this._schemes.indexOf(s);l>=0&&(this._schemes.splice(l,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const s=this._schemes.sort(),l=[];let d,D,v=14,f=14;for(const g of s){let T=d?(0,S.commonPrefixLength)(d,g):0;for(T===0?D=1:D=f;T<g.length;T++)T+1===g.length?(v=f,f=9):f+=1,l.push([D,g.toUpperCase().charCodeAt(T),f]),l.push([D,g.toLowerCase().charCodeAt(T),f]),D=f;d=g,f=v}l.push([9,58,10]),l.push([10,47,12]),this._stateMachine=new R.StateMachine(l)}}provideDocumentLinks(s){this._initStateMachine();const l=[],d=R.LinkComputer.computeLinks({getLineContent(D){return s.lineAt(D-1).text},getLineCount(){return s.lineCount}},this._stateMachine);for(const D of d){const v=t.DocumentLink.to(D);v.target&&l.push(v)}return l}}class n{constructor(s,l){this._extHostLanguageFeatures=l,this._linkProvider=new _,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=s.getProxy(F.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}_registerLinkProviderIfNotYetRegistered(){this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(void 0,"*",this._linkProvider))}registerFileSystemProvider(s,l,d,D={}){if(this._registeredSchemes.has(l))throw new Error(`a provider for the scheme '${l}' is already registered`);this._registerLinkProviderIfNotYetRegistered();const v=this._handlePool++;this._linkProvider.add(l),this._registeredSchemes.add(l),this._fsProvider.set(v,d);let f=2;D.isCaseSensitive&&(f+=1024),D.isReadonly&&(f+=2048),typeof d.copy=="function"&&(f+=8),typeof d.open=="function"&&typeof d.close=="function"&&typeof d.read=="function"&&typeof d.write=="function"&&((0,A.checkProposedApiEnabled)(s,"fsChunks"),f+=4),this._proxy.$registerFileSystemProvider(v,l,f).catch(T=>{console.error(`FAILED to register filesystem provider of ${s.identifier.value}-extension for the scheme ${l}`),console.error(T)});const g=d.onDidChangeFile(T=>{const u=[];for(const M of T){let{uri:r,type:i}=M;if(r.scheme!==l)continue;let p;switch(i){case I.FileChangeType.Changed:p=0;break;case I.FileChangeType.Created:p=1;break;case I.FileChangeType.Deleted:p=2;break;default:throw new Error("Unknown FileChangeType")}u.push({resource:r,type:p})}this._proxy.$onFileSystemChange(v,u)});return(0,w.toDisposable)(()=>{g.dispose(),this._linkProvider.delete(l),this._registeredSchemes.delete(l),this._fsProvider.delete(v),this._proxy.$unregisterProvider(v)})}static _asIStat(s){const{type:l,ctime:d,mtime:D,size:v,permissions:f}=s;return{type:l,ctime:d,mtime:D,size:v,permissions:f}}$stat(s,l){return Promise.resolve(this._getFsProvider(s).stat(c.URI.revive(l))).then(d=>n._asIStat(d))}$readdir(s,l){return Promise.resolve(this._getFsProvider(s).readDirectory(c.URI.revive(l)))}$readFile(s,l){return Promise.resolve(this._getFsProvider(s).readFile(c.URI.revive(l))).then(d=>C.VSBuffer.wrap(d))}$writeFile(s,l,d,D){return Promise.resolve(this._getFsProvider(s).writeFile(c.URI.revive(l),d.buffer,D))}$delete(s,l,d){return Promise.resolve(this._getFsProvider(s).delete(c.URI.revive(l),d))}$rename(s,l,d,D){return Promise.resolve(this._getFsProvider(s).rename(c.URI.revive(l),c.URI.revive(d),D))}$copy(s,l,d,D){const v=this._getFsProvider(s);if(!v.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(v.copy(c.URI.revive(l),c.URI.revive(d),D))}$mkdir(s,l){return Promise.resolve(this._getFsProvider(s).createDirectory(c.URI.revive(l)))}$watch(s,l,d,D){const v=this._getFsProvider(s).watch(c.URI.revive(d),D);this._watches.set(l,v)}$unwatch(s,l){const d=this._watches.get(l);d&&(d.dispose(),this._watches.delete(l))}$open(s,l,d){const D=this._getFsProvider(s);if(!D.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(D.open(c.URI.revive(l),d))}$close(s,l){const d=this._getFsProvider(s);if(!d.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(d.close(l))}$read(s,l,d,D){const v=this._getFsProvider(s);if(!v.read)throw new Error('FileSystemProvider does not implement "read"');const f=C.VSBuffer.alloc(D);return Promise.resolve(v.read(l,d,f.buffer,0,D)).then(g=>f.slice(0,g))}$write(s,l,d,D){const v=this._getFsProvider(s);if(!v.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(v.write(l,d,D.buffer,0,D.byteLength))}_getFsProvider(s){const l=this._fsProvider.get(s);if(!l){const d=new Error;throw d.name="ENOPRO",d.message="no provider",d}return l}}e.ExtHostFileSystem=n}),define(Ee[50],_e([0,1,5,46,7,22,4,13,30,6]),function(oe,e,c,F,w,I,t,R,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let A=class Ht{constructor(n,h){this._fileSystemProvider=new Map,this._proxy=n.getProxy(c.MainContext.MainThreadFileSystem);const s=this;this.value=Object.freeze({async stat(l){try{const d=s._fileSystemProvider.get(l.scheme);if(!d)return await s._proxy.$stat(l);await s._proxy.$ensureActivation(l.scheme);const D=await d.stat(l);return{type:D.type,ctime:D.ctime,mtime:D.mtime,size:D.size,permissions:D.permissions}}catch(d){Ht._handleError(d)}},async readDirectory(l){try{const d=s._fileSystemProvider.get(l.scheme);return d?(await s._proxy.$ensureActivation(l.scheme),(await d.readDirectory(l)).slice()):await s._proxy.$readdir(l)}catch(d){return Ht._handleError(d)}},async createDirectory(l){try{return await s._proxy.$mkdir(l)}catch(d){return Ht._handleError(d)}},async readFile(l){try{const d=s._fileSystemProvider.get(l.scheme);return d?(await s._proxy.$ensureActivation(l.scheme),(await d.readFile(l)).slice()):(await s._proxy.$readFile(l)).buffer}catch(d){return Ht._handleError(d)}},async writeFile(l,d){try{return await s._proxy.$writeFile(l,I.VSBuffer.wrap(d))}catch(D){return Ht._handleError(D)}},async delete(l,d){try{const D=s._fileSystemProvider.get(l.scheme);return D?(await s._proxy.$ensureActivation(l.scheme),await D.delete(l,{recursive:!1,...d})):await s._proxy.$delete(l,{recursive:!1,useTrash:!1,...d})}catch(D){return Ht._handleError(D)}},async rename(l,d,D){try{return await s._proxy.$rename(l,d,{overwrite:!1,...D})}catch(v){return Ht._handleError(v)}},async copy(l,d,D){try{return await s._proxy.$copy(l,d,{overwrite:!1,...D})}catch(v){return Ht._handleError(v)}},isWritableFileSystem(l){const d=h.getCapabilities(l);if(typeof d=="number")return!(d&2048)}})}static _handleError(n){if(n instanceof w.FileSystemError)throw n;if(!(n instanceof Error))throw new w.FileSystemError(String(n));if(n.name==="ENOPRO")throw w.FileSystemError.Unavailable(n.message);switch(n.name){case F.FileSystemProviderErrorCode.FileExists:throw w.FileSystemError.FileExists(n.message);case F.FileSystemProviderErrorCode.FileNotFound:throw w.FileSystemError.FileNotFound(n.message);case F.FileSystemProviderErrorCode.FileNotADirectory:throw w.FileSystemError.FileNotADirectory(n.message);case F.FileSystemProviderErrorCode.FileIsADirectory:throw w.FileSystemError.FileIsADirectory(n.message);case F.FileSystemProviderErrorCode.NoPermissions:throw w.FileSystemError.NoPermissions(n.message);case F.FileSystemProviderErrorCode.Unavailable:throw w.FileSystemError.Unavailable(n.message);default:throw new w.FileSystemError(n.message,n.name)}}addFileSystemProvider(n,h){return this._fileSystemProvider.set(n,h),(0,C.toDisposable)(()=>this._fileSystemProvider.delete(n))}};A=xe([$e(0,R.IExtHostRpcService),$e(1,S.IExtHostFileSystemInfo)],A),e.ExtHostConsumerFileSystem=A,e.IExtHostConsumerFileSystem=(0,t.createDecorator)("IExtHostConsumerFileSystem")}),define(Ee[187],_e([0,1,2,38]),function(oe,e,c,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class w{constructor(t,R,S,C){this._extHostNotebooks=R,this._textDocumentsAndEditors=S,this._commands=C;const A=new F.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new F.ApiCommandArgument("showOptions","Show Options",_=>!0,_=>_),new F.ApiCommandArgument("resource","Interactive resource Uri",_=>!0,_=>_),new F.ApiCommandArgument("controllerId","Notebook controller Id",_=>!0,_=>_),new F.ApiCommandArgument("title","Interactive editor title",_=>!0,_=>_)],new F.ApiCommandResult("Notebook and input URI",_=>{if(_.notebookEditorId!==void 0){const n=this._extHostNotebooks.getEditorById(_.notebookEditorId);return{notebookUri:c.URI.revive(_.notebookUri),inputUri:c.URI.revive(_.inputUri),notebookEditor:n.apiEditor}}return{notebookUri:c.URI.revive(_.notebookUri),inputUri:c.URI.revive(_.inputUri)}}));this._commands.registerApiCommand(A)}$willAddInteractiveDocument(t,R,S,C){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:R,lines:[""],languageId:S,uri:t,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(c.URI.revive(C))?.apiNotebook}]})}$willRemoveInteractiveDocument(t,R){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[t]})}}e.ExtHostInteractive=w}),define(Ee[188],_e([0,1,6,5]),function(oe,e,c,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class w{constructor(t){this._handlePool=0,this._proxy=t.getProxy(F.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(t){const R=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(R,t),(0,c.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(R)})}}e.ExtHostLabelService=w}),define(Ee[189],_e([0,1,2,27,8,7,5,9,59,16,11,229,6,79,52,63,190,15,3]),function(oe,e,c,F,w,I,t,R,S,C,A,_,n,h,s,l,d,D,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.InlineCompletionController=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class f{constructor($,G){this._documents=$,this._provider=G}async provideDocumentSymbols($,G){const X=this._documents.getDocument($),se=await this._provider.provideDocumentSymbols(X,G);if(!(0,C.isFalsyOrEmpty)(se))return se[0]instanceof I.DocumentSymbol?se.map(w.DocumentSymbol.from):f._asDocumentSymbolTree(se)}static _asDocumentSymbolTree($){$=$.slice(0).sort((se,j)=>{let Z=se.location.range.start.compareTo(j.location.range.start);return Z===0&&(Z=j.location.range.end.compareTo(se.location.range.end)),Z});const G=[],X=[];for(const se of $){const j={name:se.name||"!!MISSING: name!!",kind:w.SymbolKind.from(se.kind),tags:se.tags?.map(w.SymbolTag.from)||[],detail:"",containerName:se.containerName,range:w.Range.from(se.location.range),selectionRange:w.Range.from(se.location.range),children:[]};for(;;){if(X.length===0){X.push(j),G.push(j);break}const Z=X[X.length-1];if(S.Range.containsRange(Z.range,j.range)&&!S.Range.equalsRange(Z.range,j.range)){Z.children&&Z.children.push(j),X.push(j);break}X.pop()}}return G}}class g{constructor($,G,X){this._documents=$,this._commands=G,this._provider=X,this._cache=new l.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses($,G){const X=this._documents.getDocument($),se=await this._provider.provideCodeLenses(X,G);if(!se||G.isCancellationRequested)return;const j=this._cache.add(se),Z=new n.DisposableStore;this._disposables.set(j,Z);const fe={cacheId:j,lenses:[]};for(let Te=0;Te<se.length;Te++)fe.lenses.push({cacheId:[j,Te],range:w.Range.from(se[Te].range),command:this._commands.toInternal(se[Te].command,Z)});return fe}async resolveCodeLens($,G){const X=$.cacheId&&this._cache.get(...$.cacheId);if(!X)return;let se;if(typeof this._provider.resolveCodeLens!="function"||X.isResolved?se=X:se=await this._provider.resolveCodeLens(X,G),se||(se=X),G.isCancellationRequested)return;const j=$.cacheId&&this._disposables.get($.cacheId[0]);if(!!j)return $.command=this._commands.toInternal(se.command??g._badCmd,j),$}releaseCodeLenses($){this._disposables.get($)?.dispose(),this._disposables.delete($),this._cache.delete($)}}g._badCmd={command:"missing",title:"!!MISSING: command!!"};function T(Qe){return Array.isArray(Qe)?Qe.map(w.DefinitionLink.from):Qe?[w.DefinitionLink.from(Qe)]:[]}class u{constructor($,G){this._documents=$,this._provider=G}async provideDefinition($,G,X){const se=this._documents.getDocument($),j=w.Position.to(G),Z=await this._provider.provideDefinition(se,j,X);return T(Z)}}class M{constructor($,G){this._documents=$,this._provider=G}async provideDeclaration($,G,X){const se=this._documents.getDocument($),j=w.Position.to(G),Z=await this._provider.provideDeclaration(se,j,X);return T(Z)}}class r{constructor($,G){this._documents=$,this._provider=G}async provideImplementation($,G,X){const se=this._documents.getDocument($),j=w.Position.to(G),Z=await this._provider.provideImplementation(se,j,X);return T(Z)}}class i{constructor($,G){this._documents=$,this._provider=G}async provideTypeDefinition($,G,X){const se=this._documents.getDocument($),j=w.Position.to(G),Z=await this._provider.provideTypeDefinition(se,j,X);return T(Z)}}class p{constructor($,G){this._documents=$,this._provider=G}async provideHover($,G,X){const se=this._documents.getDocument($),j=w.Position.to(G),Z=await this._provider.provideHover(se,j,X);if(!(!Z||(0,C.isFalsyOrEmpty)(Z.contents)))return Z.range||(Z.range=se.getWordRangeAtPosition(j)),Z.range||(Z.range=new I.Range(j,j)),w.Hover.from(Z)}}class m{constructor($,G){this._documents=$,this._provider=G}async provideEvaluatableExpression($,G,X){const se=this._documents.getDocument($),j=w.Position.to(G),Z=await this._provider.provideEvaluatableExpression(se,j,X);if(Z)return w.EvaluatableExpression.from(Z)}}class o{constructor($,G){this._documents=$,this._provider=G}async provideInlineValues($,G,X,se){const j=this._documents.getDocument($),Z=await this._provider.provideInlineValues(j,w.Range.to(G),w.InlineValueContext.to(X),se);if(Array.isArray(Z))return Z.map(fe=>w.InlineValue.from(fe))}}class b{constructor($,G){this._documents=$,this._provider=G}async provideDocumentHighlights($,G,X){const se=this._documents.getDocument($),j=w.Position.to(G),Z=await this._provider.provideDocumentHighlights(se,j,X);if(Array.isArray(Z))return Z.map(w.DocumentHighlight.from)}}class a{constructor($,G){this._documents=$,this._provider=G}async provideLinkedEditingRanges($,G,X){const se=this._documents.getDocument($),j=w.Position.to(G),Z=await this._provider.provideLinkedEditingRanges(se,j,X);if(Z&&Array.isArray(Z.ranges))return{ranges:(0,C.coalesce)(Z.ranges.map(w.Range.from)),wordPattern:Z.wordPattern}}}class E{constructor($,G){this._documents=$,this._provider=G}async provideReferences($,G,X,se){const j=this._documents.getDocument($),Z=w.Position.to(G),fe=await this._provider.provideReferences(j,Z,X,se);if(Array.isArray(fe))return fe.map(w.location.from)}}class P{constructor($,G,X,se,j,Z,fe){this._documents=$,this._commands=G,this._diagnostics=X,this._provider=se,this._logService=j,this._extension=Z,this._apiDeprecation=fe,this._cache=new l.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions($,G,X,se){const j=this._documents.getDocument($),Z=_.Selection.isISelection(G)?w.Selection.to(G):w.Range.to(G),fe=[];for(const st of this._diagnostics.getDiagnostics($))if(Z.intersection(st.range)&&fe.push(st)>P._maxCodeActionsPerFile)break;const Te={diagnostics:fe,only:X.only?new I.CodeActionKind(X.only):void 0,triggerKind:w.CodeActionTriggerKind.to(X.trigger)},Ne=await this._provider.provideCodeActions(j,Z,Te,se);if(!(0,C.isNonEmptyArray)(Ne)||se.isCancellationRequested)return;const He=this._cache.add(Ne),Ke=new n.DisposableStore;this._disposables.set(He,Ke);const tt=[];for(let st=0;st<Ne.length;st++){const Xe=Ne[st];!Xe||(P._isCommand(Xe)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),tt.push({_isSynthetic:!0,title:Xe.title,command:this._commands.toInternal(Xe,Ke)})):(Te.only&&(Xe.kind?Te.only.contains(Xe.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Te.only.value} 'requested but returned code action is of kind '${Xe.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Te.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),tt.push({cacheId:[He,st],title:Xe.title,command:Xe.command&&this._commands.toInternal(Xe.command,Ke),diagnostics:Xe.diagnostics&&Xe.diagnostics.map(w.Diagnostic.from),edit:Xe.edit&&w.WorkspaceEdit.from(Xe.edit),kind:Xe.kind&&Xe.kind.value,isPreferred:Xe.isPreferred,disabled:Xe.disabled?.reason})))}return{cacheId:He,actions:tt}}async resolveCodeAction($,G){const[X,se]=$,j=this._cache.get(X,se);if(!j||P._isCommand(j)||!this._provider.resolveCodeAction)return;const Z=await this._provider.resolveCodeAction(j,G)??j;return Z?.edit?w.WorkspaceEdit.from(Z.edit):void 0}releaseCodeActions($){this._disposables.get($)?.dispose(),this._disposables.delete($),this._cache.delete($)}static _isCommand($){return typeof $.command=="string"&&typeof $.title=="string"}}P._maxCodeActionsPerFile=1e3;class k{constructor($,G){this._documents=$,this._provider=G}async provideDocumentFormattingEdits($,G,X){const se=this._documents.getDocument($),j=await this._provider.provideDocumentFormattingEdits(se,G,X);if(Array.isArray(j))return j.map(w.TextEdit.from)}}class B{constructor($,G){this._documents=$,this._provider=G}async provideDocumentRangeFormattingEdits($,G,X,se){const j=this._documents.getDocument($),Z=w.Range.to(G),fe=await this._provider.provideDocumentRangeFormattingEdits(j,Z,X,se);if(Array.isArray(fe))return fe.map(w.TextEdit.from)}}class L{constructor($,G){this._documents=$,this._provider=G,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits($,G,X,se,j){const Z=this._documents.getDocument($),fe=w.Position.to(G),Te=await this._provider.provideOnTypeFormattingEdits(Z,fe,X,se,j);if(Array.isArray(Te))return Te.map(w.TextEdit.from)}}class y{constructor($,G){this._provider=$,this._logService=G,this._symbolCache=new Map,this._resultCache=new Map}async provideWorkspaceSymbols($,G){const X=t.IdObject.mixin({symbols:[]}),se=await this._provider.provideWorkspaceSymbols($,G);if((0,C.isNonEmptyArray)(se))for(const j of se){if(!j)continue;if(!j.name){this._logService.warn("INVALID SymbolInformation, lacks name",j);continue}const Z=t.IdObject.mixin(w.WorkspaceSymbol.from(j));this._symbolCache.set(Z._id,j),X.symbols.push(Z)}return X.symbols.length>0&&this._resultCache.set(X._id,[X.symbols[0]._id,X.symbols[X.symbols.length-1]._id]),X}async resolveWorkspaceSymbol($,G){if(typeof this._provider.resolveWorkspaceSymbol!="function")return $;const X=this._symbolCache.get($._id);if(X){const se=await this._provider.resolveWorkspaceSymbol(X,G);return se&&(0,F.mixin)($,w.WorkspaceSymbol.from(se),!0)}}releaseWorkspaceSymbols($){const G=this._resultCache.get($);if(G){for(let[X,se]=G;X<=se;X++)this._symbolCache.delete(X);this._resultCache.delete($)}}}class x{constructor($,G,X){this._documents=$,this._provider=G,this._logService=X}static supportsResolving($){return typeof $.prepareRename=="function"}async provideRenameEdits($,G,X,se){const j=this._documents.getDocument($),Z=w.Position.to(G);try{const fe=await this._provider.provideRenameEdits(j,Z,X,se);return fe?w.WorkspaceEdit.from(fe):void 0}catch(fe){const Te=x._asMessage(fe);return Te?{rejectReason:Te,edits:void 0}:Promise.reject(fe)}}async resolveRenameLocation($,G,X){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const se=this._documents.getDocument($),j=w.Position.to(G);try{const Z=await this._provider.prepareRename(se,j,X);let fe,Te;if(I.Range.isRange(Z)?(fe=Z,Te=se.getText(Z)):(0,A.isObject)(Z)&&(fe=Z.range,Te=Z.placeholder),!fe||!Te)return;if(fe.start.line>j.line||fe.end.line<j.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:w.Range.from(fe),text:Te}}catch(Z){const fe=x._asMessage(Z);return fe?{rejectReason:fe,range:void 0,text:void 0}:Promise.reject(Z)}}static _asMessage($){return typeof $=="string"?$:$ instanceof Error&&typeof $.message=="string"?$.message:void 0}}class N{constructor($,G){this.resultId=$,this.tokens=G}}class z{constructor($,G){this._documents=$,this._provider=G,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens($,G,X){const se=this._documents.getDocument($),j=G!==0?this._previousResults.get(G):null;let Z=typeof j?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(se,j.resultId,X):await this._provider.provideDocumentSemanticTokens(se,X);return j&&this._previousResults.delete(G),Z?(Z=z._fixProvidedSemanticTokens(Z),this._send(z._convertToEdits(j,Z),Z)):null}async releaseDocumentSemanticColoring($){this._previousResults.delete($)}static _fixProvidedSemanticTokens($){return z._isSemanticTokens($)?z._isCorrectSemanticTokens($)?$:new I.SemanticTokens(new Uint32Array($.data),$.resultId):z._isSemanticTokensEdits($)?z._isCorrectSemanticTokensEdits($)?$:new I.SemanticTokensEdits($.edits.map(G=>new I.SemanticTokensEdit(G.start,G.deleteCount,G.data?new Uint32Array(G.data):G.data)),$.resultId):$}static _isSemanticTokens($){return $&&!!$.data}static _isCorrectSemanticTokens($){return $.data instanceof Uint32Array}static _isSemanticTokensEdits($){return $&&Array.isArray($.edits)}static _isCorrectSemanticTokensEdits($){for(const G of $.edits)if(!(G.data instanceof Uint32Array))return!1;return!0}static _convertToEdits($,G){if(!z._isSemanticTokens(G)||!$||!$.tokens)return G;const X=$.tokens,se=X.length,j=G.data,Z=j.length;let fe=0;const Te=Math.min(se,Z);for(;fe<Te&&X[fe]===j[fe];)fe++;if(fe===se&&fe===Z)return new I.SemanticTokensEdits([],G.resultId);let Ne=0;const He=Te-fe;for(;Ne<He&&X[se-Ne-1]===j[Z-Ne-1];)Ne++;return new I.SemanticTokensEdits([{start:fe,deleteCount:se-fe-Ne,data:j.subarray(fe,Z-Ne)}],G.resultId)}_send($,G){if(z._isSemanticTokens($)){const X=this._nextResultId++;return this._previousResults.set(X,new N($.resultId,$.data)),(0,h.encodeSemanticTokensDto)({id:X,type:"full",data:$.data})}if(z._isSemanticTokensEdits($)){const X=this._nextResultId++;return z._isSemanticTokens(G)?this._previousResults.set(X,new N(G.resultId,G.data)):this._previousResults.set(X,new N($.resultId)),(0,h.encodeSemanticTokensDto)({id:X,type:"delta",deltas:($.edits||[]).map(se=>({start:se.start,deleteCount:se.deleteCount,data:se.data}))})}return null}}e.DocumentSemanticTokensAdapter=z;class H{constructor($,G){this._documents=$,this._provider=G}async provideDocumentRangeSemanticTokens($,G,X){const se=this._documents.getDocument($),j=await this._provider.provideDocumentRangeSemanticTokens(se,w.Range.to(G),X);return j?this._send(j):null}_send($){return(0,h.encodeSemanticTokensDto)({id:0,type:"full",data:$.data})}}e.DocumentRangeSemanticTokensAdapter=H;class q{constructor($,G,X,se,j){this._documents=$,this._commands=G,this._provider=X,this._apiDeprecation=se,this._extension=j,this._cache=new l.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving($){return typeof $.resolveCompletionItem=="function"}async provideCompletionItems($,G,X,se){const j=this._documents.getDocument($),Z=w.Position.to(G),fe=j.getWordRangeAtPosition(Z)||new I.Range(Z,Z),Te=fe.with({end:Z}),Ne=new d.StopWatch(!0),He=await this._provider.provideCompletionItems(j,Z,se,w.CompletionContext.to(X));if(!He||se.isCancellationRequested)return;const Ke=Array.isArray(He)?new I.CompletionList(He):He,tt=q.supportsResolving(this._provider)?this._cache.add(Ke.items):this._cache.add([]),st=new n.DisposableStore;this._disposables.set(tt,st);const Xe=[],rt={x:tt,b:Xe,a:{replace:w.Range.from(fe),insert:w.Range.from(Te)},c:Ke.isIncomplete||void 0,d:Ne.elapsed()};for(let De=0;De<Ke.items.length;De++){const gt=Ke.items[De],V=this._convertCompletionItem(gt,[tt,De],Te,fe);Xe.push(V)}return rt}async resolveCompletionItem($,G){if(typeof this._provider.resolveCompletionItem!="function")return;const X=this._cache.get(...$);if(!X)return;const se=await this._provider.resolveCompletionItem(X,G);if(!!se)return this._convertCompletionItem(se,$)}releaseCompletionItems($){this._disposables.get($)?.dispose(),this._disposables.delete($),this._cache.delete($)}_convertCompletionItem($,G,X,se){const j=this._disposables.get(G[0]);if(!j)throw Error("DisposableStore is missing...");const Z={x:G,a:$.label,b:$.kind!==void 0?w.CompletionItemKind.from($.kind):void 0,n:$.tags&&$.tags.map(w.CompletionItemTag.from),c:$.detail,d:typeof $.documentation=="undefined"?void 0:w.MarkdownString.fromStrict($.documentation),e:$.sortText!==$.label?$.sortText:void 0,f:$.filterText!==$.label?$.filterText:void 0,g:$.preselect||void 0,i:$.keepWhitespace?1:0,k:$.commitCharacters,l:$.additionalTextEdits&&$.additionalTextEdits.map(w.TextEdit.from),m:this._commands.toInternal($.command,j)};$.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Z.h=$.textEdit.newText):typeof $.insertText=="string"?Z.h=$.insertText:$.insertText instanceof I.SnippetString&&(Z.h=$.insertText.value,Z.i|=4);let fe;return $.textEdit?fe=$.textEdit.range:$.range&&(fe=$.range),I.Range.isRange(fe)?Z.j=w.Range.from(fe):fe&&(!X?.isEqual(fe.inserting)||!se?.isEqual(fe.replacing))&&(Z.j={insert:w.Range.from(fe.inserting),replace:w.Range.from(fe.replacing)}),Z}}class ue{constructor($,G,X){this._documents=$,this._provider=G,this._commands=X,this._cache=new l.Cache("InlineCompletionItem"),this._disposables=new Map}async provideInlineCompletions($,G,X,se){const j=this._documents.getDocument($),Z=w.Position.to(G),fe=await this._provider.provideInlineCompletionItems(j,Z,{selectedCompletionInfo:X.selectedSuggestionInfo?{range:w.Range.to(X.selectedSuggestionInfo.range),text:X.selectedSuggestionInfo.text,isSnippetText:X.selectedSuggestionInfo.isSnippetText,completionKind:w.CompletionItemKind.to(X.selectedSuggestionInfo.completionKind)}:void 0,triggerKind:X.triggerKind},se);if(!fe||se.isCancellationRequested)return;const Te=(0,A.isArray)(fe)?{items:fe}:fe,Ne=this._cache.add(Te.items);let He;return{pid:Ne,items:Te.items.map((Ke,tt)=>{let st;return Ke.command&&(He||(He=new n.DisposableStore,this._disposables.set(Ne,He)),st=this._commands.toInternal(Ke.command,He)),{text:Ke.text,range:Ke.range?w.Range.from(Ke.range):void 0,command:st,idx:tt}})}}disposeCompletions($){this._cache.delete($);const G=this._disposables.get($);G&&G.clear(),this._disposables.delete($)}handleDidShowCompletionItem($,G){const X=this._cache.get($,G);X&&K.get(this._provider).fireOnDidShowCompletionItem({completionItem:X})}}class K{constructor(){this._onDidShowCompletionItemEmitter=new v.Emitter,this.onDidShowCompletionItem=this._onDidShowCompletionItemEmitter.event}static get($){let G=K.map.get($);return G||(G=new K,K.map.set($,G)),G}fireOnDidShowCompletionItem($){this._onDidShowCompletionItemEmitter.fire($)}}e.InlineCompletionController=K,K.map=new WeakMap;class ce{constructor($,G){this._documents=$,this._provider=G,this._cache=new l.Cache("SignatureHelp")}async provideSignatureHelp($,G,X,se){const j=this._documents.getDocument($),Z=w.Position.to(G),fe=this.reviveContext(X),Te=await this._provider.provideSignatureHelp(j,Z,se,fe);if(Te){const Ne=this._cache.add([Te]);return{...w.SignatureHelp.from(Te),id:Ne}}}reviveContext($){let G;if($.activeSignatureHelp){const X=w.SignatureHelp.to($.activeSignatureHelp),se=this._cache.get($.activeSignatureHelp.id,0);se?(G=se,G.activeSignature=X.activeSignature,G.activeParameter=X.activeParameter):G=X}return{...$,activeSignatureHelp:G}}releaseSignatureHelp($){this._cache.delete($)}}class de{constructor($,G){this._documents=$,this._provider=G}async provideInlayHints($,G,X){const se=this._documents.getDocument($),j=await this._provider.provideInlayHints(se,w.Range.to(G),X);return j?{hints:j.map(w.InlayHint.from)}:void 0}}class Q{constructor($,G){this._documents=$,this._provider=G,this._cache=new l.Cache("DocumentLink")}async provideLinks($,G){const X=this._documents.getDocument($),se=await this._provider.provideDocumentLinks(X,G);if(!(!Array.isArray(se)||se.length===0)&&!G.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:se.filter(Q._validateLink).map(w.DocumentLink.from)};{const j=this._cache.add(se),Z={links:[],id:j};for(let fe=0;fe<se.length;fe++){if(!Q._validateLink(se[fe]))continue;const Te=w.DocumentLink.from(se[fe]);Te.cacheId=[j,fe],Z.links.push(Te)}return Z}}}static _validateLink($){return $.target&&$.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink($,G){if(typeof this._provider.resolveDocumentLink!="function")return;const X=this._cache.get(...$);if(!X)return;const se=await this._provider.resolveDocumentLink(X,G);if(!(!se||!Q._validateLink(se)))return w.DocumentLink.from(se)}releaseLinks($){this._cache.delete($)}}class ie{constructor($,G){this._documents=$,this._provider=G}async provideColors($,G){const X=this._documents.getDocument($),se=await this._provider.provideDocumentColors(X,G);return Array.isArray(se)?se.map(Z=>({color:w.Color.from(Z.color),range:w.Range.from(Z.range)})):[]}async provideColorPresentations($,G,X){const se=this._documents.getDocument($),j=w.Range.to(G.range),Z=w.Color.to(G.color),fe=await this._provider.provideColorPresentations(Z,{document:se,range:j},X);if(!!Array.isArray(fe))return fe.map(w.ColorPresentation.from)}}class we{constructor($,G){this._documents=$,this._provider=G}async provideFoldingRanges($,G,X){const se=this._documents.getDocument($),j=await this._provider.provideFoldingRanges(se,G,X);if(!!Array.isArray(j))return j.map(w.FoldingRange.from)}}class Me{constructor($,G,X){this._documents=$,this._provider=G,this._logService=X}async provideSelectionRanges($,G,X){const se=this._documents.getDocument($),j=G.map(w.Position.to),Z=await this._provider.provideSelectionRanges(se,j,X);if(!(0,C.isNonEmptyArray)(Z))return[];if(Z.length!==j.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const fe=[];for(let Te=0;Te<j.length;Te++){const Ne=[];fe.push(Ne);let He=j[Te],Ke=Z[Te];for(;;){if(!Ke.range.contains(He))throw new Error("INVALID selection range, must contain the previous range");if(Ne.push(w.SelectionRange.from(Ke)),!Ke.parent)break;He=Ke.range,Ke=Ke.parent}}return fe}}class Fe{constructor($,G){this._documents=$,this._provider=G,this._idPool=new s.IdGenerator(""),this._cache=new Map}async prepareSession($,G,X){const se=this._documents.getDocument($),j=w.Position.to(G),Z=await this._provider.prepareCallHierarchy(se,j,X);if(!Z)return;const fe=this._idPool.nextId();return this._cache.set(fe,new Map),Array.isArray(Z)?Z.map(Te=>this._cacheAndConvertItem(fe,Te)):[this._cacheAndConvertItem(fe,Z)]}async provideCallsTo($,G,X){const se=this._itemFromCache($,G);if(!se)throw new Error("missing call hierarchy item");const j=await this._provider.provideCallHierarchyIncomingCalls(se,X);if(!!j)return j.map(Z=>({from:this._cacheAndConvertItem($,Z.from),fromRanges:Z.fromRanges.map(fe=>w.Range.from(fe))}))}async provideCallsFrom($,G,X){const se=this._itemFromCache($,G);if(!se)throw new Error("missing call hierarchy item");const j=await this._provider.provideCallHierarchyOutgoingCalls(se,X);if(!!j)return j.map(Z=>({to:this._cacheAndConvertItem($,Z.to),fromRanges:Z.fromRanges.map(fe=>w.Range.from(fe))}))}releaseSession($){this._cache.delete($)}_cacheAndConvertItem($,G){const X=this._cache.get($),se=w.CallHierarchyItem.from(G,$,X.size.toString(36));return X.set(se._itemId,G),se}_itemFromCache($,G){return this._cache.get($)?.get(G)}}class Be{constructor($,G){this._documents=$,this._provider=G,this._idPool=new s.IdGenerator(""),this._cache=new Map}async prepareSession($,G,X){const se=this._documents.getDocument($),j=w.Position.to(G),Z=await this._provider.prepareTypeHierarchy(se,j,X);if(!Z)return;const fe=this._idPool.nextId();return this._cache.set(fe,new Map),Array.isArray(Z)?Z.map(Te=>this._cacheAndConvertItem(fe,Te)):[this._cacheAndConvertItem(fe,Z)]}async provideSupertypes($,G,X){const se=this._itemFromCache($,G);if(!se)throw new Error("missing type hierarchy item");const j=await this._provider.provideTypeHierarchySupertypes(se,X);if(!!j)return j.map(Z=>this._cacheAndConvertItem($,Z))}async provideSubtypes($,G,X){const se=this._itemFromCache($,G);if(!se)throw new Error("missing type hierarchy item");const j=await this._provider.provideTypeHierarchySubtypes(se,X);if(!!j)return j.map(Z=>this._cacheAndConvertItem($,Z))}releaseSession($){this._cache.delete($)}_cacheAndConvertItem($,G){const X=this._cache.get($),se=w.TypeHierarchyItem.from(G,$,X.size.toString(36));return X.set(se._itemId,G),se}_itemFromCache($,G){return this._cache.get($)?.get(G)}}class Ge{constructor($,G){this.adapter=$,this.extension=G}}class je{constructor($,G,X,se,j,Z,fe){this._adapter=new Map,this._uriTransformer=G,this._proxy=$.getProxy(t.MainContext.MainThreadLanguageFeatures),this._documents=X,this._commands=se,this._diagnostics=j,this._logService=Z,this._apiDeprecation=fe}_transformDocumentSelector($){return w.DocumentSelector.from($,this._uriTransformer)}_createDisposable($){return new I.Disposable(()=>{this._adapter.delete($),this._proxy.$unregister($)})}_nextHandle(){return je._handlePool++}_withAdapter($,G,X,se,j=!1){const Z=this._adapter.get($);if(!Z)return Promise.resolve(se);if(Z.adapter instanceof G){let fe;Z.extension&&(fe=Date.now(),this._logService.trace(`[${Z.extension.identifier.value}] INVOKE provider '${G.name}'`));const Te=X(Z.adapter,Z.extension),Ne=Z.extension;return Ne&&Promise.resolve(Te).then(()=>this._logService.trace(`[${Ne.identifier.value}] provider DONE after ${Date.now()-fe}ms`),He=>{j&&He instanceof D.CancellationError||(this._logService.error(`[${Ne.identifier.value}] provider FAILED`),this._logService.error(He))}),Te}return Promise.reject(new Error("no adapter found"))}_addNewAdapter($,G){const X=this._nextHandle();return this._adapter.set(X,new Ge($,G)),X}static _extLabel($){return $.displayName||$.name}registerDocumentSymbolProvider($,G,X,se){const j=this._addNewAdapter(new f(this._documents,X),$),Z=se&&se.label||je._extLabel($);return this._proxy.$registerDocumentSymbolProvider(j,this._transformDocumentSelector(G),Z),this._createDisposable(j)}$provideDocumentSymbols($,G,X){return this._withAdapter($,f,se=>se.provideDocumentSymbols(c.URI.revive(G),X),void 0)}registerCodeLensProvider($,G,X){const se=this._nextHandle(),j=typeof X.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(se,new Ge(new g(this._documents,this._commands.converter,X),$)),this._proxy.$registerCodeLensSupport(se,this._transformDocumentSelector(G),j);let Z=this._createDisposable(se);if(j!==void 0){const fe=X.onDidChangeCodeLenses(Te=>this._proxy.$emitCodeLensEvent(j));Z=I.Disposable.from(Z,fe)}return Z}$provideCodeLenses($,G,X){return this._withAdapter($,g,se=>se.provideCodeLenses(c.URI.revive(G),X),void 0)}$resolveCodeLens($,G,X){return this._withAdapter($,g,se=>se.resolveCodeLens(G,X),void 0)}$releaseCodeLenses($,G){this._withAdapter($,g,X=>Promise.resolve(X.releaseCodeLenses(G)),void 0)}registerDefinitionProvider($,G,X){const se=this._addNewAdapter(new u(this._documents,X),$);return this._proxy.$registerDefinitionSupport(se,this._transformDocumentSelector(G)),this._createDisposable(se)}$provideDefinition($,G,X,se){return this._withAdapter($,u,j=>j.provideDefinition(c.URI.revive(G),X,se),[])}registerDeclarationProvider($,G,X){const se=this._addNewAdapter(new M(this._documents,X),$);return this._proxy.$registerDeclarationSupport(se,this._transformDocumentSelector(G)),this._createDisposable(se)}$provideDeclaration($,G,X,se){return this._withAdapter($,M,j=>j.provideDeclaration(c.URI.revive(G),X,se),[])}registerImplementationProvider($,G,X){const se=this._addNewAdapter(new r(this._documents,X),$);return this._proxy.$registerImplementationSupport(se,this._transformDocumentSelector(G)),this._createDisposable(se)}$provideImplementation($,G,X,se){return this._withAdapter($,r,j=>j.provideImplementation(c.URI.revive(G),X,se),[])}registerTypeDefinitionProvider($,G,X){const se=this._addNewAdapter(new i(this._documents,X),$);return this._proxy.$registerTypeDefinitionSupport(se,this._transformDocumentSelector(G)),this._createDisposable(se)}$provideTypeDefinition($,G,X,se){return this._withAdapter($,i,j=>j.provideTypeDefinition(c.URI.revive(G),X,se),[])}registerHoverProvider($,G,X,se){const j=this._addNewAdapter(new p(this._documents,X),$);return this._proxy.$registerHoverProvider(j,this._transformDocumentSelector(G)),this._createDisposable(j)}$provideHover($,G,X,se){return this._withAdapter($,p,j=>j.provideHover(c.URI.revive(G),X,se),void 0)}registerEvaluatableExpressionProvider($,G,X,se){const j=this._addNewAdapter(new m(this._documents,X),$);return this._proxy.$registerEvaluatableExpressionProvider(j,this._transformDocumentSelector(G)),this._createDisposable(j)}$provideEvaluatableExpression($,G,X,se){return this._withAdapter($,m,j=>j.provideEvaluatableExpression(c.URI.revive(G),X,se),void 0)}registerInlineValuesProvider($,G,X,se){const j=typeof X.onDidChangeInlineValues=="function"?this._nextHandle():void 0,Z=this._addNewAdapter(new o(this._documents,X),$);this._proxy.$registerInlineValuesProvider(Z,this._transformDocumentSelector(G),j);let fe=this._createDisposable(Z);if(j!==void 0){const Te=X.onDidChangeInlineValues(Ne=>this._proxy.$emitInlineValuesEvent(j));fe=I.Disposable.from(fe,Te)}return fe}$provideInlineValues($,G,X,se,j){return this._withAdapter($,o,Z=>Z.provideInlineValues(c.URI.revive(G),X,se,j),void 0)}registerDocumentHighlightProvider($,G,X){const se=this._addNewAdapter(new b(this._documents,X),$);return this._proxy.$registerDocumentHighlightProvider(se,this._transformDocumentSelector(G)),this._createDisposable(se)}$provideDocumentHighlights($,G,X,se){return this._withAdapter($,b,j=>j.provideDocumentHighlights(c.URI.revive(G),X,se),void 0)}registerLinkedEditingRangeProvider($,G,X){const se=this._addNewAdapter(new a(this._documents,X),$);return this._proxy.$registerLinkedEditingRangeProvider(se,this._transformDocumentSelector(G)),this._createDisposable(se)}$provideLinkedEditingRanges($,G,X,se){return this._withAdapter($,a,async j=>{const Z=await j.provideLinkedEditingRanges(c.URI.revive(G),X,se);if(Z)return{ranges:Z.ranges,wordPattern:Z.wordPattern?je._serializeRegExp(Z.wordPattern):void 0}},void 0)}registerReferenceProvider($,G,X){const se=this._addNewAdapter(new E(this._documents,X),$);return this._proxy.$registerReferenceSupport(se,this._transformDocumentSelector(G)),this._createDisposable(se)}$provideReferences($,G,X,se,j){return this._withAdapter($,E,Z=>Z.provideReferences(c.URI.revive(G),X,se,j),void 0)}registerCodeActionProvider($,G,X,se){const j=new n.DisposableStore,Z=this._addNewAdapter(new P(this._documents,this._commands.converter,this._diagnostics,X,this._logService,$,this._apiDeprecation),$);return this._proxy.$registerQuickFixSupport(Z,this._transformDocumentSelector(G),{providedKinds:se?.providedCodeActionKinds?.map(fe=>fe.value),documentation:se?.documentation?.map(fe=>({kind:fe.kind.value,command:this._commands.converter.toInternal(fe.command,j)}))},je._extLabel($),Boolean(X.resolveCodeAction)),j.add(this._createDisposable(Z)),j}$provideCodeActions($,G,X,se,j){return this._withAdapter($,P,Z=>Z.provideCodeActions(c.URI.revive(G),X,se,j),void 0)}$resolveCodeAction($,G,X){return this._withAdapter($,P,se=>se.resolveCodeAction(G,X),void 0)}$releaseCodeActions($,G){this._withAdapter($,P,X=>Promise.resolve(X.releaseCodeActions(G)),void 0)}registerDocumentFormattingEditProvider($,G,X){const se=this._addNewAdapter(new k(this._documents,X),$);return this._proxy.$registerDocumentFormattingSupport(se,this._transformDocumentSelector(G),$.identifier,$.displayName||$.name),this._createDisposable(se)}$provideDocumentFormattingEdits($,G,X,se){return this._withAdapter($,k,j=>j.provideDocumentFormattingEdits(c.URI.revive(G),X,se),void 0)}registerDocumentRangeFormattingEditProvider($,G,X){const se=this._addNewAdapter(new B(this._documents,X),$);return this._proxy.$registerRangeFormattingSupport(se,this._transformDocumentSelector(G),$.identifier,$.displayName||$.name),this._createDisposable(se)}$provideDocumentRangeFormattingEdits($,G,X,se,j){return this._withAdapter($,B,Z=>Z.provideDocumentRangeFormattingEdits(c.URI.revive(G),X,se,j),void 0)}registerOnTypeFormattingEditProvider($,G,X,se){const j=this._addNewAdapter(new L(this._documents,X),$);return this._proxy.$registerOnTypeFormattingSupport(j,this._transformDocumentSelector(G),se,$.identifier),this._createDisposable(j)}$provideOnTypeFormattingEdits($,G,X,se,j,Z){return this._withAdapter($,L,fe=>fe.provideOnTypeFormattingEdits(c.URI.revive(G),X,se,j,Z),void 0)}registerWorkspaceSymbolProvider($,G){const X=this._addNewAdapter(new y(G,this._logService),$);return this._proxy.$registerNavigateTypeSupport(X,typeof G.resolveWorkspaceSymbol=="function"),this._createDisposable(X)}$provideWorkspaceSymbols($,G,X){return this._withAdapter($,y,se=>se.provideWorkspaceSymbols(G,X),{symbols:[]})}$resolveWorkspaceSymbol($,G,X){return this._withAdapter($,y,se=>se.resolveWorkspaceSymbol(G,X),void 0)}$releaseWorkspaceSymbols($,G){this._withAdapter($,y,X=>X.releaseWorkspaceSymbols(G),void 0)}registerRenameProvider($,G,X){const se=this._addNewAdapter(new x(this._documents,X,this._logService),$);return this._proxy.$registerRenameSupport(se,this._transformDocumentSelector(G),x.supportsResolving(X)),this._createDisposable(se)}$provideRenameEdits($,G,X,se,j){return this._withAdapter($,x,Z=>Z.provideRenameEdits(c.URI.revive(G),X,se,j),void 0)}$resolveRenameLocation($,G,X,se){return this._withAdapter($,x,j=>j.resolveRenameLocation(c.URI.revive(G),X,se),void 0)}registerDocumentSemanticTokensProvider($,G,X,se){const j=this._nextHandle(),Z=typeof X.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._adapter.set(j,new Ge(new z(this._documents,X),$)),this._proxy.$registerDocumentSemanticTokensProvider(j,this._transformDocumentSelector(G),se,Z);let fe=this._createDisposable(j);if(Z){const Te=X.onDidChangeSemanticTokens(Ne=>this._proxy.$emitDocumentSemanticTokensEvent(Z));fe=I.Disposable.from(fe,Te)}return fe}$provideDocumentSemanticTokens($,G,X,se){return this._withAdapter($,z,j=>j.provideDocumentSemanticTokens(c.URI.revive(G),X,se),null,!0)}$releaseDocumentSemanticTokens($,G){this._withAdapter($,z,X=>X.releaseDocumentSemanticColoring(G),void 0)}registerDocumentRangeSemanticTokensProvider($,G,X,se){const j=this._addNewAdapter(new H(this._documents,X),$);return this._proxy.$registerDocumentRangeSemanticTokensProvider(j,this._transformDocumentSelector(G),se),this._createDisposable(j)}$provideDocumentRangeSemanticTokens($,G,X,se){return this._withAdapter($,H,j=>j.provideDocumentRangeSemanticTokens(c.URI.revive(G),X,se),null,!0)}registerCompletionItemProvider($,G,X,se){const j=this._addNewAdapter(new q(this._documents,this._commands.converter,X,this._apiDeprecation,$),$);return this._proxy.$registerSuggestSupport(j,this._transformDocumentSelector(G),se,q.supportsResolving(X),`${$.identifier.value}(${se.join("")})`),this._createDisposable(j)}$provideCompletionItems($,G,X,se,j){return this._withAdapter($,q,Z=>Z.provideCompletionItems(c.URI.revive(G),X,se,j),void 0)}$resolveCompletionItem($,G,X){return this._withAdapter($,q,se=>se.resolveCompletionItem(G,X),void 0)}$releaseCompletionItems($,G){this._withAdapter($,q,X=>X.releaseCompletionItems(G),void 0)}registerInlineCompletionsProvider($,G,X){const se=this._addNewAdapter(new ue(this._documents,X,this._commands.converter),$);return this._proxy.$registerInlineCompletionsSupport(se,this._transformDocumentSelector(G)),this._createDisposable(se)}$provideInlineCompletions($,G,X,se,j){return this._withAdapter($,ue,Z=>Z.provideInlineCompletions(c.URI.revive(G),X,se,j),void 0)}$handleInlineCompletionDidShow($,G,X){this._withAdapter($,ue,async se=>{se.handleDidShowCompletionItem(G,X)},void 0)}$freeInlineCompletionsList($,G){this._withAdapter($,ue,async X=>{X.disposeCompletions(G)},void 0)}registerSignatureHelpProvider($,G,X,se){const j=Array.isArray(se)?{triggerCharacters:se,retriggerCharacters:[]}:se,Z=this._addNewAdapter(new ce(this._documents,X),$);return this._proxy.$registerSignatureHelpProvider(Z,this._transformDocumentSelector(G),j),this._createDisposable(Z)}$provideSignatureHelp($,G,X,se,j){return this._withAdapter($,ce,Z=>Z.provideSignatureHelp(c.URI.revive(G),X,se,j),void 0)}$releaseSignatureHelp($,G){this._withAdapter($,ce,X=>X.releaseSignatureHelp(G),void 0)}registerInlayHintsProvider($,G,X){const se=typeof X.onDidChangeInlayHints=="function"?this._nextHandle():void 0,j=this._addNewAdapter(new de(this._documents,X),$);this._proxy.$registerInlayHintsProvider(j,this._transformDocumentSelector(G),se);let Z=this._createDisposable(j);if(se!==void 0){const fe=X.onDidChangeInlayHints(Te=>this._proxy.$emitInlayHintsEvent(se));Z=I.Disposable.from(Z,fe)}return Z}$provideInlayHints($,G,X,se){return this._withAdapter($,de,j=>j.provideInlayHints(c.URI.revive(G),X,se),void 0)}registerDocumentLinkProvider($,G,X){const se=this._addNewAdapter(new Q(this._documents,X),$);return this._proxy.$registerDocumentLinkProvider(se,this._transformDocumentSelector(G),typeof X.resolveDocumentLink=="function"),this._createDisposable(se)}$provideDocumentLinks($,G,X){return this._withAdapter($,Q,se=>se.provideLinks(c.URI.revive(G),X),void 0)}$resolveDocumentLink($,G,X){return this._withAdapter($,Q,se=>se.resolveLink(G,X),void 0)}$releaseDocumentLinks($,G){this._withAdapter($,Q,X=>X.releaseLinks(G),void 0)}registerColorProvider($,G,X){const se=this._addNewAdapter(new ie(this._documents,X),$);return this._proxy.$registerDocumentColorProvider(se,this._transformDocumentSelector(G)),this._createDisposable(se)}$provideDocumentColors($,G,X){return this._withAdapter($,ie,se=>se.provideColors(c.URI.revive(G),X),[])}$provideColorPresentations($,G,X,se){return this._withAdapter($,ie,j=>j.provideColorPresentations(c.URI.revive(G),X,se),void 0)}registerFoldingRangeProvider($,G,X){const se=this._nextHandle(),j=typeof X.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(se,new Ge(new we(this._documents,X),$)),this._proxy.$registerFoldingRangeProvider(se,this._transformDocumentSelector(G),j);let Z=this._createDisposable(se);if(j!==void 0){const fe=X.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(j));Z=I.Disposable.from(Z,fe)}return Z}$provideFoldingRanges($,G,X,se){return this._withAdapter($,we,j=>j.provideFoldingRanges(c.URI.revive(G),X,se),void 0)}registerSelectionRangeProvider($,G,X){const se=this._addNewAdapter(new Me(this._documents,X,this._logService),$);return this._proxy.$registerSelectionRangeProvider(se,this._transformDocumentSelector(G)),this._createDisposable(se)}$provideSelectionRanges($,G,X,se){return this._withAdapter($,Me,j=>j.provideSelectionRanges(c.URI.revive(G),X,se),[])}registerCallHierarchyProvider($,G,X){const se=this._addNewAdapter(new Fe(this._documents,X),$);return this._proxy.$registerCallHierarchyProvider(se,this._transformDocumentSelector(G)),this._createDisposable(se)}$prepareCallHierarchy($,G,X,se){return this._withAdapter($,Fe,j=>Promise.resolve(j.prepareSession(c.URI.revive(G),X,se)),void 0)}$provideCallHierarchyIncomingCalls($,G,X,se){return this._withAdapter($,Fe,j=>j.provideCallsTo(G,X,se),void 0)}$provideCallHierarchyOutgoingCalls($,G,X,se){return this._withAdapter($,Fe,j=>j.provideCallsFrom(G,X,se),void 0)}$releaseCallHierarchy($,G){this._withAdapter($,Fe,X=>Promise.resolve(X.releaseSession(G)),void 0)}registerTypeHierarchyProvider($,G,X){const se=this._addNewAdapter(new Be(this._documents,X),$);return this._proxy.$registerTypeHierarchyProvider(se,this._transformDocumentSelector(G)),this._createDisposable(se)}$prepareTypeHierarchy($,G,X,se){return this._withAdapter($,Be,j=>Promise.resolve(j.prepareSession(c.URI.revive(G),X,se)),void 0)}$provideTypeHierarchySupertypes($,G,X,se){return this._withAdapter($,Be,j=>j.provideSupertypes(G,X,se),void 0)}$provideTypeHierarchySubtypes($,G,X,se){return this._withAdapter($,Be,j=>j.provideSubtypes(G,X,se),void 0)}$releaseTypeHierarchy($,G){this._withAdapter($,Be,X=>Promise.resolve(X.releaseSession(G)),void 0)}static _serializeRegExp($){return{pattern:$.source,flags:(0,R.regExpFlags)($)}}static _serializeIndentationRule($){return{decreaseIndentPattern:je._serializeRegExp($.decreaseIndentPattern),increaseIndentPattern:je._serializeRegExp($.increaseIndentPattern),indentNextLinePattern:$.indentNextLinePattern?je._serializeRegExp($.indentNextLinePattern):void 0,unIndentedLinePattern:$.unIndentedLinePattern?je._serializeRegExp($.unIndentedLinePattern):void 0}}static _serializeOnEnterRule($){return{beforeText:je._serializeRegExp($.beforeText),afterText:$.afterText?je._serializeRegExp($.afterText):void 0,previousLineText:$.previousLineText?je._serializeRegExp($.previousLineText):void 0,action:$.action}}static _serializeOnEnterRules($){return $.map(je._serializeOnEnterRule)}setLanguageConfiguration($,G,X){let{wordPattern:se}=X;if(se&&(0,R.regExpLeadsToEndlessLoop)(se))throw new Error(`Invalid language configuration: wordPattern '${se}' is not allowed to match the empty string.`);se?this._documents.setWordDefinitionFor(G,se):this._documents.setWordDefinitionFor(G,void 0),X.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",$,"Do not use."),X.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",$,"Do not use.");const j=this._nextHandle(),Z={comments:X.comments,brackets:X.brackets,wordPattern:X.wordPattern?je._serializeRegExp(X.wordPattern):void 0,indentationRules:X.indentationRules?je._serializeIndentationRule(X.indentationRules):void 0,onEnterRules:X.onEnterRules?je._serializeOnEnterRules(X.onEnterRules):void 0,__electricCharacterSupport:X.__electricCharacterSupport,__characterPairSupport:X.__characterPairSupport};return this._proxy.$setLanguageConfiguration(j,G,Z),this._createDisposable(j)}$setWordDefinitions($){for(const G of $)this._documents.setWordDefinitionFor(G.languageId,new RegExp(G.regexSource,G.regexFlags))}}e.ExtHostLanguageFeatures=je,je._handlePool=0}),define(Ee[191],_e([0,1,5,8,7,34,14,6]),function(oe,e,c,F,w,I,t,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class S{constructor(A,_,n,h){this._documents=_,this._commands=n,this._uriTransformer=h,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=A.getProxy(c.MainContext.MainThreadLanguages)}$acceptLanguageIds(A){this._languageIds=A}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(A,_){await this._proxy.$changeLanguage(A,_);const n=this._documents.getDocumentData(A);if(!n)throw new Error(`document '${A.toString}' NOT found`);return n.document}async tokenAtPosition(A,_){const n=A.version,h=F.Position.from(_),s=await this._proxy.$tokensAtPosition(A.uri,h),l={type:w.StandardTokenType.Other,range:A.getWordRangeAtPosition(_)??new w.Range(_.line,_.character,_.line,_.character)};if(!s)return l;const d={range:F.Range.to(s.range),type:F.TokenType.to(s.type)};return!d.range.contains(_)||n!==A.version?l:d}createLanguageStatusItem(A,_,n){const h=this._handlePool++,s=this._proxy,l=this._ids,d=`${A.identifier.value}/${_}`;if(l.has(d))throw new Error(`LanguageStatusItem with id '${_}' ALREADY exists`);l.add(d);const D={selector:n,id:_,name:A.displayName??A.name,severity:w.LanguageStatusSeverity.Information,command:void 0,text:"",detail:""};let v,f=new R.DisposableStore;const g=()=>{v?.dispose(),v=(0,t.disposableTimeout)(()=>{f.clear(),this._proxy.$setLanguageStatus(h,{id:d,name:D.name??A.displayName??A.name,source:A.displayName??A.name,selector:F.DocumentSelector.from(D.selector,this._uriTransformer),label:D.text,detail:D.detail??"",severity:D.severity===w.LanguageStatusSeverity.Error?I.default.Error:D.severity===w.LanguageStatusSeverity.Warning?I.default.Warning:I.default.Info,command:D.command&&this._commands.toInternal(D.command,f),accessibilityInfo:D.accessibilityInformation})},0)},T={dispose(){f.dispose(),v?.dispose(),s.$removeLanguageStatus(h),l.delete(d)},get id(){return D.id},get name(){return D.name},set name(u){D.name=u,g()},get selector(){return D.selector},set selector(u){D.selector=u,g()},get text(){return D.text},set text(u){D.text=u,g()},get detail(){return D.detail},set detail(u){D.detail=u,g()},get severity(){return D.severity},set severity(u){D.severity=u,g()},get accessibilityInformation(){return D.accessibilityInformation},set accessibilityInformation(u){D.accessibilityInformation=u,g()},get command(){return D.command},set command(u){D.command=u,g()}};return g(),T}}e.ExtHostLanguages=S}),define(Ee[192],_e([0,1,12,5,28,13,3]),function(oe,e,c,F,w,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let R=class extends c.AbstractLoggerService{constructor(A,_){const n=new t.Emitter;super(_.logLevel,n.event);this._proxy=A.getProxy(F.MainContext.MainThreadLogger),this._onDidChangeLogLevel=this._register(n)}$setLevel(A){this._onDidChangeLogLevel.fire(A)}doCreateLogger(A,_,n){return new S(this._proxy,A,_,n)}};R=xe([$e(0,I.IExtHostRpcService),$e(1,w.IExtHostInitDataService)],R),e.ExtHostLoggerService=R;class S extends c.AbstractMessageLogger{constructor(A,_,n,h){super(h?.always);this.proxy=A,this.file=_,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(n),this.proxy.$createLogger(_,h).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(A,_){const n=[[A,_]];this.isLoggerCreated?this.doLog(n):this.buffer.push(...n)}doLog(A){this.proxy.$log(this.file,A)}}}),define(Ee[193],_e([0,1,5,12,26]),function(oe,e,c,F,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function I(R){return R&&R.title}let t=class{constructor(S,C){this._logService=C,this._proxy=S.getProxy(c.MainContext.MainThreadMessageService)}showMessage(S,C,A,_,n){const h={extension:S};let s;typeof _=="string"||I(_)?s=[_,...n]:(h.modal=_?.modal,h.useCustom=_?.useCustom,h.detail=_?.detail,s=n),h.useCustom&&(0,w.checkProposedApiEnabled)(S,"resolvers");const l=[];for(let d=0;d<s.length;d++){const D=s[d];if(typeof D=="string")l.push({title:D,handle:d,isCloseAffordance:!1});else if(typeof D=="object"){let{title:v,isCloseAffordance:f}=D;l.push({title:v,isCloseAffordance:!!f,handle:d})}else this._logService.warn("Invalid message item:",D)}return this._proxy.$showMessage(C,A,h,l).then(d=>{if(typeof d=="number")return s[d]})}};t=xe([$e(1,F.ILogService)],t),e.ExtHostMessageService=t}),define(Ee[194],_e([0,1,22,3,57,6,21,9,11,2,63,5,8,7,37,167,91]),function(oe,e,c,F,w,I,t,R,S,C,A,_,n,h,s,l,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class D{constructor(f,g,T,u,M){this._textDocumentsAndEditors=T,this._textDocuments=u,this._extensionStoragePaths=M,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new t.ResourceMap,this._editors=new Map,this._onDidChangeNotebookCells=new F.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new F.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new F.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new F.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._onDidChangeCellExecutionState=new F.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new F.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new F.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new F.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new A.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=f.getProxy(_.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=f.getProxy(_.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=f.getProxy(_.MainContext.MainThreadNotebookEditors),this._commandsConverter=g.converter,g.registerArgumentProcessor({processArgument:r=>{if(r&&r.$mid===12){const i=r.notebookEditor?.notebookUri,p=r.cell.handle,o=this._documents.get(i)?.getCell(p);if(o)return o.apiCell}return r}})}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(f=>f.apiEditor)}getEditorById(f){const g=this._editors.get(f);if(!g)throw new Error(`unknown text editor: ${f}. known editors: ${[...this._editors.keys()]} `);return g}getIdByEditor(f){for(const[g,T]of this._editors)if(T.apiEditor===f)return g}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(f,g){const T=this._documents.get(f);if(!T&&!g)throw new Error(`NO notebook document for '${f}'`);return T}_getProviderData(f){const g=this._notebookContentProviders.get(f);if(!g)throw new Error(`NO provider for '${f}'`);return g}registerNotebookContentProvider(f,g,T,u,M){if((0,R.isFalsyOrWhitespace)(g))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(g))throw new Error(`Notebook provider for '${g}' already registered`);this._notebookContentProviders.set(g,{extension:f,provider:T});let r;return T.onDidChangeNotebookContentOptions&&(r=T.onDidChangeNotebookContentOptions(()=>{const i=n.NotebookDocumentContentOptions.from(T.options);this._notebookProxy.$updateNotebookProviderOptions(g,i)})),this._notebookProxy.$registerNotebookProvider({id:f.identifier,location:f.extensionLocation},g,n.NotebookDocumentContentOptions.from(u),D._convertNotebookRegistrationData(f,M)),new h.Disposable(()=>{r?.dispose(),this._notebookContentProviders.delete(g),this._notebookProxy.$unregisterNotebookProvider(g)})}static _convertNotebookRegistrationData(f,g){if(!g)return;const T=g.filenamePattern.map(u=>n.NotebookExclusiveDocumentPattern.from(u)).filter(u=>u!==void 0);if(g.filenamePattern&&!T){console.warn(`Notebook content provider view options file name pattern is invalid ${g.filenamePattern}`);return}return{extension:f.identifier,providerDisplayName:f.displayName||f.name,displayName:g.displayName,filenamePattern:T,exclusive:g.exclusive||!1}}registerNotebookCellStatusBarItemProvider(f,g,T){const u=D._notebookStatusBarItemProviderHandlePool++,M=typeof T.onDidChangeCellStatusBarItems=="function"?D._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(u,T),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(u,M,g);let r;return M!==void 0&&(r=T.onDidChangeCellStatusBarItems(i=>this._notebookProxy.$emitCellStatusBarEvent(M))),new h.Disposable(()=>{this._notebookStatusBarItemProviders.delete(u),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(u,M),r&&r.dispose()})}async createNotebookDocument(f){const g=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:f.viewType,content:f.content&&n.NotebookData.from(f.content)});return C.URI.revive(g)}async openNotebookDocument(f){const g=this._documents.get(f);if(g)return g.apiNotebook;const T=await this._notebookDocumentsProxy.$tryOpenNotebook(f),u=this._documents.get(C.URI.revive(T));return(0,S.assertIsDefined)(u?.apiNotebook)}async showNotebookDocument(f,g){C.URI.isUri(f)&&(f=await this.openNotebookDocument(f));let T;typeof g=="object"?T={position:n.ViewColumn.from(g.viewColumn),preserveFocus:g.preserveFocus,selections:g.selections&&g.selections.map(n.NotebookRange.from),pinned:typeof g.preview=="boolean"?!g.preview:void 0}:T={preserveFocus:!1};const u=await this._notebookEditorsProxy.$tryShowNotebookDocument(f.uri,f.notebookType,T),M=u&&this._editors.get(u)?.apiEditor;if(M)return M;throw u?new Error(`Could NOT open editor for "${f.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${f.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(f,g,T,u){const M=this._notebookStatusBarItemProviders.get(f),r=C.URI.revive(g),i=this._documents.get(r);if(!i||!M)return;const p=i.getCellFromIndex(T);if(!p)return;const m=await M.provideCellStatusBarItems(p.apiCell,u);if(!m)return;const o=new I.DisposableStore,b=this._statusBarCache.add([o]),E=(Array.isArray(m)?m:[m]).map(P=>n.NotebookStatusBarItem.from(P,this._commandsConverter,o));return{cacheId:b,items:E}}$releaseNotebookCellStatusBarItems(f){this._statusBarCache.delete(f)}registerNotebookSerializer(f,g,T,u,M){if((0,R.isFalsyOrWhitespace)(g))throw new Error("viewType cannot be empty or just whitespace");const r=this._handlePool++;return this._notebookSerializer.set(r,T),this._notebookProxy.$registerNotebookSerializer(r,{id:f.identifier,location:f.extensionLocation},g,n.NotebookDocumentContentOptions.from(u),D._convertNotebookRegistrationData(f,M)),(0,I.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(r)})}async $dataToNotebook(f,g,T){const u=this._notebookSerializer.get(f);if(!u)throw new Error("NO serializer found");const M=await u.deserializeNotebook(g.buffer,T);return new s.SerializableObjectWithBuffers(n.NotebookData.from(M))}async $notebookToData(f,g,T){const u=this._notebookSerializer.get(f);if(!u)throw new Error("NO serializer found");const M=await u.serializeNotebook(n.NotebookData.to(g.value),T);return c.VSBuffer.wrap(M)}async $openNotebook(f,g,T,u,M){const{provider:r}=this._getProviderData(f),i=await r.openNotebook(C.URI.revive(g),{backupId:T,untitledDocumentData:u?.buffer},M);return new s.SerializableObjectWithBuffers({metadata:i.metadata??Object.create(null),cells:i.cells.map(n.NotebookCellData.from)})}async $saveNotebook(f,g,T){const u=this.getNotebookDocument(C.URI.revive(g)),{provider:M}=this._getProviderData(f);return await M.saveNotebook(u.apiNotebook,T),!0}async $saveNotebookAs(f,g,T,u){const M=this.getNotebookDocument(C.URI.revive(g)),{provider:r}=this._getProviderData(f);return await r.saveNotebookAs(C.URI.revive(T),M.apiNotebook,u),!0}async $backupNotebook(f,g,T){const u=this.getNotebookDocument(C.URI.revive(g)),M=this._getProviderData(f),r=this._extensionStoragePaths.workspaceValue(M.extension)??this._extensionStoragePaths.globalValue(M.extension),i=String((0,w.hash)([u.uri.toString(),this._backupIdPool++])),p=C.URI.joinPath(r,i),m=await M.provider.backupNotebook(u.apiNotebook,{destination:p},T);return u.updateBackup(m),m.id}_createExtHostEditor(f,g,T){if(this._editors.has(g))throw new Error(`editor with id ALREADY EXSIST: ${g}`);const u=new d.ExtHostNotebookEditor(g,this._notebookEditorsProxy,f,T.visibleRanges.map(n.NotebookRange.to),T.selections.map(n.NotebookRange.to),typeof T.viewColumn=="number"?n.ViewColumn.to(T.viewColumn):void 0);this._editors.set(g,u)}$acceptDocumentAndEditorsDelta(f){if(f.value.removedDocuments)for(const T of f.value.removedDocuments){const u=C.URI.revive(T),M=this._documents.get(u);M&&(M.dispose(),this._documents.delete(u),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:M.apiNotebook.getCells().map(r=>r.document.uri)}),this._onDidCloseNotebookDocument.fire(M.apiNotebook));for(const r of this._editors.values())r.notebookData.uri.toString()===u.toString()&&this._editors.delete(r.id)}if(f.value.addedDocuments){const T=[];for(const u of f.value.addedDocuments){const M=C.URI.revive(u.uri);if(this._documents.has(M))throw new Error(`adding EXISTING notebook ${M} `);const r=this,i=new l.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(p){r._onDidChangeNotebookCells.fire(p)},emitCellOutputsChange(p){r._onDidChangeCellOutputs.fire(p)},emitCellMetadataChange(p){r._onDidChangeCellMetadata.fire(p)},emitCellExecutionStateChange(p){r._onDidChangeCellExecutionState.fire(p)}},M,u);T.push(...u.cells.map(p=>l.ExtHostCell.asModelAddData(i.apiNotebook,p))),this._documents.get(M)?.dispose(),this._documents.set(M,i),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:T}),this._onDidOpenNotebookDocument.fire(i.apiNotebook)}}if(f.value.addedEditors)for(const T of f.value.addedEditors){if(this._editors.has(T.id))return;const u=C.URI.revive(T.documentUri),M=this._documents.get(u);M&&this._createExtHostEditor(M,T.id,T)}const g=[];if(f.value.removedEditors)for(const T of f.value.removedEditors){const u=this._editors.get(T);u&&(this._editors.delete(T),this._activeNotebookEditor?.id===u.id&&(this._activeNotebookEditor=void 0),g.push(u))}if(f.value.visibleEditors){this._visibleNotebookEditors=f.value.visibleEditors.map(u=>this._editors.get(u)).filter(u=>!!u);const T=new Set;this._visibleNotebookEditors.forEach(u=>T.add(u.id));for(const u of this._editors.values()){const M=T.has(u.id);u._acceptVisibility(M)}this._visibleNotebookEditors=[...this._editors.values()].map(u=>u).filter(u=>u.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}f.value.newActiveEditor===null?this._activeNotebookEditor=void 0:f.value.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(f.value.newActiveEditor)),f.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}}e.ExtHostNotebookController=D,D._notebookStatusBarItemProviderHandlePool=0}),define(Ee[195],_e([0,1,3,52,12,5,13,8]),function(oe,e,c,F,w,I,t,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;class S{constructor(_,n){const h=S._Keys.nextId();_.$registerNotebookEditorDecorationType(h,R.NotebookDecorationRenderOptions.from(n)),this.value={key:h,dispose(){_.$removeNotebookEditorDecorationType(h)}}}}S._Keys=new F.IdGenerator("NotebookEditorDecorationType");let C=class{constructor(_,n,h){this._logService=_,this._extHostRpc=n,this._notebooksAndEditors=h,this._onDidChangeNotebookEditorSelection=new c.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new c.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}createNotebookEditorDecorationType(_){return new S(this._extHostRpc.getProxy(I.MainContext.MainThreadNotebookEditors),_).value}$acceptEditorPropertiesChanged(_,n){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",_,n);const h=this._notebooksAndEditors.getEditorById(_);n.visibleRanges&&h._acceptVisibleRanges(n.visibleRanges.ranges.map(R.NotebookRange.to)),n.selections&&h._acceptSelections(n.selections.selections.map(R.NotebookRange.to)),n.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:h.apiEditor,visibleRanges:h.apiEditor.visibleRanges}),n.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:h.apiEditor,selections:h.apiEditor.selections}))}$acceptEditorViewColumns(_){for(const n in _)this._notebooksAndEditors.getEditorById(n)._acceptViewColumn(R.ViewColumn.to(_[n]))}};C=xe([$e(0,w.ILogService),$e(1,t.IExtHostRpcService)],C),e.ExtHostNotebookEditors=C}),define(Ee[196],_e([0,1,16,14,20,3,6,21,2,25,12,5,38,8,7,66,159,26,37]),function(oe,e,c,F,w,I,t,R,S,C,A,_,n,h,s,l,d,D,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;let f=class{constructor(r,i,p,m,o){this._initData=i,this._extHostNotebook=p,this._commands=m,this._logService=o,this._activeExecutions=new R.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._proxy=r.getProxy(_.MainContext.MainThreadNotebookKernels);const b=new n.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new n.ApiCommandArgument("options","Select kernel options",a=>!0,a=>{if(a&&"notebookEditor"in a&&"id"in a){const E=this._extHostNotebook.getIdByEditor(a.notebookEditor);return{id:a.id,extension:a.extension,notebookEditorId:E}}else if(a&&"notebookEditor"in a){const E=this._extHostNotebook.getIdByEditor(a.notebookEditor);if(E===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${a.notebookEditor.document.uri.toString()}`);return{notebookEditorId:E}}return a})],n.ApiCommandResult.Void);this._commands.registerApiCommand(b)}createNotebookController(r,i,p,m,o,b){for(let ce of this._kernelData.values())if(ce.controller.id===i&&C.ExtensionIdentifier.equals(r.identifier,ce.extensionId))throw new Error(`notebook controller with id '${i}' ALREADY exist`);const a=this._handlePool++,E=this;this._logService.trace(`NotebookController[${a}], CREATED by ${r.identifier.value}, ${i}`);const P=()=>console.warn(`NO execute handler from notebook controller '${x.id}' of extension: '${r.identifier}'`);let k=!1;const B=new t.DisposableStore,L=new I.Emitter,y=new I.Emitter,x={id:`${r.identifier.value}/${i}`,notebookType:p,extensionId:r.identifier,extensionLocation:r.extensionLocation,label:m||r.identifier.value,preloads:b?b.map(h.NotebookRendererScript.from):[]};let N=o??P,z;this._proxy.$addKernel(a,x).catch(ce=>{console.log(ce),k=!0});let H=0;const q=()=>{if(k)return;const ce=++H;Promise.resolve().then(()=>{ce===H&&this._proxy.$updateKernel(a,x)})},ue=new R.ResourceMap,K={get id(){return i},get notebookType(){return x.notebookType},onDidChangeSelectedNotebooks:L.event,get label(){return x.label},set label(ce){x.label=ce??r.displayName??r.name,q()},get detail(){return x.detail??""},set detail(ce){x.detail=ce,q()},get description(){return x.description??""},set description(ce){x.description=ce,q()},get kind(){return(0,D.checkProposedApiEnabled)(r,"notebookControllerKind"),x.kind??""},set kind(ce){(0,D.checkProposedApiEnabled)(r,"notebookControllerKind"),x.kind=ce,q()},get supportedLanguages(){return x.supportedLanguages},set supportedLanguages(ce){x.supportedLanguages=ce,q()},get supportsExecutionOrder(){return x.supportsExecutionOrder??!1},set supportsExecutionOrder(ce){x.supportsExecutionOrder=ce,q()},get rendererScripts(){return x.preloads?x.preloads.map(h.NotebookRendererScript.to):[]},get executeHandler(){return N},set executeHandler(ce){N=ce??P},get interruptHandler(){return z},set interruptHandler(ce){z=ce,x.supportsInterrupt=Boolean(ce),q()},createNotebookCellExecution(ce){if(k)throw new Error("notebook controller is DISPOSED");if(!ue.has(ce.notebook.uri))throw E._logService.trace(`NotebookController[${a}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ue.keys()).map(de=>de.toString())),new Error(`notebook controller is NOT associated to notebook: ${ce.notebook.uri.toString()}`);return E._createNotebookCellExecution(ce)},dispose:()=>{k||(this._logService.trace(`NotebookController[${a}], DISPOSED`),k=!0,this._kernelData.delete(a),B.dispose(),L.dispose(),y.dispose(),this._proxy.$removeKernel(a))},updateNotebookAffinity(ce,de){E._proxy.$updateNotebookPriority(a,ce.uri,de)},onDidReceiveMessage:y.event,postMessage(ce,de){return(0,D.checkProposedApiEnabled)(r,"notebookMessaging"),E._proxy.$postMessage(a,de&&E._extHostNotebook.getIdByEditor(de),ce)},asWebviewUri(ce){return(0,D.checkProposedApiEnabled)(r,"notebookMessaging"),(0,l.asWebviewUri)(ce,E._initData.remote)}};return this._kernelData.set(a,{extensionId:r.identifier,controller:K,onDidReceiveMessage:y,onDidChangeSelection:L,associatedNotebooks:ue}),K}$acceptNotebookAssociation(r,i,p){const m=this._kernelData.get(r);if(m){const o=this._extHostNotebook.getNotebookDocument(S.URI.revive(i));p?m.associatedNotebooks.set(o.uri,!0):m.associatedNotebooks.delete(o.uri),this._logService.trace(`NotebookController[${r}] ASSOCIATE notebook`,o.uri.toString(),p),m.onDidChangeSelection.fire({selected:p,notebook:o.apiNotebook})}}async $executeCells(r,i,p){const m=this._kernelData.get(r);if(!m)return;const o=this._extHostNotebook.getNotebookDocument(S.URI.revive(i)),b=[];for(let a of p){const E=o.getCell(a);E&&b.push(E.apiCell)}try{this._logService.trace(`NotebookController[${r}] EXECUTE cells`,o.uri.toString(),b.length),await m.controller.executeHandler.call(m.controller,b,o.apiNotebook,m.controller)}catch(a){this._logService.error(`NotebookController[${r}] execute cells FAILED`,a),console.error(a)}}async $cancelCells(r,i,p){const m=this._kernelData.get(r);if(!m)return;const o=this._extHostNotebook.getNotebookDocument(S.URI.revive(i));if(m.controller.interruptHandler)await m.controller.interruptHandler.call(m.controller,o.apiNotebook);else for(let b of p){const a=o.getCell(b);a&&this._activeExecutions.get(a.uri)?.cancel()}}$acceptKernelMessageFromRenderer(r,i,p){const m=this._kernelData.get(r);if(!m)return;const o=this._extHostNotebook.getEditorById(i);m.onDidReceiveMessage.fire(Object.freeze({editor:o.apiEditor,message:p}))}_createNotebookCellExecution(r){if(r.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const p=this._extHostNotebook.getNotebookDocument(r.notebook.uri).getCellFromApiCell(r);if(!p)throw new Error("invalid cell");if(this._activeExecutions.has(p.uri))throw new Error(`duplicate execution for ${p.uri}`);const m=new T(p.notebook,p,this._proxy);this._activeExecutions.set(p.uri,m);const o=m.onDidChangeState(()=>{m.state===g.Resolved&&(m.dispose(),o.dispose(),this._activeExecutions.delete(p.uri))});return m.asApiObject()}};f=xe([$e(4,A.ILogService)],f),e.ExtHostNotebookKernels=f;var g;(function(M){M[M.Init=0]="Init",M[M.Started=1]="Started",M[M.Resolved=2]="Resolved"})(g||(g={}));class T extends t.Disposable{constructor(r,i,p){super();this._document=r,this._cell=i,this._proxy=p,this._handle=T.HANDLE++,this._onDidChangeState=new I.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=g.Init,this._tokenSource=this._register(new w.CancellationTokenSource),this._collector=new u(10,m=>this.update(m)),this._executionOrder=i.internalMetadata.executionOrder,this._proxy.$addExecution(this._handle,this._cell.notebook.uri,this._cell.handle)}get state(){return this._state}cancel(){this._tokenSource.cancel()}async updateSoon(r){await this._collector.addItem(r)}async update(r){const i=Array.isArray(r)?r:[r];return this._proxy.$updateExecutions(new v.SerializableObjectWithBuffers(i))}verifyStateForOutput(){if(this._state===g.Init)throw new Error("Must call start before modifying cell output");if(this._state===g.Resolved)throw new Error("Cannot modify cell output after calling resolve")}cellIndexToHandle(r){let i=this._cell;if(r&&(i=this._document.getCellFromApiCell(r)),!i)throw new Error("INVALID cell");return i.handle}validateAndConvertOutputs(r){return r.map(i=>{const p=s.NotebookCellOutput.ensureUniqueMimeTypes(i.items,!0);return p===i.items?h.NotebookCellOutput.from(i):h.NotebookCellOutput.from({items:p,id:i.id,metadata:i.metadata})})}async updateOutputs(r,i,p){const m=this.cellIndexToHandle(i),o=this.validateAndConvertOutputs((0,c.asArray)(r));return this.updateSoon({editType:d.CellExecutionUpdateType.Output,executionHandle:this._handle,cellHandle:m,append:p,outputs:o})}async updateOutputItems(r,i,p){return r=s.NotebookCellOutput.ensureUniqueMimeTypes((0,c.asArray)(r),!0),this.updateSoon({editType:d.CellExecutionUpdateType.OutputItems,executionHandle:this._handle,items:r.map(h.NotebookCellOutputItem.from),outputId:i.id,append:p})}asApiObject(){const r=this;return Object.freeze({get token(){return r._tokenSource.token},get cell(){return r._cell.apiCell},get executionOrder(){return r._executionOrder},set executionOrder(p){r._executionOrder=p,r.update([{editType:d.CellExecutionUpdateType.ExecutionState,executionHandle:r._handle,executionOrder:r._executionOrder}])},start(p){if(r._state===g.Resolved||r._state===g.Started)throw new Error("Cannot call start again");r._state=g.Started,r._onDidChangeState.fire(),r.update({editType:d.CellExecutionUpdateType.ExecutionState,executionHandle:r._handle,runStartTime:p})},end(p,m){if(r._state===g.Resolved)throw new Error("Cannot call resolve twice");r._state=g.Resolved,r._onDidChangeState.fire(),r.updateSoon({editType:d.CellExecutionUpdateType.Complete,executionHandle:r._handle,runEndTime:m,lastRunSuccess:p}),r._collector.flush(),r._proxy.$removeExecution(r._handle)},clearOutput(p){return r.verifyStateForOutput(),r.updateOutputs([],p,!1)},appendOutput(p,m){return r.verifyStateForOutput(),r.updateOutputs(p,m,!0)},replaceOutput(p,m){return r.verifyStateForOutput(),r.updateOutputs(p,m,!1)},appendOutputItems(p,m){return r.verifyStateForOutput(),r.updateOutputItems(p,m,!0)},replaceOutputItems(p,m){return r.verifyStateForOutput(),r.updateOutputItems(p,m,!1)}})}}T.HANDLE=0;class u{constructor(r,i){this.delay=r,this.callback=i,this.batch=[],this.startedTimer=Date.now()}addItem(r){return this.batch.push(r),this.currentDeferred||(this.currentDeferred=new F.DeferredPromise,this.startedTimer=Date.now(),(0,F.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const r=this.currentDeferred;this.currentDeferred=void 0;const i=this.batch;return this.batch=[],this.callback(i).finally(()=>r.complete())}}}),define(Ee[197],_e([0,1,3,5,91,26]),function(oe,e,c,F,w,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class t{constructor(S,C){this._extHostNotebook=C,this._rendererMessageEmitters=new Map,this.proxy=S.getProxy(F.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(S,C,A){const _=this._extHostNotebook.getEditorById(S);this._rendererMessageEmitters.get(C)?.fire({editor:_.apiEditor,message:A})}createRendererMessaging(S,C){if(!S.contributes?.notebookRenderer?.some(h=>h.id===C))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${C})`);const A=(0,I.isProposedApiEnabled)(S,"notebookEditor"),_=new WeakMap;return{onDidReceiveMessage:(h,s,l)=>{const d=A?h:D=>{const v={};_.set(v,D.editor),h({editor:v,message:D.message})};return this.getOrCreateEmitterFor(C).event(d,s,l)},postMessage:(h,s)=>{w.ExtHostNotebookEditor.apiEditorsToExtHost.has(h)&&([h,s]=[s,h]);const l=A?s:_.get(s),d=l&&w.ExtHostNotebookEditor.apiEditorsToExtHost.get(l);return this.proxy.$postMessage(d?.id,C,h)}}}getOrCreateEmitterFor(S){let C=this._rendererMessageEmitters.get(S);return C||(C=new c.Emitter({onLastListenerRemove:()=>{C?.dispose(),this._rendererMessageEmitters.delete(S)}}),this._rendererMessageEmitters.set(S,C),C)}}e.ExtHostNotebookRenderers=t}),define(Ee[94],_e([0,1,5,6,4,13,12,160,50,28,30,110,22]),function(oe,e,c,F,w,I,t,R,S,C,A,_,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.ExtHostOutputChannel=void 0;class h extends F.Disposable{constructor(d,D,v,f){super();this.id=d,this.name=D,this.logger=v,this.proxy=f,this.offset=0,this.visible=!1,this._disposed=!1}get disposed(){return this._disposed}appendLine(d){this.append(d+`
`)}append(d){this.write(d),this.visible&&(this.logger.flush(),this.proxy.$update(this.id,R.OutputChannelUpdateMode.Append))}clear(){const d=this.offset;this.logger.flush(),this.proxy.$update(this.id,R.OutputChannelUpdateMode.Clear,d)}replace(d){const D=this.offset;this.write(d),this.proxy.$update(this.id,R.OutputChannelUpdateMode.Replace,D),this.visible&&this.logger.flush()}show(d,D){this.logger.flush(),this.proxy.$reveal(this.id,!!(typeof d=="boolean"?d:D))}hide(){this.proxy.$close(this.id)}write(d){this.offset+=n.VSBuffer.fromString(d).byteLength,this.logger.info(d)}dispose(){super.dispose(),this._disposed||(this.proxy.$dispose(this.id),this._disposed=!0)}}e.ExtHostOutputChannel=h;let s=class{constructor(d,D,v,f,g){this.extHostFileSystem=v,this.extHostFileSystemInfo=f,this.loggerService=g,this.namePool=1,this.channels=new Map,this.visibleChannelId=null,this.proxy=d.getProxy(c.MainContext.MainThreadOutputService),this.outputsLocation=this.extHostFileSystemInfo.extUri.joinPath(D.logsLocation,`output_logging_${(0,_.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(d){this.visibleChannelId=d;for(const[D,v]of this.channels)v.visible=D===this.visibleChannelId}createOutputChannel(d,D){if(d=d.trim(),!d)throw new Error("illegal argument `name`. must not be falsy");const v=this.doCreateOutputChannel(d,D);return v.then(f=>{this.channels.set(f.id,f),f.visible=f.id===this.visibleChannelId}),this.createExtHostOutputChannel(d,v)}async doCreateOutputChannel(d,D){const v=await this.createOutputDirectory(),f=this.extHostFileSystemInfo.extUri.joinPath(v,`${this.namePool++}-${d.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),g=this.loggerService.createLogger(f,{always:!0,donotRotate:!0,donotUseFormatters:!0}),T=await this.proxy.$register(d,!1,f,D.identifier.value);return new h(T,d,g,this.proxy)}createOutputDirectory(){return this.outputDirectoryPromise||(this.outputDirectoryPromise=this.extHostFileSystem.value.createDirectory(this.outputsLocation).then(()=>this.outputsLocation)),this.outputDirectoryPromise}createExtHostOutputChannel(d,D){let v=!1;const f=()=>{if(v)throw new Error("Channel has been closed")};return{get name(){return d},append(g){f(),D.then(T=>T.append(g))},appendLine(g){f(),D.then(T=>T.appendLine(g))},clear(){f(),D.then(g=>g.clear())},replace(g){f(),D.then(T=>T.replace(g))},show(g,T){f(),D.then(u=>u.show(g,T))},hide(){f(),D.then(g=>g.hide())},dispose(){v=!0,D.then(g=>g.dispose())}}}};s=xe([$e(0,I.IExtHostRpcService),$e(1,C.IExtHostInitDataService),$e(2,S.IExtHostConsumerFileSystem),$e(3,A.IExtHostFileSystemInfo),$e(4,t.ILoggerService)],s),e.ExtHostOutputService=s,e.IExtHostOutputService=(0,w.createDecorator)("IExtHostOutputService")}),define(Ee[198],_e([0,1,14,20,3,6,5,2,7,15,16,34,62,26]),function(oe,e,c,F,w,I,t,R,S,C,A,_,n,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function s(l,d,D){const v=l.getProxy(t.MainContext.MainThreadQuickOpen);class f{constructor(o,b){this._sessions=new Map,this._instances=0,this._workspace=o,this._commands=b}showQuickPick(o,b,a=F.CancellationToken.None){this._onDidSelectItem=void 0;const E=Promise.resolve(o),P=++this._instances,k=v.$show(P,{title:b?.title,placeHolder:b?.placeHolder,matchOnDescription:b?.matchOnDescription,matchOnDetail:b?.matchOnDetail,ignoreFocusLost:b?.ignoreFocusOut,canPickMany:b?.canPickMany},a),B={},L=k.then(()=>B);return Promise.race([L,E]).then(y=>{if(y!==B)return E.then(x=>{const N=[];for(let z=0;z<x.length;z++){const H=x[z];typeof H=="string"?N.push({label:H,handle:z}):H.kind===S.QuickPickItemKind.Separator?N.push({type:"separator",label:H.label}):N.push({label:H.label,description:H.description,detail:H.detail,picked:H.picked,alwaysShow:H.alwaysShow,handle:z})}return b&&typeof b.onDidSelectItem=="function"&&(this._onDidSelectItem=z=>{b.onDidSelectItem(x[z])}),v.$setItems(P,N),k.then(z=>{if(typeof z=="number")return x[z];if(Array.isArray(z))return z.map(H=>x[H])})})}).then(void 0,y=>{if(!(0,C.isPromiseCanceledError)(y))return v.$setError(P,y),Promise.reject(y)})}$onItemSelected(o){this._onDidSelectItem&&this._onDidSelectItem(o)}showInput(o,b=F.CancellationToken.None){return this._validateInput=o?o.validateInput:void 0,v.$input(o,typeof this._validateInput=="function",b).then(void 0,a=>{if(!(0,C.isPromiseCanceledError)(a))return Promise.reject(a)})}$validateInput(o){return this._validateInput?(0,c.asPromise)(()=>this._validateInput(o)):Promise.resolve(void 0)}async showWorkspaceFolderPick(o,b=F.CancellationToken.None){const a=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[o]);if(!a)return;const E=await this._workspace.getWorkspaceFolders2();if(!!E)return E.find(P=>P.uri.toString()===a.uri.toString())}createQuickPick(o){const b=new i(o,()=>this._sessions.delete(b._id));return this._sessions.set(b._id,b),b}createInputBox(o){const b=new p(o,()=>this._sessions.delete(b._id));return this._sessions.set(b._id,b),b}$onDidChangeValue(o,b){const a=this._sessions.get(o);a&&a._fireDidChangeValue(b)}$onDidAccept(o){const b=this._sessions.get(o);b&&b._fireDidAccept()}$onDidChangeActive(o,b){const a=this._sessions.get(o);a instanceof i&&a._fireDidChangeActive(b)}$onDidChangeSelection(o,b){const a=this._sessions.get(o);a instanceof i&&a._fireDidChangeSelection(b)}$onDidTriggerButton(o,b){const a=this._sessions.get(o);a&&a._fireDidTriggerButton(b)}$onDidTriggerItemButton(o,b,a){const E=this._sessions.get(o);E instanceof i&&E._fireDidTriggerItemButton(b,a)}$onDidHide(o){const b=this._sessions.get(o);b&&b._fireDidHide()}}class g{constructor(o,b){this._extensionId=o,this._onDidDispose=b,this._id=i._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new w.Emitter,this._onDidChangeValueEmitter=new w.Emitter,this._onDidTriggerButtonEmitter=new w.Emitter,this._onDidHideEmitter=new w.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(o){this._title=o,this.update({title:o})}get step(){return this._steps}set step(o){this._steps=o,this.update({step:o})}get totalSteps(){return this._totalSteps}set totalSteps(o){this._totalSteps=o,this.update({totalSteps:o})}get enabled(){return this._enabled}set enabled(o){this._enabled=o,this.update({enabled:o})}get busy(){return this._busy}set busy(o){this._busy=o,this.update({busy:o})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(o){this._ignoreFocusOut=o,this.update({ignoreFocusOut:o})}get value(){return this._value}set value(o){this._value=o,this.update({value:o})}get placeholder(){return this._placeholder}set placeholder(o){this._placeholder=o,this.update({placeholder:o})}get buttons(){return this._buttons}set buttons(o){this._buttons=o.slice(),this._handlesToButtons.clear(),o.forEach((b,a)=>{const E=b===S.QuickInputButtons.Back?-1:a;this._handlesToButtons.set(E,b)}),this.update({buttons:o.map((b,a)=>({...r(b),tooltip:b.tooltip,handle:b===S.QuickInputButtons.Back?-1:a}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(o){this._value=o,this._onDidChangeValueEmitter.fire(o)}_fireDidTriggerButton(o){const b=this._handlesToButtons.get(o);b&&this._onDidTriggerButtonEmitter.fire(b)}_fireDidHide(){this._expectingHide&&(this._expectingHide=this._visible,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,I.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),v.$dispose(this._id))}update(o){if(!this._disposed){for(const b of Object.keys(o)){const a=o[b];this._pendingUpdate[b]=a===void 0?null:a}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){v.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}g._nextId=1;function T(m){if(m instanceof S.ThemeIcon)return{id:m.id};const o=M(m),b=u(m);return{dark:typeof o=="string"?R.URI.file(o):o,light:typeof b=="string"?R.URI.file(b):b}}function u(m){return typeof m=="object"&&"light"in m?m.light:m}function M(m){return typeof m=="object"&&"dark"in m?m.dark:m}function r(m){const o=T(m.iconPath);let b,a;return"id"in o?a=n.ThemeIcon.asClassName(o):b=o,{iconPath:b,iconClass:a}}class i extends g{constructor(o,b){super(o.identifier,b);this.extension=o,this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new w.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new w.Emitter,this._onDidTriggerItemButtonEmitter=new w.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(o){o.some(a=>a.kind!==void 0)&&(0,h.checkProposedApiEnabled)(this.extension,"quickPickSeparators"),this._items=o.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),o.forEach((a,E)=>{this._handlesToItems.set(E,a),this._itemsToHandles.set(a,E)});const b=[];for(let a=0;a<o.length;a++){const E=o[a];E.kind===S.QuickPickItemKind.Separator?b.push({type:"separator",label:E.label}):b.push({handle:a,label:E.label,description:E.description,detail:E.detail,picked:E.picked,alwaysShow:E.alwaysShow,buttons:E.buttons?.map((P,k)=>({...r(P),tooltip:P.tooltip,handle:k}))})}this.update({items:b})}get canSelectMany(){return this._canSelectMany}set canSelectMany(o){this._canSelectMany=o,this.update({canSelectMany:o})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(o){this._matchOnDescription=o,this.update({matchOnDescription:o})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(o){this._matchOnDetail=o,this.update({matchOnDetail:o})}get sortByLabel(){return this._sortByLabel}set sortByLabel(o){this._sortByLabel=o,this.update({sortByLabel:o})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(o){this._keepScrollPosition=o,this.update({keepScrollPosition:o})}get activeItems(){return this._activeItems}set activeItems(o){this._activeItems=o.filter(b=>this._itemsToHandles.has(b)),this.update({activeItems:this._activeItems.map(b=>this._itemsToHandles.get(b))})}get selectedItems(){return this._selectedItems}set selectedItems(o){this._selectedItems=o.filter(b=>this._itemsToHandles.has(b)),this.update({selectedItems:this._selectedItems.map(b=>this._itemsToHandles.get(b))})}_fireDidChangeActive(o){const b=(0,A.coalesce)(o.map(a=>this._handlesToItems.get(a)));this._activeItems=b,this._onDidChangeActiveEmitter.fire(b)}_fireDidChangeSelection(o){const b=(0,A.coalesce)(o.map(a=>this._handlesToItems.get(a)));this._selectedItems=b,this._onDidChangeSelectionEmitter.fire(b)}_fireDidTriggerItemButton(o,b){const a=this._handlesToItems.get(o);if(!a||!a.buttons||!a.buttons.length)return;const E=a.buttons[b];E&&this._onDidTriggerItemButtonEmitter.fire({button:E,item:a})}}class p extends g{constructor(o,b){super(o,b);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(o){this._password=o,this.update({password:o})}get prompt(){return this._prompt}set prompt(o){this._prompt=o,this.update({prompt:o})}get validationMessage(){return this._validationMessage}set validationMessage(o){this._validationMessage=o,this.update({validationMessage:o,severity:o?_.default.Error:_.default.Ignore})}}return new f(d,D)}e.createExtHostQuickOpen=s}),define(Ee[199],_e([0,1,2,3,42,6,14,5,16,105,12,25,62,8,26]),function(oe,e,c,F,w,I,t,R,S,C,A,_,n,h,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function l(m){if(m)return typeof m.iconPath=="string"?c.URI.file(m.iconPath):c.URI.isUri(m.iconPath)||n.ThemeIcon.isThemeIcon(m.iconPath)?m.iconPath:void 0}function d(m,o){if(!m.iconPath&&!o.iconPath)return 0;if(m.iconPath){if(!o.iconPath)return 1}else return-1;const b=typeof m.iconPath=="string"?m.iconPath:c.URI.isUri(m.iconPath)?m.iconPath.fsPath:m.iconPath.id,a=typeof o.iconPath=="string"?o.iconPath:c.URI.isUri(o.iconPath)?o.iconPath.fsPath:o.iconPath.id;return(0,C.comparePaths)(b,a)}function D(m,o){let b=0;if(m.strikeThrough!==o.strikeThrough)return m.strikeThrough?1:-1;if(m.faded!==o.faded)return m.faded?1:-1;if(m.tooltip!==o.tooltip)return(m.tooltip||"").localeCompare(o.tooltip||"");if(b=d(m,o),b!==0)return b;if(m.light&&o.light)b=d(m.light,o.light);else{if(m.light)return 1;if(o.light)return-1}if(b!==0)return b;if(m.dark&&o.dark)b=d(m.dark,o.dark);else{if(m.dark)return 1;if(o.dark)return-1}return b}function v(m,o){if(m.command!==o.command)return m.command<o.command?-1:1;if(m.title!==o.title)return m.title<o.title?-1:1;if(m.tooltip!==o.tooltip){if(m.tooltip!==void 0&&o.tooltip!==void 0)return m.tooltip<o.tooltip?-1:1;if(m.tooltip!==void 0)return 1;if(o.tooltip!==void 0)return-1}if(m.arguments===o.arguments)return 0;if(m.arguments)if(o.arguments){if(m.arguments.length!==o.arguments.length)return m.arguments.length-o.arguments.length}else return 1;else return-1;for(let b=0;b<m.arguments.length;b++){const a=m.arguments[b],E=o.arguments[b];if(a!==E)return a<E?-1:1}return 0}function f(m,o){let b=(0,C.comparePaths)(m.resourceUri.fsPath,o.resourceUri.fsPath,!0);if(b!==0)return b;if(m.command&&o.command)b=v(m.command,o.command);else{if(m.command)return 1;if(o.command)return-1}if(b!==0)return b;if(m.decorations&&o.decorations)b=D(m.decorations,o.decorations);else{if(m.decorations)return 1;if(o.decorations)return-1}return b}function g(m,o){for(let b=0;b<m.length;b++)if(m[b]!==o[b])return!1;return!0}function T(m,o){return m.command===o.command&&m.title===o.title&&m.tooltip===o.tooltip&&(m.arguments&&o.arguments?g(m.arguments,o.arguments):m.arguments===o.arguments)}function u(m,o){return(0,S.equals)(m,o,T)}class M{constructor(o,b,a){this._extension=o,this._proxy=b,this._sourceControlHandle=a,this._value="",this._onDidChange=new F.Emitter,this._placeholder="",this._visible=!0}get value(){return this._value}set value(o){this._proxy.$setInputBoxValue(this._sourceControlHandle,o),this.updateValue(o)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(o){this._proxy.$setInputBoxPlaceholder(this._sourceControlHandle,o),this._placeholder=o}get validateInput(){return(0,s.checkProposedApiEnabled)(this._extension,"scmValidation"),this._validateInput}set validateInput(o){if((0,s.checkProposedApiEnabled)(this._extension,"scmValidation"),o&&typeof o!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=o,this._proxy.$setValidationProviderIsEnabled(this._sourceControlHandle,!!o)}get visible(){return this._visible}set visible(o){o=!!o,this._visible!==o&&(this._visible=o,this._proxy.$setInputBoxVisibility(this._sourceControlHandle,o))}showValidationMessage(o,b){(0,s.checkProposedApiEnabled)(this._extension,"scmValidation"),this._proxy.$showValidationMessage(this._sourceControlHandle,o,b)}$onInputBoxValueChange(o){this.updateValue(o)}updateValue(o){this._value=o,this._onDidChange.fire(o)}}e.ExtHostSCMInputBox=M;class r{constructor(o,b,a,E,P){this._proxy=o,this._commands=b,this._sourceControlHandle=a,this._id=E,this._label=P,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new F.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new F.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=r._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(o){this._label=o,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,o)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(o){this._hideWhenEmpty=o,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(o){this._resourceStates=[...o],this._onDidUpdateResourceStates.fire()}getResourceState(o){return this._resourceStatesMap.get(o)}$executeResourceCommand(o,b){const a=this._resourceStatesCommandsMap.get(o);return a?(0,t.asPromise)(()=>this._commands.executeCommand(a.command,...a.arguments||[],b)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const o=[...this._resourceStates].sort(f),a=(0,S.sortedDiff)(this._resourceSnapshot,o,f).map(k=>{const B=k.toInsert.map(L=>{const y=this._resourceHandlePool++;this._resourceStatesMap.set(y,L);const x=L.resourceUri;let N;if(L.command)if(L.command.command==="vscode.open"||L.command.command==="vscode.diff"){const we=new I.DisposableStore;N=this._commands.converter.toInternal(L.command,we),this._resourceStatesDisposablesMap.set(y,we)}else this._resourceStatesCommandsMap.set(y,L.command);const z=l(L.decorations),H=L.decorations&&l(L.decorations.light)||z,q=L.decorations&&l(L.decorations.dark)||z,ue=[H,q],K=L.decorations&&L.decorations.tooltip||"",ce=L.decorations&&!!L.decorations.strikeThrough,de=L.decorations&&!!L.decorations.faded,Q=L.contextValue||"";return{rawResource:[y,x,ue,K,ce,de,Q,N],handle:y}});return{start:k.start,deleteCount:k.deleteCount,toInsert:B}}),E=a.map(({start:k,deleteCount:B,toInsert:L})=>[k,B,L.map(y=>y.rawResource)]),P=a.reverse();for(const{start:k,deleteCount:B,toInsert:L}of P){const y=L.map(N=>N.handle),x=this._handlesSnapshot.splice(k,B,...y);for(const N of x)this._resourceStatesMap.delete(N),this._resourceStatesCommandsMap.delete(N),this._resourceStatesDisposablesMap.get(N)?.dispose(),this._resourceStatesDisposablesMap.delete(N)}return this._resourceSnapshot=o,E}dispose(){this._disposed=!0,this._onDidDispose.fire()}}r._handlePool=0;class i{constructor(o,b,a,E,P,k){this._extension=o,this._proxy=b,this._commands=a,this._id=E,this._label=P,this._rootUri=k,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new I.MutableDisposable,this._acceptInputCommand=void 0,this._actionButtonDisposables=new I.MutableDisposable,this._statusBarDisposables=new I.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new F.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=i._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this._inputBox=new M(o,this._proxy,this.handle),this._proxy.$registerSourceControl(this.handle,E,P,k)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(o){this._count!==o&&(this._count=o,this._proxy.$updateSourceControl(this.handle,{count:o}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(o){this._quickDiffProvider=o,this._proxy.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!o})}get commitTemplate(){return this._commitTemplate}set commitTemplate(o){o!==this._commitTemplate&&(this._commitTemplate=o,this._proxy.$updateSourceControl(this.handle,{commitTemplate:o}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(o){this._acceptInputDisposables.value=new I.DisposableStore,this._acceptInputCommand=o;const b=this._commands.converter.toInternal(o,this._acceptInputDisposables.value);this._proxy.$updateSourceControl(this.handle,{acceptInputCommand:b})}get actionButton(){return(0,s.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButton}set actionButton(o){(0,s.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButtonDisposables.value=new I.DisposableStore,this._actionButton=o;const b=o!==void 0?this._commands.converter.toInternal(this._actionButton,this._actionButtonDisposables.value):void 0;this._proxy.$updateSourceControl(this.handle,{actionButton:b??null})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(o){if(this._statusBarCommands&&o&&u(this._statusBarCommands,o))return;this._statusBarDisposables.value=new I.DisposableStore,this._statusBarCommands=o;const b=(o||[]).map(a=>this._commands.converter.toInternal(a,this._statusBarDisposables.value));this._proxy.$updateSourceControl(this.handle,{statusBarCommands:b})}get selected(){return this._selected}createResourceGroup(o,b){const a=new r(this._proxy,this._commands,this.handle,o,b),E=F.Event.once(a.onDidDispose)(()=>this.createdResourceGroups.delete(a));return this.createdResourceGroups.set(a,E),this.eventuallyAddResourceGroups(),a}eventuallyAddResourceGroups(){const o=[],b=[];for(const[a,E]of this.createdResourceGroups){E.dispose();const P=a.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(a),this.eventuallyUpdateResourceStates()});F.Event.once(a.onDidDispose)(()=>{this.updatedResourceGroups.delete(a),P.dispose(),this._groups.delete(a.handle),this._proxy.$unregisterGroup(this.handle,a.handle)}),o.push([a.handle,a.id,a.label,a.features]);const k=a._takeResourceStateSnapshot();k.length>0&&b.push([a.handle,k]),this._groups.set(a.handle,a)}this._proxy.$registerGroups(this.handle,o,b),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const o=[];this.updatedResourceGroups.forEach(b=>{const a=b._takeResourceStateSnapshot();a.length!==0&&o.push([b.handle,a])}),o.length>0&&this._proxy.$spliceResourceStates(this.handle,o),this.updatedResourceGroups.clear()}getResourceGroup(o){return this._groups.get(o)}setSelectionState(o){this._selected=o,this._onDidChangeSelection.fire(o)}dispose(){this._acceptInputDisposables.dispose(),this._actionButtonDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(o=>o.dispose()),this._proxy.$unregisterSourceControl(this.handle)}}i._handlePool=0,xe([(0,w.debounce)(100)],i.prototype,"eventuallyAddResourceGroups",null),xe([(0,w.debounce)(100)],i.prototype,"eventuallyUpdateResourceStates",null);let p=class zi{constructor(o,b,a){this._commands=b,this.logService=a,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new F.Emitter,this._proxy=o.getProxy(R.MainContext.MainThreadSCM),this._telemetry=o.getProxy(R.MainContext.MainThreadTelemetry),b.registerArgumentProcessor({processArgument:E=>{if(E&&E.$mid===3){const P=this._sourceControls.get(E.sourceControlHandle);if(!P)return E;const k=P.getResourceGroup(E.groupHandle);return k?k.getResourceState(E.handle):E}else if(E&&E.$mid===4){const P=this._sourceControls.get(E.sourceControlHandle);return P?P.getResourceGroup(E.groupHandle):E}else if(E&&E.$mid===5){const P=this._sourceControls.get(E.handle);return P||E}return E}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(o,b,a,E){this.logService.trace("ExtHostSCM#createSourceControl",o.identifier.value,b,a,E),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:o.identifier.value});const P=zi._handlePool++,k=new i(o,this._proxy,this._commands,b,a,E);this._sourceControls.set(P,k);const B=this._sourceControlsByExtension.get(_.ExtensionIdentifier.toKey(o.identifier))||[];return B.push(k),this._sourceControlsByExtension.set(_.ExtensionIdentifier.toKey(o.identifier),B),k}getLastInputBox(o){this.logService.trace("ExtHostSCM#getLastInputBox",o.identifier.value);const b=this._sourceControlsByExtension.get(_.ExtensionIdentifier.toKey(o.identifier)),a=b&&b[b.length-1];return a&&a.inputBox}$provideOriginalResource(o,b,a){const E=c.URI.revive(b);this.logService.trace("ExtHostSCM#$provideOriginalResource",o,E.toString());const P=this._sourceControls.get(o);return!P||!P.quickDiffProvider||!P.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,t.asPromise)(()=>P.quickDiffProvider.provideOriginalResource(E,a)).then(k=>k||null)}$onInputBoxValueChange(o,b){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",o);const a=this._sourceControls.get(o);return a&&a.inputBox.$onInputBoxValueChange(b),Promise.resolve(void 0)}$executeResourceCommand(o,b,a,E){this.logService.trace("ExtHostSCM#$executeResourceCommand",o,b,a);const P=this._sourceControls.get(o);if(!P)return Promise.resolve(void 0);const k=P.getResourceGroup(b);return k?k.$executeResourceCommand(a,E):Promise.resolve(void 0)}$validateInput(o,b,a){this.logService.trace("ExtHostSCM#$validateInput",o);const E=this._sourceControls.get(o);return!E||!E.inputBox.validateInput?Promise.resolve(void 0):(0,t.asPromise)(()=>E.inputBox.validateInput(b,a)).then(P=>{if(!P)return Promise.resolve(void 0);const k=h.MarkdownString.fromStrict(P.message);return k?Promise.resolve([k,P.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(o){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",o),o!==void 0&&this._sourceControls.get(o)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=o,Promise.resolve(void 0)}};p._handlePool=0,p=xe([$e(2,A.ILogService)],p),e.ExtHostSCM=p});var Ze=this&&this.__classPrivateFieldSet||function(oe,e,c,F,w){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?oe!==e||!w:!e.has(oe))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?w.call(oe,c):w?w.value=c:e.set(oe,c),c},Ae=this&&this.__classPrivateFieldGet||function(oe,e,c,F){if(c==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?oe!==e||!F:!e.has(oe))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?F:c==="a"?F.call(oe):F?F.value:e.get(oe)};define(Ee[200],_e([0,1,7,5,122,6,8,11]),function(oe,e,c,F,w,I,t,R){"use strict";var S,C;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class A{constructor(s,l,d,D,v=c.StatusBarAlignment.Left,f){S.set(this,void 0),C.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new I.DisposableStore,Ze(this,S,s,"f"),Ze(this,C,l,"f"),this._entryId=A.ID_GEN++,this._extension=d,this._id=D,this._alignment=v,this._priority=this.validatePriority(f)}validatePriority(s){if(!!(0,R.isNumber)(s))return s===Number.POSITIVE_INFINITY?Number.MAX_VALUE:s===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:s}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(s){this._text=s,this.update()}set name(s){this._name=s,this.update()}set tooltip(s){this._tooltip=s,this.update()}set color(s){this._color=s,this.update()}set backgroundColor(s){s&&!A.ALLOWED_BACKGROUND_COLORS.has(s.id)&&(s=void 0),this._backgroundColor=s,this.update()}set command(s){this._command?.fromApi!==s&&(this._internalCommandRegistration.clear(),typeof s=="string"?this._command={fromApi:s,internal:Ae(this,C,"f").toInternal({title:"",command:s},this._internalCommandRegistration)}:s?this._command={fromApi:s,internal:Ae(this,C,"f").toInternal(s,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(s){this._accessibilityInformation=s,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Ae(this,S,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let s;this._extension?this._id?s=`${this._extension.identifier.value}.${this._id}`:s=this._extension.identifier.value:s=this._id;let l;this._name?l=this._name:l=(0,w.localize)(0,null,this._extension.displayName||this._extension.name);let d=this._color;this._backgroundColor&&(d=A.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const D=this._tooltip?t.MarkdownString.fromStrict(this._tooltip):void 0;Ae(this,S,"f").$setEntry(this._entryId,s,l,this._text,D,this._command?.internal,d,this._backgroundColor,this._alignment===c.StatusBarAlignment.Left,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=A,S=new WeakMap,C=new WeakMap,A.ID_GEN=0,A.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new c.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new c.ThemeColor("statusBarItem.warningForeground")]]);class _{constructor(s){this._messages=[],this._item=s.createStatusBarEntry(void 0,"status.extensionMessage",c.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,w.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(s){const l={message:s};return this._messages.unshift(l),this._update(),new c.Disposable(()=>{const d=this._messages.indexOf(l);d>=0&&(this._messages.splice(d,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class n{constructor(s,l){this._proxy=s.getProxy(F.MainContext.MainThreadStatusBar),this._commands=l,this._statusMessage=new _(this)}createStatusBarEntry(s,l,d,D){return new A(this._proxy,this._commands,s,l,d,D)}setStatusBarMessage(s,l){const d=this._statusMessage.setMessage(s);let D;return typeof l=="number"?D=setTimeout(()=>d.dispose(),l):typeof l!="undefined"&&l.then(()=>d.dispose(),()=>d.dispose()),new c.Disposable(()=>{d.dispose(),clearTimeout(D)})}}e.ExtHostStatusBar=n}),define(Ee[71],_e([0,1,5,3,4]),function(oe,e,c,F,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class I{constructor(R){this._onDidChangeStorage=new F.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=R.getProxy(c.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(R,S){this._proxy.$registerExtensionStorageKeysToSync(R,S)}getValue(R,S,C){return this._proxy.$getValue(R,S).then(A=>A||C)}setValue(R,S,C){return this._proxy.$setValue(R,S,C)}$acceptValue(R,S,C){this._onDidChangeStorage.fire({shared:R,key:S,value:C})}}e.ExtHostStorage=I,e.IExtHostStorage=(0,w.createDecorator)("IExtHostStorage")}),define(Ee[72],_e([0,1,4,28,12,50,2]),function(oe,e,c,F,w,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,c.createDecorator)("IExtensionStoragePaths");let R=class{constructor(C,A,_){this._logService=A,this._extHostFileSystem=_,this._workspace=C.workspace??void 0,this._environment=C.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(n=>this._value=n)}async _getWorkspaceStorageURI(C){return t.URI.joinPath(this._environment.workspaceStorageHome,C)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const C=this._workspace.id,A=await this._getWorkspaceStorageURI(C);try{return await this._extHostFileSystem.value.stat(A),this._logService.trace("[ExtHostStorage] storage dir already exists",A),A}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",A),await this._extHostFileSystem.value.createDirectory(A),await this._extHostFileSystem.value.writeFile(t.URI.joinPath(A,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:t.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),A}catch(_){this._logService.error("[ExtHostStorage]",_);return}}workspaceValue(C){if(this._value)return t.URI.joinPath(this._value,C.identifier.value)}globalValue(C){return t.URI.joinPath(this._environment.globalStorageHome,C.identifier.value.toLowerCase())}onWillDeactivateAll(){}};R=xe([$e(0,F.IExtHostInitDataService),$e(1,w.ILogService),$e(2,I.IExtHostConsumerFileSystem)],R),e.ExtensionStoragePaths=R}),define(Ee[39],_e([0,1,3,5,4,2,13,6,7,123,15,162,20,35,145,62,11,14]),function(oe,e,c,F,w,I,t,R,S,C,A,_,n,h,s,l,d,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,w.createDecorator)("IExtHostTerminalService");class v{constructor(m,o,b,a){this._proxy=m,this._id=o,this._creationOptions=b,this._name=a,this._disposed=!1,this._state={isInteractedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(P=>this._pidPromiseComplete=P);const E=this;this.value={get name(){return E._name||""},get processId(){return E._pidPromise},get creationOptions(){return E._creationOptions},get exitStatus(){return E._exitStatus},get state(){return E._state},sendText(P,k=!0){E._checkDisposed(),E._proxy.$sendText(E._id,P,k)},show(P){E._checkDisposed(),E._proxy.$show(E._id,P)},hide(){E._checkDisposed(),E._proxy.$hide(E._id)},dispose(){E._disposed||(E._disposed=!0,E._proxy.$dispose(E._id))},get dimensions(){if(!(E._cols===void 0||E._rows===void 0))return{columns:E._cols,rows:E._rows}}}}async create(m,o){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:m.name,shellPath:(0,d.withNullAsUndefined)(m.shellPath),shellArgs:(0,d.withNullAsUndefined)(m.shellArgs),cwd:(0,d.withNullAsUndefined)(m.cwd),env:(0,d.withNullAsUndefined)(m.env),icon:(0,d.withNullAsUndefined)(r(m.iconPath)),color:l.ThemeColor.isThemeColor(m.color)?m.color.id:void 0,initialText:(0,d.withNullAsUndefined)(m.message),strictEnv:(0,d.withNullAsUndefined)(m.strictEnv),hideFromUser:(0,d.withNullAsUndefined)(m.hideFromUser),isFeatureTerminal:(0,d.withNullAsUndefined)(o?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,d.withNullAsUndefined)(o?.useShellEnvironment),location:o?.location||this._serializeParentTerminal(m.location,o?.resolvedExtHostIdentifier)})}async createExtensionTerminal(m,o,b,a){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:b,color:l.ThemeColor.isThemeColor(a)?a.id:void 0,location:this._serializeParentTerminal(m,o)}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(m,o){return typeof m=="object"?"parentTerminal"in m&&m.parentTerminal&&o?{parentTerminal:o}:"viewColumn"in m?{viewColumn:m.viewColumn,preserveFocus:m.preserveFocus}:void 0:m}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(m){this._name=m}setExitCode(m){this._exitStatus=Object.freeze({code:m})}setDimensions(m,o){return m===this._cols&&o===this._rows||m===0||o===0?!1:(this._cols=m,this._rows=o,!0)}setInteractedWith(){return this._state.isInteractedWith?!1:(this._state={isInteractedWith:!0},!0)}_setProcessId(m){this._pidPromiseComplete?(this._pidPromiseComplete(m),this._pidPromiseComplete=void 0):this._pidPromise.then(o=>{o!==m&&(this._pidPromise=Promise.resolve(m))})}}e.ExtHostTerminal=v;class f{constructor(m){this._pty=m,this.id=0,this.shouldPersist=!1,this._capabilities=[],this._onProcessData=new c.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessReady=new c.Emitter,this._onDidChangeProperty=new c.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=new c.Emitter,this.onProcessExit=this._onProcessExit.event}get capabilities(){return this._capabilities}get onProcessReady(){return this._onProcessReady.event}refreshProperty(m){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${m}`)}updateProperty(m,o){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${m}, value: ${o}`)}async start(){}shutdown(){this._pty.close()}input(m){this._pty.handleInput?.(m)}resize(m,o){this._pty.setDimensions?.({columns:m,rows:o})}async processBinary(m){}acknowledgeDataEvent(m){}async setUnicodeVersion(m){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(m){this._pty.onDidWrite(o=>this._onProcessData.fire(o)),this._pty.onDidClose?.((o=void 0)=>{this._onProcessExit.fire(o===void 0?void 0:o)}),this._pty.onDidOverrideDimensions?.(o=>{o&&this._onDidChangeProperty.fire({type:"overrideDimensions",value:{cols:o.columns,rows:o.rows}})}),this._pty.onDidChangeName?.(o=>{this._onDidChangeProperty.fire({type:"title",value:o})}),this._pty.open(m||void 0),m&&this._pty.setDimensions?.(m),this._onProcessReady.fire({pid:-1,cwd:"",capabilities:this._capabilities})}}e.ExtHostPseudoterminal=f;let g=1,T=class extends R.Disposable{constructor(m,o){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new c.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new c.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new c.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new c.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new c.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._proxy=o.getProxy(F.MainContext.MainThreadTerminalService),this._bufferer=new s.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new c.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(m),this._register({dispose:()=>{for(const[b,a]of this._terminalProcesses)a.shutdown(!0)}})}get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(m=>m.value)}get onDidWriteTerminalData(){return this._onDidWriteTerminalData.event}getDefaultShell(m){return(m?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(m){return(m?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(m,o){const b=new v(this._proxy,(0,h.generateUuid)(),m,m.name),a=new f(m.pty);return b.createExtensionTerminal(m.location,this._serializeParentTerminal(m,o).resolvedExtHostIdentifier,r(m.iconPath),i(m.color)).then(E=>{const P=this._setupExtHostProcessListeners(E,a);this._terminalProcessDisposables[E]=P}),this._terminals.push(b),b.value}_serializeParentTerminal(m,o){if(o=o||{},m.location&&typeof m.location=="object"&&"parentTerminal"in m.location){const b=m.location.parentTerminal;if(b){const a=this._terminals.find(E=>E.value===b);a&&(o.resolvedExtHostIdentifier=a._id)}}else m.location&&typeof m.location!="object"?o.location=m.location:o.location&&typeof o.location=="object"&&"splitActiveTerminal"in o.location&&(o.location={splitActiveTerminal:!0});return o}attachPtyToTerminal(m,o){if(!this._getTerminalById(m))throw new Error(`Cannot resolve terminal with id ${m} for virtual process`);const a=new f(o),E=this._setupExtHostProcessListeners(m,a);this._terminalProcessDisposables[m]=E}async $acceptActiveTerminalChanged(m){const o=this._activeTerminal;if(m===null){this._activeTerminal=void 0,o!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const b=this._getTerminalById(m);b&&(this._activeTerminal=b,o!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(m,o){const b=this._getTerminalById(m);b&&this._onDidWriteTerminalData.fire({terminal:b.value,data:o})}async $acceptTerminalDimensions(m,o,b){const a=this._getTerminalById(m);a&&a.setDimensions(o,b)&&this._onDidChangeTerminalDimensions.fire({terminal:a.value,dimensions:a.value.dimensions})}async $acceptTerminalMaximumDimensions(m,o,b){this._terminalProcesses.get(m)?.resize(o,b)}async $acceptTerminalTitleChange(m,o){const b=this._getTerminalById(m);b&&(b.name=o)}async $acceptTerminalClosed(m,o){const b=this._getTerminalObjectIndexById(this._terminals,m);if(b!==null){const a=this._terminals.splice(b,1)[0];a.setExitCode(o),this._onDidCloseTerminal.fire(a.value)}}$acceptTerminalOpened(m,o,b,a){if(o){const k=this._getTerminalObjectIndexById(this._terminals,o);if(k!==null){this._terminals[k]._id=m,this._onDidOpenTerminal.fire(this.terminals[k]),this._terminals[k].isOpen=!0;return}}const E={name:a.name,shellPath:a.executable,shellArgs:a.args,cwd:typeof a.cwd=="string"?a.cwd:I.URI.revive(a.cwd),env:a.env,hideFromUser:a.hideFromUser},P=new v(this._proxy,m,E,b);this._terminals.push(P),this._onDidOpenTerminal.fire(P.value),P.isOpen=!0}async $acceptTerminalProcessId(m,o){const b=this._getTerminalById(m);b&&b._setProcessId(o)}async $startExtensionTerminal(m,o){const b=this._getTerminalById(m);if(!b)return{message:(0,C.localize)(0,null,m)};b.isOpen||await new Promise(E=>{const P=this.onDidOpenTerminal(async k=>{k===b.value&&(P.dispose(),E())})});const a=this._terminalProcesses.get(m);a?a.startSendingEvents(o):this._extensionTerminalAwaitingStart[m]={initialDimensions:o}}_setupExtHostProcessListeners(m,o){const b=new R.DisposableStore;b.add(o.onProcessReady(E=>this._proxy.$sendProcessReady(m,E.pid,E.cwd))),b.add(o.onDidChangeProperty(E=>this._proxy.$sendProcessProperty(m,E))),this._bufferer.startBuffering(m,o.onProcessData),b.add(o.onProcessExit(E=>this._onProcessExit(m,E))),this._terminalProcesses.set(m,o);const a=this._extensionTerminalAwaitingStart[m];return a&&o instanceof f&&(o.startSendingEvents(a.initialDimensions),delete this._extensionTerminalAwaitingStart[m]),b}$acceptProcessAckDataEvent(m,o){this._terminalProcesses.get(m)?.acknowledgeDataEvent(o)}$acceptProcessInput(m,o){this._terminalProcesses.get(m)?.input(o)}$acceptTerminalInteraction(m){const o=this._getTerminalById(m);o?.setInteractedWith()&&this._onDidChangeTerminalState.fire(o.value)}$acceptProcessResize(m,o,b){try{this._terminalProcesses.get(m)?.resize(o,b)}catch(a){if(a.code!=="EPIPE"&&a.code!=="ERR_IPC_CHANNEL_CLOSED")throw a}}$acceptProcessShutdown(m,o){this._terminalProcesses.get(m)?.shutdown(o)}$acceptProcessRequestInitialCwd(m){this._terminalProcesses.get(m)?.getInitialCwd().then(o=>this._proxy.$sendProcessProperty(m,{type:"initialCwd",value:o}))}$acceptProcessRequestCwd(m){this._terminalProcesses.get(m)?.getCwd().then(o=>this._proxy.$sendProcessProperty(m,{type:"cwd",value:o}))}$acceptProcessRequestLatency(m){return m}registerLinkProvider(m){return this._linkProviders.add(m),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new S.Disposable(()=>{this._linkProviders.delete(m),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(m,o,b){if(this._profileProviders.has(o))throw new Error(`Terminal profile provider "${o}" already registered`);return this._profileProviders.set(o,b),this._proxy.$registerProfileProvider(o,m.identifier.value),new S.Disposable(()=>{this._profileProviders.delete(o),this._proxy.$unregisterProfileProvider(o)})}async $createContributedProfileTerminal(m,o){const b=new n.CancellationTokenSource().token;let a=await this._profileProviders.get(m)?.provideTerminalProfile(b);if(!b.isCancellationRequested){if(a&&!("options"in a)&&(a={options:a}),!a||!("options"in a))throw new Error(`No terminal profile options provided for id "${m}"`);if("pty"in a.options){this.createExtensionTerminal(a.options,o);return}this.createTerminalFromOptions(a.options,o)}}async $provideLinks(m,o){const b=this._getTerminalById(m);if(!b)return[];this._terminalLinkCache.delete(m);const a=this._terminalLinkCancellationSource.get(m);a&&a.dispose(!0);const E=new n.CancellationTokenSource;this._terminalLinkCancellationSource.set(m,E);const P=[],k={terminal:b.value,line:o},B=[];for(const x of this._linkProviders)B.push(D.Promises.withAsyncBody(async N=>{E.token.onCancellationRequested(()=>N({provider:x,links:[]}));const z=await x.provideTerminalLinks(k,E.token)||[];E.token.isCancellationRequested||N({provider:x,links:z})}));const L=await Promise.all(B);if(E.token.isCancellationRequested)return[];const y=new Map;for(const x of L)x&&x.links.length>0&&P.push(...x.links.map(N=>{const z={id:g++,startIndex:N.startIndex,length:N.length,label:N.tooltip};return y.set(z.id,{provider:x.provider,link:N}),z}));return this._terminalLinkCache.set(m,y),P}$activateLink(m,o){const b=this._terminalLinkCache.get(m)?.get(o);!b||b.provider.handleTerminalLink(b.link)}_onProcessExit(m,o){this._bufferer.stopBuffering(m),this._terminalProcesses.delete(m),delete this._extensionTerminalAwaitingStart[m];const b=this._terminalProcessDisposables[m];b&&(b.dispose(),delete this._terminalProcessDisposables[m]),this._proxy.$sendProcessExit(m,o)}_getTerminalById(m){return this._getTerminalObjectById(this._terminals,m)}_getTerminalObjectById(m,o){const b=this._getTerminalObjectIndexById(m,o);return b!==null?m[b]:null}_getTerminalObjectIndexById(m,o){let b=null;return m.some((a,E)=>a._id===o?(b=E,!0):!1),b}getEnvironmentVariableCollection(m){let o=this._environmentVariableCollections.get(m.identifier.value);return o||(o=new u,this._setEnvironmentVariableCollection(m.identifier.value,o)),o}_syncEnvironmentVariableCollection(m,o){const b=(0,_.serializeEnvironmentVariableCollection)(o.map);this._proxy.$setEnvironmentVariableCollection(m,o.persistent,b.length===0?void 0:b)}$initEnvironmentVariableCollections(m){m.forEach(o=>{const b=o[0],a=new u(o[1]);this._setEnvironmentVariableCollection(b,a)})}$acceptDefaultProfile(m,o){this._defaultProfile=m,this._defaultAutomationProfile=o}_setEnvironmentVariableCollection(m,o){this._environmentVariableCollections.set(m,o),o.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(m,o)})}};T=xe([$e(1,t.IExtHostRpcService)],T),e.BaseExtHostTerminalService=T;class u{constructor(m){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new c.Emitter,this.map=new Map(m)}get persistent(){return this._persistent}set persistent(m){this._persistent=m,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(m,o){this._setIfDiffers(m,{value:o,type:S.EnvironmentVariableMutatorType.Replace})}append(m,o){this._setIfDiffers(m,{value:o,type:S.EnvironmentVariableMutatorType.Append})}prepend(m,o){this._setIfDiffers(m,{value:o,type:S.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(m,o){const b=this.map.get(m);(!b||b.value!==o.value||b.type!==o.type)&&(this.map.set(m,o),this._onDidChangeCollection.fire())}get(m){return this.map.get(m)}forEach(m,o){this.map.forEach((b,a)=>m.call(o,a,b,this))}delete(m){this.map.delete(m),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=u;let M=class extends T{constructor(m){super(!1,m)}createTerminal(m,o,b){throw new A.NotSupportedError}createTerminalFromOptions(m,o){throw new A.NotSupportedError}};M=xe([$e(0,t.IExtHostRpcService)],M),e.WorkerExtHostTerminalService=M;function r(p){if(!(!p||typeof p=="string"))return"id"in p?{id:p.id,color:p.color}:p}function i(p){return l.ThemeColor.isThemeColor(p)?p:void 0}});var Ze=this&&this.__classPrivateFieldSet||function(oe,e,c,F,w){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?oe!==e||!w:!e.has(oe))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?w.call(oe,c):w?w.value=c:e.set(oe,c),c},Ae=this&&this.__classPrivateFieldGet||function(oe,e,c,F){if(c==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?oe!==e||!F:!e.has(oe))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?F:c==="a"?F.call(oe):F?F.value:e.get(oe)};define(Ee[201],_e([0,1,16,22,20,3,230,57,6,27,11,35,5,13,48,8,7,170,88,67]),function(oe,e,c,F,w,I,t,R,S,C,A,_,n,h,s,l,d,D,v,f){"use strict";var g;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let T=class{constructor(k,B){this.resultsChangedEmitter=new I.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=k.getProxy(n.MainContext.MainThreadTesting),this.observer=new b(this.proxy),this.runTracker=new M(this.proxy),B.registerArgumentProcessor({processArgument:L=>L?.$mid===13?l.TestItem.toItemFromContext(L):L})}createTestController(k,B){if(this.controllers.has(k))throw new Error(`Attempt to insert a duplicate controller with ID "${k}"`);const L=new S.DisposableStore,y=L.add(new D.SingleUseTestCollection(k));y.root.label=B;const x=new Map,N=this.proxy,z={items:y.root.children,get label(){return B},set label(q){B=q,y.root.label=q,N.$updateControllerLabel(k,B)},get id(){return k},createRunProfile:(q,ue,K,ce,de)=>{let Q=(0,R.hash)(q);for(;x.has(Q);)Q++;const ie=new a(this.proxy,k,Q,q,ue,K,ce,de);return x.set(Q,ie),ie},createTestItem(q,ue,K){return new s.TestItemImpl(k,q,ue,K)},createTestRun:(q,ue,K=!0)=>this.runTracker.createTestRun(k,y,q,ue,K),set resolveHandler(q){y.resolveHandler=q},get resolveHandler(){return y.resolveHandler},dispose:()=>{L.dispose()}};z.createRunConfiguration=z.createRunProfile,N.$registerTestController(k,B),L.add((0,S.toDisposable)(()=>N.$unregisterTestController(k)));const H={controller:z,collection:y,profiles:x};return this.controllers.set(k,H),L.add((0,S.toDisposable)(()=>this.controllers.delete(k))),L.add(y.onDidGenerateDiff(q=>N.$publishDiff(k,q))),z}createTestObserver(){return this.observer.checkout()}async runTests(k,B=w.CancellationToken.None){const L=r(k);if(!L)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const y=this.controllers.get(L.controllerId);if(!y)throw new Error("Controller not found");await this.proxy.$runTests({targets:[{testIds:k.include?.map(x=>x.id)??[y.collection.root.id],profileGroup:E[L.kind],profileId:L.profileId,controllerId:L.controllerId}],exclude:k.exclude?.map(x=>x.id)},B)}$provideFileCoverage(k,B,L){return(0,c.mapFind)(this.runTracker.trackers,x=>x.id===k?x.getCoverage(B):void 0)?.provideFileCoverage(L)??Promise.resolve([])}$resolveFileCoverage(k,B,L,y){return(0,c.mapFind)(this.runTracker.trackers,N=>N.id===k?N.getCoverage(B):void 0)?.resolveFileCoverage(L,y)??Promise.resolve([])}$configureRunProfile(k,B){this.controllers.get(k)?.profiles.get(B)?.configureHandler?.()}$publishTestResults(k){this.results=Object.freeze(k.map(B=>(0,C.deepFreeze)(l.TestResults.to(B))).concat(this.results).sort((B,L)=>L.completedAt-B.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(k,B){const L=this.controllers.get(f.TestId.fromString(k).controllerId)?.collection;L&&(await L.expand(k,B<0?Infinity:B),L.flushDiff())}$acceptDiff(k){this.observer.applyDiff(k)}async $runControllerTests(k,B){const L=this.controllers.get(k.controllerId);if(!L)return;const{collection:y,profiles:x}=L,N=x.get(k.profileId);if(!N)return;const z=k.testIds.map(K=>y.tree.get(K)).filter(A.isDefined),H=k.excludeExtIds.map(K=>L.collection.tree.get(K)).filter(A.isDefined).filter(K=>z.some(ce=>ce.fullId.compare(K.fullId)===2));if(!z.length)return;const q=new d.TestRunRequest(z.some(K=>K.actual instanceof s.TestItemRootImpl)?void 0:z.map(K=>K.actual),H.map(K=>K.actual),N),ue=this.runTracker.prepareForMainThreadTestRun(q,i.fromInternal(k,L.collection),B);try{await N.runHandler(q,B)}finally{ue.isRunning&&!B.isCancellationRequested&&await I.Event.toPromise(ue.onEnd),ue.dispose()}}$cancelExtensionTestRun(k){k===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(k)}};T=xe([$e(0,h.IExtHostRpcService)],T),e.ExtHostTesting=T;class u extends S.Disposable{constructor(k,B,L){super();this.dto=k,this.proxy=B,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new I.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new w.CancellationTokenSource(L)),this._register(this.cts.token.onCancellationRequested(()=>{for(const{run:y}of this.tasks.values())y.end()}))}get isRunning(){return this.tasks.size>0}get id(){return this.dto.id}getCoverage(k){return this.tasks.get(k)?.coverage}createRun(k){const B=this.dto.id,L=this.dto.controllerId,y=(0,_.generateUuid)(),x=new p(this.proxy,B,y),N=ue=>(K,...ce)=>{if(H){console.warn(`Setting the state of test "${K.id}" is a no-op after the run ends.`);return}!this.dto.isIncluded(K)||(this.ensureTestIsKnown(K),ue(K,...ce))},z=(ue,K)=>{const ce=K instanceof Array?K.map(l.TestMessage.from):[l.TestMessage.from(K)];if(ue.uri&&ue.range){const de={range:l.Range.from(ue.range),uri:ue.uri};for(const Q of ce)Q.location=Q.location||de}this.proxy.$appendTestMessagesInRun(B,y,f.TestId.fromExtHostTestItem(ue,L).toString(),ce)};let H=!1;const q={isPersisted:this.dto.isPersisted,token:this.cts.token,name:k,get coverageProvider(){return x.coverageProvider},set coverageProvider(ue){x.coverageProvider=ue},enqueued:N(ue=>{this.proxy.$updateTestStateInRun(B,y,f.TestId.fromExtHostTestItem(ue,L).toString(),1)}),skipped:N(ue=>{this.proxy.$updateTestStateInRun(B,y,f.TestId.fromExtHostTestItem(ue,L).toString(),5)}),started:N(ue=>{this.proxy.$updateTestStateInRun(B,y,f.TestId.fromExtHostTestItem(ue,L).toString(),2)}),errored:N((ue,K,ce)=>{z(ue,K),this.proxy.$updateTestStateInRun(B,y,f.TestId.fromExtHostTestItem(ue,L).toString(),6,ce)}),failed:N((ue,K,ce)=>{z(ue,K),this.proxy.$updateTestStateInRun(B,y,f.TestId.fromExtHostTestItem(ue,L).toString(),4,ce)}),passed:N((ue,K)=>{this.proxy.$updateTestStateInRun(B,y,f.TestId.fromExtHostTestItem(ue,this.dto.controllerId).toString(),3,K)}),appendOutput:(ue,K,ce)=>{H||(ce&&(this.dto.isIncluded(ce)?this.ensureTestIsKnown(ce):ce=void 0),this.proxy.$appendOutputToRun(B,y,F.VSBuffer.fromString(ue),K&&l.location.from(K),ce&&f.TestId.fromExtHostTestItem(ce,L).toString()))},end:()=>{H||(H=!0,this.proxy.$finishedTestRunTask(B,y),this.tasks.delete(y),this.isRunning||this.dispose())}};return this.tasks.set(y,{run:q,coverage:x}),this.proxy.$startedTestRunTask(B,{id:y,name:k,running:!0}),q}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}ensureTestIsKnown(k){if(!(k instanceof s.TestItemImpl))throw new s.InvalidTestItemError(k.id);if(this.sharedTestIds.has(f.TestId.fromExtHostTestItem(k,this.dto.controllerId).toString()))return;const B=[],L=this.dto.colllection.root;for(;;){const y=l.TestItem.from(k);if(B.unshift(y),this.sharedTestIds.has(y.extId)||(this.sharedTestIds.add(y.extId),k===L))break;k=k.parent||L}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,B)}}class M{constructor(k){this.proxy=k,this.tracked=new Map}get trackers(){return this.tracked.values()}prepareForMainThreadTestRun(k,B,L){return this.getTracker(k,B,L)}cancelRunById(k){for(const B of this.tracked.values())if(B.id===k){B.dispose();return}}cancelAllRuns(){for(const k of this.tracked.values())k.dispose()}createTestRun(k,B,L,y,x){const N=this.tracked.get(L);if(N)return N.createRun(y);const z=i.fromPublic(k,B,L,x),H=r(L);this.proxy.$startedExtensionTestRun({controllerId:k,profile:H&&{group:E[H.kind],id:H.profileId},exclude:L.exclude?.map(ue=>ue.id)??[],id:z.id,include:L.include?.map(ue=>ue.id)??[B.root.id],persist:x});const q=this.getTracker(L,z);return q.onEnd(()=>this.proxy.$finishedExtensionTestRun(z.id)),q.createRun(y)}getTracker(k,B,L){const y=new u(B,this.proxy,L);return this.tracked.set(k,y),y.onEnd(()=>this.tracked.delete(k)),y}}e.TestRunCoordinator=M;const r=P=>{if(!!P.profile){if(!(P.profile instanceof a))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return P.profile}};class i{constructor(k,B,L,y,x,N){this.controllerId=k,this.id=B,this.isPersisted=x,this.colllection=N,this.includePrefix=L.map(z=>z+"\0"),this.excludePrefix=y.map(z=>z+"\0")}static fromPublic(k,B,L,y){return new i(k,(0,_.generateUuid)(),L.include?.map(x=>f.TestId.fromExtHostTestItem(x,k).toString())??[k],L.exclude?.map(x=>f.TestId.fromExtHostTestItem(x,k).toString())??[],y,B)}static fromInternal(k,B){return new i(k.controllerId,k.runId,k.testIds,k.excludeExtIds,!0,B)}isIncluded(k){const B=f.TestId.fromExtHostTestItem(k,this.controllerId).toString()+"\0";for(const L of this.excludePrefix)if(B===L||B.startsWith(L))return!1;for(const L of this.includePrefix)if(B===L||B.startsWith(L))return!0;return!1}}e.TestRunDto=i;class p{constructor(k,B,L){this.proxy=k,this.runId=B,this.taskId=L}set coverageProvider(k){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!k||(this._coverageProvider=k,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}async provideFileCoverage(k){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(k))());try{return(await this.fileCoverage)?.map(l.TestCoverage.fromFile)??[]}catch(B){throw this.fileCoverage=void 0,B}}async resolveFileCoverage(k,B){const L=await this.fileCoverage;let y=L?.[k];return!this._coverageProvider||!L||!y?[]:(y.detailedCoverage||(y=L[k]=await this._coverageProvider.resolveFileCoverage?.(y,B)??y),y.detailedCoverage?.map(l.TestCoverage.fromDetailed)??[])}}class m extends v.IncrementalChangeCollector{constructor(k){super();this.emitter=k,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(k){this.added.add(k)}update(k){Object.assign(k.revived,l.TestItem.toPlain(k.item)),this.added.has(k)||this.updated.add(k)}remove(k){if(this.added.has(k)){this.added.delete(k);return}if(this.updated.delete(k),k.parent&&this.alreadyRemoved.has(k.parent)){this.alreadyRemoved.add(k.item.extId);return}this.removed.add(k)}getChangeEvent(){const{added:k,updated:B,removed:L}=this;return{get added(){return[...k].map(y=>y.revived)},get updated(){return[...B].map(y=>y.revived)},get removed(){return[...L].map(y=>y.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class o extends v.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new I.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(k){return this.items.get(k)}getMirroredTestDataByReference(k){return this.items.get(k.id)}createItem(k,B){return{...k,revived:l.TestItem.toPlain(k.item),depth:B?B.depth+1:0,children:new Set}}createChangeCollector(){return new m(this.changeEmitter)}}e.MirroredTestCollection=o;class b{constructor(k){this.proxy=k}checkout(){this.current||(this.current=this.createObserverData());const k=this.current;return k.observers++,{onDidChangeTest:k.tests.onDidChangeTests,get tests(){return[...k.tests.rootTests].map(B=>B.revived)},dispose:(0,t.once)(()=>{--k.observers==0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(k){return this.current?.tests.getMirroredTestDataByReference(k)}applyDiff(k){this.current?.tests.apply(k)}createObserverData(){const k=new o;return this.proxy.$subscribeToDiffs(),{observers:0,tests:k}}}class a{constructor(k,B,L,y,x,N,z=!1,H=void 0){this.controllerId=B,this.profileId=L,this._label=y,this.kind=x,this.runHandler=N,this._isDefault=z,this._tag=H,g.set(this,void 0),Ze(this,g,k,"f");const q=E[x];if(typeof q!="number")throw new Error(`Unknown TestRunProfile.group ${x}`);Ae(this,g,"f").$publishTestRunProfile({profileId:L,controllerId:B,tag:H?l.TestTag.namespace(this.controllerId,H.id):null,label:y,group:q,isDefault:z,hasConfigurationHandler:!1})}get label(){return this._label}set label(k){k!==this._label&&(this._label=k,Ae(this,g,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:k}))}get isDefault(){return this._isDefault}set isDefault(k){k!==this._isDefault&&(this._isDefault=k,Ae(this,g,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:k}))}get tag(){return this._tag}set tag(k){k?.id!==this._tag?.id&&(this._tag=k,Ae(this,g,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:k?l.TestTag.namespace(this.controllerId,k.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(k){k!==this._configureHandler&&(this._configureHandler=k,Ae(this,g,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!k}))}dispose(){Ae(this,g,"f").$removeTestProfile(this.controllerId,this.profileId)}}e.TestRunProfileImpl=a,g=new WeakMap;const E={[d.TestRunProfileKind.Coverage]:8,[d.TestRunProfileKind.Debug]:4,[d.TestRunProfileKind.Run]:2}}),define(Ee[202],_e([0,1,3,16,5,92,8,7]),function(oe,e,c,F,w,I,t,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class S{constructor(A,_){this._extHostDocumentsAndEditors=_,this._onDidChangeTextEditorSelection=new c.Emitter,this._onDidChangeTextEditorOptions=new c.Emitter,this._onDidChangeTextEditorVisibleRanges=new c.Emitter,this._onDidChangeTextEditorViewColumn=new c.Emitter,this._onDidChangeActiveTextEditor=new c.Emitter,this._onDidChangeVisibleTextEditors=new c.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=A.getProxy(w.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(n=>this._onDidChangeVisibleTextEditors.fire(n)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(n=>this._onDidChangeActiveTextEditor.fire(n))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(A){const _=this._extHostDocumentsAndEditors.allEditors();return A?_:_.map(n=>n.value)}async showTextDocument(A,_,n){let h;typeof _=="number"?h={position:t.ViewColumn.from(_),preserveFocus:n}:typeof _=="object"?h={position:t.ViewColumn.from(_.viewColumn),preserveFocus:_.preserveFocus,selection:typeof _.selection=="object"?t.Range.from(_.selection):void 0,pinned:typeof _.preview=="boolean"?!_.preview:void 0}:h={preserveFocus:!1};const s=await this._proxy.$tryShowTextDocument(A.uri,h),l=s&&this._extHostDocumentsAndEditors.getEditor(s);if(l)return l.value;throw s?new Error(`Could NOT open editor for "${A.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${A.uri.toString()}".`)}createTextEditorDecorationType(A,_){return new I.TextEditorDecorationType(this._proxy,A,_).value}$acceptEditorPropertiesChanged(A,_){const n=this._extHostDocumentsAndEditors.getEditor(A);if(!n)throw new Error("unknown text editor");if(_.options&&n._acceptOptions(_.options),_.selections){const h=_.selections.selections.map(t.Selection.to);n._acceptSelections(h)}if(_.visibleRanges){const h=F.coalesce(_.visibleRanges.map(t.Range.to));n._acceptVisibleRanges(h)}if(_.options&&this._onDidChangeTextEditorOptions.fire({textEditor:n.value,options:{..._.options,lineNumbers:t.TextEditorLineNumbersStyle.to(_.options.lineNumbers)}}),_.selections){const h=R.TextEditorSelectionChangeKind.fromValue(_.selections.source),s=_.selections.selections.map(t.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:n.value,selections:s,kind:h})}if(_.visibleRanges){const h=F.coalesce(_.visibleRanges.map(t.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:n.value,visibleRanges:h})}}$acceptEditorPositionData(A){for(const _ in A){const n=this._extHostDocumentsAndEditors.getEditor(_);if(!n)throw new Error("Unknown text editor");const h=t.ViewColumn.to(A[_]);n.value.viewColumn!==h&&(n._acceptViewColumn(h),this._onDidChangeTextEditorViewColumn.fire({textEditor:n.value,viewColumn:h}))}}getDiffInformation(A){return Promise.resolve(this._proxy.$getDiffInformation(A))}}e.ExtHostEditors=S}),define(Ee[203],_e([0,1,2,4,5,6,7]),function(oe,e,c,F,w,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,F.createDecorator)("IExtHostTimeline");class R{constructor(A,_){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=A.getProxy(w.MainContext.MainThreadTimeline),_.registerArgumentProcessor({processArgument:n=>{if(n&&n.$mid===11){const h=n.uri===void 0?void 0:c.URI.revive(n.uri);return this._itemsBySourceAndUriMap.get(n.source)?.get(S(h))?.get(n.handle)}return n}})}async $getTimeline(A,_,n,h,s){return this._providers.get(A)?.provideTimeline(c.URI.revive(_),n,h,s)}registerTimelineProvider(A,_,n,h){const s=new I.DisposableStore,l=this.convertTimelineItem(_.id,h,s).bind(this);let d;_.onDidChange&&(d=_.onDidChange(v=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...v,id:_.id}),this));const D=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({..._,scheme:A,onDidChange:void 0,async provideTimeline(v,f,g,T){T?.resetCache&&(s.clear(),D.get(_.id)?.clear());const u=await _.provideTimeline(v,f,g);if(u==null)return;const M=l(v,T);return{...u,source:_.id,items:u.items.map(M)}},dispose(){for(const v of D.values())v.get(_.id)?.clear();d?.dispose(),s.dispose()}})}convertTimelineItem(A,_,n){return(h,s)=>{let l;if(s?.cacheResults){let d=this._itemsBySourceAndUriMap.get(A);d===void 0&&(d=new Map,this._itemsBySourceAndUriMap.set(A,d));const D=S(h);l=d.get(D),l===void 0&&(l=new Map,d.set(D,l))}return d=>{const{iconPath:D,...v}=d,f=`${A}|${d.id??d.timestamp}`;l?.set(f,d);let g,T,u;return d.iconPath&&(D instanceof t.ThemeIcon?u={id:D.id,color:D.color}:c.URI.isUri(D)?(g=D,T=D):{light:g,dark:T}=D),{...v,id:v.id??void 0,handle:f,source:A,command:d.command?_.toInternal(d.command,n):void 0,icon:g,iconDark:T,themeIcon:u,accessibilityInformation:d.accessibilityInformation}}}}registerTimelineProviderCore(A){if(this._providers.get(A.id))throw new Error(`Timeline Provider ${A.id} already exists.`);return this._proxy.$registerTimelineProvider({id:A.id,label:A.label,scheme:A.scheme}),this._providers.set(A.id,A),(0,I.toDisposable)(()=>{for(const n of this._itemsBySourceAndUriMap.values())n.get(A.id)?.clear();this._providers.delete(A.id),this._proxy.$unregisterTimelineProvider(A.id),A.dispose()})}}e.ExtHostTimeline=R;function S(C){return C?.toString()}}),define(Ee[204],_e([0,1,6,10,2,5]),function(oe,e,c,F,w,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class t{constructor(S){this._openers=new Map,this._proxy=S.getProxy(I.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(S,C,A,_){if(this._openers.has(C))throw new Error(`Opener with id '${C}' already registered`);const n=_.schemes.find(h=>!t.supportedSchemes.has(h));if(n)throw new Error(`Scheme '${n}' is not supported. Only http and https are currently supported.`);return this._openers.set(C,A),this._proxy.$registerUriOpener(C,_.schemes,S,_.label),(0,c.toDisposable)(()=>{this._openers.delete(C),this._proxy.$unregisterUriOpener(C)})}async $canOpenUri(S,C,A){const _=this._openers.get(S);if(!_)throw new Error(`Unknown opener with id: ${S}`);const n=w.URI.revive(C);return _.canOpenExternalUri(n,A)}async $openUri(S,C,A){const _=this._openers.get(S);if(!_)throw new Error(`Unknown opener id: '${S}'`);return _.openExternalUri(w.URI.revive(C.resolvedUri),{sourceUri:w.URI.revive(C.sourceUri)},A)}}e.ExtHostUriOpeners=t,t.supportedSchemes=new Set([F.Schemas.http,F.Schemas.https])}),define(Ee[205],_e([0,1,5,2,6,15,25]),function(oe,e,c,F,w,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class R{constructor(C){this.handles=new Set,this.handlers=new Map,this._proxy=C.getProxy(c.MainContext.MainThreadUrls)}registerUriHandler(C,A){if(this.handles.has(t.ExtensionIdentifier.toKey(C)))throw new Error(`Protocol handler already registered for extension ${C}`);const _=R.HandlePool++;return this.handles.add(t.ExtensionIdentifier.toKey(C)),this.handlers.set(_,A),this._proxy.$registerUriHandler(_,C),(0,w.toDisposable)(()=>{this.handles.delete(t.ExtensionIdentifier.toKey(C)),this.handlers.delete(_),this._proxy.$unregisterUriHandler(_)})}$handleExternalUri(C,A){const _=this.handlers.get(C);if(!_)return Promise.resolve(void 0);try{_.handleUri(F.URI.revive(A))}catch(n){(0,I.onUnexpectedError)(n)}return Promise.resolve(void 0)}async createAppUri(C){return F.URI.revive(await this._proxy.$createAppUri(C))}}e.ExtHostUrls=R,R.HandlePool=0});var Ze=this&&this.__classPrivateFieldSet||function(oe,e,c,F,w){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?oe!==e||!w:!e.has(oe))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?w.call(oe,c):w?w.value=c:e.set(oe,c),c},Ae=this&&this.__classPrivateFieldGet||function(oe,e,c,F){if(c==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?oe!==e||!F:!e.has(oe))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?F:c==="a"?F.call(oe):F?F.value:e.get(oe)};define(Ee[51],_e([0,1,3,10,2,132,152,66,5]),function(oe,e,c,F,w,I,t,R,S){"use strict";var C,A,_,n,h,s,l,d,D,v,f,g;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class T{constructor(b,a,E,P,k,B,L){C.set(this,void 0),A.set(this,void 0),_.set(this,void 0),n.set(this,void 0),h.set(this,void 0),s.set(this,void 0),l.set(this,""),d.set(this,void 0),D.set(this,!1),v.set(this,!1),f.set(this,!1),this._onMessageEmitter=new c.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,g.set(this,new c.Emitter),this._onDidDispose=Ae(this,g,"f").event,Ze(this,C,b,"f"),Ze(this,A,a,"f"),Ze(this,d,E,"f"),Ze(this,n,P,"f"),Ze(this,h,k,"f"),Ze(this,s,B,"f"),Ze(this,f,u(B),"f"),Ze(this,_,L,"f")}dispose(){Ze(this,D,!0,"f"),Ae(this,g,"f").fire(),Ae(this,g,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(b){return Ze(this,v,!0,"f"),(0,R.asWebviewUri)(b,Ae(this,n,"f").remote)}get cspSource(){const b=Ae(this,s,"f").extensionLocation;if(b.scheme===F.Schemas.https||b.scheme===F.Schemas.http){let a=b.toString();return a.endsWith("/")||(a+="/"),a+" "+R.webviewGenericCspSource}return"'self' "+R.webviewGenericCspSource}get html(){return this.assertNotDisposed(),Ae(this,l,"f")}set html(b){this.assertNotDisposed(),Ae(this,l,"f")!==b&&(Ze(this,l,b,"f"),!Ae(this,v,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(b)&&(Ze(this,v,!0,"f"),Ae(this,_,"f").report("Webview vscode-resource: uris",Ae(this,s,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Ae(this,A,"f").$setHtml(Ae(this,C,"f"),b))}get options(){return this.assertNotDisposed(),Ae(this,d,"f")}set options(b){this.assertNotDisposed(),Ae(this,A,"f").$setOptions(Ae(this,C,"f"),i(Ae(this,s,"f"),Ae(this,h,"f"),b)),Ze(this,d,b,"f")}async postMessage(b){if(Ae(this,D,"f"))return!1;const a=(0,t.serializeWebviewMessage)(b,{serializeBuffersForPostMessage:Ae(this,f,"f")});return Ae(this,A,"f").$postMessage(Ae(this,C,"f"),a.message,...a.buffers)}assertNotDisposed(){if(Ae(this,D,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=T,C=new WeakMap,A=new WeakMap,_=new WeakMap,n=new WeakMap,h=new WeakMap,s=new WeakMap,l=new WeakMap,d=new WeakMap,D=new WeakMap,v=new WeakMap,f=new WeakMap,g=new WeakMap;function u(o){try{const b=(0,I.normalizeVersion)((0,I.parseVersion)(o.engines.vscode));return!!b&&b.majorBase>=1&&b.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=u;class M{constructor(b,a,E,P,k){this.initData=a,this.workspace=E,this._logService=P,this._deprecationService=k,this._webviews=new Map,this._webviewProxy=b.getProxy(S.MainContext.MainThreadWebviews)}$onMessage(b,a,...E){const P=this.getWebview(b);if(P){const{message:k}=(0,t.deserializeWebviewMessage)(a,E);P._onMessageEmitter.fire(k)}}$onMissingCsp(b,a){this._logService.warn(`${a} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(b,a,E){const P=new T(b,this._webviewProxy,p(a),this.initData,this.workspace,E,this._deprecationService);return this._webviews.set(b,P),P._onDidDispose(()=>{this._webviews.delete(b)}),P}deleteWebview(b){this._webviews.delete(b)}getWebview(b){return this._webviews.get(b)}}e.ExtHostWebviews=M;function r(o){return{id:o.identifier,location:o.extensionLocation}}e.toExtensionData=r;function i(o,b,a){return{enableCommandUris:a.enableCommandUris,enableScripts:a.enableScripts,enableForms:a.enableForms,portMapping:a.portMapping,localResourceRoots:a.localResourceRoots||m(o,b)}}e.serializeWebviewOptions=i;function p(o){return{enableCommandUris:o.enableCommandUris,enableScripts:o.enableScripts,enableForms:o.enableForms,portMapping:o.portMapping,localResourceRoots:o.localResourceRoots?.map(b=>w.URI.from(b))}}e.reviveOptions=p;function m(o,b){return[...(b?.getWorkspaceFolders()||[]).map(a=>a.uri),o.extensionLocation]}}),define(Ee[206],_e([0,1,20,57,6,10,24,2,8,51,63,5,7]),function(oe,e,c,F,w,I,t,R,S,C,A,_,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class h{constructor(u,M){this.document=u,this._storagePath=M,this._backupCounter=1,this._edits=new A.Cache("custom documents")}addEdit(u){return this._edits.add([u])}async undo(u,M){await this.getEdit(u).undo(),M||this.disposeBackup()}async redo(u,M){await this.getEdit(u).redo(),M||this.disposeBackup()}disposeEdits(u){for(const M of u)this._edits.delete(M)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const u=g(this.document.uri)+this._backupCounter++;return(0,t.joinPath)(this._storagePath,u)}updateBackup(u){this._backup?.delete(),this._backup=u}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(u){const M=this._edits.get(u,0);if(!M)throw new Error("No edit found");return M}}class s{constructor(){this._documents=new Map}get(u,M){return this._documents.get(this.key(u,M))}add(u,M,r){const i=this.key(u,M.uri);if(this._documents.has(i))throw new Error(`Document already exists for viewType:${u} resource:${M.uri}`);const p=new h(M,r);return this._documents.set(i,p),p}delete(u,M){const r=this.key(u,M.uri);this._documents.delete(r)}key(u,M){return`${u}@@@${M}`}}var l;(function(T){T[T.Text=0]="Text",T[T.Custom=1]="Custom"})(l||(l={}));class d{constructor(){this._providers=new Map}addTextProvider(u,M,r){return this.add(0,u,M,r)}addCustomProvider(u,M,r){return this.add(1,u,M,r)}get(u){return this._providers.get(u)}add(u,M,r,i){if(this._providers.has(M))throw new Error(`Provider for viewType:${M} already registered`);return this._providers.set(M,{type:u,extension:r,provider:i}),new n.Disposable(()=>this._providers.delete(M))}}class D{constructor(u,M,r,i,p){this._extHostDocuments=M,this._extensionStoragePaths=r,this._extHostWebview=i,this._extHostWebviewPanels=p,this._editorProviders=new d,this._documents=new s,this._proxy=u.getProxy(_.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(u,M,r,i){const p=new w.DisposableStore;return v(r)?(p.add(this._editorProviders.addTextProvider(M,u,r)),this._proxy.$registerTextEditorProvider((0,C.toExtensionData)(u),M,i.webviewOptions||{},{supportsMove:!!r.moveCustomTextEditor},(0,C.shouldSerializeBuffersForPostMessage)(u))):(p.add(this._editorProviders.addCustomProvider(M,u,r)),this.supportEditing(r)&&p.add(r.onDidChangeCustomDocument(m=>{const o=this.getCustomDocumentEntry(M,m.document.uri);if(f(m)){const b=o.addEdit(m);this._proxy.$onDidEdit(m.document.uri,M,b,m.label)}else this._proxy.$onContentChange(m.document.uri,M)})),this._proxy.$registerCustomEditorProvider((0,C.toExtensionData)(u),M,i.webviewOptions||{},!!i.supportsMultipleEditorsPerDocument,(0,C.shouldSerializeBuffersForPostMessage)(u))),n.Disposable.from(p,new n.Disposable(()=>{this._proxy.$unregisterEditorProvider(M)}))}async $createCustomDocument(u,M,r,i,p){const m=this._editorProviders.get(M);if(!m)throw new Error(`No provider found for '${M}'`);if(m.type!==1)throw new Error(`Invalid provide type for '${M}'`);const o=R.URI.revive(u),b=await m.provider.openCustomDocument(o,{backupId:r,untitledDocumentData:i?.buffer},p);let a;return this.supportEditing(m.provider)&&this._extensionStoragePaths&&(a=this._extensionStoragePaths.workspaceValue(m.extension)??this._extensionStoragePaths.globalValue(m.extension)),this._documents.add(M,b,a),{editable:this.supportEditing(m.provider)}}async $disposeCustomDocument(u,M){const r=this._editorProviders.get(M);if(!r)throw new Error(`No provider found for '${M}'`);if(r.type!==1)throw new Error(`Invalid provider type for '${M}'`);const i=R.URI.revive(u),{document:p}=this.getCustomDocumentEntry(M,i);this._documents.delete(M,p),p.dispose()}async $resolveWebviewEditor(u,M,r,i,p,m){const o=this._editorProviders.get(r);if(!o)throw new Error(`No provider found for '${r}'`);const b=S.ViewColumn.to(p),a=this._extHostWebview.createNewWebview(M,i.webviewOptions,o.extension),E=this._extHostWebviewPanels.createNewWebviewPanel(M,r,i.title,b,i.panelOptions,a),P=R.URI.revive(u);switch(o.type){case 1:{const{document:k}=this.getCustomDocumentEntry(r,P);return o.provider.resolveCustomEditor(k,E,m)}case 0:{const k=this._extHostDocuments.getDocument(P);return o.provider.resolveCustomTextEditor(k,E,m)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(u,M,r){this.getCustomDocumentEntry(M,u).disposeEdits(r)}async $onMoveCustomEditor(u,M,r){const i=this._editorProviders.get(r);if(!i)throw new Error(`No provider found for '${r}'`);if(!i.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${r}'`);const p=this._extHostWebviewPanels.getWebviewPanel(u);if(!p)throw new Error("No webview found");const m=R.URI.revive(M),o=this._extHostDocuments.getDocument(m);await i.provider.moveCustomTextEditor(o,p,c.CancellationToken.None)}async $undo(u,M,r,i){return this.getCustomDocumentEntry(M,u).undo(r,i)}async $redo(u,M,r,i){return this.getCustomDocumentEntry(M,u).redo(r,i)}async $revert(u,M,r){const i=this.getCustomDocumentEntry(M,u);await this.getCustomEditorProvider(M).revertCustomDocument(i.document,r),i.disposeBackup()}async $onSave(u,M,r){const i=this.getCustomDocumentEntry(M,u);await this.getCustomEditorProvider(M).saveCustomDocument(i.document,r),i.disposeBackup()}async $onSaveAs(u,M,r,i){const p=this.getCustomDocumentEntry(M,u);return this.getCustomEditorProvider(M).saveCustomDocumentAs(p.document,R.URI.revive(r),i)}async $backup(u,M,r){const i=this.getCustomDocumentEntry(M,u),m=await this.getCustomEditorProvider(M).backupCustomDocument(i.document,{destination:i.getNewBackupUri()},r);return i.updateBackup(m),m.id}getCustomDocumentEntry(u,M){const r=this._documents.get(u,R.URI.revive(M));if(!r)throw new Error("No custom document found");return r}getCustomEditorProvider(u){const r=this._editorProviders.get(u)?.provider;if(!r||!this.supportEditing(r))throw new Error("Custom document is not editable");return r}supportEditing(u){return!!u.onDidChangeCustomDocument}}e.ExtHostCustomEditors=D;function v(T){return typeof T.resolveCustomTextEditor=="function"}function f(T){return typeof T.undo=="function"&&typeof T.redo=="function"}function g(T){const u=T.scheme===I.Schemas.file||T.scheme===I.Schemas.untitled?T.fsPath:T.toString();return(0,F.hash)(u)+""}});var Ze=this&&this.__classPrivateFieldSet||function(oe,e,c,F,w){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?oe!==e||!w:!e.has(oe))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?w.call(oe,c):w?w.value=c:e.set(oe,c),c},Ae=this&&this.__classPrivateFieldGet||function(oe,e,c,F){if(c==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?oe!==e||!F:!e.has(oe))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?F:c==="a"?F.call(oe):F?F.value:e.get(oe)};define(Ee[207],_e([0,1,3,6,2,35,8,51,5,7]),function(oe,e,c,F,w,I,t,R,S,C){"use strict";var A,_,n,h,s,l,d,D,v,f,g,T,u;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class M extends F.Disposable{constructor(m,o,b,a,E,P,k){super();A.set(this,void 0),_.set(this,void 0),n.set(this,void 0),h.set(this,void 0),s.set(this,void 0),l.set(this,void 0),d.set(this,void 0),D.set(this,void 0),v.set(this,!0),f.set(this,!0),g.set(this,!1),T.set(this,this._register(new c.Emitter)),this.onDidDispose=Ae(this,T,"f").event,u.set(this,this._register(new c.Emitter)),this.onDidChangeViewState=Ae(this,u,"f").event,Ze(this,A,m,"f"),Ze(this,_,o,"f"),Ze(this,n,b,"f"),Ze(this,s,P,"f"),Ze(this,D,E,"f"),Ze(this,l,a,"f"),Ze(this,h,k,"f")}dispose(){Ae(this,g,"f")||(Ze(this,g,!0,"f"),Ae(this,T,"f").fire(),Ae(this,_,"f").$disposeWebview(Ae(this,A,"f")),Ae(this,h,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Ae(this,h,"f")}get viewType(){return this.assertNotDisposed(),Ae(this,n,"f")}get title(){return this.assertNotDisposed(),Ae(this,l,"f")}set title(m){this.assertNotDisposed(),Ae(this,l,"f")!==m&&(Ze(this,l,m,"f"),Ae(this,_,"f").$setTitle(Ae(this,A,"f"),m))}get iconPath(){return this.assertNotDisposed(),Ae(this,d,"f")}set iconPath(m){this.assertNotDisposed(),Ae(this,d,"f")!==m&&(Ze(this,d,m,"f"),Ae(this,_,"f").$setIconPath(Ae(this,A,"f"),w.URI.isUri(m)?{light:m,dark:m}:m))}get options(){return Ae(this,s,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Ae(this,D,"f")=="number"&&Ae(this,D,"f")<0))return Ae(this,D,"f")}get active(){return this.assertNotDisposed(),Ae(this,f,"f")}get visible(){return this.assertNotDisposed(),Ae(this,v,"f")}_updateViewState(m){Ae(this,g,"f")||(this.active!==m.active||this.visible!==m.visible||this.viewColumn!==m.viewColumn)&&(Ze(this,f,m.active,"f"),Ze(this,v,m.visible,"f"),Ze(this,D,m.viewColumn,"f"),Ae(this,u,"f").fire({webviewPanel:this}))}reveal(m,o){this.assertNotDisposed(),Ae(this,_,"f").$reveal(Ae(this,A,"f"),{viewColumn:m?t.ViewColumn.from(m):void 0,preserveFocus:!!o})}assertNotDisposed(){if(Ae(this,g,"f"))throw new Error("Webview is disposed")}}A=new WeakMap,_=new WeakMap,n=new WeakMap,h=new WeakMap,s=new WeakMap,l=new WeakMap,d=new WeakMap,D=new WeakMap,v=new WeakMap,f=new WeakMap,g=new WeakMap,T=new WeakMap,u=new WeakMap;class r{constructor(m,o,b){this.webviews=o,this.workspace=b,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=m.getProxy(S.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,I.generateUuid)()}createWebviewPanel(m,o,b,a,E={}){const P=typeof a=="object"?a.viewColumn:a,k={viewColumn:t.ViewColumn.from(P),preserveFocus:typeof a=="object"&&!!a.preserveFocus},B=(0,R.shouldSerializeBuffersForPostMessage)(m),L=r.newHandle();this._proxy.$createWebviewPanel((0,R.toExtensionData)(m),L,o,{title:b,panelOptions:i(E),webviewOptions:(0,R.serializeWebviewOptions)(m,this.workspace,E),serializeBuffersForPostMessage:B},k);const y=this.webviews.createNewWebview(L,E,m);return this.createNewWebviewPanel(L,o,b,P,E,y)}$onDidChangeWebviewPanelViewStates(m){const o=Object.keys(m);o.sort((b,a)=>{const E=m[b],P=m[a];return E.active?1:P.active?-1:+E.visible-+P.visible});for(const b of o){const a=this.getWebviewPanel(b);if(!a)continue;const E=m[b];a._updateViewState({active:E.active,visible:E.visible,viewColumn:t.ViewColumn.to(E.position)})}}async $onDidDisposeWebviewPanel(m){this.getWebviewPanel(m)?.dispose(),this._webviewPanels.delete(m),this.webviews.deleteWebview(m)}registerWebviewPanelSerializer(m,o,b){if(this._serializers.has(o))throw new Error(`Serializer for '${o}' already registered`);return this._serializers.set(o,{serializer:b,extension:m}),this._proxy.$registerSerializer(o,{serializeBuffersForPostMessage:(0,R.shouldSerializeBuffersForPostMessage)(m)}),new C.Disposable(()=>{this._serializers.delete(o),this._proxy.$unregisterSerializer(o)})}async $deserializeWebviewPanel(m,o,b,a){const E=this._serializers.get(o);if(!E)throw new Error(`No serializer found for '${o}'`);const{serializer:P,extension:k}=E,B=this.webviews.createNewWebview(m,b.webviewOptions,k),L=this.createNewWebviewPanel(m,o,b.title,a,b.panelOptions,B);await P.deserializeWebviewPanel(L,b.state)}createNewWebviewPanel(m,o,b,a,E,P){const k=new M(m,this._proxy,o,b,a,E,P);return this._webviewPanels.set(m,k),k}getWebviewPanel(m){return this._webviewPanels.get(m)}}e.ExtHostWebviewPanels=r;function i(p){return{enableFindWidget:p.enableFindWidget,retainContextWhenHidden:p.retainContextWhenHidden}}});var Ze=this&&this.__classPrivateFieldSet||function(oe,e,c,F,w){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?oe!==e||!w:!e.has(oe))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?w.call(oe,c):w?w.value=c:e.set(oe,c),c},Ae=this&&this.__classPrivateFieldGet||function(oe,e,c,F){if(c==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?oe!==e||!F:!e.has(oe))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?F:c==="a"?F.call(oe):F?F.value:e.get(oe)};define(Ee[208],_e([0,1,3,6,51,5,7]),function(oe,e,c,F,w,I,t){"use strict";var R,S,C,A,_,n,h,s,l,d;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class D extends F.Disposable{constructor(g,T,u,M,r,i){super();R.set(this,void 0),S.set(this,void 0),C.set(this,void 0),A.set(this,void 0),_.set(this,!1),n.set(this,void 0),h.set(this,void 0),s.set(this,void 0),l.set(this,this._register(new c.Emitter)),this.onDidChangeVisibility=Ae(this,l,"f").event,d.set(this,this._register(new c.Emitter)),this.onDidDispose=Ae(this,d,"f").event,Ze(this,C,u,"f"),Ze(this,h,M,"f"),Ze(this,R,g,"f"),Ze(this,S,T,"f"),Ze(this,A,r,"f"),Ze(this,n,i,"f")}dispose(){Ae(this,_,"f")||(Ze(this,_,!0,"f"),Ae(this,d,"f").fire(),Ae(this,A,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Ae(this,h,"f")}set title(g){this.assertNotDisposed(),Ae(this,h,"f")!==g&&(Ze(this,h,g,"f"),Ae(this,S,"f").$setWebviewViewTitle(Ae(this,R,"f"),g))}get description(){return this.assertNotDisposed(),Ae(this,s,"f")}set description(g){this.assertNotDisposed(),Ae(this,s,"f")!==g&&(Ze(this,s,g,"f"),Ae(this,S,"f").$setWebviewViewDescription(Ae(this,R,"f"),g))}get visible(){return Ae(this,n,"f")}get webview(){return Ae(this,A,"f")}get viewType(){return Ae(this,C,"f")}_setVisible(g){g===Ae(this,n,"f")||Ae(this,_,"f")||(Ze(this,n,g,"f"),Ae(this,l,"f").fire())}show(g){this.assertNotDisposed(),Ae(this,S,"f").$show(Ae(this,R,"f"),!!g)}assertNotDisposed(){if(Ae(this,_,"f"))throw new Error("Webview is disposed")}}R=new WeakMap,S=new WeakMap,C=new WeakMap,A=new WeakMap,_=new WeakMap,n=new WeakMap,h=new WeakMap,s=new WeakMap,l=new WeakMap,d=new WeakMap;class v{constructor(g,T){this._extHostWebview=T,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=g.getProxy(I.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(g,T,u,M){if(this._viewProviders.has(T))throw new Error(`View provider for '${T}' already registered`);return this._viewProviders.set(T,{provider:u,extension:g}),this._proxy.$registerWebviewViewProvider((0,w.toExtensionData)(g),T,{retainContextWhenHidden:M?.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new t.Disposable(()=>{this._viewProviders.delete(T),this._proxy.$unregisterWebviewViewProvider(T)})}async $resolveWebviewView(g,T,u,M,r){const i=this._viewProviders.get(T);if(!i)throw new Error(`No view provider found for '${T}'`);const{provider:p,extension:m}=i,o=this._extHostWebview.createNewWebview(g,{},m),b=new D(g,this._proxy,T,u,o,!0);this._webviewViews.set(g,b),await p.resolveWebviewView(b,{state:M},r)}async $onDidChangeWebviewViewVisibility(g,T){this.getWebviewView(g)._setVisible(T)}async $disposeWebviewView(g){const T=this.getWebviewView(g);this._webviewViews.delete(g),T.dispose(),this._extHostWebview.deleteWebview(g)}getWebviewView(g){const T=this._webviewViews.get(g);if(!T)throw new Error("No webview found");return T}}e.ExtHostWebviewViews=v}),define(Ee[95],_e([0,1,3,5,2,10,9,4,13]),function(oe,e,c,F,w,I,t,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let C=class Wi{constructor(_){this._onDidChangeWindowState=new c.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=Wi.InitialState,this._proxy=_.getProxy(F.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(n=>this.$onDidChangeWindowFocus(n))}get state(){return this._state}$onDidChangeWindowFocus(_){_!==this._state.focused&&(this._state={...this._state,focused:_},this._onDidChangeWindowState.fire(this._state))}openUri(_,n){let h;if(typeof _=="string"){h=_;try{_=w.URI.parse(_)}catch(s){return Promise.reject(`Invalid uri - '${_}'`)}}return(0,t.isFalsyOrWhitespace)(_.scheme)?Promise.reject("Invalid scheme - cannot be empty"):_.scheme===I.Schemas.command?Promise.reject(`Invalid scheme '${_.scheme}'`):this._proxy.$openUri(_,h,n)}async asExternalUri(_,n){if((0,t.isFalsyOrWhitespace)(_.scheme))return Promise.reject("Invalid scheme - cannot be empty");const h=await this._proxy.$asExternalUri(_,n);return w.URI.from(h)}};C.InitialState={focused:!0},C=xe([$e(0,S.IExtHostRpcService)],C),e.ExtHostWindow=C,e.IExtHostWindow=(0,R.createDecorator)("IExtHostWindow")}),define(Ee[209],_e([0,1,14,22,20,15,3,6,106,176,37]),function(oe,e,c,F,w,I,t,R,S,C,A){"use strict";var _;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function n(E,P){try{return JSON.stringify(E,P)}catch(k){return"null"}}const h="$$ref$$",s={[h]:-1};class l{constructor(P,k){this.jsonString=P,this.referencedBuffers=k}}function d(E,P=null,k=!1){const B=[];return{jsonString:(k?n:JSON.stringify)(E,(y,x)=>{if(typeof x=="undefined")return s;if(typeof x=="object"){if(x instanceof F.VSBuffer){const N=B.push(x)-1;return{[h]:N}}if(P)return P(y,x)}return x}),referencedBuffers:B}}e.stringifyJsonWithBufferRefs=d;function D(E,P,k){return JSON.parse(E,(B,L)=>{if(L){const y=L[h];if(typeof y=="number")return P[y];if(k&&L.$mid===1)return k.transformIncoming(L)}return L})}e.parseJsonAndRestoreBufferRefs=D;function v(E,P){return JSON.stringify(E,P)}function f(E){return E?(P,k)=>k&&k.$mid===1?E.transformOutgoing(k):k:null}var g;(function(E){E[E.LocalSide=0]="LocalSide",E[E.OtherSide=1]="OtherSide"})(g=e.RequestInitiator||(e.RequestInitiator={}));var T;(function(E){E[E.Responsive=0]="Responsive",E[E.Unresponsive=1]="Unresponsive"})(T=e.ResponsiveState||(e.ResponsiveState={}));const u=()=>{},M=Symbol.for("rpcProtocol"),r=Symbol.for("rpcProxy");class i extends R.Disposable{constructor(P,k=null,B=null){super();this[_]=!0,this._onDidChangeResponsiveState=this._register(new t.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=P,this._logger=k,this._uriTransformer=B,this._uriReplacer=f(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let L=0,y=A.ProxyIdentifier.count;L<y;L++)this._locals[L]=null,this._proxies[L]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new c.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(L=>this._receiveOneMessage(L))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(P=>{this._pendingRPCReplies[P].resolveErr(I.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(P){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+i.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(P){this._unresponsiveTime=Date.now()+i.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(P){this._responsiveState!==P&&(this._responsiveState=P,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(P){return this._uriTransformer?(0,S.transformIncomingURIs)(P,this._uriTransformer):P}getProxy(P){const{nid:k,sid:B}=P;return this._proxies[k]||(this._proxies[k]=this._createProxy(k,B)),this._proxies[k]}_createProxy(P,k){let B={get:(L,y)=>(typeof y=="string"&&!L[y]&&y.charCodeAt(0)===36&&(L[y]=(...x)=>this._remoteCall(P,y,x)),y===r?k:L[y])};return new Proxy(Object.create(null),B)}set(P,k){return this._locals[P.nid]=k,k}assertRegistered(P){for(let k=0,B=P.length;k<B;k++){const L=P[k];if(!this._locals[L.nid])throw new Error(`Missing actor ${L.sid} (isMain: ${L.isMain})`)}}_receiveOneMessage(P){if(this._isDisposed)return;const k=P.byteLength,B=p.read(P,0),L=B.readUInt8(),y=B.readUInt32();switch(L){case 1:case 2:{let{rpcId:x,method:N,args:z}=o.deserializeRequestJSONArgs(B);this._uriTransformer&&(z=(0,S.transformIncomingURIs)(z,this._uriTransformer)),this._receiveRequest(k,y,x,N,z,L===2);break}case 3:case 4:{let{rpcId:x,method:N,args:z}=o.deserializeRequestMixedArgs(B);this._uriTransformer&&(z=(0,S.transformIncomingURIs)(z,this._uriTransformer)),this._receiveRequest(k,y,x,N,z,L===4);break}case 5:{this._logger&&this._logger.logIncoming(k,y,0,"ack"),this._onDidReceiveAcknowledge(y);break}case 6:{this._receiveCancel(k,y);break}case 7:{this._receiveReply(k,y,void 0);break}case 9:{let x=o.deserializeReplyOKJSON(B);this._uriTransformer&&(x=(0,S.transformIncomingURIs)(x,this._uriTransformer)),this._receiveReply(k,y,x);break}case 10:{const x=o.deserializeReplyOKJSONWithBuffers(B,this._uriTransformer);this._receiveReply(k,y,x);break}case 8:{let x=o.deserializeReplyOKVSBuffer(B);this._receiveReply(k,y,x);break}case 11:{let x=o.deserializeReplyErrError(B);this._uriTransformer&&(x=(0,S.transformIncomingURIs)(x,this._uriTransformer)),this._receiveReplyErr(k,y,x);break}case 12:{this._receiveReplyErr(k,y,void 0);break}default:console.error("received unexpected message"),console.error(P)}}_receiveRequest(P,k,B,L,y,x){this._logger&&this._logger.logIncoming(P,k,1,`receiveRequest ${(0,A.getStringIdentifierForProxy)(B)}.${L}(`,y);const N=String(k);let z,H;if(x){const ue=new w.CancellationTokenSource;y.push(ue.token),z=this._invokeHandler(B,L,y),H=()=>ue.cancel()}else z=this._invokeHandler(B,L,y),H=u;this._cancelInvokedHandlers[N]=H;const q=o.serializeAcknowledged(k);this._logger&&this._logger.logOutgoing(q.byteLength,k,1,"ack"),this._protocol.send(q),z.then(ue=>{delete this._cancelInvokedHandlers[N];const K=o.serializeReplyOK(k,ue,this._uriReplacer);this._logger&&this._logger.logOutgoing(K.byteLength,k,1,"reply:",ue),this._protocol.send(K)},ue=>{delete this._cancelInvokedHandlers[N];const K=o.serializeReplyErr(k,ue);this._logger&&this._logger.logOutgoing(K.byteLength,k,1,"replyErr:",ue),this._protocol.send(K)})}_receiveCancel(P,k){this._logger&&this._logger.logIncoming(P,k,1,"receiveCancel");const B=String(k);this._cancelInvokedHandlers[B]&&this._cancelInvokedHandlers[B]()}_receiveReply(P,k,B){this._logger&&this._logger.logIncoming(P,k,0,"receiveReply:",B);const L=String(k);if(!this._pendingRPCReplies.hasOwnProperty(L))return;const y=this._pendingRPCReplies[L];delete this._pendingRPCReplies[L],y.resolveOk(B)}_receiveReplyErr(P,k,B){this._logger&&this._logger.logIncoming(P,k,0,"receiveReplyErr:",B);const L=String(k);if(!this._pendingRPCReplies.hasOwnProperty(L))return;const y=this._pendingRPCReplies[L];delete this._pendingRPCReplies[L];let x;B&&(B.$isError?(x=new Error,x.name=B.name,x.message=B.message,x.stack=B.stack):x=B),y.resolveErr(x)}_invokeHandler(P,k,B){try{return Promise.resolve(this._doInvokeHandler(P,k,B))}catch(L){return Promise.reject(L)}}_doInvokeHandler(P,k,B){const L=this._locals[P];if(!L)throw new Error("Unknown actor "+(0,A.getStringIdentifierForProxy)(P));let y=L[k];if(typeof y!="function")throw new Error("Unknown method "+k+" on actor "+(0,A.getStringIdentifierForProxy)(P));return y.apply(L,B)}_remoteCall(P,k,B){if(this._isDisposed)return Promise.reject(I.canceled());let L=null;if(B.length>0&&w.CancellationToken.isCancellationToken(B[B.length-1])&&(L=B.pop()),L&&L.isCancellationRequested)return Promise.reject(I.canceled());const y=o.serializeRequestArguments(B,this._uriReplacer),x=++this._lastMessageId,N=String(x),z=new C.LazyPromise;L&&L.onCancellationRequested(()=>{const q=o.serializeCancel(x);this._logger&&this._logger.logOutgoing(q.byteLength,x,0,"cancel"),this._protocol.send(o.serializeCancel(x))}),this._pendingRPCReplies[N]=z,this._onWillSendRequest(x);const H=o.serializeRequest(x,P,k,y,!!L);return this._logger&&this._logger.logOutgoing(H.byteLength,x,0,`request: ${(0,A.getStringIdentifierForProxy)(P)}.${k}(`,B),this._protocol.send(H),z}}e.RPCProtocol=i,_=M,i.UNRESPONSIVE_TIME=3*1e3;class p{constructor(P,k){this._buff=P,this._offset=k}static alloc(P,k,B){let L=new p(F.VSBuffer.alloc(B+1+4),0);return L.writeUInt8(P),L.writeUInt32(k),L}static read(P,k){return new p(P,k)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(P){this._buff.writeUInt8(P,this._offset),this._offset+=1}readUInt8(){const P=this._buff.readUInt8(this._offset);return this._offset+=1,P}writeUInt32(P){this._buff.writeUInt32BE(P,this._offset),this._offset+=4}readUInt32(){const P=this._buff.readUInt32BE(this._offset);return this._offset+=4,P}static sizeShortString(P){return 1+P.byteLength}writeShortString(P){this._buff.writeUInt8(P.byteLength,this._offset),this._offset+=1,this._buff.set(P,this._offset),this._offset+=P.byteLength}readShortString(){const P=this._buff.readUInt8(this._offset);this._offset+=1;const B=this._buff.slice(this._offset,this._offset+P).toString();return this._offset+=P,B}static sizeLongString(P){return 4+P.byteLength}writeLongString(P){this._buff.writeUInt32BE(P.byteLength,this._offset),this._offset+=4,this._buff.set(P,this._offset),this._offset+=P.byteLength}readLongString(){const P=this._buff.readUInt32BE(this._offset);this._offset+=4;const B=this._buff.slice(this._offset,this._offset+P).toString();return this._offset+=P,B}writeBuffer(P){this._buff.writeUInt32BE(P.byteLength,this._offset),this._offset+=4,this._buff.set(P,this._offset),this._offset+=P.byteLength}static sizeVSBuffer(P){return 4+P.byteLength}writeVSBuffer(P){this._buff.writeUInt32BE(P.byteLength,this._offset),this._offset+=4,this._buff.set(P,this._offset),this._offset+=P.byteLength}readVSBuffer(){const P=this._buff.readUInt32BE(this._offset);this._offset+=4;const k=this._buff.slice(this._offset,this._offset+P);return this._offset+=P,k}static sizeMixedArray(P){let k=0;k+=1;for(let B=0,L=P.length;B<L;B++){const y=P[B];switch(k+=1,y.type){case 1:k+=this.sizeLongString(y.value);break;case 2:k+=this.sizeVSBuffer(y.value);break;case 3:k+=this.sizeUInt32,k+=this.sizeLongString(y.value);for(let x=0;x<y.buffers.length;++x)k+=this.sizeVSBuffer(y.buffers[x]);break;case 4:break}}return k}writeMixedArray(P){this._buff.writeUInt8(P.length,this._offset),this._offset+=1;for(let k=0,B=P.length;k<B;k++){const L=P[k];switch(L.type){case 1:this.writeUInt8(1),this.writeLongString(L.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(L.value);break;case 3:this.writeUInt8(3),this.writeUInt32(L.buffers.length),this.writeLongString(L.value);for(let y=0;y<L.buffers.length;++y)this.writeBuffer(L.buffers[y]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const P=this._buff.readUInt8(this._offset);this._offset+=1;let k=new Array(P);for(let B=0;B<P;B++)switch(this.readUInt8()){case 1:k[B]=this.readLongString();break;case 2:k[B]=this.readVSBuffer();break;case 3:const y=this.readUInt32(),x=this.readLongString(),N=[];for(let z=0;z<y;++z)N.push(this.readVSBuffer());k[B]=new A.SerializableObjectWithBuffers(D(x,N,null));break;case 4:k[B]=void 0;break}return k}}p.sizeUInt32=4;var m;(function(E){E[E.Simple=0]="Simple",E[E.Mixed=1]="Mixed"})(m||(m={}));class o{static _useMixedArgSerialization(P){for(let k=0,B=P.length;k<B;k++)if(P[k]instanceof F.VSBuffer||P[k]instanceof A.SerializableObjectWithBuffers||typeof P[k]=="undefined")return!0;return!1}static serializeRequestArguments(P,k){if(this._useMixedArgSerialization(P)){const B=[];for(let L=0,y=P.length;L<y;L++){const x=P[L];if(x instanceof F.VSBuffer)B[L]={type:2,value:x};else if(typeof x=="undefined")B[L]={type:4};else if(x instanceof A.SerializableObjectWithBuffers){const{jsonString:N,referencedBuffers:z}=d(x.value,k);B[L]={type:3,value:F.VSBuffer.fromString(N),buffers:z}}else B[L]={type:1,value:F.VSBuffer.fromString(v(x,k))}}return{type:1,args:B}}return{type:0,args:v(P,k)}}static serializeRequest(P,k,B,L,y){switch(L.type){case 0:return this._requestJSONArgs(P,k,B,L.args,y);case 1:return this._requestMixedArgs(P,k,B,L.args,y)}}static _requestJSONArgs(P,k,B,L,y){const x=F.VSBuffer.fromString(B),N=F.VSBuffer.fromString(L);let z=0;z+=p.sizeUInt8(),z+=p.sizeShortString(x),z+=p.sizeLongString(N);let H=p.alloc(y?2:1,P,z);return H.writeUInt8(k),H.writeShortString(x),H.writeLongString(N),H.buffer}static deserializeRequestJSONArgs(P){const k=P.readUInt8(),B=P.readShortString(),L=P.readLongString();return{rpcId:k,method:B,args:JSON.parse(L)}}static _requestMixedArgs(P,k,B,L,y){const x=F.VSBuffer.fromString(B);let N=0;N+=p.sizeUInt8(),N+=p.sizeShortString(x),N+=p.sizeMixedArray(L);let z=p.alloc(y?4:3,P,N);return z.writeUInt8(k),z.writeShortString(x),z.writeMixedArray(L),z.buffer}static deserializeRequestMixedArgs(P){const k=P.readUInt8(),B=P.readShortString(),L=P.readMixedArray(),y=new Array(L.length);for(let x=0,N=L.length;x<N;x++){const z=L[x];typeof z=="string"?y[x]=JSON.parse(z):y[x]=z}return{rpcId:k,method:B,args:y}}static serializeAcknowledged(P){return p.alloc(5,P,0).buffer}static serializeCancel(P){return p.alloc(6,P,0).buffer}static serializeReplyOK(P,k,B){if(typeof k=="undefined")return this._serializeReplyOKEmpty(P);if(k instanceof F.VSBuffer)return this._serializeReplyOKVSBuffer(P,k);if(k instanceof A.SerializableObjectWithBuffers){const{jsonString:L,referencedBuffers:y}=d(k.value,B,!0);return this._serializeReplyOKJSONWithBuffers(P,L,y)}else return this._serializeReplyOKJSON(P,n(k,B))}static _serializeReplyOKEmpty(P){return p.alloc(7,P,0).buffer}static _serializeReplyOKVSBuffer(P,k){let B=0;B+=p.sizeVSBuffer(k);let L=p.alloc(8,P,B);return L.writeVSBuffer(k),L.buffer}static deserializeReplyOKVSBuffer(P){return P.readVSBuffer()}static _serializeReplyOKJSON(P,k){const B=F.VSBuffer.fromString(k);let L=0;L+=p.sizeLongString(B);let y=p.alloc(9,P,L);return y.writeLongString(B),y.buffer}static _serializeReplyOKJSONWithBuffers(P,k,B){const L=F.VSBuffer.fromString(k);let y=0;y+=p.sizeUInt32,y+=p.sizeLongString(L);for(const N of B)y+=p.sizeVSBuffer(N);let x=p.alloc(10,P,y);x.writeUInt32(B.length),x.writeLongString(L);for(const N of B)x.writeBuffer(N);return x.buffer}static deserializeReplyOKJSON(P){const k=P.readLongString();return JSON.parse(k)}static deserializeReplyOKJSONWithBuffers(P,k){const B=P.readUInt32(),L=P.readLongString(),y=[];for(let x=0;x<B;++x)y.push(P.readVSBuffer());return new A.SerializableObjectWithBuffers(D(L,y,k))}static serializeReplyErr(P,k){return k?this._serializeReplyErrEror(P,k):this._serializeReplyErrEmpty(P)}static _serializeReplyErrEror(P,k){const B=F.VSBuffer.fromString(n(I.transformErrorForSerialization(k),null));let L=0;L+=p.sizeLongString(B);let y=p.alloc(11,P,L);return y.writeLongString(B),y.buffer}static deserializeReplyErrError(P){const k=P.readLongString();return JSON.parse(k)}static _serializeReplyErrEmpty(P){return p.alloc(12,P,0).buffer}}var b;(function(E){E[E.RequestJSONArgs=1]="RequestJSONArgs",E[E.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",E[E.RequestMixedArgs=3]="RequestMixedArgs",E[E.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",E[E.Acknowledged=5]="Acknowledged",E[E.Cancel=6]="Cancel",E[E.ReplyOKEmpty=7]="ReplyOKEmpty",E[E.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",E[E.ReplyOKJSON=9]="ReplyOKJSON",E[E.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",E[E.ReplyErrError=11]="ReplyErrError",E[E.ReplyErrEmpty=12]="ReplyErrEmpty"})(b||(b={}));var a;(function(E){E[E.String=1]="String",E[E.VSBuffer=2]="VSBuffer",E[E.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",E[E.Undefined=4]="Undefined"})(a||(a={}))}),define(Ee[210],_e([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NestedWorker=void 0;const c=function(I){const t=R=>{self.removeEventListener("message",t);const S=R.data;Object.defineProperties(self,{postMessage:{value(C,A){S.postMessage(C,A)}},onmessage:{get(){return S.onmessage},set(C){S.onmessage=C}}}),S.addEventListener("message",C=>{self.dispatchEvent(new MessageEvent("message",{data:C.data}))}),S.start(),self.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(I)};self.addEventListener("message",t)}.toString();class F extends EventTarget{constructor(I,t,R){super();this.onmessage=null,this.onmessageerror=null,this.onerror=null;const S=`((${c})('${t}'))`,C=new Blob([S],{type:"application/javascript"}),A=URL.createObjectURL(C),_=new MessageChannel,n=A,h={type:"_newWorker",id:n,port:_.port2,url:A,options:R};I(h,[_.port2]),this.postMessage=_.port1.postMessage.bind(_.port1),this.terminate=()=>{const s={type:"_terminateWorker",id:n};_.port1.postMessage(s),URL.revokeObjectURL(A),_.port1.close(),_.port2.close()},Object.defineProperties(this,{onmessage:{get(){return _.port1.onmessage},set(s){_.port1.onmessage=s}},onmessageerror:{get(){return _.port1.onmessageerror},set(s){_.port1.onmessageerror=s}}}),_.port1.addEventListener("messageerror",s=>{const l=new MessageEvent("messageerror",{data:s.data});this.dispatchEvent(l)}),_.port1.addEventListener("message",s=>{const l=new MessageEvent("message",{data:s.data});this.dispatchEvent(l)}),_.port1.start()}}e.NestedWorker=F}),define(Ee[211],_e([0,1,4]),function(oe,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,c.createDecorator)("remoteAgentService")}),define(Ee[212],_e([0,1,10,17,23,2,4,61,47,171,211]),function(oe,e,c,F,w,I,t,R,S,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,t.createDecorator)("pathService");let _=class Vi{constructor(h,s,l,d){this.localUserHome=h,this.remoteAgentService=s,this.environmentService=l,this.contextService=d,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||w.OS)(),this.resolveUserHome=(async()=>{const D=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=D?.userHome||h})()}get defaultUriScheme(){return Vi.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(h,s){if(h.remoteAuthority)return c.Schemas.vscodeRemote;const l=(0,R.getVirtualWorkspaceScheme)(s.getWorkspace());if(l)return l;const d=s.getWorkspace().folders[0];if(d)return d.uri.scheme;const D=s.getWorkspace().configuration;return D?D.scheme:c.Schemas.file}async userHome(h){return h?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(h=>h===1?F.win32:F.posix)}async fileURI(h){let s="";if(await this.resolveOS===1&&(h=h.replace(/\\/g,"/")),h[0]==="/"&&h[1]==="/"){const d=h.indexOf("/",2);d===-1?(s=h.substring(2),h="/"):(s=h.substring(2,d),h=h.substring(d)||"/")}return I.URI.from({scheme:c.Schemas.file,authority:s,path:h,query:"",fragment:""})}};_=xe([$e(1,A.IRemoteAgentService),$e(2,C.IWorkbenchEnvironmentService),$e(3,S.IWorkspaceContextService)],_),e.AbstractPathService=_}),define(Ee[96],_e([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class c{constructor(t,R){this.line=t,this.character=R}isBefore(t){return!1}isBeforeOrEqual(t){return!1}isAfter(t){return!1}isAfterOrEqual(t){return!1}isEqual(t){return!1}compareTo(t){return 0}translate(t,R){return new c(0,0)}with(t){return new c(0,0)}}e.Position=c;class F{constructor(t,R,S,C){this.isEmpty=!1,this.isSingleLine=!1,this.start=new c(t,R),this.end=new c(S,C)}contains(t){return!1}isEqual(t){return!1}intersection(t){}union(t){return new F(0,0,0,0)}with(t){return new F(0,0,0,0)}}e.Range=F;var w;(function(I){I[I.Information=1]="Information",I[I.Warning=2]="Warning"})(w=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(Ee[40],_e([0,1,16,29,27,43,9,4,17,15,96,11]),function(oe,e,c,F,w,I,t,R,S,C,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return A.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const n="\u27EA ",h=" characters skipped \u27EB",s=(n.length+h.length+5)*2;e.ISearchService=(0,R.createDecorator)("searchService");var l;(function(q){q[q.file=0]="file",q[q.text=1]="text"})(l=e.SearchProviderType||(e.SearchProviderType={}));var d;(function(q){q[q.File=1]="File",q[q.Text=2]="Text"})(d=e.QueryType||(e.QueryType={}));function D(q){return!!q.preview}e.resultIsMatch=D;function v(q){return!!q.resource}e.isFileMatch=v;function f(q){return!!q.message}e.isProgressMessage=f;var g;(function(q){q[q.Normal=0]="Normal",q[q.NewSearchStarted=1]="NewSearchStarted"})(g=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class T{constructor(ue){this.resource=ue,this.results=[]}}e.FileMatch=T;class u{constructor(ue,K,ce){this.ranges=K;const de=Array.isArray(K)?K:[K];if(ce&&ce.matchLines===1&&M(de)){ue=(0,t.getNLines)(ue,ce.matchLines);let Q="",ie=0,we=0;const Me=Math.floor(ce.charsPerLine/5),Fe=[];for(const Be of de){const Ge=Math.max(Be.startColumn-Me,0),je=Be.startColumn+ce.charsPerLine;if(Ge>we+Me+s){const Qe=n+(Ge-we)+h;Q+=Qe+ue.slice(Ge,je),ie+=Ge-(we+Qe.length)}else Q+=ue.slice(we,je);Fe.push(new i(0,Be.startColumn-ie,Be.endColumn-ie)),we=je}this.preview={text:Q,matches:Array.isArray(this.ranges)?Fe:Fe[0]}}else{const Q=Array.isArray(K)?K[0].startLineNumber:K.startLineNumber;this.preview={text:ue,matches:(0,c.mapArrayOrNot)(K,ie=>new r(ie.startLineNumber-Q,ie.startColumn,ie.endLineNumber-Q,ie.endColumn))}}}}e.TextSearchMatch=u;function M(q){const ue=q[0].startLineNumber;for(const K of q)if(K.startLineNumber!==ue||K.endLineNumber!==ue)return!1;return!0}class r{constructor(ue,K,ce,de){this.startLineNumber=ue,this.startColumn=K,this.endLineNumber=ce,this.endColumn=de}}e.SearchRange=r;class i extends r{constructor(ue,K,ce){super(ue,K,ue,ce)}}e.OneLineRange=i;var p;(function(q){q.Default="default",q.FileNames="fileNames",q.Type="type",q.Modified="modified",q.CountDescending="countDescending",q.CountAscending="countAscending"})(p=e.SearchSortOrder||(e.SearchSortOrder={}));function m(q,ue=!0){const K=q&&q.files&&q.files.exclude,ce=ue&&q&&q.search&&q.search.exclude;if(!K&&!ce)return;if(!K||!ce)return K||ce;let de=Object.create(null);return de=w.mixin(de,w.deepClone(K)),de=w.mixin(de,w.deepClone(ce),!0),de}e.getExcludes=m;function o(q,ue){return q.excludePattern&&F.match(q.excludePattern,ue)?!1:q.includePattern||q.usingSearchPaths?q.includePattern&&F.match(q.includePattern,ue)?!0:q.usingSearchPaths?!!q.folderQueries&&q.folderQueries.some(K=>{const ce=K.folder.fsPath;if(I.isEqualOrParent(ue,ce)){const de=S.relative(ce,ue);return!K.includePattern||!!F.match(K.includePattern,de)}else return!1}):!1:!0}e.pathIncludedInQuery=o;var b;(function(q){q[q.unknownEncoding=1]="unknownEncoding",q[q.regexParseError=2]="regexParseError",q[q.globParseError=3]="globParseError",q[q.invalidLiteral=4]="invalidLiteral",q[q.rgProcessError=5]="rgProcessError",q[q.other=6]="other",q[q.canceled=7]="canceled"})(b=e.SearchErrorCode||(e.SearchErrorCode={}));class a extends Error{constructor(ue,K){super(ue);this.code=K}}e.SearchError=a;function E(q){const ue=q.message;if((0,C.isPromiseCanceledError)(q))return new a(ue,b.canceled);try{const K=JSON.parse(ue);return new a(K.message,K.code)}catch(K){return new a(ue,b.other)}}e.deserializeSearchError=E;function P(q){const ue={message:q.message,code:q.code};return new Error(JSON.stringify(ue))}e.serializeSearchError=P;function k(q){return q.type==="error"?!0:q.type==="success"}e.isSerializedSearchComplete=k;function B(q){return q.type==="success"}e.isSerializedSearchSuccess=B;function L(q){return!!q.path}e.isSerializedFileMatch=L;function y(q,ue){const K=q.searchPath?q.searchPath:q.relativePath;return(0,t.fuzzyContains)(K,ue)}e.isFilePatternMatch=y;class x{constructor(ue){this.path=ue,this.results=[]}addMatch(ue){this.results.push(ue)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=x;function N(q,ue){const K={...q||{},...ue||{}};return Object.keys(K).filter(ce=>{const de=K[ce];return typeof de=="boolean"&&de})}e.resolvePatternsForProvider=N;class z{constructor(ue,K){this._parsedIncludeExpression=null,this._excludeExpression={...ue.excludePattern||{},...K.excludePattern||{}},this._parsedExcludeExpression=F.parse(this._excludeExpression);let ce=ue.includePattern;K.includePattern&&(ce?ce={...ce,...K.includePattern}:ce=K.includePattern),ce&&(this._parsedIncludeExpression=F.parse(ce))}matchesExcludesSync(ue,K,ce){return!!(this._parsedExcludeExpression&&this._parsedExcludeExpression(ue,K,ce))}includedInQuerySync(ue,K,ce){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(ue,K,ce)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(ue,K,ce))}includedInQuery(ue,K,ce){const de=this._parsedExcludeExpression(ue,K,ce),Q=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(ue,K,ce):!0;return(0,_.isPromise)(de)?de.then(ie=>ie?!1:Q()):Q()}hasSiblingExcludeClauses(){return H(this._excludeExpression)}}e.QueryGlobTester=z;function H(q){for(const ue in q)if(typeof q[ue]!="boolean")return!0;return!1}}),define(Ee[31],_e([0,1,16,14,20,3,21,10,75,24,9,11,2,125,4,12,138,47,30,28,13,7,40,5]),function(oe,e,c,F,w,I,t,R,S,C,A,_,n,h,s,l,d,D,v,f,g,T,u,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function r(P,k,B){return new C.ExtUri(L=>o(L,B)).isEqual(P,k)}function i(P,k,B){return r(P.uri,k.uri,B)?0:(0,A.compare)(P.uri.toString(),k.uri.toString())}function p(P,k,B){return P.index!==k.index?P.index<k.index?-1:1:r(P.uri,k.uri,B)?(0,A.compare)(P.name,k.name):(0,A.compare)(P.uri.toString(),k.uri.toString())}function m(P,k,B,L){const y=P.slice(0).sort((N,z)=>B(N,z,L)),x=k.slice(0).sort((N,z)=>B(N,z,L));return(0,c.delta)(y,x,(N,z)=>B(N,z,L))}function o(P,k){const B=k.getCapabilities(P.scheme);return!(B&&B&1024)}class b extends D.Workspace{constructor(k,B,L,y,x,N,z){super(k,L.map(H=>new D.WorkspaceFolder(H)),y,x,z);this._name=B,this._isUntitled=N,this._workspaceFolders=[],this._structure=t.TernarySearchTree.forUris(z),L.forEach(H=>{this._workspaceFolders.push(H),this._structure.set(H.uri,H)})}static toExtHostWorkspace(k,B,L,y){if(!k)return{workspace:null,added:[],removed:[]};const{id:x,name:N,folders:z,configuration:H,transient:q,isUntitled:ue}=k,K=[],ce=B;B?z.forEach((we,Me)=>{const Fe=n.URI.revive(we.uri),Be=b._findFolder(L||B,Fe,y);Be?(Be.name=we.name,Be.index=we.index,K.push(Be)):K.push({uri:Fe,name:we.name,index:Me})}):K.push(...z.map(({uri:we,name:Me,index:Fe})=>({uri:n.URI.revive(we),name:Me,index:Fe}))),K.sort((we,Me)=>we.index<Me.index?-1:1);const de=new b(x,N,K,!!q,H?n.URI.revive(H):null,!!ue,we=>o(we,y)),{added:Q,removed:ie}=m(ce?ce.workspaceFolders:[],de.workspaceFolders,i,y);return{workspace:de,added:Q,removed:ie}}static _findFolder(k,B,L){for(let y=0;y<k.folders.length;y++){const x=k.workspaceFolders[y];if(r(x.uri,B,L))return x}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(k,B){return B&&this._structure.get(k)&&(k=(0,C.dirname)(k)),this._structure.findSubstr(k)}resolveWorkspaceFolder(k){return this._structure.get(k)}}let a=class{constructor(k,B,L,y){this._onDidChangeWorkspace=new I.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new I.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=y,this._extHostFileSystemInfo=L,this._requestIdProvider=new S.Counter,this._barrier=new F.Barrier,this._proxy=k.getProxy(M.MainContext.MainThreadWorkspace),this._messageService=k.getProxy(M.MainContext.MainThreadMessageService);const x=B.workspace;this._confirmedWorkspace=x?new b(x.id,x.name,[],!!x.transient,x.configuration?n.URI.revive(x.configuration):null,!!x.isUntitled,N=>o(N,L)):void 0}$initializeWorkspace(k,B){this._trusted=B,this.$acceptWorkspaceData(k),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?n.URI.from({scheme:R.Schemas.untitled,path:(0,C.basename)((0,C.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(k,B,L,...y){const x=[];if(Array.isArray(y)&&y.forEach(ue=>{n.URI.isUri(ue.uri)&&!x.some(K=>r(K.uri,ue.uri,this._extHostFileSystemInfo))&&x.push({uri:ue.uri,name:ue.name||(0,C.basenameOrAuthority)(ue.uri)})}),this._unconfirmedWorkspace||[B,L].some(ue=>typeof ue!="number"||ue<0)||L===0&&x.length===0)return!1;const N=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(B+L>N.length)return!1;const z=N.slice(0);z.splice(B,L,...x.map(ue=>({uri:ue.uri,name:ue.name||(0,C.basenameOrAuthority)(ue.uri),index:void 0})));for(let ue=0;ue<z.length;ue++){const K=z[ue];if(z.some((ce,de)=>de!==ue&&r(K.uri,ce.uri,this._extHostFileSystemInfo)))return!1}z.forEach((ue,K)=>ue.index=K);const{added:H,removed:q}=m(N,z,p,this._extHostFileSystemInfo);if(H.length===0&&q.length===0)return!1;if(this._proxy){const ue=k.displayName||k.name;this._proxy.$updateWorkspaceFolders(ue,B,L,x).then(void 0,K=>{this._unconfirmedWorkspace=void 0,this._messageService.$showMessage(d.Severity.Error,(0,h.localize)(0,null,ue,K.toString()),{extension:k},[])})}return this.trySetWorkspaceFolders(z),!0}getWorkspaceFolder(k,B){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(k,B)}async getWorkspaceFolder2(k,B){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(k,B)}async resolveWorkspaceFolder(k){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(k)}getPath(){if(!this._actualWorkspace)return;const{folders:k}=this._actualWorkspace;if(k.length!==0)return k[0].uri.fsPath}getRelativePath(k,B){let L,y="";if(typeof k=="string"?(L=n.URI.file(k),y=k):typeof k!="undefined"&&(L=k,y=k.fsPath),!L)return y;const x=this.getWorkspaceFolder(L,!0);if(!x)return y;typeof B=="undefined"&&this._actualWorkspace&&(B=this._actualWorkspace.folders.length>1);let N=(0,C.relativePath)(x.uri,L);return B&&x.name&&(N=`${x.name}/${N}`),N}trySetWorkspaceFolders(k){this._actualWorkspace&&(this._unconfirmedWorkspace=b.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:k,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(k){const{workspace:B,added:L,removed:y}=b.toExtHostWorkspace(k,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=B||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:L,removed:y}))}findFiles(k,B,L,y,x=w.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${y.value}, entryPoint: findFiles`);let N;if(B===null?N=!1:B&&(typeof B=="string"?N=B:N=B.pattern),x&&x.isCancellationRequested)return Promise.resolve([]);const{includePattern:z,folder:H}=E(k);return this._proxy.$startFileSearch((0,_.withUndefinedAsNull)(z),(0,_.withUndefinedAsNull)(H),(0,_.withUndefinedAsNull)(N),(0,_.withUndefinedAsNull)(L),x).then(q=>Array.isArray(q)?q.map(ue=>n.URI.revive(ue)):[])}async findTextInFiles(k,B,L,y,x=w.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${y.value}, entryPoint: findTextInFiles`);const N=this._requestIdProvider.getNext(),z=typeof B.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:B.previewOptions,{includePattern:H,folder:q}=E(B.include),ue=typeof B.exclude=="string"?B.exclude:B.exclude?B.exclude.pattern:void 0,K={ignoreSymlinks:typeof B.followSymlinks=="boolean"?!B.followSymlinks:void 0,disregardIgnoreFiles:typeof B.useIgnoreFiles=="boolean"?!B.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof B.useGlobalIgnoreFiles=="boolean"?!B.useGlobalIgnoreFiles:void 0,disregardExcludeSettings:typeof B.useDefaultExcludes=="boolean"?!B.useDefaultExcludes:!0,fileEncoding:B.encoding,maxResults:B.maxResults,previewOptions:z,afterContext:B.afterContext,beforeContext:B.beforeContext,includePattern:H,excludePattern:ue},ce=!1;if(this._activeSearchCallbacks[N]=de=>{if(ce)return;const Q=n.URI.revive(de.resource);de.results.forEach(ie=>{(0,u.resultIsMatch)(ie)?L({uri:Q,preview:{text:ie.preview.text,matches:(0,c.mapArrayOrNot)(ie.preview.matches,we=>new T.Range(we.startLineNumber,we.startColumn,we.endLineNumber,we.endColumn))},ranges:(0,c.mapArrayOrNot)(ie.ranges,we=>new T.Range(we.startLineNumber,we.startColumn,we.endLineNumber,we.endColumn))}):L({uri:Q,text:ie.text,lineNumber:ie.lineNumber})})},x.isCancellationRequested)return{};try{const de=await this._proxy.$startTextSearch(k,(0,_.withUndefinedAsNull)(q),K,N,x);return delete this._activeSearchCallbacks[N],de||{}}catch(de){throw delete this._activeSearchCallbacks[N],de}}$handleTextSearchResult(k,B){this._activeSearchCallbacks[B]&&this._activeSearchCallbacks[B](k)}saveAll(k){return this._proxy.$saveAll(k)}resolveProxy(k){return this._proxy.$resolveProxy(k)}get trusted(){return this._trusted}requestWorkspaceTrust(k){return this._proxy.$requestWorkspaceTrust(k)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};a=xe([$e(0,g.IExtHostRpcService),$e(1,f.IExtHostInitDataService),$e(2,v.IExtHostFileSystemInfo),$e(3,l.ILogService)],a),e.ExtHostWorkspace=a,e.IExtHostWorkspace=(0,s.createDecorator)("IExtHostWorkspace");function E(P){let k,B;return P&&(typeof P=="string"?k=P:(k=P.pattern,B=P.baseFolder||n.URI.file(P.base))),{includePattern:k,folder:B}}}),define(Ee[32],_e([0,1,27,3,31,5,7,142,83,11,14,4,13,12,2]),function(oe,e,c,F,w,I,t,R,S,C,A,_,n,h,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function l(M,r){if(r){const i=r.split(".");let p=M;for(let m=0;p&&m<i.length;m++)p=p[i[m]];return p}}function d(M){return M instanceof s.URI}function D(M){return M&&M.uri instanceof s.URI&&M.languageId&&typeof M.languageId=="string"}function v(M){return M&&!M.uri&&M.languageId&&typeof M.languageId=="string"}function f(M){return M&&M.uri instanceof s.URI&&(!M.name||typeof M.name=="string")&&(!M.index||typeof M.index=="number")}function g(M){if(d(M))return{resource:M};if(D(M))return{resource:M.uri,overrideIdentifier:M.languageId};if(v(M))return{overrideIdentifier:M.languageId};if(f(M))return{resource:M.uri};if(M===null)return{resource:null}}let T=class{constructor(r,i,p){this._proxy=r.getProxy(I.MainContext.MainThreadConfiguration),this._extHostWorkspace=i,this._logService=p,this._barrier=new A.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(r=>this._actual)}$initializeConfiguration(r){this._actual=new u(this._proxy,this._extHostWorkspace,r,this._logService),this._barrier.open()}$acceptConfigurationChanged(r,i){this.getConfigProvider().then(p=>p.$acceptConfigurationChanged(r,i))}};T=xe([$e(0,n.IExtHostRpcService),$e(1,w.IExtHostWorkspace),$e(2,h.ILogService)],T),e.ExtHostConfiguration=T;class u{constructor(r,i,p,m){this._onDidChangeConfiguration=new F.Emitter,this._proxy=r,this._logService=m,this._extHostWorkspace=i,this._configuration=R.Configuration.parse(p),this._configurationScopes=this._toMap(p.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(r,i){const p={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=R.Configuration.parse(r),this._configurationScopes=this._toMap(r.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(i,p))}getConfiguration(r,i,p){const m=g(i)||{},o=this._toReadonlyValue(r?l(this._configuration.getValue(void 0,m,this._extHostWorkspace.workspace),r):this._configuration.getValue(void 0,m,this._extHostWorkspace.workspace));r&&this._validateConfigurationAccess(r,m,p?.identifier);function b(E){if(E==null)return null;if(typeof E=="boolean")return E?1:4;switch(E){case t.ConfigurationTarget.Global:return 1;case t.ConfigurationTarget.Workspace:return 4;case t.ConfigurationTarget.WorkspaceFolder:return 5}}const a={has(E){return typeof l(o,E)!="undefined"},get:(E,P)=>{this._validateConfigurationAccess(r?`${r}.${E}`:E,m,p?.identifier);let k=l(o,E);if(typeof k=="undefined")k=P;else{let B;const L=(y,x)=>{let N;const z=()=>{B=B||(0,c.deepClone)(o),N=N||l(B,x)};return(0,C.isObject)(y)?new Proxy(y,{get:(H,q)=>{if(typeof q=="string"&&q.toLowerCase()==="tojson")return z(),()=>N;if(B)return N=N||l(B,x),N[q];const ue=H[q];return typeof q=="string"?L(ue,`${x}.${q}`):ue},set:(H,q,ue)=>(z(),N&&(N[q]=ue),!0),deleteProperty:(H,q)=>(z(),N&&delete N[q],!0),defineProperty:(H,q,ue)=>(z(),N&&Object.defineProperty(N,q,ue),!0)}):y};k=L(k,E)}return k},update:(E,P,k,B)=>{E=r?`${r}.${E}`:E;const L=b(k);return P!==void 0?this._proxy.$updateConfigurationOption(L,E,P,m,B):this._proxy.$removeConfigurationOption(L,E,m,B)},inspect:E=>{E=r?`${r}.${E}`:E;const P=(0,c.deepClone)(this._configuration.inspect(E,m,this._extHostWorkspace.workspace));if(P)return{key:E,defaultValue:P.default?.value,globalValue:P.user?.value,workspaceValue:P.workspace?.value,workspaceFolderValue:P.workspaceFolder?.value,defaultLanguageValue:P.default?.override,globalLanguageValue:P.user?.override,workspaceLanguageValue:P.workspace?.override,workspaceFolderLanguageValue:P.workspaceFolder?.override,languageIds:P.overrideIdentifiers}}};return typeof o=="object"&&(0,c.mixin)(a,o,!1),Object.freeze(a)}_toReadonlyValue(r){const i=p=>(0,C.isObject)(p)?new Proxy(p,{get:(m,o)=>i(m[o]),set:(m,o,b)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(o)}' of object`)},deleteProperty:(m,o)=>{throw new Error(`TypeError: Cannot delete read only property '${String(o)}' of object`)},defineProperty:(m,o)=>{throw new Error(`TypeError: Cannot define property '${String(o)}' for a readonly object`)},setPrototypeOf:m=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):p;return i(r)}_validateConfigurationAccess(r,i,p){const m=S.OVERRIDE_PROPERTY_REGEX.test(r)?4:this._configurationScopes.get(r),o=p?`[${p.value}] `:"";if(m===4){typeof i?.resource=="undefined"&&this._logService.warn(`${o}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${r}', provide the URI of a resource or 'null' for any resource.`);return}if(m===3){i?.resource&&this._logService.warn(`${o}Accessing a window scoped configuration for a resource is not expected. To associate '${r}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(r,i){const p=new R.ConfigurationChangeEvent(r,i,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(m,o)=>p.affectsConfiguration(m,g(o))})}_toMap(r){return r.reduce((i,p)=>(i.set(p[0],p[1]),i),new Map)}}e.ExtHostConfigProvider=u,e.IExtHostConfiguration=(0,_.createDecorator)("IExtHostConfiguration")});var Ze=this&&this.__classPrivateFieldSet||function(oe,e,c,F,w){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?oe!==e||!w:!e.has(oe))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?w.call(oe,c):w?w.value=c:e.set(oe,c),c},Ae=this&&this.__classPrivateFieldGet||function(oe,e,c,F){if(c==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?oe!==e||!F:!e.has(oe))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?F:c==="a"?F.call(oe):F?F.value:e.get(oe)};define(Ee[97],_e([0,1,2,14,3,5,7,31,49,32,20,39,13,28,4,10,23,12,69,161,15]),function(oe,e,c,F,w,I,t,R,S,C,A,_,n,h,s,l,d,D,v,f,g){"use strict";var T;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskGroupDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var u;(function(x){function N(H){if(H!=null)return H}x.from=N;function z(H){if(H!=null)return H}x.to=z})(u=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var M;(function(x){function N(H){if(H!=null)return H}x.from=N;function z(H){if(H!=null)return H}x.to=z})(M=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var r;(function(x){function N(H){if(H!=null)return H}x.from=N;function z(H){if(H!=null)return H}x.to=z})(r=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var i;(function(x){function N(q){if(q){const ue=q;return ue&&!!ue.process}else return!1}x.is=N;function z(q){if(q==null)return;const ue={process:q.process,args:q.args};return q.options&&(ue.options=r.from(q.options)),ue}x.from=z;function H(q){if(q!=null)return new t.ProcessExecution(q.process,q.args,q.options)}x.to=H})(i=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var p;(function(x){function N(H){if(H!=null)return H}x.from=N;function z(H){if(H!=null)return H}x.to=z})(p=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var m;(function(x){function N(q){if(q){const ue=q;return ue&&(!!ue.commandLine||!!ue.command)}else return!1}x.is=N;function z(q){if(q==null)return;const ue={};return q.commandLine!==void 0?ue.commandLine=q.commandLine:(ue.command=q.command,ue.args=q.args),q.options&&(ue.options=p.from(q.options)),ue}x.from=z;function H(q){if(!(q==null||q.command===void 0&&q.commandLine===void 0))return q.commandLine?new t.ShellExecution(q.commandLine,q.options):new t.ShellExecution(q.command,q.args?q.args:[],q.options)}x.to=H})(m=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var o;(function(x){function N(q){if(q){let ue=q;return ue&&ue.customExecution==="customExecution"}else return!1}x.is=N;function z(q){return{customExecution:"customExecution"}}x.from=z;function H(q,ue){return ue.get(q)}x.to=H})(o=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var b;(function(x){function N(z,H){let q;return z.scope!==void 0&&typeof z.scope!="number"?q=z.scope.uri:z.scope!==void 0&&typeof z.scope=="number"&&(z.scope===t.TaskScope.Workspace&&H&&H.workspaceFile?q=H.workspaceFile:q=f.USER_TASKS_GROUP_KEY),{id:z._id,workspaceFolder:q}}x.from=N})(b=e.TaskHandleDTO||(e.TaskHandleDTO={}));var a;(function(x){function N(z){if(z!=null)return{_id:z.id,isDefault:z.isDefault}}x.from=N})(a=e.TaskGroupDTO||(e.TaskGroupDTO={}));var E;(function(x){function N(q,ue){if(q==null)return[];const K=[];for(let ce of q){const de=z(ce,ue);de&&K.push(de)}return K}x.fromMany=N;function z(q,ue){if(q==null)return;let K;q.execution instanceof t.ProcessExecution?K=i.from(q.execution):q.execution instanceof t.ShellExecution?K=m.from(q.execution):q.execution&&q.execution instanceof t.CustomExecution&&(K=o.from(q.execution));const ce=u.from(q.definition);let de;return q.scope?typeof q.scope=="number"?de=q.scope:de=q.scope.uri:de=t.TaskScope.Workspace,!ce||!de?void 0:{_id:q._id,definition:ce,name:q.name,source:{extensionId:ue.identifier.value,label:q.source,scope:de},execution:K,isBackground:q.isBackground,group:a.from(q.group),presentationOptions:M.from(q.presentationOptions),problemMatchers:q.problemMatchers,hasDefinedMatchers:q.hasDefinedMatchers,runOptions:q.runOptions?q.runOptions:{reevaluateOnRerun:!0},detail:q.detail}}x.from=z;async function H(q,ue,K){if(q==null)return;let ce;i.is(q.execution)?ce=i.to(q.execution):m.is(q.execution)?ce=m.to(q.execution):o.is(q.execution)&&(ce=o.to(q._id,K));const de=u.to(q.definition);let Q;if(q.source&&(q.source.scope!==void 0?typeof q.source.scope=="number"?Q=q.source.scope:Q=await ue.resolveWorkspaceFolder(c.URI.revive(q.source.scope)):Q=t.TaskScope.Workspace),!de||!Q)return;const ie=new t.Task(de,Q,q.name,q.source.label,ce,q.problemMatchers);return q.isBackground!==void 0&&(ie.isBackground=q.isBackground),q.group!==void 0&&(ie.group=t.TaskGroup.from(q.group._id),ie.group&&q.group.isDefault&&(ie.group=new t.TaskGroup(ie.group.id,ie.group.label),q.group.isDefault&&(ie.group.isDefault=q.group.isDefault))),q.presentationOptions&&(ie.presentationOptions=M.to(q.presentationOptions)),q._id&&(ie._id=q._id),q.detail&&(ie.detail=q.detail),ie}x.to=H})(E=e.TaskDTO||(e.TaskDTO={}));var P;(function(x){function N(H){return H}x.from=N;function z(H){if(!!H)return Object.assign(Object.create(null),H)}x.to=z})(P=e.TaskFilterDTO||(e.TaskFilterDTO={}));class k{constructor(N,z,H){this._id=z,this._task=H,T.set(this,void 0),Ze(this,T,N,"f")}get task(){return this._task}terminate(){Ae(this,T,"f").terminateTask(this)}fireDidStartProcess(N){}fireDidEndProcess(N){}}T=new WeakMap;var B;(function(x){function N(z){return{id:z._id,task:void 0}}x.from=N})(B=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let L=class{constructor(N,z,H,q,ue,K,ce,de){this._onDidExecuteTask=new w.Emitter,this._onDidTerminateTask=new w.Emitter,this._onDidTaskProcessStarted=new w.Emitter,this._onDidTaskProcessEnded=new w.Emitter,this._proxy=N.getProxy(I.MainContext.MainThreadTask),this._workspaceProvider=H,this._editorService=q,this._configurationService=ue,this._terminalService=K,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=ce,this._deprecationService=de,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(N,z,H){if(!H)return new t.Disposable(()=>{});const q=this.nextHandle();return this._handlers.set(q,{type:z,provider:H,extension:N}),this._proxy.$registerTaskProvider(q,z),new t.Disposable(()=>{this._handlers.delete(q),this._proxy.$unregisterTaskProvider(q)})}registerTaskSystem(N,z){this._proxy.$registerTaskSystem(N,z)}fetchTasks(N){return this._proxy.$fetchTasks(P.from(N)).then(async z=>{const H=[];for(let q of z){const ue=await E.to(q,this._workspaceProvider,this._providedCustomExecutions2);ue&&H.push(ue)}return H})}get taskExecutions(){const N=[];return this._taskExecutions.forEach(z=>N.push(z)),N}terminateTask(N){if(!(N instanceof k))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(N._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(N,z,H){const q=this._providedCustomExecutions2.get(N.id);q&&(this._activeCustomExecutions2.set(N.id,q),this._terminalService.attachPtyToTerminal(z,await q.callback(H))),this._lastStartedTask=N.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(N)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(N){const z=await this.getTaskExecution(N);this._taskExecutionPromises.delete(N.id),this._taskExecutions.delete(N.id),this.customExecutionComplete(N),this._onDidTerminateTask.fire({execution:z})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(N){const z=await this.getTaskExecution(N.id);this._onDidTaskProcessStarted.fire({execution:z,processId:N.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(N){const z=await this.getTaskExecution(N.id);this._onDidTaskProcessEnded.fire({execution:z,exitCode:N.exitCode})}$provideTasks(N,z){const H=this._handlers.get(N);if(!H)return Promise.reject(new Error("no handler found"));const q=[],ue=(0,F.asPromise)(()=>H.provider.provideTasks(A.CancellationToken.None)).then(K=>this.provideTasksInternal(z,q,H,K));return new Promise(K=>{ue.then(ce=>{Promise.all(q).then(()=>{K(ce)})})})}async $resolveTask(N,z){const H=this._handlers.get(N);if(!H)return Promise.reject(new Error("no handler found"));if(z.definition.type!==H.type)throw new Error(`Unexpected: Task of type [${z.definition.type}] cannot be resolved by provider of type [${H.type}].`);const q=await E.to(z,this._workspaceProvider,this._providedCustomExecutions2);if(!q)throw new Error("Unexpected: Task cannot be resolved.");const ue=await H.provider.resolveTask(q,A.CancellationToken.None);if(!ue)return;this.checkDeprecation(ue,H);const K=E.from(ue,H.extension);if(!K)throw new Error("Unexpected: Task cannot be resolved.");if(ue.definition!==q.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return o.is(K.execution)&&await this.addCustomExecution(K,ue,!0),await this.resolveTaskInternal(K)}nextHandle(){return this._handleCounter++}async addCustomExecution(N,z,H){const q=await this._proxy.$createTaskId(N);!H&&!this._providedCustomExecutions2.has(q)&&(this._notProvidedCustomExecutions.add(q),this._activeCustomExecutions2.set(q,z.execution)),this._providedCustomExecutions2.set(q,z.execution)}async getTaskExecution(N,z){if(typeof N=="string"){const ue=this._taskExecutionPromises.get(N);if(!ue)throw new Error("Unexpected: The specified task is missing an execution");return ue}let H=this._taskExecutionPromises.get(N.id);if(H)return H;const q=new Promise((ue,K)=>{function ce(de,Q,ie){ie?ue(new k(de,Q.id,ie)):K("Unexpected: Task does not exist.")}z?ce(this,N,z):E.to(N.task,this._workspaceProvider,this._providedCustomExecutions2).then(de=>ce(this,N,de))});return this._taskExecutionPromises.set(N.id,q),q.then(ue=>(this._taskExecutions.set(N.id,ue),ue),ue=>Promise.reject(ue))}checkDeprecation(N,z){N._deprecated&&this._deprecationService.report("Task.constructor",z.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(N){this._activeCustomExecutions2.get(N.id)&&this._activeCustomExecutions2.delete(N.id),this._notProvidedCustomExecutions.has(N.id)&&this._lastStartedTask!==N.id&&(this._providedCustomExecutions2.delete(N.id),this._notProvidedCustomExecutions.delete(N.id));let H=this._notProvidedCustomExecutions.values(),q=H.next();for(;!q.done;)!this._activeCustomExecutions2.has(q.value)&&this._lastStartedTask!==q.value&&(this._providedCustomExecutions2.delete(q.value),this._notProvidedCustomExecutions.delete(q.value)),q=H.next()}};L=xe([$e(0,n.IExtHostRpcService),$e(1,h.IExtHostInitDataService),$e(2,R.IExtHostWorkspace),$e(3,S.IExtHostDocumentsAndEditors),$e(4,C.IExtHostConfiguration),$e(5,_.IExtHostTerminalService),$e(6,D.ILogService),$e(7,v.IExtHostApiDeprecationService)],L),e.ExtHostTaskBase=L;let y=class extends L{constructor(N,z,H,q,ue,K,ce,de){super(N,z,H,q,ue,K,ce,de);this.registerTaskSystem(l.Schemas.vscodeRemote,{scheme:l.Schemas.vscodeRemote,authority:"",platform:d.PlatformToString(0)})}async executeTask(N,z){if(!z.execution)throw new Error("Tasks to execute must include an execution");const H=E.from(z,N);if(H===void 0)throw new Error("Task is not valid");if(o.is(H.execution))await this.addCustomExecution(H,z,!1);else throw new g.NotSupportedError;const q=await this.getTaskExecution(await this._proxy.$getTaskExecution(H),z);return this._proxy.$executeTask(H).catch(ue=>{throw new Error(ue)}),q}provideTasksInternal(N,z,H,q){const ue=[];if(q)for(let K of q){this.checkDeprecation(K,H),(!K.definition||!N[K.definition.type])&&this._logService.warn(`The task [${K.source}, ${K.name}] uses an undefined task type. The task will be ignored in the future.`);const ce=E.from(K,H.extension);ce&&o.is(ce.execution)?(ue.push(ce),z.push(this.addCustomExecution(ce,K,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:ue,extension:H.extension}}async resolveTaskInternal(N){if(o.is(N.execution))return N;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(N,z){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(N,z,H){}};y=xe([$e(0,n.IExtHostRpcService),$e(1,h.IExtHostInitDataService),$e(2,R.IExtHostWorkspace),$e(3,S.IExtHostDocumentsAndEditors),$e(4,C.IExtHostConfiguration),$e(5,_.IExtHostTerminalService),$e(6,D.ILogService),$e(7,v.IExtHostApiDeprecationService)],y),e.WorkerExtHostTask=y,e.IExtHostTask=(0,s.createDecorator)("IExtHostTask")}),define(Ee[213],_e([0,1,16,74,29,77,21,10,17,24,9,11,2,231,128,81,47,90,212,40]),function(oe,e,c,F,w,I,t,R,S,C,A,_,n,h,s,l,d,D,v,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let g=class{constructor(b,a,E,P){this.configurationService=b,this.workspaceContextService=a,this.editorGroupsService=E,this.pathService=P}text(b,a,E={}){b=this.getContentPattern(b,E);const P=this.configurationService.getValue(),k=a&&a.some(L=>!this.configurationService.getValue({resource:L}).search.useRipgrep);return{...this.commonQuery(a?.map(d.toWorkspaceFolder),E),type:2,contentPattern:b,previewOptions:E.previewOptions,maxFileSize:E.maxFileSize,usePCRE2:P.search.usePCRE2||k||!1,beforeContext:E.beforeContext,afterContext:E.afterContext,userDisabledExcludesAndIgnoreFiles:E.disregardExcludeSettings&&E.disregardIgnoreFiles}}getContentPattern(b,a){const E=this.configurationService.getValue();b.isRegExp&&(b.pattern=b.pattern.replace(/\r?\n/g,"\\n"));const P={...b,wordSeparators:E.editor.wordSeparators};return this.isCaseSensitive(b,a)&&(P.isCaseSensitive=!0),this.isMultiline(b)&&(P.isMultiline=!0),P}file(b,a={}){return{...this.commonQuery(b,a),type:1,filePattern:a.filePattern?a.filePattern.trim():a.filePattern,exists:a.exists,sortByScore:a.sortByScore,cacheKey:a.cacheKey}}handleIncludeExclude(b,a){return b?(b=Array.isArray(b)?b.map(i):i(b),a?this.parseSearchPaths(b):{pattern:u(...Array.isArray(b)?b:[b])}):{}}commonQuery(b=[],a={}){const E=this.handleIncludeExclude(a.includePattern,a.expandPatterns),P=this.handleIncludeExclude(a.excludePattern,a.expandPatterns),k=b.length>1,B=(E.searchPaths&&E.searchPaths.length?E.searchPaths.map(x=>this.getFolderQueryForSearchPath(x,a,P)):b.map(x=>this.getFolderQueryForRoot(x,a,P,k))).filter(x=>!!x),L={_reason:a._reason,folderQueries:B,usingSearchPaths:!!(E.searchPaths&&E.searchPaths.length),extraFileResources:a.extraFileResources,excludePattern:P.pattern,includePattern:E.pattern,onlyOpenEditors:a.onlyOpenEditors,maxResults:a.maxResults};if(a.onlyOpenEditors){const N=c.coalesce(c.flatten(this.editorGroupsService.groups.map(H=>H.editors.map(q=>q.resource)))).filter(H=>(0,f.pathIncludedInQuery)(L,H.fsPath)),z=this.commonQueryFromFileList(N);return{...L,...z}}const y=a.extraFileResources&&a.extraFileResources.filter(x=>(0,f.pathIncludedInQuery)(L,x.fsPath));return L.extraFileResources=y&&y.length?y:void 0,L}commonQueryFromFileList(b){const a=[],E=new t.ResourceMap,P={};let k=!1;return b.forEach(B=>{if(B.scheme===R.Schemas.walkThrough)return;if((0,C.isAbsolutePath)(B)){const y=this.workspaceContextService.getWorkspaceFolder(B)?.uri??B.with({path:S.dirname(B.fsPath)});let x=E.get(y);x||(k=!0,x={folder:y,includePattern:{}},a.push(x),E.set(y,x));const N=S.relative(y.fsPath,B.fsPath);(0,_.assertIsDefined)(x.includePattern)[N.replace(/\\/g,"/")]=!0}else B.fsPath&&(k=!0,P[B.fsPath]=!0)}),{folderQueries:a,includePattern:P,usingSearchPaths:!0,excludePattern:k?void 0:{"**/*":!0}}}isCaseSensitive(b,a){if(a.isSmartCase){if(b.isRegExp){if(A.containsUppercaseCharacter(b.pattern,!0))return!0}else if(A.containsUppercaseCharacter(b.pattern))return!0}return!!b.isCaseSensitive}isMultiline(b){return b.isMultiline||b.isRegExp&&(0,h.isMultilineRegexSource)(b.pattern)||b.pattern.indexOf(`
`)>=0?!0:!!b.isMultiline}parseSearchPaths(b){const a=z=>S.isAbsolute(z)||/^\.\.?([\/\\]|$)/.test(z),P=(Array.isArray(b)?b:M(b)).map(z=>{const H=this.pathService.resolvedUserHome;return H?(0,I.untildify)(z,H.scheme===R.Schemas.file?H.fsPath:H.path):z}),k=F.groupBy(P,z=>a(z)?"searchPaths":"exprSegments"),B=(k.exprSegments||[]).map(z=>A.rtrim(z,"/")).map(z=>A.rtrim(z,"\\")).map(z=>(z[0]==="."&&(z="*"+z),r(z))),L={},y=this.expandSearchPathPatterns(k.searchPaths||[]);y&&y.length&&(L.searchPaths=y);const x=c.flatten(B),N=u(...x);return N&&(L.pattern=N),L}getExcludesForFolder(b,a){return a.disregardExcludeSettings?void 0:(0,f.getExcludes)(b,!a.disregardSearchExcludeSettings)}expandSearchPathPatterns(b){if(!b||!b.length)return[];const a=c.flatten(b.map(P=>{let{pathPortion:k,globPortion:B}=T(P);B&&(B=p(B));const L=this.expandOneSearchPath(k);return c.flatten(L.map(y=>this.resolveOneSearchPathPattern(y,B)))})),E=new Map;return a.forEach(P=>{const k=P.searchPath.toString(),B=E.get(k);B?P.pattern&&(B.pattern=B.pattern||{},B.pattern[P.pattern]=!0):E.set(k,{searchPath:P.searchPath,pattern:P.pattern?u(P.pattern):void 0})}),Array.from(E.values())}expandOneSearchPath(b){if(S.isAbsolute(b)){const a=this.workspaceContextService.getWorkspace().folders;return a[0]&&a[0].uri.scheme!==R.Schemas.file?[{searchPath:a[0].uri.with({path:b})}]:[{searchPath:n.URI.file(S.normalize(b))}]}if(this.workspaceContextService.getWorkbenchState()===2){const a=this.workspaceContextService.getWorkspace().folders[0].uri;if(b=i(b),b.startsWith("../")||b===".."){const P=S.posix.resolve(a.path,b);return[{searchPath:a.with({path:P})}]}const E=p(b);return[{searchPath:a,pattern:E}]}else{if(b==="./"||b===".\\")return[];{const a=b.replace(/^\.[\/\\]/,""),P=this.workspaceContextService.getWorkspace().folders.map(k=>{const B=a.match(new RegExp(`^${A.escapeRegExpCharacters(k.name)}(?:/(.*)|$)`));return B?{match:B,folder:k}:null}).filter(_.isDefined);if(P.length)return P.map(k=>{const B=k.match[1];return{searchPath:k.folder.uri,pattern:B&&p(B)}});{const k=b.match(/\.[\/\\](.+)[\/\\]?/),B=k?k[1]:b,L=s.localize(0,null,B);throw new Error(L)}}}}resolveOneSearchPathPattern(b,a){const E=b.pattern&&a?`${b.pattern}/${a}`:b.pattern||a,P=[{searchPath:b.searchPath,pattern:E}];return E&&!E.endsWith("**")&&P.push({searchPath:b.searchPath,pattern:E+"/**"}),P}getFolderQueryForSearchPath(b,a,E){const P=this.getFolderQueryForRoot((0,d.toWorkspaceFolder)(b.searchPath),a,E,!1);return P?{...P,includePattern:b.pattern}:null}getFolderQueryForRoot(b,a,E,P){let k;const B=n.URI.isUri(b)?b:b.uri;if(E.searchPaths){const z=E.searchPaths.filter(H=>(0,C.isEqual)(H.searchPath,B))[0];if(z&&!z.pattern)return null;z&&(k=z.pattern)}const L=this.configurationService.getValue({resource:B}),x={...this.getExcludesForFolder(L,a)||{},...k||{}},N=n.URI.isUri(b)?(0,C.basename)(b):b.name;return{folder:B,folderName:P?N:void 0,excludePattern:Object.keys(x).length>0?x:void 0,fileEncoding:L.files&&L.files.encoding,disregardIgnoreFiles:typeof a.disregardIgnoreFiles=="boolean"?a.disregardIgnoreFiles:!L.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof a.disregardGlobalIgnoreFiles=="boolean"?a.disregardGlobalIgnoreFiles:!L.search.useGlobalIgnoreFiles,ignoreSymlinks:typeof a.ignoreSymlinks=="boolean"?a.ignoreSymlinks:!L.search.followSymlinks}}};g=xe([$e(0,l.IConfigurationService),$e(1,d.IWorkspaceContextService),$e(2,D.IEditorGroupsService),$e(3,v.IPathService)],g),e.QueryBuilder=g;function T(o){const b=o.match(/[\*\{\}\(\)\[\]\?]/);if(b){const a=b.index,E=o.substr(0,a).match(/[/|\\][^/\\]*$/);if(E){let P=o.substr(0,E.index);return P.match(/[/\\]/)||(P+="/"),{pathPortion:P,globPortion:o.substr((E.index||0)+1)}}}return{pathPortion:o}}function u(...o){return o.length?o.reduce((b,a)=>(b[a]=!0,b),Object.create(null)):void 0}function M(o){return w.splitGlobAware(o,",").map(b=>b.trim()).filter(b=>!!b.length)}function r(o){return[`**/${o}/**`,`**/${o}`].map(a=>a.replace(/\*\*\/\*\*/g,"**"))}function i(o){return o.replace(/\\/g,"/")}function p(o){return i(o).replace(/^\.\//,"").replace(/\/+$/g,"")}function m(o,b){o=c.distinct(o,P=>P.toString());const a=[],E=b.getWorkspace();return o&&o.forEach(P=>{let k;if(b.getWorkbenchState()===2)k=(0,C.relativePath)(E.folders[0].uri,P),k&&k!=="."&&(k="./"+k);else{const B=b.getWorkspaceFolder(P);if(B){const L=B.name;if(E.folders.filter(x=>x.name===L).length===1){const x=(0,C.relativePath)(B.uri,P);x===""?k=`./${B.name}`:k=`./${B.name}/${x}`}else k=P.fsPath}}k&&a.push(k)}),a}e.resolveResourcesForSearchIncludes=m}),define(Ee[214],_e([0,1,24,2,20,15,4,213,40,47]),function(oe,e,c,F,w,I,t,R,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const A=7e3;function _(l,d){const D=d.activationEvents;if(!D)return Promise.resolve(void 0);const v=[],f=[];for(const i of D)if(/^workspaceContains:/.test(i)){const p=i.substr("workspaceContains:".length);p.indexOf("*")>=0||p.indexOf("?")>=0||l.forceUsingSearch?f.push(p):v.push(p)}if(v.length===0&&f.length===0)return Promise.resolve(void 0);let g;const T=new Promise((i,p)=>{g=i}),u=i=>g({activationEvent:i}),M=Promise.all(v.map(i=>n(l,i,u))).then(()=>{}),r=h(l,d.identifier,f,u);return Promise.all([M,r]).then(()=>{g(void 0)}),T}e.checkActivateWorkspaceContainsExtension=_;async function n(l,d,D){for(const v of l.folders)if(await l.exists(c.joinPath(F.URI.revive(v),d))){D(`workspaceContains:${d}`);return}}async function h(l,d,D,v){if(D.length===0)return Promise.resolve(void 0);const f=new w.CancellationTokenSource,g=l.checkExists(l.folders,D,f.token),T=setTimeout(async()=>{f.cancel(),l.logService.info(`Not activating extension '${d.value}': Timed out while searching for 'workspaceContains' pattern ${D.join(",")}`)},A);let u=!1;try{u=await g}catch(M){I.isPromiseCanceledError(M)||I.onUnexpectedError(M)}f.dispose(),clearTimeout(T),u&&v(`workspaceContains:${D.join(",")}`)}function s(l,d,D,v){const f=l.get(t.IInstantiationService),g=l.get(S.ISearchService),u=f.createInstance(R.QueryBuilder).file(d.map(M=>(0,C.toWorkspaceFolder)(F.URI.revive(M))),{_reason:"checkExists",includePattern:D,exists:!0});return g.fileSearch(u,v).then(M=>!!M.limitHit,M=>I.isPromiseCanceledError(M)?!1:Promise.reject(M))}e.checkGlobFileExists=s});var Ze=this&&this.__classPrivateFieldSet||function(oe,e,c,F,w){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?oe!==e||!w:!e.has(oe))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?w.call(oe,c):w?w.value=c:e.set(oe,c),c},Ae=this&&this.__classPrivateFieldGet||function(oe,e,c,F){if(c==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?oe!==e||!F:!e.has(oe))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?F:c==="a"?F.call(oe):F?F.value:e.get(oe)};define(Ee[33],_e([0,1,120,17,73,24,14,6,21,2,12,5,32,174,71,31,26,172,15,25,22,147,7,84,4,28,72,13,60,64,39,3,214,68,149,10]),function(oe,e,c,F,w,I,t,R,S,C,A,_,n,h,s,l,d,D,v,f,g,T,u,M,r,i,p,m,o,b,a,E,P,k,B,L){"use strict";var y,x,N;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,r.createDecorator)("IHostUtils");let z=class ji extends R.Disposable{constructor(K,ce,de,Q,ie,we,Me,Fe,Be,Ge){super();this._onDidChangeRemoteConnectionData=this._register(new E.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=ce,this._extHostContext=de,this._initData=Me,this._extHostWorkspace=Q,this._extHostConfiguration=ie,this._logService=we,this._extHostTunnelService=Be,this._extHostTerminalService=Ge,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(_.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(_.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(_.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new t.Barrier,this._readyToStartExtensionHost=new t.Barrier,this._readyToRunExtensions=new t.Barrier,this._eagerExtensionsActivated=new t.Barrier,this._registry=new D.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new s.ExtHostStorage(this._extHostContext),this._secretState=new k.ExtHostSecretState(this._extHostContext),this._storagePath=Fe,this._instaService=K.createChild(new o.ServiceCollection([s.IExtHostStorage,this._storage],[k.IExtHostSecretState,this._secretState]));const je=new Set;this._initData.hostExtensions.forEach(Qe=>je.add(f.ExtensionIdentifier.toKey(Qe))),this._activator=this._register(new h.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(Qe,$,G)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(Qe,v.transformErrorForSerialization($),G)},actualActivateExtension:async(Qe,$)=>{if(je.has(f.ExtensionIdentifier.toKey(Qe)))return await this._mainThreadExtensionsProxy.$activateExtension(Qe,$),new h.HostExtension;const G=this._registry.getExtensionDescription(Qe);return this._activateExtension(G,$)}},this._logService)),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),w.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(K){v.onUnexpectedError(K)}}async deactivateAll(){this._storagePath.onWillDeactivateAll();let K=[];try{K=this._registry.getAllExtensionDescriptions().map(ie=>ie.identifier).filter(ie=>this.isActivated(ie)).map(ie=>this._deactivate(ie))}catch(ce){}await Promise.all(K)}isActivated(K){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(K):!1}_activateByEvent(K,ce){return this._activator.activateByEvent(K,ce)}_activateById(K,ce){return this._activator.activateById(K,ce)}activateByIdWithErrors(K,ce){return this._activateById(K,ce).then(()=>{const de=this._activator.getActivatedExtension(K);if(de.activationFailed)return Promise.reject(de.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(K=>this._registry)}getExtensionExports(K){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(K).exports:null}async _realPathExtensionUri(K){if(K.scheme!==L.Schemas.file)return K;const ce=await this._hostUtils.realpath(K.fsPath);return C.URI.file(ce)}async getExtensionPathIndex(){return this._extensionPathIndex||(this._extensionPathIndex=(async()=>{const K=S.TernarySearchTree.forUris(ce=>I.extUriBiasedIgnorePathCase.ignorePathCasing(ce));for(const ce of this._registry.getAllExtensionDescriptions())if(this._getEntryPoint(ce)){const de=await this._realPathExtensionUri(ce.extensionLocation);K.set(de,ce)}return K})()),this._extensionPathIndex}_deactivate(K){let ce=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(K))return ce;const de=this._activator.getActivatedExtension(K);if(!de)return ce;try{typeof de.module.deactivate=="function"&&(ce=Promise.resolve(de.module.deactivate()).then(void 0,Q=>(this._logService.error(Q),Promise.resolve(void 0))))}catch(Q){this._logService.error(Q)}try{(0,R.dispose)(de.subscriptions)}catch(Q){this._logService.error(Q)}return ce}async _activateExtension(K,ce){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(K.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(K.identifier),this._doActivateExtension(K,ce).then(de=>{const Q=de.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(K.identifier,Q.codeLoadingTime,Q.activateCallTime,Q.activateResolvedTime,ce),this._logExtensionActivationTimes(K,ce,"success",Q),de},de=>{throw this._logExtensionActivationTimes(K,ce,"failure"),de})}_logExtensionActivationTimes(K,ce,de,Q){const ie=H(K,ce);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...ie,...Q||{},outcome:de})}_doActivateExtension(K,ce){const de=H(K,ce);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",de);const Q=this._getEntryPoint(K);if(!Q)return Promise.resolve(new h.EmptyExtension(h.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${K.identifier.value}, startup: ${ce.startup}, activationEvent: '${ce.activationEvent}'${K.identifier.value!==ce.extensionId.value?`, root cause: ${ce.extensionId.value}`:""}`),this._logService.flush();const ie=new h.ExtensionActivationTimesBuilder(ce.startup);return Promise.all([this._loadCommonJSModule(K.identifier,(0,I.joinPath)(K.extensionLocation,Q),ie),this._loadExtensionContext(K)]).then(we=>(w.mark(`code/extHost/willActivateExtension/${K.identifier.value}`),ji._callActivate(this._logService,K.identifier,we[0],we[1],ie))).then(we=>(w.mark(`code/extHost/didActivateExtension/${K.identifier.value}`),we))}_loadExtensionContext(K){const ce=new T.ExtensionGlobalMemento(K,this._storage),de=new T.ExtensionMemento(K.identifier.value,!1,this._storage),Q=new B.ExtensionSecrets(K,this._secretState),ie=K.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?u.ExtensionMode.Test:u.ExtensionMode.Development:u.ExtensionMode.Production,we=this._initData.remote.isRemote?u.ExtensionKind.Workspace:u.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${K.identifier.value}`),Promise.all([ce.whenReady,de.whenReady,this._storagePath.whenReady]).then(()=>{const Me=this;let Fe;return Object.freeze({globalState:ce,workspaceState:de,secrets:Q,subscriptions:[],get extensionUri(){return K.extensionLocation},get extensionPath(){return K.extensionLocation.fsPath},asAbsolutePath(Be){return F.join(K.extensionLocation.fsPath,Be)},get storagePath(){return Me._storagePath.workspaceValue(K)?.fsPath},get globalStoragePath(){return Me._storagePath.globalValue(K).fsPath},get logPath(){return F.join(Me._initData.logsLocation.fsPath,K.identifier.value)},get logUri(){return C.URI.joinPath(Me._initData.logsLocation,K.identifier.value)},get storageUri(){return Me._storagePath.workspaceValue(K)},get globalStorageUri(){return Me._storagePath.globalValue(K)},get extensionMode(){return ie},get extension(){return Fe===void 0&&(Fe=new q(Me,K.identifier,K,we)),Fe},get extensionRuntime(){return(0,d.checkProposedApiEnabled)(K,"extensionRuntime"),Me.extensionRuntime},get environmentVariableCollection(){return Me._extHostTerminalService.getEnvironmentVariableCollection(K)}})})}static _callActivate(K,ce,de,Q,ie){return de=de||{activate:void 0,deactivate:void 0},this._callActivateOptional(K,ce,de,Q,ie).then(we=>new h.ActivatedExtension(!1,null,ie.build(),de,we,Q.subscriptions))}static _callActivateOptional(K,ce,de,Q,ie){if(typeof de.activate=="function")try{ie.activateCallStart(),K.trace(`ExtensionService#_callActivateOptional ${ce.value}`);const we=typeof global=="object"?global:self,Me=de.activate.apply(we,[Q]);return ie.activateCallStop(),ie.activateResolveStart(),Promise.resolve(Me).then(Fe=>(ie.activateResolveStop(),Fe))}catch(we){return Promise.reject(we)}else return Promise.resolve(de)}_activateOneStartupFinished(K,ce){this._activateById(K.identifier,{startup:!1,extensionId:K.identifier,activationEvent:ce}).then(void 0,de=>{this._logService.error(de)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(w.getMarks());for(const K of this._registry.getAllExtensionDescriptions())if(K.activationEvents)for(const ce of K.activationEvents)ce==="onStartupFinished"&&this._activateOneStartupFinished(K,ce)}_handleEagerExtensions(){const K=this._activateByEvent("*",!0).then(void 0,ie=>{this._logService.error(ie)});this._register(this._extHostWorkspace.onDidChangeWorkspace(ie=>this._handleWorkspaceContainsEagerExtensions(ie.added)));const ce=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],de=this._handleWorkspaceContainsEagerExtensions(ce),Q=Promise.all([K,de]).then(()=>{});return Promise.race([Q,(0,t.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),Q}_handleWorkspaceContainsEagerExtensions(K){return K.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(ce=>this._handleWorkspaceContainsEagerExtension(K,ce))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(K,ce){if(this.isActivated(ce.identifier))return;const de=!this._initData.remote.isRemote&&!!this._initData.remote.authority,Q={logService:this._logService,folders:K.map(we=>we.uri),forceUsingSearch:de,exists:we=>this._hostUtils.exists(we.fsPath),checkExists:(we,Me,Fe)=>this._mainThreadWorkspaceProxy.$checkExists(we,Me,Fe)},ie=await(0,P.checkActivateWorkspaceContainsExtension)(Q,ce);if(!!ie)return this._activateById(ce.identifier,{startup:!0,extensionId:ce.identifier,activationEvent:ie.activationEvent}).then(void 0,we=>this._logService.error(we))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(K){throw console.error(K),K}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:K,extensionTestsLocationURI:ce}=this._initData.environment;if(!K||!ce)throw new Error(c.localize(0,null));const de=await this._loadCommonJSModule(null,ce,new h.ExtensionActivationTimesBuilder(!1));if(!de||typeof de.run!="function")throw new Error(c.localize(1,null,ce.toString()));return new Promise((Q,ie)=>{const we=(Be,Ge)=>{Be?ie(Be):Q(typeof Ge=="number"&&Ge>0?1:0)},Me=(0,I.originalFSPath)(ce),Fe=de.run(Me,we);Fe&&Fe.then&&Fe.then(()=>{Q(0)}).catch(Be=>{ie(Be.toString())})})}async $extensionTestsExit(K){this._logService.info(`Extension host terminating: test runner requested exit with code ${K}`),this._hostUtils.pid&&this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code ${K}`),this._logService.flush(),this._hostUtils.exit(K)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("Eager extensions activated")})}registerRemoteAuthorityResolver(K,ce){return this._resolvers[K]=ce,(0,R.toDisposable)(()=>{delete this._resolvers[K]})}async _activateAndGetResolver(K){const ce=K.indexOf("+");if(ce===-1)throw new Error("Not an authority that can be resolved!");const de=K.substr(0,ce);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${de}`,!1),{authorityPrefix:de,resolver:this._resolvers[de]}}async $resolveAuthority(K,ce){const{authorityPrefix:de,resolver:Q}=await this._activateAndGetResolver(K);if(!Q)return{type:"error",error:{code:M.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${de}.`,detail:void 0}};try{this._register(await this._extHostTunnelService.setTunnelExtensionFunctions(Q)),w.mark(`code/extHost/willResolveAuthority/${de}`);const ie=await Q.resolve(K,{resolveAttempt:ce});w.mark(`code/extHost/didResolveAuthorityOK/${de}`);const we={authority:K,host:ie.host,port:ie.port,connectionToken:ie.connectionToken},Me={extensionHostEnv:ie.extensionHostEnv,isTrusted:ie.isTrusted,authenticationSession:ie.authenticationSessionForInitializingExtensions?{id:ie.authenticationSessionForInitializingExtensions.id,providerId:ie.authenticationSessionForInitializingExtensions.providerId}:void 0};return{type:"ok",value:{authority:we,options:Me,tunnelInformation:{environmentTunnels:ie.environmentTunnels}}}}catch(ie){if(w.mark(`code/extHost/didResolveAuthorityError/${de}`),ie instanceof u.RemoteAuthorityResolverError)return{type:"error",error:{code:ie._code,message:ie._message,detail:ie._detail}};throw ie}}async $getCanonicalURI(K,ce){const{authorityPrefix:de,resolver:Q}=await this._activateAndGetResolver(K);if(!Q)throw new Error(`Cannot get canonical URI because no remote extension is installed to resolve ${de}`);const ie=C.URI.revive(ce);if(typeof Q.getCanonicalURI=="undefined")return ie;const we=await(0,t.asPromise)(()=>Q.getCanonicalURI(ie));return we||ie}$startExtensionHost(K){return this._registry.keepOnly(K),this._startExtensionHost()}$activateByEvent(K,ce){return ce===1?this._activateByEvent(K,!1):this._readyToRunExtensions.wait().then(de=>this._activateByEvent(K,!1))}async $activate(K,ce){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(K)?(await this._activateById(K,ce),!0):!1}async $deltaExtensions(K,ce){K.forEach(Q=>Q.extensionLocation=C.URI.revive(Q.extensionLocation));const de=await this.getExtensionPathIndex();return await Promise.all(ce.map(async Q=>{const ie=this._registry.getExtensionDescription(Q);ie&&de.delete(await this._realPathExtensionUri(ie.extensionLocation))})),await Promise.all(K.map(async Q=>{const ie=await this._realPathExtensionUri(Q.extensionLocation);de.set(ie,Q)})),this._registry.deltaExtensions(K,ce),Promise.resolve(void 0)}async $test_latency(K){return K}async $test_up(K){return K.byteLength}async $test_down(K){let ce=g.VSBuffer.alloc(K),de=Math.random()%256;for(let Q=0;Q<K;Q++)ce.writeUInt8(de,Q);return ce}async $updateRemoteConnectionData(K){this._remoteConnectionData=K,this._onDidChangeRemoteConnectionData.fire()}};z=xe([$e(0,r.IInstantiationService),$e(1,e.IHostUtils),$e(2,m.IExtHostRpcService),$e(3,l.IExtHostWorkspace),$e(4,n.IExtHostConfiguration),$e(5,A.ILogService),$e(6,i.IExtHostInitDataService),$e(7,p.IExtensionStoragePaths),$e(8,b.IExtHostTunnelService),$e(9,a.IExtHostTerminalService)],z),e.AbstractExtHostExtensionService=z;function H(ue,K){return{id:ue.identifier.value,name:ue.name,extensionVersion:ue.version,publisherDisplayName:ue.publisher,activationEvents:ue.activationEvents?ue.activationEvents.join(","):null,isBuiltin:ue.isBuiltin,reason:K.activationEvent,reasonId:K.extensionId.value}}e.IExtHostExtensionService=(0,r.createDecorator)("IExtHostExtensionService");class q{constructor(K,ce,de,Q){y.set(this,void 0),x.set(this,void 0),N.set(this,void 0),Ze(this,y,K,"f"),Ze(this,x,ce,"f"),Ze(this,N,de.identifier,"f"),this.id=de.identifier.value,this.extensionUri=de.extensionLocation,this.extensionPath=F.normalize((0,I.originalFSPath)(de.extensionLocation)),this.packageJSON=de,this.extensionKind=Q}get isActive(){return Ae(this,y,"f").isActivated(Ae(this,N,"f"))}get exports(){if(this.packageJSON.api!=="none")return Ae(this,y,"f").getExtensionExports(Ae(this,N,"f"))}activate(){return Ae(this,y,"f").activateByIdWithErrors(Ae(this,N,"f"),{startup:!1,extensionId:Ae(this,x,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=q,y=new WeakMap,x=new WeakMap,N=new WeakMap}),define(Ee[98],_e([0,1,17,2,3,14,5,7,156,31,33,49,163,32,157,13,4,11,89,70]),function(oe,e,c,F,w,I,t,R,S,C,A,_,n,h,s,l,d,D,v,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,d.createDecorator)("IExtHostDebugService");let g=class{constructor(o,b,a,E,P,k){this._workspaceService=b,this._extensionService=a,this._editorsService=E,this._configurationService=P,this._editorTabs=k,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new w.Emitter,this._onDidTerminateDebugSession=new w.Emitter,this._onDidChangeActiveDebugSession=new w.Emitter,this._onDidReceiveDebugSessionCustomEvent=new w.Emitter,this._debugServiceProxy=o.getProxy(t.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new w.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new u(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(B=>{B.onDidChange(L=>{this.registerAllDebugTypes(B)}),this.registerAllDebugTypes(B)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(o,b){const a=o;if(typeof a.sourceReference=="number"&&a.sourceReference>0){let E=`debug:${encodeURIComponent(a.path||"")}`,P="?";return b&&(E+=`${P}session=${encodeURIComponent(b.id)}`,P="&"),E+=`${P}ref=${a.sourceReference}`,F.URI.parse(E)}else{if(a.path)return F.URI.file(a.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(o){const b=[];for(const a of o.getAllExtensionDescriptions())if(a.contributes){const E=a.contributes.debuggers;if(E&&E.length>0)for(const P of E)(0,s.isDebuggerMainContribution)(P)&&b.push(P.type)}this._debugServiceProxy.$registerDebugTypes(b)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const o=[];return this._breakpoints.forEach(b=>o.push(b)),o}addBreakpoints(o){this.startBreakpoints();const b=o.filter(P=>{const k=P.id;return this._breakpoints.has(k)?!1:(this._breakpoints.set(k,P),!0)});this.fireBreakpointChanges(b,[],[]);const a=[],E=new Map;for(const P of b)if(P instanceof R.SourceBreakpoint){let k=E.get(P.location.uri.toString());k||(k={type:"sourceMulti",uri:P.location.uri,lines:[]},E.set(P.location.uri.toString(),k),a.push(k)),k.lines.push({id:P.id,enabled:P.enabled,condition:P.condition,hitCondition:P.hitCondition,logMessage:P.logMessage,line:P.location.range.start.line,character:P.location.range.start.character})}else P instanceof R.FunctionBreakpoint&&a.push({type:"function",id:P.id,enabled:P.enabled,hitCondition:P.hitCondition,logMessage:P.logMessage,condition:P.condition,functionName:P.functionName});return this._debugServiceProxy.$registerBreakpoints(a)}removeBreakpoints(o){this.startBreakpoints();const b=o.filter(k=>this._breakpoints.delete(k.id));this.fireBreakpointChanges([],b,[]);const a=b.filter(k=>k instanceof R.SourceBreakpoint).map(k=>k.id),E=b.filter(k=>k instanceof R.FunctionBreakpoint).map(k=>k.id),P=b.filter(k=>k instanceof R.DataBreakpoint).map(k=>k.id);return this._debugServiceProxy.$unregisterBreakpoints(a,E,P)}startDebugging(o,b,a){return this._debugServiceProxy.$startDebugging(o?o.uri:void 0,b,{parentSessionID:a.parentSession?a.parentSession.id:void 0,lifecycleManagedByParent:a.lifecycleManagedByParent,repl:a.consoleMode===R.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:a.noDebug,compact:a.compact,debugUI:a.debugUI,suppressSaveBeforeStart:a.suppressSaveBeforeStart})}stopDebugging(o){return this._debugServiceProxy.$stopDebugging(o?o.id:void 0)}registerDebugConfigurationProvider(o,b,a){if(!b)return new R.Disposable(()=>{});const E=this._configProviderHandleCounter++;return this._configProviders.push({type:o,handle:E,provider:b}),this._debugServiceProxy.$registerDebugConfigurationProvider(o,a,!!b.provideDebugConfigurations,!!b.resolveDebugConfiguration,!!b.resolveDebugConfigurationWithSubstitutedVariables,E),new R.Disposable(()=>{this._configProviders=this._configProviders.filter(P=>P.provider!==b),this._debugServiceProxy.$unregisterDebugConfigurationProvider(E)})}registerDebugAdapterDescriptorFactory(o,b,a){if(!a)return new R.Disposable(()=>{});if(!this.definesDebugType(o,b))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${b}' debugger.`);if(this.getAdapterDescriptorFactoryByType(b))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const E=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:b,handle:E,factory:a}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(b,E),new R.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(P=>P.factory!==a),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(E)})}registerDebugAdapterTrackerFactory(o,b){if(!b)return new R.Disposable(()=>{});const a=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:o,handle:a,factory:b}),new R.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(E=>E.factory!==b)})}async $runInTerminal(o,b){return Promise.resolve(void 0)}async $substituteVariables(o,b){if(!this._variableResolver){const[P,k]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(P||[],this._editorsService,k)}let a;const E=await this.getFolder(o);return E&&(a={uri:E.uri,name:E.name,index:E.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(a,b)}createDebugAdapter(o,b){if(o.type==="implementation")return new i(o.implementation)}createSignService(){}async $startDASession(o,b){const a=this,E=await this.getSession(b);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(E.type),E).then(P=>{if(!P)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${E.type}' (extension might have failed to activate)`);const k=this.convertToDto(P),B=this.createDebugAdapter(k,E);if(!B)throw new Error(`Couldn't create a debug adapter for type '${E.type}'.`);const L=B;return this._debugAdapters.set(o,L),this.getDebugAdapterTrackers(E).then(y=>(y&&this._debugAdaptersTrackers.set(o,y),L.onMessage(async x=>{if(x.type==="request"&&x.command==="handshake"){const N=x,z={type:"response",seq:0,command:N.command,request_seq:N.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const H=await this._signService.sign(N.arguments.value);z.body={signature:H},L.sendResponse(z)}else throw new Error("no signer")}catch(H){z.success=!1,z.message=H.message,L.sendResponse(z)}}else y&&y.onDidSendMessage&&y.onDidSendMessage(x),x=(0,s.convertToVSCPaths)(x,!0),a._debugServiceProxy.$acceptDAMessage(o,x)}),L.onError(x=>{y&&y.onError&&y.onError(x),this._debugServiceProxy.$acceptDAError(o,x.name,x.message,x.stack)}),L.onExit(x=>{y&&y.onExit&&y.onExit((0,D.withNullAsUndefined)(x),void 0),this._debugServiceProxy.$acceptDAExit(o,(0,D.withNullAsUndefined)(x),void 0)}),y&&y.onWillStartSession&&y.onWillStartSession(),L.startSession()))})}$sendDAMessage(o,b){b=(0,s.convertToDAPaths)(b,!1);const a=this._debugAdaptersTrackers.get(o);a&&a.onWillReceiveMessage&&a.onWillReceiveMessage(b);const E=this._debugAdapters.get(o);E&&E.sendMessage(b)}$stopDASession(o){const b=this._debugAdaptersTrackers.get(o);this._debugAdaptersTrackers.delete(o),b&&b.onWillStopSession&&b.onWillStopSession();const a=this._debugAdapters.get(o);return this._debugAdapters.delete(o),a?a.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(o){const b=[],a=[],E=[];if(o.added)for(const P of o.added){const k=P.id;if(k&&!this._breakpoints.has(k)){let B;if(P.type==="function")B=new R.FunctionBreakpoint(P.functionName,P.enabled,P.condition,P.hitCondition,P.logMessage);else if(P.type==="data")B=new R.DataBreakpoint(P.label,P.dataId,P.canPersist,P.enabled,P.hitCondition,P.condition,P.logMessage);else{const L=F.URI.revive(P.uri);B=new R.SourceBreakpoint(new R.Location(L,new R.Position(P.line,P.character)),P.enabled,P.condition,P.hitCondition,P.logMessage)}B._id=k,this._breakpoints.set(k,B),b.push(B)}}if(o.removed)for(const P of o.removed){const k=this._breakpoints.get(P);k&&(this._breakpoints.delete(P),a.push(k))}if(o.changed){for(const P of o.changed)if(P.id){const k=this._breakpoints.get(P.id);if(k){if(k instanceof R.FunctionBreakpoint&&P.type==="function"){const B=k;B.enabled=P.enabled,B.condition=P.condition,B.hitCondition=P.hitCondition,B.logMessage=P.logMessage,B.functionName=P.functionName}else if(k instanceof R.SourceBreakpoint&&P.type==="source"){const B=k;B.enabled=P.enabled,B.condition=P.condition,B.hitCondition=P.hitCondition,B.logMessage=P.logMessage,B.location=new R.Location(F.URI.revive(P.uri),new R.Position(P.line,P.character))}E.push(k)}}}this.fireBreakpointChanges(b,a,E)}$provideDebugConfigurations(o,b,a){return(0,I.asPromise)(async()=>{const E=this.getConfigProviderByHandle(o);if(!E)throw new Error("no DebugConfigurationProvider found");if(!E.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const P=await this.getFolder(b);return E.provideDebugConfigurations(P,a)}).then(E=>{if(!E)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return E})}$resolveDebugConfiguration(o,b,a,E){return(0,I.asPromise)(async()=>{const P=this.getConfigProviderByHandle(o);if(!P)throw new Error("no DebugConfigurationProvider found");if(!P.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const k=await this.getFolder(b);return P.resolveDebugConfiguration(k,a,E)})}$resolveDebugConfigurationWithSubstitutedVariables(o,b,a,E){return(0,I.asPromise)(async()=>{const P=this.getConfigProviderByHandle(o);if(!P)throw new Error("no DebugConfigurationProvider found");if(!P.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const k=await this.getFolder(b);return P.resolveDebugConfigurationWithSubstitutedVariables(k,a,E)})}async $provideDebugAdapter(o,b){const a=this.getAdapterDescriptorFactoryByHandle(o);if(!a)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const E=await this.getSession(b);return this.getAdapterDescriptor(a,E).then(P=>{if(!P)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${E.type}'`);return this.convertToDto(P)})}async $acceptDebugSessionStarted(o){const b=await this.getSession(o);this._onDidStartDebugSession.fire(b)}async $acceptDebugSessionTerminated(o){const b=await this.getSession(o);b&&(this._onDidTerminateDebugSession.fire(b),this._debugSessions.delete(b.id))}async $acceptDebugSessionActiveChanged(o){this._activeDebugSession=o?await this.getSession(o):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(o,b){const a=await this.getSession(o);a&&a._acceptNameChanged(b)}async $acceptDebugSessionCustomEvent(o,b){const E={session:await this.getSession(o),event:b.event,body:b.body};this._onDidReceiveDebugSessionCustomEvent.fire(E)}convertToDto(o){if(o instanceof R.DebugAdapterExecutable)return{type:"executable",command:o.command,args:o.args,options:o.options};if(o instanceof R.DebugAdapterServer)return{type:"server",port:o.port,host:o.host};if(o instanceof R.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:o.path};if(o instanceof R.DebugAdapterInlineImplementation)return{type:"implementation",implementation:o.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(o){const b=this._adapterFactories.filter(a=>a.type===o);if(b.length>0)return b[0].factory}getAdapterDescriptorFactoryByHandle(o){const b=this._adapterFactories.filter(a=>a.handle===o);if(b.length>0)return b[0].factory}getConfigProviderByHandle(o){const b=this._configProviders.filter(a=>a.handle===o);if(b.length>0)return b[0].provider}definesDebugType(o,b){if(o.contributes){const a=o.contributes.debuggers;if(a&&a.length>0){for(const E of a)if(E.label&&E.type&&E.type===b)return!0}}return!1}getDebugAdapterTrackers(o){const a=o.configuration.type,E=this._trackerFactories.filter(P=>P.type===a||P.type==="*").map(P=>(0,I.asPromise)(()=>P.factory.createDebugAdapterTracker(o)).then(k=>k,k=>null));return Promise.race([Promise.all(E).then(P=>{const k=P.filter(B=>!!B);if(k.length>0)return new r(k)}),new Promise((P,k)=>{const B=setTimeout(()=>{clearTimeout(B),k(new Error("timeout"))},1e3)})]).catch(P=>{})}async getAdapterDescriptor(o,b){const a=b.configuration.debugServer;if(typeof a=="number")return Promise.resolve(new R.DebugAdapterServer(a));if(o){const P=await this._extensionService.getExtensionRegistry();return(0,I.asPromise)(()=>o.createDebugAdapterDescriptor(b,this.daExecutableFromPackage(b,P))).then(k=>{if(k)return k})}const E=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(b,E))}daExecutableFromPackage(o,b){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(o,b,a){(o.length>0||b.length>0||a.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:o,removed:b,changed:a}))}async getSession(o){if(o)if(typeof o=="string"){const b=this._debugSessions.get(o);if(b)return b}else{let b=this._debugSessions.get(o.id);if(!b){const a=await this.getFolder(o.folderUri),E=o.parent?this._debugSessions.get(o.parent):void 0;b=new T(this._debugServiceProxy,o.id,o.type,o.name,a,o.configuration,E),this._debugSessions.set(b.id,b),this._debugServiceProxy.$sessionCached(b.id)}return b}throw new Error("cannot find session")}getFolder(o){if(o){const b=F.URI.revive(o);return this._workspaceService.resolveWorkspaceFolder(b)}return Promise.resolve(void 0)}};g=xe([$e(0,l.IExtHostRpcService),$e(1,C.IExtHostWorkspace),$e(2,A.IExtHostExtensionService),$e(3,_.IExtHostDocumentsAndEditors),$e(4,h.IExtHostConfiguration),$e(5,f.IExtHostEditorTabs)],g),e.ExtHostDebugServiceBase=g;class T{constructor(o,b,a,E,P,k,B){this._debugServiceProxy=o,this._id=b,this._type=a,this._name=E,this._workspaceFolder=P,this._configuration=k,this._parentSession=B}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(o){this._name=o,this._debugServiceProxy.$setDebugSessionName(this._id,o)}get parentSession(){return this._parentSession}_acceptNameChanged(o){this._name=o}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(o,b){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,o,b)}getDebugProtocolBreakpoint(o){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,o.id)}}e.ExtHostDebugSession=T;class u{constructor(o){this.value=Object.freeze({append(b){o.$appendDebugConsole(b)},appendLine(b){this.append(b+`
`)}})}}e.ExtHostDebugConsole=u;class M extends n.AbstractVariableResolverService{constructor(o,b,a,E,P){function k(){if(b){const B=b.activeEditor();if(B)return B.document.uri;const L=E.tabs.filter(y=>y.isActive);if(L.length>0){const y=L[0].resource;return y&&(y.primary||y.secondary)?y.primary??y.secondary:L[0].resource}}}super({getFolderUri:B=>{const L=o.filter(y=>y.name===B);if(L&&L.length>0)return L[0].uri},getWorkspaceFolderCount:()=>o.length,getConfigurationValue:(B,L)=>a.getConfiguration(void 0,B).get(L),getAppRoot:()=>v.cwd(),getExecPath:()=>v.env.VSCODE_EXEC_PATH,getFilePath:()=>{const B=k();if(B)return c.normalize(B.fsPath)},getWorkspaceFolderPathForFile:()=>{if(P){const B=k();if(B){const L=P.getWorkspaceFolder(B);if(L)return c.normalize(L.uri.fsPath)}}},getSelectedText:()=>{if(b){const B=b.activeEditor();if(B&&!B.selection.isEmpty)return B.document.getText(B.selection)}},getLineNumber:()=>{if(b){const B=b.activeEditor();if(B)return String(B.selection.end.line+1)}}},void 0,Promise.resolve(v.env))}}e.ExtHostVariableResolverService=M;class r{constructor(o){this.trackers=o}onWillStartSession(){this.trackers.forEach(o=>o.onWillStartSession?o.onWillStartSession():void 0)}onWillReceiveMessage(o){this.trackers.forEach(b=>b.onWillReceiveMessage?b.onWillReceiveMessage(o):void 0)}onDidSendMessage(o){this.trackers.forEach(b=>b.onDidSendMessage?b.onDidSendMessage(o):void 0)}onWillStopSession(){this.trackers.forEach(o=>o.onWillStopSession?o.onWillStopSession():void 0)}onError(o){this.trackers.forEach(b=>b.onError?b.onError(o):void 0)}onExit(o,b){this.trackers.forEach(a=>a.onExit?a.onExit(o,b):void 0)}}class i extends S.AbstractDebugAdapter{constructor(o){super();this.implementation=o,o.onDidSendMessage(b=>{this.acceptMessage(b)})}startSession(){return Promise.resolve(void 0)}sendMessage(o){this.implementation.handleMessage(o)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let p=class extends g{constructor(o,b,a,E,P,k){super(o,b,a,E,P,k)}createVariableResolver(o,b,a){return new M(o,b,a,this._editorTabs)}};p=xe([$e(0,l.IExtHostRpcService),$e(1,C.IExtHostWorkspace),$e(2,A.IExtHostExtensionService),$e(3,_.IExtHostDocumentsAndEditors),$e(4,h.IExtHostConfiguration),$e(5,f.IExtHostEditorTabs)],p),e.WorkerExtHostDebugService=p}),define(Ee[215],_e([0,1,73,2,5,32,26,25,13,28,4,33,89,12]),function(oe,e,c,F,w,I,t,R,S,C,A,_,n,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let s=class{constructor(f,g,T,u,M,r,i){this._apiFactory=f,this._extensionRegistry=g,this._instaService=T,this._extHostConfiguration=u,this._extHostExtensionService=M,this._initData=r,this._logService=i,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),c.mark("code/extHost/willWaitForConfig");const f=await this._extHostConfiguration.getConfigProvider();c.mark("code/extHost/didWaitForConfig");const g=await this._extHostExtensionService.getExtensionPathIndex();this.register(new l(this._apiFactory,g,this._extensionRegistry,f,this._logService)),this.register(this._instaService.createInstance(d,g)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(D,g,this._initData.environment.appUriScheme))}register(f){if(Array.isArray(f.nodeModuleName))for(let g of f.nodeModuleName)this._factories.set(g,f);else this._factories.set(f.nodeModuleName,f);typeof f.alternativeModuleName=="function"&&this._alternatives.push(g=>f.alternativeModuleName(g))}};s=xe([$e(2,A.IInstantiationService),$e(3,I.IExtHostConfiguration),$e(4,_.IExtHostExtensionService),$e(5,C.IExtHostInitDataService),$e(6,h.ILogService)],s),e.RequireInterceptor=s;class l{constructor(f,g,T,u,M){this._apiFactory=f,this._extensionPaths=g,this._extensionRegistry=T,this._configProvider=u,this._logService=M,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(f,g){const T=this._extensionPaths.findSubstr(g);if(T){let u=this._extApiImpl.get(R.ExtensionIdentifier.toKey(T.identifier));return u||(u=this._apiFactory(T,this._extensionRegistry,this._configProvider),this._extApiImpl.set(R.ExtensionIdentifier.toKey(T.identifier),u)),u}if(!this._defaultApiImpl){let u="";this._extensionPaths.forEach((M,r)=>u+=`	${r} -> ${M.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${g}. These are the extension path mappings: 
${u}`),this._defaultApiImpl=this._apiFactory(t.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let d=class{constructor(f,g,T){this._extensionPaths=f,this.nodeModuleName="keytar",this._mainThreadTelemetry=g.getProxy(w.MainContext.MainThreadTelemetry);const{environment:u}=T,M=g.getProxy(w.MainContext.MainThreadKeytar);if(u.appRoot){let r=u.appRoot.fsPath;n.platform==="win32"&&(r=r.replace(/\\/g,"/")),r[r.length-1]==="/"&&(r=r.substr(0,r.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${r}/node_modules.asar/keytar`),this.alternativeNames.add(`${r}/node_modules/keytar`)}this._impl={getPassword:(r,i)=>M.$getPassword(r,i),setPassword:(r,i,p)=>M.$setPassword(r,i,p),deletePassword:(r,i)=>M.$deletePassword(r,i),findPassword:r=>M.$findPassword(r),findCredentials(r){return M.$findCredentials(r)}}}load(f,g){const T=this._extensionPaths.findSubstr(g);return this._mainThreadTelemetry.$publicLog2("shimming.keytar",{extension:T?.identifier.value??"unknown_extension"}),this._impl}alternativeModuleName(f){const g=f.length;if(g<=7||!this.alternativeNames)return;const T=g-7;if((f.charAt(T)==="/"||f.charAt(T)==="\\")&&f.endsWith("keytar")&&(f=f.replace(/\\/g,"/"),this.alternativeNames.has(f)))return"keytar"}};d=xe([$e(1,S.IExtHostRpcService),$e(2,C.IExtHostInitDataService)],d);let D=class{constructor(f,g,T){this._extensionPaths=f,this._appUriScheme=g,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=T.getProxy(w.MainContext.MainThreadTelemetry);const u=T.getProxy(w.MainContext.MainThreadWindow);this._impl=(M,r)=>{const i=F.URI.parse(M);return r?this.callOriginal(M,r):i.scheme==="http"||i.scheme==="https"?u.$openUri(i,M,{allowTunneling:!0}):i.scheme==="mailto"||i.scheme===this._appUriScheme?u.$openUri(i,M,{}):this.callOriginal(M,r)}}load(f,g,T){const u=this._extensionPaths.findSubstr(g);return u&&(this._extensionId=u.identifier.value,this.sendShimmingTelemetry()),this._original=T(f),this._impl}callOriginal(f,g){return this.sendNoForwardTelemetry(),this._original(f,g)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};D=xe([$e(2,S.IExtHostRpcService)],D)}),define(Ee[216],_e([0,1,14,15,73,6,2,5,209,12,56,60,28,137,13,65,33,39]),function(oe,e,c,F,w,I,t,R,S,C,A,_,n,h,s,l,d,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class v{constructor(g,T,u,M){this._disposables=new I.DisposableStore,this._isTerminating=!1,this._hostUtils=u,this._rpcProtocol=new S.RPCProtocol(g,null,M),T=v._transform(T,this._rpcProtocol);const r=new _.ServiceCollection(...(0,A.getSingletonServiceDescriptors)());r.set(n.IExtHostInitDataService,{_serviceBrand:void 0,...T}),r.set(s.IExtHostRpcService,new s.ExtHostRpcService(this._rpcProtocol)),r.set(l.IURITransformerService,new l.URITransformerService(M)),r.set(d.IHostUtils,u);const i=new h.InstantiationService(r,!0);this._disposables.add(i.invokeFunction(b=>b.get(D.IExtHostTerminalService))),this._disposables.add(i.invokeFunction(b=>b.get(d.IExtHostExtensionService))),this._logService=i.invokeFunction(b=>b.get(C.ILogService)),w.mark("code/extHost/didCreateServices"),this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} started`):this._logService.info("Extension host started"),this._logService.trace("initData",T),this._extensionService=i.invokeFunction(b=>b.get(d.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const p=new WeakMap;this._extensionService.getExtensionPathIndex().then(b=>{Error.prepareStackTrace=(a,E)=>{let P="",k,B;for(const L of E)P+=`
	at ${L.toString()}`,B=L.getFileName(),!k&&B&&(k=b.findSubstr(t.URI.file(B)));return p.set(a,k),`${a.name||"Error"}: ${a.message||""}${P}`}});const m=this._rpcProtocol.getProxy(R.MainContext.MainThreadExtensionService),o=this._rpcProtocol.getProxy(R.MainContext.MainThreadErrors);F.setUnexpectedErrorHandler(b=>{const a=F.transformErrorForSerialization(b),E=p.get(b);E?m.$onExtensionRuntimeError(E.identifier,a):o.$onUnexpectedError(a)})}terminate(g){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`extension host terminating: ${g}`),this._logService.flush(),this._disposables.dispose(),F.setUnexpectedErrorHandler(u=>{this._logService.error(u)}),this._rpcProtocol.dispose();const T=this._extensionService.deactivateAll();Promise.race([(0,c.timeout)(5e3),T]).finally(()=>{this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code 0`):this._logService.info("Extension host exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})}static _transform(g,T){g.extensions.forEach(M=>M.extensionLocation=t.URI.revive(T.transformIncomingURIs(M.extensionLocation))),g.environment.appRoot=t.URI.revive(T.transformIncomingURIs(g.environment.appRoot));const u=g.environment.extensionDevelopmentLocationURI;return u&&(g.environment.extensionDevelopmentLocationURI=u.map(M=>t.URI.revive(T.transformIncomingURIs(M)))),g.environment.extensionTestsLocationURI=t.URI.revive(T.transformIncomingURIs(g.environment.extensionTestsLocationURI)),g.environment.globalStorageHome=t.URI.revive(T.transformIncomingURIs(g.environment.globalStorageHome)),g.environment.workspaceStorageHome=t.URI.revive(T.transformIncomingURIs(g.environment.workspaceStorageHome)),g.logsLocation=t.URI.revive(T.transformIncomingURIs(g.logsLocation)),g.logFile=t.URI.revive(T.transformIncomingURIs(g.logFile)),g.workspace=T.transformIncomingURIs(g.workspace),g}}e.ExtensionHostMain=v}),define(Ee[217],_e([0,1,17,20,44,29,24,190,40]),function(oe,e,c,F,w,I,t,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class C{constructor(n,h,s){this.config=n,this.provider=h,this.sessionToken=s,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=n.filePattern,this.includePattern=n.includePattern&&I.parse(n.includePattern),this.maxResults=n.maxResults||void 0,this.exists=n.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=n.excludePattern&&I.parse(n.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(n=>n.cancel()),this.activeCancellationTokens=new Set}search(n){const h=this.config.folderQueries||[];return new Promise((s,l)=>{const d=D=>{this.resultCount++,n(D)};if(this.isCanceled)return s({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(D=>{const v=D.toString(),f=c.basename(v);this.globalExcludePattern&&this.globalExcludePattern(v,f)||this.matchFile(d,{base:D,basename:f})}),Promise.all(h.map(D=>this.searchInFolder(D,d))).then(D=>{s({limitHit:this.isLimitHit,stats:D[0]||void 0})},D=>{l(new Error((0,w.toErrorMessage)(D)))})})}async searchInFolder(n,h){const s=new F.CancellationTokenSource,l=this.getSearchOptionsForFolder(n),d=this.initDirectoryTree(),D=new S.QueryGlobTester(this.config,n),v=!D.hasSiblingExcludeClauses();let f;try{this.activeCancellationTokens.add(s),f=R.StopWatch.create();const g=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},l,s.token),T=f.elapsed(),u=R.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(g&&g.forEach(M=>{const r=c.posix.relative(n.folder.path,M.path);if(v){const i=c.basename(M.path);this.matchFile(h,{base:n.folder,relativePath:r,basename:i});return}this.addDirectoryEntries(d,n.folder,r,h)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(d,D,h),{providerTime:T,postProcessTime:u.elapsed()})}finally{s.dispose(),this.activeCancellationTokens.delete(s)}}getSearchOptionsForFolder(n){const h=(0,S.resolvePatternsForProvider)(this.config.includePattern,n.includePattern),s=(0,S.resolvePatternsForProvider)(this.config.excludePattern,n.excludePattern);return{folder:n.folder,excludes:s,includes:h,useIgnoreFiles:!n.disregardIgnoreFiles,useGlobalIgnoreFiles:!n.disregardGlobalIgnoreFiles,followSymlinks:!n.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const n={rootEntries:[],pathToEntries:Object.create(null)};return n.pathToEntries["."]=n.rootEntries,n}addDirectoryEntries({pathToEntries:n},h,s,l){if(s===this.filePattern){const D=c.basename(this.filePattern);this.matchFile(l,{base:h,relativePath:this.filePattern,basename:D})}function d(D){const v=c.basename(D),f=c.dirname(D);let g=n[f];g||(g=n[f]=[],d(f)),g.push({base:h,relativePath:D,basename:v})}d(s)}matchDirectoryTree({rootEntries:n,pathToEntries:h},s,l){const d=this,D=this.filePattern;function v(f){const g=I.hasSiblingFn(()=>f.map(T=>T.basename));for(let T=0,u=f.length;T<u;T++){const M=f[T],{relativePath:r,basename:i}=M;if(s.matchesExcludesSync(r,i,D!==i?g:void 0))continue;const p=h[r];if(p)v(p);else{if(r===D)continue;d.matchFile(l,M)}if(d.isLimitHit)break}}v(n)}matchFile(n,h){(!this.includePattern||h.relativePath&&this.includePattern(h.relativePath,h.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||n(h))}}class A{constructor(){this.sessions=new Map}fileSearch(n,h,s,l){const d=this.getSessionTokenSource(n.cacheKey),D=new C(n,h,d&&d.token);let v=0;const f=g=>{v+=g.length,s(g.map(T=>this.rawMatchToSearchItem(T)))};return this.doSearch(D,A.BATCH_SIZE,f,l).then(g=>({limitHit:g.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:v,detailStats:g.stats}}))}clearCache(n){const h=this.getSessionTokenSource(n);h&&h.cancel()}getSessionTokenSource(n){if(!!n)return this.sessions.has(n)||this.sessions.set(n,new F.CancellationTokenSource),this.sessions.get(n)}rawMatchToSearchItem(n){return n.relativePath?{resource:t.joinPath(n.base,n.relativePath)}:{resource:n.base}}doSearch(n,h,s,l){l.onCancellationRequested(()=>{n.cancel()});const d=v=>{v&&(D.push(v),h>0&&D.length>=h&&(s(D),D=[]))};let D=[];return n.search(d).then(v=>(D.length&&s(D),v),v=>(D.length&&s(D),Promise.reject(v)))}}e.FileSearchManager=A,A.BATCH_SIZE=512}),define(Ee[218],_e([0,1,16,20,44,29,10,17,24,11,2,40]),function(oe,e,c,F,w,I,t,R,S,C,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class n{constructor(f,g,T,u){this.query=f,this.provider=g,this.fileUtils=T,this.processType=u,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(f,g){const T=this.query.folderQueries||[],u=new F.CancellationTokenSource;return g.onCancellationRequested(()=>u.cancel()),new Promise((M,r)=>{this.collector=new s(f);let i=!1;const p=(m,o)=>{if(!i&&!this.isLimitHit){const b=this.resultSize(m);d(m)&&typeof this.query.maxResults=="number"&&this.resultCount+b>this.query.maxResults&&(this.isLimitHit=!0,i=!0,u.cancel(),m=this.trimResultToSize(m,this.query.maxResults-this.resultCount));const a=this.resultSize(m);this.resultCount+=a,(a>0||!d(m))&&this.collector.add(m,o)}};Promise.all(T.map((m,o)=>this.searchInFolder(m,b=>p(b,o),u.token))).then(m=>{u.dispose(),this.collector.flush();const o=m.some(b=>!!b&&!!b.limitHit);M({limitHit:this.isLimitHit||o,messages:(0,c.flatten)(m.map(b=>b?.message?(0,C.isArray)(b.message)?b.message:[b.message]:[])),stats:{type:this.processType}})},m=>{u.dispose();const o=(0,w.toErrorMessage)(m);r(new Error(o))})})}resultSize(f){return d(f)?Array.isArray(f.ranges)?f.ranges.length:1:0}trimResultToSize(f,g){const T=Array.isArray(f.ranges)?f.ranges:[f.ranges],u=Array.isArray(f.preview.matches)?f.preview.matches:[f.preview.matches];return{ranges:T.slice(0,g),preview:{matches:u.slice(0,g),text:f.preview.text},uri:f.uri}}async searchInFolder(f,g,T){const u=new _.QueryGlobTester(this.query,f),M=[],r={report:m=>{if(!this.validateProviderResult(m))return;const o=f.folder.scheme===t.Schemas.file?I.hasSiblingPromiseFn(()=>this.fileUtils.readdir(S.dirname(m.uri))):void 0,b=S.relativePath(f.folder,m.uri);if(b){const a=u.includedInQuery(b,R.basename(b),o);(0,C.isPromise)(a)?M.push(a.then(E=>{E&&g(m)})):a&&g(m)}}},i=this.getSearchOptionsForFolder(f),p=await this.provider.provideTextSearchResults(h(this.query.contentPattern),i,r,T);return M.length&&await Promise.all(M),p}validateProviderResult(f){if(d(f)){if(Array.isArray(f.ranges)){if(!Array.isArray(f.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(f.preview.matches.length!==f.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(f.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(f){const g=(0,_.resolvePatternsForProvider)(this.query.includePattern,f.includePattern),T=(0,_.resolvePatternsForProvider)(this.query.excludePattern,f.excludePattern),u={folder:A.URI.from(f.folder),excludes:T,includes:g,useIgnoreFiles:!f.disregardIgnoreFiles,useGlobalIgnoreFiles:!f.disregardGlobalIgnoreFiles,followSymlinks:!f.ignoreSymlinks,encoding:f.fileEncoding&&this.fileUtils.toCanonicalName(f.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return u.usePCRE2=this.query.usePCRE2,u}}e.TextSearchManager=n;function h(v){return{isCaseSensitive:v.isCaseSensitive||!1,isRegExp:v.isRegExp||!1,isWordMatch:v.isWordMatch||!1,isMultiline:v.isMultiline||!1,pattern:v.pattern}}class s{constructor(f){this._onResult=f,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new D(512,g=>this.sendItems(g))}add(f,g){this._currentFileMatch&&(this._currentFolderIdx!==g||!S.isEqual(this._currentUri,f.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=g,this._currentFileMatch={resource:f.uri,results:[]}),this._currentFileMatch.results.push(l(f))}pushToCollector(){const f=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,f)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(f){this._onResult(f)}}e.TextSearchResultsCollector=s;function l(v){return d(v)?{preview:{matches:(0,c.mapArrayOrNot)(v.preview.matches,f=>({startLineNumber:f.start.line,startColumn:f.start.character,endLineNumber:f.end.line,endColumn:f.end.character})),text:v.preview.text},ranges:(0,c.mapArrayOrNot)(v.ranges,f=>({startLineNumber:f.start.line,startColumn:f.start.character,endLineNumber:f.end.line,endColumn:f.end.character}))}:{text:v.text,lineNumber:v.lineNumber}}function d(v){return!!v.preview}e.extensionResultIsMatch=d;class D{constructor(f,g){this.maxBatchSize=f,this.cb=g,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(f,g){!f||this.addItemToBatch(f,g)}addItems(f,g){!f||this.addItemsToBatch(f,g)}addItemToBatch(f,g){this.batch.push(f),this.batchSize+=g,this.onUpdate()}addItemsToBatch(f,g){this.batch=this.batch.concat(f),this.batchSize+=g,this.onUpdate()}onUpdate(){this.totalNumberCompleted<D.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},D.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=D,D.TIMEOUT=4e3,D.START_BATCH_AFTER_COUNT=50}),define(Ee[99],_e([0,1,6,5,4,217,13,65,12,2,218]),function(oe,e,c,F,w,I,t,R,S,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,w.createDecorator)("IExtHostSearch");let _=class{constructor(l,d,D){this.extHostRpc=l,this._uriTransformer=d,this._logService=D,this._proxy=this.extHostRpc.getProxy(F.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new I.FileSearchManager}_transformScheme(l){return this._uriTransformer.transformOutgoingScheme(l)}registerTextSearchProvider(l,d){if(this._textSearchUsedSchemes.has(l))throw new Error(`a text search provider for the scheme '${l}' is already registered`);this._textSearchUsedSchemes.add(l);const D=this._handlePool++;return this._textSearchProvider.set(D,d),this._proxy.$registerTextSearchProvider(D,this._transformScheme(l)),(0,c.toDisposable)(()=>{this._textSearchUsedSchemes.delete(l),this._textSearchProvider.delete(D),this._proxy.$unregisterProvider(D)})}registerFileSearchProvider(l,d){if(this._fileSearchUsedSchemes.has(l))throw new Error(`a file search provider for the scheme '${l}' is already registered`);this._fileSearchUsedSchemes.add(l);const D=this._handlePool++;return this._fileSearchProvider.set(D,d),this._proxy.$registerFileSearchProvider(D,this._transformScheme(l)),(0,c.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(l),this._fileSearchProvider.delete(D),this._proxy.$unregisterProvider(D)})}$provideFileSearchResults(l,d,D,v){const f=n(D),g=this._fileSearchProvider.get(l);if(g)return this._fileSearchManager.fileSearch(f,g,T=>{this._proxy.$handleFileMatch(l,d,T.map(u=>u.resource))},v);throw new Error("unknown provider: "+l)}$clearCache(l){return this._fileSearchManager.clearCache(l),Promise.resolve(void 0)}$provideTextSearchResults(l,d,D,v){const f=this._textSearchProvider.get(l);if(!f||!f.provideTextSearchResults)throw new Error(`Unknown provider ${l}`);const g=n(D);return this.createTextSearchManager(g,f).search(u=>this._proxy.$handleTextMatch(l,d,u),v)}$enableExtensionHostSearch(){}createTextSearchManager(l,d){return new A.TextSearchManager(l,d,{readdir:D=>Promise.resolve([]),toCanonicalName:D=>D},"textSearchProvider")}};_=xe([$e(0,t.IExtHostRpcService),$e(1,R.IURITransformerService),$e(2,S.ILogService)],_),e.ExtHostSearch=_;function n(s){return{...s,folderQueries:s.folderQueries&&s.folderQueries.map(h),extraFileResources:s.extraFileResources&&s.extraFileResources.map(l=>C.URI.revive(l))}}e.reviveQuery=n;function h(s){return{...s,folder:C.URI.revive(s.folder)}}}),define(Ee[219],_e([0,1,20,15,3,34,2,113,232,107,55,46,5,180,179,38,181,32,182,183,184,165,185,49,33,186,166,189,191,193,94,168,198,199,200,71,39,202,169,8,7,205,51,95,31,74,154,188,61,93,97,98,99,12,65,13,28,194,151,64,69,177,203,150,72,50,208,206,207,178,30,201,204,68,70,85,196,96,197,10,139,195,148,187,6,26]),function(oe,e,c,F,w,I,t,R,S,C,A,_,n,h,s,l,d,D,v,f,g,T,u,M,r,i,p,m,o,b,a,E,P,k,B,L,y,x,N,z,H,q,ue,K,ce,de,Q,ie,we,Me,Fe,Be,Ge,je,Qe,$,G,X,se,j,Z,fe,Te,Ne,He,Ke,tt,st,Xe,rt,De,gt,V,J,pe,Ue,Ye,Je,lt,Et,It,et,Tt,Pe,Se,ve){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function re(ae){const he=ae.get(G.IExtHostInitDataService),me=ae.get(De.IExtHostFileSystemInfo),Ie=ae.get(Ke.IExtHostConsumerFileSystem),ze=ae.get(r.IExtHostExtensionService),Oe=ae.get(ce.IExtHostWorkspace),We=ae.get(Ue.IExtHostTelemetry),it=ae.get(D.IExtHostConfiguration),ot=ae.get(Qe.IURITransformerService),ne=ae.get($.IExtHostRpcService),ge=ae.get(L.IExtHostStorage),te=ae.get(He.IExtensionStoragePaths),W=ae.get(je.ILoggerService),be=ae.get(je.ILogService),ke=ae.get(j.IExtHostTunnelService),qe=ae.get(Z.IExtHostApiDeprecationService),Le=ae.get(K.IExtHostWindow),dt=ae.get(J.IExtHostSecretState),bt=ae.get(pe.IExtHostEditorTabs);ne.set(n.ExtHostContext.ExtHostFileSystemInfo,me),ne.set(n.ExtHostContext.ExtHostLogLevelServiceShape,W),ne.set(n.ExtHostContext.ExtHostWorkspace,Oe),ne.set(n.ExtHostContext.ExtHostConfiguration,it),ne.set(n.ExtHostContext.ExtHostExtensionService,ze),ne.set(n.ExtHostContext.ExtHostStorage,ge),ne.set(n.ExtHostContext.ExtHostTunnelService,ke),ne.set(n.ExtHostContext.ExtHostWindow,Le),ne.set(n.ExtHostContext.ExtHostSecretState,dt),ne.set(n.ExtHostContext.ExtHostTelemetry,We),ne.set(n.ExtHostContext.ExtHostEditorTabs,bt);const Ct=ne.set(n.ExtHostContext.ExtHostDecorations,ae.get(Me.IExtHostDecorations)),pt=ne.set(n.ExtHostContext.ExtHostDocumentsAndEditors,ae.get(M.IExtHostDocumentsAndEditors)),ht=ne.set(n.ExtHostContext.ExtHostCommands,ae.get(l.IExtHostCommands)),vt=ne.set(n.ExtHostContext.ExtHostTerminalService,ae.get(y.IExtHostTerminalService)),_t=ne.set(n.ExtHostContext.ExtHostDebugService,ae.get(Be.IExtHostDebugService)),Ft=ne.set(n.ExtHostContext.ExtHostSearch,ae.get(Ge.IExtHostSearch)),yt=ne.set(n.ExtHostContext.ExtHostTask,ae.get(Fe.IExtHostTask)),At=ne.set(n.ExtHostContext.ExtHostOutputService,ae.get(a.IExtHostOutputService)),Ut=ne.set(n.ExtHostContext.ExtHostUrls,new q.ExtHostUrls(ne)),Pt=ne.set(n.ExtHostContext.ExtHostDocuments,new u.ExtHostDocuments(ne,pt)),Bt=ne.set(n.ExtHostContext.ExtHostDocumentContentProviders,new g.ExtHostDocumentContentProvider(ne,pt,be)),zt=ne.set(n.ExtHostContext.ExtHostDocumentSaveParticipant,new T.ExtHostDocumentSaveParticipant(be,Pt,ne.getProxy(n.MainContext.MainThreadBulkEdits))),wt=ne.set(n.ExtHostContext.ExtHostNotebook,new X.ExtHostNotebookController(ne,ht,pt,Pt,te)),Qt=ne.set(n.ExtHostContext.ExtHostNotebookDocuments,new Tt.ExtHostNotebookDocuments(be,wt)),Vt=ne.set(n.ExtHostContext.ExtHostNotebookEditors,new et.ExtHostNotebookEditors(be,ne,wt)),oi=ne.set(n.ExtHostContext.ExtHostNotebookKernels,new Ye.ExtHostNotebookKernels(ne,he,wt,ht,be)),si=ne.set(n.ExtHostContext.ExtHostNotebookRenderers,new lt.ExtHostNotebookRenderers(ne,wt)),Rt=ne.set(n.ExtHostContext.ExtHostEditors,new x.ExtHostEditors(ne,pt)),Yt=ne.set(n.ExtHostContext.ExtHostTreeViews,new N.ExtHostTreeViews(ne.getProxy(n.MainContext.MainThreadTreeViews),ht,be)),ai=ne.set(n.ExtHostContext.ExtHostEditorInsets,new Q.ExtHostEditorInsets(ne.getProxy(n.MainContext.MainThreadEditorInsets),Rt,he)),Xt=ne.set(n.ExtHostContext.ExtHostDiagnostics,new v.ExtHostDiagnostics(ne,be,me)),Wt=ne.set(n.ExtHostContext.ExtHostLanguages,new o.ExtHostLanguages(ne,Pt,ht.converter,ot)),mt=ne.set(n.ExtHostContext.ExtHostLanguageFeatures,new m.ExtHostLanguageFeatures(ne,ot,Pt,ht,Xt,be,qe)),ci=ne.set(n.ExtHostContext.ExtHostFileSystem,new i.ExtHostFileSystem(ne,mt)),Ot=ne.set(n.ExtHostContext.ExtHostFileSystemEventService,new p.ExtHostFileSystemEventService(ne,be,pt)),jt=ne.set(n.ExtHostContext.ExtHostQuickOpen,(0,P.createExtHostQuickOpen)(ne,Oe,ht)),Jt=ne.set(n.ExtHostContext.ExtHostSCM,new k.ExtHostSCM(ne,ht,be)),li=ne.set(n.ExtHostContext.ExtHostComments,(0,d.createExtHostComments)(ne,ht,Pt)),fi=ne.set(n.ExtHostContext.ExtHostProgress,new E.ExtHostProgress(ne.getProxy(n.MainContext.MainThreadProgress))),Ei=ne.set(n.ExtHostContext.ExtHosLabelService,new ie.ExtHostLabelService(ne)),mi=ne.set(n.ExtHostContext.ExtHostTheming,new se.ExtHostTheming(ne)),Zt=ne.set(n.ExtHostContext.ExtHostAuthentication,new fe.ExtHostAuthentication(ne)),_i=ne.set(n.ExtHostContext.ExtHostTimeline,new Te.ExtHostTimeline(ne,ht)),qt=ne.set(n.ExtHostContext.ExtHostWebviews,new ue.ExtHostWebviews(ne,{remote:he.remote},Oe,be,qe)),Gt=ne.set(n.ExtHostContext.ExtHostWebviewPanels,new Xe.ExtHostWebviewPanels(ne,qt,Oe)),yi=ne.set(n.ExtHostContext.ExtHostCustomEditors,new st.ExtHostCustomEditors(ne,Pt,te,qt,Gt)),Si=ne.set(n.ExtHostContext.ExtHostWebviewViews,new tt.ExtHostWebviewViews(ne,qt)),Kt=ne.set(n.ExtHostContext.ExtHostTesting,new gt.ExtHostTesting(ne,ht)),Ci=ne.set(n.ExtHostContext.ExtHostUriOpeners,new V.ExtHostUriOpeners(ne));ne.set(n.ExtHostContext.ExtHostInteractive,new Pe.ExtHostInteractive(ne,wt,pt,ht));const ei=(0,de.values)(n.ExtHostContext);ne.assertRegistered(ei);const Di=new rt.ExtHostBulkEdits(ne,pt),ki=new s.ExtHostClipboard(ne),ui=new b.ExtHostMessageService(ne,be),ti=new f.ExtHostDialogs(ne),gi=new B.ExtHostStatusBar(ne,ht.converter);return h.ExtHostApiCommands.register(ht),function(Re,Lt,pi){const ft=function(){let Y=!Re.isUnderDevelopment;function le(){Y||(be.info(`Extension '${Re.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),Y=!0)}return function Ce(ct){if(Array.isArray(ct))ct.forEach(Ce);else if(typeof ct=="string")le();else{const St=ct;typeof St.scheme=="undefined"&&le(),typeof St.exclusive=="boolean"&&(0,ve.checkProposedApiEnabled)(Re,"documentFiltersExclusive")}return ct}}(),ii={getSession(Y,le,Ce){return Zt.getSession(Re,Y,le,Ce)},async hasSession(Y,le){return(0,ve.checkProposedApiEnabled)(Re,"authSession"),!!await Zt.getSession(Re,Y,le,{silent:!0})},get onDidChangeSessions(){return Zt.onDidChangeSessions},registerAuthenticationProvider(Y,le,Ce,ct){return Zt.registerAuthenticationProvider(Y,le,Ce,ct)}},Ii={registerCommand(Y,le,Ce){return ht.registerCommand(!0,Y,le,Ce,void 0,Re)},registerTextEditorCommand(Y,le,Ce){return ht.registerCommand(!0,Y,(...ct)=>{const St=Rt.getActiveTextEditor();if(!St){be.warn("Cannot execute "+Y+" because there is no active text editor.");return}return St.edit(Dt=>{le.apply(Ce,[St,Dt,...ct])}).then(Dt=>{Dt||be.warn("Edits from command "+Y+" were not applied.")},Dt=>{be.warn("An error occurred while running command "+Y,Dt)})},void 0,void 0,Re)},registerDiffInformationCommand:(Y,le,Ce)=>((0,ve.checkProposedApiEnabled)(Re,"diffCommand"),ht.registerCommand(!0,Y,async(...ct)=>{const St=pt.activeEditor(!0);if(!St){be.warn("Cannot execute "+Y+" because there is no active text editor.");return}const Dt=await Rt.getDiffInformation(St.id);le.apply(Ce,[Dt,...ct])},void 0,void 0,Re)),executeCommand(Y,...le){return ht.executeCommand(Y,...le)},getCommands(Y=!1){return ht.getCommands(Y)}},vi={get machineId(){return he.telemetryInfo.machineId},get sessionId(){return he.telemetryInfo.sessionId},get language(){return he.environment.appLanguage},get appName(){return he.environment.appName},get appRoot(){return he.environment.appRoot?.fsPath??""},get appHost(){return he.environment.appHost},get uriScheme(){return he.environment.appUriScheme},get clipboard(){return ki.value},get shell(){return vt.getDefaultShell(!1)},get isTelemetryEnabled(){return We.getTelemetryEnabled()},get onDidChangeTelemetryEnabled(){return We.onDidChangeTelemetryEnabled},get isNewAppInstall(){const Y=Date.now()-new Date(he.telemetryInfo.firstSessionDate).getTime();return isNaN(Y)?!1:Y<1e3*60*60*24},openExternal(Y,le){return Le.openUri(Y,{allowTunneling:!!he.remote.authority,allowContributedOpeners:le?.allowContributedOpeners})},async asExternalUri(Y){if(Y.scheme===he.environment.appUriScheme)return Ut.createAppUri(Y);try{return await Le.asExternalUri(Y,{allowTunneling:!!he.remote.authority})}catch(le){if((0,It.matchesScheme)(Y,Et.Schemas.http)||(0,It.matchesScheme)(Y,Et.Schemas.https))return Y;throw le}},get remoteName(){return(0,we.getRemoteName)(he.remote.authority)},get remoteAuthority(){return(0,ve.checkProposedApiEnabled)(Re,"resolvers"),he.remote.authority},get uiKind(){return he.uiKind}};he.environment.extensionTestsLocationURI||Object.freeze(vi);const bi=he.remote.isRemote?H.ExtensionKind.Workspace:H.ExtensionKind.UI,Pi={createTestController(Y,le){return Kt.createTestController(Y,le)},createTestObserver(){return(0,ve.checkProposedApiEnabled)(Re,"testObserver"),Kt.createTestObserver()},runTests(Y){return(0,ve.checkProposedApiEnabled)(Re,"testObserver"),Kt.runTests(Y)},get onDidChangeTestResults(){return(0,ve.checkProposedApiEnabled)(Re,"testObserver"),Kt.onResultsChanged},get testResults(){return(0,ve.checkProposedApiEnabled)(Re,"testObserver"),Kt.results}},Ti={getExtension(Y){const le=Lt.getExtensionDescription(Y);if(le)return new r.Extension(ze,Re.identifier,le,bi)},get all(){return Lt.getAllExtensionDescriptions().map(Y=>new r.Extension(ze,Re.identifier,Y,bi))},get onDidChange(){return Lt.onDidChange}},Ai={createDiagnosticCollection(Y){return Xt.createDiagnosticCollection(Re.identifier,Y)},get onDidChangeDiagnostics(){return Xt.onDidChangeDiagnostics},getDiagnostics:Y=>Xt.getDiagnostics(Y),getLanguages(){return Wt.getLanguages()},setTextDocumentLanguage(Y,le){return Wt.changeLanguage(Y.uri,le)},match(Y,le){return(0,A.score)(z.LanguageSelector.from(Y),le.uri,le.languageId,!0)},registerCodeActionsProvider(Y,le,Ce){return mt.registerCodeActionProvider(Re,ft(Y),le,Ce)},registerCodeLensProvider(Y,le){return mt.registerCodeLensProvider(Re,ft(Y),le)},registerDefinitionProvider(Y,le){return mt.registerDefinitionProvider(Re,ft(Y),le)},registerDeclarationProvider(Y,le){return mt.registerDeclarationProvider(Re,ft(Y),le)},registerImplementationProvider(Y,le){return mt.registerImplementationProvider(Re,ft(Y),le)},registerTypeDefinitionProvider(Y,le){return mt.registerTypeDefinitionProvider(Re,ft(Y),le)},registerHoverProvider(Y,le){return mt.registerHoverProvider(Re,ft(Y),le,Re.identifier)},registerEvaluatableExpressionProvider(Y,le){return mt.registerEvaluatableExpressionProvider(Re,ft(Y),le,Re.identifier)},registerInlineValuesProvider(Y,le){return mt.registerInlineValuesProvider(Re,ft(Y),le,Re.identifier)},registerDocumentHighlightProvider(Y,le){return mt.registerDocumentHighlightProvider(Re,ft(Y),le)},registerLinkedEditingRangeProvider(Y,le){return mt.registerLinkedEditingRangeProvider(Re,ft(Y),le)},registerReferenceProvider(Y,le){return mt.registerReferenceProvider(Re,ft(Y),le)},registerRenameProvider(Y,le){return mt.registerRenameProvider(Re,ft(Y),le)},registerDocumentSymbolProvider(Y,le,Ce){return mt.registerDocumentSymbolProvider(Re,ft(Y),le,Ce)},registerWorkspaceSymbolProvider(Y){return mt.registerWorkspaceSymbolProvider(Re,Y)},registerDocumentFormattingEditProvider(Y,le){return mt.registerDocumentFormattingEditProvider(Re,ft(Y),le)},registerDocumentRangeFormattingEditProvider(Y,le){return mt.registerDocumentRangeFormattingEditProvider(Re,ft(Y),le)},registerOnTypeFormattingEditProvider(Y,le,Ce,...ct){return mt.registerOnTypeFormattingEditProvider(Re,ft(Y),le,[Ce].concat(ct))},registerDocumentSemanticTokensProvider(Y,le,Ce){return mt.registerDocumentSemanticTokensProvider(Re,ft(Y),le,Ce)},registerDocumentRangeSemanticTokensProvider(Y,le,Ce){return mt.registerDocumentRangeSemanticTokensProvider(Re,ft(Y),le,Ce)},registerSignatureHelpProvider(Y,le,Ce,...ct){return typeof Ce=="object"?mt.registerSignatureHelpProvider(Re,ft(Y),le,Ce):mt.registerSignatureHelpProvider(Re,ft(Y),le,typeof Ce=="undefined"?[]:[Ce,...ct])},registerCompletionItemProvider(Y,le,...Ce){return mt.registerCompletionItemProvider(Re,ft(Y),le,Ce)},registerInlineCompletionItemProvider(Y,le){return(0,ve.checkProposedApiEnabled)(Re,"inlineCompletions"),mt.registerInlineCompletionsProvider(Re,ft(Y),le)},registerDocumentLinkProvider(Y,le){return mt.registerDocumentLinkProvider(Re,ft(Y),le)},registerColorProvider(Y,le){return mt.registerColorProvider(Re,ft(Y),le)},registerFoldingRangeProvider(Y,le){return mt.registerFoldingRangeProvider(Re,ft(Y),le)},registerSelectionRangeProvider(Y,le){return mt.registerSelectionRangeProvider(Re,Y,le)},registerCallHierarchyProvider(Y,le){return mt.registerCallHierarchyProvider(Re,Y,le)},registerTypeHierarchyProvider(Y,le){return mt.registerTypeHierarchyProvider(Re,Y,le)},setLanguageConfiguration:(Y,le)=>mt.setLanguageConfiguration(Re,Y,le),getTokenInformationAtPosition(Y,le){return(0,ve.checkProposedApiEnabled)(Re,"tokenInformation"),Wt.tokenAtPosition(Y,le)},registerInlayHintsProvider(Y,le){return(0,ve.checkProposedApiEnabled)(Re,"inlayHints"),mt.registerInlayHintsProvider(Re,Y,le)},createLanguageStatusItem(Y,le){return(0,ve.checkProposedApiEnabled)(Re,"languageStatus"),Wt.createLanguageStatusItem(Re,Y,le)}},Ri={get activeTextEditor(){return Rt.getActiveTextEditor()},get visibleTextEditors(){return Rt.getVisibleTextEditors()},get activeTerminal(){return vt.activeTerminal},get terminals(){return vt.terminals},async showTextDocument(Y,le,Ce){const ct=await(t.URI.isUri(Y)?Promise.resolve(ni.openTextDocument(Y)):Promise.resolve(Y));return Rt.showTextDocument(ct,le,Ce)},createTextEditorDecorationType(Y){return Rt.createTextEditorDecorationType(Re,Y)},onDidChangeActiveTextEditor(Y,le,Ce){return Rt.onDidChangeActiveTextEditor(Y,le,Ce)},onDidChangeVisibleTextEditors(Y,le,Ce){return Rt.onDidChangeVisibleTextEditors(Y,le,Ce)},onDidChangeTextEditorSelection(Y,le,Ce){return Rt.onDidChangeTextEditorSelection(Y,le,Ce)},onDidChangeTextEditorOptions(Y,le,Ce){return Rt.onDidChangeTextEditorOptions(Y,le,Ce)},onDidChangeTextEditorVisibleRanges(Y,le,Ce){return Rt.onDidChangeTextEditorVisibleRanges(Y,le,Ce)},onDidChangeTextEditorViewColumn(Y,le,Ce){return Rt.onDidChangeTextEditorViewColumn(Y,le,Ce)},onDidCloseTerminal(Y,le,Ce){return vt.onDidCloseTerminal(Y,le,Ce)},onDidOpenTerminal(Y,le,Ce){return vt.onDidOpenTerminal(Y,le,Ce)},onDidChangeActiveTerminal(Y,le,Ce){return vt.onDidChangeActiveTerminal(Y,le,Ce)},onDidChangeTerminalDimensions(Y,le,Ce){return(0,ve.checkProposedApiEnabled)(Re,"terminalDimensions"),vt.onDidChangeTerminalDimensions(Y,le,Ce)},onDidChangeTerminalState(Y,le,Ce){return vt.onDidChangeTerminalState(Y,le,Ce)},onDidWriteTerminalData(Y,le,Ce){return(0,ve.checkProposedApiEnabled)(Re,"terminalDataWriteEvent"),vt.onDidWriteTerminalData(Y,le,Ce)},get state(){return Le.state},onDidChangeWindowState(Y,le,Ce){return Le.onDidChangeWindowState(Y,le,Ce)},showInformationMessage(Y,...le){return ui.showMessage(Re,I.default.Info,Y,le[0],le.slice(1))},showWarningMessage(Y,...le){return ui.showMessage(Re,I.default.Warning,Y,le[0],le.slice(1))},showErrorMessage(Y,...le){return ui.showMessage(Re,I.default.Error,Y,le[0],le.slice(1))},showQuickPick(Y,le,Ce){return Array.isArray(Y)&&Y.some(ct=>ct.kind!==void 0)&&(0,ve.checkProposedApiEnabled)(Re,"quickPickSeparators"),jt.showQuickPick(Y,le,Ce)},showWorkspaceFolderPick(Y){return jt.showWorkspaceFolderPick(Y)},showInputBox(Y,le){return jt.showInput(Y,le)},showOpenDialog(Y){return ti.showOpenDialog(Y)},showSaveDialog(Y){return ti.showSaveDialog(Y)},createStatusBarItem(Y,le,Ce){let ct,St,Dt;return typeof Y=="string"?(ct=Y,St=le,Dt=Ce):(St=Y,Dt=le),gi.createStatusBarEntry(Re,ct,St,Dt)},setStatusBarMessage(Y,le){return gi.setStatusBarMessage(Y,le)},withScmProgress(Y){return qe.report("window.withScmProgress",Re,"Use 'withProgress' instead."),fi.withProgress(Re,{location:H.ProgressLocation.SourceControl},(le,Ce)=>Y({report(ct){}}))},withProgress(Y,le){return fi.withProgress(Re,Y,le)},createOutputChannel(Y){return At.createOutputChannel(Y,Re)},createWebviewPanel(Y,le,Ce,ct){return Gt.createWebviewPanel(Re,Y,le,Ce,ct)},createWebviewTextEditorInset(Y,le,Ce,ct){return(0,ve.checkProposedApiEnabled)(Re,"editorInsets"),ai.createWebviewEditorInset(Y,le,Ce,ct,Re)},createTerminal(Y,le,Ce){return typeof Y=="object"?("location"in Y&&(0,ve.checkProposedApiEnabled)(Re,"terminalLocation"),"pty"in Y?vt.createExtensionTerminal(Y):vt.createTerminalFromOptions(Y)):vt.createTerminal(Y,le,Ce)},registerTerminalLinkProvider(Y){return vt.registerLinkProvider(Y)},registerTerminalProfileProvider(Y,le){return vt.registerProfileProvider(Re,Y,le)},registerTreeDataProvider(Y,le){return Yt.registerTreeDataProvider(Y,le,Re)},createTreeView(Y,le){return Yt.createTreeView(Y,le,Re)},registerWebviewPanelSerializer:(Y,le)=>Gt.registerWebviewPanelSerializer(Re,Y,le),registerCustomEditorProvider:(Y,le,Ce={})=>yi.registerCustomEditorProvider(Re,Y,le,Ce),registerFileDecorationProvider(Y){return Ct.registerFileDecorationProvider(Y,Re.identifier)},registerUriHandler(Y){return Ut.registerUriHandler(Re.identifier,Y)},createQuickPick(){return jt.createQuickPick(Re)},createInputBox(){return jt.createInputBox(Re.identifier)},get activeColorTheme(){return mi.activeColorTheme},onDidChangeActiveColorTheme(Y,le,Ce){return mi.onDidChangeActiveColorTheme(Y,le,Ce)},registerWebviewViewProvider(Y,le,Ce){return Si.registerWebviewViewProvider(Re,Y,le,Ce?.webviewOptions)},get activeNotebookEditor(){return(0,ve.checkProposedApiEnabled)(Re,"notebookEditor"),wt.activeNotebookEditor},onDidChangeActiveNotebookEditor(Y,le,Ce){return(0,ve.checkProposedApiEnabled)(Re,"notebookEditor"),wt.onDidChangeActiveNotebookEditor(Y,le,Ce)},get visibleNotebookEditors(){return(0,ve.checkProposedApiEnabled)(Re,"notebookEditor"),wt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,ve.checkProposedApiEnabled)(Re,"notebookEditor"),wt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(Y,le,Ce){return(0,ve.checkProposedApiEnabled)(Re,"notebookEditor"),Vt.onDidChangeNotebookEditorSelection(Y,le,Ce)},onDidChangeNotebookEditorVisibleRanges(Y,le,Ce){return(0,ve.checkProposedApiEnabled)(Re,"notebookEditor"),Vt.onDidChangeNotebookEditorVisibleRanges(Y,le,Ce)},showNotebookDocument(Y,le){return(0,ve.checkProposedApiEnabled)(Re,"notebookEditor"),wt.showNotebookDocument(Y,le)},registerExternalUriOpener(Y,le,Ce){return(0,ve.checkProposedApiEnabled)(Re,"externalUriOpener"),Ci.registerExternalUriOpener(Re.identifier,Y,le,Ce)},get tabs(){return(0,ve.checkProposedApiEnabled)(Re,"tabs"),bt.tabs},get activeTab(){return(0,ve.checkProposedApiEnabled)(Re,"tabs"),bt.activeTab},get onDidChangeTabs(){return(0,ve.checkProposedApiEnabled)(Re,"tabs"),bt.onDidChangeTabs},get onDidChangeActiveTab(){return(0,ve.checkProposedApiEnabled)(Re,"tabs"),bt.onDidChangeActiveTab},getInlineCompletionItemController(Y){return(0,ve.checkProposedApiEnabled)(Re,"inlineCompletions"),m.InlineCompletionController.get(Y)}},ni={get rootPath(){return qe.report("workspace.rootPath",Re,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),Oe.getPath()},set rootPath(Y){throw F.readonly()},getWorkspaceFolder(Y){return Oe.getWorkspaceFolder(Y)},get workspaceFolders(){return Oe.getWorkspaceFolders()},get name(){return Oe.name},set name(Y){throw F.readonly()},get workspaceFile(){return Oe.workspaceFile},set workspaceFile(Y){throw F.readonly()},updateWorkspaceFolders:(Y,le,...Ce)=>Oe.updateWorkspaceFolders(Re,Y,le||0,...Ce),onDidChangeWorkspaceFolders:function(Y,le,Ce){return Oe.onDidChangeWorkspace(Y,le,Ce)},asRelativePath:(Y,le)=>Oe.getRelativePath(Y,le),findFiles:(Y,le,Ce,ct)=>Oe.findFiles(z.GlobPattern.from(Y),z.GlobPattern.from(le),Ce,Re.identifier,ct),findTextInFiles:(Y,le,Ce,ct)=>{(0,ve.checkProposedApiEnabled)(Re,"findTextInFiles");let St,Dt;return typeof le=="object"?(St=le,Dt=Ce):(St={},Dt=le,ct=Ce),Oe.findTextInFiles(Y,St||{},Dt,Re.identifier,ct)},saveAll:Y=>Oe.saveAll(Y),applyEdit(Y){return Di.applyWorkspaceEdit(Y)},createFileSystemWatcher:(Y,le,Ce,ct)=>Ot.createFileSystemWatcher(z.GlobPattern.from(Y),le,Ce,ct),get textDocuments(){return Pt.getAllDocumentData().map(Y=>Y.document)},set textDocuments(Y){throw F.readonly()},openTextDocument(Y){let le;const Ce=Y;if(typeof Y=="string")le=Promise.resolve(t.URI.file(Y));else if(t.URI.isUri(Y))le=Promise.resolve(Y);else if(!Ce||typeof Ce=="object")le=Pt.createDocumentData(Ce);else throw new Error("illegal argument - uriOrFileNameOrOptions");return le.then(ct=>Pt.ensureDocumentData(ct).then(St=>St.document))},onDidOpenTextDocument:(Y,le,Ce)=>Pt.onDidAddDocument(Y,le,Ce),onDidCloseTextDocument:(Y,le,Ce)=>Pt.onDidRemoveDocument(Y,le,Ce),onDidChangeTextDocument:(Y,le,Ce)=>Pt.onDidChangeDocument(Y,le,Ce),onDidSaveTextDocument:(Y,le,Ce)=>Pt.onDidSaveDocument(Y,le,Ce),onWillSaveTextDocument:(Y,le,Ce)=>zt.getOnWillSaveTextDocumentEvent(Re)(Y,le,Ce),get notebookDocuments(){return wt.notebookDocuments.map(Y=>Y.apiNotebook)},async openNotebookDocument(Y,le){let Ce;if(t.URI.isUri(Y))Ce=Y,await wt.openNotebookDocument(Y);else if(typeof Y=="string")Ce=t.URI.revive(await wt.createNotebookDocument({viewType:Y,content:le}));else throw new Error("Invalid arguments");return wt.getNotebookDocument(Ce).apiNotebook},get onDidOpenNotebookDocument(){return wt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return wt.onDidCloseNotebookDocument},registerNotebookSerializer(Y,le,Ce,ct){return wt.registerNotebookSerializer(Re,Y,le,Ce,(0,ve.isProposedApiEnabled)(Re,"notebookLiveShare")?ct:void 0)},registerNotebookContentProvider:(Y,le,Ce,ct)=>((0,ve.checkProposedApiEnabled)(Re,"notebookContentProvider"),wt.registerNotebookContentProvider(Re,Y,le,Ce,(0,ve.isProposedApiEnabled)(Re,"notebookLiveShare")?ct:void 0)),onDidChangeConfiguration:(Y,le,Ce)=>pi.onDidChangeConfiguration(Y,le,Ce),getConfiguration(Y,le){return le=arguments.length===1?void 0:le,pi.getConfiguration(Y,le,Re)},registerTextDocumentContentProvider(Y,le){return Bt.registerTextDocumentContentProvider(Y,le)},registerTaskProvider:(Y,le)=>(qe.report("window.registerTaskProvider",Re,"Use the corresponding function on the 'tasks' namespace instead"),yt.registerTaskProvider(Re,Y,le)),registerFileSystemProvider(Y,le,Ce){return(0,Se.combinedDisposable)(ci.registerFileSystemProvider(Re,Y,le,Ce),Ie.addFileSystemProvider(Y,le))},get fs(){return Ie.value},registerFileSearchProvider:(Y,le)=>((0,ve.checkProposedApiEnabled)(Re,"fileSearchProvider"),Ft.registerFileSearchProvider(Y,le)),registerTextSearchProvider:(Y,le)=>((0,ve.checkProposedApiEnabled)(Re,"textSearchProvider"),Ft.registerTextSearchProvider(Y,le)),registerRemoteAuthorityResolver:(Y,le)=>((0,ve.checkProposedApiEnabled)(Re,"resolvers"),ze.registerRemoteAuthorityResolver(Y,le)),registerResourceLabelFormatter:Y=>((0,ve.checkProposedApiEnabled)(Re,"resolvers"),Ei.$registerResourceLabelFormatter(Y)),onDidCreateFiles:(Y,le,Ce)=>Ot.onDidCreateFile(Y,le,Ce),onDidDeleteFiles:(Y,le,Ce)=>Ot.onDidDeleteFile(Y,le,Ce),onDidRenameFiles:(Y,le,Ce)=>Ot.onDidRenameFile(Y,le,Ce),onWillCreateFiles:(Y,le,Ce)=>Ot.getOnWillCreateFileEvent(Re)(Y,le,Ce),onWillDeleteFiles:(Y,le,Ce)=>Ot.getOnWillDeleteFileEvent(Re)(Y,le,Ce),onWillRenameFiles:(Y,le,Ce)=>Ot.getOnWillRenameFileEvent(Re)(Y,le,Ce),openTunnel:Y=>((0,ve.checkProposedApiEnabled)(Re,"resolvers"),ke.openTunnel(Re,Y).then(le=>{if(!le)throw new Error("cannot open tunnel");return le})),get tunnels(){return(0,ve.checkProposedApiEnabled)(Re,"resolvers"),ke.getTunnels()},onDidChangeTunnels:(Y,le,Ce)=>((0,ve.checkProposedApiEnabled)(Re,"resolvers"),ke.onDidChangeTunnels(Y,le,Ce)),registerPortAttributesProvider:(Y,le)=>((0,ve.checkProposedApiEnabled)(Re,"portsAttributes"),ke.registerPortsAttributesProvider(Y,le)),registerTimelineProvider:(Y,le)=>((0,ve.checkProposedApiEnabled)(Re,"timeline"),_i.registerTimelineProvider(Y,le,Re.identifier,ht.converter)),get isTrusted(){return Oe.trusted},requestWorkspaceTrust:Y=>((0,ve.checkProposedApiEnabled)(Re,"workspaceTrust"),Oe.requestWorkspaceTrust(Y)),onDidGrantWorkspaceTrust:(Y,le,Ce)=>Oe.onDidGrantWorkspaceTrust(Y,le,Ce)},Fi={get inputBox(){return qe.report("scm.inputBox",Re,"Use 'SourceControl.inputBox' instead"),Jt.getLastInputBox(Re)},createSourceControl(Y,le,Ce){return Jt.createSourceControl(Re,Y,le,Ce)}},Mi={createCommentController(Y,le){return li.createCommentController(Re,Y,le)}},Oi={get activeDebugSession(){return _t.activeDebugSession},get activeDebugConsole(){return _t.activeDebugConsole},get breakpoints(){return _t.breakpoints},onDidStartDebugSession(Y,le,Ce){return _t.onDidStartDebugSession(Y,le,Ce)},onDidTerminateDebugSession(Y,le,Ce){return _t.onDidTerminateDebugSession(Y,le,Ce)},onDidChangeActiveDebugSession(Y,le,Ce){return _t.onDidChangeActiveDebugSession(Y,le,Ce)},onDidReceiveDebugSessionCustomEvent(Y,le,Ce){return _t.onDidReceiveDebugSessionCustomEvent(Y,le,Ce)},onDidChangeBreakpoints(Y,le,Ce){return _t.onDidChangeBreakpoints(Y,le,Ce)},registerDebugConfigurationProvider(Y,le,Ce){return _t.registerDebugConfigurationProvider(Y,le,Ce||H.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(Y,le){return _t.registerDebugAdapterDescriptorFactory(Re,Y,le)},registerDebugAdapterTrackerFactory(Y,le){return _t.registerDebugAdapterTrackerFactory(Y,le)},startDebugging(Y,le,Ce){return!Ce||typeof Ce=="object"&&"configuration"in Ce?_t.startDebugging(Y,le,{parentSession:Ce}):_t.startDebugging(Y,le,Ce||{})},stopDebugging(Y){return _t.stopDebugging(Y)},addBreakpoints(Y){return _t.addBreakpoints(Y)},removeBreakpoints(Y){return _t.removeBreakpoints(Y)},asDebugSourceUri(Y,le){return _t.asDebugSourceUri(Y,le)}},Li={registerTaskProvider:(Y,le)=>yt.registerTaskProvider(Re,Y,le),fetchTasks:Y=>yt.fetchTasks(Y),executeTask:Y=>yt.executeTask(Re,Y),get taskExecutions(){return yt.taskExecutions},onDidStartTask:(Y,le,Ce)=>yt.onDidStartTask(Y,le,Ce),onDidEndTask:(Y,le,Ce)=>yt.onDidEndTask(Y,le,Ce),onDidStartTaskProcess:(Y,le,Ce)=>yt.onDidStartTaskProcess(Y,le,Ce),onDidEndTaskProcess:(Y,le,Ce)=>yt.onDidEndTaskProcess(Y,le,Ce)},Ni={createNotebookController(Y,le,Ce,ct,St){return oi.createNotebookController(Re,Y,le,Ce,ct,(0,ve.isProposedApiEnabled)(Re,"notebookMessaging")?St:void 0)},registerNotebookCellStatusBarItemProvider:(Y,le)=>wt.registerNotebookCellStatusBarItemProvider(Re,Y,le),get onDidSaveNotebookDocument(){return(0,ve.checkProposedApiEnabled)(Re,"notebookEditor"),Qt.onDidSaveNotebookDocument},createNotebookEditorDecorationType(Y){return(0,ve.checkProposedApiEnabled)(Re,"notebookEditorDecorationType"),Vt.createNotebookEditorDecorationType(Y)},createRendererMessaging(Y){return si.createRendererMessaging(Re,Y)},onDidChangeNotebookDocumentMetadata(Y,le,Ce){return(0,ve.checkProposedApiEnabled)(Re,"notebookEditor"),Qt.onDidChangeNotebookDocumentMetadata(Y,le,Ce)},onDidChangeNotebookCells(Y,le,Ce){return(0,ve.checkProposedApiEnabled)(Re,"notebookEditor"),wt.onDidChangeNotebookCells(Y,le,Ce)},onDidChangeNotebookCellExecutionState(Y,le,Ce){return(0,ve.checkProposedApiEnabled)(Re,"notebookCellExecutionState"),wt.onDidChangeNotebookCellExecutionState(Y,le,Ce)},onDidChangeCellOutputs(Y,le,Ce){return(0,ve.checkProposedApiEnabled)(Re,"notebookEditor"),wt.onDidChangeCellOutputs(Y,le,Ce)},onDidChangeCellMetadata(Y,le,Ce){return(0,ve.checkProposedApiEnabled)(Re,"notebookEditor"),wt.onDidChangeCellMetadata(Y,le,Ce)},createConcatTextDocument(Y,le){return(0,ve.checkProposedApiEnabled)(Re,"notebookConcatTextDocument"),new Ne.ExtHostNotebookConcatDocument(wt,Pt,Y,le)}};return{version:he.version,authentication:ii,commands:Ii,comments:Mi,debug:Oi,env:vi,extensions:Ti,languages:Ai,notebooks:Ni,scm:Fi,tasks:Li,tests:Pi,window:Ri,workspace:ni,Breakpoint:H.Breakpoint,CallHierarchyIncomingCall:H.CallHierarchyIncomingCall,CallHierarchyItem:H.CallHierarchyItem,CallHierarchyOutgoingCall:H.CallHierarchyOutgoingCall,CancellationError:F.CancellationError,CancellationTokenSource:c.CancellationTokenSource,CandidatePortSource:n.CandidatePortSource,CodeAction:H.CodeAction,CodeActionKind:H.CodeActionKind,CodeActionTriggerKind:H.CodeActionTriggerKind,CodeLens:H.CodeLens,Color:H.Color,ColorInformation:H.ColorInformation,ColorPresentation:H.ColorPresentation,ColorThemeKind:H.ColorThemeKind,CommentMode:H.CommentMode,CommentThreadCollapsibleState:H.CommentThreadCollapsibleState,CompletionItem:H.CompletionItem,CompletionItemKind:H.CompletionItemKind,CompletionItemTag:H.CompletionItemTag,CompletionList:H.CompletionList,CompletionTriggerKind:H.CompletionTriggerKind,ConfigurationTarget:H.ConfigurationTarget,CustomExecution:H.CustomExecution,DebugAdapterExecutable:H.DebugAdapterExecutable,DebugAdapterInlineImplementation:H.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:H.DebugAdapterNamedPipeServer,DebugAdapterServer:H.DebugAdapterServer,DebugConfigurationProviderTriggerKind:H.DebugConfigurationProviderTriggerKind,DebugConsoleMode:H.DebugConsoleMode,DecorationRangeBehavior:H.DecorationRangeBehavior,Diagnostic:H.Diagnostic,DiagnosticRelatedInformation:H.DiagnosticRelatedInformation,DiagnosticSeverity:H.DiagnosticSeverity,DiagnosticTag:H.DiagnosticTag,Disposable:H.Disposable,DocumentHighlight:H.DocumentHighlight,DocumentHighlightKind:H.DocumentHighlightKind,DocumentLink:H.DocumentLink,DocumentSymbol:H.DocumentSymbol,EndOfLine:H.EndOfLine,EnvironmentVariableMutatorType:H.EnvironmentVariableMutatorType,EvaluatableExpression:H.EvaluatableExpression,InlineValueText:H.InlineValueText,InlineValueVariableLookup:H.InlineValueVariableLookup,InlineValueEvaluatableExpression:H.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:H.InlineCompletionTriggerKind,EventEmitter:w.Emitter,ExtensionKind:H.ExtensionKind,ExtensionMode:H.ExtensionMode,ExternalUriOpenerPriority:H.ExternalUriOpenerPriority,FileChangeType:H.FileChangeType,FileDecoration:H.FileDecoration,FileSystemError:H.FileSystemError,FileType:_.FileType,FilePermission:_.FilePermission,FoldingRange:H.FoldingRange,FoldingRangeKind:H.FoldingRangeKind,FunctionBreakpoint:H.FunctionBreakpoint,InlineCompletionItem:H.InlineSuggestion,InlineCompletionList:H.InlineSuggestions,Hover:H.Hover,IndentAction:C.IndentAction,Location:H.Location,MarkdownString:H.MarkdownString,OverviewRulerLane:S.OverviewRulerLane,ParameterInformation:H.ParameterInformation,PortAutoForwardAction:H.PortAutoForwardAction,Position:H.Position,ProcessExecution:H.ProcessExecution,ProgressLocation:H.ProgressLocation,QuickInputButtons:H.QuickInputButtons,Range:H.Range,RelativePattern:H.RelativePattern,Selection:H.Selection,SelectionRange:H.SelectionRange,SemanticTokens:H.SemanticTokens,SemanticTokensBuilder:H.SemanticTokensBuilder,SemanticTokensEdit:H.SemanticTokensEdit,SemanticTokensEdits:H.SemanticTokensEdits,SemanticTokensLegend:H.SemanticTokensLegend,ShellExecution:H.ShellExecution,ShellQuoting:H.ShellQuoting,SignatureHelp:H.SignatureHelp,SignatureHelpTriggerKind:H.SignatureHelpTriggerKind,SignatureInformation:H.SignatureInformation,SnippetString:H.SnippetString,SourceBreakpoint:H.SourceBreakpoint,StandardTokenType:H.StandardTokenType,StatusBarAlignment:H.StatusBarAlignment,SymbolInformation:H.SymbolInformation,SymbolKind:H.SymbolKind,SymbolTag:H.SymbolTag,Task:H.Task,TaskGroup:H.TaskGroup,TaskPanelKind:H.TaskPanelKind,TaskRevealKind:H.TaskRevealKind,TaskScope:H.TaskScope,TerminalLink:H.TerminalLink,TerminalLocation:H.TerminalLocation,TerminalProfile:H.TerminalProfile,TextDocumentSaveReason:H.TextDocumentSaveReason,TextEdit:H.TextEdit,TextEditorCursorStyle:R.TextEditorCursorStyle,TextEditorLineNumbersStyle:H.TextEditorLineNumbersStyle,TextEditorRevealType:H.TextEditorRevealType,TextEditorSelectionChangeKind:H.TextEditorSelectionChangeKind,TextDocumentChangeReason:H.TextDocumentChangeReason,ThemeColor:H.ThemeColor,ThemeIcon:H.ThemeIcon,TreeItem:H.TreeItem,TreeItemCollapsibleState:H.TreeItemCollapsibleState,TypeHierarchyItem:H.TypeHierarchyItem,UIKind:n.UIKind,Uri:t.URI,ViewColumn:H.ViewColumn,WorkspaceEdit:H.WorkspaceEdit,InlayHint:H.InlayHint,InlayHintKind:H.InlayHintKind,RemoteAuthorityResolverError:H.RemoteAuthorityResolverError,ResolvedAuthority:H.ResolvedAuthority,SourceControlInputBoxValidationType:H.SourceControlInputBoxValidationType,ExtensionRuntime:H.ExtensionRuntime,TimelineItem:H.TimelineItem,NotebookRange:H.NotebookRange,NotebookCellKind:H.NotebookCellKind,NotebookCellExecutionState:H.NotebookCellExecutionState,NotebookCellData:H.NotebookCellData,NotebookData:H.NotebookData,NotebookRendererScript:H.NotebookRendererScript,NotebookCellStatusBarAlignment:H.NotebookCellStatusBarAlignment,NotebookEditorRevealType:H.NotebookEditorRevealType,NotebookCellOutput:H.NotebookCellOutput,NotebookCellOutputItem:H.NotebookCellOutputItem,NotebookCellStatusBarItem:H.NotebookCellStatusBarItem,NotebookControllerAffinity:H.NotebookControllerAffinity,PortAttributes:H.PortAttributes,LinkedEditingRanges:H.LinkedEditingRanges,TestResultState:H.TestResultState,TestRunRequest:H.TestRunRequest,TestMessage:H.TestMessage,TestTag:H.TestTag,TestRunProfileKind:H.TestRunProfileKind,TextSearchCompleteMessageType:Je.TextSearchCompleteMessageType,TreeDataTransfer:H.TreeDataTransfer,TreeDataTransferItem:H.TreeDataTransferItem,CoveredCount:H.CoveredCount,FileCoverage:H.FileCoverage,StatementCoverage:H.StatementCoverage,BranchCoverage:H.BranchCoverage,FunctionCoverage:H.FunctionCoverage,WorkspaceTrustState:H.WorkspaceTrustState,LanguageStatusSeverity:H.LanguageStatusSeverity,QuickPickItemKind:H.QuickPickItemKind}}}e.createApiFactoryAndRegisterActors=re}),define(Ee[220],_e([0,1,56,94,31,93,32,38,49,39,97,98,99,71,64,69,95,50,30,68,85,70,192,12,175]),function(oe,e,c,F,w,I,t,R,S,C,A,_,n,h,s,l,d,D,v,f,g,T,u,M,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,c.registerSingleton)(M.ILoggerService,u.ExtHostLoggerService),(0,c.registerSingleton)(M.ILogService,r.ExtHostLogService),(0,c.registerSingleton)(l.IExtHostApiDeprecationService,l.ExtHostApiDeprecationService),(0,c.registerSingleton)(R.IExtHostCommands,R.ExtHostCommands),(0,c.registerSingleton)(t.IExtHostConfiguration,t.ExtHostConfiguration),(0,c.registerSingleton)(D.IExtHostConsumerFileSystem,D.ExtHostConsumerFileSystem),(0,c.registerSingleton)(_.IExtHostDebugService,_.WorkerExtHostDebugService),(0,c.registerSingleton)(I.IExtHostDecorations,I.ExtHostDecorations),(0,c.registerSingleton)(S.IExtHostDocumentsAndEditors,S.ExtHostDocumentsAndEditors),(0,c.registerSingleton)(v.IExtHostFileSystemInfo,v.ExtHostFileSystemInfo),(0,c.registerSingleton)(F.IExtHostOutputService,F.ExtHostOutputService),(0,c.registerSingleton)(n.IExtHostSearch,n.ExtHostSearch),(0,c.registerSingleton)(h.IExtHostStorage,h.ExtHostStorage),(0,c.registerSingleton)(A.IExtHostTask,A.WorkerExtHostTask),(0,c.registerSingleton)(C.IExtHostTerminalService,C.WorkerExtHostTerminalService),(0,c.registerSingleton)(s.IExtHostTunnelService,s.ExtHostTunnelService),(0,c.registerSingleton)(d.IExtHostWindow,d.ExtHostWindow),(0,c.registerSingleton)(w.IExtHostWorkspace,w.ExtHostWorkspace),(0,c.registerSingleton)(f.IExtHostSecretState,f.ExtHostSecretState),(0,c.registerSingleton)(g.IExtHostTelemetry,g.ExtHostTelemetry),(0,c.registerSingleton)(T.IExtHostEditorTabs,T.ExtHostEditorTabs)}),define(Ee[221],_e([0,1,219,33,215,7,14,5,10]),function(oe,e,c,F,w,I,t,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;var C;(function(s){const l=self.trustedTypes?.createPolicy("TrustedFunctionWorkaround",{createScript:(D,...v)=>{v.forEach(u=>{if(!self.trustedTypes?.isScript(u))throw new Error("TrustedScripts only, please")});const f=v.slice(0,-1).join(","),g=v.pop().toString();return`(function anonymous(${f}) {${g}
})`}});function d(...D){return l?self.eval(l.createScript("",...D)):new Function(...D)}s.create=d})(C||(C={}));class A extends w.RequireInterceptor{_installInterceptor(){}getModule(l,d){for(let D of this._alternatives){let v=D(l);if(v){l=v;break}}if(this._factories.has(l))return this._factories.get(l).load(l,d,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class _ extends F.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=I.ExtensionRuntime.Webworker}async _beforeAlmostReadyToRunExtensions(){const l=this._extHostContext.getProxy(R.MainContext.MainThreadConsole);h(l,this._initData.environment.isExtensionDevelopmentDebug);const d=this._instaService.invokeFunction(c.createApiFactoryAndRegisterActors);this._fakeModules=this._instaService.createInstance(A,d,this._registry),await this._fakeModules.install(),performance.mark("code/extHost/didInitAPI"),await this._waitForDebuggerAttachment()}_getEntryPoint(l){return l.browser}async _loadCommonJSModule(l,d,D){d=d.with({path:n(d.path,".js")}),l&&performance.mark(`code/extHost/willFetchExtensionCode/${l.value}`);const v=await fetch(S.FileAccess.asBrowserUri(d).toString(!0));if(l&&performance.mark(`code/extHost/didFetchExtensionCode/${l.value}`),v.status!==200)throw new Error(v.statusText);const f=await v.text(),g=`${d.toString(!0)}#vscode-extension`,T=`${f}
//# sourceURL=${g}`;let u;try{u=C.create(_._ttpExtensionScripts?.createScript("module")??"module",_._ttpExtensionScripts?.createScript("exports")??"exports",_._ttpExtensionScripts?.createScript("require")??"require",_._ttpExtensionScripts?.createScript(T)??T)}catch(p){throw console.error(l?`Loading code for extension ${l.value} failed: ${p.message}`:`Loading code failed: ${p.message}`),console.error(`${d.toString(!0)}${typeof p.line=="number"?` line ${p.line}`:""}${typeof p.column=="number"?` column ${p.column}`:""}`),console.error(p),p}const M={},r={exports:M},i=p=>{const m=this._fakeModules.getModule(p,d);if(m===void 0)throw new Error(`Cannot load module '${p}'`);return m};try{return D.codeLoadingStart(),l&&performance.mark(`code/extHost/willLoadExtensionCode/${l.value}`),u(r,M,i),r.exports!==M?r.exports:M}finally{l&&performance.mark(`code/extHost/didLoadExtensionCode/${l.value}`),D.codeLoadingStop()}}async $setRemoteEnvironment(l){}async _waitForDebuggerAttachment(l=5e3){if(!this._initData.environment.isExtensionDevelopmentDebug)return;const d=Date.now()+l;for(;Date.now()<d&&!("__jsDebugIsReady"in globalThis);)await(0,t.timeout)(10)}}e.ExtHostExtensionService=_,_._ttpExtensionScripts=self.trustedTypes?.createPolicy("ExtensionScripts",{createScript:s=>s});function n(s,l){return s.endsWith(l)?s:s+l}function h(s,l){d("info","log"),d("log","log"),d("warn","warn"),d("error","error");function d(f,g){const T=console[f];console[f]=function(){s.$logExtensionHostMessage({type:"__$console",severity:g,arguments:v(arguments)}),l&&T.apply(console,arguments)}}const D=1e5;function v(f){const g=[],T=[];if(f.length)for(let u=0;u<f.length;u++){if(typeof f[u]=="undefined")f[u]="undefined";else if(f[u]instanceof Error){const M=f[u];M.stack?f[u]=M.stack:f[u]=M.toString()}T.push(f[u])}try{const u=JSON.stringify(T,function(M,r){if(r&&typeof r=="object"){if(g.indexOf(r)!==-1)return"[Circular]";g.push(r)}return r});return u.length>D?"Output omitted for a large object that exceeds the limits":u}catch(u){return`Output omitted for an object that cannot be inspected ('${u.toString()}')`}}}}),define(Ee[222],_e([0,1,56,33,72,221]),function(oe,e,c,F,w,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,c.registerSingleton)(F.IExtHostExtensionService,I.ExtHostExtensionService),(0,c.registerSingleton)(w.IExtensionStoragePaths,w.ExtensionStoragePaths)}),define(Ee[233],_e([0,1,22,3,173,216,210,17,73,10,2,220,222]),function(oe,e,c,F,w,I,t,R,S,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const _=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const n=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");const h=fetch.bind(self);if(self.fetch=function(f,g){return f instanceof Request||/^file:/i.test(String(f))&&(f=C.FileAccess.asBrowserUri(A.URI.parse(String(f))).toString(!0)),h(f,g)},self.XMLHttpRequest=class extends XMLHttpRequest{open(f,g,T,u,M){return/^file:/i.test(g.toString())&&(g=C.FileAccess.asBrowserUri(A.URI.parse(g.toString())).toString(!0)),super.open(f,g,T??!0,u,M)}},self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const f=self.trustedTypes?.createPolicy("extensionHostWorker",{createScriptURL:T=>T}),g=self.Worker;Worker=function(T,u){/^file:/i.test(T.toString())&&(T=C.FileAccess.asBrowserUri(A.URI.parse(T.toString())).toString(!0));const r=`(${function(o){function b(k){return typeof k=="string"||k instanceof URL?String(k).replace(/^file:\/\//i,"vscode-file://vscode-app"):k}const a=fetch.bind(self);self.fetch=function(k,B){return k instanceof Request?a(k,B):a(b(k),B)},self.XMLHttpRequest=class extends XMLHttpRequest{open(k,B,L,y,x){return super.open(k,b(B),L??!0,y,x)}};const E=importScripts.bind(self);self.importScripts=(...k)=>{E(...k.map(b))};const P=self.trustedTypes?self.trustedTypes.createPolicy("extensionHostWorker",{createScriptURL:k=>k}):void 0;E(P?P.createScriptURL(o):o)}.toString()}('${T}'))`;u=u||{},u.name=u.name||R.basename(T.toString());const i=new Blob([r],{type:"application/javascript"}),p=URL.createObjectURL(i);return new g(f?f.createScriptURL(p):p,u)}}else self.Worker=class extends t.NestedWorker{constructor(f,g){super(n,f,{name:R.basename(f.toString()),...g})}};const s=new class{constructor(){this.pid=void 0}exit(f){_()}async exists(f){return!0}async realpath(f){return f}};class l{constructor(){const g=new MessageChannel,T=new F.Emitter;let u=!1;n(g.port2,[g.port2]),g.port1.onmessage=M=>{const{data:r}=M;if(!(r instanceof ArrayBuffer)){console.warn("UNKNOWN data received",r);return}const i=c.VSBuffer.wrap(new Uint8Array(r,0,r.byteLength));if((0,w.isMessageOfType)(i,2)){u=!0,D("received terminate message from renderer");return}T.fire(i)},this.protocol={onMessage:T.event,send:M=>{if(!u){const r=M.buffer.buffer.slice(M.buffer.byteOffset,M.buffer.byteOffset+M.buffer.byteLength);g.port1.postMessage(r,[r])}}}}}function d(f){return new Promise(g=>{const T=f.onMessage(u=>{T.dispose();const M=JSON.parse(u.toString());f.send((0,w.createMessageOfType)(0)),g({protocol:f,initData:M})});f.send((0,w.createMessageOfType)(1))})}let D=f=>_();function v(){const f=new l;S.mark("code/extHost/willConnectToRenderer"),d(f.protocol).then(g=>{S.mark("code/extHost/didWaitForInitData");const T=new I.ExtensionHostMain(g.protocol,g.initData,s,null);D=u=>T.terminate(u)})}e.create=v})}).call(this);

//# sourceMappingURL=extensionHostWorker.js.map
